	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\arch\ModularPS\ModularPS.c' 19 12 9 24 10 32
;1 //----- ModularPS.c ----- 10/02/12 -----(03/26/06)-----
;2 
;3 
;4 //-------------------------------------------------------------------------
;5 //  Board Support Package for the NSCL Modular Power Supply circuit board
;6 //  which uses a ZWorld Rabbit Core Module 3200 (RCM3200).
;7 //
;8 //  This board has 22 12-bit ADC inputs, 4 16-bit ADC inputs, and 3 16-bit 
;9 //  outputs
;10 //-------------------------------------------------------------------------
;11 //  Change Log (most recent first):
;12 //
;13 //
;14 //  2012-10-02 - Mark Davis (*)
;15 //               - Reduced the threshold for excessive nested scheduler loc
;16 //                 (used to detect excessive knob interrupts) from 50 to 30
;17 //                 Prior to this there was at least one instance of a stack
;18 //                 overflow that occured around the 50 level.  Also, the
;19 //                 source of the interrupt is not reenabled until the appli
;20 //                 task has run at least 20 times since the interrupt was
;21 //                 disabled (to reduce the affect on other tasks).
;22 //
;23 //  2011-12-22 - Mark Davis (*)
;24 //               - Changed IP for knob interrupt from 3 to 1 so the knob
;25 //                 interrupt is not immune to critical section locks.
;26 //               - Changed the patch that checks for excessive knob interru
;27 //                 so it is based only on the level of nested scheduler loc
;28 //
;29 //  2011-10-27 - Mark Davis (*)
;30 //               - Added patch from nscl16.c module to guard against stack
;31 //                 overflows that can occur from a continuous rapid stream
;32 //                 of interrupts from the front panel knob.
;33 //               - Changed all the DC-style WrPortI() func calls to the mor
;34 //                 efficient Softools outi() macro.
;35 //
;36 //  2011-02-25 - Mark Davis
;37 //               - Moved handling of forced bits for extraIn to ReadDigInpu
;38 //
;39 //  2011-02-07 - Mark Davis (*)
;40 //               - Removed critical section in qdPulse() ISR.  The only pur
;41 //                 it served was to protect the qdCount value from access b
;42 //                 OTHER ISRs (which I don't do), so this isn't really
;43 //                 necessary and runs the risk of overflow the IP "stack"
;44 //                 register (which MIGHT be the cause of the rare cases whe
;45 //                 there has been an unexplained interrupt "runaway" that
;46 //                 leads to a stack overflow.
;47 //              2011-04-15 NOTE:  While the critical section is still overk
;48 //              the ISR saves the IP register on the stack and restores it
;49 //              just before it returns, so its value should be correct when
;50 //              finishes executing the ISR.  The root problem is that if th
;51 //              VECTOR repeatedly get interrupted before IT returns, which 
;52 //              happen because the ISR restores the IP state on return to t
;53 //              ISR vector.  So the real question is still HOW/WHY the knob
;54 //              can get in to a state of generating a continuous stream of
;55 //              pulses?
;56 //
;57 //  2010-02-06 - Mark Davis -
;58 //               - Fixes to convertADS7825(), ReadDigInputs(),
;59 //                 WriteDigOutputs(), & hdwInit() to avoid race conditions
;60 //
;61 //  2008-06-23 - Mark Davis
;62 //               - Changed WDT_2S() call to resetWDT()
;63 //
;64 //  2008-01-08 - Mark Davis
;65 //               - removed unnecessary extra A/D channel conversion
;66 //
;67 //  2007-09-24 - Mark Davis
;68 //               - updated default ADC/DAC calibrations
;69 //
;70 //  2007-05-21 - Mark Davis
;71 //               - used pieces from nscl16, bl2105, and ps8rack to create
;72 //                 initial version.
;73 //
;74 //-------------------------------------------------------------------------
;75 
;76 #include <common.h>
;77 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;78 #include <sys/types.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;79 #include <sys/stat.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
;80 #include <unistd.h>
;81 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;82 #include <sys/backup.h>
;83 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;84 #include <sys/spi.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
;85 #include <sys/hdwDefs.h>
;86 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
;87 #include <busybox.h>
;88 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;89 #include <Rabbit.h>
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
;90 #include <dcdefs.h>
;91 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
;92 #include <stcpip.h>
;93 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
;94 #include <sys/socket.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
;95 #include <sys/srfs.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
;96 #include <sys/flashFile.h>
;97 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\flashFile.h' 15 56 20 12 3 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;98 #include <sys/farprintf.h>
;99 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
;100 
;101 //--- see hdwInit() for Digital I/O pin usage ---
;102 
;103 const char ArchName[] = { "ModularPS" };
	.defseg	CONST
	.seg	CONST
_ArchName::
	.db	"ModularPS",0
	.debug	G _ArchName 32 0
;104 
;105 #define  NUM_ADC   26
;106 #define  NUM_DAC    3
;107 
;108 #define  MAX_DIN   32
;109 #define  MAX_DOUT  16
;110 
;111 
;112 //--- these values can be set LOWER by the application ---
;113 const uint  NumHdwADC = NUM_ADC;
_NumHdwADC::
	.dw	0x1a
	.debug	G _NumHdwADC 7 0
;114 const uint  NumHdwDAC = NUM_DAC;
_NumHdwDAC::
	.dw	0x3
	.debug	G _NumHdwDAC 7 0
;115 
;116 const uint  MaxDIN =  MAX_DIN;
_MaxDIN::
	.dw	0x20
	.debug	G _MaxDIN 7 0
;117 const uint  MaxDOUT = MAX_DOUT;
_MaxDOUT::
	.dw	0x10
	.debug	G _MaxDOUT 7 0
;118 
;119 
;120 //--- NSCL 16-bit analog RCM3200-based ctlrs use port B for SPI to ADCs, DA
;121 #define  ADC_DAC_SPIPort  1  // for most RCM3200-based NSCL ctlr's w/Analog
;122 
;123 
;124 unsigned char  __brdInitFlag;
;125 
;126 #include <hdwDefs.c>
;127 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\arch\hdwDefs.c' 10 49 8 19 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.dseg
_IntVectDesc::
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word (phys @1+15)
	.dw	phys @1+15 >> 16
	.dw	word (phys @1+29)
	.dw	phys @1+29 >> 16
	.dw	word (phys @1+36)
	.dw	phys @1+36 >> 16
	.dw	word (phys @1+43)
	.dw	phys @1+43 >> 16
	.dw	word (phys @1+50)
	.dw	phys @1+50 >> 16
	.dw	word (phys @1+57)
	.dw	phys @1+57 >> 16
	.dw	word (phys @1+65)
	.dw	phys @1+65 >> 16
	.dw	word (phys @1+72)
	.dw	phys @1+72 >> 16
	.dw	word (phys @1+83)
	.dw	phys @1+83 >> 16
	.dw	word (phys @1+97)
	.dw	phys @1+97 >> 16
	.dw	word (phys @1+105)
	.dw	phys @1+105 >> 16
	.dw	word (phys @1+113)
	.dw	phys @1+113 >> 16
	.dw	word (phys @1+122)
	.dw	phys @1+122 >> 16
	.dw	word (phys @1+131)
	.dw	phys @1+131 >> 16
	.dw	word (phys @1+140)
	.dw	phys @1+140 >> 16
	.dw	word (phys @1+149)
	.dw	phys @1+149 >> 16
	.dw	word (phys @1+154)
	.dw	phys @1+154 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	word (phys @1+163)
	.dw	phys @1+163 >> 16
	.dw	word (phys @1+178)
	.dw	phys @1+178 >> 16
	.dw	word (phys @1+191)
	.dw	phys @1+191 >> 16
	.dw	word (phys @1+205)
	.dw	phys @1+205 >> 16
	.dw	word (phys @1+217)
	.dw	phys @1+217 >> 16
	.dw	word (phys @1+226)
	.dw	phys @1+226 >> 16
	.debug	G _IntVectDesc 33 0
	.defseg	FARCONST
	.seg	FARCONST
_hdwCfgParams::
	.dw	0x1
	.dw	0x68
	.dw	0
	.dl	phys _adcGain
	.dl	phys @1+235
	.dw	0
	.dw	0x2
	.dw	0x68
	.dw	0
	.dl	phys _adcOffset
	.dl	phys @1+243
	.dw	0
	.dw	0x3
	.dw	0xc
	.dw	0
	.dl	phys _dacGain
	.dl	phys @1+253
	.dw	0
	.dw	0x4
	.dw	0xc
	.dw	0
	.dl	phys _dacOffset
	.dl	phys @1+261
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.ds	2,0
	.debug	G _hdwCfgParams 35 8
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$newDACCalib::
	ex	(sp),iy
$newDACCalib::
	.debug	G $newDACCalib 37 9
	.debug	{ $newDACCalib 37 193 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@3
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@6
	jr	z,@6
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@6:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@9
	jr	z,@9
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@9:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMin)
	ld	c,phys _setValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMax)
	ld	c,phys _setValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@3:
	.debug	} @3 218

@2	equ	20
	ld	sp,ix
	pop	ix
	lret
@4	equ	22
	.align	4
$$newADCCalib::
	ex	(sp),iy
$newADCCalib::
	.debug	G $newADCCalib 37 9
	.debug	{ $newADCCalib 37 224 @14 @13
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@13
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@16
	jr	z,@16
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@16:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@19
	jr	z,@19
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@19:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMin)
	ld	c,phys _readValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMax)
	ld	c,phys _readValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAIn
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@13:
	.debug	} @13 249

@12	equ	20
	ld	sp,ix
	pop	ix
	lret
@14	equ	22
	.align	4
$$setStateDAC::
	ex	(sp),iy
$setStateDAC::
	.debug	G $setStateDAC 38 9
	.debug	{ $setStateDAC 38 254 @24 @23
	push	ix
	ld	ix,0
	add	ix,sp
	ld	a,(ix+11)
	or	a,a
	jr	z,@25
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	xor	a,a
	ld	(hl),a
	jr	@26
@25:
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@26:
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@23:
	.debug	} @23 262

@22	equ	0
	pop	ix
	lret
@24	equ	2
$initIOvalues::
	.debug	G $initIOvalues 39 9
	.debug	{ $initIOvalues 39 273 @31 @30
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@34:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@35
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-6),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-8),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,b
	ld	l,c
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@39
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@39:
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x6
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xc8
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setAvgPeriodADC
	add	sp,4
	ld	hl,0x7d0
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setNoisePeriodADC
	add	sp,4
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@34
@35:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@42:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@43
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	de,0x3f9a
	ld	bc,0xc61c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@42
@43:
@30:
	.debug	} @30 316

@29	equ	8
	ld	sp,ix
	pop	ix
	lret
@31	equ	10
$resetAvgDataADC::
	.debug	G $resetAvgDataADC 37 9
	.debug	{ $resetAvgDataADC 37 321 @47 @46
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-2),hl
	.seg	FARCODE
	ld	h,d
	ld	l,e
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@46
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	c,e
	ld	de,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@46:
	.debug	} @46 333

@45	equ	2
	ld	sp,ix
	pop	ix
	lret
@47	equ	4
$setAvgPeriodADC::
	.debug	G $setAvgPeriodADC 40 9
	.debug	{ $setAvgPeriodADC 40 339 @51 @50
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@52
	ld	hl,0x1
	jr	@50
@52:
	ld	hl,(_SchedMS)
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	de,(_SchedMS)
	call	__uidiv##
	ld	(ix-2),hl
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@53
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@53:
	ld	hl,(ix-2)
	ld	de,0x64
	or	a,a
	sbc	hl,de
	jr	c,@54
	jr	z,@54
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@54:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@50:
	.debug	} @50 355

@49	equ	2
	ld	sp,ix
	pop	ix
	lret
@51	equ	4
$getAvgPeriodADC::
	.debug	G $getAvgPeriodADC 41 9
	.debug	{ $getAvgPeriodADC 41 361 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@58
	ld	hl,0x1
	jr	@56
@58:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@56:
	.debug	} @56 372

@55	equ	2
	ld	sp,ix
	pop	ix
	lret
@57	equ	4
$getAvgSamplesADC::
	.debug	G $getAvgSamplesADC 41 9
	.debug	{ $getAvgSamplesADC 41 379 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@62
	ld	hl,0x1
	jr	@60
@62:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@60:
	.debug	} @60 390

@59	equ	2
	ld	sp,ix
	pop	ix
	lret
@61	equ	4
$getAvgdRawIn::
	.debug	G $getAvgdRawIn 42 9
	.debug	{ $getAvgdRawIn 42 397 @65 @64
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@66
	ld	de,0
	ld	c,e
	ld	b,e
	jr	@64
@66:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
@64:
	.debug	} @64 413

@63	equ	8
	ld	sp,ix
	pop	ix
	lret
@65	equ	10
$getAvgdAnaIn::
	.debug	G $getAvgdAnaIn 42 9
	.debug	{ $getAvgdAnaIn 42 419 @69 @68
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@70
	ld	de,0
	ld	c,e
	ld	b,e
	jp	@68
@70:
	ld	hl,(ix+5)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@71
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@68
@71:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@68:
	.debug	} @68 437

@67	equ	8
	ld	sp,ix
	pop	ix
	lret
@69	equ	10
$updateAvgsADC::
	.debug	G $updateAvgsADC 39 9
	.debug	{ $updateAvgsADC 39 447 @74 @73
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ex	de,hl
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@77:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@78
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-12),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-14),hl
@82:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xa
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	c,@83
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-12)
	push	hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@86
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@86:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@82
@83:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-12)
	push	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@87
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@87:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	nc,@88
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@88:
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	c,@89
	jr	z,@89
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@89:
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,bc
	or	a,a
	sbc	hl,de
	jr	c,@90
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@90:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@77
@78:
@73:
	.debug	} @73 485

@72	equ	14
	ld	sp,ix
	pop	ix
	lret
@74	equ	16
$setNoisePeriodADC::
	.debug	G $setNoisePeriodADC 40 9
	.debug	{ $setNoisePeriodADC 40 490 @95 @94
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@96
	bool	hl
	ld	l,h
	jr	@94
@96:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
@94:
	.debug	} @94 497

@93	equ	0
	pop	ix
	lret
@95	equ	2
$getNoisePeriodADC::
	.debug	G $getNoisePeriodADC 41 9
	.debug	{ $getNoisePeriodADC 41 502 @99 @98
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@100
	bool	hl
	ld	l,h
	jr	@98
@100:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@98:
	.debug	} @98 511

@97	equ	2
	ld	sp,ix
	pop	ix
	lret
@99	equ	4
$getNoiseADC::
	.debug	G $getNoiseADC 43 9
	.debug	{ $getNoiseADC 43 522 @103 @102
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@104
	bool	hl
	ld	l,h
	jr	@102
@104:
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-4),hl
	ipset	2
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	hl,(ix+7)
	bool	hl
	jr	z,@105
	ld	hl,(ix-4)
	ld	e,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@105:
	ipres
	ld	hl,(ix-2)
@102:
	.debug	} @102 537

@101	equ	4
	ld	sp,ix
	pop	ix
	lret
@103	equ	6
$resetNoiseDataADC::
	.debug	G $resetNoiseDataADC 37 9
	.debug	{ $resetNoiseDataADC 37 542 @108 @107
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@107
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-2),hl
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	inc	de
	inc	de
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	ld	bc,de
	ld	de,0x8
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@107:
	.debug	} @107 557

@106	equ	2
	ld	sp,ix
	pop	ix
	lret
@108	equ	4
;128 
;129 SerialInfo  *spiPort;
;130 
;131 uchar  restoreI1CR;
;132 
;133 
;134 
;135 #define  IFDBK_INPUT  0
;136 #define  VOUT_INPUT   1
;137 #define  VCTRL_INPUT  2
;138 #define  VLIM_INPUT   3
;139 
;140 //=========================================================================
;141 #define  BiasInputs    0x02551550L
;142 #define  CurInputs     0x01aa8aa0L
;143 #define  SpareInputs   0x00006000L
;144 //=========================================================================
;145 _nearcall float adcGetRaw(uint ui)  { return (float) adcRaw[ui]; }
	.align	4
$$adcGetRaw::
	ex	(sp),iy
$adcGetRaw::
	.debug	G $adcGetRaw 42 9
	.debug	{ $adcGetRaw 42 145 @112 @111
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@111:
	.debug	} @111 145

@110	equ	0
	pop	ix
	lret
@112	equ	2
;146 
;147 _nearcall float adcMinRaw(uint ui)  { return 0.0; }
	.align	4
$$adcMinRaw::
	ex	(sp),iy
$adcMinRaw::
	.debug	G $adcMinRaw 42 9
	.debug	{ $adcMinRaw 42 147 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@114:
	.debug	} @114 147

@113	equ	0
	pop	ix
	lret
@115	equ	2
;148 _nearcall float adcMaxRaw(uint ui)  { return (ui > 3) ? 0xfff : 0xffff; }
	.align	4
$$adcMaxRaw::
	ex	(sp),iy
$adcMaxRaw::
	.debug	G $adcMaxRaw 42 9
	.debug	{ $adcMaxRaw 42 148 @118 @117
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@119
	jr	z,@119
	ld	hl,0xfff
	jr	@120
@119:
	ld	hl,0xffff
@120:
	ex	de,hl
	call	__uitof##
@117:
	.debug	} @117 148

@116	equ	0
	pop	ix
	lret
@118	equ	2
;149 
;150 //-------------------------------------------------------------
;151 _nearcall void adcDefaults(uint ui, float *gain, float *offset)
;152 {
	.align	4
$$adcDefaults::
	ex	(sp),iy
$adcDefaults::
	.debug	G $adcDefaults 44 9
	.debug	{ $adcDefaults 44 151 @123 @122
	push	ix
	ld	ix,0
	add	ix,sp
;153   if (ui == VOUT_INPUT)  {
	ld	hl,(ix+5)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@124
;154     *gain = 0.0004578;  *offset = 32767.5;  return; }   // +/-15V
	ld	de,0x4e0
	ld	bc,0x39f0
	jr	@288
;155 
;156   if (ui < 4)  {
@124:
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@127
;157     *gain = 0.0003052;  *offset = 32767.5;  return; }   // +/-10V
	ld	de,0x340
	ld	bc,0x39a0
@288:
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0xff00
	ld	bc,0x46ff
	jr	@287
;158 
;159   if ((1L<<ui) & BiasInputs)  {
@127:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x1550
	ld	bc,0x255
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@130
;160     *gain = 0.003664;  *offset = 0.0;  return; }        // 0-15V
	ld	de,0x1fb8
	ld	bc,0x3b70
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	c,e
	ld	b,e
	jr	@287
;161 
;162   if ((1L<<ui) & CurInputs)  {
@130:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@133
;163       *gain = 0.00004885;  *offset = 2047.5;  return; } // +/-100mA
	ld	de,0xe44a
	ld	bc,0x384c
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0xf000
	ld	bc,0x44ff
@287:
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jr	@122
;164 
;165   *gain = 0.0012212;  *offset = 0.0;                    // 0-5V
@133:
	ld	de,0x10ac
	ld	bc,0x3aa0
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;166 }
@122:
	.debug	} @122 166

@121	equ	0
	pop	ix
	lret
@123	equ	2
;167 //---------------------------------------------------------
;168 _nearcall void adcCalibPoints(uint ui, float *low, float *high)
;169 {
	.align	4
$$adcCalibPoints::
	ex	(sp),iy
$adcCalibPoints::
	.debug	G $adcCalibPoints 44 9
	.debug	{ $adcCalibPoints 44 168 @138 @137
	push	ix
	ld	ix,0
	add	ix,sp
;170   if (ui == VOUT_INPUT)
	ld	hl,(ix+5)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@139
;171     { *low = -10.0;  *high = 10.0;  return; }   // +/-15V
	ld	e,d
	ld	bc,0xc120
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jr	@286
;172 
;173   if (ui < 4)
@139:
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@142
;174     { *low = -9.5;  *high = 9.5;  return; }     // +/-10V
	ld	e,d
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@286:
	ld	b,0x41
	jr	@285
;175 
;176   if ((1L<<ui) & BiasInputs)
@142:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x1550
	ld	bc,0x255
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@145
;177     { *low = 0.5;  *high = 9.5;  return; }      // 0-15V
	ld	de,0
	ld	bc,0x3f00
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	bc,0x4118
	jr	@285
;178 
;179   if ((1L<<ui) & CurInputs)  {
@145:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@148
;180      *low = -0.095;  *high = 0.095;  return; }  // +/-100mA
	ld	de,0x8f5c
	ld	bc,0xbdc2
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x3d
@285:
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jr	@137
;181 
;182   *low = 0.5;  *high = 4.5;                     // 0-5V
@148:
	ld	de,0
	ld	bc,0x3f00
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	bc,0x4090
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;183 }
@137:
	.debug	} @137 183

@136	equ	0
	pop	ix
	lret
@138	equ	2
;184 //---------------------------------------------------------
;185 _nearcall char *adcUnits(uint ui, char *buf)  {
	.align	4
$$adcUnits::
	ex	(sp),iy
$adcUnits::
	.debug	G $adcUnits 45 9
	.debug	{ $adcUnits 45 185 @153 @152
	push	ix
	ld	ix,0
	add	ix,sp
;186    return ((1L<<ui) & CurInputs) ? "A" : "V"; }
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@154
	ld	hl,@155
	jr	@152
@154:
	ld	hl,@155+2
@152:
	.debug	} @152 186

@151	equ	0
	pop	ix
	lret
@153	equ	2
;187 
;188 
;189 //=========================================================================
;190 _nearcall float dacGetRaw(uint ui)  { return (float) dacRaw[ui]; }
	.align	4
$$dacGetRaw::
	ex	(sp),iy
$dacGetRaw::
	.debug	G $dacGetRaw 42 9
	.debug	{ $dacGetRaw 42 190 @159 @158
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@158:
	.debug	} @158 190

@157	equ	0
	pop	ix
	lret
@159	equ	2
;191 
;192 _nearcall float dacMinRaw(uint ui)  { return 0.0; }
	.align	4
$$dacMinRaw::
	ex	(sp),iy
$dacMinRaw::
	.debug	G $dacMinRaw 42 9
	.debug	{ $dacMinRaw 42 192 @162 @161
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@161:
	.debug	} @161 192

@160	equ	0
	pop	ix
	lret
@162	equ	2
;193 _nearcall float dacMaxRaw(uint ui)  { return (float)0xffffL; }
	.align	4
$$dacMaxRaw::
	ex	(sp),iy
$dacMaxRaw::
	.debug	G $dacMaxRaw 42 9
	.debug	{ $dacMaxRaw 42 193 @165 @164
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xff00
	ld	bc,0x477f
@164:
	.debug	} @164 193

@163	equ	0
	pop	ix
	lret
@165	equ	2
;194 
;195 _nearcall void dacDefaults(uint ui, float *gain, float *offset)
;196   {  *gain = 0.0003125;  *offset = 32767.5;  }  // +/- 10.24V
	.align	4
$$dacDefaults::
	ex	(sp),iy
$dacDefaults::
	.debug	G $dacDefaults 44 9
	.debug	{ $dacDefaults 44 195 @168 @167
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xd70a
	ld	bc,0x39a3
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0xff00
	ld	bc,0x46ff
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@167:
	.debug	} @167 196

@166	equ	0
	pop	ix
	lret
@168	equ	2
;197 
;198 _nearcall void dacCalibPoints(uint ui, float *low, float *high)
;199   {  *low = -9.5;  *high = 9.5; }
	.align	4
$$dacCalibPoints::
	ex	(sp),iy
$dacCalibPoints::
	.debug	G $dacCalibPoints 44 9
	.debug	{ $dacCalibPoints 44 198 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@170:
	.debug	} @170 199

@169	equ	0
	pop	ix
	lret
@171	equ	2
;200 
;201 _nearcall char *dacUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$dacUnits::
	ex	(sp),iy
$dacUnits::
	.debug	G $dacUnits 45 9
	.debug	{ $dacUnits 45 201 @174 @173
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@155+2
@173:
	.debug	} @173 201

@172	equ	0
	pop	ix
	lret
@174	equ	2
;202 
;203 //=========================================================================
;204 
;205 
;206 //-------------------------------------------------------------------------
;207 
;208 /* START FUNCTION DESCRIPTION ********************************************
;209 Function: int _readExtioPort ( int port );
;210 
;211 Note:
;212 This function is setup to provide additional hold time when
;213 accessing external I/O addresses 0000 and 0002. This routine
;214 must stay         and not be changed, for the additional
;215 address hold-time to be valid.
;216 
;217 Improved by Softools to not require a copy to RAM because
;218 real tools have align and other stuff for real programmers.
;219 ************************************************************/
;220 /*
;221 unsigned readExtIO (unsigned port)      // Port is 0 or 2
;222 {
;223 #asm
;224     push    ip
;225     ipset   3
;226     ld      a,l
;227     and     a,0x03
;228     jr      z,..read0
;229     jr      ..skip
;230     .align  4           ; Align to clear A0 & A1
;231 ..read0:
;232     nop                 ; A0 = 0, A1 = 0
;233     nop                 ; A0 = 1, A1 = 0
;234     ioe     ld l,(hl)   ; A0 = 0, A1 = 1
;235     pop     ip          ; A0 = 0, A1 = 0
;236     jr      ..exit
;237     .align  4           ; Align to clear A0 & A1
;238 ..skip:
;239     ioe     ld l,(hl)   ; A0 = 0, A1 = 0 (2 bytes)
;240     pop     ip          ; A0 = 0, A1 = 1
;241 ..exit:
;242 #endasm
;243 }
;244 */
;245 
;246 //-------------------------------------------------------------------------
;247 //  determine the device ID based on external hardware settings
;248 //-------------------------------------------------------------------------
;249 ulong ReadDeviceID()
;250 {
$ReadDeviceID::
	.debug	G $ReadDeviceID 47 9
	.debug	{ $ReadDeviceID 47 249 @177 @176
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;251   uchar  inA, devID;
;252 
;253 
;254   inA = ini(PADR);
	ioi ld	a,(48)
	ld	(ix-1),a
;255 
;256 //--- device ID comes from 8-bit switch input ----
;257 //--- bits need to be reversed and then inverted ---
;258   devID = 0;
	xor	a,a
	ld	(ix-2),a
;259   if (inA & 0x01)  devID |= 0x80;
	ld	a,(ix-1)
	and	a,1
	jr	z,@178
	set	7,(ix-2)
;260   if (inA & 0x02)  devID |= 0x40;
@178:
	ld	a,(ix-1)
	and	a,2
	jr	z,@179
	set	6,(ix-2)
;261   if (inA & 0x04)  devID |= 0x20;
@179:
	ld	a,(ix-1)
	and	a,4
	jr	z,@180
	set	5,(ix-2)
;262   if (inA & 0x08)  devID |= 0x10;
@180:
	ld	a,(ix-1)
	and	a,8
	jr	z,@181
	set	4,(ix-2)
;263   if (inA & 0x10)  devID |= 0x08;
@181:
	ld	a,(ix-1)
	and	a,16
	jr	z,@182
	set	3,(ix-2)
;264   if (inA & 0x20)  devID |= 0x04;
@182:
	ld	a,(ix-1)
	and	a,32
	jr	z,@183
	set	2,(ix-2)
;265   if (inA & 0x40)  devID |= 0x02;
@183:
	ld	a,(ix-1)
	and	a,64
	jr	z,@184
	set	1,(ix-2)
;266   if (inA & 0x80)  devID |= 0x01;
@184:
	ld	a,(ix-1)
	and	a,128
	jr	z,@185
	set	0,(ix-2)
;267   devID = ~devID;
@185:
	ld	a,(ix-2)
	cpl	a
	ld	(ix-2),a
;268 
;269   return (ulong) devID;
	ld	e,a
	ld	bc,0
	ld	d,c
;270 }
@176:
	.debug	} @176 270

@175	equ	2
	ld	sp,ix
	pop	ix
	lret
@177	equ	4
;271 
;272 //-------------------------------------------------------------------------
;273 //  Return the current state of the digital inputs
;274 //
;275 //  The digital inputs are connected to a series of octal line drivers whos
;276 //  outputs are connected to the parallel G signal lines.  To read all the
;277 //  inputs, we enable the drivers one at a time and read the state of the G
;278 //  lines, adding the result to previously read bits.
;279 //
;280 //  The digital inputs and outputs are address in groups of 8 bits.  Which
;281 //  group of 8 bits we are setting or reading is controlled by a 3-to-8 lin
;282 //  decoder, where toggling one of its 8 outputs low latches the desired
;283 //  data.
;284 //
;285 //  To avoid activating the wrong one of the 8 outputs even for a moment, w
;286 //  have to make sure the 3 inputs that specify which output to toggle low
;287 //  are all stable BEFORE we enable the outputs and while we are disabling
;288 //  the outputs.
;289 //-------------------------------------------------------------------------
;290 ulong ReadDigInputs()
;291 {
$ReadDigInputs::
	.debug	G $ReadDigInputs 47 9
	.debug	{ $ReadDigInputs 47 290 @188 @187
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-9
;292   ulong  inBits0, inBits1;
;293   uchar  otherBits = srPBDR & 0x87;
	ld	a,(_srPBDR)
	and	a,135
	ld	(ix-9),a
	.seg	FARCODE
;294 
;295 
;296 //--- To insure that only the intended Y output changes state, we need to -
;297 //--- apply the bits that select which output, enable the Y outputs, ---
;298 //--- then disable the Y outputs without changing the selection bits. ---
;299 //--- If we change the selection bits at the same time that we enable ---
;300 //--- the Y outputs, then we run the risk of causing other outputs to ---
;301 //--- briefly change state.  This could be especially bad if one of them --
;302 //--- causes one of the sets of digital output latches to change state ---
;303 
;304 //--- read Front Panel inputs --- (Y6)
;305   outi(PBDR, srPBDR = otherBits | 0x38 );  // select /Y6
	or	a,56
	ld	(_srPBDR),a
	ioi ld	(64),a
;306   outi(PBDR, srPBDR = otherBits | 0x18 );  // /Y6 low to enable driver
	ld	a,(ix-9)
	or	a,24
	ld	(_srPBDR),a
	ioi ld	(64),a
;307   inBits1 = ini(PGDR);                     // read the data
	ioi ld	a,(72)
	ld	e,a
	ld	bc,0
	ld	d,c
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;308   outi(PBDR, srPBDR = otherBits | 0x38 );  // /Y6 high again
	ld	a,(ix-9)
	or	a,56
	ld	(_srPBDR),a
	ioi ld	(64),a
;309 
;310 //--- read input bits 24-31 --- (Y5)
;311   outi(PBDR, srPBDR = otherBits | 0x70 );  // select /Y5
	ld	a,(ix-9)
	or	a,112
	ld	(_srPBDR),a
	ioi ld	(64),a
;312   outi(PBDR, srPBDR = otherBits | 0x50 );  // /Y5 low to enable driver
	ld	a,(ix-9)
	or	a,80
	ld	(_srPBDR),a
	ioi ld	(64),a
;313   inBits0 = (ulong)ini(PGDR);              // read the data
	ioi ld	a,(72)
	ld	e,a
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;314   outi(PBDR, srPBDR = otherBits | 0x70 );  // /Y5 high again
	ld	a,(ix-9)
	or	a,112
	ld	(_srPBDR),a
	ioi ld	(64),a
;315 
;316 //--- read input bits 16-23 --- (Y4)
;317   outi(PBDR, srPBDR = otherBits | 0x30 );  // select /Y4
	ld	a,(ix-9)
	or	a,48
	ld	(_srPBDR),a
	ioi ld	(64),a
;318   outi(PBDR, srPBDR = otherBits | 0x10 );  // /Y4 low to enable driver
	ld	a,(ix-9)
	or	a,16
	ld	(_srPBDR),a
	ioi ld	(64),a
;319   inBits0 = (inBits0 << 8) | (ulong) ini(PGDR);  // read the data
	ld	d,e
	ld	e,c
	ioi ld	a,(72)
	push	bc
	push	de
	ld	e,a
	ld	d,c
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;320   outi(PBDR, srPBDR = otherBits | 0x70 );  // /Y4 high again
	ld	a,(ix-9)
	or	a,112
	ld	(_srPBDR),a
	ioi ld	(64),a
;321 
;322 //--- read input bits 08-15 --- (Y3)
;323   outi(PBDR, srPBDR = otherBits | 0x68 );  // select /Y3
	ld	a,(ix-9)
	or	a,104
	ld	(_srPBDR),a
	ioi ld	(64),a
;324   outi(PBDR, srPBDR = otherBits | 0x48 );  // /Y3 low to enable driver
	ld	a,(ix-9)
	or	a,72
	ld	(_srPBDR),a
	ioi ld	(64),a
;325   inBits0 = (inBits0 << 8) | (ulong) ini(PGDR);  // read the data
	ld	b,c
	ld	c,d
	ld	d,e
	ld	e,0
	ioi ld	a,(72)
	push	bc
	push	de
	ld	e,a
	ld	bc,0
	ld	d,c
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;326   outi(PBDR, srPBDR = otherBits | 0x68 );  // /Y3 high again
	ld	a,(ix-9)
	or	a,104
	ld	(_srPBDR),a
	ioi ld	(64),a
;327 
;328 //--- read input bits 00-07 --- (Y2)
;329   outi(PBDR, srPBDR = otherBits | 0x28 );  // selct /Y2
	ld	a,(ix-9)
	or	a,40
	ld	(_srPBDR),a
	ioi ld	(64),a
;330   outi(PBDR, srPBDR = otherBits | 0x08 );  // /Y2 low to enable driver
	ld	a,(ix-9)
	or	a,8
	ld	(_srPBDR),a
	ioi ld	(64),a
;331   inBits0 = (inBits0 << 8) | (ulong) ini(PGDR);  // read the data
	ld	b,c
	ld	c,d
	ld	d,e
	ld	e,0
	ioi ld	a,(72)
	push	bc
	push	de
	ld	e,a
	ld	bc,0
	ld	d,c
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;332   outi(PBDR, srPBDR = otherBits | 0x28 );  // /Y2 high again
	ld	a,(ix-9)
	or	a,40
	ld	(_srPBDR),a
	ioi ld	(64),a
;333 
;334 
;335   outi(PBDR, srPBDR = otherBits | 0x20);  // disable all drivers
	ld	a,(ix-9)
	or	a,32
	ld	(_srPBDR),a
	ioi ld	(64),a
;336 
;337   inBits0 = (inBits0 & ~forcedDigInMask) | forcedDigInBits;
	ld	de,(_forcedDigInMask)
	ld	bc,(_forcedDigInMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigInBits)
	ld	bc,(_forcedDigInBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;338   inBits1 = (inBits1 & ~forcedExtraInMask) | forcedExtraInBits;
	ld	de,(_forcedExtraInMask)
	ld	bc,(_forcedExtraInMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedExtraInBits)
	ld	bc,(_forcedExtraInBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;339 
;340   extraIn = inBits1;
	ld	(_extraIn),de
	ld	(_extraIn+2),bc
;341 
;342   return inBits0;
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;343 }
@187:
	.debug	} @187 343

@186	equ	9
	ld	sp,ix
	pop	ix
	lret
@188	equ	11
;344 
;345 
;346 //-------------------------------------------------------------------------
;347 //  set the state of the digital outputs
;348 //
;349 //  The digital inputs and outputs are address in groups of 8 bits.  Which
;350 //  group of 8 bits we are setting or reading is controlled by a 3-to-8 lin
;351 //  decoder, where toggling one of its 8 outputs low latches the desired
;352 //  data.
;353 //
;354 //  To avoid activating the wrong one of the 8 outputs even for a moment, w
;355 //  have to make sure the 3 inputs that specify which output to toggle low
;356 //  are all stable BEFORE we enable the outputs and while we are disabling
;357 //  the outputs.
;358 //-------------------------------------------------------------------------
;359 void WriteDigOutputs(ulong digOut)
;360 {
$WriteDigOutputs::
	.debug	G $WriteDigOutputs 48 9
	.debug	{ $WriteDigOutputs 48 359 @191 @190
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-5
;361   ulong  outBits;
;362   uchar  otherBits = srPBDR & 0x87;
	ld	a,(_srPBDR)
	and	a,135
	ld	(ix-5),a
	.seg	FARCODE
;363 
;364 
;365   digOut = (digOut & ~forcedDigOutMask) | forcedDigOutBits;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;366 
;367   outBits = ~digOut;
	call	__lnot##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;368 
;369 //--- set digital I/O bus (port G) to output mode ---
;370   outi(PGDDR, srPGDDR = 0xFF);
	ld	a,0xff
	ld	(_srPGDDR),a
	ioi ld	(79),a
;371 
;372 //--- update output bits 00-07 --- (Y0)
;373   outi(PGDR, srPGDR = (uchar)outBits);          // put value on bus
	ld	a,(ix-4)
	ld	(_srPGDR),a
	ioi ld	(72),a
;374   outi(PBDR, srPBDR = otherBits | 0x20);        // select /Y0
	ld	a,(ix-5)
	or	a,32
	ld	(_srPBDR),a
	ioi ld	(64),a
;375   outi(PBDR, srPBDR = otherBits );              // enable outputs (/Y0 low)
	ld	a,(ix-5)
	ld	(_srPBDR),a
	ioi ld	(64),a
;376   outi(PBDR, srPBDR = otherBits | 0x20);        // disable outputs (all hig
	or	a,32
	ld	(_srPBDR),a
	ioi ld	(64),a
;377 
;378 //--- update output bits 08-15 --- (Y1)
;379   outi(PGDR, srPGDR = (uchar)(outBits >> 8));   // put value on bus
	ld	e,d
	ld	d,c
	ld	c,b
	ld	b,0
	ld	a,e
	ld	(_srPGDR),a
	ioi ld	(72),a
;380   outi(PBDR, srPBDR = otherBits | 0x60);        // select /Y1
	ld	a,(ix-5)
	or	a,96
	ld	(_srPBDR),a
	ioi ld	(64),a
;381   outi(PBDR, srPBDR = otherBits | 0x40 );       // enable outputs (/Y1 low)
	ld	a,(ix-5)
	or	a,64
	ld	(_srPBDR),a
	ioi ld	(64),a
;382   outi(PBDR, srPBDR = otherBits | 0x60);        // disable outputs (all hig
	ld	a,(ix-5)
	or	a,96
	ld	(_srPBDR),a
	ioi ld	(64),a
;383 
;384 //--- set digital I/O bus (port G) back to input mode ---
;385   outi(PGDDR, srPGDDR = 0x00);
	xor	a,a
	ld	(_srPGDDR),a
	ioi ld	(79),a
;386 }
@190:
	.debug	} @190 386

@189	equ	5
	ld	sp,ix
	pop	ix
	lret
@191	equ	7
;387 
;388 
;389 //-------------------------------------------------------------------------
;390 //  Function to communicate with a TLC2543 (an 11-channel, 12-bit ADC)
;391 //
;392 //  This functions initiates a conversion for the specified input and saves
;393 //  the result of the previous conversion (initiated by the previous call t
;394 //  this function).
;395 //
;396 //  Inputs:
;397 //    chipSel:  0-1
;398 //    nextChan: 0-14 (12-14 return test voltages)
;399 //-------------------------------------------------------------------------
;400 void convertTLC2543(uchar chipSel, uint nextChan)
;401 {
$convertTLC2543::
	.debug	G $convertTLC2543 49 9
	.debug	{ $convertTLC2543 49 400 @194 @193
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-13
;402   uchar  yNum, eocMask;
;403   uint  i, raw;  //chan
;404   uchar  xmitBuf[2], rcvBuf[2];
;405   uint  *prevCh;
;406   bool  convDone;
;407   static uint  prevChan[2] = { 4, 15 };
	.dseg
@195:
	.dw	0x4
	.dw	0xf
	.seg	FARCODE
;408 
;409 
;410   chipSel &= 1;  eocMask = 0x40 << chipSel;
	ld	a,(ix+5)
	and	a,1
	ld	(ix+5),a
	ld	hl,0x40
	or	a,a
	jr	z,@196
	ld	b,a
@197:
	add	hl,hl
	djnz	@197
@196:
	ld	(ix-2),l
;411   prevCh = prevChan + (uint)chipSel;
	bool	hl
	ld	l,(ix+5)
	add	hl,hl
	ld	de,@195
	add	hl,de
	ld	(ix-12),hl
;412 
;413   xmitBuf[0] = (nextChan << 4) | 0x0C;  xmitBuf[1] = 0;
	ld	hl,(ix+7)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,12
	or	hl,de
	ld	(ix-8),l
	xor	a,a
	ld	(ix-7),a
;414 
;415 //--- wait for EOC to go high ---
;416   for (i=0,convDone=false; i<100; ++i)  {
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	xor	a,a
	ld	(ix-13),a
@200:
	ld	hl,(ix-4)
	ld	de,0x64
	or	a,a
	sbc	hl,de
	jr	nc,@201
;417     if (ini(PFDR) & eocMask)  { convDone = true;  break; }
	ioi ld	a,(56)
	ld	hl,(ix-2)
	and	a,l
	jr	z,@205
	ld	a,0x1
	ld	(ix-13),a
	jr	@201
;418     resetWDT();
@205:
	lcall	$resetWDT
;419   }
;420 
;421 //--- select one of the 2 ADC chips (Y3 and Y4 outputs of 3-to-8 decoder) -
;422 //--- (Y# output set by PD5-PD4-PE3) ---
;423   yNum = chipSel + 3;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@200
@201:
	ld	a,(ix+5)
	add	a,3
	ld	(ix-1),a
;424   outi(PEDR, srPEDR = (srPEDR & 0xF7) | (yNum&1)<<3 );
	ld	a,(_srPEDR)
	and	a,247
	ld	hl,(ix-1)
	ld	h,a
	ld	a,l
	ld	l,h
	and	a,1
	ld	d,0
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	d,0
	or	hl,de
	ld	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;425   outi(PDDR, srPDDR = (srPDDR & 0xCF) | (yNum&6)<<3 );
	ld	a,(_srPDDR)
	and	a,207
	ld	hl,(ix-1)
	ld	h,a
	ld	a,l
	ld	l,h
	and	a,6
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	d,0
	or	hl,de
	ld	a,l
	ld	(_srPDDR),a
	ioi ld	(96),a
;426 
;427 //--- enable selected decoder output line to set specified /CS low ---
;428   outi(PBDR, srPBDR &= 0x7F);  // PB7 ctls decoder output
	ld	a,(_srPBDR)
	and	a,127
	ld	(_srPBDR),a
	ioi ld	(64),a
;429 
;430 //--- tell ADC what input to begin conversion on and read result of the ---
;431 //--- conversion started by the previous call to this func ---
;432   _spiWrRd_(spiPort, xmitBuf, rcvBuf, 2);
	ld	hl,0x2
	push	hl
	ld	hl,-8+@192
	add	hl,sp
	push	hl
	ld	hl,-4+@192
	add	hl,sp
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;433 
;434 //--- disable decoder outputs to bring /CS high ---
;435   outi(PBDR, srPBDR |= 0x80);  // PB7 ctls decoder output
	ld	a,(_srPBDR)
	or	a,128
	ld	(_srPBDR),a
	ioi ld	(64),a
;436 
;437 //--- extract the raw value from the bytes just read ---
;438   if (convDone)
	ld	a,(ix-13)
	or	a,a
	jr	z,@208
;439     raw = ((uint)rcvBuf[0] << 4) | (rcvBuf[1] >> 4);
	bool	hl
	ld	l,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	d,0
	ld	e,(ix-9)
	ex	de,hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	hl,de
	ld	(ix-6),hl
;440   else
;441     raw = 0xBAD;
	jr	@209
@208:
	ld	hl,0xbad
	ld	(ix-6),hl
;442   adcRaw[(*prevCh)] = raw;
@209:
	ld	hl,(ix-12)
	ld	hl,(hl)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;443 
;444 //--- keep track of what channel we started the conversion on, cause that -
;445 //--- is the channel whose value will be read during the next call for ---
;446 //--- the same chip ---
;447   *prevCh = chipSel * 11 + nextChan + 4;
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0xb
	ex	de,hl
	mul
	ld	hl,(ix+7)
	add	hl,bc
	ld	e,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;448 }
@193:
	.debug	} @193 448

@192	equ	13
	ld	sp,ix
	pop	ix
	lret
@194	equ	15
;449 
;450 
;451 //-------------------------------------------------------------------------
;452 //  Function to communicate with an ADS7825 chip (a 4-channel, 16-bit ADC)
;453 //
;454 //  Call:
;455 //    convertADS7825(uint nextChan)
;456 //
;457 //    Input:
;458 //       nextChan: Channel # to sample between calls and to do conversion
;459 //                 on during the next call.
;460 //
;461 //    Result:
;462 //       The raw value for the channel specified during the previous call
;463 //       is updated.
;464 //
;465 //
;466 //  To maximize the conversion rate, the ADS7825 begins acquiring/sampling
;467 //  the signal to be converted as soon as the previous conversion is
;468 //  completed.  This requires that it already know what channel to begin
;469 //  sampling, so you have to tell it what channel to sample for the NEXT
;470 //  conversion, NOT the current conversion.
;471 //
;472 //  NOTE that this does NOT mean that the conversion initiated by this call
;473 //  is for outdated data.  The ADS7825 is sampling the channel specified
;474 //  during the last call right up to the time it is told to start the
;475 //  conversion.  The only catch is you have to know what channel that was
;476 //  so when you read the conversion data you know what channel it is for.
;477 //
;478 //  The ADC7825 is fairly unique in that it has a TAG input that allows
;479 //  multiple ADC's to be connected in a daisy-chain configuration, allowing
;480 //  you to initiate a conversion on multiple chips at the same time and the
;481 //  read the results from all of them in a single operation.  This greatly
;482 //  decreases the additonal time needed to support more than 4 channels whe
;483 //  the chips are connected in this manner.
;484 //
;485 //  NOTE:  The downside, of course, is the cost per input, both in $ and in
;486 //         board space.  Only 4 inputs means never more than 4 passes to
;487 //         read any # of channels.  It also means one more (expensive) chip
;488 //         for each additional group of 4 channels.
;489 //
;490 //-------------------------------------------------------------------------
;491 void convertADS7825(uint nextChan)
;492 {
$convertADS7825::
	.debug	G $convertADS7825 37 9
	.debug	{ $convertADS7825 37 491 @212 @211
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
;493   uchar  buf[10];
;494   static uint  prevChan = 0;
	.dseg
@213:
	.dw	0
	.seg	FARCODE
;495 
;496 
;497   nextChan &= 3;
	ld	hl,(ix+5)
	ld	de,0x3
	and	hl,de
	ld	(ix+5),hl
;498 
;499 //--- Set the bits that will tell the ADC which channel to sample between -
;500 //--- calls to this func, and to hold and convert during the next call ---
;501 //--- (PE6 and PE7 are connected to ADR0 and ADR1 on all ADC's) ---
;502   outi(PEDR, srPEDR = (srPEDR & 0x3F) | (nextChan << 6));
	ld	a,(_srPEDR)
	and	a,63
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	e,a
	or	hl,de
	ld	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;503 
;504 //--- set R/C- low first so we can use CS- to start conversion ---
;505   outi(PFDR, srPFDR &= 0xF7);  // R/C- (PF3) low (convert)
	ld	a,(_srPFDR)
	and	a,247
	ld	(_srPFDR),a
	ioi ld	(56),a
;506 
;507 //--- Toggle /CS low then high very quickly.  This starts the conversion --
;508 //--- on the previously specified input and latches the input # to be used 
;509 //--- for the next conversion.  /CS must be low for at least 40ns, but must
;510 //--- go high again before BUSY does (aprox 25us).  If /CS is still low whe
;511 //--- BUSY goes high, the next conversion will start and the results of the
;512 //--- previous one will be lost ---
;513   _EnterCritical_();
	ipset	2
;514   outi(PFDR, srPFDR &= 0xFB);  // /CS (PF2) low
	ld	a,(_srPFDR)
	and	a,251
	ld	(_srPFDR),a
	ioi ld	(56),a
;515   outi(PFDR, srPFDR |= 0x04);  // /CS (PF2) high
	ld	a,(_srPFDR)
	or	a,4
	ld	(_srPFDR),a
	ioi ld	(56),a
;516   _ExitCritical_();
	ipres
;517 
;518 //--- set R/C- high to enable read mode ---
;519   outi(PFDR, srPFDR |= 0x08);  // R/C- (PF3) high
	ld	a,(_srPFDR)
	or	a,8
	ld	(_srPFDR),a
	ioi ld	(56),a
;520 
;521 //--- The design did not include the ability to read the BUSY signal, so --
;522 //--- add a short delay to avoid trying to read the data before it is ready
;523   for (uint xx=0; xx<23; ++xx);
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	.seg	FARCODE
@216:
	ld	hl,(ix-12)
	ld	de,0x17
	or	a,a
	sbc	hl,de
	jr	nc,@217
;524 
;525 //--- set /CS low to enable transmission of data ---
;526   outi(PFDR, srPFDR &= 0xFB);  // /CS (PF2) low
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	jr	@216
@217:
	ld	a,(_srPFDR)
	and	a,251
	ld	(_srPFDR),a
	ioi ld	(56),a
;527 
;528 //--- The ModularPS controller does not have ADC's chained together, so we 
;529 //--- get just one channel's value each time.  NOTE that the ADC sends us -
;530 //--- 17 bits (2+ bytes), the first of which is NOT part of the data. ---
;531   _spiRead_(spiPort, buf, 3, false);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,-6+@210
	add	hl,sp
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiRead_
	add	sp,8
;532 
;533 //--- set /CS high so ADC does not react to clock pulses not meant for it -
;534   outi(PFDR, srPFDR |= 0x04);  // /CS (PF2) high
	ld	a,(_srPFDR)
	or	a,4
	ld	(_srPFDR),a
	ioi ld	(56),a
;535 
;536 //--- extract the raw value from the bytes just read ---
;537   adcRaw[prevChan] = (uint) (0x8000 ^ (
;538       ((uint)buf[0] << 9) |
;539       ((uint)buf[1] << 1) |
;540       ((uint)buf[2] >> 7)
;541     ) );
	bool	hl
	ld	h,(ix-10)
	ld	l,0
	add	hl,hl
	ld	d,0
	ld	e,(ix-9)
	ex	de,hl
	add	hl,hl
	or	hl,de
	ld	d,0
	ld	e,(ix-8)
	ex	de,hl
	ld	a,0x7
	call	__uishr##
	or	hl,de
	ld	a,h
	xor	a,128
	ld	h,a
	ld	de,(@213)
	ex	de,hl
	add	hl,hl
	ld	bc,de
	ld	de,_adcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;542 
;543 //--- keep track of what channel we started the conversion on, cause that -
;544 //--- is the channel whose value will be read during the next call ---
;545   prevChan = nextChan;
	ld	hl,(ix+5)
	ld	(@213),hl
;546 }
@211:
	.debug	} @211 546

@210	equ	12
	ld	sp,ix
	pop	ix
	lret
@212	equ	14
;547 
;548 //-------------------------------------------------------------------------
;549 //  Read the Analog inputs
;550 //
;551 //  The Modular Power Supply board has 3 ADC chips:
;552 //    (1)  4-channel, 16-bit ADC7825
;553 //    (2) 11-channel, 12-bit TLC2543
;554 //
;555 //  In contrast, the TLC2543's are inexpensive and provide nearly 3 times a
;556 //  many inputs.  Aside from the lower resolution, the main disadvantage is
;557 //  that reading a given number of channels takes much longer, since 11 rea
;558 //  convert cycles must be done per chip, and the cycles cannot be applied 
;559 //  more than one chip at a time like they can with the ADC7825.
;560 //
;561 //  In this case, the requirements called for reading lots of channels with
;562 //  few chips as possible.  Given that the ADC7825 is quite a bit more
;563 //  expensive than the TCL2543 (especially on a per-channel basis), the
;564 //  less expensive TLC2543 was chosen for those inputs where speed and
;565 //  resolution was not an issue.
;566 //-------------------------------------------------------------------------
;567 void readAnalogInputs(ulong mask)
;568 {
$readAnalogInputs::
	.debug	G $readAnalogInputs 48 9
	.debug	{ $readAnalogInputs 48 567 @221 @220
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;569   uint  nextChan;
;570   static uint  ticks;
	.bseg
@222:
	.ds	2
	.seg	FARCODE
;571   static uint  waitTicks = 20, lastLogged = 0;
	.dseg
@223:
	.dw	0x14
	.seg	FARCODE
	.dseg
@224:
	.dw	0
	.seg	FARCODE
;572 
;573 
;574 //--- We use the fact that this is called periodically but NOT by ISRs. --
;575 //--- This allows us to check for a temporarily disabled INT1 ISR ---
;576 //--- and re-enable it (after a bunch of nested INTs have "unwound") ---
;577   if (restoreI1CR)  if (--waitTicks == 0)  {
	ld	a,(_restoreI1CR)
	or	a,a
	jr	z,@225
	ld	hl,(@223)
	dec	hl
	ld	(@223),hl
	bool	hl
	jr	nz,@226
;578     if (msSince_(lastLogged) > 30000)  {
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(@224)
	or	a,a
	sbc	hl,de
	ld	de,0x7530
	or	a,a
	sbc	hl,de
	jr	c,@229
	jr	z,@229
;579       printf("*** Excessive INT1 occurances detected ***\r\n");
	ld	de,word (phys @1+271)
	ld	c,phys @1+271 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;580       lastLogged = GetMS_();
	ld	hl,(__TimerMilliSeconds+4)
	ld	(@224),hl
;581     }
;582     _EnterCritical_();
@229:
	ipset	2
;583     outi(I1CR, srI1CR = restoreI1CR);  // reenable INT1
	ld	a,(_restoreI1CR)
	ld	(_srI1CR),a
	ioi ld	(153),a
;584     restoreI1CR = 0;  waitTicks = 20;
	xor	a,a
	ld	(_restoreI1CR),a
	ld	hl,0x14
	ld	(@223),hl
;585     _ExitCritical_();
	ipres
;586   }
;587 
;588 
;589   if (! spiPort)  return;
@226:
@225:
	ld	hl,(_spiPort)
	bool	hl
	jr	z,@220
;590 
;591 
;592 //===== process the 4 inputs on the ADC7825 first =====
;593 
;594 //--- Remember we have to tell the ADC which channel's data we will read --
;595 //--- NEXT time we call it, so consistently using the sequence 1, 2, 3, 0 -
;596 //--- each time means we get the data for 0, 1, 2, 3.  Also remember that -
;597 //--- this means channel 0 will be continously sampled (READY for conversio
;598 //--- between calls to this function ---
;599   _spiConfig_(spiPort, CLK_1MHz, NORM_LOW_LATCH_FALL);
	ld	l,0x1
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;600   convertADS7825(1);  // chan to convert NEXT call
	ld	hl,0x1
	push	hl
	lcall	$convertADS7825
	pop	hl
;601   convertADS7825(2);  // chan to convert NEXT call
	ld	hl,0x2
	push	hl
	lcall	$convertADS7825
	pop	hl
;602   convertADS7825(3);  // chan to convert NEXT call
	ld	hl,0x3
	push	hl
	lcall	$convertADS7825
	pop	hl
;603   convertADS7825(0);  // chan to convert NEXT call
	bool	hl
	ld	l,h
	push	hl
	lcall	$convertADS7825
	pop	hl
;604 
;605 
;606 //--- There are 22 channels total for the 2 TLC2543 ADC's, and they don't -
;607 //--- support the TAG feature, so getting RECENT data for all 22 channels -
;608 //--- would require making 24 consecutive calls, which would take too long.
;609 
;610 //--- Since the timing and sample rate for these inputs is not critical, --
;611 //--- we read just one from each chip for each call to this function ---
;612   _spiConfig_(spiPort, CLK_1MHz, NORM_LOW_LATCH_RISE);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;613   nextChan = ++ticks % 11;
	ld	hl,(@222)
	inc	hl
	ld	(@222),hl
	ld	de,0xb
	call	__uidiv##
	ex	de,hl
	ld	(ix-2),hl
;614   convertTLC2543(0, nextChan);
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$convertTLC2543
	add	sp,4
;615   convertTLC2543(1, nextChan);
	ld	hl,(ix-2)
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$convertTLC2543
	add	sp,4
;616 }
@220:
	.debug	} @220 616

@219	equ	2
	ld	sp,ix
	pop	ix
	lret
@221	equ	4
;617 
;618 
;619 //-------------------------------------------------------------------------
;620 //  Update the state of the AD5542 DAC chips
;621 //-------------------------------------------------------------------------
;622 void writeAnalogOutputs(ulong mask)
;623 {
$writeAnalogOutputs::
	.debug	G $writeAnalogOutputs 48 9
	.debug	{ $writeAnalogOutputs 48 622 @235 @234
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
;624   uchar  buf[2];
;625   uint   rawVal, bitTest;
;626   uchar  i;
;627 
;628 
;629   if (! spiPort)  return;
	ld	hl,(_spiPort)
	bool	hl
	jp	z,@234
;630 
;631 //--- set SPI clock mode ---
;632   _spiConfig_(spiPort, CLK_1MHz, NORM_LOW_LATCH_RISE);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;633 
;634   for (i=0,bitTest=1; i<NUM_DAC; ++i,bitTest<<=1)  if (bitTest & (uint)mask
	xor	a,a
	ld	(ix-7),a
	ld	hl,0x1
	ld	(ix-6),hl
@239:
	ld	a,(ix-7)
	sub	a,3
	jp	nc,@240
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	and	hl,de
	jp	z,@242
;635 
;636   //--- select one of the 3 DAC chips ---
;637   //--- (chip # set by PD5-PD4-PE3) ---
;638     outi(PEDR, srPEDR = (srPEDR & 0xF7) | (i&1)<<3 );
	ld	a,(_srPEDR)
	and	a,247
	ld	hl,(ix-7)
	ld	h,a
	ld	a,l
	ld	l,h
	and	a,1
	ld	d,0
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	d,0
	or	hl,de
	ld	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;639     outi(PDDR, srPDDR = (srPDDR & 0xCF) | (i&6)<<3 );
	ld	a,(_srPDDR)
	and	a,207
	ld	hl,(ix-7)
	ld	h,a
	ld	a,l
	ld	l,h
	and	a,6
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	d,0
	or	hl,de
	ld	a,l
	ld	(_srPDDR),a
	ioi ld	(96),a
;640 
;641   //--- enable selected decoder output line to set /CS low for one DAC ---
;642     outi(PBDR, srPBDR &= 0x7F);  // PB7 ctls decoder output
	ld	a,(_srPBDR)
	and	a,127
	ld	(_srPBDR),a
	ioi ld	(64),a
;643 
;644   //--- send cmd to DAC chip ---
;645     rawVal = dacRaw[i];   buf[0] = rawVal >> 8;  buf[1] = rawVal & 0xff;
	bool	hl
	ld	l,(ix-7)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	l,h
	ld	(ix-2),l
	ld	hl,(ix-4)
	ld	h,0
	ld	(ix-1),l
;646     _spiWrite_(spiPort, buf, 2, false);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,2+@233
	add	hl,sp
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;647 
;648   //--- disable decoder outputs to bring /DS high for all DAC's ---
;649     outi(PBDR, srPBDR |= 0x80);  // PB7 ctls decoder output
	ld	a,(_srPBDR)
	or	a,128
	ld	(_srPBDR),a
	ioi ld	(64),a
;650   }
;651 
;652 }
@242:
	ld	a,(ix-7)
	inc	a
	ld	(ix-7),a
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@239
@240:
@234:
	.debug	} @234 652

@233	equ	7
	ld	sp,ix
	pop	ix
	lret
@235	equ	9
;653 
;654 
;655 //-------------------------------------------------------------------------
;656 /*
;657 float ADCtoVolts(uchar chan, uint rawADC)
;658 {
;659   return (ADCOffset(chan) - (float)(rawADC)) * ADCGain(chan);
;660 }
;661 */
;662 
;663 //-------------------------------------------------------------------------
;664 //  Interrupt Service Routine to catch state of IQ optical encoder.
;665 //  Assumes that A is tied to an input bit and B is tied to the INT-PE5 inp
;666 //  (and triggered the interrupt that called this func)
;667 //-------------------------------------------------------------------------
;668 void _int qdPulse()
;669 {
	.cseg
_qdPulse::
	.debug	G _qdPulse 50 3
	.debug	{ _qdPulse 50 668 @247 @246
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;670 /*
;671   If the same interrupt occurs again before the ISR shim that called this I
;672   returns to the interrupted code, the next instance will cause this ISR to
;673   be called right after the ipres/ret at the end of this ISR.  This means t
;674   ISR shim which called this ISR will not return to the originally interrup
;675   code before this ISR is invoked again.  If this happens too many times in
;676   row, the stack of the originally interrupted task will overflow.
;677 
;678   To guard against this possibility, we check to see if the level of nested
;679   scheduler locks has gotten unreasonably large.  If it has, this ISR disab
;680   the interrupt that calls it, which (if the above IS the cause of the
;681   scheduler not running), will allow all the previous occurances to return.
;682 
;683   Once all the previous occurances have finished, the scheduler will be act
;684   again and the application task will run.  One of the functions that the
;685   application task calls is used to check to see if the interrupt was disab
;686   If it was, it reenables it, and things will be back to normal (unless, of
;687   couse, we are still getting a continuous stream of interrupts, in which c
;688   the cycle keeps repeating.
;689 
;690   While this can hurt performance, that is still far better than allowing t
;691   OS to crash and reboot.  And experience has shown that this situation is
;692   often temporary, and can easily be stopped just by touching the knob on t
;693   front of the controller.
;694  */
;695 //  uint  stackLeft;
;696 
;697 //  stackLeft = CurSP() - (uint) current->stack_start;
;698 
;699 //  if ((stackLeft < 100) AND (_disabled > 30))  {
;700   if (_disabled > 30)  {  // _disabled is incr by the ISR shim...
	ld	a,(__disabled)
	sub	a,30
	jr	c,@248
	jr	z,@248
;701     restoreI1CR = srI1CR;  // save the value that will reenable this ISR
	ld	a,(_srI1CR)
	ld	(_restoreI1CR),a
;702     outi(I1CR, srI1CR = 0x00);  // disable INT1
	xor	a,a
	ld	(_srI1CR),a
	ioi ld	(153),a
;703   }
;704 
;705 //--- got here because B just went high - if A already high (i.e. A leads B
;706 //--- then knob was turned clockwise and count should be increased ---
;707   if (ini(PEDR) & 0x10)  ++qdCount;  else  --qdCount;   // A tied to PE4
@248:
	ioi ld	a,(112)
	and	a,16
	jr	z,@251
	ld	hl,(_qdCount)
	inc	hl
	ld	(_qdCount),hl
	jr	@252
@251:
	ld	hl,(_qdCount)
	dec	hl
	ld	(_qdCount),hl
;708 }
@252:
@246:
	.debug	} @246 708

@245	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@247	equ	2
;709 
;710 
;711 //-------------------------------------------------------------------------
;712 //  Set an External 2/4-wire RS-485 adapter to transmit mode
;713 //-------------------------------------------------------------------------
;714 void setExt485Tx(void)
;715 {
	.seg	FARCODE
$setExt485Tx::
	.debug	G $setExt485Tx 39 9
	.debug	{ $setExt485Tx 39 714 @255 @254
;716 }
@254:
	.debug	} @254 716

@253	equ	0
	lret
@255	equ	0
;717 //-------------------------------------------------------------------------
;718 //  Set an External 2/4-wire RS-485 adapter to receive mode
;719 //-------------------------------------------------------------------------
;720 void setExt485Rx(void)
;721 {
$setExt485Rx::
	.debug	G $setExt485Rx 39 9
	.debug	{ $setExt485Rx 39 720 @258 @257
;722 }
@257:
	.debug	} @257 722

@256	equ	0
	lret
@258	equ	0
;723 
;724 //-------------------------------------------------------------------------
;725 //  functions to enable/disable the transmitter for an RS-485 connection
;726 //-------------------------------------------------------------------------
;727 void _nearcall SerSetDirA(int enableXmit)  {  }
	.align	4
$$SerSetDirA::
	ex	(sp),iy
$SerSetDirA::
	.debug	G $SerSetDirA 51 9
	.debug	{ $SerSetDirA 51 727 @261 @260
	push	ix
	ld	ix,0
	add	ix,sp
@260:
	.debug	} @260 727

@259	equ	0
	pop	ix
	lret
@261	equ	2
;728 void _nearcall SerSetDirB(int enableXmit)  {  }
	.align	4
$$SerSetDirB::
	ex	(sp),iy
$SerSetDirB::
	.debug	G $SerSetDirB 51 9
	.debug	{ $SerSetDirB 51 728 @264 @263
	push	ix
	ld	ix,0
	add	ix,sp
@263:
	.debug	} @263 728

@262	equ	0
	pop	ix
	lret
@264	equ	2
;729 void _nearcall SerSetDirC(int enableXmit)  {  }
	.align	4
$$SerSetDirC::
	ex	(sp),iy
$SerSetDirC::
	.debug	G $SerSetDirC 51 9
	.debug	{ $SerSetDirC 51 729 @267 @266
	push	ix
	ld	ix,0
	add	ix,sp
@266:
	.debug	} @266 729

@265	equ	0
	pop	ix
	lret
@267	equ	2
;730 void _nearcall SerSetDirD(int enableXmit)
;731 {  // PF5 controls RS-485 line driver for port D(3) RS-485 connections
	.align	4
$$SerSetDirD::
	ex	(sp),iy
$SerSetDirD::
	.debug	G $SerSetDirD 51 9
	.debug	{ $SerSetDirD 51 730 @270 @269
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
;732   char  val;
;733   val = enableXmit ? (srPFDR | 0x20) : (srPFDR & ~0x20);
	ld	hl,(ix+5)
	bool	hl
	jr	z,@271
	ld	a,(_srPFDR)
	or	a,32
	jr	@272
@271:
	ld	a,(_srPFDR)
	and	a,223
@272:
	ld	(ix-1),a
;734   outi(PFDR, srPFDR = val);
	ld	(_srPFDR),a
	ioi ld	(56),a
;735 }
@269:
	.debug	} @269 735

@268	equ	1
	ld	sp,ix
	pop	ix
	lret
@270	equ	3
;736 
;737 
;738 //-------------------------------------------------------------------------
;739 void hdwInit(ulong digOutState)
;740 {
$hdwInit::
	.debug	G $hdwInit 48 9
	.debug	{ $hdwInit 48 739 @275 @274
	push	ix
	ld	ix,0
	add	ix,sp
;741   hdwType = HT_MODULAR_PS;
	ld	hl,0x6
	ld	(_hdwType),hl
;742 
;743   __brdInitFlag = TRUE;
	ld	a,0x1
	ld	(___brdInitFlag),a
;744 
;745 // (NI) = Normal Input
;746 // (NO) = Normal Output
;747 // (AI) = Alternate Input
;748 // (AO) = Alternate Output
;749 // (xx) = Used by ZWorld core - do not change
;750 
;751   //--- Port A --- (*must be inputs due to bug in earlier Rabbit 3000's)
;752   //  PA0 - (NI) *
;753   //  PA1 - (NI) *
;754   //  PA2 - (NI) *
;755   //  PA3 - (NI) *
;756   //  PA4 - (NI) *
;757   //  PA5 - (NI) *
;758   //  PA6 - (NI) *
;759   //  PA7 - (NI) *
;760     outi(SPCR, srSPCR &= ~0x0c);  // PortA: byte input
	ld	a,(_srSPCR)
	and	a,243
	ld	(_srSPCR),a
	ioi ld	(36),a
;761 
;762   //--- Port B ---
;763   //  PB0 - (AO)  Serial-B (SPI) clock
;764   //  PB1 - (AO)  Serial-A (Diag/Prog) clock
;765   //  PB2 - (NO)  /OE input on all Digital output line drivers
;766   //  PB3 - (NO)  A1 input on 3-to-8 line decoder for Dig I/O Bus
;767   //  PB4 - (NO)  A2 input on 3-to-8 line decoder for Dig I/O Bus
;768   //  PB5 - (NO)  /OE2A input on 3-to-8 line decoder for Dig I/O Bus
;769   //  PB6 - (NO)  A0 input on 3-to-8 line decoder for Dig I/O Bus
;770   //  PB7 - (NO)  G2A on 3-to-8 decoder for Analog output selector
;771     outi(PBDR, srPBDR |= 0xA0);   // PB7 and PB5 high
	ld	a,(_srPBDR)
	or	a,160
	ld	(_srPBDR),a
	ioi ld	(64),a
;772     outi(PBDDR, srPBDDR |= 0xFC); // dir: OOOO-OOxx
	ld	a,(_srPBDDR)
	or	a,252
	ld	(_srPBDDR),a
	ioi ld	(71),a
;773 
;774   //--- Port C ---
;775   //  PC0 - (AO)  Serial-D (RS-232/485) transmit (to rear connectors)
;776   //  PC1 - (xI)  Serial-D (RS-232/485) receive (to rear connectors)
;777   //  PC2 - (AO)  Serial-C (RS-232) transmit (to front panel LCD)
;778   //  PC3 - (xI)  Serial-C (RS-232) receive (from front panel LCD)
;779   //  PC4 - (AO)  Serial-B (SPI) transmit (to all DAC's)
;780   //  PC5 - (xI)  Serial-B (SPI) receive (from 1st ADC in the chain)
;781   //  PC6 - (AO)  Serial-A (Diag/Prog) transmit
;782   //  PC7 - (xI)  Serial-A (Diag/Prog) receive
;783     outi(PCFR, srPCFR = 0x55);  // func: xAxA-xAxA
	ld	a,0x55
	ld	(_srPCFR),a
	ioi ld	(85),a
;784 
;785   //--- Port D ---
;786   //  PD0 - (xx)  Ethernet Controller Reset
;787   //  PD1 - (xx)  Not Avail (pulled high - not even connected???)
;788   //  PD2 - (xx)  Ethernet Controller (TPOUT-)
;789   //  PD3 - (xx)  Ethernet Controller (TPOUT+)
;790   //  PD4 - (NO)  B input on 3-to-8 decoder for Analog output selector
;791   //  PD5 - (NO)  C input on 3-to-8 decoder for Analog output selector
;792   //  PD6 - (xx)  Ethernet Controller (TPIN-)
;793   //  PD7 - (xx)  Ethernet Controller (TPIN+)
;794     outi(PDDDR, srPDDDR |= 0x30);    // dir:  xxOO-xxxx
	ld	a,(_srPDDDR)
	or	a,48
	ld	(_srPDDDR),a
	ioi ld	(103),a
;795     outi(PDFR, srPDFR &= ~0x30);     // func: xxNN-xxxx
	ld	a,(_srPDFR)
	and	a,207
	ld	(_srPDFR),a
	ioi ld	(101),a
;796 
;797   //--- Port E ---
;798   //  PE0 - (xx)  Interrupt Input 0A (Ethernet ctlr Interrupt)
;799   //  PE1 - (AI)  Interrupt Input 1A (buffered from external source)
;800   //  PE2 - (xx)  Ethernet Controller Chip Select (output)
;801   //  PE3 - (NO)  A on 3-to-8 decoder for Analog output selector
;802   //  PE4 - (NI)  Normal input ("A" input from quadrature-encoded knob)
;803   //  PE5 - (AI)  Interrupt Input 1B (buffered from external source)
;804   //  PE6 - (NO)  ADR0 on all ADC's (output)
;805   //  PE7 - (NO)  ADR1 on all ADC's (output)
;806     outi(PEDDR, srPEDDR = (srPEDDR | 0xC8) & ~0x32); // dir:  OOII-OxIx
	ld	a,(_srPEDDR)
	or	a,200
	and	a,205
	ld	(_srPEDDR),a
	ioi ld	(119),a
;807     outi(PEFR, srPEFR = (srPEFR | 0x22) & ~0xD8);    // func: NNAN-NxAx
	ld	a,(_srPEFR)
	or	a,34
	and	a,39
	ld	(_srPEFR),a
	ioi ld	(117),a
;808 
;809   //--- Port F ---
;810   //  PF0 - (AO)  Serial-D clock (to RS-485/RS-232 port)
;811   //  PF1 - (AO)  Serial-C clock (to RS-485/RS-232 port)
;812   //  PF2 - (NO)  to CS on all ADC's (output)
;813   //  PF3 - (NO)  to R/C on all ADC's (output)
;814   //  PF4 - (NO)  xmit enable for Serial C (output)
;815   //  PF5 - (NO)  xmit enable for Serial D (output)
;816   //  PF6 - (NI)  EOC for 1st 12-bit ADC
;817   //  PF7 - (NI)  EOC for 2nd 12-bit ADC
;818     outi(PFDR, srPFDR |= 0x0C);   // PF2/3 high (ADC R/C-, /CS)
	ld	a,(_srPFDR)
	or	a,12
	ld	(_srPFDR),a
	ioi ld	(56),a
;819     outi(PFDDR, srPFDDR = 0x3F);  // dir:  IIOO-OOOO
	ld	a,0x3f
	ld	(_srPFDDR),a
	ioi ld	(63),a
;820     outi(PFFR, srPFFR = 0x03);    // func: NNNN-NNAA
	ld	a,0x3
	ld	(_srPFFR),a
	ioi ld	(61),a
;821 
;822   //--- Port G ---
;823   //  PG0 - (NIO)  Digital I/O bus
;824   //  PG1 - (NIO)  Digital I/O bus
;825   //  PG2 - (NIO)  Digital I/O bus
;826   //  PG3 - (NIO)  Digital I/O bus
;827   //  PG4 - (NIO)  Digital I/O bus
;828   //  PG5 - (NIO)  Digital I/O bus
;829   //  PG6 - (NIO)  Digital I/O bus
;830   //  PG7 - (NIO)  Digital I/O bus
;831     outi(PGDDR, srPGDDR = 0x00);  // dir:  IIII-IIII (for now)
	xor	a,a
	ld	(_srPGDDR),a
	ioi ld	(79),a
;832     outi(PGFR, srPGFR = 0x00);    // func: NNNN-NNNN
	xor	a,a
	ld	(_srPGFR),a
	ioi ld	(77),a
;833 
;834 
;835   //--- all parallel port outputs driven hi/lo (no open-drain outputs) ---
;836     outi(PDDCR, srPDDCR = 0x00);
	xor	a,a
	ld	(_srPDDCR),a
	ioi ld	(102),a
;837     outi(PFDCR, srPFDCR = 0x00);
	xor	a,a
	ld	(_srPFDCR),a
	ioi ld	(62),a
;838     outi(PGDCR, srPGDCR = 0x00);
	xor	a,a
	ld	(_srPGDCR),a
	ioi ld	(78),a
;839 
;840   //--- prep state of digital outputs ---
;841     digitalOut = digOutState;  WriteDigOutputs(digitalOut);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
;842 
;843   //--- enable output latches so digital output states take effect ---
;844     outi(PBDR, srPBDR &= ~0x04);  // bring PB2 low
	ld	a,(_srPBDR)
	and	a,251
	ld	(_srPBDR),a
	ioi ld	(64),a
;845 
;846 //    ser485Rx();  // disable the RS485 transmitter
;847 //    setExt485Rx();  // set external 2/4-wire RS-485 adapter to Rx mode
;848 
;849     spiPort = NULL;  // set later by a call from the kernel process
	bool	hl
	ld	l,h
	ld	(_spiPort),hl
;850 
;851 
;852 //--- set INT1B interrupt handler for rising edge on PE5 using priority 1 -
;853   qdCount = 0;  restoreI1CR = 0;
	ld	(_qdCount),hl
	xor	a,a
	ld	(_restoreI1CR),a
;854   setInterruptHandler(INT_INT1, qdPulse);
	ld	hl,_qdPulse
	push	hl
	ld	hl,0x11
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;855   outi(I1CR, srI1CR = 0x21);  // enable extern INT1B on PE5, rising edge, I
	ld	a,0x21
	ld	(_srI1CR),a
	ioi ld	(153),a
;856 
;857 
;858   flashSize = 524288L;
	ld	de,0
	ld	bc,0x8
	ld	(_flashSize),de
	ld	(_flashSize+2),bc
;859 
;860   printf("\r\nInitialized %s hardware\r\n", ArchName);
	ld	hl,_ArchName
	push	hl
	ld	de,word (phys @1+316)
	ld	c,phys @1+316 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;861 }
@274:
	.debug	} @274 861

@273	equ	0
	pop	ix
	lret
@275	equ	2
;862 
;863 
;864 //-------------------------------------------------------------------------
;865 //  Initialize and register hardware-dependent file systems
;866 //-------------------------------------------------------------------------
;867 void registerFileSystems(void)
;868 {
$registerFileSystems::
	.debug	G $registerFileSystems 39 9
	.debug	{ $registerFileSystems 39 867 @278 @277
;869   socketInit_();
	lcall	$socketInit_
;870   srfsInit_();
	lcall	$srfsInit_
;871   serialInit_();
	lcall	$serialInit_
;872 
;873   flashFileInit_();
	lcall	$flashFileInit_
;874 }
@277:
	.debug	} @277 874

@276	equ	0
	lret
@278	equ	0
;875 
;876 //-------------------------------------------------------------------------
;877 //  Initialize the network hardware
;878 //-------------------------------------------------------------------------
;879 void netHdwInit()
;880 {
$netHdwInit::
	.debug	G $netHdwInit 50 9
	.debug	{ $netHdwInit 50 879 @281 @280
;881 //  Select ethernet hardware:
;882 //  usingAsix, usingDevKit, usingRealtek, usingSMSC
;883 //  usingAll() can be used to support all cmd core modules, but req's more 
;884 
;885   usingAsix();
	lcall	$usingAsix
;886 }
@280:
	.debug	} @280 886

@279	equ	0
	lret
@281	equ	0
;887 
;888 
;889 //-------------------------------------------------------------------------
;890 //  allocate any resources that should be owned by the kernel process
;891 //
;892 //  To be called ONLY by the kernel process!!!!
;893 //-------------------------------------------------------------------------
;894 void hdwInit2(void)
;895 {
$hdwInit2::
	.debug	G $hdwInit2 39 9
	.debug	{ $hdwInit2 39 894 @284 @283
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;896   fd_t  spifd;
;897 
;898 
;899   spifd = _serial_(ADC_DAC_SPIPort, 0, SER_SPI, SER_NO_FLOW);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x4
	push	hl
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	lcall	$_serial_
	add	sp,8
	ld	(ix-2),hl
;900 
;901   spiPort = _FileFromFD_(spifd)->ioDev;
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	(_spiPort),de
;902 
;903   printf("spiPort: %04lX (%d)\r\n", (ulong)spiPort, spiPort->port);  //tdeb
	ld	h,d
	ld	l,e
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	h,d
	ld	l,e
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @1+344)
	ld	c,phys @1+344 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;904 }
@283:
	.debug	} @283 904

@282	equ	2
	ld	sp,ix
	pop	ix
	lret
@284	equ	4
;905 
;906 //-------------------------------------------------------------------------
;907 
	.extern	__disabled 3
	.extern	_SchedMS 7
	.extern	$farprintf 52
	.extern	_srSPCR 3
	.extern	_srPBDR 3
	.extern	_srPCFR 3
	.extern	_srPDDR 3
	.extern	_srPDFR 3
	.extern	_srPDDCR 3
	.extern	_srPDDDR 3
	.extern	_srPEDR 3
	.extern	_srPEFR 3
	.extern	_srPEDDR 3
	.extern	_srI1CR 3
	.extern	_srPFDR 3
	.extern	_srPFFR 3
	.extern	_srPFDCR 3
	.extern	_srPFDDR 3
	.extern	_srPBDDR 3
	.extern	_srPGDR 3
	.extern	_srPGFR 3
	.extern	_srPGDCR 3
	.extern	_srPGDDR 3
	.extern	$setInterruptHandler 53
	.extern	__TimerMilliSeconds 54
	.bseg
___brdInitFlag::
	.ds	1
	.debug	G ___brdInitFlag 3 0
_ramSize::
	.ds	4
	.debug	G _ramSize 9 0
_flashSize::
	.ds	4
	.debug	G _flashSize 9 0
_qdCount::
	.ds	2
	.debug	G _qdCount 6 0
_updateAIn::
	.ds	26
	.debug	G _updateAIn 55 0
_updateAOut::
	.ds	3
	.debug	G _updateAOut 56 0
_adcGain::
	.ds	104
	.debug	G _adcGain 57 0
_adcOffset::
	.ds	104
	.debug	G _adcOffset 57 0
_dacGain::
	.ds	12
	.debug	G _dacGain 58 0
_dacOffset::
	.ds	12
	.debug	G _dacOffset 58 0
_ainMin::
	.ds	104
	.debug	G _ainMin 57 0
_ainMax::
	.ds	104
	.debug	G _ainMax 57 0
_aoutMin::
	.ds	12
	.debug	G _aoutMin 58 0
_aoutMax::
	.ds	12
	.debug	G _aoutMax 58 0
	.defseg	FARBSS
	.seg	FARBSS
_setValMin::
	.ds	12
	.debug	G _setValMin 58 8
_setValMax::
	.ds	12
	.debug	G _setValMax 58 8
_readValMin::
	.ds	104
	.debug	G _readValMin 57 8
_readValMax::
	.ds	104
	.debug	G _readValMax 57 8
	.bseg
_anaIn::
	.ds	104
	.debug	G _anaIn 57 0
_anaOut::
	.ds	12
	.debug	G _anaOut 58 0
_lastAnaOut::
	.ds	12
	.debug	G _lastAnaOut 58 0
_adcRaw::
	.ds	52
	.debug	G _adcRaw 59 0
_dacRaw::
	.ds	6
	.debug	G _dacRaw 60 0
_lastadcRaw::
	.ds	52
	.debug	G _lastadcRaw 59 0
_newRdg::
	.ds	26
	.debug	G _newRdg 55 0
_adcForced::
	.ds	26
	.debug	G _adcForced 55 0
_dacForced::
	.ds	3
	.debug	G _dacForced 56 0
_adcForcedVal::
	.ds	104
	.debug	G _adcForcedVal 57 0
_dacForcedVal::
	.ds	12
	.debug	G _dacForcedVal 58 0
	.seg	FARBSS
_adcRawHist::
	.ds	5200
	.debug	G _adcRawHist 61 8
	.bseg
_adcAvgData::
	.ds	312
	.debug	G _adcAvgData 63 0
_adcNoiseData::
	.ds	260
	.debug	G _adcNoiseData 65 0
	.extern	_readGain 67
	.extern	_readOffset 67
	.extern	_setGain 67
	.extern	_setOffset 67
	.extern	_readVal 67
_digitalIn::
	.ds	4
	.debug	G _digitalIn 9 0
_digitalOut::
	.ds	4
	.debug	G _digitalOut 9 0
_forcedDigInMask::
	.ds	4
	.debug	G _forcedDigInMask 9 0
_forcedDigInBits::
	.ds	4
	.debug	G _forcedDigInBits 9 0
_forcedDigOutMask::
	.ds	4
	.debug	G _forcedDigOutMask 9 0
_forcedDigOutBits::
	.ds	4
	.debug	G _forcedDigOutBits 9 0
_extraIn::
	.ds	4
	.debug	G _extraIn 9 0
_forcedExtraInMask::
	.ds	4
	.debug	G _forcedExtraInMask 9 0
_forcedExtraInBits::
	.ds	4
	.debug	G _forcedExtraInBits 9 0
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
_setStateDAC:
	pop	iy
	lcall	$$setStateDAC
	.extern	$_FileFromFD_ 68
	.extern	_KLOCK 39
	.extern	_KUNLOCK 39
	.extern	$resetWDT 39
	.extern	_hdwType 7
	.extern	$serialInit_ 39
	.extern	$_serial_ 71
	.extern	$_spiConfig_ 72
	.extern	$_spiRead_ 73
	.extern	$_spiWrite_ 73
	.extern	$_spiWrRd_ 74
	.extern	$usingAsix 39
	.extern	$socketInit_ 39
	.extern	$srfsInit_ 39
	.extern	$flashFileInit_ 39
	.extern	_NumApplAIN 7
	.extern	_ADC_Mask 9
_adcGetRaw:
	pop	iy
	lcall	$$adcGetRaw
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
_adcCalibPoints:
	pop	iy
	lcall	$$adcCalibPoints
_dacGetRaw:
	pop	iy
	lcall	$$dacGetRaw
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
_dacCalibPoints:
	pop	iy
	lcall	$$dacCalibPoints
	.bseg
_spiPort::
	.ds	2
	.debug	G _spiPort 75 0
_restoreI1CR::
	.ds	1
	.debug	G _restoreI1CR 3 0
	.cseg
_SerSetDirA:
	pop	iy
	lcall	$$SerSetDirA
_SerSetDirB:
	pop	iy
	lcall	$$SerSetDirB
_SerSetDirC:
	pop	iy
	lcall	$$SerSetDirC
_SerSetDirD:
	pop	iy
	lcall	$$SerSetDirD
	.debug	T	09000120000A0003000A00
	.debug	T	0900012100780022001E00
	.debug	T	070008220004000300
	.debug	T	0900012300500024000500
	.debug	T	49000324001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E004D00060005646174610022000A
	.debug	T	00056E616D65004E000E000B726573746F726556616C00
	.debug	T	0B000225000100010007000000
	.debug	T	130002260003000100070000000A00020003000600
	.debug	T	0B000227000100010001000000
	.debug	T	0F00022800020007000700000007000200
	.debug	T	0B000229000100070007000000
	.debug	T	0B00022A0001000A0007000000
	.debug	T	0F00022B00020007000700000050000200
	.debug	T	1300022C0003000100070000005100020051000400
	.debug	T	0F00022D0002002E00070000002E000200
	.debug	T	0700002E0002000300
	.debug	T	0700022F0000000900
	.debug	T	0B000230000100010009000000
	.debug	T	0F00023100020001000300000007000200
	.debug	T	070002320000000100
	.debug	T	0B000233000100010006000000
	.debug	T	0F0002340002000600220000000D000000
	.debug	T	0F00023500020001005200000053000200
	.debug	T	0900013600080009000200
	.debug	T	09000137001A0003001A00
	.debug	T	0900013800030003000300
	.debug	T	090001390068000A001A00
	.debug	T	0900013A000C000A000300
	.debug	T	0900013B00340007001A00
	.debug	T	0900013C00060007000300
	.debug	T	0900013D0050143E001A00
	.debug	T	0900013E00C80007006400
	.debug	T	0900013F00380140001A00
	.debug	T	4E000340000C0005000100090000000473756D0007000400076F6C
	.debug	T	646573740007000600056E65787400070008000E6375724E75
	.debug	T	6D53616D706C65730007000A000E7573654E756D53616D706C
	.debug	T	657300
	.debug	T	0900014100040142001A00
	.debug	T	51000342000A000500010007000000077261774D696E0007000200
	.debug	T	077261774D617800070004000C6E6F697365506572696F6400
	.debug	T	07000600097261774E6F69736500070008000C6E6F69736554
	.debug	T	696D654D5300
	.debug	T	090001430000000A000000
	.debug	T	0B000244000100450006000000
	.debug	T	070008450004004600
	.debug	T	0B01034600270013000100060000000A6F70656E436F756E740054
	.debug	T	00020008696F46756E6373005600040006696F446576005700
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	17000247000400060003000000030002000300040003000600
	.debug	T	130002480003000600560000000300020003000400
	.debug	T	170002490004000600560000002E0002000600040003000600
	.debug	T	1700024A0004000600560000002E0002002E00040006000600
	.debug	T	0700004B0002004C00
	.debug	T	E700034C001800110001000300000006696E557365000300010005
	.debug	T	706F7274005600020005734465760003000400056D6F646500
	.debug	T	0300050008666C6F7743746C000300060007636C6F73656400
	.debug	T	0300070008706B744D6F646500090008000962617564526174
	.debug	T	650003000C0008636C6B4D6F64650006000D0007636C6B4469
	.debug	T	760003000F000B7365724461746152656700030010000A7365
	.debug	T	7243746C52656700030011000B736572537461745265670003
	.debug	T	0012000A736572457874526567002E0013000A705368457874
	.debug	T	526567000300150007544154526567002E0016000A70544154
	.debug	T	736852656700
	.debug	T	0700084D0004000100
	.debug	T	0700004E0002004F00
	.debug	T	1300024F00030001004D0000002E00040007000600
	.debug	T	070000500002000700
	.debug	T	070000510002000A00
	.debug	T	EC0109520001001F00010000000A494E545F54494D45520001000D
	.debug	T	494E545F4E4F545F555345440002000A494E545F5253543130
	.debug	T	0003000A494E545F52535431380004000A494E545F52535432
	.debug	T	300005000A494E545F52535432380006000E494E545F4E4F54
	.debug	T	5F55534544320007000A494E545F52535433380008000F494E
	.debug	T	545F534C4156455F504F52540009000E494E545F4E4F545F55
	.debug	T	53454433000A000C494E545F54494D45525F41000B000C494E
	.debug	T	545F54494D45525F42000C000D494E545F53455249414C5F41
	.debug	T	000D000D494E545F53455249414C5F42000E000D494E545F53
	.debug	T	455249414C5F43000F000D494E545F53455249414C5F440010
	.debug	T	0009494E545F494E543000110009494E545F494E5431001200
	.debug	T	0E494E545F4E4F545F55534544340013000E494E545F4E4F54
	.debug	T	5F55534544350014000E494E545F4E4F545F55534544360015
	.debug	T	000E494E545F4E4F545F55534544370016000E494E545F4E4F
	.debug	T	545F55534544380017000E494E545F4E4F545F555345443900
	.debug	T	18000F494E545F4E4F545F55534544313000190011494E545F
	.debug	T	515541445F4445434F444552001A000E494E545F494E505554
	.debug	T	5F434150001B000F494E545F4E4F545F555345443131001C00
	.debug	T	0D494E545F53455249414C5F45001D000D494E545F53455249
	.debug	T	414C5F46001E0009494E545F4C41535400
	.debug	T	070000530002002700
	.debug	T	070000540002005500
	.debug	T	640003550010000800010058000000057265616400580002000677
	.debug	T	72697465005900040006636C6F7365005B000600066C736565
	.debug	T	6B005D000800066673746174005F000A0006696F63746C0061
	.debug	T	000C000664657363720063000E000A67657451756575657300
	.debug	T	070000560002000100
	.debug	T	2800035700040002000100650000000A7265616451756575650065
	.debug	T	0002000B7772697465517565756500
	.debug	T	070000580002004900
	.debug	T	070000590002005A00
	.debug	T	0B00025A000100060056000000
	.debug	T	0700005B0002005C00
	.debug	T	1300025C0003000900560000000900020006000600
	.debug	T	0700005D0002005E00
	.debug	T	0F00025E00020006005600000067000200
	.debug	T	0700005F0002006000
	.debug	T	130002600003000600560000000600020056000400
	.debug	T	070000610002006200
	.debug	T	130002620003002E00560000002E00020006000400
	.debug	T	070000630002006400
	.debug	T	0F00026400020006005600000069000200
	.debug	T	070000650002006600
	.debug	T	280003660004000100125F5F776169745F71756575655F68656164
	.debug	T	006A000000096C6973744865616400
	.debug	T	070000670002006800
	.debug	T	BB000368002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	070008690004005700
	.debug	T	2600036A00040002000A6C6973745F68656164006B000000056E65
	.debug	T	7874006B000200057072657600
	.debug	T	0700006B0002006A00
	.seg	CONST
@155:
	.db	"A",0,"V",0
	.seg	FARCONST
@1:
	.db	"Periodic Timer",0,"Secondary WDT",0,"RST 10",0,"RST 18",0,"RST 20",0,"RST 28",0,"Syscall",0,"RST 38",0,"Slave Port",0,"Wr"
	.db	"ite Protect",0,"Timer A",0,"Timer B",0,"Serial A",0,"Serial B",0,"Serial C",0,"Serial D",0,"INT0",0,"INT1",0,"PWM",0,"Mode Vi"
	.db	"olation",0,"Quad Decoder",0,"Input capture",0,"Stack Limit",0,"Serial E",0,"Serial F",0,"adcGain",0,"adcOffset",0,"da"
	.db	"cGain",0,"dacOffset",0,"*** Excessive INT1 occurances detected ***",13,10,0,13,10,"Initialized %s hardwar"
	.db	"e",13,10,0,"spiPort: %04lX (%d)",13,10,0
	.end
