//----- time.c ----- 07/18/07 -----(07/19/06)-----

// based on earlier work for ZWorld/Rabbit-based controllers

//  simple client to get time of day using good old time protocol (port 37)


#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>

#include <string.h>

#include <time.h>

#include <sys/srfs.h>

#include <services.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
void _task timeClient(int argc, char **argv)
{
  int  sockfd;
  ulong  sleepTime, diff;
  time_t  curSecs, newSecs;
  uchar  buf[4];
  struct tm  tms;
  struct sockaddr_in  srvAddr;


  redirectStdio();  // so printf, perror, etc don't end up in data stream

  sleepTime = 5000;  // made much longer after first successful query


  for (;;)  {
    errno = 0;

    srvAddr.sin_family = AF_INET;
    srvAddr.sin_port   = htons(TIME_PORT);
    srvAddr.sin_addr   = htonl(srfsIPAddr);

    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)  {
      perror("socket() error");
      sleepMS(10000);  continue;
    }

    if (connect(sockfd, (struct sockaddr *) &srvAddr, sizeof(srvAddr)) < 0)  {
      perror("connect error");  close(sockfd);
      sleepMS(10000);  continue;
    }

    if (read(sockfd, buf, 4) != 4)  {
      perror("read error");  close(sockfd);
      sleepMS(10000);  continue;
    }

    close(sockfd);

    time(&curSecs);
    newSecs = ntohl(*((ulong *)buf)) - 2208988782L;

    diff = ULDIF(curSecs, newSecs);

    if ((diff > 5) OR !gotTime)  {
      gmtime_r(&newSecs, &tms);
      printf("UTC time: %04d-%02d-%02d %02d:%02d:%02d (%lu)\r\n",
              tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
              tms.tm_hour, tms.tm_min, tms.tm_sec, newSecs );
      gotTime = true;
    }

    stime(&newSecs);


    sleepTime = 300000L + ((ntohl(srvAddr.sin_addr) & 0x000000ff) << 4);

    sleepMS(sleepTime);
  }

}

//-----------------------------------------------------------------------------
