//----- sys/poll.h ----- 04/30/10 -----(04/30/10)-----

//-----------------------------------------------------------------------------
//  Very basic version of standard Linux header file
//-----------------------------------------------------------------------------
//  Change log (most recent first):
//
//
//  2010-04-30 - Mark Davis
//               - Original version
//
//-----------------------------------------------------------------------------

#ifndef _LINUX_POLL_H
#define _LINUX_POLL_H


struct pollfd {
  int fd;           /* file descriptor */
  short events;     /* requested events */
  short revents;    /* returned events */
};

//--- values for events and revents ---
#define POLLIN      0x0001    /* There is data to read */
#define POLLPRI     0x0002    /* There is urgent data to read */
#define POLLOUT     0x0004    /* Writing now will not block */
#define POLLERR     0x0008    /* Error condition */
#define POLLHUP     0x0010    /* Hung up */
#define POLLNVAL    0x0020    /* Invalid request: fd not open */


int poll(struct pollfd *ufds, unsigned int nfds, int timeout);



#endif /* _LINUX_POLL_H */
