//----- spi.h ----- 10/20/07 -----(05/05/05)-----

// ported from earlier version created for use with ZWorld compiler

#ifndef _spiH_
#define _spiH_


#include <sys/serial.h>
#include <fcntl.h>


//--- values for clkDiv parameter for spiInit() and spiConfig() ---
//--- (other values can be used, but must be >= 5 for stable operation) ---
//    RATE = 10MHz / value
#define  CLK_2MHz      5
#define  CLK_1MHz     10
#define  CLK_500KHz   20
#define  CLK_100KHz  100
#define  CLK_50KHz   200


//--- values for clkMode parameter for spiInit() and spiConfig() ---
#define  NORM_LOW_LATCH_RISE   0
#define  NORM_LOW_LATCH_FALL   1
#define  NORM_HIGH_LATCH_FALL  2
#define  NORM_HIGH_LATCH_RISE  3


extern bool  spiInUse;


bool  _spiInit_(void *ioDev, uchar clkDiv, uchar clkMode);

int  _spiConfig_(void *ioDev, uchar clkDiv, uchar clkMode);

//finish: temp - until I can support sharing descriptors across processes
extern int _spiRead_(void *ioDev, char *buf, int numBytes, bool dontBlock);
extern int _spiWrite_(void *ioDev, char *buf, int numBytes, bool dontBlock);
extern int _spiWrRd_(void *ioDev, char *xmitBuf, char *rcvBuf, int numBytes);

//--- To reduce overhead for a series of small count r/w ops, call the Lock ---
//--- func once, call the Fast I/O funcs as needed, and then the Unlock func ---
extern int _spiLock_(void *ioDev);
extern int _spiWrRdFast_(char *xmitBuf, char *rcvBuf, int numBytes);
extern int _spiUnlock_(void *ioDev);

#endif
