//----- fstrcpy.c ----- 07/16/10 -----(07/16/10)-----

//-----------------------------------------------------------------------------
//  A version of fstrcpy that avoids single write operations that span a
//  4K boundary
//-----------------------------------------------------------------------------
//  Version log (most recent first):
//
//
//  2010-07-16 - Mark Davis (*)
//               - Temporary and slow version that is comptabile with memory
//                 write protection (i.e. it calls the modified __farst1 to
//                 write to memory so it doesn't do a write that crosses a
//                 4K boundary).
//
//-----------------------------------------------------------------------------

#include <sys/types.h>
#include <unistd.h>


//-----------------------------------------------------------------------------
//  A version of fstrcpy() that uses the safe version of __farst1 to avoid
//  writing to 4K pages outside the specified range.
//-----------------------------------------------------------------------------
void near fstrcpy(uchar far *to, uchar const far *from)
{
  while (*from)  *to++ = *from++;

  *to = 0;
}


//-----------------------------------------------------------------------------
