//----- inet.c ----- 09/30/06 -----(08/25/06)-----

#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <stdio.h>

#include <string.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
const char *inet_ntop(int af, const void *src, char *dst, socklen_t cnt)
{
  if (af != AF_INET)  { ERRNO = EAFNOSUPPORT;  return NULL; }

  sprintf(dst, "%d.%d.%d.%d",
    ((uchar *)src)[0], ((uchar *)src)[1],
    ((uchar *)src)[2], ((uchar *)src)[3] );

  return dst;
}


//=============================================================================
// NOTE: Rabbit versions of inet_ntoa()/inet_addr() expect/return values in
//       HOST byte order NOT NET byte order like they are supposed to!!!!
//=============================================================================

//-----------------------------------------------------------------------------
int inet_pton(int af, const char *src, void *dst)
{
  if (af != AF_INET)  { ERRNO = EAFNOSUPPORT;  return -1; }

  *((ulong *)dst) = htonl(inet_addr((char *)src));

  return 1;
}


//-----------------------------------------------------------------------------
