	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\lib\_farcopy.c' 14 19 13 8 6 32
;1 //----- _farcopy.c ----- 03/28/12 -----(03/28/12)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  A version of _farcopy() that is compatible with write protection.
;5 //-------------------------------------------------------------------------
;6 //  Version log (most recent first):
;7 //
;8 //
;9 //  2012-03-28 - Mark Davis
;10 //               - First version of replacement for Softools _farcopy().  T
;11 //                 version is compatible with hardware write protection, wh
;12 //                 the Softools version at the time of this writing was not
;13 //
;14 //-------------------------------------------------------------------------
;15 
;16 
;17 /*-------------------------------------------------------------------------
;18   The problem that needs to be addressed is this:  If the destination addr
;19   ends in 0xFFFF, then it will wrap around (i.e. it write to the last byte 
;20   the 64K block and then the 1st byte in the SAME 64K block).  Even if the
;21   byte it would written to the first byte in the block is the same as what 
;22   already there, it will cause a write protection fault if the 1st byte in
;23   the block is in a 4K segment that is write protected.
;24 
;25   To avoid the possible write protection fault, what we must do is check th
;26   destination addr each time through the loop.  If the offset in to the 64K
;27   block is 0xFFFF, then for that pass through the loop, we execute an
;28   alternative version of the read/write loop that does this:
;29 
;30       - Decrement the destination addr
;31       - Read 2 bytes from the destination addr
;32       - Save the 1st byte from the dest
;33       - Read 2 bytes from the source addr
;34       - Set 2nd byte from dest = 1st byte from source
;35       - Write the 2 bytes to the dest
;36       - incr dest addr twice
;37 
;38  *-------------------------------------------------------------------------
;39 
;40 #asm
	.debug	# 42
.extern $fmemcpy

	.debug	# 44
.cseg

	.debug	# 46
__farcopy::

	.debug	# 50
push  ix

	.debug	# 51
push  bc

	.debug	# 52
push  de

	.debug	# 54
ex    de,hl         

	.debug	# 56
ld    ix,hl         

	.debug	# 58
ld    hl,(sp+8)

	.debug	# 59
ld    iy,hl

	.debug	# 60
ld    hl,(sp+10)

	.debug	# 61
ld    b,l           

	.debug	# 63
ld    de',0x0001    ;; de'= 1

	.debug	# 103
@loop:

	.debug	# 104
exx                  

	.debug	# 105
ld    hl,ix          

	.debug	# 106
add   hl,de          

	.debug	# 107
exx                  

	.debug	# 108
jr    c,@avoidWrap   

	.debug	# 112
ld    a,b            

	.debug	# 113
ldp   hl,(iy)        

	.debug	# 116
ld    a,l            

	.debug	# 117
ex    af,af'         ;; [2]


	.debug	# 120
ld    a,c            

	.debug	# 121
ldp   hl,(ix)        

	.debug	# 124
ex    af,af'         ;; [2]


	.debug	# 125
ld    l,a            

	.debug	# 129
ld    a,c            

	.debug	# 130
ldp   (ix),hl        

	.debug	# 132
jr   @decrCount      

	.debug	# 138
@avoidWrap:

	.debug	# 139
dec   ix             

	.debug	# 142
ld    a,b            

	.debug	# 143
ldp   hl,(iy)        

	.debug	# 146
ld    a,l            

	.debug	# 147
ex    af,af'         ;; [2]


	.debug	# 150
ld    a,c            

	.debug	# 151
ldp   hl,(ix)        

	.debug	# 154
ex    af,af'         ;; [2]


	.debug	# 155
ld    h,a            

	.debug	# 159
ld    a,c            

	.debug	# 160
ldp   (ix),hl        

	.debug	# 162
inc   ix             

	.debug	# 164
@decrCount:

	.debug	# 165
dec   de             

	.debug	# 166
ld    a,d            

	.debug	# 167
or    e              

	.debug	# 168
jr    z,@return      

	.debug	# 170
exx                  

	.debug	# 171
add   ix,de          

	.debug	# 172
exx                  

	.debug	# 173
jr    nc,@incrFrom   

	.debug	# 174
inc   c              

	.debug	# 176
@incrFrom:

	.debug	# 177
exx                  

	.debug	# 178
add   iy,de          

	.debug	# 179
exx                  

	.debug	# 180
jr    nc,@loop       

	.debug	# 181
inc   b              

	.debug	# 182
jr    @loop          

	.debug	# 184
@return:

	.debug	# 185
pop   de

	.debug	# 186
pop   bc

	.debug	# 187
pop   ix

	.debug	# 189
ret

;192 
	.cseg
;193 //-------------------------------------------------------------------------
;194 
	.end
