	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\arch\flash.c' 4 47 15 21 12 32
;1 //----- flash.c ----- 12/21/12 ----(??/??/??)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Flash device programming support program.
;5 //  Copyright (c) 2000-2003, Softools, Inc.  All rights reserved
;6 //
;7 //  Modifications by Mark Davis, National Superconducting Laboratory.
;8 //
;9 //  Supports writing to flash from the application.
;10 //
;11 //  Currently, the supplied driver does not support sector write
;12 //  devices.  This was done because byte-write are currently the
;13 //  only type supplied by Z-World and because byte-write are the
;14 //  predominate ones used.  To support sector write devices, ...
;15 //
;16 //  Flash memories supported:  SST39SF010A / SST39SF020A / SST39SF040
;17 //  (or compatible).
;18 //
;19 //-------------------------------------------------------------------------
;20 //  Change log (most recent first)
;21 //
;22 //
;23 //  2012-12-21 - Mark Davis (*)
;24 //               - Changed mapFlashAddress() so it uses the highest possibl
;25 //                 bank # to minimize the chance of selecting a bank that
;26 //                 might contain code that an un-blockable (fault handler)
;27 //                 ISR might try to access.
;28 //                 NOTE that the PROPER way to deal with this (so it works 
;29 //                 hardware that DOES normally have RAM mapped in to the
;30 //                 highest bank/quadrant) is to insure the ISRs for the fau
;31 //                 interrupts (the ones that can occur while a portion of f
;32 //                 is mapped in) is to insure that the ISR vector points to
;33 //                 function in the root code (in the 1st quadrant which is
;34 //                 never mapped out) and that the first thing the ISR does 
;35 //                 to insure the MMU regs are configured the way they norma
;36 //                 are, and (if the ISR doesn't reboot the OS) to put them
;37 //                 back the way it found them before returning.
;38 //
;39 //  2010-07-19 - Mark Davis
;40 //               - Refined the code for calling the write function to elimi
;41 //                 excess overhead in the computation of the arguments for 
;42 //                 call.
;43 //
;44 //  2010-06-11 - Mark Davis
;45 //               - Made all write functions the same in terms of saving and
;46 //                 restoring the value of XPC.  The (currently unused) func
;47 //                 for writing to sectors where not the same as the (curren
;48 //                 used) byte-at-atime version.
;49 //
;50 //  2010-06-03 - Mark Davis
;51 //               - Memory write protection is temporarily disabled in the
;52 //                 functions that do the work of writing to flash
;53 //
;54 //  2010-05-20 - Mark Davis (*)
;55 //               - Created alternate version of Softools file for DEBROS us
;56 //                  - mapFlashAddress() checks to make sure the memory bank
;57 //                    the stack is in does not get mapped out.  This was a
;58 //                    problem for DEBROS since stacks can be located anywhe
;59 //                    in RAM.
;60 //                  - mapFlashAddress() takes a pointer to the function tha
;61 //                    will use the values it sets and insure the memory ban
;62 //                    it is in will not be mapped out.  Before it assumed t
;63 //                    the code would always be in a buffer with a fixed roo
;64 //                    location, which was not true even before my changes
;65 //                    because the read function used a buffer on the stack.
;66 //                  - Root memory is no longer allowed to be mapped out.
;67 //                  - DEBROS always runs from RAM so I removed the code tha
;68 //                    supported running from flash by copying code to a buf
;69 //                    and executing it from there (which just added overhea
;70 //                  - Added calls to disable the scheduler
;71 //
;72 //-------------------------------------------------------------------------
;73 //  To-Do:
;74 //
;75 //    - WriteFlash() still has lots of room for improvement.  There is an
;76 //      awful lot of redundant computation going on for each byte written,
;77 //      particulary if we just specify a few more restictions on the call
;78 //      (which are already true for DEBROS).  Basically the LACK of assumpt
;79 //      about how it is called adds LOTS of overhead for flexability that w
;80 //      don't use!
;81 //
;82 //-------------------------------------------------------------------------
;83 
;84 #include <Rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
;85 #include <string.h>
;86 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;87 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;88 #include <common.h>
;89 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;90 #include <sys/serial.h>  // required to use flushConsole()
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;91 
;92 #include <linux/sched.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
;93 #include <unistd.h>
;94 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;95 #include <flash.h>
;96 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\flash.h' 0 55 21 17 7 26
	.debug	I
;97 #include <sys/hdwDefs.h>
;98 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;99 
;100 
;101 #undef YES
;102 #undef NO
;103 #define YES 1
;104 #define NO  0
;105 
;106 
;107 
;108 //  Types of functions in RAM
;109 typedef uint (*tDetectFlash) (uint);
;110 typedef uchar (*tWriteFlashByte) (uint, uchar *, uint, uint);
;111 typedef void (*tReadFlash)(ulong, char *, uint);
;112 
;113 //  Accessors for address as pointer, ulong, and in parts
;114 typedef union {
;115   char const far  *p;
;116   ulong   dw;
;117   uint    w;
;118   uchar   b[4];
;119   uint    hl[2];
;120 } FlAddress;
;121 
;122 //  Define a list of Flashes with their address range and type
;123 typedef struct  {
;124   FlType     type;        //  Type in range
;125   uint       sectorSize;  //  Size of sector
;126   ulong      deviceSize;  //  Size of device
;127   FlAddress  start;       //  Start of a flash
;128   FlAddress  end;         //  End address of device (+1)
;129   uchar      mbxcr;       //  Lower nibble of MBxCR
;130 } FlDeviceInt;
;131 
;132 //  Define storage for 2 flash devices.  These are by range and need not
;133 //  be contiguous addresses.  deviceCount is the number of flashes detected
;134 static FlDeviceInt    device[2];
;135 static int        deviceCount;
;136 
;137 //  The global unlock DWord used to add some safety to the programming proc
;138 ulong       _FlashUnlock;
;139 
;140 //  This buffer size depends on the size of function  _DetectFlashDevice,
;141 // _ByteWriteFlash, and _SectorWriteFlash.  The lager one "wins"
;142 
;143 //  Set to 0 when DetectFlash is called and the flash is detected.
;144 static uchar   notReady = 1;   //  Mark flash not detected
	.dseg
_notReady:
	.db	0x1
	.debug	F _notReady 3 0
;145 
;146 //  Set to address of last programming error when an error occurs
;147 ulong       _FlashError;
;148 
;149 //  Declare detectFlash prototype for initializer following.
;150 FlDeviceInfo  *detectFlash(ulong _4kBlock);
;151 
;152 extern const FlDeviceInfo far supportedDevices[];
;153 extern const int numDevices;
;154 
;155 //
;156 //  Detect a single flash device.  This is not used directly
;157 //  by an application.
;158 //
;159 const far FlDeviceInfo * far DetectFlashDevice(ulong baseAddr, uchar mbxcr)
;160 
;161 //--- set by mapFlashAddress() ---
;162 // WARNING:  These must values must be in root memory (the 1st 58K) and
;163 // protected against change between when they are set and when they are use
;164 // See mapFlashAddress() for description of these values:
;165 static uchar  MBcr;
;166 static uchar  MBval;
;167 static uchar  MBsVal;
;168 static ulong  MBaddr;
;169 
;170 
;171 //-------------------------------------------------------------------------
;172 //  Determine which memory bank we can safely map the specified flash addre
;173 //  to long enough to read or write a block of bytes that are all in the sa
;174 //  4K block of memory.  This is generally called just once for the 1st byt
;175 //  in a 4K block, as the values are the same for all bytes in the same blo
;176 //
;177 //  The decision is based on the following assumptions:
;178 //    - The size of each memory bank is 256K
;179 //    - The code is running from RAM, NOT from flash
;180 //    - The function that codeAddr refers to does not cross a memory bank
;181 //    - The stack does not cross a memory bank
;182 //
;183 //  The function sets the following global variables:
;184 //    - MBcr:    WHICH memory bank register to use to access the flash
;185 //    - MBVal:   The VALUE to use for the selected memory bank's MBxCR regi
;186 //    - MBaddr:  The ADDR in the meory bank's range to use to access the fl
;187 //    - MBsVal:  The value to restore the memory bank register to
;188 //-------------------------------------------------------------------------
;189 void  mapFlashAddress(ulong flashAddr_, uchar mbxcr, char far *codeAddr_)
;190 {
	.defseg	FARCODE
	.seg	FARCODE
$mapFlashAddress::
	.debug	G $mapFlashAddress 32 9
	.debug	{ $mapFlashAddress 32 189 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-19
	.debug	A flashAddr_ 5 9
	.debug	A mbxcr 9 3
	.debug	A codeAddr_ 11 33
;191   FlAddress  flashAddr, codeAddr, stackAddr;
	.debug	L flashAddr -4 34
	.debug	L codeAddr -8 34
	.debug	L stackAddr -12 34
;192   uchar  test, bank, flashBank, codeBank, stackBank;
	.debug	L test -13 3
	.debug	L bank -14 3
	.debug	L flashBank -15 3
	.debug	L codeBank -16 3
	.debug	L stackBank -17 3
;193   uchar  ws = SerialGet19200TC() > 76 ? _WS2 : _WS1;
	.debug	L ws -18 3
	.debug	# 193
	ld	a,(__serial19200TC)
	sub	a,76
	jr	c,@4
	jr	z,@4
	ld	a,0x40
	jr	@5
@4:
	ld	a,0x80
@5:
	ld	(ix-18),a
	.seg	FARCODE
;194 
;195 
;196   codeAddr.p = codeAddr_;
	.debug	# 196
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;197   flashAddr.dw = flashAddr_;
	.debug	# 197
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;198   stackAddr.dw = 0;  stackAddr.b[1] = (uint)ini(SEGSIZE) & 0xF0;
	.debug	# 198
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ioi ld	a,(19)
	ld	l,a
	ld	de,0xf0
	and	hl,de
	ld	(ix-11),l
;199   stackAddr.dw += ((ulong)ini(STACKSEG) << 12);
	.debug	# 199
	ioi ld	a,(17)
	ld	e,a
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;200 
;201   flashBank = (flashAddr.b[2] & 0x0C) >> 2;
	.debug	# 201
	ld	a,(ix-2)
	and	a,12
	bool	hl
	ld	l,a
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-15),l
;202   codeBank = (codeAddr.b[2] & 0x0C) >> 2;
	.debug	# 202
	ld	a,(ix-6)
	and	a,12
	bool	hl
	ld	l,a
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-16),l
;203   stackBank = (stackAddr.b[2] & 0x0C) >> 2;
	.debug	# 203
	ld	a,(ix-10)
	and	a,12
	bool	hl
	ld	l,a
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-17),l
;204 
;205 //--- Determine which bank is safe to use to access the flash ---
;206 //--- Note we don't allow 0 to be used to access flash because that is ---
;207 //--- where ROOT is (which holds some of the values we set here and use ---
;208 //--- elsewhere) ---
;209   for (test=1; test<4; ++test)  {
@6:
	.debug	< @6 @7
	.debug	# 209
	ld	(ix-13),0x1
@8:
	ld	a,(ix-13)
	sub	a,4
	jr	nc,@9
;210     if ((test == codeBank) OR (test == stackBank))  continue;
@11:
	.debug	< @11 @12
	.debug	# 210
	ld	a,(ix-13)
	ld	hl,(ix-16)
	sub	a,l
	jr	z,@10
	ld	a,(ix-13)
	ld	hl,(ix-17)
	sub	a,l
	jr	z,@10
;211 //    if ((bank = test) == flashBank)  break;
;212     bank = test;  // use the largest possible # bank to minimize ISR clashe
	.debug	# 212
	ld	a,(ix-13)
	ld	(ix-14),a
;213   }
@12:
	.debug	>
;214 
;215 //--- If we have to use a different bank than the "natural" one (i.e. the -
;216 //--- one that would not require any address translation), then figure out 
;217 //--- which bits need to be inverted, invert them now in the address we wil
;218 //--- use in the code to access the flash, and set the MBxCR register value
;219 //--- so the same bits will be re-inverted when using the selected bank ---
;220 //--- (i.e. so writing to the modified address in the selected bank causes 
;221 //--- the MMU to generate the correct physical addresses) ---
;222 
;223   if (bank != flashBank)  {
@10:
	ld	a,(ix-13)
	inc	a
	ld	(ix-13),a
	jr	@8
@9:
@7:
	.debug	>
	.debug	# 223
	ld	a,(ix-14)
	ld	hl,(ix-15)
	sub	a,l
	jr	z,@15
;224     uchar invert = bank ^ flashBank;
@16:
	.debug	< @16 @17
	.debug	L invert -19 3
	.debug	# 224
	ld	a,(ix-14)
	xor	a,l
	ld	(ix-19),a
	.seg	FARCODE
;225     flashAddr.b[2] ^= (invert <<= 2);
	.debug	# 225
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	ld	(ix-19),l
	ld	a,(ix-2)
	xor	a,l
	ld	(ix-2),a
;226     mbxcr |= (invert << 2);  flashBank = bank;
	.debug	# 226
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	d,0
	ld	e,(ix+9)
	or	hl,de
	ld	(ix+9),l
	ld	a,(ix-14)
	ld	(ix-15),a
;227   }
@17:
	.debug	>
;228 
;229   MBaddr = flashAddr.dw;
@15:
	.debug	# 229
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_MBaddr),de
	ld	(_MBaddr+2),bc
;230   MBcr = MB0CR + flashBank;
	.debug	# 230
	ld	a,(ix-15)
	add	a,20
	ld	(_MBcr),a
;231   MBval = mbxcr | ws;
	.debug	# 231
	ld	a,(ix+9)
	ld	hl,(ix-18)
	or	a,l
	ld	(_MBval),a
;232   MBsVal = *(&srMB0CR + flashBank);
	.debug	# 232
	bool	hl
	ld	l,(ix-15)
	ld	de,_srMB0CR
	add	hl,de
	ld	a,(hl)
	ld	(_MBsVal),a
;233 }
@2:
	.debug	} @2 233

@1	equ	19
	ld	sp,ix
	pop	ix
	lret
@3	equ	21
;234 
;235 
;236 
;237 /*
;238 #if SECTOR_DEVICE_SUPPORT
;239 //-------------------------------------------------------------------------
;240 //  _SectorWrite: Write a sector (block) to a device.  This uses SDP mode
;241 //  which is safer and prevents random/inadvertent writes to flash from
;242 //  going into page write mode.
;243 //
;244 //  SDP Write : 5555H=AAH 2AAAH=55H 5555H=A0H
;245 //-------------------------------------------------------------------------
;246 //  WARNING:  This function must be located in root memory (the 1st 64K) an
;247 //            must NOT call functions that may be in the memory bank that i
;248 //            used to write to flash.  Near functions (that don't call any 
;249 //            or nearcall functions) are safe because mapFlashAddress()
;250 //            currently does not allow bank 0 to be used for this.  Macros 
;251 //            (if the compiler ever supports them) in-line functions are sa
;252 //            Anything else (including nearcall functions) are NOT safe to 
;253 //-------------------------------------------------------------------------
;254 writeReturn near *_SectorWrite(uint _4kBlock, ulong writeOffset, uint count
;255 {
;256   char    xpc0000 = _4kBlock - 0x0E;
;257   char    xpc5555 = _4kBlock - (0x0E - 0x05);
;258   char    xpc2AAA = _4kBlock - (0x0E - 0x02);
;259   char    xpcSave;
;260   ulong   writeAddr = _4kBlock + writeOffset;
;261   char    xpcWrite = (uint) (writeAddr >> 12) + (0x80 - 0xE);
;262   uchar    *log5555 = (uchar *) 0xE555;
;263   uchar    *log2AAA = (uchar *) 0xEAAA;
;264   uchar    *addr = (uchar *) (((uint) writeAddr & 0xFFF) | 0xE000);
;265   uchar    wr, rd;
;266   uint    offset;
;267   uchar    *buff = buffer;
;268   static writeReturn wrReturn;
;269 
;270 
;271   wrReturn.length = sizeof (writeReturn);
;272   wrReturn.error = 0;
;273 
;274   getXPC(xpcSave);  ipset3();  outi(MBcr, MBval);  DisableWriteProtection()
;275 
;276   setXPC(xpc5555);  *log5555 = 0xAA;    //  Write SDP
;277   setXPC(xpc2AAA);  *log2AAA = 0x55;
;278   setXPC(xpc5555);  *log5555 = 0xA0;
;279 
;280   setXPC(xpcWrite);  memcopy( addr, buffer, count );   //  Uses LDIR!
;281 
;282   while ((*addr ^ *addr) & 0x40); //  Use toggle mode to wait for prev writ
;283 
;284   for (offset = 0; count; --count, ++offset)
;285     if ((rd = *addr++) != (wr = *buff++))  {
;286       wrReturn.error = 1;   //  Can use more info later if nec
;287       wrReturn.address = writeAddr + offset;
;288       wrReturn.writtenByte = wr;
;289       wrReturn.readByte = rd;
;290     }
;291 
;292   EnableWriteProtection();  setXPC(xpcSave);  outi(MBcr, MBsVal);  ipres();
;293 
;294   return &wrReturn;
;295 }
;296 #endif
;297 */
;298 
;299 //-------------------------------------------------------------------------
;300 //  This is left for the user to implement.  Since it's a byte-write
;301 //  function, reading in the sector, changing the byte, and writing
;302 //  back is the algorithm.  But it is highly inefficient.  Some method
;303 //  of buffering and writing a sector at a time should be provided.
;304 //  Since this function is likley to be called sequentially, this
;305 //  could buffer a sector and write it when the last byte is written.
;306 //  Of course, finishing the final buffer's worth has to be handled.
;307 //
;308 //  _FlashByteSecWrite: Write a byte to a device.
;309 //
;310 //  _4kBlock is the address >> 12 (since we can't do a runtime call in this
;311 //
;312 //  If erase is non-0, the sector containing the byte to program will be er
;313 //  It's unlikely that this paramter is useful for sector-write devices.
;314 //
;315 //  This must not contain branching code more than 128 bytes.
;316 //
;317 //  Returns 0 on no errors, or 1 if the byte doesn't match.
;318 //-------------------------------------------------------------------------
;319 //  WARNING:  This function must be located in root memory (the 1st 64K) an
;320 //            must NOT call functions that may be in the memory bank that i
;321 //            used to write to flash.  Near functions (that don't call any 
;322 //            or nearcall functions) are safe because mapFlashAddress()
;323 //            currently does not allow bank 0 to be used for this.  Macros 
;324 //            (if the compiler ever supports them) in-line functions are sa
;325 //            Anything else (including nearcall functions) are NOT safe to 
;326 //-------------------------------------------------------------------------
;327 uchar near _FlashByteSecWrite(uint _4kBlock, uchar *logAddr,
;328                               uint byte, uint DontErase)
;329 {
	.cseg
__FlashByteSecWrite::
	.debug	G __FlashByteSecWrite 35 1
	.debug	{ __FlashByteSecWrite 35 327 @20 @19
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A _4kBlock 4 7
	.debug	A logAddr 6 36
	.debug	A byte 8 7
	.debug	A DontErase 10 7
;330 #if SECTOR_DEVICE_SUPPORT
;352   return 1;
	.debug	# 352
	ld	a,0x1
;353 #pragma warn 760
;354 #endif // SECTOR_DEVICE_SUPPORT
;355 }
@19:
	.debug	} @19 355

@18	equ	0
	pop	ix
	ret
@20	equ	2
;356 
;357 #pragma warn +760
;358 
;359 
;360 //-------------------------------------------------------------------------
;361 //  RAM portion of FlashByteDevWrite.
;362 //
;363 //  _FlashByteDevWrite: Write a byte to a device.  This uses SDP mode
;364 //  which is safer and prevents random/inadvertent writes to flash from
;365 //  going into page write mode.
;366 //
;367 //  SDP Write Byte:   5555H=AAH 2AAAH=55H 5555H=A0H
;368 //
;369 //  SDP Sector erase: 5555H=AAH 2AAAH=55H 5555H=80H
;370 //                    5555H=AAH 2AAAH=55H 5555H=30H
;371 //
;372 //  _4kBlock is the address >> 12 (since we can't do a runtime call in this
;373 //
;374 //  If erase is non-0, the sector containing the byte to program will be er
;375 //
;376 //  This must not contain branching code more than 128 bytes.
;377 //
;378 //  Returns 0 on no errors, or 1 if the byte doesn't match.
;379 //-------------------------------------------------------------------------
;380 //  WARNING:  This function must be located in root memory (the 1st 64K) an
;381 //            must NOT call functions that may be in the memory bank that i
;382 //            used to write to flash.  Near functions (that don't call any 
;383 //            or nearcall functions) are safe because mapFlashAddress()
;384 //            currently does not allow bank 0 to be used for this.  Macros 
;385 //            (if the compiler ever supports them) in-line functions are sa
;386 //            Anything else (including nearcall functions) are NOT safe to 
;387 //-------------------------------------------------------------------------
;388 uchar near _nostep _FlashByteDevWrite(uint _4kBlock, uchar *logAddr,
;389                                       uint byte, uint DontErase)
;390 {
__FlashByteDevWrite::
	.debug	G __FlashByteDevWrite 35 3
	.debug	{ __FlashByteDevWrite 35 388 @23 @22
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A _4kBlock 4 7
	.debug	A logAddr 6 36
	.debug	A byte 8 7
	.debug	A DontErase 10 7
;391   // These values are the same every call for a given 4K block of bytes...
;392   char  xpcBase = _4kBlock - 0x0E;  // XPC for logAddr
	.debug	L xpcBase -1 3
	.debug	# 392
	ld	hl,(ix+4)
	ld	de,0xfff2
	add	hl,de
	ld	(ix-1),l
	.cseg
;393   char  xpcDev = _4kBlock & 0xF0;
	.debug	L xpcDev -2 3
	.debug	# 393
	ld	hl,(ix+4)
	ld	de,0xf0
	and	hl,de
	ld	(ix-2),l
	.cseg
;394   char  xpc5555 = xpcDev - (0x0E - 0x05);
	.debug	L xpc5555 -3 3
	.debug	# 394
	ld	a,l
	add	a,247
	ld	(ix-3),a
	.cseg
;395   char  xpc2AAA = xpcDev - (0x0E - 0x02);
	.debug	L xpc2AAA -4 3
	.debug	# 395
	ld	a,l
	add	a,244
	ld	(ix-4),a
	.cseg
;396   uchar  *log5555 = (uchar *) 0xE555;
	.debug	L log5555 -6 36
	.debug	# 396
	ld	hl,0xe555
	ld	(ix-6),hl
	.cseg
;397   uchar  *log2AAA = (uchar *) 0xEAAA;
	.debug	L log2AAA -8 36
	.debug	# 397
	ld	hl,0xeaaa
	ld	(ix-8),hl
	.cseg
;398 
;399   char  xpcSave;
	.debug	L xpcSave -9 3
;400   uchar  read;
	.debug	L read -10 3
;401   uint  loop;
	.debug	L loop -12 7
;402 
;403 
;404   getXPC(xpcSave);  ipset3();  outi(MBcr, MBval);  DisableWriteProtection()
	.debug	# 404
	ld	a,xpc
	ld	(ix-9),a
	ipset	3
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBval)
	ioi ld	(hl),a
@24:
	.debug	< @24 @25
	ld	a,0x80
	ioi ld	(16),a
	xor	a,a
	ioi ld	(1088),a
	xor	a,a
	ioi ld	(16),a
@25:
	.debug	>
;405 
;406   //  Erase sector - 2 steps of SDP
;407   if (! DontErase)  {       //  Or, if( erase )
	.debug	# 407
	ld	hl,(ix+10)
	bool	hl
	jr	nz,@26
;408     for (loop=2; loop; )  {
@27:
	.debug	< @27 @28
@29:
	.debug	< @29 @30
	.debug	# 408
	ld	hl,0x2
	ld	(ix-12),hl
@31:
	ld	hl,(ix-12)
	bool	hl
	jr	z,@32
;409       setXPC(xpc5555);  *log5555 = 0xAA;    //  Write SDP
@33:
	.debug	< @33 @34
	.debug	# 409
	ld	a,(ix-3)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0xaa
;410       setXPC(xpc2AAA);  *log2AAA = 0x55;
	.debug	# 410
	ld	a,(ix-4)
	ld	xpc,a
	ld	a,0x55
	ld	hl,(ix-8)
	ld	(hl),a
;411       if (--loop)  {    //  First pass, write 0x80
	.debug	# 411
	ld	hl,(ix-12)
	dec	hl
	ld	(ix-12),hl
	bool	hl
	jr	z,@35
;412         setXPC(xpc5555);  *log5555 = 0x80;  }
@36:
	.debug	< @36 @37
	.debug	# 412
	ld	a,(ix-3)
	ld	xpc,a
	ld	a,0x80
	ld	hl,(ix-6)
	jr	@157
@37:
	.debug	>
;413       else  {           //  Second pass, write 0x30 to sector
@35:
;414         setXPC(xpcBase);  *logAddr = 0x30;  }
@39:
	.debug	< @39 @40
	.debug	# 414
	ld	a,(ix-1)
	ld	xpc,a
	ld	a,0x30
	ld	hl,(ix+6)
@157:
	ld	(hl),a
@40:
	.debug	>
;415     }
@34:
	.debug	>
;416     while ((*logAddr ^ *logAddr) & 0x40); //  Use toggle mode to wait for p
	jr	@31
@32:
@30:
	.debug	>
@41:
	.debug	# 416
	ld	hl,(ix+6)
	ld	a,(hl)
	ld	l,(hl)
	xor	a,l
	and	a,64
	jr	nz,@41
;417   }
@28:
	.debug	>
;418 
;419   setXPC(xpc5555);  *log5555 = 0xAA;  //  Prep to write the byte
@26:
	.debug	# 419
	ld	a,(ix-3)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0xaa
;420   setXPC(xpc2AAA);  *log2AAA = 0x55;
	.debug	# 420
	ld	a,(ix-4)
	ld	xpc,a
	ld	hl,(ix-8)
	ld	(hl),0x55
;421   setXPC(xpc5555);  *log5555 = 0xA0;
	.debug	# 421
	ld	a,(ix-3)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0xa0
;422 
;423   setXPC(xpcBase);  *logAddr = byte;  // Write the byte
	.debug	# 423
	ld	a,(ix-1)
	ld	xpc,a
	ld	a,(ix+8)
	ld	hl,(ix+6)
	ld	(hl),a
;424 
;425   while ((*logAddr ^ *logAddr) & 0x40);  // Wait for write to finish
@43:
	.debug	# 425
	ld	hl,(ix+6)
	ld	a,(hl)
	ld	l,(hl)
	xor	a,l
	and	a,64
	jr	nz,@43
;426 
;427   read = *logAddr;
	.debug	# 427
	ld	hl,(ix+6)
	ld	a,(hl)
	ld	(ix-10),a
;428 
;429   EnableWriteProtection();  setXPC(xpcSave);  outi(MBcr, MBsVal);  ipres();
@45:
	.debug	< @45 @46
	.debug	# 429
	ld	a,0x80
	ioi ld	(16),a
	ld	a,0x1
	ioi ld	(1088),a
	xor	a,a
	ioi ld	(16),a
@46:
	.debug	>
	ld	a,(ix-9)
	ld	xpc,a
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBsVal)
	ioi ld	(hl),a
	ipres
;430 
;431   return read != (uchar) byte;
	.debug	# 431
	ld	a,(ix-10)
	ld	hl,(ix+8)
	sub	a,l
	jr	z,@22
	ld	a,1
;432 }
@22:
	.debug	} @22 432

@21	equ	12
	ld	sp,ix
	pop	ix
	ret
@23	equ	14
;433 
;434 
;435 //-------------------------------------------------------------------------
;436 //  WriteFlash: Write a block of data to Flash.  If a sector boundary is
;437 //  crossed, this needs to split on the boundary and tell the ByteWrite
;438 //  RAM routine to erase the sector.
;439 //
;440 //  *** WARNING ***  *** WARNING ***  *** WARNING ***  *** WARNING ***
;441 //
;442 //    All calls should be for a complete sector worth of bytes.  Each secto
;443 //    must be erased before new data can be written, so the caller is
;444 //    responsible for all caching (i.e. read the whole sector, modify it, t
;445 //    rewrite the whole sector).  Anything else will leave a mess!
;446 //
;447 //    The only thing this function does to facilitate this is to erase
;448 //    the sector it is about to write to IF (and ONLY IF) the address
;449 //    of the first byte to be written is the first byte in a sector.
;450 //
;451 //    While the rewriting of a sector COULD be spread across multiple
;452 //    calls, care must be taken to insure the first call is for the
;453 //    address of the first byte of a sector, and that no other task
;454 //    tries to read from or write to the sector until it has been
;455 //    completely rewritten (i.e. it basically needs to be locked
;456 //    by whatever task is modifying it until it is done).
;457 //
;458 //  This returns:
;459 //     0 if no error
;460 //    -1 if a fatal error (didn't detect flash),
;461 //    -2 if the _FlashUnlock ulong wasn't set before the call
;462 //     1 if a programming error.  Calling FlashError() will return the addr
;463 //       in flash that didn't verify.
;464 //-------------------------------------------------------------------------
;465 #pragma offset_labels on
;466 #pragma warn -757
;467 
;468 int far WriteFlash(char const far *addr, uchar const far *buffer, ulong cou
;469 {
	.seg	FARCODE
$WriteFlash::
	.debug	G $WriteFlash 37 9
	.debug	{ $WriteFlash 37 468 @50 @49
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-21
.addr = 5
	.debug	A addr 5 33
.buffer = 9
	.debug	A buffer 9 33
.count = 13
	.debug	A count 13 9
;470   FlAddress  writeAddr, endAddr;
.writeAddr = -4
	.debug	L writeAddr -4 34
.endAddr = -8
	.debug	L endAddr -8 34
;471   int     usingDevice;      //  Device in device[] we're using.
.usingDevice = -10
	.debug	L usingDevice -10 6
;472   FlDeviceInt *pDev;
.pDev = -12
	.debug	L pDev -12 38
;473   uint    sectorMask;
.sectorMask = -14
	.debug	L sectorMask -14 7
;474   FlAddress bytes;
.bytes = -18
	.debug	L bytes -18 34
;475   char    wrFailed;
.wrFailed = -19
	.debug	L wrFailed -19 3
;476   tWriteFlashByte  writeByteFunc;
.writeByteFunc = -21
	.debug	L writeByteFunc -21 40
;477 
;478 
;479   //  Ensure the driver has been copied!
;480   if (notReady || deviceCount == 0)  return -1;
	.debug	# 480
	ld	a,(_notReady)
	or	a,a
	jr	nz,@51
	ld	hl,(_deviceCount)
	bool	hl
	jr	nz,@52
@51:
	ld	hl,0xffff
	jp	@49
;481 
;482   //  Store start and end address (+1)
;483   writeAddr.p = addr;
@52:
	.debug	# 483
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;484 
;485   //  Check that this write has been unlocked or that the address isn't 0xF
;486   if( ~_FlashUnlock != writeAddr.dw || ! (writeAddr.dw+1) )  return -2;
	.debug	# 486
	ld	de,(__FlashUnlock)
	ld	bc,(__FlashUnlock+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	jr	nz,@53
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	or	hl,de
	jr	nz,@54
@53:
	ld	hl,0xfffe
	jp	@49
;487 
;488   _FlashUnlock = 0;           //  Reset it
@54:
	.debug	# 488
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(__FlashUnlock),de
	ld	(__FlashUnlock+2),bc
;489   endAddr.dw = writeAddr.dw + count;
	.debug	# 489
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;490 
;491   while (count)  {
@55:
	.debug	# 491
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	or	hl,de
	jp	z,@56
;492     //  Find device in device[] list.  This loops when a write spans more t
;493     //  device.  So the tests all use writeAddr since it is updated while p
;494     usingDevice = GetFlashDevice( writeAddr.dw, NULL );
@57:
	.debug	< @57 @58
	.debug	# 494
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$GetFlashDevice
	add	sp,6
	ld	(ix-10),hl
;495 
;496       //  If address not in a detected flash, return
;497     if (usingDevice == -1)  return -1;
	.debug	# 497
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@59
	ld	h,d
	ld	l,e
	jp	@49
;498 
;499     //  Get the sector boundary test mask and device xpc
;500     pDev = &device[usingDevice];
@59:
	.debug	# 500
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_device
	add	hl,de
	ld	(ix-12),hl
;501     sectorMask = pDev->sectorSize - 1;
	.debug	# 501
	inc	hl
	ld	hl,(hl)
	dec	hl
	ld	(ix-14),hl
;502 
;503     //  Find amount of bytes in addressed device.  This allows writing whil
;504     //  spanning different flash configurations (i.e. different sector size
;505     if( pDev->end.dw < endAddr.dw )
	.debug	# 505
	ld	hl,(ix-12)
	ld	de,0xb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	nc,@60
;506       bytes.dw = pDev->end.dw - pDev->start.dw;
	.debug	# 506
	ld	hl,(ix-12)
	ld	de,0xb
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x7
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;507     else
;508       bytes.dw = count;
	jr	@61
@60:
	.debug	# 508
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;509 
;510     if (pDev->type == FlBytePrg)
@61:
	.debug	# 510
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jr	nz,@62
;511       writeByteFunc = _FlashByteDevWrite;
	.debug	# 511
	ld	hl,__FlashByteDevWrite
	ld	(ix-21),hl
;512     else
;513       writeByteFunc = _FlashByteSecWrite;
	jr	@63
@62:
	.debug	# 513
	ld	hl,__FlashByteSecWrite
	ld	(ix-21),hl
;514 
;515   //--- The count is decremented to 0 by the loop, so we update the count o
;516   //--- not-yet written bytes before the loop that actually writes them. --
;517     count -= bytes.dw;
@63:
	.debug	# 517
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;518 
;519   //--- We can only write to one sector of flash at a time, and part of ---
;520   //--- RAM is often mapped out of the physical address space while we are 
;521   //--- doing it, so we insure we can't be preempted while writing a block 
;522   //--- of bytes (which also protects the values set by mapFlashAddress, --
;523   //--- which are currently global values in root memory to insure they ---
;524   //--- are accessible while a part of flash is mapped in) ---
;525     KLOCK();
	.debug	# 525
	call	_KLOCK
;526 
;527     mapFlashAddress(writeAddr.dw, pDev->mbxcr, (char far *)writeByteFunc);
	.debug	# 527
	ld	hl,(ix-21)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-12)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$mapFlashAddress
	add	sp,10
;528 
;529     while (bytes.dw)  {
@64:
	.debug	# 529
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	or	hl,de
	jp	z,@65
;530       if (bytes.hl[0]-- == 0)  --bytes.hl[1];
@66:
	.debug	< @66 @67
	.debug	# 530
	ld	h,d
	ld	l,e
	dec	hl
	ld	(ix-18),hl
	inc	hl
	bool	hl
	jr	nz,@68
	ld	h,b
	ld	l,c
	dec	hl
	ld	(ix-16),hl
;531 
;532       //  A bit ugly, but significantly more efficient than the compiled
;533       //  version, in part because it eliminates a call to the shift functi
;534 
;535       //finish:  Changing the loop so it handles only bytes all within a gi
;536       //         4K block will allow me to eliminate an awful lot of redund
;537       //         stuff here and in _FlashByteDevWrite()
;538       //         NOTE:  Spec sheet says MAX 20usec Byte-Program time, so
;539       //         optimization here could yield very significant results (in
;540       //         minimizing interferance with ISRs and reducing latency).
;541 
;542       wrFailed = (writeByteFunc) (
@68:
;543         // MBaddr >> 12  (4k block #)
;544           _asm( [_HL],
;545                 "ld   hl,(_MBaddr+1)",
;546                 "rr   hl",
;547                 "rr   hl",
;548                 "rr   hl",
;549                 "rr   hl",
;550                 "ld   h,0",
;551               _HL ),
;552         // MBaddr & 0xFFF | 0xE000  (logical 64K space Addr)
;553         (uchar *) _asm( [_HL, _DE, _A],
;554                 "ld   hl,(_MBaddr)",
;555                 "ld   de,0FFFh",
;556                 "and  hl,de",
;557                 "ld   a,0E0h",
;558                 "or   a,h",
;559                 "ld   h,a",
;560               _HL ),
;561         // *(uint far *)buffer  (byte to write)
;562           _asm( [_HL, _A],
;563                 "ld   hl,(ix+.buffer+2)",
;564                 "ld   a,l",
;565                 "ld   hl,(ix+.buffer)",
;566                 "ldp  hl,(hl)",
;567               _HL ),
;568         // MBaddr & sectorMask  (DontErase true unless 1st byte of a sector
;569           _asm( [_HL, _DE],
;570                 "ld   hl,(_MBaddr)",
;571                 "ex   de,hl",
;572                 "ld   hl,(ix+.sectorMask)",
;573                 "and  hl,de",
;574               _HL )
;575       );
	.debug	# 575
ld   hl,(_MBaddr)
ex   de,hl
ld   hl,(ix+.sectorMask)
and  hl,de
	push	hl
ld   hl,(ix+.buffer+2)
ld   a,l
ld   hl,(ix+.buffer)
ldp  hl,(hl)
	push	hl
ld   hl,(_MBaddr)
ld   de,0FFFh
and  hl,de
ld   a,0E0h
or   a,h
ld   h,a
	push	hl
ld   hl,(_MBaddr+1)
rr   hl
rr   hl
rr   hl
rr   hl
ld   h,0
	push	hl
	ex	de,hl
	ld	hl,(ix-21)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-19),a
;576 
;577       if (wrFailed)  {
	.debug	# 577
	or	a,a
	jr	z,@69
;578         _FlashError = MBaddr;
@70:
	.debug	< @70 @71
	.debug	# 578
	ld	de,(_MBaddr)
	ld	bc,(_MBaddr+2)
	ld	(__FlashError),de
	ld	(__FlashError+2),bc
;579         count = 0;  //  Terminate outer loop
	.debug	# 579
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;580         break;
	.debug	# 580
;581       }
	jp	@65
@71:
	.debug	>
;582       //  This is the fastest way to increment a 32-bit value.
;583       //  Since the compiler doesn't always have the address
;584       //  and it might need the value again, it can't generate this.
;585       _asm( _HL = (unsigned) &MBaddr, // does ++MBaddr
@69:
;586                   "inc (hl)", "jr nz,..x",
;587         "inc hl", "inc (hl)", "jr nz,..x",
;588         "inc hl", "inc (hl)", "jr nz,..x",
;589         "inc hl", "inc (hl)", "..x:" );
	.debug	# 589
	ld	hl,_MBaddr
inc (hl)
jr nz,..x
inc hl
inc (hl)
jr nz,..x
inc hl
inc (hl)
jr nz,..x
inc hl
inc (hl)
..x:
;590       ++buffer;
	.debug	# 590
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
;591     }
@67:
	.debug	>
;592 
;593     KUNLOCK();
	jp	@64
@65:
	.debug	# 593
	call	_KUNLOCK
;594   }
@58:
	.debug	>
;595 
;596   return wrFailed;
	jp	@55
@56:
	.debug	# 596
	bool	hl
	ld	l,(ix-19)
;597 }
@49:
	.debug	} @49 597

@48	equ	21
	ld	sp,ix
	pop	ix
	lret
@50	equ	23
;598 
;599 #pragma warn 757
;600 #pragma offset_labels off
;601 
;602 
;603 //-------------------------------------------------------------------------
;604 //  Return _FlashError.  Called after WriteFlash fails to get location of e
;605 //-------------------------------------------------------------------------
;606 ulong FlashError( void )
;607 {
$FlashError::
	.debug	G $FlashError 41 9
	.debug	{ $FlashError 41 606 @74 @73
;608   return _FlashError;
	.debug	# 608
	ld	de,(__FlashError)
	ld	bc,(__FlashError+2)
;609 }
@73:
	.debug	} @73 609

@72	equ	0
	lret
@74	equ	0
;610 
;611 
;612 //-------------------------------------------------------------------------
;613 //  Fill the next unused entry in the table of flash devices
;614 //-------------------------------------------------------------------------
;615 static void far fillFlashInfo( ulong address, const far FlDeviceInfo *dev,
;616                                uchar mbxcr )
;617 {
$fillFlashInfo:
	.debug	F $fillFlashInfo 42 9
	.debug	{ $fillFlashInfo 42 615 @77 @76
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A address 5 9
	.debug	A dev 9 43
	.debug	A mbxcr 13 3
;618   FlDeviceInt *flash = &device[deviceCount];
	.debug	L flash -2 38
	.debug	# 618
	ld	hl,(_deviceCount)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_device
	add	hl,de
	ld	(ix-2),hl
	.seg	FARCODE
;619 
;620   //  Fill in a device member of the array
;621   flash->start.dw = address;
	.debug	# 621
	ld	de,0x7
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;622   flash->type = dev->type;
	.debug	# 622
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix-2)
	ld	(hl),a
;623   flash->sectorSize = dev->sectorSize;
	.debug	# 623
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-2)
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;624   flash->deviceSize = dev->deviceSize;
	.debug	# 624
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;625   flash->end.dw = address + dev->deviceSize;
	.debug	# 625
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ladd##
	ld	hl,(ix-2)
	push	de
	ld	de,0xb
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;626   flash->mbxcr = mbxcr;
	.debug	# 626
	ld	hl,(ix-2)
	ld	de,0xf
	add	hl,de
	ld	a,(ix+13)
	ld	(hl),a
;627 
;628   ++deviceCount;
	.debug	# 628
	ld	hl,(_deviceCount)
	inc	hl
	ld	(_deviceCount),hl
;629 }
@76:
	.debug	} @76 629

@75	equ	2
	ld	sp,ix
	pop	ix
	lret
@77	equ	4
;630 
;631 //-------------------------------------------------------------------------
;632 //  RAM portion of DetectFlash.
;633 //
;634 //  This returns the Flash ID and Mfc ID at _4kBlock.
;635 //  (since we can't do a runtime call in this).
;636 //
;637 //  This must not contain branching code more than 128 bytes.
;638 //-------------------------------------------------------------------------
;639 //  WARNING:  This function must be located in root memory (the 1st 64K) an
;640 //            must NOT call functions that may be in the memory bank that i
;641 //            used to write to flash.  Near functions (that don't call any 
;642 //            or nearcall functions) are safe because mapFlashAddress()
;643 //            currently does not allow bank 0 to be used for this.  Macros 
;644 //            (if the compiler ever supports them) in-line functions are sa
;645 //            Anything else (including nearcall functions) are NOT safe to 
;646 //-------------------------------------------------------------------------
;647 unsigned int _nostep near  _DetectFlashDevice(uint _4kBlock)
;648 {
	.cseg
__DetectFlashDevice::
	.debug	G __DetectFlashDevice 45 3
	.debug	{ __DetectFlashDevice 45 647 @80 @79
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A _4kBlock 4 7
;649   char    xpc0000 = _4kBlock - 0x0E;
	.debug	L xpc0000 -1 3
	.debug	# 649
	ld	hl,(ix+4)
	ld	de,0xfff2
	add	hl,de
	ld	(ix-1),l
	.cseg
;650   char    xpc5555 = _4kBlock - (0x0E - 0x05);
	.debug	L xpc5555 -2 3
	.debug	# 650
	ld	hl,(ix+4)
	ld	e,0xf7
	add	hl,de
	ld	(ix-2),l
	.cseg
;651   char    xpc2AAA = _4kBlock - (0x0E - 0x02);
	.debug	L xpc2AAA -3 3
	.debug	# 651
	ld	hl,(ix+4)
	ld	e,0xf4
	add	hl,de
	ld	(ix-3),l
	.cseg
;652   char    xpcSave;
	.debug	L xpcSave -4 3
;653   uchar    *log5555 = (uchar *) 0xE555;
	.debug	L log5555 -6 36
	.debug	# 653
	ld	hl,0xe555
	ld	(ix-6),hl
	.cseg
;654   uchar    *log2AAA = (uchar *) 0xEAAA;
	.debug	L log2AAA -8 36
	.debug	# 654
	ld	hl,0xeaaa
	ld	(ix-8),hl
	.cseg
;655   uchar    mfcID;
	.debug	L mfcID -9 3
;656   uchar    flashID;
	.debug	L flashID -10 3
;657 
;658 
;659   getXPC(xpcSave);  ipset3();  outi(MBcr, MBval);
	.debug	# 659
	ld	a,xpc
	ld	(ix-4),a
	ipset	3
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBval)
	ioi ld	(hl),a
;660 
;661   setXPC(xpc5555);  *log5555 = 0xAA;
	.debug	# 661
	ld	a,(ix-2)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0xaa
;662   setXPC(xpc2AAA);  *log2AAA = 0x55;
	.debug	# 662
	ld	a,(ix-3)
	ld	xpc,a
	ld	hl,(ix-8)
	ld	(hl),0x55
;663   setXPC(xpc5555);  *log5555 = 0x90;
	.debug	# 663
	ld	a,(ix-2)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0x90
;664 
;665   setXPC(xpc0000);        //  Atmel says to read 0 and 1
	.debug	# 665
	ld	a,(ix-1)
	ld	xpc,a
;666   mfcID = * (uchar *) 0xE000;    //  Read mfcID
	.debug	# 666
	ld	a,(0xe000)
	ld	(ix-9),a
;667   flashID = * (uchar *) 0xE001;  //  Read flashID
	.debug	# 667
	ld	a,(0xe001)
	ld	(ix-10),a
;668 
;669   setXPC(xpc5555);  *log5555 = 0xAA;
	.debug	# 669
	ld	a,(ix-2)
	ld	xpc,a
	ld	(hl),0xaa
;670   setXPC(xpc2AAA);  *log2AAA = 0x55;
	.debug	# 670
	ld	a,(ix-3)
	ld	xpc,a
	ld	hl,(ix-8)
	ld	(hl),0x55
;671   setXPC(xpc5555);  *log5555 = 0xF0;
	.debug	# 671
	ld	a,(ix-2)
	ld	xpc,a
	ld	hl,(ix-6)
	ld	(hl),0xf0
;672 
;673   setXPC(xpcSave);  outi(MBcr, MBsVal);  ipres();
	.debug	# 673
	ld	a,(ix-4)
	ld	xpc,a
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBsVal)
	ioi ld	(hl),a
	ipres
;674 
;675   return (flashID << 8) | mfcID;
	.debug	# 675
	bool	hl
	ld	h,(ix-10)
	ld	l,0
	ld	d,l
	ld	e,(ix-9)
	or	hl,de
;676 }
@79:
	.debug	} @79 676

@78	equ	10
	ld	sp,ix
	pop	ix
	ret
@80	equ	12
;677 
;678 
;679 //-------------------------------------------------------------------------
;680 //  Detect flash devices in the system.
;681 //
;682 //  This checks baseAddr looking for a flash ID.  If found,
;683 //  a pointer to flash device info is filled in and 1 is returned.
;684 //  Otherwise 0 is returned.
;685 //  This does no translation for running in Flash versus RAM.
;686 //-------------------------------------------------------------------------
;687 const far FlDeviceInfo * far DetectFlashDevice(ulong baseAddr, uchar mbxcr)
;688 {
	.seg	FARCODE
$DetectFlashDevice::
	.debug	G $DetectFlashDevice 46 9
	.debug	{ $DetectFlashDevice 46 687 @83 @82
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A baseAddr 5 9
	.debug	A mbxcr 9 3
;689   uchar      mfcID;
	.debug	L mfcID -1 3
;690   uchar      flashID;
	.debug	L flashID -2 3
;691   unsigned int  val;
	.debug	L val -4 7
;692 
;693 
;694   KLOCK();
	.debug	# 694
	call	_KLOCK
;695 
;696   mapFlashAddress(baseAddr, mbxcr, (char far *)_DetectFlashDevice);
	.debug	# 696
	ld	hl,__DetectFlashDevice
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$mapFlashAddress
	add	sp,10
;697   notReady = 0;           //  Mark Detect Flash called
	.debug	# 697
	xor	a,a
	ld	(_notReady),a
;698 
;699   val = _DetectFlashDevice((uint)(MBaddr >> 12));
	.debug	# 699
	ld	de,(_MBaddr)
	ld	bc,(_MBaddr+2)
	ld	a,0xc
	call	__ulshr##
	push	de
	ex	de,hl
	call	__DetectFlashDevice
	pop	de
	ld	(ix-4),hl
;700 
;701   KUNLOCK();
	.debug	# 701
	call	_KUNLOCK
;702 
;703   flashID = val >> 8;  mfcID = (char) val;
	.debug	# 703
	ld	hl,(ix-4)
	ld	l,h
	ld	h,0
	ld	(ix-2),l
	ld	a,(ix-4)
	ld	(ix-1),a
;704 
;705   for (unsigned int idx = 0; idx != numDevices; ++idx)  {
@84:
	.debug	< @84 @85
	.debug	L idx -6 7
	.debug	# 705
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
@86:
	ld	hl,(ix-6)
	ld	de,(_numDevices)
	or	a,a
	sbc	hl,de
	jr	z,@87
;706     const FlDeviceInfo far *item = &supportedDevices[ idx ];
@89:
	.debug	< @89 @90
	.debug	L item -10 43
	.debug	# 706
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x9
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _supportedDevices)
	ld	c,phys _supportedDevices >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	.seg	FARCODE
;707     if (item->mfcID == mfcID)  if (item->flashID == flashID)  return item; 
	.debug	# 707
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix-1)
	sub	a,l
	jr	nz,@91
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix-2)
	sub	a,l
	jr	nz,@92
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	jr	@82
;708   }
@92:
@91:
@90:
	.debug	>
;709 
;710   return 0;
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@86
@87:
@85:
	.debug	>
	.debug	# 710
	ld	de,0
	ld	c,e
	ld	b,e
;711 }
@82:
	.debug	} @82 711

@81	equ	10
	ld	sp,ix
	pop	ix
	lret
@83	equ	12
;712 
;713 
;714 //-------------------------------------------------------------------------
;715 //  Detect all flashes in the system and fill out the device list for the
;716 //  range, type and sector size.
;717 //
;718 //  This ensures we get each MBxCR that is allocated to the 256k halves.
;719 //  Unused device2 and device3 should be set to 0xFFFF.
;720 //
;721 //  Returns the number of devices detected.
;722 //-------------------------------------------------------------------------
;723 int far DetectFlash( void )
;724 {
$DetectFlash::
	.debug	G $DetectFlash 47 9
	.debug	{ $DetectFlash 47 723 @95 @94
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;725   const far FlDeviceInfo *dev;
	.debug	L dev -4 43
;726 
;727   deviceCount = 0;
	.debug	# 727
	bool	hl
	ld	l,h
	ld	(_deviceCount),hl
;728 
;729   dev = DetectFlashDevice( 0, _CS0 | _OE0_WE0 );
	.debug	# 729
	push	hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$DetectFlashDevice
	add	sp,6
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;730 
;731   if (dev != NULL)  {
	.debug	# 731
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@96
;732     fillFlashInfo( 0, dev, _CS0 | _OE0_WE0 );
@97:
	.debug	< @97 @98
	.debug	# 732
	bool	hl
	ld	l,h
	push	hl
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$fillFlashInfo
	add	sp,10
;733 
;734     if (device[0].deviceSize == _256K)  {
	.debug	# 734
	ld	de,(_device+3)
	ld	bc,(_device+5)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xfffc
	call	__ladd##
	jr	nz,@99
;735       dev = DetectFlashDevice( _256K, _CS2 | _OE0_WE0 );
@100:
	.debug	< @100 @101
	.debug	# 735
	ld	hl,0x2
	push	hl
	ld	d,h
	ld	e,h
	ld	bc,0x4
	push	bc
	push	de
	lcall	$DetectFlashDevice
	add	sp,6
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;736       if( dev != NULL )  fillFlashInfo( _256K, dev, _CS2 | _OE0_WE0 );
	.debug	# 736
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@103
	ld	hl,0x2
	push	hl
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4
	push	bc
	push	de
	lcall	$fillFlashInfo
	add	sp,10
;737     }
@101:
	.debug	>
;738     else if (device[0].deviceSize == _512K)  {
	jr	@103
@99:
	.debug	# 738
	ld	de,(_device+3)
	ld	bc,(_device+5)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xfff8
	call	__ladd##
	jr	nz,@104
;739       dev = DetectFlashDevice( 0, _CS0 | _OE1_WE1 );
@105:
	.debug	< @105 @106
	.debug	# 739
	ld	hl,0x4
	push	hl
	ld	d,h
	ld	e,h
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$DetectFlashDevice
	add	sp,6
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;740       if( dev != NULL )  fillFlashInfo( 0, dev, _CS0 | _OE1_WE1 );
	.debug	# 740
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@107
	ld	hl,0x4
	push	hl
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$fillFlashInfo
	add	sp,10
;741     }
@107:
@106:
	.debug	>
;742   }
@104:
@103:
@98:
	.debug	>
;743 
;744   notReady = 0;
@96:
	.debug	# 744
	xor	a,a
	ld	(_notReady),a
;745 
;746   return deviceCount;
	.debug	# 746
	ld	hl,(_deviceCount)
;747 }
@94:
	.debug	} @94 747

@93	equ	4
	ld	sp,ix
	pop	ix
	lret
@95	equ	6
;748 
;749 
;750 //-------------------------------------------------------------------------
;751 //  GetFlashDevice.
;752 //
;753 //  If there is are no detected devices, this will detect the
;754 //  device at the passed address.
;755 //
;756 //  Returns -1 if there is no device at the passed address.
;757 //
;758 //  Returns the device index if not -1, and stores the sector
;759 //  size in sectorSize unless this is NULL.
;760 //-------------------------------------------------------------------------
;761 int far GetFlashDevice(FlDWord address, FlWord *sectorSize)
;762 {
$GetFlashDevice::
	.debug	G $GetFlashDevice 48 9
	.debug	{ $GetFlashDevice 48 761 @110 @109
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A address 5 9
	.debug	A sectorSize 9 49
;763   FlDeviceInt *pDev;
	.debug	L pDev -2 38
;764   int     usingDevice;
	.debug	L usingDevice -4 6
;765 
;766   //  If we have no devices, detect the one in question
;767   if (deviceCount == 0)  if (DetectFlash() == 0)  return -1;
	.debug	# 767
	ld	hl,(_deviceCount)
	bool	hl
	jr	nz,@111
	lcall	$DetectFlash
	bool	hl
	jr	nz,@112
	ld	hl,0xffff
	jr	@109
;768 
;769   //  Find device in device[] list.  This loops when a write spans more tha
;770   //  one device.  So the tests all use writeAddr since it is updated while
;771   //  programming.
;772   for (usingDevice=0; usingDevice!=deviceCount; ++usingDevice)  {
@112:
@111:
@113:
	.debug	< @113 @114
	.debug	# 772
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@115:
	ld	hl,(ix-4)
	ld	de,(_deviceCount)
	or	a,a
	sbc	hl,de
	jr	z,@116
;773     pDev = &device[ usingDevice ];
@118:
	.debug	< @118 @119
	.debug	# 773
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_device
	add	hl,de
	ld	(ix-2),hl
;774     if ((pDev->start.dw <= address) AND (address < pDev->end.dw))  {
	.debug	# 774
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	z,@122
	jr	nc,@121
@122:
	ld	hl,(ix-2)
	ld	de,0xb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	nc,@121
;775       if (sectorSize)  *sectorSize = pDev->sectorSize;
@123:
	.debug	< @123 @124
	.debug	# 775
	ld	hl,(ix+9)
	bool	hl
	jr	z,@125
	ld	hl,(ix-2)
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;776       return usingDevice;
@125:
	.debug	# 776
	ld	hl,(ix-4)
	jr	@109
;777     }
@124:
	.debug	>
;778   }
@121:
@119:
	.debug	>
;779 
;780   return -1;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@115
@116:
@114:
	.debug	>
	.debug	# 780
	ld	hl,0xffff
;781 }
@109:
	.debug	} @109 781

@108	equ	4
	ld	sp,ix
	pop	ix
	lret
@110	equ	6
;782 
;783 
;784 //-------------------------------------------------------------------------
;785 //  GetFlashDeviceEnd.
;786 //
;787 //  If there is are no detected devices, this will detect the
;788 //  device at the passed address.
;789 //
;790 //  Returns 0 if there is no device at the passed address.
;791 //
;792 //  Returns the end address of the passed device + 1, and stores the sector
;793 //  size in the passed pointer unless this is NULL.
;794 //-------------------------------------------------------------------------
;795 FlDWord far GetFlashDeviceEnd(FlDWord address, FlWord *sectorSize)
;796 {
$GetFlashDeviceEnd::
	.debug	G $GetFlashDeviceEnd 50 9
	.debug	{ $GetFlashDeviceEnd 50 795 @128 @127
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A address 5 9
	.debug	A sectorSize 9 49
;797   FlDeviceInt  *pDev;
	.debug	L pDev -2 38
;798   int  usingDevice;
	.debug	L usingDevice -4 6
;799 
;800   //  If we have no devices, detect the one in question
;801   if (deviceCount == 0)  if (DetectFlash() == 0)  return 0;
	.debug	# 801
	ld	hl,(_deviceCount)
	bool	hl
	jr	nz,@129
	lcall	$DetectFlash
	bool	hl
	jr	nz,@130
	ld	d,h
	ld	e,h
	ld	c,e
	ld	b,e
	jr	@127
;802 
;803   //  Find device in device[] list.  This loops when a write spans more tha
;804   //  device.  So the tests all use writeAddr since it is updated while pro
;805   for (usingDevice=0; usingDevice!=deviceCount; ++usingDevice)  {
@130:
@129:
@131:
	.debug	< @131 @132
	.debug	# 805
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@133:
	ld	hl,(ix-4)
	ld	de,(_deviceCount)
	or	a,a
	sbc	hl,de
	jr	z,@134
;806     pDev = &device[ usingDevice ];
@136:
	.debug	< @136 @137
	.debug	# 806
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_device
	add	hl,de
	ld	(ix-2),hl
;807     if( (pDev->start.dw <= address) && (address < pDev->end.dw) )  {
	.debug	# 807
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	z,@140
	jr	nc,@139
@140:
	ld	hl,(ix-2)
	ld	de,0xb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	nc,@139
;808       if (sectorSize)  *sectorSize = pDev->sectorSize;
@141:
	.debug	< @141 @142
	.debug	# 808
	ld	hl,(ix+9)
	bool	hl
	jr	z,@143
	ld	hl,(ix-2)
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;809       return pDev->end.dw;
@143:
	.debug	# 809
	ld	hl,(ix-2)
	ld	de,0xb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@127
;810     }
@142:
	.debug	>
;811   }
@139:
@137:
	.debug	>
;812 
;813   return 0;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@133
@134:
@132:
	.debug	>
	.debug	# 813
	ld	de,0
	ld	c,e
	ld	b,e
;814 }
@127:
	.debug	} @127 814

@126	equ	4
	ld	sp,ix
	pop	ix
	lret
@128	equ	6
;815 
;816 
;817 //-------------------------------------------------------------------------
;818 //  This uses the MMU settings computed by mapFlashAddress() to insure the
;819 //  desired portion of flash is accessable.  The value MBaddr is the absolu
;820 //  address of the first byte to copy.  The toAddr has to point to a buffer
;821 //  that does not cross a quadrant boundary and is in one of the quadrants
;822 //  that remains at the same location and is accessible while the needed
;823 //  portion of flash is also mapped in.
;824 //
;825 //  This function is designed to be copied to and run from anywhere in
;826 //  memory.  The only requirement is that all the following be in quadrants
;827 //  that can all be mapped in at the same time:
;828 //
;829 //     - fromAddr:  The absolute addr where the needed portion of flash wil
;830 //       be mapped to
;831 //     - toAddr:  The addr of a buffer to copy the data to
;832 //     - The stack with all the passed argument values
;833 //
;834 //-------------------------------------------------------------------------
;835 //  WARNING:  This function must be located in root memory (the 1st 64K) an
;836 //            must NOT call functions that may be in the memory bank that i
;837 //            used to write to flash.  Near functions (that don't call any 
;838 //            or nearcall functions) are safe because mapFlashAddress()
;839 //            currently does not allow bank 0 to be used for this.  Macros 
;840 //            (if the compiler ever supports them) in-line functions are sa
;841 //            Anything else (including nearcall functions) are NOT safe to 
;842 //-------------------------------------------------------------------------
;843 #pragma offset_labels on
;844 #pragma warn 760
;845 
;846 static void _nostep near _ReadFlash(ulong fromAddr, char *toAddr, uint coun
;847 {
	.cseg
__ReadFlash:
	.debug	F __ReadFlash 51 3
	.debug	{ __ReadFlash 51 846 @146 @145
	push	ix
	ld	ix,0
	add	ix,sp
.fromAddr = 4
	.debug	A fromAddr 4 9
.toAddr = 8
	.debug	A toAddr 8 36
.count = 10
	.debug	A count 10 7
;848   ipset3();  outi(MBcr, MBval);
	.debug	# 848
	ipset	3
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBval)
	ioi ld	(hl),a
;849 
;850   _BCDE = fromAddr;  _HL = (unsigned) toAddr;
	.debug	# 850
	ld	hl,(ix+4)
	ex	de,hl
	ld	hl,(ix+6)
	ld	bc,hl
	ld	hl,(ix+8)
;851 
;852 #asm
	.debug	# 853
push  ix               

	.debug	# 854
push  hl               

	.debug	# 855
ld    hl,(ix+.count)   

	.debug	# 856
pop   ix               

	.debug	# 857
ex    de,hl            

	.debug	# 858
ld    iy,hl            

	.debug	# 859
ld    de',1            ;; DE'= 1

	.debug	# 860
..lp:                    

	.debug	# 861
ld    a,d              

	.debug	# 862
or    a,e              

	.debug	# 863
jr    z,..done         

	.debug	# 864
ld    a,c              

	.debug	# 865
ldp   hl,(iy)          

	.debug	# 866
ld    (ix),l           

	.debug	# 867
dec   de               

	.debug	# 868
inc   ix               

	.debug	# 869
exx                    

	.debug	# 870
add   iy,de            

	.debug	# 871
exx                    

	.debug	# 872
jr    nc,..lp          

	.debug	# 873
inc   c                

	.debug	# 874
jr    ..lp             

	.debug	# 875
..done:

	.debug	# 876
pop   ix               

;878 
	.cseg
;879   outi(MBcr, MBsVal);  ipres();
	.debug	# 879
	ld	a,(_MBcr)
	ld	l,a
	ld	a,(_MBsVal)
	ioi ld	(hl),a
	ipres
;880 }
@145:
	.debug	} @145 880

@144	equ	0
	pop	ix
	ret
@146	equ	2
;881 #pragma warn +760
;882 
;883 //-------------------------------------------------------------------------
;884 //  ReadFlash.
;885 //
;886 //  This reads flash to memory.
;887 //  This is done since the flash could be mapped out if running in RAM.
;888 //-------------------------------------------------------------------------
;889 void far ReadFlash(char const far *fromAddr, uchar far *buffer, ulong count
;890 {
	.seg	FARCODE
$ReadFlash::
	.debug	G $ReadFlash 52 9
	.debug	{ $ReadFlash 52 889 @149 @148
	ld	hl,-264
	call	__fent##
.fromAddr = 5
	.debug	A fromAddr 5 33
.buffer = 9
	.debug	A buffer 9 33
.count = 13
	.debug	A count 13 9
;891   FlDeviceInt *pDev;
.pDev = -2
	.debug	L pDev -2 38
;892   int   usingDevice;      //  Device in device[] we're using.
.usingDevice = -4
	.debug	L usingDevice -4 6
;893   ulong  read;
.read = -8
	.debug	L read -8 9
;894   char readBuff[0x100];
.readBuff = -264
	.debug	L readBuff -264 53
;895 
;896 
;897   while( count )  {
@150:
	.debug	# 897
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	or	hl,de
	jp	z,@151
;898     //  Find device in device[] list.  This loops when a write spans more t
;899     //  device.  So the tests all use writeAddr since it is updated while p
;900     usingDevice = GetFlashDevice( (ulong) fromAddr, NULL );
@152:
	.debug	< @152 @153
	.debug	# 900
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$GetFlashDevice
	add	sp,6
	ld	(ix-4),hl
;901 
;902       //  If address not in a detected flash, return
;903     if (usingDevice == -1)  return;
	.debug	# 903
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jp	z,@148
;904 
;905     //  Get the sector boundary test mask and device xpc
;906     pDev = &device[ usingDevice ];
	.debug	# 906
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_device
	add	hl,de
	ld	(ix-2),hl
;907 
;908   // Make sure the range of addresses for the bytes we are about to copy FR
;909   // are all in one 256K Memory Bank.  NOTE that this DOES assume that all
;910   // the bytes on the stack are always within a single 4K aligned block, so
;911   // readBuff[] will not cross a boundary.  Things would get a LOT messier 
;912   // we had to deal with the possiblity that BOTH the source and either the
;913   // destination or the code that does the copy could cross a boundary!
;914 
;915     read = _256K - ((ulong) fromAddr & 0x3FFFFl);  // # bytes to end of ban
	.debug	# 915
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	de,0xffff
	ld	c,0x3
	call	__land##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4
	call	__lsubr##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;916     if (read > count)  read = count;  // no more than the total remaining
	.debug	# 916
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__lsub##
	jr	c,@155
	jr	z,@155
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;917     if (read > sizeof(readBuff))  read = sizeof(readBuff);  // or size of b
@155:
	.debug	# 917
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x100
	ld	c,e
	ld	b,e
	call	__lsub##
	jr	c,@156
	jr	z,@156
	ld	de,0x100
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;918 
;919     KLOCK();
@156:
	.debug	# 919
	call	_KLOCK
;920 
;921     mapFlashAddress((ulong)fromAddr, pDev->mbxcr, (char far *)_ReadFlash);
	.debug	# 921
	ld	hl,__ReadFlash
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-2)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$mapFlashAddress
	add	sp,10
;922     _ReadFlash(MBaddr, readBuff, (uint)read);
	.debug	# 922
	ld	hl,(ix-8)
	push	hl
	ld	hl,-262+@147
	add	hl,sp
	push	hl
	ld	de,(_MBaddr)
	ld	bc,(_MBaddr+2)
	push	bc
	push	de
	call	__ReadFlash
	add	sp,8
;923 
;924     KUNLOCK();
	.debug	# 924
	call	_KUNLOCK
;925 
;926     fmemcpy(buffer, readBuff, read);
	.debug	# 926
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-260+@147
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;927 
;928     count -= read;  fromAddr += read;  buffer += read;
	.debug	# 928
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
;929   }
@153:
	.debug	>
;930 }
	jp	@150
@151:
@148:
	.debug	} @148 930

@147	equ	264
	ld	sp,ix
	pop	ix
	lret
@149	equ	266
;931 
;932 
;933 //-------------------------------------------------------------------------
;934 
	.bseg
__FlashUnlock::
	.ds	4
	.debug	G __FlashUnlock 9 0
	.extern	_srMB0CR 3
	.extern	__serial19200TC 3
	.extern	$fmemcpy 54
	.extern	_KLOCK 56
	.extern	_KUNLOCK 56
_device:
	.ds	32
	.debug	F _device 57 0
_deviceCount:
	.ds	2
	.debug	F _deviceCount 6 0
__FlashError::
	.ds	4
	.debug	G __FlashError 9 0
	.extern	_supportedDevices 58
	.extern	_numDevices 6
_MBcr:
	.ds	1
	.debug	F _MBcr 3 0
_MBval:
	.ds	1
	.debug	F _MBval 3 0
_MBsVal:
	.ds	1
	.debug	F _MBsVal 3 0
_MBaddr:
	.ds	4
	.debug	F _MBaddr 9 0
	.debug	T	130002200003000100090000000300040021000600
	.debug	T	070008210004000300
.p = 0
.dw = 0
.w = 0
.b = 0
.hl = 0
	.debug	T	2E0004220004000500010021000000027000090000000364770007
	.debug	T	0000000277003B0000000262003C00000003686C00
	.debug	T	17000223000400030007000000240002000700040007000600
	.debug	T	070000240002000300
	.debug	T	130002250003000600210000002100040009000800
	.debug	T	070000260002002700
.type = 0
.sectorSize = 1
.deviceSize = 3
.start = 7
.end = 11
.mbxcr = 15
	.debug	T	52000327001000060001003D000000057479706500070001000B73
	.debug	T	6563746F7253697A6500090003000B64657669636553697A65
	.debug	T	00220007000673746172740022000B0004656E640003000F00
	.debug	T	066D6278637200
	.debug	T	070000280002002300
	.debug	T	0B000229000100090001000000
	.debug	T	1300022A0003000100090000002B00040003000800
	.debug	T	0700082B0004002C00
.mfcID = 0
.flashID = 1
.sectorSize = 2
.deviceSize = 4
.type = 8
	.debug	T	4B00032C0009000500010003000000066D66634944000300010008
	.debug	T	666C617368494400050002000B736563746F7253697A650009
	.debug	T	0004000B64657669636553697A65003D000800057479706500
	.debug	T	0B00022D000100070007000000
	.debug	T	0F00022E0002002B000900000003000400
	.debug	T	0B00022F000100060001000000
	.debug	T	0F00023000020006000900000031000400
	.debug	T	070000310002000500
	.debug	T	0F00023200020009000900000031000400
	.debug	T	130002330003000100090000002400040007000600
	.debug	T	130002340003000100210000002100040009000800
	.debug	T	0900013500000103000001
	.debug	T	130002360003003700370000003700040009000800
	.debug	T	070008370004000100
	.debug	T	0B000238000100010001000000
	.debug	T	0900013900200027000200
	.debug	T	0900013A0000002C000000
	.debug	T	0900013B00040003000400
	.debug	T	0900013C00040007000200
	.debug	T	2500093D0001000200010000000A466C427974655072670001000C
	.debug	T	466C536563746F7250726700
	.end
