	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\drivers\spi.c' 1 24 15 8 1 33
;1 //----- spi.c ----- 01/08/13 -----(05/05/05)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  NOTE:  While multiple serial interfaces can be configured for SPI use,
;5 //         only ONE can be IN use (transmitting or receiving) at a time!
;6 //-------------------------------------------------------------------------
;7 //  Update log (most recent first)
;8 //
;9 //
;10 //  2013-01-08 - Mark Davis (*)
;11 //               - Added .cseg directive to SPITxRx assembly func.  Prior t
;12 //                 this, it was being located in FARCODE, so the calls to i
;13 //                 (which are all local ones) would work only as long as th
;14 //                 call came from within the same 4K memory block.
;15 //
;16 //  2012-02-08 - Mark Davis
;17 //               - errno is now set to EBADF rather than ENXIO when a funct
;18 //                 is passed an invalid device pointer.
;19 //
;20 //  2011-12-09 - Mark Davis
;21 //               - Changed macro name, modified comments
;22 //
;23 //  2010-03-09 - Mark Davis
;24 //               - The "invalid SPI port" msg is now logged only if the
;25 //                 DebugBits are set (i.e. ShowDebugMsgs is true)
;26 //
;27 //  2007-03-26 - Mark Davis
;28 //               - added check for non-NULL devio pointer in most funcs
;29 //
;30 //  2006-05-16 - Mark Davis -
;31 //               -  ported from earlier ZWorld compiler compatible version
;32 //
;33 //-------------------------------------------------------------------------
;34 //  To-Do:
;35 //
;36 //    - Rabbit 3000 manual has two references to the ability to set the ord
;37 //      of the bits (just search on the word "order").  Supposedly this is
;38 //      controlled via the Serial Port Extended Registers for ports A-D (Sx
;39 //      but the description of that register has a description for each bit
;40 //      and none of them mentions anything about the bit order.
;41 //
;42 //
;43 //    - Revisions A-C of the Rabbit 2000 include the "transceive" feature
;44 //      that allows a transmit and receive (full-duplex) operation to be
;45 //      started at the same time without having to issue the receive comman
;46 //      within one-half bit time after issuing a transmit command.  This co
;47 //      be used to free up a handful of CPU cycles per char (a tiny bit, bu
;48 //      it also avoids disabling interrupts to guarantee the timing of
;49 //      issuing one then the other).
;50 //
;51 //
;52 //    - Add code for all the Rabbit 3000 features and what ports support
;53 //      them, then use the CPU ID and revision values to determine if/when
;54 //      they can be used.
;55 //
;56 //
;57 //    - It might speed things up if I added support for interrupt driven I/
;58 //
;59 //      Like in async mode, the ports each have a 1-byte buffer that can be
;60 //      read or written to while the hdw is busy reading a byte into the rc
;61 //      shift register or writing one from the xmit shift include.
;62 //
;63 //      The possible gain comes from the fact that even at the current max
;64 //      clock freq of 2MHz, the non-interrupt driven method ends up looping
;65 //      several times waiting for an operation to finish:  CPU cycles that
;66 //      could be used to do something useful.
;67 //
;68 //      NOTE:  I should check this for the read, write, and transceive (w/r
;69 //             modes to see just how long it is a different rates.  If it I
;70 //             long enough, then the added overhead of the ISR (very little
;71 //             and copying data to/from buffers would still leave enough fo
;72 //             the applic code to do processing during what was wasted CPU
;73 //             cycles just waiting for the current SPI operation to complet
;74 //
;75 //             It might also allow each port to be running simultaneously
;76 //             at different clock rates.  As long as the Rabbit is the one
;77 //             clock, then it can always read the current byte in the
;78 //             1-byte rcv buffer before it initiates the next rcv operation
;79 //             (which generates the clock pulses that cause the sending
;80 //             device to send the next byte).
;81 //
;82 //      Of course it gets a bit trickier when additional handshake signals
;83 //      are needed.  For example, the PhaseCtlr has to communicate with the
;84 //      DSP usign 4 byte "packets" and toggle an output bit to indicate the
;85 //      start and end of each packet of 4 bytes (and it has use the
;86 //      transceive mode where it is simultaneously sending and receiving a
;87 //      byte.  For this, I would have to have a way to supply an ISR-callab
;88 //      func (possibly even two different funcs) to manage the output and
;89 //      some whay to tell it WHEN to call the function(s).
;90 //
;91 //-------------------------------------------------------------------------
;92 
;93 #include <common.h>
;94 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;95 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;96 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;97 #include <sys/stat.h>
;98 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;99 #include <errno.h>
;100 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;101 #include <sys/serial.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;102 #include <sys/spi.h>
;103 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
	.debug	I
;104 #include <Rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
;105 #include <dcdefs.h>
;106 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;107 //#include <sys/farprintf.h>
;108 
;109 
;110 
;111 #define SPI_ICLK  0x0C             // clocked mode using internal clock
;112 #define SPI_RX    0x40 | SPI_ICLK  // start clocked byte receive
;113 #define SPI_TX    0x80 | SPI_ICLK  // start clocked byte transmit
;114 
;115 //char  SPIxor;
;116 //char  SPITXxor;
;117 
;118 //char  spiRXxor[4];    // flags for inverting the received byte
;119 //char  spiTXxor[4];    // flags for inverting the transmitted byte
;120 
;121 uchar  SPI_DR, SPI_CR, SPI_SR, SPI_ER;
;122 
;123 const uchar  serDataReg[4] = { SADR, SBDR, SCDR, SDDR };
	.defseg	CONST
	.seg	CONST
_serDataReg::
	.db	0xc0
	.db	0xd0
	.db	0xe0
	.db	0xf0
	.debug	G _serDataReg 32 0
;124 const uchar  serCtlReg[4]  = { SACR, SBCR, SCCR, SDCR };
_serCtlReg::
	.db	0xc4
	.db	0xd4
	.db	0xe4
	.db	0xf4
	.debug	G _serCtlReg 32 0
;125 const uchar  serStatReg[4] = { SASR, SBSR, SCSR, SDSR };
_serStatReg::
	.db	0xc3
	.db	0xd3
	.db	0xe3
	.db	0xf3
	.debug	G _serStatReg 32 0
;126 const uchar  serExtReg[4]  = { SAER, SBER, SCER, SDER };
_serExtReg::
	.db	0xc5
	.db	0xd5
	.db	0xe5
	.db	0xf5
	.debug	G _serExtReg 32 0
;127 const uchar *pShExtReg[4]  =
;128                        { &SAERShadow, &SBERShadow, &SCERShadow, &SDERShadow
_pShExtReg::
	.dw	word _srSAER
	.dw	word _srSBER
	.dw	word _srSCER
	.dw	word _srSDER
	.debug	G _pShExtReg 33 0
;129 
;130 const uchar  TATReg[4] = { TAT4R, TAT5R, TAT6R, TAT7R };
_TATReg::
	.db	0xa9
	.db	0xab
	.db	0xad
	.db	0xaf
	.debug	G _TATReg 32 0
;131 
;132 const uchar *pTATshReg[4] =
;133                     { &TAT4RShadow, &TAT5RShadow, &TAT6RShadow, &TAT7RShado
_pTATshReg::
	.dw	word _srTAT4R
	.dw	word _srTAT5R
	.dw	word _srTAT6R
	.dw	word _srTAT7R
	.debug	G _pTATshReg 33 0
;134 
;135 IODEV_FUNCS(spi)
_spiIOFuncs::
	.dw	word __spiRead_
	.dw	word __spiWrite_
	.dw	word __spiClose_
	.dw	word __spiLseek_
	.dw	word __spiFstat_
	.dw	word __spiioctl_
	.dw	word __spiDescr_
	.dw	word __spiGetQueues_
	.debug	G _spiIOFuncs 35 0
;136 IODEV_FUNCS(spi)
;137 bool  spiInUse;
;138 
;139 const uchar RevBitTable[] = {
;140   0x00, 0x80, 0x40, 0xC0, 0x20, 0xA0, 0x60, 0xE0, 0x10, 0x90, 0x50, 0xD0, 0
_RevBitTable::
	.db	0
	.db	0x80
	.db	0x40
	.db	0xc0
	.db	0x20
	.db	0xa0
	.db	0x60
	.db	0xe0
	.db	0x10
	.db	0x90
	.db	0x50
	.db	0xd0
	.db	0x30
	.db	0xb0
	.db	0x70
	.db	0xf0
;141   0x08, 0x88, 0x48, 0xC8, 0x28, 0xA8, 0x68, 0xE8, 0x18, 0x98, 0x58, 0xD8, 0
	.db	0x8
	.db	0x88
	.db	0x48
	.db	0xc8
	.db	0x28
	.db	0xa8
	.db	0x68
	.db	0xe8
	.db	0x18
	.db	0x98
	.db	0x58
	.db	0xd8
	.db	0x38
	.db	0xb8
	.db	0x78
	.db	0xf8
;142   0x04, 0x84, 0x44, 0xC4, 0x24, 0xA4, 0x64, 0xE4, 0x14, 0x94, 0x54, 0xD4, 0
	.db	0x4
	.db	0x84
	.db	0x44
	.db	0xc4
	.db	0x24
	.db	0xa4
	.db	0x64
	.db	0xe4
	.db	0x14
	.db	0x94
	.db	0x54
	.db	0xd4
	.db	0x34
	.db	0xb4
	.db	0x74
	.db	0xf4
;143   0x0C, 0x8C, 0x4C, 0xCC, 0x2C, 0xAC, 0x6C, 0xEC, 0x1C, 0x9C, 0x5C, 0xDC, 0
	.db	0xc
	.db	0x8c
	.db	0x4c
	.db	0xcc
	.db	0x2c
	.db	0xac
	.db	0x6c
	.db	0xec
	.db	0x1c
	.db	0x9c
	.db	0x5c
	.db	0xdc
	.db	0x3c
	.db	0xbc
	.db	0x7c
	.db	0xfc
;144   0x02, 0x82, 0x42, 0xC2, 0x22, 0xA2, 0x62, 0xE2, 0x12, 0x92, 0x52, 0xD2, 0
	.db	0x2
	.db	0x82
	.db	0x42
	.db	0xc2
	.db	0x22
	.db	0xa2
	.db	0x62
	.db	0xe2
	.db	0x12
	.db	0x92
	.db	0x52
	.db	0xd2
	.db	0x32
	.db	0xb2
	.db	0x72
	.db	0xf2
;145   0x0A, 0x8A, 0x4A, 0xCA, 0x2A, 0xAA, 0x6A, 0xEA, 0x1A, 0x9A, 0x5A, 0xDA, 0
	.db	0xa
	.db	0x8a
	.db	0x4a
	.db	0xca
	.db	0x2a
	.db	0xaa
	.db	0x6a
	.db	0xea
	.db	0x1a
	.db	0x9a
	.db	0x5a
	.db	0xda
	.db	0x3a
	.db	0xba
	.db	0x7a
	.db	0xfa
;146   0x06, 0x86, 0x46, 0xC6, 0x26, 0xA6, 0x66, 0xE6, 0x16, 0x96, 0x56, 0xD6, 0
	.db	0x6
	.db	0x86
	.db	0x46
	.db	0xc6
	.db	0x26
	.db	0xa6
	.db	0x66
	.db	0xe6
	.db	0x16
	.db	0x96
	.db	0x56
	.db	0xd6
	.db	0x36
	.db	0xb6
	.db	0x76
	.db	0xf6
;147   0x0E, 0x8E, 0x4E, 0xCE, 0x2E, 0xAE, 0x6E, 0xEE, 0x1E, 0x9E, 0x5E, 0xDE, 0
	.db	0xe
	.db	0x8e
	.db	0x4e
	.db	0xce
	.db	0x2e
	.db	0xae
	.db	0x6e
	.db	0xee
	.db	0x1e
	.db	0x9e
	.db	0x5e
	.db	0xde
	.db	0x3e
	.db	0xbe
	.db	0x7e
	.db	0xfe
;148   0x01, 0x81, 0x41, 0xC1, 0x21, 0xA1, 0x61, 0xE1, 0x11, 0x91, 0x51, 0xD1, 0
	.db	0x1
	.db	0x81
	.db	0x41
	.db	0xc1
	.db	0x21
	.db	0xa1
	.db	0x61
	.db	0xe1
	.db	0x11
	.db	0x91
	.db	0x51
	.db	0xd1
	.db	0x31
	.db	0xb1
	.db	0x71
	.db	0xf1
;149   0x09, 0x89, 0x49, 0xC9, 0x29, 0xA9, 0x69, 0xE9, 0x19, 0x99, 0x59, 0xD9, 0
	.db	0x9
	.db	0x89
	.db	0x49
	.db	0xc9
	.db	0x29
	.db	0xa9
	.db	0x69
	.db	0xe9
	.db	0x19
	.db	0x99
	.db	0x59
	.db	0xd9
	.db	0x39
	.db	0xb9
	.db	0x79
	.db	0xf9
;150   0x05, 0x85, 0x45, 0xC5, 0x25, 0xA5, 0x65, 0xE5, 0x15, 0x95, 0x55, 0xD5, 0
	.db	0x5
	.db	0x85
	.db	0x45
	.db	0xc5
	.db	0x25
	.db	0xa5
	.db	0x65
	.db	0xe5
	.db	0x15
	.db	0x95
	.db	0x55
	.db	0xd5
	.db	0x35
	.db	0xb5
	.db	0x75
	.db	0xf5
;151   0x0D, 0x8D, 0x4D, 0xCD, 0x2D, 0xAD, 0x6D, 0xED, 0x1D, 0x9D, 0x5D, 0xDD, 0
	.db	0xd
	.db	0x8d
	.db	0x4d
	.db	0xcd
	.db	0x2d
	.db	0xad
	.db	0x6d
	.db	0xed
	.db	0x1d
	.db	0x9d
	.db	0x5d
	.db	0xdd
	.db	0x3d
	.db	0xbd
	.db	0x7d
	.db	0xfd
;152   0x03, 0x83, 0x43, 0xC3, 0x23, 0xA3, 0x63, 0xE3, 0x13, 0x93, 0x53, 0xD3, 0
	.db	0x3
	.db	0x83
	.db	0x43
	.db	0xc3
	.db	0x23
	.db	0xa3
	.db	0x63
	.db	0xe3
	.db	0x13
	.db	0x93
	.db	0x53
	.db	0xd3
	.db	0x33
	.db	0xb3
	.db	0x73
	.db	0xf3
;153   0x0B, 0x8B, 0x4B, 0xCB, 0x2B, 0xAB, 0x6B, 0xEB, 0x1B, 0x9B, 0x5B, 0xDB, 0
	.db	0xb
	.db	0x8b
	.db	0x4b
	.db	0xcb
	.db	0x2b
	.db	0xab
	.db	0x6b
	.db	0xeb
	.db	0x1b
	.db	0x9b
	.db	0x5b
	.db	0xdb
	.db	0x3b
	.db	0xbb
	.db	0x7b
	.db	0xfb
;154   0x07, 0x87, 0x47, 0xC7, 0x27, 0xA7, 0x67, 0xE7, 0x17, 0x97, 0x57, 0xD7, 0
	.db	0x7
	.db	0x87
	.db	0x47
	.db	0xc7
	.db	0x27
	.db	0xa7
	.db	0x67
	.db	0xe7
	.db	0x17
	.db	0x97
	.db	0x57
	.db	0xd7
	.db	0x37
	.db	0xb7
	.db	0x77
	.db	0xf7
;155   0x0F, 0x8F, 0x4F, 0xCF, 0x2F, 0xAF, 0x6F, 0xEF, 0x1F, 0x9F, 0x5F, 0xDF, 0
	.db	0xf
	.db	0x8f
	.db	0x4f
	.db	0xcf
	.db	0x2f
	.db	0xaf
	.db	0x6f
	.db	0xef
	.db	0x1f
	.db	0x9f
	.db	0x5f
	.db	0xdf
	.db	0x3f
	.db	0xbf
	.db	0x7f
;156 };
	.db	0xff
	.debug	G _RevBitTable 36 0
;157 
;158 #define SPI  ((SerialInfo *)ioDev)
;159 
;160 //-------------------------------------------------------------------------
;161 //  Kernel function to initialize a serial port for SPI use
;162 //
;163 //  Intended to be called ONLY from serial.c's _serial_() func!!!!
;164 //
;165 //  Attributes:
;166 //     port:         serial port # (0-3)
;167 //     clkDiv        clock divider (>= 5) (see spi.h)
;168 //     clkMode:      SPI clode mode (0-3)  (see spi.h)
;169 //-------------------------------------------------------------------------
;170 bool  _spiInit_(void *ioDev, uchar clkDiv, uchar clkMode)
;171 {
	.defseg	FARCODE
	.seg	FARCODE
$_spiInit_::
	.debug	G $_spiInit_ 37 9
	.debug	{ $_spiInit_ 37 170 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A ioDev 5 38
	.debug	A clkDiv 7 3
	.debug	A clkMode 9 3
;172   uchar  port;
	.debug	L port -1 3
;173 
;174 //KLOCK()/KUNLOCK() done by _serial_() function (see serial.c)
;175 
;176   port = SPI->port;
	.debug	# 176
	ld	hl,(ix+5)
	inc	hl
	ld	a,(hl)
	ld	(ix-1),a
;177 
;178   SPI->clkDiv = clkDiv;  SPI->clkMode = clkMode;
	.debug	# 178
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	e,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0xc
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;179 
;180   SPI->serDataReg = serDataReg[port];  // serial Data Register
	.debug	# 180
	bool	hl
	ld	l,(ix-1)
	ld	de,_serDataReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xf
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;181   SPI->serCtlReg  = serCtlReg[port];   // serial Control Register
	.debug	# 181
	bool	hl
	ld	l,(ix-1)
	ld	de,_serCtlReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x10
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;182   SPI->serStatReg = serStatReg[port];  // serial Status Register
	.debug	# 182
	bool	hl
	ld	l,(ix-1)
	ld	de,_serStatReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x11
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;183   SPI->serExtReg  = serExtReg[port];   // serial Extended Register
	.debug	# 183
	bool	hl
	ld	l,(ix-1)
	ld	de,_serExtReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x12
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;184   SPI->pShExtReg  = pShExtReg[port];   // ptr to "shadow" for Extended Regi
	.debug	# 184
	bool	hl
	ld	l,(ix-1)
	add	hl,hl
	ld	de,_pShExtReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x13
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;185   SPI->TATReg     = TATReg[port];      // Timer A Time const reg (timer div
	.debug	# 185
	bool	hl
	ld	l,(ix-1)
	ld	de,_TATReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x15
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;186   SPI->pTATshReg  = pTATshReg[port];   // ptr to "shadow" for Time constant
	.debug	# 186
	bool	hl
	ld	l,(ix-1)
	add	hl,hl
	ld	de,_pTATshReg
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x16
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;187 
;188   if (port == 0)
	.debug	# 188
	ld	a,(ix-1)
	or	a,a
	jp	nz,@4
;189     BitWrPortI ( PCFR, &PCFRShadow, 1, 6 );   // enable serial A UART outpu
	.debug	# 189
	ld	de,0x55
	ld	hl,_srPCFR##
	set	6,(hl)
	ioi ldi
;190   else if (port == 1)
	jp	@5
@4:
	.debug	# 190
	ld	a,(ix-1)
	sub	a,1
	jp	nz,@6
;191     BitWrPortI ( PCFR, &PCFRShadow, 1, 4 );   // PC4 = serial B UART output
	.debug	# 191
	ld	de,0x55
	ld	hl,_srPCFR##
	set	4,(hl)
	ioi ldi
;192 #if (_CPU_ID_ >= R3000)
;193   else  if (port == 2)  {
	jp	@7
@6:
	.debug	# 193
	ld	a,(ix-1)
	sub	a,2
	jp	nz,@8
;194     BitWrPortI ( PCFR, &PCFRShadow, 1, 2 );   // PC2 = serial C UART output
@9:
	.debug	< @9 @10
	.debug	# 194
	ld	de,0x55
	ld	hl,_srPCFR##
	set	2,(hl)
	ioi ldi
;195     BitWrPortI ( PFDDR, &PFDDRShadow, 1, 1 ); // set PF1 as output
	.debug	# 195
	ld	de,0x3f
	ld	hl,_srPFDDR##
	set	1,(hl)
	ioi ldi
;196     BitWrPortI ( PFFR, &PFFRShadow, 1, 1 );   // set PF1 as serial clock
	.debug	# 196
	ld	de,0x3d
	ld	hl,_srPFFR##
	set	1,(hl)
	ioi ldi
;197   }
@10:
	.debug	>
;198   else  if (port == 3)  {
	jp	@11
@8:
	.debug	# 198
	ld	a,(ix-1)
	sub	a,3
	jp	nz,@12
;199     BitWrPortI ( PCFR, &PCFRShadow, 1, 0 );   // PC0 = serial D UART output
@13:
	.debug	< @13 @14
	.debug	# 199
	ld	de,0x55
	ld	hl,_srPCFR##
	set	0,(hl)
	ioi ldi
;200     BitWrPortI ( PFDDR, &PFDDRShadow, 1, 0 ); // set PF0 as output
	.debug	# 200
	ld	de,0x3f
	ld	hl,_srPFDDR##
	set	0,(hl)
	ioi ldi
;201     BitWrPortI ( PFFR, &PFFRShadow, 1, 0 );   // set PF0 as serial clock
	.debug	# 201
	ld	de,0x3d
	ld	hl,_srPFFR##
	set	0,(hl)
	ioi ldi
;202   }
@14:
	.debug	>
;203 #endif
;204 
;205 //--- Read from PC#; internal clock; Disable interrupts ---
;206   WrPortI ( serCtlReg[port], NULL, SPI_ICLK );
@12:
@11:
@7:
@5:
	.debug	# 206
	bool	hl
	ld	l,(ix-1)
	ld	de,_serCtlReg
	add	hl,de
	ld	a,0xc
	ld	l,(hl)
	ioi ld	(hl),a
;207 
;208   _spiConfig_(SPI, clkDiv, clkMode);
	.debug	# 208
	bool	hl
	ld	l,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;209 
;210   RdPortI ( serDataReg[port] );  // dummy read to empty the buffer
	.debug	# 210
	bool	hl
	ld	l,(ix-1)
	ld	de,_serDataReg
	add	hl,de
	ld	a,(hl)
	ld	l,a
	ioi ld	l,(hl)
;211 
;212 
;213   return true;
	.debug	# 213
	ld	a,0x1
;214 }
@2:
	.debug	} @2 214

@1	equ	1
	ld	sp,ix
	pop	ix
	lret
@3	equ	3
;215 
;216 
;217 //-------------------------------------------------------------------------
;218 //  Returns true if provided pointer is a valid, in-use SPI Serial device.
;219 //  Returns false if is not.
;220 //-------------------------------------------------------------------------
;221 bool  validSPI(void *ioDev)
;222 {
$validSPI::
	.debug	G $validSPI 39 9
	.debug	{ $validSPI 39 221 @17 @16
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
;223   if (ioDev)
	.debug	# 223
	ld	hl,(ix+5)
	bool	hl
	jr	z,@18
;224     if (SPI == serPort + (int)(SPI - serPort))
	.debug	# 224
	ld	hl,(ix+5)
	ld	de,_serPort
	or	a,a
	sbc	hl,de
	ld	de,0x18
	call	__idiv##
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@19
;225       if (SPI->inUse)  return true;
	.debug	# 225
	ld	h,d
	ld	l,e
	ld	a,(hl)
	or	a,a
	jr	z,@20
	ld	a,0x1
	jr	@16
;226 
;227   if (ShowDebugMsgs)
@20:
@19:
@18:
	.debug	# 227
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x800
	and	hl,de
	jr	z,@21
;228     fprintf(DiagLog, "***** invalid SPI port: [%04X] *****\n", (uint)ioDev)
	.debug	# 228
	ld	hl,(ix+5)
	push	hl
	ld	hl,@22
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fprintf
	add	sp,6
;229 
;230   return false;
@21:
	.debug	# 230
	xor	a,a
;231 }
@16:
	.debug	} @16 231

@15	equ	0
	pop	ix
	lret
@17	equ	2
;232 
;233 //-------------------------------------------------------------------------
;234 int _spiGetQueues_(void *ioDev, WaitQueues far *queues)
;235 {
	.align	4
$$_spiGetQueues_::
	ex	(sp),iy
$_spiGetQueues_::
	.debug	G $_spiGetQueues_ 40 9
	.debug	{ $_spiGetQueues_ 40 234 @25 @24
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
	.debug	A queues 7 41
;236   queues->readQueue = queues->writeQueue = &sleepQueue;
	.debug	# 236
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,_sleepQueue
	call	__farst2##
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farst2##
;237   return 0;
	.debug	# 237
	bool	hl
	ld	l,h
;238 }
@24:
	.debug	} @24 238

@23	equ	0
	pop	ix
	lret
@25	equ	2
;239 
;240 //-------------------------------------------------------------------------
;241 //  Attempt to read bytes from an SPI port
;242 //
;243 //  Should only be called from the fcntl.c/read() function!
;244 //
;245 //  RETURN VALUEs:
;246 //  - if bytes read: # of bytes read
;247 //  - if no bytes read:
;248 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;249 //    - if no more possible (EOF):  0
;250 //-------------------------------------------------------------------------
;251 #pragma offset_labels on
;252 
;253 int _spiRead_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;254 {
	.align	4
$$_spiRead_::
	ex	(sp),iy
$_spiRead_::
	.debug	G $_spiRead_ 43 9
	.debug	{ $_spiRead_ 43 253 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
.ioDev = 5
	.debug	A ioDev 5 38
.buf = 7
	.debug	A buf 7 34
.numBytes = 9
	.debug	A numBytes 9 6
.dontBlock = 11
	.debug	A dontBlock 11 3
;255   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 255
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@29
@30:
	.debug	< @30 @31
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@120
@31:
	.debug	>
;256 
;257 //--- SPI I/O not reentrant yet, so use a global lock for all SPI I/O ---
;258 
;259   _EnterCritical_();
@29:
	.debug	# 259
	ipset	2
;260   if (spiInUse)  {
	.debug	# 260
	ld	a,(_spiInUse)
	or	a,a
	jr	z,@32
;261     _ExitCritical_();
@33:
	.debug	< @33 @34
	.debug	# 261
	ipres
;262     fprintf(DiagLog, "***** nested _spiRead_() *****");  //tdebug
	.debug	# 262
	ld	hl,@22+38
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fprintf
	add	sp,4
;263     ERRNO = EAGAIN;  return -1;
	.debug	# 263
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@120:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@27
;264   }
@34:
	.debug	>
;265   spiInUse = true;
@32:
	.debug	# 265
	ld	a,0x1
	ld	(_spiInUse),a
;266   _ExitCritical_();
	.debug	# 266
	ipres
;267 
;268 
;269 //--- global vars:  is this the MAIN reason the SPI lib is not reentrant? -
;270 //finish: If I passed these to other funcs, could all this be reentrant?
;271 //  SPIxor = SPI->spiRXxor;
;272   SPI_DR = SPI->serDataReg;
	.debug	# 272
	ld	hl,(ix+5)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_DR),a
;273   SPI_CR = SPI->serCtlReg;
	.debug	# 273
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_CR),a
;274   SPI_SR = SPI->serStatReg;
	.debug	# 274
	ld	hl,(ix+5)
	ld	e,0x11
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_SR),a
;275   SPI_ER = SPI->serExtReg;
	.debug	# 275
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_ER),a
;276 
;277 #asm
	.debug	# 280
push  ix            

	.debug	# 283
ld    a, 0xFF       

	.debug	# 284
ld    d, a

	.debug	# 285
ld    e, a

	.debug	# 288
ld    ix, (sp+2+.buf)       

	.debug	# 289
ld    iy, (sp+2+.numBytes)  

	.debug	# 295
ld    bc, (_SPI_DR)

	.debug	# 296
ioi ld    a, (bc)       

	.debug	# 299
SPI_ReadA:

	.debug	# 300
ld    a, 0x40 | 0x0C     

	.debug	# 301
ld    bc, (_SPI_CR)

	.debug	# 302
ioi ld    (bc), a       

	.debug	# 305
ld    bc,(_SPI_SR)

	.debug	# 306
Rx0:

	.debug	# 307
ioi ld    a, (bc)       

	.debug	# 308
and   0x80          

	.debug	# 309
jr    z, Rx0        

	.debug	# 312
ld    bc, (_SPI_DR)

	.debug	# 313
ioi ld    a, (bc)       

	.debug	# 314
ld    c, a

	.debug	# 325
xor   a                

	.debug	# 326
ld    b, a             

	.debug	# 327
ld    HL, _RevBitTable 

	.debug	# 328
add   HL, bc           

	.debug	# 329
ld    L, (HL)          

	.debug	# 332
ld    (ix), l       

	.debug	# 333
inc   ix            

	.debug	# 334
dec   iy            

	.debug	# 335
and   iy, de        

	.debug	# 336
jr    nz, SPI_ReadA 

	.debug	# 338
pop ix

;341 
	.seg	FARCODE
;342   spiInUse = false;
	.debug	# 342
	xor	a,a
	ld	(_spiInUse),a
;343 
;344   return numBytes;
	.debug	# 344
	ld	hl,(ix+9)
;345 }
@27:
	.debug	} @27 345

@26	equ	0
	pop	ix
	lret
@28	equ	2
;346 
;347 
;348 //-------------------------------------------------------------------------
;349 //  Attempt to write bytes to an SPI port
;350 //
;351 //  Should only be called from the fcntl.c/write() function!
;352 //
;353 //  RETURN VALUEs:
;354 //  - if bytes written: # of bytes written
;355 //  - if no bytes written:
;356 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;357 //    - if no more possible (EOF):  0
;358 //-------------------------------------------------------------------------
;359 int _spiWrite_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;360 {
	.align	4
$$_spiWrite_::
	ex	(sp),iy
$_spiWrite_::
	.debug	G $_spiWrite_ 43 9
	.debug	{ $_spiWrite_ 43 359 @37 @36
	push	ix
	ld	ix,0
	add	ix,sp
.ioDev = 5
	.debug	A ioDev 5 38
.buf = 7
	.debug	A buf 7 34
.numBytes = 9
	.debug	A numBytes 9 6
.dontBlock = 11
	.debug	A dontBlock 11 3
;361   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 361
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@38
@39:
	.debug	< @39 @40
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@36
@40:
	.debug	>
;362 
;363   _EnterCritical_();
@38:
	.debug	# 363
	ipset	2
;364   if (spiInUse)  { _ExitCritical_();  ERRNO = EAGAIN;  return 0; }
	.debug	# 364
	ld	a,(_spiInUse)
	or	a,a
	jr	z,@41
@42:
	.debug	< @42 @43
	ipres
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	jp	@36
@43:
	.debug	>
;365   spiInUse = true;
@41:
	.debug	# 365
	ld	a,0x1
	ld	(_spiInUse),a
;366   _ExitCritical_();
	.debug	# 366
	ipres
;367 
;368 //  SPITXxor = SPI->spiTXxor;
;369   SPI_DR = SPI->serDataReg;
	.debug	# 369
	ld	hl,(ix+5)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_DR),a
;370   SPI_CR = SPI->serCtlReg;
	.debug	# 370
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_CR),a
;371   SPI_SR = SPI->serStatReg;
	.debug	# 371
	ld	hl,(ix+5)
	ld	e,0x11
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_SR),a
;372   SPI_ER = SPI->serExtReg;
	.debug	# 372
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_ER),a
;373 
;374 #asm
	.debug	# 377
push  ix            

	.debug	# 379
ld    a, 0xFF       

	.debug	# 380
ld    d, a

	.debug	# 381
ld    e, a          

	.debug	# 383
ld    ix, (sp+2+.buf)      

	.debug	# 384
ld    iy, (sp+2+.numBytes)     

	.debug	# 391
SPI_WriteA:

	.debug	# 393
ld    l, (ix)     

	.debug	# 399
ld    c, L            

	.debug	# 400
xor   a               

	.debug	# 401
ld    b, a            

	.debug	# 402
ld    HL, _RevBitTable  

	.debug	# 403
add   HL, bc          

	.debug	# 404
ld    a, (HL)         

	.debug	# 406
ld    bc,(_SPI_DR)

	.debug	# 407
ioi ld    (bc), a         

	.debug	# 408
ld    a, 0x80 | 0x0C       

	.debug	# 409
ld    bc,(_SPI_CR)

	.debug	# 410
ioi ld    (bc), a         

	.debug	# 413
ld    bc,(_SPI_CR)    

	.debug	# 414
Tx0:

	.debug	# 415
ioi ld    a, (bc)         

	.debug	# 416
and   0x08            

	.debug	# 417
jr    nz, Tx0         

	.debug	# 419
inc   ix              

	.debug	# 420
dec   iy              

	.debug	# 421
and   iy, de          

	.debug	# 422
jr    nz, SPI_WriteA  

	.debug	# 425
ld    bc,(_SPI_SR)     

	.debug	# 426
SPI_WaitXmit:

	.debug	# 427
ioi ld    a, (bc)          

	.debug	# 428
and   0x04             

	.debug	# 429
jr    nz, SPI_WaitXmit 

	.debug	# 431
pop ix

;433 
	.seg	FARCODE
;434   spiInUse = false;
	.debug	# 434
	xor	a,a
	ld	(_spiInUse),a
;435 
;436   return numBytes;
	.debug	# 436
	ld	hl,(ix+9)
;437 }
@36:
	.debug	} @36 437

@35	equ	0
	pop	ix
	lret
@37	equ	2
;438 
;439 #pragma offset_labels off
;440 
;441 
;442 //-------------------------------------------------------------------------
;443 //  Transmit and Receive a byte via a serial port set up in synchronous mod
;444 //
;445 //  Input parameter: the byte value to transmit: in L
;446 //  Return value: the received byte in L
;447 //
;448 //  Uses: A, HL, BC
;449 //-------------------------------------------------------------------------
	.debug	# 451
.cseg

	.debug	# 456
SPITxRx::

	.debug	# 458
ld     c, l             

	.debug	# 459
xor    a                

	.debug	# 460
ld     b, a             

	.debug	# 461
ld     hl, _RevBitTable 

	.debug	# 462
add    hl, bc           

	.debug	# 463
ld     a, (hl)          

	.debug	# 465
ld     hl,(_SPI_DR)

	.debug	# 466
ioi ld     (hl), a          

	.debug	# 474
ld     hl,(_SPI_CR)     

	.debug	# 475
ld     c, 0x40 | 0x0C        

	.debug	# 476
ld     a, 0x80 | 0x0C        

	.debug	# 477
ipset  3                

	.debug	# 478
ioi ld     (hl), a          

	.debug	# 479
nop

	.debug	# 480
ioi ld     (hl), c          

	.debug	# 481
nop

	.debug	# 482
ipres

	.debug	# 486
ld     hl, (_SPI_SR)    

	.debug	# 487
SPITxRx0:

	.debug	# 488
ioi ld     a, (hl)          

	.debug	# 489
and    0x80             

	.debug	# 490
jr     z, SPITxRx0      

	.debug	# 492
ld     hl, (_SPI_DR)    

	.debug	# 493
ioi ld     a, (hl)

	.debug	# 496
ld    c, a              

	.debug	# 497
xor   a                 

	.debug	# 498
ld    b, a              

	.debug	# 499
ld    hl, _RevBitTable  

	.debug	# 500
add   hl, bc            

	.debug	# 501
ld    l, (hl)           

	.debug	# 504
ret  

;507 
	.seg	FARCODE
;508 
;509 
;510 //-------------------------------------------------------------------------
;511 //  Send AND Receive the specified # of bytes to/from an SPI port
;512 //
;513 //  Should normally only be called from the fcntl.c/read() function!
;514 //
;515 //  RETURN VALUEs:
;516 //  - if bytes read: # of bytes read
;517 //  - if no bytes read:
;518 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;519 //    - if no more possible (EOF):  0
;520 //-------------------------------------------------------------------------
;521 #pragma offset_labels on
;522 
;523 int _spiWrRd_(void *ioDev, char *xmitBuf, char *rcvBuf, int numBytes)
;524 {
$_spiWrRd_::
	.debug	G $_spiWrRd_ 44 9
	.debug	{ $_spiWrRd_ 44 523 @46 @45
	push	ix
	ld	ix,0
	add	ix,sp
.ioDev = 5
	.debug	A ioDev 5 38
.xmitBuf = 7
	.debug	A xmitBuf 7 34
.rcvBuf = 9
	.debug	A rcvBuf 9 34
.numBytes = 11
	.debug	A numBytes 11 6
;525   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 525
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@47
@48:
	.debug	< @48 @49
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@119
@49:
	.debug	>
;526 
;527   _EnterCritical_();
@47:
	.debug	# 527
	ipset	2
;528   if (spiInUse)  { _ExitCritical_();  ERRNO = EAGAIN;  return -1; }
	.debug	# 528
	ld	a,(_spiInUse)
	or	a,a
	jr	z,@50
@51:
	.debug	< @51 @52
	ipres
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@119:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@45
@52:
	.debug	>
;529   spiInUse = true;
@50:
	.debug	# 529
	ld	a,0x1
	ld	(_spiInUse),a
;530   _ExitCritical_();
	.debug	# 530
	ipres
;531 
;532 //  SPIxor = SPI->spiRXxor;
;533   SPI_DR = SPI->serDataReg;
	.debug	# 533
	ld	hl,(ix+5)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_DR),a
;534   SPI_CR = SPI->serCtlReg;
	.debug	# 534
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_CR),a
;535   SPI_SR = SPI->serStatReg;
	.debug	# 535
	ld	hl,(ix+5)
	ld	e,0x11
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_SR),a
;536   SPI_ER = SPI->serExtReg;
	.debug	# 536
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_ER),a
;537 
;538 #asm
	.debug	# 541
push   ix                    

	.debug	# 542
ld     ix, (sp+2+.xmitBuf)   

	.debug	# 543
ld     iy, (sp+2+.rcvBuf)    

	.debug	# 544
ld     hl, (sp+2+.numBytes)  

	.debug	# 545
ld     e, L             

	.debug	# 548
SPIWrRdA:

	.debug	# 549
ld     L, (ix)          

	.debug	# 550
call   SPITxRx          

	.debug	# 552
ld     (iy), L          

	.debug	# 553
inc    ix               

	.debug	# 554
inc    iy               

	.debug	# 555
dec    e                

	.debug	# 556
jr     nz, SPIWrRdA     

	.debug	# 558
pop    ix

;561 
	.seg	FARCODE
;562   spiInUse = false;
	.debug	# 562
	xor	a,a
	ld	(_spiInUse),a
;563 
;564   return numBytes;
	.debug	# 564
	ld	hl,(ix+11)
;565 }
@45:
	.debug	} @45 565

@44	equ	0
	pop	ix
	lret
@46	equ	2
;566 
;567 #pragma offset_labels off
;568 
;569 
;570 //-------------------------------------------------------------------------
;571 //  Get the global SPI lock and set values used by the _xxxFast_() function
;572 //
;573 //  NOTE:  Nested locking/unlocking is NOT supported, and _spiUnlock_()
;574 //         MUST be called to release the global SPI lock.
;575 //
;576 //  Returns 0 if the lock is obtained and the _xxxFast_() functions can now
;577 //  be used by the caller, < 0 if an error.
;578 //-------------------------------------------------------------------------
;579 int _spiLock_(void *ioDev)
;580 {
$_spiLock_::
	.debug	G $_spiLock_ 45 9
	.debug	{ $_spiLock_ 45 579 @55 @54
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
;581   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 581
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@56
@57:
	.debug	< @57 @58
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@118
@58:
	.debug	>
;582 
;583   _EnterCritical_();
@56:
	.debug	# 583
	ipset	2
;584   if (spiInUse)  { _ExitCritical_();  ERRNO = EBUSY;  return -1; }
	.debug	# 584
	ld	a,(_spiInUse)
	or	a,a
	jr	z,@59
@60:
	.debug	< @60 @61
	ipres
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x10
@118:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@54
@61:
	.debug	>
;585   spiInUse = true;
@59:
	.debug	# 585
	ld	a,0x1
	ld	(_spiInUse),a
;586   _ExitCritical_();
	.debug	# 586
	ipres
;587 
;588 //  SPIxor = SPI->spiRXxor;
;589   SPI_DR = SPI->serDataReg;
	.debug	# 589
	ld	hl,(ix+5)
	ld	de,0xf
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_DR),a
;590   SPI_CR = SPI->serCtlReg;
	.debug	# 590
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_CR),a
;591   SPI_SR = SPI->serStatReg;
	.debug	# 591
	ld	hl,(ix+5)
	ld	e,0x11
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_SR),a
;592   SPI_ER = SPI->serExtReg;
	.debug	# 592
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	ld	a,(hl)
	ld	(_SPI_ER),a
;593 
;594   return 0;
	.debug	# 594
	bool	hl
	ld	l,h
;595 }
@54:
	.debug	} @54 595

@53	equ	0
	pop	ix
	lret
@55	equ	2
;596 
;597 //-------------------------------------------------------------------------
;598 //  Release the global SPI lock
;599 //-------------------------------------------------------------------------
;600 int _spiUnlock_(void *ioDev)
;601 {
$_spiUnlock_::
	.debug	G $_spiUnlock_ 45 9
	.debug	{ $_spiUnlock_ 45 600 @64 @63
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
;602 //  if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
;603 
;604   _EnterCritical_();
	.debug	# 604
	ipset	2
;605   if (!spiInUse)  { _ExitCritical_();  ERRNO = EACCES;  return -1; }
	.debug	# 605
	ld	a,(_spiInUse)
	or	a,a
	jr	nz,@65
@66:
	.debug	< @66 @67
	ipres
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xd
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@63
@67:
	.debug	>
;606   spiInUse = false;
@65:
	.debug	# 606
	xor	a,a
	ld	(_spiInUse),a
;607   _ExitCritical_();
	.debug	# 607
	ipres
;608 
;609   return 0;
	.debug	# 609
	bool	hl
	ld	l,h
;610 }
@63:
	.debug	} @63 610

@62	equ	0
	pop	ix
	lret
@64	equ	2
;611 
;612 
;613 //-------------------------------------------------------------------------
;614 //  Send AND Receive the specified # of bytes to/from an SPI port.
;615 //
;616 //  NOTE:  _spiLock_() must be called before calling this function to get t
;617 //         global SPI lock and initialize values used to read/write from/to
;618 //         the port, and _spiUnlock_() must be called later to release the
;619 //         global SPI lock.
;620 //
;621 //  RETURN VALUE:  # bytes written/read
;622 //-------------------------------------------------------------------------
;623 // NOTES on speed:
;624 //
;625 //   Possible use of a far * for the rcvBuf:
;626 //
;627 //     All reads and writes from/to a far address operate on 2 bytes at onc
;628 //     If the address is at the end of a 64K boundary (0x?FFFF), the R/W
;629 //     operation will wrap back around to the beginning of the 64K boundary
;630 //     And even if it doesn't cross a 64K boundary, crossing a 4K boundary
;631 //     could result in a write to a write-protected 4K block of memory.
;632 //
;633 //     But my tests with having the caller use a larger near buffer for
;634 //     calls to this func within the loop (and then copying the whole
;635 //     near buffer to a far, a MUCH faster process then all the additional
;636 //     code that goes in to using and upating a far pointer to a long after
;637 //     each call to this func for the next 4 bytes).
;638 //
;639 //
;640 //   What uses most the time?
;641 //
;642 //      The majority of the time spent is in the actual xmit/rcv process in
;643 //      SPITxRx.  If I eliminate the bit reversing, there is only a tiny
;644 //      improvement.  If I simply don't wait for the rcv done bit in the
;645 //      status register, that cuts the time way down (but of course it
;646 //      probably means I get garbage).
;647 //
;648 //
;649 //   Bottom line:
;650 //
;651 //      The main limitation seems to be the actual xmit/rcv step in SPITxRx
;652 //      All the other things I tried, expecting to make a sizeable impact o
;653 //      the overall speed each had only minor effects.  All added together
;654 //      they might add up to a small boost, but the max clock speed for
;655 //      synchronous transfers seems to be the major limitation at this time
;656 //-------------------------------------------------------------------------
;657 #pragma offset_labels on
;658 
;659 int _spiWrRdFast_(char *xmitBuf, char *rcvBuf, int numBytes)
;660 {
$_spiWrRdFast_::
	.debug	G $_spiWrRdFast_ 46 9
	.debug	{ $_spiWrRdFast_ 46 659 @70 @69
	push	ix
	ld	ix,0
	add	ix,sp
.xmitBuf = 5
	.debug	A xmitBuf 5 34
.rcvBuf = 7
	.debug	A rcvBuf 7 34
.numBytes = 9
	.debug	A numBytes 9 6
;661 ;
;662 
;663 #asm
	.debug	# 666
push   ix                    

	.debug	# 668
ld     ix, (sp+2+.xmitBuf)   

	.debug	# 669
ld     iy, (sp+2+.rcvBuf)    

	.debug	# 670
ld     hl, (sp+2+.numBytes)  

	.debug	# 671
ld     e, L             

	.debug	# 674
SPIWrRdAF:

	.debug	# 675
ld     L, (ix)          

	.debug	# 676
call   SPITxRx          

	.debug	# 677
ld     (iy), L          

	.debug	# 679
inc    ix               

	.debug	# 680
inc    iy               

	.debug	# 682
dec    e                

	.debug	# 683
jr     nz, SPIWrRdAF    

	.debug	# 685
pop    ix

	.seg	FARCODE
;688 ;
;689 
;690   return numBytes;
	.debug	# 690
	ld	hl,(ix+9)
;691 }
@69:
	.debug	} @69 691

@68	equ	0
	pop	ix
	lret
@70	equ	2
;692 
;693 #pragma offset_labels off
;694 
;695 
;696 
;697 //-------------------------------------------------------------------------
;698 //  change the configuration of an SPI serial connection
;699 //-------------------------------------------------------------------------
;700 int  _spiConfig_(void *ioDev, uchar clkDiv, uchar clkMode)
;701 {
$_spiConfig_::
	.debug	G $_spiConfig_ 47 9
	.debug	{ $_spiConfig_ 47 700 @73 @72
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
	.debug	A clkDiv 7 3
	.debug	A clkMode 9 3
;702   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 702
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@74
@75:
	.debug	< @75 @76
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@72
@76:
	.debug	>
;703 
;704   if (clkDiv < 5)  clkDiv = 5;  // min divisor for max stable rate
@74:
	.debug	# 704
	ld	a,(ix+7)
	sub	a,5
	jr	nc,@77
	ld	(ix+7),0x5
;705 
;706 //--- set clock divider for timer associated with clocked serial port outpu
;707   WrPortI( SPI->TATReg, SPI->pTATshReg, clkDiv);
@77:
	.debug	# 707
	ld	hl,(ix+5)
	ld	de,0x16
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jp	z,@78
	ld	a,(ix+7)
	ld	hl,(ix+5)
	ld	de,0x15
	add	hl,de
	ld	l,(hl)
	ld	h,d
	ex	de,hl
	ld	hl,(ix+5)
	ld	bc,hl
	ld	hl,0x16
	add	hl,bc
	ld	hl,(hl)
	ld	(hl),a
	ioi	ldi
	jr	@79
@78:
	ld	hl,(ix+5)
	ld	de,0x15
	add	hl,de
	ld	a,(hl)
	ld	hl,(ix+7)
	ld	h,a
	ld	a,l
	ld	l,h
	ioi ld	(hl),a
@79:
;708   SPI->clkDiv = clkDiv;
	.debug	# 708
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	e,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;709 
;710 //--- for Rabbit 3000 processors, set clock mode (inactive level and phase)
;711 #if (_CPU_ID_ >= R3000)
;712   WrPortI( SPI->serExtReg, SPI->pShExtReg, ((clkMode+1) & 3) << 4 );
	.debug	# 712
	ld	hl,(ix+5)
	ld	e,0x13
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jp	z,@80
	ld	a,(ix+9)
	inc	a
	and	a,3
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	a,l
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	l,(hl)
	ld	h,d
	ex	de,hl
	ld	hl,(ix+5)
	ld	bc,hl
	ld	hl,0x13
	add	hl,bc
	ld	hl,(hl)
	ld	(hl),a
	ioi	ldi
	jr	@81
@80:
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	a,(ix+9)
	inc	a
	and	a,3
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	a,(de)
	ld	h,a
	ld	a,l
	ld	l,h
	ioi ld	(hl),a
@81:
;713   SPI->clkMode = clkMode;
	.debug	# 713
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;714 #endif
;715 
;716   return 0;
	.debug	# 716
	bool	hl
	ld	l,h
;717 }
@72:
	.debug	} @72 717

@71	equ	0
	pop	ix
	lret
@73	equ	2
;718 
;719 //-------------------------------------------------------------------------
;720 //  release an SPI port for use by another process
;721 //-------------------------------------------------------------------------
;722 int _spiClose_(void *ioDev)
;723 {
	.align	4
$$_spiClose_::
	ex	(sp),iy
$_spiClose_::
	.debug	G $_spiClose_ 45 9
	.debug	{ $_spiClose_ 45 722 @84 @83
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
;724   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 724
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@85
@86:
	.debug	< @86 @87
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@83
@87:
	.debug	>
;725 
;726   KLOCK();  SPI->inUse = false;  KUNLOCK();
@85:
	.debug	# 726
	call	_KLOCK
	ld	hl,(ix+5)
	xor	a,a
	ld	(hl),a
	call	_KUNLOCK
;727 
;728   return 0;
	.debug	# 728
	bool	hl
	ld	l,h
;729 }
@83:
	.debug	} @83 729

@82	equ	0
	pop	ix
	lret
@84	equ	2
;730 
;731 
;732 //-------------------------------------------------------------------------
;733 //  Kernel-space function to reposition a file offset
;734 //
;735 //  WARNING!  To be called ONLY by KERNELFUNC functions (or functions calle
;736 //            KERNELFUNC functions) !!!!
;737 //-------------------------------------------------------------------------
;738 off_t  _spiLseek_(void *ioDev, off_t offset, int whence)
;739 {
	.align	4
$$_spiLseek_::
	ex	(sp),iy
$_spiLseek_::
	.debug	G $_spiLseek_ 48 9
	.debug	{ $_spiLseek_ 48 738 @90 @89
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
	.debug	A offset 7 9
	.debug	A whence 11 6
;740   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 740
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@91
@92:
	.debug	< @92 @93
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@89
@93:
	.debug	>
;741 
;742   ERRNO = ESPIPE;  return (off_t)-1;
@91:
	.debug	# 742
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x1d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
;743 }
@89:
	.debug	} @89 743

@88	equ	0
	pop	ix
	lret
@90	equ	2
;744 
;745 
;746 //-------------------------------------------------------------------------
;747 //  Get information about ...
;748 //-------------------------------------------------------------------------
;749 int  _spiFstat_(void *ioDev, struct stat *fsbuf)
;750 {
	.align	4
$$_spiFstat_::
	ex	(sp),iy
$_spiFstat_::
	.debug	G $_spiFstat_ 49 9
	.debug	{ $_spiFstat_ 49 749 @96 @95
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 38
	.debug	A fsbuf 7 50
;751   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 751
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@97
@98:
	.debug	< @98 @99
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@95
@99:
	.debug	>
;752 
;753   fsbuf->st_mode = S_IFCHR | 00777;
@97:
	.debug	# 753
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	de,0x21ff
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;754 
;755   return 0;
	.debug	# 755
	bool	hl
	ld	l,h
;756 }
@95:
	.debug	} @95 756

@94	equ	0
	pop	ix
	lret
@96	equ	2
;757 
;758 
;759 //-------------------------------------------------------------------------
;760 //  Kernel-space function to handle ioctl calls for SPI serial ports
;761 //-------------------------------------------------------------------------
;762 int _spiioctl_(void *ioDev, int request, void *arg)
;763 {
	.align	4
$$_spiioctl_::
	ex	(sp),iy
$_spiioctl_::
	.debug	G $_spiioctl_ 52 9
	.debug	{ $_spiioctl_ 52 762 @102 @101
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ioDev 5 38
	.debug	A request 7 6
	.debug	A arg 9 38
;764   int  stat;
	.debug	L stat -2 6
;765 
;766 
;767   if (!validSPI(ioDev))  { ERRNO = EBADF;  return -1; }
	.debug	# 767
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	nz,@103
@104:
	.debug	< @104 @105
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@101
@105:
	.debug	>
;768 
;769   stat = -1;  KLOCK();
@103:
	.debug	# 769
	ld	hl,0xffff
	ld	(ix-2),hl
	call	_KLOCK
;770 
;771   switch (request)  {
	.debug	# 771
	ld	hl,(ix+7)
	jr	@106
;772     case IOC_SET_CLK_RATE:
@108:
	.debug	< @108 @109
;773       _spiConfig_(ioDev, *((uchar *)arg), SPI->clkMode);  stat = 0;  break;
	.debug	# 773
@110:
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+9)
	ld	a,(hl)
	bool	hl
	ld	l,a
	jr	@117
;774 
;775 #if (_CPU_ID_ >= R3000)
;776     case IOC_SET_CLK_MODE:
;777       _spiConfig_(ioDev, SPI->clkDiv, *((uchar *)arg));  stat = 0;  break;
	.debug	# 777
@111:
	ld	hl,(ix+9)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	hl,(hl)
@117:
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;778 #endif
;779 
;780     default:
	jr	@107
;781       ERRNO = EINVAL;
	.debug	# 781
@112:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
;782   }
@109:
	.debug	>
;783 
;784   KUNLOCK();  return stat;
	jr	@107
@106:
	ex	de,hl
	ld	hl,0xfffffbb4
	add	hl,de
	bool	hl
	jr	z,@110
	ld	hl,0xfffffbb3
	add	hl,de
	bool	hl
	jr	z,@111
	jr	@112
@107:
	.debug	# 784
	call	_KUNLOCK
	ld	hl,(ix-2)
;785 }
@101:
	.debug	} @101 785

@100	equ	2
	ld	sp,ix
	pop	ix
	lret
@102	equ	4
;786 
;787 
;788 //-------------------------------------------------------------------------
;789 //  Kernel-space function to return a description of the serial port
;790 //-------------------------------------------------------------------------
;791 char *_spiDescr_(void *ioDev, char *buf, int bufSize)
;792 {
	.align	4
$$_spiDescr_::
	ex	(sp),iy
$_spiDescr_::
	.debug	G $_spiDescr_ 53 9
	.debug	{ $_spiDescr_ 53 791 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ioDev 5 38
	.debug	A buf 7 34
	.debug	A bufSize 9 6
;793   char  *ptr;
	.debug	L ptr -2 34
;794 
;795   sprintf(buf, "spi 0x%04lX ", (ulong)ioDev);
	.debug	# 795
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,@22+69
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$sprintf
	add	sp,8
;796 
;797   ptr = buf + strlen(buf);  strcpy(ptr, "bad bad");
	.debug	# 797
	ld	hl,(ix+7)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
	ld	hl,@22+82
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcpy
	add	sp,4
;798 
;799 //finish: limit output to bufSize
;800 
;801   if (validSPI(ioDev))
	.debug	# 801
	ld	hl,(ix+5)
	push	hl
	lcall	$validSPI
	pop	hl
	or	a,a
	jr	z,@116
;802     sprintf(ptr, "ser[%d] /dev/spi%d mode:%d rate:%ld",
;803                  (uint)(SPI - serPort), SPI->port,
;804                  SPI->clkMode, (ulong) 10000000UL / SPI->clkDiv);
	.debug	# 804
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x9680
	ld	bc,0x98
	call	__uldivr##
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	ld	de,_serPort
	or	a,a
	sbc	hl,de
	ld	de,0x18
	call	__idiv##
	push	hl
	ld	hl,@22+90
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$sprintf
	add	sp,14
;805 
;806   return buf;
@116:
	.debug	# 806
	ld	hl,(ix+7)
;807 }
@114:
	.debug	} @114 807

@113	equ	2
	ld	sp,ix
	pop	ix
	lret
@115	equ	4
;808 
;809 
;810 //-------------------------------------------------------------------------
	.extern	_strcpy 54
	.extern	_strlen 55
	.extern	_current 56
	.extern	$fprintf 58
	.extern	$sprintf 59
	.extern	_srTAT4R 3
	.extern	_srTAT5R 3
	.extern	_srTAT6R 3
	.extern	_srTAT7R 3
	.extern	_srSAER 3
	.extern	_srSBER 3
	.extern	_srSCER 3
	.extern	_srSDER 3
	.extern	_KLOCK 60
	.extern	_KUNLOCK 60
	.extern	_diagLog 61
	.extern	_sleepQueue 62
	.extern	_serPort 63
	.bseg
_spiInUse::
	.ds	1
	.debug	G _spiInUse 3 0
	.cseg
__spiRead_:
	pop	iy
	lcall	$$_spiRead_
__spiWrite_:
	pop	iy
	lcall	$$_spiWrite_
	.bseg
_SPI_DR::
	.ds	1
	.debug	G _SPI_DR 3 0
_SPI_CR::
	.ds	1
	.debug	G _SPI_CR 3 0
_SPI_SR::
	.ds	1
	.debug	G _SPI_SR 3 0
_SPI_ER::
	.ds	1
	.debug	G _SPI_ER 3 0
	.cseg
__spiClose_:
	pop	iy
	lcall	$$_spiClose_
__spiLseek_:
	pop	iy
	lcall	$$_spiLseek_
__spiFstat_:
	pop	iy
	lcall	$$_spiFstat_
__spiioctl_:
	pop	iy
	lcall	$$_spiioctl_
__spiDescr_:
	pop	iy
	lcall	$$_spiDescr_
__spiGetQueues_:
	pop	iy
	lcall	$$_spiGetQueues_
	.debug	T	0900012000040003000400
	.debug	T	0900012100080022000400
	.debug	T	070000220002000300
	.debug	T	640003230010000800010041000000057265616400410002000677
	.debug	T	72697465004200040006636C6F73650043000600066C736565
	.debug	T	6B00440008000666737461740045000A0006696F63746C0046
	.debug	T	000C000664657363720047000E000A67657451756575657300
	.debug	T	0900012400000103000001
	.debug	T	130002250003000300260000000300020003000400
	.debug	T	070000260002000100
	.debug	T	0B000227000100030026000000
	.debug	T	0F00022800020006002600000029000200
	.debug	T	070008290004002A00
	.debug	T	2800032A00040002000100480000000A7265616451756575650048
	.debug	T	0002000B7772697465517565756500
	.debug	T	1700022B000400060026000000220002000600040003000600
	.debug	T	1700022C000400060026000000220002002200040006000600
	.debug	T	0B00022D000100060026000000
	.debug	T	1300022E0003000600220000002200020006000400
	.debug	T	1300022F0003000600260000000300020003000400
	.debug	T	130002300003000900260000000900020006000600
	.debug	T	0F00023100020006002600000032000200
	.debug	T	070000320002003300
	.debug	T	BB000333002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	130002340003000600260000000600020026000400
	.debug	T	130002350003002200260000002200020006000400
	.debug	T	0F00023600020022002200000022000200
	.debug	T	0B000237000100060022000000
	.debug	T	070000380002003900
	.debug	T	7702033900E8002D000C7461736B5F737472756374004900000006
	.debug	T	737461636B00490002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872004A000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465003800150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	000561726763004C001A000561726776004D001C0005617267
	.debug	T	73003E009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773004E00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74005000D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	1300023A000300060051000000220002000D000000
	.debug	T	1300023B000300060022000000220002000D000000
	.debug	T	0B00023C000100010001000000
	.debug	T	5400033D000C000600010052000000065F5F6F7574004200020005
	.debug	T	5F5F696E0054000400085F5F77726974650054000600075F5F
	.debug	T	726561640006000800085F5F756E6765740026000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	2800033E0004000100125F5F776169745F71756575655F68656164
	.debug	T	0056000000096C6973744865616400
	.debug	T	0900013F00600040000400
	.debug	T	E7000340001800110001000300000006696E557365000300010005
	.debug	T	706F7274002600020005734465760003000400056D6F646500
	.debug	T	0300050008666C6F7743746C000300060007636C6F73656400
	.debug	T	0300070008706B744D6F646500090008000962617564526174
	.debug	T	650003000C0008636C6B4D6F64650006000D0007636C6B4469
	.debug	T	760003000F000B7365724461746152656700030010000A7365
	.debug	T	7243746C52656700030011000B736572537461745265670003
	.debug	T	0012000A73657245787452656700220013000A705368457874
	.debug	T	52656700030015000754415452656700220016000A70544154
	.debug	T	736852656700
	.debug	T	070000410002002B00
	.debug	T	070000420002002D00
	.debug	T	070000430002003000
	.debug	T	070000440002003100
	.debug	T	070000450002003400
	.debug	T	070000460002003500
	.debug	T	070000470002002800
	.debug	T	070000480002003E00
	.debug	T	070000490002000700
	.debug	T	0700004A0002004B00
	.debug	T	0700084B0004000100
	.debug	T	0700004C0002002200
	.debug	T	0900014D00800003008000
	.debug	T	0700004E0002004F00
	.debug	T	0F00024F0002000100060000004C000200
	.debug	T	070008500004000300
	.debug	T	070000510002003D00
	.debug	T	070000520002005300
	.debug	T	0F00025300020006000300000026000200
	.debug	T	070000540002005500
	.debug	T	130002550003000800500000000800040026000800
	.debug	T	2600035600040002000A6C6973745F686561640057000000056E65
	.debug	T	78740057000200057072657600
	.debug	T	070000570002005600
	.seg	CONST
@22:
	.db	"***** invalid SPI port: [%04X] *****",10,0,"***** nested _spiRead_() *****",0,"spi 0x%04lX ",0,"bad"
	.db	" bad",0,"ser[%d] /dev/spi%d mode:%d rate:%ld",0
	.end
