	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\lib\stricmp.c' 6 1 14 30 4 32
;1 //----- stricmp.c ----- 04/30/12 -----(04/27/12)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  A version of stricmp() that works (the Softools one doesn't produce
;5 //  consistent results when comparing a non-alpha char to the same alpha
;6 //  character in upper and lower case (e.g. 'A' < '_' but 'a' > '_').
;7 //
;8 //  The result is that you get different results based on the case of the
;9 //  characters in your string (which rather defeats the whole purpose of a
;10 //  case insensitve compariosn!)
;11 //-------------------------------------------------------------------------
;12 //  Version log (most recent first):
;13 //
;14 //
;15 //  2012-04-30 - Mark Davis
;16 //               - First version of replacement for Softools stricmp().
;17 //
;18 //-------------------------------------------------------------------------
;19 
;20 //-------------------------------------------------------------------------
;21 //int near stricmp (const unsigned char *str1, const unsigned char *str2)
;22 
;23 #asm
	.debug	# 24
.cseg

	.debug	# 26
_stricmp::

	.debug	# 30
push  ix

	.debug	# 31
ld    ix,0x0000

	.debug	# 32
add   ix,sp

	.debug	# 34
ld    hl,(ix+4)

	.debug	# 35
ex    de,hl      

	.debug	# 36
ld    hl,(ix+6)  

	.debug	# 39
@1:   ld    a,(de)     

	.debug	# 41
cp    (hl)       

	.debug	# 42
jr    z,@4

	.debug	# 45
cp    0x41       

	.debug	# 46
jr    c,@2

	.debug	# 47
cp    0x5B       

	.debug	# 48
jr    nc,@2

	.debug	# 50
or    0x20       

	.debug	# 53
@2:   ld    b,a        

	.debug	# 54
ld    a,(hl)     

	.debug	# 56
cp    0x41       

	.debug	# 57
jr    c,@3

	.debug	# 58
cp    0x5B       

	.debug	# 59
jr    nc,@3

	.debug	# 61
or    0x20       

	.debug	# 64
@3:   cp    b          

	.debug	# 65
jr    c,@5       

	.debug	# 66
jr    nz,@6      

	.debug	# 69
@4:   or    a          

	.debug	# 70
inc   de         

	.debug	# 71
inc   hl         

	.debug	# 72
jr    nz,@1

	.debug	# 75
ld    h,a

	.debug	# 76
ld    l,a

	.debug	# 77
jr    @8

	.debug	# 80
@5:   ld    hl,1

	.debug	# 81
jr    @8

	.debug	# 84
@6:   ld    hl,0xffff

	.debug	# 88
@8:   pop   ix

	.debug	# 89
ret

;93 
	.cseg
;94 
;95 
;96 
;97 /*
;98 
;99 #define AND  &&
;100 
;101 //-------------------------------------------------------------------------
;102 //  My own C version alternative
;103 //-------------------------------------------------------------------------
;104 int near stricmp(const unsigned char *str1, const unsigned char *str2)
;105 {
;106   unsigned char  c1, c2;
;107 
;108   while (*str1 AND *str2)  {
;109     if ((c1 = *str1) > 0x40)  if (c1 < 0x5B)  c1 |= 0x20;
;110     if ((c2 = *str2) > 0x40)  if (c2 < 0x5B)  c2 |= 0x20;
;111     if (c1 > c2)  return  1;
;112     if (c1 < c2)  return -1;
;113     ++str1;  ++str2;
;114   }
;115 
;116   if (*str1 > *str2)  return  1;
;117   if (*str1 < *str2)  return -1;
;118 
;119   return 0;
;120 }
;121 
;122 
;123 //-------------------------------------------------------------------------
;124 //  Another pretty efficient looking C code version from the web
;125 //-------------------------------------------------------------------------
;126 int near stricmp(const unsigned char *s1, const unsigned char *s2)
;127 {
;128   unsigned char  c1, c2;
;129   int  ret = 0;
;130 
;131   if (s1 AND s2)  for (;;)  {
;132     c1 = *s1++;  c2 = *s2++;
;133 
;134     if (c1 AND c2)  {   // both chars not == 0
;135       if (!(c1 ^ c2))  continue;  // my own (optional) addition
;136       c1 = tolower(c1);  c2 = tolower(c2);
;137       if (c1 < c2)  { ret = -1;  break; }
;138       if (c1 > c2)  { ret =  1;  break; }
;139     }
;140     else  {  // one or both chars == 0
;141       if (c1)  ret = 1;  else  if (c2)  ret = -1;
;142       break;
;143     }
;144   }
;145 
;146   return ret;
;147 }
;148 
;149 */
;150 
;151 //-------------------------------------------------------------------------
;152 
	.end
