@rem --- upfirm.bat --- 06/18/09 ---(01/04/07)---
@echo off

rem --------------------------------------------------------------------------
rem  -- Script to write a compressed copy of a boot image file for DEBROS ---
rem --------------------------------------------------------------------------
rem
rem  2009-06-18 - Mark Davis
rem               - added copying of the map file associated with the bin files
rem
rem  2009-04-13 - Mark Davis
rem               - The directory used when the "release" option is specified
rem                 was changed to \\icarus\ctlrData\release and the code
rem                 that makes a 2nd copy in another directory has been
rem                 commented out.
rem
rem  2008-09-03 - Mark Davis - when the "release" option is specified, the
rem                            uncompressed copy in the setup_tools dir is
rem                            now updated as well
rem
rem  2008-03-29 - Mark Davis - default (test) target now the test subdir of
rem                            of the release dir on main SRFS server
rem
rem  2007-11-15 - Mark Davis - added support for release and test servers
rem
rem  2007-01-04 - Mark Davis - original version
rem
rem ----------------------------------------------------------------------------

setlocal ENABLEDELAYEDEXPANSION

rem  set setupPath=\\exp\files\control\ctldev\Source\Embedded\Rabbit_ST\setup_tools\appl

  echo.
  if /I "%1" equ "release" (
    set srfsPath=\\icarus\ctlrData\release
  ) else (
    set srfsPath=\\icarus\ctlrData\test
  )

rem --- Get name of .bin file in current directory ---
  for %%F in (*.bin) do set binFile=%%~nxF

rem --- write a compressed copy to another location ---
  for %%F in (%binFile%) do set fileDesc=%%~nxF   %%~tF   %%~zF   
  echo Copy/Compress:
  echo   %fileDesc%
  lz77 %binFile% %srfsPath%\%binFile% /CRC

rem --- show the new destination file ---
  for %%F in (%srfsPath%\%binFile%) do set fileDesc=%%~nxF   %%~tF   %%~zF
  echo   !fileDesc!

rem --- if release version, update the copy in the setup/tools dir as well ---
rem  if /I "%1" equ "release" (
rem    copy %binFile% %setupPath%
rem    set fileDesc="???"
rem    for %%F in (%setupPath%\%binFile%) do set fileDesc=%%~nxF   %%~tF   %%~zF
rem    echo   !fileDesc!
rem  )

rem --- Get name of .map file in current directory ---
  for %%F in (*.map) do set mapFile=%%~nxF

rem --- copy map file to another location ---
  for %%F in (%mapFile%) do set fileDesc=%%~nxF   %%~tF   %%~zF   
rem  echo   %fileDesc%
  copy %mapFile% %srfsPath%\%mapFile%

rem --- show the new destination file ---
  for %%F in (%srfsPath%\%mapFile%) do set fileDesc=%%~nxF   %%~tF   %%~zF
  echo   !fileDesc!


  exit /b
