//----- arp.c ----- 03/20/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  show the arp (Address Resolution Protocol) table
//-----------------------------------------------------------------------------
void _task _arp(int argc, char **argv)
{
  uint  i;
  long  ttl;
  ATEntry  *ae;
  char  ipStr[16], macStr[18];


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  %s\r\n", argv[0]);  Exit(-1); }


  printf("\r\nNet to Media Table: IPv4 \r\n");
  printf("Device  IP Address       Flags   Phys Addr             TTL\r\n");
  printf("------  ---------------  ------  -----------------  ------\r\n");
  //      xxxxxx  ###.###.###.###  0x####  ##:##:##:##:##:##  ######

//finish: need standard interface for this data...

  for (i=0; i<ARP_TABLE_SIZE; ++i)  {
    if ((ae = _arp_data + i)->ath == 0)  continue;

    inet_htop(AF_INET, &ae->ip, ipStr, 4);

    if (ae->flags & ATE_RESOLVED)
      mactoa(macStr, (char *)&ae->hwa);
    else
      strcpy(macStr, "??:??:??:??:??:??");

    if (!ae->timestamp)
      ttl = 0;
    else if (ae->flags & ATE_PERMANENT)
      ttl = -1;
    else
      ttl = msInterval(MS_TIMER, ae->timestamp) / 1000;

    printf("eth%d    %-15.15s  0x%04x  %s  %6ld\r\n",
         ae->iface, ipStr, ae->flags, macStr, ttl);
  }

/*
typedef struct _ATEntry {
  ATHandle      ath;         // Handle for this entry (0 if not used)
  longword      ip;          // IP address of destination host
  eth_address   hwa;         // Corresponding hardware (ethernet or MAC) address
  byte          iface;       // Interface number to use
  byte          router_used; // router table entry if flags & ATE_ROUTER_HOP
  longword      timestamp;   // Expiration time as ms value compared to MS_TIMER.
  struct _ATEntry * nextto;  // Next entry to timeout.
  word          flags;       // Flags (see below)
  union {
    struct {
      // Per-host information
      word      path_mtu;    // Path MTU (if known, else 0)
      longword  rtt_avg;     // Average round-trip time (if known, else 0)
      longword  rtt_dev;     // RTT average deviation
    } perhost;
    struct {
      byte      userflag;    // Has the user explicitly joined this group?
      int       slot;        // Value to which this group address hashes
    } multicast;
  } u;
} ATEntry;

values for flags:
  #define ATE_PERMANENT     0x0001  // Do not expire this entry
  #define ATE_RESOLVING     0x0002  // In process of being resolved
  #define ATE_ROUTER_ENT    0x0004  // This is a router entry
  #define ATE_FLUSH         0x0008  // Upper layer requested flush
  #define ATE_VOLATILE      0x0010  // Short timeout for this entry
  #define ATE_GRACE         0x0020  // This entry in grace period i.e. known but being re-resolved
  #define ATE_NOARP         0x0040  // Timeout with no ARP response
  #define ATE_ROUTER_HOP    0x0080  // IP address not on this subnet - use "router_used"
  #define ATE_PATHMTU_DISC  0x0100  // Path MTU discovery in progress
  #define ATE_RESOLVED      0x0200  // HWA is valid (resolved)
  #define ATE_MULTICAST     0x0400  // Represents a multicast address
  #define ATE_RETRY_MASK    0x7000  // Retry count when resolving
  #define ATE_RETRY_SHIFT   12      //   ...corresponding bit shift
  #define ATE_REDIRECTED    0x8000  // This entry was ICMP redirected
*/


  Exit(0);
}

//-----------------------------------------------------------------------------
