//----- fifoServ.c ----- 04/02/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <applic.h>

#include <sys/farprintf.h>


//int mkfifo(const char *path, int mode);

//-----------------------------------------------------------------------------
//  simple server to test FIFO functionality
//-----------------------------------------------------------------------------
void _task _fifoServ(int argc, char **argv)
{
  fd_t  fd;
  char  ch;
  int  stat;


  if (showHelp(2, argc, argv))  {
    printf("\nusage: fifoServer fifoName\r\n");  Exit(-1); }

  stat = mkfifo(argv[1], 0);
  if (stat AND (errno != EEXIST))  {
    perror("Unable to create FIFO file");  Exit(-1); }

  fd = open(argv[1], O_RDONLY, 0);

  if (fd < 0)  { perror("Unable to open FIFO file");  Exit(-1); }

  printf("fd: %d\r\n", fd);

  while (read(fd, &ch, 1) > 0)  {
    if (ch == 0x03)  break;
    write(1, &ch, 1);
  }

  close(fd);  unlink(argv[1]);

  Exit(0);
}


//-----------------------------------------------------------------------------
