//----- grep.c ----- 01/14/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-01-14 - Mark Davis
//               - changed it so it ignores case
//
//  2009-12-09 - Mark Davis
//               - Original version of basic grep (just handles literal
//                 strings - no regular expressions yet)
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  show lines read from stdin or a file that contain the specified string
//-----------------------------------------------------------------------------
void _task _grep(int argc, char **argv)
{
//  uchar  ch;
  int  stat, bytesInBuf, lineLen;
  fd_t  datafd;  //, keybdfd;
  char  *endPtr;
  char  buf[256];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: grep string [file]\r\n");  Exit(-1);  }

//--- set the data and keybd fd's ---
  if (argc > 2)  {  // if reading from file: use stdin for keybd cmds
    if ((datafd = open(argv[2], O_RDONLY, 0)) < 0)  {
      perror(argv[1]);  Exit(-1); }
//    keybdfd = 0;
  }
  else  {  // reading from stdin: use tty for keybd cmds
    if (isatty(0))  { printf("\nusage: more name\r\n");  Exit(-1); }
    datafd = 0;  //stdin
//    if ((keybdfd = open("/dev/tty", O_RDONLY, 0)) < 0)  {
//      perror("/dev/tty");  Exit(-1);  }
  }

  bytesInBuf = 0;

  for (;;)  {
    stat = read(datafd, buf+bytesInBuf, sizeof(buf)-1-bytesInBuf);
    if (stat > 0)  bytesInBuf += stat;

    if (bytesInBuf < 1)  break;

    buf[bytesInBuf] = 0;  endPtr = strchr(buf, '\n');
    if (!endPtr)  { endPtr = buf + bytesInBuf;  ++bytesInBuf; }
    *endPtr = 0;  lineLen = endPtr - buf;

    if (stristr(buf, argv[1]))  {
      write(1, buf, lineLen);  write(1, "\r\n", 2); }
    bytesInBuf -= (lineLen + 1);

    if (bytesInBuf)  memcpy(buf, endPtr+1, bytesInBuf);
  }

  Exit(0);
}


//-----------------------------------------------------------------------------
