//----- od.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  show contents of a file in hex (dispite name, octal not supported...)
//-----------------------------------------------------------------------------
void _task _od(int argc, char **argv)
{
  uchar  i;
  long  offset, count, remain;
  int  stat;
  fd_t  fd;
  char  msg[160], buf[16];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: %s file [offset [count]]\r\n\n", argv[0]);  Exit(-1); }

  if (argc > 2)  offset = ATOL(argv[2]);  else  offset = 0;
  if (argc > 3)  count = ATOL(argv[3]);  else  count = 128;

  if ((fd = open(argv[1], O_RDONLY, 0)) < 0)  { perror(argv[1]);  Exit(-1); }

  if (offset)
    if (lseek(fd, offset, SEEK_SET) != offset)  { perror("lseek");  Exit(-1); }

  for (remain=count; remain>0; remain-=16)  {
    i = (uchar)((remain >= 16) ? 16 : remain);
    memset(buf, 0xbb, sizeof(buf));
    stat = read(fd, buf, (int)i);
    if (stat < 0)  { perror("read");  Exit(-1); }
    if (stat == 0)  break;
    fmtHexLine(msg, offset, buf, (char)stat);
    strcat(msg, "\r\n");  printf(msg);
    offset += 16;  if (remain < 16)  break;
    CheckETX();
  }

//tdebug
/*
  printf("\r\nand again....\r\n");  fflush(stdout);  sleepMS(3000);

  if (argc > 2)  offset = ATOL(argv[2]);  else  offset = 0;
  if (lseek(fd, offset, SEEK_SET) != offset)  { perror("lseek");  Exit(-1); }

  for (remain=count; remain>0; remain-=16)  {
    i = (uchar)((remain >= 16) ? 16 : remain);
    memset(buf, 0xbb, sizeof(buf));
    stat = read(fd, buf, (int)i);
    if (stat < 0)  { perror("read");  Exit(-1); }
    if (stat == 0)  break;
    fmtHexLine(msg, offset, buf, (char)stat);
    strcat(msg, "\r\n");  printf(msg);
    offset += 16;  if (remain < 16)  break;
    CheckETX();
  }
*/

  close(fd);  Exit(0);
}

//-----------------------------------------------------------------------------
