//----- reload_save.c ----- 10/06/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-10-06 - Mark Davis
//               - Updated call to saveParams() to include new parameter that
//                 tells it to save to flash (which was the only option before)
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <sys/modbus.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  Save the current set of persistent values for a specified group of values
//  or for all groups
//-----------------------------------------------------------------------------
void _task paramFileCmd(int argc, char **argv)
{
  uint  i;
  bool  saveCmd;
  char  buf[256];

//finish:  should send msg to applic task to do loading of param files
//         rather than doing it directly

  if (showHelp(2, argc, argv))  {
    printf("\nusage:  %s <baseName>|all\r\n", argv[0]);
    printf("\r\n  valid baseName's:\r\n");
    for (i=0; i<NumParamFiles; ++i)
      printf("    %s\r\n", paramFiles[i]->baseName);
    Exit(-1);
  }

  saveCmd = StriEq(argv[0], "save");

//finish - shouldn't really reload directly - should be sending a msg to ---
//         the applic task to do it and wait for a response ---

  if (StriEq(argv[1], "all"))  {
    if (saveCmd)
      saveAllParams(buf, sizeof(buf));
    else
      loadAllParams(buf, sizeof(buf));
    Exit(0);
  }

  for (i=0; i<NumParamFiles; ++i)
    if (stricmp(paramFiles[i]->baseName, argv[1]) == 0)  break;

  if (i == NumParamFiles)  { printf("invalid baseName\r\n");  Exit(-1); }

  if (saveCmd)
    saveParams(buf, sizeof(buf), paramFiles[i], ForceFlush);
  else
    loadParams(buf, sizeof(buf), paramFiles[i], false);

  Exit(0);
}


//-----------------------------------------------------------------------------
