//----- testOut.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <sys/srfs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <sys/modbus.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  continually stream a bunch of text to stdout to test throughput and
//  multitasking response
//-----------------------------------------------------------------------------
void _task _testOut(int argc, char **argv)
{
  uchar  i;
  ulong  line, sleepTime;
  bool  useWrite, checkForKill;
  char  buf[80];


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  testOut [write] [nokill] [#sleepMS]\r\n");  Exit(-1); }

//--- parse cmd line options (if any) ---
  sleepTime = 1;  useWrite = false;  checkForKill = true;
  for (i=1; i<(uchar)argc; ++i)  {
    useWrite = (stricmp(argv[i], "write") == 0);
    if (stricmp(argv[i], "nokill") == 0)  checkForKill = false;
    if (isdigit(*argv[i]))  sleepTime = ATOUL(argv[i]);
  }


  for (line=0; ; ++line)  {
    if (useWrite)  {
      if ((uchar)line & 0x1f)
        sprintf(buf, "%10lu", line);
      else
        strcpy(buf, "==========");
      write(1, buf, 10);
      write(1,
"-23456789.123456789.123456789.123456789.123456789.123456789.123456789.\r\n",
            72);
    }
    else  {
      if ((uchar)line & 0x1f)  printf("%10lu", line);  else  printf("==========");
      printf(
"-23456789.123456789.123456789.123456789.123456789.123456789.123456789.\r\n");
    }

    if (checkForKill)  CheckETX();

    if (sleepTime)  sleepMS(sleepTime);
  }

}

//-----------------------------------------------------------------------------
