	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
;1 //----- ModularPSAppl.c ----- 11/16/12 -----(03/05/06)----
;2 
;3 // EE Documents bundle # 211 (Older FET design) and # 160 (newer SCR design
;4 
;5 
;6 // command for temp "soft scope" traces needed for debugging control loop:
;7 
;8 //    scope 5 ampApply ampRead ttlbulkcur bjtbias vctrl vout polcmd outmode
;9 
;10 //-------------------------------------------------------------------------
;11 //  Application specific code for the main application task that is run at
;12 //  a fixed interval and application specific commands run on demand.
;13 //
;14 //  Application code for the Modular Power Supply
;15 //-------------------------------------------------------------------------
;16 //  TO-DO:
;17 //
;18 //  - With the VLIM settings having much more affect on the gain of the
;19 //    regulation circuit, can they be used to manage the oscillation better
;20 //    Could they, in fact, be used to ALMOST disable the feedback circuit
;21 //    while changing the polarity of the connection to the load?
;22 //
;23 //
;24 //  - More intelligent detection of calibration problem and load state:
;25 //
;26 //    While it is true that all controllers require properly calibrated
;27 //    readings in order to provide accurate information to the control syst
;28 //    and to function as designed, the ModularPS controller is more depende
;29 //    on the relationships between such readings than most.  An offset or g
;30 //    error on any one of the readings can easily cause to control logic to
;31 //    conclude the system is in a different state than the one it is really
;32 //    in which can result in a system that does not work smoothly, does not
;33 //    work at ALL, or damages the equipment.
;34 //
;35 //    For that reason, the ability to monitor the behavior of the system an
;36 //    log or otherwise react to any anomolies it discovers can be a big hel
;37 //    in avoiding or at least diagnosing problems.  The more checks and
;38 //    balances we can incorporate, the less likely we are to have unexpecte
;39 //    problems, and easier it will be to diagnose them when the do occur.
;40 //
;41 //    One possibility that is not (yet) implemented would be to determine t
;42 //    approximate slope of certain readings and use that to double-check th
;43 //    conclusions that are currently based almost entirely on the most rece
;44 //    values (i.e. historical data plays little or no part in most of the
;45 //    logic).  Such an approach could help detect and warn of offset errors
;46 //    in the calibrations or possibly a hardware failure.
;47 //
;48 //    Of course, this requires an efficient means of tracking the slope.
;49 //    It would require a method that could update the value with each new
;50 //    reading while using very little CPU time.
;51 //
;52 //   ----------------------------------------------------------------------
;53 //
;54 //    Assuming the bulk/bridge current, load current, and load voltage read
;55 //    are correct, then the resistance of the dump resistor should equal:
;56 //
;57 //         load volts / (bridge cur - load cur)
;58 //
;59 //    And the resistance of the load at any given moment is:
;60 //
;61 //         load volts / load cur
;62 //
;63 //
;64 //    In theory, it should be possible to use the 1st to compensate for
;65 //    calibration errors as follows:
;66 //
;67 //       - Whenever the load and bridge currents are stable, compute the
;68 //         apparent dump resistor value and save it (log a message if I
;69 //         have a previous value that is significantly different).
;70 //
;71 //       - If the computed value is fairly consistent for multiple current
;72 //         values, then the calibration must be fairly good.
;73 //
;74 //         If the values are different, then compute what gain and offset
;75 //         values (probably just for the bridge current) would result in
;76 //         a consistent value.  At the very least, these values would be
;77 //         logged.  If the method proves to be reliable, then we could
;78 //         use them them instead of the existing calibrations to determine
;79 //         what mode the load and supply are in (regulating, dumping, sinki
;80 //         ramping, etc).
;81 //
;82 //    Questions:
;83 //
;84 //         Is there anything about the behavior of the load itself that
;85 //         would affect this logic?  Even if the load resistance was
;86 //         different for different (steady state) current values, that
;87 //         would not change the above relationship for a given current.
;88 //         Of course, this assumes the resistance of the dump resistor
;89 //         doesn't change much as the current varies over the normally
;90 //         used range of values.
;91 //
;92 //         While the ttlBulkCur/bridge current is the reading that seems
;93 //         to be most frequently in error, it is possible that the
;94 //         load current and voltage readings are wrong as well.  Can
;95 //         changing the (assumed) gain and offset for just the bridge
;96 //         current make up for one or both being wrong?
;97 //
;98 //   ---------------------------------------------------------------------
;99 //
;100 //  When logging a message about an observed error in some reading, it
;101 //  would help if the message listed the possible causes (i.e. which
;102 //  calibration values for which signals could result in the observed
;103 //  error).
;104 //
;105 //  - Log the following as calibration errors:
;106 //
;107 //     - The load current is changing and the polarity (sign) of the slope
;108 //       is different than that of the load voltage.
;109 //
;110 //     - The bridge/bulk current is not close to the load current and the
;111 //       polarity (sign) of the difference is not the same as the
;112 //       polarity of the load voltage.
;113 //
;114 //
;115 //     - The following is true:
;116 //         - The supply is on
;117 //         - The mode has been stable in REG+ or REG-
;118 //         - The load current is stable
;119 //         - The readback error or total bulk current error is > a
;120 //           specified percentage of the maximum reading
;121 //
;122 // ------------------------------------------------------------------------
;123 //  NOTES:
;124 //
;125 //     (Most of this refers to behavior for inductive loads)
;126 //
;127 //     Regardless of what the readings tell us and how we may have been
;128 //     able to correct for calibration errors, regulation won't work unless
;129 //     the feedback regulation circuit is properly adjusted.  So we
;130 //     might as well assume it IS (since nothing will work if it isn't),
;131 //     and also make the additional assumption that follows from that:
;132 //
;133 //        The controller is changing the polarity of the bridge to
;134 //        match the polarity of the output of regulation circuit, and
;135 //        the polarity is oscillating, then the bridge current is
;136 //        close to 0.
;137 //
;138 //     Of course, this assumes that the readback of the regulation
;139 //     circuit's output is correct (or at least its offset is).
;140 //
;141 //     But this is also another opportunity for double-checking the accurac
;142 //     of the calibrations:
;143 //
;144 //       - The absolute value of the regulation circuit's output voltage
;145 //         should be roughly the same just before and just after it switche
;146 //         polarity.  If it isn't, then the offset is probably wrong.
;147 //
;148 //       - When the polarity of the setpoint for the load current is change
;149 //         and the previous and new values are not close to 0, then we can
;150 //         record the absolute value of the load current at the time the
;151 //         polarity of the regulation circuit changes.  Then, at a later ti
;152 //         when the polarity of the setpoint changes back (again, to a valu
;153 //         not close to 0), then the absolute value of the load current at
;154 //         the time the polarity of the regulation circuit changes back
;155 //         should be about the same (i.e. the absolute value of the load
;156 //         current should always be about the same when the polarity of the
;157 //         regulation circuit first changes).
;158 //           NOTE:  Do not confuse changing the polarity of the connection
;159 //         to the load with the polarity of the regulation circuit.  The
;160 //         changing of the polarity of the connection to the load is done b
;161 //         the software and always occurs after the change in the regulatio
;162 //         polarity (LONG after, in terms of how fast the regulation circui
;163 //         reacts to changes - this lag is what makes avoiding oscillation
;164 //         during a change in polarity nearly impossible).
;165 //
;166 // ------------------------------------------------------------------------
;167 //
;168 //    - Add code to track the observed vout (load voltage) and determine wh
;169 //      it appears to be "railed".  This differs from the current method fo
;170 //      setting "voltageLimited", which assumes that the hardware and softw
;171 //      gains are all correct.
;172 //
;173 //    - The per-supply error checking includes comparing the load current t
;174 //      the supply currents, but doesn't yet take in to account the differe
;175 //      that occurs when ramping or sinking because some of the current is
;176 //      going through the dump resistor.
;177 //
;178 //    - The magnitude of the load voltage when "railed" should be the same
;179 //      for both postive and negative values.  If they are significantly
;180 //      different, then log a message that indicates a problem (i.e. one or
;181 //      more of the following are incorrect):
;182 //         - The hardware gains for vout
;183 //         - The adcCalib or readCalib values for vout
;184 //         - The dacCalib or setCalib for vlimPlus and/or vlimMinus
;185 //
;186 //    - Add code to track and log the observed ratio of vctrl to ifdbk when
;187 //      iset, ifdbk, ttlBulkCur, bjtBias, vctrl, vout, and polCmd are all
;188 //      stable.
;189 //
;190 //    - Add code to track and log the observed gain for the iset/ifdbk port
;191 //      of the feedback circuit (i.e. the ratio of vctrl to iset-ifdbk duri
;192 //      the VERY short period between a steady state and when vout is raile
;193 //      after a change in the setpoint). (Q: Is the period actually TOO sho
;194 //      to get useful data to do this?  Especially with the change from a 1
;195 //      to a 20ms scheduler tick interval?)
;196 //
;197 //    - Add code to track and log the actual ramp rate of the load current.
;198 //      The ideal ramp rate would be the minimum rate required to cause
;199 //      vout to "rail" (i.e. for the vlim settings to take affect) as this
;200 //      minimizes the oscillation that occurs around a polarity change with
;201 //      slowing down the rate of change.
;202 //
;203 // Question:
;204 //    Are the gain settings for vlimMinus, vlimPlus, and vout dependant on 
;205 //    load?
;206 //
;207 //
;208 //-------------------------------------------------------------------------
;209 //  Update Log (most recent first)
;210 //
;211 //
;212 //  2012-11-16 - Mark Davis (*)
;213 //               - Added debounceMS setting and the debounceDigIn() functio
;214 //                 developed for the TCP controller.  Prior to this, there
;215 //                 was at least one observed instance of anomalous readings
;216 //                 the digital inputs (where nearly all the inputs changed 
;217 //                 a 0 to a 1 state for one pass).
;218 //
;219 //  2012-10-19 - Mark Davis (*)
;220 //               - Readings that indicate a bulk supply is shorted must be
;221 //                 consistent for > 700 ms (which covers just the last 3
;222 //                 readings for bulk supplies) before it triggers a shorted
;223 //                 error (and an interlock that shuts off the supplies).
;224 //                 Prior to this, many of the controllers experienced what
;225 //                 appeared to be spurious one-time readings that triggered
;226 //                 the error when there wasn't actually a problem.
;227 //
;228 //  2012-03-22 - Mark Davis
;229 //               - Added logic to limit polarity and mode change messages
;230 //                 while waiting to turn the supplies on.  Prior to this,
;231 //                 there could be up to 500 messages logged while waiting
;232 //                 (even more if new setpoints were received while waiting)
;233 //
;234 //  2012-03-19 - Mark Davis
;235 //               - Added loop at beginning of applic task to insure that we
;236 //                 have read the state of ALL the bulk supply signals prior
;237 //                 to normal initialization.
;238 //
;239 //  2012-03-12 - Mark Davis
;240 //               - The flag indicating the code detected a load type config
;241 //                 error (i.e. inductive load behavior when the type was no
;242 //                 set to inductive) is now reset when current conditions d
;243 //                 not indicate this.  Prior to this change, the flag would
;244 //                 stay set (and generate periodic error messages in the lo
;245 //                 until the conflict was resolved (as opposed to waiting
;246 //                 until the error was seen again).
;247 //
;248 //  2012-02-17 - Mark Davis
;249 //               - Moved some of the code from updatecurState() to a sepera
;250 //                 function because updateCurState() was large enough to ca
;251 //                 linker problems (it was larger than 4K which, depending 
;252 //                 its location, can result in pieces residing in 3 differe
;253 //                 4K blocks, while the Rabbit extended program counter use
;254 //                 for executing code in extended memory spans only 2 4K bl
;255 //                 at a time).
;256 //
;257 //  2011-12-28 - Mark Davis (*)
;258 //               - Added bulkSupErr flag that considers only relevant bulk
;259 //                 supplies when checking for interlock errors.  Recent cha
;260 //                 prior to this would result in unclearable interlocks.
;261 //               - Added bridgeStateStable flag and used it to avoid updati
;262 //                 readings for bulk supplies until after the bride has bee
;263 //                 on for a short period.  This reduces the number of error
;264 //                 (and resulting log messages) about the current operating
;265 //                 state.
;266 //               - Added ampReadMax (set to the largest load current readin
;267 //                 possible using the current analog calibrations) and used
;268 //                 it to set the bulkCurClose flag.  The later is used to h
;269 //                 detect when the system is in ramping or sinking modes.
;270 //               - Updated the logic that keeps track of the number of msgs
;271 //                 logged between setpoint and on/off changes and disables
;272 //                 many of the messages if too many have occured since the
;273 //                 last change (to avoid filling the log with useless info)
;274 //               - Added bits to vctrlStatus for regPolStable and inductive
;275 //               - The inductiveLoad flag is once again set from the loadTy
;276 //                 configuration value.  However, new logic was added that
;277 //                 periodically logs a warning message if the load behaves
;278 //                 like an inductive one with a load resistor but the loadT
;279 //                 setting does not specify this type of load.
;280 //               - Messages are now periodically written to the syslog
;281 //                 indicating the state of key values.  The interval varies
;282 //                 based on the current operating mode, and the same messag
;283 //                 are triggered by changes in various values.
;284 //
;285 //  2011-12-13 - Mark Davis (*)
;286 //               - The bias and current errors for bulk supplies are still
;287 //                 logged but no longer cause an interlock.
;288 //               - All changes to the individual bulk supply error states a
;289 //                 now logged.  Prior to this, the clearing of error condit
;290 //                 were not logged.
;291 //               - The error checking for the bulk supplies now treats a
;292 //                 change in polarity the same as the supplies being turned
;293 //                 on (in terms of giving the bulk supply currents time to
;294 //                 stablize under the new conditions).  Prior to this chang
;295 //                 the checking resumed too quickly after a polarity change
;296 //                 and would see bulk supply currents of 0 amps when the lo
;297 //                 current was still quite high, which would cause an inter
;298 //               - Changed the ampApply code so it uses the actual sched ti
;299 //                 rate.  Previous to this, it assumed a fixed 10ms interva
;300 //                 which resulted in a slower then specified rate of change
;301 //                 the setpoint.
;302 //
;303 //  2011-12-08 - Mark Davis (*)
;304 //               - Updated code to comply with the newer version that has a
;305 //                 regulation circuit that reduces the magnitude of the
;306 //                 control signal oscillations around 0.  These changes
;307 //                 include the following:
;308 //                   - The input that used to read vlim now reads bjtBias
;309 //                   - The new design appears to use the pos and neg vlim
;310 //                     settings to limit the effect of the set/read error o
;311 //                     the control voltage.  It is not clear how much influ
;312 //                     it still has on actually limiting the load voltage.
;313 //               - The UNCAL output mode is asserted only if it continues f
;314 //                 at least maxErrTime milliseconds.  Prior to this, it
;315 //                 would be asserted frequently between mode changes, filli
;316 //                 up the log with misleading messages (it is STILL doing t
;317 //                 although hopefully to a lesser degree).
;318 //               - Like a polarity change for any other mode, changing the
;319 //                 bridge polarity for SINK mode now requires the polarity 
;320 //                 the control voltage to be stable for a period before the
;321 //                 change.  Prior to this change, the software would allow
;322 //                 rapid changes in the bridge polarity while in SINK mode.
;323 //               - The error checking for the state of each bulk supply now
;324 //                 takes the OFF state of the bridges in to account.  Prior
;325 //                 this an interlock would occur when it was off and the lo
;326 //                 current was non-0 (i.e. it was dumping energy via the du
;327 //                 resistor while the bridge was off).
;328 //
;329 //  2011-06-24 - Mark Davis
;330 //               - Changed the order of the data elements in the devData fi
;331 //                 to deal with order-of-restoration dependencies.
;332 //
;333 //  2010-02-08 - Mark Davis
;334 //               - Added msgs for the individual bulk supplies turning on a
;335 //                 off
;336 //
;337 //  2010-02-04 - Mark Davis
;338 //               - maxErrtime is actually used now!
;339 //
;340 //  2009-12-14 - Mark Davis
;341 //               - Changed order of param files to deal with problems cause
;342 //                 by the order in which they were restored at startup.
;343 //
;344 //  2009-11-02 - Mark Davis
;345 //               - Moved contrast to settings persistent file.
;346 //
;347 //  2009-09-23 - Mark Davis
;348 //               - If the setpoint has not changed in several minutes and t
;349 //                 rate at which certain state changes happen exceeds some
;350 //                 threshold, then the logging of the state changes is disa
;351 //                 Prior to this leaving the supplies on with a near 0 sett
;352 //                 would cause an endless stream of log messages.
;353 //
;354 //  2009-07-01 - Mark Davis -
;355 //                - The enabled/disabled setting for each supply is now par
;356 //                  of the persistent configuration data.  This was necessa
;357 //                  because many of the controller boards are not completel
;358 //                  stuffed resulting in input values that are erroneous.
;359 //
;360 //  2009-04-23 - Mark Davis -
;361 //                - Fixed macros used to toggle the ActivityLED output bit
;362 //
;363 //  2009-03-20 - Mark Davis -
;364 //                - Added digInDescr[] and digOutDescr[] to support the new
;365 //                  generic methof for logging changes of interest in the s
;366 //                  of the digital I/O signals.
;367 //
;368 //  2009-02-03 - Mark Davis
;369 //               - added code to skip logging msgs for most input bit chang
;370 //                 if the applic task is starving other processes for CPU c
;371 //
;372 //  2009-01-20 - Mark Davis
;373 //               - modified formatting of ISET and IFDBK for "state" comman
;374 //                 and LCD interface to deal with changes in how we calibra
;375 //                 those values.
;376 //
;377 //  2008-11-13 - Mark Davis
;378 //               - made the numeric portion of the labels for bulk supply
;379 //                 signals 2 digits for all cases (to avoid ambiguity or
;380 //                 mismatches when specifying signal names)
;381 //               - reversed polarity of VLIM_POS and VLIM_NEG to deal with
;382 //                 new calibration regime
;383 //
;384 //  2008-08-26 - Mark Davis
;385 //               - added check for a psCount value of 0
;386 //
;387 //  2008-07-02 - Mark Davis
;388 //               - ttlBulkCur register now reads +/- again depending upon
;389 //                 bridge polarity
;390 //
;391 //  2008-06-17 - Mark Davis
;392 //               - new loadType setting is now actually used (in place of
;393 //                 logic that tried to determine load type automatically)
;394 //               - scaled voltage reading (readVal[]) rather than "raw"
;395 //                 reading (anaIn[]) is used to compare load voltage to
;396 //                 voltage limits (which is important to detect RAMP and
;397 //                 SINK modes)
;398 //
;399 //  2008-06-11 - Mark Davis
;400 //               - vlimMinus setting now checks the limit of its setting
;401 //                 properly so it doesn't force the setting to the wrong
;402 //                 value
;403 //               - changed default labels for temp OK bits for bulk supplie
;404 //
;405 //  2008-06-05 - Mark Davis
;406 //               - loadType is now a configurable value, and both loadType
;407 //                 and supplyType are settable via the LCD screen (althogh
;408 //                 the supplyType setting doesn't yet do anything...)
;409 //
;410 //  2008-05-21 - Mark Davis
;411 //               - new values for vlimMinus and vlimPlus now compared to
;412 //                 min/max set (scaled) values rather than min/max DAC valu
;413 //
;414 //  2008-04-28 - Mark Davis
;415 //               - changes for current-to-voltage-loop version of regulatio
;416 //                 circuit
;417 //
;418 //  2008-02-11 - Mark Davis
;419 //               - changes for supporting bulk supplies that use SCR's rath
;420 //                 than BJT/FET bridges on their outputs.
;421 //
;422 //---------------------------------------------
;423 //  2008-01-30 - Mark Davis
;424 //               - brought up to date in terms of latest code structure
;425 //               - Added minBSVolts setting to detect when a bulk supply
;426 //                 is not working properly.  Any bulk supply whose voltage
;427 //                 drops below this value for any significant period of tim
;428 //                 while "ON" causes an interlock and a message is added to
;429 //                 the log.
;430 //
;431 //  2007-09-19 - Mark Davis
;432 //               - first properly functioning prototype!
;433 //
;434 //  2007-05-08 - Mark Davis -
;435 //               - Started new project.
;436 //
;437 //-------------------------------------------------------------------------
;438 
;439 /*
;440 ===========================================================================
;441                    Description of persistent register values
;442 ===========================================================================
;443 
;444   The main concepts to keep in mind:
;445 
;446     - Regulation is done by an analog feeback loop
;447 
;448     - The Rabbit's job is to control the bridges that connect the load to t
;449       power supplies and change the polarity of the bridges as necessary to
;450       match the polarity of the control voltage from the feedback loop.
;451 
;452     - The Rabbit has no way to stop the feedback loop from TRYING to regula
;453       the current through the load, even when the load is not connected.
;454 
;455 
;456 Basic design flaw:
;457 
;458   The above indicates a basic flaw in the design:  The bridge connecting th
;459   supplies to the load has to be turned off for some period of time to swit
;460   the polarity.  During this time the regulation circuit tries to keep
;461   regulating the current through the load.  But of course it can't when the
;462   load isn't connected.  The result is that, whenever the load is disconnec
;463   the control voltage (VCTRL) spikes.
;464 
;465   This really doesn't matter while the load is disconnected.  But the momen
;466   you reconnect it, the control voltage again, in the opposite direction.
;467   The Rabbit responds by disconnecting and then reconnecting the load in th
;468   new polarity, which just causes the cycle to repeat.
;469 
;470   In earlier versions, this resulted in wild oscillations as the Rabbit wou
;471   keep disconnecting and reconnecting the load, trying to keep the polarity
;472   the same as the control voltage from the feedback loop's output.  Because
;473   the Rabbit was so much slower, it couldn't keep up, and the oscillation c
;474   go on for quite some time.
;475 
;476   Even worse, in the original version, the feeback loop's control voltage
;477   set the polarity for the lower half of the bridges, resulting in a short
;478   across the bulk supply outputs until the Rabbit swapped the top half to
;479   match.  And because the shorted state meant the load current was not bein
;480   affected by the feedback loop, these spikes could produce considerable
;481   current, potentially damaging the supplies and/or the bridges.
;482 
;483   Since the Rabbit has no way to disable the regulation circuit, it cannot
;484   eliminate the spike that happens each time it switches the polarity of th
;485   connection to the load.  The best that can be done is to try to minimize
;486   them.  Instead of trying to do what is CAN'T do (i.e. change the bridge
;487   polarity faster than the feedback loop can respond), it does the opposite
;488   It figures out when it should IGNORE the polarity of VCTRL.
;489 
;490 
;491   In the latest version, the flow of current through the bridge is disabled
;492   when the polarity of VCTRL is different than what the bridge is configure
;493   for.  So when the polarity of VCTRL suddenly changes, at least it does no
;494   result in a power spike through the bridge, which greatly reduces the ris
;495   of damaging the load or the supplies.
;496 
;497   However, on the older FET/BJT bridge design, this is a major issue.  If
;498   the Rabbit simply waits for the polarity of VCTRL to change, by the time
;499   it reacts, the bottom portion of the bridge (controlled by the polarity
;500   of VCTRL) has already changed, causing a short through the bridge that
;501   bypasses the load.  Trying to keep up with the changes in VCTRL just
;502   prolongs the oscillation.  Turning off both sides of the upper portion
;503   of the bridge stops the oscillation, but eventually it has to be turned
;504   back on, at which point the oscillation will start again.
;505 
;506   Unfortunately, "If it hurts, don't do it!" isn't an option.  We can't
;507   just leave the load disconnected all the time.  The only viable option is
;508   for the Rabbit to switch the polarity of the bridge when needed, but then
;509   ignore changes in the VCTRL polarity for a short period.
;510 
;511   For the older version, this means that the bottom half of the bridge will
;512   keep oscillating back and forth between causing the bridge to be a short
;513   (with the load disconnected), and connecting the load using the polarity
;514   needed to nudge it further along in the direction that will eventually le
;515   to VCTRL stablizing again.
;516 
;517   While this does (eventually) lead to stable regulation again, there is
;518   a modification on this theme that drastically reduces the magnitude and
;519   period of the oscillation:  If the Rabbit changes the polarity of the
;520   top half of the bridge JUST BEFORE the instant when VCTRL WOULD have
;521   changed polarity on its own, this avoids the huge initial spike that
;522   occurs if the Rabbit waits and simply reacts to the change AFTER it has
;523   happened.  It also helps a great deal if the Rabbit temporarily reduces
;524   the VLIM settings at the same time, which helps dampen the initial
;525   oscillation.
;526 
;527   The Rabbit does this by monitoring the state of the load and the feedback
;528   loop and trying to determine when a SINK mode is about to end (a SINK mod
;529   being the state where the magnet is dumping energy through the bridge and
;530   the dump resistor).  But of course, for this to work, the values the
;531   Rabbit is using must be accurate, which means the calibrations for the
;532   signals that provide those values must be accurate.
;533 
;534   NOTE:  One very logical alternative that was tried was to change the acti
;535          setpoint to the match the readback when oscillation started (or wa
;536          about to start) and then to slowly restore it until the system had
;537          passed through the region where oscillation occurs.  But the gain 
;538          the feedback loop made this impractical, as even a TINY difference
;539          between the setpoint and the readback would result in a large
;540          control voltage.  And given how much slower the Rabbit is, even if
;541          it HAD the needed accuracy in its settings and readings, it could
;542          not adjust the setpoint QUICKLY enough to avoid the oscillation.
;543 
;544 
;545 Load Voltage limits:
;546 
;547   The controller also supports voltage limit settings for the voltage acros
;548   the load.  The Rabbit supplies these to the feedback loop, which uses the
;549   to limit the control voltage (VCTRL) so as not to exceed these limits for
;550   any significant period of time.
;551 
;552   In the latest version, the voltage limit settings are applied to the
;553   IFDBK-ISET error as well as the load voltage.  This helps by putting a ca
;554   on the magnitude of the oscillations that occur around a change in the
;555   polarity of the bridge.
;556 
;557   Perhaps even more significant is the addition of switches between the
;558   control voltage from the analog feedback circuit (VCTRL) and the voltage 
;559   gets applied to the BJTs in series with the bridges.  The new arrangement
;560   is designed to ensure that the BJTs (now in series with the bridges) and
;561   the bridge itself (now made up entirely of SCRs) are conducting ONLY when
;562   the polarity command asserted by the Rabbit agrees with the polarity of t
;563   VCTRL signal.
;564 
;565   Since the Rabbit is WAY too slow to keep up with polarity changes in the
;566   VCTRL signal, this all but ensures that the bridge will not bypass the
;567   load (i.e. cause a short across the output of bulk supplies) while any
;568   significant amount of current is flowing through the BJTs.  And while it
;569   doesn't eliminate the problem of the VCTRL signal spiking in the opposite
;570   direction when the bridge is turned back on, it stops such spikes from
;571   causing a jump in current through the bridge.
;572 
;573 
;574 The REAL solution (never implemented):
;575 
;576   While all of this means the latest version is a big improvement over the
;577   earlier versions, what would be even better is if the Rabbit could contro
;578   the gain of the feedback loop, which would allow it to effectively elimin
;579   the root of the problem:  A feedback loop that keeps trying to regulate t
;580   current through the load even when the load isn't connected.  If the
;581   gain on the feedback loop could be reduced far enough, the Rabbit could
;582   simply AVOID the conditions that result in the initial spike and the
;583   oscillation.
;584 
;585 
;586 
;587 The importance of accurate calibrations:
;588 
;589   But of course NONE of this will work unless the Rabbit has accurate data,
;590   which means everything must be calibrated BEFORE this will work - which l
;591   to a bit of a Catch-22, since such calibrations generally require running
;592   the controller connected to the device it has not yet been calibrated for
;593 
;594   The best compromise has been to start with some default calibrations that
;595   allow the controller to operate well enough to complete the more precise
;596   field-level calibrations.
;597 
;598 
;599 The settings:
;600 
;601   Roughly in order of importance (i.e. the ones closer to the start of the
;602   list are more likely to result in damage to the load, controller, and/or
;603   supplies if they are not reasonably close to the optimal values, followed
;604   by ones that determine whether the ctlr will or will not operate properly
;605 
;606   bulkShortCur:      Value that indicates a short across a bulk supply's ou
;607                      (i.e. both SCR's on one side of its output bridge are 
;608                      so most or all the current is going through the 2 SCR'
;609                      on one side of the bridge and NOT contributing to the
;610                      current through the load).  This can save you from the
;611                      time consuming and expensive process of replacing the
;612                      bridge components if you get something else wrong.
;613 
;614   loadType:          Specifies if the load is a resistor (DC) or an inducto
;615                      (i.e. a magnet) with a dump resistor (RL).
;616 
;617   supplyType:        Specifies what type of bridge the supplies have: SCR's
;618                      or FET's with BJT's (not yet used, as this version of 
;619                      code is designed for the latest version with the SCR
;620                      bridges and polarity cutoff switches).
;621 
;622   sinkEndAmps:       The optimal total bulk-supply currrent value at which 
;623                      switch the polarity of the bridge at the end of SINK m
;624                      Affects the size of the unavoidable voltage spike that
;625                      occurs while the bridge is off (because the regulation
;626                      circuit, which is still active, keeps trying to regula
;627                      but can't while the bridge is off).
;628 
;629   vlimReduction:     The amount the voltage limits are temporary reduced by
;630                      during sink mode to minimize the voltage spike when
;631                      sink mode ends.
;632 
;633   minBridgeOffTime:  Min time (in ms) the bridge must be off before being
;634                      turned back on (by reasserting a polarity command).  A
;635                      affects the size of the unavoidable voltage spike that
;636                      occurs while the bridge is off.
;637 
;638   minPolStableTime:  Min time (in ms) the regulation polarity (inverse of V
;639                      polarity) must be stable before the bridge polarity is
;640                      changed to match.
;641 
;642   vlimPlus:          The maximum positive voltage across the load
;643 
;644   vlimMinus:         The maximum negative voltage across the load
;645 
;646   vctrlHyst:         The magnitude of the "deadman" range around 0 that VCT
;647                      must cross for changes in its polarity to be recognize
;648                      This avoids constantly turning the bridge on and off w
;649                      VCTRL is near zero (and avoids initiating the very kin
;650                      of oscillation we are trying so hard to avoid).
;651 
;652   maxErrTime:        The maximum contiguous time normal operating parameter
;653                      are allowed to be exceeded before an Interlock conditi
;654                      is asserted (in ms)
;655 
;656   rampRate:          The rate at which the active setpoint changes until it
;657                      reaches the requested setpoint (in Amps/second)
;658 
;659   maxAmpSet:         The maximum allowable setpoint (in amps)
;660 
;661   minPSonTime:       The minimum amount of time the bulk supplies and bridg
;662                      must be on before normal operation is allowed (in ms)
;663 
;664   minBSVolts:        The minimum Bias voltage that each Bulk Supply should 
;665                      while turned on and working properly.  If a Bulk Suppl
;666                      Bias voltage drops below this value for a significant
;667                      period of time, then an interlock state is asserted
;668                      (another guard against shorts).
;669 
;670   maxBSFracCurDiff:  Max allowed differrence in the current reading for eac
;671                      active Bulk Supply while in regulation mode.  Expresse
;672                      as a fraction of the max current reading for each supp
;673 
;674   knobSelectRate:    Controls how much the knob on the front panel has be b
;675                      turned to change what value is selected.
;676 
;677 
;678 ===========================================================================
;679               Notes on how the Modular Power Supply operates
;680 ===========================================================================
;681 
;682     The ModularPS controller supports up to 10 "bulk" power supplies.  The
;683     output is normally connected to an inductive load (a magnet) through
;684     bridges that acts as switches to control the direction current from the
;685     supplies can flow through the bridges and affect the load.
;686 
;687     The magnitude of the current flow from the supplies through the bridges
;688     set by a control voltage produced by an analog feedback control loop wh
;689     reacts much faster than the Rabbit can.
;690 
;691     The inputs to the feedback circuit consist of the following:
;692       - The current through the load.  This does NOT include the current
;693         through the dump resistor which is in parallel with the load.
;694       - The voltage across the load
;695       - The setpoint
;696       - Positive and Negative limits for the voltage across the load
;697 
;698     The analog feedback loop sets the control voltage based on the differen
;699     between the setpoint and the load current and how close the load voltag
;700     is to one of the limits.  As long as the load voltage is well below the
;701     set limits, the result is due primarily to the difference between the
;702     setpoint and load current.  But when the load voltage gets close to one
;703     of the set limits, the result is a "clipped" value which effectively
;704     limits the bridge current so as not to exceed the set voltage limits.
;705 
;706     Inputs to the Rabbit allow it to monitor the following:
;707       - The current through the load
;708       - The voltage across the load
;709       - The control voltage produced by the analog feedback circuit
;710       - The output current and voltage from each of the bulk supplies
;711 
;712 
;713     In the original version of the controller, the bridge consisted of FET'
;714     on the "top" and BJT's on the "bottom".  Which "side" of the bottom of
;715     the bridge was conducting was determined by the polarity of the control
;716     voltage, while which side of the top was controlled by the Rabbit.
;717 
;718     The Rabbit's primary task was to monitor the polarity of the control vo
;719     (which told it which side of the bottom of the bridge was conducting) a
;720     to try to insure that the correct side on the top was conducting to ins
;721     that the output from the supplies was flowing through the load (and the
;722     dump resistor) rather than just through the bridge.  Because the Rabbit
;723     is so much slower than the feedback loop, the result would be a tempora
;724     mismatch, causing the bridges to be configured as a short across the
;725     outputs of the supplies.
;726 
;727     In the latest design includes several changes/enhancements:
;728 
;729       - The bridges are made up entirely of SCRs with one set of BJTs in
;730         series with the bridges (i.e. not one set for each polarity, as was
;731         the case when the BJT's were part of the bridges).
;732 
;733       - Switches that enable current to flow through the bridges only when
;734         the polarity settings for the bridge match the polarity of the cont
;735         voltage from the feedback loop.  This guards against shorts, and
;736         provides a way for the Rabbit to turn off the bridge.  Once enabled
;737         SCRs will continue to conduct after the enable signal is removed,
;738         unless the current flow drops below some fairly low level.  So even
;739         if the Rabbit stops asserting both polarity commands, the bridge
;740         would stay on if the current flow was not also stopped.
;741 
;742       - The voltage limit settings now place a cap on the gain applied to
;743         the setpoint/readback difference (ISET-IFDBK).  This helps to
;744         minimize the magnitude of spikes in the control voltage (VCTRL).
;745 
;746 
;747 The control loop in more detail:
;748 
;749     The controller has an analog feedback loop that uses the following inpu
;750 
;751       ISET:  Active setpoint for the analog feedback loop
;752 
;753       IFDBK: The current through the load
;754       VOUT:  The voltage across the load
;755 
;756       VLIM_NEG:  The largest negative voltage allowed across the load
;757       VLIM_POS:  The largest positive voltage allowed across the load
;758 
;759     and produces the following outputs:
;760 
;761       VCTRL:  The control signal whose polarity indicates the polarity the
;762               bridges should be set to.  This signal passes through switche
;763               and buffers that effectively do an absolute value operation o
;764               it and feed it to BJTBIAS, but ONLY when the polarity command
;765               to the bridge match the polarity of VCTRL.
;766 
;767       BJTBIAS: The control signal (not including a hdw adjustable offset)
;768                applied to the BJTs that are in series with all the bridges
;769                for the individual supplies (i.e. this signal controls how
;770                much current flows through the bridges).  See note below.
;771                In effect:
;772                    BJTBIAS = (POL(VCTRL) == POL(BRIDGE)) ? ABS(VCTRL) : 0
;773 
;774 
;775     NOTES:
;776 
;777       - The total current flowing through the bridges is generally differen
;778         than the load current when ramping or sinking an inductive load
;779         (because some of the current will be going through the dump resisto
;780         that is in parallel with the load)
;781 
;782       - In the latest design (bundle #160 rather than the older design in
;783         bundle # 211), the feedback loop limit settings VLIM_POS and VLIM_N
;784         seem to be used more to limit the effect of the iset/ifdbk differen
;785         rather than limiting the actual load voltage.
;786 
;787 
;788 
;789     The software controls the following outputs:
;790 
;791        Analog:
;792           ISET, VLIM_NEG, VLIM_POS
;793 
;794        Digital:
;795           Positive and Negative polarity enable for the SCR bridges
;796           Positive and Negative polarity indicator LEDs
;797           On enable for each bulk supply
;798           Activity LED
;799 
;800     and reads the following inputs:
;801 
;802        Analog:
;803           IFDBK, VOUT, VCTRL, BJTBIAS
;804           Current and Voltage for each of the bulk supplies
;805 
;806        Digital:
;807           On/Off, Available, and Temp OK states from each of the bulk suppl
;808           Holec OK
;809           External Interlock
;810 
;811 
;812     The software controls the setpoint for the analog feedback circuit, the
;813     on/off state of the bulk supplies, the pos/neg gain limits, and
;814     (indirectly) the state of the SCR bridges connecting the load to the
;815     bulk supplies.
;816 
;817     The primary duties of the software are as follows:
;818 
;819       - Keep track of what state the load and the bulk supplies are in
;820 
;821       - Minimize the chaos that results when the polarity of the current
;822         through the bridge needs to be changed
;823 
;824       - Protect the load and the power supplies from harm
;825 
;826 
;827     To accomplish this, the software must be able to determine what state
;828     the supplies, load, and bridge are in and change its outputs at the
;829     correct time.
;830 
;831     The following describe the various states the code must be able to
;832     recognize:
;833 
;834     NOTES:
;835        The following discussion applies mostly to an inductive load with a
;836        "dump resistor" connected in parallel to the load.  The purpose of t
;837        dump resistor is to provide a controlled means of converting the ene
;838        stored as a magnetic field in to heat energy.
;839 
;840        A sudden collapse of the magnetic field must be avoided, as this wou
;841        exert considerable force on the conductors within the coil, which wo
;842        likely damage them.  By having a dump resistor connected in parallel
;843        to the coil, there is always a path for the electrons to flow, so a
;844        sudden collapse of the field is avoided.  The conductivity of the du
;845        resistor determines how quickly the energy of the (controlled) colla
;846        of the magnetic field is converted in to heat eminating from the dum
;847        resistor.
;848 
;849        In addition to protecting the load from excessive physical stress, t
;850        presense of the dump resistor means that, under certain conditions,
;851        there will be a significant difference between the current flowing
;852        through the bridge and the current flowing through an inductive load
;853 
;854        This difference shows up when the current through the load is changi
;855        which causes the magnetic field around the load to increase or decre
;856        which in turn exerts an opposing force on the electron flow (which
;857        means even a superconducting electro-magnet will have an effective
;858        resistance).
;859 
;860        At these times, a significant amount of current will flow through
;861        the dump resistor, causing a significant difference between the
;862        current flowing through the bridge and the current flowing through
;863        the load.
;864 
;865 
;866     REGULATION:
;867        This state is characterized by a steady state for all the major
;868        inputs and outputs:  VCTRL, BJTBIAS, IFDBK, VOUT, ttlBulkCur, ISET,
;869        polCmd.  In this state, the magnetic field around the inductor is
;870        also steady, so the inductor has little resistance and most of the
;871        current flowing through the bridges flows through the inductive load
;872 
;873        The result is very little difference between the bridge/bulk supplie
;874        current and the load current.
;875 
;876 
;877     RAMPING:
;878        Ramping occurs when the energy stored in the load is being increased
;879 
;880        During RAMPING, the difference between the setpoint and the load cur
;881        causes the current output from the supplies to be increased, raising
;882        the current flowing through the bridges.  This causes an increase in
;883        supply current flowing through the inductor, which enlarges the magn
;884        field, which increases the effective resistance of the load.  All of
;885        which means more of the increasing supply/bridge current will flow
;886        through the dump resistor, causing a significant increase in the
;887        difference between the load current and the bridge/supplies current,
;888        well as a rise in the voltage across the load and dump resistor.
;889 
;890        In short, RAMPING mode is indicated by the following conditions:
;891         - The bridge polarity is the same as the load voltage polarity
;892         - The value (ttlBulkCur-ifdbk) is significantly shifted in the dire
;893           of the polarity of the load voltage polarity compared to the same
;894           value during REGULATION:
;895              i.e. POLARITY( CUR(ttlBulkCur-ifdbk) - REG(ttlBulkCur-ifdbk) )
;896                     == POLARITY(vout)
;897         - The load voltage is signifcantly larger than it is during REGULAT
;898 
;899 
;900     SINKING:
;901        Sinking occurs when the energy stored in the load is being decreased
;902 
;903        During SINKING, the difference between the setpoint and the load cur
;904        causes the current output from the supplies to be decreased, reducin
;905        the current flow through the bridges.  This causes a decrease in the
;906        supply current flowing through the inductor and dump resistor, which
;907        shrinks the magnetic field, which resists the change by increasing t
;908        current flow through the inductor.  Some of this current flows throu
;909        the dump resistor in the opposite direction the bridge/supply curren
;910        normally flows through it, so the voltage across it (and the load)
;911        reverses.
;912 
;913        In short, SINKING mode is indicated by the following conditions:
;914         - The bridge polarity is the opposite of the load voltage polarity
;915         - The value (ttlBulkCur-ifdbk) is significantly shifted in the dire
;916           of the polarity of the load voltage polarity compared to the same
;917           value during REGULATION:
;918              i.e. POLARITY( CUR(ttlBulkCur-ifdbk) - REG(ttlBulkCur-ifdbk) )
;919                     == POLARITY(vout)
;920         - The load voltage is signifcantly larger than it is during REGULAT
;921 
;922 
;923 
;924 
;925 ===========================================================================
;926 *** Need to review/revise pretty much everything below this.  Some of it is
;927 *** outdated, some of it is misleading, and some of it only applies to the 
;928 *** older BJT+FET bridge design that predates both the SCR bridge designs) 
;929 ===========================================================================
;930 
;931 Question:
;932 
;933   Shouldn't we be able to determine the effective resistance of the magnet
;934   based on the available readings and determine if a magnet has "quenched"
;935   (i.e. a portion of the windings got too warm to be superconduncting, so
;936   the resistance jumped?)
;937 
;938 
;939 NOTES:
;940 
;941   The ModularPS controller contains hardware configurable gains for 2 of th
;942   possible sources for the IFDBK signal.  For the internal HOLEC, the gain 
;943   set by 6 jumpers that determine which of 6 resistors are connected to the
;944   feedback loop for an op-amp.  For the external shunt, a variable resistor
;945   sets the gain.
;946 
;947   For the control logic to work correctly, the read/set gains (and to a les
;948   degree, the offsets) must be set to match the hardware configuration.
;949   Unfortunately, the design does not provide any means for the sofware to
;950   know where the IFDBK signal is coming from or what the gain on it is.
;951 
;952   The only information related to the gain that the software has available 
;953   the number of bulk supplies that are connected.  The software COULD assum
;954   that the hardware gain is configured properly for the number of supplies
;955   connected, but all you would need to do is connect or disconnect a single
;956   supply without changing the hardware settings and that assumption would b
;957   incorrect and the controller would malfunction.
;958 
;959   The best that can be done (short of correcting this design flaw) is to ad
;960   a software configurable parameter that tells the software how the hardwar
;961   is configured, and compare that to the number of supplies connected.  If
;962   the two do not match, then log a warning and set a bit read by the contro
;963   system to signal a possible error.
;964 
;965 ---------------------------------------------------------------------------
;966 
;967   VOUT jumping to zero at the end of a sink period/start of the unstable
;968   period can only happen if both sides of the bridge are on, placing a
;969   short across the dump resistor and the magnet.
;970 
;971   VLIM is largely influenced by ISET-IFDBK.  The value of VLIM cannot be
;972   used (at least by itself) to determine things like how much current is
;973   flowing through the dump resistor, or when the regulation is primarily
;974   due to the voltage limit or to the current error.
;975 
;976   Comparing the polarity of VCTRL to VOUT when VOUT is close to or greater
;977   than the applied voltage limit is how you can tell if regulation is due
;978   to the voltage limit or the current error.  When VOUT is close to (or
;979   greater than) the applied voltage limit, and VCTRL specifies a polarity
;980   opposite the polarity of VOUT, then regulation is due to the applied
;981   voltage limit.
;982 
;983 ---------------------------------------------------------------------------
;984   Remember:  A zero VCTRL has nothing to do with a zero load current.  The
;985              magnitude and polarity of VCTRL indicates how much CHANGE we
;986              want in the load current, not the VALUE of the load current!
;987 
;988              VCTRL is driven one of 2 values:
;989               - The difference between ISET and IFDBK
;990               - The voltage across the load exceeding the set limits
;991 
;992              The 1st case is in effect when the load voltage is below the
;993              specified limits, and the current is being ramped toward or
;994              maintained at a specific value.
;995 
;996              The 2nd case is in effect when the load voltage exceeds one of
;997              the specified limits, and some of the current is being diverte
;998              from the load resistor (through the bridge and - for the SCR
;999              type bridges - through the supplies themselves) to control
;1000              the rate at which power is dumped through the resistor and
;1001              turned in to heat.
;1002 
;1003              NOTE:  The dump resistor can handle an off condition in which
;1004                     all the current is going through the resistor, but this
;1005                     results in a faster rate of change in the current in
;1006                     the magnet, which puts more stress on the magnet and
;1007                     can damage it, so this is avoided whenever possible.
;1008 
;1009 
;1010 ---------------------------------------------------------------------------
;1011 
;1012   For the BJT/FET type bridges, control of the bridge is split between the
;1013   regulation circuit and the software.  The output of the regulation circui
;1014   is VCTRL.  The polarity of VCTRL sets which of side of the lower (BJT)
;1015   portion of the bridge is conducting, and its magnitude determines the
;1016   amount of current.  The software determines which side of the upper (FET)
;1017   portion of the bridge is enabled, and it monitors the VCTRL signal to
;1018   determine which one should be enabled to keep current flowing through the
;1019   load.
;1020 
;1021   One problem with this approach is that the software is FAR slower than th
;1022   regulation circuit.  As long as the polarity of the VCTRL signal does not
;1023   change, this is not a problem.  But when it does change (which it does
;1024   whenever SINK mode ends), the output of the power supplies is shorted
;1025   through one side of the bridge until the software sees the change and
;1026   switches which set of FETs are enabled.
;1027 
;1028   Since this condition normally happens only at lower currents, it generall
;1029   doesn't present a danger to the equipment, but the result is oscillation
;1030   as the software keeps lagging behind the changes in the VCTRL polarity.
;1031 
;1032   What happens is this:
;1033 
;1034       VCTRL changes polarity, changing which side of the BJT portion of the
;1035       bridge is conducting.  The software hasn't yet switched which FETs ar
;1036       conducting, so there is a temporary short through the bridge.
;1037 
;1038       During this period, the regulation circuit has no effect on the curre
;1039       it is trying to regulate.
;1040 
;1041 
;1042     VOUT (the voltage across the load?) is (mostly?) determined by the
;1043     current through the dump resistor that is in parallel with the magnet.
;1044 
;1045     When the FETs are disabled during SINK mode, the power is dumped
;1046     primarily through the dump resistor.
;1047 
;1048 
;1049     As the current through the load drops, the portion of the current ...
;1050 
;1051   -------------------------------------------------------------------------
;1052 
;1053     Eash supply has its own bridge with the load connected to the center
;1054     of the bridge.
;1055 
;1056   ==================================
;1057     Supplies with FET/BJT bridges
;1058   ==================================
;1059 
;1060            +---------------------------------------+
;1061            |                                       |
;1062            |                              +--------+-------+
;1063            |                              |                |
;1064            |                            |-+                +-|
;1065            |              Enable(+) ---|                      |--- Enable(-
;1066            |                            |-+                +-|
;1067            |                    [+] FET   |                |   FET [-]
;1068            |                              +----- load -----+
;1069            | (+)                          |                |
;1070            |                              +--- resistor ---+
;1071           bulk                            |                |
;1072          supply                           +---+        +---+
;1073            |                              |  _|_      _|_  |
;1074            | (-)          abs(VCTRL) ___|/    +        +    \|___ abs(VCTRL
;1075            |                            |\   / \      / \   /|
;1076            |                    [-] BJT   v  ===      ===  v   BJT [+]
;1077            |                              |   |        |   |
;1078            |                              +---+        +---+
;1079            |                              |                |
;1080            |                              +--------+-------+
;1081            |                                       |
;1082            +---------------------------------------+
;1083 
;1084 
;1085      - FET forms "upper" half of bridges, BJTs the "lower" half
;1086 
;1087      - The software controls the FETs, while the regulation circuit control
;1088        the BJTs
;1089 
;1090      - The software monitors the state of the BJTs and the load and determi
;1091        which (if either) side of the FET portion of the bridges should be
;1092        enabled.
;1093 
;1094      - The software has no control over the BJTs.  The polarity of the VCTR
;1095        signal (the output of the regulation circuit) determines which side
;1096        of the BJT portion of the bridge should be enabled.  The software mu
;1097        monitor the VCTRL value and keep the correct FET side enabled to
;1098        avoid a short through the bridge.
;1099 
;1100      - The amplitude of the VCTRL signal determines how much current flows
;1101        through the BJT portion of the bridge.  If one of the FET sides
;1102        is enabled, it also determines how much current flows through each
;1103        bulk supply.
;1104 
;1105      - The software is much slower (100Hz) than the regulation circuit.  An
;1106        time the polarity of VCTRL changes while the FETs are enabled, there
;1107        will be a short period (before the software can detect and react to
;1108        the change) when there is a short across the bridge.  This must NOT
;1109        happen when there is any significant current through the supplies.
;1110 
;1111 
;1112      - SINK mode operation:
;1113 
;1114         - The polarity commands are both disabled while in SINK mode, which
;1115           turns off all the FETs
;1116 
;1117         - BJTs are still controlled by VCTRL to limit the dump rate.  Durin
;1118           this time, the voltage across the load/dump resistor is effective
;1119           in control of the VCTRL signal, which adjusts the current flowing
;1120           through the BJTs to maintain the voltage set by the VLIM values (
;1121           controlling how much current does NOT flow through the dump resis
;1122 
;1123      - Coming out of SINK mode:
;1124 
;1125         - When enough power has been dumped through the resitor that the
;1126           voltage across it drops below the VLIM setting, the difference
;1127           between ISET and IFDBK regains control of the VCTRL value, which
;1128           then changes polarity, trying to drive the load current in the
;1129           desired direction (by changing the BJT polarity).
;1130 
;1131         - At this point VCTRL begins to spike, trying to regulate the
;1132           feedback value (the load current) which it does not yet have
;1133           control over.
;1134 
;1135         - To minimize the magnitude of the spike, and magnitude and period
;1136           of oscillation will occur when the FETs are turned back on, ISET
;1137           is set equal to IFBDK.
;1138 
;1139         - The FETs are turned on based on the polarity indicated by VCTRL
;1140           (before ISET was changed to match IFDBK).  At this point there wi
;1141           some osciallation of VCTRL (including its polarity).  Because the
;1142           software cannot keep pace with the speed of these changes, it
;1143           must "ride out" this period of oscillation, allowing the bridge
;1144           to temporarily short at low current until VCTRL settles down.
;1145 
;1146         - For a fixed period of time after coming out of SINK mode:
;1147            - Do NOT turn off or change the polarity of the FETs after they
;1148              are turned on
;1149            - Do NOT reassert SINK mode
;1150 
;1151 
;1152   ==============================
;1153     Supplies with SCR bridges
;1154   ==============================
;1155 
;1156            +---------------------------------------+
;1157            |                                       |
;1158            |                              +--------+-------+
;1159            |                    [+] SCR  _|_              _|_  SCR [-]
;1160            |                        ---+ \ /              \ / +---
;1161            |                            \_v_              _v_/
;1162            | (+)                          | \            / |
;1163            |                              +----- load -----+
;1164           bulk                            |                |
;1165          supply                           +--- resistor ---+
;1166            |                              |                |
;1167            | (-)                [-] SCR  _|_              _|_  SCR [+]
;1168            |                        ---+ \ /              \ / +---
;1169            |  abs(VCTRL)                \_v_              _v_/
;1170            |       ---+                   | \            / |
;1171            |         _|_                  +--------+-------+
;1172            |         / \                           |
;1173            +--------v   ---------------------------+
;1174 
;1175 
;1176      - The bridge is made up entirely of SCRs.
;1177 
;1178      - The polarity commands turn on SCRs, but they cannot (directly) turn
;1179        off SCRs that are conducting more than about 200ma of current (but
;1180        they can indirectly as described below).
;1181 
;1182      - The BJTs are now in series with the bridge, controlling the amount
;1183        of current flowing through the supply AND the bridge (in the FET/BJT
;1184        bridge supplies, the BJTs controlled the current flowing through the
;1185        bottom half of the bridge, which could be different than what was
;1186        flowing through the supplies).
;1187 
;1188      - The only way the SCRs can be turned off is to insure no current
;1189        through the bridge.  This is done by turing off the BJTs.
;1190 
;1191      - The VCTRL signal passes through an additional circuit that insures
;1192        that the BJTs are enabled only when one of the polarity commands is
;1193        asserted, and it is in agreement with the polarity specified by the
;1194        VCTRL signal.  This insures that the bridge is disabled until the
;1195        software detects and reacts to changes in the VCTRL polarity.
;1196 
;1197 
;1198      - SINK mode operation:
;1199 
;1200        - The polarity command continues to be asserted in SINK mode to insu
;1201          the bulk supplies are still connected.  This allows the regulation
;1202          circuit to maintain the specified voltage across the load/dump
;1203          resistor by controlling how much flows through the supplies rather
;1204          than the dump resistor.
;1205 
;1206      - Coming out of SINK mode:
;1207 
;1208         - Treated the same as for the FET/BJT type bridges.
;1209 
;1210 
;1211   ------------------------------------
;1212     The end result?
;1213 
;1214     The only difference is that, for the SCR type bridges, we MUST leave
;1215     the polarity command enabled to avoid disconnecting supplies from the
;1216     bridge and turning off the bridge.  Doing so causes the dump resistor
;1217     to absorb all the power being dumped by the magnet, with no control
;1218     over the current going through it.  While the dump resistors are
;1219     intended to handle this when needed, it should NOT be the normal mode
;1220     of operation as it increases the likelihood of the magnet "quenching".
;1221 
;1222       NOTE:  The polarity commands themselves cannot turn off the SCRs.
;1223              While disabling a polarity command disables the "on" signal
;1224              to the SCRs, the SCR's will continue to conduct if there is
;1225              any appreciable current going through them.  The only reason
;1226              the SCR's DO go off (soon) after the polarity commands are
;1227              disabled is that the circuit is set up to force the BJT's
;1228              off unless a regulation polarity command is asserted that
;1229              agrees with the regulation polarity.
;1230 
;1231 ===========================================================================
;1232     At the end of a SINK period, there is a period where the polarity of
;1233     VCTRL is not stable.  This period is is caused by the following:
;1234 
;1235       There are 2 factors that determine the magnitude and polarity
;1236       of VCTRL:  The voltage across load and dump resistor, and the
;1237       differece between ISET and IFDBK.
;1238 
;1239       As long
;1240 
;1241       Whenever the load voltage reaches one of the set limits, the
;1242       voltage limit portion of the feedback control circuit applies
;1243       an offset to VCTRL in the direction needed to keep the load
;1244       voltage from exceeding the set limits.
;1245 
;1246       If the portion of VCTRL
;1247 
;1248       The current in the magnet has dropped just low enough that the
;1249         voltage across the dump resistor dips below the set limits
;1250 
;1251       - The difference
;1252 
;1253     between ISET and IFDBK
;1254 
;1255 --- When
;1256 
;1257 
;1258 --- Are we starting or ending that period at the end of SINK mode ---
;1259 --- where we have to keep the bridge off to avoid oscillation? ---
;1260 --- This period is a special "crossover" case because the following ---
;1261 --- conditions exist at this time: ---
;1262 
;1263       - The voltage limit we are/were at during SINK mode requires
;1264         the bridge be set for one polarity to allow the bridge to
;1265         divert some of the current flow from the magnet away from
;1266         the dump resistor
;1267 
;1268       - The different between ISET and IFDBK requires the bridge to
;1269         to be set to the opposite polarity to ramp the magnet current
;1270         in the needed direction
;1271 
;1272       - When the load voltage dips below the set limit, the polarity
;1273         of VCTRL (which specifies what polarity we need for the bridge)
;1274         switches to that needed to ramp.  But attempting to ramp using
;1275         the indicated polarity will bump the load voltage back to the
;1276         limit it was just at.  Because the bulk supply's contribution
;1277         to the current through the resistor is so small, the voltage
;1278         limit portion of the control circuit once again overwhelms it
;1279         and causes the polarity of VCTRL switch back.
;1280 
;1281     During this period, the only way to avoid this oscillation in the
;1282     polarity of VCTRL is to wait for the power level in the magent to
;1283     drop to the point where the VLIM portion of the feedback control
;1284     simply reduces the magnitude of VCTRL, rather than causes it to
;1285     change polarity.
;1286 
;1287     SO:  We detect that start of this period by watching the polarity of
;1288     VCTRL.  If it switches while we are at one of the voltage limits,
;1289     then we are at the start of one of these unstable periods.  When the
;1290     voltage drops significantly below the limit, we are no longer in one
;1291     of these unstable periods.
;1292 
;1293 
;1294 ===========================================================================
;1295 
;1296   The feedback control circuit assumes that the polarity of the bridges
;1297   follow what it is trying to do.  If they are backwards from what the
;1298   polarity of the VCTRL signal requires, the result is runaway.  If they ar
;1299   OFF while it is trying to regulate, the result is a large VCTRL that
;1300   will take effect as soon as the bridges are turned on.
;1301 
;1302   Properly controlling the bridges requires you know what state they are in
;1303 
;1304   For the BJT/FET bridges, the state of the BJTs is determined by the VCTRL
;1305   signal, which the controller reads, and the state of the FETs is set by
;1306   the controller.
;1307 
;1308 ---------------------------------------------------------------------------
;1309   Load current vs bulk currents:
;1310 
;1311     The load current measures just what is going through the load (NOT the
;1312     dump resistor in parallel with the load).
;1313 
;1314     The bulk currents measure how much is flowing through each bulk supply.
;1315 
;1316     A voltage across the load means there is a current through the dump
;1317     resistor.
;1318 
;1319     If there is a voltage across the load, then the sum of the currents
;1320     through the bulk supplies will be LARGER than the current through the
;1321     load, because the load current does not include the current through
;1322     the dump resistor.
;1323 
;1324     In fact, the difference between the sum of the bulk supply currents
;1325     and the load current multiplied by the voltage across the load provides
;1326     a ballpark value for how much power the dump resistor is disapating
;1327     (ballpark because the bulk supply currents aren't always well calibrate
;1328     the values are lower resolution and lower sample rate, so the sum of al
;1329     these errors is included in the difference).
;1330 
;1331 
;1332   Characteristics of various modes:
;1333 
;1334     REG+/-
;1335 
;1336        The current through the load (noramlly a superconducting magnet) and
;1337        the bulk supplies is fairly stable.  Because the magnet has almost
;1338        no resistance to a steady current, the voltage across the load is
;1339        nearly zero and VCTRL is at some small, steady value.
;1340 
;1341     RAMP+/-
;1342 
;1343        The ISET output is gradually ramped toward the new setpoint, and
;1344        IFDBK is changing in the same direction.  For an inductive load,
;1345        IFDBK lags behind ISET quite a bit, which is important, as this
;1346        fact is used to detect RAMP and SINK modes.  For RAMP mode, the
;1347        polarity for the bridge (the inverse of VCTRL's polarity) and the
;1348        slope of IFBDK are the same so the bridge is left on so that it can
;1349        actively drive the load in the desired direction.
;1350 
;1351     SINK+/-
;1352 
;1353        Just like RAMP mode, except that the polarity for the bridge is
;1354        opposite the slope of IFDBK.  For the BJT/FET-type bridges, the
;1355        bridge is turned off so the power supplies do not have to
;1356        dissapate some of the power being dumped by the magnet.  For the
;1357        SCR-type bridges, the SCR's will be locked on during SINK mode
;1358        so turning off the bridges is not an option.
;1359 
;1360 
;1361 
;1362 ---------------------------------------------------------------------------
;1363   Misc thoughts:
;1364 
;1365     - What if instead of trying to "ride out" the glitch that happens when 
;1366       FET's are turned back on at the end of SINK mode, we could eliminate
;1367       the cause?  What if, just before turning on the FET's, we set ISET
;1368       equal to IFDBK?  Would that eliminate the glitch?
;1369 
;1370     - Coming out of SINK mode seems to happen at a certain IFDBK voltage.
;1371       Why is that?  Should it be based on the relative difference between
;1372       IFDBK and ISET?  If the setpoint goes from a large value down to one
;1373       that results in an IFDBK value well above 1.25 volts, it still has
;1374       to go into and back out of SINK mode.  Does the glitch still happen
;1375       in such cases?
;1376 
;1377     - Difference between load in SINK mode and supply in SINK mode (?)
;1378       True or false:  The BJT switches polarity when VOUT drops below the
;1379       VLIM_POS/_NEG limits, so the supply then tries to drive the load in
;1380       the correct direction, even though it has some power to dissapate in
;1381       the wrong polarity (?)  So the IFDBK voltage at which this occurs is
;1382       dependant upon the VLIM_XXX settings?
;1383 
;1384 
;1385 ===========================================================================
;1386 
;1387     The combination of ISET and IFDBK provides regulation of the load curre
;1388     while the VLIM value imposes a limit based on the voltage across the lo
;1389     The combined result (VCTRL) is used to bias the BJT's which control the
;1390     combined power output of the bulk supplies.
;1391 
;1392 
;1393     The software's role in the control loop is to monitor the state of the
;1394     load and the BJT's and determine when one side of the bridge should be
;1395     turned on via the positive or negative FET driver.  The VCTRL, IFDBK,
;1396     ISET, and VOUT values provide the needed information.
;1397 
;1398 
;1399     The polarity of the VCTRL signal determines which polarity BJT driver i
;1400     enabled.  This value, and the difference between ISET and IFDBK allow
;1401     the software to determine when the power in the load is decreasing (SIN
;1402     mode) and when power should be increased or maintained (RAMP and REG
;1403     modes).  This works as follows:
;1404 
;1405     - If the difference between ISET and IFDBK exceeds some preset level,
;1406       then the power in the load is changing.
;1407 
;1408       If the BJT polarity is consistent with the direction of change (+ for
;1409       value that is getting more positive, - for a value that is getting mo
;1410       negative), then the power supply is in RAMP mode.  In this mode the
;1411       load voltage (VOUT) is normally at the VLIM_NEG or VLIM_POS limit.
;1412 
;1413       If the BJT polarity is NOT consistent with the direction of change, t
;1414       the supply is in SINK mode.
;1415 
;1416       If there is little difference between ISET and IFDBK, then the supply
;1417       in REGulation mode.  At this point, the voltage across the load (VOUT
;1418       will also be significantly smaller than the VLIM_NEG/VLIM_POS values.
;1419 
;1420     - When the supply is in SINK mode, the dump resistors on the bulk suppl
;1421       are sinking (absorbing) power from the load.
;1422 
;1423 
;1424     When in RAMP or REG mode, the bridge should be turned on and the polari
;1425     of the enabled FET driver normally must match the active BJT driver.
;1426 
;1427     In SINK mode, the FET's are disabled to avoid dumping lots of power
;1428     through the bridge.
;1429 
;1430     When the mode changes from SINK back to RAMP or REG, the appropriate FE
;1431     must be re-enabled.  However, this is where a bit of a problem occurs.
;1432 
;1433     SINK mode ends when the polarity of the active BJT changes.  But when t
;1434     load is reconnected at the end of the SINK mode, VCTRL spikes, causing 
;1435     active BJT to switch back.  If the software attempts to keep the active
;1436     FET in sync with the active BJT at this time, the result is oscillation
;1437 
;1438     To avoid this problem, the changes in the BJT state are ignored for a
;1439     (configurable) period time after coming out of SINK mode.  This avoids
;1440     having the control loop oscillate between SINK and RAMP or REG mode.
;1441     Only a change in polarity of the ISET-IFDBK difference will shorten thi
;1442     period and cause the control loop to resume using the BJT state to trig
;1443     another SINK mode.
;1444 
;1445 --------------------------------------------------------------------------
;1446 NOTES:
;1447 --------------------------------------------------------------------------
;1448 Signals for each of the 10 supplies:
;1449 
;1450 12-Analog Inputs:
;1451 - HOLEC Current
;1452 - Bulk Supply Volt
;1453 
;1454 Digital Inputs:
;1455 - On/Off status
;1456 - Temperature
;1457 - Roll Call Jumper
;1458 
;1459 Digital Outputs:
;1460 - On/Off Command
;1461 
;1462 -------------------------------------------------
;1463 Signals for all supplies:
;1464 
;1465 16-bit Analog Inputs:
;1466 - IFDBK     current through load
;1467 - VOUT      voltage across load
;1468 - VCTRL     output of current regulation feedback-ctl circuit
;1469 - VLIM      scaled/limited load voltage used for feedback-ctl circuit
;1470 
;1471 16-bit Analog Outputs:
;1472 - ISet      setpoint for current feeback-ctl circuit
;1473 - VLimPos   positive limit for VOUT feedback ctl
;1474 - VLimNeg   negative limit for VOUT feedback ctl
;1475 
;1476 Digital Inputs:
;1477 - HOLEC OK
;1478 - External Interlock
;1479 
;1480 Digital Outputs:
;1481 - Activity LED
;1482 
;1483 - Negative Polarity
;1484 - Positive Polarity
;1485 - Negative Polarity LED
;1486 - Positive Polarity LED
;1487 
;1488 ---------------------------------------------------------------------------
;1489 #include <common.h>
;1490 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;1491 #include <unistd.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;1492 #include <sys/types.h>
;1493 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;1494 
;1495 
;1496 #ifndef  ApplicSource
;1497   #define  ApplicSource  "ModularPSAppl.c"
;1498 #endif
;1499 
;1500 #ifndef DidRegDefs
;1501   #define  DidRegDefs
;1502   #include <modbusRegs.c>
	.debug	i 'C:\work\dev\Rabbit_ST\daemons\modbusRegs.c' 29 38 11 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.dseg
_DoReboot_CoilInfo::
	.dw	word _DoReboot
	.db	0
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word _setCoil
	.db	0x2
	.debug	G _DoReboot_CoilInfo 32 0
_dlmVersTime_RegInfo::
	.dw	word _dlmVersTime
	.dw	0
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dlmVersTime_ChgEventVal
	.dw	word _dlmVersTime_MinChg
	.debug	G _dlmVersTime_RegInfo 33 0
_rtosVersTime_RegInfo::
	.dw	word _rtosVersTime
	.dw	0x2
	.dw	word (phys @1+21)
	.dw	phys @1+21 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rtosVersTime_ChgEventVal
	.dw	word _rtosVersTime_MinChg
	.debug	G _rtosVersTime_RegInfo 33 0
_applVersTime_RegInfo::
	.dw	word _applVersTime
	.dw	0x4
	.dw	word (phys @1+34)
	.dw	phys @1+34 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applVersTime_ChgEventVal
	.dw	word _applVersTime_MinChg
	.debug	G _applVersTime_RegInfo 33 0
_devType__RegInfo::
	.dw	word _devType_
	.dw	0x6
	.dw	word (phys @1+47)
	.dw	phys @1+47 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _devType__ChgEventVal
	.dw	word _devType__MinChg
	.debug	G _devType__RegInfo 33 0
_deviceID__RegInfo::
	.dw	word _deviceID_
	.dw	0x7
	.dw	word (phys @1+56)
	.dw	phys @1+56 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _deviceID__ChgEventVal
	.dw	word _deviceID__MinChg
	.debug	G _deviceID__RegInfo 33 0
_upSecs_RegInfo::
	.dw	word _upSecs
	.dw	0x9
	.dw	word (phys @1+66)
	.dw	phys @1+66 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _upSecs_ChgEventVal
	.dw	word _upSecs_MinChg
	.debug	G _upSecs_RegInfo 33 0
_percentIdle__RegInfo::
	.dw	word _percentIdle_
	.dw	0xb
	.dw	word (phys @1+73)
	.dw	phys @1+73 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentIdle__ChgEventVal
	.dw	word _percentIdle__MinChg
	.debug	G _percentIdle__RegInfo 33 0
_numChans_RegInfo::
	.dw	word _numChans
	.dw	0xc
	.dw	word (phys @1+86)
	.dw	phys @1+86 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _numChans_ChgEventVal
	.dw	word _numChans_MinChg
	.debug	G _numChans_RegInfo 33 0
_coilChanMult_RegInfo::
	.dw	word _coilChanMult
	.dw	0xd
	.dw	word (phys @1+95)
	.dw	phys @1+95 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _coilChanMult_ChgEventVal
	.dw	word _coilChanMult_MinChg
	.debug	G _coilChanMult_RegInfo 33 0
_reg3ChanMult_RegInfo::
	.dw	word _reg3ChanMult
	.dw	0xe
	.dw	word (phys @1+108)
	.dw	phys @1+108 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg3ChanMult_ChgEventVal
	.dw	word _reg3ChanMult_MinChg
	.debug	G _reg3ChanMult_RegInfo 33 0
_reg4ChanMult_RegInfo::
	.dw	word _reg4ChanMult
	.dw	0xf
	.dw	word (phys @1+121)
	.dw	phys @1+121 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg4ChanMult_ChgEventVal
	.dw	word _reg4ChanMult_MinChg
	.debug	G _reg4ChanMult_RegInfo 33 0
_digInBits_RegInfo::
	.dw	word _digInBits
	.dw	0x10
	.dw	word (phys @1+134)
	.dw	phys @1+134 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _digInBits_ChgEventVal
	.dw	word _digInBits_MinChg
	.debug	G _digInBits_RegInfo 33 0
_statusBitsStdA_RegInfo::
	.dw	word _statusBitsStdA
	.dw	0x12
	.dw	word (phys @1+144)
	.dw	phys @1+144 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdA_ChgEventVal
	.dw	word _statusBitsStdA_MinChg
	.debug	G _statusBitsStdA_RegInfo 33 0
_statusBitsStdB_RegInfo::
	.dw	word _statusBitsStdB
	.dw	0x13
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdB_ChgEventVal
	.dw	word _statusBitsStdB_MinChg
	.debug	G _statusBitsStdB_RegInfo 33 0
_statusBitsAppl_RegInfo::
	.dw	word _statusBitsAppl
	.dw	0x14
	.dw	word (phys @1+174)
	.dw	phys @1+174 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAppl_ChgEventVal
	.dw	word _statusBitsAppl_MinChg
	.debug	G _statusBitsAppl_RegInfo 33 0
_bsv_1_RegInfo::
	.dw	word _bsv_1
	.dw	0x16
	.dw	word (phys @1+189)
	.dw	phys @1+189 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_1_ChgEventVal
	.dw	word _bsv_1_MinChg
	.debug	G _bsv_1_RegInfo 33 0
_bsv_2_RegInfo::
	.dw	word _bsv_2
	.dw	0x18
	.dw	word (phys @1+195)
	.dw	phys @1+195 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_2_ChgEventVal
	.dw	word _bsv_2_MinChg
	.debug	G _bsv_2_RegInfo 33 0
_bsv_3_RegInfo::
	.dw	word _bsv_3
	.dw	0x1a
	.dw	word (phys @1+201)
	.dw	phys @1+201 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_3_ChgEventVal
	.dw	word _bsv_3_MinChg
	.debug	G _bsv_3_RegInfo 33 0
_bsv_4_RegInfo::
	.dw	word _bsv_4
	.dw	0x1c
	.dw	word (phys @1+207)
	.dw	phys @1+207 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_4_ChgEventVal
	.dw	word _bsv_4_MinChg
	.debug	G _bsv_4_RegInfo 33 0
_bsv_5_RegInfo::
	.dw	word _bsv_5
	.dw	0x1e
	.dw	word (phys @1+213)
	.dw	phys @1+213 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_5_ChgEventVal
	.dw	word _bsv_5_MinChg
	.debug	G _bsv_5_RegInfo 33 0
_bsv_6_RegInfo::
	.dw	word _bsv_6
	.dw	0x20
	.dw	word (phys @1+219)
	.dw	phys @1+219 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_6_ChgEventVal
	.dw	word _bsv_6_MinChg
	.debug	G _bsv_6_RegInfo 33 0
_bsv_7_RegInfo::
	.dw	word _bsv_7
	.dw	0x22
	.dw	word (phys @1+225)
	.dw	phys @1+225 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_7_ChgEventVal
	.dw	word _bsv_7_MinChg
	.debug	G _bsv_7_RegInfo 33 0
_bsv_8_RegInfo::
	.dw	word _bsv_8
	.dw	0x24
	.dw	word (phys @1+231)
	.dw	phys @1+231 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_8_ChgEventVal
	.dw	word _bsv_8_MinChg
	.debug	G _bsv_8_RegInfo 33 0
_bsv_9_RegInfo::
	.dw	word _bsv_9
	.dw	0x26
	.dw	word (phys @1+237)
	.dw	phys @1+237 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_9_ChgEventVal
	.dw	word _bsv_9_MinChg
	.debug	G _bsv_9_RegInfo 33 0
_bsv_10_RegInfo::
	.dw	word _bsv_10
	.dw	0x28
	.dw	word (phys @1+243)
	.dw	phys @1+243 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bsv_10_ChgEventVal
	.dw	word _bsv_10_MinChg
	.debug	G _bsv_10_RegInfo 33 0
_amps_1_RegInfo::
	.dw	word _amps_1
	.dw	0x2a
	.dw	word (phys @1+250)
	.dw	phys @1+250 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_1_ChgEventVal
	.dw	word _amps_1_MinChg
	.debug	G _amps_1_RegInfo 33 0
_amps_2_RegInfo::
	.dw	word _amps_2
	.dw	0x2c
	.dw	word (phys @1+257)
	.dw	phys @1+257 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_2_ChgEventVal
	.dw	word _amps_2_MinChg
	.debug	G _amps_2_RegInfo 33 0
_amps_3_RegInfo::
	.dw	word _amps_3
	.dw	0x2e
	.dw	word (phys @1+264)
	.dw	phys @1+264 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_3_ChgEventVal
	.dw	word _amps_3_MinChg
	.debug	G _amps_3_RegInfo 33 0
_amps_4_RegInfo::
	.dw	word _amps_4
	.dw	0x30
	.dw	word (phys @1+271)
	.dw	phys @1+271 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_4_ChgEventVal
	.dw	word _amps_4_MinChg
	.debug	G _amps_4_RegInfo 33 0
_amps_5_RegInfo::
	.dw	word _amps_5
	.dw	0x32
	.dw	word (phys @1+278)
	.dw	phys @1+278 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_5_ChgEventVal
	.dw	word _amps_5_MinChg
	.debug	G _amps_5_RegInfo 33 0
_amps_6_RegInfo::
	.dw	word _amps_6
	.dw	0x34
	.dw	word (phys @1+285)
	.dw	phys @1+285 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_6_ChgEventVal
	.dw	word _amps_6_MinChg
	.debug	G _amps_6_RegInfo 33 0
_amps_7_RegInfo::
	.dw	word _amps_7
	.dw	0x36
	.dw	word (phys @1+292)
	.dw	phys @1+292 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_7_ChgEventVal
	.dw	word _amps_7_MinChg
	.debug	G _amps_7_RegInfo 33 0
_amps_8_RegInfo::
	.dw	word _amps_8
	.dw	0x38
	.dw	word (phys @1+299)
	.dw	phys @1+299 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_8_ChgEventVal
	.dw	word _amps_8_MinChg
	.debug	G _amps_8_RegInfo 33 0
_amps_9_RegInfo::
	.dw	word _amps_9
	.dw	0x3a
	.dw	word (phys @1+306)
	.dw	phys @1+306 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_9_ChgEventVal
	.dw	word _amps_9_MinChg
	.debug	G _amps_9_RegInfo 33 0
_amps_10_RegInfo::
	.dw	word _amps_10
	.dw	0x3c
	.dw	word (phys @1+313)
	.dw	phys @1+313 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _amps_10_ChgEventVal
	.dw	word _amps_10_MinChg
	.debug	G _amps_10_RegInfo 33 0
_ampRead_RegInfo::
	.dw	word _ampRead
	.dw	0x3e
	.dw	word (phys @1+321)
	.dw	phys @1+321 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _ampRead_ChgEventVal
	.dw	word _ampRead_MinChg
	.debug	G _ampRead_RegInfo 33 0
_voltRead_RegInfo::
	.dw	word _voltRead
	.dw	0x40
	.dw	word (phys @1+329)
	.dw	phys @1+329 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _voltRead_ChgEventVal
	.dw	word _voltRead_MinChg
	.debug	G _voltRead_RegInfo 33 0
_vctrl_RegInfo::
	.dw	word _vctrl
	.dw	0x42
	.dw	word (phys @1+338)
	.dw	phys @1+338 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _vctrl_ChgEventVal
	.dw	word _vctrl_MinChg
	.debug	G _vctrl_RegInfo 33 0
_bjtBias_RegInfo::
	.dw	word _bjtBias
	.dw	0x44
	.dw	word (phys @1+344)
	.dw	phys @1+344 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _bjtBias_ChgEventVal
	.dw	word _bjtBias_MinChg
	.debug	G _bjtBias_RegInfo 33 0
_state_1_RegInfo::
	.dw	word _state_1
	.dw	0x46
	.dw	word (phys @1+352)
	.dw	phys @1+352 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_1_ChgEventVal
	.dw	word _state_1_MinChg
	.debug	G _state_1_RegInfo 33 0
_state_2_RegInfo::
	.dw	word _state_2
	.dw	0x47
	.dw	word (phys @1+360)
	.dw	phys @1+360 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_2_ChgEventVal
	.dw	word _state_2_MinChg
	.debug	G _state_2_RegInfo 33 0
_state_3_RegInfo::
	.dw	word _state_3
	.dw	0x48
	.dw	word (phys @1+368)
	.dw	phys @1+368 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_3_ChgEventVal
	.dw	word _state_3_MinChg
	.debug	G _state_3_RegInfo 33 0
_state_4_RegInfo::
	.dw	word _state_4
	.dw	0x49
	.dw	word (phys @1+376)
	.dw	phys @1+376 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_4_ChgEventVal
	.dw	word _state_4_MinChg
	.debug	G _state_4_RegInfo 33 0
_state_5_RegInfo::
	.dw	word _state_5
	.dw	0x4a
	.dw	word (phys @1+384)
	.dw	phys @1+384 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_5_ChgEventVal
	.dw	word _state_5_MinChg
	.debug	G _state_5_RegInfo 33 0
_state_6_RegInfo::
	.dw	word _state_6
	.dw	0x4b
	.dw	word (phys @1+392)
	.dw	phys @1+392 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_6_ChgEventVal
	.dw	word _state_6_MinChg
	.debug	G _state_6_RegInfo 33 0
_state_7_RegInfo::
	.dw	word _state_7
	.dw	0x4c
	.dw	word (phys @1+400)
	.dw	phys @1+400 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_7_ChgEventVal
	.dw	word _state_7_MinChg
	.debug	G _state_7_RegInfo 33 0
_state_8_RegInfo::
	.dw	word _state_8
	.dw	0x4d
	.dw	word (phys @1+408)
	.dw	phys @1+408 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_8_ChgEventVal
	.dw	word _state_8_MinChg
	.debug	G _state_8_RegInfo 33 0
_state_9_RegInfo::
	.dw	word _state_9
	.dw	0x4e
	.dw	word (phys @1+416)
	.dw	phys @1+416 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_9_ChgEventVal
	.dw	word _state_9_MinChg
	.debug	G _state_9_RegInfo 33 0
_state_10_RegInfo::
	.dw	word _state_10
	.dw	0x4f
	.dw	word (phys @1+424)
	.dw	phys @1+424 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_10_ChgEventVal
	.dw	word _state_10_MinChg
	.debug	G _state_10_RegInfo 33 0
_outMode_RegInfo::
	.dw	word _outMode
	.dw	0x50
	.dw	word (phys @1+433)
	.dw	phys @1+433 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _outMode_ChgEventVal
	.dw	word _outMode_MinChg
	.debug	G _outMode_RegInfo 33 0
_ampApply_RegInfo::
	.dw	word _ampApply
	.dw	0x51
	.dw	word (phys @1+441)
	.dw	phys @1+441 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _ampApply_ChgEventVal
	.dw	word _ampApply_MinChg
	.debug	G _ampApply_RegInfo 33 0
_psCount_RegInfo::
	.dw	word _psCount
	.dw	0x53
	.dw	word (phys @1+450)
	.dw	phys @1+450 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _psCount_ChgEventVal
	.dw	word _psCount_MinChg
	.debug	G _psCount_RegInfo 33 0
_state_RegInfo::
	.dw	word _state
	.dw	0x54
	.dw	word (phys @1+458)
	.dw	phys @1+458 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _state_ChgEventVal
	.dw	word _state_MinChg
	.debug	G _state_RegInfo 33 0
_iset_RegInfo::
	.dw	word _iset
	.dw	0x55
	.dw	word (phys @1+464)
	.dw	phys @1+464 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _iset_ChgEventVal
	.dw	word _iset_MinChg
	.debug	G _iset_RegInfo 33 0
_ifdbk_RegInfo::
	.dw	word _ifdbk
	.dw	0x57
	.dw	word (phys @1+469)
	.dw	phys @1+469 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _ifdbk_ChgEventVal
	.dw	word _ifdbk_MinChg
	.debug	G _ifdbk_RegInfo 33 0
_vout_RegInfo::
	.dw	word _vout
	.dw	0x59
	.dw	word (phys @1+475)
	.dw	phys @1+475 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _vout_ChgEventVal
	.dw	word _vout_MinChg
	.debug	G _vout_RegInfo 33 0
_polCmd_RegInfo::
	.dw	word _polCmd
	.dw	0x5b
	.dw	word (phys @1+480)
	.dw	phys @1+480 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _polCmd_ChgEventVal
	.dw	word _polCmd_MinChg
	.debug	G _polCmd_RegInfo 33 0
_vctrlStatus_RegInfo::
	.dw	word _vctrlStatus
	.dw	0x5c
	.dw	word (phys @1+487)
	.dw	phys @1+487 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _vctrlStatus_ChgEventVal
	.dw	word _vctrlStatus_MinChg
	.debug	G _vctrlStatus_RegInfo 33 0
_ampErr_RegInfo::
	.dw	word _ampErr
	.dw	0x5d
	.dw	word (phys @1+499)
	.dw	phys @1+499 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _ampErr_ChgEventVal
	.dw	word _ampErr_MinChg
	.debug	G _ampErr_RegInfo 33 0
_ttlBulkCur_RegInfo::
	.dw	word _ttlBulkCur
	.dw	0x5f
	.dw	word (phys @1+506)
	.dw	phys @1+506 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _ttlBulkCur_ChgEventVal
	.dw	word _ttlBulkCur_MinChg
	.debug	G _ttlBulkCur_RegInfo 33 0
_unused2_RegInfo::
	.dw	word _unused2
	.dw	0x61
	.dw	word (phys @1+517)
	.dw	phys @1+517 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused2_ChgEventVal
	.dw	word _unused2_MinChg
	.debug	G _unused2_RegInfo 33 0
_latency_RegInfo::
	.dw	word _latency
	.dw	0x63
	.dw	word (phys @1+525)
	.dw	phys @1+525 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _latency_ChgEventVal
	.dw	word _latency_MinChg
	.debug	G _latency_RegInfo 33 0
_tcpTickTime_RegInfo::
	.dw	word _tcpTickTime
	.dw	0x64
	.dw	word (phys @1+533)
	.dw	phys @1+533 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _tcpTickTime_ChgEventVal
	.dw	word _tcpTickTime_MinChg
	.debug	G _tcpTickTime_RegInfo 33 0
_applLoopTime_RegInfo::
	.dw	word _applLoopTime
	.dw	0x65
	.dw	word (phys @1+545)
	.dw	phys @1+545 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applLoopTime_ChgEventVal
	.dw	word _applLoopTime_MinChg
	.debug	G _applLoopTime_RegInfo 33 0
_kernelLoopTime_RegInfo::
	.dw	word _kernelLoopTime
	.dw	0x66
	.dw	word (phys @1+558)
	.dw	phys @1+558 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _kernelLoopTime_ChgEventVal
	.dw	word _kernelLoopTime_MinChg
	.debug	G _kernelLoopTime_RegInfo 33 0
_loadRes_RegInfo::
	.dw	word _loadRes
	.dw	0x67
	.dw	word (phys @1+573)
	.dw	phys @1+573 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _loadRes_ChgEventVal
	.dw	word _loadRes_MinChg
	.debug	G _loadRes_RegInfo 33 0
_dumpRes_RegInfo::
	.dw	word _dumpRes
	.dw	0x69
	.dw	word (phys @1+581)
	.dw	phys @1+581 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dumpRes_ChgEventVal
	.dw	word _dumpRes_MinChg
	.debug	G _dumpRes_RegInfo 33 0
	.defseg	CONST
	.seg	CONST
_OutModeDesc::
	.dw	@2
	.dw	@2+6
	.dw	@2+12
	.dw	@2+18
	.dw	@2+24
	.dw	@2+30
	.dw	@2+36
	.dw	@2+42
	.dw	@2+48
	.dw	@2+54
	.debug	G _OutModeDesc 34 0
	.dseg
_timeZone__RegInfo::
	.dw	word _timeZone_
	.dw	0
	.dw	word (phys @1+589)
	.dw	phys @1+589 >> 16
	.dw	word _MB_timeZone
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _timeZone__ChgEventVal
	.dw	word _timeZone__MinChg
	.debug	G _timeZone__RegInfo 33 0
_curTime_RegInfo::
	.dw	word _curTime
	.dw	0x1
	.dw	word (phys @1+599)
	.dw	phys @1+599 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _curTime_ChgEventVal
	.dw	word _curTime_MinChg
	.debug	G _curTime_RegInfo 33 0
_ipAddr_RegInfo::
	.dw	word _ipAddr
	.dw	0x3
	.dw	word (phys @1+607)
	.dw	phys @1+607 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ipAddr_ChgEventVal
	.dw	word _ipAddr_MinChg
	.debug	G _ipAddr_RegInfo 33 0
_netmask_RegInfo::
	.dw	word _netmask
	.dw	0x5
	.dw	word (phys @1+614)
	.dw	phys @1+614 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _netmask_ChgEventVal
	.dw	word _netmask_MinChg
	.debug	G _netmask_RegInfo 33 0
_gateway_RegInfo::
	.dw	word _gateway
	.dw	0x7
	.dw	word (phys @1+622)
	.dw	phys @1+622 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _gateway_ChgEventVal
	.dw	word _gateway_MinChg
	.debug	G _gateway_RegInfo 33 0
_setACoil_RegInfo::
	.dw	word _setACoil
	.dw	0x9
	.dw	word (phys @1+630)
	.dw	phys @1+630 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _setACoil_ChgEventVal
	.dw	word _setACoil_MinChg
	.debug	G _setACoil_RegInfo 33 0
_resetACoil_RegInfo::
	.dw	word _resetACoil
	.dw	0xa
	.dw	word (phys @1+639)
	.dw	phys @1+639 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _resetACoil_ChgEventVal
	.dw	word _resetACoil_MinChg
	.debug	G _resetACoil_RegInfo 33 0
_digOutBits_RegInfo::
	.dw	word _digOutBits
	.dw	0xb
	.dw	word (phys @1+650)
	.dw	phys @1+650 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _digOutBits_ChgEventVal
	.dw	word _digOutBits_MinChg
	.debug	G _digOutBits_RegInfo 33 0
_cmdBitsStd_RegInfo::
	.dw	word _cmdBitsStd
	.dw	0xd
	.dw	word (phys @1+661)
	.dw	phys @1+661 >> 16
	.dw	word _MB_cmdBitsStd
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsStd_ChgEventVal
	.dw	word _cmdBitsStd_MinChg
	.debug	G _cmdBitsStd_RegInfo 33 0
_cmdBitsAppl_RegInfo::
	.dw	word _cmdBitsAppl
	.dw	0xf
	.dw	word (phys @1+672)
	.dw	phys @1+672 >> 16
	.dw	word _MB_cmdBitsAppl
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl_ChgEventVal
	.dw	word _cmdBitsAppl_MinChg
	.debug	G _cmdBitsAppl_RegInfo 33 0
_ampSet_RegInfo::
	.dw	word _ampSet
	.dw	0x11
	.dw	word (phys @1+684)
	.dw	phys @1+684 >> 16
	.dw	word _MB_ampSet
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ampSet_ChgEventVal
	.dw	word _ampSet_MinChg
	.debug	G _ampSet_RegInfo 33 0
_vlimPlus_RegInfo::
	.dw	word _vlimPlus
	.dw	0x13
	.dw	word (phys @1+691)
	.dw	phys @1+691 >> 16
	.dw	word _MB_vlimPlus
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _vlimPlus_ChgEventVal
	.dw	word _vlimPlus_MinChg
	.debug	G _vlimPlus_RegInfo 33 0
_vlimMinus_RegInfo::
	.dw	word _vlimMinus
	.dw	0x15
	.dw	word (phys @1+700)
	.dw	phys @1+700 >> 16
	.dw	word _MB_vlimMinus
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _vlimMinus_ChgEventVal
	.dw	word _vlimMinus_MinChg
	.debug	G _vlimMinus_RegInfo 33 0
_rampRate_RegInfo::
	.dw	word _rampRate
	.dw	0x17
	.dw	word (phys @1+710)
	.dw	phys @1+710 >> 16
	.dw	word _MB_rampRate
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rampRate_ChgEventVal
	.dw	word _rampRate_MinChg
	.debug	G _rampRate_RegInfo 33 0
_vctrlHyst_RegInfo::
	.dw	word _vctrlHyst
	.dw	0x19
	.dw	word (phys @1+719)
	.dw	phys @1+719 >> 16
	.dw	word _MB_vctrlHyst
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _vctrlHyst_ChgEventVal
	.dw	word _vctrlHyst_MinChg
	.debug	G _vctrlHyst_RegInfo 33 0
_minPolStableTime_RegInfo::
	.dw	word _minPolStableTime
	.dw	0x1b
	.dw	word (phys @1+729)
	.dw	phys @1+729 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _minPolStableTime_ChgEventVal
	.dw	word _minPolStableTime_MinChg
	.debug	G _minPolStableTime_RegInfo 33 0
_unused1_RegInfo::
	.dw	word _unused1
	.dw	0x1c
	.dw	word (phys @1+746)
	.dw	phys @1+746 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused1_ChgEventVal
	.dw	word _unused1_MinChg
	.debug	G _unused1_RegInfo 33 0
_minBSVolts_RegInfo::
	.dw	word _minBSVolts
	.dw	0x1d
	.dw	word (phys @1+754)
	.dw	phys @1+754 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _minBSVolts_ChgEventVal
	.dw	word _minBSVolts_MinChg
	.debug	G _minBSVolts_RegInfo 33 0
_maxBSFracCurDiff_RegInfo::
	.dw	word _maxBSFracCurDiff
	.dw	0x1f
	.dw	word (phys @1+765)
	.dw	phys @1+765 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxBSFracCurDiff_ChgEventVal
	.dw	word _maxBSFracCurDiff_MinChg
	.debug	G _maxBSFracCurDiff_RegInfo 33 0
_vlimReduction_RegInfo::
	.dw	word _vlimReduction
	.dw	0x21
	.dw	word (phys @1+782)
	.dw	phys @1+782 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _vlimReduction_ChgEventVal
	.dw	word _vlimReduction_MinChg
	.debug	G _vlimReduction_RegInfo 33 0
_sinkEndAmps_RegInfo::
	.dw	word _sinkEndAmps
	.dw	0x23
	.dw	word (phys @1+796)
	.dw	phys @1+796 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _sinkEndAmps_ChgEventVal
	.dw	word _sinkEndAmps_MinChg
	.debug	G _sinkEndAmps_RegInfo 33 0
_unused3_RegInfo::
	.dw	word _unused3
	.dw	0x25
	.dw	word (phys @1+808)
	.dw	phys @1+808 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused3_ChgEventVal
	.dw	word _unused3_MinChg
	.debug	G _unused3_RegInfo 33 0
_knobSelectRate_RegInfo::
	.dw	word _knobSelectRate
	.dw	0x27
	.dw	word (phys @1+816)
	.dw	phys @1+816 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _knobSelectRate_ChgEventVal
	.dw	word _knobSelectRate_MinChg
	.debug	G _knobSelectRate_RegInfo 33 0
_maxAmpSet_RegInfo::
	.dw	word _maxAmpSet
	.dw	0x28
	.dw	word (phys @1+831)
	.dw	phys @1+831 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxAmpSet_ChgEventVal
	.dw	word _maxAmpSet_MinChg
	.debug	G _maxAmpSet_RegInfo 33 0
_minPSonTime_RegInfo::
	.dw	word _minPSonTime
	.dw	0x2a
	.dw	word (phys @1+841)
	.dw	phys @1+841 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _minPSonTime_ChgEventVal
	.dw	word _minPSonTime_MinChg
	.debug	G _minPSonTime_RegInfo 33 0
_minBridgeOffTime_RegInfo::
	.dw	word _minBridgeOffTime
	.dw	0x2b
	.dw	word (phys @1+853)
	.dw	phys @1+853 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _minBridgeOffTime_ChgEventVal
	.dw	word _minBridgeOffTime_MinChg
	.debug	G _minBridgeOffTime_RegInfo 33 0
_unused4_RegInfo::
	.dw	word _unused4
	.dw	0x2c
	.dw	word (phys @1+870)
	.dw	phys @1+870 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused4_ChgEventVal
	.dw	word _unused4_MinChg
	.debug	G _unused4_RegInfo 33 0
_unused5_RegInfo::
	.dw	word _unused5
	.dw	0x2d
	.dw	word (phys @1+878)
	.dw	phys @1+878 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused5_ChgEventVal
	.dw	word _unused5_MinChg
	.debug	G _unused5_RegInfo 33 0
_maxErrTime_RegInfo::
	.dw	word _maxErrTime
	.dw	0x2f
	.dw	word (phys @1+886)
	.dw	phys @1+886 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxErrTime_ChgEventVal
	.dw	word _maxErrTime_MinChg
	.debug	G _maxErrTime_RegInfo 33 0
_contrast_RegInfo::
	.dw	word _contrast
	.dw	0x30
	.dw	word (phys @1+897)
	.dw	phys @1+897 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _contrast_ChgEventVal
	.dw	word _contrast_MinChg
	.debug	G _contrast_RegInfo 33 0
_bulkShortCur_RegInfo::
	.dw	word _bulkShortCur
	.dw	0x31
	.dw	word (phys @1+906)
	.dw	phys @1+906 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _bulkShortCur_ChgEventVal
	.dw	word _bulkShortCur_MinChg
	.debug	G _bulkShortCur_RegInfo 33 0
_supplyType_RegInfo::
	.dw	word _supplyType
	.dw	0x33
	.dw	word (phys @1+919)
	.dw	phys @1+919 >> 16
	.dw	word _MB_supplyType
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _supplyType_ChgEventVal
	.dw	word _supplyType_MinChg
	.debug	G _supplyType_RegInfo 33 0
_loadType_RegInfo::
	.dw	word _loadType
	.dw	0x34
	.dw	word (phys @1+930)
	.dw	phys @1+930 >> 16
	.dw	word _MB_loadType
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _loadType_ChgEventVal
	.dw	word _loadType_MinChg
	.debug	G _loadType_RegInfo 33 0
_debounceMS_RegInfo::
	.dw	word _debounceMS
	.dw	0x35
	.dw	word (phys @1+939)
	.dw	phys @1+939 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _debounceMS_ChgEventVal
	.dw	word _debounceMS_MinChg
	.debug	G _debounceMS_RegInfo 33 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_c0Coils::
	.dw	word _DoReboot_CoilInfo
	.dw	0
	.debug	G _c0Coils 36 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r3Regs::
	.dw	word _dlmVersTime_RegInfo
	.dw	word _dlmVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _devType__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _percentIdle__RegInfo
	.dw	word _numChans_RegInfo
	.dw	word _coilChanMult_RegInfo
	.dw	word _reg3ChanMult_RegInfo
	.dw	word _reg4ChanMult_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _statusBitsStdA_RegInfo
	.dw	word _statusBitsStdB_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _bsv_1_RegInfo
	.dw	word _bsv_1_RegInfo
	.dw	word _bsv_2_RegInfo
	.dw	word _bsv_2_RegInfo
	.dw	word _bsv_3_RegInfo
	.dw	word _bsv_3_RegInfo
	.dw	word _bsv_4_RegInfo
	.dw	word _bsv_4_RegInfo
	.dw	word _bsv_5_RegInfo
	.dw	word _bsv_5_RegInfo
	.dw	word _bsv_6_RegInfo
	.dw	word _bsv_6_RegInfo
	.dw	word _bsv_7_RegInfo
	.dw	word _bsv_7_RegInfo
	.dw	word _bsv_8_RegInfo
	.dw	word _bsv_8_RegInfo
	.dw	word _bsv_9_RegInfo
	.dw	word _bsv_9_RegInfo
	.dw	word _bsv_10_RegInfo
	.dw	word _bsv_10_RegInfo
	.dw	word _amps_1_RegInfo
	.dw	word _amps_1_RegInfo
	.dw	word _amps_2_RegInfo
	.dw	word _amps_2_RegInfo
	.dw	word _amps_3_RegInfo
	.dw	word _amps_3_RegInfo
	.dw	word _amps_4_RegInfo
	.dw	word _amps_4_RegInfo
	.dw	word _amps_5_RegInfo
	.dw	word _amps_5_RegInfo
	.dw	word _amps_6_RegInfo
	.dw	word _amps_6_RegInfo
	.dw	word _amps_7_RegInfo
	.dw	word _amps_7_RegInfo
	.dw	word _amps_8_RegInfo
	.dw	word _amps_8_RegInfo
	.dw	word _amps_9_RegInfo
	.dw	word _amps_9_RegInfo
	.dw	word _amps_10_RegInfo
	.dw	word _amps_10_RegInfo
	.dw	word _ampRead_RegInfo
	.dw	word _ampRead_RegInfo
	.dw	word _voltRead_RegInfo
	.dw	word _voltRead_RegInfo
	.dw	word _vctrl_RegInfo
	.dw	word _vctrl_RegInfo
	.dw	word _bjtBias_RegInfo
	.dw	word _bjtBias_RegInfo
	.dw	word _state_1_RegInfo
	.dw	word _state_2_RegInfo
	.dw	word _state_3_RegInfo
	.dw	word _state_4_RegInfo
	.dw	word _state_5_RegInfo
	.dw	word _state_6_RegInfo
	.dw	word _state_7_RegInfo
	.dw	word _state_8_RegInfo
	.dw	word _state_9_RegInfo
	.dw	word _state_10_RegInfo
	.dw	word _outMode_RegInfo
	.dw	word _ampApply_RegInfo
	.dw	word _ampApply_RegInfo
	.dw	word _psCount_RegInfo
	.dw	word _state_RegInfo
	.dw	word _iset_RegInfo
	.dw	word _iset_RegInfo
	.dw	word _ifdbk_RegInfo
	.dw	word _ifdbk_RegInfo
	.dw	word _vout_RegInfo
	.dw	word _vout_RegInfo
	.dw	word _polCmd_RegInfo
	.dw	word _vctrlStatus_RegInfo
	.dw	word _ampErr_RegInfo
	.dw	word _ampErr_RegInfo
	.dw	word _ttlBulkCur_RegInfo
	.dw	word _ttlBulkCur_RegInfo
	.dw	word _unused2_RegInfo
	.dw	word _unused2_RegInfo
	.dw	word _latency_RegInfo
	.dw	word _tcpTickTime_RegInfo
	.dw	word _applLoopTime_RegInfo
	.dw	word _kernelLoopTime_RegInfo
	.dw	word _loadRes_RegInfo
	.dw	word _loadRes_RegInfo
	.dw	word _dumpRes_RegInfo
	.dw	word _dumpRes_RegInfo
	.dw	0
	.debug	G _r3Regs 38 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r4Regs::
	.dw	word _timeZone__RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _setACoil_RegInfo
	.dw	word _resetACoil_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _ampSet_RegInfo
	.dw	word _ampSet_RegInfo
	.dw	word _vlimPlus_RegInfo
	.dw	word _vlimPlus_RegInfo
	.dw	word _vlimMinus_RegInfo
	.dw	word _vlimMinus_RegInfo
	.dw	word _rampRate_RegInfo
	.dw	word _rampRate_RegInfo
	.dw	word _vctrlHyst_RegInfo
	.dw	word _vctrlHyst_RegInfo
	.dw	word _minPolStableTime_RegInfo
	.dw	word _unused1_RegInfo
	.dw	word _minBSVolts_RegInfo
	.dw	word _minBSVolts_RegInfo
	.dw	word _maxBSFracCurDiff_RegInfo
	.dw	word _maxBSFracCurDiff_RegInfo
	.dw	word _vlimReduction_RegInfo
	.dw	word _vlimReduction_RegInfo
	.dw	word _sinkEndAmps_RegInfo
	.dw	word _sinkEndAmps_RegInfo
	.dw	word _unused3_RegInfo
	.dw	word _unused3_RegInfo
	.dw	word _knobSelectRate_RegInfo
	.dw	word _maxAmpSet_RegInfo
	.dw	word _maxAmpSet_RegInfo
	.dw	word _minPSonTime_RegInfo
	.dw	word _minBridgeOffTime_RegInfo
	.dw	word _unused4_RegInfo
	.dw	word _unused5_RegInfo
	.dw	word _unused5_RegInfo
	.dw	word _maxErrTime_RegInfo
	.dw	word _contrast_RegInfo
	.dw	word _bulkShortCur_RegInfo
	.dw	word _bulkShortCur_RegInfo
	.dw	word _supplyType_RegInfo
	.dw	word _loadType_RegInfo
	.dw	word _debounceMS_RegInfo
	.dw	0
	.debug	G _r4Regs 40 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_nonRegPVs::
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
	.db	0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.debug	G _nonRegPVs 41 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ModularPS\ModularPSAppl.c' 27 17 9 14 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;1503 #endif
;1504 #ifndef RegDefs
;1505 
;1506 
;1507 //APPLCODE - change to the application name
;1508 const char far applName[] = { "ModularPS" };
	.defseg	FARCONST
	.seg	FARCONST
_applName::
	.db	"ModularPS",0
	.debug	G _applName 43 8
;1509 const char ApplAbbrev[] = { "ModPS" };
	.seg	CONST
_ApplAbbrev::
	.db	"ModPS",0
	.debug	G _ApplAbbrev 44 0
;1510 
;1511 //APPLCODE - add ID to unistd.h and place it here
;1512 #define DeviceType  DT_ModularPS
;1513 
;1514 //APPLCODE - set the # of input and outputs used
;1515 #define  NUM_APPL_AIN     26   // analog inputs
;1516 #define  NUM_APPL_AOUT     3   // analog outputs
;1517 #define  NUM_APPL_DIN     32   // digital inputs
;1518 #define  NUM_APPL_DOUT    16   // digital outputs
;1519 
;1520 #define  ADC_MASK_APPL  0x03FFFFFFL
;1521 #define  DAC_MASK_APPL  0x00000007L
;1522 
;1523 //APPLCODE - set to state we want outputs in during initialization
;1524 #define InitialDigOutState  ( 0x0000 )
;1525 
;1526 
;1527 #define SharedINC
;1528 #include <sharedAppl.c>
;1529 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.dseg
_consCfg::
	.dw	0xffffc200, 0x1
	.dw	0x1
	.debug	G _consCfg 45 0
	.seg	CONST
_NumApplAIN::
	.dw	0x1a
	.debug	G _NumApplAIN 7 0
_NumApplAOUT::
	.dw	0x3
	.debug	G _NumApplAOUT 7 0
_NumApplDIN::
	.dw	0x20
	.debug	G _NumApplDIN 7 0
_NumApplDOUT::
	.dw	0x10
	.debug	G _NumApplDOUT 7 0
_NumExtraIn::
	.dw	0x20
	.debug	G _NumExtraIn 7 0
;1530 
;1531 #define  NumPS  10  // # of Bulk Power Supplies supported
;1532 
;1533 
;1534 
;1535 //=========================================================================
;1536 //  definitions related to use of the Digital and Analog I/O signals
;1537 //=========================================================================
;1538 
;1539 //=============== digitalIn bit usage ===============
;1540 #define  PS5_IS_ON       0x00000001    // DI-00
;1541 #define  PS5_AVAIL       0x00000002    // DI-01
;1542 #define  PS5_TEMP_OK     0x00000004    // DI-02
;1543 
;1544 #define  PS10_IS_ON      0x00000008    // DI-03
;1545 #define  PS10_AVAIL      0x00000010    // DI-04
;1546 #define  PS10_TEMP_OK    0x00000020    // DI-05
;1547 
;1548 #define  PS4_IS_ON       0x00000040    // DI-06
;1549 #define  PS4_AVAIL       0x00000080    // DI-07
;1550 #define  PS4_TEMP_OK     0x00000100    // DI-08
;1551 
;1552 #define  PS9_IS_ON       0x00000200    // DI-09
;1553 #define  PS9_AVAIL       0x00000400    // DI-10
;1554 #define  PS9_TEMP_OK     0x00000800    // DI-11
;1555 
;1556 #define  PS3_IS_ON       0x00001000    // DI-12
;1557 #define  PS3_AVAIL       0x00002000    // DI-13
;1558 #define  PS3_TEMP_OK     0x00004000    // DI-14
;1559 
;1560 #define  PS8_IS_ON       0x00008000    // DI-15
;1561 #define  PS8_AVAIL       0x00010000L   // DI-16
;1562 #define  PS8_TEMP_OK     0x00020000L   // DI-17
;1563 
;1564 #define  PS2_IS_ON       0x00040000L   // DI-18
;1565 #define  PS2_AVAIL       0x00080000L   // DI-19
;1566 #define  PS2_TEMP_OK     0x00100000L   // DI-20
;1567 
;1568 #define  PS7_IS_ON       0x00200000L   // DI-21
;1569 #define  PS7_AVAIL       0x00400000L   // DI-22
;1570 #define  PS7_TEMP_OK     0x00800000L   // DI-23
;1571 
;1572 #define  PS1_IS_ON       0x01000000L   // DI-24
;1573 #define  PS1_AVAIL       0x02000000L   // DI-25
;1574 #define  PS1_TEMP_OK     0x04000000L   // DI-26
;1575 
;1576 #define  PS6_IS_ON       0x08000000L   // DI-27
;1577 #define  PS6_AVAIL       0x10000000L   // DI-28
;1578 #define  PS6_TEMP_OK     0x20000000L   // DI-29
;1579 
;1580 #define  HOLEC_OK        0x40000000L   // DI-30
;1581 #define  NO_INTLK        0x80000000L   // DI-31
;1582 
;1583 #define  PS_AVAIL_MASK   0x12492492L  // mask for all AVAIL bits
;1584 
;1585 //--- map from Bulk PS index to first bit in a group of digitalIn bits ---
;1586 const uint  psDigInIdx[NumPS] = { 24, 18, 12, 6, 0, 27, 21, 15, 9, 3 };
_psDigInIdx::
	.dw	0x18
	.dw	0x12
	.dw	0xc
	.dw	0x6
	.dw	0
	.dw	0x1b
	.dw	0x15
	.dw	0xf
	.dw	0x9
	.dw	0x3
	.debug	G _psDigInIdx 46 0
;1587 
;1588 //--- sensible, human-readable order for displaying digital inputs ---
;1589 const uchar  LogicOrderDIn[NUM_APPL_DIN] = {
;1590   24,25,26, 18,19,20, 12,13,14,  6,7,8,   0,1,2,
_LogicOrderDIn::
	.db	0x18
	.db	0x19
	.db	0x1a
	.db	0x12
	.db	0x13
	.db	0x14
	.db	0xc
	.db	0xd
	.db	0xe
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0
	.db	0x1
	.db	0x2
;1591   27,28,29, 21,22,23, 15,16,17,  9,10,11, 3,4,5,
	.db	0x1b
	.db	0x1c
	.db	0x1d
	.db	0x15
	.db	0x16
	.db	0x17
	.db	0xf
	.db	0x10
	.db	0x11
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0x3
	.db	0x4
	.db	0x5
;1592   30, 31
	.db	0x1e
;1593 };
	.db	0x1f
	.debug	G _LogicOrderDIn 47 0
;1594 
;1595 //--- msgs to log automatically when a digital input changes state ---
;1596 const char far *digInDescr[NUM_APPL_DIN*2] = {
;1597 //-0 state descr-    -1 state descr-
;1598   "PS1 is OFF",      "PS1 is ON",
	.dseg
_digInDescr::
	.dw	word (phys @1+950)
	.dw	phys @1+950 >> 16
	.dw	word (phys @1+961)
	.dw	phys @1+961 >> 16
;1599   "PS5 NOT Avail",   "PS5 Avail",
	.dw	word (phys @1+971)
	.dw	phys @1+971 >> 16
	.dw	word (phys @1+985)
	.dw	phys @1+985 >> 16
;1600   "PS5 Temp BAD",    "PS5 Temp OK",
	.dw	word (phys @1+995)
	.dw	phys @1+995 >> 16
	.dw	word (phys @1+1008)
	.dw	phys @1+1008 >> 16
;1601 
;1602   "PS10 is OFF",     "PS10 is ON",
	.dw	word (phys @1+1020)
	.dw	phys @1+1020 >> 16
	.dw	word (phys @1+1032)
	.dw	phys @1+1032 >> 16
;1603   "PS10 NOT Avail",  "PS10 Avail",
	.dw	word (phys @1+1043)
	.dw	phys @1+1043 >> 16
	.dw	word (phys @1+1058)
	.dw	phys @1+1058 >> 16
;1604   "PS10 Temp BAD",   "PS10 Temp OK",
	.dw	word (phys @1+1069)
	.dw	phys @1+1069 >> 16
	.dw	word (phys @1+1083)
	.dw	phys @1+1083 >> 16
;1605 
;1606   "PS4 is OFF",      "PS4 is ON",
	.dw	word (phys @1+1096)
	.dw	phys @1+1096 >> 16
	.dw	word (phys @1+1107)
	.dw	phys @1+1107 >> 16
;1607   "PS4 NOT Avail",   "PS4 Avail",
	.dw	word (phys @1+1117)
	.dw	phys @1+1117 >> 16
	.dw	word (phys @1+1131)
	.dw	phys @1+1131 >> 16
;1608   "PS4 Temp BAD",    "PS4 Temp OK",
	.dw	word (phys @1+1141)
	.dw	phys @1+1141 >> 16
	.dw	word (phys @1+1154)
	.dw	phys @1+1154 >> 16
;1609 
;1610   "PS9 is OFF",      "PS9 is ON",
	.dw	word (phys @1+1166)
	.dw	phys @1+1166 >> 16
	.dw	word (phys @1+1177)
	.dw	phys @1+1177 >> 16
;1611   "PS9 NOT Avail",   "PS9 Avail",
	.dw	word (phys @1+1187)
	.dw	phys @1+1187 >> 16
	.dw	word (phys @1+1201)
	.dw	phys @1+1201 >> 16
;1612   "PS9 Temp BAD",    "PS9 Temp OK",
	.dw	word (phys @1+1211)
	.dw	phys @1+1211 >> 16
	.dw	word (phys @1+1224)
	.dw	phys @1+1224 >> 16
;1613 
;1614   "PS3 is OFF",      "PS3 is ON",
	.dw	word (phys @1+1236)
	.dw	phys @1+1236 >> 16
	.dw	word (phys @1+1247)
	.dw	phys @1+1247 >> 16
;1615   "PS3 NOT Avail",   "PS3 Avail",
	.dw	word (phys @1+1257)
	.dw	phys @1+1257 >> 16
	.dw	word (phys @1+1271)
	.dw	phys @1+1271 >> 16
;1616   "PS3 Temp BAD",    "PS3 Temp OK",
	.dw	word (phys @1+1281)
	.dw	phys @1+1281 >> 16
	.dw	word (phys @1+1294)
	.dw	phys @1+1294 >> 16
;1617 
;1618   "PS8 is OFF",      "PS8 is ON",
	.dw	word (phys @1+1306)
	.dw	phys @1+1306 >> 16
	.dw	word (phys @1+1317)
	.dw	phys @1+1317 >> 16
;1619   "PS8 NOT Avail",   "PS8 Avail",
	.dw	word (phys @1+1327)
	.dw	phys @1+1327 >> 16
	.dw	word (phys @1+1341)
	.dw	phys @1+1341 >> 16
;1620   "PS8 Temp BAD",    "PS8 Temp OK",
	.dw	word (phys @1+1351)
	.dw	phys @1+1351 >> 16
	.dw	word (phys @1+1364)
	.dw	phys @1+1364 >> 16
;1621 
;1622   "PS2 is OFF",      "PS2 is ON",
	.dw	word (phys @1+1376)
	.dw	phys @1+1376 >> 16
	.dw	word (phys @1+1387)
	.dw	phys @1+1387 >> 16
;1623   "PS2 NOT Avail",   "PS2 Avail",
	.dw	word (phys @1+1397)
	.dw	phys @1+1397 >> 16
	.dw	word (phys @1+1411)
	.dw	phys @1+1411 >> 16
;1624   "PS2 Temp BAD",    "PS2 Temp OK",
	.dw	word (phys @1+1421)
	.dw	phys @1+1421 >> 16
	.dw	word (phys @1+1434)
	.dw	phys @1+1434 >> 16
;1625 
;1626   "PS7 is OFF",      "PS7 is ON",
	.dw	word (phys @1+1446)
	.dw	phys @1+1446 >> 16
	.dw	word (phys @1+1457)
	.dw	phys @1+1457 >> 16
;1627   "PS7 NOT Avail",   "PS7 Avail",
	.dw	word (phys @1+1467)
	.dw	phys @1+1467 >> 16
	.dw	word (phys @1+1481)
	.dw	phys @1+1481 >> 16
;1628   "PS7 Temp BAD",    "PS7 Temp OK",
	.dw	word (phys @1+1491)
	.dw	phys @1+1491 >> 16
	.dw	word (phys @1+1504)
	.dw	phys @1+1504 >> 16
;1629 
;1630   "PS1 is OFF",      "PS1 is ON",
	.dw	word (phys @1+950)
	.dw	phys @1+950 >> 16
	.dw	word (phys @1+961)
	.dw	phys @1+961 >> 16
;1631   "PS1 NOT Avail",   "PS1 Avail",
	.dw	word (phys @1+1516)
	.dw	phys @1+1516 >> 16
	.dw	word (phys @1+1530)
	.dw	phys @1+1530 >> 16
;1632   "PS1 Temp BAD",    "PS1 Temp OK",
	.dw	word (phys @1+1540)
	.dw	phys @1+1540 >> 16
	.dw	word (phys @1+1553)
	.dw	phys @1+1553 >> 16
;1633 
;1634   "PS6 is OFF",      "PS6 is ON",
	.dw	word (phys @1+1565)
	.dw	phys @1+1565 >> 16
	.dw	word (phys @1+1576)
	.dw	phys @1+1576 >> 16
;1635   "PS6 NOT Avail",   "PS6 Avail",
	.dw	word (phys @1+1586)
	.dw	phys @1+1586 >> 16
	.dw	word (phys @1+1600)
	.dw	phys @1+1600 >> 16
;1636   "PS6 Temp BAD",    "PS6 Temp OK",
	.dw	word (phys @1+1610)
	.dw	phys @1+1610 >> 16
	.dw	word (phys @1+1623)
	.dw	phys @1+1623 >> 16
;1637 
;1638   "*** HOLEC BAD ***",  "HOLEC OK",
	.dw	word (phys @1+1635)
	.dw	phys @1+1635 >> 16
	.dw	word (phys @1+1653)
	.dw	phys @1+1653 >> 16
;1639   "*** External Interlock ***",  "External Interlock cleared"
	.dw	word (phys @1+1662)
	.dw	phys @1+1662 >> 16
;1640 };
	.dw	word (phys @1+1689)
	.dw	phys @1+1689 >> 16
	.debug	G _digInDescr 48 0
;1641 
;1642 
;1643 //=============== digitalOut bit usage ===============
;1644 #define  PS10_SET_ON      0x00000001  // PS 10 ON ctl      DO-00
;1645 #define  PS5_SET_ON       0x00000002  // PS  5 ON ctl      DO-01
;1646 #define  PS9_SET_ON       0x00000004  // PS  9 ON ctl      DO-02
;1647 #define  PS4_SET_ON       0x00000008  // PS  4 ON ctl      DO-03
;1648 #define  PS8_SET_ON       0x00000010  // PS  8 ON ctl      DO-04
;1649 #define  PS3_SET_ON       0x00000020  // PS  3 ON ctl      DO-05
;1650 #define  PS7_SET_ON       0x00000040  // PS  7 ON ctl      DO-06
;1651 #define  UNUSED_OUT       0x00000080  // unused output     DO-07
;1652 
;1653 #define  PS2_SET_ON       0x00000100  // PS  2 ON ctl      DO-08
;1654 #define  PS6_SET_ON       0x00000200  // PS  6 ON ctl      DO-09
;1655 #define  PS1_SET_ON       0x00000400  // PS  1 ON ctl      DO-10
;1656 #define  ENABLE_POL_NEG   0x00000800  // FET- ctl          DO-11
;1657 #define  ENABLE_POL_POS   0x00001000  // FET+ ctl          DO-12
;1658 #define  LED_POS          0x00002000  // Positive LED ctl  DO-13
;1659 #define  LED_NEG          0x00004000  // Negative LED ctl  DO-14
;1660 #define  ActivityLED      0x00008000  // Activity LED      DO-15
;1661 
;1662 #define  PS_SET_ON_MASK      0x077F  // mask for all SET_ON bits
;1663 
;1664 //--- map from Bulk PS index to digitalOut bits index ---
;1665 const uint psDigOutIdx[NumPS] = { 10, 8, 5, 3, 1, 9, 6, 4, 2, 0 };
	.seg	CONST
_psDigOutIdx::
	.dw	0xa
	.dw	0x8
	.dw	0x5
	.dw	0x3
	.dw	0x1
	.dw	0x9
	.dw	0x6
	.dw	0x4
	.dw	0x2
	.dw	0
	.debug	G _psDigOutIdx 46 0
;1666 
;1667 //--- sensible, human-readable order for displaying digital outputs ---
;1668 const uchar  LogicOrderDOut[NUM_APPL_DOUT] = {
;1669   10, 8, 5, 3, 1, 9, 6, 4, 2, 0, 11, 12, 13, 14, 15, 7 };
_LogicOrderDOut::
	.db	0xa
	.db	0x8
	.db	0x5
	.db	0x3
	.db	0x1
	.db	0x9
	.db	0x6
	.db	0x4
	.db	0x2
	.db	0
	.db	0xb
	.db	0xc
	.db	0xd
	.db	0xe
	.db	0xf
	.db	0x7
	.debug	G _LogicOrderDOut 50 0
;1670 
;1671 #define  TurnOnActivityLED()    ClearBits(Next.digitalOut, ActivityLED)
;1672 #define  TurnOffActivityLED()   SetBits(Next.digitalOut, ActivityLED)
;1673 
;1674 //--- msgs to log automatically when a digital output changes state ---
;1675 //--- use NULL for bits that we don't want to log changes for ---
;1676 const char far *digOutDescr[NUM_APPL_DOUT*2] = {
;1677 //--0 state descr--    --1 state descr--
;1678   "Set PS10 OFF",       "Set PS10 ON",
	.dseg
_digOutDescr::
	.dw	word (phys @1+1716)
	.dw	phys @1+1716 >> 16
	.dw	word (phys @1+1729)
	.dw	phys @1+1729 >> 16
;1679   "Set PS05 OFF",       "Set PS05 ON",
	.dw	word (phys @1+1741)
	.dw	phys @1+1741 >> 16
	.dw	word (phys @1+1754)
	.dw	phys @1+1754 >> 16
;1680   "Set PS09 OFF",       "Set PS09 ON",
	.dw	word (phys @1+1766)
	.dw	phys @1+1766 >> 16
	.dw	word (phys @1+1779)
	.dw	phys @1+1779 >> 16
;1681   "Set PS04 OFF",       "Set PS04 ON",
	.dw	word (phys @1+1791)
	.dw	phys @1+1791 >> 16
	.dw	word (phys @1+1804)
	.dw	phys @1+1804 >> 16
;1682   "Set PS08 OFF",       "Set PS08 ON",
	.dw	word (phys @1+1816)
	.dw	phys @1+1816 >> 16
	.dw	word (phys @1+1829)
	.dw	phys @1+1829 >> 16
;1683   "Set PS03 OFF",       "Set PS03 ON",
	.dw	word (phys @1+1841)
	.dw	phys @1+1841 >> 16
	.dw	word (phys @1+1854)
	.dw	phys @1+1854 >> 16
;1684   "Set PS07 OFF",       "Set PS07 ON",
	.dw	word (phys @1+1866)
	.dw	phys @1+1866 >> 16
	.dw	word (phys @1+1879)
	.dw	phys @1+1879 >> 16
;1685   NULL,                 NULL,
	.dw	0, 0
	.dw	0, 0
;1686   "Set PS02 OFF",       "Set PS02 ON",
	.dw	word (phys @1+1891)
	.dw	phys @1+1891 >> 16
	.dw	word (phys @1+1904)
	.dw	phys @1+1904 >> 16
;1687   "Set PS06 OFF",       "Set PS06 ON",
	.dw	word (phys @1+1916)
	.dw	phys @1+1916 >> 16
	.dw	word (phys @1+1929)
	.dw	phys @1+1929 >> 16
;1688   "Set PS01 OFF",       "Set PS01 ON",
	.dw	word (phys @1+1941)
	.dw	phys @1+1941 >> 16
	.dw	word (phys @1+1954)
	.dw	phys @1+1954 >> 16
;1689   NULL,                 NULL,   // "POL [-] Disabled",   "POL [-] Enabled",
	.dw	0, 0
	.dw	0, 0
;1690   NULL,                 NULL,   // "POL [+] Disabled",   "POL [+] Enabled",
	.dw	0, 0
	.dw	0, 0
;1691   NULL,                 NULL,
	.dw	0, 0
	.dw	0, 0
;1692   NULL,                 NULL,
	.dw	0, 0
	.dw	0, 0
;1693   NULL,                 NULL
	.dw	0, 0
;1694 
	.dw	0, 0
	.debug	G _digOutDescr 51 0
;1695 
;1696 
;1697 //--- extraIn bit usage ---
;1698 #define  SELECT_BTN      0x0001  // select LCD page to show on LCD
;1699 #define  SET_BTN         0x0002  // change value on LCD display
;1700 #define  START_BTN       0x0004  // turn ON
;1701 #define  STOP_BTN        0x0008  // turn OFF
;1702 #define  RESET_BTN       0x0010  // reset interlock (?)
;1703 
;1704 
;1705 //=============== Analog input indexes ================
;1706 //--- 16-bit ADC channels ---
;1707 #define  AI_IFDBK    0
;1708 #define  AI_VOUT     1
;1709 #define  AI_VCTRL    2
;1710 #define  AI_BJT_BIAS 3
;1711 //--- 1st 12-bit ADC channels ---
;1712 #define  AI_BSV6     4
;1713 #define  AI_HECT6    5
;1714 #define  AI_BSV1     6
;1715 #define  AI_HECT1    7
;1716 #define  AI_BSV7     8
;1717 #define  AI_HECT7    9
;1718 #define  AI_BSV2    10
;1719 #define  AI_HECT2   11
;1720 #define  AI_BSV8    12
;1721 #define  AI_SPARE0  13
;1722 #define  AI_SPARE1  14
;1723 //--- 2nd 12-bit ADC channels ---
;1724 #define  AI_HECT8   15
;1725 #define  AI_BSV3    16
;1726 #define  AI_HECT3   17
;1727 #define  AI_BSV9    18
;1728 #define  AI_HECT9   19
;1729 #define  AI_BSV4    20
;1730 #define  AI_HECT4   21
;1731 #define  AI_BSV10   22
;1732 #define  AI_HECT10  23
;1733 #define  AI_HECT5   24
;1734 #define  AI_BSV5    25
;1735 
;1736 //--- sensible, human-readable order for displaying analog inputs ---
;1737 const uchar  LogicOrderAIn[NUM_APPL_AIN] = {
;1738    7, 11, 17, 21, 24, 5, 9, 15, 19, 23,  // cur1 - cur10
	.seg	CONST
_LogicOrderAIn::
	.db	0x7
	.db	0xb
	.db	0x11
	.db	0x15
	.db	0x18
	.db	0x5
	.db	0x9
	.db	0xf
	.db	0x13
	.db	0x17
;1739    6, 10, 16, 20, 25, 4, 8, 12, 18, 22,  // bias1 - bias10
	.db	0x6
	.db	0xa
	.db	0x10
	.db	0x14
	.db	0x19
	.db	0x4
	.db	0x8
	.db	0xc
	.db	0x12
	.db	0x16
;1740    0,  1,  2,  3,   // ifdbk, vout, vctrl, bjtBias
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
;1741   13, 14  // SPARE0, SPARE1
	.db	0xd
;1742 };
	.db	0xe
	.debug	G _LogicOrderAIn 52 0
;1743 
;1744 
;1745 //=============== Analog output indexes ===============
;1746 #define  AO_ISET       0
;1747 #define  AO_VLIM_POS   1
;1748 #define  AO_VLIM_NEG   2
;1749 
;1750 //--- sensible, human-readable order for displaying analog outputs ---
;1751 const uchar  LogicOrderAOut[NUM_APPL_AOUT] = { 0, 1, 2 };
_LogicOrderAOut::
	.db	0
	.db	0x1
	.db	0x2
	.debug	G _LogicOrderAOut 53 0
;1752 
;1753 
;1754 //=========================================================================
;1755 //  List of daemon processes.  The inetd process listens for connection
;1756 //  requests on each port in the list and creates a new instance of the
;1757 //  specified process to service each new connection.
;1758 //=========================================================================
;1759 #include <services.h>
;1760 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
;1761 //--- service funcs declared the same as standard command funcs:
;1762 //     e.g.:   void _task fastdatad(int argc, char **argv);
;1763 
;1764 void _task tsh(int argc, char **argv);
;1765 
;1766 
;1767 ServiceInfo inetdConf[] = {
;1768 //--- add any application-specific inetd-type network services here ---
;1769 //--- (add port # names to services.h) ---
;1770 //  NAME          PORT           PROTOCOL  FUNC       PRI  -1  Config Param
;1771 //  ------------  -------------  --------  ---------- ---  --  ------------
;1772 
;1773 //--- example of standard ones defined in sharedAppl.c ---
;1774 //{ "console",    TTY0,          ASYNC,    tsh,        10, -1, &consCfg },
;1775 //{ "fastdatad",  FASTDATA_PORT, ProtoTCP, fastdatad,   5, -1, NULL },
;1776 //{ "modbusTCPd", MODBUS_PORT,   ProtoTCP, modbusTCPd,  6, -1, NULL },
;1777 //{ "tsh",        TELNET_PORT,   ProtoTCP, tsh,        10, -1, NULL }
;1778 
;1779   #define SharedServices
;1780   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dseg
_inetdConf::
	.dw	@2+60
	.dw	0
	.db	0x3
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	word _consCfg
	.ds	6,0
	.dw	@2+68
	.dw	0x7d3
	.db	0x2
	.dw	word _fastdatad
	.db	0x5
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+78
	.dw	0x1f6
	.db	0x2
	.dw	word _modbusTCPd
	.db	0x6
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+89
	.dw	0x17
	.db	0x2
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	0
;1781 };
	.ds	6,0
	.debug	G _inetdConf 54 0
;1782 
;1783 const int  NumServices = sizeof(inetdConf) / sizeof(ServiceInfo);
	.seg	CONST
_NumServices::
	.dw	0x4
	.debug	G _NumServices 6 0
;1784 
;1785 
;1786 
;1787 //=========================================================================
;1788 //  Definition of data elements needed to keep track of the current state o
;1789 //  the device and the controller logic
;1790 //=========================================================================
;1791 typedef struct  {
;1792 //--- values updated in "cur" instance at start of each pass ---
;1793   bool   isOn;       // bulk supply is ON
;1794   bool   isAvail;    // bulk supply is available
;1795   bool   tempOK;     // no temp problem with this supply
;1796 
;1797   float  biasVolts;  // bias voltage readback
;1798   float  current;    // current output readback
;1799   float  curDiff;    // diff from nominal value
;1800 
;1801   ulong  lastTimeBiasOK; // last time biasVolts was nominal
;1802   ulong  lastTimeCurOK;  // last time current was nominal
;1803 
;1804   bool   biasErr;     // bias voltage exceeded max
;1805   bool   curErr;      // current out of nominal range for too long
;1806   bool   shortErr;    // current exceeded upper limit
;1807 
;1808 //--- values updated in "next" instance during each pass ---
;1809   bool   enabled;    // supply not manually or automatically disabled
;1810   bool   setOn;      // assert ON for this supply
;1811 }  BulkSupplyState;
;1812 
;1813 
;1814 //-------------------------------------------------------------------------
;1815 
;1816 typedef struct  {
;1817   BulkSupplyState  bs[NumPS];  // state of each bulk supply
;1818 
;1819 //--- values updated in "next" instance by tasks other than "applic" ---
;1820 //--- these are copied to "cur" at start of the pass and then "reset" ---
;1821 //--- (as needed) so we can tell if they are set again ---
;1822   bool   onRequest;
;1823   bool   offRequest;
;1824   bool   resetRequest;
;1825 
;1826   float  ampSet;      // most recent setpoint
;1827 
;1828 //--- values updated in "cur" instance at start of each pass ---
;1829   ulong  digitalIn;
;1830 
;1831   bool   externIntlk;
;1832 
;1833   bool   regPol;      // current polarity indicated by VCTRL
;1834   bool   hystRegPol;  // current polarity indicated by VCTRL with hysteresi
;1835 
;1836   bool   regPolStable;  // is the regulation polarity stable?
;1837   bool   sinkOrDump;  // bridge polarity is opposite the load voltage polar
;1838 
;1839   uint   btnBits;
;1840   uint   psCount;     // # of avail and enabled bulk supplies
;1841 
;1842   float  ifdbk;       // unscaled IFDBK voltage reading
;1843   float  vout;        // unscaled VOUT voltage reading
;1844   float  vctrl;       // unscaled VCTRL voltage reading
;1845   float  bjtBias;     // unscaled BJT BIAS voltage reading
;1846 
;1847   float  iset;        // unscaled ctl volt setting (scaled from ampApply)
;1848 
;1849   float  ctlErr;      //
;1850 
;1851   uint  outMode;      // OFF, WAIT, REG+, REG-, SINK+, SINK-, RAMP+, RAMP-,
;1852 
;1853 //--- values updated in "next" instance during each pass ---
;1854   uint   state;       // STATE_INIT, STATE_OFF, STATE_ON, STATE_INTLK;
;1855 
;1856   float  ampApply;    // in-use value, ramping toward ampSet
;1857 
;1858   uint   polCmd;      // polarity cmd asserted for the bridges (OFF, -, +)
;1859 
;1860   ulong  digitalOut;  // state for digital outputs
;1861 }  ApplState;
;1862 
;1863 
;1864 ApplState  prevState, curState, nextState;
;1865 
;1866 #define  Prev  prevState
;1867 #define  Cur   curState
;1868 #define  Next  nextState
;1869 
;1870 
;1871 const uint ApplStateDataSize =  ( sizeof(ApplState)*3 + sizeof(setVal) );
_ApplStateDataSize::
	.dw	0x402
	.debug	G _ApplStateDataSize 7 0
;1872 
;1873 
;1874 
;1875 //===== "cur" values that we don't need to compare to "prev" instance =====
;1876 //----- (so we don't need them to be in the ApplState structure) -----
;1877 
;1878 //ulong  msSincePrev;
;1879 
;1880 uint   numLoggedChgMsgs; // # pol/mode chgs since last ampSet or on/off/int
;1881 uint  lastLoggableStateChg, lastEnabledChgMsg;
;1882 bool  logStateChgMsgs;
;1883 
;1884 uint  psOnTime;  // the time the bulk supplies where turned on
;1885 bool  psOnAndReady;    // bulk supplies on long enough to be stable
;1886 
;1887 uint  bridgeChgdTime;  // time of last bridge state change
;1888 bool  bridgeStateStable;  // bridge state unchanged for at least minPSonTim
;1889 
;1890 float  absErr;  // error in load current
;1891 
;1892 bool  tempRegPol, bridgeJustOff, voltageLimited, inductiveLoad, bulkSupErr,
;1893       loadTypeWrong;
;1894 
;1895 ulong  bridgeOffTime, unstableStartTime, lastModeSetTime,
;1896        lastRegPolChgTime, lastNotWaitingTime;
;1897 
;1898 uint  lastLoadTypeWarnTime, lastValLogTime, logInterval;
;1899 
;1900 bool  ramping, regulating, sinking, dumping,
;1901       lowLoadCur, holecOK, bulkCurClose, usePolarity;
;1902 
;1903 float  perSupCur, maxCurDiff, vlimAdjust, bulkCurDiff, absBulkCurDiff,
;1904        absAmpRead;
;1905 
;1906 uint  enabledMask;  // bit-mapped persistent vers of BulkSupplyState[].enab
;1907 
;1908 uint  bulkShortStarted[NumPS];
;1909 
;1910 
;1911 #define  Pos_Pol  true
;1912 #define  Neg_Pol  false
;1913 
;1914 
;1915 //--- values for polCmd ---
;1916 #define  POL_NEG   0   // negative FET driver ON
;1917 #define  POL_OFF   1   // both FETs OFF
;1918 #define  POL_POS   2   // positive FET driver ON
;1919 
;1920 const char *PolCmdDesc[] = { "[-]", "OFF", "[+]" };
_PolCmdDesc::
	.dw	@2+93
	.dw	@2+97
	.dw	@2+101
	.debug	G _PolCmdDesc 56 0
;1921 
;1922 
;1923 //=========================================================================
;1924 //  Defintions for variables that are accessable as ModBus registers
;1925 //=========================================================================
;1926 #else  // end of before-RegDefs portion
;2252 #ifndef RegDefs // start of after-RegDefs portion
;2253 
;2254 
;2255 //----- values for state -----
;2256 #define  STATE_INIT   0
;2257 #define  STATE_OFF    1
;2258 #define  STATE_ON     2
;2259 #define  STATE_INTLK  3
;2260 
;2261 const char *CtlStateDesc[4] = { "INIT ", "OFF  ", "ON   ", "INTLK" };
_CtlStateDesc::
	.dw	@2+105
	.dw	@2
	.dw	@2+111
	.dw	@2+117
	.debug	G _CtlStateDesc 57 0
;2262 
;2263 
;2264 //----- values for cmdBitsAppl -----
;2265 #define  CBA_TURN_ON     0x00000001
;2266 #define  CBA_TURN_OFF    0x00000002
;2267 #define  CBA_CLR_INTLK   0x00000004
;2268 
;2269 #define  CBA_ENABLE_1    0x00000008
;2270 #define  CBA_ENABLE_2    0x00000010
;2271 #define  CBA_ENABLE_3    0x00000020
;2272 #define  CBA_ENABLE_4    0x00000040
;2273 #define  CBA_ENABLE_5    0x00000080
;2274 #define  CBA_ENABLE_6    0x00000100
;2275 #define  CBA_ENABLE_7    0x00000200
;2276 #define  CBA_ENABLE_8    0x00000400
;2277 #define  CBA_ENABLE_9    0x00000800
;2278 #define  CBA_ENABLE_10   0x00001000
;2279 
;2280 #define  CBA_DISABLE_1   0x00002000
;2281 #define  CBA_DISABLE_2   0x00004000
;2282 #define  CBA_DISABLE_3   0x00008000
;2283 #define  CBA_DISABLE_4   0x00010000
;2284 #define  CBA_DISABLE_5   0x00020000
;2285 #define  CBA_DISABLE_6   0x00040000
;2286 #define  CBA_DISABLE_7   0x00080000
;2287 #define  CBA_DISABLE_8   0x00100000
;2288 #define  CBA_DISABLE_9   0x00200000
;2289 #define  CBA_DISABLE_10  0x00400000
;2290 
;2291 
;2292 //--- values for supplyType --- (not used at this time)
;2293 #define  TYPE_FET    1   // FET upper/BJT lower bridges, each
;2294 #define  TYPE_SCR    2   // SCR upper/lower bridges, BJT ctl for all bridge
;2295 
;2296 const char *SupplyTypeDesc[3] = { "???", "FET", "SCR" };
_SupplyTypeDesc::
	.dw	@2+123
	.dw	@2+127
	.dw	@2+131
	.debug	G _SupplyTypeDesc 56 0
;2297 
;2298 //--- values for loadType ---
;2299 #define  LOAD_RL   1   // inductive (electro-magnet) load
;2300 #define  LOAD_DC   2   // resistive (or open) load
;2301 
;2302 const char *LoadTypeDesc[3] = { "??LOAD??", "INDUCTOR", "RESISTOR" };
_LoadTypeDesc::
	.dw	@2+135
	.dw	@2+144
	.dw	@2+153
	.debug	G _LoadTypeDesc 56 0
;2303 
;2304 //=========================================================================
;2305 //  defintions for "parameterized" data values - lists of values that we wa
;2306 //  to be "persistent" (i.e. saved to a file and restored on startup)
;2307 //=========================================================================
;2308 
;2309 float dummyFloat;
;2310 
;2311 //--- parameter ID's for data in Device Data/calibration file ---
;2312 //-------------------------------------------------------------------------
;2313 // WARNING:  ID's can be added, but existing ID's (and the format of the
;2314 //           data the represent) should NEVER change!  NOTE:  Existing ones
;2315 //           can be "eliminated" by changing their name and no longer
;2316 //           using them, but never REUSE an old one for something new!!!
;2317 //-------------------------------------------------------------------------
;2318 //  NOTE:  ID's >= 1000 are rsvd for values shared by most applications
;2319 //-------------------------------------------------------------------------
;2320 RESTORE_FUNC(enabledMask);
;2321 
;2322 const ParamData far  devDataParams[] = {
;2323   #define SharedDevParams
;2324   #include <sharedAppl.c>
;2325 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.seg	FARCONST
_devDataParams::
	.dw	0x3ec
	.dw	0x2
	.dw	0
	.dl	phys _timeZone
	.dl	phys @1+1966
	.dw	0
	.dw	0x3ed
	.dw	0x4
	.dw	0
	.dl	phys _srfsIPAddr
	.dl	phys @1+1975
	.dw	0
	.dw	0x3e8
	.dw	0x270
	.dw	0x18
	.dl	phys _ainLabel
	.dl	phys @1+1986
	.dw	0
	.dw	0x3e9
	.dw	0x48
	.dw	0x18
	.dl	phys _aoutLabel
	.dl	phys @1+1995
	.dw	0
	.dw	0x3ea
	.dw	0x300
	.dw	0x18
	.dl	phys _dinLabel
	.dl	phys @1+2005
	.dw	0
	.dw	0x3eb
	.dw	0x180
	.dw	0x18
	.dl	phys _doutLabel
	.dl	phys @1+2014
	.dw	0
	.dw	0x3ee
	.dw	0x68
	.dw	0
	.dl	phys _readGain
	.dl	phys @1+2024
	.dw	0
	.dw	0x3ef
	.dw	0x68
	.dw	0
	.dl	phys _readOffset
	.dl	phys @1+2033
	.dw	0
	.dw	0x3f0
	.dw	0xc
	.dw	0
	.dl	phys _setGain
	.dl	phys @1+2044
	.dw	0
	.dw	0x3f1
	.dw	0xc
	.dw	0
	.dl	phys _setOffset
	.dl	phys @1+2052
	.dw	word _ReadSetCalibsRestore
	.dw	0x3f2
	.dw	0x20
	.dw	0
	.dl	phys _hostName
	.dl	phys @1+2062
	.dw	word _hostNameRestore
	.dw	0x3f3
	.dw	0x4
	.dw	0
	.dl	phys _srfsAltAddr
	.dl	phys @1+2071
	.dw	0
	.dw	0x3f4
	.dw	0x300
	.dw	0x18
	.dl	phys _extraInLabel
	.dl	phys @1+2083
	.dw	0
	.dw	0x3f5
	.dw	0x4
	.dw	0
	.dl	phys _netmask
	.dl	phys @1+614
	.dw	0
	.dw	0x3f6
	.dw	0x4
	.dw	0
	.dl	phys _gateway
	.dl	phys @1+622
	.dw	0
;2326 // NOTE:  The application-specific ones need to come AFTER the generic ones
;2327 //        if (as in this case) there are values that depend on the generic
;2328 //        ones (in this case, the vlimPlus and vlimMinus depend on the
;2329 //        setGain and setOffset values)
;2330 //APPLDATA
;2331 //                ID   ---value---  --RESTORE_FUNC--
;2332   PERSISTENT_VAR(  1,  vlimPlus,         NULL ),
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _vlimPlus
	.dl	phys @1+691
	.dw	0
;2333   PERSISTENT_VAR(  2,  vlimMinus,        NULL ),
	.dw	0x2
	.dw	0x4
	.dw	0
	.dl	phys _vlimMinus
	.dl	phys @1+700
	.dw	0
;2334   PERSISTENT_VAR(  3,  rampRate,         NULL ),
	.dw	0x3
	.dw	0x4
	.dw	0
	.dl	phys _rampRate
	.dl	phys @1+710
	.dw	0
;2335   PERSISTENT_VAR(  4,  vctrlHyst,        NULL ),
	.dw	0x4
	.dw	0x4
	.dw	0
	.dl	phys _vctrlHyst
	.dl	phys @1+719
	.dw	0
;2336   PERSISTENT_VAR(  5,  maxErrTime,       NULL ),
	.dw	0x5
	.dw	0x2
	.dw	0
	.dl	phys _maxErrTime
	.dl	phys @1+886
	.dw	0
;2337 //  PERSISTENT_VAR(  6,  maxVctrl,         NULL ),
;2338 //  PERSISTENT_VAR(  7,  forcePolTime,     NULL ),
;2339 //  PERSISTENT_VAR(  8,  maxCurDiff,       NULL ),
;2340 //  PERSISTENT_VAR(  9,  maxVoltDiff,      NULL ),
;2341 //  PERSISTENT_VAR( 10,  maxDiffSec,       NULL ),
;2342   PERSISTENT_VAR( 11,  knobSelectRate,   NULL ),
	.dw	0xb
	.dw	0x2
	.dw	0
	.dl	phys _knobSelectRate
	.dl	phys @1+816
	.dw	0
;2343   PERSISTENT_VAR( 12,  maxAmpSet,        NULL ),
	.dw	0xc
	.dw	0x4
	.dw	0
	.dl	phys _maxAmpSet
	.dl	phys @1+831
	.dw	0
;2344   PERSISTENT_VAR( 13,  minPSonTime,      NULL ),
	.dw	0xd
	.dw	0x2
	.dw	0
	.dl	phys _minPSonTime
	.dl	phys @1+841
	.dw	0
;2345   PERSISTENT_VAR( 14,  minBridgeOffTime, NULL ),
	.dw	0xe
	.dw	0x2
	.dw	0
	.dl	phys _minBridgeOffTime
	.dl	phys @1+853
	.dw	0
;2346   PERSISTENT_VAR( 15,  minPolStableTime, NULL ),
	.dw	0xf
	.dw	0x2
	.dw	0
	.dl	phys _minPolStableTime
	.dl	phys @1+729
	.dw	0
;2347 //  PERSISTENT_VAR( 16,  rampThreshold,    NULL ),
;2348   PERSISTENT_VAR( 17,  minBSVolts,       NULL ),
	.dw	0x11
	.dw	0x4
	.dw	0
	.dl	phys _minBSVolts
	.dl	phys @1+754
	.dw	0
;2349   PERSISTENT_VAR( 18,  maxBSFracCurDiff, NULL ),
	.dw	0x12
	.dw	0x4
	.dw	0
	.dl	phys _maxBSFracCurDiff
	.dl	phys @1+765
	.dw	0
;2350   PERSISTENT_VAR( 19,  bulkShortCur,     NULL ),
	.dw	0x13
	.dw	0x4
	.dw	0
	.dl	phys _bulkShortCur
	.dl	phys @1+906
	.dw	0
;2351   PERSISTENT_VAR( 20,  supplyType,       NULL ),
	.dw	0x14
	.dw	0x2
	.dw	0
	.dl	phys _supplyType
	.dl	phys @1+919
	.dw	0
;2352   PERSISTENT_VAR( 21,  vlimReduction,    NULL ),
	.dw	0x15
	.dw	0x4
	.dw	0
	.dl	phys _vlimReduction
	.dl	phys @1+782
	.dw	0
;2353 //  PERSISTENT_VAR( 22,  contrast,         NULL ),
;2354   PERSISTENT_VAR( 23,  sinkEndAmps,      NULL ),
	.dw	0x17
	.dw	0x4
	.dw	0
	.dl	phys _sinkEndAmps
	.dl	phys @1+796
	.dw	0
;2355   PERSISTENT_VAR( 24,  loadType,         NULL ),
	.dw	0x18
	.dw	0x2
	.dw	0
	.dl	phys _loadType
	.dl	phys @1+930
	.dw	0
;2356   PERSISTENT_VAR( 25,  enabledMask,      PVRF(enabledMask) ),
	.dw	0x19
	.dw	0x2
	.dw	0
	.dl	phys _enabledMask
	.dl	phys @1+2096
	.dw	word _enabledMaskRestore
;2357   PERSISTENT_VAR( 26,  debounceMS,       NULL ),
	.dw	0x1a
	.dw	0x2
	.dw	0
	.dl	phys _debounceMS
	.dl	phys @1+939
	.dw	0
;2358 
;2359   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2360 
	.ds	2,0
	.debug	G _devDataParams 58 8
;2361 
;2362 //----------------------------------------------------
;2363 RESTORE_FUNC(ampSet);
;2364 
;2365 const ParamData far  settingsParams[] = {
;2366 //APPLDATA
;2367 //                ID   ---value---  --RESTORE_FUNC--
;2368   PERSISTENT_VAR(  1,  ampSet,       PVRF(ampSet) ),
_settingsParams::
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _ampSet
	.dl	phys @1+684
	.dw	word _ampSetRestore
;2369   PERSISTENT_VAR(  2,  contrast,     NULL ),
	.dw	0x2
	.dw	0x2
	.dw	0
	.dl	phys _contrast
	.dl	phys @1+897
	.dw	0
;2370 
;2371   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2372 
	.ds	2,0
	.debug	G _settingsParams 60 8
;2373 
;2374 
;2375 //-----------------------------------------------------------------
;2376 //  Application-specific values needed to restore the state of the
;2377 //  controller following a "soft" reset (i.e. a restart without a
;2378 //  CPU reset)
;2379 //-----------------------------------------------------------------
;2380 const ParamData far  ctlrStateParams[] = {
;2381 // sample values from sharedAppl.c, common to all applications
;2382 //                   --ID--  ---value,granularity---  --restoreFunc--
;2383 //    PERSISTENT_VARx(  1000,  prevState,               NULL ),
;2384 //    PERSISTENT_VARx(  1001,  curState,                NULL ),
;2385 //    PERSISTENT_VARx(  1002,  nextState,               NULL ),
;2386 //    PERSISTENT_TBL (  1003,  setVal,4,                NULL ),
;2387 // // PERSISTENT_TBL (  1004,  shadowRegValues,4,       NULL ),
;2388 
;2389 //APPLDATA
;2390 //    PERSISTENT_VAR(  1,  myApplStateVar,        NULL ),
;2391 
;2392 
;2393   #define SharedCtlrStateParams
;2394   #include <sharedAppl.c>
;2395 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;2396   END_PARAM_DATA
_ctlrStateParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2397 
	.ds	2,0
	.debug	G _ctlrStateParams 61 8
;2398 
;2399 
;2400 //-------------------------------------------------------------------------
;2401 //  A list of parameterized "persistent" data.  Backup copies of such value
;2402 //  are stored in files and restored on startup.
;2403 //-------------------------------------------------------------------------
;2404 
;2405 //    Base File Name    Category  ParamData
;2406 //    ----------------  --------  ---------
;2407 //--- add any application-specific parameterized file defs here ---
;2408 //ParamFile  myAppCfgFile =
;2409 //  { "myFileName",     PDC_CTLR, myCfgParams,   0 };
;2410 
;2411 ParamFile  settingsFile =
;2412     { "settings",       PDC_SET,  settingsParams  };
	.dseg
_settingsFile::
	.dw	@2+162
	.db	0x4
	.dl	phys _settingsParams
	.ds	42,0
	.debug	G _settingsFile 62 0
;2413 
;2414 
;2415 #define SharedParams
;2416 #include <sharedAppl.c>
;2417 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_devDataFile::
	.dw	@2+171
	.db	0x3
	.dl	phys _devDataParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _devDataFile 62 0
_hdwCfgFile::
	.dw	@2+179
	.db	0x1
	.dl	phys _hdwCfgParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _hdwCfgFile 62 0
;2418 
;2419 ParamFile *paramFiles[] = {
;2420   #define SharedParamsList
;2421   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_paramFiles::
	.dw	word _hdwCfgFile
	.dw	word _devDataFile
;2422 //--- add any application-specific ParamData references here ---
;2423 //  &myAppCfgFile,
;2424   &settingsFile
;2425 };
	.dw	word _settingsFile
	.debug	G _paramFiles 63 0
;2426 
;2427 const int NumParamFiles = sizeof(paramFiles) / sizeof(paramFiles[0]);
	.seg	CONST
_NumParamFiles::
	.dw	0x3
	.debug	G _NumParamFiles 6 0
;2428 
;2429 
;2430 //=========================================================================
;2431 //  Declarations for functions that handle setting "next" values that serve
;2432 //  as inputs to the application control logic (run by the "applic" task in
;2433 //  a periodically executed loop).
;2434 //
;2435 //  While care must be taken in these functions to use locks to avoid the
;2436 //  possibility of being preempted in the middle of an operation, such lock
;2437 //  must be kept to as short a time as possible to avoid excessively latenc
;2438 //  in the main control loop.
;2439 //=========================================================================
;2440 
;2441 void onRequest(void);
;2442 void offRequest(void);
;2443 void resetRequest(void);
;2444 
;2445 void enableBulkSupply(uint idx);
;2446 void disableBulkSupply(uint idx);
;2447 
;2448 void newSetpoint(float newAmps);
;2449 
;2450 
;2451 //=========================================================================
;2452 //  This is where misc global variables should be defined
;2453 //=========================================================================
;2454 #define SharedGlobals
;2455 #include <sharedAppl.c>
;2456 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_DigOutInitState::
	.dw	0, 0
	.debug	G _DigOutInitState 9 0
	.dseg
_applicReady::
	.db	0
	.debug	G _applicReady 3 0
_restoredApplState::
	.db	0
	.debug	G _restoredApplState 3 0
_allowSoftReset::
	.db	0
	.debug	G _allowSoftReset 3 0
_startupComplete::
	.db	0
	.debug	G _startupComplete 3 0
;2457 //--- add definitions for application-specific global variables here ---
;2458 
;2459 float * const bsvX[] = {
;2460   &bsv_1, &bsv_2, &bsv_3, &bsv_4, &bsv_5,
_bsvX::
	.dw	word _bsv_1
	.dw	word _bsv_2
	.dw	word _bsv_3
	.dw	word _bsv_4
	.dw	word _bsv_5
;2461   &bsv_6, &bsv_7, &bsv_8, &bsv_9, &bsv_10
	.dw	word _bsv_6
	.dw	word _bsv_7
	.dw	word _bsv_8
	.dw	word _bsv_9
;2462 };
	.dw	word _bsv_10
	.debug	G _bsvX 65 0
;2463 float * const ampsX[] = {
;2464   &amps_1, &amps_2, &amps_3, &amps_4, &amps_5,
_ampsX::
	.dw	word _amps_1
	.dw	word _amps_2
	.dw	word _amps_3
	.dw	word _amps_4
	.dw	word _amps_5
;2465   &amps_6, &amps_7, &amps_8, &amps_9, &amps_10
	.dw	word _amps_6
	.dw	word _amps_7
	.dw	word _amps_8
	.dw	word _amps_9
;2466 };
	.dw	word _amps_10
	.debug	G _ampsX 65 0
;2467 
;2468 //--- mapping from supply index to Analog Input #'s ---
;2469 const uint BSVidx[NumPS] = {
;2470   AI_BSV1, AI_BSV2, AI_BSV3, AI_BSV4, AI_BSV5,
	.seg	CONST
_BSVidx::
	.dw	0x6
	.dw	0xa
	.dw	0x10
	.dw	0x14
	.dw	0x19
;2471   AI_BSV6, AI_BSV7, AI_BSV8, AI_BSV9, AI_BSV10
	.dw	0x4
	.dw	0x8
	.dw	0xc
	.dw	0x12
;2472 
	.dw	0x16
	.debug	G _BSVidx 46 0
;2473 const uint HECTidx[NumPS] = {
;2474   AI_HECT1, AI_HECT2, AI_HECT3, AI_HECT4, AI_HECT5,
_HECTidx::
	.dw	0x7
	.dw	0xb
	.dw	0x11
	.dw	0x15
	.dw	0x18
;2475   AI_HECT6, AI_HECT7, AI_HECT8, AI_HECT9, AI_HECT10
	.dw	0x5
	.dw	0x9
	.dw	0xf
	.dw	0x13
;2476 
	.dw	0x17
	.debug	G _HECTidx 46 0
;2477 
;2478 //--- list of bit-masks for testing state of each bulk PS ---
;2479 const uint SetOnBit[NumPS] = {
;2480   PS1_SET_ON, PS2_SET_ON, PS3_SET_ON, PS4_SET_ON, PS5_SET_ON,
_SetOnBit::
	.dw	0x400
	.dw	0x100
	.dw	0x20
	.dw	0x8
	.dw	0x2
;2481   PS6_SET_ON, PS7_SET_ON, PS8_SET_ON, PS9_SET_ON, PS10_SET_ON
	.dw	0x200
	.dw	0x40
	.dw	0x10
	.dw	0x4
;2482 
	.dw	0x1
	.debug	G _SetOnBit 46 0
;2483 
;2484 const ulong IsOnBit[NumPS] = {
;2485   PS1_IS_ON, PS2_IS_ON, PS3_IS_ON, PS4_IS_ON, PS5_IS_ON,
_IsOnBit::
	.dw	0, 0x100
	.dw	0, 0x4
	.dw	0x1000, 0
	.dw	0x40, 0
	.dw	0x1, 0
;2486   PS6_IS_ON, PS7_IS_ON, PS8_IS_ON, PS9_IS_ON, PS10_IS_ON
	.dw	0, 0x800
	.dw	0, 0x20
	.dw	0xffff8000, 0
	.dw	0x200, 0
;2487 
	.dw	0x8, 0
	.debug	G _IsOnBit 67 0
;2488 
;2489 const ulong AvailBit[NumPS] = {
;2490   PS1_AVAIL, PS2_AVAIL, PS3_AVAIL, PS4_AVAIL, PS5_AVAIL,
_AvailBit::
	.dw	0, 0x200
	.dw	0, 0x8
	.dw	0x2000, 0
	.dw	0x80, 0
	.dw	0x2, 0
;2491   PS6_AVAIL, PS7_AVAIL, PS8_AVAIL, PS9_AVAIL, PS10_AVAIL
	.dw	0, 0x1000
	.dw	0, 0x40
	.dw	0, 0x1
	.dw	0x400, 0
;2492 
	.dw	0x10, 0
	.debug	G _AvailBit 67 0
;2493 
;2494 const ulong TempOKBit[NumPS] = {
;2495   PS1_TEMP_OK, PS2_TEMP_OK, PS3_TEMP_OK, PS4_TEMP_OK, PS5_TEMP_OK,
_TempOKBit::
	.dw	0, 0x400
	.dw	0, 0x10
	.dw	0x4000, 0
	.dw	0x100, 0
	.dw	0x4, 0
;2496   PS6_TEMP_OK, PS7_TEMP_OK, PS8_TEMP_OK, PS9_TEMP_OK, PS10_TEMP_OK
	.dw	0, 0x2000
	.dw	0, 0x80
	.dw	0, 0x2
	.dw	0x800, 0
;2497 
	.dw	0x20, 0
	.debug	G _TempOKBit 67 0
;2498 
;2499 
;2500 float absBulkCur;
;2501 
;2502 //=========================================================================
;2503 //  Functions referenced in the Modbus register definitions to handle write
;2504 //  specific global values defined as ModBus registers
;2505 //=========================================================================
;2506 
;2507 //-------------------------------------------------------------------------
;2508 //  External ModBus client sent a new value for "cmdBitsAppl"
;2509 //
;2510 //  Check the bits that where set and trigger the corresponding events as
;2511 //  appropriate (but do NOT save the new value - just use it to trigger
;2512 //  events)
;2513 //-------------------------------------------------------------------------
;2514 bool _nearcall MB_cmdBitsAppl(SetRegFuncParams)
;2515 {
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$MB_cmdBitsAppl::
	ex	(sp),iy
$MB_cmdBitsAppl::
	.debug	G $MB_cmdBitsAppl 68 9
	.debug	{ $MB_cmdBitsAppl 68 2514 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
;2516   uint  ui;
;2517   ulong  mask, cmdBits = MB_VAL(ulong);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	.seg	FARCODE
;2518 
;2519 
;2520   if (cmdBits & CBA_TURN_ON)    onRequest();
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@6
	lcall	$onRequest
;2521   if (cmdBits & CBA_TURN_OFF)   offRequest();
@6:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@7
	lcall	$offRequest
;2522   if (cmdBits & CBA_CLR_INTLK)  resetRequest();
@7:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@8
	lcall	$resetRequest
;2523 
;2524   mask = CBA_ENABLE_1;
@8:
	ld	de,0x8
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;2525   for (ui=0; ui<10; ++ui,mask<<=1)  if (cmdBits & mask)  enableBulkSupply(u
	ld	(ix-2),hl
@11:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@12
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@14
	ld	hl,(ix-2)
	push	hl
	lcall	$enableBulkSupply
	pop	hl
;2526 
;2527   mask = CBA_DISABLE_1;
@14:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@11
@12:
	ld	de,0x2000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;2528   for (ui=0; ui<10; ++ui,mask<<=1)  if (cmdBits & mask)  disableBulkSupply(
	ld	(ix-2),hl
@17:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@18
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@20
	ld	hl,(ix-2)
	push	hl
	lcall	$disableBulkSupply
	pop	hl
;2529 
;2530   return true;
@20:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@17
@18:
	ld	a,0x1
;2531 }
@4:
	.debug	} @4 2531

@3	equ	10
	ld	sp,ix
	pop	ix
	lret
@5	equ	12
;2532 
;2533 
;2534 //-------------------------------------------------------------------------
;2535 //  External ModBus client sent a new setpoint
;2536 //
;2537 //  Check the new setting and alter output values as appropriate
;2538 //-------------------------------------------------------------------------
;2539 bool MB_ampSet(SetRegFuncParams)
;2540 {
	.align	4
$$MB_ampSet::
	ex	(sp),iy
$MB_ampSet::
	.debug	G $MB_ampSet 68 9
	.debug	{ $MB_ampSet 68 2539 @23 @22
	push	ix
	ld	ix,0
	add	ix,sp
;2541   newSetpoint(MB_VAL(float));
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$newSetpoint
	add	sp,4
;2542 
;2543   return true;
	ld	a,0x1
;2544 }
@22:
	.debug	} @22 2544

@21	equ	0
	pop	ix
	lret
@23	equ	2
;2545 
;2546 //-------------------------------------------------------------------------
;2547 //  External ModBus client sent a new value for xxx
;2548 //-------------------------------------------------------------------------
;2549 bool MB_vlimPlus(SetRegFuncParams)
;2550 {
	.align	4
$$MB_vlimPlus::
	ex	(sp),iy
$MB_vlimPlus::
	.debug	G $MB_vlimPlus 68 9
	.debug	{ $MB_vlimPlus 68 2549 @26 @25
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;2551   float  limit, fval = MB_VAL(float);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
;2552 
;2553 //--- make sure value is achievable ---
;2554   limit = SetMin(AO_VLIM_POS);  limit = FABS(limit);
	ld	hl,0x1
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	c,@27
	ld	de,0
	ld	bc,0x3f80
	jr	@28
@27:
	ld	de,word (phys _setValMin+4)
	ld	c,phys _setValMin+4 >> 16
	call	__farld4##
@28:
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2555   if (fval < 0.0)  fval = 0.0;
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@29
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2556   if (fval > limit)  fval = limit;
@29:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsub##
	jp	m,@30
	jr	z,@30
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2557 
;2558   KLOCK();  vlimPlus = fval;  KUNLOCK();
@30:
	call	_KLOCK
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	(_vlimPlus),de
	ld	(_vlimPlus+2),bc
	call	_KUNLOCK
;2559 
;2560   return true;
	ld	a,0x1
;2561 }
@25:
	.debug	} @25 2561

@24	equ	8
	ld	sp,ix
	pop	ix
	lret
@26	equ	10
;2562 
;2563 //-------------------------------------------------------------------------
;2564 //  External ModBus client sent a new value for xxx
;2565 //-------------------------------------------------------------------------
;2566 bool MB_vlimMinus(SetRegFuncParams)
;2567 {
	.align	4
$$MB_vlimMinus::
	ex	(sp),iy
$MB_vlimMinus::
	.debug	G $MB_vlimMinus 68 9
	.debug	{ $MB_vlimMinus 68 2566 @33 @32
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;2568   float  limit, fval = MB_VAL(float);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
;2569 
;2570 //--- make sure value is achievable ---
;2571   limit = SetMax(AO_VLIM_NEG);  limit = FABS(limit);
	ld	hl,0x2
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	c,@34
	ld	de,0
	ld	bc,0xbf80
	jr	@35
@34:
	ld	de,word (phys _setValMax+8)
	ld	c,phys _setValMax+8 >> 16
	call	__farld4##
@35:
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2572   if (fval < 0.0)  fval = 0.0;
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@36
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2573   if (fval > limit)  fval = limit;
@36:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsub##
	jp	m,@37
	jr	z,@37
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2574 
;2575   KLOCK();  vlimMinus = fval;  KUNLOCK();
@37:
	call	_KLOCK
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	(_vlimMinus),de
	ld	(_vlimMinus+2),bc
	call	_KUNLOCK
;2576 
;2577   return true;
	ld	a,0x1
;2578 }
@32:
	.debug	} @32 2578

@31	equ	8
	ld	sp,ix
	pop	ix
	lret
@33	equ	10
;2579 
;2580 //-------------------------------------------------------------------------
;2581 //  External ModBus client sent a new value for xxx
;2582 //-------------------------------------------------------------------------
;2583 bool MB_rampRate(SetRegFuncParams)
;2584 {
	.align	4
$$MB_rampRate::
	ex	(sp),iy
$MB_rampRate::
	.debug	G $MB_rampRate 68 9
	.debug	{ $MB_rampRate 68 2583 @40 @39
	push	ix
	ld	ix,0
	add	ix,sp
;2585   rampRate = MB_VAL(float);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	(_rampRate),de
	ld	(_rampRate+2),bc
;2586 
;2587   return true;
	ld	a,0x1
;2588 }
@39:
	.debug	} @39 2588

@38	equ	0
	pop	ix
	lret
@40	equ	2
;2589 
;2590 //-------------------------------------------------------------------------
;2591 //  External ModBus client sent a new value for the VCTRL Hysterisis
;2592 //-------------------------------------------------------------------------
;2593 bool MB_vctrlHyst(SetRegFuncParams)
;2594 {
	.align	4
$$MB_vctrlHyst::
	ex	(sp),iy
$MB_vctrlHyst::
	.debug	G $MB_vctrlHyst 68 9
	.debug	{ $MB_vctrlHyst 68 2593 @43 @42
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;2595   float fval = MB_VAL(float);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;2596 
;2597   fval = FABS(fval);
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2598 
;2599   if (fval > 0.50)  fval = 0.50;
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fsub##
	jp	m,@44
	jr	z,@44
	ld	de,0
	ld	hl,0x3f00
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2600 
;2601   vctrlHyst = fval;
@44:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_vctrlHyst),de
	ld	(_vctrlHyst+2),bc
;2602 
;2603   return true;
	ld	a,0x1
;2604 }
@42:
	.debug	} @42 2604

@41	equ	4
	ld	sp,ix
	pop	ix
	lret
@43	equ	6
;2605 
;2606 //-------------------------------------------------------------------------
;2607 //  External ModBus client sent a new value for the supplyType
;2608 //-------------------------------------------------------------------------
;2609 bool MB_supplyType(SetRegFuncParams)
;2610 {
	.align	4
$$MB_supplyType::
	ex	(sp),iy
$MB_supplyType::
	.debug	G $MB_supplyType 68 9
	.debug	{ $MB_supplyType 68 2609 @47 @46
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;2611   uint newType = MB_VAL(uint);
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
;2612 
;2613   if ((newType != TYPE_FET) AND (newType != TYPE_SCR))  newType = 0;
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@49
	ld	hl,(ix-2)
	inc	e
	or	a,a
	sbc	hl,de
	jr	z,@49
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;2614 
;2615   supplyType = newType;
@49:
	ld	hl,(ix-2)
	ld	(_supplyType),hl
;2616 
;2617   return true;
	ld	a,0x1
;2618 }
@46:
	.debug	} @46 2618

@45	equ	2
	ld	sp,ix
	pop	ix
	lret
@47	equ	4
;2619 
;2620 //-------------------------------------------------------------------------
;2621 //  External ModBus client sent a new value for the loadType
;2622 //-------------------------------------------------------------------------
;2623 bool MB_loadType(SetRegFuncParams)
;2624 {
	.align	4
$$MB_loadType::
	ex	(sp),iy
$MB_loadType::
	.debug	G $MB_loadType 68 9
	.debug	{ $MB_loadType 68 2623 @52 @51
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;2625   uint newType = MB_VAL(uint);
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
;2626 
;2627   if ((newType != LOAD_RL) AND (newType != LOAD_DC))  newType = 0;
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@54
	ld	hl,(ix-2)
	inc	e
	or	a,a
	sbc	hl,de
	jr	z,@54
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;2628 
;2629   loadType = newType;
@54:
	ld	hl,(ix-2)
	ld	(_loadType),hl
;2630 
;2631   return true;
	ld	a,0x1
;2632 }
@51:
	.debug	} @51 2632

@50	equ	2
	ld	sp,ix
	pop	ix
	lret
@52	equ	4
;2633 
;2634 //-------------------------------------------------------------------------
;2635 
;2636 
;2637 
;2638 
;2639 //=========================================================================
;2640 //  functions to handle restoration of saved "persistent" values
;2641 //=========================================================================
;2642 
;2643 //-------------------------------------------------------------------------
;2644 //  restore an ampSet value from the settings file
;2645 //-------------------------------------------------------------------------
;2646 RESTORE_FUNC(ampSet)
;2647 RESTORE_FUNC(ampSet)
	.align	4
$$ampSetRestore::
	ex	(sp),iy
$ampSetRestore::
	.debug	G $ampSetRestore 69 9
	.debug	{ $ampSetRestore 69 2646 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
;2648   newSetpoint(NEW_VAL(float));
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$newSetpoint
	add	sp,4
;2649 }
@56:
	.debug	} @56 2649

@55	equ	0
	pop	ix
	lret
@57	equ	2
;2650 
;2651 
;2652 //-------------------------------------------------------------------------
;2653 //  restore the enabled/disabled settings for each bulk supply
;2654 //-------------------------------------------------------------------------
;2655 RESTORE_FUNC(enabledMask)
;2656 RESTORE_FUNC(enabledMask)
	.align	4
$$enabledMaskRestore::
	ex	(sp),iy
$enabledMaskRestore::
	.debug	G $enabledMaskRestore 69 9
	.debug	{ $enabledMaskRestore 69 2655 @60 @59
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;2657   uint  u, bit, mask;
;2658 
;2659   mask = NEW_VAL(uint);
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-6),hl
;2660 
;2661   for (u=0,bit=1; u<NumPS; ++u,bit<<=1)
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	inc	l
	ld	(ix-4),hl
@63:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@64
;2662     if (mask & bit)  enableBulkSupply(u);  else  disableBulkSupply(u);
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	and	hl,de
	jr	z,@66
	ld	hl,(ix-2)
	push	hl
	lcall	$enableBulkSupply
	pop	hl
	jr	@67
@66:
	ld	hl,(ix-2)
	push	hl
	lcall	$disableBulkSupply
	pop	hl
;2663 }
@67:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	add	hl,hl
	ld	(ix-4),hl
	jr	@63
@64:
@59:
	.debug	} @59 2663

@58	equ	6
	ld	sp,ix
	pop	ix
	lret
@60	equ	8
;2664 
;2665 
;2666 //-------------------------------------------------------------------------
;2667 #define SharedFuncs
;2668 #include <sharedAppl.c>
;2669 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
$initModBusRegs::
	.debug	G $initModBusRegs 70 9
	.debug	{ $initModBusRegs 70 454 @70 @69
	ld	hl,0x64
	ld	(_C0ChanMult),hl
	ld	l,0x1
	ld	(_NumC0Chans),hl
	ld	l,0x64
	ld	(_R3ChanMult),hl
	ld	l,0x1
	ld	(_NumR3Chans),hl
	ld	l,0x64
	ld	(_R4ChanMult),hl
	ld	l,0x1
	ld	(_NumR4Chans),hl
	lcall	$pvInitLists
	bool	hl
	jr	z,@71
	ld	a,0x1
	ld	(_doShutdown),a
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@74
	ld	a,0x1
	ld	(_runBackup),a
	ld	(_doReboot),a
@74:
@71:
@69:
	.debug	} @69 464

@68	equ	0
	lret
@70	equ	0
	.align	4
$$MB_timeZone::
	ex	(sp),iy
$MB_timeZone::
	.debug	G $MB_timeZone 68 9
	.debug	{ $MB_timeZone 68 470 @77 @76
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	de,0x7ff4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@78
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@79
	jr	z,@79
@78:
	xor	a,a
	jr	@76
@79:
	ld	hl,(ix-2)
	ld	(_timeZone),hl
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@80
	push	hl
	ld	de,word (phys @1+2108)
	ld	c,phys @1+2108 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
@80:
	ipset	2
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	a,0x1
@76:
	.debug	} @76 486

@75	equ	2
	ld	sp,ix
	pop	ix
	lret
@77	equ	4
	.align	4
$$MB_cmdBitsStd::
	ex	(sp),iy
$MB_cmdBitsStd::
	.debug	G $MB_cmdBitsStd 68 9
	.debug	{ $MB_cmdBitsStd 68 494 @83 @82
	ld	hl,-132
	call	__fent##
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@84
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
@84:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@85
	ld	a,0x1
	ld	(_doShutdown),a
@85:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@86
	ld	hl,0x1
	push	hl
	ld	hl,_devDataFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@81
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@86:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@87
	ld	hl,_devDataFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@87:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@88
	ld	hl,0x1
	push	hl
	ld	hl,_hdwCfgFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@81
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@88:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@89
	ld	hl,_hdwCfgFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@89:
	ld	a,0x1
@82:
	.debug	} @82 524

@81	equ	132
	ld	sp,ix
	pop	ix
	lret
@83	equ	134
$rwIO::
	.debug	G $rwIO 70 9
	.debug	{ $rwIO 70 531 @92 @91
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.bseg
@93:
	.ds	2
	.seg	FARCODE
	ld	hl,(@93)
	inc	hl
	ld	(@93),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	inc	l
	ld	(ix-6),hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@94
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@97:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@98
	ld	hl,(ix-2)
	ld	de,_updateAOut
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@102
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_lastSetVal
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fequ##
	jr	z,@103
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastSetVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	(hl),0x1
@103:
@102:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fequ##
	jr	z,@106
	ld	hl,(ix-12)
	ld	(hl),0x1
@106:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@99
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@108
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
	jr	@109
@108:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@110
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_setGain
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@110:
@109:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	p,@111
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@111:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	m,@112
	jr	z,@112
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@112:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastAnaOut
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_dacRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@99:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@97
@98:
@94:
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@113
	ld	hl,(@93)
	ld	e,0x1f
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@114
	ld	b,a
@115:
	add	hl,hl
	djnz	@115
@114:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@113:
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadTime),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@116
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
@116:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_readTicks),de
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@117
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	d,h
	ld	e,l
	ld	bc,(_DAC_Mask+2)
	call	__land##
	push	bc
	push	de
	lcall	$writeAnalogOutputs
	add	sp,4
@117:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_writeTicks),de
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@118
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@121:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@122
	ld	hl,(ix-2)
	ld	de,_updateAIn
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@126
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	(hl),0x1
@126:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@123
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@130
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@131
@130:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@131:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@132
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@132:
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@123:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@121
@122:
@118:
	lcall	$updateAvgsADC
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	ld	(_rwTicks),de
@91:
	.debug	} @91 607

@90	equ	28
	ld	sp,ix
	pop	ix
	lret
@92	equ	30
$logDigIOChgs::
	.debug	G $logDigIOChgs 71 9
	.debug	{ $logDigIOChgs 71 613 @135 @134
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	de,(_curState+287)
	ld	bc,(_curState+289)
	push	bc
	push	de
	ld	de,(_prevState+287)
	ld	bc,(_prevState+289)
	call	__lxor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
	ld	de,(_curState+334)
	ld	bc,(_curState+336)
	push	bc
	push	de
	ld	de,(_prevState+334)
	ld	bc,(_prevState+336)
	call	__lxor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.seg	FARCODE
	ld	a,(ix+5)
	or	a,a
	jr	z,@136
	ld	de,word (phys @1+2132)
	ld	c,phys @1+2132 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@136:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@137
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jp	z,@138
@137:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@141:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jp	nc,@142
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@146
	ld	a,(ix+5)
	or	a,a
	jr	z,@147
@146:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+287)
	ld	bc,(_curState+289)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@150
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@150:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digInDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@151
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2177)
	ld	c,phys @1+2177 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@151:
@147:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@141
@142:
@138:
	ld	a,(ix+5)
	or	a,a
	jr	z,@152
	ld	de,word (phys @1+2183)
	ld	c,phys @1+2183 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@152:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@153
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jp	z,@154
@153:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@157:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jp	nc,@158
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@162
	ld	a,(ix+5)
	or	a,a
	jr	z,@163
@162:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+334)
	ld	bc,(_curState+336)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@166
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@166:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digOutDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@167
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2177)
	ld	c,phys @1+2177 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@167:
@163:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@157
@158:
@154:
	ld	a,(ix+5)
	or	a,a
	jr	z,@168
	ld	de,word (phys @1+2174)
	ld	c,phys @1+2174 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@168:
@134:
	.debug	} @134 648

@133	equ	20
	ld	sp,ix
	pop	ix
	lret
@135	equ	22
	.align	4
$$EVENT_RestoredParamFile::
	ex	(sp),iy
$EVENT_RestoredParamFile::
	.debug	G $EVENT_RestoredParamFile 72 9
	.debug	{ $EVENT_RestoredParamFile 72 654 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	add	hl,hl
	ld	de,_paramFiles
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+2229)
	ld	c,phys @1+2229 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadParams
	add	sp,8
@170:
	.debug	} @170 666

@169	equ	4
	ld	sp,ix
	pop	ix
	lret
@171	equ	6
	.align	4
$$hostNameRestore::
	ex	(sp),iy
$hostNameRestore::
	.debug	G $hostNameRestore 69 9
	.debug	{ $hostNameRestore 69 671 @174 @173
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+9)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$SetHostName
	add	sp,4
@173:
	.debug	} @173 674

@172	equ	0
	pop	ix
	lret
@174	equ	2
	.align	4
$$ReadSetCalibsRestore::
	ex	(sp),iy
$ReadSetCalibsRestore::
	.debug	G $ReadSetCalibsRestore 69 9
	.debug	{ $ReadSetCalibsRestore 69 679 @177 @176
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	call	_KLOCK
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	call	_KUNLOCK
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@180:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@181
	ld	hl,(ix-2)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@180
@181:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@185:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@186
	ld	hl,(ix-2)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@185
@186:
@176:
	.debug	} @176 689

@175	equ	2
	ld	sp,ix
	pop	ix
	lret
@177	equ	4
$setApplDTM::
	.debug	G $setApplDTM 70 9
	.debug	{ $setApplDTM 70 694 @190 @189
	ld	hl,@2+186
	push	hl
	ld	hl,@2+195
	push	hl
	ld	de,word (phys @1+2261)
	ld	c,phys @1+2261 >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,@2+186
	push	hl
	ld	hl,@2+195
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_applVersTime),de
	ld	(_applVersTime+2),bc
@189:
	.debug	} @189 699

@188	equ	0
	lret
@190	equ	0
$saveApplState::
	.debug	G $saveApplState 73 9
	.debug	{ $saveApplState 73 709 @193 @192
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@194
	ld	hl,0xffff
	jp	@192
@194:
	call	_KLOCK
	ld	de,word (phys @1+2267)
	ld	c,phys @1+2267 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	call	_KUNLOCK
	bool	hl
	ld	l,h
@192:
	.debug	} @192 746

@191	equ	10
	ld	sp,ix
	pop	ix
	lret
@193	equ	12
$restoreApplState::
	.debug	G $restoreApplState 73 9
	.debug	{ $restoreApplState 73 764 @197 @196
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@198
	ld	hl,0xffff
	jp	@196
@198:
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@199
	ld	hl,0x1
	jp	@196
@199:
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@200
	jr	z,@200
	ld	hl,0x2
	jp	@196
@200:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	pop	de
	or	a,a
	sbc	hl,de
	jr	z,@201
	ld	hl,0x3
	jp	@196
@201:
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x152
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x152
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+287),de
	ld	(_nextState+289),bc
	ld	(_curState+287),de
	ld	(_curState+289),bc
	ld	de,(_curState+334)
	ld	bc,(_curState+336)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	de,word (phys @1+2294)
	ld	c,phys @1+2294 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
@196:
	.debug	} @196 801

@195	equ	10
	ld	sp,ix
	pop	ix
	lret
@197	equ	12
$setGenericLabels::
	.debug	G $setGenericLabels 70 9
	.debug	{ $setGenericLabels 70 806 @204 @203
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@207:
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@208
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2334)
	ld	c,phys @1+2334 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@207
@208:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@214:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@215
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2341)
	ld	c,phys @1+2341 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@214
@215:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@221:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jr	nc,@222
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2349)
	ld	c,phys @1+2349 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@221
@222:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@228:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@229
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2356)
	ld	c,phys @1+2356 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@228
@229:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@235:
	ld	hl,(ix-2)
	ld	de,(_NumExtraIn)
	or	a,a
	sbc	hl,de
	jr	nc,@236
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2364)
	ld	c,phys @1+2364 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@235
@236:
@203:
	.debug	} @203 831

@202	equ	2
	ld	sp,ix
	pop	ix
	lret
@204	equ	4
;2670 
;2671 
;2672 //=========================================================================
;2673 //  Misc Application-specific functions
;2674 //=========================================================================
;2675 
;2676 //-------------------------------------------------------------------------
;2677 //  Return a # indicating the state of the FETs based on the passed digital
;2678 //  value.
;2679 //
;2680 //  The return value is 0, 1, 2, or 3 with the following meaning:
;2681 //   0 - both FET drivers off
;2682 //   1 - negative FET driver on
;2683 //   2 - positive FET driver on
;2684 //   3 - both FET drivers on (an ERROR!)
;2685 //-------------------------------------------------------------------------
;2686 uint bitStateFETS(ulong outBits)
;2687 {
$bitStateFETS::
	.debug	G $bitStateFETS 74 9
	.debug	{ $bitStateFETS 74 2686 @242 @241
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;2688   uint  state = 0;
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
;2689 
;2690   if (outBits & ENABLE_POL_NEG)  state = 1;
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x800
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@243
	ld	hl,0x1
	ld	(ix-2),hl
;2691   if (outBits & ENABLE_POL_POS)  state |= 2;
@243:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@244
	ld	hl,(ix-2)
	set	1,l
	ld	(ix-2),hl
;2692 
;2693   return state;
@244:
	ld	hl,(ix-2)
;2694 }
@241:
	.debug	} @241 2694

@240	equ	2
	ld	sp,ix
	pop	ix
	lret
@242	equ	4
;2695 
;2696 
;2697 
;2698 
;2699 //=========================================================================
;2700 //  Task functions to handle application-specific commands
;2701 //=========================================================================
;2702 
;2703 typedef struct LCDElem_  LCDElem;
;2704 
;2705 typedef char * (*LCDFmtFunc)(LCDElem far *elem, void far *val, char *buf);
;2706 typedef bool   (*LCDChgFunc)(LCDElem far *elem, void far *val, float chgBy)
;2707 typedef void   (*LCDSetFunc)(LCDElem far *elem, void far *val);
;2708 
;2709 typedef struct LCDElem_ {
;2710   uchar        type;
;2711   uchar        col, row;
;2712   float        chgRate;
;2713   void far    *val;
;2714   int          valSize;
;2715   long         p1, p2;
;2716   LCDFmtFunc   fmtFunc;
;2717   LCDChgFunc   chgFunc;
;2718   LCDSetFunc   setFunc;
;2719 };
;2720 
;2721 //--- values for LCDElem.type ---
;2722 #define  RO_DATA   0
;2723 #define  RW_DATA   1
;2724 #define  PAGE_REF  2
;2725 
;2726 
;2727 typedef struct {
;2728   const char far   *name;      // name of the page
;2729   const char far  **text;      // static text for page
;2730   LCDElem far      *elems;     // elems that make up the page
;2731   LCDElem far      *cur;       // ptr to current element
;2732 } PageDef;
;2733 
;2734 
;2735 
;2736 #define LCD_ELEM_VAL(type)  ( *((type far *)elem->val) )
;2737 
;2738 #define LCD_VAL(type)  ( *((type far *)val) )
;2739 
;2740 #define VAR(name)   VFPV(name), sizeof(name)
;2741 
;2742 #define ENABLED(idx)  VAR(Next.bs[idx-1].enabled)
;2743 
;2744 
;2745 #define LCD_FMT_FUNC(name)  
;2746   _nearcall char *name(LCDElem far *elem, void far *val, char *buf)
;2747 
;2748 #define LCD_CHG_FUNC(name)  
;2749   _nearcall bool  name(LCDElem far *elem, void far *val, float chgBy)
;2750 
;2751 #define LCD_SET_FUNC(name)  
;2752   _nearcall void  name(LCDElem far *elem, void far *val)
;2753 
;2754 #define LCD_SET_REG_FUNC(funcname, reg, type)  
;2755   _nearcall void  funcname(LCDElem far *elem, void far *val)  { 
;2756     type newVal = LCD_VAL(type);  
;2757     char  temp[64];  
;2758     printf("new value for %ls: %s\r\n", reg##_RegInfo.name,  
;2759            fmtRegVal(&reg##_RegInfo, (S16 *)&newVal, 0, temp) );  
;2760     (reg##_RegInfo.setRegFunc)(&reg##_RegInfo, 0, &newVal, -1);  
;2761   }
;2762 
;2763 #define  PAGE_TEXT(name)   const char far * name##Text[]
;2764 
;2765 #define  PAGE_ELEMS(name)  const LCDElem far name##Elems[]
;2766 
;2767 #define  PAGE_DEF(name, title)  const PageDef far name##Page = {  
;2768                 title, name##Text, VFP(name##Elems),  VFP(name##Elems) };
;2769 
;2770 
;2771 bool  lcdBlink;
;2772 
;2773 //-------------------------------------------------------------------------
;2774 LCD_FMT_FUNC(strF32)  {
	.align	4
$$strF32::
	ex	(sp),iy
$strF32::
	.debug	G $strF32 75 9
	.debug	{ $strF32 75 2774 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
;2775   return fmtFloat(LCD_VAL(float), (int)elem->p1, (int)elem->p2, buf); }
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x11
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
@246:
	.debug	} @246 2775

@245	equ	0
	pop	ix
	lret
@247	equ	2
;2776 
;2777 LCD_CHG_FUNC(chgF32)  {  LCD_VAL(float) += chgBy;  return true; }
	.align	4
$$chgF32::
	ex	(sp),iy
$chgF32::
	.debug	G $chgF32 76 9
	.debug	{ $chgF32 76 2777 @250 @249
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farst4p##
	ld	a,0x1
@249:
	.debug	} @249 2777

@248	equ	0
	pop	ix
	lret
@250	equ	2
;2778 
;2779 
;2780 LCD_SET_FUNC(savF32)  {
	.align	4
$$savF32::
	ex	(sp),iy
$savF32::
	.debug	G $savF32 77 9
	.debug	{ $savF32 77 2780 @253 @252
	push	ix
	ld	ix,0
	add	ix,sp
;2781   KLOCK();  LCD_ELEM_VAL(float) = LCD_VAL(float);  KUNLOCK(); }
	call	_KLOCK
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farst4p##
	call	_KUNLOCK
@252:
	.debug	} @252 2781

@251	equ	0
	pop	ix
	lret
@253	equ	2
;2782 
;2783 LCD_FMT_FUNC(strU16)  {
	.align	4
$$strU16::
	ex	(sp),iy
$strU16::
	.debug	G $strU16 75 9
	.debug	{ $strU16 75 2783 @256 @255
	push	ix
	ld	ix,0
	add	ix,sp
;2784   sprintf(buf, "%*u", (int)elem->p1, LCD_VAL(uint) );  return buf; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,word (phys @1+2375)
	ld	c,phys @1+2375 >> 16
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,(ix+13)
@255:
	.debug	} @255 2784

@254	equ	0
	pop	ix
	lret
@256	equ	2
;2785 
;2786 
;2787 LCD_SET_REG_FUNC(set_ampSet, ampSet, F32)
	.align	4
$$set_ampSet::
	ex	(sp),iy
$set_ampSet::
	.debug	G $set_ampSet 77 9
	.debug	{ $set_ampSet 77 2787 @259 @258
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-68
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
	ld	hl,-68+@257
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,0+@257
	add	hl,sp
	push	hl
	ld	hl,_ampSet_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_ampSet_RegInfo+4)
	ld	bc,(_ampSet_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,-2+@257
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_ampSet_RegInfo
	push	hl
	ld	de,(_ampSet_RegInfo+8)
	call	__callde##
	add	sp,8
@258:
	.debug	} @258 2787

@257	equ	68
	ld	sp,ix
	pop	ix
	lret
@259	equ	70
;2788 D_SET_REG_FUNC(set_plim, vlimPlus, F32)
	.align	4
$$set_plim::
	ex	(sp),iy
$set_plim::
	.debug	G $set_plim 77 9
	.debug	{ $set_plim 77 2788 @262 @261
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-68
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
	ld	hl,-68+@260
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,0+@260
	add	hl,sp
	push	hl
	ld	hl,_vlimPlus_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_vlimPlus_RegInfo+4)
	ld	bc,(_vlimPlus_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,-2+@260
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_vlimPlus_RegInfo
	push	hl
	ld	de,(_vlimPlus_RegInfo+8)
	call	__callde##
	add	sp,8
@261:
	.debug	} @261 2788

@260	equ	68
	ld	sp,ix
	pop	ix
	lret
@262	equ	70
;2789 D_SET_REG_FUNC(set_mlim, vlimMinus, F32)
	.align	4
$$set_mlim::
	ex	(sp),iy
$set_mlim::
	.debug	G $set_mlim 77 9
	.debug	{ $set_mlim 77 2789 @265 @264
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-68
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
	ld	hl,-68+@263
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,0+@263
	add	hl,sp
	push	hl
	ld	hl,_vlimMinus_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_vlimMinus_RegInfo+4)
	ld	bc,(_vlimMinus_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,-2+@263
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_vlimMinus_RegInfo
	push	hl
	ld	de,(_vlimMinus_RegInfo+8)
	call	__callde##
	add	sp,8
@264:
	.debug	} @264 2789

@263	equ	68
	ld	sp,ix
	pop	ix
	lret
@265	equ	70
;2790 D_SET_REG_FUNC(set_mlim, vlimMinus, F32)
;2791 
;2792 LCD_FMT_FUNC(strCtlState) {
	.align	4
$$strCtlState::
	ex	(sp),iy
$strCtlState::
	.debug	G $strCtlState 75 9
	.debug	{ $strCtlState 75 2792 @268 @267
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;2793   uint ui = LCD_VAL(uint);
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
;2794   if ((ui != STATE_INTLK) OR lcdBlink)  return (char *)CtlStateDesc[ui];
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@269
	ld	a,(_lcdBlink)
	or	a,a
	jr	z,@270
@269:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_CtlStateDesc
	add	hl,de
	ld	hl,(hl)
	jr	@267
;2795   return "     ";
@270:
	ld	hl,@2+211
;2796 }
@267:
	.debug	} @267 2796

@266	equ	2
	ld	sp,ix
	pop	ix
	lret
@268	equ	4
;2797 
;2798 LCD_FMT_FUNC(strOutMode) {
	.align	4
$$strOutMode::
	ex	(sp),iy
$strOutMode::
	.debug	G $strOutMode 75 9
	.debug	{ $strOutMode 75 2798 @273 @272
	push	ix
	ld	ix,0
	add	ix,sp
;2799   return (char *) OutModeDesc[LCD_VAL(uint)]; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_OutModeDesc
	add	hl,de
	ld	hl,(hl)
@272:
	.debug	} @272 2799

@271	equ	0
	pop	ix
	lret
@273	equ	2
;2800 
;2801 LCD_FMT_FUNC(fetStr) {
	.align	4
$$fetStr::
	ex	(sp),iy
$fetStr::
	.debug	G $fetStr 75 9
	.debug	{ $fetStr 75 2801 @276 @275
	push	ix
	ld	ix,0
	add	ix,sp
;2802   return (char *) PolCmdDesc[LCD_VAL(uint)]; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_PolCmdDesc
	add	hl,de
	ld	hl,(hl)
@275:
	.debug	} @275 2802

@274	equ	0
	pop	ix
	lret
@276	equ	2
;2803 
;2804 LCD_FMT_FUNC(loadTypeStr) {
	.align	4
$$loadTypeStr::
	ex	(sp),iy
$loadTypeStr::
	.debug	G $loadTypeStr 75 9
	.debug	{ $loadTypeStr 75 2804 @279 @278
	push	ix
	ld	ix,0
	add	ix,sp
;2805   return (char *) LoadTypeDesc[LCD_VAL(uint)]; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_LoadTypeDesc
	add	hl,de
	ld	hl,(hl)
@278:
	.debug	} @278 2805

@277	equ	0
	pop	ix
	lret
@279	equ	2
;2806 
;2807 LCD_FMT_FUNC(supTypeStr) {
	.align	4
$$supTypeStr::
	ex	(sp),iy
$supTypeStr::
	.debug	G $supTypeStr 75 9
	.debug	{ $supTypeStr 75 2807 @282 @281
	push	ix
	ld	ix,0
	add	ix,sp
;2808   return (char *) SupplyTypeDesc[LCD_VAL(uint)]; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_SupplyTypeDesc
	add	hl,de
	ld	hl,(hl)
@281:
	.debug	} @281 2808

@280	equ	0
	pop	ix
	lret
@282	equ	2
;2809 
;2810 LCD_FMT_FUNC(polStr) {
	.align	4
$$polStr::
	ex	(sp),iy
$polStr::
	.debug	G $polStr 75 9
	.debug	{ $polStr 75 2810 @285 @284
	push	ix
	ld	ix,0
	add	ix,sp
;2811   return (LCD_VAL(bool)) ? "[+]" : "[-]"; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@286
	ld	hl,@2+101
	jr	@284
@286:
	ld	hl,@2+93
@284:
	.debug	} @284 2811

@283	equ	0
	pop	ix
	lret
@285	equ	2
;2812 
;2813 LCD_FMT_FUNC(strHolec) {
	.align	4
$$strHolec::
	ex	(sp),iy
$strHolec::
	.debug	G $strHolec 75 9
	.debug	{ $strHolec 75 2813 @291 @290
	push	ix
	ld	ix,0
	add	ix,sp
;2814   return (LCD_VAL(ulong) & HOLEC_OK) ? "OK " : (lcdBlink?"BAD":"   "); }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4000
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@292
	ld	hl,@2+217
	jr	@290
@292:
	ld	a,(_lcdBlink)
	or	a,a
	jr	z,@294
	ld	hl,@2+221
	jr	@290
@294:
	ld	hl,@2+113
@290:
	.debug	} @290 2814

@289	equ	0
	pop	ix
	lret
@291	equ	2
;2815 
;2816 LCD_FMT_FUNC(strIlk)  {
	.align	4
$$strIlk::
	ex	(sp),iy
$strIlk::
	.debug	G $strIlk 75 9
	.debug	{ $strIlk 75 2816 @299 @298
	push	ix
	ld	ix,0
	add	ix,sp
;2817   return (LCD_VAL(ulong)  & NO_INTLK) ? "OK   " : (lcdBlink?"FAULT":"     "
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x8000
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@300
	ld	hl,@2+225
	jr	@298
@300:
	ld	a,(_lcdBlink)
	or	a,a
	jr	z,@302
	ld	hl,@2+231
	jr	@298
@302:
	ld	hl,@2+211
@298:
	.debug	} @298 2817

@297	equ	0
	pop	ix
	lret
@299	equ	2
;2818 
;2819 LCD_FMT_FUNC(pageName)  {
	.align	4
$$pageName::
	ex	(sp),iy
$pageName::
	.debug	G $pageName 75 9
	.debug	{ $pageName 75 2819 @307 @306
	push	ix
	ld	ix,0
	add	ix,sp
;2820   fstrcpy(buf, LCD_VAL(PageDef).name);  return buf;  }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
	ld	hl,(ix+13)
@306:
	.debug	} @306 2820

@305	equ	0
	pop	ix
	lret
@307	equ	2
;2821 
;2822 LCD_FMT_FUNC(bitYN)  {
	.align	4
$$bitYN::
	ex	(sp),iy
$bitYN::
	.debug	G $bitYN 75 9
	.debug	{ $bitYN 75 2822 @310 @309
	push	ix
	ld	ix,0
	add	ix,sp
;2823   return (LCD_VAL(ulong)  & elem->p1) ? "Y" : "N"; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@311
	ld	hl,@2+237
	jr	@309
@311:
	ld	hl,@2+239
@309:
	.debug	} @309 2823

@308	equ	0
	pop	ix
	lret
@310	equ	2
;2824 
;2825 LCD_FMT_FUNC(bitOB)  {
	.align	4
$$bitOB::
	ex	(sp),iy
$bitOB::
	.debug	G $bitOB 75 9
	.debug	{ $bitOB 75 2825 @315 @314
	push	ix
	ld	ix,0
	add	ix,sp
;2826   return (LCD_VAL(ulong) & elem->p1) ? "OK " : (lcdBlink?"BAD":"   "); }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@316
	ld	hl,@2+217
	jr	@314
@316:
	ld	a,(_lcdBlink)
	or	a,a
	jr	z,@318
	ld	hl,@2+221
	jr	@314
@318:
	ld	hl,@2+113
@314:
	.debug	} @314 2826

@313	equ	0
	pop	ix
	lret
@315	equ	2
;2827 
;2828 LCD_FMT_FUNC(bitYN_)  {
	.align	4
$$bitYN_::
	ex	(sp),iy
$bitYN_::
	.debug	G $bitYN_ 75 9
	.debug	{ $bitYN_ 75 2828 @323 @322
	push	ix
	ld	ix,0
	add	ix,sp
;2829   return (LCD_VAL(ulong)  & elem->p1) ? "YES" : "NO "; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@324
	ld	hl,@2+241
	jr	@322
@324:
	ld	hl,@2+245
@322:
	.debug	} @322 2829

@321	equ	0
	pop	ix
	lret
@323	equ	2
;2830 
;2831 LCD_FMT_FUNC(enaYN)  {
	.align	4
$$enaYN::
	ex	(sp),iy
$enaYN::
	.debug	G $enaYN 75 9
	.debug	{ $enaYN 75 2831 @329 @328
	push	ix
	ld	ix,0
	add	ix,sp
;2832   return LCD_VAL(bool) ? "YES" : "NO "; }
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@330
	ld	hl,@2+241
	jr	@328
@330:
	ld	hl,@2+245
@328:
	.debug	} @328 2832

@327	equ	0
	pop	ix
	lret
@329	equ	2
;2833 
;2834 //========================================================================
;2835 PAGE_TEXT(main) = {
;2836 //----------------------------------------
;2837  "SET:-####.##A  CUR:-####.##A   V:-##.###",
	.dseg
_mainText::
	.dw	word (phys @1+2403)
	.dw	phys @1+2403 >> 16
;2838  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;2839  "ISET:-###.##A   +LIM:-##.###V   SFT: ###",
	.dw	word (phys @1+2446)
	.dw	phys @1+2446 >> 16
;2840  "BJTB:-##.###V   -LIM:-##.###V   HDW: ###",
	.dw	word (phys @1+2487)
	.dw	phys @1+2487 >> 16
;2841  "IFDK:-###.##A  VCTRL:-##.###V      #####",
	.dw	word (phys @1+2528)
	.dw	phys @1+2528 >> 16
;2842  "                LOAD:########  STYP: ###",
	.dw	word (phys @1+2569)
	.dw	phys @1+2569 >> 16
;2843  "HOLEC: ###  EXTILK: #####  #####  #PS:##",
	.dw	word (phys @1+2610)
	.dw	phys @1+2610 >> 16
;2844 //----------------------------------------
;2845  NULL
;2846 
	.dw	0, 0
	.debug	G _mainText 78 0
;2847 
;2848 PAGE_ELEMS(main) = {
;2849 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;2850   { RW_DATA,  5,1,  0.001,  VAR(ampSet),      8,2, strF32, chgF32, set_ampS
	.seg	FARCONST
_mainElems::
	.db	0x1
	.db	0x5
	.db	0x1
	.dw	0x126f, 0x3a83
	.dl	phys _ampSet
	.dw	0x4
	.dw	0x8, 0
	.dw	0x2, 0
	.dw	word _strF32
	.dw	word _chgF32
	.dw	word _set_ampSet
;2851   { RO_DATA, 20,1,  0.0,    VAR(ampRead),     8,2, strF32,       NULL, NULL
	.db	0
	.db	0x14
	.db	0x1
	.dw	0, 0
	.dl	phys _ampRead
	.dw	0x4
	.dw	0x8, 0
	.dw	0x2, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2852   { RO_DATA, 34,1,  0.0,    VAR(voltRead),    7,3, strF32,       NULL, NULL
	.db	0
	.db	0x22
	.db	0x1
	.dw	0, 0
	.dl	phys _voltRead
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2853 
;2854   { RO_DATA,  6,3,  0.0,    VAR(iset),        7,2, strF32,       NULL, NULL
	.db	0
	.db	0x6
	.db	0x3
	.dw	0, 0
	.dl	phys _iset
	.dw	0x4
	.dw	0x7, 0
	.dw	0x2, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2855   { RO_DATA,  6,4,  0.0,    VAR(bjtBias),     7,3, strF32,       NULL, NULL
	.db	0
	.db	0x6
	.db	0x4
	.dw	0, 0
	.dl	phys _bjtBias
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2856   { RO_DATA,  6,5,  0.0,    VAR(ifdbk),       7,2, strF32,       NULL, NULL
	.db	0
	.db	0x6
	.db	0x5
	.dw	0, 0
	.dl	phys _ifdbk
	.dw	0x4
	.dw	0x7, 0
	.dw	0x2, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2857 
;2858   { RW_DATA, 22,3,  0.0001, VAR(vlimPlus),    7,3, strF32, chgF32, set_plim
	.db	0x1
	.db	0x16
	.db	0x3
	.dw	0xffffb717, 0x38d1
	.dl	phys _vlimPlus
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	word _chgF32
	.dw	word _set_plim
;2859   { RW_DATA, 22,4,  0.0001, VAR(vlimMinus),   7,3, strF32, chgF32, set_mlim
	.db	0x1
	.db	0x16
	.db	0x4
	.dw	0xffffb717, 0x38d1
	.dl	phys _vlimMinus
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	word _chgF32
	.dw	word _set_mlim
;2860   { RO_DATA, 22,5,  0.0,    VAR(vctrl),       7,3, strF32,       NULL, NULL
	.db	0
	.db	0x16
	.db	0x5
	.dw	0, 0
	.dl	phys _vctrl
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2861 
;2862   { RO_DATA, 38,3,  0.0,    VAR(polCmd),     -1,1, fetStr,       NULL, NULL
	.db	0
	.db	0x26
	.db	0x3
	.dw	0, 0
	.dl	phys _polCmd
	.dw	0x2
	.dw	0xffffffff, 0xffff
	.dw	0x1, 0
	.dw	word _fetStr
	.dw	0
	.dw	0
;2863   { RO_DATA, 38,4,  0.0,    VAR(Cur.regPol), -1,1, polStr,       NULL, NULL
	.db	0
	.db	0x26
	.db	0x4
	.dw	0, 0
	.dl	phys _curState+292
	.dw	0x1
	.dw	0xffffffff, 0xffff
	.dw	0x1, 0
	.dw	word _polStr
	.dw	0
	.dw	0
;2864   { RO_DATA, 36,5,  0.0,    VAR(outMode),    -5,5, strOutMode,   NULL, NULL
	.db	0
	.db	0x24
	.db	0x5
	.dw	0, 0
	.dl	phys _outMode
	.dw	0x2
	.dw	0xfffffffb, 0xffff
	.dw	0x5, 0
	.dw	word _strOutMode
	.dw	0
	.dw	0
;2865 
;2866   { RO_DATA, 22,6,  0.0,    VAR(loadType),    8,8, loadTypeStr,  NULL, NULL
	.db	0
	.db	0x16
	.db	0x6
	.dw	0, 0
	.dl	phys _loadType
	.dw	0x2
	.dw	0x8, 0
	.dw	0x8, 0
	.dw	word _loadTypeStr
	.dw	0
	.dw	0
;2867   { RO_DATA, 38,6,  0.0,    VAR(supplyType),  3,3, supTypeStr,   NULL, NULL
	.db	0
	.db	0x26
	.db	0x6
	.dw	0, 0
	.dl	phys _supplyType
	.dw	0x2
	.dw	0x3, 0
	.dw	0x3, 0
	.dw	word _supTypeStr
	.dw	0
	.dw	0
;2868 
;2869   { RO_DATA,  8,7,  0.0,    VAR(digitalIn),  -3,3, strHolec,     NULL, NULL
	.db	0
	.db	0x8
	.db	0x7
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0xfffffffd, 0xffff
	.dw	0x3, 0
	.dw	word _strHolec
	.dw	0
	.dw	0
;2870   { RO_DATA, 21,7,  0.0,    VAR(digitalIn),  -5,5, strIlk,       NULL, NULL
	.db	0
	.db	0x15
	.db	0x7
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0xfffffffb, 0xffff
	.dw	0x5, 0
	.dw	word _strIlk
	.dw	0
	.dw	0
;2871   { RO_DATA, 28,7,  0.0,    VAR(state),      -4,4, strCtlState,  NULL, NULL
	.db	0
	.db	0x1c
	.db	0x7
	.dw	0, 0
	.dl	phys _state
	.dw	0x2
	.dw	0xfffffffc, 0xffff
	.dw	0x4, 0
	.dw	word _strCtlState
	.dw	0
	.dw	0
;2872   { RO_DATA, 39,7,  0.0,    VAR(psCount),     2,0, strU16,       NULL, NULL
	.db	0
	.db	0x27
	.db	0x7
	.dw	0, 0
	.dl	phys _psCount
	.dw	0x2
	.dw	0x2, 0
	.dw	0, 0
	.dw	word _strU16
	.dw	0
	.dw	0
;2873 
;2874 
;2875   { 0,        0,0,  0.0,    NULL,              0,0, NULL, NULL, NULL }
	.db	0
	.db	0
	.db	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0
;2876 };
	.ds	2,0
	.debug	G _mainElems 79 8
;2877 PAGE_DEF(main, "MAIN");
	.dseg
_mainPage::
	.dw	word (phys @1+2651)
	.dw	phys @1+2651 >> 16
	.dw	word _mainText
	.dl	phys _mainElems
	.dl	phys _mainElems
	.debug	G _mainPage 81 8
;2878 
;2879 //========================================================================
;2880 PAGE_TEXT(ps1) = {
;2881 //----------------------------------------
;2882  "    --Bias- --Cur--  On  Temp Avail Ena ",
_ps1Text::
	.dw	word (phys @1+2656)
	.dw	phys @1+2656 >> 16
;2883  "  1.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2697)
	.dw	phys @1+2697 >> 16
;2884  "  2.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2738)
	.dw	phys @1+2738 >> 16
;2885  "  3.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2779)
	.dw	phys @1+2779 >> 16
;2886  "  4.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2820)
	.dw	phys @1+2820 >> 16
;2887  "  5.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2861)
	.dw	phys @1+2861 >> 16
;2888  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;2889 //----------------------------------------
;2890  NULL
;2891 
	.dw	0, 0
	.debug	G _ps1Text 78 0
;2892 PAGE_ELEMS(ps1) = {
;2893 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;2894   { RO_DATA,  5,2,  0.0,  VAR(bsv_1),       7,3, strF32, NULL, NULL },
	.seg	FARCONST
_ps1Elems::
	.db	0
	.db	0x5
	.db	0x2
	.dw	0, 0
	.dl	phys _bsv_1
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2895   { RO_DATA,  5,3,  0.0,  VAR(bsv_2),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x3
	.dw	0, 0
	.dl	phys _bsv_2
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2896   { RO_DATA,  5,4,  0.0,  VAR(bsv_3),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x4
	.dw	0, 0
	.dl	phys _bsv_3
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2897   { RO_DATA,  5,5,  0.0,  VAR(bsv_4),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x5
	.dw	0, 0
	.dl	phys _bsv_4
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2898   { RO_DATA,  5,6,  0.0,  VAR(bsv_5),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x6
	.dw	0, 0
	.dl	phys _bsv_5
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2899 
;2900   { RO_DATA, 13,2,  0.0,  VAR(amps_1),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x2
	.dw	0, 0
	.dl	phys _amps_1
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2901   { RO_DATA, 13,3,  0.0,  VAR(amps_2),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x3
	.dw	0, 0
	.dl	phys _amps_2
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2902   { RO_DATA, 13,4,  0.0,  VAR(amps_3),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x4
	.dw	0, 0
	.dl	phys _amps_3
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2903   { RO_DATA, 13,5,  0.0,  VAR(amps_4),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x5
	.dw	0, 0
	.dl	phys _amps_4
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2904   { RO_DATA, 13,6,  0.0,  VAR(amps_5),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x6
	.dw	0, 0
	.dl	phys _amps_5
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2905 
;2906   { RO_DATA, 22,2,  0.0,  VAR(digitalOut), PS1_SET_ON,0, bitYN, NULL, NULL 
	.db	0
	.db	0x16
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x400, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2907   { RO_DATA, 22,3,  0.0,  VAR(digitalOut), PS2_SET_ON,0, bitYN, NULL, NULL 
	.db	0
	.db	0x16
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x100, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2908   { RO_DATA, 22,4,  0.0,  VAR(digitalOut), PS3_SET_ON,0, bitYN, NULL, NULL 
	.db	0
	.db	0x16
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x20, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2909   { RO_DATA, 22,5,  0.0,  VAR(digitalOut), PS4_SET_ON,0, bitYN, NULL, NULL 
	.db	0
	.db	0x16
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x8, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2910   { RO_DATA, 22,6,  0.0,  VAR(digitalOut), PS5_SET_ON,0, bitYN, NULL, NULL 
	.db	0
	.db	0x16
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x2, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2911 
;2912   { RO_DATA, 24,2,  0.0,  VAR(digitalIn), PS1_IS_ON,0, bitYN, NULL, NULL },
	.db	0
	.db	0x18
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x100
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2913   { RO_DATA, 24,3,  0.0,  VAR(digitalIn), PS2_IS_ON,0, bitYN, NULL, NULL },
	.db	0
	.db	0x18
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x4
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2914   { RO_DATA, 24,4,  0.0,  VAR(digitalIn), PS3_IS_ON,0, bitYN, NULL, NULL },
	.db	0
	.db	0x18
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x1000, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2915   { RO_DATA, 24,5,  0.0,  VAR(digitalIn), PS4_IS_ON,0, bitYN, NULL, NULL },
	.db	0
	.db	0x18
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x40, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2916   { RO_DATA, 24,6,  0.0,  VAR(digitalIn), PS5_IS_ON,0, bitYN, NULL, NULL },
	.db	0
	.db	0x18
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x1, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2917 
;2918   { RO_DATA, 27,2,  0.0,  VAR(digitalIn), PS1_TEMP_OK,0, bitOB, NULL, NULL 
	.db	0
	.db	0x1b
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x400
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2919   { RO_DATA, 27,3,  0.0,  VAR(digitalIn), PS2_TEMP_OK,0, bitOB, NULL, NULL 
	.db	0
	.db	0x1b
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x10
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2920   { RO_DATA, 27,4,  0.0,  VAR(digitalIn), PS3_TEMP_OK,0, bitOB, NULL, NULL 
	.db	0
	.db	0x1b
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x4000, 0
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2921   { RO_DATA, 27,5,  0.0,  VAR(digitalIn), PS4_TEMP_OK,0, bitOB, NULL, NULL 
	.db	0
	.db	0x1b
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x100, 0
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2922   { RO_DATA, 27,6,  0.0,  VAR(digitalIn), PS5_TEMP_OK,0, bitOB, NULL, NULL 
	.db	0
	.db	0x1b
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x4, 0
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2923 
;2924   { RO_DATA, 32,2,  0.0,  VAR(digitalIn), PS1_AVAIL,0, bitYN_, NULL, NULL }
	.db	0
	.db	0x20
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x200
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2925   { RO_DATA, 32,3,  0.0,  VAR(digitalIn), PS2_AVAIL,0, bitYN_, NULL, NULL }
	.db	0
	.db	0x20
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x8
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2926   { RO_DATA, 32,4,  0.0,  VAR(digitalIn), PS3_AVAIL,0, bitYN_, NULL, NULL }
	.db	0
	.db	0x20
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x2000, 0
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2927   { RO_DATA, 32,5,  0.0,  VAR(digitalIn), PS4_AVAIL,0, bitYN_, NULL, NULL }
	.db	0
	.db	0x20
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x80, 0
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2928   { RO_DATA, 32,6,  0.0,  VAR(digitalIn), PS5_AVAIL,0, bitYN_, NULL, NULL }
	.db	0
	.db	0x20
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x2, 0
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2929 
;2930   { RO_DATA, 37,2,  0.0,  ENABLED(1),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x2
	.dw	0, 0
	.dl	phys _nextState+26
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2931   { RO_DATA, 37,3,  0.0,  ENABLED(2),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x3
	.dw	0, 0
	.dl	phys _nextState+54
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2932   { RO_DATA, 37,4,  0.0,  ENABLED(3),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x4
	.dw	0, 0
	.dl	phys _nextState+82
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2933   { RO_DATA, 37,5,  0.0,  ENABLED(4),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x5
	.dw	0, 0
	.dl	phys _nextState+110
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2934   { RO_DATA, 37,6,  0.0,  ENABLED(5),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x6
	.dw	0, 0
	.dl	phys _nextState+138
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2935 
;2936   { 0,        0,0,  0.0,  NULL,             0,0, NULL, NULL, NULL }
	.db	0
	.db	0
	.db	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0
;2937 };
	.ds	2,0
	.debug	G _ps1Elems 82 8
;2938 PAGE_DEF(ps1, "S1-5");
	.dseg
_ps1Page::
	.dw	word (phys @1+2902)
	.dw	phys @1+2902 >> 16
	.dw	word _ps1Text
	.dl	phys _ps1Elems
	.dl	phys _ps1Elems
	.debug	G _ps1Page 81 8
;2939 
;2940 
;2941 //========================================================================
;2942 PAGE_TEXT(ps2) = {
;2943 //----------------------------------------
;2944  "    --Bias- --Cur--  On  Temp Avail Ena ",
_ps2Text::
	.dw	word (phys @1+2656)
	.dw	phys @1+2656 >> 16
;2945  "  6.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2907)
	.dw	phys @1+2907 >> 16
;2946  "  7.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2948)
	.dw	phys @1+2948 >> 16
;2947  "  8.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+2989)
	.dw	phys @1+2989 >> 16
;2948  "  9.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+3030)
	.dw	phys @1+3030 >> 16
;2949  " 10.-##.### -###.##  #/#  ###  ###  ### ",
	.dw	word (phys @1+3071)
	.dw	phys @1+3071 >> 16
;2950  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;2951 //----------------------------------------
;2952  NULL
;2953 
	.dw	0, 0
	.debug	G _ps2Text 78 0
;2954 PAGE_ELEMS(ps2) = {
;2955 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;2956   { RO_DATA,  5,2,  0.0,  VAR(bsv_6),       7,3, strF32, NULL, NULL },
	.seg	FARCONST
_ps2Elems::
	.db	0
	.db	0x5
	.db	0x2
	.dw	0, 0
	.dl	phys _bsv_6
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2957   { RO_DATA,  5,3,  0.0,  VAR(bsv_7),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x3
	.dw	0, 0
	.dl	phys _bsv_7
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2958   { RO_DATA,  5,4,  0.0,  VAR(bsv_8),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x4
	.dw	0, 0
	.dl	phys _bsv_8
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2959   { RO_DATA,  5,5,  0.0,  VAR(bsv_9),       7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x5
	.dw	0, 0
	.dl	phys _bsv_9
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2960   { RO_DATA,  5,6,  0.0,  VAR(bsv_10),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0x5
	.db	0x6
	.dw	0, 0
	.dl	phys _bsv_10
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2961 
;2962   { RO_DATA, 13,2,  0.0,  VAR(amps_6),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x2
	.dw	0, 0
	.dl	phys _amps_6
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2963   { RO_DATA, 13,3,  0.0,  VAR(amps_7),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x3
	.dw	0, 0
	.dl	phys _amps_7
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2964   { RO_DATA, 13,4,  0.0,  VAR(amps_8),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x4
	.dw	0, 0
	.dl	phys _amps_8
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2965   { RO_DATA, 13,5,  0.0,  VAR(amps_9),      7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x5
	.dw	0, 0
	.dl	phys _amps_9
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2966   { RO_DATA, 13,6,  0.0,  VAR(amps_10),     7,3, strF32, NULL, NULL },
	.db	0
	.db	0xd
	.db	0x6
	.dw	0, 0
	.dl	phys _amps_10
	.dw	0x4
	.dw	0x7, 0
	.dw	0x3, 0
	.dw	word _strF32
	.dw	0
	.dw	0
;2967 
;2968   { RO_DATA, 22,2,  0.0,  VAR(digitalOut), PS6_SET_ON,0,  bitYN, NULL, NULL
	.db	0
	.db	0x16
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x200, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2969   { RO_DATA, 22,3,  0.0,  VAR(digitalOut), PS7_SET_ON,0,  bitYN, NULL, NULL
	.db	0
	.db	0x16
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x40, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2970   { RO_DATA, 22,4,  0.0,  VAR(digitalOut), PS8_SET_ON,0,  bitYN, NULL, NULL
	.db	0
	.db	0x16
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x10, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2971   { RO_DATA, 22,5,  0.0,  VAR(digitalOut), PS9_SET_ON,0,  bitYN, NULL, NULL
	.db	0
	.db	0x16
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x4, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2972   { RO_DATA, 22,6,  0.0,  VAR(digitalOut), PS10_SET_ON,0, bitYN, NULL, NULL
	.db	0
	.db	0x16
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalOut
	.dw	0x4
	.dw	0x1, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2973   { RO_DATA, 24,2,  0.0,  VAR(digitalIn), PS6_IS_ON,0,  bitYN, NULL, NULL }
	.db	0
	.db	0x18
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x800
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2974   { RO_DATA, 24,3,  0.0,  VAR(digitalIn), PS7_IS_ON,0,  bitYN, NULL, NULL }
	.db	0
	.db	0x18
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x20
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2975   { RO_DATA, 24,4,  0.0,  VAR(digitalIn), PS8_IS_ON,0,  bitYN, NULL, NULL }
	.db	0
	.db	0x18
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0xffff8000, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2976   { RO_DATA, 24,5,  0.0,  VAR(digitalIn), PS9_IS_ON,0,  bitYN, NULL, NULL }
	.db	0
	.db	0x18
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x200, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2977   { RO_DATA, 24,6,  0.0,  VAR(digitalIn), PS10_IS_ON,0, bitYN, NULL, NULL }
	.db	0
	.db	0x18
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x8, 0
	.dw	0, 0
	.dw	word _bitYN
	.dw	0
	.dw	0
;2978 
;2979   { RO_DATA, 27,2,  0.0,  VAR(digitalIn), PS6_TEMP_OK,0,  bitOB, NULL, NULL
	.db	0
	.db	0x1b
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x2000
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2980   { RO_DATA, 27,3,  0.0,  VAR(digitalIn), PS7_TEMP_OK,0,  bitOB, NULL, NULL
	.db	0
	.db	0x1b
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x80
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2981   { RO_DATA, 27,4,  0.0,  VAR(digitalIn), PS8_TEMP_OK,0,  bitOB, NULL, NULL
	.db	0
	.db	0x1b
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x2
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2982   { RO_DATA, 27,5,  0.0,  VAR(digitalIn), PS9_TEMP_OK,0,  bitOB, NULL, NULL
	.db	0
	.db	0x1b
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x800, 0
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2983   { RO_DATA, 27,6,  0.0,  VAR(digitalIn), PS10_TEMP_OK,0, bitOB, NULL, NULL
	.db	0
	.db	0x1b
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x20, 0
	.dw	0, 0
	.dw	word _bitOB
	.dw	0
	.dw	0
;2984 
;2985   { RO_DATA, 32,2,  0.0,  VAR(digitalIn), PS6_AVAIL,0,  bitYN_, NULL, NULL 
	.db	0
	.db	0x20
	.db	0x2
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x1000
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2986   { RO_DATA, 32,3,  0.0,  VAR(digitalIn), PS7_AVAIL,0,  bitYN_, NULL, NULL 
	.db	0
	.db	0x20
	.db	0x3
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x40
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2987   { RO_DATA, 32,4,  0.0,  VAR(digitalIn), PS8_AVAIL,0,  bitYN_, NULL, NULL 
	.db	0
	.db	0x20
	.db	0x4
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0, 0x1
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2988   { RO_DATA, 32,5,  0.0,  VAR(digitalIn), PS9_AVAIL,0,  bitYN_, NULL, NULL 
	.db	0
	.db	0x20
	.db	0x5
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x400, 0
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2989   { RO_DATA, 32,6,  0.0,  VAR(digitalIn), PS10_AVAIL,0, bitYN_, NULL, NULL 
	.db	0
	.db	0x20
	.db	0x6
	.dw	0, 0
	.dl	phys _digitalIn
	.dw	0x4
	.dw	0x10, 0
	.dw	0, 0
	.dw	word _bitYN_
	.dw	0
	.dw	0
;2990 
;2991   { RO_DATA, 37,2,  0.0,  ENABLED(6),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x2
	.dw	0, 0
	.dl	phys _nextState+166
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2992   { RO_DATA, 37,3,  0.0,  ENABLED(7),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x3
	.dw	0, 0
	.dl	phys _nextState+194
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2993   { RO_DATA, 37,4,  0.0,  ENABLED(8),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x4
	.dw	0, 0
	.dl	phys _nextState+222
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2994   { RO_DATA, 37,5,  0.0,  ENABLED(9),       3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x5
	.dw	0, 0
	.dl	phys _nextState+250
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2995   { RO_DATA, 37,6,  0.0,  ENABLED(10),      3,0, enaYN, NULL, NULL },
	.db	0
	.db	0x25
	.db	0x6
	.dw	0, 0
	.dl	phys _nextState+278
	.dw	0x1
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _enaYN
	.dw	0
	.dw	0
;2996 
;2997   { 0,        0,0,  0.0,  NULL,             0,0, NULL, NULL, NULL }
	.db	0
	.db	0
	.db	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0
;2998 };
	.ds	2,0
	.debug	G _ps2Elems 82 8
;2999 PAGE_DEF(ps2, "S6-10");
	.dseg
_ps2Page::
	.dw	word (phys @1+3112)
	.dw	phys @1+3112 >> 16
	.dw	word _ps2Text
	.dl	phys _ps2Elems
	.dl	phys _ps2Elems
	.debug	G _ps2Page 81 8
;3000 
;3001 
;3002 //========================================================================
;3003 PAGE_TEXT(config) = {
;3004 //----------------------------------------
;3005  "Contrast: ### ",
_configText::
	.dw	word (phys @1+3118)
	.dw	phys @1+3118 >> 16
;3006  "Load Type: ######## ",
	.dw	word (phys @1+3133)
	.dw	phys @1+3133 >> 16
;3007  "Bridge Type: ### ",
	.dw	word (phys @1+3154)
	.dw	phys @1+3154 >> 16
;3008  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;3009  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;3010  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;3011  " ",
	.dw	word (phys @1+2444)
	.dw	phys @1+2444 >> 16
;3012 //----------------------------------------
;3013  NULL
;3014 
	.dw	0, 0
	.debug	G _configText 78 0
;3015 
;3016 //------------------------------------------------------------------------
;3017 //--- contrast ---
;3018 LCD_CHG_FUNC(chgContr)  {
	.seg	FARCODE
	.align	4
$$chgContr::
	ex	(sp),iy
$chgContr::
	.debug	G $chgContr 76 9
	.debug	{ $chgContr 76 3018 @335 @334
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;3019   int ii = LCD_VAL(U16);
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
;3020   ii += (int)chgBy;
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,de
	ld	(ix-2),hl
;3021   if (ii < 5)  ii = 5;
	ld	de,0x8005
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@336
	ld	hl,0x5
	ld	(ix-2),hl
;3022   if (ii > 200)  ii = 200;
@336:
	ld	hl,(ix-2)
	ld	de,0x80c8
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@337
	jr	z,@337
	ld	hl,0xc8
	ld	(ix-2),hl
;3023   if ((uint)ii != LCD_VAL(U16))  { LCD_VAL(U16) = ii;  return true; }
@337:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@338
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__farst2##
	ld	a,0x1
	jr	@334
;3024   return false;
@338:
	xor	a,a
;3025 }
@334:
	.debug	} @334 3025

@333	equ	2
	ld	sp,ix
	pop	ix
	lret
@335	equ	4
;3026 LCD_SET_REG_FUNC(setContr, contrast, U16)
	.align	4
$$setContr::
	ex	(sp),iy
$setContr::
	.debug	G $setContr 77 9
	.debug	{ $setContr 77 3026 @343 @342
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-66
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
	ld	hl,-66+@341
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,2+@341
	add	hl,sp
	push	hl
	ld	hl,_contrast_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_contrast_RegInfo+4)
	ld	bc,(_contrast_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,0+@341
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_contrast_RegInfo
	push	hl
	ld	de,(_contrast_RegInfo+8)
	call	__callde##
	add	sp,8
@342:
	.debug	} @342 3026

@341	equ	66
	ld	sp,ix
	pop	ix
	lret
@343	equ	68
;3027 LCD_SET_REG_FUNC(setContr, contrast, U16)
;3028 //--- loadType ---
;3029 LCD_CHG_FUNC(chgLTyp)  {
	.align	4
$$chgLTyp::
	ex	(sp),iy
$chgLTyp::
	.debug	G $chgLTyp 76 9
	.debug	{ $chgLTyp 76 3029 @346 @345
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;3030   int ii = LCD_VAL(U16);
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
;3031   ii += (int)chgBy;
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,de
	ld	(ix-2),hl
;3032   if (ii < 0)  ii = 0;
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@347
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;3033   if (ii > 2)  ii = 2;
@347:
	ld	hl,(ix-2)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@348
	jr	z,@348
	ld	hl,0x2
	ld	(ix-2),hl
;3034   if ((uint)ii != LCD_VAL(U16))  { LCD_VAL(U16) = ii;  return true; }
@348:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@349
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__farst2##
	ld	a,0x1
	jr	@345
;3035   return false;
@349:
	xor	a,a
;3036 }
@345:
	.debug	} @345 3036

@344	equ	2
	ld	sp,ix
	pop	ix
	lret
@346	equ	4
;3037 LCD_SET_REG_FUNC(setLTyp, loadType, U16)
	.align	4
$$setLTyp::
	ex	(sp),iy
$setLTyp::
	.debug	G $setLTyp 77 9
	.debug	{ $setLTyp 77 3037 @354 @353
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-66
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
	ld	hl,-66+@352
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,2+@352
	add	hl,sp
	push	hl
	ld	hl,_loadType_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_loadType_RegInfo+4)
	ld	bc,(_loadType_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,0+@352
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_loadType_RegInfo
	push	hl
	ld	de,(_loadType_RegInfo+8)
	call	__callde##
	add	sp,8
@353:
	.debug	} @353 3037

@352	equ	66
	ld	sp,ix
	pop	ix
	lret
@354	equ	68
;3038 LCD_SET_REG_FUNC(setLTyp, loadType, U16)
;3039 //--- supplyType ---
;3040 LCD_CHG_FUNC(chgSTyp)  {
	.align	4
$$chgSTyp::
	ex	(sp),iy
$chgSTyp::
	.debug	G $chgSTyp 76 9
	.debug	{ $chgSTyp 76 3040 @357 @356
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;3041   int ii = LCD_VAL(U16);
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
;3042   ii += (int)chgBy;
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,de
	ld	(ix-2),hl
;3043   if (ii < 0)  ii = 0;
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@358
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;3044   if (ii > 2)  ii = 2;
@358:
	ld	hl,(ix-2)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@359
	jr	z,@359
	ld	hl,0x2
	ld	(ix-2),hl
;3045   if ((uint)ii != LCD_VAL(U16))  { LCD_VAL(U16) = ii;  return true; }
@359:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@360
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__farst2##
	ld	a,0x1
	jr	@356
;3046   return false;
@360:
	xor	a,a
;3047 }
@356:
	.debug	} @356 3047

@355	equ	2
	ld	sp,ix
	pop	ix
	lret
@357	equ	4
;3048 LCD_SET_REG_FUNC(setSTyp, supplyType, U16)
	.align	4
$$setSTyp::
	ex	(sp),iy
$setSTyp::
	.debug	G $setSTyp 77 9
	.debug	{ $setSTyp 77 3048 @365 @364
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-66
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
	ld	hl,-66+@363
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,2+@363
	add	hl,sp
	push	hl
	ld	hl,_supplyType_RegInfo
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	de,(_supplyType_RegInfo+4)
	ld	bc,(_supplyType_RegInfo+6)
	push	bc
	push	de
	ld	de,word (phys @1+2379)
	ld	c,phys @1+2379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
	ld	hl,0xffff
	push	hl
	ld	hl,0+@363
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_supplyType_RegInfo
	push	hl
	ld	de,(_supplyType_RegInfo+8)
	call	__callde##
	add	sp,8
@364:
	.debug	} @364 3048

@363	equ	66
	ld	sp,ix
	pop	ix
	lret
@365	equ	68
;3049 LCD_SET_REG_FUNC(setSTyp, supplyType, U16)
;3050 //------------------------------------------------------------------------
;3051 PAGE_ELEMS(config) = {
;3052 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;3053   { RW_DATA, 11,1,  0.005,  VAR(contrast),    3,0, strU16,  chgContr,setCon
	.seg	FARCONST
_configElems::
	.db	0x1
	.db	0xb
	.db	0x1
	.dw	0xffffd70a, 0x3ba3
	.dl	phys _contrast
	.dw	0x2
	.dw	0x3, 0
	.dw	0, 0
	.dw	word _strU16
	.dw	word _chgContr
	.dw	word _setContr
;3054   { RW_DATA, 12,2,  0.001,  VAR(loadType),    8,8, loadTypeStr,chgLTyp,setL
	.db	0x1
	.db	0xc
	.db	0x2
	.dw	0x126f, 0x3a83
	.dl	phys _loadType
	.dw	0x2
	.dw	0x8, 0
	.dw	0x8, 0
	.dw	word _loadTypeStr
	.dw	word _chgLTyp
	.dw	word _setLTyp
;3055   { RW_DATA, 14,3,  0.001,  VAR(supplyType),  3,3, supTypeStr, chgSTyp,setS
	.db	0x1
	.db	0xe
	.db	0x3
	.dw	0x126f, 0x3a83
	.dl	phys _supplyType
	.dw	0x2
	.dw	0x3, 0
	.dw	0x3, 0
	.dw	word _supTypeStr
	.dw	word _chgSTyp
	.dw	word _setSTyp
;3056 
;3057   { 0,        0,0,  0.0,    NULL,              0,0, NULL, NULL, NULL }
	.db	0
	.db	0
	.db	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0
;3058 };
	.ds	2,0
	.debug	G _configElems 83 8
;3059 PAGE_DEF(config, "CONFIG");
	.dseg
_configPage::
	.dw	word (phys @1+3172)
	.dw	phys @1+3172 >> 16
	.dw	word _configText
	.dl	phys _configElems
	.dl	phys _configElems
	.debug	G _configPage 81 8
;3060 
;3061 
;3062 //========================================================================
;3063 /*
;3064 PAGE_TEXT(pageName) = {
;3065 //----------------------------------------
;3066  "........................................",
;3067  "........................................",
;3068  "........................................",
;3069  "........................................",
;3070  "........................................",
;3071  "........................................",
;3072  "........................................",
;3073 //----------------------------------------
;3074  NULL
;3075 };
;3076 
;3077 PAGE_ELEMS(pageName) = {
;3078 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;3079   { RW_DATA, ##,#,  #.###,  VAR(varName),    #,#,  xxxxxx,  xxxxxx, xxxxxx 
;3080 
;3081   { 0,        0,0,  0.0,    NULL,              0,0, NULL, NULL, NULL }
;3082 };
;3083 PAGE_DEF(pageName, "PAGE NAME");
;3084 
;3085 */
;3086 
;3087 //========================================================================
;3088 PAGE_TEXT(list) = { NULL };
_listText::
	.dw	0, 0
	.debug	G _listText 84 0
;3089 
;3090 PAGE_ELEMS(list) = {
;3091 //{ type,     C,R, chgRate, *val,valSize,   p1,p2, fmtFunc, chgFunc, setFun
;3092   { PAGE_REF, 1,1,  0.0,   VAR(mainPage),    0,0,  pageName,  NULL, NULL },
	.seg	FARCONST
_listElems::
	.db	0x2
	.db	0x1
	.db	0x1
	.dw	0, 0
	.dl	phys _mainPage
	.dw	0xe
	.dw	0, 0
	.dw	0, 0
	.dw	word _pageName
	.dw	0
	.dw	0
;3093   { PAGE_REF, 1,2,  0.0,   VAR(ps1Page),     0,0,  pageName,  NULL, NULL },
	.db	0x2
	.db	0x1
	.db	0x2
	.dw	0, 0
	.dl	phys _ps1Page
	.dw	0xe
	.dw	0, 0
	.dw	0, 0
	.dw	word _pageName
	.dw	0
	.dw	0
;3094   { PAGE_REF, 1,3,  0.0,   VAR(ps2Page),     0,0,  pageName,  NULL, NULL },
	.db	0x2
	.db	0x1
	.db	0x3
	.dw	0, 0
	.dl	phys _ps2Page
	.dw	0xe
	.dw	0, 0
	.dw	0, 0
	.dw	word _pageName
	.dw	0
	.dw	0
;3095   { PAGE_REF, 1,4,  0.0,   VAR(configPage),  0,0,  pageName,  NULL, NULL },
	.db	0x2
	.db	0x1
	.db	0x4
	.dw	0, 0
	.dl	phys _configPage
	.dw	0xe
	.dw	0, 0
	.dw	0, 0
	.dw	word _pageName
	.dw	0
	.dw	0
;3096 
;3097   { 0,        0,0,  0.0,  NULL,            0,0, NULL, NULL, NULL }
	.db	0
	.db	0
	.db	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.dw	0
	.dw	0
;3098 };
	.ds	2,0
	.debug	G _listElems 85 8
;3099 PAGE_DEF(list, "LIST");
	.dseg
_listPage::
	.dw	word (phys @1+3179)
	.dw	phys @1+3179 >> 16
	.dw	word _listText
	.dl	phys _listElems
	.dl	phys _listElems
	.debug	G _listPage 81 8
;3100 
;3101 //========================================================================
;3102 
;3103 /*
;3104 //----------------------------------------
;3105  "........................................",
;3106  "........................................",
;3107  "........................................",
;3108  "........................................",
;3109  "........................................",
;3110  "........................................",
;3111  "........................................",
;3112 //----------------------------------------
;3113 */
;3114 
;3115 
;3116 //-------------------------------------------------------------------------
;3117   #define SetNormal(fd)  { 
;3118         write(fd, "\376\061\001\376\062\000\000\000\001\100", 10); }
;3119   #define SetReverse(fd)  { 
;3120         write(fd, "\376\061\002\376\062\000\000\000\001\100", 10); }
;3121   #define ResetLCD(fd)  {  
;3122       write(fd, "\376\223\001\376\071\147\376\120\200\376\223\000", 12);  
;3123       write(fd, "\376\072\024\024\376\130\376\122", 8);  SetNormal(fd);  
;3124 }
;3125 
;3126 //-------------------------------------------------------------------------
;3127 //  Change the current element ptr for a page to the next/prev page element
;3128 //  that can be altered
;3129 //
;3130 //  If no such elements, then the ptr is left unchanged
;3131 //
;3132 //  delta determines direction (>=0 means next, < 0 means prev)
;3133 //-------------------------------------------------------------------------
;3134 void chgFocus(PageDef far *page, int delta)
;3135 {
	.seg	FARCODE
$chgFocus::
	.debug	G $chgFocus 86 9
	.debug	{ $chgFocus 86 3134 @368 @367
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;3136   LCDElem far *elem = page->cur;
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;3137 
;3138   for (;;)  {
@371:
;3139     if (delta < 0)  --elem;  else  ++elem;
	ld	hl,(ix+9)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@376
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffe5
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	jr	@377
@376:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3140     if ((elem < page->elems) OR !elem->col)  return;
@377:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fpcmpr##
	jr	c,@367
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__linc##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@367
;3141     if (elem->type != RO_DATA)  { page->cur = elem;  return; }
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@380
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farst4d##
	jr	@367
;3142   }
@380:
;3143 }
	jp	@371
@367:
	.debug	} @367 3143

@366	equ	4
	ld	sp,ix
	pop	ix
	lret
@368	equ	6
;3144 
;3145 
;3146 //-------------------------------------------------------------------------
;3147 //  display the static text for an LCD display page
;3148 //-------------------------------------------------------------------------
;3149 void updateLCD(fd_t fd, PageDef far *page, void far *modVal)
;3150 {
$updateLCD::
	.debug	G $updateLCD 87 9
	.debug	{ $updateLCD 87 3149 @385 @384
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-64
;3151   uchar  i;
;3152   bool  hasFocus;
;3153   char far **ptr;
;3154   char  *str;
;3155   void far  *val;
;3156   LCDElem far *elem;
;3157   char  temp[50];
;3158   static PageDef far *lastPage = NULL;
	.dseg
@386:
	.dw	0, 0
	.seg	FARCODE
;3159 
;3160 
;3161   SetNormal(fd);
	ld	hl,0xa
	push	hl
	ld	hl,@2+249
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
;3162 
;3163 //--- clear screen and draw static text if page changed ---
;3164   if (page != lastPage)  {
	ld	de,(@386)
	ld	bc,(@386+2)
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__fpcmp##
	jp	z,@389
;3165   //--- Home + CLS, disable scrolling, set Normal font ---
;3166     write(fd, "\376\130\376\122", 4);  SetNormal(fd);
	ld	hl,0x4
	push	hl
	ld	hl,@2+260
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
	ld	hl,0xa
	push	hl
	ld	hl,@2+249
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
;3167 
;3168     temp[41] = 0;   ptr = (char far **) page->text;
	xor	a,a
	ld	(ix-23),a
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;3169     for (i=1; *ptr; ++i,++ptr)  {
	ld	(ix-1),0x1
@396:
	ld	hl,(ix-4)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@397
;3170       sprintf(temp, "\376\107\001%c%.41ls", i, *ptr);
	ld	hl,(ix-4)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+3184)
	ld	c,phys @1+3184 >> 16
	push	bc
	push	de
	ld	hl,-54+@383
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,14
;3171       write(fd, temp, strlen(temp));
	ld	hl,-64+@383
	add	hl,sp
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,-62+@383
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
;3172     }
;3173 
;3174     lastPage = page;
	ld	a,(ix-1)
	inc	a
	ld	(ix-1),a
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	ld	(ix-4),hl
	jr	@396
@397:
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	(@386),de
	ld	(@386+2),bc
;3175   }
;3176 
;3177 //--- display the data and link elements ---
;3178   for (elem=page->elems; elem->col; ++elem)  {
@389:
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
@403:
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__linc##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jp	z,@404
;3179     hasFocus = (elem == page->cur);
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__fpcmp##
	ld	de,0
	jr	nz,@408
	inc	e
@408:
	ld	(ix-2),e
;3180     if (elem->type == RO_DATA)  hasFocus = false;
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	nz,@409
	xor	a,a
	ld	(ix-2),a
;3181 
;3182     val = elem->val;
@409:
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3183     if (hasFocus)  { SetReverse(fd);  if (modVal)  val = modVal;  }
	ld	a,(ix-2)
	or	a,a
	jr	z,@410
	ld	hl,0xa
	push	hl
	ld	hl,@2+265
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@415
	ld	h,b
	ld	l,c
	ld	bc,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
@415:
;3184 
;3185     sprintf(temp, "\376\107%c%c", elem->col, elem->row);  // set cursor pos
@410:
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__linc##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	de,word (phys @1+3196)
	ld	c,phys @1+3196 >> 16
	push	bc
	push	de
	ld	hl,-56+@383
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;3186     str = elem->fmtFunc(elem, val, temp+4);
	ld	hl,-60+@383
	add	hl,sp
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	push	bc
	push	de
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x15
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	pop	de
	pop	bc
	call	__callhl##
	add	sp,10
	ld	(ix-6),hl
;3187     if (str != temp+4)  strncpy(temp+4, str, (sizeof temp)-5);
	ld	hl,-60+@383
	add	hl,sp
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@416
	ld	hl,0x2d
	push	hl
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,-56+@383
	add	hl,sp
	push	hl
	call	_strncpy
	add	sp,6
;3188     temp[(sizeof temp)-1] = 0;  write(fd, temp, strlen(temp));
@416:
	xor	a,a
	ld	(ix-15),a
	ld	hl,-64+@383
	add	hl,sp
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,-62+@383
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
;3189 
;3190     if (hasFocus)  SetNormal(fd);
	ld	a,(ix-2)
	or	a,a
	jr	z,@417
	ld	hl,0xa
	push	hl
	ld	hl,@2+249
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
@417:
;3191   }
;3192 
;3193 }
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	jp	@403
@404:
@384:
	.debug	} @384 3193

@383	equ	64
	ld	sp,ix
	pop	ix
	lret
@385	equ	66
;3194 
;3195 
;3196 //-------------------------------------------------------------------------
;3197 //  Process to manage the front panel LCD display and monitor front panel
;3198 //  controls
;3199 //-------------------------------------------------------------------------
;3200 void _task lcdUI(int argc, char **argv)
;3201 {
	.align	4
$$lcdUI::
	ex	(sp),iy
$lcdUI::
	.debug	G $lcdUI 88 9
	.debug	{ $lcdUI 88 3200 @422 @421
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-114
;3202 #pragma warn -775
;3203 
;3204   fd_t  lcdfd;
;3205   int  delta, knobCount, newCount;
;3206   uint  flowChars, btnBits, prevBtnBits, curContrast, prevContrast;
;3207   bool  updateDisplay;
;3208   ulong  baudRate, lastKnobTime, lastUpdateTime;
;3209   float  chg;
;3210   char  contrByte;
;3211   void far  *modVal = NULL;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-38),hl
	ex	de,hl
	ld	(ix-40),hl
	ex	de,hl
	.seg	FARCODE
;3212   LCDElem far  *elem;
;3213   PageDef far  *page;
;3214   char  *lcdDev;
;3215   char  valBuf[64];
;3216 
;3217 
;3218   redirectStdio();
	lcall	$redirectStdio
;3219 
;3220 
;3221 //--- open port for LCD connection in Xon/Xoff mode ---
;3222   lcdDev = (hdwType == HT_MODULAR_PS) ? "/dev/ttyx2" : "/dev/ttyx3";
	ld	hl,(_hdwType)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nz,@423
	ld	hl,@2+276
	jr	@424
@423:
	ld	hl,@2+287
@424:
	ld	(ix-50),hl
;3223   if ((lcdfd = open(lcdDev, O_RDWR, 0)) < 0)  {
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,(ix-50)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@426
;3224     printf("Unable to open port for LCD\r\n");  Exit(-3); }
	ld	de,word (phys @1+3203)
	ld	c,phys @1+3203 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
;3225 
;3226 //--- set baud rate and Xon/Xoff chars ---
;3227   //finish - use std termio interface instead of non-std ioctl values
;3228   baudRate = 19200;  ioctl(lcdfd, IOC_SET_BAUD, &baudRate);
@426:
	ld	de,0x4b00
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-21),hl
	ex	de,hl
	ld	(ix-23),hl
	ex	de,hl
	ld	hl,-23+@420
	add	hl,sp
	push	hl
	ld	hl,0x3ea
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$ioctl
	add	sp,6
;3229   flowChars = 0xFFFE;  ioctl(lcdfd, IOC_SET_FLOW_CHARS, &flowChars);
	ld	hl,0xfffe
	ld	(ix-10),hl
	ld	hl,-10+@420
	add	hl,sp
	push	hl
	ld	hl,0x3f0
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$ioctl
	add	sp,6
;3230 
;3231 //--- Initialize LCD: ---
;3232 //---   Enable Flow Ctl, Xoff when 20 unused bytes, Xon when 20 unread byte
;3233 //---   Home + CLS, disable scrolling
;3234   write(lcdfd, "\376\072\024\024\376\130\376\122", 8);  SetNormal(lcdfd);
	ld	hl,0x8
	push	hl
	ld	hl,@2+298
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
	ld	hl,0xa
	push	hl
	ld	hl,@2+249
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
;3235 
;3236   page = (PageDef far *) &mainPage;  updateDisplay = true;
	ld	de,word (phys _mainPage)
	ld	c,phys _mainPage >> 16
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
	ld	(ix-19),0x1
;3237 
;3238 //--- get initial values ---
;3239   prevContrast = 0;
	bool	hl
	ld	l,h
	ld	(ix-18),hl
;3240   KLOCK();
	call	_KLOCK
;3241   btnBits = Cur.btnBits;  curContrast = contrast;
	ld	hl,(_curState+296)
	ld	(ix-12),hl
	ld	hl,(_contrast)
	ld	(ix-16),hl
;3242   KUNLOCK();
	call	_KUNLOCK
;3243   _EnterCritical_();  knobCount = qdCount = 0;  _ExitCritical_();
	ipset	2
	bool	hl
	ld	l,h
	ld	(_qdCount),hl
	ld	(ix-6),hl
	ipres
;3244 
;3245   lastUpdateTime = GetMS();  updateDisplay = true;
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-29),hl
	ex	de,hl
	ld	(ix-31),hl
	ex	de,hl
	ld	(ix-19),0x1
;3246 
;3247   for (;;)  {
@433:
;3248     if (! updateDisplay)  {
	ld	a,(ix-19)
	or	a,a
	jp	nz,@438
;3249       sleepMS(100);
	ld	de,0x64
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3250       if (msSince(lastUpdateTime) >= 500)  updateDisplay = true;
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f4
	ld	bc,0
	call	__lsub##
	jr	c,@441
	ld	(ix-19),0x1
;3251     }
@441:
;3252 
;3253   //--- update display periodically or because of user action ---
;3254     if (updateDisplay)  {
@438:
	ld	a,(ix-19)
	or	a,a
	jp	z,@442
;3255       lcdBlink = !lcdBlink;
	ld	a,(_lcdBlink)
	or	a,a
	ld	a,0
	jr	nz,@445
	inc	a
@445:
	ld	(_lcdBlink),a
;3256       updateLCD(lcdfd, page, modVal);  updateDisplay = false;
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$updateLCD
	add	sp,10
	xor	a,a
	ld	(ix-19),a
;3257       lastUpdateTime = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-29),hl
	ex	de,hl
	ld	(ix-31),hl
	ex	de,hl
;3258     }
;3259 
;3260   //--- get last recorded state of buttons ---
;3261     prevBtnBits = btnBits;
@442:
	ld	hl,(ix-12)
	ld	(ix-14),hl
;3262     KLOCK();
	call	_KLOCK
;3263     btnBits = Cur.btnBits;  curContrast = contrast;
	ld	hl,(_curState+296)
	ld	(ix-12),hl
	ld	hl,(_contrast)
	ld	(ix-16),hl
;3264     KUNLOCK();
	call	_KUNLOCK
;3265 
;3266   //--- get # of knob ticks since last pass and reset count ---
;3267     _EnterCritical_();  newCount = qdCount;  qdCount = 0;  _ExitCritical_()
	ipset	2
	ld	hl,(_qdCount)
	ld	(ix-8),hl
	bool	hl
	ld	l,h
	ld	(_qdCount),hl
	ipres
;3268 
;3269 
;3270     if (newCount)  {
	ld	hl,(ix-8)
	bool	hl
	jp	z,@446
;3271       lastKnobTime = GetMS();  knobCount += newCount;  }
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	add	hl,de
	ld	(ix-6),hl
;3272     else
;3273       if (msSince(lastKnobTime) > 500)  knobCount = 0;
	jp	@449
@446:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f4
	ld	bc,0
	call	__lsub##
	jr	c,@450
	jr	z,@450
	bool	hl
	ld	l,h
	ld	(ix-6),hl
;3274 
;3275   //--- if knob turned while no buttons are being pressed, move the ---
;3276   //--- highlight to the next or prev selectable element ---
;3277     if (!btnBits AND (abs(knobCount) > knobSelectRate))  {
@450:
@449:
	ld	hl,(ix-12)
	bool	hl
	jr	nz,@452
	ld	hl,(ix-6)
	push	hl
	call	_abs
	pop	de
	ld	de,(_knobSelectRate)
	or	a,a
	sbc	hl,de
	jr	c,@452
	jr	z,@452
;3278       delta = (knobCount < 0) ? -1 : 1;
	ld	hl,(ix-6)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@455
	ld	hl,0xffff
	jr	@456
@455:
	ld	hl,0x1
@456:
	ld	(ix-4),hl
;3279       knobCount -= knobSelectRate * delta;
	ld	hl,(_knobSelectRate)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	mul
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,bc
	ld	(ix-6),hl
;3280       chgFocus(page, delta);  updateDisplay = true;
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	push	bc
	push	de
	lcall	$chgFocus
	add	sp,6
	ld	(ix-19),0x1
;3281     }
;3282 
;3283   //--- SELECT button:
;3284   //---   if focus is on page ref, then switch to selected page
;3285   //---   otherwise, switch to page with list of pages
;3286     if ((btnBits == SELECT_BTN) AND (prevBtnBits != SELECT_BTN))  {
@452:
	ld	hl,(ix-12)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@458
	ld	hl,(ix-14)
	or	a,a
	sbc	hl,de
	jr	z,@458
;3287       elem = page->cur;
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
;3288       if (elem->type != PAGE_REF)
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,2
	jr	z,@461
;3289         page = (PageDef far *) &listPage;
	ld	de,word (phys _listPage)
	ld	c,phys _listPage >> 16
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
;3290       else
;3291         page = (PageDef far *) elem->val;
	jr	@462
@461:
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
;3292       updateDisplay = true;
@462:
	ld	(ix-19),0x1
;3293     } while (0);
@458:
;3294 
;3295 
;3296   //--- SET button (with focus on RW element):
;3297   //---   if just pressed, make a copy of the cur elem's value
;3298   //---   while pressed, apply knob movements to copy of cur's value
;3299     if (btnBits == SET_BTN)  do  {
	ld	hl,(ix-12)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@465
;3300       if ((elem = page->cur)->type != RW_DATA)  break;
	ld	hl,(ix-48)
	ex	de,hl
	ld	hl,(ix-46)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,1
	jp	nz,@482
;3301       if (!modVal)  {  // copy existing value if just pressed
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@472
;3302         fmemcpy(valBuf, elem->val, elem->valSize);  modVal = valBuf;  }
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xb
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,-106+@420
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,-114+@420
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-38),hl
	ex	de,hl
	ld	(ix-40),hl
	ex	de,hl
;3303       if (!knobCount)  break;
@472:
	ld	hl,(ix-6)
	bool	hl
	jp	z,@482
;3304       chg = (float) knobCount;
	ld	hl,(ix-6)
	ex	de,hl
	call	__itof##
	ld	hl,bc
	ld	(ix-33),hl
	ex	de,hl
	ld	(ix-35),hl
	ex	de,hl
;3305       chg = SIGN(knobCount) * chg * chg * elem->chgRate;
	ld	hl,(ix-6)
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@476
	ld	hl,0xffff
	jr	@477
@476:
	ld	hl,0x1
@477:
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	call	__fmlt##
	push	bc
	push	de
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	call	__fmlt##
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__fmlt##
	ld	hl,bc
	ld	(ix-33),hl
	ex	de,hl
	ld	(ix-35),hl
	ex	de,hl
;3306       if (elem->chgFunc)  if (elem->chgFunc(elem, modVal, chg))  {
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x17
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jp	z,@482
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	push	bc
	push	de
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x17
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	pop	de
	pop	bc
	call	__callhl##
	add	sp,12
	or	a,a
	jr	z,@482
;3307         updateDisplay = true;  knobCount = 0;  }
	ld	a,0x1
	ld	(ix-19),a
	bool	hl
	ld	l,h
	ld	(ix-6),hl
;3308     } while (0);
;3309     else  if (modVal)  {
	jr	@482
@465:
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@483
;3310       if (elem->setFunc)  elem->setFunc(elem, modVal);
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@486
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	push	bc
	push	de
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	pop	de
	pop	bc
	call	__callhl##
	add	sp,8
;3311 //      printf("done modifying\r\n");
;3312       modVal = NULL;  knobCount = 0;
@486:
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-38),hl
	ex	de,hl
	ld	(ix-40),hl
	ex	de,hl
	ld	(ix-6),hl
;3313     }
;3314 
;3315 
;3316   //--- if contrast changed, update the display's contrast ---
;3317     if (curContrast != prevContrast)  {
@483:
@482:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@487
;3318       write(lcdfd, "\376\120", 2);  contrByte = contrast;
	ld	hl,0x2
	push	hl
	ld	hl,@2+307
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
	ld	a,(_contrast)
	ld	(ix-36),a
;3319       write(lcdfd, &contrByte, 1);
	ld	hl,0x1
	push	hl
	ld	hl,-34+@420
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
;3320       prevContrast = curContrast;
	ld	hl,(ix-16)
	ld	(ix-18),hl
;3321     }
;3322 
;3323 
;3324   //--- if SELECT and SET buttons both pressed at once, then reinitialize -
;3325   //--- the display (if manual override jumper was in when it was powered -
;3326   //--- up, this should force it to remember the 19200 baud rate when it --
;3327   //--- is next powered up without the jumper ---
;3328     if (btnBits == (SELECT_BTN | SET_BTN))   {
@487:
	ld	hl,(ix-12)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@490
;3329       ResetLCD(lcdfd);  updateDisplay = true;  }
	ld	hl,0xc
	push	hl
	ld	hl,@2+310
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
	ld	hl,0x8
	push	hl
	ld	hl,@2+298
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
	ld	hl,0xa
	push	hl
	ld	hl,@2+249
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write
	add	sp,6
	ld	(ix-19),0x1
;3330 
;3331 #pragma warn 775
;3332   }
@490:
;3333 
;3334 }
	jp	@433
@421:
	.debug	} @421 3334

@420	equ	114
	ld	sp,ix
	pop	ix
	lret
@422	equ	116
;3335 
;3336 
;3337 //-------------------------------------------------------------------------
;3338 //  example func to process a command entered via a user shell
;3339 //-------------------------------------------------------------------------
;3340 /*
;3341 void _task miscTest(int argc, char **argv)
;3342 {
;3343   int  idx;
;3344   bool  validCmd;
;3345 
;3346 //used by EVENT macro
;3347   fd_t  eventsfd = -1;
;3348   EventMsg  eventMsg;
;3349 
;3350 
;3351   validCmd = false;
;3352 
;3353   for (;;)  {
;3354     if (argc < 3)  break;
;3355     if (! isdigit(argv[1][0]))  break;
;3356 
;3357     idx = atoi(argv[1]);
;3358     if ((idx < 1) OR (idx > NumChan))  {
;3359       printf("Invalid chan #\n");  Exit(-2); }
;3360 
;3361     --idx;  validCmd = true;
;3362 
;3363     if (StriEq(argv[2], "x"))     { EVENT(MyEventX, idx, NULL, 0);  break; 
;3364     if (StriEq(argv[2], "y"))     { EVENT(MyEventY, idx, NULL, 0);  break; 
;3365 
;3366     validCmd = false;  break;
;3367   }
;3368 
;3369   if (! validCmd)  { printf("Usage:  misc # x|y\r\n");  Exit(-1); }
;3370 
;3371   Exit(0);
;3372 }
;3373 */
;3374 
;3375 //=========================================================================
;3376 //  Generic structure to handle application-specific presentation of the
;3377 //  digital and analog input/output values.  Code to handle additional
;3378 //  formatting that cannot be handled in this generic manner should be
;3379 //  placed in the showState() task routine.
;3380 //=========================================================================
;3381 
;3382 
;3383 //-------------------------------------------------------------------------
;3384 _nearcall char *fmtState(DispElem far *elem, char *buf)
;3385 {
	.align	4
$$fmtState::
	ex	(sp),iy
$fmtState::
	.debug	G $fmtState 89 9
	.debug	{ $fmtState 89 3384 @499 @498
	push	ix
	ld	ix,0
	add	ix,sp
;3386   return (char *) CtlStateDesc[ ELEM_VAL(uint) ];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_CtlStateDesc
	add	hl,de
	ld	hl,(hl)
;3387 }
@498:
	.debug	} @498 3387

@497	equ	0
	pop	ix
	lret
@499	equ	2
;3388 
;3389 //-------------------------------------------------------------------------
;3390 _nearcall char *fmtMode(DispElem far *elem, char *buf)
;3391 {
	.align	4
$$fmtMode::
	ex	(sp),iy
$fmtMode::
	.debug	G $fmtMode 89 9
	.debug	{ $fmtMode 89 3390 @502 @501
	push	ix
	ld	ix,0
	add	ix,sp
;3392   return (char *) OutModeDesc[ ELEM_VAL(uint) ];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_OutModeDesc
	add	hl,de
	ld	hl,(hl)
;3393 }
@501:
	.debug	} @501 3393

@500	equ	0
	pop	ix
	lret
@502	equ	2
;3394 
;3395 //-------------------------------------------------------------------------
;3396 _nearcall char *fmtFET(DispElem far *elem, char *buf)
;3397 {
	.align	4
$$fmtFET::
	ex	(sp),iy
$fmtFET::
	.debug	G $fmtFET 89 9
	.debug	{ $fmtFET 89 3396 @505 @504
	push	ix
	ld	ix,0
	add	ix,sp
;3398   return (char *) PolCmdDesc[ELEM_VAL(uint)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_PolCmdDesc
	add	hl,de
	ld	hl,(hl)
;3399 }
@504:
	.debug	} @504 3399

@503	equ	0
	pop	ix
	lret
@505	equ	2
;3400 
;3401 //-------------------------------------------------------------------------
;3402 _nearcall char *fmtPol(DispElem far *elem, char *buf)
;3403 {
	.align	4
$$fmtPol::
	ex	(sp),iy
$fmtPol::
	.debug	G $fmtPol 89 9
	.debug	{ $fmtPol 89 3402 @508 @507
	push	ix
	ld	ix,0
	add	ix,sp
;3404   return (ELEM_VAL(bool) ? "[+]" : "[-]");
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@509
	ld	hl,@2+101
	jr	@507
@509:
	ld	hl,@2+93
;3405 }
@507:
	.debug	} @507 3405

@506	equ	0
	pop	ix
	lret
@508	equ	2
;3406 
;3407 //-------------------------------------------------------------------------
;3408 _nearcall char *fmtBSFault(DispElem far *elem, char *buf)
;3409 {
	.align	4
$$fmtBSFault::
	ex	(sp),iy
$fmtBSFault::
	.debug	G $fmtBSFault 89 9
	.debug	{ $fmtBSFault 89 3408 @514 @513
	push	ix
	ld	ix,0
	add	ix,sp
;3410   return (ELEM_VAL(bool) ? "*" : "_");
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@515
	ld	hl,@2+323
	jr	@513
@515:
	ld	hl,@2+325
;3411 }
@513:
	.debug	} @513 3411

@512	equ	0
	pop	ix
	lret
@514	equ	2
;3412 
;3413 //-------------------------------------------------------------------------
;3414 _nearcall char *fmtSupType(DispElem far *elem, char *buf)
;3415 {
	.align	4
$$fmtSupType::
	ex	(sp),iy
$fmtSupType::
	.debug	G $fmtSupType 89 9
	.debug	{ $fmtSupType 89 3414 @519 @518
	push	ix
	ld	ix,0
	add	ix,sp
;3416   return (char *) SupplyTypeDesc[ELEM_VAL(uint)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_SupplyTypeDesc
	add	hl,de
	ld	hl,(hl)
;3417 }
@518:
	.debug	} @518 3417

@517	equ	0
	pop	ix
	lret
@519	equ	2
;3418 
;3419 //-------------------------------------------------------------------------
;3420 _nearcall char *fmtLoadType(DispElem far *elem, char *buf)
;3421 {
	.align	4
$$fmtLoadType::
	ex	(sp),iy
$fmtLoadType::
	.debug	G $fmtLoadType 89 9
	.debug	{ $fmtLoadType 89 3420 @522 @521
	push	ix
	ld	ix,0
	add	ix,sp
;3422   return (char *) LoadTypeDesc[ELEM_VAL(uint)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_LoadTypeDesc
	add	hl,de
	ld	hl,(hl)
;3423 }
@521:
	.debug	} @521 3423

@520	equ	0
	pop	ix
	lret
@522	equ	2
;3424 
;3425 //-------------------------------------------------------------------------
;3426 _nearcall char *fmtEnabled(DispElem far *elem, char *buf)
;3427 {
	.align	4
$$fmtEnabled::
	ex	(sp),iy
$fmtEnabled::
	.debug	G $fmtEnabled 89 9
	.debug	{ $fmtEnabled 89 3426 @525 @524
	push	ix
	ld	ix,0
	add	ix,sp
;3428   return (ELEM_VAL(bool) ? BlueText"YES" : RedText"NO " );
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@526
	ld	hl,@2+327
	jr	@524
@526:
	ld	hl,@2+336
;3429 }
@524:
	.debug	} @524 3429

@523	equ	0
	pop	ix
	lret
@525	equ	2
;3430 
;3431 //-------------------------------------------------------------------------
;3432 /*
;3433 _nearcall char *fmtBridgeState(DispElem far *elem, char *buf)
;3434 {
;3435   return  (char *) BridgeStateDesc[ELEM_VAL(uint)];
;3436 }
;3437 */
;3438 
;3439 //-------------------------------------------------------------------------
;3440   const char far DevStateStr[] = {
;3441 " Set:-####.##A   Read:-####.##A       --Bias-  --Cur-- On   Temp Avail Ena
;3442 "                                   1. -##.### -###.##  #/#   ###  ###    #
;3443 "Volts:-##.###V   Err: -####.##A    2. -##.### -###.##  #/#   ###  ###    #
;3444 "                                   3. -##.### -###.##  #/#   ###  ###    #
;3445 "ISET:-####.##A   Sft: ###          4. -##.### -###.##  #/#   ###  ###    #
;3446 "BJTB: -##.###V   Hdw: ###          5. -##.### -###.##  #/#   ###  ###    #
;3447 "IFDK:-####.##A   #####/#####       6. -##.### -###.##  #/#   ###  ###    #
;3448 "                                   7. -##.### -###.##  #/#   ###  ###    #
;3449 "VCTRL:-##.###V  +LIM:-##.##V       8. -##.### -###.##  #/#   ###  ###    #
;3450 "#PS: ##         -LIM:-##.##V       9. -##.### -###.##  #/#   ###  ###    #
;3451 "                                  10. -##.### -###.##  #/#   ###  ###    #
;3452 "HOLEC: ###   ExtILK: ##### \r\n"
;3453 "                                     Nominal: -###.##  (TTL: -####.##) \r\
;3454 "SupplyType: ###  Load: ########      Max Diff:-###.## \r\n"
;3455 "\r\n"
;3456 "Apparent Resistance:\r\n"
;3457 "  Load:    -##.### ohms\r\n"
;3458 "  Dump Res:-##.### ohms\r\n"
;3459 };
	.seg	FARCONST
_DevStateStr::
	.db	" Set:-####.##A   Read:-####.##A       --Bias-  --Cur-- On   Temp Avail Enabled",13,10,"     "
	.db	"                              1. -##.### -###.##  #/#   ###  ###    ###",13,10,"Volts:-##.##"
	.db	"#V   Err: -####.##A    2. -##.### -###.##  #/#   ###  ###    ###",13,10,"                   "
	.db	"                3. -##.### -###.##  #/#   ###  ###    ###",13,10,"ISET:-####.##A   Sft: ### "
	.db	"         4. -##.### -###.##  #/#   ###  ###    ###",13,10,"BJTB: -##.###V   Hdw: ###        "
	.db	"  5. -##.### -###.##  #/#   ###  ###    ###",13,10,"IFDK:-####.##A   #####/#####       6. -#"
	.db	"#.### -###.##  #/#   ###  ###    ###",13,10,"                                   7. -##.### -"
	.db	"###.##  #/#   ###  ###    ###",13,10,"VCTRL:-##.###V  +LIM:-##.##V       8. -##.### -###.## "
	.db	" #/#   ###  ###    ###",13,10,"#PS: ##         -LIM:-##.##V       9. -##.### -###.##  #/#   "
	.db	"###  ###    ###",13,10,"                                  10. -##.### -###.##  #/#   ###  ##"
	.db	"#    ###",13,10,"HOLEC: ###   ExtILK: ##### ",13,10,"                                     Nominal:"
	.db	" -###.##  (TTL: -####.##) ",13,10,"SupplyType: ###  Load: ########      Max Diff:-###.## ",13,10
	.db	13,10,"Apparent Resistance:",13,10,"  Load:    -##.### ohms",13,10,"  Dump Res:-##.### ohms",13,10,0
	.debug	G _DevStateStr 90 8
;3460 
;3461 const DispElem  far dispElems[] = {
;3462   {  5, 3, VFPV(ampSet),      DARK_BLUE, fmtF32,    8,2 },
_dispElems::
	.db	0x5
	.db	0x3
	.dl	phys _ampSet
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3463   { 22, 3, VFPV(ampRead),     DARK_BLUE, fmtF32,    8,2 },
	.db	0x16
	.db	0x3
	.dl	phys _ampRead
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3464 
;3465   {  6, 5, VFPV(voltRead),    DARK_BLUE, fmtF32,    7,3 },
	.db	0x6
	.db	0x5
	.dl	phys _voltRead
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3466   { 22, 5, VFPV(ampErr),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x16
	.db	0x5
	.dl	phys _ampErr
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3467 
;3468   {  5, 7, VFPV(iset),        DARK_BLUE, fmtF32,    8,2 },
	.db	0x5
	.db	0x7
	.dl	phys _iset
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3469   {  6, 8, VFPV(bjtBias),     DARK_BLUE, fmtF32,    7,3 },
	.db	0x6
	.db	0x8
	.dl	phys _bjtBias
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3470   {  5, 9, VFPV(ifdbk),       DARK_BLUE, fmtF32,    8,2 },
	.db	0x5
	.db	0x9
	.dl	phys _ifdbk
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3471 
;3472   { 22, 7, VFPV(polCmd),      DARK_BLUE, fmtFET,    3,3 },
	.db	0x16
	.db	0x7
	.dl	phys _polCmd
	.dw	@2+345
	.dw	word _fmtFET
	.dw	0x3
	.dw	0x3
;3473   { 22, 8, VFPV(Cur.regPol),  DARK_BLUE, fmtPol,    3,3 },
	.db	0x16
	.db	0x8
	.dl	phys _curState+292
	.dw	@2+345
	.dw	word _fmtPol
	.dw	0x3
	.dw	0x3
;3474   { 17, 9, VFPV(state),       DARK_BLUE, fmtState, -5,5 },
	.db	0x11
	.db	0x9
	.dl	phys _state
	.dw	@2+345
	.dw	word _fmtState
	.dw	0xfffb
	.dw	0x5
;3475   { 23, 9, VFPV(outMode),     DARK_BLUE, fmtMode,  -5,5 },
	.db	0x17
	.db	0x9
	.dl	phys _outMode
	.dw	@2+345
	.dw	word _fmtMode
	.dw	0xfffb
	.dw	0x5
;3476 
;3477   {  6,11, VFPV(vctrl),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x6
	.db	0xb
	.dl	phys _vctrl
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3478   {  5,12, VFPV(psCount),     DARK_BLUE, fmtU16,    2,2 },
	.db	0x5
	.db	0xc
	.dl	phys _psCount
	.dw	@2+345
	.dw	word _fmtU16
	.dw	0x2
	.dw	0x2
;3479 
;3480   { 21,11, VFPV(vlimPlus),    DARK_BLUE, fmtF32,    6,2 },
	.db	0x15
	.db	0xb
	.dl	phys _vlimPlus
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;3481   { 21,12, VFPV(vlimMinus),   DARK_BLUE, fmtF32,    6,2 },
	.db	0x15
	.db	0xc
	.dl	phys _vlimMinus
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;3482 
;3483   { 12,16, VFPV(supplyType),  DARK_BLUE, fmtSupType,  3,3 },
	.db	0xc
	.db	0x10
	.dl	phys _supplyType
	.dw	@2+345
	.dw	word _fmtSupType
	.dw	0x3
	.dw	0x3
;3484   { 23,16, VFPV(loadType),    DARK_BLUE, fmtLoadType, 8,8 },
	.db	0x17
	.db	0x10
	.dl	phys _loadType
	.dw	@2+345
	.dw	word _fmtLoadType
	.dw	0x8
	.dw	0x8
;3485 
;3486   { 38, 4, VFPV(bsv_1),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x4
	.dl	phys _bsv_1
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3487   { 38, 5, VFPV(bsv_2),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x5
	.dl	phys _bsv_2
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3488   { 38, 6, VFPV(bsv_3),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x6
	.dl	phys _bsv_3
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3489   { 38, 7, VFPV(bsv_4),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x7
	.dl	phys _bsv_4
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3490   { 38, 8, VFPV(bsv_5),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x8
	.dl	phys _bsv_5
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3491   { 38, 9, VFPV(bsv_6),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0x9
	.dl	phys _bsv_6
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3492   { 38,10, VFPV(bsv_7),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0xa
	.dl	phys _bsv_7
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3493   { 38,11, VFPV(bsv_8),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0xb
	.dl	phys _bsv_8
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3494   { 38,12, VFPV(bsv_9),       DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0xc
	.dl	phys _bsv_9
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3495   { 38,13, VFPV(bsv_10),      DARK_BLUE, fmtF32,    7,3 },
	.db	0x26
	.db	0xd
	.dl	phys _bsv_10
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3496 
;3497   { 45, 4, VFPV(amps_1),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x4
	.dl	phys _amps_1
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3498   { 45, 5, VFPV(amps_2),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x5
	.dl	phys _amps_2
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3499   { 45, 6, VFPV(amps_3),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x6
	.dl	phys _amps_3
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3500   { 45, 7, VFPV(amps_4),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x7
	.dl	phys _amps_4
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3501   { 45, 8, VFPV(amps_5),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x8
	.dl	phys _amps_5
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3502   { 45, 9, VFPV(amps_6),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0x9
	.dl	phys _amps_6
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3503   { 45,10, VFPV(amps_7),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0xa
	.dl	phys _amps_7
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3504   { 45,11, VFPV(amps_8),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0xb
	.dl	phys _amps_8
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3505   { 45,12, VFPV(amps_9),      DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0xc
	.dl	phys _amps_9
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3506   { 45,13, VFPV(amps_10),     DARK_BLUE, fmtF32,    8,2 },
	.db	0x2d
	.db	0xd
	.dl	phys _amps_10
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3507 
;3508   { 73, 4, VFPV(Cur.bs[0].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x4
	.dl	phys _curState+26
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3509   { 73, 5, VFPV(Cur.bs[1].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x5
	.dl	phys _curState+54
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3510   { 73, 6, VFPV(Cur.bs[2].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x6
	.dl	phys _curState+82
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3511   { 73, 7, VFPV(Cur.bs[3].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x7
	.dl	phys _curState+110
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3512   { 73, 8, VFPV(Cur.bs[4].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x8
	.dl	phys _curState+138
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3513   { 73, 9, VFPV(Cur.bs[5].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0x9
	.dl	phys _curState+166
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3514   { 73,10, VFPV(Cur.bs[6].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0xa
	.dl	phys _curState+194
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3515   { 73,11, VFPV(Cur.bs[7].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0xb
	.dl	phys _curState+222
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3516   { 73,12, VFPV(Cur.bs[8].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0xc
	.dl	phys _curState+250
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3517   { 73,13, VFPV(Cur.bs[9].enabled), "", fmtEnabled, 3,3 },
	.db	0x49
	.db	0xd
	.dl	phys _curState+278
	.dw	@2+5
	.dw	word _fmtEnabled
	.dw	0x3
	.dw	0x3
;3518 
;3519   { 45,15, VFPV(perSupCur),   DARK_BLUE, fmtF32, 8,2 },
	.db	0x2d
	.db	0xf
	.dl	phys _perSupCur
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3520   { 60,15, VFPV(ttlBulkCur),  DARK_BLUE, fmtF32, 9,2 },
	.db	0x3c
	.db	0xf
	.dl	phys _ttlBulkCur
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x9
	.dw	0x2
;3521   { 45,16, VFPV(maxCurDiff),  DARK_BLUE, fmtF32, 8,2 },
	.db	0x2d
	.db	0x10
	.dl	phys _maxCurDiff
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;3522 
;3523   { 11,19, VFPV(loadRes),     DARK_BLUE, fmtF32, 7,3 },
	.db	0xb
	.db	0x13
	.dl	phys _loadRes
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3524   { 11,20, VFPV(dumpRes),     DARK_BLUE, fmtF32, 7,3 },
	.db	0xb
	.db	0x14
	.dl	phys _dumpRes
	.dw	@2+345
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;3525 
;3526   { 0,0, NULL, NULL, NULL, 0,0 }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;3527 };
	.debug	G _dispElems 91 8
;3528 
;3529 
;3530 const DigDispElem far digInElems[] = {
;3531   {  7,14,  HOLEC_OK,  "BAD",DARK_RED,    "OK ",DARK_BLUE },
_digInElems::
	.db	0x7
	.db	0xe
	.dw	0, 0x4000
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3532   { 21,14,  NO_INTLK,  "FAULT",DARK_RED,  "OK   ",DARK_BLUE },
	.db	0x15
	.db	0xe
	.dw	0, 0x8000
	.dw	@2+231
	.dw	@2+347
	.dw	@2+225
	.dw	@2+345
;3533 
;3534   { 57, 4,  PS1_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x4
	.dw	0, 0x100
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3535   { 57, 5,  PS2_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x5
	.dw	0, 0x4
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3536   { 57, 6,  PS3_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x6
	.dw	0x1000, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3537   { 57, 7,  PS4_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x7
	.dw	0x40, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3538   { 57, 8,  PS5_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x8
	.dw	0x1, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3539   { 57, 9,  PS6_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0x9
	.dw	0, 0x800
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3540   { 57,10,  PS7_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0xa
	.dw	0, 0x20
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3541   { 57,11,  PS8_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0xb
	.dw	0xffff8000, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3542   { 57,12,  PS9_IS_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0xc
	.dw	0x200, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3543   { 57,13,  PS10_IS_ON, "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x39
	.db	0xd
	.dw	0x8, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3544 
;3545   { 61, 4,  PS1_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x4
	.dw	0, 0x400
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3546   { 61, 5,  PS2_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x5
	.dw	0, 0x10
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3547   { 61, 6,  PS3_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x6
	.dw	0x4000, 0
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3548   { 61, 7,  PS4_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x7
	.dw	0x100, 0
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3549   { 61, 8,  PS5_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x8
	.dw	0x4, 0
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3550   { 61, 9,  PS6_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0x9
	.dw	0, 0x2000
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3551   { 61,10,  PS7_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0xa
	.dw	0, 0x80
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3552   { 61,11,  PS8_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0xb
	.dw	0, 0x2
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3553   { 61,12,  PS9_TEMP_OK,   "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0xc
	.dw	0x800, 0
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3554   { 61,13,  PS10_TEMP_OK,  "BAD",DARK_RED,  "OK ",DARK_BLUE },
	.db	0x3d
	.db	0xd
	.dw	0x20, 0
	.dw	@2+221
	.dw	@2+347
	.dw	@2+217
	.dw	@2+345
;3555 
;3556   { 66, 4,  PS1_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x4
	.dw	0, 0x200
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3557   { 66, 5,  PS2_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x5
	.dw	0, 0x8
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3558   { 66, 6,  PS3_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x6
	.dw	0x2000, 0
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3559   { 66, 7,  PS4_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x7
	.dw	0x80, 0
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3560   { 66, 8,  PS5_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x8
	.dw	0x2, 0
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3561   { 66, 9,  PS6_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0x9
	.dw	0, 0x1000
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3562   { 66,10,  PS7_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0xa
	.dw	0, 0x40
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3563   { 66,11,  PS8_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0xb
	.dw	0, 0x1
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3564   { 66,12,  PS9_AVAIL,  "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0xc
	.dw	0x400, 0
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3565   { 66,13,  PS10_AVAIL, "NO ",DARK_RED,  "YES",DARK_BLUE },
	.db	0x42
	.db	0xd
	.dw	0x10, 0
	.dw	@2+245
	.dw	@2+347
	.dw	@2+241
	.dw	@2+345
;3566 
;3567   { 0,0, 0, NULL,NULL, NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;3568 };
	.debug	G _digInElems 93 8
;3569 
;3570 const DigDispElem far digOutElems[] = {
;3571   { 55, 4,  PS1_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
_digOutElems::
	.db	0x37
	.db	0x4
	.dw	0x400, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3572   { 55, 5,  PS2_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0x5
	.dw	0x100, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3573   { 55, 6,  PS3_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0x6
	.dw	0x20, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3574   { 55, 7,  PS4_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0x7
	.dw	0x8, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3575   { 55, 8,  PS5_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0x8
	.dw	0x2, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3576   { 55, 9,  PS6_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0x9
	.dw	0x200, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3577   { 55,10,  PS7_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0xa
	.dw	0x40, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3578   { 55,11,  PS8_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0xb
	.dw	0x10, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3579   { 55,12,  PS9_SET_ON,   "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0xc
	.dw	0x4, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3580   { 55,13,  PS10_SET_ON,  "N",DARK_RED,  "Y",DARK_BLUE },
	.db	0x37
	.db	0xd
	.dw	0x1, 0
	.dw	@2+239
	.dw	@2+347
	.dw	@2+237
	.dw	@2+345
;3581 
;3582   { 0,0,  0,  NULL,NULL,  NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;3583 };
	.debug	G _digOutElems 95 8
;3584 
;3585 
;3586 const DigFmtInfo digInFmt[] = {
;3587   { -1,-1, "",0, "",0 }
	.seg	CONST
_digInFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+5
	.db	0
	.dw	@2+5
	.db	0
;3588 };
	.debug	G _digInFmt 96 0
;3589 
;3590 const DigFmtInfo digOutFmt[] = {
;3591   { -1,-1, "",0, "",0 }
_digOutFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+5
	.db	0
	.dw	@2+5
	.db	0
;3592 };
	.debug	G _digOutFmt 96 0
;3593 
;3594 const AnalogFmtInfo  adcFmt[] = {
;3595   { -1,-1,  0,0 }
_adcFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;3596 };
	.debug	G _adcFmt 98 0
;3597 
;3598 const AnalogFmtInfo  dacFmt[] = {
;3599   { -1,-1, 0,0 }
_dacFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;3600 };
	.debug	G _dacFmt 98 0
;3601 
;3602 //-------------------------------------------------------------------------
;3603 //  "state":  Show continuously updated state of the system
;3604 //-------------------------------------------------------------------------
;3605 void _task showState(int argc, char **argv)
;3606 {
	.seg	FARCODE
	.align	4
$$showState::
	ex	(sp),iy
$showState::
	.debug	G $showState 88 9
	.debug	{ $showState 88 3605 @531 @530
	ld	hl,-129
	call	__fent##
;3607   bool  blinkOff;
;3608   char  temp[128];
;3609 
;3610 
;3611   printf(clsCmd);  blinkOff = false;
	ld	hl,_clsCmd
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	ld	(ix-1),a
;3612 
;3613   CursorTo(0, 3);  printf(DevStateStr);
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	de,word (phys @1+3233)
	ld	c,phys @1+3233 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	de,word (phys _DevStateStr)
	ld	c,phys _DevStateStr >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3614 
;3615   for (;;)  {
@534:
;3616     CursorTo(0, 0);  blinkOff = !blinkOff;
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @1+3233)
	ld	c,phys @1+3233 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,(ix-1)
	or	a,a
	ld	a,0
	jr	nz,@539
	inc	a
@539:
	ld	(ix-1),a
;3617 
;3618     stdHeader();  displayElems((DispElem far *)dispElems, blinkOff, temp);
	lcall	$stdHeader
	ld	hl,-129+@529
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _dispElems)
	ld	c,phys _dispElems >> 16
	push	bc
	push	de
	lcall	$displayElems
	add	sp,8
;3619 
;3620     displayDigElems(digitalIn, (DigDispElem far *)digInElems, blinkOff, tem
	ld	hl,-129+@529
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digInElems)
	ld	c,phys _digInElems >> 16
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;3621     displayDigElems(digitalOut, (DigDispElem far *)digOutElems, blinkOff, t
	ld	hl,-129+@529
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digOutElems)
	ld	c,phys _digOutElems >> 16
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;3622 
;3623     CursorTo(0,22);  fflush(stdout);  CheckETX();  sleepMS(500);
	ld	hl,0x1
	push	hl
	ld	l,0x17
	push	hl
	ld	de,word (phys @1+3233)
	ld	c,phys @1+3233 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	lcall	$CheckETX
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3624   }
;3625 
;3626 }
	jp	@534
@530:
	.debug	} @530 3626

@529	equ	129
	ld	sp,ix
	pop	ix
	lret
@531	equ	131
;3627 
;3628 
;3629 //-------------------------------------------------------------------------
;3630 //  Turn supplies On/Off, enable/disable individual supplies, reset interlo
;3631 //  condition
;3632 //-------------------------------------------------------------------------
;3633 void _task cmd(int argc, char **argv)
;3634 {
	.align	4
$$cmd::
	ex	(sp),iy
$cmd::
	.debug	G $cmd 88 9
	.debug	{ $cmd 88 3633 @542 @541
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
;3635   bool  validCmd, enableCmd, disableCmd;
;3636   uint  idx;
;3637   char  *cmdStr;
;3638 
;3639 
;3640   validCmd = false;  cmdStr = argv[1];
	xor	a,a
	ld	(ix-1),a
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-7),hl
;3641 
;3642   do  {
;3643     if (argc < 2)  break;
	ld	hl,(ix+5)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@544
;3644 
;3645     if (StriEq(cmdStr, "on"))  { onRequest();  validCmd = true;  break; }
	ld	hl,@2+349
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@549
	lcall	$onRequest
	jp	@568
;3646 
;3647     if (StriEq(cmdStr, "off"))  { offRequest();  validCmd = true;  break; }
@549:
	ld	hl,@2+352
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@552
	lcall	$offRequest
	jp	@568
;3648 
;3649     if (StriEq(cmdStr, "reset"))  { resetRequest();  validCmd = true;  brea
@552:
	ld	hl,@2+356
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@555
	lcall	$resetRequest
	jp	@568
;3650 
;3651     enableCmd = StriEq(cmdStr, "enable");
@555:
	ld	hl,@2+362
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	ld	l,h
	jr	nz,@558
	inc	l
@558:
	ld	(ix-2),l
;3652     disableCmd = StriEq(cmdStr, "disable");
	ld	hl,@2+369
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	ld	l,h
	jr	nz,@559
	inc	l
@559:
	ld	(ix-3),l
;3653 
;3654     if (argc < 3)  break;
	ld	hl,(ix+5)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@544
;3655 
;3656     if (enableCmd OR disableCmd)  {
	ld	a,(ix-2)
	or	a,a
	jr	nz,@561
	ld	a,(ix-3)
	or	a,a
	jr	z,@562
@561:
;3657       idx = ATOI(argv[2]);  if ((idx < 1) OR (idx > NumPS))  break;
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-5),hl
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	c,@544
	ld	hl,(ix-5)
	ld	e,0xa
	or	a,a
	sbc	hl,de
	jr	c,@566
	jr	nz,@544
;3658       --idx;
@566:
	ld	hl,(ix-5)
	dec	hl
	ld	(ix-5),hl
;3659       if (enableCmd)  enableBulkSupply(idx);  else  disableBulkSupply(idx);
	ld	a,(ix-2)
	or	a,a
	jr	z,@567
	push	hl
	lcall	$enableBulkSupply
	pop	hl
	jr	@568
@567:
	ld	hl,(ix-5)
	push	hl
	lcall	$disableBulkSupply
	pop	hl
;3660       validCmd = true;  break;
@568:
	ld	a,0x1
	ld	(ix-1),a
;3661     }
	jr	@544
;3662 
;3663     if (StriEq(cmdStr, "set"))  {
@562:
	ld	hl,@2+358
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@569
;3664       newSetpoint(atof(argv[2]));  validCmd = true;  break;  }
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	push	bc
	push	de
	lcall	$newSetpoint
	add	sp,4
	ld	(ix-1),0x1
;3665 
;3666   }  while(0);
@569:
;3667 
;3668 
;3669   if (! validCmd)  {
@544:
	ld	a,(ix-1)
	or	a,a
	jr	nz,@572
;3670     printf("Usage:  cmd on|off|reset\r\n"
;3671            "            enable|disable #\r\n"
;3672            "            set #.#\r\n" );
	ld	de,word (phys @1+3246)
	ld	c,phys @1+3246 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3673     Exit(-1);
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3674   }
;3675 
;3676   Exit(0);
@572:
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;3677 }
@541:
	.debug	} @541 3677

@540	equ	7
	ld	sp,ix
	pop	ix
	lret
@542	equ	9
;3678 
;3679 
;3680 //=========================================================================
;3681 //  Event-Handler functions called by the appl task to process event messag
;3682 //=========================================================================
;3683 
;3684 //-------------------------------------------------------------------------
;3685 //  Event-Handler for a request to ...
;3686 //-------------------------------------------------------------------------
;3687 /*
;3688 void EVENT_MyEvent(EventMsg *event)
;3689 {
;3690   uint  idx;
;3691   float  setpoint;
;3692   char  temp[16];
;3693 
;3694 
;3695   idx = event->chanNum;
;3696 
;3697   if (error)  {
;3698     fprintf(DiagLog, "error msg, chan:\n", idx+1);
;3699     return;
;3700   }
;3701 
;3702   setpoint = *((float *)event->data);
;3703 
;3704   fprintf(DiagLog, "New SetPoint for PS%d: %s\n",
;3705      idx+1, fmtFloat(setpoint, 8,3, temp) );
;3706 
;3707   *((float *)((&iSet_1_RegInfo + idx)->regVal)) = setpoint;
;3708 
;3709   voltsOut[idx] = ISETtoVolts(idx, setpoint);
;3710 }
;3711 */
;3712 
;3713 
;3714 //=========================================================================
;3715 //  Update the the state of the application logic in well-defined phases
;3716 //=========================================================================
;3717 // IMPORTANT NOTES and RULES:
;3718 //
;3719 //  - The code to change ANY value must be in ONE place.  NEVER spread the
;3720 //    logic for updating a single value around.  There should be ONE place
;3721 //    to look to see how a value gets set.
;3722 //
;3723 //  - "cur" values are basically "inputs" - literally (they are set based
;3724 //    on the just-read state of a digital or analog input) and/or figurativ
;3725 //    (they hold a value set by some external source, such as a cmd from a
;3726 //    remote client or another user-interface task).
;3727 //
;3728 //  - "next" values are basically "outputs" - literally (they determine the
;3729 //    next state of a digital or analog output) and/or figuratively (they
;3730 //    can affect the state of the logic for the next pass).
;3731 //
;3732 //  - The "cur" OR the "next" instance of a value may be changed - NEVER
;3733 //    both of them (with the exception of the first step below that copies
;3734 //    all of cur to prev and next to cur).
;3735 //
;3736 //  - A value MUST be in the ApplState struct if one of the following appli
;3737 //     - The application logic is dependent on if or how much the value has
;3738 //       changed between passes.
;3739 //     - The value is used as both input (used in in a conditional and/or i
;3740 //       an expression that can affect the result of an assignment) and out
;3741 //       (the target of an assignment).
;3742 //
;3743 //  - Variables that are NOT in the ApplState struct but are USED (in
;3744 //    conditionals or other expressions) by the application logic must be
;3745 //    treated just like "cur" values.  Variables SET (the target in an
;3746 //    assignment statement) by the application logic must be treated just
;3747 //    like "next" values.
;3748 //
;3749 //  - When the logic requires comparing an "input" to a related "output", b
;3750 //    sure to use the "cur" value for the "input", and the "prev" value for
;3751 //    the "output".
;3752 //
;3753 //    This is because during the processing of the loop, the "cur" values
;3754 //    represent the input values just read (what they are "now") and the
;3755 //    "prev" values represent the values the outputs were set to at the
;3756 //    beginning of the prev pass (i.e. they are the values that "caused"
;3757 //    the inputs to have their "cur" values).
;3758 //
;3759 //    During a pass the output values in "cur" represent what the outputs
;3760 //    where set to AFTER the "cur" inputs were updated, so comparing them
;3761 //    makes no sense.  Doing so is the equivalent of comparing a past respo
;3762 //    to a condition that didn't exist at the time.
;3763 //=========================================================================
;3764 
;3765 
;3766 //=========================================================================
;3767 //  Definitions for functions that handle setting "next" values that serve
;3768 //  as inputs to the application control logic (run by the "applic" task in
;3769 //  a periodically executed loop).
;3770 //
;3771 //  While care must be taken in these functions to use locks to avoid the
;3772 //  possibility of being preempted in the middle of an operation, such lock
;3773 //  must be kept to as short a time as possible to avoid excessively latenc
;3774 //  in the main control loop.
;3775 //
;3776 //  For REALLY short locks, using a critical section is best, because this
;3777 //  has the least overhead (but it has to be REALLY short to avoid causing
;3778 //  problems for interrupt handlers).
;3779 //
;3780 //  For longer locks (ones that involve anything but the most trivial
;3781 //  conditional logic), use either KLOCK() and KUNLOCK() (which disable the
;3782 //  scheduler) or a more specific global semaphore/mutex lock.
;3783 //=========================================================================
;3784 
;3785 //-------------------------------------------------------------------------
;3786 void onRequest(void)
;3787 {
$onRequest::
	.debug	G $onRequest 70 9
	.debug	{ $onRequest 70 3786 @577 @576
;3788   _EnterCritical_();
	ipset	2
;3789   Next.onRequest = true;  Next.offRequest = false;
	ld	a,0x1
	ld	(_nextState+280),a
	xor	a,a
	ld	(_nextState+281),a
;3790   _ExitCritical_();
	ipres
;3791 
;3792   fprintf(DiagLog, "ON request\n");
	ld	de,word (phys @1+3324)
	ld	c,phys @1+3324 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3793 }
@576:
	.debug	} @576 3793

@575	equ	0
	lret
@577	equ	0
;3794 
;3795 //-------------------------------------------------------------------------
;3796 void offRequest(void)
;3797 {
$offRequest::
	.debug	G $offRequest 70 9
	.debug	{ $offRequest 70 3796 @580 @579
;3798   _EnterCritical_();
	ipset	2
;3799   Next.offRequest = true;  Next.onRequest = false;
	ld	a,0x1
	ld	(_nextState+281),a
	xor	a,a
	ld	(_nextState+280),a
;3800   _ExitCritical_();
	ipres
;3801 
;3802   fprintf(DiagLog, "OFF request\n");
	ld	de,word (phys @1+3336)
	ld	c,phys @1+3336 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3803 }
@579:
	.debug	} @579 3803

@578	equ	0
	lret
@580	equ	0
;3804 
;3805 //-------------------------------------------------------------------------
;3806 void resetRequest(void)
;3807 {
$resetRequest::
	.debug	G $resetRequest 70 9
	.debug	{ $resetRequest 70 3806 @583 @582
;3808   _EnterCritical_();  Next.resetRequest = true;  _ExitCritical_();
	ipset	2
	ld	a,0x1
	ld	(_nextState+282),a
	ipres
;3809 
;3810   fprintf(DiagLog, "RESET request\n");
	ld	de,word (phys @1+3349)
	ld	c,phys @1+3349 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3811 }
@582:
	.debug	} @582 3811

@581	equ	0
	lret
@583	equ	0
;3812 
;3813 //-------------------------------------------------------------------------
;3814 void enableBulkSupply(uint idx)
;3815 {
$enableBulkSupply::
	.debug	G $enableBulkSupply 100 9
	.debug	{ $enableBulkSupply 100 3814 @586 @585
	push	ix
	ld	ix,0
	add	ix,sp
;3816   _EnterCritical_();  Next.bs[idx].enabled = true;  _ExitCritical_();
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	de,0x1a
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ipres
;3817 
;3818   enabledMask |= (uint)1 << idx;
	ld	h,d
	ld	l,a
	ld	a,(ix+5)
	or	a,a
	jr	z,@587
	ld	b,a
@588:
	add	hl,hl
	djnz	@588
@587:
	ld	de,(_enabledMask)
	or	hl,de
	ld	(_enabledMask),hl
;3819 
;3820   fprintf(DiagLog, "Enable Bulk Supply #%d\n", idx+1);
	ld	hl,(ix+5)
	inc	hl
	push	hl
	ld	de,word (phys @1+3364)
	ld	c,phys @1+3364 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;3821 }
@585:
	.debug	} @585 3821

@584	equ	0
	pop	ix
	lret
@586	equ	2
;3822 
;3823 //-------------------------------------------------------------------------
;3824 void disableBulkSupply(uint idx)
;3825 {
$disableBulkSupply::
	.debug	G $disableBulkSupply 100 9
	.debug	{ $disableBulkSupply 100 3824 @591 @590
	push	ix
	ld	ix,0
	add	ix,sp
;3826   _EnterCritical_();  Next.bs[idx].enabled = false;  _ExitCritical_();
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	de,0x1a
	add	hl,de
	xor	a,a
	ld	(hl),a
	ipres
;3827 
;3828   enabledMask &= ~((uint)1 << idx);
	ld	hl,0x1
	ld	a,(ix+5)
	or	a,a
	jr	z,@592
	ld	b,a
@593:
	add	hl,hl
	djnz	@593
@592:
	ld	a,l
	cpl	a
	ld	l,a
	ld	a,h
	cpl	a
	ld	h,a
	ld	de,(_enabledMask)
	and	hl,de
	ld	(_enabledMask),hl
;3829 
;3830   fprintf(DiagLog, "Disable Bulk Supply #%d\n", idx+1);
	ld	hl,(ix+5)
	inc	hl
	push	hl
	ld	de,word (phys @1+3388)
	ld	c,phys @1+3388 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;3831 }
@590:
	.debug	} @590 3831

@589	equ	0
	pop	ix
	lret
@591	equ	2
;3832 
;3833 //-------------------------------------------------------------------------
;3834 void newSetpoint(float newAmps)
;3835 {
$newSetpoint::
	.debug	G $newSetpoint 101 9
	.debug	{ $newSetpoint 101 3834 @596 @595
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
;3836   char  temp[16];
;3837 
;3838 
;3839   KLOCK();
	call	_KLOCK
;3840 
;3841   if (FABS(newAmps) > maxAmpSet)  newAmps = (float)SIGN(newAmps) * maxAmpSe
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,(_maxAmpSet)
	ld	bc,(_maxAmpSet+2)
	call	__fsub##
	jp	m,@597
	jr	z,@597
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@598
	ld	hl,0xffff
	jr	@599
@598:
	ld	hl,0x1
@599:
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,(_maxAmpSet)
	ld	bc,(_maxAmpSet+2)
	call	__fmlt##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;3842 
;3843   Next.ampSet = newAmps;
@597:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(_nextState+283),de
	ld	(_nextState+285),bc
;3844 
;3845   KUNLOCK();
	call	_KUNLOCK
;3846 
;3847   fprintf(DiagLog, "New Setpoint: %s\n", fmtFloat(newAmps, 10,3, temp) );
	ld	hl,-16+@594
	add	hl,sp
	push	hl
	ld	hl,0x3
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	de,word (phys @1+3413)
	ld	c,phys @1+3413 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;3848 }
@595:
	.debug	} @595 3848

@594	equ	16
	ld	sp,ix
	pop	ix
	lret
@596	equ	18
;3849 
;3850 
;3851 int  bitCounts[32];
;3852 
;3853 //-------------------------------------------------------------------------
;3854 //  Minimize the effect of noise on the digitial inputs in trade for some
;3855 //  added latency in response time to actual "legitimate" changes in state.
;3856 //
;3857 //  What this func does is add or subtract the periodic timer interval valu
;3858 //  to/from a running total for each input bit, with a cap on the total bei
;3859 //  the configured # of ms for debouncing.
;3860 //
;3861 //  The current state of each input is determined by whether the running to
;3862 //  for each input is positive or negative.  A positive value indicates a
;3863 //  predominately ON state, while a negative value indicates a predominiate
;3864 //  OFF state.
;3865 //
;3866 //  Inputs that are mostly stable (anomolies not very frequent) will quickl
;3867 //  reach the positive or negative limit and stay close to it until the "re
;3868 //  state changes to the opposite state.  When that happens, the total will
;3869 //  shrink, cross 0, and grow toward the opposite limit.
;3870 //
;3871 //  NOTE the latency effect of this approach on the two extremes:
;3872 //    - No noise:  No errors, but Max latency (== the debounce period)
;3873 //    - Max noise:  Min latency, but constant errors.
;3874 //
;3875 //  NOTE that debounce period also effectively sets a limit on how short a
;3876 //  period that a change in state must last for it to be recognized:  Any
;3877 //  change that lasts for less than twice the debounceMS setting will
;3878 //  generally not be detected.
;3879 //
;3880 //  The setting for the debounce period effectively allows you to ajust the
;3881 //  inherent compromise between delays introduced for the correct readings 
;3882 //  the probability of getting a false reading.  A setting of 0 effectively
;3883 //  disables the filter, while larger values reduce the effect of any noise
;3884 //
;3885 //  This approach behaves aproximately like connecting a capacitor across a
;3886 //  noisy input.  As long as the noise level is low enough, the capacitor
;3887 //  will tend to charge up to the level of the ON voltage, or dischage to
;3888 //  0.  Noise will increase or decrease the voltage, but so long as it is
;3889 //  less frequent than the "real" value, the voltage across the capacitor
;3890 //  will tend to stay near the voltage level for the "real" state.
;3891 //-------------------------------------------------------------------------
;3892 void debounceDigIn(void)
;3893 {
$debounceDigIn::
	.debug	G $debounceDigIn 70 9
	.debug	{ $debounceDigIn 70 3892 @602 @601
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
;3894   int  i;
;3895   int  *bitCount;
;3896   ulong  mask, digIn;
;3897 
;3898 
;3899   bitCount = bitCounts;  digIn = 0;  mask = 1;
	ld	hl,_bitCounts
	ld	(ix-4),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	inc	e
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;3900 
;3901   for (i=0; i<32;  ++i)  {
	ld	(ix-2),hl
@605:
	ld	hl,(ix-2)
	ld	de,0x8020
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@606
;3902     if (digitalIn & mask)
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@610
;3903       *bitCount += (int)SchedMS;
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	de,(_SchedMS)
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3904     else
;3905       *bitCount -= (int)SchedMS;
	jr	@611
@610:
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	de,(_SchedMS)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3906 
;3907     if (*bitCount >  (int)debounceMS)  *bitCount =  (int)debounceMS;
@611:
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	de,(_debounceMS)
	call	__icmp##
	jr	c,@612
	jr	z,@612
	ld	hl,(_debounceMS)
	ex	de,hl
	ld	hl,(ix-4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3908     if (*bitCount < -(int)debounceMS)  *bitCount = -(int)debounceMS;
@612:
	ld	hl,(_debounceMS)
	xor	a,a
	sub	a,l
	ld	l,a
	ld	a,0
	sbc	a,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-4)
	ld	hl,(hl)
	call	__icmp##
	jr	nc,@613
	ld	hl,(_debounceMS)
	xor	a,a
	sub	a,l
	ld	l,a
	ld	a,0
	sbc	a,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3909 
;3910     if (*bitCount > 0)  digIn |= mask;
@613:
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@614
	jr	z,@614
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;3911 
;3912     ++bitCount;  mask <<= 1;
@614:
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;3913   }
;3914 
;3915   digitalIn = digIn;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@605
@606:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
;3916 }
@601:
	.debug	} @601 3916

@600	equ	12
	ld	sp,ix
	pop	ix
	lret
@602	equ	14
;3917 
;3918 
;3919 //-------------------------------------------------------------------------
;3920 //  Check the state of the bulk supplies.
;3921 //-------------------------------------------------------------------------
;3922 void checkBulkSupplies(void)
;3923 {
$checkBulkSupplies::
	.debug	G $checkBulkSupplies 70 9
	.debug	{ $checkBulkSupplies 70 3922 @617 @616
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-52
;3924   uint  ui;
;3925   float  absCur, absCurDiff, maxReadableCur;
;3926   uint  *shortStarted;
;3927   BulkSupplyState  *bsPrev, *bsCur;
;3928   char  temp[32];
;3929 
;3930 
;3931 // NOTE:  Due to the choice of ADCs used for monitoring the bulk supplies a
;3932 //        the time required to get just a single value from them, the volta
;3933 //        and current readings for the bulk supplies are updated only once
;3934 //        every 11 passes through the main application loop, which happens
;3935 //        every SchedMS milliseconds.  At the (typical) setting of 20ms, th
;3936 //        means it takes 220ms to update the current and voltage readings f
;3937 //        all the supplies (s sample rate of just over 4Hz)!
;3938 
;3939 //        In contrast, the IFDBK, VOUT, VTCRL, and BJT_BIAS values are read
;3940 //        every pass (a sample rate of 50Hz when SchedMS = 20ms).
;3941 
;3942 
;3943 //finish:  We could reduce the overhead of these checks by taking in to
;3944 //         account the fact that we have new values only every 220ms.
;3945 //         To spread the (reduced) load out and avoid large jumps in the
;3946 //         time the appl tasks takes, we need to know WHICH inputs we have
;3947 //         new readings for, so I will need to have the hardware layer
;3948 //         provide this information (e.g. a bitmask that the hardware layer
;3949 //         sets bits in for each input it reads, and then applications like
;3950 //         this one could clear those bits when they have processed the
;3951 //         latest value).
;3952 //
;3953 // NOTE:  The inital reads to get the state of the inputs doesn't actually
;3954 //        work in this case, as that first call will only read 2 of the 22
;3955 //        bulk supply inputs (not even that, really, since the first call
;3956 //        will convert whatever channel the chip was sampling - if any -
;3957 //        BEFORE the first call, which could be the wrong channel (or nothi
;3958 //
;3959 //        Note that, while we pass the readAnalogInputs a mask "telling" it
;3960 //        what inputs we want read, it generally isn't practical for the
;3961 //        hardware to read ONLY the specified inputs because you have to
;3962 //        tell the ADC's LAST time what channel you want to read the value
;3963 //        for THIS time.  So trying to honor the bitmask during the step
;3964 //        where we are sending commands to and reading data from the ADCs
;3965 //        could easily take LONGER than just converting and reading all the
;3966 //        inputs in sequence.
;3967 //
;3968 
;3969 
;3970 //----- check state of each bulk supply for problems -----
;3971   maxCurDiff = 0.0;  bulkSupErr = false;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_maxCurDiff),de
	ld	(_maxCurDiff+2),bc
	xor	a,a
	ld	(_bulkSupErr),a
;3972   for (ui=0; ui<NumPS; ++ui)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@620:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jp	nc,@621
;3973     bsPrev = Prev.bs + ui;
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_prevState
	add	hl,bc
	ld	(ix-18),hl
;3974     bsCur = Cur.bs + ui;
	ld	h,d
	ld	l,e
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_curState
	add	hl,bc
	ld	(ix-20),hl
;3975     shortStarted = bulkShortStarted + ui;
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_bulkShortStarted
	add	hl,de
	ld	(ix-16),hl
;3976 
;3977     bsCur->curErr = bsCur->biasErr = bsCur->shortErr = false;
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-20)
	ld	e,0x17
	add	hl,de
	ld	(hl),a
	ld	hl,(ix-20)
	inc	e
	add	hl,de
	ld	(hl),a
;3978 
;3979   //--- skip if no supply attached or the supply is disabled ---
;3980     if (!bsCur->isAvail OR !bsCur->enabled)  continue;
	ld	hl,(ix-20)
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@625
	ld	hl,(ix-20)
	ld	e,0x1a
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@626
@625:
;3981 
;3982   //--- wait until readings have had time to stablize ---
;3983     if (!bridgeStateStable)  {
	jp	@622
@626:
	ld	a,(_bridgeStateStable)
	or	a,a
	jp	nz,@627
;3984       bsCur->lastTimeCurOK = bsCur->lastTimeBiasOK = GetMS();  continue; }
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-20)
	push	de
	ld	de,0xf
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-20)
	push	de
	ld	de,0x13
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jp	@622
;3985 
;3986   //--- compare current and voltage to nominal operating values ---
;3987     bsCur->curDiff = bsCur->current - perSupCur;  // difference from nomina
@627:
	ld	hl,(ix-20)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_perSupCur)
	ld	bc,(_perSupCur+2)
	call	__fsub##
	ld	hl,(ix-20)
	push	de
	ld	de,0xb
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3988     absCurDiff = FABS(bsCur->curDiff);
	ld	hl,(ix-20)
	ld	de,0xb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3989     absCur = FABS(bsCur->current);
	ld	hl,(ix-20)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;3990 
;3991   //--- keep track of max diff for all active supplies ---
;3992     if (absCurDiff > maxCurDiff)  maxCurDiff = absCurDiff;
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_maxCurDiff)
	ld	bc,(_maxCurDiff+2)
	call	__fsub##
	jp	m,@630
	jr	z,@630
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	(_maxCurDiff),de
	ld	(_maxCurDiff+2),bc
;3993 
;3994     maxReadableCur = ReadMax(HECTidx[ui]);  // max possible reading
@630:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_HECTidx
	add	hl,de
	ld	hl,(hl)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@631
	ld	de,0
	ld	bc,0xbf80
	jr	@632
@631:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_HECTidx
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMax)
	ld	c,phys _readValMax >> 16
	call	__ladd##
	call	__farld4##
@632:
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3995 
;3996   //--- is supply operating in expected cur and volt range? ---
;3997     if (absCurDiff/maxReadableCur < maxBSFracCurDiff)
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__fdiv##
	push	bc
	push	de
	ld	de,(_maxBSFracCurDiff)
	ld	bc,(_maxBSFracCurDiff+2)
	call	__fsub##
	jp	p,@633
;3998       bsCur->lastTimeCurOK = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-20)
	push	de
	ld	de,0x13
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3999     if (bsCur->biasVolts >= minBSVolts)
@633:
	ld	hl,(ix-20)
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_minBSVolts)
	ld	bc,(_minBSVolts+2)
	call	__fsub##
	jp	m,@634
;4000       bsCur->lastTimeBiasOK = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-20)
	push	de
	ld	de,0xf
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4001 
;4002   //--- error if nominal values exceeded for too long ---
;4003     bsCur->curErr = (msSince(bsCur->lastTimeCurOK) > maxErrTime);
@634:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-20)
	push	bc
	push	de
	ld	de,0x13
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	hl,(_maxErrTime)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	ld	de,0
	jr	c,@635
	jr	z,@635
	inc	e
@635:
	ld	hl,(ix-20)
	ld	bc,de
	ld	de,0x18
	add	hl,de
	ld	(hl),c
;4004     bsCur->biasErr = (msSince(bsCur->lastTimeBiasOK) > maxErrTime);
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-20)
	push	bc
	push	de
	ld	de,0xf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	hl,(_maxErrTime)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	ld	de,0
	jr	c,@636
	jr	z,@636
	inc	e
@636:
	ld	hl,(ix-20)
	ld	bc,de
	ld	de,0x17
	add	hl,de
	ld	(hl),c
;4005 
;4006   //--- error if current so high there is probably a short ---
;4007     if ((absCur < bulkShortCur) AND (absCur/maxReadableCur < 0.99))  {
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_bulkShortCur)
	ld	bc,(_bulkShortCur+2)
	call	__fsub##
	jp	p,@638
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__fdiv##
	push	bc
	push	de
	ld	de,0x70a4
	ld	bc,0x3f7d
	call	__fsub##
	jp	p,@638
;4008       bsCur->shortErr = false;  *shortStarted = 0;  }
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	xor	a,a
	ld	(hl),a
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix-16)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;4009     else
;4010       if (!*shortStarted)
	jr	@641
@638:
	ld	hl,(ix-16)
	ld	hl,(hl)
	bool	hl
	jr	nz,@642
;4011         *shortStarted = GetMS_();
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-16)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;4012       else
;4013         // NOTE: The bulk current value is only updated once every 11 * Sch
;4014         // ms (at SchedMS = 20 ms, that is only about 4Hz!)
;4015         if (msSince_(*shortStarted) > 700)  // covers just 3 samples...
	jr	@643
@642:
	ld	hl,(ix-16)
	ld	hl,(hl)
	ld	de,(__TimerMilliSeconds+4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x2bc
	or	a,a
	sbc	hl,de
	jr	c,@644
	jr	z,@644
;4016           bsCur->shortErr = true;
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;4017 
;4018 
;4019     if (bsCur->shortErr OR !bsCur->tempOK)  bulkSupErr = true;
@644:
@643:
@641:
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@645
	ld	hl,(ix-20)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@646
@645:
	ld	a,0x1
	ld	(_bulkSupErr),a
;4020 
;4021   //===== log messages about supply-specific changes of state =====
;4022     if (bsCur->curErr != bsPrev->curErr)
@646:
	ld	hl,(ix-20)
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x18
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	z,@647
;4023       printf("Supply #%d current %s nominal range\n"
;4024              "  Actual: %sA  Nominal: %sA\n", ui+1,
;4025              (bsCur->curErr ? "OUTSIDE OF" : "RETURNED TO"),
;4026              fmtFloat(bsCur->current, 6,1, temp),
;4027              fmtFloat(perSupCur, 6,1, temp+10) );
	ld	hl,-42+@615
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x6
	push	hl
	ld	de,(_perSupCur)
	ld	bc,(_perSupCur+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-50+@615
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x6
	push	hl
	ld	hl,(ix-20)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,(ix-20)
	ld	de,0x18
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@648
	ld	hl,@2+377
	jr	@649
@648:
	ld	hl,@2+388
@649:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+3431)
	ld	c,phys @1+3431 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;4028 
;4029     if (bsCur->biasErr != bsPrev->biasErr)
@647:
	ld	hl,(ix-20)
	ld	de,0x17
	add	hl,de
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x17
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	z,@651
;4030       printf("Supply #%d bias voltage %s\n"
;4031              "  Actual: %sV  Min: %sV\n", ui+1,
;4032              (bsCur->biasErr ? "TOO LOW" : "OK"),
;4033              fmtFloat(bsCur->biasVolts, 7,3, temp),
;4034              fmtFloat(minBSVolts, 7,3, temp+10) );
	ld	hl,-42+@615
	add	hl,sp
	push	hl
	ld	hl,0x3
	push	hl
	ld	l,0x7
	push	hl
	ld	de,(_minBSVolts)
	ld	bc,(_minBSVolts+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-50+@615
	add	hl,sp
	push	hl
	ld	hl,0x3
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,(ix-20)
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,(ix-20)
	ld	de,0x17
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@652
	ld	hl,@2+400
	jr	@653
@652:
	ld	hl,@2+408
@653:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+3496)
	ld	c,phys @1+3496 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;4035 
;4036     if (bsCur->shortErr != bsPrev->shortErr)
@651:
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x19
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jp	z,@655
;4037       printf("Supply #%d appears to %s SHORTED\n"
;4038              "  Actual: %sA  Max: %sA or %sA\n", ui+1,
;4039              (bsCur->shortErr ? "BE" : "NO LONGER BE"),
;4040              fmtFloat(bsCur->current, 6,1, temp),
;4041              fmtFloat(maxReadableCur, 6,1, temp+10),
;4042              fmtFloat(bulkShortCur, 6,1, temp+20)  );
	ld	hl,-32+@615
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x6
	push	hl
	ld	de,(_bulkShortCur)
	ld	bc,(_bulkShortCur+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-40+@615
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x6
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-48+@615
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x6
	push	hl
	ld	hl,(ix-20)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,(ix-20)
	ld	de,0x19
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@656
	ld	hl,@2+411
	jr	@657
@656:
	ld	hl,@2+414
@657:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+3548)
	ld	c,phys @1+3548 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;4043 
;4044     if (bsCur->tempOK != bsPrev->tempOK)
@655:
	ld	hl,(ix-20)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	inc	de
	inc	de
	ld	a,(de)
	ld	l,(hl)
	sub	a,l
	jr	z,@659
;4045       printf("Supply #%d temperature fault: %s\n", ui+1,
;4046              (bsCur->tempOK ? "CLEARED" : "ASSERTED")  );
	ld	hl,(ix-20)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@660
	ld	hl,@2+427
	jr	@661
@660:
	ld	hl,@2+435
@661:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+3613)
	ld	c,phys @1+3613 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;4047   }
@659:
;4048 }
@622:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@620
@621:
@616:
	.debug	} @616 4048

@615	equ	52
	ld	sp,ix
	pop	ix
	lret
@617	equ	54
;4049 
;4050 
;4051 //=========================================================================
;4052 //  Copy the "cur" state from last time to "prev", and update "cur"
;4053 //=========================================================================
;4054 //  Just before this function is called, readings were taken of the current
;4055 //  state of the hardware, and any changes to the output states specified b
;4056 //  the last pass were applied (just after taking the readings).
;4057 //
;4058 //  This func first copies "cur" to "prev" and then "next" to "cur" which d
;4059 //  2 things for us:
;4060 //
;4061 //    - We have a copy of the controller's logical state from the last pass
;4062 //      (so we can determine what has changed)
;4063 //
;4064 //    - We have a copy of values set by other tasks indicating events/reque
;4065 //      that happend/were made since the beginning of the last pass
;4066 //
;4067 //  We then reset the values (as needed) that are set by other tasks to
;4068 //  indicate events and requests, and update the current state based on the
;4069 //  readings just taken and the requests and events communicated by other
;4070 //  tasks.
;4071 //
;4072 //  All of this is in preperation for the updateNextState() function, which
;4073 //  implements the main "decision making" portion of the application logic,
;4074 //  determining what the next state should be based on the latest condition
;4075 //  (as determined by the updateCurState() function).
;4076 //
;4077 //=========================================================================
;4078 void updateCurState(void)
;4079 {
$updateCurState::
	.debug	G $updateCurState 70 9
	.debug	{ $updateCurState 70 4078 @665 @664
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-78
;4080   uint  ui;
;4081   float  vlimOffset, ampReadMax;
;4082   bool  loggableStateChg, loggedStateChg;
;4083   BulkSupplyState  *bsCur;
;4084   char  temp[64];
;4085 
;4086 #define POLARITY(val)  ( (val) > 0.0 ? Pos_Pol : Neg_Pol )
;4087 
;4088 
;4089   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@664
;4090 
;4091 //-----------------------------------------------------------------
;4092 // The following conditions exist at this point:
;4093 // - The inputs have just been read
;4094 // - The outputs were just set to values computed during the last pass
;4095 // - "cur" contains the state the inputs were in at the START of
;4096 //   of the previous pass, and the state the outputs were in DURING
;4097 //   the previous pass
;4098 // - "next" contains the values that the outputs were just set
;4099 //   to and any "input" values that were changed by other tasks
;4100 //------------------------------------------------------------------
;4101 
;4102 //  Next.processTime = GetMS();  curTime = time(NULL);
;4103 
;4104 //  msSincePrev = msSince(Cur.processTime);
;4105 
;4106   debounceDigIn();  Next.digitalIn = digitalIn;
	lcall	$debounceDigIn
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+287),de
	ld	(_nextState+289),bc
;4107 
;4108 
;4109 // Note that a copy is done (rather than just switching pointer values) to
;4110 // insure all values are set in both the source and destination.  If we
;4111 // simply kept pointers and swapped the pointer values, then EVERY value
;4112 // would have to be updated independently by the code, which is a pain to
;4113 // program, adds overhead and code, and is a VERY easy way to introduce odd
;4114 // bugs.  Overall, copying everything here is actually faster overall,
;4115 // simpler, and much safer.
;4116 
;4117   Prev = Cur;  Cur = Next;
	ld	hl,_curState
	ld	de,_prevState
	push	hl
	ld	bc,338
	ldir
	pop	hl
	ld	hl,_nextState
	ld	de,_curState
	push	hl
	ld	bc,338
	ldir
	pop	hl
;4118 
;4119 //--- At this point the Cur copy contains what the inputs were at the start
;4120 //--- of this pass, and the Prev copy contains the output values from the -
;4121 //--- the previous pass (i.e. the output values that resulted in the input 
;4122 //--- values in Cur) ---
;4123 
;4124 
;4125 //--------------------------------------------------------------------
;4126 // Next we update the rest of the "cur" values needed by the control
;4127 // logic (the ones that do NOT come from "next" values set by other
;4128 // tasks)
;4129 //
;4130 // NOTES:
;4131 //  - This portion of the logic has order-of-execution dependencies,
;4132 //    so be sure that all values referenced in an expression are ones
;4133 //    set before they are used.
;4134 //
;4135 //  - References to "prev" values are always safe since they are just
;4136 //    a copy of values from the last pass
;4137 //--------------------------------------------------------------------
;4138 
;4139 
;4140 //--- log msgs for bit chgs only if not starving other processes for cycles
;4141   if (SchedMS - applLoopTime > 2)  logDigIOChgs(false);
	ld	hl,(_SchedMS)
	ld	de,(_applLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	c,@667
	jr	z,@667
	bool	hl
	ld	l,h
	push	hl
	lcall	$logDigIOChgs
	pop	hl
;4142 
;4143 
;4144 //APPLCODE
;4145 
;4146   if ((supplyType != TYPE_FET) AND (supplyType != TYPE_SCR))  supplyType = 
@667:
	ld	hl,(_supplyType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@669
	ld	hl,(_supplyType)
	inc	e
	or	a,a
	sbc	hl,de
	jr	z,@669
	bool	hl
	ld	l,h
	ld	(_supplyType),hl
;4147   if ((loadType != LOAD_DC) AND (loadType != LOAD_RL))  loadType = 0;
@669:
	ld	hl,(_loadType)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@671
	ld	hl,(_loadType)
	dec	e
	or	a,a
	sbc	hl,de
	jr	z,@671
	bool	hl
	ld	l,h
	ld	(_loadType),hl
;4148 
;4149   Cur.btnBits = ~(uint)extraIn & 0x001F;
@671:
	ld	hl,(_extraIn)
	ld	a,l
	cpl	a
	ld	l,a
	ld	a,h
	cpl	a
	ld	h,a
	ld	de,0x1f
	and	hl,de
	ld	(_curState+296),hl
;4150 
;4151 
;4152 //--- check for front-panel button activity ---
;4153 //--- These bits are not in the normal digitalIn so they are not covered --
;4154 //---  by the call to logInputChgs() ---
;4155   if (Cur.btnBits != Prev.btnBits)  {
	ld	de,(_prevState+296)
	or	a,a
	sbc	hl,de
	jr	z,@672
;4156     if (Cur.btnBits == START_BTN)  {
	ld	hl,(_curState+296)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nz,@675
;4157       Cur.onRequest = true;  printf("\nSTART btn pressed\n");  }
	ld	a,0x1
	ld	(_curState+280),a
	ld	de,word (phys @1+3647)
	ld	c,phys @1+3647 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4158     if (Cur.btnBits == STOP_BTN)   {
@675:
	ld	hl,(_curState+296)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jr	nz,@678
;4159       Cur.offRequest = true;  printf("\nSTOP btn pressed\n");  }
	ld	a,0x1
	ld	(_curState+281),a
	ld	de,word (phys @1+3667)
	ld	c,phys @1+3667 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4160     if (Cur.btnBits == RESET_BTN)  {
@678:
	ld	hl,(_curState+296)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nz,@681
;4161       Cur.resetRequest = true;  printf("\nRESET intlk btn pressed\n");  }
	ld	a,0x1
	ld	(_curState+282),a
	ld	de,word (phys @1+3686)
	ld	c,phys @1+3686 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4162   }
@681:
;4163 
;4164   Cur.externIntlk = !(digitalIn & NO_INTLK);
@672:
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x8000
	call	__land##
	ld	hl,bc
	or	hl,de
	ld	de,0
	jr	nz,@684
	inc	e
@684:
	ld	a,e
	ld	(_curState+291),a
;4165   holecOK = BOOL(digitalIn & HOLEC_OK);
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4000
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@685
	ld	a,0x1
	jr	@686
@685:
	xor	a,a
@686:
	ld	(_holecOK),a
;4166 
;4167 //--- unscaled input voltage readings ---
;4168   Cur.ifdbk = anaIn[AI_IFDBK];
	ld	de,(_anaIn)
	ld	bc,(_anaIn+2)
	ld	(_curState+300),de
	ld	(_curState+302),bc
;4169   Cur.vctrl = -anaIn[AI_VCTRL];
	ld	de,(_anaIn+8)
	ld	bc,(_anaIn+10)
	ld	a,b
	xor	a,0x80
	ld	b,a
	ld	(_curState+308),de
	ld	(_curState+310),bc
;4170   Cur.bjtBias = anaIn[AI_BJT_BIAS];
	ld	de,(_anaIn+12)
	ld	bc,(_anaIn+14)
	ld	(_curState+312),de
	ld	(_curState+314),bc
;4171 
;4172 //--- unscaled output voltages applied just after the readings were taken -
;4173   Cur.iset = -anaOut[AO_ISET];
	ld	de,(_anaOut)
	ld	bc,(_anaOut+2)
	ld	a,b
	xor	a,0x80
	ld	b,a
	ld	(_curState+316),de
	ld	(_curState+318),bc
;4174 
;4175 //--- input voltages scaled to engineering units ---
;4176   voltRead = Cur.vout = -readVal[AI_VOUT];
	ld	de,(_readVal+4)
	ld	bc,(_readVal+6)
	ld	a,b
	xor	a,0x80
	ld	b,a
	ld	(_curState+304),de
	ld	(_curState+306),bc
	ld	(_voltRead),de
	ld	(_voltRead+2),bc
;4177   ampRead = readVal[AI_IFDBK];
	ld	de,(_readVal)
	ld	bc,(_readVal+2)
	ld	(_ampRead),de
	ld	(_ampRead+2),bc
;4178   absAmpRead = FABS(ampRead);
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	(_absAmpRead),de
	ld	(_absAmpRead+2),bc
;4179 
;4180   ampReadMax = ReadMax(AI_IFDBK);
	bool	hl
	ld	l,h
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@687
	ld	de,0
	ld	bc,0xbf80
	jr	@688
@687:
	ld	de,word (phys _readValMax)
	ld	c,phys _readValMax >> 16
	call	__farld4##
@688:
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4181 
;4182 //--- have bulk supplies provided power long enough to have stable outputs?
;4183   if (Cur.state != STATE_ON)  {
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@689
;4184     psOnAndReady = false;  psOnTime = 0; }
	xor	a,a
	ld	(_psOnAndReady),a
	bool	hl
	ld	l,h
	ld	(_psOnTime),hl
;4185   else  {
	jr	@692
@689:
;4186     if (!psOnTime)  psOnTime = GetMS_();
	ld	hl,(_psOnTime)
	bool	hl
	jr	nz,@695
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_psOnTime),hl
;4187     if (!psOnAndReady)
@695:
	ld	a,(_psOnAndReady)
	or	a,a
	jr	nz,@696
;4188       if (msSince_(psOnTime) > minPSonTime)  psOnAndReady = true;
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_psOnTime)
	or	a,a
	sbc	hl,de
	ld	de,(_minPSonTime)
	or	a,a
	sbc	hl,de
	jr	c,@697
	jr	z,@697
	ld	a,0x1
	ld	(_psOnAndReady),a
;4189   }
@697:
@696:
;4190 
;4191 //--- have the bridges been in the same state long enough for stable rdgs? 
;4192   if (Cur.polCmd != Prev.polCmd)  {
@692:
	ld	hl,(_curState+332)
	ld	de,(_prevState+332)
	or	a,a
	sbc	hl,de
	jr	z,@698
;4193     bridgeStateStable = false;  bridgeChgdTime = GetMS_(); }
	xor	a,a
	ld	(_bridgeStateStable),a
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_bridgeChgdTime),hl
;4194   else
;4195     if (!bridgeStateStable)
	jr	@701
@698:
	ld	a,(_bridgeStateStable)
	or	a,a
	jr	nz,@702
;4196       if (msSince_(bridgeChgdTime) > minPSonTime)  bridgeStateStable = true
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_bridgeChgdTime)
	or	a,a
	sbc	hl,de
	ld	de,(_minPSonTime)
	or	a,a
	sbc	hl,de
	jr	c,@703
	jr	z,@703
	ld	a,0x1
	ld	(_bridgeStateStable),a
;4197 
;4198 //--- keep track of if and how long the bridges have been off ---
;4199   if (Cur.polCmd != POL_OFF)
@703:
@702:
@701:
	ld	hl,(_curState+332)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@704
;4200     bridgeOffTime = 0;   // bridges are on
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(_bridgeOffTime),de
	ld	(_bridgeOffTime+2),bc
;4201   else  {
	jp	@705
@704:
;4202     if (!bridgeOffTime)  {  // bridges just changed from ON to OFF?
	ld	de,(_bridgeOffTime)
	ld	bc,(_bridgeOffTime+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@708
;4203       bridgeOffTime = GetMS();  bridgeJustOff = true; }
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_bridgeOffTime),de
	ld	(_bridgeOffTime+2),bc
	ld	a,0x1
	ld	(_bridgeJustOff),a
;4204     else
;4205       if (msSince(bridgeOffTime) >= minBridgeOffTime)  bridgeJustOff = fals
	jp	@711
@708:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_bridgeOffTime)
	ld	bc,(_bridgeOffTime+2)
	call	__lsub##
	ld	hl,(_minBridgeOffTime)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	c,@712
	xor	a,a
	ld	(_bridgeJustOff),a
;4206   }
@712:
@711:
;4207 
;4208 
;4209 
;4210 //=================================================
;4211 //===== update the state of the bulk supplies =====
;4212 //=================================================
;4213 
;4214 //--- update readings for each bulk supply and determine # of supplies ---
;4215 //--- that should be operating and the total current they are handling ---
;4216   Cur.psCount = 0;  ttlBulkCur = 0.0;
@705:
	bool	hl
	ld	l,h
	ld	(_curState+298),hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	ld	(_ttlBulkCur),de
	ld	(_ttlBulkCur+2),bc
;4217   for (ui=0; ui<NumPS; ++ui)  {
	ld	(ix-2),hl
@715:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jp	nc,@716
;4218     bsCur = Cur.bs + ui;
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_curState
	add	hl,bc
	ld	(ix-14),hl
;4219 
;4220     bsCur->biasVolts = readVal[BSVidx[ui]];
	ld	h,d
	ld	l,e
	add	hl,hl
	ld	de,_BSVidx
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4221     bsCur->current = readVal[HECTidx[ui]];
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_HECTidx
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-14)
	push	de
	ld	de,0x7
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4222 
;4223     bsCur->isOn = BOOL(digitalIn & IsOnBit[ui]);
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_IsOnBit
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@720
	ld	a,0x1
	jr	@721
@720:
	xor	a,a
@721:
	ld	hl,(ix-14)
	ld	(hl),a
;4224     bsCur->tempOK = BOOL(digitalIn & TempOKBit[ui]);
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_TempOKBit
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@722
	ld	a,0x1
	jr	@723
@722:
	xor	a,a
@723:
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ld	(hl),a
;4225     bsCur->isAvail = BOOL(digitalIn & AvailBit[ui]);
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_AvailBit
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@724
	ld	a,0x1
	jr	@725
@724:
	xor	a,a
@725:
	ld	hl,(ix-14)
	inc	hl
	ld	(hl),a
;4226 
;4227     if (!bsCur->isAvail)  continue;
	ld	hl,(ix-14)
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@717
;4228 
;4229     ++Cur.psCount;  ttlBulkCur += bsCur->current;
	ld	hl,(_curState+298)
	inc	hl
	ld	(_curState+298),hl
	ld	hl,(ix-14)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_ttlBulkCur)
	ld	bc,(_ttlBulkCur+2)
	call	__fadd##
	ld	(_ttlBulkCur),de
	ld	(_ttlBulkCur+2),bc
;4230   }
;4231   absBulkCur = FABS(ttlBulkCur);
@717:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@715
@716:
	ld	de,(_ttlBulkCur)
	ld	bc,(_ttlBulkCur+2)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	(_absBulkCur),de
	ld	(_absBulkCur+2),bc
;4232   if (polCmd == POL_NEG)  ttlBulkCur = -absBulkCur;
	ld	hl,(_polCmd)
	bool	hl
	jr	nz,@727
	ld	a,b
	xor	a,0x80
	ld	b,a
	ld	(_ttlBulkCur),de
	ld	(_ttlBulkCur+2),bc
;4233 
;4234 
;4235 //--- how much current should we be reading for each active bulk supply ---
;4236   if (polCmd == POL_OFF)
@727:
	ld	hl,(_polCmd)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@728
;4237     perSupCur = 0.0;
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(_perSupCur),de
	ld	(_perSupCur+2),bc
;4238   else  {
	jr	@729
@728:
;4239     perSupCur = (Cur.psCount ? ampRead / Cur.psCount : 0.0);
	ld	hl,(_curState+298)
	bool	hl
	jr	z,@732
	ld	hl,(_curState+298)
	ex	de,hl
	call	__uitof##
	push	bc
	push	de
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	call	__fdivr##
	jr	@733
@732:
	ld	de,0
	ld	c,e
	ld	b,e
@733:
	ld	(_perSupCur),de
	ld	(_perSupCur+2),bc
;4240     perSupCur = FABS(perSupCur);
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	(_perSupCur),de
	ld	(_perSupCur+2),bc
;4241     //finish: need to incr/decr by amount that flows through dump resistor
;4242     //  When ramping, some of the supply current is going through the dump
;4243     //  resistor, so the perSupCur is larger than the load current/#supplie
;4244     //  When sinking, some of the load current is going through the dump
;4245     //  resistor, so the perSupCur is smaller then the load current/#suppli
;4246   }
;4247 
;4248 
;4249   checkBulkSupplies();
@729:
	lcall	$checkBulkSupplies
;4250 
;4251 
;4252 //===========================================================
;4253 //===== update values that are not bulk-supply-specific =====
;4254 //===========================================================
;4255 
;4256 //--- polarity and magnitude of error in the load current ---
;4257   ampErr = Prev.ampApply - ampRead;
	ld	de,(_prevState+328)
	ld	bc,(_prevState+330)
	push	bc
	push	de
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	call	__fsub##
	ld	(_ampErr),de
	ld	(_ampErr+2),bc
;4258   Cur.ctlErr = Prev.iset - Cur.ifdbk;
	ld	de,(_prevState+316)
	ld	bc,(_prevState+318)
	push	bc
	push	de
	ld	de,(_curState+300)
	ld	bc,(_curState+302)
	call	__fsub##
	ld	(_curState+320),de
	ld	(_curState+322),bc
;4259   absErr = FABS(Cur.ctlErr);
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	(_absErr),de
	ld	(_absErr+2),bc
;4260 
;4261 //--- what polarity is the regulation circuit asserting? ---
;4262 //--- NOTE:  VCTRL has been inverted from schematic to make logical sense -
;4263   Cur.regPol = POLARITY(Cur.vctrl);
	ld	de,(_curState+308)
	ld	bc,(_curState+310)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	m,@734
	jr	z,@734
	ld	a,0x1
	jr	@735
@734:
	xor	a,a
@735:
	ld	(_curState+292),a
;4264 
;4265 //--- determine what the polarity is (ignoring changes within a small ---
;4266 //--- window around zero) ---
;4267 //--- NOTE:  VCTRL has been inverted from schematic to make logical sense -
;4268   Cur.hystRegPol = Prev.hystRegPol;
	ld	a,(_prevState+293)
	ld	(_curState+293),a
;4269   if (FABS(Cur.vctrl) > vctrlHyst)  Cur.hystRegPol = Cur.regPol;
	ld	de,(_curState+308)
	ld	bc,(_curState+310)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,(_vctrlHyst)
	ld	bc,(_vctrlHyst+2)
	call	__fsub##
	jp	m,@736
	jr	z,@736
	ld	a,(_curState+292)
	ld	(_curState+293),a
;4270 
;4271 //--- keep track of whether regulation polarity is stable or not ---
;4272   Cur.regPolStable = Prev.regPolStable;
@736:
	ld	a,(_prevState+294)
	ld	(_curState+294),a
;4273   if (Cur.hystRegPol != Prev.hystRegPol)   {
	ld	a,(_curState+293)
	ld	l,a
	ld	a,(_prevState+293)
	sub	a,l
	jp	z,@737
;4274     Cur.regPolStable = false;  lastRegPolChgTime = GetMS();  }
	xor	a,a
	ld	(_curState+294),a
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_lastRegPolChgTime),de
	ld	(_lastRegPolChgTime+2),bc
;4275   else
;4276     if (msSince(lastRegPolChgTime) > minPolStableTime)
	jp	@740
@737:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_lastRegPolChgTime)
	ld	bc,(_lastRegPolChgTime+2)
	call	__lsub##
	ld	hl,(_minPolStableTime)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	c,@741
	jr	z,@741
;4277       Cur.regPolStable = true;
	ld	a,0x1
	ld	(_curState+294),a
;4278 
;4279 
;4280 //--- are we close to one of the voltage limits? ---
;4281   vlimOffset = (Cur.vout < 0.0) ?
@741:
@740:
;4282       (vlimMinus - vlimAdjust + Cur.vout) : (vlimPlus - vlimAdjust - Cur.vo
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@742
	ld	de,(_vlimMinus)
	ld	bc,(_vlimMinus+2)
	push	bc
	push	de
	ld	de,(_vlimAdjust)
	ld	bc,(_vlimAdjust+2)
	call	__fsub##
	push	bc
	push	de
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	call	__fadd##
	jr	@743
@742:
	ld	de,(_vlimPlus)
	ld	bc,(_vlimPlus+2)
	push	bc
	push	de
	ld	de,(_vlimAdjust)
	ld	bc,(_vlimAdjust+2)
	call	__fsub##
	push	bc
	push	de
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	call	__fsub##
@743:
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4283   voltageLimited = (vlimOffset < 0.1);  // includes neg values for exceedin
	push	bc
	push	de
	ld	de,0xcccd
	ld	bc,0x3dcc
	call	__fsub##
	ld	de,0
	jp	p,@744
	inc	e
@744:
	ld	a,e
	ld	(_voltageLimited),a
;4284 
;4285 
;4286 //--- Is bulk current close to the magnet current? ---
;4287   bulkCurDiff = ttlBulkCur - ampRead;  absBulkCurDiff = FABS(bulkCurDiff);
	ld	de,(_ttlBulkCur)
	ld	bc,(_ttlBulkCur+2)
	push	bc
	push	de
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	call	__fsub##
	ld	(_bulkCurDiff),de
	ld	(_bulkCurDiff+2),bc
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	(_absBulkCurDiff),de
	ld	(_absBulkCurDiff+2),bc
;4288   bulkCurClose = absBulkCurDiff < ampReadMax * 0.10;
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xcccd
	ld	bc,0x3dcc
	call	__fmlt##
	push	bc
	push	de
	ld	de,(_absBulkCurDiff)
	ld	bc,(_absBulkCurDiff+2)
	call	__fsubr##
	ld	de,0
	jp	p,@745
	inc	e
@745:
	ld	a,e
	ld	(_bulkCurClose),a
;4289 
;4290 //--- Is the load current large enough to allow us to determine with any --
;4291 //--- accuracy what mode the load and supplies are in? ---
;4292   lowLoadCur = (absAmpRead < sinkEndAmps);
	ld	de,(_absAmpRead)
	ld	bc,(_absAmpRead+2)
	push	bc
	push	de
	ld	de,(_sinkEndAmps)
	ld	bc,(_sinkEndAmps+2)
	call	__fsub##
	ld	de,0
	jp	p,@746
	inc	e
@746:
	ld	a,e
	ld	(_lowLoadCur),a
;4293 
;4294 
;4295   if (!lowLoadCur)  {
	or	a,a
	jr	nz,@747
;4296     loadRes = Cur.vout / ampRead;
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	call	__fdiv##
	ld	(_loadRes),de
	ld	(_loadRes+2),bc
;4297     dumpRes = Cur.vout / (ttlBulkCur - ampRead);
	ld	de,(_ttlBulkCur)
	ld	bc,(_ttlBulkCur+2)
	push	bc
	push	de
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	call	__fsub##
	push	bc
	push	de
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	call	__fdivr##
	ld	(_dumpRes),de
	ld	(_dumpRes+2),bc
;4298   }
;4299 
;4300 //--- If the polarity of the voltage across the load and dump resistor is -
;4301 //--- opposite that of the current through the bridge, then the dump ---
;4302 //--- resistor (and possibly the supplies) are absorbing power from an ---
;4303 //... inductive load ---
;4304   sinking = !bulkCurClose AND
@747:
;4305            ( ((Cur.vout > 0.0) AND (Cur.polCmd == POL_NEG))
;4306             OR ((Cur.vout < 0.0) AND (Cur.polCmd == POL_POS)) );
	ld	a,(_bulkCurClose)
	or	a,a
	jr	nz,@751
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	m,@753
	jr	z,@753
	ld	hl,(_curState+332)
	bool	hl
	jr	z,@759
@753:
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@751
	ld	hl,(_curState+332)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@751
@759:
	ld	hl,1
	jr	@760
@751:
	bool	hl
	ld	l,h
@760:
	ld	a,l
	ld	(_sinking),a
;4307 
;4308 //--- If the polarity of the voltage across the load and dump resistor is -
;4309 //--- the same as the bridge polarity (i.e. the bridge is on and we aren't 
;4310 //--- sinking power), and the supply/bridge current is significantly ---
;4311 //--- different than the load current, then we are ramping (i.e. the load -
;4312 //--- is absorbing power from the bulk supplies) ---
;4313   ramping = (!sinking AND (polCmd != POL_OFF) AND !bulkCurClose);
	or	a,a
	jr	nz,@762
	ld	hl,(_polCmd)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@762
	ld	a,(_bulkCurClose)
	or	a,a
	jr	nz,@762
	ld	a,e
	jr	@763
@762:
	xor	a
@763:
	ld	(_ramping),a
;4314 
;4315 //--- If the bulk current is close to the load current, and the load voltag
;4316 //--- is not at the limits, then we are in a steady regulation state ---
;4317   regulating = bulkCurClose AND !voltageLimited;
	ld	a,(_bulkCurClose)
	or	a,a
	jr	z,@765
	ld	a,(_voltageLimited)
	or	a,a
	jr	nz,@765
	ld	a,1
	jr	@766
@765:
	xor	a
@766:
	ld	(_regulating),a
;4318 
;4319 //--- If the bridge is OFF, and the load current is not close to 0, then --
;4320 //--- the load is dumping energy via the dump resistor ---
;4321   dumping = ((polCmd == POL_OFF) AND !lowLoadCur);
	ld	hl,(_polCmd)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@768
	ld	a,(_lowLoadCur)
	or	a,a
	jr	nz,@768
	ld	a,e
	jr	@769
@768:
	xor	a
@769:
	ld	(_dumping),a
;4322 
;4323 
;4324 //--- reduce applied voltage limits during sink mode ---
;4325   vlimAdjust = sinking ? vlimReduction : 0.0;
	ld	a,(_sinking)
	or	a,a
	jr	z,@770
	ld	de,(_vlimReduction)
	ld	bc,(_vlimReduction+2)
	jr	@771
@770:
	ld	de,0
	ld	c,e
	ld	b,e
@771:
	ld	(_vlimAdjust),de
	ld	(_vlimAdjust+2),bc
;4326 
;4327 //--- combine output state logic values in to a single index ---
;4328   Cur.outMode = OM_UNCAL;
	ld	hl,0x9
	ld	(_curState+324),hl
;4329   do  {
;4330     if (Cur.state != STATE_ON)  {
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@777
;4331       Cur.outMode = OM_OFF;  break; }
	bool	hl
	ld	l,h
	jr	@798
;4332     if (!psOnAndReady OR !bridgeStateStable)  {
@777:
	ld	a,(_psOnAndReady)
	or	a,a
	jr	z,@780
	ld	a,(_bridgeStateStable)
	or	a,a
	jr	nz,@781
@780:
;4333       Cur.outMode = OM_WAIT;  break; }
	ld	hl,0x1
	jr	@798
;4334     if (sinking)  {
@781:
	ld	a,(_sinking)
	or	a,a
	jr	z,@784
;4335       Cur.outMode = ((Cur.vout > 0.0) ? OM_SINK_P : OM_SINK_N);  break; }
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	m,@787
	jr	z,@787
	ld	hl,0x4
	jr	@798
@787:
	ld	hl,0x5
	jr	@798
;4336     if (ramping)  {
@784:
	ld	a,(_ramping)
	or	a,a
	jr	z,@789
;4337       Cur.outMode = (Cur.hystRegPol ? OM_RAMP_P : OM_RAMP_N);  break; }
	ld	a,(_curState+293)
	or	a,a
	jr	z,@792
	ld	hl,0x6
	jr	@798
@792:
	ld	hl,0x7
	jr	@798
;4338     if (regulating)  {
@789:
	ld	a,(_regulating)
	or	a,a
	jr	z,@794
;4339       Cur.outMode = (Cur.hystRegPol ? OM_REG_P : OM_REG_N);  break; }
	ld	a,(_curState+293)
	or	a,a
	jr	z,@797
	ld	hl,0x2
	jr	@798
@797:
	ld	hl,0x3
@798:
	ld	(_curState+324),hl
	jr	@773
;4340     if (dumping)  {
@794:
	ld	a,(_dumping)
	or	a,a
	jr	z,@799
;4341       Cur.outMode = OM_DUMP;  break; }
	ld	hl,0x8
	ld	(_curState+324),hl
;4342   } while(0);
@799:
;4343   if (Cur.outMode != OM_UNCAL)
@773:
	ld	hl,(_curState+324)
	ld	de,0x9
	or	a,a
	sbc	hl,de
	jp	z,@802
;4344     lastModeSetTime = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_lastModeSetTime),de
	ld	(_lastModeSetTime+2),bc
;4345   else
;4346     if (msSince(lastModeSetTime) < maxErrTime)  Cur.outMode = Prev.outMode;
	jp	@803
@802:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_lastModeSetTime)
	ld	bc,(_lastModeSetTime+2)
	call	__lsub##
	ld	hl,(_maxErrTime)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	nc,@804
	ld	hl,(_prevState+324)
	ld	(_curState+324),hl
;4347 
;4348 
;4349 //--- check to see if the loadType appears to be wrong ---
;4350   inductiveLoad = (loadType == LOAD_RL);
@804:
@803:
	ld	hl,(_loadType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	ld	h,d
	ld	l,d
	jr	nz,@805
	inc	l
@805:
	ld	a,l
	ld	(_inductiveLoad),a
;4351   if (sinking OR ramping OR dumping)
	ld	a,(_sinking)
	or	a,a
	jr	nz,@806
	ld	a,(_ramping)
	or	a,a
	jr	nz,@806
	ld	a,(_dumping)
	or	a,a
	jr	z,@807
@806:
;4352     loadTypeWrong = !inductiveLoad;
	ld	a,(_inductiveLoad)
	or	a,a
	ld	a,0
	jr	nz,@808
	inc	a
@808:
	ld	(_loadTypeWrong),a
;4353   else
;4354     loadTypeWrong = false;
	jr	@809
@807:
	xor	a,a
	ld	(_loadTypeWrong),a
;4355   if (!loadTypeWrong)
@809:
	ld	a,(_loadTypeWrong)
	or	a,a
	jr	nz,@810
;4356     lastLoadTypeWarnTime = GetSeconds_() - 300;
	ld	hl,(__TimerSeconds)
	ld	de,0xfed4
	add	hl,de
	ld	(_lastLoadTypeWarnTime),hl
;4357   else
;4358     if (SecSince_(lastLoadTypeWarnTime) > 300)  {
	jr	@811
@810:
	ld	hl,(__TimerSeconds)
	ld	de,(_lastLoadTypeWarnTime)
	or	a,a
	sbc	hl,de
	ld	de,0x12c
	or	a,a
	sbc	hl,de
	jr	c,@812
	jr	z,@812
;4359       printf("***** loadType appears to be set wrong ***\n\n");
	ld	de,word (phys @1+3712)
	ld	c,phys @1+3712 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4360       lastLoadTypeWarnTime = GetSeconds_();
	ld	hl,(__TimerSeconds)
	ld	(_lastLoadTypeWarnTime),hl
;4361     }
;4362 
;4363 
;4364 
;4365 //===== log messages about non-supply-specific changes of state =====
;4366 
;4367 //--- limit unwanted "noise" messages in the log ---
;4368   if ((Cur.ampSet != Prev.ampSet) OR (Cur.ampApply != Prev.ampApply)
@812:
@811:
;4369       OR (Cur.state != Prev.state) OR (SecSince_(lastLoggableStateChg) > 12
	ld	de,(_curState+283)
	ld	bc,(_curState+285)
	push	bc
	push	de
	ld	de,(_prevState+283)
	ld	bc,(_prevState+285)
	call	__fequ##
	jr	nz,@815
	ld	de,(_curState+328)
	ld	bc,(_curState+330)
	push	bc
	push	de
	ld	de,(_prevState+328)
	ld	bc,(_prevState+330)
	call	__fequ##
	jr	nz,@815
	ld	hl,(_curState+326)
	ld	de,(_prevState+326)
	or	a,a
	sbc	hl,de
	jr	nz,@815
	ld	hl,(__TimerSeconds)
	ld	de,(_lastLoggableStateChg)
	or	a,a
	sbc	hl,de
	ld	de,0x78
	or	a,a
	sbc	hl,de
	jr	c,@816
	jr	z,@816
@815:
;4370     numLoggedChgMsgs = 0;  logStateChgMsgs = true;
	bool	hl
	ld	l,h
	ld	(_numLoggedChgMsgs),hl
	ld	a,0x1
	ld	(_logStateChgMsgs),a
;4371     lastEnabledChgMsg = GetMS_();
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastEnabledChgMsg),hl
;4372   }
;4373   else  if (logStateChgMsgs AND (numLoggedChgMsgs > 12)
	jr	@819
@816:
;4374             AND (msSince_(lastEnabledChgMsg) > 1000))  {
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@821
	ld	hl,(_numLoggedChgMsgs)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	c,@821
	jr	z,@821
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastEnabledChgMsg)
	or	a,a
	sbc	hl,de
	ld	de,0x3e8
	or	a,a
	sbc	hl,de
	jr	c,@821
	jr	z,@821
;4375     logStateChgMsgs = false;
	xor	a,a
	ld	(_logStateChgMsgs),a
;4376     printf("--- Polarity and Mode change msgs temporarily disabled ---\n");
	ld	de,word (phys @1+3757)
	ld	c,phys @1+3757 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4377   }
;4378 
;4379 
;4380   loggableStateChg = loggedStateChg = false;
@821:
@819:
	xor	a,a
	ld	(ix-12),a
	ld	(ix-11),a
;4381 
;4382   if (Cur.state == STATE_ON)  {
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@824
;4383     if (Cur.hystRegPol != Prev.hystRegPol)  {
	ld	a,(_curState+293)
	ld	l,a
	ld	a,(_prevState+293)
	sub	a,l
	jr	z,@827
;4384       loggableStateChg = true;
	ld	(ix-11),0x1
;4385       if (logStateChgMsgs)
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@834
;4386         printf("Regulation polarity changed to %s\n",
;4387                Cur.hystRegPol ? "POS" : "NEG" );
	ld	a,l
	or	a,a
	jr	z,@831
	ld	hl,@2+444
	jr	@832
@831:
	ld	hl,@2+448
@832:
	push	hl
	ld	de,word (phys @1+3817)
	ld	c,phys @1+3817 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4388     }
;4389     else  if (Cur.regPolStable != Prev.regPolStable)  {
	jr	@834
@827:
	ld	a,(_curState+294)
	ld	l,a
	ld	a,(_prevState+294)
	sub	a,l
	jr	z,@835
;4390       loggableStateChg = true;
	ld	(ix-11),0x1
;4391       if (logStateChgMsgs)
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@838
;4392         printf("Regulation polarity %sSTABLE\n", Cur.regPolStable ? "" : "U
	ld	a,l
	or	a,a
	jr	z,@839
	ld	hl,@2+5
	jr	@840
@839:
	ld	hl,@2+452
@840:
	push	hl
	ld	de,word (phys @1+3852)
	ld	c,phys @1+3852 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4393     }
@838:
;4394   }
@835:
@834:
;4395 
;4396   if (Cur.polCmd != Prev.polCmd)  {
@824:
	ld	hl,(_curState+332)
	ld	de,(_prevState+332)
	or	a,a
	sbc	hl,de
	jr	z,@842
;4397     loggableStateChg = true;
	ld	(ix-11),0x1
;4398     if (logStateChgMsgs)  printf("Polarity cmds: %s\n", PolCmdDesc[Cur.polC
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@845
	ld	hl,(_curState+332)
	add	hl,hl
	ld	de,_PolCmdDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+3882)
	ld	c,phys @1+3882 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4399   }
@845:
;4400 
;4401   if (Cur.outMode != Prev.outMode)  {
@842:
	ld	hl,(_curState+324)
	ld	de,(_prevState+324)
	or	a,a
	sbc	hl,de
	jr	z,@846
;4402     loggableStateChg = true;
	ld	(ix-11),0x1
;4403     if (logStateChgMsgs)  printf("Output Mode: %s\n", OutModeDesc[Cur.outMo
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@849
	ld	hl,(_curState+324)
	add	hl,hl
	ld	de,_OutModeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+3901)
	ld	c,phys @1+3901 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4404   }
@849:
;4405 
;4406   if (loggableStateChg)  {
@846:
	ld	a,(ix-11)
	or	a,a
	jr	z,@850
;4407     if (logStateChgMsgs)  { ++numLoggedChgMsgs;  loggedStateChg = true; }
	ld	a,(_logStateChgMsgs)
	or	a,a
	jr	z,@853
	ld	hl,(_numLoggedChgMsgs)
	inc	hl
	ld	(_numLoggedChgMsgs),hl
	ld	(ix-12),0x1
;4408     lastLoggableStateChg = GetSeconds_();
@853:
	ld	hl,(__TimerSeconds)
	ld	(_lastLoggableStateChg),hl
;4409   }
;4410 
;4411 
;4412   if (Cur.state != Prev.state)
@850:
	ld	hl,(_curState+326)
	ld	de,(_prevState+326)
	or	a,a
	sbc	hl,de
	jr	z,@856
;4413     printf("Run state: %s\n", CtlStateDesc[Cur.state]);
	ld	hl,(_curState+326)
	add	hl,hl
	ld	de,_CtlStateDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+3918)
	ld	c,phys @1+3918 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4414 
;4415 
;4416   logInterval = (Cur.state != STATE_ON) ? 3600
@856:
;4417       : ((sinking OR ramping OR dumping) ? 20 : 300);
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@857
	ld	hl,0xe10
	jr	@858
@857:
	ld	a,(_sinking)
	or	a,a
	jr	nz,@859
	ld	a,(_ramping)
	or	a,a
	jr	nz,@859
	ld	a,(_dumping)
	or	a,a
	jr	z,@860
@859:
	ld	hl,0x14
	jr	@861
@860:
	ld	hl,0x12c
@861:
@858:
	ld	(_logInterval),hl
;4418 
;4419   if ( loggedStateChg OR (SecSince_(lastValLogTime) > logInterval) )  {
	ld	a,(ix-12)
	or	a,a
	jr	nz,@862
	ld	hl,(__TimerSeconds)
	ld	de,(_lastValLogTime)
	or	a,a
	sbc	hl,de
	ld	de,(_logInterval)
	or	a,a
	sbc	hl,de
	jp	c,@863
	jp	z,@863
@862:
;4420     if (!loggedStateChg)  printf("Current state:\n");
	ld	a,(ix-12)
	or	a,a
	jr	nz,@866
	ld	de,word (phys @1+3933)
	ld	c,phys @1+3933 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4421     printf("  ampApply:%s   ampRead:%s   ttlBulkCur:%s\n"
@866:
;4422            "  bjtBias:%s   vctrl:%s   vout:%s   \n"
;4423            "  polCmd: %s   outMode: %s\n\n",
;4424            fmtFloat(ampApply, 7,2, temp),
;4425            fmtFloat(ampRead, 7,2, temp+10),
;4426            fmtFloat(ttlBulkCur, 7,2,  temp+20),
;4427            fmtFloat(Cur.bjtBias, 6,2, temp+30),
;4428            fmtFloat(Cur.vctrl, 6,2, temp+40),
;4429            fmtFloat(Cur.vout, 6,2, temp+50),
;4430            PolCmdDesc[Cur.polCmd], OutModeDesc[Cur.outMode]
;4431           );
	ld	hl,(_curState+324)
	add	hl,hl
	ld	de,_OutModeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(_curState+332)
	add	hl,hl
	ld	de,_PolCmdDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,-24+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x6
	push	hl
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-32+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x6
	push	hl
	ld	de,(_curState+308)
	ld	bc,(_curState+310)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-40+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x6
	push	hl
	ld	de,(_curState+312)
	ld	bc,(_curState+314)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-48+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x7
	push	hl
	ld	de,(_ttlBulkCur)
	ld	bc,(_ttlBulkCur+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-56+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x7
	push	hl
	ld	de,(_ampRead)
	ld	bc,(_ampRead+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	hl,-64+@663
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x7
	push	hl
	ld	de,(_ampApply)
	ld	bc,(_ampApply+2)
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
	push	hl
	ld	de,word (phys @1+3949)
	ld	c,phys @1+3949 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;4432     lastValLogTime = GetSeconds_();
	ld	hl,(__TimerSeconds)
	ld	(_lastValLogTime),hl
;4433   }
;4434 
;4435 }
@863:
@664:
	.debug	} @664 4435

@663	equ	78
	ld	sp,ix
	pop	ix
	lret
@665	equ	80
;4436 
;4437 
;4438 //=========================================================================
;4439 //  Now we update the values in "next" based on the "cur" and "prev"
;4440 //  values.
;4441 //=========================================================================
;4442 //  All values changed by updateNextState() are "outputs" from this func.
;4443 //  All other values referenced in this function are "inputs" to this func.
;4444 //
;4445 //  All the values in "next" provide information about the next logical sta
;4446 //  for the controller:  Values to be applied during the next pass of the
;4447 //  control logic.  All "next" values fall in to one of 2 categories:
;4448 //
;4449 //    - They are set/updated ONLY by this function (which is executed only
;4450 //      by the "applic" task)
;4451 //
;4452 //    - They are set ONLY by other tasks (within a lock), and possibly
;4453 //      reset/cleared by the "applic" task in updateCurState() (after copyi
;4454 //      "next" to "cur")
;4455 //
;4456 //
;4457 //  All values that act as input to this func must fall in to one of these
;4458 //  categories:
;4459 //
;4460 //    - "prev" values
;4461 //
;4462 //    - "cur" values updated directly by statements in updateCurState()
;4463 //
;4464 //    - "cur" values updated indirectly by updateCurState() due to the copy
;4465 //      of "next" to "cur", which includes the values in "next" that are
;4466 //      set by other tasks
;4467 //
;4468 //    - a shared/global value that is the equivalent of a "cur" value but
;4469 //      for which we don't need to track changes
;4470 //
;4471 //
;4472 //  All "outputs" from this function must be altered ONLY within this funct
;4473 //
;4474 //  All "inputs" to this function must NEVER be altered within this functio
;4475 //
;4476 //  Each output value (or VERY small "set" of ouput values) must be updated
;4477 //  in a single, self-contained block of code.  NO output may be referenced
;4478 //  OR altered in ANOTHER block of code:  This is a declarative style of
;4479 //  programming and has multiple advantages:
;4480 //
;4481 //     - There are no order-of-execution dependencies across nodes/blocks
;4482 //       within a pass.  They can be executed in any order and the result
;4483 //       will be the same (get used to it - this method will be the norm as
;4484 //       computer languages and hardware add support for atomic transaction
;4485 //       and computers evolve in to neural-net-like processor arrays - FPGA
;4486 //       are just the beginning of this trend).
;4487 //
;4488 //     - Encapsulating all logic for an output within a single node/block
;4489 //       leaves just one place to start when tracking a problem backward fr
;4490 //       the result (far simpler than guessing at the possible causes and
;4491 //       trying to work forward, looking for paths to the observed result).
;4492 //
;4493 //     - Drastically reduces the complexity of the code by greatly reducing
;4494 //       the number of possible paths through the code.  This simplifies
;4495 //       testing and verification processes.
;4496 //
;4497 //  Each node/block-of-code should be prefaced with the following informati
;4498 //   - The names of the values it modifies
;4499 //   - A descr of the meaning of the values and the logic used to set them
;4500 //   - A list of the values that serve as "inputs" to the node
;4501 //
;4502 //=========================================================================
;4503 void updateNextState(void)
;4504 {
$updateNextState::
	.debug	G $updateNextState 70 9
	.debug	{ $updateNextState 70 4503 @869 @868
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-15
;4505   bool  chgPolarity;
;4506   uint  ui;
;4507   BulkSupplyState  *bsCur, *bsNext;
;4508   float  ampsPerPass, diff;
;4509 
;4510 
;4511   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@868
;4512 
;4513 //--------------------------------------------------------------------
;4514 // Next.state
;4515 // Next.onRequest, Next.offRequest, Next.resetRequest (resets)
;4516 //    Description:
;4517 //       Determines the next state of for the application logic
;4518 //       (STATE_ON, STATE_OFF, STATE_INTLK)
;4519 //    Inputs:
;4520 //       Cur.onRequest
;4521 //       Cur.offRequest
;4522 //       Cur.resetRequest
;4523 //       Cur.externIntlk
;4524 //       Cur.bulkSup[]
;4525 //       holecOK
;4526 //----------------------------------------------------------------------
;4527 
;4528 //--- chg state from OFF to ON? ---
;4529   if (Cur.onRequest)  do  {
	ld	a,(_curState+280)
	or	a,a
	jr	z,@871
;4530     Next.onRequest = false;
	xor	a,a
	ld	(_nextState+280),a
;4531     if (!supplyType)  {
	ld	hl,(_supplyType)
	bool	hl
	jr	nz,@877
;4532       printf("Must set supplyType 1st!\n");  break;  }
	ld	de,word (phys @1+4058)
	ld	c,phys @1+4058 >> 16
	jr	@1219
;4533     if (!loadType)  {
@877:
	ld	hl,(_loadType)
	bool	hl
	jr	nz,@880
;4534       printf("Must set loadType 1st!\n");  break;  }
	ld	de,word (phys @1+4084)
	ld	c,phys @1+4084 >> 16
	jr	@1219
;4535     if ((Cur.state == STATE_INTLK) OR Cur.externIntlk)  {
@880:
	ld	hl,(_curState+326)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@883
	ld	a,(_curState+291)
	or	a,a
	jr	z,@884
@883:
;4536       printf("Must clear Interlock first\n\n");  break; }
	ld	de,word (phys @1+4108)
	ld	c,phys @1+4108 >> 16
	jr	@1219
;4537     if (Cur.state == STATE_ON)  { printf("Already ON\n\n");  break; }
@884:
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@887
	ld	de,word (phys @1+4137)
	ld	c,phys @1+4137 >> 16
@1219:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@873
;4538     Next.state = STATE_ON;  printf("Turning ON\n\n");
@887:
	ld	hl,0x2
	ld	(_nextState+326),hl
	ld	de,word (phys @1+4150)
	ld	c,phys @1+4150 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4539   } while(0);
;4540 
;4541 //--- chg state from ON to OFF? ---
;4542   if (Cur.offRequest)  do {
@873:
@871:
	ld	a,(_curState+281)
	or	a,a
	jr	z,@890
;4543     Next.offRequest = false;
	xor	a,a
	ld	(_nextState+281),a
;4544     if ((Cur.state == STATE_INTLK) OR Cur.externIntlk)  {
	ld	hl,(_curState+326)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@896
	ld	a,(_curState+291)
	or	a,a
	jr	z,@897
@896:
;4545       printf("Must clear Interlock first\n\n");  break; }
	ld	de,word (phys @1+4108)
	ld	c,phys @1+4108 >> 16
	jr	@1218
;4546     if (Cur.state == STATE_OFF)  { printf("Already OFF\n\n");  break; }
@897:
	ld	hl,(_curState+326)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@900
	ld	de,word (phys @1+4163)
	ld	c,phys @1+4163 >> 16
@1218:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@892
;4547     Next.state = STATE_OFF;  printf("Turning OFF\n\n");
@900:
	ld	hl,0x1
	ld	(_nextState+326),hl
	ld	de,word (phys @1+4177)
	ld	c,phys @1+4177 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4548   } while(0);
;4549 
;4550 //--- chg state from INTLK to OFF? ---
;4551   if (Cur.resetRequest)  do {
@892:
@890:
	ld	a,(_curState+282)
	or	a,a
	jr	z,@903
;4552     Next.resetRequest = false;
	xor	a,a
	ld	(_nextState+282),a
;4553     if (Cur.state != STATE_INTLK)  {
	ld	hl,(_curState+326)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@909
;4554       printf("No Interlock to clear\n\n");  break;  }
	ld	de,word (phys @1+4191)
	ld	c,phys @1+4191 >> 16
	jr	@1217
;4555     if (Cur.externIntlk)  {
@909:
	ld	a,(_curState+291)
	or	a,a
	jr	z,@912
;4556       printf("External Interlock still exists\n\n");  break; }
	ld	de,word (phys @1+4215)
	ld	c,phys @1+4215 >> 16
	jr	@1217
;4557     if (!holecOK)  {
@912:
	ld	a,(_holecOK)
	or	a,a
	jr	nz,@915
;4558       printf("HOLEC still reads BAD\n\n");  break; }
	ld	de,word (phys @1+4249)
	ld	c,phys @1+4249 >> 16
	jr	@1217
;4559     if (bulkSupErr)  {
@915:
	ld	a,(_bulkSupErr)
	or	a,a
	jr	z,@918
;4560       printf("Bulk supply error still exists\n\n");  break; }
	ld	de,word (phys @1+4273)
	ld	c,phys @1+4273 >> 16
@1217:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@905
;4561     Next.state = STATE_OFF;  printf("Interlock cleared\n\n");
@918:
	ld	hl,0x1
	ld	(_nextState+326),hl
	ld	de,word (phys @1+4306)
	ld	c,phys @1+4306 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4562   } while(0);
;4563 
;4564 //--- chg state to INTLK due toan error or external interlock? ---
;4565   if (Cur.externIntlk OR !holecOK OR bulkSupErr)  do {
@905:
@903:
	ld	a,(_curState+291)
	or	a,a
	jr	nz,@921
	ld	a,(_holecOK)
	or	a,a
	jr	z,@921
	ld	a,(_bulkSupErr)
	or	a,a
	jr	z,@922
@921:
;4566     if (Cur.state == STATE_INTLK)  break;
	ld	hl,(_curState+326)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@924
;4567     Next.state = STATE_INTLK;
	ld	h,d
	ld	l,e
	ld	(_nextState+326),hl
;4568   } while(0);
;4569 
;4570 
;4571 
;4572 //-------------------------------------------------------------------
;4573 // Next.polCmd
;4574 //    Description:
;4575 //       Determines which (if either) of the polarity commands should
;4576 //       asserted.
;4577 //
;4578 //       Sink mode ends when the regulation polarity changes so it is the
;4579 //       same as the polarity of the load voltage.
;4580 //
;4581 //       To avoid an oscillation caused by the time required to change the
;4582 //       bridge polarity, we have to make the change "just BEFORE" the
;4583 //       regulation polarity changes, so it can regulate the moment it does
;4584 //       change.  "Just before" is currently determined by comparing the lo
;4585 //       current to a set threshold, a value that (unfortunately) is not
;4586 //       terribly consistent.
;4587 //
;4588 //       Note that changing the bridge polarity before the regulation polar
;4589 //       changes causes the amplitutde of the control voltage to peak.  Thi
;4590 //       is not a problem ONLY if the power supply output is disconnected
;4591 //       from the bridge whenever the polarity commands are in conflict wit
;4592 //       the regulation polarity.  Since this also means the bridge is no
;4593 //       longer sinking any of the power from the magnet, the load voltage
;4594 //       jumps a bit - a side effect we live with to avoid the oscillation
;4595 //       that occurs if we don't change the bridge polarity early
;4596 //
;4597 //    Inputs:
;4598 //       inductiveLoad
;4599 //       Cur.ampApply
;4600 //       Prev.regPolStable
;4601 //       sinking
;4602 //       absBulkCur
;4603 //       sinkEndAmps
;4604 //       Cur.hystRegPol
;4605 //       Cur.polCmd
;4606 //       psOnAndReady
;4607 //       bridgeJustOff
;4608 //-------------------------------------------------------------------
;4609 /*
;4610   Two different types of loads with two different requirements:
;4611 
;4612   Inductive loads:
;4613     The current through an inductive load responds slowly to changes in the
;4614     bulk supply currents.  If the regulation circuit response time is too
;4615     fast in comparison the result is oscillation in the bulk supply outputs
;4616 
;4617   Resistive/DC loads:
;4618     The current through a resistive load responds quickly to changes in the
;4619     bulk supply currents.  If the regulation circuit response time is too
;4620     slow in comparison, the result is oscillation as the regulation lags
;4621     behind the load current.
;4622 
;4623   In case you think a compromise between these two is a reasonable
;4624   approach, there is the problem of regulation near zero.  The load is
;4625   connected to the bulk supply outputs by a bridge, and changing the
;4626   polarity of current through the load requires the connections in the brid
;4627   to be changed.  But the current bridge uses SCR's, and so the bridge must
;4628   be turned OFF for several ms (at least) to ensure one set is turned off
;4629   before the other set is turned on.  Since the regulation circuit is NOT
;4630   designed to handle a step-wise transfer function like this, regulation
;4631   too close to zero is NOT possible.
;4632 
;4633   Besides making regulation close to zero impossible, this also has the
;4634   effect of making oscillation near zero worse for one case when the
;4635   regulation circuit is tuned for the other case.
;4636 
;4637   A fast response time (for resistive loads) means the loop tends to go in
;4638   to regulation WITHOUT changing polarity, so oscillation caused by crossin
;4639   zero is not common.  But when an inductive load is connected, the load
;4640   current doesn't respond fast enough, and the regulation circuit naturally
;4641   oscillates.  If this happens near zero, it is a disaster.
;4642 
;4643   A slow response time (for inductive loads) means the regulation loop does
;4644   not try to change the load current faster than it can respond, so it tend
;4645   to be stable when connected to an inductive load.  But when connected to
;4646   a resistive load, then the regulation circuit lags behind the changes in
;4647   the load and (again) naturally causes oscillation.  And again, if it occu
;4648   near zero, it is disaster.
;4649 
;4650 
;4651   The "solution" is to tune the regulation circuit response for inductive
;4652   loads, and simply follow the active setpoint polarity for resistive loads
;4653 
;4654   Not only does the slower response time tend to dampen the osciallation ne
;4655   zero for inductive loads, but significant changes in the load current for
;4656   inductive loads causes the voltage across the dump resistor in parallel t
;4657   the inductor to reach the voltage limits, which puts an upper limit on ho
;4658   much the error in the load current can affect the regulation output.
;4659 
;4660   For resistive loads, which are always in phase with the regulation circui
;4661   we avoid any significant oscillation by simply forcing the bridge polarit
;4662   to the polarity of the active setpoint.  While a regulation polarity
;4663   opposite the active setpoint polarity means the bridge still won't conduc
;4664   (and therefore not "actively" regulate), we avoid the usual delay incurre
;4665   for changing the polarity of the bridge, so regulation resumes the moment
;4666   the regulation polarity changes back in to agreement with the active
;4667   setpoint polarity.
;4668 */
;4669 
;4670   if (!inductiveLoad)
@924:
@922:
	ld	a,(_inductiveLoad)
	or	a,a
	jr	nz,@929
;4671     usePolarity = POLARITY(Cur.ampApply);
	ld	de,(_curState+328)
	ld	bc,(_curState+330)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	m,@930
	jr	z,@930
	ld	a,0x1
	jr	@931
@930:
	xor	a,a
@931:
	ld	(_usePolarity),a
;4672   else
;4673   //--- To minimize the oscillation that can occur when the polarity of the
;4674   //--- bridge is changed, we change the bridge polarity (to match that of 
;4675   //--- the control voltage) only when a change in the control voltage ---
;4676   //--- polarity has been preceeded by short period of no change.  By ---
;4677   //--- ignoring changes that are NOT preceeded by a stable period, we avoi
;4678   //--- at least the worst of the oscillation that normally occurs when we 
;4679   //--- reach the end of a sink period (i.e. the bulk supply currents get -
;4680   //--- near 0 and the polarity of the control voltage changes to match the
;4681   //--- polarity of the load voltage) ---
;4682     if (Prev.regPolStable)
	jr	@932
@929:
	ld	a,(_prevState+294)
	or	a,a
	jr	z,@933
;4683       usePolarity = (sinking AND (absBulkCur < sinkEndAmps)) ?
;4684                       !Cur.hystRegPol : Cur.hystRegPol;
	ld	a,(_sinking)
	or	a,a
	jr	z,@935
	ld	de,(_absBulkCur)
	ld	bc,(_absBulkCur+2)
	push	bc
	push	de
	ld	de,(_sinkEndAmps)
	ld	bc,(_sinkEndAmps+2)
	call	__fsub##
	jp	p,@935
	ld	a,(_curState+293)
	or	a,a
	ld	a,0
	jr	nz,@937
	inc	a
	jr	@937
@935:
	ld	a,(_curState+293)
@937:
	ld	(_usePolarity),a
;4685 
;4686 //--- A change in polarity has to be preceeded by a short period where the 
;4687 //--- bridge is off (to insure the SCR's have had TIME to turn off) ---
;4688   chgPolarity = ( ((usePolarity == Pos_Pol) AND (Cur.polCmd == POL_NEG))
@933:
@932:
;4689                OR ((usePolarity == Neg_Pol) AND (Cur.polCmd == POL_POS)) );
	ld	a,(_usePolarity)
	sub	a,1
	jr	nz,@939
	ld	hl,(_curState+332)
	bool	hl
	jr	z,@940
@939:
	ld	a,(_usePolarity)
	or	a,a
	jr	nz,@941
	ld	hl,(_curState+332)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@941
@940:
	ld	hl,1
	jr	@945
@941:
	bool	hl
	ld	l,h
@945:
	ld	(ix-1),l
;4690 
;4691 #define PolCmd(pol)  ( (pol) ? POL_POS : POL_NEG )
;4692 
;4693   Next.polCmd = (!psOnAndReady OR bridgeJustOff OR chgPolarity) ?
;4694                         POL_OFF : PolCmd(usePolarity);
	ld	a,(_psOnAndReady)
	or	a,a
	jr	z,@946
	ld	a,(_bridgeJustOff)
	or	a,a
	jr	nz,@946
	ld	a,l
	or	a,a
	jr	z,@947
@946:
	ld	hl,0x1
	jr	@948
@947:
	ld	a,(_usePolarity)
	or	a,a
	jr	z,@949
	ld	hl,0x2
	jr	@950
@949:
	bool	hl
	ld	l,h
@950:
@948:
	ld	(_nextState+332),hl
;4695 
;4696 
;4697 //-------------------------------------------------------------------
;4698 // Next.ampApply
;4699 //    Description:
;4700 //       Determines the active setpoint to apply at the start of
;4701 //       the next pass.  If we are in the period where the polarity
;4702 //       is not stable, we set the active setpoint to the current
;4703 //       reading to minimize the spike in VCTRL when we turn the
;4704 //       bridges back on.
;4705 //    Inputs:
;4706 //       Cur.state
;4707 //       Cur.ampset
;4708 //       Cur.ampApply
;4709 //       rampRate
;4710 //-------------------------------------------------------------------
;4711   ampsPerPass = rampRate * SchedMS * 0.001;  // amps/sec --> amps/SchedMS
	ld	hl,(_SchedMS)
	ex	de,hl
	call	__uitof##
	push	bc
	push	de
	ld	de,(_rampRate)
	ld	bc,(_rampRate+2)
	call	__fmlt##
	push	bc
	push	de
	ld	de,0x126f
	ld	bc,0x3a83
	call	__fmlt##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;4712 
;4713   diff = Cur.ampSet - Cur.ampApply;
	ld	de,(_curState+283)
	ld	bc,(_curState+285)
	push	bc
	push	de
	ld	de,(_curState+328)
	ld	bc,(_curState+330)
	call	__fsub##
	ld	hl,bc
	ld	(ix-13),hl
	ex	de,hl
	ld	(ix-15),hl
	ex	de,hl
;4714 
;4715   do  {
;4716     if (Cur.state != STATE_ON)  { Next.ampApply = 0;  break; }
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@956
	ld	e,d
	ld	c,e
	ld	b,e
	jr	@1216
;4717 
;4718     if (FABS(diff) < ampsPerPass) { Next.ampApply = Cur.ampSet;  break; }
@956:
	ld	hl,(ix-15)
	ex	de,hl
	ld	hl,(ix-13)
	ld	bc,hl
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__fsub##
	jp	p,@959
	ld	de,(_curState+283)
	ld	bc,(_curState+285)
@1216:
	ld	(_nextState+328),de
	ld	(_nextState+330),bc
	jr	@952
;4719 
;4720     if (diff < 0.0)
@959:
	ld	hl,(ix-15)
	ex	de,hl
	ld	hl,(ix-13)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@962
;4721       Next.ampApply -= ampsPerPass;
	ld	de,(_nextState+328)
	ld	bc,(_nextState+330)
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__fsub##
	ld	(_nextState+328),de
	ld	(_nextState+330),bc
;4722     else
;4723       Next.ampApply += ampsPerPass;
	jr	@963
@962:
	ld	de,(_nextState+328)
	ld	bc,(_nextState+330)
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__fadd##
	ld	(_nextState+328),de
	ld	(_nextState+330),bc
;4724   }  while (0);
@963:
;4725 
;4726 
;4727 
;4728 //-------------------------------------------------------------------
;4729 // bsNext->setOn,
;4730 //    Description:
;4731 //       Determines which bulk supplies should have the setOn output
;4732 //       enabled at the start of the next pass
;4733 //    Inputs:
;4734 //       Cur.state
;4735 //       bsCur->isAvail
;4736 //       bsCur->enabled
;4737 //       bsCur->shortErr
;4738 //       bsCur->tempOK
;4739 //-------------------------------------------------------------------
;4740 //--- set next state for each bulk supply ---
;4741   for (ui=0; ui<NumPS; ++ui)  {
@952:
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@966:
	ld	hl,(ix-3)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@967
;4742     bsCur = Cur.bs + ui;
	ld	hl,(ix-3)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_curState
	add	hl,bc
	ld	(ix-5),hl
;4743     bsNext = Next.bs + ui;
	ld	h,d
	ld	l,e
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	(ix-7),hl
;4744     bsNext->setOn =
;4745       ((Cur.state == STATE_ON) AND bsCur->isAvail AND bsCur->enabled
;4746        AND !bsCur->shortErr AND bsCur->tempOK);
	ld	hl,(_curState+326)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@972
	ld	hl,(ix-5)
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@972
	ld	hl,(ix-5)
	ld	e,0x1a
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@972
	ld	hl,(ix-5)
	dec	e
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@972
	ld	hl,(ix-5)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@972
	ld	a,1
	jr	@973
@972:
	xor	a
@973:
	ld	hl,(ix-7)
	ld	de,0x1b
	add	hl,de
	ld	(hl),a
;4747 
;4748   }
;4749 
;4750 }
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jr	@966
@967:
@868:
	.debug	} @868 4750

@867	equ	15
	ld	sp,ix
	pop	ix
	lret
@869	equ	17
;4751 
;4752 
;4753 //=========================================================================
;4754 //  Next we update output signal values to be written to the outputs at
;4755 //  the beginning of the next pass (just after the inputs are read).
;4756 //=========================================================================
;4757 void updateOutputState(void)
;4758 {
$updateOutputState::
	.debug	G $updateOutputState 70 9
	.debug	{ $updateOutputState 70 4757 @976 @975
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;4759   uint  ui;
;4760 
;4761 
;4762   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@975
;4763 
;4764 //--- update output values that are based on current conditions (values ---
;4765 //--- in "cur" or any values used in a conditional in the applic logic) ---
;4766 
;4767 /*EXAMPLE:
;4768   // (insured earlier that only ONE of these can be true when setting them)
;4769   if (initialBtnPressed)  setVal[FP_METER] = rfOffSetpoint;  else
;4770   if (finalBtnPressed)    setVal[FP_METER] = rfOnSetpoint;  else
;4771                           setVal[FP_METER] = cavityVolts;
;4772 
;4773 
;4774   SetOffApplLEDs(Next.digitalOut);
;4775 
;4776   if (limited)  SetOnLimitLED(Next.digitalOut);
;4777   if (regErr)   SetOnErrorLED(Next.digitalOut);
;4778 */
;4779 
;4780 //--- update output values based on values that were set by the application
;4781 //--- logic (e.g. values in "next" or variables that are the target of an -
;4782 //--- assignment statement in the application logic) ---
;4783 
;4784 //  setVal[CTL_VOLTS] = Next.ctlVolts;  // ctl voltage to DC Servo amplifie
;4785 
;4786 //  setVal[EXTERN_METER] = Next.meterValue;
;4787 
;4788 
;4789   Next.digitalOut = 0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
;4790 
;4791 //APPLCODE
;4792 
;4793   for (ui=0; ui<NumPS; ++ui)
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@980:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@981
;4794     if (Next.bs[ui].setOn)  Next.digitalOut |= SetOnBit[ui];
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	de,0x1b
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@983
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_SetOnBit
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	call	__lor##
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
;4795 
;4796   if (Next.polCmd == POL_POS)  Next.digitalOut |= (ENABLE_POL_POS | LED_POS
@983:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@980
@981:
	ld	hl,(_nextState+332)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@984
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	set	4,d
	set	5,d
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
;4797   if (Next.polCmd == POL_NEG)  Next.digitalOut |= (ENABLE_POL_NEG | LED_NEG
@984:
	ld	hl,(_nextState+332)
	bool	hl
	jr	nz,@985
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	set	3,d
	set	6,d
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
;4798 
;4799   setVal[AO_ISET] = Next.ampApply;
@985:
	ld	de,(_nextState+328)
	ld	bc,(_nextState+330)
	ld	(_setVal),de
	ld	(_setVal+2),bc
;4800 
;4801 //  setVal[AO_VLIM_POS] = -vlimPlus + vlimAdjust;
;4802 //  setVal[AO_VLIM_NEG] = vlimMinus - vlimAdjust;
;4803   setVal[AO_VLIM_POS] = vlimPlus - vlimAdjust;
	ld	de,(_vlimPlus)
	ld	bc,(_vlimPlus+2)
	push	bc
	push	de
	ld	de,(_vlimAdjust)
	ld	bc,(_vlimAdjust+2)
	call	__fsub##
	ld	(_setVal+4),de
	ld	(_setVal+6),bc
;4804   setVal[AO_VLIM_NEG] = -vlimMinus + vlimAdjust;
	ld	de,(_vlimMinus)
	ld	bc,(_vlimMinus+2)
	ld	a,b
	xor	a,0x80
	ld	b,a
	push	bc
	push	de
	ld	de,(_vlimAdjust)
	ld	bc,(_vlimAdjust+2)
	call	__fadd##
	ld	(_setVal+8),de
	ld	(_setVal+10),bc
;4805 }
@975:
	.debug	} @975 4805

@974	equ	2
	ld	sp,ix
	pop	ix
	lret
@976	equ	4
;4806 
;4807 
;4808 
;4809 
;4810 //=========================================================================
;4811 // The last thing we do is update values read by other tasks
;4812 //=========================================================================
;4813 // IMPORTANT NOTES and WARNINGS:
;4814 //
;4815 //   To avoid concurrency issues, other tasks need to use locks when readin
;4816 //   values set here.  But be careful to keep such locks short to avoid
;4817 //   delaying the timing of the main application task.  If necessary, split
;4818 //   such code in to sections, getting and releasing the lock(s) in each
;4819 //   section to avoid increasing latency for the main application task.
;4820 //
;4821 //   Values in the "next" instance of the application state fall in to 2
;4822 //   categories:  Inputs and Outputs.
;4823 //
;4824 //   The "next" Outputs are those that may be changed in updateOutputState(
;4825 //   The reset are Inputs, and may be changed by other tasks within a lock.
;4826 //
;4827 //   Since each pass through the application logic starts by setting
;4828 //   cur = next, any "next" values set by other tasks become part of the
;4829 //   "cur" instance used by the rest of the applic logic.  Because the
;4830 //   "applic" task at a higher priority than any other real-time task, the
;4831 //   changes to "next" values by other tasks can ONLY happen between passes
;4832 //   through the applic logic loop.
;4833 //
;4834 //   NOTES:
;4835 //     - Some of these "next" input values values must be initialized in
;4836 //       updateCurState() in order to tell when a value is set by another
;4837 //       task.  For example, if we have a boolean flag that is set when we
;4838 //       get an ON command, then (after its "next" value is copied to "cur"
;4839 //       we have to clear the flag in order to tell if another ON command i
;4840 //       received between passes.
;4841 //
;4842 //     - As with reads to these values, other tasks must use locks when
;4843 //       writing to the "next" input values to insure they are not preempte
;4844 //       by the "applic" task in the middle of a write.
;4845 //
;4846 //=========================================================================
;4847 void updateExternals(void)
;4848 {
$updateExternals::
	.debug	G $updateExternals 70 9
	.debug	{ $updateExternals 70 4847 @988 @987
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;4849   uint  ui, bsState;
;4850   BulkSupplyState  *bsCur;
;4851 
;4852 
;4853   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@987
;4854 
;4855   digInBits = Cur.digitalIn;
	ld	de,(_curState+287)
	ld	bc,(_curState+289)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
;4856   digOutBits = Cur.digitalOut;
	ld	de,(_curState+334)
	ld	bc,(_curState+336)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
;4857 
;4858 //APPLCODE
;4859 
;4860   iset = Cur.iset;
	ld	de,(_curState+316)
	ld	bc,(_curState+318)
	ld	(_iset),de
	ld	(_iset+2),bc
;4861   polCmd = Cur.polCmd;
	ld	hl,(_curState+332)
	ld	(_polCmd),hl
;4862   ampApply = Cur.ampApply;
	ld	de,(_curState+328)
	ld	bc,(_curState+330)
	ld	(_ampApply),de
	ld	(_ampApply+2),bc
;4863 
;4864   state = Cur.state;
	ld	hl,(_curState+326)
	ld	(_state),hl
;4865 
;4866   ampSet = Cur.ampSet;
	ld	de,(_curState+283)
	ld	bc,(_curState+285)
	ld	(_ampSet),de
	ld	(_ampSet+2),bc
;4867 
;4868 
;4869   vctrlStatus  = (Cur.regPol ? 1 : 0);
	ld	a,(_curState+292)
	or	a,a
	jr	z,@990
	ld	hl,0x1
	jr	@991
@990:
	bool	hl
	ld	l,h
@991:
	ld	(_vctrlStatus),hl
;4870   vctrlStatus |= (Cur.hystRegPol ? 2 : 0);
	ld	a,(_curState+293)
	or	a,a
	jr	z,@992
	ld	hl,0x2
	jr	@993
@992:
	bool	hl
	ld	l,h
@993:
	ld	de,(_vctrlStatus)
	or	hl,de
	ld	(_vctrlStatus),hl
;4871   vctrlStatus |= (Cur.regPolStable ? 4 : 0);
	ld	a,(_curState+294)
	or	a,a
	jr	z,@994
	ld	hl,0x4
	jr	@995
@994:
	bool	hl
	ld	l,h
@995:
	ld	de,(_vctrlStatus)
	or	hl,de
	ld	(_vctrlStatus),hl
;4872   vctrlStatus |= (inductiveLoad ? 8 : 0);
	ld	a,(_inductiveLoad)
	or	a,a
	jr	z,@996
	ld	hl,0x8
	jr	@997
@996:
	bool	hl
	ld	l,h
@997:
	ld	de,(_vctrlStatus)
	or	hl,de
	ld	(_vctrlStatus),hl
;4873 
;4874   psCount = Cur.psCount;
	ld	hl,(_curState+298)
	ld	(_psCount),hl
;4875 
;4876   ifdbk = Cur.ifdbk;
	ld	de,(_curState+300)
	ld	bc,(_curState+302)
	ld	(_ifdbk),de
	ld	(_ifdbk+2),bc
;4877   vout = Cur.vout;
	ld	de,(_curState+304)
	ld	bc,(_curState+306)
	ld	(_vout),de
	ld	(_vout+2),bc
;4878   vctrl = Cur.vctrl;
	ld	de,(_curState+308)
	ld	bc,(_curState+310)
	ld	(_vctrl),de
	ld	(_vctrl+2),bc
;4879   bjtBias = Cur.bjtBias;
	ld	de,(_curState+312)
	ld	bc,(_curState+314)
	ld	(_bjtBias),de
	ld	(_bjtBias+2),bc
;4880 
;4881   outMode = Cur.outMode;
	ld	hl,(_curState+324)
	ld	(_outMode),hl
;4882 
;4883 
;4884   for (ui=0; ui<NumPS;  ++ui)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1000:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jp	nc,@1001
;4885     bsCur = Cur.bs + ui;
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_curState
	add	hl,bc
	ld	(ix-6),hl
;4886 
;4887     *bsvX[ui] = bsCur->biasVolts;
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	push	de
	ld	de,_bsvX
	add	hl,de
	pop	de
	ld	hl,(hl)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4888     *ampsX[ui] = bsCur->current;
	ld	hl,(ix-6)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	push	de
	ld	de,_ampsX
	add	hl,de
	pop	de
	ld	hl,(hl)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4889 
;4890     bsState = 0;
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;4891 
;4892     if (bsCur->isOn)      bsState |= PS_IS_ON;
	ld	hl,(ix-6)
	ld	a,(hl)
	or	a,a
	jr	z,@1005
	ld	hl,(ix-4)
	set	0,l
	ld	(ix-4),hl
;4893     if (bsCur->isAvail)   bsState |= PS_AVAIL;
@1005:
	ld	hl,(ix-6)
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@1006
	ld	hl,(ix-4)
	set	1,l
	ld	(ix-4),hl
;4894     if (bsCur->tempOK)    bsState |= PS_TEMP_OK;
@1006:
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@1007
	ld	hl,(ix-4)
	set	2,l
	ld	(ix-4),hl
;4895     if (!bsCur->biasErr)  bsState |= PS_BIAS_OK;
@1007:
	ld	hl,(ix-6)
	ld	de,0x17
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@1008
	ld	hl,(ix-4)
	set	5,l
	ld	(ix-4),hl
;4896 
;4897     if (bsCur->setOn)     bsState |= PS_SET_ON;
@1008:
	ld	hl,(ix-6)
	ld	de,0x1b
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@1009
	ld	hl,(ix-4)
	set	3,l
	ld	(ix-4),hl
;4898     if (bsCur->enabled)   bsState |= PS_ENABLED;
@1009:
	ld	hl,(ix-6)
	ld	de,0x1a
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@1010
	ld	hl,(ix-4)
	set	4,l
	ld	(ix-4),hl
;4899 
;4900     PS_STATE(ui) = bsState;
@1010:
	ld	hl,(ix-2)
	ld	bc,0x14
	ex	de,hl
	mul
	ld	hl,_state_1_RegInfo
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;4901   }
;4902 
;4903 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@1000
@1001:
@987:
	.debug	} @987 4903

@986	equ	6
	ld	sp,ix
	pop	ix
	lret
@988	equ	8
;4904 
;4905 
;4906 
;4907 //=========================================================================
;4908 #define  BiasInputs    0x02551550L
;4909 #define  CurInputs     0x01aa8aa0L
;4910 #define  SpareInputs   0x00006000L
;4911 
;4912 //=========================================================================
;4913 _nearcall float readGetRaw(uint ui)  {
	.align	4
$$readGetRaw::
	ex	(sp),iy
$readGetRaw::
	.debug	G $readGetRaw 102 9
	.debug	{ $readGetRaw 102 4913 @1013 @1012
	push	ix
	ld	ix,0
	add	ix,sp
;4914   return (ui < NumHdwADC ? anaIn[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1014
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@1012
@1014:
	ld	de,0
	ld	c,e
	ld	b,e
@1012:
	.debug	} @1012 4914

@1011	equ	0
	pop	ix
	lret
@1013	equ	2
;4915 
;4916 _nearcall float readMinRaw(uint ui)  {
	.align	4
$$readMinRaw::
	ex	(sp),iy
$readMinRaw::
	.debug	G $readMinRaw 102 9
	.debug	{ $readMinRaw 102 4916 @1018 @1017
	push	ix
	ld	ix,0
	add	ix,sp
;4917   return (ui < NumHdwADC) ? (adcMinRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1019
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1017
@1019:
	ld	de,0
	ld	c,e
	ld	b,e
@1017:
	.debug	} @1017 4917

@1016	equ	0
	pop	ix
	lret
@1018	equ	2
;4918 
;4919 _nearcall float readMaxRaw(uint ui)  {
	.align	4
$$readMaxRaw::
	ex	(sp),iy
$readMaxRaw::
	.debug	G $readMaxRaw 102 9
	.debug	{ $readMaxRaw 102 4919 @1023 @1022
	push	ix
	ld	ix,0
	add	ix,sp
;4920   return (ui < NumHdwADC) ? (adcMaxRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1024
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1022
@1024:
	ld	de,0xcccd
	ld	bc,0x411c
@1022:
	.debug	} @1022 4920

@1021	equ	0
	pop	ix
	lret
@1023	equ	2
;4921 
;4922 //------------------------------------------------------------------
;4923 _nearcall void readDefaults(uint ui, float *gain, float *offset)
;4924 {
	.align	4
$$readDefaults::
	ex	(sp),iy
$readDefaults::
	.debug	G $readDefaults 103 9
	.debug	{ $readDefaults 103 4923 @1028 @1027
	push	ix
	ld	ix,0
	add	ix,sp
;4925   *gain = 1.0;  *offset = 0.0;
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4926   if (ui == AI_IFDBK)        *gain =  100.0;
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1029
	ld	bc,0x42c8
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4927   if (ui == AI_VOUT)         *gain =    1.0;
@1029:
	ld	hl,(ix+5)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@1030
	ld	e,d
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4928   if ((1L<<ui) & CurInputs)  *gain = 1000.0;
@1030:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1031
	ld	de,0
	ld	bc,0x447a
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4929 }
@1031:
@1027:
	.debug	} @1027 4929

@1026	equ	0
	pop	ix
	lret
@1028	equ	2
;4930 //------------------------------------------------------------------
;4931 _nearcall void readCalibPoints(uint ui, float *low, float *high)
;4932 {
	.align	4
$$readCalibPoints::
	ex	(sp),iy
$readCalibPoints::
	.debug	G $readCalibPoints 103 9
	.debug	{ $readCalibPoints 103 4931 @1034 @1033
	push	ix
	ld	ix,0
	add	ix,sp
;4933   *low = -9.5;  *high = 9.5;
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4934   if (ui == AI_IFDBK)        { *low = -500.0;  *high = 500.0;  }
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1035
	ld	bc,0xc3fa
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x43
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4935   if ((1L<<ui) & CurInputs)  { *low =  -70.0;  *high =  70.0;  }
@1035:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1038
	ld	de,0
	ld	bc,0xc28c
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x42
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4936 }
@1038:
@1033:
	.debug	} @1033 4936

@1032	equ	0
	pop	ix
	lret
@1034	equ	2
;4937 //--------------------------------------------------------
;4938 _nearcall char *readUnits(uint ui, char *buf)  {
	.align	4
$$readUnits::
	ex	(sp),iy
$readUnits::
	.debug	G $readUnits 104 9
	.debug	{ $readUnits 104 4938 @1043 @1042
	push	ix
	ld	ix,0
	add	ix,sp
;4939    return (((1L<<ui) & CurInputs) OR (ui == AI_IFDBK)) ? "A" : "V"; }
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	push	bc
	push	de
	ld	de,0x8aa0
	ld	bc,0x1aa
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@1044
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1045
@1044:
	ld	hl,@2+455
	jr	@1042
@1045:
	ld	hl,@2+457
@1042:
	.debug	} @1042 4939

@1041	equ	0
	pop	ix
	lret
@1043	equ	2
;4940 
;4941 
;4942 //=========================================================================
;4943 _nearcall float setGetRaw(uint ui)  {
	.align	4
$$setGetRaw::
	ex	(sp),iy
$setGetRaw::
	.debug	G $setGetRaw 102 9
	.debug	{ $setGetRaw 102 4943 @1049 @1048
	push	ix
	ld	ix,0
	add	ix,sp
;4944   return (ui < NumHdwDAC ? anaOut[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1050
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@1048
@1050:
	ld	de,0
	ld	c,e
	ld	b,e
@1048:
	.debug	} @1048 4944

@1047	equ	0
	pop	ix
	lret
@1049	equ	2
;4945 
;4946 _nearcall float setMinRaw(uint ui)  {
	.align	4
$$setMinRaw::
	ex	(sp),iy
$setMinRaw::
	.debug	G $setMinRaw 102 9
	.debug	{ $setMinRaw 102 4946 @1054 @1053
	push	ix
	ld	ix,0
	add	ix,sp
;4947   return (ui < NumHdwDAC) ? (dacMinRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1055
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1053
@1055:
	ld	de,0
	ld	c,e
	ld	b,e
@1053:
	.debug	} @1053 4947

@1052	equ	0
	pop	ix
	lret
@1054	equ	2
;4948 
;4949 _nearcall float setMaxRaw(uint ui)  {
	.align	4
$$setMaxRaw::
	ex	(sp),iy
$setMaxRaw::
	.debug	G $setMaxRaw 102 9
	.debug	{ $setMaxRaw 102 4949 @1059 @1058
	push	ix
	ld	ix,0
	add	ix,sp
;4950   return (ui < NumHdwDAC) ? (dacMaxRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1060
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1058
@1060:
	ld	de,0xcccd
	ld	bc,0x411c
@1058:
	.debug	} @1058 4950

@1057	equ	0
	pop	ix
	lret
@1059	equ	2
;4951 
;4952 //-------------------------------------------------------------------------
;4953 _nearcall void setDefaults(uint ui, float *gain, float *offset)
;4954 {  *gain = (ui == AO_ISET) ? 100.0 : 1.5;  *offset = 0.0;  }
	.align	4
$$setDefaults::
	ex	(sp),iy
$setDefaults::
	.debug	G $setDefaults 103 9
	.debug	{ $setDefaults 103 4953 @1064 @1063
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1065
	ld	d,h
	ld	e,h
	ld	bc,0x42c8
	jr	@1066
@1065:
	ld	de,0
	ld	bc,0x3fc0
@1066:
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@1063:
	.debug	} @1063 4954

@1062	equ	0
	pop	ix
	lret
@1064	equ	2
;4955 
;4956 _nearcall void setCalibPoints(uint ui, float *low, float *high)
;4957 {
	.align	4
$$setCalibPoints::
	ex	(sp),iy
$setCalibPoints::
	.debug	G $setCalibPoints 103 9
	.debug	{ $setCalibPoints 103 4956 @1069 @1068
	push	ix
	ld	ix,0
	add	ix,sp
;4958   if (ui == AO_ISET)  { *low = -500.0;  *high = 500.0;  return; }
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1070
	ld	d,h
	ld	e,h
	ld	bc,0xc3fa
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x43
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jr	@1068
;4959   *low = -9.5;  *high = 9.5;
@1070:
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4960 }
@1068:
	.debug	} @1068 4960

@1067	equ	0
	pop	ix
	lret
@1069	equ	2
;4961 _nearcall char *setUnits(uint ui, char *buf)  {
	.align	4
$$setUnits::
	ex	(sp),iy
$setUnits::
	.debug	G $setUnits 104 9
	.debug	{ $setUnits 104 4961 @1075 @1074
	push	ix
	ld	ix,0
	add	ix,sp
;4962   return (ui == AO_ISET) ? "A" : "V"; }
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@1076
	ld	hl,@2+455
	jr	@1074
@1076:
	ld	hl,@2+457
@1074:
	.debug	} @1074 4962

@1073	equ	0
	pop	ix
	lret
@1075	equ	2
;4963 
;4964 
;4965 //=========================================================================
;4966 //  Set default labels for all the I/O signals
;4967 //=========================================================================
;4968 void setDefaultLabels(void)
;4969 {
$setDefaultLabels::
	.debug	G $setDefaultLabels 70 9
	.debug	{ $setDefaultLabels 70 4968 @1080 @1079
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;4970   uint  ui, uidx;
;4971 
;4972 
;4973   printf("Setting default labels for I/O signals\r\n");
	ld	de,word (phys @1+4326)
	ld	c,phys @1+4326 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4974 
;4975 //--- set application-appropriate default labels ---
;4976 //APPLCODE
;4977 
;4978 //--- set default labels for the I/O signals ---
;4979   fstrcpy(ainLabel[AI_SPARE0], "SPARE0");
	ld	de,word (phys @1+4367)
	ld	c,phys @1+4367 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+312)
	ld	c,phys _ainLabel+312 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4980   fstrcpy(ainLabel[AI_SPARE1], "SPARE1");
	ld	de,word (phys @1+4374)
	ld	c,phys @1+4374 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+336)
	ld	c,phys _ainLabel+336 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4981 
;4982   for (ui=0; ui<NumPS; ++ui)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1083:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jp	nc,@1084
;4983     sprintf(ainLabel[BSVidx[ui]], "bias%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4381)
	ld	c,phys @1+4381 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_BSVidx
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4984     sprintf(ainLabel[HECTidx[ui]], "cur%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4390)
	ld	c,phys @1+4390 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_HECTidx
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4985 
;4986     uidx = psDigInIdx[ui];
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_psDigInIdx
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
;4987     sprintf(dinLabel[uidx],   "IS_ON_%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4398)
	ld	c,phys @1+4398 >> 16
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4988     sprintf(dinLabel[uidx+1], "AVAIL_%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4409)
	ld	c,phys @1+4409 >> 16
	push	bc
	push	de
	ld	hl,(ix-4)
	inc	hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4989     sprintf(dinLabel[uidx+2], "TEMPOK_%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4420)
	ld	c,phys @1+4420 >> 16
	push	bc
	push	de
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4990 
;4991     sprintf(doutLabel[psDigOutIdx[ui]], "SET_ON_%02u", ui+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4432)
	ld	c,phys @1+4432 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_psDigOutIdx
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;4992   }
;4993   fstrcpy(dinLabel[30], "HOLEC_OK");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@1083
@1084:
	ld	de,word (phys @1+4444)
	ld	c,phys @1+4444 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+720)
	ld	c,phys _dinLabel+720 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4994   fstrcpy(dinLabel[31], "NO_INTLK");
	ld	de,word (phys @1+4453)
	ld	c,phys @1+4453 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+744)
	ld	c,phys _dinLabel+744 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4995 
;4996   fstrcpy(ainLabel[AI_IFDBK], "IFDBK");
	ld	de,word (phys @1+4462)
	ld	c,phys @1+4462 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4997   fstrcpy(ainLabel[AI_VOUT], "VOUT");
	ld	de,word (phys @1+4468)
	ld	c,phys @1+4468 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+24)
	ld	c,phys _ainLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4998   fstrcpy(ainLabel[AI_VCTRL], "VCTRL");
	ld	de,word (phys @1+4473)
	ld	c,phys @1+4473 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+48)
	ld	c,phys _ainLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4999   fstrcpy(ainLabel[AI_BJT_BIAS], "BJT_BIAS");
	ld	de,word (phys @1+4479)
	ld	c,phys @1+4479 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+72)
	ld	c,phys _ainLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5000 
;5001   fstrcpy(aoutLabel[AO_ISET], "ISET");
	ld	de,word (phys @1+4488)
	ld	c,phys @1+4488 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5002   fstrcpy(aoutLabel[AO_VLIM_POS], "VLIM_POS");
	ld	de,word (phys @1+4493)
	ld	c,phys @1+4493 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+24)
	ld	c,phys _aoutLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5003   fstrcpy(aoutLabel[AO_VLIM_NEG], "VLIM_NEG");
	ld	de,word (phys @1+4502)
	ld	c,phys @1+4502 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+48)
	ld	c,phys _aoutLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5004 
;5005   fstrcpy(doutLabel[7],  "unused");
	ld	de,word (phys @1+4511)
	ld	c,phys @1+4511 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+168)
	ld	c,phys _doutLabel+168 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5006   fstrcpy(doutLabel[11], "Enable_Pol_Minus");
	ld	de,word (phys @1+4518)
	ld	c,phys @1+4518 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+264)
	ld	c,phys _doutLabel+264 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5007   fstrcpy(doutLabel[12], "Enable_Pol_Plus");
	ld	de,word (phys @1+4535)
	ld	c,phys @1+4535 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+288)
	ld	c,phys _doutLabel+288 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5008   fstrcpy(doutLabel[13], "Pol_Plus_LED");
	ld	de,word (phys @1+4551)
	ld	c,phys @1+4551 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+312)
	ld	c,phys _doutLabel+312 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5009   fstrcpy(doutLabel[14], "Pol_Minus_LED");
	ld	de,word (phys @1+4564)
	ld	c,phys @1+4564 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+336)
	ld	c,phys _doutLabel+336 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5010   fstrcpy(doutLabel[15], "ActivityLED");
	ld	de,word (phys @1+4578)
	ld	c,phys @1+4578 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+360)
	ld	c,phys _doutLabel+360 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;5011 }
@1079:
	.debug	} @1079 5011

@1078	equ	4
	ld	sp,ix
	pop	ix
	lret
@1080	equ	6
;5012 
;5013 //=========================================================================
;5014 //  This function is called to force software configurable values to defaul
;5015 //  values.
;5016 //=========================================================================
;5017 void setDefaultConfig(void)
;5018 {
$setDefaultConfig::
	.debug	G $setDefaultConfig 70 9
	.debug	{ $setDefaultConfig 70 5017 @1090 @1089
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;5019   uint  u;
;5020   BulkSupplyState  *bsNext;
;5021 
;5022 
;5023   printf("Setting in-RAM device config to default values\r\n");
	ld	de,word (phys @1+4590)
	ld	c,phys @1+4590 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5024 
;5025 //===== set default values for persistent data values =====
;5026 //APPLCODE
;5027 
;5028   vlimPlus = vlimMinus = 7.0;
	ld	de,0
	ld	bc,0x40e0
	ld	(_vlimMinus),de
	ld	(_vlimMinus+2),bc
	ld	(_vlimPlus),de
	ld	(_vlimPlus+2),bc
;5029 
;5030   rampRate = 10.0;  // in amps/sec
	ld	bc,0x4120
	ld	(_rampRate),de
	ld	(_rampRate+2),bc
;5031 
;5032   knobSelectRate = 20;  maxAmpSet = 2000.0;
	ld	hl,0x14
	ld	(_knobSelectRate),hl
	ld	bc,0x44fa
	ld	(_maxAmpSet),de
	ld	(_maxAmpSet+2),bc
;5033 
;5034   minPSonTime = 1000;  minBridgeOffTime = 20;  // in ms
	ld	hl,0x3e8
	ld	(_minPSonTime),hl
	ld	hl,0x14
	ld	(_minBridgeOffTime),hl
;5035 
;5036   vctrlHyst = 0.100;  // in volts
	ld	de,0xcccd
	ld	bc,0x3dcc
	ld	(_vctrlHyst),de
	ld	(_vctrlHyst+2),bc
;5037 
;5038   maxErrTime = 1000;  // in ms
	ld	hl,0x3e8
	ld	(_maxErrTime),hl
;5039 
;5040   minBSVolts = 5.0;  // min Bulk Supply bias voltage (in volts)
	ld	de,0
	ld	bc,0x40a0
	ld	(_minBSVolts),de
	ld	(_minBSVolts+2),bc
;5041 
;5042   maxBSFracCurDiff = 0.10;  // max Bulk Supply current error (frac of full 
	ld	de,0xcccd
	ld	bc,0x3dcc
	ld	(_maxBSFracCurDiff),de
	ld	(_maxBSFracCurDiff+2),bc
;5043 
;5044   bulkShortCur = 100.0;  // bulk supply current that indicates a short
	ld	de,0
	ld	bc,0x42c8
	ld	(_bulkShortCur),de
	ld	(_bulkShortCur+2),bc
;5045 
;5046   supplyType = 0;  // someone must set the type correctly to enable operati
	bool	hl
	ld	l,h
	ld	(_supplyType),hl
;5047   loadType = 0;    // someone must set the type correctly to enable operati
	ld	(_loadType),hl
;5048 
;5049 //  sinkEndAmps = 0.5;  // ttlBulkCur threshold that JUST preceeds end of s
;5050 
;5051   minPolStableTime = 500;  // min time regulation polarity must be stable b
	ld	hl,0x1f4
	ld	(_minPolStableTime),hl
;5052                            // bridge polarity is changed to match (in ms)
;5053 
;5054   vlimReduction = 0.5;  // amount to reduce voltage limits by during SINK m
	ld	bc,0x3f00
	ld	(_vlimReduction),de
	ld	(_vlimReduction+2),bc
;5055                         // to minimize voltage spike at end of sink mode
;5056 
;5057   contrast = 32;  // LCD contrast, range 0-255
	ld	hl,0x20
	ld	(_contrast),hl
;5058 
;5059   enabledMask = 0xFFFF;  // all PS enabled unless overridden by stored conf
	ld	hl,0xffff
	ld	(_enabledMask),hl
;5060   for (u=0; u<NumPS; ++u)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1093:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@1094
;5061     bsNext = Next.bs + u;
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	(ix-4),hl
;5062     bsNext->enabled = true;
	ld	de,0x1a
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;5063   }
;5064 
;5065   debounceMS = 250;  // interval (in ms) for debouncing digitalIn bits
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@1093
@1094:
	ld	hl,0xfa
	ld	(_debounceMS),hl
;5066 }
@1089:
	.debug	} @1089 5066

@1088	equ	4
	ld	sp,ix
	pop	ix
	lret
@1090	equ	6
;5067 
;5068 
;5069 //=========================================================================
;5070 //  Set the initial state we want the controller to start with.  This inclu
;5071 //  "next" values that will be used to set the output signal states as soon
;5072 //  as the main application loop begins.
;5073 //
;5074 //  WARNING:  This is run AFTER the persistent values are restored so do
;5075 //            NOT set default values for persistent values here.  That shou
;5076 //            be done in setDefaultConfig() instead!
;5077 //=========================================================================
;5078 void setInitialState(void)
;5079 {
$setInitialState::
	.debug	G $setInitialState 70 9
	.debug	{ $setInitialState 70 5078 @1100 @1099
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;5080   uint  ui;
;5081   BulkSupplyState  *bsNext;
;5082 
;5083 
;5084   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@1099
;5085 
;5086   inductiveLoad = (loadType == LOAD_RL);
	ld	hl,(_loadType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	ld	h,d
	ld	l,d
	jr	nz,@1102
	inc	l
@1102:
	ld	a,l
	ld	(_inductiveLoad),a
;5087 
;5088   lastRegPolChgTime = lastModeSetTime = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_lastModeSetTime),de
	ld	(_lastModeSetTime+2),bc
	ld	(_lastRegPolChgTime),de
	ld	(_lastRegPolChgTime+2),bc
;5089 
;5090 //---------------------------------------------------------------
;5091 //  At this point the analog and digital input values have been
;5092 //  read so they can be used in determining what state to start
;5093 //  with for the outputs and any other values.
;5094 //--------------------------------------------------------------
;5095 
;5096 //--- update current state, both for use here, and so when updateCurState()
;5097 //--- is called near the start of the application loop, there will be valid
;5098 //--- data to copy to the previous state ---
;5099   updateCurState();
	lcall	$updateCurState
;5100 
;5101   Next.ampSet = Next.ampApply = 0.0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_nextState+328),de
	ld	(_nextState+330),bc
	ld	(_nextState+283),de
	ld	(_nextState+285),bc
;5102 
;5103   Next.state = STATE_INIT;
	bool	hl
	ld	l,h
	ld	(_nextState+326),hl
;5104 
;5105   for (ui=0; ui<NumPS; ++ui)  {
	ld	(ix-2),hl
@1105:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@1106
;5106     bsNext = Next.bs + ui;
	ld	hl,(ix-2)
	ld	bc,0x1c
	ex	de,hl
	mul
	ld	hl,_nextState
	add	hl,bc
	ld	(ix-4),hl
;5107     bsNext->setOn = false;
	ld	de,0x1b
	add	hl,de
	xor	a,a
	ld	(hl),a
;5108   }
;5109 
;5110   psOnTime = 0;  psOnAndReady = loadTypeWrong = false;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@1105
@1106:
	bool	hl
	ld	l,h
	ld	(_psOnTime),hl
	xor	a,a
	ld	(_loadTypeWrong),a
	ld	(_psOnAndReady),a
;5111 
;5112   Cur.regPol = Cur.hystRegPol = true;
	ld	a,0x1
	ld	(_curState+293),a
	ld	(_curState+292),a
;5113 
;5114   bridgeOffTime = 0;
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	ld	(_bridgeOffTime),de
	ld	(_bridgeOffTime+2),bc
;5115   lastLoadTypeWarnTime = lastValLogTime = GetSeconds_();
	ld	hl,(__TimerSeconds)
	ld	(_lastValLogTime),hl
	ld	(_lastLoadTypeWarnTime),hl
;5116 
;5117   logStateChgMsgs = true;
	ld	(_logStateChgMsgs),a
;5118 
;5119   dummyFloat = 0;
	ld	(_dummyFloat),de
	ld	(_dummyFloat+2),bc
;5120 
;5121   bridgeStateStable = false;  bridgeChgdTime = GetMS_();
	xor	a,a
	ld	(_bridgeStateStable),a
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_bridgeChgdTime),hl
;5122 
;5123   logInterval = 3600;
	ld	hl,0xe10
	ld	(_logInterval),hl
;5124 }
@1099:
	.debug	} @1099 5124

@1098	equ	4
	ld	sp,ix
	pop	ix
	lret
@1100	equ	6
;5125 
;5126 
;5127 
;5128 //=========================================================================
;5129 //  This function is called by the application loop just before a shutdown.
;5130 //  The appliation must do whatever is necessary for a clean shutdown and
;5131 //  then exit
;5132 //=========================================================================
;5133 void applicShutdown(void)
;5134 {
$applicShutdown::
	.debug	G $applicShutdown 70 9
	.debug	{ $applicShutdown 70 5133 @1112 @1111
;5135   printf("Application prepping for shutdown\r\n");  fflush(stdout);
	ld	de,word (phys @1+4639)
	ld	c,phys @1+4639 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;5136 
;5137 
;5138   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5139 }
@1111:
	.debug	} @1111 5139

@1110	equ	0
	lret
@1112	equ	0
;5140 
;5141 //=========================================================================
;5142 //  This is the highest priority task, usually resumed at a regular interva
;5143 //  so that it can do what it needs and sleep again until the start of the
;5144 //  next interval.
;5145 //=========================================================================
;5146 void _task applic(int argc, char **argv)
;5147 {
	.align	4
$$applic::
	ex	(sp),iy
$applic::
	.debug	G $applic 88 9
	.debug	{ $applic 88 5146 @1115 @1114
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-114
;5148   #define SharedApplLocals
;5149   #include <sharedAppl.c>
;5150 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;5151 //--- add local variable definitions here ---
;5152 
;5153 
;5154   #define SharedApplLocals2
;5155   #include <sharedAppl.c>
;5156 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;5157 
;5158 //--- Required to insure that we have read ALL the bulk supply signals once
;5159   for (u=0; u<11; ++u)  readAnalogInputs(ADC_Mask);
	bool	hl
	ld	l,h
	ld	(ix-22),hl
@1118:
	ld	hl,(ix-22)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@1119
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
;5160 
;5161   #define SharedApplInit
;5162   #include <sharedAppl.c>
;5163 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(ix-22)
	inc	hl
	ld	(ix-22),hl
	jr	@1118
@1119:
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_prevState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_curState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	ld	(_numScopeRegs),hl
	lcall	$resetWDT
	ld	de,0xffff
	ld	bc,0x3ff
	ld	(_ADC_Mask),de
	ld	(_ADC_Mask+2),bc
	ld	de,0x7
	ld	c,d
	ld	b,d
	ld	(_DAC_Mask),de
	ld	(_DAC_Mask+2),bc
	ld	e,c
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1123:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1124
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$adcDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,0xbad
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1123
@1124:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1130:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1131
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$dacDefaults
	add	sp,6
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1130
@1131:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1137:
	ld	hl,(ix-24)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@1138
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$readDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	z,@1143
	jr	nc,@1142
@1143:
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
@1142:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1137
@1138:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1146:
	ld	hl,(ix-24)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@1147
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$setDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	z,@1152
	jr	nc,@1151
@1152:
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
@1151:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1146
@1147:
	lcall	$setGenericLabels
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
	push	hl
	ld	hl,-46+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
	ld	de,word (phys @1+4675)
	ld	c,phys @1+4675 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$initModBusRegs
	ld	hl,0x51
	ld	(_devType),hl
	ld	hl,_netmask
	push	hl
	ld	hl,@2+459
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	ld	hl,_gateway
	push	hl
	ld	hl,@2+471
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	ld	hl,@2+483
	push	hl
	lcall	$mkfifo
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x21
	push	hl
	ld	hl,@2+483
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-38),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	(_lastCtlLoopTime),hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	lcall	$setDefaultLabels
	lcall	$setDefaultConfig
	lcall	$initIOvalues
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@1153
	lcall	$restoreApplState
	ld	(ix-36),hl
	bool	hl
	jr	z,@1156
	ld	hl,(ix-36)
	push	hl
	ld	de,word (phys @1+4700)
	ld	c,phys @1+4700 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@1159
	xor	a,a
	ld	(_runBackup),a
@1159:
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@1156:
	ld	a,0x1
	ld	(_restoredApplState),a
@1153:
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$initParamModule
	add	sp,4
	ld	a,(_restoredApplState)
	or	a,a
	jr	nz,@1160
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+287),de
	ld	(_nextState+289),bc
	ld	(_curState+287),de
	ld	(_curState+289),bc
	ld	(_prevState+287),de
	ld	(_prevState+289),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
	ld	(_curState+334),de
	ld	(_curState+336),bc
	ld	(_prevState+334),de
	ld	(_prevState+336),bc
@1160:
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetUp
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
@1163:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@1165
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@1165
	lcall	$resetWDT
	jp	@1163
@1165:
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@1166
	ld	de,word (phys @1+4759)
	ld	c,phys @1+4759 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@1167
@1166:
	bool	hl
	ld	l,h
	push	hl
	lcall	$showNetState
	pop	hl
@1167:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1170:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1171
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1170
@1171:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1175:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1176
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
;5164   BZERO(bitCounts);  // counts for debouncing the digital inputs
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1175
@1176:
	ld	hl,0x40
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_bitCounts
	push	hl
	call	_memset
	add	sp,6
;5165 
;5166   _EnterCritical_();  SchedMS = 20;  _ExitCritical_();
	ipset	2
	ld	hl,0x14
	ld	(_SchedMS),hl
	ipres
;5167 
;5168 //--- workaround for older devData files with order-of-reload dependencies 
;5169   if (vlimPlus == 0.0)  loadAllParams(applBuf, sizeof(applBuf));
	ld	de,(_vlimPlus)
	ld	bc,(_vlimPlus+2)
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@1178
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadAllParams
	add	sp,4
;5170 
;5171 
;5172   setInitialState();
@1178:
	lcall	$setInitialState
;5173 
;5174 //--- add application initialization code here ---
;5175 //APPLCODE
;5176 
;5177   numLoggedChgMsgs = 0;
	bool	hl
	ld	l,h
	ld	(_numLoggedChgMsgs),hl
;5178 
;5179   BZERO(bulkShortStarted);
	ld	l,0x14
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_bulkShortStarted
	push	hl
	call	_memset
	add	sp,6
;5180 
;5181 
;5182   #define SharedApplInit2
;5183   #include <sharedAppl.c>
;5184 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$resetWDT
	ld	hl,0x1
	push	hl
	lcall	$logDigIOChgs
	pop	hl
	ld	hl,@2+494
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,_inetd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+500
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,_configd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+508
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_backupd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+516
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,0x5dc
	ld	(ix-34),hl
	lcall	$resetWDT
	bool	hl
	ld	l,h
	ld	(_applicTicks),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	bool	hl
	ld	l,h
	ld	(_applLoopTime),hl
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+4800)
	ld	c,phys @1+4800 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,0x1
	ld	(_startupComplete),a
;5185 //--- start process to manage the LCD display ---
;5186   argv_[0] = "lcdUI";  argv_[1] = NULL;
	ld	hl,@2+524
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
;5187   createProc(lcdUI, 4, 1, argv_, 0, 1, 2);
	ld	l,0x2
	push	hl
	ld	l,a
	push	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1113
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_lcdUI
	push	hl
	lcall	$createProc
	add	sp,14
;5188 
;5189 
;5190 //--- The following loop is run at a periodic interval (every SchedMS ms). 
;5191 //--- The application process consists of reading the current state of the 
;5192 //--- digital and analog inputs, changing the state of the analog and ---
;5193 //--- digital outputs to the values computed during the previous pass, then
;5194 //--- computing new values for the outputs and updating values that outside
;5195 //--- clients can read. ---
;5196 
;5197   Next.state = STATE_OFF;
	ld	hl,0x1
	ld	(_nextState+326),hl
;5198 
;5199   for (;;)  {
@1181:
;5200     #define SharedApplLoopStart
;5201     #include <sharedAppl.c>
;5202 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(_applicTicks)
	inc	hl
	ld	(_applicTicks),hl
	ld	hl,(ix-34)
	bool	hl
	jr	z,@1186
	ld	hl,(ix-34)
	dec	hl
	ld	(ix-34),hl
	bool	hl
	jr	nz,@1187
	xor	a,a
	ld	(_runBackup),a
@1187:
@1186:
	lcall	$resetWDT
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_applLoopTime),hl
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	ipset	2
	ld	a,(_intTicks)
	bool	hl
	ld	l,a
	ld	(_latency),hl
	ipres
	ld	hl,(_ctlLoopTicks)
	inc	hl
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	de,(_lastCtlLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jr	c,@1188
	ld	hl,(_ctlLoopTicks)
	or	a,a
	rr	hl
	ld	(_ctlLoopTicksPerSec),hl
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	(_lastCtlLoopTime),hl
;5203 
;5204   //--- read the current state of the analog and digital Input signals, and
;5205   //--- write the values computed at the end of the last pass ---
;5206     digitalOut = Next.digitalOut;  rwIO();
@1188:
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	lcall	$rwIO
;5207 
;5208   //--- process next event message (if any) ---
;5209     processMsg(eventsfd, (EventMsg *)buf, sizeof(buf));
	ld	hl,0x40
	push	hl
	ld	hl,-112+@1113
	add	hl,sp
	push	hl
	ld	hl,(ix-38)
	push	hl
	lcall	$processMsg
	add	sp,6
;5210 
;5211   //--- update the current state and determine the next state ---
;5212     updateCurState();  updateNextState();
	lcall	$updateCurState
	lcall	$updateNextState
;5213     updateOutputState();  updateExternals();
	lcall	$updateOutputState
	lcall	$updateExternals
;5214 
;5215 
;5216     #define SharedApplLoopEnd
;5217     #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastIdleTime)
	or	a,a
	sbc	hl,de
	ld	(ix-28),hl
	ld	de,0xbb8
	or	a,a
	sbc	hl,de
	jr	c,@1191
	ld	hl,(_idleTask)
	ld	de,0xd3
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,(_lastIdleMS)
	ld	bc,(_lastIdleMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ulmlt##
	ld	hl,(ix-28)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	(_percentIdle),de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
@1191:
	ld	hl,(_devType)
	ld	(_devType_),hl
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_deviceID_),de
	ld	(_deviceID_+2),bc
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	(_upSecs),de
	ld	(_upSecs+2),bc
	ld	hl,(_percentIdle)
	ld	(_percentIdle_),hl
	ld	hl,(_timeZone)
	ld	(_timeZone_),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
	ld	hl,-48+@1113
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@1194
	ld	l,0xf
	push	hl
	ld	hl,-46+@1113
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@1195
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	nz,@1196
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@1196:
@1195:
@1194:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	z,@1198
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f40
	ld	bc,0
	call	__lsub##
	jr	c,@1198
	jr	z,@1198
	lcall	$applicShutdown
@1198:
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,0x40
	and	hl,de
	jr	z,@1199
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	res	7,d
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
	jr	@1200
@1199:
	ld	de,(_nextState+334)
	ld	bc,(_nextState+336)
	set	7,d
	ld	(_nextState+334),de
	ld	(_nextState+336),bc
@1200:
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@1201
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-32),hl
	ipres
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-22),hl
	ld	hl,(_scopeList)
	ld	(ix-50),hl
@1206:
	ld	hl,(ix-22)
	ld	de,(_numScopeRegs)
	or	a,a
	sbc	hl,de
	jp	nc,@1207
	ld	hl,(ix-50)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-30),hl
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@1211
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst2##
	jp	@1212
@1211:
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
@1212:
	ld	hl,(ix-30)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-22)
	inc	hl
	ld	(ix-22),hl
	add	hl,hl
	ld	de,_scopeList
	add	hl,de
	ld	hl,(hl)
	ld	(ix-50),hl
	jp	@1206
@1207:
	ld	de,(_captureCount)
	ld	bc,(_captureCount+2)
	call	__linc##
	ld	(_captureCount),de
	ld	(_captureCount+2),bc
	ld	hl,(_captureIdx)
	inc	hl
	ld	(_captureIdx),hl
	ld	de,(_scopeBufSampleSize)
	or	a,a
	sbc	hl,de
	jr	nz,@1213
	bool	hl
	ld	l,h
	ld	(_captureIdx),hl
	ld	de,(_scopeBuf)
	ld	bc,(_scopeBuf+2)
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@1213:
@1201:
	ld	a,0x1
	ld	(_applicReady),a
;5218   }
;5219 
;5220 }
	jp	@1181
@1114:
	.debug	} @1114 5220

@1113	equ	114
	ld	sp,ix
	pop	ix
	lret
@1115	equ	116
;5221 
;5222 
;5223 //=========================================================================
;5224 //  list of application-specific commands that are normally entered via a
;5225 //  user shell
;5226 //=========================================================================
;5227 //void _task nsclSeriald(int argc, char **argv);
;5228 
;5229 //--- add any application-specific commands here ---
;5230 const CmdInfo far applCmds[] = {
;5231   { "lcdui",     lcdUI,       "LCD user interface daemon" },
	.seg	CONST
_applCmds::
	.dw	word (phys @1+4819)
	.dw	phys @1+4819 >> 16
	.dw	word _lcdUI
	.dw	word (phys @1+4825)
	.dw	phys @1+4825 >> 16
;5232   { "cmd",       cmd,         "Turn On/Off, Reset, enable/disable, etc" },
	.dw	word (phys @1+4851)
	.dw	phys @1+4851 >> 16
	.dw	word _cmd
	.dw	word (phys @1+4855)
	.dw	phys @1+4855 >> 16
;5233   { "state",     showState,   "Show state of controller" }
	.dw	word (phys @1+458)
	.dw	phys @1+458 >> 16
	.dw	word _showState
	.dw	word (phys @1+4895)
	.dw	phys @1+4895 >> 16
;5234 };
	.debug	G _applCmds 105 8
;5235 
;5236 int const NumApplCmds = ( sizeof(applCmds) / sizeof(CmdInfo) );
_NumApplCmds::
	.dw	0x3
	.debug	G _NumApplCmds 6 0
;5237 
;5238 //-------------------------------------------------------------------------
;5239 
;5240 #endif
	.extern	$time 107
	.extern	_memset 108
	.extern	_stricmp 110
	.extern	_strlen 111
	.extern	_strncpy 112
	.extern	$fmemcpy 113
	.extern	_fmemset 115
	.extern	_fstrcpy 116
	.extern	_fabs 117
	.extern	$redirectStdio 73
	.extern	$clockTicks 118
	.extern	$memCRC16 119
	.extern	$fmtFloat 120
	.extern	$stdHeader 70
	.extern	$showNetState 121
	.extern	$CheckETX 73
	.extern	$compileTime 122
	.extern	$processMsg 123
	.extern	$inet_ptoh 124
	.extern	_clsCmd 125
	.extern	$sigismember 126
	.extern	$sigprocmask 127
	.extern	$sigpending 128
	.extern	_current 129
	.extern	_idleTask 129
	.extern	_applTask 129
	.extern	_SchedMS 7
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 70
	.extern	__stdio 131
	.extern	$farfprintf 133
	.extern	$farprintf 134
	.extern	$farsprintf 135
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 136
	.extern	$xavail 118
	.extern	_abs 137
	.extern	_strtod 138
	.extern	$strtoi 139
	.extern	_qdCount 6
	.extern	_updateAIn 125
	.extern	_updateAOut 125
	.extern	_adcGain 140
	.extern	_adcOffset 140
	.extern	_dacGain 140
	.extern	_dacOffset 140
	.extern	_aoutMin 140
	.extern	_aoutMax 140
	.extern	_setValMin 140
	.extern	_setValMax 140
	.extern	_readValMax 140
	.extern	_anaIn 140
	.extern	_anaOut 140
	.extern	_lastAnaOut 140
	.extern	_adcRaw 141
	.extern	_dacRaw 141
	.extern	_lastadcRaw 141
	.extern	_newRdg 125
	.extern	_adcForced 125
	.extern	_dacForced 125
	.extern	_adcForcedVal 140
	.extern	_dacForcedVal 140
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.bseg
_readGain::
	.ds	104
	.debug	G _readGain 142 0
_readOffset::
	.ds	104
	.debug	G _readOffset 142 0
_setGain::
	.ds	12
	.debug	G _setGain 143 0
_setOffset::
	.ds	12
	.debug	G _setOffset 143 0
_readVal::
	.ds	104
	.debug	G _readVal 142 0
_setVal::
	.ds	12
	.debug	G _setVal 143 0
_lastSetVal::
	.ds	12
	.debug	G _lastSetVal 143 0
	.extern	_digitalIn 9
	.extern	_digitalOut 9
	.extern	_extraIn 9
	.defseg	FARBSS
	.seg	FARBSS
_ainLabel::
	.ds	624
	.debug	G _ainLabel 144 8
_aoutLabel::
	.ds	72
	.debug	G _aoutLabel 146 8
_dinLabel::
	.ds	768
	.debug	G _dinLabel 147 8
_doutLabel::
	.ds	384
	.debug	G _doutLabel 148 8
_extraInLabel::
	.ds	768
	.debug	G _extraInLabel 147 8
	.extern	$initIOvalues 70
	.extern	$ReadDigInputs 118
	.extern	$WriteDigOutputs 149
	.extern	$ReadDeviceID 118
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 100
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 100
	.extern	$writeAnalogOutputs 149
	.extern	$readAnalogInputs 149
	.extern	$updateAvgsADC 70
	.extern	$open 150
	.extern	$write 151
	.extern	$fflush 152
	.extern	$ioctl 153
	.extern	_KLOCK 70
	.extern	_KUNLOCK 70
	.extern	$resetWDT 70
	.extern	_hostName 47
	.bseg
_ctlLoopTicksPerSec::
	.ds	2
	.debug	G _ctlLoopTicksPerSec 7 0
	.extern	_prevLogInfo 154
	.extern	_runBackup 3
	.extern	_runningPrimary 3
	.extern	_doReboot 3
	.extern	_doShutdown 3
	.extern	_diagLog 132
	.extern	_intTicks 3
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_hdwType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$REBOOT 71
	.extern	$createProc 155
	.extern	$sleepMS 156
	.extern	$Exit 121
	.extern	$SetHostName 157
_C0ChanMult::
	.ds	2
	.debug	G _C0ChanMult 7 0
_NumC0Chans::
	.ds	2
	.debug	G _NumC0Chans 7 0
_R3ChanMult::
	.ds	2
	.debug	G _R3ChanMult 7 0
_NumR3Chans::
	.ds	2
	.debug	G _NumR3Chans 7 0
_R4ChanMult::
	.ds	2
	.debug	G _R4ChanMult 7 0
_NumR4Chans::
	.ds	2
	.debug	G _NumR4Chans 7 0
	.extern	_numScopeRegs 7
	.extern	_captureIdx 7
	.extern	_scopeBufSampleSize 7
	.extern	_captureCount 9
	.extern	_scopeList 158
	.extern	_scopeBuf 49
	.extern	_capturePtr 49
	.cseg
_setU16:
	pop	iy
	lcall	$$setU16
	.extern	$$setU16
	.extern	$setU16 68
_setU32:
	pop	iy
	lcall	$$setU32
	.extern	$$setU32
	.extern	$setU32 68
_setF32:
	pop	iy
	lcall	$$setF32
	.extern	$$setF32
	.extern	$setF32 68
	.extern	$fmtRegVal 159
	.extern	$pvInitLists 73
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.extern	$$modbusTCPd
	.extern	$modbusTCPd 88
	.bseg
_DoReboot::
	.ds	1
	.debug	G _DoReboot 3 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.extern	$$setCoil
	.extern	$setCoil 160
	.bseg
_dlmVersTime::
	.ds	4
	.debug	G _dlmVersTime 9 0
_dlmVersTime_ChgEventVal::
	.ds	4
	.debug	G _dlmVersTime_ChgEventVal 9 0
_dlmVersTime_MinChg::
	.ds	4
	.debug	G _dlmVersTime_MinChg 9 0
_rtosVersTime::
	.ds	4
	.debug	G _rtosVersTime 9 0
_rtosVersTime_ChgEventVal::
	.ds	4
	.debug	G _rtosVersTime_ChgEventVal 9 0
_rtosVersTime_MinChg::
	.ds	4
	.debug	G _rtosVersTime_MinChg 9 0
_applVersTime::
	.ds	4
	.debug	G _applVersTime 9 0
_applVersTime_ChgEventVal::
	.ds	4
	.debug	G _applVersTime_ChgEventVal 9 0
_applVersTime_MinChg::
	.ds	4
	.debug	G _applVersTime_MinChg 9 0
_devType_::
	.ds	2
	.debug	G _devType_ 5 0
_devType__ChgEventVal::
	.ds	2
	.debug	G _devType__ChgEventVal 5 0
_devType__MinChg::
	.ds	2
	.debug	G _devType__MinChg 5 0
_deviceID_::
	.ds	4
	.debug	G _deviceID_ 9 0
_deviceID__ChgEventVal::
	.ds	4
	.debug	G _deviceID__ChgEventVal 9 0
_deviceID__MinChg::
	.ds	4
	.debug	G _deviceID__MinChg 9 0
_upSecs::
	.ds	4
	.debug	G _upSecs 9 0
_upSecs_ChgEventVal::
	.ds	4
	.debug	G _upSecs_ChgEventVal 9 0
_upSecs_MinChg::
	.ds	4
	.debug	G _upSecs_MinChg 9 0
_percentIdle_::
	.ds	2
	.debug	G _percentIdle_ 5 0
_percentIdle__ChgEventVal::
	.ds	2
	.debug	G _percentIdle__ChgEventVal 5 0
_percentIdle__MinChg::
	.ds	2
	.debug	G _percentIdle__MinChg 5 0
_numChans::
	.ds	2
	.debug	G _numChans 5 0
_numChans_ChgEventVal::
	.ds	2
	.debug	G _numChans_ChgEventVal 5 0
_numChans_MinChg::
	.ds	2
	.debug	G _numChans_MinChg 5 0
_coilChanMult::
	.ds	2
	.debug	G _coilChanMult 5 0
_coilChanMult_ChgEventVal::
	.ds	2
	.debug	G _coilChanMult_ChgEventVal 5 0
_coilChanMult_MinChg::
	.ds	2
	.debug	G _coilChanMult_MinChg 5 0
_reg3ChanMult::
	.ds	2
	.debug	G _reg3ChanMult 5 0
_reg3ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg3ChanMult_ChgEventVal 5 0
_reg3ChanMult_MinChg::
	.ds	2
	.debug	G _reg3ChanMult_MinChg 5 0
_reg4ChanMult::
	.ds	2
	.debug	G _reg4ChanMult 5 0
_reg4ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg4ChanMult_ChgEventVal 5 0
_reg4ChanMult_MinChg::
	.ds	2
	.debug	G _reg4ChanMult_MinChg 5 0
_digInBits::
	.ds	4
	.debug	G _digInBits 9 0
_digInBits_ChgEventVal::
	.ds	4
	.debug	G _digInBits_ChgEventVal 9 0
_digInBits_MinChg::
	.ds	4
	.debug	G _digInBits_MinChg 9 0
_statusBitsStdA::
	.ds	2
	.debug	G _statusBitsStdA 5 0
_statusBitsStdA_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdA_ChgEventVal 5 0
_statusBitsStdA_MinChg::
	.ds	2
	.debug	G _statusBitsStdA_MinChg 5 0
_statusBitsStdB::
	.ds	2
	.debug	G _statusBitsStdB 5 0
_statusBitsStdB_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdB_ChgEventVal 5 0
_statusBitsStdB_MinChg::
	.ds	2
	.debug	G _statusBitsStdB_MinChg 5 0
_statusBitsAppl::
	.ds	4
	.debug	G _statusBitsAppl 9 0
_statusBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _statusBitsAppl_ChgEventVal 9 0
_statusBitsAppl_MinChg::
	.ds	4
	.debug	G _statusBitsAppl_MinChg 9 0
_bsv_1::
	.ds	4
	.debug	G _bsv_1 10 0
_bsv_1_ChgEventVal::
	.ds	4
	.debug	G _bsv_1_ChgEventVal 10 0
_bsv_1_MinChg::
	.ds	4
	.debug	G _bsv_1_MinChg 10 0
_bsv_2::
	.ds	4
	.debug	G _bsv_2 10 0
_bsv_2_ChgEventVal::
	.ds	4
	.debug	G _bsv_2_ChgEventVal 10 0
_bsv_2_MinChg::
	.ds	4
	.debug	G _bsv_2_MinChg 10 0
_bsv_3::
	.ds	4
	.debug	G _bsv_3 10 0
_bsv_3_ChgEventVal::
	.ds	4
	.debug	G _bsv_3_ChgEventVal 10 0
_bsv_3_MinChg::
	.ds	4
	.debug	G _bsv_3_MinChg 10 0
_bsv_4::
	.ds	4
	.debug	G _bsv_4 10 0
_bsv_4_ChgEventVal::
	.ds	4
	.debug	G _bsv_4_ChgEventVal 10 0
_bsv_4_MinChg::
	.ds	4
	.debug	G _bsv_4_MinChg 10 0
_bsv_5::
	.ds	4
	.debug	G _bsv_5 10 0
_bsv_5_ChgEventVal::
	.ds	4
	.debug	G _bsv_5_ChgEventVal 10 0
_bsv_5_MinChg::
	.ds	4
	.debug	G _bsv_5_MinChg 10 0
_bsv_6::
	.ds	4
	.debug	G _bsv_6 10 0
_bsv_6_ChgEventVal::
	.ds	4
	.debug	G _bsv_6_ChgEventVal 10 0
_bsv_6_MinChg::
	.ds	4
	.debug	G _bsv_6_MinChg 10 0
_bsv_7::
	.ds	4
	.debug	G _bsv_7 10 0
_bsv_7_ChgEventVal::
	.ds	4
	.debug	G _bsv_7_ChgEventVal 10 0
_bsv_7_MinChg::
	.ds	4
	.debug	G _bsv_7_MinChg 10 0
_bsv_8::
	.ds	4
	.debug	G _bsv_8 10 0
_bsv_8_ChgEventVal::
	.ds	4
	.debug	G _bsv_8_ChgEventVal 10 0
_bsv_8_MinChg::
	.ds	4
	.debug	G _bsv_8_MinChg 10 0
_bsv_9::
	.ds	4
	.debug	G _bsv_9 10 0
_bsv_9_ChgEventVal::
	.ds	4
	.debug	G _bsv_9_ChgEventVal 10 0
_bsv_9_MinChg::
	.ds	4
	.debug	G _bsv_9_MinChg 10 0
_bsv_10::
	.ds	4
	.debug	G _bsv_10 10 0
_bsv_10_ChgEventVal::
	.ds	4
	.debug	G _bsv_10_ChgEventVal 10 0
_bsv_10_MinChg::
	.ds	4
	.debug	G _bsv_10_MinChg 10 0
_amps_1::
	.ds	4
	.debug	G _amps_1 10 0
_amps_1_ChgEventVal::
	.ds	4
	.debug	G _amps_1_ChgEventVal 10 0
_amps_1_MinChg::
	.ds	4
	.debug	G _amps_1_MinChg 10 0
_amps_2::
	.ds	4
	.debug	G _amps_2 10 0
_amps_2_ChgEventVal::
	.ds	4
	.debug	G _amps_2_ChgEventVal 10 0
_amps_2_MinChg::
	.ds	4
	.debug	G _amps_2_MinChg 10 0
_amps_3::
	.ds	4
	.debug	G _amps_3 10 0
_amps_3_ChgEventVal::
	.ds	4
	.debug	G _amps_3_ChgEventVal 10 0
_amps_3_MinChg::
	.ds	4
	.debug	G _amps_3_MinChg 10 0
_amps_4::
	.ds	4
	.debug	G _amps_4 10 0
_amps_4_ChgEventVal::
	.ds	4
	.debug	G _amps_4_ChgEventVal 10 0
_amps_4_MinChg::
	.ds	4
	.debug	G _amps_4_MinChg 10 0
_amps_5::
	.ds	4
	.debug	G _amps_5 10 0
_amps_5_ChgEventVal::
	.ds	4
	.debug	G _amps_5_ChgEventVal 10 0
_amps_5_MinChg::
	.ds	4
	.debug	G _amps_5_MinChg 10 0
_amps_6::
	.ds	4
	.debug	G _amps_6 10 0
_amps_6_ChgEventVal::
	.ds	4
	.debug	G _amps_6_ChgEventVal 10 0
_amps_6_MinChg::
	.ds	4
	.debug	G _amps_6_MinChg 10 0
_amps_7::
	.ds	4
	.debug	G _amps_7 10 0
_amps_7_ChgEventVal::
	.ds	4
	.debug	G _amps_7_ChgEventVal 10 0
_amps_7_MinChg::
	.ds	4
	.debug	G _amps_7_MinChg 10 0
_amps_8::
	.ds	4
	.debug	G _amps_8 10 0
_amps_8_ChgEventVal::
	.ds	4
	.debug	G _amps_8_ChgEventVal 10 0
_amps_8_MinChg::
	.ds	4
	.debug	G _amps_8_MinChg 10 0
_amps_9::
	.ds	4
	.debug	G _amps_9 10 0
_amps_9_ChgEventVal::
	.ds	4
	.debug	G _amps_9_ChgEventVal 10 0
_amps_9_MinChg::
	.ds	4
	.debug	G _amps_9_MinChg 10 0
_amps_10::
	.ds	4
	.debug	G _amps_10 10 0
_amps_10_ChgEventVal::
	.ds	4
	.debug	G _amps_10_ChgEventVal 10 0
_amps_10_MinChg::
	.ds	4
	.debug	G _amps_10_MinChg 10 0
_ampRead::
	.ds	4
	.debug	G _ampRead 10 0
_ampRead_ChgEventVal::
	.ds	4
	.debug	G _ampRead_ChgEventVal 10 0
_ampRead_MinChg::
	.ds	4
	.debug	G _ampRead_MinChg 10 0
_voltRead::
	.ds	4
	.debug	G _voltRead 10 0
_voltRead_ChgEventVal::
	.ds	4
	.debug	G _voltRead_ChgEventVal 10 0
_voltRead_MinChg::
	.ds	4
	.debug	G _voltRead_MinChg 10 0
_vctrl::
	.ds	4
	.debug	G _vctrl 10 0
_vctrl_ChgEventVal::
	.ds	4
	.debug	G _vctrl_ChgEventVal 10 0
_vctrl_MinChg::
	.ds	4
	.debug	G _vctrl_MinChg 10 0
_bjtBias::
	.ds	4
	.debug	G _bjtBias 10 0
_bjtBias_ChgEventVal::
	.ds	4
	.debug	G _bjtBias_ChgEventVal 10 0
_bjtBias_MinChg::
	.ds	4
	.debug	G _bjtBias_MinChg 10 0
_state_1::
	.ds	2
	.debug	G _state_1 5 0
_state_1_ChgEventVal::
	.ds	2
	.debug	G _state_1_ChgEventVal 5 0
_state_1_MinChg::
	.ds	2
	.debug	G _state_1_MinChg 5 0
_state_2::
	.ds	2
	.debug	G _state_2 5 0
_state_2_ChgEventVal::
	.ds	2
	.debug	G _state_2_ChgEventVal 5 0
_state_2_MinChg::
	.ds	2
	.debug	G _state_2_MinChg 5 0
_state_3::
	.ds	2
	.debug	G _state_3 5 0
_state_3_ChgEventVal::
	.ds	2
	.debug	G _state_3_ChgEventVal 5 0
_state_3_MinChg::
	.ds	2
	.debug	G _state_3_MinChg 5 0
_state_4::
	.ds	2
	.debug	G _state_4 5 0
_state_4_ChgEventVal::
	.ds	2
	.debug	G _state_4_ChgEventVal 5 0
_state_4_MinChg::
	.ds	2
	.debug	G _state_4_MinChg 5 0
_state_5::
	.ds	2
	.debug	G _state_5 5 0
_state_5_ChgEventVal::
	.ds	2
	.debug	G _state_5_ChgEventVal 5 0
_state_5_MinChg::
	.ds	2
	.debug	G _state_5_MinChg 5 0
_state_6::
	.ds	2
	.debug	G _state_6 5 0
_state_6_ChgEventVal::
	.ds	2
	.debug	G _state_6_ChgEventVal 5 0
_state_6_MinChg::
	.ds	2
	.debug	G _state_6_MinChg 5 0
_state_7::
	.ds	2
	.debug	G _state_7 5 0
_state_7_ChgEventVal::
	.ds	2
	.debug	G _state_7_ChgEventVal 5 0
_state_7_MinChg::
	.ds	2
	.debug	G _state_7_MinChg 5 0
_state_8::
	.ds	2
	.debug	G _state_8 5 0
_state_8_ChgEventVal::
	.ds	2
	.debug	G _state_8_ChgEventVal 5 0
_state_8_MinChg::
	.ds	2
	.debug	G _state_8_MinChg 5 0
_state_9::
	.ds	2
	.debug	G _state_9 5 0
_state_9_ChgEventVal::
	.ds	2
	.debug	G _state_9_ChgEventVal 5 0
_state_9_MinChg::
	.ds	2
	.debug	G _state_9_MinChg 5 0
_state_10::
	.ds	2
	.debug	G _state_10 5 0
_state_10_ChgEventVal::
	.ds	2
	.debug	G _state_10_ChgEventVal 5 0
_state_10_MinChg::
	.ds	2
	.debug	G _state_10_MinChg 5 0
_outMode::
	.ds	2
	.debug	G _outMode 5 0
_outMode_ChgEventVal::
	.ds	2
	.debug	G _outMode_ChgEventVal 5 0
_outMode_MinChg::
	.ds	2
	.debug	G _outMode_MinChg 5 0
_ampApply::
	.ds	4
	.debug	G _ampApply 10 0
_ampApply_ChgEventVal::
	.ds	4
	.debug	G _ampApply_ChgEventVal 10 0
_ampApply_MinChg::
	.ds	4
	.debug	G _ampApply_MinChg 10 0
_psCount::
	.ds	2
	.debug	G _psCount 5 0
_psCount_ChgEventVal::
	.ds	2
	.debug	G _psCount_ChgEventVal 5 0
_psCount_MinChg::
	.ds	2
	.debug	G _psCount_MinChg 5 0
_state::
	.ds	2
	.debug	G _state 5 0
_state_ChgEventVal::
	.ds	2
	.debug	G _state_ChgEventVal 5 0
_state_MinChg::
	.ds	2
	.debug	G _state_MinChg 5 0
_iset::
	.ds	4
	.debug	G _iset 10 0
_iset_ChgEventVal::
	.ds	4
	.debug	G _iset_ChgEventVal 10 0
_iset_MinChg::
	.ds	4
	.debug	G _iset_MinChg 10 0
_ifdbk::
	.ds	4
	.debug	G _ifdbk 10 0
_ifdbk_ChgEventVal::
	.ds	4
	.debug	G _ifdbk_ChgEventVal 10 0
_ifdbk_MinChg::
	.ds	4
	.debug	G _ifdbk_MinChg 10 0
_vout::
	.ds	4
	.debug	G _vout 10 0
_vout_ChgEventVal::
	.ds	4
	.debug	G _vout_ChgEventVal 10 0
_vout_MinChg::
	.ds	4
	.debug	G _vout_MinChg 10 0
_polCmd::
	.ds	2
	.debug	G _polCmd 5 0
_polCmd_ChgEventVal::
	.ds	2
	.debug	G _polCmd_ChgEventVal 5 0
_polCmd_MinChg::
	.ds	2
	.debug	G _polCmd_MinChg 5 0
_vctrlStatus::
	.ds	2
	.debug	G _vctrlStatus 5 0
_vctrlStatus_ChgEventVal::
	.ds	2
	.debug	G _vctrlStatus_ChgEventVal 5 0
_vctrlStatus_MinChg::
	.ds	2
	.debug	G _vctrlStatus_MinChg 5 0
_ampErr::
	.ds	4
	.debug	G _ampErr 10 0
_ampErr_ChgEventVal::
	.ds	4
	.debug	G _ampErr_ChgEventVal 10 0
_ampErr_MinChg::
	.ds	4
	.debug	G _ampErr_MinChg 10 0
_ttlBulkCur::
	.ds	4
	.debug	G _ttlBulkCur 10 0
_ttlBulkCur_ChgEventVal::
	.ds	4
	.debug	G _ttlBulkCur_ChgEventVal 10 0
_ttlBulkCur_MinChg::
	.ds	4
	.debug	G _ttlBulkCur_MinChg 10 0
_unused2::
	.ds	4
	.debug	G _unused2 10 0
_unused2_ChgEventVal::
	.ds	4
	.debug	G _unused2_ChgEventVal 10 0
_unused2_MinChg::
	.ds	4
	.debug	G _unused2_MinChg 10 0
_latency::
	.ds	2
	.debug	G _latency 5 0
_latency_ChgEventVal::
	.ds	2
	.debug	G _latency_ChgEventVal 5 0
_latency_MinChg::
	.ds	2
	.debug	G _latency_MinChg 5 0
_tcpTickTime::
	.ds	2
	.debug	G _tcpTickTime 5 0
_tcpTickTime_ChgEventVal::
	.ds	2
	.debug	G _tcpTickTime_ChgEventVal 5 0
_tcpTickTime_MinChg::
	.ds	2
	.debug	G _tcpTickTime_MinChg 5 0
_applLoopTime::
	.ds	2
	.debug	G _applLoopTime 5 0
_applLoopTime_ChgEventVal::
	.ds	2
	.debug	G _applLoopTime_ChgEventVal 5 0
_applLoopTime_MinChg::
	.ds	2
	.debug	G _applLoopTime_MinChg 5 0
_kernelLoopTime::
	.ds	2
	.debug	G _kernelLoopTime 5 0
_kernelLoopTime_ChgEventVal::
	.ds	2
	.debug	G _kernelLoopTime_ChgEventVal 5 0
_kernelLoopTime_MinChg::
	.ds	2
	.debug	G _kernelLoopTime_MinChg 5 0
_loadRes::
	.ds	4
	.debug	G _loadRes 10 0
_loadRes_ChgEventVal::
	.ds	4
	.debug	G _loadRes_ChgEventVal 10 0
_loadRes_MinChg::
	.ds	4
	.debug	G _loadRes_MinChg 10 0
_dumpRes::
	.ds	4
	.debug	G _dumpRes 10 0
_dumpRes_ChgEventVal::
	.ds	4
	.debug	G _dumpRes_ChgEventVal 10 0
_dumpRes_MinChg::
	.ds	4
	.debug	G _dumpRes_MinChg 10 0
_timeZone_::
	.ds	2
	.debug	G _timeZone_ 4 0
_timeZone__ChgEventVal::
	.ds	2
	.debug	G _timeZone__ChgEventVal 4 0
_timeZone__MinChg::
	.ds	2
	.debug	G _timeZone__MinChg 4 0
	.cseg
_MB_timeZone:
	pop	iy
	lcall	$$MB_timeZone
	.bseg
_curTime::
	.ds	4
	.debug	G _curTime 9 0
_curTime_ChgEventVal::
	.ds	4
	.debug	G _curTime_ChgEventVal 9 0
_curTime_MinChg::
	.ds	4
	.debug	G _curTime_MinChg 9 0
_ipAddr::
	.ds	4
	.debug	G _ipAddr 9 0
_ipAddr_ChgEventVal::
	.ds	4
	.debug	G _ipAddr_ChgEventVal 9 0
_ipAddr_MinChg::
	.ds	4
	.debug	G _ipAddr_MinChg 9 0
_netmask::
	.ds	4
	.debug	G _netmask 9 0
_netmask_ChgEventVal::
	.ds	4
	.debug	G _netmask_ChgEventVal 9 0
_netmask_MinChg::
	.ds	4
	.debug	G _netmask_MinChg 9 0
_gateway::
	.ds	4
	.debug	G _gateway 9 0
_gateway_ChgEventVal::
	.ds	4
	.debug	G _gateway_ChgEventVal 9 0
_gateway_MinChg::
	.ds	4
	.debug	G _gateway_MinChg 9 0
_setACoil::
	.ds	2
	.debug	G _setACoil 161 0
_setACoil_ChgEventVal::
	.ds	2
	.debug	G _setACoil_ChgEventVal 161 0
_setACoil_MinChg::
	.ds	2
	.debug	G _setACoil_MinChg 161 0
_resetACoil::
	.ds	2
	.debug	G _resetACoil 161 0
_resetACoil_ChgEventVal::
	.ds	2
	.debug	G _resetACoil_ChgEventVal 161 0
_resetACoil_MinChg::
	.ds	2
	.debug	G _resetACoil_MinChg 161 0
_digOutBits::
	.ds	4
	.debug	G _digOutBits 9 0
_digOutBits_ChgEventVal::
	.ds	4
	.debug	G _digOutBits_ChgEventVal 9 0
_digOutBits_MinChg::
	.ds	4
	.debug	G _digOutBits_MinChg 9 0
_cmdBitsStd::
	.ds	4
	.debug	G _cmdBitsStd 9 0
_cmdBitsStd_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsStd_ChgEventVal 9 0
_cmdBitsStd_MinChg::
	.ds	4
	.debug	G _cmdBitsStd_MinChg 9 0
	.cseg
_MB_cmdBitsStd:
	pop	iy
	lcall	$$MB_cmdBitsStd
	.bseg
_cmdBitsAppl::
	.ds	4
	.debug	G _cmdBitsAppl 9 0
_cmdBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsAppl_ChgEventVal 9 0
_cmdBitsAppl_MinChg::
	.ds	4
	.debug	G _cmdBitsAppl_MinChg 9 0
	.cseg
_MB_cmdBitsAppl:
	pop	iy
	lcall	$$MB_cmdBitsAppl
	.bseg
_ampSet::
	.ds	4
	.debug	G _ampSet 10 0
_ampSet_ChgEventVal::
	.ds	4
	.debug	G _ampSet_ChgEventVal 10 0
_ampSet_MinChg::
	.ds	4
	.debug	G _ampSet_MinChg 10 0
	.cseg
_MB_ampSet:
	pop	iy
	lcall	$$MB_ampSet
	.bseg
_vlimPlus::
	.ds	4
	.debug	G _vlimPlus 10 0
_vlimPlus_ChgEventVal::
	.ds	4
	.debug	G _vlimPlus_ChgEventVal 10 0
_vlimPlus_MinChg::
	.ds	4
	.debug	G _vlimPlus_MinChg 10 0
	.cseg
_MB_vlimPlus:
	pop	iy
	lcall	$$MB_vlimPlus
	.bseg
_vlimMinus::
	.ds	4
	.debug	G _vlimMinus 10 0
_vlimMinus_ChgEventVal::
	.ds	4
	.debug	G _vlimMinus_ChgEventVal 10 0
_vlimMinus_MinChg::
	.ds	4
	.debug	G _vlimMinus_MinChg 10 0
	.cseg
_MB_vlimMinus:
	pop	iy
	lcall	$$MB_vlimMinus
	.bseg
_rampRate::
	.ds	4
	.debug	G _rampRate 10 0
_rampRate_ChgEventVal::
	.ds	4
	.debug	G _rampRate_ChgEventVal 10 0
_rampRate_MinChg::
	.ds	4
	.debug	G _rampRate_MinChg 10 0
	.cseg
_MB_rampRate:
	pop	iy
	lcall	$$MB_rampRate
	.bseg
_vctrlHyst::
	.ds	4
	.debug	G _vctrlHyst 10 0
_vctrlHyst_ChgEventVal::
	.ds	4
	.debug	G _vctrlHyst_ChgEventVal 10 0
_vctrlHyst_MinChg::
	.ds	4
	.debug	G _vctrlHyst_MinChg 10 0
	.cseg
_MB_vctrlHyst:
	pop	iy
	lcall	$$MB_vctrlHyst
	.bseg
_minPolStableTime::
	.ds	2
	.debug	G _minPolStableTime 5 0
_minPolStableTime_ChgEventVal::
	.ds	2
	.debug	G _minPolStableTime_ChgEventVal 5 0
_minPolStableTime_MinChg::
	.ds	2
	.debug	G _minPolStableTime_MinChg 5 0
_unused1::
	.ds	2
	.debug	G _unused1 5 0
_unused1_ChgEventVal::
	.ds	2
	.debug	G _unused1_ChgEventVal 5 0
_unused1_MinChg::
	.ds	2
	.debug	G _unused1_MinChg 5 0
_minBSVolts::
	.ds	4
	.debug	G _minBSVolts 10 0
_minBSVolts_ChgEventVal::
	.ds	4
	.debug	G _minBSVolts_ChgEventVal 10 0
_minBSVolts_MinChg::
	.ds	4
	.debug	G _minBSVolts_MinChg 10 0
_maxBSFracCurDiff::
	.ds	4
	.debug	G _maxBSFracCurDiff 10 0
_maxBSFracCurDiff_ChgEventVal::
	.ds	4
	.debug	G _maxBSFracCurDiff_ChgEventVal 10 0
_maxBSFracCurDiff_MinChg::
	.ds	4
	.debug	G _maxBSFracCurDiff_MinChg 10 0
_vlimReduction::
	.ds	4
	.debug	G _vlimReduction 10 0
_vlimReduction_ChgEventVal::
	.ds	4
	.debug	G _vlimReduction_ChgEventVal 10 0
_vlimReduction_MinChg::
	.ds	4
	.debug	G _vlimReduction_MinChg 10 0
_sinkEndAmps::
	.ds	4
	.debug	G _sinkEndAmps 10 0
_sinkEndAmps_ChgEventVal::
	.ds	4
	.debug	G _sinkEndAmps_ChgEventVal 10 0
_sinkEndAmps_MinChg::
	.ds	4
	.debug	G _sinkEndAmps_MinChg 10 0
_unused3::
	.ds	4
	.debug	G _unused3 10 0
_unused3_ChgEventVal::
	.ds	4
	.debug	G _unused3_ChgEventVal 10 0
_unused3_MinChg::
	.ds	4
	.debug	G _unused3_MinChg 10 0
_knobSelectRate::
	.ds	2
	.debug	G _knobSelectRate 5 0
_knobSelectRate_ChgEventVal::
	.ds	2
	.debug	G _knobSelectRate_ChgEventVal 5 0
_knobSelectRate_MinChg::
	.ds	2
	.debug	G _knobSelectRate_MinChg 5 0
_maxAmpSet::
	.ds	4
	.debug	G _maxAmpSet 10 0
_maxAmpSet_ChgEventVal::
	.ds	4
	.debug	G _maxAmpSet_ChgEventVal 10 0
_maxAmpSet_MinChg::
	.ds	4
	.debug	G _maxAmpSet_MinChg 10 0
_minPSonTime::
	.ds	2
	.debug	G _minPSonTime 5 0
_minPSonTime_ChgEventVal::
	.ds	2
	.debug	G _minPSonTime_ChgEventVal 5 0
_minPSonTime_MinChg::
	.ds	2
	.debug	G _minPSonTime_MinChg 5 0
_minBridgeOffTime::
	.ds	2
	.debug	G _minBridgeOffTime 5 0
_minBridgeOffTime_ChgEventVal::
	.ds	2
	.debug	G _minBridgeOffTime_ChgEventVal 5 0
_minBridgeOffTime_MinChg::
	.ds	2
	.debug	G _minBridgeOffTime_MinChg 5 0
_unused4::
	.ds	2
	.debug	G _unused4 5 0
_unused4_ChgEventVal::
	.ds	2
	.debug	G _unused4_ChgEventVal 5 0
_unused4_MinChg::
	.ds	2
	.debug	G _unused4_MinChg 5 0
_unused5::
	.ds	4
	.debug	G _unused5 10 0
_unused5_ChgEventVal::
	.ds	4
	.debug	G _unused5_ChgEventVal 10 0
_unused5_MinChg::
	.ds	4
	.debug	G _unused5_MinChg 10 0
_maxErrTime::
	.ds	2
	.debug	G _maxErrTime 5 0
_maxErrTime_ChgEventVal::
	.ds	2
	.debug	G _maxErrTime_ChgEventVal 5 0
_maxErrTime_MinChg::
	.ds	2
	.debug	G _maxErrTime_MinChg 5 0
_contrast::
	.ds	2
	.debug	G _contrast 5 0
_contrast_ChgEventVal::
	.ds	2
	.debug	G _contrast_ChgEventVal 5 0
_contrast_MinChg::
	.ds	2
	.debug	G _contrast_MinChg 5 0
_bulkShortCur::
	.ds	4
	.debug	G _bulkShortCur 10 0
_bulkShortCur_ChgEventVal::
	.ds	4
	.debug	G _bulkShortCur_ChgEventVal 10 0
_bulkShortCur_MinChg::
	.ds	4
	.debug	G _bulkShortCur_MinChg 10 0
_supplyType::
	.ds	2
	.debug	G _supplyType 5 0
_supplyType_ChgEventVal::
	.ds	2
	.debug	G _supplyType_ChgEventVal 5 0
_supplyType_MinChg::
	.ds	2
	.debug	G _supplyType_MinChg 5 0
	.cseg
_MB_supplyType:
	pop	iy
	lcall	$$MB_supplyType
	.bseg
_loadType::
	.ds	2
	.debug	G _loadType 5 0
_loadType_ChgEventVal::
	.ds	2
	.debug	G _loadType_ChgEventVal 5 0
_loadType_MinChg::
	.ds	2
	.debug	G _loadType_MinChg 5 0
	.cseg
_MB_loadType:
	pop	iy
	lcall	$$MB_loadType
	.bseg
_debounceMS::
	.ds	2
	.debug	G _debounceMS 5 0
_debounceMS_ChgEventVal::
	.ds	2
	.debug	G _debounceMS_ChgEventVal 5 0
_debounceMS_MinChg::
	.ds	2
	.debug	G _debounceMS_MinChg 5 0
	.extern	$ifpending 137
	.extern	$startNetUp 137
	.extern	$mkfifo 157
	.extern	_hdwCfgParams 162
	.extern	$initParamModule 163
	.extern	$saveParams 164
	.extern	$loadParams 164
	.extern	$loadAllParams 165
	.extern	$loadParamsMsg 166
	.cseg
_backupd:
	pop	iy
	lcall	$$backupd
	.extern	$$backupd
	.extern	$backupd 88
	.extern	_srfsIPAddr 9
	.extern	_srfsAltAddr 9
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
	.extern	$$ca_tcpd
	.extern	$ca_tcpd 88
_inetd:
	pop	iy
	lcall	$$inetd
	.extern	$$inetd
	.extern	$inetd 88
	.extern	$displayElems 167
	.extern	$displayDigElems 168
_fmtF32:
	pop	iy
	lcall	$$fmtF32
	.extern	$$fmtF32
	.extern	$fmtF32 89
_fmtU16:
	pop	iy
	lcall	$$fmtU16
	.extern	$$fmtU16
	.extern	$fmtU16 89
	.seg	FARBSS
_applDTM::
	.ds	32
	.debug	G _applDTM 47 8
	.bseg
_ctlLoopTicks::
	.ds	2
	.debug	G _ctlLoopTicks 7 0
_lastCtlLoopTime::
	.ds	2
	.debug	G _lastCtlLoopTime 7 0
_lastReadTime::
	.ds	2
	.debug	G _lastReadTime 7 0
_readTicks::
	.ds	2
	.debug	G _readTicks 7 0
_writeTicks::
	.ds	2
	.debug	G _writeTicks 7 0
_rwTicks::
	.ds	2
	.debug	G _rwTicks 7 0
_ADC_Mask::
	.ds	4
	.debug	G _ADC_Mask 9 0
_DAC_Mask::
	.ds	4
	.debug	G _DAC_Mask 9 0
_stateDataBuf::
	.ds	4
	.debug	G _stateDataBuf 114 0
	.cseg
_EVENT_RestoredParamFile:
	pop	iy
	lcall	$$EVENT_RestoredParamFile
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 102
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 102
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 103
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 102
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 102
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 103
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
_readDefaults:
	pop	iy
	lcall	$$readDefaults
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
_setDefaults:
	pop	iy
	lcall	$$setDefaults
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
_applic:
	pop	iy
	lcall	$$applic
_tsh:
	pop	iy
	lcall	$$tsh
	.extern	$$tsh
	.extern	$tsh 88
_configd:
	pop	iy
	lcall	$$configd
	.extern	$$configd
	.extern	$configd 88
_fastdatad:
	pop	iy
	lcall	$$fastdatad
	.extern	$$fastdatad
	.extern	$fastdatad 88
_ReadSetCalibsRestore:
	pop	iy
	lcall	$$ReadSetCalibsRestore
_hostNameRestore:
	pop	iy
	lcall	$$hostNameRestore
	.bseg
_prevState::
	.ds	338
	.debug	G _prevState 169 0
_curState::
	.ds	338
	.debug	G _curState 169 0
_nextState::
	.ds	338
	.debug	G _nextState 169 0
_numLoggedChgMsgs::
	.ds	2
	.debug	G _numLoggedChgMsgs 7 0
_lastLoggableStateChg::
	.ds	2
	.debug	G _lastLoggableStateChg 7 0
_lastEnabledChgMsg::
	.ds	2
	.debug	G _lastEnabledChgMsg 7 0
_logStateChgMsgs::
	.ds	1
	.debug	G _logStateChgMsgs 3 0
_psOnTime::
	.ds	2
	.debug	G _psOnTime 7 0
_psOnAndReady::
	.ds	1
	.debug	G _psOnAndReady 3 0
_bridgeChgdTime::
	.ds	2
	.debug	G _bridgeChgdTime 7 0
_bridgeStateStable::
	.ds	1
	.debug	G _bridgeStateStable 3 0
_absErr::
	.ds	4
	.debug	G _absErr 10 0
_tempRegPol::
	.ds	1
	.debug	G _tempRegPol 3 0
_bridgeJustOff::
	.ds	1
	.debug	G _bridgeJustOff 3 0
_voltageLimited::
	.ds	1
	.debug	G _voltageLimited 3 0
_inductiveLoad::
	.ds	1
	.debug	G _inductiveLoad 3 0
_bulkSupErr::
	.ds	1
	.debug	G _bulkSupErr 3 0
_loadTypeWrong::
	.ds	1
	.debug	G _loadTypeWrong 3 0
_bridgeOffTime::
	.ds	4
	.debug	G _bridgeOffTime 9 0
_unstableStartTime::
	.ds	4
	.debug	G _unstableStartTime 9 0
_lastModeSetTime::
	.ds	4
	.debug	G _lastModeSetTime 9 0
_lastRegPolChgTime::
	.ds	4
	.debug	G _lastRegPolChgTime 9 0
_lastNotWaitingTime::
	.ds	4
	.debug	G _lastNotWaitingTime 9 0
_lastLoadTypeWarnTime::
	.ds	2
	.debug	G _lastLoadTypeWarnTime 7 0
_lastValLogTime::
	.ds	2
	.debug	G _lastValLogTime 7 0
_logInterval::
	.ds	2
	.debug	G _logInterval 7 0
_ramping::
	.ds	1
	.debug	G _ramping 3 0
_regulating::
	.ds	1
	.debug	G _regulating 3 0
_sinking::
	.ds	1
	.debug	G _sinking 3 0
_dumping::
	.ds	1
	.debug	G _dumping 3 0
_lowLoadCur::
	.ds	1
	.debug	G _lowLoadCur 3 0
_holecOK::
	.ds	1
	.debug	G _holecOK 3 0
_bulkCurClose::
	.ds	1
	.debug	G _bulkCurClose 3 0
_usePolarity::
	.ds	1
	.debug	G _usePolarity 3 0
_perSupCur::
	.ds	4
	.debug	G _perSupCur 10 0
_maxCurDiff::
	.ds	4
	.debug	G _maxCurDiff 10 0
_vlimAdjust::
	.ds	4
	.debug	G _vlimAdjust 10 0
_bulkCurDiff::
	.ds	4
	.debug	G _bulkCurDiff 10 0
_absBulkCurDiff::
	.ds	4
	.debug	G _absBulkCurDiff 10 0
_absAmpRead::
	.ds	4
	.debug	G _absAmpRead 10 0
_enabledMask::
	.ds	2
	.debug	G _enabledMask 7 0
_bulkShortStarted::
	.ds	20
	.debug	G _bulkShortStarted 46 0
_dummyFloat::
	.ds	4
	.debug	G _dummyFloat 10 0
	.cseg
_enabledMaskRestore:
	pop	iy
	lcall	$$enabledMaskRestore
_ampSetRestore:
	pop	iy
	lcall	$$ampSetRestore
	.bseg
_lastIdleMS:
	.ds	4
_lastIdleTime:
	.ds	2
_applBuf::
	.ds	256
	.debug	G _applBuf 170 0
_absBulkCur::
	.ds	4
	.debug	G _absBulkCur 10 0
_lcdBlink::
	.ds	1
	.debug	G _lcdBlink 3 0
	.cseg
_strF32:
	pop	iy
	lcall	$$strF32
_chgF32:
	pop	iy
	lcall	$$chgF32
_savF32:
	pop	iy
	lcall	$$savF32
_strU16:
	pop	iy
	lcall	$$strU16
_set_ampSet:
	pop	iy
	lcall	$$set_ampSet
_set_plim:
	pop	iy
	lcall	$$set_plim
_set_mlim:
	pop	iy
	lcall	$$set_mlim
_strCtlState:
	pop	iy
	lcall	$$strCtlState
_strOutMode:
	pop	iy
	lcall	$$strOutMode
_fetStr:
	pop	iy
	lcall	$$fetStr
_loadTypeStr:
	pop	iy
	lcall	$$loadTypeStr
_supTypeStr:
	pop	iy
	lcall	$$supTypeStr
_polStr:
	pop	iy
	lcall	$$polStr
_strHolec:
	pop	iy
	lcall	$$strHolec
_strIlk:
	pop	iy
	lcall	$$strIlk
_pageName:
	pop	iy
	lcall	$$pageName
_bitYN:
	pop	iy
	lcall	$$bitYN
_bitOB:
	pop	iy
	lcall	$$bitOB
_bitYN_:
	pop	iy
	lcall	$$bitYN_
_enaYN:
	pop	iy
	lcall	$$enaYN
_chgContr:
	pop	iy
	lcall	$$chgContr
_setContr:
	pop	iy
	lcall	$$setContr
_chgLTyp:
	pop	iy
	lcall	$$chgLTyp
_setLTyp:
	pop	iy
	lcall	$$setLTyp
_chgSTyp:
	pop	iy
	lcall	$$chgSTyp
_setSTyp:
	pop	iy
	lcall	$$setSTyp
_lcdUI:
	pop	iy
	lcall	$$lcdUI
_fmtState:
	pop	iy
	lcall	$$fmtState
_fmtMode:
	pop	iy
	lcall	$$fmtMode
_fmtFET:
	pop	iy
	lcall	$$fmtFET
_fmtPol:
	pop	iy
	lcall	$$fmtPol
_fmtSupType:
	pop	iy
	lcall	$$fmtSupType
_fmtLoadType:
	pop	iy
	lcall	$$fmtLoadType
_fmtEnabled:
	pop	iy
	lcall	$$fmtEnabled
_showState:
	pop	iy
	lcall	$$showState
_cmd:
	pop	iy
	lcall	$$cmd
	.bseg
_bitCounts::
	.ds	64
	.debug	G _bitCounts 171 0
	.debug	T	49000320000A00050001002300000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D0031000300056E616D6500AC0007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	AD0003210014000C000100AD0000000772656756616C0005000200
	.debug	T	077265674E756D0031000400056E616D6500AE0008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F636375726564006D0010000B
	.debug	T	6C61737443686756616C006D001200076D696E43686700
	.debug	T	0900012200140023000A00
	.debug	T	070000230002000300
	.debug	T	0900012400040025000200
	.debug	T	070000250002002000
	.debug	T	0900012600D80027006C00
	.debug	T	070000270002002100
	.debug	T	09000128006E0027003700
	.debug	T	09000129001D002A000100
	.debug	T	8A00032A001D0009000950565F446573635F00AF00000007707649
	.debug	T	6E666F0072000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F63637572656400B00015000A75706461746556616C00
	.debug	T	B2001700086C6F636B56616C00B40019000873656E6456616C
	.debug	T	00B4001B000772637656616C00
	.debug	T	0900012B000A0003000A00
	.debug	T	0900012C00060003000600
	.debug	T	1D00032D000600020001000900000005626175640006000400056D
	.debug	T	6F646500
	.debug	T	0900012E00140007000A00
	.debug	T	0900012F00200003002000
	.debug	T	0900013000000131004000
	.debug	T	070008310004000300
	.debug	T	0900013200100003001000
	.debug	T	0900013300800031002000
	.debug	T	09000134001A0003001A00
	.debug	T	0900013500030003000300
	.debug	T	0900013600480037000400
	.debug	T	820003370012000900010023000000087372764E616D6500070002
	.debug	T	0005706F727400030004000970726F746F636F6C00B6000500
	.debug	T	0970726F634D61696E0003000700097072696F726974790006
	.debug	T	000800066465766664006D000A000A636667506172616D7300
	.debug	T	06000C00086C6173744572720009000E000C6C617374457272
	.debug	T	54696D6500
	.debug	T	0900013800060023000300
	.debug	T	0900013900080023000400
	.debug	T	0900013A0030023B002300
	.debug	T	4900033B001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E007200060005646174610031000A
	.debug	T	00056E616D6500B7000E000B726573746F726556616C00
	.debug	T	0900013C0030003B000300
	.debug	T	0900013D0010003B000100
	.debug	T	7200033E003100080001002300000009626173654E616D65000300
	.debug	T	02000963617465676F727900B800030007706172616D7300B9
	.debug	T	0007000B7772697465436F756E74000600270003666400BA00
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	0900013F00060040000300
	.debug	T	070000400002003E00
	.debug	T	0900014100140042000A00
	.debug	T	070000420002000A00
	.debug	T	0900014300280009000A00
	.debug	T	1700024400040003006D000000030002006D00040006000600
	.debug	T	130002450003000100720000002300040007000600
	.debug	T	0B000246000100010001000000
	.debug	T	0B000247000100010003000000
	.debug	T	0B0002480001000100BC000000
	.debug	T	0B000249000100060001000000
	.debug	T	0B00024A000100070009000000
	.debug	T	1300024B0003002300BE0000007200040023000800
	.debug	T	1300024C0003000300BE000000720004000A000800
	.debug	T	0F00024D0002000100BE00000072000400
	.debug	T	0900014E00200031000800
	.debug	T	0900014F00010250001300
	.debug	T	87000350001B000B00094C4344456C656D5F000300000005747970
	.debug	T	65000300010004636F6C000300020004726F77000A00030008
	.debug	T	6368675261746500720007000476616C0006000B000876616C
	.debug	T	53697A650008000D00037031000800110003703200BF001500
	.debug	T	08666D7446756E6300C00017000863686746756E6300C10019
	.debug	T	000873657446756E6300
	.debug	T	31000351000E000400010031000000056E616D6500C20004000574
	.debug	T	65787400BE00060006656C656D7300BE000A000463757200
	.debug	T	0900015200CC0350002400
	.debug	T	09000153006C0050000400
	.debug	T	0900015400040031000100
	.debug	T	0900015500870050000500
	.debug	T	0F0002560002000100C300000006000400
	.debug	T	13000257000300010006000000C300020072000600
	.debug	T	0F000258000200010006000000C4000200
	.debug	T	0F0002590002002300C500000023000400
	.debug	T	0900015A00450403004504
	.debug	T	0900015B00E6025C003500
	.debug	T	5600035C000E0007000A44697370456C656D5F0003000000027800
	.debug	T	03000100027900720002000476616C00230006000661747472
	.debug	T	7300C600080008666D7446756E630006000A00067769647468
	.debug	T	0006000C00057072656300
	.debug	T	0900015D00CE015E002100
	.debug	T	4B00035E000E000700010003000000027800030001000279000900
	.debug	T	0200056D61736B002300060005737472300023000800066174
	.debug	T	7472300023000A0005737472310023000C0006617474723100
	.debug	T	0900015F009A005E000B00
	.debug	T	09000160000A0061000100
	.debug	T	53000361000A00060011646967466D74496E666F53747275637400
	.debug	T	04000000027800040002000279002300040005737472300003
	.debug	T	00060007626C696E6B30002300070005737472310003000900
	.debug	T	07626C696E6B3100
	.debug	T	0900016200080063000100
	.debug	T	3D000363000800040014616E616C6F67466D74496E666F53747275
	.debug	T	637400040000000278000400020002790004000400046C656E
	.debug	T	0004000600057072656300
	.debug	T	0B000264000100010007000000
	.debug	T	0B00026500010001000A000000
	.debug	T	0B0002660001000A0007000000
	.debug	T	130002670003000100070000004200020042000400
	.debug	T	0F00026800020023000700000023000200
	.debug	T	09000169001E006A000300
	.debug	T	2F00036A000A00030001003100000008636D644E616D6500B60004
	.debug	T	000970726F634D61696E003100060006646573637200
	.debug	T	0B00026B0001000900C7000000
	.debug	T	1300026C0003006D006D0000000600020007000400
	.debug	T	0700006D0002000100
	.debug	T	0F00026E00020006002300000023000200
	.debug	T	0B00026F000100060023000000
	.debug	T	130002700003002300230000002300020007000400
	.debug	T	130002710003007200720000007200040009000800
	.debug	T	070008720004000100
	.debug	T	130002730003007200720000000600040009000600
	.debug	T	0F00027400020001003100000031000400
	.debug	T	0B0002750001000B000B000000
	.debug	T	0B000276000100090001000000
	.debug	T	0F00027700020007000900000009000400
	.debug	T	1700027800040023000A000000060004000600060023000800
	.debug	T	0B000279000100010006000000
	.debug	T	0F00027A00020009002300000023000200
	.debug	T	1300027B000300010006000000BC00020006000400
	.debug	T	1300027C000300060006000000230002006D000400
	.debug	T	0900017D00000003000000
	.debug	T	0F00027E0002000600C700000006000200
	.debug	T	1300027F000300060006000000C7000200C7000400
	.debug	T	0B0002800001000600C7000000
	.debug	T	070000810002008200
	.debug	T	7702038200E8002D000C7461736B5F73747275637400C800000006
	.debug	T	737461636B00C80002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C687200C9000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465008100150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	00056172676300C4001A00056172677600CA001C0005617267
	.debug	T	7300CB009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C61677300B600B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74003100D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	070000830002008400
	.debug	T	54000384000C0006000100CC000000065F5F6F757400CE00020005
	.debug	T	5F5F696E00D0000400085F5F777269746500D0000600075F5F
	.debug	T	726561640006000800085F5F756E676574006D000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	13000285000300060083000000310002000D000000
	.debug	T	0F0002860002000600310000000D000000
	.debug	T	13000287000300060031000000310004000D000000
	.debug	T	0900018800080009000200
	.debug	T	0B000289000100060006000000
	.debug	T	0F00028A0002000B0023000000C4000200
	.debug	T	1300028B000300060023000000C400020006000400
	.debug	T	0900018C0000000A000000
	.debug	T	0900018D00000007000000
	.debug	T	0900018E0068000A001A00
	.debug	T	0900018F000C000A000300
	.debug	T	0900019000700291001A00
	.debug	T	0900019100180003001800
	.debug	T	0900019200480091000300
	.debug	T	0900019300000391002000
	.debug	T	0900019400800191001000
	.debug	T	0B000295000100010009000000
	.debug	T	130002960003000600230000000600020006000400
	.debug	T	130002970003000600060000006D00020006000400
	.debug	T	0B000298000100060083000000
	.debug	T	13000299000300060006000000060002006D000400
	.debug	T	2701039A00F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D6500D2001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900D30085000866696C6C65723200
	.debug	T	2300029B0007000600B60000000300020006000400C40006000600
	.debug	T	080006000A0006000C00
	.debug	T	0B00029C000100090009000000
	.debug	T	0F00029D00020006002300000006000200
	.debug	T	0900019E00200027001000
	.debug	T	1700029F000400230027000000AD0002000700040023000600
	.debug	T	170002A000040003006D000000030002000300040006000600
	.debug	T	090001A100020005000100
	.debug	T	090001A20000003B000000
	.debug	T	0F0002A300020006002300000007000200
	.debug	T	170002A4000400060023000000070002004000040003000600
	.debug	T	0F0002A500020001002300000007000200
	.debug	T	0B0002A6000100060040000000
	.debug	T	130002A70003000100C50000000300040023000600
	.debug	T	170002A8000400010009000000D40004000300080023000A00
	.debug	T	4B0103A900520118000100D500000003627300030018010A6F6E52
	.debug	T	65717565737400030019010B6F666652657175657374000300
	.debug	T	1A010D726573657452657175657374000A001B0107616D7053
	.debug	T	65740009001F010A6469676974616C496E00030023010C6578
	.debug	T	7465726E496E746C6B000300240107726567506F6C00030025
	.debug	T	010B68797374526567506F6C00030026010D726567506F6C53
	.debug	T	7461626C6500030027010B73696E6B4F7244756D7000070028
	.debug	T	010862746E426974730007002A01087073436F756E74000A00
	.debug	T	2C0106696664626B000A00300105766F7574000A0034010676
	.debug	T	6374726C000A00380108626A7442696173000A003C01056973
	.debug	T	6574000A0040010763746C4572720007004401086F75744D6F
	.debug	T	64650007004601067374617465000A00480109616D70417070
	.debug	T	6C790007004C0107706F6C436D640009004E010B6469676974
	.debug	T	616C4F757400
	.debug	T	090001AA00000103000001
	.debug	T	090001AB00400006002000
	.debug	T	070000AC000200A000
	.debug	T	070000AD0002000400
	.debug	T	070000AE0002004400
	.debug	T	520003AF000D000600010031000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	070000B0000200B100
	.debug	T	0B0002B10001000600D7000000
	.debug	T	070000B2000200B300
	.debug	T	130002B30003000600D70000000600020006000400
	.debug	T	070000B4000200B500
	.debug	T	170002B5000400060006000000070002006D000400D8000600
	.debug	T	070000B60002005800
	.debug	T	070000B70002004500
	.debug	T	070008B80004003B00
	.debug	T	090001B900200007001000
	.debug	T	070008BA000400BB00
	.debug	T	330003BB000A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	070000BC000200BD00
	.debug	T	3C0003BD001600040001000700000008646174614C656E006D0002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	32000600056461746100
	.debug	T	070008BE0004005000
	.debug	T	070000BF0002004B00
	.debug	T	070000C00002004C00
	.debug	T	070000C10002004D00
	.debug	T	070000C20002003100
	.debug	T	070008C30004005100
	.debug	T	070000C40002002300
	.debug	T	070008C50004005C00
	.debug	T	070000C60002005900
	.debug	T	070000C70002000900
	.debug	T	070000C80002000700
	.debug	T	070000C90002007200
	.debug	T	090001CA00800003008000
	.debug	T	280003CB0004000100125F5F776169745F71756575655F68656164
	.debug	T	00DA000000096C6973744865616400
	.debug	T	070000CC000200CD00
	.debug	T	0F0002CD0002000600030000006D000200
	.debug	T	070000CE000200CF00
	.debug	T	0B0002CF00010006006D000000
	.debug	T	070000D0000200D100
	.debug	T	130002D1000300080031000000080004006D000800
	.debug	T	090001D200500003005000
	.debug	T	090001D300740003007400
	.debug	T	070008D40004005E00
	.debug	T	090001D5001801D6000A00
	.debug	T	BB0003D6001C000D000100030000000569734F6E00030001000869
	.debug	T	73417661696C00030002000774656D704F4B000A0003000A62
	.debug	T	696173566F6C7473000A0007000863757272656E74000A000B
	.debug	T	0008637572446966660009000F000F6C61737454696D654269
	.debug	T	61734F4B00090013000E6C61737454696D654375724F4B0003
	.debug	T	00170008626961734572720003001800076375724572720003
	.debug	T	0019000973686F72744572720003001A0008656E61626C6564
	.debug	T	0003001B00067365744F6E00
	.debug	T	070000D70002002A00
	.debug	T	070000D8000200D900
	.debug	T	130002D900030006006D0000007200020007000600
	.debug	T	260003DA00040002000A6C6973745F6865616400DB000000056E65
	.debug	T	787400DB000200057072657600
	.debug	T	070000DB000200DA00
	.seg	CONST
@2:
	.db	"OFF  ",0,"WAIT ",0,"REG+ ",0,"REG- ",0,"SINK+",0,"SINK-",0,"RAMP+",0,"RAMP-",0,"DUMPG",0,"UNCAL",0,"console",0,"fastdatad",0,"modbusT"
	.db	"CPd",0,"tsh",0,"[-]",0,"OFF",0,"[+]",0,"INIT ",0,"ON   ",0,"INTLK",0,"???",0,"FET",0,"SCR",0,"??LOAD??",0,"INDUCTOR",0,"RESISTOR",0,"settings"
	.db	0,"devData",0,"hdwcfg",0,"16:39:04",0,"Fri Jan 11 2013",0,"     ",0,"OK ",0,"BAD",0,"OK   ",0,"FAULT",0,"Y",0,"N",0,"YES",0,"NO ",0,254,"1",1,254,"2"
	.db	0,0,0,1,"@",0,254,"X",254,"R",0,254,"1",2,254,"2",0,0,0,1,"@",0,"/dev/ttyx2",0,"/dev/ttyx3",0,254,":",20,20,254,"X",254,"R",0,254,"P",0,254,147,1,254,"9g",254,"P",128,254,147,0,0,"*",0,"_",0,27,"[34mYES"
	.db	0,27,"[31mNO ",0,34,0,31,0,"on",0,"off",0,"reset",0,"enable",0,"disable",0,"OUTSIDE OF",0,"RETURNED TO",0,"TOO LOW",0,"OK",0,"BE",0,"NO LONG"
	.db	"ER BE",0,"CLEARED",0,"ASSERTED",0,"POS",0,"NEG",0,"UN",0,"A",0,"V",0,"255.255.0.0",0,"192.168.0.1",0,"fifoEvents",0,"inetd",0,"config"
	.db	"d",0,"backupd",0,"ca_tcpd",0,"lcdUI",0
	.seg	FARCONST
@1:
	.db	"DoReboot",0,"dlmVersTime",0,"rtosVersTime",0,"applVersTime",0,"devType_",0,"deviceID_",0,"upSecs",0,"percentIdle_"
	.db	0,"numChans",0,"coilChanMult",0,"reg3ChanMult",0,"reg4ChanMult",0,"digInBits",0,"statusBitsStdA",0,"statusBitsS"
	.db	"tdB",0,"statusBitsAppl",0,"bsv_1",0,"bsv_2",0,"bsv_3",0,"bsv_4",0,"bsv_5",0,"bsv_6",0,"bsv_7",0,"bsv_8",0,"bsv_9",0,"bsv_10",0,"amps_"
	.db	"1",0,"amps_2",0,"amps_3",0,"amps_4",0,"amps_5",0,"amps_6",0,"amps_7",0,"amps_8",0,"amps_9",0,"amps_10",0,"ampRead",0,"voltRead",0,"vc"
	.db	"trl",0,"bjtBias",0,"state_1",0,"state_2",0,"state_3",0,"state_4",0,"state_5",0,"state_6",0,"state_7",0,"state_8",0,"state_9",0,"s"
	.db	"tate_10",0,"outMode",0,"ampApply",0,"psCount",0,"state",0,"iset",0,"ifdbk",0,"vout",0,"polCmd",0,"vctrlStatus",0,"ampErr",0,"ttlB"
	.db	"ulkCur",0,"unused2",0,"latency",0,"tcpTickTime",0,"applLoopTime",0,"kernelLoopTime",0,"loadRes",0,"dumpRes",0,"timeZo"
	.db	"ne_",0,"curTime",0,"ipAddr",0,"netmask",0,"gateway",0,"setACoil",0,"resetACoil",0,"digOutBits",0,"cmdBitsStd",0,"cmdBitsA"
	.db	"ppl",0,"ampSet",0,"vlimPlus",0,"vlimMinus",0,"rampRate",0,"vctrlHyst",0,"minPolStableTime",0,"unused1",0,"minBSVolts",0
	.db	"maxBSFracCurDiff",0,"vlimReduction",0,"sinkEndAmps",0,"unused3",0,"knobSelectRate",0,"maxAmpSet",0,"minPSonTi"
	.db	"me",0,"minBridgeOffTime",0,"unused4",0,"unused5",0,"maxErrTime",0,"contrast",0,"bulkShortCur",0,"supplyType",0,"loadT"
	.db	"ype",0,"debounceMS",0,"PS1 is OFF",0,"PS1 is ON",0,"PS5 NOT Avail",0,"PS5 Avail",0,"PS5 Temp BAD",0,"PS5 Temp OK",0
	.db	"PS10 is OFF",0,"PS10 is ON",0,"PS10 NOT Avail",0,"PS10 Avail",0,"PS10 Temp BAD",0,"PS10 Temp OK",0,"PS4 is OF"
	.db	"F",0,"PS4 is ON",0,"PS4 NOT Avail",0,"PS4 Avail",0,"PS4 Temp BAD",0,"PS4 Temp OK",0,"PS9 is OFF",0,"PS9 is ON",0,"PS9"
	.db	" NOT Avail",0,"PS9 Avail",0,"PS9 Temp BAD",0,"PS9 Temp OK",0,"PS3 is OFF",0,"PS3 is ON",0,"PS3 NOT Avail",0,"PS3 "
	.db	"Avail",0,"PS3 Temp BAD",0,"PS3 Temp OK",0,"PS8 is OFF",0,"PS8 is ON",0,"PS8 NOT Avail",0,"PS8 Avail",0,"PS8 Temp "
	.db	"BAD",0,"PS8 Temp OK",0,"PS2 is OFF",0,"PS2 is ON",0,"PS2 NOT Avail",0,"PS2 Avail",0,"PS2 Temp BAD",0,"PS2 Temp OK"
	.db	0,"PS7 is OFF",0,"PS7 is ON",0,"PS7 NOT Avail",0,"PS7 Avail",0,"PS7 Temp BAD",0,"PS7 Temp OK",0,"PS1 NOT Avail",0
	.db	"PS1 Avail",0,"PS1 Temp BAD",0,"PS1 Temp OK",0,"PS6 is OFF",0,"PS6 is ON",0,"PS6 NOT Avail",0,"PS6 Avail",0,"PS6 T"
	.db	"emp BAD",0,"PS6 Temp OK",0,"*** HOLEC BAD ***",0,"HOLEC OK",0,"*** External Interlock ***",0,"External In"
	.db	"terlock cleared",0,"Set PS10 OFF",0,"Set PS10 ON",0,"Set PS05 OFF",0,"Set PS05 ON",0,"Set PS09 OFF",0,"Set PS"
	.db	"09 ON",0,"Set PS04 OFF",0,"Set PS04 ON",0,"Set PS08 OFF",0,"Set PS08 ON",0,"Set PS03 OFF",0,"Set PS03 ON",0,"Set "
	.db	"PS07 OFF",0,"Set PS07 ON",0,"Set PS02 OFF",0,"Set PS02 ON",0,"Set PS06 OFF",0,"Set PS06 ON",0,"Set PS01 OFF",0,"S"
	.db	"et PS01 ON",0,"timeZone",0,"srfsIPAddr",0,"ainLabel",0,"aoutLabel",0,"dinLabel",0,"doutLabel",0,"readGain",0,"readOff"
	.db	"set",0,"setGain",0,"setOffset",0,"hostName",0,"srfsAltAddr",0,"extraInLabel",0,"enabledMask",0,"new timezone valu"
	.db	"e: %d",10,0,13,10,"===== Initial Digital Input states =====",13,10,0,"%ls",13,10,0,13,10,"===== Initial Digital Out"
	.db	"put states =====",13,10,0,"restore from param file: %.24s",10,0,"%s %s",0,"*** Saving ApplState ***",13,10,0,13
	.db	10,"*** Restored Application State ***",13,10,10,0,"AIN-%u",0,"AOUT-%u",0,"DIN-%u",0,"DOUT-%u",0,"ExtraIN-%u",0,"%*u",0,"n"
	.db	"ew value for %ls: %s",13,10,0,"SET:-####.##A  CUR:-####.##A   V:-##.###",0," ",0,"ISET:-###.##A   +LI"
	.db	"M:-##.###V   SFT: ###",0,"BJTB:-##.###V   -LIM:-##.###V   HDW: ###",0,"IFDK:-###.##A  VCTRL:-"
	.db	"##.###V      #####",0,"                LOAD:########  STYP: ###",0,"HOLEC: ###  EXTILK: #####"
	.db	"  #####  #PS:##",0,"MAIN",0,"    --Bias- --Cur--  On  Temp Avail Ena ",0,"  1.-##.### -###.##  #/"
	.db	"#  ###  ###  ### ",0,"  2.-##.### -###.##  #/#  ###  ###  ### ",0,"  3.-##.### -###.##  #/#  "
	.db	"###  ###  ### ",0,"  4.-##.### -###.##  #/#  ###  ###  ### ",0,"  5.-##.### -###.##  #/#  ###"
	.db	"  ###  ### ",0,"S1-5",0,"  6.-##.### -###.##  #/#  ###  ###  ### ",0,"  7.-##.### -###.##  #/#  #"
	.db	"##  ###  ### ",0,"  8.-##.### -###.##  #/#  ###  ###  ### ",0,"  9.-##.### -###.##  #/#  ### "
	.db	" ###  ### ",0," 10.-##.### -###.##  #/#  ###  ###  ### ",0,"S6-10",0,"Contrast: ### ",0,"Load Type: #"
	.db	"####### ",0,"Bridge Type: ### ",0,"CONFIG",0,"LIST",0,254,"G",1,"%c%.41ls",0,254,"G%c%c",0,"Unable to open port for LC"
	.db	"D",13,10,0,27,"[%02d;%02dH",0,"Usage:  cmd on|off|reset",13,10,"            enable|disable #",13,10,"           "
	.db	" set #.#",13,10,0,"ON request",10,0,"OFF request",10,0,"RESET request",10,0,"Enable Bulk Supply #%d",10,0,"Disable Bu"
	.db	"lk Supply #%d",10,0,"New Setpoint: %s",10,0,"Supply #%d current %s nominal range",10,"  Actual: %sA  N"
	.db	"ominal: %sA",10,0,"Supply #%d bias voltage %s",10,"  Actual: %sV  Min: %sV",10,0,"Supply #%d appears t"
	.db	"o %s SHORTED",10,"  Actual: %sA  Max: %sA or %sA",10,0,"Supply #%d temperature fault: %s",10,0,10,"START"
	.db	" btn pressed",10,0,10,"STOP btn pressed",10,0,10,"RESET intlk btn pressed",10,0,"***** loadType appears to "
	.db	"be set wrong ***",10,10,0,"--- Polarity and Mode change msgs temporarily disabled ---",10,0,"Regula"
	.db	"tion polarity changed to %s",10,0,"Regulation polarity %sSTABLE",10,0,"Polarity cmds: %s",10,0,"Output "
	.db	"Mode: %s",10,0,"Run state: %s",10,0,"Current state:",10,0,"  ampApply:%s   ampRead:%s   ttlBulkCur:%s",10," "
	.db	" bjtBias:%s   vctrl:%s   vout:%s   ",10,"  polCmd: %s   outMode: %s",10,10,0,"Must set supplyType "
	.db	"1st!",10,0,"Must set loadType 1st!",10,0,"Must clear Interlock first",10,10,0,"Already ON",10,10,0,"Turning ON",10,10,0
	.db	"Already OFF",10,10,0,"Turning OFF",10,10,0,"No Interlock to clear",10,10,0,"External Interlock still exists",10,10
	.db	0,"HOLEC still reads BAD",10,10,0,"Bulk supply error still exists",10,10,0,"Interlock cleared",10,10,0,"Setting"
	.db	" default labels for I/O signals",13,10,0,"SPARE0",0,"SPARE1",0,"bias%02u",0,"cur%02u",0,"IS_ON_%02u",0,"AVAIL_%02"
	.db	"u",0,"TEMPOK_%02u",0,"SET_ON_%02u",0,"HOLEC_OK",0,"NO_INTLK",0,"IFDBK",0,"VOUT",0,"VCTRL",0,"BJT_BIAS",0,"ISET",0,"VLIM_POS",0,"V"
	.db	"LIM_NEG",0,"unused",0,"Enable_Pol_Minus",0,"Enable_Pol_Plus",0,"Pol_Plus_LED",0,"Pol_Minus_LED",0,"ActivityLE"
	.db	"D",0,"Setting in-RAM device config to default values",13,10,0,"Application prepping for shutdown",13
	.db	10,0,"applic process started",13,10,0,"*** restoreApplState() failed (%d):  Doing CPU reset ***",13,10
	.db	0,13,10,"***** Network did not come up! *****",13,10,0,"free memory: %ld",13,10,0,"lcdui",0,"LCD user interface"
	.db	" daemon",0,"cmd",0,"Turn On/Off, Reset, enable/disable, etc",0,"Show state of controller",0
	.end
