	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
;1 //----- testAppl.c ----- 08/11/10 -----(03/05/06)----
;2 
;3 // Sections that typically require application-specific code are marked wit
;4 // the comment:  //APPLCODE
;5 
;6 //-------------------------------------------------------------------------
;7 //  Application specific code for the main application task that is run at
;8 //  a fixed interval and application specific commands run on demand.
;9 //
;10 //APPLCODE
;11 //  Application code to ...
;12 //-------------------------------------------------------------------------
;13 //
;14 //  2010-08-11 - Mark Davis
;15 //               - Created test "application" to use as a place to put code
;16 //                 that is only needed to test other modules (i.e. commands
;17 //                 that sever little or no purpose on real device controlle
;18 //                 and just take up space).
;19 //
;20 //  2009-12-14 - Mark Davis
;21 //               - Changed order of param files to deal with problems cause
;22 //                 by the order in which they were restored at startup.
;23 //
;24 //  2007-03-14 - Mark Davis -
;25 //               - added call to rwIO() (replaces "invisible" code in the
;26 //                 sharedAppl.c file that did this for all applications).
;27 //
;28 //  2007-03-04 - Mark Davis -
;29 //               - reworked X-Macro usage to allow application-specific
;30 //                 register definitions to reside in the same file as the
;31 //                 rest of the application-specific code.
;32 //
;33 //  2006-11-14 - Mark Davis -
;34 //               - original version started based on ps8rack code
;35 //
;36 //-------------------------------------------------------------------------
;37 /*
;38   Checklist for adding apaplication-specific functionality:
;39 
;40   Sections that application-specific code goes is generally marked with a
;41   comment line like this:
;42 
;43   //APPLCODE - ... descr of what to do ...
;44 
;45 
;46   Print this section out and remove it after all items completed and tested
;47 
;48   __ Write Software Requirements document
;49 
;50   __ Add summary of functionality and operational overview to top of source
;51      code file (just after the update log)
;52 
;53   __ Set applName[] and ApplAbbrev[] values near top of file
;54 
;55   __ Set NUM_APPL_AIN, _AOUT, _DIN, _DOUT values
;56 
;57   __ Define digital inputs/outputs:
;58        - #define name for each bit
;59        - LogicOrderXXX[] for the bits to group them in the most readable or
;60          in the ios command
;61        - DigXXXDescr[] 0 and 1 state description for each bit whose value
;62          changes we want logged
;63        - set InitialDigOutState value to specify state the digitalOut bits
;64          should be set to on startup
;65 
;66   __ Define analog inputs/outputs:
;67        - #define name for each signal used
;68        - LogicOrderXXX[] for the bits to group them in the most readable or
;69          in the ios command
;70 
;71   __ Define ApplState structure such that it contains all the data
;72      needed to define the current state of the device and the control logic
;73      The code uses 3 instances of this structure:  Prev, Cur, Next (see
;74      description below on how these are used)
;75 
;76   __ Add #defines for bit-mapped ApplState values
;77 
;78   __ Add COIL0(), REG3(), and REG4() macros to define global variables that
;79      need to be accessible via the ModBus interface.  Even if a value does
;80      not need to accessed by an external client, this is often the easiest
;81      way to define values that can be examined and changed at run time.
;82 
;83   __ Add #defines for bit-mapped register values
;84 
;85   __ Set default values for labels (short descirptions) for each of the
;86      digital and analog inputs and outputs used (in setDefaultLabels() func
;87 
;88   __ Set the DevStateStr[] text for showing the basic state of the controll
;89      (via the "state" command), and add entries to the xxxElems[] "tables" 
;90      manage basic formatting of digital and analog values.  Add code as nee
;91      to the showState() function to handle any formatting that the cannot b
;92      handled by the basic xxxElems[] table entries.
;93 
;94 
;95 This is a good point at which to test what you have done so far.  Compile t
;96 code and load it on a controller and make sure the state and ios commands
;97 show the right values and that the descriptions and labels agrees with the
;98 state of each input, that the correct messages are logged, etc.
;99 
;100 
;101   __ Add devDataParams[] for configuration values that need to be persisten
;102      (i.e. those that are configurable without changing the code and need t
;103      be restored at startup).  Values in this structure are saved as a grou
;104      to a file (on command) to the flash file system on the controller, and
;105      that file is automatically backed up to an external server.
;106 
;107   __ Add setingsParams[] for run-time values that may be frequently changed
;108      at run time and that we want to be restored on startup.  Changes to
;109      the values in this structure are automatically saved to the flash file
;110      system on occasion (the rate varies based on how often changes occur t
;111      minimize wear on the flash memory).  This file is NOT (currently) back
;112      up, but it probably will be in the future.
;113 
;114   __ Add any global variables needed to the SharedGlobals section.  Remembe
;115      that any global values accessed by multiple tasks will need to use som
;116      form of locking to avoid concurrency issues.
;117 
;118   __ Write MB_regName() functions for any values defined as ModBus register
;119      that require special handling when they receive a new value.  The usua
;120      functions for handling register value changes (e.g. setU16, setF32, et
;121      only insure that the value is locked before changing it.  If a new val
;122      requires ANYTHING else (e.g. a range check, or possibly comparing to
;123      or altering other values), then a custom function must be written to
;124      handle it (and don't forget to include locking for any global values
;125      referenced in the function - the usual methods being KLOCK()/KUNLOCK()
;126      or - for REALLY short pieces of code - _EnterCritical_()/_ExitCritical
;127 
;128   __ Write xxxRestore() functions for any "persistent" values that need
;129      special handling when they are restored from a file.  This can happen
;130      at run time if a controller has no copy of the file used to save the
;131      values or a backup version of a file is newer.  Again, don't forget to
;132      lock values against concurrent access as needed.
;133 
;134   __ For global values that may be changed by more than one task (e.g. the
;135      applic and the modbusTCPd tasks), it often makes the most sense to
;136      write a single function that can be called by any task to safely chang
;137      the value.  For register values, these functions would be called by
;138      the MB_regName() functions.
;139 
;140      Write functions as needed for such values and place them just before t
;141      updateCurState() function and add forward declarations near the top of
;142      the source file (to satisfy the need for prototypes in the MB_regName(
;143      functions).
;144 
;145   Much more details in the comments preceeding the following functions, but
;146   the basic idea is that the applic task runs every 10ms and calls the
;147   following functions:
;148     rwIO():
;149        - get current state of digital and analog input signals
;150        - update state of output signals using values computed in previous p
;151     updateCurState():
;152        - interpret the meaning of the latest values
;153     updateNextState():
;154        - decide what changes need to be made
;155     updateOutputState():
;156        - apply changes to values used to set output signals in rwIO()
;157     updateExternals():
;158        - update state of values accessed by other tasks (in particular, the
;159          values accessed via external clients through processes such as
;160          modbusTCPd)
;161 
;162   __ Add code as needed to implement the application login in updateCurStat
;163      updateNextState(), updateOutputState(), and updateExternals()
;164 
;165   __ Write "_task" functions as needed to implement applications-specific
;166      commands that can be executed from a login shell and add them to the
;167      applCmds[] table at the end of the source file.
;168 
;169      Many applications use a single "cmd" task and various parameters to
;170      handle most or all the application-specific commands.  Following this
;171      standard helps make controllers easier to use for everyone.
;172 
;173 */
;174 //-------------------------------------------------------------------------
;175 
;176 #include <common.h>
;177 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;178 #include <unistd.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;179 #include <sys/types.h>
;180 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;181 #include <semaphore.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
;182 #include <sys/time.h>
;183 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;184 
;185 //APPLCODE - change to match the name of this file
;186 #ifndef  ApplicSource
;187   #define  ApplicSource  "testAppl.c"
;188 #endif
;189 
;190 #ifndef DidRegDefs
;191   #define  DidRegDefs
;192   #include <modbusRegs.c>
	.debug	i 'C:\work\dev\Rabbit_ST\daemons\modbusRegs.c' 29 38 11 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.dseg
_DoReboot_CoilInfo::
	.dw	word _DoReboot
	.db	0
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word _setCoil
	.db	0x2
	.debug	G _DoReboot_CoilInfo 32 0
_dlmVersTime_RegInfo::
	.dw	word _dlmVersTime
	.dw	0
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dlmVersTime_ChgEventVal
	.dw	word _dlmVersTime_MinChg
	.debug	G _dlmVersTime_RegInfo 33 0
_rtosVersTime_RegInfo::
	.dw	word _rtosVersTime
	.dw	0x2
	.dw	word (phys @1+21)
	.dw	phys @1+21 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rtosVersTime_ChgEventVal
	.dw	word _rtosVersTime_MinChg
	.debug	G _rtosVersTime_RegInfo 33 0
_applVersTime_RegInfo::
	.dw	word _applVersTime
	.dw	0x4
	.dw	word (phys @1+34)
	.dw	phys @1+34 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applVersTime_ChgEventVal
	.dw	word _applVersTime_MinChg
	.debug	G _applVersTime_RegInfo 33 0
_devType__RegInfo::
	.dw	word _devType_
	.dw	0x6
	.dw	word (phys @1+47)
	.dw	phys @1+47 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _devType__ChgEventVal
	.dw	word _devType__MinChg
	.debug	G _devType__RegInfo 33 0
_deviceID__RegInfo::
	.dw	word _deviceID_
	.dw	0x7
	.dw	word (phys @1+56)
	.dw	phys @1+56 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _deviceID__ChgEventVal
	.dw	word _deviceID__MinChg
	.debug	G _deviceID__RegInfo 33 0
_upSecs_RegInfo::
	.dw	word _upSecs
	.dw	0x9
	.dw	word (phys @1+66)
	.dw	phys @1+66 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _upSecs_ChgEventVal
	.dw	word _upSecs_MinChg
	.debug	G _upSecs_RegInfo 33 0
_percentIdle__RegInfo::
	.dw	word _percentIdle_
	.dw	0xb
	.dw	word (phys @1+73)
	.dw	phys @1+73 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentIdle__ChgEventVal
	.dw	word _percentIdle__MinChg
	.debug	G _percentIdle__RegInfo 33 0
_numChans_RegInfo::
	.dw	word _numChans
	.dw	0xc
	.dw	word (phys @1+86)
	.dw	phys @1+86 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _numChans_ChgEventVal
	.dw	word _numChans_MinChg
	.debug	G _numChans_RegInfo 33 0
_coilChanMult_RegInfo::
	.dw	word _coilChanMult
	.dw	0xd
	.dw	word (phys @1+95)
	.dw	phys @1+95 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _coilChanMult_ChgEventVal
	.dw	word _coilChanMult_MinChg
	.debug	G _coilChanMult_RegInfo 33 0
_reg3ChanMult_RegInfo::
	.dw	word _reg3ChanMult
	.dw	0xe
	.dw	word (phys @1+108)
	.dw	phys @1+108 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg3ChanMult_ChgEventVal
	.dw	word _reg3ChanMult_MinChg
	.debug	G _reg3ChanMult_RegInfo 33 0
_reg4ChanMult_RegInfo::
	.dw	word _reg4ChanMult
	.dw	0xf
	.dw	word (phys @1+121)
	.dw	phys @1+121 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg4ChanMult_ChgEventVal
	.dw	word _reg4ChanMult_MinChg
	.debug	G _reg4ChanMult_RegInfo 33 0
_digInBits_RegInfo::
	.dw	word _digInBits
	.dw	0x10
	.dw	word (phys @1+134)
	.dw	phys @1+134 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _digInBits_ChgEventVal
	.dw	word _digInBits_MinChg
	.debug	G _digInBits_RegInfo 33 0
_statusBitsStdA_RegInfo::
	.dw	word _statusBitsStdA
	.dw	0x12
	.dw	word (phys @1+144)
	.dw	phys @1+144 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdA_ChgEventVal
	.dw	word _statusBitsStdA_MinChg
	.debug	G _statusBitsStdA_RegInfo 33 0
_statusBitsStdB_RegInfo::
	.dw	word _statusBitsStdB
	.dw	0x13
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdB_ChgEventVal
	.dw	word _statusBitsStdB_MinChg
	.debug	G _statusBitsStdB_RegInfo 33 0
_statusBitsAppl_RegInfo::
	.dw	word _statusBitsAppl
	.dw	0x14
	.dw	word (phys @1+174)
	.dw	phys @1+174 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAppl_ChgEventVal
	.dw	word _statusBitsAppl_MinChg
	.debug	G _statusBitsAppl_RegInfo 33 0
_latency_RegInfo::
	.dw	word _latency
	.dw	0x16
	.dw	word (phys @1+189)
	.dw	phys @1+189 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _latency_ChgEventVal
	.dw	word _latency_MinChg
	.debug	G _latency_RegInfo 33 0
_tcpTickTime_RegInfo::
	.dw	word _tcpTickTime
	.dw	0x17
	.dw	word (phys @1+197)
	.dw	phys @1+197 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _tcpTickTime_ChgEventVal
	.dw	word _tcpTickTime_MinChg
	.debug	G _tcpTickTime_RegInfo 33 0
_applLoopTime_RegInfo::
	.dw	word _applLoopTime
	.dw	0x18
	.dw	word (phys @1+209)
	.dw	phys @1+209 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applLoopTime_ChgEventVal
	.dw	word _applLoopTime_MinChg
	.debug	G _applLoopTime_RegInfo 33 0
_kernelLoopTime_RegInfo::
	.dw	word _kernelLoopTime
	.dw	0x19
	.dw	word (phys @1+222)
	.dw	phys @1+222 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _kernelLoopTime_ChgEventVal
	.dw	word _kernelLoopTime_MinChg
	.debug	G _kernelLoopTime_RegInfo 33 0
_rdg_1_RegInfo::
	.dw	word _rdg_1
	.dw	0x1a
	.dw	word (phys @1+237)
	.dw	phys @1+237 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_1_ChgEventVal
	.dw	word _rdg_1_MinChg
	.debug	G _rdg_1_RegInfo 33 0
_rdg_2_RegInfo::
	.dw	word _rdg_2
	.dw	0x1c
	.dw	word (phys @1+243)
	.dw	phys @1+243 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_2_ChgEventVal
	.dw	word _rdg_2_MinChg
	.debug	G _rdg_2_RegInfo 33 0
_rdg_3_RegInfo::
	.dw	word _rdg_3
	.dw	0x1e
	.dw	word (phys @1+249)
	.dw	phys @1+249 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_3_ChgEventVal
	.dw	word _rdg_3_MinChg
	.debug	G _rdg_3_RegInfo 33 0
_rdg_4_RegInfo::
	.dw	word _rdg_4
	.dw	0x20
	.dw	word (phys @1+255)
	.dw	phys @1+255 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_4_ChgEventVal
	.dw	word _rdg_4_MinChg
	.debug	G _rdg_4_RegInfo 33 0
_rdg_5_RegInfo::
	.dw	word _rdg_5
	.dw	0x22
	.dw	word (phys @1+261)
	.dw	phys @1+261 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_5_ChgEventVal
	.dw	word _rdg_5_MinChg
	.debug	G _rdg_5_RegInfo 33 0
_rdg_6_RegInfo::
	.dw	word _rdg_6
	.dw	0x24
	.dw	word (phys @1+267)
	.dw	phys @1+267 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_6_ChgEventVal
	.dw	word _rdg_6_MinChg
	.debug	G _rdg_6_RegInfo 33 0
_rdg_7_RegInfo::
	.dw	word _rdg_7
	.dw	0x26
	.dw	word (phys @1+273)
	.dw	phys @1+273 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_7_ChgEventVal
	.dw	word _rdg_7_MinChg
	.debug	G _rdg_7_RegInfo 33 0
_rdg_8_RegInfo::
	.dw	word _rdg_8
	.dw	0x28
	.dw	word (phys @1+279)
	.dw	phys @1+279 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rdg_8_ChgEventVal
	.dw	word _rdg_8_MinChg
	.debug	G _rdg_8_RegInfo 33 0
_timeZone__RegInfo::
	.dw	word _timeZone_
	.dw	0
	.dw	word (phys @1+285)
	.dw	phys @1+285 >> 16
	.dw	word _MB_timeZone
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _timeZone__ChgEventVal
	.dw	word _timeZone__MinChg
	.debug	G _timeZone__RegInfo 33 0
_curTime_RegInfo::
	.dw	word _curTime
	.dw	0x1
	.dw	word (phys @1+295)
	.dw	phys @1+295 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _curTime_ChgEventVal
	.dw	word _curTime_MinChg
	.debug	G _curTime_RegInfo 33 0
_ipAddr_RegInfo::
	.dw	word _ipAddr
	.dw	0x3
	.dw	word (phys @1+303)
	.dw	phys @1+303 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ipAddr_ChgEventVal
	.dw	word _ipAddr_MinChg
	.debug	G _ipAddr_RegInfo 33 0
_netmask_RegInfo::
	.dw	word _netmask
	.dw	0x5
	.dw	word (phys @1+310)
	.dw	phys @1+310 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _netmask_ChgEventVal
	.dw	word _netmask_MinChg
	.debug	G _netmask_RegInfo 33 0
_gateway_RegInfo::
	.dw	word _gateway
	.dw	0x7
	.dw	word (phys @1+318)
	.dw	phys @1+318 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _gateway_ChgEventVal
	.dw	word _gateway_MinChg
	.debug	G _gateway_RegInfo 33 0
_setACoil_RegInfo::
	.dw	word _setACoil
	.dw	0x9
	.dw	word (phys @1+326)
	.dw	phys @1+326 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _setACoil_ChgEventVal
	.dw	word _setACoil_MinChg
	.debug	G _setACoil_RegInfo 33 0
_resetACoil_RegInfo::
	.dw	word _resetACoil
	.dw	0xa
	.dw	word (phys @1+335)
	.dw	phys @1+335 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _resetACoil_ChgEventVal
	.dw	word _resetACoil_MinChg
	.debug	G _resetACoil_RegInfo 33 0
_digOutBits_RegInfo::
	.dw	word _digOutBits
	.dw	0xb
	.dw	word (phys @1+346)
	.dw	phys @1+346 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _digOutBits_ChgEventVal
	.dw	word _digOutBits_MinChg
	.debug	G _digOutBits_RegInfo 33 0
_cmdBitsStd_RegInfo::
	.dw	word _cmdBitsStd
	.dw	0xd
	.dw	word (phys @1+357)
	.dw	phys @1+357 >> 16
	.dw	word _MB_cmdBitsStd
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsStd_ChgEventVal
	.dw	word _cmdBitsStd_MinChg
	.debug	G _cmdBitsStd_RegInfo 33 0
_cmdBitsAppl_RegInfo::
	.dw	word _cmdBitsAppl
	.dw	0xf
	.dw	word (phys @1+368)
	.dw	phys @1+368 >> 16
	.dw	word _MB_cmdBitsAppl
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl_ChgEventVal
	.dw	word _cmdBitsAppl_MinChg
	.debug	G _cmdBitsAppl_RegInfo 33 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
_c0Coils::
	.dw	word _DoReboot_CoilInfo
	.dw	0
	.debug	G _c0Coils 34 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
_r3Regs::
	.dw	word _dlmVersTime_RegInfo
	.dw	word _dlmVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _devType__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _percentIdle__RegInfo
	.dw	word _numChans_RegInfo
	.dw	word _coilChanMult_RegInfo
	.dw	word _reg3ChanMult_RegInfo
	.dw	word _reg4ChanMult_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _statusBitsStdA_RegInfo
	.dw	word _statusBitsStdB_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _latency_RegInfo
	.dw	word _tcpTickTime_RegInfo
	.dw	word _applLoopTime_RegInfo
	.dw	word _kernelLoopTime_RegInfo
	.dw	word _rdg_1_RegInfo
	.dw	word _rdg_1_RegInfo
	.dw	word _rdg_2_RegInfo
	.dw	word _rdg_2_RegInfo
	.dw	word _rdg_3_RegInfo
	.dw	word _rdg_3_RegInfo
	.dw	word _rdg_4_RegInfo
	.dw	word _rdg_4_RegInfo
	.dw	word _rdg_5_RegInfo
	.dw	word _rdg_5_RegInfo
	.dw	word _rdg_6_RegInfo
	.dw	word _rdg_6_RegInfo
	.dw	word _rdg_7_RegInfo
	.dw	word _rdg_7_RegInfo
	.dw	word _rdg_8_RegInfo
	.dw	word _rdg_8_RegInfo
	.dw	0
	.debug	G _r3Regs 36 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
_r4Regs::
	.dw	word _timeZone__RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _setACoil_RegInfo
	.dw	word _resetACoil_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	0
	.debug	G _r4Regs 38 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
_nonRegPVs::
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
	.db	0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.debug	G _nonRegPVs 39 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\test\testAppl.c' 7 18 10 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
;193 #endif
;194 #ifndef RegDefs
;195 
;196 
;197 //APPLCODE - change to the application name
;198 const char far applName[] = { "Test" };
	.defseg	FARCONST
	.seg	FARCONST
_applName::
	.db	"Test",0
	.debug	G _applName 41 8
;199 const char ApplAbbrev[] = { "Test" };
	.defseg	CONST
	.seg	CONST
_ApplAbbrev::
	.db	"Test",0
	.debug	G _ApplAbbrev 41 0
;200 
;201 
;202 //APPLCODE - add ID to unistd.h and place it here
;203 #define DeviceType  DT_Test
;204 
;205 //APPLCODE - set the # of input and outputs used
;206 #define  NUM_APPL_AIN      8   // analog inputs
;207 #define  NUM_APPL_AOUT     4   // analog outputs
;208 #define  NUM_APPL_DIN     16   // digital inputs
;209 #define  NUM_APPL_DOUT    16   // digital outputs
;210 
;211 #define  ADC_MASK_APPL  0x000000FFL
;212 #define  DAC_MASK_APPL  0x0000000FL
;213 
;214 #define SharedINC
;215 #include <sharedAppl.c>
;216 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.dseg
_consCfg::
	.dw	0xffffc200, 0x1
	.dw	0x1
	.debug	G _consCfg 42 0
	.seg	CONST
_NumApplAIN::
	.dw	0x8
	.debug	G _NumApplAIN 7 0
_NumApplAOUT::
	.dw	0x4
	.debug	G _NumApplAOUT 7 0
_NumApplDIN::
	.dw	0x10
	.debug	G _NumApplDIN 7 0
_NumApplDOUT::
	.dw	0x10
	.debug	G _NumApplDOUT 7 0
_NumExtraIn::
	.dw	0x20
	.debug	G _NumExtraIn 7 0
;217 
;218 
;219 //=========================================================================
;220 //  definitions related to use of the Digital and Analog I/O signals
;221 //=========================================================================
;222 
;223 //APPLCODE - define macros for each Digital bit and each Analog index
;224 
;225 //=============== digitalIn bit usage ===============
;226 /*EXAMPLE:
;227 #define  CLOSED_LOOP     0x00000001  // 00: 0=Open Loop, 1=Closed Loop
;228 #define  FINAL_BTN       0x00000002  // 01: 1=SET button being pushed
;229 #define  INITIAL_BTN     0x00000004  // 02: 1=INITIAL button being pushed
;230 #define  RF_IS_OFF       0x00000008  // 03: 1=RF is OFF, 0=RF is ON
;231 #define  LOC_REM_SW      0x00000010  // 04: 1=Local, 0=Remote
;232 */
;233 
;234 const uchar  LogicOrderDIn[NUM_APPL_DIN] =  {
;235    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
_LogicOrderDIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0xc
	.db	0xd
	.db	0xe
	.db	0xf
	.debug	G _LogicOrderDIn 43 0
;236 
;237 /*EXAMPLE:
;238 #define  ClosedLoop(din)        ( (bool)((din) & CLOSED_LOOP) )
;239 #define  FinalBtnPushed(din)    ( (bool)((din) & FINAL_BTN) )
;240 #define  InitialBtnPushed(din)  ( (bool)((din) & INITIAL_BTN) )
;241 #define  RFisOff(din)           ( (bool)((din) & RF_IS_OFF) )
;242 #define  LocalMode(din)         ( (bool)((din) & LOC_REM_SW) )
;243 */
;244 
;245 
;246 //--- msgs to log automatically when a digital input changes state ---
;247 //--- use NULL for bits that we don't want to log changes for ---
;248 const char far *digInDescr[NUM_APPL_DIN*2] = {
;249 //--0 state descr--    --1 state descr--
;250   "DI-00 now 0",       "DI-00 now 1",
	.dseg
_digInDescr::
	.dw	word (phys @1+380)
	.dw	phys @1+380 >> 16
	.dw	word (phys @1+392)
	.dw	phys @1+392 >> 16
;251   "DI-01 now 0",       "DI-01 now 1",
	.dw	word (phys @1+404)
	.dw	phys @1+404 >> 16
	.dw	word (phys @1+416)
	.dw	phys @1+416 >> 16
;252   "DI-02 now 0",       "DI-02 now 1",
	.dw	word (phys @1+428)
	.dw	phys @1+428 >> 16
	.dw	word (phys @1+440)
	.dw	phys @1+440 >> 16
;253   "DI-03 now 0",       "DI-03 now 1",
	.dw	word (phys @1+452)
	.dw	phys @1+452 >> 16
	.dw	word (phys @1+464)
	.dw	phys @1+464 >> 16
;254   "DI-04 now 0",       "DI-04 now 1",
	.dw	word (phys @1+476)
	.dw	phys @1+476 >> 16
	.dw	word (phys @1+488)
	.dw	phys @1+488 >> 16
;255   "DI-05 now 0",       "DI-05 now 1",
	.dw	word (phys @1+500)
	.dw	phys @1+500 >> 16
	.dw	word (phys @1+512)
	.dw	phys @1+512 >> 16
;256   "DI-06 now 0",       "DI-06 now 1",
	.dw	word (phys @1+524)
	.dw	phys @1+524 >> 16
	.dw	word (phys @1+536)
	.dw	phys @1+536 >> 16
;257   "DI-07 now 0",       "DI-07 now 1",
	.dw	word (phys @1+548)
	.dw	phys @1+548 >> 16
	.dw	word (phys @1+560)
	.dw	phys @1+560 >> 16
;258   "DI-08 now 0",       "DI-08 now 1",
	.dw	word (phys @1+572)
	.dw	phys @1+572 >> 16
	.dw	word (phys @1+584)
	.dw	phys @1+584 >> 16
;259   "DI-09 now 0",       "DI-09 now 1",
	.dw	word (phys @1+596)
	.dw	phys @1+596 >> 16
	.dw	word (phys @1+608)
	.dw	phys @1+608 >> 16
;260   "DI-10 now 0",       "DI-10 now 1",
	.dw	word (phys @1+620)
	.dw	phys @1+620 >> 16
	.dw	word (phys @1+632)
	.dw	phys @1+632 >> 16
;261   "DI-11 now 0",       "DI-11 now 1",
	.dw	word (phys @1+644)
	.dw	phys @1+644 >> 16
	.dw	word (phys @1+656)
	.dw	phys @1+656 >> 16
;262   "DI-12 now 0",       "DI-12 now 1",
	.dw	word (phys @1+668)
	.dw	phys @1+668 >> 16
	.dw	word (phys @1+680)
	.dw	phys @1+680 >> 16
;263   "DI-13 now 0",       "DI-13 now 1",
	.dw	word (phys @1+692)
	.dw	phys @1+692 >> 16
	.dw	word (phys @1+704)
	.dw	phys @1+704 >> 16
;264   "DI-14 now 0",       "DI-14 now 1",
	.dw	word (phys @1+716)
	.dw	phys @1+716 >> 16
	.dw	word (phys @1+728)
	.dw	phys @1+728 >> 16
;265   "DI-15 now 0",       "DI-15 now 1"
	.dw	word (phys @1+740)
	.dw	phys @1+740 >> 16
;266 };
	.dw	word (phys @1+752)
	.dw	phys @1+752 >> 16
	.debug	G _digInDescr 44 0
;267 
;268 
;269 //=============== digitalOut bit usage ===============
;270 /*EXAMPLE:
;271 #define  LIMITED_LED     0x00000001   // 00: 1=On, 0=Off
;272 #define  ERROR_LED       0x00000002   // 01: 1=On, 0=Off
;273 #define  LED_BITS        0x00000003   // 02: bits for all LEDs
;274 */
;275 
;276 #define  ActivityLED     0x00000100L
;277 
;278 const uchar  LogicOrderDOut[NUM_APPL_DOUT] =  {
;279    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
	.seg	CONST
_LogicOrderDOut::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0xc
	.db	0xd
	.db	0xe
	.db	0xf
	.debug	G _LogicOrderDOut 43 0
;280 
;281 //APPLCODE - set to state we want outputs in during initialization
;282 #define InitialDigOutState  ( 0 )
;283 
;284 
;285 #define  TurnOnActivityLED()    ClearBits(Next.digitalOut, ActivityLED)
;286 #define  TurnOffActivityLED()   SetBits(Next.digitalOut, ActivityLED)
;287 
;288 //--- msgs to log automatically when a digital output changes state ---
;289 //--- use NULL for bits that we don't want to log changes for ---
;290 const char far *digOutDescr[NUM_APPL_DOUT*2] = {
;291 //--0 state descr--    --1 state descr--
;292   "DO-00 now 0",       "DO-00 now 1",
	.dseg
_digOutDescr::
	.dw	word (phys @1+764)
	.dw	phys @1+764 >> 16
	.dw	word (phys @1+776)
	.dw	phys @1+776 >> 16
;293   "DO-01 now 0",       "DO-01 now 1",
	.dw	word (phys @1+788)
	.dw	phys @1+788 >> 16
	.dw	word (phys @1+800)
	.dw	phys @1+800 >> 16
;294   "DO-02 now 0",       "DO-02 now 1",
	.dw	word (phys @1+812)
	.dw	phys @1+812 >> 16
	.dw	word (phys @1+824)
	.dw	phys @1+824 >> 16
;295   "DO-03 now 0",       "DO-03 now 1",
	.dw	word (phys @1+836)
	.dw	phys @1+836 >> 16
	.dw	word (phys @1+848)
	.dw	phys @1+848 >> 16
;296   "DO-04 now 0",       "DO-04 now 1",
	.dw	word (phys @1+860)
	.dw	phys @1+860 >> 16
	.dw	word (phys @1+872)
	.dw	phys @1+872 >> 16
;297   "DO-05 now 0",       "DO-05 now 1",
	.dw	word (phys @1+884)
	.dw	phys @1+884 >> 16
	.dw	word (phys @1+896)
	.dw	phys @1+896 >> 16
;298   "DO-06 now 0",       "DO-06 now 1",
	.dw	word (phys @1+908)
	.dw	phys @1+908 >> 16
	.dw	word (phys @1+920)
	.dw	phys @1+920 >> 16
;299   "DO-07 now 0",       "DO-07 now 1",
	.dw	word (phys @1+932)
	.dw	phys @1+932 >> 16
	.dw	word (phys @1+944)
	.dw	phys @1+944 >> 16
;300    NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;301   "DO-09 now 0",       "DO-09 now 1",
	.dw	word (phys @1+956)
	.dw	phys @1+956 >> 16
	.dw	word (phys @1+968)
	.dw	phys @1+968 >> 16
;302   "DO-10 now 0",       "DO-10 now 1",
	.dw	word (phys @1+980)
	.dw	phys @1+980 >> 16
	.dw	word (phys @1+992)
	.dw	phys @1+992 >> 16
;303   "DO-11 now 0",       "DO-11 now 1",
	.dw	word (phys @1+1004)
	.dw	phys @1+1004 >> 16
	.dw	word (phys @1+1016)
	.dw	phys @1+1016 >> 16
;304   "DO-12 now 0",       "DO-12 now 1",
	.dw	word (phys @1+1028)
	.dw	phys @1+1028 >> 16
	.dw	word (phys @1+1040)
	.dw	phys @1+1040 >> 16
;305   "DO-13 now 0",       "DO-13 now 1",
	.dw	word (phys @1+1052)
	.dw	phys @1+1052 >> 16
	.dw	word (phys @1+1064)
	.dw	phys @1+1064 >> 16
;306   "DO-14 now 0",       "DO-14 now 1",
	.dw	word (phys @1+1076)
	.dw	phys @1+1076 >> 16
	.dw	word (phys @1+1088)
	.dw	phys @1+1088 >> 16
;307   "DO-15 now 0",       "DO-15 now 1"
	.dw	word (phys @1+1100)
	.dw	phys @1+1100 >> 16
;308 };
	.dw	word (phys @1+1112)
	.dw	phys @1+1112 >> 16
	.debug	G _digOutDescr 44 0
;309 
;310 
;311 
;312 
;313 //=============== Analog inputs ===============
;314 //--- indexes for anaIn[] and readVal[] ---
;315 /*EXAMPLE:
;316 #define  RF_CAV_VOLT      0  // RF cavity voltage
;317 #define  LIMITER_VOLT     1  // Setpoint Limiter voltage
;318 #define  HDW_CFG          2  // Fixed volt indicating HD1 component set
;319 */
;320 
;321 const uchar  LogicOrderAIn[NUM_APPL_AIN] = { 0, 1, 2, 3, 4, 5, 6, 7 };
	.seg	CONST
_LogicOrderAIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.debug	G _LogicOrderAIn 46 0
;322 
;323 
;324 //=============== Anlog outputs ===============
;325 //--- indexes for anaOut[] and setVal[] ---
;326 /*EXAMPLE:
;327 #define  SETPOINT         0  // Setpoint for Cav Voltage Regulator circuit
;328 #define  FP_METER         1  // FrontPanel Meter if INITIAL or SET pressed
;329 */
;330 
;331 const uchar  LogicOrderAOut[NUM_APPL_AOUT] = { 0, 1, 2, 3 };
_LogicOrderAOut::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.debug	G _LogicOrderAOut 47 0
;332 
;333 
;334 //=========================================================================
;335 //  Application-specific data structures and definitions
;336 //=========================================================================
;337 
;338 // Each value in the ApplState structure should be throught of as represent
;339 // a "signal" in a clocked logic circuit, with the "applic" task representi
;340 // the logic implemented by the circuit elements such as gates, latches, et
;341 
;342 // The main "applic" task is the highest priority task and executes the cod
;343 // that implements the application logic on a real-time, periodic basis.
;344 
;345 //                 ====== IMPORTANT NOTE on LOCKING ======
;346 // Remember to use a semaphore or some other form of locking mechanism to
;347 // protect all access to shared values by more than one task.  The only
;348 // exception to this is when the applic task needs to access a value protec
;349 // by other tasks using only a scheduler/kernel lock (the KLOCK and KUNLOCK
;350 // macros).  Because the applic task is the only task that runs at the high
;351 // priority, no other task can preempt it, and if the scheduler is locked,
;352 // the applic task cannot preempt another task.  But scheduler locks must b
;353 // kept short to avoid creating large latency in the timely execution of ot
;354 // tasks (the applic task in particular).
;355 
;356 typedef struct {
;357  //-----------------------------------------------------------------------
;358  // SOFTWARE SETTING INPUTS
;359  //
;360  //  These values represent Software Inputs to the application logic.
;361  //
;362  //  These values are set in the "Next" instance by tasks OTHER than the
;363  //  "applic" task to change some value used by the application logic.
;364  //  Remember that all tasks besides the main "applic" task must use a
;365  //  scheduler lock to protect reads and writes to these values.
;366  //
;367  //  Note that the application task may alter these values (e.g. to change
;368  //  an invalid value in to a valid one).
;369  //-----------------------------------------------------------------------
;370 //  bool   onRequest;
;371 //  bool   offRequest;
;372 //  bool   resetRequest;
;373 
;374 //  float  ampSet;      // most recent setpoint
;375 
;376 
;377  //-----------------------------------------------------------------------
;378  // READINGS
;379  //
;380  //  These values represent "passive" inputs to the application logic.
;381  //
;382  //  These values are set in the "Next" instance of ApplState by the applic
;383  //  task just after reading the state of the hardware inputs.
;384  //
;385  //  These values generally come from one of two sources:
;386  //    - The just-read state of analog and/or digital hardware inputs
;387  //    - Values maintained by other tasks
;388  //
;389  //  While some of these values are simply copies of "external" values,
;390  //  including them in the ApplState structure allows us to see how
;391  //  they change between cycles.  Also, some of these values are the result
;392  //  of applying logic to "external" values.  Applying that logic once at
;393  //  at the beginning of the applic loop and saving the result eliminates
;394  //  the need to repeat the same logic in multiple blocks of code later on,
;395  //  avoiding unnecessary redundancy.
;396  //-----------------------------------------------------------------------
;397 //--- values updated in "cur" instance at start of each pass ---
;398   ulong  processTime;     // time (in ms) when processing was started
;399 //  bool   rfIsOn;
;400   ulong  digitalIn;       // state of digital inputs
;401 
;402 
;403  //-----------------------------------------------------------------------
;404  // OUTPUTS from UN-CLOCKED (asynchronous, gate-level) LOGIC ELEMENTS
;405  //
;406  //  These values are outputs from one of the blocks of code in the applic
;407  //  task that represent a non-clocked logic element (such as a gate).
;408  //
;409  //  Each value here is set by one (and ONLY one) of the blocks of code in
;410  //  the applic task.  This group contains ONLY values that are set by a
;411  //  block of code that represents a NON-clocked logic element.
;412  //
;413  //  These values are set in the "Next" instance of ApplState by the applic
;414  //  task just after reading the state of the hardware inputs.  These value
;415  //  must  NOT be altered by other tasks (although they can read them as lo
;416  //  as they use appropriate locking to do so).
;417  //
;418  //  Because these values represent the outputs of un-clocked logic element
;419  //  and such elements often need to be cascaded (the outputs used as input
;420  //  to other non-clocked elements), the result is often dependent on the
;421  //  order of execution of the blocks of code.
;422  //-----------------------------------------------------------------------
;423 //  bool   ovenModeOn;           // Turn on power, enable output soon after
;424 //  bool   ovenOutErrInterlock;  // Oven PS Output state was wrong
;425 //  ulong  ovenOutErrStartTime;  // start of period of Output state error
;426 
;427 
;428  //-----------------------------------------------------------------------
;429  // OUTPUTS from CLOCKED (latched inputs and outputs) LOGIC ELEMENTS
;430  //
;431  //  These values are outputs from one of the blocks of code in the applic
;432  //  task that represent a clocked logic element (i.e. it acts like a
;433  //  clocked latch but is in software and the clock is one pass through
;434  //  the main application loop).
;435  //
;436  //  Each value here is set by one (and ONLY one) of the blocks of code in
;437  //  the applic task.  This group contains only values that are set by a
;438  //  block of code that represents a CLOCKED logic element.
;439  //
;440  //  These values are set in the "Next" instance of ApplState by the applic
;441  //  task AFTER all the other ApplState values are set.  Because they repre
;442  //  only the clocked logic elements, and each block of code reads only val
;443  //  from the Cur instance, the blocks can be executed in any order and the
;444  //  result will always be the same.
;445  //
;446  //  These values are used as inputs by other blocks and/or to set values
;447  //  used by other tasks (such as values read by the ModBus server task).
;448  //
;449  //  Again, these values must NOT be altered by other tasks (although they
;450  //  can read them as long as they use appropriate locking to do so).
;451  //-----------------------------------------------------------------------
;452   ulong  digitalOut;      // state for digital outputs
;453 
;454 //  float  activeSetpoint;  // value applied to regulation circuit
;455 
;456 //  float  rfOnSetpoint;    // warm/final setpoint
;457 //  float  rfOffSetpoint;   // cold/initial setpoint
;458 
;459 } ApplState;
;460 
;461 
;462 //bool  localMode, closedLoop;
;463 
;464 ApplState  prevState, curState, nextState;
;465 
;466 #define  Prev  prevState
;467 #define  Cur   curState
;468 #define  Next  nextState
;469 
;470 
;471 //ulong  rfOnTime;   // time RF turned on (in milliseconds)
;472 
;473 //float  regulationError;  // diff between setpoint and readback
;474 
;475 const uint ApplStateDataSize =  ( sizeof(ApplState)*3 + sizeof(setVal) );
_ApplStateDataSize::
	.dw	0x34
	.debug	G _ApplStateDataSize 7 0
;476 
;477 
;478 
;479 
;480 //=========================================================================
;481 //  List of daemon processes.  The inetd process listens for connection
;482 //  requests on each port in the list and creates a new instance of the
;483 //  specified process to service each new connection.
;484 //=========================================================================
;485 #include <services.h>
;486 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
;487 //APPLCODE - add tasks that service network clients
;488 
;489 //--- service funcs declared the same as standard command funcs:
;490 //     e.g.:   void _task fastdatad(int argc, char **argv);
;491 
;492 void _task tsh(int argc, char **argv);
;493 
;494 
;495 ServiceInfo inetdConf[] = {
;496 //--- add any application-specific inetd-type network services here ---
;497 //--- (add port # names to services.h) ---
;498 //  NAME          PORT           PROTOCOL  FUNC       PRI  -1  Config Param
;499 //  ------------  -------------  --------  ---------- ---  --  ------------
;500 
;501 //--- standard ones defined in sharedAppl.c ---
;502 //{ "console",    TTY0,          ASYNC,    tsh,        10, -1, &consCfg },
;503 //{ "fastdatad",  FASTDATA_PORT, ProtoTCP, fastdatad,   5, -1, NULL },
;504 //{ "modbusTCPd", MODBUS_PORT,   ProtoTCP, modbusTCPd,  6, -1, NULL },
;505 //{ "tsh",        TELNET_PORT,   ProtoTCP, tsh,        10, -1, NULL }
;506 
;507   #define SharedServices
;508   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dseg
_inetdConf::
	.dw	@2
	.dw	0
	.db	0x3
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	word _consCfg
	.ds	6,0
	.dw	@2+8
	.dw	0x7d3
	.db	0x2
	.dw	word _fastdatad
	.db	0x5
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+18
	.dw	0x1f6
	.db	0x2
	.dw	word _modbusTCPd
	.db	0x6
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+29
	.dw	0x17
	.db	0x2
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	0
;509 };
	.ds	6,0
	.debug	G _inetdConf 48 0
;510 
;511 const int  NumServices = sizeof(inetdConf) / sizeof(ServiceInfo);
	.seg	CONST
_NumServices::
	.dw	0x4
	.debug	G _NumServices 6 0
;512 
;513 
;514 
;515 //=========================================================================
;516 //  Defintions for variables that are accessable as ModBus registers
;517 //=========================================================================
;518 #else  // end of before-RegDefs portion
;822 #ifndef RegDefs // start of after-RegDefs portion
;823 
;824 
;825 
;826 
;827 //=========================================================================
;828 //  defintions for "parameterized" data values - lists of values that we wa
;829 //  to be "persistent" (i.e. saved to a file and restored on startup)
;830 //=========================================================================
;831 //APPLCODE - settings/values we want saved to/restored from files
;832 
;833 
;834 //--- parameter ID's for data in Device Data/calibration file ---
;835 //-------------------------------------------------------------------------
;836 // WARNING:  ID's can be added, but existing ID's (and the format of the
;837 //           data they represent) should NEVER change!  NOTE:  Existing one
;838 //           can be "eliminated" by changing their name and no longer
;839 //           using them, but never REUSE an old one for something new!!!
;840 //-------------------------------------------------------------------------
;841 //  NOTE:  ID's >= 1000 are rsvd for values shared by most applications
;842 //-------------------------------------------------------------------------
;843 
;844 //RESTORE_FUNC(myVar);
;845 
;846 const ParamData far  devDataParams[] = {
;847 //APPLDATA
;848 //                ID   ---value---  --RESTORE_FUNC--
;849 //PERSISTENT_VAR(  1,  myVarName,     PVRF(myVar) ),
;850 //                ID   ---value---  granularity  --RESTORE_FUNC--
;851 //PERSISTENT_TBL(  2   myArrayName, elemSize,     NULL ),
;852 
;853   #define SharedDevParams
;854   #include <sharedAppl.c>
;855 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.seg	FARCONST
_devDataParams::
	.dw	0x3ec
	.dw	0x2
	.dw	0
	.dl	phys _timeZone
	.dl	phys @1+1124
	.dw	0
	.dw	0x3ed
	.dw	0x4
	.dw	0
	.dl	phys _srfsIPAddr
	.dl	phys @1+1133
	.dw	0
	.dw	0x3e8
	.dw	0xc0
	.dw	0x18
	.dl	phys _ainLabel
	.dl	phys @1+1144
	.dw	0
	.dw	0x3e9
	.dw	0x60
	.dw	0x18
	.dl	phys _aoutLabel
	.dl	phys @1+1153
	.dw	0
	.dw	0x3ea
	.dw	0x180
	.dw	0x18
	.dl	phys _dinLabel
	.dl	phys @1+1163
	.dw	0
	.dw	0x3eb
	.dw	0x180
	.dw	0x18
	.dl	phys _doutLabel
	.dl	phys @1+1172
	.dw	0
	.dw	0x3ee
	.dw	0x20
	.dw	0
	.dl	phys _readGain
	.dl	phys @1+1182
	.dw	0
	.dw	0x3ef
	.dw	0x20
	.dw	0
	.dl	phys _readOffset
	.dl	phys @1+1191
	.dw	0
	.dw	0x3f0
	.dw	0x10
	.dw	0
	.dl	phys _setGain
	.dl	phys @1+1202
	.dw	0
	.dw	0x3f1
	.dw	0x10
	.dw	0
	.dl	phys _setOffset
	.dl	phys @1+1210
	.dw	word _ReadSetCalibsRestore
	.dw	0x3f2
	.dw	0x20
	.dw	0
	.dl	phys _hostName
	.dl	phys @1+1220
	.dw	word _hostNameRestore
	.dw	0x3f3
	.dw	0x4
	.dw	0
	.dl	phys _srfsAltAddr
	.dl	phys @1+1229
	.dw	0
	.dw	0x3f4
	.dw	0x300
	.dw	0x18
	.dl	phys _extraInLabel
	.dl	phys @1+1241
	.dw	0
	.dw	0x3f5
	.dw	0x4
	.dw	0
	.dl	phys _netmask
	.dl	phys @1+310
	.dw	0
	.dw	0x3f6
	.dw	0x4
	.dw	0
	.dl	phys _gateway
	.dl	phys @1+318
	.dw	0
;856   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;857 
	.ds	2,0
	.debug	G _devDataParams 50 8
;858 
;859 
;860 //----------------------------------------------------
;861 
;862 //RESTORE_FUNC(ampSet);
;863 
;864 const ParamData far  settingsParams[] = {
;865 //APPLDATA
;866 //_nearcall void ampSetRestore(void far *curVal, char *newVal, uint count);
;867 //
;868 //                ID   ---value---  --RESTORE_FUNC--
;869 //  PERSISTENT_VAR(  1,  ampSet,     PVRF(ampSet) ),
;870 //  PERSISTENT_VAR(  2,  rfOnSetpoint,    NULL ),
;871 
;872   END_PARAM_DATA
_settingsParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;873 
	.ds	2,0
	.debug	G _settingsParams 52 8
;874 
;875 
;876 //-----------------------------------------------------------------
;877 //  Application-specific values needed to restore the state of the
;878 //  controller following a "soft" reset (i.e. a restart without a
;879 //  CPU reset)
;880 //-----------------------------------------------------------------
;881 const ParamData far  ctlrStateParams[] = {
;882 // sample values from sharedAppl.c, common to all applications
;883 //                   --ID--  ---value,granularity---  --RESTORE_FUNC--
;884 //    PERSISTENT_VARx(  1000,  prevState,               NULL ),
;885 //    PERSISTENT_VARx(  1001,  curState,                NULL ),
;886 //    PERSISTENT_VARx(  1002,  nextState,               NULL ),
;887 //    PERSISTENT_TBL (  1003,  setVal,4,                NULL ),
;888 // // PERSISTENT_TBL (  1004,  shadowRegValues,4,       NULL ),
;889 
;890 //APPLDATA
;891 //    PERSISTENT_VAR(  1,  myApplStateVar,        NULL ),
;892 
;893 
;894   #define SharedCtlrStateParams
;895   #include <sharedAppl.c>
;896 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;897   END_PARAM_DATA
_ctlrStateParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;898 
	.ds	2,0
	.debug	G _ctlrStateParams 52 8
;899 
;900 
;901 //-------------------------------------------------------------------------
;902 //  A list of parameterized "persistent" data.  Backup copies of such value
;903 //  are stored in files and restored on startup.
;904 //-------------------------------------------------------------------------
;905 
;906 //    Base File Name    Category  ParamData
;907 //    ----------------  --------  ---------
;908 //--- add any application-specific parameterized file defs here ---
;909 //ParamFile  myAppCfgFile =
;910 //  { "myFileName",     PDC_CTLR, myCfgParams,   0 };
;911 
;912 ParamFile  settingsFile =
;913     { "settings",       PDC_SET,  settingsParams  };
	.dseg
_settingsFile::
	.dw	@2+33
	.db	0x4
	.dl	phys _settingsParams
	.ds	42,0
	.debug	G _settingsFile 53 0
;914 
;915 
;916 #define SharedParams
;917 #include <sharedAppl.c>
;918 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_devDataFile::
	.dw	@2+42
	.db	0x3
	.dl	phys _devDataParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _devDataFile 53 0
_hdwCfgFile::
	.dw	@2+50
	.db	0x1
	.dl	phys _hdwCfgParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _hdwCfgFile 53 0
;919 
;920 ParamFile *paramFiles[] = {
;921   #define SharedParamsList
;922   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_paramFiles::
	.dw	word _hdwCfgFile
	.dw	word _devDataFile
;923 //--- add any application-specific ParamData references here ---
;924 //  &myAppCfgFile,
;925   &settingsFile
;926 };
	.dw	word _settingsFile
	.debug	G _paramFiles 54 0
;927 
;928 const int NumParamFiles = sizeof(paramFiles) / sizeof(paramFiles[0]);
	.seg	CONST
_NumParamFiles::
	.dw	0x3
	.debug	G _NumParamFiles 6 0
;929 
;930 
;931 //=========================================================================
;932 //  Declarations for functions that handle setting "Next" values that serve
;933 //  as inputs to the application control logic (run by the "applic" task in
;934 //  a periodically executed loop).
;935 //
;936 //  While care must be taken in these functions to use locks to avoid the
;937 //  possibility of being preempted in the middle of an operation, such lock
;938 //  must be kept to as short a time as possible to avoid excessively latenc
;939 //  in the main control loop.
;940 //=========================================================================
;941 
;942 //void onRequest(void);
;943 //void offRequest(void);
;944 //void resetRequest(void);
;945 
;946 //void newSetpoint(float newAmps);
;947 
;948 
;949 //=========================================================================
;950 //  This is where misc global variables should be defined
;951 //=========================================================================
;952 #define SharedGlobals
;953 #include <sharedAppl.c>
;954 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_DigOutInitState::
	.dw	0, 0
	.debug	G _DigOutInitState 9 0
	.dseg
_applicReady::
	.db	0
	.debug	G _applicReady 3 0
_restoredApplState::
	.db	0
	.debug	G _restoredApplState 3 0
_allowSoftReset::
	.db	0
	.debug	G _allowSoftReset 3 0
_startupComplete::
	.db	0
	.debug	G _startupComplete 3 0
;955 //APPLCODE
;956 //--- add definitions for application-specific global variables here ---
;957 
;958 
;959 
;960 //=========================================================================
;961 //  Functions referenced in the Modbus register definitions to handle write
;962 //  specific global values defined as ModBus registers
;963 //=========================================================================
;964 
;965 //APPLCODE - add functions to process writes to ModBus register values
;966 
;967 //-------------------------------------------------------------------------
;968 //  External ModBus client sent a new value for "cmdBitsAppl"
;969 //
;970 //  Check the bits that where set and trigger the corresponding events as
;971 //  appropriate (but do NOT save the new value - just use it to trigger
;972 //  events)
;973 //-------------------------------------------------------------------------
;974 bool _nearcall MB_cmdBitsAppl(SetRegFuncParams)
;975 {
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$MB_cmdBitsAppl::
	ex	(sp),iy
$MB_cmdBitsAppl::
	.debug	G $MB_cmdBitsAppl 56 9
	.debug	{ $MB_cmdBitsAppl 56 974 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
;976 /*
;977   ulong  cmdBits;
;978   EventData  eventMsg;  // used by EVENT macro
;979 
;980 
;981   cmdBits = *((ulong *)newVal);
;982 
;983   if (cmdBits & x)  EVENT(MyEventX, chan, newVal, sizeof(int)); // w/ data
;984   if (cmdBits & y)  EVENT(MyEVentY, chan, NULL, 0);             // w/o data
;985 */
;986 
;987   return true;
	ld	a,0x1
;988 }
@4:
	.debug	} @4 988

@3	equ	0
	pop	ix
	lret
@5	equ	2
;989 
;990 //-------------------------------------------------------------------------
;991 //  External ModBus client sent a new setpoint
;992 //
;993 //  Check the new setting and alter output values as appropriate
;994 //-------------------------------------------------------------------------
;995 /*EXAMPLE
;996 bool MB_ampSet(SetRegFuncParams)
;997 {
;998   newSetpoint(MB_VAL(float));
;999 
;1000   return true;
;1001 }
;1002 */
;1003 
;1004 
;1005 //=========================================================================
;1006 //  functions to handle restoration of saved "persistent" values
;1007 //=========================================================================
;1008 
;1009 /*
;1010 //-------------------------------------------------------------------------
;1011 //  one of the setpoint values needs restoring from the settings file
;1012 //-------------------------------------------------------------------------
;1013 RESTORE_FUNC(myVal)
;1014 {
;1015   uint  u;
;1016   float  fval;
;1017   char  temp[32];
;1018 
;1019   for (u=0; u<NumPS; ++u)  if (curVal == (void far *) &ISET(u))  {
;1020     fval = *(float far *)newVal;
;1021     printf("restoring iSet_%u to: %s\r\n", u, fmtFloat(fval, 8,2, temp));
;1022     newSetpoint(u, fval);
;1023   }
;1024 
;1025 }
;1026 
;1027 //-------------------------------------------------------------------------
;1028 //  restore an ampSet value from the settings file
;1029 //-------------------------------------------------------------------------
;1030 RESTORE_FUNC(ampSet)
;1031 {
;1032   newSetpoint(NEW_VAL(float));
;1033 }
;1034 
;1035 
;1036 */
;1037 
;1038 //-------------------------------------------------------------------------
;1039 
;1040 
;1041 //-------------------------------------------------------------------------
;1042 #define SharedFuncs
;1043 #include <sharedAppl.c>
;1044 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
$initModBusRegs::
	.debug	G $initModBusRegs 57 9
	.debug	{ $initModBusRegs 57 454 @8 @7
	ld	hl,0x64
	ld	(_C0ChanMult),hl
	ld	l,0x1
	ld	(_NumC0Chans),hl
	ld	l,0x64
	ld	(_R3ChanMult),hl
	ld	l,0x1
	ld	(_NumR3Chans),hl
	ld	l,0x64
	ld	(_R4ChanMult),hl
	ld	l,0x1
	ld	(_NumR4Chans),hl
	lcall	$pvInitLists
	bool	hl
	jr	z,@9
	ld	a,0x1
	ld	(_doShutdown),a
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@12
	ld	a,0x1
	ld	(_runBackup),a
	ld	(_doReboot),a
@12:
@9:
@7:
	.debug	} @7 464

@6	equ	0
	lret
@8	equ	0
	.align	4
$$MB_timeZone::
	ex	(sp),iy
$MB_timeZone::
	.debug	G $MB_timeZone 56 9
	.debug	{ $MB_timeZone 56 470 @15 @14
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	de,0x7ff4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@16
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@17
	jr	z,@17
@16:
	xor	a,a
	jr	@14
@17:
	ld	hl,(ix-2)
	ld	(_timeZone),hl
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@18
	push	hl
	ld	de,word (phys @1+1254)
	ld	c,phys @1+1254 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
@18:
	ipset	2
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	a,0x1
@14:
	.debug	} @14 486

@13	equ	2
	ld	sp,ix
	pop	ix
	lret
@15	equ	4
	.align	4
$$MB_cmdBitsStd::
	ex	(sp),iy
$MB_cmdBitsStd::
	.debug	G $MB_cmdBitsStd 56 9
	.debug	{ $MB_cmdBitsStd 56 494 @21 @20
	ld	hl,-132
	call	__fent##
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@22
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
@22:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@23
	ld	a,0x1
	ld	(_doShutdown),a
@23:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@24
	ld	hl,0x1
	push	hl
	ld	hl,_devDataFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@19
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@24:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@25
	ld	hl,_devDataFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@25:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@26
	ld	hl,0x1
	push	hl
	ld	hl,_hdwCfgFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@19
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@26:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@27
	ld	hl,_hdwCfgFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@27:
	ld	a,0x1
@20:
	.debug	} @20 524

@19	equ	132
	ld	sp,ix
	pop	ix
	lret
@21	equ	134
$rwIO::
	.debug	G $rwIO 57 9
	.debug	{ $rwIO 57 531 @30 @29
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.bseg
@31:
	.ds	2
	.seg	FARCODE
	ld	hl,(@31)
	inc	hl
	ld	(@31),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	inc	l
	ld	(ix-6),hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@32
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@35:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@36
	ld	hl,(ix-2)
	ld	de,_updateAOut
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@40
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_lastSetVal
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fequ##
	jr	z,@41
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastSetVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	(hl),0x1
@41:
@40:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fequ##
	jr	z,@44
	ld	hl,(ix-12)
	ld	(hl),0x1
@44:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@37
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@46
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
	jr	@47
@46:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@48
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_setGain
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@48:
@47:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	p,@49
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@49:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	m,@50
	jr	z,@50
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@50:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastAnaOut
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_dacRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@37:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@35
@36:
@32:
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@51
	ld	hl,(@31)
	ld	e,0x1f
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@52
	ld	b,a
@53:
	add	hl,hl
	djnz	@53
@52:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@51:
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadTime),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@54
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
@54:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_readTicks),de
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@55
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	d,h
	ld	e,l
	ld	bc,(_DAC_Mask+2)
	call	__land##
	push	bc
	push	de
	lcall	$writeAnalogOutputs
	add	sp,4
@55:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_writeTicks),de
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@56
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@59:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@60
	ld	hl,(ix-2)
	ld	de,_updateAIn
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@64
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	(hl),0x1
@64:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@61
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@68
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@69
@68:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@69:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@70
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@70:
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@61:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@59
@60:
@56:
	lcall	$updateAvgsADC
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	ld	(_rwTicks),de
@29:
	.debug	} @29 607

@28	equ	28
	ld	sp,ix
	pop	ix
	lret
@30	equ	30
$logDigIOChgs::
	.debug	G $logDigIOChgs 58 9
	.debug	{ $logDigIOChgs 58 613 @73 @72
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	push	bc
	push	de
	ld	de,(_prevState+4)
	ld	bc,(_prevState+6)
	call	__lxor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
	ld	de,(_curState+8)
	ld	bc,(_curState+10)
	push	bc
	push	de
	ld	de,(_prevState+8)
	ld	bc,(_prevState+10)
	call	__lxor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.seg	FARCODE
	ld	a,(ix+5)
	or	a,a
	jr	z,@74
	ld	de,word (phys @1+1278)
	ld	c,phys @1+1278 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@74:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@75
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jp	z,@76
@75:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@79:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jp	nc,@80
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@84
	ld	a,(ix+5)
	or	a,a
	jr	z,@85
@84:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@88
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@88:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digInDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@89
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1323)
	ld	c,phys @1+1323 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@89:
@85:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@79
@80:
@76:
	ld	a,(ix+5)
	or	a,a
	jr	z,@90
	ld	de,word (phys @1+1329)
	ld	c,phys @1+1329 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@90:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@91
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jp	z,@92
@91:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@95:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jp	nc,@96
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@100
	ld	a,(ix+5)
	or	a,a
	jr	z,@101
@100:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+8)
	ld	bc,(_curState+10)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@104
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@104:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digOutDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@105
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1323)
	ld	c,phys @1+1323 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@105:
@101:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@95
@96:
@92:
	ld	a,(ix+5)
	or	a,a
	jr	z,@106
	ld	de,word (phys @1+1320)
	ld	c,phys @1+1320 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@106:
@72:
	.debug	} @72 648

@71	equ	20
	ld	sp,ix
	pop	ix
	lret
@73	equ	22
	.align	4
$$EVENT_RestoredParamFile::
	ex	(sp),iy
$EVENT_RestoredParamFile::
	.debug	G $EVENT_RestoredParamFile 59 9
	.debug	{ $EVENT_RestoredParamFile 59 654 @109 @108
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	add	hl,hl
	ld	de,_paramFiles
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1375)
	ld	c,phys @1+1375 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadParams
	add	sp,8
@108:
	.debug	} @108 666

@107	equ	4
	ld	sp,ix
	pop	ix
	lret
@109	equ	6
	.align	4
$$hostNameRestore::
	ex	(sp),iy
$hostNameRestore::
	.debug	G $hostNameRestore 60 9
	.debug	{ $hostNameRestore 60 671 @112 @111
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+9)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$SetHostName
	add	sp,4
@111:
	.debug	} @111 674

@110	equ	0
	pop	ix
	lret
@112	equ	2
	.align	4
$$ReadSetCalibsRestore::
	ex	(sp),iy
$ReadSetCalibsRestore::
	.debug	G $ReadSetCalibsRestore 60 9
	.debug	{ $ReadSetCalibsRestore 60 679 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	call	_KLOCK
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	call	_KUNLOCK
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@118:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@119
	ld	hl,(ix-2)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@118
@119:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@123:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@124
	ld	hl,(ix-2)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@123
@124:
@114:
	.debug	} @114 689

@113	equ	2
	ld	sp,ix
	pop	ix
	lret
@115	equ	4
$setApplDTM::
	.debug	G $setApplDTM 57 9
	.debug	{ $setApplDTM 57 694 @128 @127
	ld	hl,@2+57
	push	hl
	ld	hl,@2+66
	push	hl
	ld	de,word (phys @1+1407)
	ld	c,phys @1+1407 >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,@2+57
	push	hl
	ld	hl,@2+66
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_applVersTime),de
	ld	(_applVersTime+2),bc
@127:
	.debug	} @127 699

@126	equ	0
	lret
@128	equ	0
$saveApplState::
	.debug	G $saveApplState 61 9
	.debug	{ $saveApplState 61 709 @131 @130
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@132
	ld	hl,0xffff
	jp	@130
@132:
	call	_KLOCK
	ld	de,word (phys @1+1413)
	ld	c,phys @1+1413 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x10
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	call	_KUNLOCK
	bool	hl
	ld	l,h
@130:
	.debug	} @130 746

@129	equ	10
	ld	sp,ix
	pop	ix
	lret
@131	equ	12
$restoreApplState::
	.debug	G $restoreApplState 61 9
	.debug	{ $restoreApplState 61 764 @135 @134
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@136
	ld	hl,0xffff
	jp	@134
@136:
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@137
	ld	hl,0x1
	jp	@134
@137:
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@138
	jr	z,@138
	ld	hl,0x2
	jp	@134
@138:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	pop	de
	or	a,a
	sbc	hl,de
	jr	z,@139
	ld	hl,0x3
	jp	@134
@139:
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0xc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x10
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_curState+4),de
	ld	(_curState+6),bc
	ld	de,(_curState+8)
	ld	bc,(_curState+10)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	de,word (phys @1+1440)
	ld	c,phys @1+1440 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
@134:
	.debug	} @134 801

@133	equ	10
	ld	sp,ix
	pop	ix
	lret
@135	equ	12
$setGenericLabels::
	.debug	G $setGenericLabels 57 9
	.debug	{ $setGenericLabels 57 806 @142 @141
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@145:
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@146
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1480)
	ld	c,phys @1+1480 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@145
@146:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@152:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@153
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1487)
	ld	c,phys @1+1487 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@152
@153:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@159:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jr	nc,@160
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1495)
	ld	c,phys @1+1495 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@159
@160:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@166:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@167
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1502)
	ld	c,phys @1+1502 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@166
@167:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@173:
	ld	hl,(ix-2)
	ld	de,(_NumExtraIn)
	or	a,a
	sbc	hl,de
	jr	nc,@174
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1510)
	ld	c,phys @1+1510 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@173
@174:
@141:
	.debug	} @141 831

@140	equ	2
	ld	sp,ix
	pop	ix
	lret
@142	equ	4
;1045 
;1046 //=========================================================================
;1047 //  Misc Application-specific functions
;1048 //=========================================================================
;1049 //APPLCODE
;1050 
;1051 
;1052 
;1053 //=========================================================================
;1054 //  Task functions to handle application-specific commands
;1055 //=========================================================================
;1056 //APPLCODE
;1057 
;1058 //-------------------------------------------------------------------------
;1059 //  example func to process a command entered via a user shell
;1060 //-------------------------------------------------------------------------
;1061 /*
;1062 void _task miscTest(int argc, char **argv)
;1063 {
;1064   int  idx;
;1065   bool  validCmd;
;1066 
;1067 //used by EVENT macro
;1068   fd_t  eventsfd = -1;
;1069   EventMsg  eventMsg;
;1070 
;1071 
;1072   validCmd = false;
;1073 
;1074   for (;;)  {
;1075     if (argc < 3)  break;
;1076     if (! isdigit(argv[1][0]))  break;
;1077 
;1078     idx = atoi(argv[1]);
;1079     if ((idx < 1) OR (idx > NumChan))  {
;1080       printf("Invalid chan #\n");  Exit(-2); }
;1081 
;1082     --idx;  validCmd = true;
;1083 
;1084     if (StriEq(argv[2], "x"))     { EVENT(MyEventX, idx, NULL, 0);  break; 
;1085     if (StriEq(argv[2], "y"))     { EVENT(MyEventY, idx, NULL, 0);  break; 
;1086 
;1087     validCmd = false;  break;
;1088   }
;1089 
;1090   if (! validCmd)  { printf("Usage:  misc # x|y\r\n");  Exit(-1); }
;1091 
;1092   Exit(0);
;1093 }
;1094 */
;1095 
;1096 //=========================================================================
;1097 //  Generic structure to handle application-specific presentation of the
;1098 //  digital and analog input/output values.  Code to handle additional
;1099 //  formatting that cannot be handled in this generic manner should be
;1100 //  placed in the showState() task routine.
;1101 //=========================================================================
;1102 //APPLCODE - text and formatting info for application state summary
;1103 
;1104 /*EXAMPLE:
;1105 //-------------------------------------------------------------------------
;1106 _nearcall char *fmtMode(DispElem far *elem, char *buf)
;1107 {
;1108   return (char *) ModeDesc[ELEM_VAL(U16)];
;1109 }
;1110 
;1111 //-------------------------------------------------------------------------
;1112 _nearcall char *fmtHdwCfg(DispElem far *elem, char *buf)
;1113 {
;1114   return (char *) HdwCfgDesc[ELEM_VAL(U16)];
;1115 }
;1116 */
;1117 
;1118 //-------------------------------------------------------------------------
;1119   const char far DevStateStr[] = {
;1120 "---- Nothing defined yet ---\r\n"
;1121 /*EXAMPLE:
;1122 "Cavity Voltage:  ###.## kV    Open/Closed: ######    HdwConfig: ##### \r\n
;1123 "Active setpoint: ###.## kV    RF On/Off:   ### \r\n"
;1124 "Error:          -###.## kV    Loc/Rem:     ###### \r\n"
;1125 " \r\n"
;1126 "Limiter Voltage: -##.### V    Limited:     ### \r\n"
;1127 "                              Regulation:  ##### \r\n"
;1128 "RF OFF setpoint: ###.## kV \r\n"
;1129 "RF ON setpoint:  ###.## kV    Ramp Mode:   #### \r\n"
;1130 " \r\n"
;1131 */
;1132 };
	.seg	FARCONST
_DevStateStr::
	.db	"---- Nothing defined yet ---",13,10,0
	.debug	G _DevStateStr 62 8
;1133 
;1134 const DispElem  far dispElems[] = {
;1135 /*EXAMPLE:
;1136   { 17, 3, VFPV(cavityVolts),     DARK_BLUE, fmtF32,    6,2 },
;1137   { 17, 4, VFPV(activeSetpoint),  DARK_BLUE, fmtF32,    6,2 },
;1138   { 16, 5, VFPV(regulationError), DARK_BLUE, fmtF32,    7,2 },
;1139 
;1140   { 17, 7, VFPV(limiterVolts),    DARK_BLUE, fmtF32,    7,3 },
;1141 
;1142   { 17, 9, VFPV(rfOffSetpoint),   DARK_BLUE, fmtF32,    6,2 },
;1143   { 17,10, VFPV(rfOnSetpoint),    DARK_BLUE, fmtF32,    6,2 },
;1144 
;1145   { 43,10, VFPV(rampMode),        DARK_BLUE, fmtMode,   4,4 },
;1146 
;1147   { 64, 3, VFPV(hdwCfg),          DARK_BLUE, fmtHdwCfg, 5,5 },
;1148 */
;1149   { 0,0, NULL, NULL, NULL, 0,0 }
_dispElems::
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1150 };
	.debug	G _dispElems 63 8
;1151 
;1152 //--- ATTR_NAME macros currently defined in fcntl.h ---
;1153 const DigDispElem far digInElems[] = {
;1154 /*EXAMPLE:
;1155 //{ xx,yy,  BIT_MASK,     "0STR"  ,ATTR_NAME,  "1STR"  ,ATTR_NAME },
;1156   { 43, 3,  CLOSED_LOOP,  "OPEN  ",DARK_RED,   "CLOSED",DARK_BLUE },
;1157   { 43, 4,  RF_IS_OFF,    "ON "   ,DARK_BLUE,  "OFF"   ,DARK_RED },
;1158   { 43, 5,  LOC_REM_SW,   "REMOTE",DARK_BLUE,  "LOCAL ",DARK_BLUE },
;1159 */
;1160   { 0,0, 0, NULL,NULL, NULL,NULL }
_digInElems::
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1161 };
	.debug	G _digInElems 65 8
;1162 
;1163 const DigDispElem far digOutElems[] = {
;1164 /*EXAMPLE:
;1165 //{ xx,yy,  BIT_MASK,     "0STR"  ,ATTR_NAME,  "1STR" ,ATTR_NAME },
;1166   { 43, 7,  LIMITED_LED,   "NO "  ,DARK_BLUE,  "YES"  ,DARK_RED },
;1167   { 43, 8,  ERROR_LED,     "OK   ",DARK_BLUE,  "ERROR",DARK_RED },
;1168 */
;1169   { 0,0,  0,  NULL,NULL,  NULL,NULL }
_digOutElems::
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1170 };
	.debug	G _digOutElems 65 8
;1171 
;1172 //---------------------------------------------------------------
;1173 //---- older style - do not use for newer applications -----
;1174 const DigFmtInfo digInFmt[] = {
;1175 //{ xx,yy, "0-str"  ,1,  "1-str" ,0 },  //  descr
;1176   { -1,-1, "",0, "",0 }
	.seg	CONST
_digInFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+7
	.db	0
	.dw	@2+7
	.db	0
;1177 };
	.debug	G _digInFmt 67 0
;1178 
;1179 const DigFmtInfo digOutFmt[] = {
;1180 //{ xx,yy, "0-str"  ,1,  "1-str" ,0 },  //  descr
;1181   { -1,-1, "",0, "",0 }
_digOutFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+7
	.db	0
	.dw	@2+7
	.db	0
;1182 };
	.debug	G _digOutFmt 67 0
;1183 
;1184 
;1185 const AnalogFmtInfo  adcFmt[] = {
;1186   { -1,-1, 0,0 }
_adcFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;1187 };
	.debug	G _adcFmt 69 0
;1188 
;1189 const AnalogFmtInfo  dacFmt[] = {
;1190   { -1,-1, 0,0 }
_dacFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;1191 };
	.debug	G _dacFmt 69 0
;1192 
;1193 
;1194 //-------------------------------------------------------------------------
;1195 //  "state":  Show continuously updated state of the system
;1196 //-------------------------------------------------------------------------
;1197 void _task showState(int argc, char **argv)
;1198 {
	.seg	FARCODE
	.align	4
$$showState::
	ex	(sp),iy
$showState::
	.debug	G $showState 71 9
	.debug	{ $showState 71 1197 @180 @179
	ld	hl,-129
	call	__fent##
;1199   bool  blinkOff;
;1200   char  temp[128];
;1201 
;1202 
;1203   printf(clsCmd);  blinkOff = false;
	ld	hl,_clsCmd
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	ld	(ix-1),a
;1204 
;1205   CursorTo(0, 3);  printf(DevStateStr);
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	de,word (phys @1+1521)
	ld	c,phys @1+1521 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	de,word (phys _DevStateStr)
	ld	c,phys _DevStateStr >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1206 
;1207   for (;;)  {
@183:
;1208     CursorTo(0, 0);  blinkOff = !blinkOff;
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @1+1521)
	ld	c,phys @1+1521 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,(ix-1)
	or	a,a
	ld	a,0
	jr	nz,@188
	inc	a
@188:
	ld	(ix-1),a
;1209 
;1210     stdHeader();  displayElems((DispElem far *)dispElems, blinkOff, temp);
	lcall	$stdHeader
	ld	hl,-129+@178
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _dispElems)
	ld	c,phys _dispElems >> 16
	push	bc
	push	de
	lcall	$displayElems
	add	sp,8
;1211 
;1212     displayDigElems(digitalIn, (DigDispElem far *)digInElems, blinkOff, tem
	ld	hl,-129+@178
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digInElems)
	ld	c,phys _digInElems >> 16
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1213     displayDigElems(digitalOut, (DigDispElem far *)digOutElems, blinkOff, t
	ld	hl,-129+@178
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digOutElems)
	ld	c,phys _digOutElems >> 16
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1214 
;1215     CursorTo(0,22);  fflush(stdout);  CheckETX();  sleepMS(500);
	ld	hl,0x1
	push	hl
	ld	l,0x17
	push	hl
	ld	de,word (phys @1+1521)
	ld	c,phys @1+1521 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	lcall	$CheckETX
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1216   }
;1217 
;1218 }
	jp	@183
@179:
	.debug	} @179 1218

@178	equ	129
	ld	sp,ix
	pop	ix
	lret
@180	equ	131
;1219 
;1220 //-------------------------------------------------------------------------
;1221 //  Application-specific commands
;1222 //-------------------------------------------------------------------------
;1223 void _task cmd(int argc, char **argv)
;1224 {
	.align	4
$$cmd::
	ex	(sp),iy
$cmd::
	.debug	G $cmd 71 9
	.debug	{ $cmd 71 1223 @191 @190
	push	ix
	ld	ix,0
	add	ix,sp
;1225 /*
;1226   bool  validCmd, allChans, validChan;
;1227   int  chan;
;1228   char  *cmdStr;
;1229 
;1230 
;1231   validCmd = allChans = validChan = false;
;1232 
;1233   do  {
;1234     if (argc < 2)  break;
;1235 
;1236     cmdStr = argv[1];
;1237 
;1238     if (argc > 2)  {
;1239       if (StriEq(argv[2], "all"))
;1240         allChans = validChan = true;
;1241       else  {
;1242         if (isdigit(*argv[2]))  chan = atoi(argv[2]) - 1;
;1243         if ((chan >= 0) AND (chan < 4))  validChan = true;
;1244       }
;1245     }
;1246 
;1247     if (StriEq(cmdStr, "enable"))  {
;1248       if (!validChan)  { printf("Invalid channel\r\n");  break; }
;1249       KLOCK();
;1250       if (allChans)
;1251         cmdBitsAppl |= cmdEnableAllBits;
;1252       else
;1253         cmdBitsAppl |= cmdEnableBits[chan];
;1254       KUNLOCK();  validCmd = true;
;1255     }
;1256 
;1257     if (StriEq(cmdStr, "disable"))  {
;1258       if (!validChan)  { printf("Invalid channel\r\n");  break; }
;1259       KLOCK();
;1260       if (allChans)
;1261         cmdBitsAppl |= cmdDisableAllBits;
;1262       else
;1263         cmdBitsAppl |= cmdDisableBits[chan];
;1264       KUNLOCK();  validCmd = true;
;1265     }
;1266 
;1267     if (StriEq(cmdStr, "clear"))  {
;1268       if (!validChan)  { printf("Invalid channel\r\n");  break; }
;1269       KLOCK();
;1270       if (allChans)
;1271         cmdBitsAppl |= cmdClearAllBits;
;1272       else
;1273         cmdBitsAppl |= cmdClearBits[chan];
;1274       KUNLOCK();  validCmd = true;
;1275     }
;1276 
;1277 //    if (StriEq(cmdStr, "reset"))  {
;1278 //      KLOCK();  cmdBitsAppl |= CBA_RESET_FAULT;  KUNLOCK();  validCmd = t
;1279 
;1280   }  while(0);
;1281 
;1282 
;1283   if (! validCmd)  {
;1284     printf("\r\n"
;1285            "Usage:  cmd enable #|all   (enable one or all channels)\r\n"
;1286            "            disable #|all  (disable one or all channels)\r\n"
;1287            "            clear #|all    (clear count for one or all channels
;1288            "            reset          (reset current spark fault)\r\n" );
;1289     Exit(-1);
;1290   }
;1291 */
;1292 
;1293   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;1294 }
@190:
	.debug	} @190 1294

@189	equ	0
	pop	ix
	lret
@191	equ	2
;1295 
;1296 static int  lastpid = 0;
	.dseg
_lastpid:
	.dw	0
;1297 
;1298 //-------------------------------------------------------------------------
;1299 void semErr(sem_t *sem, const char far *funcName)
;1300 {
	.seg	FARCODE
$semErr::
	.debug	G $semErr 72 9
	.debug	{ $semErr 72 1299 @194 @193
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1301   ulong  msTime = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;1302 
;1303   printf("%s  %5u.%03u [%05d]: sem_%ls(): %ls\r\n",
;1304          (getpid() == lastpid) ? "" : "\r\n",
;1305          (uint)(msTime/1000), (uint)(msTime % 1000), getpid(),
;1306          funcName, strerror(errno) );
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strerror
	pop	hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ulmod##
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__uldiv##
	push	de
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	de,(_lastpid)
	or	a,a
	sbc	hl,de
	jr	nz,@195
	ld	hl,@2+7
	jr	@196
@195:
	ld	hl,@2+82
@196:
	push	hl
	ld	de,word (phys @1+1534)
	ld	c,phys @1+1534 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;1307 
;1308   lastpid = getpid();
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(_lastpid),hl
;1309 }
@193:
	.debug	} @193 1309

@192	equ	4
	ld	sp,ix
	pop	ix
	lret
@194	equ	6
;1310 
;1311 //-------------------------------------------------------------------------
;1312 void semMsg(sem_t *sem, const char far *msg)
;1313 {
$semMsg::
	.debug	G $semMsg 72 9
	.debug	{ $semMsg 72 1312 @200 @199
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1314   ulong  msTime = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;1315 
;1316   printf("%s  %5u.%03u [%05d]: %ls\r\n",
;1317          (getpid() == lastpid) ? "" : "\r\n",
;1318          (uint)(msTime/1000), (uint)(msTime % 1000), getpid(), msg);
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ulmod##
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__uldiv##
	push	de
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	de,(_lastpid)
	or	a,a
	sbc	hl,de
	jr	nz,@201
	ld	hl,@2+7
	jr	@202
@201:
	ld	hl,@2+82
@202:
	push	hl
	ld	de,word (phys @1+1572)
	ld	c,phys @1+1572 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;1319 
;1320   lastpid = getpid();
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(_lastpid),hl
;1321 }
@199:
	.debug	} @199 1321

@198	equ	4
	ld	sp,ix
	pop	ix
	lret
@200	equ	6
;1322 
;1323 //-------------------------------------------------------------------------
;1324 //  Task to test use of POSIX-style semaphores
;1325 //-------------------------------------------------------------------------
;1326 void _task sem_user(int argc, char **argv)
;1327 {
	.align	4
$$sem_user::
	ex	(sp),iy
$sem_user::
	.debug	G $sem_user 71 9
	.debug	{ $sem_user 71 1326 @206 @205
	ld	hl,-155
	call	__fent##
;1328   sem_t  *sem = NULL;
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
;1329   int  semValue, stat;
;1330   uint  u;
;1331   long  waitSecs, delay;
;1332   char  *name;
;1333   char  func;
;1334   struct timespec endWaitTOD;
;1335   char  msg[128];
;1336 
;1337 
;1338 #define  SemName  "test-sem"
;1339 
;1340 
;1341   delay = (getpid() % 4) * 500 + 1000;
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	call	__idiv##
	ld	bc,0x1f4
	mul
	ld	hl,0x3e8
	add	hl,bc
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;1342 
;1343   waitSecs = atol(argv[1]);
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtol
	add	sp,6
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;1344 
;1345   for (u=0; (func=argv[2][u])!=0; ++u)  {
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@209:
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	a,(hl)
	ld	(ix-19),a
	or	a,a
	jp	z,@210
;1346     switch (func)  {
	jp	@214
;1347 
;1348       case 'o':
;1349         sem = sem_open(SemName, 0, 0, 0);
@218:
	bool	hl
	ld	l,h
	push	hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	push	bc
	push	de
	push	hl
	ld	hl,@2+85
	push	hl
	lcall	$sem_open
	add	sp,10
	ld	(ix-2),hl
;1350         if (!sem)  { semErr(sem, "open");  semMsg(sem, "exiting");  Exit(-1
	bool	hl
	jr	nz,@219
	ld	de,word (phys @1+1599)
	ld	c,phys @1+1599 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semErr
	add	sp,6
	ld	de,word (phys @1+1604)
	ld	c,phys @1+1604 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;1351         semMsg(sem, "opened");
@219:
	ld	de,word (phys @1+1612)
	ld	c,phys @1+1612 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
;1352         sem_getvalue(sem, &semValue);
	ld	hl,-4+@204
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_getvalue
	add	sp,4
;1353         sprintf(msg, "cur value: %d", semValue);  semMsg(sem, msg);
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @1+1619)
	ld	c,phys @1+1619 >> 16
	jp	@440
;1354         break;
;1355 
;1356       case 'w':
;1357         if (waitSecs < 0)  {
@222:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@223
;1358           name = "wait";  stat = sem_wait(sem);  }
	ld	hl,@2+94
	ld	(ix-18),hl
	ld	de,0xffff
	ld	bc,0x7fff
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_wait_
	add	sp,6
	ld	(ix-6),hl
;1359         else if (waitSecs == 0)  {
	jr	@226
@223:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jr	nz,@227
;1360           name = "trywait";  stat = sem_trywait(sem);  }
	ld	hl,@2+99
	ld	(ix-18),hl
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_trywait
	pop	de
	ld	(ix-6),hl
;1361         else  {
	jr	@230
@227:
;1362           endWaitTOD.tv_sec = time(NULL) + waitSecs;  endWaitTOD.tv_nsec = 
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-21),hl
	ex	de,hl
	ld	(ix-23),hl
	ex	de,hl
;1363           name = "timedwait";  stat = sem_timedwait(sem, &endWaitTOD);
	ld	hl,@2+107
	ld	(ix-18),hl
	ld	hl,-27+@204
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_timedwait
	add	sp,4
	ld	(ix-6),hl
;1364         }
;1365         if (stat)  semErr(sem, name);  else  semMsg(sem, "got lock");
@230:
@226:
	ld	hl,(ix-6)
	bool	hl
	jr	z,@233
	ld	hl,(ix-18)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semErr
	add	sp,6
	jr	@234
@233:
	ld	de,word (phys @1+1633)
	ld	c,phys @1+1633 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
;1366         break;
@234:
;1367 
;1368       case 'p':
	jp	@215
;1369         if (sem_post(sem))
@235:
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_post
	pop	de
	bool	hl
	jr	z,@236
;1370           semErr(sem, "post");
	ld	de,word (phys @1+1642)
	ld	c,phys @1+1642 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semErr
	add	sp,6
;1371         else
;1372           semMsg(sem, "released lock");
	jr	@237
@236:
	ld	de,word (phys @1+1647)
	ld	c,phys @1+1647 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
;1373         break;
@237:
;1374 
;1375       case 'c':
	jp	@215
;1376         if (sem_close(sem))
@238:
	ld	hl,(ix-2)
	push	hl
	lcall	$sem_close
	pop	de
	bool	hl
	jr	z,@239
;1377           perror("close");
	ld	de,word (phys @1+1661)
	ld	c,phys @1+1661 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;1378         else
;1379           semMsg(sem, "closed");
	jp	@215
@239:
	ld	de,word (phys @1+1667)
	ld	c,phys @1+1667 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
;1380         break;
;1381 
;1382       case 'u':
	jr	@215
;1383         if (sem_unlink(SemName))
@241:
	ld	hl,@2+85
	push	hl
	lcall	$sem_unlink
	pop	de
	bool	hl
	jr	z,@242
;1384           semErr(sem, "unlink");
	ld	de,word (phys @1+1674)
	ld	c,phys @1+1674 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semErr
	jr	@439
;1385         else
;1386           semMsg(sem, "unlinked");
@242:
	ld	de,word (phys @1+1681)
	ld	c,phys @1+1681 >> 16
	jr	@438
;1387         break;
;1388 
;1389       default:
;1390         sprintf(msg, "unrecognized func specifier: '%c'", func);
@244:
	ld	a,(ix-19)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+1690)
	ld	c,phys @1+1690 >> 16
@440:
	push	bc
	push	de
	ld	hl,-149+@204
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;1391         semMsg(sem, msg);
	ld	hl,-155+@204
	add	hl,sp
	ex	de,hl
	call	__farcvp##
@438:
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
@439:
	add	sp,6
;1392     }
;1393     sleepMS(delay);
	jr	@215
@214:
	cp	0x63
	jp	z,@238
	cp	0x6f
	jp	z,@218
	cp	0x70
	jp	z,@235
	cp	0x75
	jr	z,@241
	cp	0x77
	jp	z,@222
	jr	@244
@215:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1394   }
;1395 
;1396   semMsg(sem, "exiting");  Exit(0);
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jp	@209
@210:
	ld	de,word (phys @1+1604)
	ld	c,phys @1+1604 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$semMsg
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;1397 }
@205:
	.debug	} @205 1397

@204	equ	155
	ld	sp,ix
	pop	ix
	lret
@206	equ	157
;1398 
;1399 
;1400 //-------------------------------------------------------------------------
;1401 //  Test the POSIX-style semaphore functions
;1402 //-------------------------------------------------------------------------
;1403 void _task sem_test(int argc, char **argv)
;1404 {
	.align	4
$$sem_test::
	ex	(sp),iy
$sem_test::
	.debug	G $sem_test 71 9
	.debug	{ $sem_test 71 1403 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-32
;1405   #define  MaxTasks  8
;1406   uint  u, numTasks;
;1407   int  stat;
;1408   sem_t  *sem;
;1409   int  pids[8];
;1410   char  *argv_[4];
;1411 
;1412 
;1413   if (showHelp(3, argc, argv))  {
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@248
;1414     printf("\n"
;1415            "usage: sem_test <waitSec> <testMask> [...testMask]\r\n"
;1416            "\r\n"
;1417            "          waitSec:  > 0:  use sem_timedwait() (block w/timeout)
;1418            "                      0:  use sem_trywait()   (don't block)\r\n
;1419            "                    < 0:  use sem_wait()      (block)\r\n"
;1420            "          testMask str indicating funcs to call & order:\r\n"
;1421            "                    o:   sem_open()\r\n"
;1422            "                    w:   sem_???wait()\r\n"
;1423            "                    p:   sem_post()\r\n"
;1424            "                    c:   sem_close()\r\n"
;1425            "                    u:   sem_unlink()\r\n"
;1426            "          # of testMasks = # of concurrent tasks\r\n"
;1427           );
	ld	de,word (phys @1+1724)
	ld	c,phys @1+1724 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1428 
;1429     Exit(-1);
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;1430   }
;1431 
;1432   sem = sem_open("test-sem", O_CREAT, 0666, 1);
@248:
	ld	hl,0x1
	push	hl
	ld	de,0x1b6
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,0x4
	push	hl
	ld	hl,@2+85
	push	hl
	lcall	$sem_open
	add	sp,10
	ld	(ix-8),hl
;1433 
;1434   if (!sem)  { perror("sem_open");  Exit(-1);  }
	bool	hl
	jr	nz,@251
	ld	de,word (phys @1+2260)
	ld	c,phys @1+2260 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;1435 
;1436   semMsg(sem, "Created");
@251:
	ld	de,word (phys @1+2269)
	ld	c,phys @1+2269 >> 16
	push	bc
	push	de
	ld	hl,(ix-8)
	push	hl
	lcall	$semMsg
	add	sp,6
;1437 
;1438   argv_[0] = "sem_user";  argv_[1] = argv[1];  argv_[3] = NULL;
	ld	hl,@2+117
	ld	(ix-32),hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-30),hl
	bool	hl
	ld	l,h
	ld	(ix-26),hl
;1439 
;1440   numTasks = 0;
	ld	(ix-4),hl
;1441   for (u=2; u<argc; ++u)  {
	ld	l,0x2
	ld	(ix-2),hl
@256:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@257
;1442     argv_[2] = argv[u];
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	ld	(ix-28),hl
;1443     pids[numTasks++] = createProc(sem_user, 9, 3, argv_, 0, 1, 2);
	ld	hl,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-26+@245
	add	hl,sp
	push	hl
	ld	hl,0x3
	push	hl
	ld	l,0x9
	push	hl
	ld	hl,_sem_user
	push	hl
	lcall	$createProc
	add	sp,14
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	inc	de
	ex	de,hl
	ld	(ix-4),hl
	dec	hl
	add	hl,hl
	ld	bc,de
	ex	de,hl
	ld	hl,-24+@245
	add	hl,sp
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1444     if (numTasks == MaxTasks)  break;
	ld	hl,(ix-4)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jr	z,@257
;1445   }
;1446 
;1447   sem_close(sem);  sem_unlink("test-sem");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@256
@257:
	ld	hl,(ix-8)
	push	hl
	lcall	$sem_close
	pop	de
	ld	hl,@2+85
	push	hl
	lcall	$sem_unlink
	pop	de
;1448 
;1449   for (u=0; u<numTasks; ++u)  waitpid(pids[u], &stat, 0);
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@264:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@265
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-4+@245
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,-20+@245
	add	hl,sp
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$waitpid
	add	sp,6
;1450 
;1451   printf("\r\nall child tasks exited\r\n");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@264
@265:
	ld	de,word (phys @1+2277)
	ld	c,phys @1+2277 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1452 
;1453   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;1454 }
@246:
	.debug	} @246 1454

@245	equ	32
	ld	sp,ix
	pop	ix
	lret
@247	equ	34
;1455 
;1456 
;1457 //=========================================================================
;1458 //  Event-Handler functions called by the appl task to process event messag
;1459 //=========================================================================
;1460 //APPLCODE
;1461 
;1462 //-------------------------------------------------------------------------
;1463 //  Event-Handler for a request to ...
;1464 //-------------------------------------------------------------------------
;1465 /*
;1466 void EVENT_MyEvent(EventMsg *event)
;1467 {
;1468   uint  idx;
;1469   float  setpoint;
;1470   char  temp[16];
;1471 
;1472 
;1473   idx = event->chanNum;
;1474 
;1475   if (error)  {
;1476     fprintf(DiagLog, "error msg, chan:\n", idx+1);
;1477     return;
;1478   }
;1479 
;1480   setpoint = *((float *)event->data);
;1481 
;1482   fprintf(DiagLog, "New SetPoint for PS%d: %s\n",
;1483      idx+1, fmtFloat(setpoint, 8,3, temp) );
;1484 
;1485   *((float *)((&iSet_1_RegInfo + idx)->regVal)) = setpoint;
;1486 
;1487   anaOut[idx] = ISETtoVolts(idx, setpoint);
;1488 }
;1489 */
;1490 
;1491 
;1492 //=========================================================================
;1493 //  Update the the state of the application logic in well-defined phases
;1494 //=========================================================================
;1495 // IMPORTANT NOTES and RULES:
;1496 //
;1497 //  - The code to change ANY value must be in ONE place.  NEVER spread the
;1498 //    logic for updating a single value around.  There should be ONE place
;1499 //    to look to see how a value gets set.
;1500 //
;1501 //  - "Cur" values are basically "inputs" - literally (they are set based
;1502 //    on the just-read state of a digital or analog input) and/or figurativ
;1503 //    (they hold a value set by some external source, such as a cmd from a
;1504 //    remote client or another user-interface task).
;1505 //
;1506 //  - "Next" values are basically "outputs" - literally (they determine the
;1507 //    next state of a digital or analog output) and/or figuratively (they
;1508 //    can affect the state of the logic for the next pass).
;1509 //
;1510 //  - The "Cur" OR the "Next" instance of a value may be changed - NEVER
;1511 //    both of them (with the exception of the first step below that copies
;1512 //    all of cur to prev and next to cur).
;1513 //
;1514 //  - A value MUST be in the ApplState struct if one of the following appli
;1515 //     - The application logic is dependent on if or how much the value has
;1516 //       changed between passes.
;1517 //     - The value is used as both input (used in in a conditional and/or i
;1518 //       an expression that can affect the result of an assignment) and out
;1519 //       (the target of an assignment).
;1520 //
;1521 //  - Variables that are NOT in the ApplState struct but are USED (in
;1522 //    conditionals or other expressions) by the application logic must be
;1523 //    treated just like "Cur" values.  Variables SET (the target in an
;1524 //    assignment statement) by the application logic must be treated just
;1525 //    like "Next" values.
;1526 //
;1527 //  - When the logic requires comparing an "input" to a related "output", b
;1528 //    sure to use the "Cur" value for the "input", and the "Prev" value for
;1529 //    the "output".
;1530 //
;1531 //    This is because during the processing of the loop, the "Cur" values
;1532 //    represent the input values just read (what they are "now") and the
;1533 //    "Prev" values represent the values the outputs were set to at the
;1534 //    beginning of the prev pass (i.e. they are the values that "caused"
;1535 //    the inputs to have their "Cur" values).
;1536 //
;1537 //    During a pass the output values in "Cur" represent what the outputs
;1538 //    where set to AFTER the "Cur" inputs were updated, so comparing them
;1539 //    makes no sense.  Doing so is the equivalent of comparing a past respo
;1540 //    to a condition that didn't exist at the time.
;1541 //=========================================================================
;1542 
;1543 
;1544 //=========================================================================
;1545 //  Definitions for functions that handle setting "Next" values that serve
;1546 //  as inputs to the application control logic (run by the "applic" task in
;1547 //  a periodically executed loop).
;1548 //
;1549 //  While care must be taken in these functions to use locks to avoid the
;1550 //  possibility of being preempted in the middle of an operation, such lock
;1551 //  must be kept to as short a time as possible to avoid excessive latency
;1552 //  in the main control loop.
;1553 //
;1554 //  For REALLY short locks, using a critical section is best, because this
;1555 //  has the least overhead (but it has to be REALLY short to avoid causing
;1556 //  problems for interrupt handlers).
;1557 //
;1558 //  For longer locks (ones that involve anything but the most trivial
;1559 //  conditional logic), use either KLOCK() and KUNLOCK() (which disable the
;1560 //  scheduler) or a more specific global semaphore/mutex lock.
;1561 //=========================================================================
;1562 
;1563 /*Examples
;1564 //-------------------------------------------------------------------------
;1565 void onRequest(void)
;1566 {
;1567   _EnterCritical_();
;1568   Next.onRequest = true;  Next.offRequest = false;
;1569   _ExitCritical_();
;1570 
;1571   fprintf(DiagLog, "ON request\n");
;1572 }
;1573 
;1574 //-------------------------------------------------------------------------
;1575 void offRequest(void)
;1576 {
;1577   _EnterCritical_();
;1578   Next.offRequest = true;  Next.onRequest = false;
;1579   _ExitCritical_();
;1580 
;1581   fprintf(DiagLog, "OFF request\n");
;1582 }
;1583 
;1584 //-------------------------------------------------------------------------
;1585 void resetRequest(void)
;1586 {
;1587   _EnterCritical_();  Next.resetRequest = true;  _ExitCritical_();
;1588 
;1589   fprintf(DiagLog, "RESET request\n");
;1590 }
;1591 
;1592 //-------------------------------------------------------------------------
;1593 void newSetpoint(float newAmps)
;1594 {
;1595   char  temp[16];
;1596 
;1597 
;1598   KLOCK();
;1599 
;1600   if (FABS(newAmps) > maxAmpSet)  newAmps = (float)SIGN(newAmps) * maxAmpSe
;1601 
;1602   Next.ampSet = newAmps;
;1603 
;1604   KUNLOCK();
;1605 
;1606   fprintf(DiagLog, "New Setpoint: %s\n", fmtFloat(newAmps, 10,3, temp) );
;1607 }
;1608 
;1609 //-------------------------------------------------------------------------
;1610 */
;1611 
;1612 /*
;1613 =========== NOTES on Locking ============
;1614 
;1615 The applic task runs at the highest priority (even above the kernel), so it
;1616 cannot be preempted by any other task.  As long as this is true, the applic
;1617 task does not need to use locks when accessing global variables.
;1618 
;1619 However, all other tasks MUST disable the scheduler when accessing values
;1620 used by the applic task to avoid being preempted while doing so.  Care must
;1621 be taken to keep these times short to avoid latency issues.
;1622 
;1623 For REALLY short times, a critical section can be used as this is much more
;1624 efficient than disabling and reenabling the scheduler.  But critical sectio
;1625 disable all interrupts, so it is not practical in most cases.
;1626 
;1627 */
;1628 
;1629 //=========================================================================
;1630 //  Update the "Cur"rent state of the controller
;1631 //
;1632 //  Be sure to read the "NOTES on Locking" section above....
;1633 //=========================================================================
;1634 //
;1635 //  Just before this function is called, readings were taken of the current
;1636 //  state of the hardware, and any changes to the output states specified b
;1637 //  the last pass were applied (just after taking the readings).  These val
;1638 //  are copied to Next as needed and constitute the Hardware Inputs.
;1639 //
;1640 //  Other tasks can affect the state of the control logic by changing value
;1641 //  in Next as well.  These values constitute Software Inputs.
;1642 //
;1643 //  This function is responsible for the Asynchronous logic that is applied
;1644 //  each pass.  It updates values in Next (or other global variables) based
;1645 //  on the Software and Hardware Input values in Next.  This portion of the
;1646 //  logic is analogous to unclocked gates in an electronic circuit.
;1647 //
;1648 //  After the Asychronous logic is applied, we set Prev = Cur and Cur = Nex
;1649 //  The result is that Prev contains the controller state as it was during 
;1650 //  previous pass, and Cur indicates the current state of the controller.
;1651 //
;1652 //  Also, see the "NOTES on Locking" section above....
;1653 //=========================================================================
;1654 void updateCurState(void)
;1655 {
$updateCurState::
	.debug	G $updateCurState 57 9
	.debug	{ $updateCurState 57 1654 @269 @268
;1656   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@268
;1657 
;1658 //-----------------------------------------------------------------
;1659 // The following conditions exist at this point:
;1660 // - The analog and digital hardware inputs have just been read
;1661 // - The outputs were just set to values computed during the last pass
;1662 // - "Cur" contains the state the inputs were in at the START of
;1663 //   of the previous pass, and the state the outputs were in DURING
;1664 //   the previous pass
;1665 // - "Next" contains the values that the outputs were just set
;1666 //   to and any "input" values that were changed by other tasks
;1667 //------------------------------------------------------------------
;1668 
;1669 // Now we update the values in "Next" that are based solely on the
;1670 // state of the hardware inputs we just read and values maintained by
;1671 // by other tasks (basically, we deal with READINGS here: Values that
;1672 // we need but are not written to "Next" by another task)
;1673 
;1674   Next.digitalIn = digitalIn;
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
;1675 
;1676 //APPLCODE
;1677 
;1678 /*EXAMPLES:
;1679   Next.rfgenFault =  !(digitalIn & RF_PS_NOT_FAULT);
;1680   Next.rfgenHeatOn = !(digitalIn & RF_PS_NOT_HEAT_ON);
;1681   Next.rfgenReady =  !(digitalIn & RF_PS_NOT_READY);
;1682 
;1683   ovenRespAge = msSince(ovenLastRespTime);
;1684 
;1685   Next.ovenInactive = (ovenRespAge > 3000);
;1686   Next.rfgenInactive = (msSince(rfgenLastRespTime) > 3000);
;1687 
;1688   Next.ovenReadV = readVal[OVEN_READ_V];
;1689   Next.ovenReadA = readVal[OVEN_READ_A];
;1690 
;1691   Next.biasReadV = readVal[BIAS_READ_V];
;1692   Next.biasReadA = readVal[BIAS_READ_A];
;1693 
;1694   Next.sptrReadV = readVal[SPTR_READ_V];
;1695   Next.sptrReadA = readVal[SPTR_READ_A];
;1696 
;1697   Next.biasSetV = biasSetV;
;1698   Next.sptrSetV = sptrSetV;
;1699   Next.rfgenSetV = rfgenSetV;
;1700 
;1701 
;1702 //--- apply range limits to new settings ---
;1703   checkSetValRange(&ovenSetV,  &Next.ovenSetV,  OVEN_SET_V);
;1704   checkSetValRange(&biasSetV,  &Next.biasSetV,  BIAS_SET_V);
;1705   checkSetValRange(&sptrSetV,  &Next.sptrSetV,  SPTR_SET_V);
;1706   checkSetValRange(&rfgenSetV, &Next.rfgenSetV, RFGEN_SET_V);
;1707 
;1708 
;1709 #define CheckThresholds(name, prefix)  
;1710   checkThresholds(name, &prefix##ReadErrStartTime,  
;1711                   &Next.prefix##RuntimeErr, Cur.prefix##RuntimeErr,  
;1712                   prefix##MaxErrV, prefix##MaxErrMS,  
;1713                   Cur.prefix##SetVassert, Next.prefix##ReadV, Next.prefix##
;1714 
;1715 //--- check set/read error against allowed thresholds ---
;1716 //--- (these checks are very time consuming at present) ---
;1717   CheckThresholds("Oven", oven);
;1718   CheckThresholds("Bias", bias);
;1719   CheckThresholds("Sputter", sptr);
;1720 */
;1721 
;1722 
;1723 // Next we do the asynchronous/gate-level type logic.  This logic often has
;1724 // order of execution dependencies so be careful!
;1725 
;1726 /*EXAMPLES:
;1727 //--- ovenPowerOnTime ---
;1728   if (digitalOut & OVEN_PS_OFF)
;1729     ovenPowerOnTime = 0;
;1730   else
;1731     if (!ovenPowerOnTime)  ovenPowerOnTime = GetMS();
;1732 
;1733 //--- Next.ovenModeOn ---
;1734   if (Next.ovenOutErrInterlock)  {
;1735     Next.ovenModeOn = false;
;1736     if (ovenOnCmd)  printf("Oven ON cmd ignored while Interlock exists\r\n"
;1737   }
;1738   else  {
;1739     if (ovenOnCmd)  Next.ovenModeOn = true;
;1740     if (ovenOffCmd)  Next.ovenModeOn = false;
;1741   }
;1742 
;1743 //--- ovenOffCmdTime ---
;1744   if (ovenOnCmd)  ovenOffCmdTime = 0;
;1745   if (ovenOffCmd)  if (!ovenOffCmdTime)  ovenOffCmdTime = GetMS();
;1746 */
;1747 
;1748 
;1749 
;1750 // Next we make a copy of the application state before we apply all the
;1751 // logic that updates the overall state.  This allows us to have a copy of
;1752 // all the relevant values that remain unchanged during the processing,
;1753 // avoiding all kinds of order-of-execution dependencies.
;1754 
;1755 // We also make a copy of the state from last time before overwriting it
;1756 // so we can see if/how values have changed since the last pass
;1757 
;1758 // Note that a copy is done (rather than just switching pointer values) to
;1759 // insure all values are set in both the source and destination.  If we
;1760 // simply kept pointers and swapped the pointer values, then EVERY value
;1761 // would have to be updated independently by the code, which is a pain to
;1762 // program, adds overhead and code, and is a VERY easy way to introduce odd
;1763 // bugs.  Use of pointers would also result in larger, slower code for ever
;1764 // reference to Prev, Cur, and Next.  Overall, copying everything here is
;1765 // actually faster overall, simpler, and much safer.
;1766 
;1767   Prev = Cur;  Cur = Next;
	ld	hl,_curState
	ld	de,_prevState
	push	hl
	ld	bc,12
	ldir
	pop	hl
	ld	hl,_nextState
	ld	de,_curState
	push	hl
	ld	bc,12
	ldir
	pop	hl
;1768 
;1769 
;1770 //--- log msgs for bit chgs only if not starving other processes for cycles
;1771   if (applLoopTime < 14)  logDigIOChgs(false);
	ld	hl,(_applLoopTime)
	ld	de,0xe
	or	a,a
	sbc	hl,de
	jr	nc,@271
	bool	hl
	ld	l,h
	push	hl
	lcall	$logDigIOChgs
	pop	hl
;1772 
;1773 /*EXAMPLES:
;1774   if (Cur.rfgenInactive != Prev.rfgenInactive)
;1775     printf("RF Gen PS %s responding\r\n",
;1776            Cur.rfgenInactive ? "NOT" : "started");
;1777 
;1778   if (Cur.ovenInactive != Prev.ovenInactive)
;1779     printf("Oven PS %s responding\r\n",
;1780            Cur.ovenInactive ? "NOT" : "started");
;1781 
;1782 
;1783   if (rfgenStartCmd)  {
;1784     printf("Start RF Gen PS request\r\n");
;1785     if (Cur.rfgenReady)  printf("RF Gen PS already ON\r\n");
;1786   }
;1787   if (rfgenStopCmd)  {
;1788     printf("Stop RF Gen PS request\r\n");
;1789     if (!Cur.rfgenHeatOn AND !Cur.rfgenReady)
;1790       printf("RF Gen PS already OFF\r\n");
;1791   }
;1792   if (rfgenResetCmd)  printf("Reset RF Gen PS request\r\n");
;1793 */
;1794 
;1795 }
@271:
@268:
	.debug	} @268 1795

@267	equ	0
	lret
@269	equ	0
;1796 
;1797 
;1798 //=========================================================================
;1799 //  Update the values in "Next" based on the "Cur" and "Prev" values.
;1800 //
;1801 //  Be sure to read the "NOTES on Locking" section above....
;1802 //=========================================================================
;1803 //
;1804 //  This function contains the Synchronous logic used to compute the next
;1805 //  state we want the controller to be in.
;1806 //
;1807 //  A few simple rules that apply to all the values used by this function:
;1808 //
;1809 //    - All values changed within this function are "outputs"
;1810 //
;1811 //    - Every value read by this function is an "input"
;1812 //
;1813 //    - There must be no overlap between inputs and outputs
;1814 //
;1815 //    - The output values from this function must not be altered outside of
;1816 //      this function.
;1817 //
;1818 //  Any global variable can be an input OR an output, but they must NEVER
;1819 //  serve both purposes.  Most inputs come from Prev or Cur, while most
;1820 //  outputs are in Next.  If the logic requires detecting a change in a
;1821 //  value between passes (edge-triggered logic), then the value should be
;1822 //  part of the ApplState structure so we can compare its Prev and Cur valu
;1823 //
;1824 //  Following these simple rules allows the code to be organized as small,
;1825 //  self-contained blocks, with well-defined inputs and outputs.  Furthermo
;1826 //  there are no order-of-execution dependencies between blocks of code.  T
;1827 //  blocks can be executed in any order:  The result will always be the sam
;1828 //
;1829 //
;1830 //  Each output value (or VERY small "set" of output values) must be update
;1831 //  in a single, self-contained block of code.  NO output may be referenced
;1832 //  OR altered in ANOTHER block of code:  This is a declarative, data-orien
;1833 //  style of programming and has many advantages including:
;1834 //
;1835 //     - There are no order-of-execution dependencies across nodes/blocks
;1836 //       within a pass.  They can be executed in any order and the result
;1837 //       will be the same (get used to it - this method will be the norm as
;1838 //       computer languages and hardware add support for atomic transaction
;1839 //       and computers evolve in to neural-net-like processor arrays - FPGA
;1840 //       are just the beginning of this trend).
;1841 //
;1842 //     - Encapsulating all logic for an output within a single node/block
;1843 //       leaves just one place to start when tracking a problem backward fr
;1844 //       the result.  Far simpler than debugging code structured around the
;1845 //       traditional process/event-driven approach which can contain numero
;1846 //       independent paths of execution leading to an observed result.
;1847 //
;1848 //  Each node/block-of-code should be prefaced with the following informati
;1849 //   - The name(s) of the value(s) it modifies
;1850 //   - A descr of the meaning of the value(s) and the logic used
;1851 //   - A list of the values that serve as "inputs" to the node
;1852 //
;1853 //=========================================================================
;1854 void updateNextState(void)
;1855 {
$updateNextState::
	.debug	G $updateNextState 57 9
	.debug	{ $updateNextState 57 1854 @274 @273
;1856 
;1857   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
;1858 
;1859 //APPLCODE
;1860 
;1861 /* ===== EXAMPLES =====
;1862 
;1863 ====== ON/OFF/Reset state =======
;1864 //--------------------------------------------------------------------
;1865 // Next.state
;1866 // Next.onRequest, Next.offRequest, Next.resetRequest (resets)
;1867 //    Description:
;1868 //       Determines the next state of for the application logic
;1869 //       (STATE_ON, STATE_OFF, STATE_INTLK)
;1870 //    Inputs:
;1871 //       Cur.onRequest
;1872 //       Cur.offRequest
;1873 //       Cur.resetRequest
;1874 //       Cur.externIntlk
;1875 //       Cur.bulkSup[]
;1876 //       holecOK
;1877 //       psReady
;1878 //----------------------------------------------------------------------
;1879 //--- chg state from OFF to ON? ---
;1880   if (Cur.onRequest)  do  {
;1881     Next.onRequest = false;
;1882     if (!supplyType)  {
;1883       printf("Must set supplyType 1st!\n");  break;  }
;1884     if ((Cur.state == STATE_INTLK) OR Cur.externIntlk)  {
;1885       printf("Must clear Interlock first\n\n");  break; }
;1886     if (Cur.state == STATE_ON)  { printf("Already ON\n\n");  break; }
;1887     Next.state = STATE_ON;  printf("Turning ON\n\n");
;1888   } while(0);
;1889 
;1890 //--- chg state from ON to OFF? ---
;1891   if (Cur.offRequest)  do {
;1892     Next.offRequest = false;
;1893     if ((Cur.state == STATE_INTLK) OR Cur.externIntlk)  {
;1894       printf("Must clear Interlock first\n\n");  break; }
;1895     if (Cur.state == STATE_OFF)  { printf("Already OFF\n\n");  break; }
;1896     Next.state = STATE_OFF;  printf("Turning OFF\n\n");
;1897   } while(0);
;1898 
;1899 //--- chg state from INTLK to OFF? ---
;1900   if (Cur.resetRequest)  do {
;1901     Next.resetRequest = false;
;1902     if (Cur.state != STATE_INTLK)  {
;1903       printf("No Interlock to clear\n\n");  break;  }
;1904     if (Cur.externIntlk)  {
;1905       printf("External Interlock still exists\n\n");  break; }
;1906     Next.state = STATE_OFF;  printf("Interlock cleared\n\n");
;1907   } while(0);
;1908 
;1909 //--- chg state to INTLK due to external interlock? ---
;1910   if (Cur.externIntlk OR !holecOK)  do {
;1911     if (Cur.state == STATE_INTLK)  break;
;1912     Next.state = STATE_INTLK;
;1913   } while(0);
;1914 //--- change state to INTLK due to a bulk supply error? ---
;1915   for (ui=0; ui<NumPS; ++ui)  if (Cur.bs[ui].error)  Next.state = STATE_INT
;1916 
;1917 
;1918 ====== Pulse a digital output =====
;1919 //--------------------------------------------------------------------
;1920 // Next.rfgenResetTime
;1921 //    Description:
;1922 //       The time a pulse was started to RESET the RF Gen supply.
;1923 //    Inputs:
;1924 //       cmdBitsAppl
;1925 //--------------------------------------------------------------------
;1926   if (cmdBitsAppl & CBA_RFGenReset)  Next.rfgenResetTime = GetMS();
;1927   if (msSince(Next.rfgenResetTime) >= 500)  Next.rfgenResetTime = 0;
;1928 
;1929 */
;1930 
;1931 
;1932 }
@273:
	.debug	} @273 1932

@272	equ	0
	lret
@274	equ	0
;1933 
;1934 
;1935 
;1936 //=========================================================================
;1937 //  Next we update output signal values to be written to the outputs at
;1938 //  the beginning of the next pass (just after the inputs are read).
;1939 //
;1940 //  Be sure to read the "NOTES on Locking" section above....
;1941 //=========================================================================
;1942 void updateOutputState(void)
;1943 {
$updateOutputState::
	.debug	G $updateOutputState 57 9
	.debug	{ $updateOutputState 57 1942 @278 @277
;1944   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
;1945 
;1946 //APPLCODE
;1947 
;1948 //--- update output values that are based on current conditions (values ---
;1949 //--- in "Cur" or any values used in a conditional in the applic logic) ---
;1950 
;1951 // NOTE:  Do NOT clear all the bits of a bit-mapped value unless you are
;1952 //        going to check the state of every bit every time (i.e. clearing
;1953 //        every bit and then forgetting about some macro or piece of code
;1954 //        shared by multiple applications to manage a bit is an easy way
;1955 //        to mess things up - so do NOT touch bits that aren't specifically
;1956 //        handled by the function that clears them!
;1957 
;1958 /* ===== EXAMPLES =====
;1959 
;1960   // (insured earlier that only ONE of these can be true when setting them)
;1961   if (initialBtnPressed)  setVal[FP_METER] = rfOffSetpoint;  else
;1962   if (finalBtnPressed)    setVal[FP_METER] = rfOnSetpoint;  else
;1963                           setVal[FP_METER] = cavityVolts;
;1964 
;1965 
;1966   SetOffApplLEDs(Next.digitalOut);
;1967 
;1968   if (limited)  SetOnLimitLED(Next.digitalOut);
;1969   if (regErr)   SetOnErrorLED(Next.digitalOut);
;1970 
;1971 
;1972 //--- update output values based on values that were set by the application
;1973 //--- logic (e.g. values in "Next" or variables that are the target of an -
;1974 //--- assignment statement in the application logic) ---
;1975 
;1976   setVal[CTL_VOLTS] = Next.ctlVolts;  // ctl voltage to DC Servo amplifier
;1977 
;1978   setVal[EXTERN_METER] = Next.meterValue;
;1979 */
;1980 
;1981 }
@277:
	.debug	} @277 1981

@276	equ	0
	lret
@278	equ	0
;1982 
;1983 
;1984 
;1985 
;1986 //=========================================================================
;1987 // The last thing we do is update values read by other tasks
;1988 //
;1989 //  Be sure to read the "NOTES on Locking" section above....
;1990 //=========================================================================
;1991 void updateExternals(void)
;1992 {
$updateExternals::
	.debug	G $updateExternals 57 9
	.debug	{ $updateExternals 57 1991 @282 @281
;1993   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@281
;1994 
;1995   digInBits = Cur.digitalIn;
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
;1996   digOutBits = Cur.digitalOut;
	ld	de,(_curState+8)
	ld	bc,(_curState+10)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
;1997 
;1998 //APPLCODE
;1999 
;2000 /*Example
;2001   iset = Cur.iset;
;2002   polCmd = Cur.polCmd;
;2003   ampApply = Cur.ampApply;
;2004 
;2005   state = Cur.state;
;2006 
;2007   ampSet = Cur.ampSet;
;2008 
;2009 
;2010   vctrlStatus = (Cur.regPol ? 1 : 0);
;2011   vctrlStatus |= (Cur.hystRegPol ? 2 : 0);
;2012 
;2013   digInBits = Cur.digitalIn;
;2014 
;2015   psCount = Cur.psCount;
;2016 
;2017   ifdbk = Cur.ifdbk;
;2018   vout = Cur.vout;
;2019   vctrl = Cur.vctrl;
;2020   vlim = Cur.vlim;
;2021 
;2022   outMode = Cur.outMode;
;2023 
;2024 
;2025   for (ui=0; ui<NumPS;  ++ui)  {
;2026     bsCur = Cur.bs + ui;
;2027 
;2028     *bsvX[ui] = Cur.biasVolts;
;2029     *ampsX[ui] = Cur.current;
;2030 
;2031     bsState = 0;
;2032 
;2033     if (Cur.isOn)      bsState |= PS_IS_ON;
;2034     if (Cur.isAvail)   bsState |= PS_AVAIL;
;2035     if (Cur.tempOK)    bsState |= PS_TEMP_OK;
;2036     if (!Cur.biasErr)  bsState |= PS_BIAS_OK;
;2037 
;2038     if (Cur.setOn)     bsState |= PS_SET_ON;
;2039     if (Cur.enabled)   bsState |= PS_ENABLED;
;2040 
;2041     PS_STATE(ui) = bsState;
;2042   }
;2043 */
;2044 
;2045 }
@281:
	.debug	} @281 2045

@280	equ	0
	lret
@282	equ	0
;2046 
;2047 
;2048 
;2049 //=========================================================================
;2050 _nearcall float readGetRaw(uint ui)  {
	.align	4
$$readGetRaw::
	ex	(sp),iy
$readGetRaw::
	.debug	G $readGetRaw 73 9
	.debug	{ $readGetRaw 73 2050 @286 @285
	push	ix
	ld	ix,0
	add	ix,sp
;2051   return (ui < NumHdwADC ? anaIn[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@287
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@285
@287:
	ld	de,0
	ld	c,e
	ld	b,e
@285:
	.debug	} @285 2051

@284	equ	0
	pop	ix
	lret
@286	equ	2
;2052 
;2053 _nearcall float readMinRaw(uint ui)  {
	.align	4
$$readMinRaw::
	ex	(sp),iy
$readMinRaw::
	.debug	G $readMinRaw 73 9
	.debug	{ $readMinRaw 73 2053 @291 @290
	push	ix
	ld	ix,0
	add	ix,sp
;2054   return (ui < NumHdwADC) ? (adcMinRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@292
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@290
@292:
	ld	de,0
	ld	c,e
	ld	b,e
@290:
	.debug	} @290 2054

@289	equ	0
	pop	ix
	lret
@291	equ	2
;2055 
;2056 _nearcall float readMaxRaw(uint ui)  {
	.align	4
$$readMaxRaw::
	ex	(sp),iy
$readMaxRaw::
	.debug	G $readMaxRaw 73 9
	.debug	{ $readMaxRaw 73 2056 @296 @295
	push	ix
	ld	ix,0
	add	ix,sp
;2057   return (ui < NumHdwADC) ? (adcMaxRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@297
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@295
@297:
	ld	de,0xcccd
	ld	bc,0x411c
@295:
	.debug	} @295 2057

@294	equ	0
	pop	ix
	lret
@296	equ	2
;2058 
;2059 _nearcall void readDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$readDefaults::
	ex	(sp),iy
$readDefaults::
	.debug	G $readDefaults 74 9
	.debug	{ $readDefaults 74 2059 @301 @300
	push	ix
	ld	ix,0
	add	ix,sp
;2060   *gain = 1.0;  *offset = 0.0; }
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@300:
	.debug	} @300 2060

@299	equ	0
	pop	ix
	lret
@301	equ	2
;2061 
;2062 _nearcall void readCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$readCalibPoints::
	ex	(sp),iy
$readCalibPoints::
	.debug	G $readCalibPoints 74 9
	.debug	{ $readCalibPoints 74 2062 @304 @303
	push	ix
	ld	ix,0
	add	ix,sp
;2063   *low = -9.5;  *high = 9.5; }
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@303:
	.debug	} @303 2063

@302	equ	0
	pop	ix
	lret
@304	equ	2
;2064 
;2065 _nearcall char *readUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$readUnits::
	ex	(sp),iy
$readUnits::
	.debug	G $readUnits 75 9
	.debug	{ $readUnits 75 2065 @307 @306
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+126
@306:
	.debug	} @306 2065

@305	equ	0
	pop	ix
	lret
@307	equ	2
;2066 
;2067 
;2068 //=========================================================================
;2069 _nearcall float setGetRaw(uint ui)  {
	.align	4
$$setGetRaw::
	ex	(sp),iy
$setGetRaw::
	.debug	G $setGetRaw 73 9
	.debug	{ $setGetRaw 73 2069 @310 @309
	push	ix
	ld	ix,0
	add	ix,sp
;2070   return (ui < NumHdwADC ? anaOut[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@311
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@309
@311:
	ld	de,0
	ld	c,e
	ld	b,e
@309:
	.debug	} @309 2070

@308	equ	0
	pop	ix
	lret
@310	equ	2
;2071 
;2072 _nearcall float setMinRaw(uint ui)  {
	.align	4
$$setMinRaw::
	ex	(sp),iy
$setMinRaw::
	.debug	G $setMinRaw 73 9
	.debug	{ $setMinRaw 73 2072 @315 @314
	push	ix
	ld	ix,0
	add	ix,sp
;2073   return (ui < NumHdwDAC) ? (dacMinRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@316
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@314
@316:
	ld	de,0
	ld	c,e
	ld	b,e
@314:
	.debug	} @314 2073

@313	equ	0
	pop	ix
	lret
@315	equ	2
;2074 
;2075 _nearcall float setMaxRaw(uint ui)  {
	.align	4
$$setMaxRaw::
	ex	(sp),iy
$setMaxRaw::
	.debug	G $setMaxRaw 73 9
	.debug	{ $setMaxRaw 73 2075 @320 @319
	push	ix
	ld	ix,0
	add	ix,sp
;2076   return (ui < NumHdwDAC) ? (dacMaxRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@321
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@319
@321:
	ld	de,0xcccd
	ld	bc,0x411c
@319:
	.debug	} @319 2076

@318	equ	0
	pop	ix
	lret
@320	equ	2
;2077 
;2078 _nearcall void setDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$setDefaults::
	ex	(sp),iy
$setDefaults::
	.debug	G $setDefaults 74 9
	.debug	{ $setDefaults 74 2078 @325 @324
	push	ix
	ld	ix,0
	add	ix,sp
;2079   *gain = 1.0;  *offset = 0.0;  }
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@324:
	.debug	} @324 2079

@323	equ	0
	pop	ix
	lret
@325	equ	2
;2080 
;2081 _nearcall void setCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$setCalibPoints::
	ex	(sp),iy
$setCalibPoints::
	.debug	G $setCalibPoints 74 9
	.debug	{ $setCalibPoints 74 2081 @328 @327
	push	ix
	ld	ix,0
	add	ix,sp
;2082   *low = -9.5;  *high = 9.5;  }
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@327:
	.debug	} @327 2082

@326	equ	0
	pop	ix
	lret
@328	equ	2
;2083 
;2084 _nearcall char *setUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$setUnits::
	ex	(sp),iy
$setUnits::
	.debug	G $setUnits 75 9
	.debug	{ $setUnits 75 2084 @331 @330
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+126
@330:
	.debug	} @330 2084

@329	equ	0
	pop	ix
	lret
@331	equ	2
;2085 
;2086 
;2087 //=========================================================================
;2088 //  Set default labels for all the I/O signals
;2089 //=========================================================================
;2090 void setDefaultLabels(void)
;2091 {
$setDefaultLabels::
	.debug	G $setDefaultLabels 57 9
	.debug	{ $setDefaultLabels 57 2090 @334 @333
;2092   printf("Setting default labels for I/O signals\r\n");
	ld	de,word (phys @1+2304)
	ld	c,phys @1+2304 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2093 
;2094 //--- set application-appropriate default labels ---
;2095 //APPLCODE
;2096 
;2097 //--- set default labels for the I/O signals ---
;2098 //--- Fixed size arrays are used so the values can be changed at run time -
;2099 //--- (i.e. if pointers where used instead, and initialized to const string
;2100 //--- values, then we couldn't change them at run time) ---
;2101 /*
;2102   fstrcpy(ainLabel[0], "ai0-Descr");
;2103   fstrcpy(ainLabel[1], "ai1-Descr");
;2104 
;2105   fstrcpy(aoutLabel[0], "ao0-Descr");
;2106   fstrcpy(aoutLabel[1], "ao1-Descr");
;2107 
;2108   fstrcpy(dinLabel[0], "di0-Descr");
;2109   fstrcpy(dinLabel[1], "di1-Descr");
;2110 
;2111   fstrcpy(doutLabel[0], "do0-Descr");
;2112   fstrcpy(doutLabel[1], "do1-Descr");
;2113 */
;2114 }
@333:
	.debug	} @333 2114

@332	equ	0
	lret
@334	equ	0
;2115 
;2116 
;2117 //=========================================================================
;2118 //  This function is called to force software configurable values to defaul
;2119 //  values.
;2120 //=========================================================================
;2121 void setDefaultConfig(void)
;2122 {
$setDefaultConfig::
	.debug	G $setDefaultConfig 57 9
	.debug	{ $setDefaultConfig 57 2121 @337 @336
;2123   printf("Setting in-RAM device config to default values\r\n");
	ld	de,word (phys @1+2345)
	ld	c,phys @1+2345 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2124 
;2125 //===== set default values for persistent data values =====
;2126 //APPLCODE
;2127 
;2128 }
@336:
	.debug	} @336 2128

@335	equ	0
	lret
@337	equ	0
;2129 
;2130 
;2131 //=========================================================================
;2132 //  This function is called by the application loop just before a shutdown.
;2133 //  The appliation must do whatever is necessary for a clean shutdown and
;2134 //  then exit
;2135 //=========================================================================
;2136 void applicShutdown(void)
;2137 {
$applicShutdown::
	.debug	G $applicShutdown 57 9
	.debug	{ $applicShutdown 57 2136 @340 @339
;2138   printf("Application prepping for shutdown\r\n");  fflush(stdout);
	ld	de,word (phys @1+2394)
	ld	c,phys @1+2394 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;2139 
;2140 //APPLCODE
;2141 
;2142 
;2143   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;2144 }
@339:
	.debug	} @339 2144

@338	equ	0
	lret
@340	equ	0
;2145 
;2146 
;2147 //=========================================================================
;2148 //  This is the highest priority task, usually resumed at a regular interva
;2149 //  so that it can do what it needs and sleep again until the start of the
;2150 //  next interval.
;2151 //=========================================================================
;2152 void _task applic(int argc, char **argv)
;2153 {
	.align	4
$$applic::
	ex	(sp),iy
$applic::
	.debug	G $applic 71 9
	.debug	{ $applic 71 2152 @343 @342
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-114
;2154   #define SharedApplLocals
;2155   #include <sharedAppl.c>
;2156 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;2157 //--- add local variable definitions here ---
;2158 //APPLCODE
;2159 
;2160 
;2161   #define SharedApplLocals2
;2162   #include <sharedAppl.c>
;2163 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;2164 
;2165 
;2166   #define SharedApplInit
;2167   #include <sharedAppl.c>
;2168 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_prevState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_curState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	ld	(_numScopeRegs),hl
	lcall	$resetWDT
	ld	de,0xff
	ld	c,d
	ld	b,d
	ld	(_ADC_Mask),de
	ld	(_ADC_Mask+2),bc
	ld	de,0xf
	ld	(_DAC_Mask),de
	ld	(_DAC_Mask+2),bc
	ld	e,c
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@346:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@347
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$adcDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,0xbad
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@346
@347:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@353:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@354
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$dacDefaults
	add	sp,6
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@353
@354:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@360:
	ld	hl,(ix-24)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@361
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$readDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	z,@366
	jr	nc,@365
@366:
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
@365:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@360
@361:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@369:
	ld	hl,(ix-24)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@370
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$setDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	z,@375
	jr	nc,@374
@375:
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
@374:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@369
@370:
	lcall	$setGenericLabels
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
	push	hl
	ld	hl,-46+@341
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
	ld	de,word (phys @1+2430)
	ld	c,phys @1+2430 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$initModBusRegs
	ld	hl,0xf9
	ld	(_devType),hl
	ld	hl,_netmask
	push	hl
	ld	hl,@2+128
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	ld	hl,_gateway
	push	hl
	ld	hl,@2+140
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	ld	hl,@2+152
	push	hl
	lcall	$mkfifo
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x21
	push	hl
	ld	hl,@2+152
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-38),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	(_lastCtlLoopTime),hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	lcall	$setDefaultLabels
	lcall	$setDefaultConfig
	lcall	$initIOvalues
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@376
	lcall	$restoreApplState
	ld	(ix-36),hl
	bool	hl
	jr	z,@379
	ld	hl,(ix-36)
	push	hl
	ld	de,word (phys @1+2455)
	ld	c,phys @1+2455 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@382
	xor	a,a
	ld	(_runBackup),a
@382:
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@379:
	ld	a,0x1
	ld	(_restoredApplState),a
@376:
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$initParamModule
	add	sp,4
	ld	a,(_restoredApplState)
	or	a,a
	jr	nz,@383
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_curState+4),de
	ld	(_curState+6),bc
	ld	(_prevState+4),de
	ld	(_prevState+6),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_nextState+8),de
	ld	(_nextState+10),bc
	ld	(_curState+8),de
	ld	(_curState+10),bc
	ld	(_prevState+8),de
	ld	(_prevState+10),bc
@383:
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetUp
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
@386:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@388
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@388
	lcall	$resetWDT
	jp	@386
@388:
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@389
	ld	de,word (phys @1+2514)
	ld	c,phys @1+2514 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@390
@389:
	bool	hl
	ld	l,h
	push	hl
	lcall	$showNetState
	pop	hl
@390:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@393:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@394
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@393
@394:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@398:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@399
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
;2169 //--- At this point generic initialization has been done which includes ---
;2170 //--- the following: ---
;2171 //      - The Prev, Cur, and Next ApplState objects have been zeroed
;2172 //      -
;2173 
;2174 
;2175 //--- add application initialization code here ---
;2176 //APPLCODE
;2177 
;2178 
;2179   #define SharedApplInit2
;2180   #include <sharedAppl.c>
;2181 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@398
@399:
	lcall	$resetWDT
	ld	hl,0x1
	push	hl
	lcall	$logDigIOChgs
	pop	hl
	ld	hl,@2+163
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@341
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,_inetd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+169
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@341
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,_configd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+177
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@341
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_backupd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+185
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@341
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,0x5dc
	ld	(ix-34),hl
	lcall	$resetWDT
	bool	hl
	ld	l,h
	ld	(_applicTicks),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	bool	hl
	ld	l,h
	ld	(_applLoopTime),hl
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+2555)
	ld	c,phys @1+2555 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,0x1
	ld	(_startupComplete),a
;2182 
;2183 //--- The following loop is run at a periodic interval (normally 100 times 
;2184 //--- per second, or every 10ms).  The application process normally ---
;2185 //--- consists of reading the current state of the digital and analog ---
;2186 //--- inputs, changing the state of the analog and digital outputs to the -
;2187 //--- values computed during the previous pass, then computing new values -
;2188 //--- for the outputs and updating values that outside clients can view ---
;2189 //--- (currently accessable as a set of ModBus registers) ---
;2190 
;2191   for (;;)  {
@403:
;2192     #define SharedApplLoopStart
;2193     #include <sharedAppl.c>
;2194 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(_applicTicks)
	inc	hl
	ld	(_applicTicks),hl
	ld	hl,(ix-34)
	bool	hl
	jr	z,@408
	ld	hl,(ix-34)
	dec	hl
	ld	(ix-34),hl
	bool	hl
	jr	nz,@409
	xor	a,a
	ld	(_runBackup),a
@409:
@408:
	lcall	$resetWDT
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_applLoopTime),hl
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	ipset	2
	ld	a,(_intTicks)
	bool	hl
	ld	l,a
	ld	(_latency),hl
	ipres
	ld	hl,(_ctlLoopTicks)
	inc	hl
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	de,(_lastCtlLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jr	c,@410
	ld	hl,(_ctlLoopTicks)
	or	a,a
	rr	hl
	ld	(_ctlLoopTicksPerSec),hl
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	(_lastCtlLoopTime),hl
;2195 
;2196   //--- read the current state of the analog and digital Input signals, and
;2197   //--- write the values computed at the end of the last pass ---
;2198     digitalOut = Next.digitalOut;  rwIO();
@410:
	ld	de,(_nextState+8)
	ld	bc,(_nextState+10)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	lcall	$rwIO
;2199 
;2200   //--- process next event message (if any) ---
;2201     processMsg(eventsfd, (EventMsg *)buf, sizeof(buf));
	ld	hl,0x40
	push	hl
	ld	hl,-112+@341
	add	hl,sp
	push	hl
	ld	hl,(ix-38)
	push	hl
	lcall	$processMsg
	add	sp,6
;2202 
;2203   //--- update the current state and determine the next state ---
;2204     updateCurState();  updateNextState();
	lcall	$updateCurState
	lcall	$updateNextState
;2205     updateOutputState();  updateExternals();
	lcall	$updateOutputState
	lcall	$updateExternals
;2206 
;2207 
;2208     #define SharedApplLoopEnd
;2209     #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastIdleTime)
	or	a,a
	sbc	hl,de
	ld	(ix-28),hl
	ld	de,0xbb8
	or	a,a
	sbc	hl,de
	jr	c,@413
	ld	hl,(_idleTask)
	ld	de,0xd3
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,(_lastIdleMS)
	ld	bc,(_lastIdleMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ulmlt##
	ld	hl,(ix-28)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	(_percentIdle),de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
@413:
	ld	hl,(_devType)
	ld	(_devType_),hl
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_deviceID_),de
	ld	(_deviceID_+2),bc
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	(_upSecs),de
	ld	(_upSecs+2),bc
	ld	hl,(_percentIdle)
	ld	(_percentIdle_),hl
	ld	hl,(_timeZone)
	ld	(_timeZone_),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
	ld	hl,-48+@341
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@416
	ld	l,0xf
	push	hl
	ld	hl,-46+@341
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@417
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	nz,@418
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@418:
@417:
@416:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	z,@420
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f40
	ld	bc,0
	call	__lsub##
	jr	c,@420
	jr	z,@420
	lcall	$applicShutdown
@420:
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,0x40
	and	hl,de
	jr	z,@421
	ld	de,(_nextState+8)
	ld	bc,(_nextState+10)
	res	0,d
	ld	(_nextState+8),de
	ld	(_nextState+10),bc
	jr	@422
@421:
	ld	de,(_nextState+8)
	ld	bc,(_nextState+10)
	set	0,d
	ld	(_nextState+8),de
	ld	(_nextState+10),bc
@422:
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@423
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-32),hl
	ipres
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-22),hl
	ld	hl,(_scopeList)
	ld	(ix-50),hl
@428:
	ld	hl,(ix-22)
	ld	de,(_numScopeRegs)
	or	a,a
	sbc	hl,de
	jp	nc,@429
	ld	hl,(ix-50)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-30),hl
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@433
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst2##
	jp	@434
@433:
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
@434:
	ld	hl,(ix-30)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-22)
	inc	hl
	ld	(ix-22),hl
	add	hl,hl
	ld	de,_scopeList
	add	hl,de
	ld	hl,(hl)
	ld	(ix-50),hl
	jp	@428
@429:
	ld	de,(_captureCount)
	ld	bc,(_captureCount+2)
	call	__linc##
	ld	(_captureCount),de
	ld	(_captureCount+2),bc
	ld	hl,(_captureIdx)
	inc	hl
	ld	(_captureIdx),hl
	ld	de,(_scopeBufSampleSize)
	or	a,a
	sbc	hl,de
	jr	nz,@435
	bool	hl
	ld	l,h
	ld	(_captureIdx),hl
	ld	de,(_scopeBuf)
	ld	bc,(_scopeBuf+2)
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@435:
@423:
	ld	a,0x1
	ld	(_applicReady),a
;2210   }
;2211 
;2212 }
	jp	@403
@342:
	.debug	} @342 2212

@341	equ	114
	ld	sp,ix
	pop	ix
	lret
@343	equ	116
;2213 
;2214 
;2215 //=========================================================================
;2216 //  list of application-specific commands that are normally entered via a
;2217 //  user shell
;2218 //=========================================================================
;2219 //void _task nsclSeriald(int argc, char **argv);
;2220 
;2221 //--- add any application-specific commands here ---
;2222 //APPLCODE
;2223 const CmdInfo far applCmds[] = {
;2224 //  { "misc",        miscTest,       "..." },
;2225   { "cmd",       cmd,         "Application-specific commands" },
	.seg	CONST
_applCmds::
	.dw	word (phys @1+2574)
	.dw	phys @1+2574 >> 16
	.dw	word _cmd
	.dw	word (phys @1+2578)
	.dw	phys @1+2578 >> 16
;2226   { "sem_test",  sem_test,    "Test POSIX-style semaphore funcs" },
	.dw	word (phys @1+2608)
	.dw	phys @1+2608 >> 16
	.dw	word _sem_test
	.dw	word (phys @1+2617)
	.dw	phys @1+2617 >> 16
;2227   { "state",     showState,   "Show state of controller" }
	.dw	word (phys @1+2650)
	.dw	phys @1+2650 >> 16
	.dw	word _showState
	.dw	word (phys @1+2656)
	.dw	phys @1+2656 >> 16
;2228 };
	.debug	G _applCmds 77 8
;2229 
;2230 int const NumApplCmds = ( sizeof(applCmds) / sizeof(CmdInfo) );
_NumApplCmds::
	.dw	0x3
	.debug	G _NumApplCmds 6 0
;2231 
;2232 //-------------------------------------------------------------------------
;2233 
;2234 #endif
	.extern	$time 79
	.extern	_memset 80
	.extern	_strlen 82
	.extern	$fmemcpy 83
	.extern	_fmemset 85
	.extern	$clockTicks 86
	.extern	$memCRC16 87
	.extern	$stdHeader 57
	.extern	$showNetState 88
	.extern	$CheckETX 61
	.extern	$compileTime 89
	.extern	$processMsg 90
	.extern	$inet_ptoh 91
	.extern	_clsCmd 92
	.extern	$sigismember 93
	.extern	$sigprocmask 94
	.extern	$sigpending 95
	.extern	_current 96
	.extern	_idleTask 96
	.extern	_applTask 96
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 57
	.extern	__stdio 98
	.extern	$farfprintf 100
	.extern	$farprintf 101
	.extern	$farsprintf 102
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 103
	.extern	$xavail 86
	.extern	$strtol 104
	.extern	_updateAIn 92
	.extern	_updateAOut 92
	.extern	_adcGain 105
	.extern	_adcOffset 105
	.extern	_dacGain 105
	.extern	_dacOffset 105
	.extern	_aoutMin 105
	.extern	_aoutMax 105
	.extern	_anaIn 105
	.extern	_anaOut 105
	.extern	_lastAnaOut 105
	.extern	_adcRaw 106
	.extern	_dacRaw 106
	.extern	_lastadcRaw 106
	.extern	_newRdg 92
	.extern	_adcForced 92
	.extern	_dacForced 92
	.extern	_adcForcedVal 105
	.extern	_dacForcedVal 105
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.bseg
_readGain::
	.ds	32
	.debug	G _readGain 107 0
_readOffset::
	.ds	32
	.debug	G _readOffset 107 0
_setGain::
	.ds	16
	.debug	G _setGain 108 0
_setOffset::
	.ds	16
	.debug	G _setOffset 108 0
_readVal::
	.ds	32
	.debug	G _readVal 107 0
_setVal::
	.ds	16
	.debug	G _setVal 108 0
_lastSetVal::
	.ds	16
	.debug	G _lastSetVal 108 0
	.extern	_digitalIn 9
	.extern	_digitalOut 9
	.defseg	FARBSS
	.seg	FARBSS
_ainLabel::
	.ds	192
	.debug	G _ainLabel 109 8
_aoutLabel::
	.ds	96
	.debug	G _aoutLabel 111 8
_dinLabel::
	.ds	384
	.debug	G _dinLabel 112 8
_doutLabel::
	.ds	384
	.debug	G _doutLabel 112 8
_extraInLabel::
	.ds	768
	.debug	G _extraInLabel 113 8
	.extern	$initIOvalues 57
	.extern	$ReadDigInputs 86
	.extern	$WriteDigOutputs 114
	.extern	$ReadDeviceID 86
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 115
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 115
	.extern	$writeAnalogOutputs 114
	.extern	$readAnalogInputs 114
	.extern	$updateAvgsADC 57
	.extern	$open 116
	.extern	$fflush 117
	.extern	_KLOCK 57
	.extern	_KUNLOCK 57
	.extern	$resetWDT 57
	.extern	_hostName 118
	.bseg
_ctlLoopTicksPerSec::
	.ds	2
	.debug	G _ctlLoopTicksPerSec 7 0
	.extern	_prevLogInfo 119
	.extern	_runBackup 3
	.extern	_runningPrimary 3
	.extern	_doReboot 3
	.extern	_doShutdown 3
	.extern	_diagLog 99
	.extern	_intTicks 3
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_hdwType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$REBOOT 58
	.extern	$createProc 120
	.extern	$sleepMS 121
	.extern	$waitpid 122
	.extern	$Exit 88
	.extern	$SetHostName 123
	.extern	$sem_wait_ 124
	.extern	$sem_open 125
	.extern	$sem_close 128
	.extern	$sem_timedwait 129
	.extern	$sem_trywait 128
	.extern	$sem_post 128
	.extern	$sem_getvalue 130
	.extern	$sem_unlink 82
_C0ChanMult::
	.ds	2
	.debug	G _C0ChanMult 7 0
_NumC0Chans::
	.ds	2
	.debug	G _NumC0Chans 7 0
_R3ChanMult::
	.ds	2
	.debug	G _R3ChanMult 7 0
_NumR3Chans::
	.ds	2
	.debug	G _NumR3Chans 7 0
_R4ChanMult::
	.ds	2
	.debug	G _R4ChanMult 7 0
_NumR4Chans::
	.ds	2
	.debug	G _NumR4Chans 7 0
	.extern	_numScopeRegs 7
	.extern	_captureIdx 7
	.extern	_scopeBufSampleSize 7
	.extern	_captureCount 9
	.extern	_scopeList 131
	.extern	_scopeBuf 45
	.extern	_capturePtr 45
	.cseg
_setU16:
	pop	iy
	lcall	$$setU16
	.extern	$$setU16
	.extern	$setU16 56
_setU32:
	pop	iy
	lcall	$$setU32
	.extern	$$setU32
	.extern	$setU32 56
	.extern	$pvInitLists 61
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.extern	$$modbusTCPd
	.extern	$modbusTCPd 71
	.bseg
_DoReboot::
	.ds	1
	.debug	G _DoReboot 3 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.extern	$$setCoil
	.extern	$setCoil 132
	.bseg
_dlmVersTime::
	.ds	4
	.debug	G _dlmVersTime 9 0
_dlmVersTime_ChgEventVal::
	.ds	4
	.debug	G _dlmVersTime_ChgEventVal 9 0
_dlmVersTime_MinChg::
	.ds	4
	.debug	G _dlmVersTime_MinChg 9 0
_rtosVersTime::
	.ds	4
	.debug	G _rtosVersTime 9 0
_rtosVersTime_ChgEventVal::
	.ds	4
	.debug	G _rtosVersTime_ChgEventVal 9 0
_rtosVersTime_MinChg::
	.ds	4
	.debug	G _rtosVersTime_MinChg 9 0
_applVersTime::
	.ds	4
	.debug	G _applVersTime 9 0
_applVersTime_ChgEventVal::
	.ds	4
	.debug	G _applVersTime_ChgEventVal 9 0
_applVersTime_MinChg::
	.ds	4
	.debug	G _applVersTime_MinChg 9 0
_devType_::
	.ds	2
	.debug	G _devType_ 5 0
_devType__ChgEventVal::
	.ds	2
	.debug	G _devType__ChgEventVal 5 0
_devType__MinChg::
	.ds	2
	.debug	G _devType__MinChg 5 0
_deviceID_::
	.ds	4
	.debug	G _deviceID_ 9 0
_deviceID__ChgEventVal::
	.ds	4
	.debug	G _deviceID__ChgEventVal 9 0
_deviceID__MinChg::
	.ds	4
	.debug	G _deviceID__MinChg 9 0
_upSecs::
	.ds	4
	.debug	G _upSecs 9 0
_upSecs_ChgEventVal::
	.ds	4
	.debug	G _upSecs_ChgEventVal 9 0
_upSecs_MinChg::
	.ds	4
	.debug	G _upSecs_MinChg 9 0
_percentIdle_::
	.ds	2
	.debug	G _percentIdle_ 5 0
_percentIdle__ChgEventVal::
	.ds	2
	.debug	G _percentIdle__ChgEventVal 5 0
_percentIdle__MinChg::
	.ds	2
	.debug	G _percentIdle__MinChg 5 0
_numChans::
	.ds	2
	.debug	G _numChans 5 0
_numChans_ChgEventVal::
	.ds	2
	.debug	G _numChans_ChgEventVal 5 0
_numChans_MinChg::
	.ds	2
	.debug	G _numChans_MinChg 5 0
_coilChanMult::
	.ds	2
	.debug	G _coilChanMult 5 0
_coilChanMult_ChgEventVal::
	.ds	2
	.debug	G _coilChanMult_ChgEventVal 5 0
_coilChanMult_MinChg::
	.ds	2
	.debug	G _coilChanMult_MinChg 5 0
_reg3ChanMult::
	.ds	2
	.debug	G _reg3ChanMult 5 0
_reg3ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg3ChanMult_ChgEventVal 5 0
_reg3ChanMult_MinChg::
	.ds	2
	.debug	G _reg3ChanMult_MinChg 5 0
_reg4ChanMult::
	.ds	2
	.debug	G _reg4ChanMult 5 0
_reg4ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg4ChanMult_ChgEventVal 5 0
_reg4ChanMult_MinChg::
	.ds	2
	.debug	G _reg4ChanMult_MinChg 5 0
_digInBits::
	.ds	4
	.debug	G _digInBits 9 0
_digInBits_ChgEventVal::
	.ds	4
	.debug	G _digInBits_ChgEventVal 9 0
_digInBits_MinChg::
	.ds	4
	.debug	G _digInBits_MinChg 9 0
_statusBitsStdA::
	.ds	2
	.debug	G _statusBitsStdA 5 0
_statusBitsStdA_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdA_ChgEventVal 5 0
_statusBitsStdA_MinChg::
	.ds	2
	.debug	G _statusBitsStdA_MinChg 5 0
_statusBitsStdB::
	.ds	2
	.debug	G _statusBitsStdB 5 0
_statusBitsStdB_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdB_ChgEventVal 5 0
_statusBitsStdB_MinChg::
	.ds	2
	.debug	G _statusBitsStdB_MinChg 5 0
_statusBitsAppl::
	.ds	4
	.debug	G _statusBitsAppl 9 0
_statusBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _statusBitsAppl_ChgEventVal 9 0
_statusBitsAppl_MinChg::
	.ds	4
	.debug	G _statusBitsAppl_MinChg 9 0
_latency::
	.ds	2
	.debug	G _latency 5 0
_latency_ChgEventVal::
	.ds	2
	.debug	G _latency_ChgEventVal 5 0
_latency_MinChg::
	.ds	2
	.debug	G _latency_MinChg 5 0
_tcpTickTime::
	.ds	2
	.debug	G _tcpTickTime 5 0
_tcpTickTime_ChgEventVal::
	.ds	2
	.debug	G _tcpTickTime_ChgEventVal 5 0
_tcpTickTime_MinChg::
	.ds	2
	.debug	G _tcpTickTime_MinChg 5 0
_applLoopTime::
	.ds	2
	.debug	G _applLoopTime 5 0
_applLoopTime_ChgEventVal::
	.ds	2
	.debug	G _applLoopTime_ChgEventVal 5 0
_applLoopTime_MinChg::
	.ds	2
	.debug	G _applLoopTime_MinChg 5 0
_kernelLoopTime::
	.ds	2
	.debug	G _kernelLoopTime 5 0
_kernelLoopTime_ChgEventVal::
	.ds	2
	.debug	G _kernelLoopTime_ChgEventVal 5 0
_kernelLoopTime_MinChg::
	.ds	2
	.debug	G _kernelLoopTime_MinChg 5 0
_rdg_1::
	.ds	4
	.debug	G _rdg_1 10 0
_rdg_1_ChgEventVal::
	.ds	4
	.debug	G _rdg_1_ChgEventVal 10 0
_rdg_1_MinChg::
	.ds	4
	.debug	G _rdg_1_MinChg 10 0
_rdg_2::
	.ds	4
	.debug	G _rdg_2 10 0
_rdg_2_ChgEventVal::
	.ds	4
	.debug	G _rdg_2_ChgEventVal 10 0
_rdg_2_MinChg::
	.ds	4
	.debug	G _rdg_2_MinChg 10 0
_rdg_3::
	.ds	4
	.debug	G _rdg_3 10 0
_rdg_3_ChgEventVal::
	.ds	4
	.debug	G _rdg_3_ChgEventVal 10 0
_rdg_3_MinChg::
	.ds	4
	.debug	G _rdg_3_MinChg 10 0
_rdg_4::
	.ds	4
	.debug	G _rdg_4 10 0
_rdg_4_ChgEventVal::
	.ds	4
	.debug	G _rdg_4_ChgEventVal 10 0
_rdg_4_MinChg::
	.ds	4
	.debug	G _rdg_4_MinChg 10 0
_rdg_5::
	.ds	4
	.debug	G _rdg_5 10 0
_rdg_5_ChgEventVal::
	.ds	4
	.debug	G _rdg_5_ChgEventVal 10 0
_rdg_5_MinChg::
	.ds	4
	.debug	G _rdg_5_MinChg 10 0
_rdg_6::
	.ds	4
	.debug	G _rdg_6 10 0
_rdg_6_ChgEventVal::
	.ds	4
	.debug	G _rdg_6_ChgEventVal 10 0
_rdg_6_MinChg::
	.ds	4
	.debug	G _rdg_6_MinChg 10 0
_rdg_7::
	.ds	4
	.debug	G _rdg_7 10 0
_rdg_7_ChgEventVal::
	.ds	4
	.debug	G _rdg_7_ChgEventVal 10 0
_rdg_7_MinChg::
	.ds	4
	.debug	G _rdg_7_MinChg 10 0
_rdg_8::
	.ds	4
	.debug	G _rdg_8 10 0
_rdg_8_ChgEventVal::
	.ds	4
	.debug	G _rdg_8_ChgEventVal 10 0
_rdg_8_MinChg::
	.ds	4
	.debug	G _rdg_8_MinChg 10 0
_timeZone_::
	.ds	2
	.debug	G _timeZone_ 4 0
_timeZone__ChgEventVal::
	.ds	2
	.debug	G _timeZone__ChgEventVal 4 0
_timeZone__MinChg::
	.ds	2
	.debug	G _timeZone__MinChg 4 0
	.cseg
_MB_timeZone:
	pop	iy
	lcall	$$MB_timeZone
	.bseg
_curTime::
	.ds	4
	.debug	G _curTime 9 0
_curTime_ChgEventVal::
	.ds	4
	.debug	G _curTime_ChgEventVal 9 0
_curTime_MinChg::
	.ds	4
	.debug	G _curTime_MinChg 9 0
_ipAddr::
	.ds	4
	.debug	G _ipAddr 9 0
_ipAddr_ChgEventVal::
	.ds	4
	.debug	G _ipAddr_ChgEventVal 9 0
_ipAddr_MinChg::
	.ds	4
	.debug	G _ipAddr_MinChg 9 0
_netmask::
	.ds	4
	.debug	G _netmask 9 0
_netmask_ChgEventVal::
	.ds	4
	.debug	G _netmask_ChgEventVal 9 0
_netmask_MinChg::
	.ds	4
	.debug	G _netmask_MinChg 9 0
_gateway::
	.ds	4
	.debug	G _gateway 9 0
_gateway_ChgEventVal::
	.ds	4
	.debug	G _gateway_ChgEventVal 9 0
_gateway_MinChg::
	.ds	4
	.debug	G _gateway_MinChg 9 0
_setACoil::
	.ds	2
	.debug	G _setACoil 133 0
_setACoil_ChgEventVal::
	.ds	2
	.debug	G _setACoil_ChgEventVal 133 0
_setACoil_MinChg::
	.ds	2
	.debug	G _setACoil_MinChg 133 0
_resetACoil::
	.ds	2
	.debug	G _resetACoil 133 0
_resetACoil_ChgEventVal::
	.ds	2
	.debug	G _resetACoil_ChgEventVal 133 0
_resetACoil_MinChg::
	.ds	2
	.debug	G _resetACoil_MinChg 133 0
_digOutBits::
	.ds	4
	.debug	G _digOutBits 9 0
_digOutBits_ChgEventVal::
	.ds	4
	.debug	G _digOutBits_ChgEventVal 9 0
_digOutBits_MinChg::
	.ds	4
	.debug	G _digOutBits_MinChg 9 0
_cmdBitsStd::
	.ds	4
	.debug	G _cmdBitsStd 9 0
_cmdBitsStd_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsStd_ChgEventVal 9 0
_cmdBitsStd_MinChg::
	.ds	4
	.debug	G _cmdBitsStd_MinChg 9 0
	.cseg
_MB_cmdBitsStd:
	pop	iy
	lcall	$$MB_cmdBitsStd
	.bseg
_cmdBitsAppl::
	.ds	4
	.debug	G _cmdBitsAppl 9 0
_cmdBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsAppl_ChgEventVal 9 0
_cmdBitsAppl_MinChg::
	.ds	4
	.debug	G _cmdBitsAppl_MinChg 9 0
	.cseg
_MB_cmdBitsAppl:
	pop	iy
	lcall	$$MB_cmdBitsAppl
	.extern	$ifpending 134
	.extern	$startNetUp 134
	.extern	$mkfifo 123
	.extern	$perror 135
	.extern	$strerror 136
	.extern	_hdwCfgParams 137
	.extern	$initParamModule 138
	.extern	$saveParams 139
	.extern	$loadParams 139
	.extern	$loadParamsMsg 140
_backupd:
	pop	iy
	lcall	$$backupd
	.extern	$$backupd
	.extern	$backupd 71
	.extern	_srfsIPAddr 9
	.extern	_srfsAltAddr 9
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
	.extern	$$ca_tcpd
	.extern	$ca_tcpd 71
_inetd:
	pop	iy
	lcall	$$inetd
	.extern	$$inetd
	.extern	$inetd 71
	.extern	$showHelp 141
	.extern	$displayElems 142
	.extern	$displayDigElems 143
	.seg	FARBSS
_applDTM::
	.ds	32
	.debug	G _applDTM 118 8
	.bseg
_ctlLoopTicks::
	.ds	2
	.debug	G _ctlLoopTicks 7 0
_lastCtlLoopTime::
	.ds	2
	.debug	G _lastCtlLoopTime 7 0
_lastReadTime::
	.ds	2
	.debug	G _lastReadTime 7 0
_readTicks::
	.ds	2
	.debug	G _readTicks 7 0
_writeTicks::
	.ds	2
	.debug	G _writeTicks 7 0
_rwTicks::
	.ds	2
	.debug	G _rwTicks 7 0
_ADC_Mask::
	.ds	4
	.debug	G _ADC_Mask 9 0
_DAC_Mask::
	.ds	4
	.debug	G _DAC_Mask 9 0
_stateDataBuf::
	.ds	4
	.debug	G _stateDataBuf 84 0
	.cseg
_EVENT_RestoredParamFile:
	pop	iy
	lcall	$$EVENT_RestoredParamFile
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 73
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 73
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 74
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 73
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 73
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 74
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
_readDefaults:
	pop	iy
	lcall	$$readDefaults
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
_setDefaults:
	pop	iy
	lcall	$$setDefaults
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
_applic:
	pop	iy
	lcall	$$applic
_tsh:
	pop	iy
	lcall	$$tsh
	.extern	$$tsh
	.extern	$tsh 71
_configd:
	pop	iy
	lcall	$$configd
	.extern	$$configd
	.extern	$configd 71
_fastdatad:
	pop	iy
	lcall	$$fastdatad
	.extern	$$fastdatad
	.extern	$fastdatad 71
_ReadSetCalibsRestore:
	pop	iy
	lcall	$$ReadSetCalibsRestore
_hostNameRestore:
	pop	iy
	lcall	$$hostNameRestore
	.bseg
_prevState::
	.ds	12
	.debug	G _prevState 144 0
_curState::
	.ds	12
	.debug	G _curState 144 0
_nextState::
	.ds	12
	.debug	G _nextState 144 0
_lastIdleMS:
	.ds	4
_lastIdleTime:
	.ds	2
_applBuf::
	.ds	256
	.debug	G _applBuf 145 0
	.cseg
_showState:
	pop	iy
	lcall	$$showState
_cmd:
	pop	iy
	lcall	$$cmd
_sem_user:
	pop	iy
	lcall	$$sem_user
_sem_test:
	pop	iy
	lcall	$$sem_test
	.debug	T	49000320000A00050001004C00000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D002D000300056E616D6500920007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	AD0003210014000C000100930000000772656756616C0005000200
	.debug	T	077265674E756D002D000400056E616D6500940008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F63637572656400510010000B
	.debug	T	6C61737443686756616C0051001200076D696E43686700
	.debug	T	0900012200040023000200
	.debug	T	070000230002002000
	.debug	T	0900012400560025002B00
	.debug	T	070000250002002100
	.debug	T	0900012600240025001200
	.debug	T	09000127001D0028000100
	.debug	T	8A000328001D0009000950565F446573635F009500000007707649
	.debug	T	6E666F0054000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F63637572656400960015000A75706461746556616C00
	.debug	T	98001700086C6F636B56616C009A0019000873656E6456616C
	.debug	T	009A001B000772637656616C00
	.debug	T	0900012900050003000500
	.debug	T	1D00032A000600020001000900000005626175640006000400056D
	.debug	T	6F646500
	.debug	T	0900012B00100003001000
	.debug	T	0900012C0080002D002000
	.debug	T	0700082D0004000300
	.debug	T	0900012E00080003000800
	.debug	T	0900012F00040003000400
	.debug	T	0900013000480031000400
	.debug	T	82000331001200090001004C000000087372764E616D6500070002
	.debug	T	0005706F727400030004000970726F746F636F6C009C000500
	.debug	T	0970726F634D61696E0003000700097072696F726974790006
	.debug	T	0008000664657666640051000A000A636667506172616D7300
	.debug	T	06000C00086C6173744572720009000E000C6C617374457272
	.debug	T	54696D6500
	.debug	T	0900013200000133001000
	.debug	T	49000333001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E00540006000564617461002D000A
	.debug	T	00056E616D65009D000E000B726573746F726556616C00
	.debug	T	0900013400100033000100
	.debug	T	72000335003100080001004C00000009626173654E616D65000300
	.debug	T	02000963617465676F7279009E00030007706172616D73009F
	.debug	T	0007000B7772697465436F756E74000600270003666400A000
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	0900013600060037000300
	.debug	T	070000370002003500
	.debug	T	17000238000400030051000000030002005100040006000600
	.debug	T	0B000239000100010001000000
	.debug	T	0B00023A000100010003000000
	.debug	T	0B00023B0001000100A2000000
	.debug	T	1300023C0003000100540000004C00040007000600
	.debug	T	0B00023D000100060001000000
	.debug	T	0900013E001F0003001F00
	.debug	T	0900013F000E0040000100
	.debug	T	56000340000E0007000A44697370456C656D5F0003000000027800
	.debug	T	03000100027900540002000476616C004C0006000661747472
	.debug	T	7300A400080008666D7446756E630006000A00067769647468
	.debug	T	0006000C00057072656300
	.debug	T	09000141000E0042000100
	.debug	T	4B000342000E000700010003000000027800030001000279000900
	.debug	T	0200056D61736B004C0006000573747230004C000800066174
	.debug	T	747230004C000A000573747231004C000C0006617474723100
	.debug	T	09000143000A0044000100
	.debug	T	53000344000A00060011646967466D74496E666F53747275637400
	.debug	T	04000000027800040002000279004C00040005737472300003
	.debug	T	00060007626C696E6B30004C00070005737472310003000900
	.debug	T	07626C696E6B3100
	.debug	T	0900014500080046000100
	.debug	T	3D000346000800040014616E616C6F67466D74496E666F53747275
	.debug	T	637400040000000278000400020002790004000400046C656E
	.debug	T	0004000600057072656300
	.debug	T	0F000247000200010006000000A6000200
	.debug	T	0F00024800020001007E0000002D000200
	.debug	T	0B0002490001000A0007000000
	.debug	T	1300024A000300010007000000A7000200A7000400
	.debug	T	0F00024B0002004C00070000004C000200
	.debug	T	0700004C0002000300
	.debug	T	0900014D001E004E000300
	.debug	T	2F00034E000A00030001002D00000008636D644E616D65009C0004
	.debug	T	000970726F634D61696E002D00060006646573637200
	.debug	T	0B00024F0001000900A8000000
	.debug	T	130002500003005100510000000600020007000400
	.debug	T	070000510002000100
	.debug	T	0B00025200010006004C000000
	.debug	T	130002530003005400540000005400040009000800
	.debug	T	070008540004000100
	.debug	T	130002550003005400540000000600040009000600
	.debug	T	0B000256000100090001000000
	.debug	T	0F00025700020007000900000009000400
	.debug	T	0B000258000100010006000000
	.debug	T	0F00025900020009004C0000004C000200
	.debug	T	1300025A000300010006000000A200020006000400
	.debug	T	1300025B0003000600060000004C00020051000400
	.debug	T	0900015C00000003000000
	.debug	T	0F00025D0002000600A800000006000200
	.debug	T	1300025E000300060006000000A8000200A8000400
	.debug	T	0B00025F0001000600A8000000
	.debug	T	070000600002006100
	.debug	T	7702036100E8002D000C7461736B5F73747275637400A900000006
	.debug	T	737461636B00A90002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C687200AA000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465006000150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	00056172676300A6001A00056172677600AB001C0005617267
	.debug	T	7300AC009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773009C00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002D00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	070000620002006300
	.debug	T	54000363000C0006000100AD000000065F5F6F757400AF00020005
	.debug	T	5F5F696E00B1000400085F5F777269746500B1000600075F5F
	.debug	T	726561640006000800085F5F756E6765740051000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	130002640003000600620000002D0002000D000000
	.debug	T	0F00026500020006002D0000000D000000
	.debug	T	1300026600030006002D0000002D0004000D000000
	.debug	T	0900016700080009000200
	.debug	T	1300026800030008004C000000A600020006000400
	.debug	T	090001690000000A000000
	.debug	T	0900016A00000007000000
	.debug	T	0900016B0020000A000800
	.debug	T	0900016C0010000A000400
	.debug	T	0900016D00C0006E000800
	.debug	T	0900016E00180003001800
	.debug	T	0900016F0060006E000400
	.debug	T	090001700080016E001000
	.debug	T	090001710000036E002000
	.debug	T	0B000272000100010009000000
	.debug	T	0B000273000100010007000000
	.debug	T	1300027400030006004C0000000600020006000400
	.debug	T	0B000275000100060062000000
	.debug	T	0900017600200003002000
	.debug	T	2701037700F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D6500B3001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900B40085000866696C6C65723200
	.debug	T	2300027800070006009C0000000300020006000400A60006000600
	.debug	T	080006000A0006000C00
	.debug	T	0B000279000100090009000000
	.debug	T	1300027A000300060006000000B500020006000400
	.debug	T	0F00027B00020006004C00000006000200
	.debug	T	0F00027C00020006007E00000009000200
	.debug	T	1700027D0004007E004C000000060002000900040007000800
	.debug	T	0700007E0002007F00
	.debug	T	6800037F001600080001002D000000056E616D6500AC000400076F
	.debug	T	70656E656400AC000800076C6F636B656400AC000C0008626C
	.debug	T	6F636B6564000300100009756E6C696E6B6564000300110006
	.debug	T	696E55736500060012000676616C75650051001400076D7941
	.debug	T	64647200
	.debug	T	0B00028000010006007E000000
	.debug	T	0F00028100020006007E000000B6000200
	.debug	T	0F00028200020006007E000000B5000200
	.debug	T	0900018300200025001000
	.debug	T	17000284000400030051000000030002000300040006000600
	.debug	T	0900018500020005000100
	.debug	T	0B000286000100060006000000
	.debug	T	0B00028700010001002D000000
	.debug	T	0B0002880001002D0006000000
	.debug	T	0900018900000033000000
	.debug	T	0F00028A00020006004C00000007000200
	.debug	T	1700028B00040006004C000000070002003700040003000600
	.debug	T	0B00028C000100060037000000
	.debug	T	1300028D00030003000600000006000200A6000400
	.debug	T	1300028E0003000100B8000000030004004C000600
	.debug	T	1700028F000400010009000000B9000400030008004C000A00
	.debug	T	39000390000C0003000100090000000C70726F6365737354696D65
	.debug	T	00090004000A6469676974616C496E00090008000B64696769
	.debug	T	74616C4F757400
	.debug	T	0900019100000103000001
	.debug	T	070000920002008400
	.debug	T	070000930002000400
	.debug	T	070000940002003800
	.debug	T	52000395000D00060001002D000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	070000960002009700
	.debug	T	0B0002970001000600BA000000
	.debug	T	070000980002009900
	.debug	T	130002990003000600BA0000000600020006000400
	.debug	T	0700009A0002009B00
	.debug	T	1700029B0004000600060000000700020051000400BB000600
	.debug	T	0700009C0002004700
	.debug	T	0700009D0002003C00
	.debug	T	0700089E0004003300
	.debug	T	0900019F00200007001000
	.debug	T	070008A0000400A100
	.debug	T	330003A1000A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	070000A2000200A300
	.debug	T	3C0003A3001600040001000700000008646174614C656E00510002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	2B000600056461746100
	.debug	T	070000A4000200A500
	.debug	T	0F0002A50002004C00B80000004C000400
	.debug	T	070000A60002004C00
	.debug	T	070000A70002000A00
	.debug	T	070000A80002000900
	.debug	T	070000A90002000700
	.debug	T	070000AA0002005400
	.debug	T	090001AB00800003008000
	.debug	T	280003AC0004000100125F5F776169745F71756575655F68656164
	.debug	T	00BD000000096C6973744865616400
	.debug	T	070000AD000200AE00
	.debug	T	0F0002AE00020006000300000051000200
	.debug	T	070000AF000200B000
	.debug	T	0B0002B0000100060051000000
	.debug	T	070000B1000200B200
	.debug	T	130002B200030008002D0000000800040051000800
	.debug	T	090001B300500003005000
	.debug	T	090001B400740003007400
	.debug	T	070000B50002000600
	.debug	T	070000B6000200B700
	.debug	T	2A0003B700080002000974696D657370656300090000000774765F
	.debug	T	73656300080004000874765F6E73656300
	.debug	T	070008B80004004000
	.debug	T	070008B90004004200
	.debug	T	070000BA0002002800
	.debug	T	070000BB000200BC00
	.debug	T	130002BC0003000600510000005400020007000600
	.debug	T	260003BD00040002000A6C6973745F6865616400BE000000056E65
	.debug	T	787400BE000200057072657600
	.debug	T	070000BE000200BD00
	.seg	CONST
@2:
	.db	"console",0,"fastdatad",0,"modbusTCPd",0,"tsh",0,"settings",0,"devData",0,"hdwcfg",0,"16:39:28",0,"Fri Jan 11 2013",0,13,10,0
	.db	"test-sem",0,"wait",0,"trywait",0,"timedwait",0,"sem_user",0,"V",0,"255.255.0.0",0,"192.168.0.1",0,"fifoEvents",0,"inetd",0,"c"
	.db	"onfigd",0,"backupd",0,"ca_tcpd",0
	.seg	FARCONST
@1:
	.db	"DoReboot",0,"dlmVersTime",0,"rtosVersTime",0,"applVersTime",0,"devType_",0,"deviceID_",0,"upSecs",0,"percentIdle_"
	.db	0,"numChans",0,"coilChanMult",0,"reg3ChanMult",0,"reg4ChanMult",0,"digInBits",0,"statusBitsStdA",0,"statusBitsS"
	.db	"tdB",0,"statusBitsAppl",0,"latency",0,"tcpTickTime",0,"applLoopTime",0,"kernelLoopTime",0,"rdg_1",0,"rdg_2",0,"rdg_3",0
	.db	"rdg_4",0,"rdg_5",0,"rdg_6",0,"rdg_7",0,"rdg_8",0,"timeZone_",0,"curTime",0,"ipAddr",0,"netmask",0,"gateway",0,"setACoil",0,"reset"
	.db	"ACoil",0,"digOutBits",0,"cmdBitsStd",0,"cmdBitsAppl",0,"DI-00 now 0",0,"DI-00 now 1",0,"DI-01 now 0",0,"DI-01 now"
	.db	" 1",0,"DI-02 now 0",0,"DI-02 now 1",0,"DI-03 now 0",0,"DI-03 now 1",0,"DI-04 now 0",0,"DI-04 now 1",0,"DI-05 now "
	.db	"0",0,"DI-05 now 1",0,"DI-06 now 0",0,"DI-06 now 1",0,"DI-07 now 0",0,"DI-07 now 1",0,"DI-08 now 0",0,"DI-08 now 1"
	.db	0,"DI-09 now 0",0,"DI-09 now 1",0,"DI-10 now 0",0,"DI-10 now 1",0,"DI-11 now 0",0,"DI-11 now 1",0,"DI-12 now 0",0
	.db	"DI-12 now 1",0,"DI-13 now 0",0,"DI-13 now 1",0,"DI-14 now 0",0,"DI-14 now 1",0,"DI-15 now 0",0,"DI-15 now 1",0,"D"
	.db	"O-00 now 0",0,"DO-00 now 1",0,"DO-01 now 0",0,"DO-01 now 1",0,"DO-02 now 0",0,"DO-02 now 1",0,"DO-03 now 0",0,"DO"
	.db	"-03 now 1",0,"DO-04 now 0",0,"DO-04 now 1",0,"DO-05 now 0",0,"DO-05 now 1",0,"DO-06 now 0",0,"DO-06 now 1",0,"DO-"
	.db	"07 now 0",0,"DO-07 now 1",0,"DO-09 now 0",0,"DO-09 now 1",0,"DO-10 now 0",0,"DO-10 now 1",0,"DO-11 now 0",0,"DO-1"
	.db	"1 now 1",0,"DO-12 now 0",0,"DO-12 now 1",0,"DO-13 now 0",0,"DO-13 now 1",0,"DO-14 now 0",0,"DO-14 now 1",0,"DO-15"
	.db	" now 0",0,"DO-15 now 1",0,"timeZone",0,"srfsIPAddr",0,"ainLabel",0,"aoutLabel",0,"dinLabel",0,"doutLabel",0,"readGain"
	.db	0,"readOffset",0,"setGain",0,"setOffset",0,"hostName",0,"srfsAltAddr",0,"extraInLabel",0,"new timezone value: %"
	.db	"d",10,0,13,10,"===== Initial Digital Input states =====",13,10,0,"%ls",13,10,0,13,10,"===== Initial Digital Output "
	.db	"states =====",13,10,0,"restore from param file: %.24s",10,0,"%s %s",0,"*** Saving ApplState ***",13,10,0,13,10,"***"
	.db	" Restored Application State ***",13,10,10,0,"AIN-%u",0,"AOUT-%u",0,"DIN-%u",0,"DOUT-%u",0,"ExtraIN-%u",0,27,"[%02d;%0"
	.db	"2dH",0,"%s  %5u.%03u [%05d]: sem_%ls(): %ls",13,10,0,"%s  %5u.%03u [%05d]: %ls",13,10,0,"open",0,"exiting",0,"ope"
	.db	"ned",0,"cur value: %d",0,"got lock",0,"post",0,"released lock",0,"close",0,"closed",0,"unlink",0,"unlinked",0,"unrecogniz"
	.db	"ed func specifier: '%c'",0,10,"usage: sem_test <waitSec> <testMask> [...testMask]",13,10,13,10,"      "
	.db	"    waitSec:  > 0:  use sem_timedwait() (block w/timeout)",13,10,"                      0:  "
	.db	"use sem_trywait()   (don't block)",13,10,"                    < 0:  use sem_wait()      (blo"
	.db	"ck)",13,10,"          testMask str indicating funcs to call & order:",13,10,"                    o"
	.db	":   sem_open()",13,10,"                    w:   sem_???wait()",13,10,"                    p:   sem"
	.db	"_post()",13,10,"                    c:   sem_close()",13,10,"                    u:   sem_unlink()"
	.db	13,10,"          # of testMasks = # of concurrent tasks",13,10,0,"sem_open",0,"Created",0,13,10,"all child tas"
	.db	"ks exited",13,10,0,"Setting default labels for I/O signals",13,10,0,"Setting in-RAM device config to "
	.db	"default values",13,10,0,"Application prepping for shutdown",13,10,0,"applic process started",13,10,0,"*** res"
	.db	"toreApplState() failed (%d):  Doing CPU reset ***",13,10,0,13,10,"***** Network did not come up! "
	.db	"*****",13,10,0,"free memory: %ld",13,10,0,"cmd",0,"Application-specific commands",0,"sem_test",0,"Test POSIX-styl"
	.db	"e semaphore funcs",0,"state",0,"Show state of controller",0
	.end
