	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\lib\common.c' 12 27 11 12 12 32
;1 //--- common.c --- 12/12/12 ---(05/06/05)---
;2 
;3 //-------------------------------------------------------------------------
;4 //
;5 //  Copyright (c) 2003-2012 National Superconducting Cyclotron Laboratory,
;6 //            Michigan State University, and Mark Davis
;7 //
;8 //=========================================================================
;9 //  Misc functions common to almost all NSCL ZWorld code
;10 //=========================================================================
;11 //  Change log (most recent first):
;12 //
;13 //
;14 //  2012-12-12 - Mark Davis
;15 //               - Fixed compileTime() so it works with date strings that d
;16 //                 not include the day of the week.
;17 //
;18 //  2012-12-05 - Mark Davis
;19 //               - Removed Force/Release/Dig/In/Out() functions
;20 //               - Moved the following from fcntl to common:
;21 //                    vt100 escape sequence definitions
;22 //                    DispStr() and DispStrAttr()
;23 //                    read_() and write_()
;24 //                    redirectStdio() and logStdout()
;25 //
;26 //  2012-02-14 - Mark Davis
;27 //               - Modified fwrite_() to call writeFDEV() rather than write
;28 //                 to reduce its overhead.
;29 //
;30 //  2011-03-29 - Mark Davis
;31 //               - showNetState() now takes the interface ID as an argument
;32 //
;33 //  2011-03-25 - Mark Davis (*)
;34 //               - ValidatePtr() now checks for pointer values of 0 and -1
;35 //                 (0xFFFF)
;36 //
;37 //  2010-12-14 - Mark Davis
;38 //               - Changed _TimerSeconds + secTimerOffset to TIME()
;39 //
;40 //  2010-07-13 - Mark Davis
;41 //               - Commented out the fmult() function and replaced it with 
;42 //                 macro that just does a regular multiply.
;43 //                 fmult() is no longer necessary because I created a
;44 //                 modified version of fmult() that can be substituted for 
;45 //                 Softools internal __fmlt() function so ALL floating poin
;46 //                 multiples will use the faster (but less accurate) versio
;47 //
;48 //  2010-06-15 - Mark Davis (*)
;49 //               - renamed fWriteBytes() to fwrite_()
;50 //               - read_() and write_() now check for a NULL buffer pointer
;51 //               - added skipBytes() to use instead of calling new read_()
;52 //                 with a NULL buffer pointer.
;53 //
;54 //  2010-06-15 - Mark Davis
;55 //               - renamed fWriteBytes() to fwrite_()
;56 //
;57 //  2010-05-14 - Mark Davis (*)
;58 //               - Fixed fWriteBytes() so it no longer gets stuck in a loop
;59 //                 if write_() returns < 0 each time.
;60 //
;61 //  2010-05-13 - Mark Davis
;62 //               - Removed readBytes() and writeBytes() (they are replaced 
;63 //                 read_() and write_() in the fcntl module).
;64 //
;65 //  2010-03-29 - Mark Davis
;66 //               - fWriteBytes() now uses the fd passed to it (it was alway
;67 //                 writing to stdout!)
;68 //               - fWriteBytes() now uses a buffer passed by the caller (to
;69 //                 avoid possibly overflowing the stack of the caller)
;70 //
;71 //  2010-03-11 - Mark Davis
;72 //               - CheckETX() now tosses away any additional input characte
;73 //                 available at the time it is called after the first one,
;74 //                 unless one of them is a Ctrl-C.
;75 //
;76 //  2010-03-08 - Mark Davis
;77 //               - Added fGetShort(), fGetLong(), fAddShort(), fAddLong()
;78 //
;79 //  2010-03-03 - Mark Davis
;80 //               - Added sendBCastPkt() (moved it here from configd.c)
;81 //
;82 //  2010-02-15 - Mark Davis
;83 //               - Moved readBufCh() from the "busybox" shared code in to t
;84 //                 module
;85 //
;86 //  2010-01-29 - Mark Davis (*)
;87 //               - moved resetWDT() in readBytes() and writeBytes() to avoi
;88 //                 problems if they are called by the applic task
;89 //               - setBlockTimeout() is now called to reset the timeout to 
;90 //                 if an unexpected error occurs during a read() call in
;91 //                 readBytes() or a write() call in writeBytes()
;92 //               - Changed writeBytes() so, like readBytes(), it uses the
;93 //                 timeout mechanism supported by write() for each call.  P
;94 //                 to this change it was basically polling (calling write()
;95 //                 with blocking disabled, sleeping if the timeout had not
;96 //                 been reached without progress, repeat...)
;97 //
;98 //  2009-06-23- Mark Davis -
;99 //               - Changed WDT_2S() calls to resetWDT()
;100 //
;101 //  2009-05-07- Mark Davis
;102 //               - fixes to readBytes()
;103 //
;104 //  2007-10-30- Mark Davis
;105 //               - readBytes() now uses blocking reads with a timeout handl
;106 //                 by the kernel (if a timeout specified)
;107 //
;108 //  2007-10-02- Mark Davis
;109 //               - moved rounding from fmtFloat() (where it could alter the
;110 //                 result so it doesn't fit in specified space) to the
;111 //                 Engineering() func (which calls fmtFloat())
;112 //
;113 //  2007-03-23- Mark Davis
;114 //               - added strstri() - a case insensitive version of strstr()
;115 //
;116 //  2007-03-08 - Mark Davis
;117 //               - added writeBytes()
;118 //
;119 //  2006-03-07 - Mark Davis
;120 //               - started port of selected portions to Softools compiler
;121 //
;122 //  2005-07-15 - Mark Davis
;123 //               - Added ForceDigOut() and ReleaseDigOut()
;124 //
;125 //  2005-06-01 - Mark Davis
;126 //               - Changed Engineering() so it works with larger exponents
;127 //
;128 //  2005-05-06 - Mark Davis
;129 //               - Extracted various pieces from older code
;130 //
;131 //-------------------------------------------------------------------------
;132 
;133 #include <time.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
;134 #include <ctype.h>
;135 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.debug	I
;136 #include <common.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;137 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;138 #include <sys/socket.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;139 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;140 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;141 #include <stdio.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
;142 #include <math.h>
;143 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
;144 #include <sys/stat.h>
;145 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;146 #include <netinet/in.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
;147 #include <arpa/inet.h>
;148 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;149 #include <sys/backup.h>
;150 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
;151 #include <sys/hdwDefs.h>
;152 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;153 #ifdef RABBIT
;154   #include <dcdefs.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;155 #endif
;156 #include <limits.h>
;157 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;158 
;159 
;160 typedef  struct in_addr      INET_ADDR;
;161 typedef  struct sockaddr    *SAP;
;162 typedef  struct sockaddr_in  SAI;
;163 
;164 typedef  struct ether_addr  EtherAddr;
;165 
;166 #ifdef RABBIT
;167   #define  SIN_ADDR  sin_addr
;168 #else
;172 #define  MaxPow10  24
;173 #define  Pow0Idx   MaxPow10
;174 
;175 extern int  timeZone;
;176 
;177 
;178 //--- common vt100 commands ---
;179 const char clsCmd[] = {"\033[2J\033[00;00H"};  // CLear Screen
	.defseg	CONST
	.seg	CONST
_clsCmd::
	.db	27,"[2J",27,"[00;00H",0
	.debug	G _clsCmd 32 0
;180 const char cllCmd[] = {"\033[K"};              // CLear to end-of-Line
_cllCmd::
	.db	27,"[K",0
	.debug	G _cllCmd 33 0
;181 const char clpCmd[] = {"\033[J"};              // CLear to end-of-Page
_clpCmd::
	.db	27,"[J",0
	.debug	G _clpCmd 33 0
;182 
;183 
;184 
;185 float far  powOf10[MaxPow10*2+1];
;186 #define  PowOf10(pow)  (powOf10[Pow0Idx+(pow)])
;187 
;188 
;189 const unsigned short far crc16_rev_table[256] =
;190 {   0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241,
	.defseg	FARCONST
	.seg	FARCONST
_crc16_rev_table::
	.dw	0
	.dw	0xc0c1
	.dw	0xc181
	.dw	0x140
	.dw	0xc301
	.dw	0x3c0
	.dw	0x280
	.dw	0xc241
;191     0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
	.dw	0xc601
	.dw	0x6c0
	.dw	0x780
	.dw	0xc741
	.dw	0x500
	.dw	0xc5c1
	.dw	0xc481
	.dw	0x440
;192     0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40,
	.dw	0xcc01
	.dw	0xcc0
	.dw	0xd80
	.dw	0xcd41
	.dw	0xf00
	.dw	0xcfc1
	.dw	0xce81
	.dw	0xe40
;193     0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
	.dw	0xa00
	.dw	0xcac1
	.dw	0xcb81
	.dw	0xb40
	.dw	0xc901
	.dw	0x9c0
	.dw	0x880
	.dw	0xc841
;194     0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40,
	.dw	0xd801
	.dw	0x18c0
	.dw	0x1980
	.dw	0xd941
	.dw	0x1b00
	.dw	0xdbc1
	.dw	0xda81
	.dw	0x1a40
;195     0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
	.dw	0x1e00
	.dw	0xdec1
	.dw	0xdf81
	.dw	0x1f40
	.dw	0xdd01
	.dw	0x1dc0
	.dw	0x1c80
	.dw	0xdc41
;196     0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641,
	.dw	0x1400
	.dw	0xd4c1
	.dw	0xd581
	.dw	0x1540
	.dw	0xd701
	.dw	0x17c0
	.dw	0x1680
	.dw	0xd641
;197     0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
	.dw	0xd201
	.dw	0x12c0
	.dw	0x1380
	.dw	0xd341
	.dw	0x1100
	.dw	0xd1c1
	.dw	0xd081
	.dw	0x1040
;198     0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240,
	.dw	0xf001
	.dw	0x30c0
	.dw	0x3180
	.dw	0xf141
	.dw	0x3300
	.dw	0xf3c1
	.dw	0xf281
	.dw	0x3240
;199     0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
	.dw	0x3600
	.dw	0xf6c1
	.dw	0xf781
	.dw	0x3740
	.dw	0xf501
	.dw	0x35c0
	.dw	0x3480
	.dw	0xf441
;200     0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41,
	.dw	0x3c00
	.dw	0xfcc1
	.dw	0xfd81
	.dw	0x3d40
	.dw	0xff01
	.dw	0x3fc0
	.dw	0x3e80
	.dw	0xfe41
;201     0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
	.dw	0xfa01
	.dw	0x3ac0
	.dw	0x3b80
	.dw	0xfb41
	.dw	0x3900
	.dw	0xf9c1
	.dw	0xf881
	.dw	0x3840
;202     0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41,
	.dw	0x2800
	.dw	0xe8c1
	.dw	0xe981
	.dw	0x2940
	.dw	0xeb01
	.dw	0x2bc0
	.dw	0x2a80
	.dw	0xea41
;203     0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
	.dw	0xee01
	.dw	0x2ec0
	.dw	0x2f80
	.dw	0xef41
	.dw	0x2d00
	.dw	0xedc1
	.dw	0xec81
	.dw	0x2c40
;204     0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640,
	.dw	0xe401
	.dw	0x24c0
	.dw	0x2580
	.dw	0xe541
	.dw	0x2700
	.dw	0xe7c1
	.dw	0xe681
	.dw	0x2640
;205     0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
	.dw	0x2200
	.dw	0xe2c1
	.dw	0xe381
	.dw	0x2340
	.dw	0xe101
	.dw	0x21c0
	.dw	0x2080
	.dw	0xe041
;206     0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240,
	.dw	0xa001
	.dw	0x60c0
	.dw	0x6180
	.dw	0xa141
	.dw	0x6300
	.dw	0xa3c1
	.dw	0xa281
	.dw	0x6240
;207     0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
	.dw	0x6600
	.dw	0xa6c1
	.dw	0xa781
	.dw	0x6740
	.dw	0xa501
	.dw	0x65c0
	.dw	0x6480
	.dw	0xa441
;208     0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41,
	.dw	0x6c00
	.dw	0xacc1
	.dw	0xad81
	.dw	0x6d40
	.dw	0xaf01
	.dw	0x6fc0
	.dw	0x6e80
	.dw	0xae41
;209     0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
	.dw	0xaa01
	.dw	0x6ac0
	.dw	0x6b80
	.dw	0xab41
	.dw	0x6900
	.dw	0xa9c1
	.dw	0xa881
	.dw	0x6840
;210     0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41,
	.dw	0x7800
	.dw	0xb8c1
	.dw	0xb981
	.dw	0x7940
	.dw	0xbb01
	.dw	0x7bc0
	.dw	0x7a80
	.dw	0xba41
;211     0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
	.dw	0xbe01
	.dw	0x7ec0
	.dw	0x7f80
	.dw	0xbf41
	.dw	0x7d00
	.dw	0xbdc1
	.dw	0xbc81
	.dw	0x7c40
;212     0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640,
	.dw	0xb401
	.dw	0x74c0
	.dw	0x7580
	.dw	0xb541
	.dw	0x7700
	.dw	0xb7c1
	.dw	0xb681
	.dw	0x7640
;213     0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
	.dw	0x7200
	.dw	0xb2c1
	.dw	0xb381
	.dw	0x7340
	.dw	0xb101
	.dw	0x71c0
	.dw	0x7080
	.dw	0xb041
;214     0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241,
	.dw	0x5000
	.dw	0x90c1
	.dw	0x9181
	.dw	0x5140
	.dw	0x9301
	.dw	0x53c0
	.dw	0x5280
	.dw	0x9241
;215     0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
	.dw	0x9601
	.dw	0x56c0
	.dw	0x5780
	.dw	0x9741
	.dw	0x5500
	.dw	0x95c1
	.dw	0x9481
	.dw	0x5440
;216     0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40,
	.dw	0x9c01
	.dw	0x5cc0
	.dw	0x5d80
	.dw	0x9d41
	.dw	0x5f00
	.dw	0x9fc1
	.dw	0x9e81
	.dw	0x5e40
;217     0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
	.dw	0x5a00
	.dw	0x9ac1
	.dw	0x9b81
	.dw	0x5b40
	.dw	0x9901
	.dw	0x59c0
	.dw	0x5880
	.dw	0x9841
;218     0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40,
	.dw	0x8801
	.dw	0x48c0
	.dw	0x4980
	.dw	0x8941
	.dw	0x4b00
	.dw	0x8bc1
	.dw	0x8a81
	.dw	0x4a40
;219     0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
	.dw	0x4e00
	.dw	0x8ec1
	.dw	0x8f81
	.dw	0x4f40
	.dw	0x8d01
	.dw	0x4dc0
	.dw	0x4c80
	.dw	0x8c41
;220     0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641,
	.dw	0x4400
	.dw	0x84c1
	.dw	0x8581
	.dw	0x4540
	.dw	0x8701
	.dw	0x47c0
	.dw	0x4680
	.dw	0x8641
;221     0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040
	.dw	0x8201
	.dw	0x42c0
	.dw	0x4380
	.dw	0x8341
	.dw	0x4100
	.dw	0x81c1
	.dw	0x8081
;222 };
	.dw	0x4040
	.debug	G _crc16_rev_table 34 8
;223 
;224 
;225 const char *months[12] = { "Jan", "Feb", "Mar",
	.seg	CONST
_months::
	.dw	@1
	.dw	@1+4
	.dw	@1+8
;226                            "Apr", "May", "Jun",
	.dw	@1+12
	.dw	@1+16
	.dw	@1+20
;227                            "Jul", "Aug", "Sep",
	.dw	@1+24
	.dw	@1+28
	.dw	@1+32
;228                            "Oct", "Nov", "Dec" };
	.dw	@1+36
	.dw	@1+40
	.dw	@1+44
	.debug	G _months 35 0
;229 
;230 #ifdef RABBIT
;231   #include <sys/farprintf.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;232 #endif
;233 
;234 
;235 //-------------------------------------------------------------------------
;236 //  Redirect buffered IO (printf, perror(), etc) so it does not use fds 0,1
;237 //  If successful, all buffered output goes to a log file instead.
;238 //-------------------------------------------------------------------------
;239 int redirectStdio(void)
;240 {
	.defseg	FARCODE
	.seg	FARCODE
$redirectStdio::
	.debug	G $redirectStdio 37 9
	.debug	{ $redirectStdio 37 239 @4 @3
;241   #ifdef RABBIT
;242     current->logStdout = current->redirStdio = true;  return 0;
	.debug	# 242
	ld	hl,(_current)
	ld	de,0xad
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(_current)
	dec	e
	add	hl,de
	ld	(hl),a
	bool	hl
	ld	l,h
;243   #else
;250 }
@3:
	.debug	} @3 250

@2	equ	0
	lret
@4	equ	0
;251 
;252 //-------------------------------------------------------------------------
;253 //  Cause everything written to stdout to be written to the log file as wel
;254 //-------------------------------------------------------------------------
;255 int logStdout(void)
;256 {
$logStdout::
	.debug	G $logStdout 37 9
	.debug	{ $logStdout 37 255 @7 @6
;257   #ifdef RABBIT
;258     current->logStdout = true;  return 0;
	.debug	# 258
	ld	hl,(_current)
	ld	de,0xac
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	bool	hl
	ld	l,h
;259   #else
;263 }
@6:
	.debug	} @6 263

@5	equ	0
	lret
@7	equ	0
;264 
;265 
;266 //-------------------------------------------------------------------------
;267 //  given an array of elements of specified size and # elements and the off
;268 //  within each element to a byte that acts as an "in Use" flag, return a p
;269 //  to the 1st element that was not in use (or NULL, if all the elements ar
;270 //  in use) (returned element is filled with 0's and marked as in use)
;271 //-------------------------------------------------------------------------
;272 /*
;273 char *unused(void *arrayOf, int elemSize, int numElements, int inUseOffset)
;274 {
;275   int  i;
;276   char  *ptr;
;277 
;278 
;279   for (i=0; i<numElements; ++i)  {
;280     ptr = (char *)arrayOf + (uint)(elemSize * i);
;281     if (! ptr[inUseOffset])  break;
;282   }
;283   if (i == numElements)  return NULL;
;284 
;285   memset(ptr, 0, elemSize);  ptr[inUseOffset] = true;
;286 
;287   return ptr;
;288 }
;289 */
;290 
;291 
;292 
;293 
;294 /*-------------------------------------------------------------------------
;295  *  Functions for adding to and extracting data from a byte array in networ
;296  *  (most significant byte 1st) order.
;297  *  All functions update the value of the pointer into the array.
;298  *-------------------------------------------------------------------------
;299 void addShort(uchar **ptr, short val)
;300 {
$addShort::
	.debug	G $addShort 38 9
	.debug	{ $addShort 38 299 @10 @9
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ptr 5 39
	.debug	A val 7 4
;301 /*
;302   uchar bufPtr = *ptr + 1;  *ptr += 2;
;303 
;304   *bufPtr = (uchar)(val & 0xff);  --bufPtr;  val >>= 8;
;305   *bufPtr = (uchar)(val & 0xff);
;306 */
;307 //  *((short *)(*ptr)) = htons(val);  *ptr += 2;
;308 
;309   ushort  netShort = htons(val);
	.debug	L netShort -2 5
	.debug	# 309
	ld	hl,(ix+7)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-2),hl
	.seg	FARCODE
;310   uchar  *nsp = (uchar *)&netShort;
	.debug	L nsp -4 36
	.debug	# 310
	ld	hl,-2+@8
	add	hl,sp
	ld	(ix-4),hl
	.seg	FARCODE
;311 
;312   **ptr = *nsp++;  ++(*ptr);
	.debug	# 312
	inc	hl
	ld	(ix-4),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;313   **ptr = *nsp++;  ++(*ptr);
	.debug	# 313
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;314 }
@9:
	.debug	} @9 314

@8	equ	4
	ld	sp,ix
	pop	ix
	lret
@10	equ	6
;315 
;316 /*-------------------------------------------------------------------------
;317 void addLong(uchar **ptr, long val)
;318 {
$addLong::
	.debug	G $addLong 40 9
	.debug	{ $addLong 40 317 @13 @12
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ptr 5 39
	.debug	A val 7 8
;319 /*
;320   uchar bufPtr = *ptr + 3;  *ptr += 4;
;321 
;322   *bufPtr = (uchar)(val & 0xff);  --bufPtr;  val >>= 8;
;323   *bufPtr = (uchar)(val & 0xff);  --bufPtr;  val >>= 8;
;324   *bufPtr = (uchar)(val & 0xff);  --bufPtr;  val >>= 8;
;325   *bufPtr = (uchar)(val & 0xff);
;326 */
;327 //  *((long *)(*ptr)) = htonl(val);  *ptr += 4;
;328 
;329   ulong  netLong = htonl(val);
	.debug	L netLong -4 9
	.debug	# 329
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;330   uchar  *nlp = (uchar *)&netLong;
	.debug	L nlp -6 36
	.debug	# 330
	ld	hl,-4+@11
	add	hl,sp
	ld	(ix-6),hl
	.seg	FARCODE
;331 
;332   **ptr = *nlp++;  ++(*ptr);
	.debug	# 332
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;333   **ptr = *nlp++;  ++(*ptr);
	.debug	# 333
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;334   **ptr = *nlp++;  ++(*ptr);
	.debug	# 334
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;335   **ptr = *nlp++;  ++(*ptr);
	.debug	# 335
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;336 }
@12:
	.debug	} @12 336

@11	equ	6
	ld	sp,ix
	pop	ix
	lret
@13	equ	8
;337 
;338 //-------------------------------------------------------------------------
;339 void fAddShort(uchar far **ptr, short val)
;340 {
$fAddShort::
	.debug	G $fAddShort 41 9
	.debug	{ $fAddShort 41 339 @16 @15
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ptr 5 42
	.debug	A val 7 4
;341   ushort  netShort = htons(val);
	.debug	L netShort -2 5
	.debug	# 341
	ld	hl,(ix+7)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-2),hl
	.seg	FARCODE
;342   uchar  *nsp = (uchar *)&netShort;
	.debug	L nsp -4 36
	.debug	# 342
	ld	hl,-2+@14
	add	hl,sp
	ld	(ix-4),hl
	.seg	FARCODE
;343 
;344   **ptr = *nsp++;  ++(*ptr);
	.debug	# 344
	inc	hl
	ld	(ix-4),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;345   **ptr = *nsp++;  ++(*ptr);
	.debug	# 345
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;346 }
@15:
	.debug	} @15 346

@14	equ	4
	ld	sp,ix
	pop	ix
	lret
@16	equ	6
;347 
;348 /*-------------------------------------------------------------------------
;349 void fAddLong(uchar far **ptr, long val)
;350 {
$fAddLong::
	.debug	G $fAddLong 44 9
	.debug	{ $fAddLong 44 349 @19 @18
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ptr 5 42
	.debug	A val 7 8
;351   ulong  netLong = htonl(val);
	.debug	L netLong -4 9
	.debug	# 351
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;352   uchar  *nlp = (uchar *)&netLong;
	.debug	L nlp -6 36
	.debug	# 352
	ld	hl,-4+@17
	add	hl,sp
	ld	(ix-6),hl
	.seg	FARCODE
;353 
;354   **ptr = *nlp++;  ++(*ptr);
	.debug	# 354
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;355   **ptr = *nlp++;  ++(*ptr);
	.debug	# 355
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;356   **ptr = *nlp++;  ++(*ptr);
	.debug	# 356
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;357   **ptr = *nlp++;  ++(*ptr);
	.debug	# 357
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farst1##
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;358 }
@18:
	.debug	} @18 358

@17	equ	6
	ld	sp,ix
	pop	ix
	lret
@19	equ	8
;359 
;360 /*-------------------------------------------------------------------------
;361  *  Return the 2-byte integer stored in network byte order (MSB first) at  
;362  *  the specified address, and increment the a pointer by 2 bytes.         
;363  *-------------------------------------------------------------------------
;364 short getShort(uchar **ptr)
;365 {
$getShort::
	.debug	G $getShort 45 9
	.debug	{ $getShort 45 364 @22 @21
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ptr 5 39
;366   short netShort = *((short *)(*ptr));  *ptr += 2;
	.debug	L netShort -2 4
	.debug	# 366
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	(ix-2),hl
	.seg	FARCODE
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;367 /*
;368   ushort  netShort;
;369   uchar  *nsp = (uchar *)&netShort;
;370 
;371   *nsp++ = **ptr;  ++(*ptr);
;372   *nsp++ = **ptr;  ++(*ptr);
;373 */
;374   return ntohs(netShort);
	.debug	# 374
	ld	hl,(ix-2)
	ld	a,l
	ld	l,h
	ld	h,a
;375 }
@21:
	.debug	} @21 375

@20	equ	2
	ld	sp,ix
	pop	ix
	lret
@22	equ	4
;376 
;377 /*-------------------------------------------------------------------------
;378  *  Return the 4-byte integer stored in network byte order (MSB first) at  
;379  *  the specified address, and increment the a pointer by 4 bytes.         
;380  *-------------------------------------------------------------------------
;381 long getLong(uchar **ptr)
;382 {
$getLong::
	.debug	G $getLong 46 9
	.debug	{ $getLong 46 381 @25 @24
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ptr 5 39
;383   long netLong = *((long *)(*ptr));  *ptr += 4;
	.debug	L netLong -4 8
	.debug	# 383
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;384 /*
;385   ulong  netLong;
;386   uchar  *nlp = (uchar *)&netLong;
;387 
;388   *nlp++ = **ptr;  ++(*ptr);
;389   *nlp++ = **ptr;  ++(*ptr);
;390   *nlp++ = **ptr;  ++(*ptr);
;391   *nlp++ = **ptr;  ++(*ptr);
;392 */
;393   return ntohl(netLong);
	.debug	# 393
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
;394 }
@24:
	.debug	} @24 394

@23	equ	4
	ld	sp,ix
	pop	ix
	lret
@25	equ	6
;395 
;396 /*-------------------------------------------------------------------------
;397  *  Return the 2-byte integer stored in network byte order (MSB first) at  
;398  *  the specified address, and increment the a pointer by 2 bytes.         
;399  *-------------------------------------------------------------------------
;400 short fGetShort(uchar far **ptr)
;401 {
$fGetShort::
	.debug	G $fGetShort 47 9
	.debug	{ $fGetShort 47 400 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ptr 5 42
;402   short netShort = *((short far *)(*ptr));  *ptr += 2;
	.debug	L netShort -2 4
	.debug	# 402
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	.seg	FARCODE
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;403 
;404   return ntohs(netShort);
	.debug	# 404
	ld	hl,(ix-2)
	ld	a,l
	ld	l,h
	ld	h,a
;405 }
@27:
	.debug	} @27 405

@26	equ	2
	ld	sp,ix
	pop	ix
	lret
@28	equ	4
;406 
;407 /*-------------------------------------------------------------------------
;408  *  Return the 4-byte integer stored in network byte order (MSB first) at  
;409  *  the specified address, and increment the a pointer by 4 bytes.         
;410  *-------------------------------------------------------------------------
;411 long fGetLong(uchar far **ptr)
;412 {
$fGetLong::
	.debug	G $fGetLong 48 9
	.debug	{ $fGetLong 48 411 @31 @30
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ptr 5 42
;413   long netLong = *((long far *)(*ptr));  *ptr += 4;
	.debug	L netLong -4 8
	.debug	# 413
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;414 
;415   return ntohl(netLong);
	.debug	# 415
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
;416 }
@30:
	.debug	} @30 416

@29	equ	4
	ld	sp,ix
	pop	ix
	lret
@31	equ	6
;417 
;418 
;419 //-------------------------------------------------------------------------
;420 short GetShort_(uchar *buf, int idx)
;421 {
$GetShort_::
	.debug	G $GetShort_ 49 9
	.debug	{ $GetShort_ 49 420 @34 @33
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A buf 5 36
	.debug	A idx 7 6
;422   return ((ushort)(buf[idx]) * 256) + (ushort)(buf[idx+1]);
	.debug	# 422
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	h,a
	ld	l,0
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	ld	bc,hl
	ld	hl,(ix+5)
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,bc
;423 }
@33:
	.debug	} @33 423

@32	equ	0
	pop	ix
	lret
@34	equ	2
;424 
;425 /*-------------------------------------------------------------------------
;426  *  Functions to add "tagged" parameter values to a buffer, where each valu
;427  *  is prefaced with a 2-byte ID and a 2-byte length.
;428  *-------------------------------------------------------------------------
;429 void addShortParam(uchar **ptr, short id, short val)
;430 {
$addShortParam::
	.debug	G $addShortParam 50 9
	.debug	{ $addShortParam 50 429 @37 @36
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ptr 5 39
	.debug	A id 7 4
	.debug	A val 9 4
;431   addShort(ptr, id);  addShort(ptr, 2);  addShort(ptr, val);
	.debug	# 431
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,0x2
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
;432 }
@36:
	.debug	} @36 432

@35	equ	0
	pop	ix
	lret
@37	equ	2
;433 
;434 /*-------------------------------------------------------------------------
;435 void addLongParam(uchar **ptr, short id, long val)
;436 {
$addLongParam::
	.debug	G $addLongParam 51 9
	.debug	{ $addLongParam 51 435 @40 @39
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ptr 5 39
	.debug	A id 7 4
	.debug	A val 9 8
;437   addShort(ptr, id);  addShort(ptr, 4);  addLong(ptr, val);
	.debug	# 437
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addLong
	add	sp,6
;438 }
@39:
	.debug	} @39 438

@38	equ	0
	pop	ix
	lret
@40	equ	2
;439 
;440 /*-------------------------------------------------------------------------
;441 void addStrParam(uchar **ptr, short id, char *buf, short len)
;442 {
$addStrParam::
	.debug	G $addStrParam 52 9
	.debug	{ $addStrParam 52 441 @43 @42
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ptr 5 39
	.debug	A id 7 4
	.debug	A buf 9 36
	.debug	A len 11 4
;443   short  i;
	.debug	L i -2 4
;444 
;445   addShort(ptr, id);  addShort(ptr, len);
	.debug	# 445
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$addShort
	add	sp,4
;446 
;447   for (i=0; i<len; ++i)  { **ptr = (uchar)*buf;  ++(*ptr);  ++buf; }
@44:
	.debug	< @44 @45
	.debug	# 447
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@46:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	call	__icmp##
	jr	nc,@47
@49:
	.debug	< @49 @50
	ld	hl,(ix+9)
	ld	a,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(hl),a
	ld	hl,(ix+5)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+9)
	inc	hl
	ld	(ix+9),hl
@50:
	.debug	>
;448 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@46
@47:
@45:
	.debug	>
@42:
	.debug	} @42 448

@41	equ	2
	ld	sp,ix
	pop	ix
	lret
@43	equ	4
;449 
;450 
;451 //-------------------------------------------------------------------------
;452 //  return the time as a millisecond counter that wraps around
;453 //-------------------------------------------------------------------------
;454 #ifndef RABBIT
;466 
;467 //-------------------------------------------------------------------------
;468 //  return the time in seconds
;469 //-------------------------------------------------------------------------
;470 #ifndef RABBIT
;482 
;483 /*-------------------------------------------------------------------------
;484  *  format a MAC addr as an ASCII string
;485  *-------------------------------------------------------------------------
;486 char *mactoa(char *str, uchar far *macAddr)
;487 {
$mactoa::
	.debug	G $mactoa 53 9
	.debug	{ $mactoa 53 486 @53 @52
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A str 5 36
	.debug	A macAddr 7 43
;488   sprintf(str, "%02x:%02x:%02x:%02x:%02x:%02x",
;489       macAddr[0], macAddr[1], macAddr[2], macAddr[3], macAddr[4], macAddr[5
	.debug	# 489
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__linc##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	de,word (phys @54)
	ld	c,phys @54 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,20
;490 
;491   return str;
	.debug	# 491
	ld	hl,(ix+5)
;492 }
@52:
	.debug	} @52 492

@51	equ	0
	pop	ix
	lret
@53	equ	2
;493 
;494 
;495 //-------------------------------------------------------------------------
;496 //  convert host-byte-ordered inet value to octet-dot-delimited string
;497 //-------------------------------------------------------------------------
;498 const char *inet_htop(int af, const void *src, char *dst, socklen_t cnt)
;499 {
$inet_htop::
	.debug	G $inet_htop 54 9
	.debug	{ $inet_htop 54 498 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A af 5 6
	.debug	A src 7 55
	.debug	A dst 9 36
	.debug	A cnt 11 6
;500   ulong  netLong;
	.debug	L netLong -4 9
;501   uchar  *ptr;
	.debug	L ptr -6 36
;502 
;503   if (af != AF_INET)  { ERRNO = EAFNOSUPPORT;  return NULL; }
	.debug	# 503
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@58
@59:
	.debug	< @59 @60
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x61
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	jp	@56
@60:
	.debug	>
;504 
;505   netLong = htonl(*(ulong *)src);
@58:
	.debug	# 505
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;506   ptr = (uchar *)&netLong;
	.debug	# 506
	ld	hl,-4+@55
	add	hl,sp
	ld	(ix-6),hl
;507 
;508   sprintf(dst, "%d.%d.%d.%d", ptr[0], ptr[1], ptr[2], ptr[3]);
	.debug	# 508
	inc	hl
	inc	hl
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-6)
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-6)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+30)
	ld	c,phys @54+30 >> 16
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,16
;509 
;510   return dst;
	.debug	# 510
	ld	hl,(ix+9)
;511 }
@56:
	.debug	} @56 511

@55	equ	6
	ld	sp,ix
	pop	ix
	lret
@57	equ	8
;512 
;513 
;514 //-------------------------------------------------------------------------
;515 //  convert octet-dot-delimited string to host-byte-ordered inet value
;516 //-------------------------------------------------------------------------
;517 int inet_ptoh(int af, const char *src, void *dst)
;518 {
$inet_ptoh::
	.debug	G $inet_ptoh 56 9
	.debug	{ $inet_ptoh 56 517 @63 @62
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A af 5 6
	.debug	A src 7 36
	.debug	A dst 9 55
;519   if (af != AF_INET)  { ERRNO = EAFNOSUPPORT;  return -1; }
	.debug	# 519
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@64
@65:
	.debug	< @65 @66
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x61
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@62
@66:
	.debug	>
;520 
;521   inet_pton(af, src, dst);
@64:
	.debug	# 521
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$inet_pton
	add	sp,6
;522   *((ulong *)dst) = ntohl(*(ulong *)dst);
	.debug	# 522
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;523 
;524   return 1;
	.debug	# 524
	ld	hl,0x1
;525 }
@62:
	.debug	} @62 525

@61	equ	0
	pop	ix
	lret
@63	equ	2
;526 
;527 
;528 
;529 //-------------------------------------------------------------------------
;530 //  return unsigned-long value for network-ordered (MSB-1st) IPV4 IP addres
;531 //-------------------------------------------------------------------------
;532 ulong ipv4_ntohl(uchar *ipAddr)
;533 {
$ipv4_ntohl::
	.debug	G $ipv4_ntohl 57 9
	.debug	{ $ipv4_ntohl 57 532 @69 @68
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ipAddr 5 36
;534   return
;535     (ulong)ipAddr[0] << 24 |
;536     (ulong)ipAddr[1] << 16 |
;537     (ulong)ipAddr[2] << 8  |
;538     (ulong)ipAddr[3];
	.debug	# 538
	ld	hl,(ix+5)
	ld	bc,0
	ld	b,(hl)
	ld	d,c
	ld	e,c
	inc	hl
	ld	a,(hl)
	push	bc
	push	de
	ld	b,d
	ld	c,a
	call	__lor##
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	a,(hl)
	push	bc
	push	de
	ld	bc,0
	ld	d,a
	ld	e,b
	call	__lor##
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	inc	hl
	ld	a,(hl)
	push	bc
	push	de
	ld	e,a
	ld	bc,0
	ld	d,c
	call	__lor##
;539 }
@68:
	.debug	} @68 539

@67	equ	0
	pop	ix
	lret
@69	equ	2
;540 
;541 //-------------------------------------------------------------------------
;542 //  copy host-style IPV4 unsigned-long IP addr to network-ordered (MSB-1st)
;543 //  string of bytes
;544 //-------------------------------------------------------------------------
;545 void ipv4_htonl(ulong ipAddrLong, uchar *ipAddrStr)
;546 {
$ipv4_htonl::
	.debug	G $ipv4_htonl 58 9
	.debug	{ $ipv4_htonl 58 545 @72 @71
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ipAddrLong 5 9
	.debug	A ipAddrStr 9 36
;547   ipAddrStr[0] = (uchar) (ipAddrLong >> 24);
	.debug	# 547
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	e,b
	ld	bc,0
	ld	d,c
	ld	hl,(ix+9)
	ld	(hl),e
;548   ipAddrStr[1] = (uchar) (ipAddrLong >> 16);
	.debug	# 548
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	d,b
	ld	e,c
	ld	hl,(ix+9)
	inc	hl
	ld	(hl),e
;549   ipAddrStr[2] = (uchar) (ipAddrLong >>  8);
	.debug	# 549
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	e,d
	ld	d,c
	ld	c,b
	ld	b,0
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	ld	(hl),e
;550   ipAddrStr[3] = (uchar) ipAddrLong;
	.debug	# 550
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	inc	hl
	ld	a,(ix+5)
	ld	(hl),a
;551 }
@71:
	.debug	} @71 551

@70	equ	0
	pop	ix
	lret
@72	equ	2
;552 
;553 
;554 //-------------------------------------------------------------------------
;555 uint fastCRC16(uchar *ucpBuf, int nSize, ushort accum)
;556 {
$fastCRC16::
	.debug	G $fastCRC16 59 9
	.debug	{ $fastCRC16 59 555 @75 @74
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ucpBuf 5 36
	.debug	A nSize 7 6
	.debug	A accum 9 5
;557   ushort  x, crc;
	.debug	L x -2 5
	.debug	L crc -4 5
;558   int  i;
	.debug	L i -6 6
;559 
;560 
;561   for (crc=accum,i=0; i<nSize; ++i)  {
@76:
	.debug	< @76 @77
	.debug	# 561
	ld	hl,(ix+9)
	ld	(ix-4),hl
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@78:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@79
;562     x = crc ^ (ushort)ucpBuf[i];
@81:
	.debug	< @81 @82
	.debug	# 562
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	ld	h,a
	ld	(ix-2),hl
;563     crc = (crc >> 8) ^ crc16_rev_table[x & 0x00FF];
	.debug	# 563
	ld	l,h
	ld	h,0
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	d,h
	ld	b,d
	ld	c,d
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _crc16_rev_table)
	ld	c,phys _crc16_rev_table >> 16
	call	__ladd##
	call	__farld2##
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	xor	a,h
	ld	h,a
	ld	(ix-4),hl
;564   }
@82:
	.debug	>
;565 
;566   return crc;
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@78
@79:
@77:
	.debug	>
	.debug	# 566
	ld	hl,(ix-4)
;567 }
@74:
	.debug	} @74 567

@73	equ	6
	ld	sp,ix
	pop	ix
	lret
@75	equ	8
;568 
;569 //-------------------------------------------------------------------------
;570 //  compute a 16-bit CRC on the specified block of memory
;571 //-------------------------------------------------------------------------
;572 uint memCRC16(ulong startAddr, ulong size)
;573 {
$memCRC16::
	.debug	G $memCRC16 60 9
	.debug	{ $memCRC16 60 572 @85 @84
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A startAddr 5 9
	.debug	A size 9 9
;574   ushort  x, crc;
	.debug	L x -2 5
	.debug	L crc -4 5
;575   uchar far *ptr, *endPtr;
	.debug	L ptr -8 43
	.debug	L endPtr -12 43
;576 
;577 
;578   ptr = (uchar far *)startAddr;  endPtr = ptr + size;
	.debug	# 578
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;579 
;580   for (crc=0; ptr<endPtr; ++ptr)  {
@86:
	.debug	< @86 @87
	.debug	# 580
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@88:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__fpcmp##
	jp	nc,@89
;581     x = crc ^ (ushort)(*ptr);
@91:
	.debug	< @91 @92
	.debug	# 581
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	ld	h,a
	ld	(ix-2),hl
;582     crc = (crc >> 8) ^ crc16_rev_table[x & 0x00FF];
	.debug	# 582
	ld	l,h
	ld	h,0
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	d,h
	ld	b,d
	ld	c,d
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _crc16_rev_table)
	ld	c,phys _crc16_rev_table >> 16
	call	__ladd##
	call	__farld2##
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	xor	a,h
	ld	h,a
	ld	(ix-4),hl
;583     WDT_2S();
	.debug	# 583
  ld  a,0x5A
  ioi ld  (0x08),a
;584   }
@92:
	.debug	>
;585 
;586   return crc;
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	jp	@88
@89:
@87:
	.debug	>
	.debug	# 586
	ld	hl,(ix-4)
;587 }
@84:
	.debug	} @84 587

@83	equ	12
	ld	sp,ix
	pop	ix
	lret
@85	equ	14
;588 
;589 
;590 //-------------------------------------------------------------------------
;591 //  Format a string for display purposes - changes CR's to '[' and LF's to 
;592 //  All other non-displayable chars are changed to '*'
;593 //-------------------------------------------------------------------------
;594 char *FmtStrCmd(char *cmdBuf, char *dispBuf, short dispBufSize)
;595 {
$FmtStrCmd::
	.debug	G $FmtStrCmd 61 9
	.debug	{ $FmtStrCmd 61 594 @95 @94
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A cmdBuf 5 36
	.debug	A dispBuf 7 36
	.debug	A dispBufSize 9 4
;596   short  i;
	.debug	L i -2 4
;597   char  ch;
	.debug	L ch -3 3
;598 
;599 
;600   for (i=0; cmdBuf[i] AND (i<dispBufSize-1); ++i)  {
@96:
	.debug	< @96 @97
	.debug	# 600
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@98:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@100
	ld	hl,(ix+9)
	dec	hl
	ex	de,hl
	ld	hl,(ix-2)
	call	__icmp##
	jr	nc,@100
;601     dispBuf[i] = ch = cmdBuf[i];
@103:
	.debug	< @103 @104
	.debug	# 601
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	(ix-3),a
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	(hl),a
;602     if ((ch < ' ') OR (ch > '~'))  {
	.debug	# 602
	ld	a,(ix-3)
	sub	a,32
	jr	c,@105
	ld	a,(ix-3)
	sub	a,126
	jr	c,@106
	jr	z,@106
@105:
;603       if (ch == 0x0a)  dispBuf[i] = '[';  else
@107:
	.debug	< @107 @108
	.debug	# 603
	ld	a,(ix-3)
	sub	a,10
	jr	nz,@109
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	a,0x5b
	ld	(hl),a
;604       if (ch == 0x0d)  dispBuf[i] = ']';  else
	jr	@110
@109:
	.debug	# 604
	ld	a,(ix-3)
	sub	a,13
	jr	nz,@111
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	a,0x5d
	ld	(hl),a
;605       dispBuf[i] = '*';
	jr	@112
@111:
	.debug	# 605
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	a,0x2a
	ld	(hl),a
;606     }
@112:
@110:
@108:
	.debug	>
;607   }
@106:
@104:
	.debug	>
;608 
;609   dispBuf[i] = 0;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@98
@100:
@97:
	.debug	>
	.debug	# 609
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;610 
;611   return dispBuf;
	.debug	# 611
	ld	h,d
	ld	l,e
;612 }
@94:
	.debug	} @94 612

@93	equ	3
	ld	sp,ix
	pop	ix
	lret
@95	equ	5
;613 
;614 //-------------------------------------------------------------------------
;615 //  Given a pointer to a char buffer and the number of chars within it, the
;616 //  order of the characters in that buffer are reversed. This function dest
;617 //  the original string and store the resulting string in the same buffer.
;618 //-------------------------------------------------------------------------
;619 char* ReverseStr(char *buffer, char dataCount)
;620 {
$ReverseStr::
	.debug	G $ReverseStr 62 9
	.debug	{ $ReverseStr 62 619 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-5
	.debug	A buffer 5 36
	.debug	A dataCount 7 3
;621   char  temp, *left, *right;
	.debug	L temp -1 3
	.debug	L left -3 36
	.debug	L right -5 36
;622 
;623   left = buffer;  right = buffer + dataCount - 1;
	.debug	# 623
	ld	hl,(ix+5)
	ld	(ix-3),hl
	bool	hl
	ld	l,(ix+7)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	dec	hl
	ld	(ix-5),hl
;624   while ( left < right ) {
@116:
	.debug	# 624
	ld	hl,(ix-3)
	ex	de,hl
	ld	hl,(ix-5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@117
;625     temp = *left;  *left = *right;  *right = temp;
@118:
	.debug	< @118 @119
	.debug	# 625
	ld	hl,(ix-3)
	ld	a,(hl)
	ld	(ix-1),a
	ld	h,d
	ld	l,e
	ld	a,(hl)
	ld	hl,(ix-3)
	ld	(hl),a
	ld	a,(ix-1)
	ld	h,d
	ld	l,e
	ld	(hl),a
;626     ++left;  --right;
	.debug	# 626
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	h,d
	ld	l,e
	dec	hl
	ld	(ix-5),hl
;627   }
@119:
	.debug	>
;628   return buffer;
	jr	@116
@117:
	.debug	# 628
	ld	hl,(ix+5)
;629 }
@114:
	.debug	} @114 629

@113	equ	5
	ld	sp,ix
	pop	ix
	lret
@115	equ	7
;630 
;631 //-------------------------------------------------------------------------
;632 //  pad a string with blanks until it is the specified length (does nothing
;633 //  the string is already >= the specified length).  Returns the address of
;634 //  the string.
;635 //-------------------------------------------------------------------------
;636 char *padStr(char *str, int toLen)
;637 {
$padStr::
	.debug	G $padStr 63 9
	.debug	{ $padStr 63 636 @122 @121
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A str 5 36
	.debug	A toLen 7 6
;638   int  i;
	.debug	L i -2 6
;639 
;640   for (i=0; i<toLen; ++i)  if (! str[i])  break;
@123:
	.debug	< @123 @124
	.debug	# 640
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@125:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@126
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@126
;641   if (i == toLen)  return str;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@125
@126:
@124:
	.debug	>
	.debug	# 641
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@129
	ld	hl,(ix+5)
	jr	@121
;642   while (i < toLen)  str[i++] = ' ';
@129:
@130:
	.debug	# 642
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@131
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	dec	hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,0x20
	ld	(hl),a
;643   str[toLen] = 0;
	jr	@130
@131:
	.debug	# 643
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;644 
;645   return str;
	.debug	# 645
	ld	h,d
	ld	l,e
;646 }
@121:
	.debug	} @121 646

@120	equ	2
	ld	sp,ix
	pop	ix
	lret
@122	equ	4
;647 
;648 
;649 //-------------------------------------------------------------------------
;650 uchar far *fstrncat(uchar far *dst, uchar far *src, size_t size)
;651 {
$fstrncat::
	.debug	G $fstrncat 64 9
	.debug	{ $fstrncat 64 650 @134 @133
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A dst 5 43
	.debug	A src 9 43
	.debug	A size 13 7
;652   uint  i;
	.debug	L i -2 7
;653   uchar far  *ptr;
	.debug	L ptr -6 43
;654 
;655   ptr = dst;
	.debug	# 655
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;656   while (*ptr) ++ptr;
@135:
	.debug	# 656
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@136
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;657   for (i=0; (i<size) AND *src; ++i)  *ptr++ = *src++;
	jr	@135
@136:
@137:
	.debug	< @137 @138
	.debug	# 657
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@139:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@141
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@141
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
	call	__ldec##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	l,a
	call	__linc##
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-4),c
	ld	(ix-3),b
	call	__ldec##
	ld	a,l
	call	__farst1##
;658   *ptr = 0;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@139
@141:
@138:
	.debug	>
	.debug	# 658
	xor	a,a
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farst1##
;659 
;660   return dst;
	.debug	# 660
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
;661 }
@133:
	.debug	} @133 661

@132	equ	6
	ld	sp,ix
	pop	ix
	lret
@134	equ	8
;662 
;663 
;664 //-------------------------------------------------------------------------
;665 //  case insensitive version of strstr()
;666 //-------------------------------------------------------------------------
;667 char *strstri(char *inStr, char *lookfor)
;668 {
$strstri::
	.debug	G $strstri 65 9
	.debug	{ $strstri 65 667 @146 @145
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A inStr 5 36
	.debug	A lookfor 7 36
;669   char *start, *p1, *p2;
	.debug	L start -2 36
	.debug	L p1 -4 36
	.debug	L p2 -6 36
;670 
;671   for (start=inStr; *start; ++start)  {
@147:
	.debug	< @147 @148
	.debug	# 671
	ld	hl,(ix+5)
	ld	(ix-2),hl
@149:
	ld	hl,(ix-2)
	ld	a,(hl)
	or	a,a
	jr	z,@150
;672     p1 = start;  p2 = lookfor;
@152:
	.debug	< @152 @153
	.debug	# 672
	ld	(ix-4),hl
	ld	hl,(ix+7)
	ld	(ix-6),hl
;673     while (*p1 AND *p2 AND (tolower(*p1) == tolower(*p2)))  { ++p1;  ++p2; 
@154:
	.debug	# 673
	ld	hl,(ix-4)
	ld	a,(hl)
	or	a,a
	jr	z,@156
	ld	hl,(ix-6)
	ld	a,(hl)
	or	a,a
	jr	z,@156
	ld	hl,(ix-4)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_tolower
	pop	de
	push	hl
	ld	hl,(ix-6)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_tolower
	pop	de
	pop	de
	or	a,a
	sbc	hl,de
	jr	nz,@156
@157:
	.debug	< @157 @158
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
@158:
	.debug	>
;674     if (!*p2)  return start;
	jr	@154
@156:
	.debug	# 674
	ld	hl,(ix-6)
	ld	a,(hl)
	or	a,a
	jr	nz,@159
	ld	hl,(ix-2)
	jr	@145
;675   }
@159:
@153:
	.debug	>
;676 
;677   return NULL;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@149
@150:
@148:
	.debug	>
	.debug	# 677
	bool	hl
	ld	l,h
;678 }
@145:
	.debug	} @145 678

@144	equ	6
	ld	sp,ix
	pop	ix
	lret
@146	equ	8
;679 
;680 //-------------------------------------------------------------------------
;681 //  Parse a given string in to a list of NULL-terminated strings
;682 //
;683 //  Returns the # of blank-separated strings found
;684 //-------------------------------------------------------------------------
;685 int parseArgs(char *buf, int maxArgs, char **argv, int *argc)
;686 {
$parseArgs::
	.debug	G $parseArgs 66 9
	.debug	{ $parseArgs 66 685 @162 @161
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A buf 5 36
	.debug	A maxArgs 7 6
	.debug	A argv 9 39
	.debug	A argc 11 67
;687   char  *ptr;
	.debug	L ptr -2 36
;688   char  endCh;
	.debug	L endCh -3 3
;689 
;690 
;691   argv[0] = NULL;  ptr = buf;
	.debug	# 691
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	(ix-2),hl
;692 
;693   for (*argc=0; *argc<maxArgs; )  {
@163:
	.debug	< @163 @164
	.debug	# 693
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@165:
	ld	hl,(ix+11)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@166
;694   //--- find start of next argument ---
;695     endCh = ' ';
@167:
	.debug	< @167 @168
	.debug	# 695
	ld	(ix-3),0x20
;696     while (*ptr AND (*ptr <= ' '))  ++ptr;
@169:
	.debug	# 696
	ld	hl,(ix-2)
	ld	a,(hl)
	or	a,a
	jr	z,@171
	sub	a,32
	jr	z,@172
	jr	nc,@171
@172:
	inc	hl
	ld	(ix-2),hl
;697     if (*ptr < ' ')  break;
	jr	@169
@171:
	.debug	# 697
	ld	hl,(ix-2)
	ld	a,(hl)
	sub	a,32
	jr	c,@166
;698 
;699   //--- check for start of quoted string ---
;700     if ((*ptr == '"') OR (*ptr == '\''))  {
	.debug	# 700
	ld	a,(hl)
	sub	a,34
	jr	z,@174
	ld	a,(hl)
	sub	a,39
	jr	nz,@175
@174:
;701       endCh = *ptr;  ++ptr;  if (*ptr < ' ')  break;
@176:
	.debug	< @176 @177
	.debug	# 701
	ld	hl,(ix-2)
	ld	a,(hl)
	ld	(ix-3),a
	inc	hl
	ld	(ix-2),hl
	ld	a,(hl)
	sub	a,32
	jr	c,@166
;702     }
@177:
	.debug	>
;703 
;704   //--- save start of new argument ---
;705     argv[*argc] = ptr;  ++*argc;
@175:
	.debug	# 705
	ld	hl,(ix+11)
	ld	hl,(hl)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+11)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;706 
;707   //--- locate end of argument ---
;708     while ((*ptr >= ' ') AND (*ptr != endCh))  ++ptr;
@179:
	.debug	# 708
	ld	hl,(ix-2)
	ld	a,(hl)
	sub	a,32
	jr	c,@181
	ld	a,(hl)
	ld	hl,(ix-3)
	sub	a,l
	jr	z,@181
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;709 
;710   //--- mark end of argument ---
;711     if (*ptr)  { *ptr = 0;  ++ptr; }
	jr	@179
@181:
	.debug	# 711
	ld	hl,(ix-2)
	ld	a,(hl)
	or	a,a
	jr	z,@182
@183:
	.debug	< @183 @184
	xor	a,a
	ld	(hl),a
	inc	hl
	ld	(ix-2),hl
@184:
	.debug	>
;712   }
@182:
@168:
	.debug	>
;713 
;714   return *argc;
	jp	@165
@166:
@164:
	.debug	>
	.debug	# 714
	ld	hl,(ix+11)
	ld	hl,(hl)
;715 }
@161:
	.debug	} @161 715

@160	equ	3
	ld	sp,ix
	pop	ix
	lret
@162	equ	5
;716 
;717 
;718 //-------------------------------------------------------------------------
;719 //  Converts the given long integer to a decimal format we can send back
;720 //  in a debug-poll reply.
;721 //-------------------------------------------------------------------------
;722 long DecimalRep(long num)
;723 {
$DecimalRep::
	.debug	G $DecimalRep 68 9
	.debug	{ $DecimalRep 68 722 @187 @186
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
	.debug	A num 5 8
;724   long z, k, r;
	.debug	L z -4 8
	.debug	L k -8 8
	.debug	L r -12 8
;725   int ii;
	.debug	L ii -14 6
;726 
;727   z = num;
	.debug	# 727
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;728   r = 0;
	.debug	# 728
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;729   for (ii = 0; ii < 8; ii++) {
@188:
	.debug	< @188 @189
	.debug	# 729
	ld	(ix-14),hl
@190:
	ld	hl,(ix-14)
	ld	de,0x8008
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@191
;730     k = z % 10;
@193:
	.debug	< @193 @194
	.debug	# 730
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__lmod##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;731     z = z / 10;
	.debug	# 731
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ldiv##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;732     k <<= 28;
	.debug	# 732
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	a,0x1c
	call	__lshl##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;733     r >>= 4;
	.debug	# 733
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	a,0x4
	call	__lshr##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;734     r &= 0x0FFFFFFFL;
	.debug	# 734
	res	4,b
	res	5,b
	res	6,b
	res	7,b
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;735     r |= k;
	.debug	# 735
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;736   }
@194:
	.debug	>
;737   ReverseStr((char *)&r,4);
	ld	hl,(ix-14)
	inc	hl
	ld	(ix-14),hl
	jp	@190
@191:
@189:
	.debug	>
	.debug	# 737
	ld	hl,0x4
	push	hl
	ld	hl,-10+@185
	add	hl,sp
	push	hl
	lcall	$ReverseStr
	add	sp,4
;738   return(r);
	.debug	# 738
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
;739 }
@186:
	.debug	} @186 739

@185	equ	14
	ld	sp,ix
	pop	ix
	lret
@187	equ	16
;740 
;741 //-------------------------------------------------------------------------
;742 //  initialize power of 10 table
;743 //-------------------------------------------------------------------------
;744 void initPow10(void)
;745 {
$initPow10::
	.debug	G $initPow10 69 9
	.debug	{ $initPow10 69 744 @197 @196
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;746   uint  ui;
	.debug	L ui -2 7
;747   float  f;
	.debug	L f -6 10
;748 
;749   for (ui=0,f=1.0; ui<=MaxPow10; ++ui,f*=10.0)  powOf10[Pow0Idx+ui] = f;
@198:
	.debug	< @198 @199
	.debug	# 749
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	d,h
	ld	e,l
	ld	hl,0x3f80
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
@200:
	ld	hl,(ix-2)
	ld	de,0x18
	or	a,a
	sbc	hl,de
	jr	z,@202
	jr	nc,@201
@202:
	ld	hl,(ix-2)
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farst4d##
;750   for (ui=1,f=0.1; ui<=MaxPow10; ++ui,f*=0.1)   powOf10[Pow0Idx-ui] = f;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fmlt##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@200
@201:
@199:
	.debug	>
@204:
	.debug	< @204 @205
	.debug	# 750
	ld	hl,0x1
	ld	(ix-2),hl
	ld	de,0xcccd
	ld	hl,0x3dcc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
@206:
	ld	hl,(ix-2)
	ld	de,0x18
	or	a,a
	sbc	hl,de
	jr	z,@208
	jr	nc,@207
@208:
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farst4d##
;751 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xcccd
	ld	bc,0x3dcc
	call	__fmlt##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@206
@207:
@205:
	.debug	>
@196:
	.debug	} @196 751

@195	equ	6
	ld	sp,ix
	pop	ix
	lret
@197	equ	8
;752 
;753 //-------------------------------------------------------------------------
;754 //  Passed a real number, returns the number expressed in engineering
;755 //  notation format  [+/-]XXX.X(..)E[+/-]XX
;756 //-------------------------------------------------------------------------
;757 char *Engineering(float num, int sigDigs, char *str)
;758 {
$Engineering::
	.debug	G $Engineering 70 9
	.debug	{ $Engineering 70 757 @212 @211
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-44
	.debug	A num 5 10
	.debug	A sigDigs 9 6
	.debug	A str 11 36
;759   uint  ui, idigs;
	.debug	L ui -2 7
	.debug	L idigs -4 7
;760   int  pow;
	.debug	L pow -6 6
;761   char  numSign, expSign;
	.debug	L numSign -7 3
	.debug	L expSign -8 3
;762   char  temp[32];
	.debug	L temp -40 71
;763   float  absNum;
	.debug	L absNum -44 10
;764 
;765 
;766 //--- make sure our power-of-10 table is initialized ---
;767   if (powOf10[Pow0Idx+1] != 10.0)  initPow10();
	.debug	# 767
	ld	de,word (phys _powOf10+100)
	ld	c,phys _powOf10+100 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fequ##
	jr	z,@213
	lcall	$initPow10
;768 
;769 //--- check for 0 ---
;770   if (num == 0.0)  {
@213:
	.debug	# 770
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@214
;771     strcpy(str, " 0.");
@215:
	.debug	< @215 @216
	.debug	# 771
	ld	hl,@1+48
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_strcpy
	add	sp,4
;772     for (ui=3; ui<sigDigs+2; ++ui)  str[ui] = '0';
@217:
	.debug	< @217 @218
	.debug	# 772
	ld	hl,0x3
	ld	(ix-2),hl
@219:
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	nc,@220
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	ld	a,0x30
	ld	(hl),a
;773     strcpy(str+sigDigs+2, "E+00");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@219
@220:
@218:
	.debug	>
	.debug	# 773
	ld	hl,@1+52
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	inc	hl
	inc	hl
	push	hl
	call	_strcpy
	add	sp,4
;774     return str;
	.debug	# 774
	jp	@534
;775   }
@216:
	.debug	>
;776 
;777   if (sigDigs > 8)  sigDigs = 8;
@214:
	.debug	# 777
	ld	hl,(ix+9)
	ld	de,0x8008
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@222
	jr	z,@222
	ld	hl,0x8
	ld	(ix+9),hl
;778 
;779   memcpy(str, "*ERR*", 5);  memset(str+5, ' ', sigDigs+1);  str[sigDigs+6] 
@222:
	.debug	# 779
	ld	hl,0x5
	push	hl
	ld	hl,@1+57
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_memcpy
	add	sp,6
	ld	hl,(ix+9)
	inc	hl
	push	hl
	ld	hl,0x20
	push	hl
	ld	hl,(ix+11)
	ld	de,0x5
	add	hl,de
	push	hl
	call	_memset
	add	sp,6
	ld	hl,(ix+9)
	ld	de,0x6
	add	hl,de
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;780 
;781 //--- determine exponent to get normalized value between 0 and 10 ---
;782   if (num < 0.0)  {
	.debug	# 782
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@223
;783     absNum = -num;  numSign = '-'; }
@224:
	.debug	< @224 @225
	.debug	# 783
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,b
	xor	a,0x80
	ld	b,a
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
	ld	a,0x2d
	ld	(ix-7),a
@225:
	.debug	>
;784   else {
	jr	@226
@223:
;785     absNum = num;  numSign = ' '; }
@227:
	.debug	< @227 @228
	.debug	# 785
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
	ld	(ix-7),0x20
@228:
	.debug	>
;786 
;787   if (absNum < 1.0)  {
@226:
	.debug	# 787
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f80
	call	__fsub##
	jp	p,@229
;788     for (ui=Pow0Idx; powOf10[ui]>absNum; --ui)
@230:
	.debug	< @230 @231
@232:
	.debug	< @232 @233
	.debug	# 788
	ld	hl,0x18
	ld	(ix-2),hl
@234:
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	call	__fsub##
	jp	m,@238
	jr	z,@238
;789       if (ui < sigDigs)  return str;
	.debug	# 789
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@534
;790   }
	ld	hl,(ix-2)
	dec	hl
	ld	(ix-2),hl
	jr	@234
@233:
	.debug	>
@231:
	.debug	>
;791   else  {
@229:
;792     for (ui=Pow0Idx; powOf10[ui]<=absNum; ++ui)
@239:
	.debug	< @239 @240
@241:
	.debug	< @241 @242
	.debug	# 792
	ld	hl,0x18
	ld	(ix-2),hl
@243:
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	call	__fsub##
	jr	z,@245
	jp	p,@244
@245:
;793       if (ui > (MaxPow10<<1))  return str;
	.debug	# 793
	ld	hl,(ix-2)
	ld	de,0x30
	or	a,a
	sbc	hl,de
	jr	c,@247
	jr	z,@247
@534:
	ld	hl,(ix+11)
	jp	@211
;794     --ui;
@247:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@243
@244:
@242:
	.debug	>
	.debug	# 794
	ld	hl,(ix-2)
	dec	hl
	ld	(ix-2),hl
;795   }
@240:
	.debug	>
;796   absNum /= powOf10[ui];
@238:
	.debug	# 796
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	call	__fdivr##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
;797 //printf("exponent (before rounding): %d (%ldE-6)\r\n",
;798 //       Pow0Idx - (int)ui, (long)(absNum*1000000.0) );  //tdebug
;799 
;800 //--- round the result and adjust exponent if needed ---
;801   absNum += 5.0 / PowOf10((uint)sigDigs);
	.debug	# 801
	ld	hl,(ix+9)
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x40a0
	call	__fdivr##
	push	bc
	push	de
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
;802   if (absNum >= 10.0)  { absNum /= 10.0;  ++ui; }
	.debug	# 802
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fsub##
	jp	m,@248
@249:
	.debug	< @249 @250
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fdiv##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
@250:
	.debug	>
;803 //printf("exponent (after rounding):  %d (%ldE-6)\r\n",
;804 //       Pow0Idx - (int)ui, (long)(absNum*1000000.0) );  //tdebug
;805 
;806   pow = (int)ui - Pow0Idx;  idigs = 1;
@248:
	.debug	# 806
	ld	hl,(ix-2)
	ld	de,0xffe8
	add	hl,de
	ld	(ix-6),hl
	ld	hl,0x1
	ld	(ix-4),hl
;807 
;808 //--- if at least 4 significant digits, adjust exponent to a mult of 3 ---
;809   if (sigDigs >= 4)
	.debug	# 809
	ld	hl,(ix+9)
	ld	de,0x8004
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@251
;810     while (pow % 3)  { absNum = fmult(absNum, 10.0); --pow;  ++idigs; }
@252:
	.debug	# 810
	ld	hl,(ix-6)
	ld	de,0x3
	call	__idiv##
	ld	a,e
	or	a,d
	jr	z,@253
@254:
	.debug	< @254 @255
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fmlt##
	ld	hl,bc
	ld	(ix-42),hl
	ex	de,hl
	ld	(ix-44),hl
	ex	de,hl
	ld	hl,(ix-6)
	dec	hl
	ld	(ix-6),hl
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@255:
	.debug	>
;811 
;812 //--- format the # without the exponent ---
;813   fmtFloat(absNum, sigDigs+1, sigDigs-idigs, temp);
	jr	@252
@253:
@251:
	.debug	# 813
	ld	hl,-40+@210
	add	hl,sp
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	push	hl
	ld	hl,(ix+9)
	inc	hl
	push	hl
	ld	hl,(ix-44)
	ex	de,hl
	ld	hl,(ix-42)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
;814 
;815 //--- add the exponent portion ---
;816   if (pow >= 0)  expSign = '+';  else { expSign = '-';  pow = -pow; }
	.debug	# 816
	ld	hl,(ix-6)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@256
	ld	a,0x2b
	ld	(ix-8),a
	jr	@257
@256:
@258:
	.debug	< @258 @259
	ld	a,0x2d
	ld	(ix-8),a
	ld	hl,(ix-6)
	xor	a,a
	sub	a,l
	ld	l,a
	ld	a,0
	sbc	a,h
	ld	h,a
	ld	(ix-6),hl
@259:
	.debug	>
;817   sprintf(str, "%c%sE%c%02d", numSign, temp, expSign, pow);
@257:
	.debug	# 817
	ld	hl,(ix-6)
	push	hl
	bool	hl
	ld	l,(ix-8)
	push	hl
	ld	hl,-36+@210
	add	hl,sp
	push	hl
	ld	a,(ix-7)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+42)
	ld	c,phys @54+42 >> 16
	push	bc
	push	de
	ld	hl,(ix+11)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,16
;818 
;819 
;820   return(str);
	.debug	# 820
	ld	hl,(ix+11)
;821 }
@211:
	.debug	} @211 821

@210	equ	44
	ld	sp,ix
	pop	ix
	lret
@212	equ	46
;822 
;823 //-------------------------------------------------------------------------
;824 //  Format a floating point for display (much faster than printf %#.#f)
;825 //  Limitations:
;826 //  - ttlLen > 1 and < 9
;827 //  - decDigs > 0 and < ttlLen
;828 //  - any rounding must be done before calling this func
;829 //-------------------------------------------------------------------------
;830 char *fmtFloat(float num, int ttlLen, int decDigs, char *str)
;831 {
$fmtFloat::
	.debug	G $fmtFloat 72 9
	.debug	{ $fmtFloat 72 830 @262 @261
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-9
	.debug	A num 5 10
	.debug	A ttlLen 9 6
	.debug	A decDigs 11 6
	.debug	A str 13 36
;832   int  i, j, decIdx, intDigs;
	.debug	L i -2 6
	.debug	L j -4 6
	.debug	L decIdx -6 6
	.debug	L intDigs -8 6
;833   char  save1st;
	.debug	L save1st -9 3
;834 
;835 //tdebug
;836 //  fprintf(DiagLog, "len: %d, dec:%d, num: %5d.%04d\r\n",
;837 //                    ttlLen, decDigs, (int)num,
;838 //                    abs((int)((num-(float)((int)num))*10000.0))
;839 //         );  //tdebug
;840 
;841 //--- make sure our power-of-10 table is initialized ---
;842   if (powOf10[Pow0Idx+1] != 10.0)  initPow10();
	.debug	# 842
	ld	de,word (phys _powOf10+100)
	ld	c,phys _powOf10+100 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4120
	call	__fequ##
	jr	z,@263
	lcall	$initPow10
;843 
;844 
;845 //--- if # won't fit in specified format, return a str of '*' ---
;846   intDigs = ttlLen - decDigs - 1;
@263:
	.debug	# 846
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	or	a,a
	sbc	hl,de
	dec	hl
	ld	(ix-8),hl
;847   for (;;)  {
@264:
	.debug	< @264 @265
;848     if (num < 0.0)  {
@269:
	.debug	< @269 @270
	.debug	# 848
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@271
;849       if (fabs(num) < PowOf10((uint)intDigs-1))  break;  }
@272:
	.debug	< @272 @273
	.debug	# 849
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,(ix-8)
	dec	hl
	push	bc
	push	de
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	call	__fsub##
	jp	p,@275
	jr	@267
@273:
	.debug	>
;850     else
;851       if (num < PowOf10((uint)intDigs))  break;
@271:
	.debug	# 851
	ld	hl,(ix-8)
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__fsubr##
	jp	m,@267
;852     for (i=0; i<ttlLen; ++i)  str[i] = '*';
@275:
@277:
	.debug	< @277 @278
	.debug	# 852
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@279:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@280
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ld	a,0x2a
	ld	(hl),a
;853     str[ttlLen] = 0;  return str;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@279
@280:
@278:
	.debug	>
	.debug	# 853
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	h,d
	ld	l,e
	jp	@261
;854   }
@270:
	.debug	>
;855 
;856 //--- get all the digits we want in to a long ---
;857 ;;  sprintf(str, "%0*ld", ttlLen-1, (long)fmult(num, PowOf10((uint)decDigs)
@267:
@265:
	.debug	>
	.debug	# 857
	ld	hl,(ix+11)
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__fmlt##
	call	__ftol##
	push	bc
	push	de
	ld	hl,(ix+9)
	dec	hl
	push	hl
	ld	de,word (phys @54+54)
	ld	c,phys @54+54 >> 16
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,14
;858   sprintf(str, "%0*ld", ttlLen-1, (long)(num * PowOf10((uint)decDigs)) );
	.debug	# 858
	ld	hl,(ix+11)
	ld	de,0x18
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _powOf10)
	ld	c,phys _powOf10 >> 16
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__fmlt##
	call	__ftol##
	push	bc
	push	de
	ld	hl,(ix+9)
	dec	hl
	push	hl
	ld	de,word (phys @54+54)
	ld	c,phys @54+54 >> 16
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,14
;859 
;860 //--- insert a decimal point at the appropriate spot ---
;861   decIdx = ttlLen - 1 - decDigs;
	.debug	# 861
	ld	hl,(ix+9)
	dec	hl
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-6),hl
;862   for (i=ttlLen; i>decIdx; --i)  str[i] = str[i-1];
@282:
	.debug	< @282 @283
	.debug	# 862
	ld	hl,(ix+9)
	ld	(ix-2),hl
@284:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	call	__icmp##
	jr	c,@285
	jr	z,@285
	ld	hl,(ix-2)
	dec	hl
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,(ix+13)
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;863   str[decIdx] = '.';
	ld	h,d
	ld	l,e
	dec	hl
	ld	(ix-2),hl
	jr	@284
@285:
@283:
	.debug	>
	.debug	# 863
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ld	a,0x2e
	ld	(hl),a
;864 
;865 //--- eliminate unwanted leading zeros and move sign char---
;866   save1st = *str;  if (save1st == '-')  *str = '0';
	.debug	# 866
	ld	h,d
	ld	l,e
	ld	a,(hl)
	ld	(ix-9),a
	sub	a,45
	jr	nz,@287
	ld	(hl),0x30
;867   for (i=0,j=-1; (i<decIdx-1) AND (str[i]=='0'); ++i,++j)  str[i] = ' ';
@287:
@288:
	.debug	< @288 @289
	.debug	# 867
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,0xffff
	ld	(ix-4),hl
@290:
	ld	hl,(ix-6)
	dec	hl
	ex	de,hl
	ld	hl,(ix-2)
	call	__icmp##
	jr	nc,@292
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	sub	a,48
	jr	nz,@292
	ld	hl,(ix-2)
	add	hl,de
	ld	a,0x20
	ld	(hl),a
;868   if (j >= 0)  if (save1st == '-')  str[j] = '-';
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@290
@292:
@289:
	.debug	>
	.debug	# 868
	ld	hl,(ix-4)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@295
	ld	a,(ix-9)
	sub	a,45
	jr	nz,@296
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ld	a,0x2d
	ld	(hl),a
;869 
;870   return str;
@296:
@295:
	.debug	# 870
	ld	hl,(ix+13)
;871 }
@261:
	.debug	} @261 871

@260	equ	9
	ld	sp,ix
	pop	ix
	lret
@262	equ	11
;872 
;873 
;874 //-------------------------------------------------------------------------
;875 //  Format the specified Least significant # of bits of an integer value as
;876 //  a binary number.  The left-most bit is the Most significant bit of the
;877 //  selected # least significant bits (e.g. numBits = 4 means format the 4
;878 //  least significant bits, left-most = num & 16, rightmost = num & 1)
;879 //-------------------------------------------------------------------------
;880 char *LongToBinMS1st(long num, char *buf, int numBits)
;881 {
$LongToBinMS1st::
	.debug	G $LongToBinMS1st 73 9
	.debug	{ $LongToBinMS1st 73 880 @299 @298
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A num 5 8
	.debug	A buf 9 36
	.debug	A numBits 11 6
;882   uint  i;
	.debug	L i -2 7
;883   char  *ptr;
	.debug	L ptr -4 36
;884 
;885   ptr = buf + numBits;  *ptr-- = 0;
	.debug	# 885
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
	dec	hl
	ld	(ix-4),hl
	inc	hl
	xor	a,a
	ld	(hl),a
;886   for (i=numBits; i; --i,num>>=1)  *ptr-- = '0' + ((uchar)num & 1);
@300:
	.debug	< @300 @301
	.debug	# 886
	ld	hl,(ix+11)
	ld	(ix-2),hl
@302:
	ld	hl,(ix-2)
	bool	hl
	jr	z,@303
	ld	a,(ix+5)
	and	a,1
	add	a,48
	ld	hl,(ix-4)
	dec	hl
	ld	(ix-4),hl
	inc	hl
	ld	(hl),a
;887   return buf;
	ld	hl,(ix-2)
	dec	hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,0x1
	call	__lshr##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
	jr	@302
@303:
@301:
	.debug	>
	.debug	# 887
	ld	hl,(ix+9)
;888 }
@298:
	.debug	} @298 888

@297	equ	4
	ld	sp,ix
	pop	ix
	lret
@299	equ	6
;889 
;890 
;891 //-------------------------------------------------------------------------
;892 //  Format the specified Least significant # of bits of an integer value as
;893 //  a binary number.  The left-most bit is the Least significant bit of the
;894 //  selected # least significant bits (e.g. numBits = 4 means format the 4
;895 //  least significant bits, left-most = num & 1, rightmost = num & 16)
;896 //-------------------------------------------------------------------------
;897 char *LongToBinLS1st(long num, char *buf, int numBits)
;898 {
$LongToBinLS1st::
	.debug	G $LongToBinLS1st 73 9
	.debug	{ $LongToBinLS1st 73 897 @307 @306
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A num 5 8
	.debug	A buf 9 36
	.debug	A numBits 11 6
;899   uint  i;
	.debug	L i -2 7
;900   char  *ptr;
	.debug	L ptr -4 36
;901 
;902   ptr = buf;
	.debug	# 902
	ld	hl,(ix+9)
	ld	(ix-4),hl
;903   for (i=numBits; i; --i,num>>=1)  *ptr++ = '0' + ((uchar)num & 1);
@308:
	.debug	< @308 @309
	.debug	# 903
	ld	hl,(ix+11)
	ld	(ix-2),hl
@310:
	ld	hl,(ix-2)
	bool	hl
	jr	z,@311
	ld	a,(ix+5)
	and	a,1
	add	a,48
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	dec	hl
	ld	(hl),a
;904   *ptr = 0;
	ld	hl,(ix-2)
	dec	hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,0x1
	call	__lshr##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
	jr	@310
@311:
@309:
	.debug	>
	.debug	# 904
	xor	a,a
	ld	hl,(ix-4)
	ld	(hl),a
;905   return buf;
	.debug	# 905
	ld	hl,(ix+9)
;906 }
@306:
	.debug	} @306 906

@305	equ	4
	ld	sp,ix
	pop	ix
	lret
@307	equ	6
;907 
;908 
;909 //-------------------------------------------------------------------------
;910 //  format # of seconds as days, hours, mins, secs
;911 //-------------------------------------------------------------------------
;912 char *fmtDHMS(char *str, ulong count)
;913 {
$fmtDHMS::
	.debug	G $fmtDHMS 74 9
	.debug	{ $fmtDHMS 74 912 @315 @314
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A str 5 36
	.debug	A count 7 9
;914   int  days, hours, mins, secs;
	.debug	L days -2 6
	.debug	L hours -4 6
	.debug	L mins -6 6
	.debug	L secs -8 6
;915 
;916   secs = (int)(count % 60);  count /= 60;
	.debug	# 916
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__ulmod##
	ex	de,hl
	ld	(ix-8),hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__uldiv##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;917   mins = (int)(count % 60);  count /= 60;
	.debug	# 917
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__ulmod##
	ex	de,hl
	ld	(ix-6),hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__uldiv##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;918   hours = (int)(count % 24);
	.debug	# 918
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ulmod##
	ex	de,hl
	ld	(ix-4),hl
;919   days = (int)(count / 24);
	.debug	# 919
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__uldiv##
	ex	de,hl
	ld	(ix-2),hl
;920 
;921   sprintf(str, "%dd %02d:%02d:%02d", days, hours, mins, secs);
	.debug	# 921
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @54+60)
	ld	c,phys @54+60 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,16
;922 
;923   return str;
	.debug	# 923
	ld	hl,(ix+5)
;924 }
@314:
	.debug	} @314 924

@313	equ	8
	ld	sp,ix
	pop	ix
	lret
@315	equ	10
;925 
;926 
;927 //-------------------------------------------------------------------------
;928 //  convert a date string (of the form "Day Mon dd yyyy" or "Mon dd yyyy") 
;929 //  a time string (in the form "hh:mm:ss") in to a time_t value (seconds si
;930 //  the epoch: Jan 01 1970 00:00:00)
;931 //-------------------------------------------------------------------------
;932 time_t  compileTime(char *dateStr, char *timeStr)
;933 {
$compileTime::
	.debug	G $compileTime 75 9
	.debug	{ $compileTime 75 932 @318 @317
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-23
	.debug	A dateStr 5 36
	.debug	A timeStr 7 36
;934   uchar  i;
	.debug	L i -1 3
;935   uint  offset = 0;
	.debug	L offset -3 7
	.debug	# 935
	bool	hl
	ld	l,h
	ld	(ix-3),hl
	.seg	FARCODE
;936   char *ptr;
	.debug	L ptr -5 36
;937   struct tm  tim;
	.debug	L tim -23 76
;938 
;939   for (i=0; i<12; ++i)
@319:
	.debug	< @319 @320
	.debug	# 939
	xor	a,a
	ld	(ix-1),a
@321:
	ld	a,(ix-1)
	sub	a,12
	jr	nc,@322
;940     if ((ptr = strstr(dateStr, months[i])) != NULL)  {
	.debug	# 940
	bool	hl
	ld	l,(ix-1)
	add	hl,hl
	ld	de,_months
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-5),hl
	bool	hl
	jr	z,@324
;941       offset = ptr - dateStr;  break; }
@325:
	.debug	< @325 @326
	.debug	# 941
	ld	hl,(ix-5)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-3),hl
	jr	@322
@326:
	.debug	>
;942 
;943   tim.tm_sec = atoi(timeStr+6);
@324:
	ld	a,(ix-1)
	inc	a
	ld	(ix-1),a
	jr	@321
@322:
@320:
	.debug	>
	.debug	# 943
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-23),hl
;944   tim.tm_min = atoi(timeStr+3);
	.debug	# 944
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	inc	hl
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-21),hl
;945   tim.tm_hour = atoi(timeStr);
	.debug	# 945
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-19),hl
;946 
;947   tim.tm_mday = atoi(dateStr+4+offset);
	.debug	# 947
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	add	hl,de
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-17),hl
;948   tim.tm_mon = i;
	.debug	# 948
	bool	hl
	ld	l,(ix-1)
	ld	(ix-15),hl
;949   tim.tm_year = atoi(dateStr+7+offset) - 1900;
	.debug	# 949
	ld	l,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	ld	de,0x7
	add	hl,de
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	add	hl,de
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	de,0xf894
	add	hl,de
	ld	(ix-13),hl
;950 
;951   tim.tm_wday = tim.tm_yday = tim.tm_isdst = 0;
	.debug	# 951
	bool	hl
	ld	l,h
	ld	(ix-7),hl
	ld	(ix-9),hl
	ld	(ix-11),hl
;952 
;953   return  mktime(&tim);
	.debug	# 953
	ld	hl,-23+@316
	add	hl,sp
	push	hl
	lcall	$mktime
	pop	hl
;954 }
@317:
	.debug	} @317 954

@316	equ	23
	ld	sp,ix
	pop	ix
	lret
@318	equ	25
;955 
;956 
;957 //-------------------------------------------------------------------------
;958 //  Get the # of bytes available for reading on the specified descriptor
;959 //
;960 //  On success, returns the # of unread bytes.  Returns < 0 if an error
;961 //-------------------------------------------------------------------------
;962 int bytesAvail(fd_t fd)
;963 {
$bytesAvail::
	.debug	G $bytesAvail 77 9
	.debug	{ $bytesAvail 77 962 @329 @328
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A fd 5 6
;964   int  count;
	.debug	L count -2 6
;965 
;966   if (ioctl(fd, FIONREAD, &count) != 0)  return -1;
	.debug	# 966
	ld	hl,-2+@327
	add	hl,sp
	push	hl
	ld	hl,0x541b
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ioctl
	add	sp,6
	bool	hl
	jr	z,@330
	ld	hl,0xffff
	jr	@328
;967 
;968   return count;
@330:
	.debug	# 968
	ld	hl,(ix-2)
;969 }
@328:
	.debug	} @328 969

@327	equ	2
	ld	sp,ix
	pop	ix
	lret
@329	equ	4
;970 
;971 
;972 //-------------------------------------------------------------------------
;973 //  check the std input fd[0] for the char ETX (Ctl-C).  If found, exit the
;974 //  calling process with a status of -3
;975 //
;976 //Finish:  This is a temporary workaround for tty shells.  Once I finish
;977 //  implementing signals, the shell process can check for this sort of thin
;978 //  and send a terminate signal to its child process(es).
;979 //-------------------------------------------------------------------------
;980 int CheckETX(void)
;981 {
$CheckETX::
	.debug	G $CheckETX 37 9
	.debug	{ $CheckETX 37 980 @333 @332
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;982   int  count, fflags;
	.debug	L count -2 6
	.debug	L fflags -4 6
;983   uchar  ch, toss;
	.debug	L ch -5 3
	.debug	L toss -6 3
;984 
;985 
;986   ch = 0;
	.debug	# 986
	xor	a,a
	ld	(ix-5),a
;987 
;988   fflags = fcntl(0, F_GETFL, 0);
	.debug	# 988
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-4),hl
;989   if ((fflags == -1) AND (errno == EBADF))  return -1;
	.debug	# 989
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@335
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0x9
	or	a,a
	sbc	hl,de
	jp	z,@533
;990 
;991   fcntl(0, F_SETFL, fflags | O_NONBLOCK);
@335:
	.debug	# 991
	ld	hl,(ix-4)
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$fcntl
	add	sp,6
;992 
;993   count = read(0, &ch, 1);  // read the first character (if any)
	.debug	# 993
	ld	hl,0x1
	push	hl
	ld	hl,-3+@331
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-2),hl
;994 
;995   if (count > 0)  // toss away any additional chars except a Ctrl-C
	.debug	# 995
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@336
	jr	z,@336
;996     while (read(0, &toss, 1) > 0)  if ((toss & 0x7f) == 0x03)  Exit(-3);
@337:
	.debug	# 996
	ld	hl,0x1
	push	hl
	ld	hl,-4+@331
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@338
	jr	z,@338
	ld	a,(ix-6)
	and	a,127
	sub	a,3
	jr	nz,@337
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
;997 
;998   fcntl(0, F_SETFL, fflags);
	jr	@337
@338:
@336:
	.debug	# 998
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x4
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$fcntl
	add	sp,6
;999 
;1000   if (count == 0)  { fprintf(DiagLog, "connection closed\r\n");  Exit(-1); 
	.debug	# 1000
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@340
@341:
	.debug	< @341 @342
	ld	de,word (phys @54+79)
	ld	c,phys @54+79 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@342:
	.debug	>
;1001 
;1002   if (count < 0)  {
@340:
	.debug	# 1002
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@343
;1003     if (errno == EAGAIN)  return -1;
@344:
	.debug	< @344 @345
	.debug	# 1003
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@346
@533:
	ld	hl,0xffff
	jr	@332
;1004     perror("CheckETX()/stdin");  Exit(-2);
@346:
	.debug	# 1004
	ld	de,word (phys @54+99)
	ld	c,phys @54+99 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;1005   }
@345:
	.debug	>
;1006 
;1007 
;1008   if ((ch & 0x7f) == 0x03)  Exit(-3);
@343:
	.debug	# 1008
	ld	a,(ix-5)
	and	a,127
	sub	a,3
	jr	nz,@347
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
;1009 
;1010   return ch;
@347:
	.debug	# 1010
	bool	hl
	ld	l,(ix-5)
;1011 }
@332:
	.debug	} @332 1011

@331	equ	6
	ld	sp,ix
	pop	ix
	lret
@333	equ	8
;1012 
;1013 
;1014 //-------------------------------------------------------------------------
;1015 //  Read and ignore bytes from an fd.
;1016 //
;1017 //  timeOut values > 0 tell it the max # of ms that can pass without making
;1018 //  any progress toward reading the specified # of bytes.  Values < 0 means
;1019 //  block until all the bytes are read or an error occurs.
;1020 //
;1021 //  Returns the # of bytes read or -1 if an error
;1022 //-------------------------------------------------------------------------
;1023 int  skipBytes(fd_t fd, int numBytes, ulong timeOut)
;1024 {
$skipBytes::
	.debug	G $skipBytes 78 9
	.debug	{ $skipBytes 78 1023 @350 @349
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-70
	.debug	A fd 5 6
	.debug	A numBytes 7 6
	.debug	A timeOut 9 9
;1025   int  remain, count, stat;
	.debug	L remain -2 6
	.debug	L count -4 6
	.debug	L stat -6 6
;1026   char  buf[64];
	.debug	L buf -70 79
;1027 
;1028 
;1029   for (remain=numBytes; remain>0; remain-=stat)  {
@351:
	.debug	< @351 @352
	.debug	# 1029
	ld	hl,(ix+7)
	ld	(ix-2),hl
@353:
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@354
	jr	z,@354
;1030     count = (remain > sizeof(buf) ? sizeof(buf) : remain);
@356:
	.debug	< @356 @357
	.debug	# 1030
	ld	hl,(ix-2)
	ld	e,0x40
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@358
	jr	z,@358
	ld	hl,0x40
	jr	@359
@358:
	ld	hl,(ix-2)
@359:
	ld	(ix-4),hl
;1031     if ((stat = read_(fd, buf, count, timeOut)) <= 0)  break;
	.debug	# 1031
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,-64+@348
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read_
	add	sp,10
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@354
	jr	c,@354
;1032   }
@357:
	.debug	>
;1033 
;1034   return (numBytes - remain);
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
	jr	@353
@354:
@352:
	.debug	>
	.debug	# 1034
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
;1035 }
@349:
	.debug	} @349 1035

@348	equ	70
	ld	sp,ix
	pop	ix
	lret
@350	equ	72
;1036 
;1037 //-------------------------------------------------------------------------
;1038 //  Wrapper around write_() to write from a buffer located in extended
;1039 //  memory
;1040 //-------------------------------------------------------------------------
;1041 int fwrite_(fd_t fd, char far *from, int numBytes,
;1042             char *buf, uint bufSize, ulong inactiveTimeout)
;1043 {
$fwrite_::
	.debug	G $fwrite_ 80 9
	.debug	{ $fwrite_ 80 1041 @364 @363
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
	.debug	A fd 5 6
	.debug	A from 7 43
	.debug	A numBytes 11 6
	.debug	A buf 13 36
	.debug	A bufSize 15 7
	.debug	A inactiveTimeout 17 9
;1044   int  count, remain, stat;
	.debug	L count -2 6
	.debug	L remain -4 6
	.debug	L stat -6 6
;1045   char far  *ptr;
	.debug	L ptr -10 43
;1046   FDEV far  *file;
	.debug	L file -14 81
;1047 
;1048 
;1049   ptr = from;  count = bufSize;  file = _fdToOpenFile_(fd);
	.debug	# 1049
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix+15)
	ld	(ix-2),hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;1050 
;1051   for (remain=numBytes; remain; remain-=count)  {
@365:
	.debug	< @365 @366
	.debug	# 1051
	ld	hl,(ix+11)
	ld	(ix-4),hl
@367:
	ld	hl,(ix-4)
	bool	hl
	jp	z,@368
;1052     if (count > remain)  count = remain;
@370:
	.debug	< @370 @371
	.debug	# 1052
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	call	__icmp##
	jr	c,@372
	jr	z,@372
	ld	hl,(ix-4)
	ld	(ix-2),hl
;1053     fmemcpy(buf, ptr, count);  ptr += (uint)count;
@372:
	.debug	# 1053
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;1054     stat = writeFDEV(file, buf, count, inactiveTimeout);
	.debug	# 1054
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$writeFDEV
	add	sp,12
	ld	(ix-6),hl
;1055     if (stat == count)  continue;  // no timeout, no error
	.debug	# 1055
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@369
;1056     if (stat < 0)  return stat;  // an error occured
	.debug	# 1056
	ld	hl,(ix-6)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@374
	ld	hl,(ix-6)
	jr	@363
;1057     remain -= stat;  break;  // timeout expired
@374:
	.debug	# 1057
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-4),hl
;1058   }
	jr	@368
@371:
	.debug	>
;1059 
;1060   return  (numBytes - remain);
@369:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-4),hl
	jp	@367
@368:
@366:
	.debug	>
	.debug	# 1060
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
;1061 }
@363:
	.debug	} @363 1061

@362	equ	14
	ld	sp,ix
	pop	ix
	lret
@364	equ	16
;1062 
;1063 //-------------------------------------------------------------------------
;1064 //  Function to do buffered reading from a file descriptor and return the n
;1065 //  unused char from the buffer.  Returns -1 if no chars left in the buffer
;1066 //  and no more chars could be read from the descriptor.
;1067 //-------------------------------------------------------------------------
;1068 int  readBufCh(BufInfo *bufInfo)
;1069 {
$readBufCh::
	.debug	G $readBufCh 83 9
	.debug	{ $readBufCh 83 1068 @377 @376
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A bufInfo 5 84
;1070   int  ch, stat;
	.debug	L ch -2 6
	.debug	L stat -4 6
;1071 
;1072   for (;;)  {
@378:
	.debug	< @378 @379
@380:
;1073   //--- return next unread char in the buffer if there is one ---
;1074     if (bufInfo->nextOut < bufInfo->count)  {
@383:
	.debug	< @383 @384
	.debug	# 1074
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	nc,@385
;1075       ch = (uint) bufInfo->buf[bufInfo->nextOut];
@386:
	.debug	< @386 @387
	.debug	# 1075
	ld	hl,(ix+5)
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x6
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-2),hl
;1076       ++bufInfo->nextOut;  return ch;
	.debug	# 1076
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	jr	@376
;1077     }
@387:
	.debug	>
;1078 
;1079   //--- read as many more chars as we can in to the buffer ---
;1080     if ((stat = read(bufInfo->fd, bufInfo->buf, bufInfo->bufSize)) < 1)
@385:
	.debug	# 1080
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-4),hl
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@388
;1081       return -1;
	.debug	# 1081
	ld	hl,0xffff
	jr	@376
;1082 
;1083     bufInfo->nextOut = 0;  bufInfo->count = stat;
@388:
	.debug	# 1083
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1084   }
@384:
	.debug	>
;1085 
;1086 }
	jp	@380
@379:
	.debug	>
@376:
	.debug	} @376 1086

@375	equ	4
	ld	sp,ix
	pop	ix
	lret
@377	equ	6
;1087 
;1088 
;1089 //-------------------------------------------------------------------------
;1090 //  sleepMS() implementation for Linux/Unix systems
;1091 //-------------------------------------------------------------------------
;1092 #ifndef RABBIT
;1110 
;1111 //-------------------------------------------------------------------------
;1112 //  Attempt to read specified # of bytes from a device
;1113 //
;1114 //  maxIdleMS determines blocking mode as follows:
;1115 //    < 0: indefinite timeout (i.e. block until done or error)
;1116 //      0: non-blocking:  read as much as possible and return
;1117 //    > 0: max # of ms to wait with no progress
;1118 //
;1119 //  Note that a positive value does NOT place an upper limit on how long th
;1120 //  function will wait to read the requested # of bytes, but rather the max
;1121 //  time it will wait while NO PROGRESS is being made at reading the bytes.
;1122 //
;1123 //  Note that if non blocking mode is set for the file descriptor then the
;1124 //  maxIdleMS value is ignored (treated as if it were 0)
;1125 //
;1126 //  If a timeout > 0 expires, errno is set to ETIME (regardless of what the
;1127 //  return value is, which could be > 0 if some bytes were read).
;1128 //-------------------------------------------------------------------------
;1129 int read_(fd_t fd, void *buf, int numBytes, long maxIdleMS)
;1130 {
$read_::
	.debug	G $read_ 86 9
	.debug	{ $read_ 86 1129 @391 @390
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
	.debug	A buf 7 55
	.debug	A numBytes 9 6
	.debug	A maxIdleMS 11 8
;1131   #ifdef RABBIT
;1132     return readFDEV(_fdToOpenFile_(fd), buf, numBytes, maxIdleMS);
	.debug	# 1132
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	push	bc
	push	de
	lcall	$readFDEV
	add	sp,12
;1133   #else
;1158 }
@390:
	.debug	} @390 1158

@389	equ	0
	pop	ix
	lret
@391	equ	2
;1159 
;1160 //-------------------------------------------------------------------------
;1161 //  Attempt to write specified # of bytes to a device.
;1162 //
;1163 //  maxIdleMS determines blocking mode as follows:
;1164 //    < 0: indefinite timeout (i.e. block until done or error)
;1165 //      0: non-blocking:  write as much as possible and return
;1166 //    > 0: max # of ms to wait with no progress
;1167 //
;1168 //  Note that a positive value does NOT place an upper limit on how long th
;1169 //  function will wait to write the specified # of bytes, but rather the ma
;1170 //  time it will wait while NO PROGRESS is being made at writing the bytes.
;1171 //
;1172 //  Note that if non blocking mode is set for the file descriptor then the
;1173 //  maxIdleMS value is ignored (treated as if it were 0)
;1174 //
;1175 //  If a timeout > 0 expires, errno is set to ETIME (regardless of what the
;1176 //  return value is, which could be > 0 if some bytes were written).
;1177 //-------------------------------------------------------------------------
;1178 int write_(fd_t fd, void *buf, int numBytes, long maxIdleMS)
;1179 {
$write_::
	.debug	G $write_ 86 9
	.debug	{ $write_ 86 1178 @394 @393
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
	.debug	A buf 7 55
	.debug	A numBytes 9 6
	.debug	A maxIdleMS 11 8
;1180   #ifdef RABBIT
;1181     return writeFDEV(_fdToOpenFile_(fd), buf, numBytes, maxIdleMS);
	.debug	# 1181
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	push	bc
	push	de
	lcall	$writeFDEV
	add	sp,12
;1182   #else
;1207 }
@393:
	.debug	} @393 1207

@392	equ	0
	pop	ix
	lret
@394	equ	2
;1208 
;1209 
;1210 //-------------------------------------------------------------------------
;1211 //  Copy a file by name.  Deletes an existing file with the toName before
;1212 //  doing the copy.
;1213 //
;1214 //  On success, returns 0
;1215 //  On error, returns -1 and *errContext points to name of file that produc
;1216 //  the error.
;1217 //-------------------------------------------------------------------------
;1218 int copyFileByName(char *fromName, char *toName, bool showProgress,
;1219                    char *buf, int bufSize, char **errContext)
;1220 {
$copyFileByName::
	.debug	G $copyFileByName 87 9
	.debug	{ $copyFileByName 87 1218 @397 @396
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-58
	.debug	A fromName 5 36
	.debug	A toName 7 36
	.debug	A showProgress 9 3
	.debug	A buf 11 36
	.debug	A bufSize 13 6
	.debug	A errContext 15 39
;1221   ulong  remain, fromSize;
	.debug	L remain -4 9
	.debug	L fromSize -8 9
;1222   struct stat  fsInfo;
	.debug	L fsInfo -50 88
;1223   int  fromfd, tofd, count, reqCount;
	.debug	L fromfd -52 6
	.debug	L tofd -54 6
	.debug	L count -56 6
	.debug	L reqCount -58 6
;1224 
;1225 
;1226   *errContext = "Error";
	.debug	# 1226
	ld	hl,@1+63
	ex	de,hl
	ld	hl,(ix+15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1227 
;1228   if ((fromfd = open(fromName, O_RDONLY, 0)) < 0)  {
	.debug	# 1228
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-52),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@398
;1229     *errContext = fromName;  return -1; }
@399:
	.debug	< @399 @400
	.debug	# 1229
	ld	hl,(ix+5)
	jr	@532
@400:
	.debug	>
;1230   if (fstat(fromfd, &fsInfo) < 0)  { *errContext = fromName;  Exit(-2); }
@398:
	.debug	# 1230
	ld	hl,-50+@395
	add	hl,sp
	push	hl
	ld	hl,(ix-52)
	push	hl
	lcall	$fstat
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@401
@402:
	.debug	< @402 @403
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
@403:
	.debug	>
;1231   fromSize = fsInfo.st_size;
@401:
	.debug	# 1231
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;1232 
;1233   unlink(toName);
	.debug	# 1233
	ld	hl,(ix+7)
	push	hl
	lcall	$unlink
	pop	de
;1234 
;1235   if ((tofd = open(toName, O_RDWR | O_CREAT, 0666)) < 0)  {
	.debug	# 1235
	ld	hl,0x1b6
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-54),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@404
;1236       close(fromfd);  *errContext = toName;  return -1;  }
@405:
	.debug	< @405 @406
	.debug	# 1236
	ld	hl,(ix-52)
	push	hl
	lcall	$close
	pop	de
	ld	hl,(ix+7)
@532:
	ex	de,hl
	ld	hl,(ix+15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@530
@406:
	.debug	>
;1237 
;1238   remain = fromSize;  reqCount = bufSize;
@404:
	.debug	# 1238
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+13)
	ld	(ix-58),hl
;1239   while (remain)  {
@407:
	.debug	# 1239
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	or	hl,de
	jp	z,@408
;1240     if (remain < (ulong)bufSize)  reqCount = (uint)remain;
@409:
	.debug	< @409 @410
	.debug	# 1240
	ld	hl,(ix+13)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	jr	nc,@411
	ld	hl,(ix-4)
	ld	(ix-58),hl
;1241     if ((count = read(fromfd, buf, reqCount)) < reqCount)  {
@411:
	.debug	# 1241
	ld	hl,(ix-58)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix-52)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-56),hl
	ex	de,hl
	ld	hl,(ix-58)
	ex	de,hl
	call	__icmp##
	jr	nc,@412
;1242       *errContext = fromName;  break;  }
@413:
	.debug	< @413 @414
	.debug	# 1242
	ld	hl,(ix+5)
	jr	@531
@414:
	.debug	>
;1243     if (write(tofd, buf, count) != count)  {
@412:
	.debug	# 1243
	ld	hl,(ix-56)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix-54)
	push	hl
	lcall	$write
	add	sp,6
	ex	de,hl
	ld	hl,(ix-56)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@415
;1244       *errContext = toName;  break;  }
@416:
	.debug	< @416 @417
	.debug	# 1244
	ld	hl,(ix+7)
@531:
	ex	de,hl
	ld	hl,(ix+15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@408
@417:
	.debug	>
;1245     remain -= count;
@415:
	.debug	# 1245
	ld	hl,(ix-56)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1246     if (showProgress)  { printf("%10lu\r", fromSize-remain);  fflush(stdout
	.debug	# 1246
	ld	a,(ix+9)
	or	a,a
	jr	z,@418
@419:
	.debug	< @419 @420
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,word (phys @54+116)
	ld	c,phys @54+116 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
@420:
	.debug	>
;1247   }
@418:
@410:
	.debug	>
;1248   if (showProgress)  printf("\r\n");
	jp	@407
@408:
	.debug	# 1248
	ld	a,(ix+9)
	or	a,a
	jr	z,@421
	ld	de,word (phys @54+96)
	ld	c,phys @54+96 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1249 
;1250   close(fromfd);  close(tofd);
@421:
	.debug	# 1250
	ld	hl,(ix-52)
	push	hl
	lcall	$close
	pop	de
	ld	hl,(ix-54)
	push	hl
	lcall	$close
	pop	de
;1251 
;1252   if (remain)  return -1;
	.debug	# 1252
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	or	hl,de
	jr	z,@422
@530:
	ld	hl,0xffff
	jr	@396
;1253 
;1254   return 0;
@422:
	.debug	# 1254
	bool	hl
	ld	l,h
;1255 }
@396:
	.debug	} @396 1255

@395	equ	58
	ld	sp,ix
	pop	ix
	lret
@397	equ	60
;1256 
;1257 
;1258 //-------------------------------------------------------------------------
;1259 //  Manage the process of copying bytes from an arbitray source to an
;1260 //  arbitrary destination.  It calls the provided functions to read and
;1261 //  write bytes in groups until an error occurs or the specified # of bytes
;1262 //  has been processed.
;1263 //
;1264 //  Parameters:
;1265 //    readFunc:      Pointer to function to read bytes
;1266 //    readContext:   Pointer to information needed by the readFunc to manag
;1267 //                   the reading of a group of bytes
;1268 //
;1269 //    writeFunc:     Pointer to a function to write bytes
;1270 //    writeContext:  Pointer to information needed by the writeFunc to mana
;1271 //                   the writing of a group of bytes
;1272 //
;1273 //    *buf:          Pointer to a block of memory to be used for transferri
;1274 //                   bytes from the readFunc to the writeFunc
;1275 //    bufSize:       The size of the memory block pointed to *buf
;1276 //
;1277 //    showProgres:   Specifies whether or not a count of the # of bytes
;1278 //                   transferred so far should be displayed.
;1279 //
;1280 //  The read and write functions must be written to read or write the # of
;1281 //  bytes they are told to and return the # of bytes they successfully copi
;1282 //  to/from the buffer.
;1283 //
;1284 //  The read and write Context pointers are used to provide the read and wr
;1285 //  functions with whatever context or state information they need to carry
;1286 //  out their tasks.  The values pointed to by each should be initialized a
;1287 //  needed before calling copyBytes, and the read and write functions can d
;1288 //  whatever they need to the values pointed to.
;1289 //
;1290 //  Returns the # of bytes successfully copied.
;1291 //-------------------------------------------------------------------------
;1292 ulong copyBytes(ReadFunc readFunc, void *readContext,
;1293                 WriteFunc writeFunc, void *writeContext,
;1294                 char *buf, int bufSize, ulong copyCount, bool showProgress)
;1295 {
$copyBytes::
	.debug	G $copyBytes 89 9
	.debug	{ $copyBytes 89 1292 @425 @424
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A readFunc 5 90
	.debug	A readContext 7 55
	.debug	A writeFunc 9 90
	.debug	A writeContext 11 55
	.debug	A buf 13 36
	.debug	A bufSize 15 6
	.debug	A copyCount 17 9
	.debug	A showProgress 21 3
;1296   ulong  remain;
	.debug	L remain -4 9
;1297   int  count;
	.debug	L count -6 6
;1298 
;1299 
;1300   remain = copyCount;  count = bufSize;
	.debug	# 1300
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+15)
	ld	(ix-6),hl
;1301   while (remain)  {
@426:
	.debug	# 1301
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	or	hl,de
	jp	z,@427
;1302     if (remain < (ulong)bufSize)  count = (uint)remain;
@428:
	.debug	< @428 @429
	.debug	# 1302
	ld	hl,(ix+15)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	jr	nc,@430
	ld	hl,(ix-4)
	ld	(ix-6),hl
;1303     if ((readFunc)(readContext, buf, count) != count)  break;
@430:
	.debug	# 1303
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	call	__callde##
	add	sp,6
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@427
;1304     if ((writeFunc)(writeContext, buf, count) != count)  break;
	.debug	# 1304
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__callde##
	add	sp,6
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@427
;1305     remain -= count;
	.debug	# 1305
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1306     if (showProgress)  { printf("%10lu\r", copyCount-remain);  fflush(stdou
	.debug	# 1306
	ld	a,(ix+21)
	or	a,a
	jr	z,@433
@434:
	.debug	< @434 @435
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,word (phys @54+116)
	ld	c,phys @54+116 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
@435:
	.debug	>
;1307   }
@433:
@429:
	.debug	>
;1308   if (showProgress)  printf("\r\n");
	jp	@426
@427:
	.debug	# 1308
	ld	a,(ix+21)
	or	a,a
	jr	z,@436
	ld	de,word (phys @54+96)
	ld	c,phys @54+96 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1309 
;1310   return copyCount - remain;
@436:
	.debug	# 1310
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
;1311 }
@424:
	.debug	} @424 1311

@423	equ	6
	ld	sp,ix
	pop	ix
	lret
@425	equ	8
;1312 
;1313 
;1314 //-------------------------------------------------------------------------
;1315 //  Send a pakcet using a UDP socket set for broadcast mode.
;1316 //
;1317 //  Returns 0 if successful.  If an error occurs, it closes the socket and
;1318 //  returns -1.
;1319 //-------------------------------------------------------------------------
;1320 int sendBCastPkt(int *sockfd, int port, ulong bcIPv4Addr,
;1321                  char far *pktBuf, int pktLen)
;1322 {
$sendBCastPkt::
	.debug	G $sendBCastPkt 92 9
	.debug	{ $sendBCastPkt 92 1320 @439 @438
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	.debug	A sockfd 5 67
	.debug	A port 7 6
	.debug	A bcIPv4Addr 9 9
	.debug	A pktBuf 13 43
	.debug	A pktLen 17 6
;1323   int  stat, addrLen, fflags;
	.debug	L stat -2 6
	.debug	L addrLen -4 6
	.debug	L fflags -6 6
;1324   SAI  bcAddr;
	.debug	L bcAddr -20 93
;1325 
;1326 
;1327   addrLen = sizeof(SAI);
	.debug	# 1327
	ld	hl,0xe
	ld	(ix-4),hl
;1328 
;1329 /*--- Form the broadcast address ---*/
;1330   memset(&bcAddr, 0, addrLen);
	.debug	# 1330
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-16+@437
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;1331   #ifdef  vxWorks
;1334   bcAddr.sin_family = AF_INET;
	.debug	# 1334
	ld	hl,0x2
	ld	(ix-20),hl
;1335   bcAddr.sin_port = htons(port);
	.debug	# 1335
	ld	hl,(ix+7)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-18),hl
;1336   bcAddr.SIN_ADDR = htonl(bcIPv4Addr);
	.debug	# 1336
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;1337 
;1338 //--- set the socket descriptor to blocking mode ---
;1339   fflags = fcntl(*sockfd, F_GETFL, 0);
	.debug	# 1339
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-6),hl
;1340   fcntl(*sockfd, F_SETFL, fflags & ~O_NONBLOCK);
	.debug	# 1340
	res	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$fcntl
	add	sp,6
;1341 
;1342 //--- send the broadcast packet ---
;1343   stat = sendto(*sockfd, (void far *)pktBuf, pktLen, 0, (SAP)&bcAddr, addrL
	.debug	# 1343
	ld	hl,(ix-4)
	push	hl
	ld	hl,-18+@437
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sendto
	add	sp,14
	ld	(ix-2),hl
;1344   if (stat < 0)  {
	.debug	# 1344
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@440
;1345     perror("sendBCastPkt()");  close(*sockfd);  *sockfd = -1;  return -1; }
@441:
	.debug	< @441 @442
	.debug	# 1345
	ld	de,word (phys @54+123)
	ld	c,phys @54+123 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	h,d
	ld	l,e
	jr	@438
@442:
	.debug	>
;1346 
;1347 //--- reset the flags for the socket descriptor ---
;1348   fcntl(*sockfd, F_SETFL, fflags);
@440:
	.debug	# 1348
	ld	hl,(ix-6)
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$fcntl
	add	sp,6
;1349 
;1350   return 0;
	.debug	# 1350
	bool	hl
	ld	l,h
;1351 }
@438:
	.debug	} @438 1351

@437	equ	20
	ld	sp,ix
	pop	ix
	lret
@439	equ	22
;1352 
;1353 
;1354 
;1355 //-------------------------------------------------------------------------
;1356 //  Check a list of strings to see if a given string is in the list
;1357 //  The end of strList is denoted by a NULL ptr
;1358 //
;1359 //  Returns the index in to the list if found, or -1 if not
;1360 //-------------------------------------------------------------------------
;1361 int strListIdx(char **listPtr, char *testStr)
;1362 {
$strListIdx::
	.debug	G $strListIdx 94 9
	.debug	{ $strListIdx 94 1361 @445 @444
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A listPtr 5 39
	.debug	A testStr 7 36
;1363   int  i;
	.debug	L i -2 6
;1364 
;1365 
;1366   if (!listPtr OR !testStr)  return -1;
	.debug	# 1366
	ld	hl,(ix+5)
	bool	hl
	jr	z,@446
	ld	hl,(ix+7)
	bool	hl
	jr	nz,@447
@446:
	ld	hl,0xffff
	jr	@444
;1367 
;1368   for (i=0; listPtr[i]; ++i)
@447:
@448:
	.debug	< @448 @449
	.debug	# 1368
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@450:
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@451
;1369     if (stricmp(testStr, listPtr[i]) == 0)  return i;
	.debug	# 1369
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@453
	ld	hl,(ix-2)
	jr	@444
;1370 
;1371   return -1;
@453:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@450
@451:
@449:
	.debug	>
	.debug	# 1371
	ld	hl,0xffff
;1372 }
@444:
	.debug	} @444 1372

@443	equ	2
	ld	sp,ix
	pop	ix
	lret
@445	equ	4
;1373 
;1374 
;1375 //-------------------------------------------------------------------------
;1376 //  format the current time in to the supplied buffer in the format:
;1377 //      yyyy-dd-mm hh:mm:ss.mmm
;1378 //-------------------------------------------------------------------------
;1379 char *dateTimeMS(char *buf, const time_t dateTime, uint ms)
;1380 {
$dateTimeMS::
	.debug	G $dateTimeMS 95 9
	.debug	{ $dateTimeMS 95 1379 @456 @455
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-18
	.debug	A buf 5 36
	.debug	A dateTime 7 9
	.debug	A ms 11 7
;1381   struct tm  tms;
	.debug	L tms -18 76
;1382 
;1383   localtime_r(&dateTime, &tms);
	.debug	# 1383
	ld	hl,-18+@454
	add	hl,sp
	push	hl
	ld	hl,9+@454
	add	hl,sp
	push	hl
	lcall	$localtime_r
	add	sp,4
;1384 
;1385   sprintf(buf, "%04d-%02d-%02d %02d:%02d:%02d.%03u",
;1386          tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;1387          tms.tm_hour, tms.tm_min, tms.tm_sec, ms );
	.debug	# 1387
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-16)
	push	hl
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	hl,(ix-10)
	inc	hl
	push	hl
	ld	hl,(ix-8)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	de,word (phys @54+138)
	ld	c,phys @54+138 >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,22
;1388 
;1389   return buf;
	.debug	# 1389
	ld	hl,(ix+5)
;1390 }
@455:
	.debug	} @455 1390

@454	equ	18
	ld	sp,ix
	pop	ix
	lret
@456	equ	20
;1391 
;1392 //-------------------------------------------------------------------------
;1393 //  print a "header" line common to several user commands
;1394 //-------------------------------------------------------------------------
;1395 void stdHeader(void)
;1396 {
$stdHeader::
	.debug	G $stdHeader 69 9
	.debug	{ $stdHeader 69 1395 @459 @458
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-44
;1397   uint  ctlRate;
	.debug	L ctlRate -2 7
;1398   ulong  upSecs;
	.debug	L upSecs -6 9
;1399   time_t  dateTime;
	.debug	L dateTime -10 9
;1400   struct tm  tms;
	.debug	L tms -28 76
;1401   char  msg[16];
	.debug	L msg -44 96
;1402 
;1403 
;1404 //2011-12-29 13:46:49   Idle: 42%  Control: 100/s  [51:0026]   Up: 0d 02:57
;1405 
;1406   CursorTo(0, 0);
	.debug	# 1406
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @54+173)
	ld	c,phys @54+173 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1407 
;1408   _EnterCritical_();
	.debug	# 1408
	ipset	2
;1409   ctlRate = ctlLoopTicksPerSec;  dateTime = TIME();
	.debug	# 1409
	ld	hl,(_ctlLoopTicksPerSec)
	ld	(ix-2),hl
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;1410     _ExitCritical_();
	.debug	# 1410
	ipres
;1411 
;1412   upSecs = GetSeconds();;
	.debug	# 1412
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;1413 
;1414   localtime_r(&dateTime, &tms);
	.debug	# 1414
	ld	hl,-28+@457
	add	hl,sp
	push	hl
	ld	hl,-8+@457
	add	hl,sp
	push	hl
	lcall	$localtime_r
	add	sp,4
;1415   printf("%04d-%02d-%02d %02d:%02d:%02d",
;1416          tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;1417          tms.tm_hour, tms.tm_min, tms.tm_sec );
	.debug	# 1417
	ld	hl,(ix-28)
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-22)
	push	hl
	ld	hl,(ix-20)
	inc	hl
	push	hl
	ld	hl,(ix-18)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	de,word (phys @54+186)
	ld	c,phys @54+186 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;1418 
;1419   printf("   Idle: %2d%%  Control: %3u/s  [%02X:%04lX]   Up: %s %s\r\n",
;1420     percentIdle, ctlRate, devType, deviceID, fmtDHMS(msg, upSecs), cllCmd);
	.debug	# 1420
	ld	hl,_cllCmd
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-38+@457
	add	hl,sp
	push	hl
	lcall	$fmtDHMS
	add	sp,6
	push	hl
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	hl,(_devType)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,(_percentIdle)
	push	hl
	ld	de,word (phys @54+216)
	ld	c,phys @54+216 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;1421 }
@458:
	.debug	} @458 1421

@457	equ	44
	ld	sp,ix
	pop	ix
	lret
@459	equ	46
;1422 
;1423 //-------------------------------------------------------------------------
;1424 void showNetState(int iface)
;1425 {
$showNetState::
	.debug	G $showNetState 97 9
	.debug	{ $showNetState 97 1424 @462 @461
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-93
	.debug	A iface 5 6
;1426   IFConfig  ifConfig;
	.debug	L ifConfig -25 98
;1427   char  *stateDesc;
	.debug	L stateDesc -27 36
;1428   char  macStr[18], ipStr[16], bcStr[16], maskStr[16];
	.debug	L macStr -45 99
	.debug	L ipStr -61 96
	.debug	L bcStr -77 96
	.debug	L maskStr -93 96
;1429 
;1430 /* Sample output for ifconfig command on a Linux box:
;1431 
;1432 eth0      Link encap:Ethernet  HWaddr 00:11:09:65:E8:15
;1433           inet addr:35.9.57.207  Bcast:35.15.255.255  Mask:255.248.0.0
;1434           inet6 addr: fe80::211:9ff:fe65:e815/64 Scope:Link
;1435           UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
;1436           RX packets:273501680 errors:0 dropped:0 overruns:0 frame:0
;1437           TX packets:45036584 errors:0 dropped:0 overruns:0 carrier:0
;1438           collisions:0 txqueuelen:1000
;1439           RX bytes:2732679160 (2.5 GiB)  TX bytes:3498902465 (3.2 GiB)
;1440           Interrupt:169 Base address:0x6f00
;1441 */
;1442 
;1443   getIFConfig(iface, &ifConfig);
	.debug	# 1443
	ld	hl,-25+@460
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$getIFConfig
	add	sp,4
;1444 
;1445   mactoa(macStr, ifConfig.macAddr);
	.debug	# 1445
	ld	hl,-9+@460
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-41+@460
	add	hl,sp
	push	hl
	lcall	$mactoa
	add	sp,6
;1446   inet_htop(AF_INET, &ifConfig.ipAddr,  ipStr,   sizeof(ipStr));
	.debug	# 1446
	ld	hl,0x10
	push	hl
	ld	hl,-59+@460
	add	hl,sp
	push	hl
	ld	hl,-21+@460
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;1447   inet_htop(AF_INET, &ifConfig.bcAddr,  bcStr,   sizeof(bcStr));
	.debug	# 1447
	ld	hl,0x10
	push	hl
	ld	hl,-75+@460
	add	hl,sp
	push	hl
	ld	hl,-17+@460
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;1448   inet_htop(AF_INET, &ifConfig.netmask, maskStr, sizeof(maskStr));
	.debug	# 1448
	ld	hl,0x10
	push	hl
	ld	hl,-91+@460
	add	hl,sp
	push	hl
	ld	hl,-13+@460
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;1449 
;1450   switch (ifConfig.state)  {
	.debug	# 1450
	ld	a,(ix-1)
	jr	@463
;1451     case IF_DOWN:         stateDesc = "DOWN";         break;
@465:
	.debug	< @465 @466
	.debug	# 1451
@467:
	ld	hl,@1+69
	jr	@529
;1452     case IF_COMING_UP:    stateDesc = "COMING UP";    break;
	.debug	# 1452
@468:
	ld	hl,@1+74
	jr	@529
;1453     case IF_UP:           stateDesc = "UP";           break;
	.debug	# 1453
@469:
	ld	hl,@1+81
	jr	@529
;1454     case IF_COMING_DOWN:  stateDesc = "COMING DOWN";  break;
	.debug	# 1454
@470:
	ld	hl,@1+84
	jr	@529
;1455     default:              stateDesc = "UNKNOWN";
	.debug	# 1455
@471:
	ld	hl,@1+96
@529:
	ld	(ix-27),hl
;1456   }
@466:
	.debug	>
;1457 
;1458 
;1459   printf("eth%d      Link encap:Ethernet  HWaddr %.18s\r\n", iface, macStr)
	jr	@464
@463:
	or	a,a
	jr	z,@467
	cp	0x1
	jr	z,@468
	cp	0x2
	jr	z,@469
	cp	0x3
	jr	z,@470
	jr	@471
@464:
	.debug	# 1459
	ld	hl,-45+@460
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @54+275)
	ld	c,phys @54+275 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1460   printf("          inet addr:%.16s  Bcast:%.16s  Mask:%.16s\r\n",
;1461          ipStr, bcStr, maskStr);
	.debug	# 1461
	ld	hl,-93+@460
	add	hl,sp
	push	hl
	ld	hl,-75+@460
	add	hl,sp
	push	hl
	ld	hl,-57+@460
	add	hl,sp
	push	hl
	ld	de,word (phys @54+322)
	ld	c,phys @54+322 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;1462   printf("          %s BROADCAST MTU:%d\r\n", stateDesc, ifConfig.mtu);
	.debug	# 1462
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix-27)
	push	hl
	ld	de,word (phys @54+375)
	ld	c,phys @54+375 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1463 }
@461:
	.debug	} @461 1463

@460	equ	93
	ld	sp,ix
	pop	ix
	lret
@462	equ	95
;1464 
;1465 //-------------------------------------------------------------------------
;1466 //  Add an EventMsg to the end of an event queue FIFO
;1467 //-------------------------------------------------------------------------
;1468 // PARAMTERS:
;1469 //
;1470 //   eventsfd:
;1471 //      The file descriptor to which the EventMsg is to be written.  If < 0
;1472 //      this function will attempt to write the msg in to the standard
;1473 //      application process' event queue.
;1474 //
;1475 //   eventFunc:
;1476 //      A pointer to the function to be called by the task that processes
;1477 //      the events in the queue (normally the main application process).
;1478 //      A pointer to a copy of the message will be passed to the function.
;1479 //
;1480 //   chan:
;1481 //      For controllers that manage multiple devices, the channel or device
;1482 //      that the message applies to.  Use 0 if the command does not apply t
;1483 //      a specific channel (or there IS only 1 channel).
;1484 //
;1485 //   eventMsg:
;1486 //      A pointer to a buffer to use for constructing an EventMsg structure
;1487 //
;1488 //   data:
;1489 //      A pointer to any data for the message.  Specify NULL if there is no
;1490 //      data for the message, or the data is already in the EventMsg struct
;1491 //      pointed to by the eventMsg pointer.
;1492 //
;1493 //   dataLen:
;1494 //      The # of bytes of data to be sent in the message.  If dataLen > 0 a
;1495 //      the data pointer is NULL, the assumption is the data already reside
;1496 //      in the EventMsg structure pointed to by the eventMsg parameter.
;1497 //
;1498 //
;1499 // RETURNS:
;1500 //     0 on success, < 0 if an error
;1501 //
;1502 //
;1503 //  NOTES:
;1504 //    - The data for a message must NOT contain pointers to local (auto) da
;1505 //      values since these pointers will not be valid in the context of the
;1506 //      process that actually processes the message.  Pointers to global
;1507 //      shared memory values are allowed (alothough keep in mind that the
;1508 //      value pointed to could change by the time the msg is processed).
;1509 //
;1510 //    - Use of separate pointers for the EventMsg structure and the msg dat
;1511 //      provides 2 important features for msgs with larger data sizes:
;1512 //      - No need to provide stack large enough for a 2nd copy of the msg d
;1513 //      - No need to spend time copying the msg data from one buffer to ano
;1514 //
;1515 //      The intent is that, for larger messages, the calling function will
;1516 //      simply read the msg data into a buffer holding an EventMsg structur
;1517 //      and specify NULL for the data pointer (even though the dataLen is >
;1518 //
;1519 //    - Specifying -1 for the eventsfd and/or specifying a non-NULL pointer
;1520 //      for the data allows the calling function to minimize its size in
;1521 //      exchange for a bit more CPU time (to open the FIFO and/or copy the
;1522 //      data in to the EventMsg structure).
;1523 //
;1524 //-------------------------------------------------------------------------
;1525 int putMsg(fd_t eventsfd, EventHandler eventFunc, int chan,
;1526            EventMsg *eventMsg, void *data, int dataLen)
;1527 {
$putMsg::
	.debug	G $putMsg 100 9
	.debug	{ $putMsg 100 1525 @474 @473
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A eventsfd 5 6
	.debug	A eventFunc 7 101
	.debug	A chan 9 6
	.debug	A eventMsg 11 103
	.debug	A data 13 55
	.debug	A dataLen 15 6
;1528   bool  closefd;
	.debug	L closefd -1 3
;1529 
;1530 
;1531 //--- if the caller did not provide an fd to write to, then assume the ---
;1532 //--- msg should go in the standard application events FIFO queue ---
;1533   closefd = false;
	.debug	# 1533
	xor	a,a
	ld	(ix-1),a
;1534   if (eventsfd < 0)  {
	.debug	# 1534
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@475
;1535     if ((eventsfd = open(EventsFIFO, O_WRONLY, 0)) < 0)  {
@476:
	.debug	< @476 @477
	.debug	# 1535
	bool	hl
	ld	l,h
	push	hl
	inc	l
	inc	l
	push	hl
	ld	hl,@1+104
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix+5),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@478
;1536       perror(EventsFIFO);  return -1;  }
@479:
	.debug	< @479 @480
	.debug	# 1536
	ld	de,word (phys @54+407)
	ld	c,phys @54+407 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	jr	@473
@480:
	.debug	>
;1537     closefd = true;
@478:
	.debug	# 1537
	ld	(ix-1),0x1
;1538   }
@477:
	.debug	>
;1539 
;1540   eventMsg->dataLen = dataLen;
@475:
	.debug	# 1540
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+15)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1541   eventMsg->eventFunc = eventFunc;
	.debug	# 1541
	ld	hl,(ix+11)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1542   eventMsg->chanNum = chan;
	.debug	# 1542
	ld	hl,(ix+11)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1543   if (dataLen AND (data != NULL))  memcpy(eventMsg->data, data, dataLen);
	.debug	# 1543
	ld	hl,(ix+15)
	bool	hl
	jr	z,@482
	ld	hl,(ix+13)
	bool	hl
	jr	z,@482
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	ld	de,0x6
	add	hl,de
	push	hl
	call	_memcpy
	add	sp,6
;1544 
;1545   write(eventsfd, (char *)eventMsg, dataLen + MSG_HDR_SIZE);
@482:
	.debug	# 1545
	ld	hl,(ix+15)
	ld	de,0x6
	add	hl,de
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$write
	add	sp,6
;1546 
;1547   if (closefd)  close(eventsfd);
	.debug	# 1547
	ld	a,(ix-1)
	or	a,a
	jr	z,@483
	ld	hl,(ix+5)
	push	hl
	lcall	$close
	pop	de
;1548 
;1549   return 0;
@483:
	.debug	# 1549
	bool	hl
	ld	l,h
;1550 }
@473:
	.debug	} @473 1550

@472	equ	1
	ld	sp,ix
	pop	ix
	lret
@474	equ	3
;1551 
;1552 
;1553 //-------------------------------------------------------------------------
;1554 //  process the next event msg in the queue (if any)
;1555 //-------------------------------------------------------------------------
;1556 void processMsg(fd_t eventsfd, EventMsg *eventMsg, int bufSize)
;1557 {
$processMsg::
	.debug	G $processMsg 105 9
	.debug	{ $processMsg 105 1556 @486 @485
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A eventsfd 5 6
	.debug	A eventMsg 7 103
	.debug	A bufSize 9 6
;1558   int  ttlLen, readLen;
	.debug	L ttlLen -2 6
	.debug	L readLen -4 6
;1559 
;1560 
;1561   if (read(eventsfd, (char *)eventMsg, 2) != 2)  return;
	.debug	# 1561
	ld	hl,0x2
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read
	add	sp,6
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@485
;1562 
;1563   ttlLen = eventMsg->dataLen + MSG_HDR_SIZE;
	.debug	# 1563
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	e,0x6
	add	hl,de
	ld	(ix-2),hl
;1564   readLen = ttlLen  - 2;
	.debug	# 1564
	dec	hl
	dec	hl
	ld	(ix-4),hl
;1565 
;1566   if (ttlLen > bufSize)  {
	.debug	# 1566
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	c,@488
	jr	z,@488
;1567     fprintf(DiagLog, "event msg too long: %d\n", ttlLen);
@489:
	.debug	< @489 @490
	.debug	# 1567
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @54+418)
	ld	c,phys @54+418 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1568     skipBytes(eventsfd, readLen, 500);  return;
	.debug	# 1568
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipBytes
	jr	@528
;1569   }
@490:
	.debug	>
;1570 
;1571   if (ttlLen < MSG_HDR_SIZE)  {
@488:
	.debug	# 1571
	ld	hl,(ix-2)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nc,@491
;1572     fprintf(DiagLog, "event msg too short: %d\n", ttlLen);  return;  }
@492:
	.debug	< @492 @493
	.debug	# 1572
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @54+442)
	ld	c,phys @54+442 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
@528:
	add	sp,8
	jr	@485
@493:
	.debug	>
;1573 
;1574   if (read(eventsfd, (char *)eventMsg+2, readLen) != readLen)  {
@491:
	.debug	# 1574
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read
	add	sp,6
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@494
;1575     perror("processMsg");  return;  }
@495:
	.debug	< @495 @496
	.debug	# 1575
	ld	de,word (phys @54+467)
	ld	c,phys @54+467 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	jr	@485
@496:
	.debug	>
;1576 
;1577   if (ShowEventMsgs)
@494:
	.debug	# 1577
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x1000
	and	hl,de
	jr	z,@497
;1578     fprintf(DiagLog, "EventMsg: Addr: 0x%08lx  dataLen: %d\n",
;1579            (ulong)eventMsg->eventFunc, eventMsg->dataLen);
	.debug	# 1579
	ld	hl,(ix+7)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	b,l
	ld	c,l
	push	bc
	push	de
	ld	de,word (phys @54+478)
	ld	c,phys @54+478 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;1580 
;1581   (*(EventHandler)(eventMsg->eventFunc))(eventMsg);
@497:
	.debug	# 1581
	ld	hl,(ix+7)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	pop	hl
;1582 }
@485:
	.debug	} @485 1582

@484	equ	4
	ld	sp,ix
	pop	ix
	lret
@486	equ	6
;1583 
;1584 
;1585 /*
;1586 //-------------------------------------------------------------------------
;1587 //  (slow) test of algorithm for floating point multiply
;1588 //-------------------------------------------------------------------------
;1589 float near fmult(float f1, float f2)
;1590 {
;1591   int  exp;
;1592   ulong  result;
;1593   uchar  exp1, exp2;
;1594   uint  man1, man2;
;1595 
;1596 
;1597 #define  f1_0  (*(((uchar *)&f1)+3))
;1598 #define  f1_1  (*(((uchar *)&f1)+2))
;1599 #define  f1_2  (*(((uchar *)&f1)+1))
;1600 #define  f1_3  (*(((uchar *)&f1)+0))
;1601 
;1602 #define  f2_0  (*(((uchar *)&f2)+3))
;1603 #define  f2_1  (*(((uchar *)&f2)+2))
;1604 #define  f2_2  (*(((uchar *)&f2)+1))
;1605 #define  f2_3  (*(((uchar *)&f2)+0))
;1606 
;1607 #define  result_0  (*(((uchar *)&result)+3))
;1608 #define  result_1  (*(((uchar *)&result)+2))
;1609 #define  result_2  (*(((uchar *)&result)+1))
;1610 #define  result_3  (*(((uchar *)&result)+0))
;1611 
;1612 #define  man1_0 (*(((uchar *)&man1)+1))
;1613 #define  man1_1 (*(((uchar *)&man1)+0))
;1614 
;1615 #define  man2_0 (*(((uchar *)&man2)+1))
;1616 #define  man2_1 (*(((uchar *)&man2)+0))
;1617 
;1618 
;1619   man1_0 = (f1_1 | 0x80);  man1_1 = f1_2;
;1620   man2_0 = (f2_1 | 0x80);  man2_1 = f2_2;
;1621 
;1622   result =  ((ulong)man1 * man2);
;1623 
;1624 //  result += (((ulong)m1l * (uint)f2_3) + ((ulong)m2l * (uint)f1_3)) >> 8;
;1625 
;1626 //  result = result >> 8;
;1627   result_3 = result_2;  result_2 = result_1;  result_1 = result_0;
;1628 
;1629   exp1 = ((f1_0 << 1) | (f1_1 >> 7));
;1630   exp2 = ((f2_0 << 1) | (f2_1 >> 7));
;1631   exp = (int)((uint)exp1 + (uint)exp2) - 254;
;1632   while (!(result_1 & 0x80))  { result <<= 1; --exp; }
;1633 
;1634 //  result_1 &= 0x7f;  result |= ((ulong)(exp + 128)) << 23;
;1635   exp += 128;
;1636   result_0 = ((uchar)exp >> 1);
;1637   result_1 &= 0x7f;  result_1 |= ((uchar)exp << 7);
;1638 
;1639   if ((f1_0 ^ f2_0) & 0x80)  result_0 |= 0x80;
;1640 
;1641 
;1642   return *((float *)&result);
;1643 }
;1644 */
;1645 
;1646 
;1647 
;1648 //-------------------------------------------------------------------------
;1649 //  faster but less accurate floating point multiply than the Softools C
;1650 //  version (this uses "mul" instructions like the DynamicC libs, while the
;1651 //  Softools C version uses shifts and meets IEEE standards)
;1652 //-------------------------------------------------------------------------
;1653 /*
;1654 #pragma warn -764  // turn off warning about not returning a value
;1655 
;1656 float near fmult(float f1, float f2)
;1657 {
;1658 //  if ((f1 == 0.0) OR (f2 == 0.0))  return 0.0;  //tdebug
;1659   ;
;1660 #asm
;1661 ;;        .cseg
;1662 
;1663 .result     equ   -20     ;; temp 32-bit mantissa for result
;1664 .man2A      equ   -16     ;; mantissa 2  (16-bits)
;1665 .man1A      equ   -14     ;; mantissa 1  (16-bits)
;1666 .resultExp  EQU   -8      ;; 1 byte
;1667 .f1         EQU    4      ;; IEEE float (4 bytes)
;1668 .f2         EQU    8      ;; IEEE float (4 bytes)
;1669 
;1670 
;1671 ;;----- provided by compiler -----
;1672 ;;        push    ix
;1673 ;;
;1674 ;;        ld      ix,0
;1675 ;;        add     ix,sp
;1676 ;;--------------------------------
;1677 
;1678         add     sp,-12             ; additional local variables
;1679 
;1680 ;  if ((f1 == 0.0) OR (f2 == 0.0))  return 0.0;
;1681         ld      hl,(ix+.f1)
;1682         ex      de,hl
;1683         ld      hl,(ix+.f1+2)
;1684         ld      bc,hl
;1685         ld      a,b
;1686         and     a,7Fh
;1687         or      a,c
;1688         or      a,d
;1689         or      a,e
;1690         jr      z,@501x
;1691         ld      hl,(ix+.f2)
;1692         ex      de,hl
;1693         ld      hl,(ix+.f2+2)
;1694         ld      bc,hl
;1695         ld      a,b
;1696         and     a,7Fh
;1697         or      a,c
;1698         or      a,d
;1699         or      a,e
;1700         jr      nz,@502x
;1701 @501x:
;1702         ld      de,0
;1703         ld      c,e
;1704         ld      b,e
;1705         jp      done
;1706 @502x:
;1707 
;1708 
;1709 ;#define  f1_0  (*(((uchar *)&f1)+3))
;1710 ;#define  f1_1  (*(((uchar *)&f1)+2))
;1711 ;#define  f1_2  (*(((uchar *)&f1)+1))
;1712 ;#define  f1_3  (*(((uchar *)&f1)+0))
;1713 
;1714 ;#define  f2_0  (*(((uchar *)&f2)+3))
;1715 ;#define  f2_1  (*(((uchar *)&f2)+2))
;1716 ;#define  f2_2  (*(((uchar *)&f2)+1))
;1717 ;#define  f2_3  (*(((uchar *)&f2)+0))
;1718 ;
;1719 ;#define  FirstByte  (*(((uchar *)&u3)+2))
;1720 
;1721 
;1722 ;=== D = ((f1_0 << 1) | (f1_1 >> 7));  // f1 exponent
;1723     ld      hl,(ix+.f1+2)      ;[9]  HL = MSW(f1)
;1724     ld      a,h                ;[2]  save byte with f1's sign bit
;1725     ex      de,hl              ;[2]  DE = HL
;1726     rl      de                 ;[2]  D = MSB(DE << 1) == f1 exponent
;1727     ld      c,d                ;[2]  C = f1 exponent
;1728 
;1729 ;=== H = ((f2_0 << 1) | (f2_1 >> 7));  // f2 exponent
;1730     ld      hl,(ix+.f2+2)      ;[9]  HL = MSW(f2)
;1731     xor     h                  ;[2]  msbit of A has sign bit for result
;1732     sla     a                  ;[4]  now carry bit has sign bit
;1733     ex      af,af'             ;[2]  save carry bit with sign bit for resul
;1734     ex      de,hl              ;[2]  DE = HL
;1735     rl      de                 ;[2]  D = MSB(DE << 1) == f2 exponent
;1736 
;1737 ;=== exp = (int)((uint)exp1 + (uint)exp2) - 254;
;1738     bool    hl                 ;[2]  H = 0
;1739     ld      b,h                ;[2]  BC = f1 exponent
;1740     ld      l,d                ;[2]  HL = f2 exponent
;1741     add     hl,bc              ;[2]  HL = f1 exp + f2 exp
;1742     ld      de,0xff82          ;[6]  DE = 128-254
;1743     add     hl,de              ;[2]  HL = result exponent
;1744     ld      (ix+.resultExp),l  ;[10] save 8 bit result exponent
;1745 
;1746 ;; close approximation of result Mantissa computed as:
;1747 ;;   man1A*man2A + (man1A*man2B + man2A*man1B) >> 8
;1748 ;;
;1749 ;; where man1A, man2A are 15 msb of each mantissa (incl implied 1 bit)
;1750 ;;       man2B, man2B are  9 lsb of each mantissa
;1751 ;;
;1752 ;;   s-eeeeeee e-
;1753 ;;             1-AAAAAAA AAAAAAA-B BBBBBBB
;1754 
;1755 ;=== BC = ((uint)(f1_1 | 0x80)<<8 | (uint)f1_2) >> 1;  // 15 msb of f1 mant
;1756     bool    hl                 ;[2]  to clear carry flag
;1757     ld      hl,(ix+.f1+1)      ;[9]  2nd and 3rd bytes of f1
;1758     set     7,h                ;[4]  force implied 1 bit
;1759     rr      hl                 ;[2]  carry -> [HL] -> carry
;1760     ld      bc,hl              ;[4]  BC = 01xxxxxx xxxxxxxx
;1761     push    bc                 ;[10] save result at (ix-14)
;1762 
;1763 ;=== DE = ((uint)(f2_1 | 0x80)<<8 | (uint)f2_2) >> 1;  // 15 msb of f2 mant
;1764     bool    hl                 ;[2]  to clear carry flag
;1765     ld      hl,(ix+.f2+1)      ;[9]  2nd and 3rd bytes of f2
;1766     set     7,h                ;[4]  force implied 1 bit
;1767     rr      hl                 ;[2]  carry -> [HL] -> carry
;1768     ld      de,hl              ;[4]  DE = 01xxxxxx xxxxxxxx
;1769     push    de                 ;[10] save result at (ix-16)
;1770 
;1771 ;=== multiply 2 15-bit mantissa values (msb is 0 for both values)
;1772     mul                        ;[16] HL:BC = BC * DE
;1773 
;1774     push    hl                 ;[10] msw at (ix-18)
;1775     push    bc                 ;[10] lsw at (ix-20)
;1776 
;1777 ;=== add in (man1A * man2B) >> 8
;1778     ld      hl,(ix+.f2)        ;[9]  HL = 3rd and 4th bytes of f2
;1779     ld      a,h                ;[2]
;1780     and     a,0x01             ;[4]  keep on 9th bit
;1781     ld      b,a                ;[2]  A
;1782     ld      c,l                ;[2]  BC = 9 lsb of f1 mantissa
;1783     ld      hl,(ix+.man1A)     ;[9]
;1784     ex      de,hl              ;[2]  DE = 15 msb of f1 mantissa (with impli
;1785     mul                        ;[16] HL:BC = man1A * man2B
;1786     ld      e,b                ;[2]
;1787     ld      d,l                ;[2]  DE has 12-msb of 20-bit result
;1788     rr      de                 ;[2]
;1789     res     7,d                ;[4]
;1790     ; add to 32-bit result mantissa
;1791     ld      hl,(ix+.result)    ;[9]  HL = LSW(result)
;1792     add     hl,de              ;[2]
;1793     ld      (ix+.result),hl    ;[11]
;1794     jr      nc,nocarry1        ;[5]
;1795     ld      hl,(ix+.result+2)  ;[9]  HL = MSW(result)
;1796     inc     hl                 ;[2]
;1797     ld      (ix+.result+2),hl  ;[9]
;1798 nocarry1:
;1799 ;=== add in (man2A * man1B) >> 8
;1800     ld      hl,(ix+.f1)        ;[9]  HL = LSW(f1)
;1801     ld      a,h                ;[2]
;1802     and     a,0x01             ;[4]  keep on 9th bit
;1803     ld      b,a                ;[2]  A
;1804     ld      c,l                ;[2]  BC = 9 lsb of f1 mantissa
;1805     ld      hl,(ix+.man2A)     ;[9]
;1806     ex      de,hl              ;[2]  DE = 15 msb of f1 mantissa (with impli
;1807     mul                        ;[16] HL:BC = man2A * man1B
;1808     ld      e,b                ;[2]
;1809     ld      d,l                ;[2]  DE has 12-msb of 20-bit result
;1810     rr      de                 ;[2]
;1811     res     7,d                ;[4]
;1812   ; add to 32-bit result mantissa
;1813     ld      hl,(ix+.result)    ;[9]  HL = lsw of 32-bit result
;1814     add     hl,de              ;[2]
;1815     ld      (ix+.result),hl    ;[11]
;1816     jr      nc,nocarry2        ;[5]
;1817     ld      hl,(ix+.result+2)  ;[9]  HL = msw of 32-bit mantissa
;1818     inc     hl                 ;[2]
;1819     ld      (ix+.result+2),hl  ;[9]
;1820 nocarry2:
;1821 
;1822 ;=== set HL:DE = 32-bit result
;1823     ld      hl,(ix+.result)    ;[9]
;1824     ex      de,hl              ;[2]
;1825     ld      hl,(ix+.result+2)  ;[9]
;1826 
;1827 ;=== shift HL:DE left 2 or 3 bits (until msb is a 1)
;1828 
;1829     rl      de                 ;[2]  carry <- [DE] <- carry
;1830     ex      de,hl              ;[2]
;1831     rl      de                 ;[2]  carry <- [DE] <- carry
;1832     ex      de,hl              ;[2]
;1833 
;1834     rl      de                 ;[2]  carry <- [DE] <- carry
;1835     ex      de,hl              ;[2]
;1836     rl      de                 ;[2]  carry <- [DE] <- carry
;1837     ex      de,hl              ;[2]
;1838 
;1839     ld      b,(ix+.resultExp)  ;[9]  B = 8-bit result exponent
;1840 
;1841     ;--- if msb is not 1, then shift one more time ---
;1842     bit     7,h                ;[4]  F.z
;1843     jr      nz,clear1stbit     ;[5]
;1844 
;1845     rl      de                 ;[2]  carry <- [DE] <- carry
;1846     ex      de,hl              ;[2]
;1847     rl      de                 ;[2]  carry <- [DE] <- carry
;1848     ex      de,hl              ;[2]
;1849 
;1850     dec     b                  ;[2]  and decr exponent
;1851 
;1852 clear1stbit:
;1853     res     7,h                ;[4]  reset msb (the implied 1 bit for manti
;1854 
;1855 ;=== put result in to BC:DE
;1856     ex      af,af'             ;[2]  carry bit contains sign bit for result
;1857     rr      b                  ;[4]  carry -> [B] -> carry
;1858     ld      c,0                ;[4]
;1859     rr      c                  ;[4]  carry -> [C] -> carry
;1860     ld      a,c                ;[2]
;1861     or      h                  ;[2]
;1862     ld      c,a                ;[2]
;1863     ld      e,d                ;[2]
;1864     ld      d,l                ;[2]
;1865 
;1866 .COMMENT ~
;1867 ;// ... a LOT more work for a TINY bit more accuracy....
;1868 ;  u3 += (((ulong)m1l * (uint)f2_3) + ((ulong)m2l * (uint)f1_3)) >> 8;
;1869     ld      a,(ix+8)
;1870     bool    hl
;1871     ld      l,a
;1872     ex      de,hl
;1873     ld      hl,(ix-10)
;1874     ex      de,hl
;1875     ld      b,h
;1876     ld      c,h
;1877     push    bc
;1878     push    de
;1879     ex      de,hl
;1880     call    __ulmlt##
;1881     ld      a,(ix+4)
;1882     bool    hl
;1883     ld      l,a
;1884     push    bc
;1885     push    de
;1886     ex      de,hl
;1887     ld      hl,(ix-12)
;1888     ex      de,hl
;1889     ld      b,h
;1890     ld      c,h
;1891     push    bc
;1892     push    de
;1893     ex      de,hl
;1894     call    __ulmlt##
;1895     call    __ladd##
;1896     ld      e,d
;1897     ld      d,c
;1898     ld      c,b
;1899     ld      b,0
;1900     push    bc
;1901     push    de
;1902     ld      hl,(ix-4)
;1903     ex      de,hl
;1904     ld      hl,(ix-2)
;1905     ld      bc,hl
;1906     call    __ladd##
;1907     ld      hl,bc
;1908     ld      (ix-2),hl
;1909     ex      de,hl
;1910     ld      (ix-4),hl
;1911     ex      de,hl
;1912 
;1913 ;  u3 = u3 >> 8;
;1914     ld      e,d
;1915     ld      d,c
;1916     ld      c,b
;1917     ld      b,0
;1918     ld      hl,bc
;1919     ld      (ix-2),hl
;1920     ex      de,hl
;1921     ld      (ix-4),hl
;1922     ex      de,hl
;1923 
;1924 ;  if ((f1_0 ^ f2_0) & 0x80)  u3 |= 0x80000000L;
;1925     ld      a,(ix+7)
;1926     ld      hl,(ix+11)
;1927     xor     a,l
;1928     and     a,128
;1929     jr      z,..endif
;1930     ld      hl,(ix-2)
;1931     ld      bc,hl
;1932     set     7,b
;1933     ld      hl,bc
;1934     ld      (ix-2),hl
;1935     ex      de,hl
;1936     ld      (ix-4),hl
;1937     ex      de,hl
;1938 ..endif:
;1939 ~
;1940 
;1941 
;1942 done:
;1943     ld      sp,ix
;1944 
;1945 ;;    pop     ix
;1946 ;;        ret
;1947 
;1948 #endasm
;1949 }
;1950 
;1951 #pragma warn 764  // turn back on warning about not returning a value
;1952 */
;1953 
;1954 //-------------------------------------------------------------------------
;1955 //  Function to compare the copy of a structure's address stored in the
;1956 //  structure to the address of the structure as a means of verifying that
;1957 //  the address does indeed point to the desired type of structure.
;1958 //
;1959 //  Returns 0 if the values match.
;1960 //
;1961 //  Logs a message and returns -1 if the values do NOT match.
;1962 //-------------------------------------------------------------------------
;1963 int ValidatePtr(void *structPtr, void *copyOfPtr,
;1964                 const char *typeName, const char *context)
;1965 {
$ValidatePtr::
	.debug	G $ValidatePtr 106 9
	.debug	{ $ValidatePtr 106 1963 @500 @499
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A structPtr 5 55
	.debug	A copyOfPtr 7 55
	.debug	A typeName 9 36
	.debug	A context 11 36
;1966   if (structPtr AND ((int)structPtr != -1) AND (structPtr == copyOfPtr) )
	.debug	# 1966
	ld	hl,(ix+5)
	bool	hl
	jr	z,@502
	ld	hl,(ix+5)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@502
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@502
;1967     return 0;
	.debug	# 1967
	bool	hl
	ld	l,h
	jr	@499
;1968 
;1969   fprintf(DiagLog, "*** %s: Invalid '%s' ptr: [0x%04X] ***\r\n",
@502:
;1970           context, typeName, (uint)structPtr );
	.debug	# 1970
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	de,word (phys @54+516)
	ld	c,phys @54+516 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;1971 
;1972   return -1;
	.debug	# 1972
	ld	hl,0xffff
;1973 }
@499:
	.debug	} @499 1973

@498	equ	0
	pop	ix
	lret
@500	equ	2
;1974 
;1975 
;1976 
;1977 //-------------------------------------------------------------------------
;1978 //  Functions to display strings and/or set display attributes
;1979 //  (assumes ANSI/vt100 compatible terminal)
;1980 //-------------------------------------------------------------------------
;1981 void DispStr(uchar x, uchar y, char *msg, bool blankToEnd)
;1982 {
$DispStr::
	.debug	G $DispStr 107 9
	.debug	{ $DispStr 107 1981 @505 @504
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A x 5 3
	.debug	A y 7 3
	.debug	A msg 9 36
	.debug	A blankToEnd 11 3
;1983   printf("\033[%02d;%02dH%s", y+1, x+1, msg);
	.debug	# 1983
	ld	hl,(ix+9)
	push	hl
	ld	a,(ix+5)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	a,(ix+7)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+557)
	ld	c,phys @54+557 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;1984   if (blankToEnd)  printf("\033[K");
	.debug	# 1984
	ld	a,(ix+11)
	or	a,a
	jr	z,@506
	ld	de,word (phys @54+572)
	ld	c,phys @54+572 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1985 }
@506:
@504:
	.debug	} @504 1985

@503	equ	0
	pop	ix
	lret
@505	equ	2
;1986 
;1987 //-------------------------------------------------------------------------
;1988 void DispStrAttr(uchar x, uchar y, char *attrs, char *msg, bool blankToEnd)
;1989 {
$DispStrAttr::
	.debug	G $DispStrAttr 108 9
	.debug	{ $DispStrAttr 108 1988 @509 @508
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A x 5 3
	.debug	A y 7 3
	.debug	A attrs 9 36
	.debug	A msg 11 36
	.debug	A blankToEnd 13 3
;1990   char  *ptr;
	.debug	L ptr -2 36
;1991 
;1992   printf("\033[%02d;%02dH", y+1, x+1);
	.debug	# 1992
	ld	a,(ix+5)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	a,(ix+7)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+173)
	ld	c,phys @54+173 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1993 
;1994   ptr = attrs;
	.debug	# 1994
	ld	hl,(ix+9)
	ld	(ix-2),hl
;1995   if (*ptr)  {
	.debug	# 1995
	ld	a,(hl)
	or	a,a
	jr	z,@510
;1996     printf("\033[%d", *ptr);
@511:
	.debug	< @511 @512
	.debug	# 1996
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+576)
	ld	c,phys @54+576 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1997     while (*(++ptr))  printf(";%d", *ptr);
@513:
	.debug	# 1997
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	a,(hl)
	or	a,a
	jr	z,@514
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @54+581)
	ld	c,phys @54+581 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1998     printf("m");
	jr	@513
@514:
	.debug	# 1998
	ld	de,word (phys @54+585)
	ld	c,phys @54+585 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1999   }
@512:
	.debug	>
;2000 
;2001   printf("%s\033[0m", msg);
@510:
	.debug	# 2001
	ld	hl,(ix+11)
	push	hl
	ld	de,word (phys @54+587)
	ld	c,phys @54+587 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2002 
;2003   if (blankToEnd)  printf("\033[K");
	.debug	# 2003
	ld	a,(ix+13)
	or	a,a
	jr	z,@515
	ld	de,word (phys @54+572)
	ld	c,phys @54+572 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2004 }
@515:
@508:
	.debug	} @508 2004

@507	equ	2
	ld	sp,ix
	pop	ix
	lret
@509	equ	4
;2005 
;2006 //-------------------------------------------------------------------------
;2007 
;2008 
;2009 //=========================================================================
;2010 //  some standard Linux functions
;2011 //=========================================================================
;2012 
;2013 #ifdef RABBIT
;2014 
;2015 //-------------------------------------------------------------------------
;2016 //  return the specified time broken down in the provided tm structure
;2017 //-------------------------------------------------------------------------
;2018 struct tm *gmtime_r(const time_t *secs, struct tm *dts)
;2019 {
$gmtime_r::
	.debug	G $gmtime_r 109 9
	.debug	{ $gmtime_r 109 2018 @518 @517
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A secs 5 111
	.debug	A dts 7 110
;2020   KLOCK();  *dts = *gmtime(secs);  KUNLOCK();
	.debug	# 2020
	call	_KLOCK
	ld	hl,(ix+5)
	push	hl
	lcall	$gmtime
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	hl
	ld	bc,18
	ldir
	pop	hl
	call	_KUNLOCK
;2021 
;2022   return dts;
	.debug	# 2022
	ld	hl,(ix+7)
;2023 }
@517:
	.debug	} @517 2023

@516	equ	0
	pop	ix
	lret
@518	equ	2
;2024 
;2025 //-------------------------------------------------------------------------
;2026 //  return the specified time broken down in the provided tm structure as a
;2027 //  local time
;2028 //-------------------------------------------------------------------------
;2029 struct tm *localtime_r(const time_t *utcSecs, struct tm *dts)
;2030 {
$localtime_r::
	.debug	G $localtime_r 109 9
	.debug	{ $localtime_r 109 2029 @521 @520
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A utcSecs 5 111
	.debug	A dts 7 110
;2031   time_t  localSecs;
	.debug	L localSecs -4 9
;2032 
;2033   KLOCK();
	.debug	# 2033
	call	_KLOCK
;2034 
;2035   localSecs = *utcSecs + (long)timeZone * 3600;
	.debug	# 2035
	ld	hl,(_timeZone)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0xe10
	ld	bc,0
	call	__ulmlt##
	ld	hl,(ix+5)
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2036   *dts = *gmtime(&localSecs);
	.debug	# 2036
	ld	hl,-4+@519
	add	hl,sp
	push	hl
	lcall	$gmtime
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	hl
	ld	bc,18
	ldir
	pop	hl
;2037 
;2038   KUNLOCK();
	.debug	# 2038
	call	_KUNLOCK
;2039 
;2040   return dts;
	.debug	# 2040
	ld	hl,(ix+7)
;2041 }
@520:
	.debug	} @520 2041

@519	equ	4
	ld	sp,ix
	pop	ix
	lret
@521	equ	6
;2042 
;2043 //-------------------------------------------------------------------------
;2044 //  format a broken-down time value into a string of the following format:
;2045 //    "Wed Jun 30 21:49:08 1993\n"
;2046 //-------------------------------------------------------------------------
;2047 char *asctime_r(const struct tm *dts, char *str)
;2048 {
$asctime_r::
	.debug	G $asctime_r 112 9
	.debug	{ $asctime_r 112 2047 @524 @523
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A dts 5 110
	.debug	A str 7 36
;2049   KLOCK();
	.debug	# 2049
	call	_KLOCK
;2050   strcpy(str, asctime(dts));
	.debug	# 2050
	ld	hl,(ix+5)
	push	hl
	lcall	$asctime
	pop	de
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_strcpy
	add	sp,4
;2051   KUNLOCK();
	.debug	# 2051
	call	_KUNLOCK
;2052 
;2053   return str;
	.debug	# 2053
	ld	hl,(ix+7)
;2054 }
@523:
	.debug	} @523 2054

@522	equ	0
	pop	ix
	lret
@524	equ	2
;2055 
;2056 //-------------------------------------------------------------------------
;2057 //  format a calendar time value into a string of the following format:
;2058 //    "Wed Jun 30 21:49:08 1993\n"
;2059 //-------------------------------------------------------------------------
;2060 char *ctime_r(const time_t *utcSecs, char *str)
;2061 {
$ctime_r::
	.debug	G $ctime_r 113 9
	.debug	{ $ctime_r 113 2060 @527 @526
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-18
	.debug	A utcSecs 5 111
	.debug	A str 7 36
;2062   struct tm  dts;
	.debug	L dts -18 76
;2063 
;2064   localtime_r(utcSecs, &dts);  asctime_r((const struct tm *)&dts, str);
	.debug	# 2064
	ld	hl,-18+@525
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$localtime_r
	add	sp,4
	ld	hl,(ix+7)
	push	hl
	ld	hl,-16+@525
	add	hl,sp
	push	hl
	lcall	$asctime_r
	add	sp,4
;2065 
;2066   return str;
	.debug	# 2066
	ld	hl,(ix+7)
;2067 }
@526:
	.debug	} @526 2067

@525	equ	18
	ld	sp,ix
	pop	ix
	lret
@527	equ	20
;2068 
;2069 
;2070 #endif
;2071 
	.extern	$asctime 114
	.extern	$gmtime 115
	.extern	$mktime 116
	.extern	_tolower 77
	.extern	_memcpy 117
	.extern	_memset 118
	.extern	_strcpy 65
	.extern	_stricmp 119
	.extern	_strstr 65
	.extern	$fmemcpy 120
	.extern	_fabs 122
	.extern	_current 123
	.extern	__stdio 125
	.extern	$farfprintf 127
	.extern	$farprintf 128
	.extern	$farsprintf 129
	.extern	__TimerSeconds 9
	.extern	$strtoi 130
	.extern	$_fdToOpenFile_ 131
	.extern	$writeFDEV 132
	.extern	$readFDEV 132
	.extern	$open 133
	.extern	$close 77
	.extern	$read 134
	.extern	$write 134
	.extern	$fcntl 135
	.extern	$unlink 136
	.extern	$fflush 137
	.extern	$ioctl 138
	.extern	_KLOCK 69
	.extern	_KUNLOCK 69
	.extern	_ctlLoopTicksPerSec 7
	.extern	_diagLog 126
	.extern	_hdwResetTime 9
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$Exit 97
	.extern	$getIFConfig 139
	.extern	$sendto 140
	.extern	$perror 141
	.extern	$fstat 142
	.extern	$inet_pton 56
	.defseg	FARBSS
	.seg	FARBSS
_powOf10::
	.ds	196
	.debug	G _powOf10 143 8
	.debug	T	09000120000D0003000D00
	.debug	T	0900012100040003000400
	.debug	T	0900012200000205000001
	.debug	T	0900012300180024000C00
	.debug	T	070000240002000300
	.debug	T	0B000225000100060001000000
	.debug	T	0F00022600020001002700000004000200
	.debug	T	070000270002002400
	.debug	T	0F00022800020001002700000008000200
	.debug	T	0F00022900020001002A00000004000200
	.debug	T	0700002A0002002B00
	.debug	T	0700082B0004000300
	.debug	T	0F00022C00020001002A00000008000200
	.debug	T	0B00022D000100040027000000
	.debug	T	0B00022E000100080027000000
	.debug	T	0B00022F00010004002A000000
	.debug	T	0B00023000010008002A000000
	.debug	T	0F00023100020004002400000006000200
	.debug	T	130002320003000100270000000400020004000400
	.debug	T	130002330003000100270000000400020008000400
	.debug	T	17000234000400010027000000040002002400040004000600
	.debug	T	0F0002350002002400240000002B000200
	.debug	T	17000236000400240006000000370002002400040006000600
	.debug	T	070000370002000100
	.debug	T	130002380003000600060000002400020037000400
	.debug	T	0B000239000100090024000000
	.debug	T	0F00023A00020001000900000024000400
	.debug	T	1300023B0003000700240000000600020005000400
	.debug	T	0F00023C00020007000900000009000400
	.debug	T	1300023D0003002400240000002400020004000400
	.debug	T	0F00023E00020024002400000003000200
	.debug	T	0F00023F00020024002400000006000200
	.debug	T	130002400003002B002B0000002B00040007000800
	.debug	T	0F00024100020024002400000024000200
	.debug	T	17000242000400060024000000060002002700040043000600
	.debug	T	070000430002000600
	.debug	T	0B000244000100080008000000
	.debug	T	0B000245000100010001000000
	.debug	T	1300024600030024000A0000000600040024000600
	.debug	T	0900014700200003002000
	.debug	T	1700024800040024000A000000060004000600060024000800
	.debug	T	130002490003002400080000002400040006000600
	.debug	T	0F00024A00020024002400000009000200
	.debug	T	0F00024B00020009002400000024000200
	.debug	T	7E00034C001200090003746D000600000007746D5F736563000600
	.debug	T	020007746D5F6D696E000600040008746D5F686F7572000600
	.debug	T	060008746D5F6D646179000600080007746D5F6D6F6E000600
	.debug	T	0A0008746D5F796561720006000C0008746D5F776461790006
	.debug	T	000E0008746D5F79646179000600100009746D5F6973647374
	.debug	T	00
	.debug	T	0B00024D000100060006000000
	.debug	T	1300024E0003000600060000000600020009000400
	.debug	T	0900014F00400003004000
	.debug	T	1F0002500006000600060000002B00020006000600240008000700
	.debug	T	0A0009000C00
	.debug	T	070008510004005200
	.debug	T	0B01035200270013000100060000000A6F70656E436F756E740090
	.debug	T	00020008696F46756E6373003700040006696F446576009200
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	0B000253000100060054000000
	.debug	T	070000540002005500
	.debug	T	3F000355000A000500010024000000046275660006000200036664
	.debug	T	00070004000862756653697A650007000600086E6578744F75
	.debug	T	74000700080006636F756E7400
	.debug	T	17000256000400060006000000370002000600040008000600
	.debug	T	1F0002570006000600240000002400020003000400240006000600
	.debug	T	080027000A00
	.debug	T	BB000358002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	2700025900080009005A000000370002005A000400370006002400
	.debug	T	080006000A0009000C0003001000
	.debug	T	0700005A0002005B00
	.debug	T	1300025B0003000600370000002400020006000400
	.debug	T	1B00025C00050006004300000006000200090004002B0008000600
	.debug	T	0C00
	.debug	T	4100035D000E00040009736F636B61646472000500000007735F74
	.debug	T	797065000500020007735F706F7274000900040005735F6970
	.debug	T	009300080009735F73706172657300
	.debug	T	0F00025E00020006002700000024000200
	.debug	T	1300025F0003002400240000000900020007000600
	.debug	T	0900016000100003001000
	.debug	T	0B000261000100010006000000
	.debug	T	5C0003620019000700010009000000076970416464720009000400
	.debug	T	076263416464720009000800086E65746D61736B0009000C00
	.debug	T	08676174657761790093001000086D61634164647200070016
	.debug	T	00046D7475000300180006737461746500
	.debug	T	0900016300120003001200
	.debug	T	1F0002640006000600060000006500020006000400670006003700
	.debug	T	080006000A00
	.debug	T	070000650002006600
	.debug	T	0B000266000100010067000000
	.debug	T	070000670002006800
	.debug	T	3C000368001600040001000700000008646174614C656E00370002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	60000600056461746100
	.debug	T	130002690003000100060000006700020006000400
	.debug	T	1700026A000400060037000000370002002400040024000600
	.debug	T	1700026B000400010003000000030002002400040003000600
	.debug	T	1B00026C0005000100030000000300020024000400240006000300
	.debug	T	0800
	.debug	T	0F00026D0002006E006F0000006E000200
	.debug	T	0700006E0002004C00
	.debug	T	0700006F0002000900
	.debug	T	0F00027000020024006E00000024000200
	.debug	T	0F00027100020024006F00000024000200
	.debug	T	0B00027200010024006E000000
	.debug	T	0B0002730001006E006F000000
	.debug	T	0B00027400010009006E000000
	.debug	T	130002750003003700370000003700020007000400
	.debug	T	130002760003003700370000000600020007000400
	.debug	T	0F00027700020006002400000024000200
	.debug	T	130002780003007900790000007900040009000800
	.debug	T	070008790004000100
	.debug	T	0B00027A0001000B000B000000
	.debug	T	0700007B0002007C00
	.debug	T	7702037C00E8002D000C7461736B5F737472756374009400000006
	.debug	T	737461636B00940002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720095000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465007B00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630027001A0005617267760096001C0005617267
	.debug	T	730097009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773009800B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002B00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0700007D0002007E00
	.debug	T	5400037E000C00060001009A000000065F5F6F7574009C00020005
	.debug	T	5F5F696E009E000400085F5F7772697465009E000600075F5F
	.debug	T	726561640006000800085F5F756E6765740037000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	1300027F00030006007D0000002B0002000D000000
	.debug	T	0F00028000020006002B0000000D000000
	.debug	T	1300028100030006002B0000002B0004000D000000
	.debug	T	130002820003000600240000002700020006000400
	.debug	T	0B000283000100510006000000
	.debug	T	17000284000400060051000000370004000600060008000800
	.debug	T	130002850003000600240000000600020006000400
	.debug	T	130002860003000600060000003700020006000400
	.debug	T	130002870003000600060000000600020006000400
	.debug	T	0B000288000100060024000000
	.debug	T	0B00028900010006007D000000
	.debug	T	1300028A0003000600060000000600020037000400
	.debug	T	0F00028B000200060006000000A0000200
	.debug	T	1F00028C000600060006000000790002000600060006000800A100
	.debug	T	0A0006000C00
	.debug	T	0B00028D00010001002B000000
	.debug	T	0F00028E000200060006000000A2000200
	.debug	T	0900018F00C4000A003100
	.debug	T	070000900002009100
	.debug	T	6400039100100008000100A3000000057265616400A30002000677
	.debug	T	72697465009C00040006636C6F736500A5000600066C736565
	.debug	T	6B00A700080006667374617400A9000A0006696F63746C00AB
	.debug	T	000C0006646573637200AD000E000A67657451756575657300
	.debug	T	2800039200040002000100AF0000000A72656164517565756500AF
	.debug	T	0002000B7772697465517565756500
	.debug	T	0900019300060003000600
	.debug	T	070000940002000700
	.debug	T	070000950002007900
	.debug	T	0900019600800003008000
	.debug	T	280003970004000100125F5F776169745F71756575655F68656164
	.debug	T	00B0000000096C6973744865616400
	.debug	T	070000980002009900
	.debug	T	0F00029900020001000600000027000200
	.debug	T	0700009A0002009B00
	.debug	T	0F00029B00020006000300000037000200
	.debug	T	0700009C0002009D00
	.debug	T	0B00029D000100060037000000
	.debug	T	0700009E0002009F00
	.debug	T	1300029F00030008002B0000000800040037000800
	.debug	T	070000A00002006200
	.debug	T	070000A10002005D00
	.debug	T	070000A20002005800
	.debug	T	070000A3000200A400
	.debug	T	170002A4000400060037000000240002000600040003000600
	.debug	T	070000A5000200A600
	.debug	T	130002A60003000900370000000900020006000600
	.debug	T	070000A7000200A800
	.debug	T	0F0002A8000200060037000000A2000200
	.debug	T	070000A9000200AA00
	.debug	T	130002AA0003000600370000000600020037000400
	.debug	T	070000AB000200AC00
	.debug	T	130002AC0003002400370000002400020006000400
	.debug	T	070000AD000200AE00
	.debug	T	0F0002AE000200060037000000B1000200
	.debug	T	070000AF0002009700
	.debug	T	260003B000040002000A6C6973745F6865616400B2000000056E65
	.debug	T	787400B2000200057072657600
	.debug	T	070008B10004009200
	.debug	T	070000B2000200B000
	.seg	CONST
@1:
	.db	"Jan",0,"Feb",0,"Mar",0,"Apr",0,"May",0,"Jun",0,"Jul",0,"Aug",0,"Sep",0,"Oct",0,"Nov",0,"Dec",0," 0.",0,"E+00",0,"*ERR*",0,"Error",0,"DOWN",0,"COMING UP",0,"C"
	.db	"OMING DOWN",0,"UNKNOWN",0,"fifoEvents",0
	.seg	FARCONST
@54:
	.db	"%02x:%02x:%02x:%02x:%02x:%02x",0,"%d.%d.%d.%d",0,"%c%sE%c%02d",0,"%0*ld",0,"%dd %02d:%02d:%02d",0,"connec"
	.db	"tion closed",13,10,0,"CheckETX()/stdin",0,"%10lu",13,0,"sendBCastPkt()",0,"%04d-%02d-%02d %02d:%02d:%02d.%0"
	.db	"3u",0,27,"[%02d;%02dH",0,"%04d-%02d-%02d %02d:%02d:%02d",0,"   Idle: %2d%%  Control: %3u/s  [%02X:%"
	.db	"04lX]   Up: %s %s",13,10,0,"eth%d      Link encap:Ethernet  HWaddr %.18s",13,10,0,"          inet add"
	.db	"r:%.16s  Bcast:%.16s  Mask:%.16s",13,10,0,"          %s BROADCAST MTU:%d",13,10,0,"fifoEvents",0,"event m"
	.db	"sg too long: %d",10,0,"event msg too short: %d",10,0,"processMsg",0,"EventMsg: Addr: 0x%08lx  dataLen"
	.db	": %d",10,0,"*** %s: Invalid '%s' ptr: [0x%04X] ***",13,10,0,27,"[%02d;%02dH%s",0,27,"[K",0,27,"[%d",0,";%d",0,"m",0,"%s",27,"[0m",0
	.end
