	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\fcntl.c' 25 48 12 5 12 32
;1 //----- fcntl.c ----- 12/05/12 -----(03/12/06)-----
;2 
;3 //=========================================================================
;4 //  Copyright (c) 2006-2012, NSCL and Mark Davis.  All rights reserved.
;5 //=========================================================================
;6 //  The generic or Virtual File System layer.  This layer provides the
;7 //  functionality that is common to most of the file system drivers (such a
;8 //  the handling of blocking vs non-blocking mode).  This avoids redundancy
;9 //  the individual drivers, helping to keep them small and minimize differe
;10 //  in their behavior.
;11 //=========================================================================
;12 // TO-DO:
;13 //
;14 //  - Recent (re)reading leads me to believe that blocking mode for fds is
;15 //    supposed to behave a bit differently than I thought.  While the man p
;16 //    do state that reads and writes on fds that have blocking mode set may
;17 //    return without having read or written the requested # of bytes, my
;18 //    impression was that only occured when there was an error or some sign
;19 //    received that interrupted the process.
;20 //
;21 //    But now I believe that the intended behavior is that blocking mode si
;22 //    means that SOME data is read or written (or a non-blocked signal was
;23 //    received).  The caller is supposed to take in to account the fact tha
;24 //    it is quite normal for a read or write on an fd with blocking mode se
;25 //    to return having processed less than the requested # of bytes.
;26 //
;27 //    Even with this new interpretation, blocking mode is useful because it
;28 //    allows a task to wait for SOME progress without using CPU cycles.  Bu
;29 //    it means that is the ONLY difference between the two.  In both cases,
;30 //    you are responsible for dealing with the possibility that only some (
;31 //    even NONE) of the specified # of bytes were read or written (a rather
;32 //    strong possibility when using non-blocking mode).
;33 //
;34 //    But I THOUGHT it meant that, excluding errors or interruptions (which
;35 //    you would be informed of), blocking mode insured no interference with
;36 //    your reading or writing the specified # of bytes.  That no other task
;37 //    or thread could write to or read from the connection until your read
;38 //    or write completed (or was interrupted).
;39 //
;40 //    I thought, in addition to being critical to saving CPU cycles, that
;41 //    blocking mode effectively created a temporary lock that meant no othe
;42 //    thread of execution could inject bytes into or take bytes from the
;43 //    middle of the data stream you were writing to or reading from (with a
;44 //    single call).
;45 //
;46 //    Could this be what locking mode is designed to handle?
;47 //
;48 //    A common enough circumstance where it would seem to me to be critical
;49 //    is a service that forks off multiple child tasks that all read from
;50 //    the same fds.  I don't remember any examples for such code that
;51 //    mentions the possibility that multiple child tasks all reading from
;52 //    the same fd could end up getting non-contiguous blocks of the byte
;53 //    stream, or that blocking writes could return with only a portion of
;54 //    the specified buffer written to the fd, and that you had to use locks
;55 //    to insure other tasks did not inject data into the stream between
;56 //    the multiple write calls that might be needed to write all the bytes
;57 //    you need to.
;58 //
;59 //
;60 //  NOTES:
;61 //
;62 //    The linux open() function defines O_DIRECT and O_ASYNC options for
;63 //    the flags value.  O_DIRECT specifies synchronous I/O (the data is
;64 //    guaranteed to have been transferred at the end of the call), while
;65 //    O_ASYNC specifies asynchronous mode, which generates a signal when
;66 //    input or output becomes possible on the descriptor (which is only
;67 //    available for terminals, pseudo-terminals, and sockets).
;68 //
;69 //    So the question is, if neither of these is specified, what behavior
;70 //    can you expect from read() and write() (and send() and recv()) calls?
;71 //
;72 //    Is it really normal that these return with less then the specified
;73 //    number of bytes having been transferred?  Or, if they don't return
;74 //    with having transferred all the bytes, do such operations on an fd
;75 //    with blocking-mode set really not guard against concurrent operations
;76 //    on the same I/O channel?
;77 //
;78 //    What if the fd represents a directory?  Surely you can't allow the
;79 //    bytes from single reads and writes from multiple threads to be
;80 //    mingled together without total chaos!
;81 //
;82 //    Could it be that some (maybe most) devices simply don't allow the
;83 //    documented behavior to occur?  That most of them DO guarantee
;84 //    all the bytes are transferred before the read or write returns?
;85 //    And that each transferred block will be processed by the device
;86 //    atomically?
;87 //
;88 //    I don't see how any other mode of operation make sense!
;89 //
;90 //    Also, while it is a bit old now, the book "UNIX Network Programming"
;91 //    by W. Richard Stevens states (on page 163 of the 1990 edition):
;92 //
;93 //    "Unix I/O is termed synchronous.  A read or write system call does
;94 //    not return to the calling process until the operation is complete
;95 //    and the requested data has been copied by the kernel, either into
;96 //    the buffer for a read, or from the buffer for a write."
;97 //
;98 //    While, as the book also explains, this is separate from the actual
;99 //    reading from or writing to a disk, it means (at least) that the
;100 //    call doesn't return with only SOME of the buffer transfered and
;101 //    consider that a normal, error-free condition!
;102 //
;103 //    Of course, this doesn't address non-blocking mode calls, but you
;104 //    only do that when your code IS designed to handle incomplete reads
;105 //    and writes.
;106 //
;107 //=========================================================================
;108 //  Update Log (most recent first):
;109 //
;110 //
;111 //  2012-12-05 - Mark Davis
;112 //               - Moved the following from fcntl to common:
;113 //                    vt100 escape sequence definitions
;114 //                    DispStr() and DispStrAttr()
;115 //                    read_() and write_()
;116 //                    redirectStdio() and logStdout()
;117 //
;118 //  2012-04-20 - Mark Davis
;119 //               - Added gfdCounts() to get total and free counts for the
;120 //                 global file descriptor table.
;121 //
;122 //  2011-12-29 - Mark Davis (*)
;123 //               - read_(),readFDEV(), write_(), and writeFDEV() now set er
;124 //                 to ETIME if a timeout expires (regardless of what the re
;125 //                 value is, which could be > 0 if any bytes were read/writ
;126 //                 Prior to this, the caller of one of these functions had 
;127 //                 way to tell when a failure to read/write the requested #
;128 //                 of bytes was due to a timeout (which is a normal, expect
;129 //                 scenario in many cases).
;130 //
;131 //  2011-12-22 - Mark Davis (*)
;132 //               - openCrashLog() now clears the redirStdio flag for the ca
;133 //                 task so the data meant for the crash-log file is actuall
;134 //                 written to the file even if the task running at the time
;135 //                 the flag set (either because it had nothing open on pfd 
;136 //                 because it had been using that fd for something else).
;137 //
;138 //  2011-03-17 - Mark Davis
;139 //               - Removed the nestedFDs[][] table as it is no longer neede
;140 //
;141 //  2011-03-17 - Mark Davis (*)
;142 //               - Fixed bug in fileSysCheck() where if it detected orphane
;143 //                 global fds and was asked to close them then it would
;144 //                 attempt to do so using invalid (or incorrect) pointers.
;145 //                 Luckily, the option to close them was never used, so thi
;146 //                 never actually happened.
;147 //
;148 //  2011-03-15 - Mark Davis
;149 //               - Reduced stack usage of fileSysCheck() by using bit rathe
;150 //                 than byte arrays.
;151 //               - added clear-to-end-of-line strings at end of each line o
;152 //                 output for use with the -r option added to lsof
;153 //
;154 //  2011-02-04 - Mark Davis
;155 //               - Added nestedFDs[][] for better supporting drivers like t
;156 //                 revised SRFS one where one fd can be referenced by other
;157 //
;158 //  2011-01-10 - Mark Davis
;159 //               - Elimiated extra blank lines in system log when the appli
;160 //                 task writes to it in 2 conscecutive passes w/o another
;161 //                 task doing so in between.
;162 //
;163 //  2010-12-14 - Mark Davis
;164 //               - Changed _TimerSeconds + secTimerOffset to TIME()
;165 //
;166 //  2010-08-13 - Mark Davis
;167 //               - Changed 'logStdio' to 'logStdout' in the task structure
;168 //               - Added redirStdio flag to the task structure, which the
;169 //                 redirectStdio() macro now sets in addition to the logStd
;170 //                 flag.  Setting both now causes redirectStdio() to work a
;171 //                 originally intended:  Leave fd's 0,1,2 alone - just don'
;172 //                 use them for stdin, stdout, stderr.
;173 //               - Added the logStdout() macro that does what redirectStdio
;174 //                 WAS doing: DUPLICATES stdout in the system log, rather t
;175 //                 redirecting it.
;176 //
;177 //  2010-08-12 - Mark Davis
;178 //               - Added OS and Appl date/time strings to the information
;179 //                 written to the crash-log file.
;180 //
;181 //  2010-06-30 - Mark Davis (*)
;182 //               - read_() and write_() now return -1 if a wait node cannot
;183 //                 allocated.
;184 //
;185 //  2010-06-15 - Mark Davis (*)
;186 //               - read_() and write_() now check for a NULL buffer pointer
;187 //
;188 //  2010-06-02 - Mark Davis
;189 //               - Added openCrashLog() to allow the stdio of the task that
;190 //                 called postMortem() to change its stdout to a file to co
;191 //                 crash log data to.
;192 //
;193 //  2010-05-27 - Mark Davis
;194 //               - Got rid of unnecessary modulus operation for millisecond
;195 //                 value in diagOut function (the one that writes to the sy
;196 //                 log).
;197 //
;198 //  2010-05-13 - Mark Davis
;199 //               - Added read_() and changed write_() to they can be used a
;200 //                 more efficient replacements for readBytes() and writeByt
;201 //
;202 //  2010-04-29 - Mark Davis
;203 //               - Changes as needed to support the overhauled wait queue c
;204 //
;205 //  2010-03-05 - Mark Davis (*)
;206 //               - When not in use by a user shell, diagOut_() copies chara
;207 //                 written to the system log to the console port (serial po
;208 //                 Prior to this change, it would wait (if necessary) for s
;209 //                 in the output buffer before returning.  Now it only does
;210 //                 if the WaitOnConsole bit is set in the calling task's
;211 //                 diagFlags.
;212 //
;213 //                 NOTE that msgs are always written to the circular buffer
;214 //                 regardless of whether this bit is set, so the only downs
;215 //                 to not having the bit set is some lost characters if you
;216 //                 monitoring things via the serial port (without a shell
;217 //                 running on it).  The advantage of this change is to elim
;218 //                 the delays that could affect any task writing to the sys
;219 //                 log (since any task can fill the console's buffer, even 
;220 //                 that writes very little can be affected).
;221 //
;222 //                 Also NOTE that diagOut_() had KLOCK()/KUNLOCK() calls, b
;223 //                 is only called by diagOut() (no underscore), which has
;224 //                 KLOCK() invoked whenever diagOut_() is called, so the
;225 //                 KUNLOCK()/sleep/KLOCK() sequence in diagOut_() would not
;226 //                 suspend the process.  The effect was to waste CPU cycles
;227 //                 causing everything but interrupts to be disabled until s
;228 //                 opened up in the serial output buffer.  Given that the s
;229 //                 call was only for 5ms, and the serial output rate is 115
;230 //                 baud (11,500 cps), the delay would not be long in human 
;231 //                 but it was probably one of the causes of measurable sche
;232 //                 delays.
;233 //
;234 //  2009-12-18 - Mark Davis
;235 //               - Made several near functions _nearcall to free up root sp
;236 //
;237 //  2009-08-05 - Mark Davis
;238 //               - _File_Swap_() now stops the descriptor's flags attribute
;239 //                 from being swapped
;240 //
;241 //  2009-06-18 - Mark Davis
;242 //               - The index used to copy data from the syslog buffer when
;243 //                 writing to the remote backup copy of the log is now upda
;244 //                 if the index for writing new chars "catches up" to it.  
;245 //                 minimizes the potential for lost data (the old way would
;246 //                 an entire buffer's worth when this happened).
;247 //
;248 //  2009-06-12 - Mark Davis
;249 //               - The clearing of the pid that is doing a read or write on
;250 //                 file is now done in a critical section to insure can't b
;251 //                 preempted.
;252 //
;253 //  2009-06-11 - Mark Davis
;254 //              - Corrected diagOut() so the date/time values in the system
;255 //                 entries have a millisecond value that is syncronized wit
;256 //                 hh:mm:ss portion of the logged time.
;257 //
;258 //  2009-05-01 - Mark Davis
;259 //               - fileSysCheck() (used by the lsof command) now takes a po
;260 //                 to a buffer and its size as parameters (to reduce stack 
;261 //                 which was overflowing sometimes...)
;262 //
;263 //  2009-04-15 - Mark Davis
;264 //               - various calls that did not set errno for bad fds now set
;265 //                 to EBADF
;266 //
;267 //  2009-04-14 - Mark Davis
;268 //               - diagIn() (which handles reads from FILE DiagLog/syslog) 
;269 //                 sets errno to EAGAIN and returns -1 (so any task trying 
;270 //                 read from it will not block and will not believe it has
;271 //                 reached the end of the input).
;272 //
;273 //  2009-04-02 - Mark Davis
;274 //               - The read/write mode of the flags value in an open are no
;275 //                 enforced by read() and write()
;276 //
;277 //  2009-03-25 - Mark Davis
;278 //               - Added unlink() and rename() to the FileSysFuncs API
;279 //
;280 //  2009-03-24 - Mark Davis
;281 //               - Finished up fileSysChk() for checking on corrupt or orph
;282 //                 file descriptors at the global and driver levels.
;283 //
;284 //  2009-03-20 - Mark Davis
;285 //               - fixed bug in _closeFD_() that could result in a task clo
;286 //                 a file just opened by another and leave the one it was
;287 //                 supposed to close "orphaned".  This could be the cause o
;288 //                 "orphaned" UDP sockets that use up the small pool of ava
;289 //                 ones (resulting in a configd that can't do its job).
;290 //
;291 //  2008-04-30 - Mark Davis
;292 //               - lseek now resets the dontCallRead flag if it doesn't ret
;293 //                 an error
;294 //
;295 //  2008-04-07 - Mark Davis
;296 //               - changes to use dynamically registered file systems model
;297 //
;298 //  2007-10-27 - Mark Davis
;299 //               - got basic wait queue stuff working
;300 //
;301 //  2007-10-05 - Mark Davis
;302 //               - added support for unlink() calls for SRFS files
;303 //
;304 //  2006-03-12 - Mark Davis
;305 //               - began work on original version
;306 //
;307 //-------------------------------------------------------------------------
;308 /*
;309   NOTES:
;310 
;311 
;312  Process, Global, and Driver File Descriptors
;313 
;314     The standard file system API (open, close, read, write, etc) provides
;315     a generic API for creating connections to files and devices.  The
;316     fcntl layer provides the functionality that is common to all the driver
;317     allowing the drivers to be smaller and concern themselves with just the
;318     device-specific functionality.
;319 
;320     Each driver implements a standard set of functions, allowing the fcntl
;321     layer to work with all the different types of devices supported by the
;322     drivers with little or no concern for diferrences between the different
;323     devices.
;324 
;325     Each open file normally has 3 different descriptors associated with it:
;326 
;327        - Process-specific File Descrptor (pfd, or just fd):  This is a
;328          number assigned to an open file.  Its value is usuable ONLY by
;329          the process that called the function that returned the pfd (e.g.
;330          open() or socket()).  The only exception to this is when a task
;331          spawns a child process.  In this case the child usually has a
;332          copy of its parent's pfds.  But while the fd values will be the
;333          same, they still represent a reference to the child's list of
;334          open files, not the parents.  pfd values currently represent an
;335          index in to the process' list of Global File Descriptors pointers
;336          (FD[pix][fd]).
;337 
;338        - Global File Descriptor (gfd):  A structure allocated by the fcntl
;339          layer to hold state information common to most drivers.  Multiple
;340          pfds (belonging to 1 or more tasks) can reference a given gfd.
;341          A gfd is usually expressed as a pointer to an FDEV structure.
;342 
;343        - Driver-specific File Descriptor (dfd):  A structure allocated by
;344          the driver responsible for accessing and making changes to the
;345          file.  In most cases, each dfd is referred to by just 1 gfd.
;346          But there are exceptions (such s the FIFO driver).  The structures
;347          are generally referred to generically as ioDev structures, and
;348          dfd's are usually expressed as a void pointer called ioDev.
;349 
;350 
;351     The FDEV structure is used by the fcntl layer to keep track of a single
;352     connection.  It contains the following information:
;353 
;354       - The data related to the state of the connection which is independen
;355         of what driver is used to access it.
;356 
;357       - A pointer to a structure (of pointers to) the driver-specifc versio
;358         of standard I/O functions (e.g. read, write, lseek) (*ioFuncs)
;359 
;360       - A pointer to a driver-specific structure that contains driver-speci
;361         state information for an open connection. (*ioDev)
;362 
;363     Each call to a driver-specific function from the fcntl layer includes t
;364     driver provided structure so the driver knows which device or connectio
;365     to operate on.
;366 
;367     When a process opens a connection it gets back a pfd that refers to an
;368     FDEV structure for an open file.  NOTE that an FDEV structure can be
;369     referenced by more than one pfd.  This means that any changes to the
;370     state of a file by one process will be seen by all the other pfds that
;371     reference the same FDEV.
;372 
;373     Each FDEV entry has a counter that keeps track of how many pfds referen
;374     it.  Only when all pfd references to an FDEV are closed will the
;375     device represented by the FDEV actually be closed.
;376 
;377 
;378  Protecting shared resources:
;379 
;380     fcntl.c insures that only one task enters the _xxxxRead_() or _xxxxWrit
;381     driver functions for a given FDEV, so most drivers do not have to
;382     use locks in these functions to protect against concurrent use of an
;383     ioDev entry.
;384 
;385     However, if more than one FDEV can point to the same ioDev (as in
;386     FIFOs) or to ioDev's that share a resource, then the driver must use
;387     locks to protect the shared resource.  The SPI and SRFS drivers are
;388     examples of this:  The SPI driver because only one SPI transfer can
;389     be going on at any given time (even where there are multiple ports
;390     open in SPI mode).  And the SRFS driver because it uses a single
;391     connection to the server for all files and tasks and can handle just
;392     1 conversation for 1 operation at a time.
;393 
;394 
;395  Blocking - The fcntl layer vs the driver layer:
;396 
;397     From the point of view of the fcntl layer, drivers come in 2
;398     varieties:  Those that handle blocking on their own and those
;399     that don't.
;400 
;401     For the later group, the driver's read and write functions
;402     never block:  They simply read or write however bytes they can
;403     each time they are called.  It is up to the fcntl layer to handle
;404     the difference between blocking and non-blocking calls.
;405 
;406     For non-blocking reads and writes, the fcntl layer simply
;407     returns whatever the driver supplies.
;408 
;409     For blocking calls, it will call the driver's read or write
;410     function repeatedly until the specified # of bytes are processed
;411     or an error occurs.  Between calls to the driver, the task is
;412     suspended using the specified wait queue.  The more intelligent
;413     drivers provide their own wait queues which allows them to wake
;414     up tasks as soon as (and only when) there is a good chance the
;415     driver can process more bytes.  This improves response time and
;416     minimizes the number of CPU cycles wasted calling the driver
;417     when it cannot process more bytes.
;418 
;419 
;420 -----//finish--------------------------------------------------------------
;421 
;422 - Should implement 2 tables to manage all the drivers:
;423   - one with an entry for each "mounted" file system
;424   - one for each type of device
;425 
;426   The device table will have one entry for each driver (e.g. flash, srfs,
;427   async, spi, etc).  Each row will have pointers to generic func calls, som
;428   of which may be NULL (e.g. lseek, unlink, and rename would be null for
;429   char-mode devices like async).
;430 
;431   The file system table will have one entry for each file system.  Each ent
;432   in this table will have a device type that refers to an entry in the devi
;433   table.
;434 
;435 2008-04-07
;436   NOTE:  I now use a table of drivers, where each filesystem driver registe
;437          itself (usually at startup).  This allows the BSP (Board Support
;438          Package) or arch(itecture) hardware-specific layer to register
;439          drivers based on what the hardware supports.
;440 
;441 -------------------------------------------------------
;442 - Use a global (far?) array of file descriptors that are allocated as neede
;443   when processes open a new descriptor.
;444 
;445 - Move the elements that should be per-process (like permissions, flags, et
;446   out of the global file descriptor and in to the per-process descriptor
;447   (actually I don't believe this is correct - I think the flags ARE suppose
;448   to be shared...)
;449 
;450 - Create a global array of _IO_FILE structures that are allocated as needed
;451   when a process calls functions like fopen(), fdopen(), etc. that return
;452   a pointer to a FILE.  This structure will have to keep a pointer to the
;453   owning process, so it can be cleaned up when a process terminates (or
;454   keep a linked list of open FILE's in the process descriptor?)
;455 
;456 ---------------------------------------------------------------------------
;457 
;458 #include <time.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
;459 #include <common.h>
;460 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;461 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;462 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;463 #include <sys/socket.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;464 #include <arpa/inet.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;465 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;466 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;467 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;468 #include <signal.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
;469 #include <utime.h>
;470 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\utime.h' 29 54 20 12 3 27
	.debug	I
;471 
;472 #include <busybox.h>
;473 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
;474 #include <sys/hdwDefs.h>
;475 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;476 #include <sys/srfs.h>
;477 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	I
;478 #include <dcdefs.h>
;479 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;480 #include <ctype.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.debug	I
;481 #include <limits.h>
;482 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;483 #include <sys/SHD_headers.h>
;484 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\SHD_headers.h' 7 57 11 8 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
	.debug	I
;485 #include <sys/modbus.h>
;486 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
;487 #include <tsh.h>
;488 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	I
;489 #include <applic.h>
;490 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I
	.debug	I
;491 #include <sys/serial.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;492 #include <sys/fifo.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\fifo.h' 22 26 9 7 4 28
	.debug	I
;493 #include <sys/flashFile.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\flashFile.h' 15 56 20 12 3 27
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;494 #include <sys/srfs.h>
;495 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	I
;496 
;497 #include <sys/farprintf.h>
;498 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;499 
;500 #define __KERNEL__
;501 
;502 #include <linux/wait.h>
;503 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
;504 
;505 
;506 //--- global list of open files ---
;507 FDEV  far fileTbl[MaxOpenFiles];
;508 
;509 //--- all references to open files by process ---
;510 FDEV far *FD[NUM_TASKS][FD_SETSIZE];   // NULL ==> not in use
;511 
;512 //--- table of registered file systems ---
;513 FileSysFuncs *fileSysFuncs[MAX_FILE_SYS];
;514 
;515 DiagLogInfo far  *diagLogInfo;
;516 uint  DiagLogSize;
;517 char far  *diagLogBuf;
;518 bool  logDateTime = false;  // prefix each line with a date/time stamp
	.dseg
_logDateTime::
	.db	0
	.debug	G _logDateTime 3 0
;519 
;520 bool  noGettyOnA = true;
_noGettyOnA::
	.db	0x1
	.debug	G _noGettyOnA 3 0
;521 
;522 
;523 
;524 typedef struct  {
;525   char  *prefix;              // used to determine which driver to use
;526   char  *driverName;          // name of driver to use for prefix value
;527   const FileSysFuncs  *fsFuncs;     // table of funcs provided by each driv
;528 }  FSTAB;
;529 
;530 // fsFuncs value set when a driver's init func calls registerFileSys()
;531 static FSTAB  fstab[] = {
;532   { "",          "flashFile", NULL },  // reserved for root file system
_fstab:
	.dw	@1
	.dw	@1+1
	.dw	0
;533 //  { "syslog",    "syslog",    NULL },  // dummy stdin, stdout/err ==> sys
;534   { "fifo",      "fifo",      NULL },  // fifos and pipes
	.dw	@1+11
	.dw	@1+11
	.dw	0
;535   { "/srfs/",    "srfs",      NULL },
	.dw	@1+16
	.dw	@1+23
	.dw	0
;536   { "/dev/tty",  "serial",    NULL },
	.dw	@1+28
	.dw	@1+37
	.dw	0
;537   { "/dev/ttyx", "serial",    NULL },
	.dw	@1+44
	.dw	@1+37
	.dw	0
;538   { "/dev/spi",  "serial",    NULL }
	.dw	@1+54
	.dw	@1+37
	.dw	0
;539 };
	.debug	F _fstab 32 0
;540 
;541 #define NumPrefixes  (sizeof(fstab) / sizeof(FSTAB) )
;542 
;543 
;544 #include <SHD_DLM.h>
;545 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I
;546 #include <sys/farprintf.h>
;547 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;548 
;549 
;550 //--- for now assume only one file system per device type/driver ---
;551 //finish: Eventually arg should be index in to table of file systems
;552 //        that allows multiple file systems per device type/driver
;553 #define FileSysDev(fsidx)  (fsidx)
;554 
;555 fd_t  corefd = -1;
_corefd::
	.dw	0xffff
	.debug	G _corefd 6 0
;556 
;557 
;558 //-------------------------------------------------------------------------
;559 //  for debugging - list names of registered file systems
;560 //-------------------------------------------------------------------------
;561 /*
;562 void listFileSystems(void)
;563 {
;564   uint  u;
;565   FileSysFuncs *fsf;
;566 
;567 //--- check each file system driver for orphaned entries ---
;568   printf("~~~~~~~ ");
;569   for (u=0; u<MAX_FILE_SYS; ++u)  {
;570     fsf = fileSysFuncs[u];  if (!fsf)  continue;
;571     printf("[%.16s] ", fsf->name);
;572   }
;573   printf("\r\n");
;574 }
;575 */
;576 
;577 //-------------------------------------------------------------------------
;578 //  Initialize file descriptor table and related structures
;579 //-------------------------------------------------------------------------
;580 void fcntlInit()
;581 {
	.defseg	FARCODE
	.seg	FARCODE
$fcntlInit::
	.debug	G $fcntlInit 34 9
	.debug	{ $fcntlInit 34 580 @4 @3
;582   FBZERO(fileTbl);  FBZERO(FD);  BZERO(fileSysFuncs);
	.debug	# 582
	ld	de,0x9c0
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	de,0x500
	ld	c,e
	ld	b,e
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_FD
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,0x10
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_fileSysFuncs
	push	hl
	call	_memset
	add	sp,6
;583 
;584 //--- initialize and register file systems that are NOT hardware dependent 
;585   //syslogInit_();
;586   fifoInit_();
	.debug	# 586
	lcall	$fifoInit_
;587 
;588 //--- initialize and regsiter file systems that ARE hardware dependent ---
;589   registerFileSystems();
	.debug	# 589
	lcall	$registerFileSystems
;590 }
@3:
	.debug	} @3 590

@2	equ	0
	lret
@4	equ	0
;591 
;592 //-------------------------------------------------------------------------
;593 //  function called by hardware-specific setup code (in the arch source
;594 //  directory) to register a file system with the fcntl layer
;595 //
;596 //  On success, returns index in to list of file systems
;597 //  On error, returns < 0
;598 //-------------------------------------------------------------------------
;599 int registerFileSys(const FileSysFuncs *fsFuncs)
;600 {
$registerFileSys::
	.debug	G $registerFileSys 35 9
	.debug	{ $registerFileSys 35 599 @7 @6
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A fsFuncs 5 36
;601   uint  u, d;
	.debug	L u -2 7
	.debug	L d -4 7
;602   const FileSysFuncs  **fsf;
	.debug	L fsf -6 38
;603 
;604 
;605   printf("  Registering file system: %.32s\r\n", fsFuncs->name);
	.debug	# 605
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8)
	ld	c,phys @8 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;606 
;607   for (u=0; u<MAX_FILE_SYS; ++u)  {
@9:
	.debug	< @9 @10
	.debug	# 607
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@11:
	ld	hl,(ix-2)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jp	nc,@12
;608     fsf = fileSysFuncs + u;
@14:
	.debug	< @14 @15
	.debug	# 608
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_fileSysFuncs
	add	hl,de
	ld	(ix-6),hl
;609 
;610   //--- return existing index if already registered ---
;611     if (*fsf)  {
	.debug	# 611
	ld	hl,(hl)
	bool	hl
	jr	z,@16
;612       if ((*fsf)->open == fsFuncs->open)  return (int)u;
@17:
	.debug	< @17 @18
	.debug	# 612
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	nz,@13
	jr	@23
;613       continue;
	.debug	# 613
;614     }
@18:
	.debug	>
;615 
;616   //--- Found an unused entry, which means we checked all the registered --
;617   //--- drivers for a match, so add the driver to the list ---
;618     *fsf = fsFuncs;
@16:
	.debug	# 618
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;619 //    printf("Registered file system: %u, %.32s\r\n", u, fsFuncs->name);
;620 
;621   //--- Scan the list of file name prefixes and save a pointer to the ---
;622   //--- driver's functions for each entry with a matching driver name ---
;623     for (d=0; d<NumPrefixes; ++d)
@20:
	.debug	< @20 @21
	.debug	# 623
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@22:
	ld	hl,(ix-4)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nc,@23
;624       if (StrEq(fstab[d].driverName, fsFuncs->name))
	.debug	# 624
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	b,d
	ld	c,e
	ex	de,hl
	mul
	ld	hl,_fstab
	add	hl,bc
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@25
;625         fstab[d].fsFuncs = fsFuncs;
	.debug	# 625
	ld	hl,(ix-4)
	ld	bc,0x6
	ex	de,hl
	mul
	ld	hl,_fstab
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;626 
;627     return (int)u;
@25:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@22
@23:
@21:
	.debug	>
	.debug	# 627
	ld	hl,(ix-2)
	jr	@6
;628   }
@15:
	.debug	>
;629 
;630 
;631   return -1;
@13:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@11
@12:
@10:
	.debug	>
	.debug	# 631
	ld	hl,0xffff
;632 }
@6:
	.debug	} @6 632

@5	equ	6
	ld	sp,ix
	pop	ix
	lret
@7	equ	8
;633 
;634 //-------------------------------------------------------------------------
;635 //  call the "tick" function for each registered file system that has one
;636 //-------------------------------------------------------------------------
;637 void fileSysTick(void)
;638 {
$fileSysTick::
	.debug	G $fileSysTick 39 9
	.debug	{ $fileSysTick 39 637 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;639   uint  u;
	.debug	L u -2 7
;640   FileSysFuncs  *fsf;
	.debug	L fsf -4 36
;641 
;642   for (u=0; u<MAX_FILE_SYS; ++u)  {
@29:
	.debug	< @29 @30
	.debug	# 642
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@31:
	ld	hl,(ix-2)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jr	nc,@32
;643     fsf = fileSysFuncs[u];
@34:
	.debug	< @34 @35
	.debug	# 643
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_fileSysFuncs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
;644     if (fsf)  if (fsf->tick)  (fsf->tick)();
	.debug	# 644
	bool	hl
	jr	z,@36
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@37
	ld	hl,(ix-4)
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
;645   }
@37:
@36:
@35:
	.debug	>
;646 
;647 }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@31
@32:
@30:
	.debug	>
@27:
	.debug	} @27 647

@26	equ	4
	ld	sp,ix
	pop	ix
	lret
@28	equ	6
;648 
;649 //-------------------------------------------------------------------------
;650 //  Get the total and free counts for the global file descriptor table.
;651 //  The *ttl is set to the total, and the free count is the return value.
;652 //-------------------------------------------------------------------------
;653 uint gfdCounts(uint *ttl)
;654 {
	.align	4
$$gfdCounts::
	ex	(sp),iy
$gfdCounts::
	.debug	G $gfdCounts 40 9
	.debug	{ $gfdCounts 40 653 @40 @39
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ttl 5 41
;655   uint  u, freeCount = 0;
	.debug	L u -2 7
	.debug	L freeCount -4 7
	.debug	# 655
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;656 
;657 
;658 //--- count the # unused descriptors ---
;659   KLOCK();
	.debug	# 659
	call	_KLOCK
;660   for (u=0; u<MaxOpenFiles; ++u)  if (fileTbl[u].openCount == 0)  ++freeCou
@41:
	.debug	< @41 @42
	.debug	# 660
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@43:
	ld	hl,(ix-2)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nc,@44
	ld	hl,(ix-2)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	de,0x27
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	nz,@46
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;661   KUNLOCK();
@46:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@43
@44:
@42:
	.debug	>
	.debug	# 661
	call	_KUNLOCK
;662 
;663   *ttl = MaxOpenFiles;
	.debug	# 663
	ld	hl,0x40
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;664 
;665   return freeCount;
	.debug	# 665
	ld	hl,(ix-4)
;666 }
@39:
	.debug	} @39 666

@38	equ	4
	ld	sp,ix
	pop	ix
	lret
@40	equ	6
;667 
;668 
;669 //-------------------------------------------------------------------------
;670 //  check for "orphaned" global file descriptors (ones that are marked as
;671 //  in-use but are not referenced by any process' local descriptors)
;672 //-------------------------------------------------------------------------
;673 void fileSysCheck(bool closeOrphans, char *buf, int bufSize)
;674 {
$fileSysCheck::
	.debug	G $fileSysCheck 42 9
	.debug	{ $fileSysCheck 42 673 @49 @48
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-79
	.debug	A closeOrphans 5 3
	.debug	A buf 7 43
	.debug	A bufSize 9 6
;675   uint  pfd, gfd, dfd, pix, u;
	.debug	L pfd -2 7
	.debug	L gfd -4 7
	.debug	L dfd -6 7
	.debug	L pix -8 7
	.debug	L u -10 7
;676   FDEV far *file;
	.debug	L file -14 44
;677   void  *ioDev;
	.debug	L ioDev -16 46
;678   const IODevFuncs  *ioFuncs;
	.debug	L ioFuncs -18 47
;679   FileSysFuncs  *fsf;
	.debug	L fsf -20 36
;680   EntryState  entryState;
	.debug	L entryState -23 49
;681   bool  hasRef[MaxOpenFiles/8], orphaned[MaxOpenFiles/8],
	.debug	L hasRef -31 50
	.debug	L orphaned -39 50
;682         invalidFD[NUM_TASKS][FD_SETSIZE/8];
	.debug	L invalidFD -79 51
;683 
;684 
;685   BZERO(hasRef);  BZERO(orphaned);  BZERO(invalidFD);
	.debug	# 685
	ld	hl,0x8
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-27+@47
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x8
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-35+@47
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x28
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-75+@47
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;686 
;687   KLOCK();
	.debug	# 687
	call	_KLOCK
;688 
;689 //--- Check each process fd for each active task to make sure it is valid -
;690 //--- and generate a list of which global fds have active references ---
;691   for (pix=0; pix<NUM_TASKS; ++pix)  {
@50:
	.debug	< @50 @51
	.debug	# 691
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@52:
	ld	hl,(ix-8)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jp	nc,@53
;692     if (! tasks[pix].inUse)  continue;
@55:
	.debug	< @55 @56
	.debug	# 692
	ld	hl,(ix-8)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@54
;693     for (pfd=0; pfd<FD_SETSIZE; ++pfd)    {
@58:
	.debug	< @58 @59
	.debug	# 693
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@60:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jp	nc,@61
;694       file = FD[pix][pfd];  if (! file)  continue;
@63:
	.debug	< @63 @64
	.debug	# 694
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@62
;695       gfd = (uint)(file - fileTbl);
	.debug	# 695
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__lsub##
	push	bc
	push	de
	ld	de,0x27
	ld	c,d
	ld	b,d
	call	__ldiv##
	ex	de,hl
	ld	(ix-4),hl
;696       if ((file == fileTbl + gfd) AND (gfd < MaxOpenFiles))  {
	.debug	# 696
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x27
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__fpcmp##
	jr	nz,@67
	ld	hl,(ix-4)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nc,@67
;697          SetBit(hasRef, gfd);  continue; }
@68:
	.debug	< @68 @69
	.debug	# 697
	ld	hl,(ix-4)
	ld	e,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@70
	ld	b,a
@71:
	add	hl,hl
	djnz	@71
@70:
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	bc,de
	ex	de,hl
	ld	hl,-31+@47
	add	hl,sp
	add	hl,de
	push	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,bc
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
	jr	@62
@69:
	.debug	>
;698       SetBit(invalidFD[pix], pfd);
@67:
	.debug	# 698
	ld	hl,(ix-2)
	ld	de,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@72
	ld	b,a
@73:
	add	hl,hl
	djnz	@73
@72:
	ex	de,hl
	ld	hl,(ix-8)
	add	hl,hl
	ld	bc,de
	ex	de,hl
	ld	hl,-79+@47
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	add	hl,de
	push	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,bc
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
;699     }
@64:
	.debug	>
;700   }
@62:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@60
@61:
@59:
	.debug	>
@56:
	.debug	>
;701 
;702 //--- Generate a list of global fds that are active but are not referenced 
;703 //--- by any process fds ---
;704   for (gfd=0; gfd<MaxOpenFiles; ++gfd)  {
@54:
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jp	@52
@53:
@51:
	.debug	>
@74:
	.debug	< @74 @75
	.debug	# 704
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@76:
	ld	hl,(ix-4)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jp	nc,@77
;705     if (GetBit(hasRef, gfd))  continue;
@79:
	.debug	< @79 @80
	.debug	# 705
	ld	hl,(ix-4)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,-31+@47
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@81
@82:
	add	hl,hl
	dec	a
	jr	nz,@82
@81:
	ld	a,(bc)
	ld	d,0
	ld	e,a
	and	hl,de
	jr	z,@83
	ld	a,0x1
	jr	@84
@83:
	xor	a,a
@84:
	or	a,a
	jr	nz,@78
;706     file = fileTbl + gfd;
	.debug	# 706
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x27
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;707     if (file->openCount)  SetBit(orphaned, gfd);
	.debug	# 707
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@86
	ld	hl,(ix-4)
	ld	de,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@87
	ld	b,a
@88:
	add	hl,hl
	djnz	@88
@87:
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	bc,de
	ex	de,hl
	ld	hl,-39+@47
	add	hl,sp
	add	hl,de
	push	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,bc
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
;708   }
@86:
@80:
	.debug	>
;709 
;710   KUNLOCK();
@78:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jp	@76
@77:
@75:
	.debug	>
	.debug	# 710
	call	_KUNLOCK
;711 
;712 
;713 //===== Display a list of the active driver fds for each driver =====
;714   for (u=0; u<MAX_FILE_SYS; ++u)  {
@89:
	.debug	< @89 @90
	.debug	# 714
	bool	hl
	ld	l,h
	ld	(ix-10),hl
@91:
	ld	hl,(ix-10)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jp	nc,@92
;715     fsf = fileSysFuncs[u];  if (!fsf)  continue;
@94:
	.debug	< @94 @95
	.debug	# 715
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_fileSysFuncs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-20),hl
	bool	hl
	jp	z,@93
;716     printf("checking fsf[%u] (%.32s)%s\r\n", u, fsf->name, cllCmd);
	.debug	# 716
	ld	hl,_cllCmd
	push	hl
	ld	hl,(ix-20)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-10)
	push	hl
	ld	de,word (phys @8+35)
	ld	c,phys @8+35 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;717     for (dfd=0; ; ++dfd)  {
@97:
	.debug	< @97 @98
	.debug	# 717
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@99:
;718       if (! (ioDev = (fsf->entry)(dfd, &entryState)))  break;
@102:
	.debug	< @102 @103
	.debug	# 718
	ld	hl,-23+@47
	add	hl,sp
	push	hl
	ld	hl,(ix-6)
	push	hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x6
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,4
	ld	(ix-16),hl
	bool	hl
	jr	z,@100
;719       if (entryState.unused)  continue;
	.debug	# 719
	ld	a,(ix-21)
	or	a,a
	jr	nz,@101
;720       printf("  [%2u]: %2u refs:  %.100s%s\r\n",
;721              dfd, entryState.openCount,
;722              (fsf->ioFuncs->descr)(ioDev, buf, bufSize-1), cllCmd );
	.debug	# 722
	ld	hl,_cllCmd
	push	hl
	ld	hl,(ix+9)
	dec	hl
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-16)
	push	hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ld	bc,de
	ld	de,0xc
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
	push	hl
	ld	hl,(ix-23)
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @8+64)
	ld	c,phys @8+64 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;723     }
@103:
	.debug	>
;724     printf("%s\r\n", cllCmd);
@101:
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@99
@100:
@98:
	.debug	>
	.debug	# 724
	ld	hl,_cllCmd
	push	hl
	ld	de,word (phys @8+59)
	ld	c,phys @8+59 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;725   }
@95:
	.debug	>
;726 
;727 
;728 //===== Display a list of the invalid process fds =====
;729 //   Strictly speaking the task that had the corrupted fd(s) may be gone
;730 //   by the time we print/log a message about it (since we release the
;731 //   global lock) but we still want to know that it happened
;732   for (pix=0; pix<NUM_TASKS; ++pix)
@93:
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jp	@91
@92:
@90:
	.debug	>
@106:
	.debug	< @106 @107
	.debug	# 732
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@108:
	ld	hl,(ix-8)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@109
;733     for (pfd=0; pfd<FD_SETSIZE; ++pfd)   if (GetBit(invalidFD[pix], pfd))
@111:
	.debug	< @111 @112
	.debug	# 733
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@113:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@114
	ld	hl,(ix-8)
	add	hl,hl
	ex	de,hl
	ld	hl,-79+@47
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@116
@117:
	add	hl,hl
	dec	a
	jr	nz,@117
@116:
	ld	a,(bc)
	ld	d,0
	ld	e,a
	and	hl,de
	jr	z,@118
	ld	a,0x1
	jr	@119
@118:
	xor	a,a
@119:
	or	a,a
	jr	z,@120
;734       printf("PID %5d:  fd[%u]:  Invalid fd%s\r\n",
;735              tasks[pix].pid, pfd, cllCmd);
	.debug	# 735
	ld	hl,_cllCmd
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix-8)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+95)
	ld	c,phys @8+95 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;736 
;737 
;738 //===== Display a list of (and optionally close) any orphaned global fds ==
;739 //   NOTE that a lock isn't necessary here because the global FDs that
;740 //   we are dealing with are already orphans
;741   for (gfd=0; gfd<MaxOpenFiles; ++gfd)  {
@120:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@113
@114:
@112:
	.debug	>
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jp	@108
@109:
@107:
	.debug	>
@121:
	.debug	< @121 @122
	.debug	# 741
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@123:
	ld	hl,(ix-4)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jp	nc,@124
;742     if (!GetBit(orphaned, gfd))  continue;
@126:
	.debug	< @126 @127
	.debug	# 742
	ld	hl,(ix-4)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,-39+@47
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@128
@129:
	add	hl,hl
	dec	a
	jr	nz,@129
@128:
	ld	a,(bc)
	ld	d,0
	ld	e,a
	and	hl,de
	jr	z,@130
	ld	a,0x1
	jr	@131
@130:
	xor	a,a
@131:
	or	a,a
	jp	z,@125
;743     file = fileTbl + gfd;
	.debug	# 743
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x27
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;744     if (file->shared)  continue;
	.debug	# 744
	push	bc
	push	de
	ld	de,0x26
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jp	nz,@125
;745     ioDev = file->ioDev;  ioFuncs = file->ioFuncs;
	.debug	# 745
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-16),hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-18),hl
;746     ioFuncs->descr(ioDev, buf, bufSize-1);
	.debug	# 746
	ld	hl,(ix+9)
	dec	hl
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-16)
	push	hl
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xc
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
;747     printf("Orphaned global fd[%d]: %.128%s", gfd, buf, cllCmd);
	.debug	# 747
	ld	hl,_cllCmd
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @8+129)
	ld	c,phys @8+129 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;748     if (closeOrphans)  ioFuncs->close(ioDev);
	.debug	# 748
	ld	a,(ix+5)
	or	a,a
	jr	z,@134
	ld	hl,(ix-16)
	push	hl
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	pop	de
;749   }
@134:
@127:
	.debug	>
;750 
;751 }
@125:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jp	@123
@124:
@122:
	.debug	>
@48:
	.debug	} @48 751

@47	equ	79
	ld	sp,ix
	pop	ix
	lret
@49	equ	81
;752 
;753 //-------------------------------------------------------------------------
;754 //  attempt to open a file to copy messages for a post-mortem dump to and
;755 //  replace stdout with the fd for the file
;756 //-------------------------------------------------------------------------
;757 void openCrashLog(void)
;758 {
$openCrashLog::
	.debug	G $openCrashLog 39 9
	.debug	{ $openCrashLog 39 757 @137 @136
;759   if (corefd >= 0)  return;
	.debug	# 759
	ld	hl,(_corefd)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@136
;760 
;761   logStdout();  // so FILE *stdout is copied to the syslog buffer
	.debug	# 761
	lcall	$logStdout
;762 
;763   noGettyOnA = true;  // so syslog is copied to the console port
	.debug	# 763
	ld	a,0x1
	ld	(_noGettyOnA),a
;764 
;765   corefd = open("crash-log", O_RDWR | O_CREAT | O_APPEND, 0x666);
	.debug	# 765
	ld	hl,0x666
	push	hl
	ld	hl,0x16
	push	hl
	ld	hl,@1+63
	push	hl
	lcall	$open
	add	sp,6
	ld	(_corefd),hl
;766 
;767 //--- change pfd 1 so it also points to the crash-log file and make sure --
;768 //--- anything written to FILE *stdout is written to pfd 1 ---
;769   if (corefd >= 0)  { dup2(corefd, 1);  current->redirStdio = false;  }
	.debug	# 769
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@139
@140:
	.debug	< @140 @141
	ld	hl,0x1
	push	hl
	ld	hl,(_corefd)
	push	hl
	lcall	$dup2
	add	sp,4
	ld	hl,(_current)
	ld	de,0xad
	add	hl,de
	xor	a,a
	ld	(hl),a
@141:
	.debug	>
;770 
;771   printf("\r\n"
@139:
;772     "=====================================================================\
	.debug	# 771
	ld	de,word (phys @8+161)
	ld	c,phys @8+161 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;773   printf("\r\n"
;774     "  RTOS: %.40ls\r\n"
;775     "  APPL: %.40ls  %.40ls\r\n"
;776     "\r\n",
;777     osDTM, applDTM, applName);
	.debug	# 777
	ld	de,word (phys _applName)
	ld	c,phys _applName >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	ld	de,word (phys _osDTM)
	ld	c,phys _osDTM >> 16
	push	bc
	push	de
	ld	de,word (phys @8+235)
	ld	c,phys @8+235 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;778 }
@136:
	.debug	} @136 778

@135	equ	0
	lret
@137	equ	0
;779 
;780 //-------------------------------------------------------------------------
;781 //  attempt to open a file to copy messages for a post-mortem dump to and
;782 //  replace stdout with the fd for the file
;783 //-------------------------------------------------------------------------
;784 void closeCrashLog(void)
;785 {
$closeCrashLog::
	.debug	G $closeCrashLog 39 9
	.debug	{ $closeCrashLog 39 784 @144 @143
;786   if (corefd < 0)  return;
	.debug	# 786
	ld	hl,(_corefd)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@143
;787 
;788   close(corefd);  corefd = -1;
	.debug	# 788
	ld	hl,(_corefd)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(_corefd),hl
;789 
;790 //--- The crash-log fd is duplicated on pfd 1 (stdout) by openCrashLog() --
;791 //--- which means we must close pfd 1 for the file to actually BE closed an
;792 //--- cached data flushed to flash before we reboot ---
;793   fflush(stdout);  close(1);
	.debug	# 793
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	ld	hl,0x1
	push	hl
	lcall	$close
	pop	de
;794 }
@143:
	.debug	} @143 794

@142	equ	0
	lret
@144	equ	0
;795 
;796 //-------------------------------------------------------------------------
;797 //  function to handle reads from FILE diagLog
;798 //-------------------------------------------------------------------------
;799 int _nearcall diagIn(void *userData)
;800 {
	.align	4
$$diagIn::
	ex	(sp),iy
$diagIn::
	.debug	G $diagIn 53 9
	.debug	{ $diagIn 53 799 @148 @147
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A userData 5 46
;801   errno = EAGAIN;  return -1;
	.debug	# 801
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;802 }
@147:
	.debug	} @147 802

@146	equ	0
	pop	ix
	lret
@148	equ	2
;803 
;804 //-------------------------------------------------------------------------
;805 //  Write a character to the circular diagnostic log buffer (diagLogBuf[]).
;806 //
;807 //  KLOCK() must be active when this is called.  This should ONLY be called
;808 //  by diagOut()!
;809 //-------------------------------------------------------------------------
;810 void diagOut_(uchar ch)
;811 {
$diagOut_::
	.debug	G $diagOut_ 54 9
	.debug	{ $diagOut_ 54 810 @151 @150
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ch 5 3
;812   diagLogBuf[diagLogInfo->toIdx] = ch;
	.debug	# 812
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,0
	push	bc
	push	de
	ld	de,(_diagLogBuf)
	ld	bc,(_diagLogBuf+2)
	call	__ladd##
	ld	a,(ix+5)
	call	__farst1##
;813   if (++diagLogInfo->toIdx >= DiagLogSize)  {
	.debug	# 813
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
	ld	de,(_DiagLogSize)
	or	a,a
	sbc	hl,de
	jr	c,@152
;814     diagLogInfo->toIdx = 0;  diagLogInfo->wrapped = true; }
@153:
	.debug	< @153 @154
	.debug	# 814
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
@154:
	.debug	>
;815 
;816 //--- if we "caught up" to the next char to be copied to the remote log, th
;817 //--- bump the index for the log copying, because its better to loose a few
;818 //--- chars then the entire buffer worth of messages ---
;819   if (diagLogInfo->toIdx == diagLogInfo->fromIdx)  {
@152:
	.debug	# 819
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	or	a,a
	sbc	hl,de
	jr	nz,@155
;820     if (++diagLogInfo->fromIdx >= DiagLogSize)  diagLogInfo->fromIdx = 0;  
@156:
	.debug	< @156 @157
	.debug	# 820
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
	ld	de,(_DiagLogSize)
	or	a,a
	sbc	hl,de
	jr	c,@158
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
@158:
@157:
	.debug	>
;821 
;822 //--- if there is no login shell running on the serial console/diag/prog --
;823 //--- port, then copy the char to the serial port's output buffer ---
;824   if (noGettyOnA)  {
@155:
	.debug	# 824
	ld	a,(_noGettyOnA)
	or	a,a
	jr	z,@159
;825     if (SerialSendCountA() < 250)
@160:
	.debug	< @160 @161
	.debug	# 825
	lcall	$SerialSendCountA
	ld	de,0xfa
	or	a,a
	sbc	hl,de
	jr	nc,@162
;826       SerialPutcA(ch);
	.debug	# 826
	bool	hl
	ld	l,(ix+5)
	push	hl
	call	_SerialPutcA
	pop	de
;827     else  if (WaitOnConsole)  {
	jr	@163
@162:
	.debug	# 827
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x4000
	and	hl,de
	jr	z,@164
;828       while (SerialSendCountA() > 250);
@165:
	.debug	< @165 @166
@167:
	.debug	# 828
	lcall	$SerialSendCountA
	ld	de,0xfa
	or	a,a
	sbc	hl,de
	jr	c,@168
	jr	nz,@167
;829       SerialPutcA(ch);
@168:
	.debug	# 829
	bool	hl
	ld	l,(ix+5)
	push	hl
	call	_SerialPutcA
	pop	de
;830     }
@166:
	.debug	>
;831   }
@164:
@163:
@161:
	.debug	>
;832 
;833 }
@159:
@150:
	.debug	} @150 833

@149	equ	0
	pop	ix
	lret
@151	equ	2
;834 
;835 //-------------------------------------------------------------------------
;836 //  The output handler for the FILE * DiagLog.
;837 //
;838 //  This function is called whenever one of the stdio stream oriented outpu
;839 //  functions is called for the FILE *DiagLog (e.g. fprintf, fputs, fwrite,
;840 //  fputc, putc, vfprintf)
;841 //
;842 //  The FILE *DiagLog is used to write messages to the system log, which ca
;843 //  be viewed by the syslog command.  The system log is stored in a circula
;844 //  buffer that is continuosly backed up to a remote file server by the bac
;845 //  daemon.
;846 //
;847 //  NOTES:
;848 //
;849 //    The FILE *DiagLog stream does not simply copy the data sent to it to 
;850 //    buffer.  It keeps track of 3 things:
;851 //
;852 //     - What task is it currently writing a message for?
;853 //     - Is the character a newline character?
;854 //     - How long has it been since it was last called?
;855 //
;856 //    The purpose of this "filtering" is to make the log messages more usef
;857 //    and readable as follows:
;858 //
;859 //     - Each non-blank line in the log has a date/time stamp and identifie
;860 //       what task wrote the message
;861 //
;862 //     - Output from different tasks never shows up on the same line.  This
;863 //       means messages can sometimes be split across lines when a task is
;864 //       preempted while in the middle of writing a message to the log, but
;865 //       allows concurrent writes to the log without adding undue latency.
;866 //
;867 //     - If enough time has passed between messages, a blank line is added 
;868 //       the log before writing the new message.  This keeps messages in
;869 //       groups and makes the log MUCH easier to read.
;870 //
;871 //-------------------------------------------------------------------------
;872 int _nearcall diagOut(uchar ch, void *userData)
;873 {
	.align	4
$$diagOut::
	ex	(sp),iy
$diagOut::
	.debug	G $diagOut 55 9
	.debug	{ $diagOut 55 872 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.debug	A ch 5 3
	.debug	A userData 7 46
;874   uint  curTime;
	.debug	L curTime -2 7
;875   time_t  dateTime;
	.debug	L dateTime -6 9
;876   uint  ms;
	.debug	L ms -8 7
;877   char  *ptr;
	.debug	L ptr -10 43
;878   struct tm  tms;
	.debug	L tms -28 56
;879   static bool  onNewLine, blankLine;
	.bseg
@172:
	.ds	1
	.debug	S onNewLine @172 3
	.seg	FARCODE
	.bseg
@173:
	.ds	1
	.debug	S blankLine @173 3
	.seg	FARCODE
;880   static uint  lastTime, lastApplicTicks;
	.bseg
@174:
	.ds	2
	.debug	S lastTime @174 7
	.seg	FARCODE
	.bseg
@175:
	.ds	2
	.debug	S lastApplicTicks @175 7
	.seg	FARCODE
;881   static task_t  *lastTask;
	.bseg
@176:
	.ds	2
	.debug	S lastTask @176 57
	.seg	FARCODE
;882   static char  temp[64];
	.bseg
@177:
	.ds	64
	.debug	S temp @177 59
	.seg	FARCODE
;883 
;884 
;885   if (!(ch & 0x60) AND (ch != '\n'))  return 0;
	.debug	# 885
	ld	a,(ix+5)
	and	a,96
	jr	nz,@179
	ld	a,(ix+5)
	sub	a,10
	jr	z,@179
	bool	hl
	ld	l,h
	jp	@170
;886 
;887   KLOCK();
@179:
	.debug	# 887
	call	_KLOCK
;888 
;889   curTime = GetMS_();
	.debug	# 889
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-2),hl
;890 
;891 //--- if char is from diff task than prev char, or it is the first char ---
;892 //--- written to the log in several seconds, start a new group of lines ---
;893   if (logDateTime) if ((current != lastTask) OR (curTime - lastTime >  4000
	.debug	# 893
	ld	a,(_logDateTime)
	or	a,a
	jr	z,@180
	ld	hl,(@176)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@181
	ld	hl,(ix-2)
	ld	de,(@174)
	or	a,a
	sbc	hl,de
	ld	de,0xfa0
	or	a,a
	sbc	hl,de
	jr	c,@182
	jr	z,@182
@181:
;894     if (!onNewLine)  { diagOut_('\r');  diagOut_('\n'); }
@183:
	.debug	< @183 @184
	.debug	# 894
	ld	a,(@172)
	or	a,a
	jr	nz,@185
@186:
	.debug	< @186 @187
	ld	hl,0xd
	push	hl
	lcall	$diagOut_
	pop	hl
	ld	hl,0xa
	push	hl
	lcall	$diagOut_
	pop	hl
@187:
	.debug	>
;895     if (!blankLine)  { diagOut_('\r');  diagOut_('\n'); }
@185:
	.debug	# 895
	ld	a,(@173)
	or	a,a
	jr	nz,@188
@189:
	.debug	< @189 @190
	ld	hl,0xd
	push	hl
	lcall	$diagOut_
	pop	hl
	ld	hl,0xa
	push	hl
	lcall	$diagOut_
	pop	hl
@190:
	.debug	>
;896     onNewLine = blankLine = true;  lastTask = current;
@188:
	.debug	# 896
	ld	a,0x1
	ld	(@173),a
	ld	(@172),a
	ld	hl,(_current)
	ld	(@176),hl
;897   }
@184:
	.debug	>
;898 
;899   if (onNewLine AND (ch != '\n'))  {
@182:
@180:
	.debug	# 899
	ld	a,(@172)
	or	a,a
	jp	z,@192
	ld	a,(ix+5)
	sub	a,10
	jp	z,@192
;900     if (current == applTask)  if (applicTicks != lastApplicTicks)
@193:
	.debug	< @193 @194
	.debug	# 900
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@195
	ld	hl,(_applicTicks)
	ld	de,(@175)
	or	a,a
	sbc	hl,de
	jr	z,@196
;901       if (!blankLine)  { diagOut_('\r');  diagOut_('\n');  }
	.debug	# 901
	ld	a,(@173)
	or	a,a
	jr	nz,@197
@198:
	.debug	< @198 @199
	ld	hl,0xd
	push	hl
	lcall	$diagOut_
	pop	hl
	ld	hl,0xa
	push	hl
	lcall	$diagOut_
	pop	hl
@199:
	.debug	>
;902     if (logDateTime)  {
@197:
@196:
@195:
	.debug	# 902
	ld	a,(_logDateTime)
	or	a,a
	jp	z,@200
;903       _EnterCritical_();
@201:
	.debug	< @201 @202
	.debug	# 903
	ipset	2
;904       dateTime = TIME();  ms = milliTicks;
	.debug	# 904
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-8),hl
;905       _ExitCritical_();
	.debug	# 905
	ipres
;906       localtime_r(&dateTime, &tms);
	.debug	# 906
	ld	hl,-28+@169
	add	hl,sp
	push	hl
	ld	hl,-4+@169
	add	hl,sp
	push	hl
	lcall	$localtime_r
	add	sp,4
;907       sprintf(temp, "%04d-%02d-%02d %02d:%02d:%02d.%03d %.24s[%d]: ",
;908               tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;909               tms.tm_hour, tms.tm_min, tms.tm_sec, ms,
;910               current->argv[0], current->pid );
	.debug	# 910
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(_current)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-28)
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-22)
	push	hl
	ld	hl,(ix-20)
	inc	hl
	push	hl
	ld	hl,(ix-18)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	de,word (phys @8+280)
	ld	c,phys @8+280 >> 16
	push	bc
	push	de
	ld	hl,@177
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,26
;911       for (ptr=temp; *ptr; ++ptr)  diagOut_(*ptr);
@203:
	.debug	< @203 @204
	.debug	# 911
	ld	hl,@177
	ld	(ix-10),hl
@205:
	ld	hl,(ix-10)
	ld	a,(hl)
	or	a,a
	jr	z,@206
	bool	hl
	ld	l,a
	push	hl
	lcall	$diagOut_
	pop	hl
;912     }
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jr	@205
@206:
@204:
	.debug	>
@202:
	.debug	>
;913     onNewLine = blankLine = false;
@200:
	.debug	# 913
	xor	a,a
	ld	(@173),a
	ld	(@172),a
;914   }
@194:
	.debug	>
;915 
;916 //--- if end of line char, prefix it with a CR and set the flag saying ---
;917 //--- we need to start a new line ---
;918   if (ch != '\n')  {
@192:
	.debug	# 918
	ld	a,(ix+5)
	sub	a,10
	jr	z,@208
;919     diagOut_(ch);  onNewLine = blankLine = false;  }
@209:
	.debug	< @209 @210
	.debug	# 919
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$diagOut_
	pop	hl
	xor	a,a
	ld	(@173),a
	ld	(@172),a
@210:
	.debug	>
;920   else
;921     if (!blankLine)  {
	jr	@211
@208:
	.debug	# 921
	ld	a,(@173)
	or	a,a
	jr	nz,@212
;922       if (!onNewLine)  diagOut_('\r');
@213:
	.debug	< @213 @214
	.debug	# 922
	ld	a,(@172)
	or	a,a
	jr	nz,@215
	ld	hl,0xd
	push	hl
	lcall	$diagOut_
	pop	hl
;923       diagOut_('\n');
@215:
	.debug	# 923
	ld	hl,0xa
	push	hl
	lcall	$diagOut_
	pop	hl
;924       if (onNewLine)  blankLine = true;  else   onNewLine = true;
	.debug	# 924
	ld	a,(@172)
	or	a,a
	jr	z,@216
	ld	a,0x1
	ld	(@173),a
	jr	@217
@216:
	ld	a,0x1
	ld	(@172),a
;925     }
@217:
@214:
	.debug	>
;926 
;927   lastTime = curTime;  lastApplicTicks = applicTicks;
@212:
@211:
	.debug	# 927
	ld	hl,(ix-2)
	ld	(@174),hl
	ld	hl,(_applicTicks)
	ld	(@175),hl
;928 
;929   KUNLOCK();
	.debug	# 929
	call	_KUNLOCK
;930 
;931   return 0;
	.debug	# 931
	bool	hl
	ld	l,h
;932 }
@170:
	.debug	} @170 932

@169	equ	28
	ld	sp,ix
	pop	ix
	lret
@171	equ	30
;933 
;934 
;935 //-------------------------------------------------------------------------
;936 //  Handles input for FILE *stdin
;937 //-------------------------------------------------------------------------
;938 int _nearcall rcvChar(void *userData)
;939 {
	.align	4
$$rcvChar::
	ex	(sp),iy
$rcvChar::
	.debug	G $rcvChar 53 9
	.debug	{ $rcvChar 53 938 @220 @219
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A userData 5 46
;940   char  ch;
	.debug	L ch -1 3
;941 
;942 
;943   fflush(stdout);
	.debug	# 943
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;944 
;945   if (!FD[MyTaskIdx][0])  return 0;
	.debug	# 945
	ld	hl,(_current)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@221
	bool	hl
	ld	l,h
	jp	@219
;946 
;947   read(0, &ch, 1);  putchar(ch);
@221:
	.debug	# 947
	ld	hl,0x1
	push	hl
	ld	hl,1+@218
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read
	add	sp,6
	ld	hl,(__stdio)
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	push	hl
	ld	de,(__stdio)
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,4
;948 
;949 //finish - handle cooked vs raw line discipline
;950   if (ch == 0x0d)  { ch = 0x0a;  putchar(ch);  }
	.debug	# 950
	ld	a,(ix-1)
	sub	a,13
	jr	nz,@222
@223:
	.debug	< @223 @224
	ld	(ix-1),0xa
	ld	hl,(__stdio)
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	push	hl
	ld	de,(__stdio)
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,4
@224:
	.debug	>
;951 
;952 //finish - do proper signal handling
;953   if (ch == 0x03)  { printf("\r\n");  fflush(stdout);  Exit(-1); }
@222:
	.debug	# 953
	ld	a,(ix-1)
	sub	a,3
	jr	nz,@225
@226:
	.debug	< @226 @227
	ld	de,word (phys @8+32)
	ld	c,phys @8+32 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@227:
	.debug	>
;954 
;955   return (int) ch;
@225:
	.debug	# 955
	bool	hl
	ld	l,(ix-1)
;956 }
@219:
	.debug	} @219 956

@218	equ	1
	ld	sp,ix
	pop	ix
	lret
@220	equ	3
;957 
;958 //-------------------------------------------------------------------------
;959 //  The output handler for the FILE * stdout.
;960 //
;961 //  This function is called whenever one of the stdio stream oriented outpu
;962 //  functions is called for the FILE *stdout (e.g. fprintf, fputs, fwrite,
;963 //  fputc, putc, vfprintf) and the equivalent ones that assume FILE *stdout
;964 //  printf, puts, putchar)
;965 //
;966 //  By default, writes to FILE *stdout get buffered and eventually written 
;967 //  fd_1.  And while DEBROS currently doesn't support freopen(), stdout CAN
;968 //  be redirected by calling redirectStdio() which sets a flag that causes
;969 //  this function to redirect the output to FILE *DiagLog.
;970 //-------------------------------------------------------------------------
;971 int _nearcall xmitChar(uchar ch, void *userData)
;972 {
	.align	4
$$xmitChar::
	ex	(sp),iy
$xmitChar::
	.debug	G $xmitChar 55 9
	.debug	{ $xmitChar 55 971 @230 @229
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ch 5 3
	.debug	A userData 7 46
;973   FDEV far *stdoutDev = FD[userPix][1];
	.debug	L stdoutDev -4 44
	.debug	# 973
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD+0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;974 
;975 //--- If the process has no fd_1, or the flag indicating that data written 
;976 //--- to stdout should be copied to the diagnostic log, then write the char
;977 //--- to the diagnostic log.  NOTE: logStdout must be set if redirStdio is.
;978   if (!stdoutDev OR current->logStdout)  {
	.debug	# 978
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@231
	ld	hl,(_current)
	ld	de,0xac
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@232
@231:
;979     diagOut(ch, userData);
@233:
	.debug	< @233 @234
	.debug	# 979
	ld	hl,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$diagOut
	add	sp,4
;980     if (!stdoutDev OR current->redirStdio)  return 0;  // don't use fd_1 fo
	.debug	# 980
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@235
	ld	hl,(_current)
	ld	de,0xad
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@236
@235:
	bool	hl
	ld	l,h
	jr	@229
;981   }
@236:
@234:
	.debug	>
;982 
;983 //--- add char to the stdout buffer for the current process ---
;984   *current->outPtr++ = ch;  ++current->outCount;
@232:
	.debug	# 984
	ld	hl,(_current)
	ld	de,0xd8
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	__ldec##
	ld	a,(ix+5)
	call	__farst1##
	ld	hl,(_current)
	ld	de,0xd7
	add	hl,de
	ld	a,(hl)
	inc	a
	ld	(hl),a
;985 
;986 //--- if end of a "line" or the buffer is full, then flush it now ---
;987   if ((ch == '\n') OR (current->outCount == StdOutBufSize))  fflush(stdout)
	.debug	# 987
	ld	a,(ix+5)
	sub	a,10
	jr	z,@237
	ld	hl,(_current)
	add	hl,de
	ld	a,(hl)
	sub	a,128
	jr	nz,@238
@237:
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;988 
;989   return 0;
@238:
	.debug	# 989
	bool	hl
	ld	l,h
;990 }
@229:
	.debug	} @229 990

@228	equ	4
	ld	sp,ix
	pop	ix
	lret
@230	equ	6
;991 
;992 
;993 //-------------------------------------------------------------------------
;994 //  Return the device funcs for the "file system" corresponding to a file n
;995 //
;996 //  Basically a simple stand-in for /dev files their major device #
;997 //
;998 //  NOTE:  This does not check to see if the file actually exists.  It mear
;999 //         determines which driver to use.
;1000 //-------------------------------------------------------------------------
;1001 const FileSysFuncs *drvFuncs(const char *fileName)
;1002 {
$drvFuncs::
	.debug	G $drvFuncs 60 9
	.debug	{ $drvFuncs 60 1001 @241 @240
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A fileName 5 43
;1003   uint  u;
	.debug	L u -2 7
;1004 
;1005   for (u=1; u<NumPrefixes; ++u)
@242:
	.debug	< @242 @243
	.debug	# 1005
	ld	hl,0x1
	ld	(ix-2),hl
@244:
	ld	hl,(ix-2)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nc,@245
;1006     if (strncmp(fstab[u].prefix, fileName, strlen(fstab[u].prefix)) == 0)
	.debug	# 1006
	ld	hl,(ix-2)
	ld	b,d
	ld	c,e
	ex	de,hl
	mul
	ld	hl,_fstab
	add	hl,bc
	ld	hl,(hl)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-2)
	ld	bc,0x6
	ex	de,hl
	mul
	ld	hl,_fstab
	add	hl,bc
	ld	hl,(hl)
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	nz,@247
;1007       return fstab[u].fsFuncs;
	.debug	# 1007
	ld	hl,(ix-2)
	ld	bc,0x6
	ex	de,hl
	mul
	ld	hl,_fstab
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	jr	@240
;1008 
;1009   return fstab[0].fsFuncs;
@247:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@244
@245:
@243:
	.debug	>
	.debug	# 1009
	ld	hl,(_fstab+4)
;1010 }
@240:
	.debug	} @240 1010

@239	equ	2
	ld	sp,ix
	pop	ix
	lret
@241	equ	4
;1011 
;1012 
;1013 //-------------------------------------------------------------------------
;1014 //  set the istty flag for the specified file descriptor
;1015 //-------------------------------------------------------------------------
;1016 void setIstty(fd_t fd, bool istty)
;1017 {
$setIstty::
	.debug	G $setIstty 61 9
	.debug	{ $setIstty 61 1016 @250 @249
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
	.debug	A istty 7 3
;1018   if ((uint)fd >= FD_SETSIZE) return;
	.debug	# 1018
	ld	hl,(ix+5)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@249
;1019 
;1020 printf("pid: %d: setIstty(%d, %d)\r\n", getpid(), fd, istty);  //tdebug
	.debug	# 1020
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(_current)
	ld	e,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+327)
	ld	c,phys @8+327 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;1021   FD[MyTaskIdx][fd]->istty = istty;
	.debug	# 1021
	ld	hl,(_current)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x25
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,(ix+7)
	call	__farst1##
;1022 }
@249:
	.debug	} @249 1022

@248	equ	0
	pop	ix
	lret
@250	equ	2
;1023 
;1024 //-------------------------------------------------------------------------
;1025 //  return 1 if fd is a valid descriptor for a terminal device
;1026 //-------------------------------------------------------------------------
;1027 int isatty(fd_t fd)
;1028 {
$isatty::
	.debug	G $isatty 62 9
	.debug	{ $isatty 62 1027 @254 @253
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
;1029   if ((uint)fd >= FD_SETSIZE) return 0;
	.debug	# 1029
	ld	hl,(ix+5)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	c,@255
	bool	hl
	ld	l,h
	jr	@253
;1030 
;1031   return (FD[MyTaskIdx][fd]->istty ? 1 : 0);
@255:
	.debug	# 1031
	ld	hl,(_current)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x25
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@256
	ld	a,0x1
	jr	@257
@256:
	xor	a,a
@257:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
;1032 }
@253:
	.debug	} @253 1032

@252	equ	0
	pop	ix
	lret
@254	equ	2
;1033 
;1034 
;1035 //-------------------------------------------------------------------------
;1036 //  return first unused file descriptor for specified pid that is >= the
;1037 //  specified minimum fd #
;1038 //  returns -1 if no unused descriptors available
;1039 //
;1040 //  NOTE that the structure being used is specific to the task that called,
;1041 //  and the structure itself is not altered, so locking is not required to
;1042 //  protect against corruption (although any task that looks at ANOTHER tas
;1043 //  structures should use locking to make sure the structures don't change
;1044 //  while it is looking at them).
;1045 //-------------------------------------------------------------------------
;1046 int nextfd(uint pix, fd_t minFD)
;1047 {
$nextfd::
	.debug	G $nextfd 63 9
	.debug	{ $nextfd 63 1046 @260 @259
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pix 5 7
	.debug	A minFD 7 6
;1048   fd_t  fd;
	.debug	L fd -2 6
;1049   FDEV far  **fdList;
	.debug	L fdList -4 64
;1050 
;1051   fdList = FD[pix];
	.debug	# 1051
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	(ix-4),hl
;1052 
;1053 //--- see if there is an unused descriptor for the calling process ---
;1054   for (fd=minFD; fd<FD_SETSIZE; ++fd)  if (! fdList[fd])  break;
@261:
	.debug	< @261 @262
	.debug	# 1054
	ld	hl,(ix+7)
	ld	(ix-2),hl
@263:
	ld	hl,(ix-2)
	ld	de,0x8010
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@264
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@264
;1055 
;1056   return (fd < FD_SETSIZE) ? fd : -1;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@263
@264:
@262:
	.debug	>
	.debug	# 1056
	ld	hl,(ix-2)
	ld	de,0x8010
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@267
	ld	hl,(ix-2)
	jr	@259
@267:
	ld	hl,0xffff
;1057 }
@259:
	.debug	} @259 1057

@258	equ	4
	ld	sp,ix
	pop	ix
	lret
@260	equ	6
;1058 
;1059 //-------------------------------------------------------------------------
;1060 //  Returns a non-zero value if the provided pointer refers to an in-use
;1061 //  global file descriptor.  Otherwise, it returns 0.
;1062 //-------------------------------------------------------------------------
;1063 bool  _validFDEV_(FDEV far *file)
;1064 {
$_validFDEV_::
	.debug	G $_validFDEV_ 65 9
	.debug	{ $_validFDEV_ 65 1063 @271 @270
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A file 5 44
;1065   uint  gfd;
	.debug	L gfd -2 7
;1066   int  openCount;
	.debug	L openCount -4 6
;1067 
;1068 
;1069   gfd = (uint)(file - fileTbl);
	.debug	# 1069
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__lsub##
	push	bc
	push	de
	ld	de,0x27
	ld	c,d
	ld	b,d
	call	__ldiv##
	ex	de,hl
	ld	(ix-2),hl
;1070 
;1071   if (gfd >= MaxOpenFiles) return false;
	.debug	# 1071
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nc,@650
;1072 
;1073   if (file != fileTbl + gfd)  return false;
	.debug	# 1073
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x27
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__fpcmp##
	jr	nz,@650
;1074 
;1075   _EnterCritical_();  openCount = file->openCount;  _ExitCritical_();
	.debug	# 1075
	ipset	2
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
	ipres
;1076 
;1077   if (openCount < 1)  return false;
	.debug	# 1077
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@274
@650:
	xor	a,a
	jr	@270
;1078 
;1079   return true;
@274:
	.debug	# 1079
	ld	a,0x1
;1080 }
@270:
	.debug	} @270 1080

@269	equ	4
	ld	sp,ix
	pop	ix
	lret
@271	equ	6
;1081 
;1082 //-------------------------------------------------------------------------
;1083 //  Return a user-space (task-specific) descriptor for the specified global
;1084 //  file table entry.
;1085 //
;1086 //  Normally called by individual device drivers
;1087 //
;1088 //  WARNING:  KLOCK() must be active before calling this function!
;1089 //-------------------------------------------------------------------------
;1090 fd_t _addFileRef_(FDEV far *file)
;1091 {
$_addFileRef_::
	.debug	G $_addFileRef_ 66 9
	.debug	{ $_addFileRef_ 66 1090 @277 @276
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A file 5 44
;1092   fd_t  fd;
	.debug	L fd -2 6
;1093 
;1094 
;1095   if (! KLOCKED())  { klockErr(__func__);  return -1; }
	.debug	# 1095
	ld	a,(__disabled)
	or	a,a
	jr	nz,@278
@279:
	.debug	< @279 @280
	ld	de,word (phys @8+355)
	ld	c,phys @8+355 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
	jr	@649
@280:
	.debug	>
;1096 
;1097 //--- Make sure the global file table pointer points to an in-use file ---
;1098   if (! _validFDEV_(file))  { errno = EBADF;  return -1; }
@278:
	.debug	# 1098
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$_validFDEV_
	add	sp,4
	or	a,a
	jr	nz,@281
@282:
	.debug	< @282 @283
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@648
@283:
	.debug	>
;1099 
;1100 //--- see if there is an unused descriptor for the calling process ---
;1101   if ((fd = nextfd(userPix, 0)) < 0)  { ERRNO = EMFILE;  return -1; }
@281:
	.debug	# 1101
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(_userPix)
	push	hl
	lcall	$nextfd
	add	sp,4
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@284
@285:
	.debug	< @285 @286
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x18
@648:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@649:
	ld	hl,0xffff
	jr	@276
@286:
	.debug	>
;1102 
;1103 //--- point new user-space descriptor to global file table entry and ---
;1104 //--- increment the usage count of the global entry ---
;1105   FD[(uint)userPix][(uint)fd] = file;
@284:
	.debug	# 1105
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1106   ++file->openCount;
	.debug	# 1106
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
;1107 
;1108   return fd;
	.debug	# 1108
	ld	hl,(ix-2)
;1109 }
@276:
	.debug	} @276 1109

@275	equ	2
	ld	sp,ix
	pop	ix
	lret
@277	equ	4
;1110 
;1111 
;1112 //-------------------------------------------------------------------------
;1113 //  Allocate an entry in the global file table and a User-space File Descri
;1114 //  that points to it.
;1115 //
;1116 //  Normally called by individual device drivers
;1117 //
;1118 //  WARNING:  KLOCK() must be active before calling this function!
;1119 //-------------------------------------------------------------------------
;1120 fd_t _allocFile_(fd_t minFD, const IODevFuncs *ioFuncs, void *ioDev)
;1121 {
$_allocFile_::
	.debug	G $_allocFile_ 67 9
	.debug	{ $_allocFile_ 67 1120 @289 @288
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-9
	.debug	A minFD 5 6
	.debug	A ioFuncs 7 47
	.debug	A ioDev 9 46
;1122   char  i;
	.debug	L i -1 3
;1123   fd_t  fd;
	.debug	L fd -3 6
;1124   FDEV far  *file;
	.debug	L file -7 44
;1125   FDEV far  **fdList;
	.debug	L fdList -9 64
;1126 
;1127 
;1128   if (! KLOCKED())  { klockErr(__func__);  return -1; }
	.debug	# 1128
	ld	a,(__disabled)
	or	a,a
	jr	nz,@290
@291:
	.debug	< @291 @292
	ld	de,word (phys @8+368)
	ld	c,phys @8+368 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
	jr	@647
@292:
	.debug	>
;1129 
;1130   fdList = FD[userPix];
@290:
	.debug	# 1130
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	(ix-9),hl
;1131 
;1132 //--- see if there is an unused descriptor for the calling process ---
;1133   if ((fd = nextfd(userPix, minFD)) < 0)  { ERRNO = EMFILE;  return -1; }
	.debug	# 1133
	ld	hl,(ix+5)
	push	hl
	ld	hl,(_userPix)
	push	hl
	lcall	$nextfd
	add	sp,4
	ld	(ix-3),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@293
@294:
	.debug	< @294 @295
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x18
	jr	@646
@295:
	.debug	>
;1134 
;1135 //--- see if there is an unused entry in the global file table ---
;1136   for (i=0; i<MaxOpenFiles; ++i)  if (fileTbl[i].openCount == 0)  break;
@293:
@296:
	.debug	< @296 @297
	.debug	# 1136
	xor	a,a
	ld	(ix-1),a
@298:
	ld	a,(ix-1)
	sub	a,64
	jr	nc,@299
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	ld	bc,0x27
	ex	de,hl
	mul
	ld	de,bc
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@299
;1137 
;1138   if (i == MaxOpenFiles)  { ERRNO = ENFILE;  return -1; }
	ld	a,(ix-1)
	inc	a
	ld	(ix-1),a
	jr	@298
@299:
@297:
	.debug	>
	.debug	# 1138
	ld	a,(ix-1)
	sub	a,64
	jr	nz,@302
@303:
	.debug	< @303 @304
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x17
@646:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@647:
	ld	hl,0xffff
	jp	@288
@304:
	.debug	>
;1139 
;1140 //--- point descriptor to global file table entry ---
;1141   fdList[fd] = file = fileTbl + i;
@302:
	.debug	# 1141
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	ld	bc,0x27
	ex	de,hl
	mul
	ld	de,bc
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-5),hl
	ex	de,hl
	ld	(ix-7),hl
	ex	de,hl
	ld	hl,(ix-3)
	add	hl,hl
	add	hl,hl
	push	de
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1142 
;1143 //--- initialize global file table entry ---
;1144   fmemset(file, 0, sizeof(FDEV));
	.debug	# 1144
	ld	de,0x27
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;1145   file->openCount = 1;
	.debug	# 1145
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	ld	hl,0x1
	call	__farst2##
;1146   file->ioFuncs = ioFuncs;
	.debug	# 1146
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+7)
	call	__farst2##
;1147   file->ioDev = ioDev;
	.debug	# 1147
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+9)
	call	__farst2##
;1148   file->readCount = file->writeCount = 0;
	.debug	# 1148
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__farst4d##
	push	bc
	push	de
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;1149   file->dontCallRead = file->dontCallWrite = false;
	.debug	# 1149
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x23
	ld	c,d
	ld	b,d
	call	__ladd##
	xor	a,a
	call	__farst1##
	ld	l,a
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	ld	hl,(ix-7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,l
	call	__farst1##
;1150   (file->ioFuncs->getQueues)(file->ioDev, &file->waitQueues);
	.debug	# 1150
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-5)
	ld	bc,hl
	ld	hl,(ix-7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,hl
	ld	hl,0xe
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
;1151   file->flags = O_RDWR;
	.debug	# 1151
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,0x2
	call	__farst2##
;1152 
;1153   return fd;
	.debug	# 1153
	ld	hl,(ix-3)
;1154 }
@288:
	.debug	} @288 1154

@287	equ	9
	ld	sp,ix
	pop	ix
	lret
@289	equ	11
;1155 
;1156 
;1157 //-------------------------------------------------------------------------
;1158 //  Return a pointer to the entry in the global file table that a file
;1159 //  descriptor refers to.
;1160 //
;1161 //  Returns NULL if an error or the FD does not refer to an open file.
;1162 //  Sets errno if the fd is out of range.
;1163 //-------------------------------------------------------------------------
;1164 FDEV far *_FileFromFD_(fd_t fd)
;1165 {
$_FileFromFD_::
	.debug	G $_FileFromFD_ 68 9
	.debug	{ $_FileFromFD_ 68 1164 @307 @306
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
;1166   if ((uint)fd >= FD_SETSIZE)  { ERRNO = EBADF;  return NULL; }
	.debug	# 1166
	ld	hl,(ix+5)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	c,@308
@309:
	.debug	< @309 @310
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	e,d
	ld	c,e
	ld	b,e
	jr	@306
@310:
	.debug	>
;1167 
;1168   return FD[(uint)userPix][fd];
@308:
	.debug	# 1168
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
;1169 }
@306:
	.debug	} @306 1169

@305	equ	0
	pop	ix
	lret
@307	equ	2
;1170 
;1171 //-------------------------------------------------------------------------
;1172 //  Check the specified descriptor to see if it is valid and refers to an
;1173 //  open file.
;1174 //
;1175 //  Returns a pointer to the entry in the global file table if the descript
;1176 //  points to an open file.
;1177 //
;1178 //  Returns NULL if not a valid open file and sets errno.
;1179 //-------------------------------------------------------------------------
;1180 FDEV far *_fdToOpenFile_(fd_t fd)
;1181 {
$_fdToOpenFile_::
	.debug	G $_fdToOpenFile_ 68 9
	.debug	{ $_fdToOpenFile_ 68 1180 @313 @312
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A fd 5 6
;1182   FDEV far  *file;
	.debug	L file -4 44
;1183 
;1184 
;1185   if ((fd < 0) OR (fd >= FD_SETSIZE))  { ERRNO = EBADF;  return NULL; }
	.debug	# 1185
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@314
	ld	hl,(ix+5)
	ld	e,0x10
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@315
@314:
@316:
	.debug	< @316 @317
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@645
@317:
	.debug	>
;1186   if (! (file = FD[userPix][fd]))  { ERRNO = EBADF;  return NULL; }
@315:
	.debug	# 1186
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@318
@319:
	.debug	< @319 @320
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
@645:
	ld	e,d
	jr	@644
@320:
	.debug	>
;1187 
;1188   if (! _validFDEV_(file))  { ERRNO = EBADF;  return NULL; }
@318:
	.debug	# 1188
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$_validFDEV_
	add	sp,4
	or	a,a
	jr	nz,@321
@322:
	.debug	< @322 @323
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	e,d
@644:
	ld	c,e
	ld	b,e
	jr	@312
@323:
	.debug	>
;1189 
;1190   return file;
@321:
	.debug	# 1190
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;1191 }
@312:
	.debug	} @312 1191

@311	equ	4
	ld	sp,ix
	pop	ix
	lret
@313	equ	6
;1192 
;1193 //-------------------------------------------------------------------------
;1194 //  Swap everything in two file table entries EXCEPT the reference counts a
;1195 //  the fcntl-type (task-fd-specific) attributes.
;1196 //
;1197 //  WARNING:  KLOCK() must be in effect before calling this function!
;1198 //-------------------------------------------------------------------------
;1199 int _File_Swap_(FDEV far *f1, FDEV far *f2)
;1200 {
$_File_Swap_::
	.debug	G $_File_Swap_ 69 9
	.debug	{ $_File_Swap_ 69 1199 @326 @325
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-78
	.debug	A f1 5 44
	.debug	A f2 9 44
;1201   FDEV  origf1, origf2;
	.debug	L origf1 -39 45
	.debug	L origf2 -78 45
;1202 
;1203 
;1204   if (! KLOCKED())  klockErr(__func__);
	.debug	# 1204
	ld	a,(__disabled)
	or	a,a
	jr	nz,@327
	ld	de,word (phys @8+380)
	ld	c,phys @8+380 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1205 
;1206   origf1 = *f1;  origf2 = *f2;
@327:
	.debug	# 1206
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,-39+@324
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,39
	call	__farcopy##
	add	sp,4
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,-78+@324
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,39
	call	__farcopy##
	add	sp,4
;1207 
;1208   *f1 = origf2;
	.debug	# 1208
	ld	hl,-78+@324
	add	hl,sp
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,39
	call	__farcopyr##
	add	sp,4
;1209   f1->openCount = origf1.openCount;
	.debug	# 1209
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix-39)
	call	__farst2##
;1210   f1->flags = origf1.flags;
	.debug	# 1210
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-29)
	call	__farst2##
;1211 
;1212   *f2 = origf1;
	.debug	# 1212
	ld	hl,-39+@324
	add	hl,sp
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix+9)
	ex	de,hl
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,39
	call	__farcopyr##
	add	sp,4
;1213   f2->openCount = origf2.openCount;
	.debug	# 1213
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	hl,(ix-78)
	call	__farst2##
;1214   f2->flags = origf2.flags;
	.debug	# 1214
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-68)
	call	__farst2##
;1215 
;1216   return 0;
	.debug	# 1216
	bool	hl
	ld	l,h
;1217 }
@325:
	.debug	} @325 1217

@324	equ	78
	ld	sp,ix
	pop	ix
	lret
@326	equ	80
;1218 
;1219 //-------------------------------------------------------------------------
;1220 //  Func for use by kernel-space functions to safely close a user-space
;1221 //  file descriptor
;1222 //-------------------------------------------------------------------------
;1223 int _closeFD_(task_t *task, fd_t fd)
;1224 {
$_closeFD_::
	.debug	G $_closeFD_ 70 9
	.debug	{ $_closeFD_ 70 1223 @330 @329
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-11
	.debug	A task 5 57
	.debug	A fd 7 6
;1225   FDEV far  *file;
	.debug	L file -4 44
;1226   FDEV far  **fdPtr;
	.debug	L fdPtr -6 64
;1227   const IODevFuncs  *ioFuncs;
	.debug	L ioFuncs -8 47
;1228   void  *ioDev;
	.debug	L ioDev -10 46
;1229   bool  doDevClose;
	.debug	L doDevClose -11 3
;1230 
;1231 
;1232   if ((fd < 0) OR (fd >= FD_SETSIZE))  { ERRNO = EBADF;  return -1; }
	.debug	# 1232
	ld	hl,(ix+7)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@331
	ld	hl,(ix+7)
	ld	e,0x10
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@332
@331:
@333:
	.debug	< @333 @334
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@643
@334:
	.debug	>
;1233 
;1234   fdPtr = (FDEV far **)task->FDSet + fd;  // ptr to process' descriptor
@332:
	.debug	# 1234
	ld	hl,(ix+5)
	ld	de,0xf
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	(ix-6),hl
;1235 
;1236   KLOCK();
	.debug	# 1236
	call	_KLOCK
;1237 
;1238 //--- Validate descriptor and keep a pointer to it ---
;1239   if (! (file = *fdPtr))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 1239
	ld	hl,(ix-6)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@335
@336:
	.debug	< @336 @337
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
@643:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@329
@337:
	.debug	>
;1240 
;1241   if (ShowFileEvents)
@335:
	.debug	# 1241
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x400
	and	hl,de
	jr	z,@338
;1242     fprintf(DiagLog, "close fd %d for [%d](%s), openCounts: %d\n",
;1243            fd, task->pid, task->argv[0], file->openCount);
	.debug	# 1243
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	e,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	de,word (phys @8+392)
	ld	c,phys @8+392 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1244 
;1245 //--- Free descriptor and decrement open count for referenced file. ---
;1246 //--- If no more references to the file, then prepare to close it ---
;1247   *fdPtr = NULL;  doDevClose = false;
@338:
	.debug	# 1247
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix-6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	xor	a,a
	ld	(ix-11),a
;1248   if (file->openCount > 0)  doDevClose = (--file->openCount == 0);
	.debug	# 1248
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farld2##
	ld	hl,0x8000
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@339
	jr	z,@339
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	call	__farld2##
	dec	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
	bool	hl
	ld	l,h
	jr	nz,@340
	inc	l
@340:
	ld	(ix-11),l
;1249 
;1250 //--- We can't call the driver's close func with KLOCK in place because ---
;1251 //--- the close func might need to block, but releasing the lock before ---
;1252 //--- calling the driver means the global descriptor could get snatched ---
;1253 //--- up by another task so we need to save refs to the driver and the ---
;1254 //--- device driver's structure BEFORE we release the lock ---
;1255   if (doDevClose)  { ioFuncs = file->ioFuncs;  ioDev = file->ioDev; }
@339:
	.debug	# 1255
	ld	a,(ix-11)
	or	a,a
	jr	z,@341
@342:
	.debug	< @342 @343
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-8),hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-10),hl
@343:
	.debug	>
;1256 
;1257   KUNLOCK();
@341:
	.debug	# 1257
	call	_KUNLOCK
;1258 
;1259   if (doDevClose)  ioFuncs->close(ioDev);
	.debug	# 1259
	ld	a,(ix-11)
	or	a,a
	jr	z,@344
	ld	hl,(ix-10)
	push	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	pop	de
;1260 
;1261   return 0;
@344:
	.debug	# 1261
	bool	hl
	ld	l,h
;1262 }
@329:
	.debug	} @329 1262

@328	equ	11
	ld	sp,ix
	pop	ix
	lret
@330	equ	13
;1263 
;1264 
;1265 //-------------------------------------------------------------------------
;1266 //  Open a file/device
;1267 //-------------------------------------------------------------------------
;1268 fd_t open(const char *path, int flags, int mode)
;1269 {
$open::
	.debug	G $open 71 9
	.debug	{ $open 71 1268 @347 @346
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A path 5 43
	.debug	A flags 7 6
	.debug	A mode 9 6
;1270   int  fd;
	.debug	L fd -2 6
;1271   PID  pid;
	.debug	L pid -4 6
;1272   uint  pix;
	.debug	L pix -6 7
;1273   FDEV far  *file;
	.debug	L file -10 44
;1274   const FileSysFuncs  *fsf;
	.debug	L fsf -12 36
;1275 
;1276 
;1277 //--- check for a request to open the terminal device ---
;1278   if (StrEq(path, "/dev/tty"))  {
	.debug	# 1278
	ld	hl,@1+28
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jp	nz,@348
;1279     for (pid=getpid(); pid>=0; pid=tasks[pix].ppid)  {
@349:
	.debug	< @349 @350
@351:
	.debug	< @351 @352
	.debug	# 1279
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
@353:
	ld	hl,(ix-4)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@354
;1280       KLOCK();
@356:
	.debug	< @356 @357
	.debug	# 1280
	call	_KLOCK
;1281       pix = TaskIdx(pid);  if (!tasks[pix].inUse)  { KUNLOCK();  continue; 
	.debug	# 1281
	ld	hl,(ix-4)
	ld	de,0x1f
	and	hl,de
	ld	(ix-6),hl
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@642
@359:
	.debug	< @359 @360
@360:
	.debug	>
;1282       if ((file = FD[pix][0]) == NULL)  { KUNLOCK();  continue; }
	.debug	# 1282
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@361
@362:
	.debug	< @362 @363
@642:
	call	_KUNLOCK
	jp	@355
@363:
	.debug	>
;1283       if (file->istty)  {
@361:
	.debug	# 1283
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x25
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@364
;1284         if ((fd = nextfd(pix, 0)) < 0)  {
@365:
	.debug	< @365 @366
	.debug	# 1284
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$nextfd
	add	sp,4
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@367
;1285           KUNLOCK();  ERRNO = EMFILE;  return -1; }
@368:
	.debug	< @368 @369
	.debug	# 1285
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x18
	jp	@641
@369:
	.debug	>
;1286         FD[MyTaskIdx][fd] = file;  ++file->openCount;
@367:
	.debug	# 1286
	ld	hl,(_current)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
;1287         KUNLOCK();  return fd;
	.debug	# 1287
	call	_KUNLOCK
	ld	hl,(ix-2)
	jp	@346
;1288       }
@366:
	.debug	>
;1289       KUNLOCK();
@364:
	.debug	# 1289
	call	_KUNLOCK
;1290     }
@357:
	.debug	>
;1291   }
@355:
	ld	hl,(ix-6)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xb6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	jp	@353
@354:
@352:
	.debug	>
@350:
	.debug	>
;1292 
;1293   if (ShowFileEvents)
@348:
	.debug	# 1293
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x400
	and	hl,de
	jr	z,@370
;1294     fprintf(DiagLog, "open('%.*s', 0x%04x, 0%03o)\n",
;1295             PATH_MAX, path, flags, mode);
	.debug	# 1295
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x40
	push	hl
	ld	de,word (phys @8+434)
	ld	c,phys @8+434 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1296 
;1297 
;1298   fsf = drvFuncs(path);  if (!fsf)  { ERRNO = ENOENT;  return -1; }
@370:
	.debug	# 1298
	ld	hl,(ix+5)
	push	hl
	lcall	$drvFuncs
	pop	de
	ld	(ix-12),hl
	bool	hl
	jr	nz,@371
@372:
	.debug	< @372 @373
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
@641:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@377
@373:
	.debug	>
;1299 
;1300 
;1301   fd = fsf->open(path, flags, mode);
@371:
	.debug	# 1301
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
	ld	(ix-2),hl
;1302 
;1303   if (fd < 0)  {
	.debug	# 1303
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@374
;1304     if (ShowFileEvents)
@375:
	.debug	< @375 @376
	.debug	# 1304
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x400
	and	hl,de
	jr	z,@377
;1305       fprintf(DiagLog, "failed open [%.32s] using [%.32s]\r\n", path, fsf->
	.debug	# 1305
	ld	hl,(ix-12)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @8+463)
	ld	c,phys @8+463 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1306     return -1;
@377:
	.debug	# 1306
	ld	hl,0xffff
	jr	@346
;1307   }
@376:
	.debug	>
;1308 
;1309 //--- save parameter values passed in open call ---
;1310 //NOTE:  Most of the FDEV struct is initialized in _allocFile_(), which is
;1311 //       called by the open func in each driver to get an unused FDEV eleme
;1312   KLOCK();
@374:
	.debug	# 1312
	call	_KLOCK
;1313   file = _fdToOpenFile_(fd);
	.debug	# 1313
	ld	hl,(ix-2)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;1314   file->flags = flags;  file->mode = mode;
	.debug	# 1314
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+7)
	call	__farst2##
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+9)
	call	__farst2##
;1315   KUNLOCK();
	.debug	# 1315
	call	_KUNLOCK
;1316 
;1317 /*
;1318 fprintf(DiagLog, "%.64s: %d: readQueue:[%04lx]  writeQueue:[%04lx]\n",  //t
;1319         path, fd,
;1320         (ulong)file->waitQueues.readQueue,
;1321         (ulong)file->waitQueues.writeQueue );
;1322 */
;1323 
;1324   return fd;
	.debug	# 1324
	ld	hl,(ix-2)
;1325 }
@346:
	.debug	} @346 1325

@345	equ	12
	ld	sp,ix
	pop	ix
	lret
@347	equ	14
;1326 
;1327 
;1328 
;1329 //-------------------------------------------------------------------------
;1330 //  Close the specified user-space file descriptor
;1331 //-------------------------------------------------------------------------
;1332 int close(fd_t fd)
;1333 {
$close::
	.debug	G $close 62 9
	.debug	{ $close 62 1332 @380 @379
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
;1334   if (ShowFileEvents)  fprintf(DiagLog, "close(%d)\n", fd);
	.debug	# 1334
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x400
	and	hl,de
	jr	z,@381
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @8+499)
	ld	c,phys @8+499 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1335 
;1336   return  _closeFD_(current, fd);
@381:
	.debug	# 1336
	ld	hl,(ix+5)
	push	hl
	ld	hl,(_current)
	push	hl
	lcall	$_closeFD_
	add	sp,4
;1337 }
@379:
	.debug	} @379 1337

@378	equ	0
	pop	ix
	lret
@380	equ	2
;1338 
;1339 
;1340 
;1341 //-------------------------------------------------------------------------
;1342 //  Attempt to read specified # of bytes from a device
;1343 //
;1344 //  maxIdleMS determines blocking mode as follows:
;1345 //    < 0: indefinite timeout (i.e. block until done or error)
;1346 //      0: non-blocking:  read as much as possible and return
;1347 //    > 0: max # of ms to wait with no progress
;1348 //
;1349 //  Note that a positive value does NOT place an upper limit on how long th
;1350 //  function will wait to read the requested # of bytes, but rather the max
;1351 //  time it will wait while NO PROGRESS is being made at reading the bytes.
;1352 //
;1353 //  Note that if non blocking mode is set for the file descriptor then the
;1354 //  maxIdleMS value is ignored (treated as if it were 0)
;1355 //
;1356 //  If a timeout > 0 expires, errno is set to ETIME (regardless of what the
;1357 //  return value is, which could be > 0 if some bytes were read).
;1358 //-------------------------------------------------------------------------
;1359 int readFDEV(FDEV far *file, void *buf, int numBytes, long maxIdleMS)
;1360 {
$readFDEV::
	.debug	G $readFDEV 72 9
	.debug	{ $readFDEV 72 1359 @384 @383
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-17
	.debug	A file 5 44
	.debug	A buf 9 46
	.debug	A numBytes 11 6
	.debug	A maxIdleMS 13 8
;1361   int  stat, pid, bytesRead;
	.debug	L stat -2 6
	.debug	L pid -4 6
	.debug	L bytesRead -6 6
;1362   bool  nonBlocking;
	.debug	L nonBlocking -7 3
;1363   char  *inPtr;
	.debug	L inPtr -9 43
;1364   ulong  maxIdleTicks = 0;
	.debug	L maxIdleTicks -13 9
	.debug	# 1364
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
	.seg	FARCODE
;1365   WaitQueue  *readQueue;
	.debug	L readQueue -15 73
;1366   WaitQueueNode  *wqNode;
	.debug	L wqNode -17 75
;1367 
;1368 
;1369   if (ShowRWCalls)
	.debug	# 1369
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@385
;1370     fprintf(DiagLog, "readFDEV([%05lX], 0x%04X, %d)\r\n",
;1371             (ulong)file, (uint)buf, numBytes);
	.debug	# 1371
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	de,word (phys @8+510)
	ld	c,phys @8+510 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1372 
;1373   if (!file)  {
@385:
	.debug	# 1373
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@386
;1374     if (ShowRWCalls)  fprintf(DiagLog, "  read returned: %d\r\n", -1);
@387:
	.debug	< @387 @388
	.debug	# 1374
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@389
	ld	hl,0xffff
	push	hl
	ld	de,word (phys @8+542)
	ld	c,phys @8+542 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1375     return -1;
@389:
	.debug	# 1375
	jp	@639
;1376   }
@388:
	.debug	>
;1377 
;1378   if (numBytes <= 0)  return 0;
@386:
	.debug	# 1378
	ld	hl,(ix+11)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@391
	jr	nc,@390
@391:
	jp	@419
;1379 
;1380   if (!buf)  { errno = EINVAL;  return -1; }
@390:
	.debug	# 1380
	ld	hl,(ix+9)
	bool	hl
	jr	nz,@392
@393:
	.debug	< @393 @394
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@640
@394:
	.debug	>
;1381 
;1382   pid = getpid();
@392:
	.debug	# 1382
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
;1383 
;1384 //--- if driver won't return any new data, just return status from last ---
;1385 //--- call to driver ---
;1386   if (file->dontCallRead)  {  errno = file->rdErr;  return file->rdStat; }
	.debug	# 1386
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@395
@396:
	.debug	< @396 @397
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(_current)
	ld	bc,de
	ld	de,0xb9
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	jp	@383
@397:
	.debug	>
;1387 
;1388   if (! ((file->flags & O_RDONLY) OR (file->flags & O_RDWR)) )  {
@395:
	.debug	# 1388
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x1
	and	hl,de
	jr	nz,@401
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x2
	and	hl,de
	jr	nz,@401
;1389     errno = EBADF;  return -1; }
@402:
	.debug	< @402 @403
	.debug	# 1389
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@640
@403:
	.debug	>
;1390 
;1391   KLOCK();
@401:
	.debug	# 1391
	call	_KLOCK
;1392 
;1393     //finish: all the relavant "flags" values...
;1394     //finish: lots of other details - see recv()/revfrom() man page
;1395 
;1396   if (file->flags & O_NONBLOCK)  maxIdleMS = 0;
	.debug	# 1396
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x20
	and	hl,de
	jr	z,@404
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;1397 
;1398   nonBlocking = (maxIdleMS == 0);
@404:
	.debug	# 1398
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	or	hl,de
	ld	de,0
	jr	nz,@405
	inc	e
@405:
	ld	(ix-7),e
;1399 
;1400   if (maxIdleMS > 0)  maxIdleTicks = msToTicks((ulong)maxIdleMS);
	.debug	# 1400
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	c,@406
	jr	z,@406
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;1401 
;1402 
;1403 //--- is another process in the middle of a read on this file/device? ---
;1404   while (file->rdInProgress)  if (file->rdInProgress != pid)
@406:
@407:
	.debug	# 1404
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@408
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	z,@409
;1405     if (_activeTaskIdx_(file->rdInProgress) >= 0)  {
	.debug	# 1405
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@410
;1406       if (nonBlocking)  { KUNLOCK();  ERRNO = EAGAIN;  return -1; }
@411:
	.debug	< @411 @412
	.debug	# 1406
	ld	a,(ix-7)
	or	a,a
	jr	z,@413
@414:
	.debug	< @414 @415
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@640:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@639
@415:
	.debug	>
;1407       KUNLOCK();  sleepMS(5);  KLOCK();
@413:
	.debug	# 1407
	call	_KUNLOCK
	ld	de,0x5
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
;1408     }
@412:
	.debug	>
;1409 
;1410   if (file->eof)  {
@410:
@409:
	jp	@407
@408:
	.debug	# 1410
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x24
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@416
;1411     KUNLOCK();
@417:
	.debug	< @417 @418
	.debug	# 1411
	call	_KUNLOCK
;1412     if (ShowRWCalls)  fprintf(DiagLog, "  read returned: %d\r\n", 0);
	.debug	# 1412
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@419
	bool	hl
	ld	l,h
	push	hl
	ld	de,word (phys @8+542)
	ld	c,phys @8+542 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1413     return 0;
@419:
	.debug	# 1413
	bool	hl
	ld	l,h
	jp	@383
;1414   }
@418:
	.debug	>
;1415 
;1416   file->rdInProgress = pid;
@416:
	.debug	# 1416
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
;1417 
;1418   KUNLOCK();
	.debug	# 1418
	call	_KUNLOCK
;1419 
;1420 
;1421 
;1422   readQueue = file->waitQueues.readQueue;
	.debug	# 1422
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-15),hl
;1423 
;1424 //finish:  don't have driver set global errno?  Or push/pop global errno?
;1425 
;1426 //--- If doing a non-blocking read, or the driver directly below this level
;1427 //--- does not provide wait queues for use by the fcntl layer, then simply 
;1428 //--- return the result from the driver (if doing a blocking read, the ---
;1429 //--- blocking needs to be handled by the driver or whatever the driver is 
;1430 //--- calling to do the work) ---
;1431   if (nonBlocking OR !readQueue)  {
	.debug	# 1431
	ld	a,(ix-7)
	or	a,a
	jr	nz,@420
	bool	hl
	jp	nz,@421
@420:
;1432     stat = (file->ioFuncs->read)(file->ioDev, buf, numBytes, nonBlocking);
@422:
	.debug	< @422 @423
	.debug	# 1432
	ld	a,(ix-7)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-2),hl
;1433     if (stat > 0)  {
	.debug	# 1433
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@424
	jr	z,@424
;1434       _EnterCritical_();  file->readCount += (ulong)stat;  _ExitCritical_()
@425:
	.debug	< @425 @426
	.debug	# 1434
	ipset	2
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	pop	iy
	pop	af
	push	bc
	push	de
	push	af
	push	iy
	call	__farld4##
	call	__ladd##
	call	__farst4d##
	ipres
@426:
	.debug	>
;1435     else  if ((stat == 0) OR ((stat < 0) AND (errno != EAGAIN)))  {
	jr	@427
@424:
	.debug	# 1435
	ld	hl,(ix-2)
	bool	hl
	jr	z,@428
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@429
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	z,@429
@428:
;1436       file->dontCallRead = true;
@433:
	.debug	< @433 @434
	.debug	# 1436
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;1437       file->rdStat = stat;  file->rdErr = errno;
	.debug	# 1437
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
;1438     }
@434:
	.debug	>
;1439     if (ShowRWCalls)  fprintf(DiagLog, "  read returned: %d\r\n", stat);
@429:
@427:
	.debug	# 1439
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@435
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @8+542)
	ld	c,phys @8+542 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1440     _EnterCritical_();  file->rdInProgress = 0;  _ExitCritical_();
@435:
	.debug	# 1440
	ipset	2
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
	ipres
;1441     return stat;
	.debug	# 1441
	ld	hl,(ix-2)
	jp	@383
;1442   }
@423:
	.debug	>
;1443 
;1444 
;1445 //--- do blocking read using queue specified by the driver ---
;1446   bytesRead = 0;  inPtr = buf;
@421:
	.debug	# 1446
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	ld	hl,(ix+9)
	ld	(ix-9),hl
;1447 
;1448 //  if (! list_empty(&WQNode.task_list))  {
;1449 //    fprintf(DiagLog, "Already in wait queue!\n");  //tdebug
;1450 //    errno = EDEADLK;  file->rdInProgress = false;  return -1; }
;1451 
;1452   if (!(wqNode = alloc_WaitQueueNode()))  return -1;
	.debug	# 1452
	lcall	$alloc_WaitQueueNode
	ld	(ix-17),hl
	bool	hl
	jr	nz,@436
@639:
	ld	hl,0xffff
	jp	@383
;1453 
;1454   for (;;)  {
@436:
@437:
	.debug	< @437 @438
@439:
;1455     if (readQueue == &sleepQueue)  {
@442:
	.debug	< @442 @443
	.debug	# 1455
	ld	hl,_sleepQueue
	ex	de,hl
	ld	hl,(ix-15)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@444
;1456       current->sleepTicks = 1;  current->sleepStarted = GetMS(); }
@445:
	.debug	< @445 @446
	.debug	# 1456
	ld	hl,(_current)
	ld	de,0xdc
	add	hl,de
	ld	e,0x1
	ld	c,d
	ld	b,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	de
	ld	de,0xe0
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@446:
	.debug	>
;1457 
;1458     prepare_to_wait(readQueue, wqNode, TASK_UNINTERRUPTIBLE);
@444:
	.debug	# 1458
	ld	hl,0x2
	push	hl
	ld	hl,(ix-17)
	push	hl
	ld	hl,(ix-15)
	push	hl
	lcall	$prepare_to_wait
	add	sp,6
;1459 
;1460     if (errno == EAGAIN)  errno = 0;  //tdebug
	.debug	# 1460
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@447
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1461 
;1462     stat = (file->ioFuncs->read)(file->ioDev, inPtr, numBytes-bytesRead, tr
@447:
	.debug	# 1462
	ld	hl,0x1
	push	hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	push	hl
	ld	hl,(ix-9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-2),hl
;1463 
;1464     if (stat > 0)  {
	.debug	# 1464
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@448
	jr	z,@448
;1465       _EnterCritical_();  file->readCount += (ulong)stat;  _ExitCritical_()
@449:
	.debug	< @449 @450
	.debug	# 1465
	ipset	2
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	pop	iy
	pop	af
	push	bc
	push	de
	push	af
	push	iy
	call	__farld4##
	call	__ladd##
	call	__farst4d##
	ipres
;1466       inPtr += (uint)stat;  bytesRead += stat;
	.debug	# 1466
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	add	hl,de
	ld	(ix-9),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(ix-6),hl
;1467     }
@450:
	.debug	>
;1468     else  if ((stat == 0) OR ((stat == -1) AND (errno != EAGAIN)))  {
	jr	@451
@448:
	.debug	# 1468
	ld	hl,(ix-2)
	bool	hl
	jr	z,@452
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@453
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	z,@453
@452:
;1469       file->dontCallRead = true;
@457:
	.debug	< @457 @458
	.debug	# 1469
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;1470       file->rdStat = stat;  file->rdErr = errno;
	.debug	# 1470
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
;1471       break;
	.debug	# 1471
;1472     }
	jr	@440
@458:
	.debug	>
;1473 
;1474     if (bytesRead >= numBytes)  break;
@453:
@451:
	.debug	# 1474
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	call	__icmp##
	jr	nc,@440
;1475 
;1476     if (maxIdleMS < 0)  // indefinite wait for possibility to read more byt
	.debug	# 1476
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@460
;1477       schedule();
	.debug	# 1477
	lcall	$schedule
;1478     else  // block but with a limit on idle (no progress) time
;1479       if (! schedule_timeout(maxIdleTicks))  { errno = ETIME;  break; }
	jr	@461
@460:
	.debug	# 1479
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	lcall	$schedule_timeout
	add	sp,4
	ld	hl,bc
	or	hl,de
	jr	nz,@462
@463:
	.debug	< @463 @464
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@440
@464:
	.debug	>
;1480   }
@462:
@461:
@443:
	.debug	>
;1481 
;1482   finish_wait(readQueue, wqNode);  // set state to RUNNING & free the node
	jp	@439
@440:
@438:
	.debug	>
	.debug	# 1482
	ld	hl,(ix-17)
	push	hl
	ld	hl,(ix-15)
	push	hl
	lcall	$finish_wait
	add	sp,4
;1483 
;1484   file->rdInProgress = 0;
	.debug	# 1484
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;1485 
;1486   if (bytesRead)  stat = bytesRead;
	.debug	# 1486
	ld	hl,(ix-6)
	bool	hl
	jr	z,@465
	ld	hl,(ix-6)
	ld	(ix-2),hl
;1487 
;1488   if (ShowRWCalls)  fprintf(DiagLog, "  read returned: %d\r\n", stat);
@465:
	.debug	# 1488
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@466
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @8+542)
	ld	c,phys @8+542 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1489 
;1490   return stat;
@466:
	.debug	# 1490
	ld	hl,(ix-2)
;1491 }
@383:
	.debug	} @383 1491

@382	equ	17
	ld	sp,ix
	pop	ix
	lret
@384	equ	19
;1492 
;1493 //-------------------------------------------------------------------------
;1494 //  Attempt to read the requested # of bytes from a device.
;1495 //-------------------------------------------------------------------------
;1496 int read(fd_t fd, void *buf, int numBytes)
;1497 {
$read::
	.debug	G $read 77 9
	.debug	{ $read 77 1496 @469 @468
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
	.debug	A buf 7 46
	.debug	A numBytes 9 6
;1498   return readFDEV(_fdToOpenFile_(fd), buf, numBytes, -1);
	.debug	# 1498
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	push	bc
	push	de
	lcall	$readFDEV
	add	sp,12
;1499 }
@468:
	.debug	} @468 1499

@467	equ	0
	pop	ix
	lret
@469	equ	2
;1500 
;1501 
;1502 //-------------------------------------------------------------------------
;1503 //  Attempt to write specified # of bytes to a device.
;1504 //
;1505 //  maxIdleMS determines blocking mode as follows:
;1506 //    < 0: indefinite timeout (i.e. block until done or error)
;1507 //      0: non-blocking:  write as much as possible and return
;1508 //    > 0: max # of ms to wait with no progress
;1509 //
;1510 //  Note that a positive value does NOT place an upper limit on how long th
;1511 //  function will wait to write the specified # of bytes, but rather the ma
;1512 //  time it will wait while NO PROGRESS is being made at writing the bytes.
;1513 //
;1514 //  Note that if non blocking mode is set for the file descriptor then the
;1515 //  maxIdleMS value is ignored (treated as if it were 0)
;1516 //
;1517 //  If a timeout > 0 expires, errno is set to ETIME (regardless of what the
;1518 //  return value is, which could be > 0 if some bytes were written).
;1519 //-------------------------------------------------------------------------
;1520 int writeFDEV(FDEV far *file, void *buf, int numBytes, long maxIdleMS)
;1521 {
$writeFDEV::
	.debug	G $writeFDEV 72 9
	.debug	{ $writeFDEV 72 1520 @472 @471
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-17
	.debug	A file 5 44
	.debug	A buf 9 46
	.debug	A numBytes 11 6
	.debug	A maxIdleMS 13 8
;1522   int  stat, pid, bytesSent;
	.debug	L stat -2 6
	.debug	L pid -4 6
	.debug	L bytesSent -6 6
;1523   bool  nonBlocking;
	.debug	L nonBlocking -7 3
;1524   char  *outPtr;
	.debug	L outPtr -9 43
;1525   ulong  maxIdleTicks = 0;
	.debug	L maxIdleTicks -13 9
	.debug	# 1525
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
	.seg	FARCODE
;1526   WaitQueue  *writeQueue;
	.debug	L writeQueue -15 73
;1527   WaitQueueNode  *wqNode;
	.debug	L wqNode -17 75
;1528 
;1529 
;1530   if (numBytes <= 0)  return 0;
	.debug	# 1530
	ld	hl,(ix+11)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@474
	jr	nc,@473
@474:
	jp	@507
;1531 
;1532   if (!buf)  { errno = EINVAL;  return -1; }
@473:
	.debug	# 1532
	ld	hl,(ix+9)
	bool	hl
	jr	nz,@475
@476:
	.debug	< @476 @477
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@638
@477:
	.debug	>
;1533 
;1534   pid = getpid();
@475:
	.debug	# 1534
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
;1535 
;1536   if (ShowRWCalls)
	.debug	# 1536
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@478
;1537     fprintf(DiagLog, "writeFDEV([%05lX], 0x%04X, %d, %ld)\r\n",
;1538             (ulong)file, buf, numBytes, maxIdleMS);
	.debug	# 1538
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	de,word (phys @8+564)
	ld	c,phys @8+564 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,18
;1539 
;1540   if (!file)  {
@478:
	.debug	# 1540
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@479
;1541     if (ShowRWCalls)  fprintf(DiagLog, "  writeFDEV returned: %d\r\n", -1);
@480:
	.debug	< @480 @481
	.debug	# 1541
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@482
	ld	hl,0xffff
	push	hl
	ld	de,word (phys @8+602)
	ld	c,phys @8+602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1542     return -1;
@482:
	.debug	# 1542
	jp	@637
;1543   }
@481:
	.debug	>
;1544 
;1545 //--- if driver won't return any new data, just return status from last ---
;1546 //--- call to driver ---
;1547   if (file->dontCallWrite)  {  errno = file->wrErr;  return file->wrStat; }
@479:
	.debug	# 1547
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x23
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@483
@484:
	.debug	< @484 @485
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x21
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(_current)
	ld	bc,de
	ld	de,0xb9
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1f
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	jp	@471
@485:
	.debug	>
;1548 
;1549   if (! ((file->flags & O_WRONLY) OR (file->flags & O_RDWR)) )  {
@483:
	.debug	# 1549
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x2
	and	hl,de
	jr	nz,@489
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x2
	and	hl,de
	jr	nz,@489
;1550     errno = EBADF;  return -1; }
@490:
	.debug	< @490 @491
	.debug	# 1550
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@638
@491:
	.debug	>
;1551 
;1552 
;1553   KLOCK();
@489:
	.debug	# 1553
	call	_KLOCK
;1554 
;1555   //finish: all the relavant "flags" values...
;1556   //finish: lots of other details - see recv()/revfrom() man page
;1557 
;1558   if (file->flags & O_NONBLOCK)  maxIdleMS = 0;
	.debug	# 1558
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x20
	and	hl,de
	jr	z,@492
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix+15),hl
	ex	de,hl
	ld	(ix+13),hl
	ex	de,hl
;1559 
;1560   nonBlocking = (!maxIdleMS);
@492:
	.debug	# 1560
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	or	hl,de
	ld	de,0
	jr	nz,@493
	inc	e
@493:
	ld	(ix-7),e
;1561 
;1562   if (maxIdleMS > 0)  maxIdleTicks = msToTicks((ulong)maxIdleMS);
	.debug	# 1562
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	c,@494
	jr	z,@494
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;1563 
;1564 
;1565 //--- is another process in the middle of a write on this file/device? ---
;1566   while (file->wrInProgress)  if (file->wrInProgress != pid)
@494:
@495:
	.debug	# 1566
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@496
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	z,@497
;1567     if (_activeTaskIdx_(file->wrInProgress) >= 0)  {
	.debug	# 1567
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@498
;1568       if (nonBlocking)  { KUNLOCK();  ERRNO = EAGAIN;  return -1; }
@499:
	.debug	< @499 @500
	.debug	# 1568
	ld	a,(ix-7)
	or	a,a
	jr	z,@501
@502:
	.debug	< @502 @503
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@638:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@637
@503:
	.debug	>
;1569       KUNLOCK();  sleepMS(5);  KLOCK();
@501:
	.debug	# 1569
	call	_KUNLOCK
	ld	de,0x5
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
;1570     }
@500:
	.debug	>
;1571 
;1572   if (file->eof)  {
@498:
@497:
	jp	@495
@496:
	.debug	# 1572
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x24
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@504
;1573     KUNLOCK();
@505:
	.debug	< @505 @506
	.debug	# 1573
	call	_KUNLOCK
;1574     if (ShowRWCalls)  fprintf(DiagLog, "  writeFDEV returned: %d\r\n", 0);
	.debug	# 1574
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@507
	bool	hl
	ld	l,h
	push	hl
	ld	de,word (phys @8+602)
	ld	c,phys @8+602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1575     return 0;
@507:
	.debug	# 1575
	bool	hl
	ld	l,h
	jp	@471
;1576   }
@506:
	.debug	>
;1577 
;1578   file->wrInProgress = pid;
@504:
	.debug	# 1578
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
;1579 
;1580   KUNLOCK();
	.debug	# 1580
	call	_KUNLOCK
;1581 
;1582 
;1583   writeQueue = file->waitQueues.writeQueue;
	.debug	# 1583
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-15),hl
;1584 
;1585 //finish:  don't have driver set global errno?  Or push/pop global errno?
;1586 
;1587 //--- if doing a non-blocking write, or the driver directly below this ---
;1588 //--- level does not use wait queues, then simply return the result from --
;1589 //--- the driver (if doing a blocking write, the blocking needs to be ---
;1590 //--- handled by whatever the driver is calling to do the work) ---
;1591   if (nonBlocking OR !writeQueue)  {
	.debug	# 1591
	ld	a,(ix-7)
	or	a,a
	jr	nz,@508
	bool	hl
	jp	nz,@509
@508:
;1592     stat = (file->ioFuncs->write)(file->ioDev, buf, numBytes, nonBlocking);
@510:
	.debug	< @510 @511
	.debug	# 1592
	ld	a,(ix-7)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-2),hl
;1593     if ((stat == 0) OR ((stat < 0) AND (errno != EAGAIN)))  {
	.debug	# 1593
	bool	hl
	jr	z,@512
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@513
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	z,@513
@512:
;1594       file->dontCallWrite = true;
@517:
	.debug	< @517 @518
	.debug	# 1594
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x23
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;1595       file->wrStat = stat;  file->wrErr = errno;
	.debug	# 1595
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1f
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x21
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
;1596     }
@518:
	.debug	>
;1597     if (stat > 0)  {
@513:
	.debug	# 1597
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@519
	jr	z,@519
;1598       _EnterCritical_();  file->writeCount += (ulong)stat;  _ExitCritical_(
@520:
	.debug	< @520 @521
	.debug	# 1598
	ipset	2
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	pop	iy
	pop	af
	push	bc
	push	de
	push	af
	push	iy
	call	__farld4##
	call	__ladd##
	call	__farst4d##
	ipres
@521:
	.debug	>
;1599     if (ShowRWCalls)  fprintf(DiagLog, "  writeFDEV returned: %d\r\n", stat
@519:
	.debug	# 1599
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@522
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @8+602)
	ld	c,phys @8+602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1600     _EnterCritical_();  file->wrInProgress = 0;  _ExitCritical_();
@522:
	.debug	# 1600
	ipset	2
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
	ipres
;1601     return stat;
	.debug	# 1601
	ld	hl,(ix-2)
	jp	@471
;1602   }
@511:
	.debug	>
;1603 
;1604 //--- do blocking write using queue specified by the driver ---
;1605   bytesSent = 0;  outPtr = buf;
@509:
	.debug	# 1605
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	ld	hl,(ix+9)
	ld	(ix-9),hl
;1606 
;1607 //  if (! list_empty(&WQNode.queueList))  {
;1608 //    fprintf(DiagLog, "Already in wait queue!\n");  //tdebug
;1609 //    errno = EDEADLK;  file->wrInProgress = false;  return -1; }
;1610 
;1611 
;1612   if (!(wqNode = alloc_WaitQueueNode()))  return -1;
	.debug	# 1612
	lcall	$alloc_WaitQueueNode
	ld	(ix-17),hl
	bool	hl
	jr	nz,@523
@637:
	ld	hl,0xffff
	jp	@471
;1613 
;1614   for (;;)  {
@523:
@524:
	.debug	< @524 @525
@526:
;1615     if (writeQueue == &sleepQueue)  {
@529:
	.debug	< @529 @530
	.debug	# 1615
	ld	hl,_sleepQueue
	ex	de,hl
	ld	hl,(ix-15)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@531
;1616       current->sleepTicks = 1;  current->sleepStarted = GetMS(); }
@532:
	.debug	< @532 @533
	.debug	# 1616
	ld	hl,(_current)
	ld	de,0xdc
	add	hl,de
	ld	e,0x1
	ld	c,d
	ld	b,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	de
	ld	de,0xe0
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@533:
	.debug	>
;1617 
;1618     prepare_to_wait(writeQueue, wqNode, TASK_UNINTERRUPTIBLE);
@531:
	.debug	# 1618
	ld	hl,0x2
	push	hl
	ld	hl,(ix-17)
	push	hl
	ld	hl,(ix-15)
	push	hl
	lcall	$prepare_to_wait
	add	sp,6
;1619 
;1620     if (errno == EAGAIN)  errno = 0;  //tdebug
	.debug	# 1620
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@534
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1621 
;1622     stat = (file->ioFuncs->write)
@534:
;1623                 (file->ioDev, outPtr, numBytes-bytesSent, true);
	.debug	# 1623
	ld	hl,0x1
	push	hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	push	hl
	ld	hl,(ix-9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-2),hl
;1624 
;1625     if (stat > 0)  {
	.debug	# 1625
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@535
	jr	z,@535
;1626       _EnterCritical_();  file->writeCount += (ulong)stat;  _ExitCritical_(
@536:
	.debug	< @536 @537
	.debug	# 1626
	ipset	2
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	pop	iy
	pop	af
	push	bc
	push	de
	push	af
	push	iy
	call	__farld4##
	call	__ladd##
	call	__farst4d##
	ipres
;1627       outPtr += (uint)stat;  bytesSent += stat;
	.debug	# 1627
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	add	hl,de
	ld	(ix-9),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(ix-6),hl
;1628     }
@537:
	.debug	>
;1629     else  {
	jr	@538
@535:
;1630       if ((stat == 0) OR ((stat == -1) AND (errno != EAGAIN)))  {
@539:
	.debug	< @539 @540
	.debug	# 1630
	ld	hl,(ix-2)
	bool	hl
	jr	z,@541
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@542
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	z,@542
@541:
;1631         file->dontCallWrite = true;
@546:
	.debug	< @546 @547
	.debug	# 1631
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x23
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;1632         file->wrStat = stat;  file->wrErr = errno;
	.debug	# 1632
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1f
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix+5)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x21
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
;1633         break;
	.debug	# 1633
;1634       }
	jr	@527
@547:
	.debug	>
;1635     }
@542:
@540:
	.debug	>
;1636 
;1637     if (bytesSent >= numBytes)  break;
@538:
	.debug	# 1637
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	call	__icmp##
	jr	nc,@527
;1638 
;1639     if (maxIdleMS < 0)  // indefinite wait for possibility to write more by
	.debug	# 1639
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@549
;1640       schedule();
	.debug	# 1640
	lcall	$schedule
;1641     else  // block but with a limit on idle (no progress) time
;1642       if (! schedule_timeout(maxIdleTicks))  {
	jr	@550
@549:
	.debug	# 1642
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	lcall	$schedule_timeout
	add	sp,4
	ld	hl,bc
	or	hl,de
	jr	nz,@551
;1643         stat = -1;  errno = ETIME;  break; }
@552:
	.debug	< @552 @553
	.debug	# 1643
	ld	hl,0xffff
	ld	(ix-2),hl
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@527
@553:
	.debug	>
;1644   }
@551:
@550:
@530:
	.debug	>
;1645 
;1646   finish_wait(writeQueue, wqNode);  // set state to RUNNING & free the node
	jp	@526
@527:
@525:
	.debug	>
	.debug	# 1646
	ld	hl,(ix-17)
	push	hl
	ld	hl,(ix-15)
	push	hl
	lcall	$finish_wait
	add	sp,4
;1647 
;1648   file->wrInProgress = 0;
	.debug	# 1648
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1d
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;1649 
;1650   if (bytesSent)  stat = bytesSent;
	.debug	# 1650
	ld	hl,(ix-6)
	bool	hl
	jr	z,@554
	ld	hl,(ix-6)
	ld	(ix-2),hl
;1651 
;1652   if (ShowRWCalls)  fprintf(DiagLog, "  writeFDEV returned: %d\r\n", stat);
@554:
	.debug	# 1652
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@555
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @8+602)
	ld	c,phys @8+602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1653 
;1654   return stat;
@555:
	.debug	# 1654
	ld	hl,(ix-2)
;1655 }
@471:
	.debug	} @471 1655

@470	equ	17
	ld	sp,ix
	pop	ix
	lret
@472	equ	19
;1656 
;1657 
;1658 //-------------------------------------------------------------------------
;1659 //  Attempt to write specified # of bytes to a device.
;1660 //-------------------------------------------------------------------------
;1661 int write(fd_t fd, void *buf, int numBytes)
;1662 {
$write::
	.debug	G $write 77 9
	.debug	{ $write 77 1661 @558 @557
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
	.debug	A buf 7 46
	.debug	A numBytes 9 6
;1663   return writeFDEV(_fdToOpenFile_(fd), buf, numBytes, -1);
	.debug	# 1663
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	push	bc
	push	de
	lcall	$writeFDEV
	add	sp,12
;1664 }
@557:
	.debug	} @557 1664

@556	equ	0
	pop	ix
	lret
@558	equ	2
;1665 
;1666 
;1667 //-------------------------------------------------------------------------
;1668 //  Reposition a file offset
;1669 //-------------------------------------------------------------------------
;1670 off_t lseek(fd_t fd, off_t offset, int whence)
;1671 {
$lseek::
	.debug	G $lseek 78 9
	.debug	{ $lseek 78 1670 @561 @560
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A fd 5 6
	.debug	A offset 7 9
	.debug	A whence 11 6
;1672   off_t  stat;
	.debug	L stat -4 9
;1673   FDEV far  *file;
	.debug	L file -8 44
;1674 
;1675 
;1676   if (! (file = _fdToOpenFile_(fd)))  return -1;
	.debug	# 1676
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@562
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@560
;1677 
;1678   stat = (file->ioFuncs->lseek)(file->ioDev, offset, whence);
@562:
	.debug	# 1678
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,de
	ld	de,0x6
	ex	de,hl
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1679 
;1680   if (stat != (off_t)-1)  file->dontCallRead = false;
	.debug	# 1680
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	z,@563
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x18
	ld	c,d
	ld	b,d
	call	__ladd##
	xor	a,a
	call	__farst1##
;1681 
;1682   return stat;
@563:
	.debug	# 1682
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;1683 }
@560:
	.debug	} @560 1683

@559	equ	8
	ld	sp,ix
	pop	ix
	lret
@561	equ	10
;1684 
;1685 
;1686 //-------------------------------------------------------------------------
;1687 //  return information about an open file descriptor
;1688 //-------------------------------------------------------------------------
;1689 int fstat(int fd, struct stat *fsbuf)
;1690 {
$fstat::
	.debug	G $fstat 79 9
	.debug	{ $fstat 79 1689 @566 @565
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A fd 5 6
	.debug	A fsbuf 7 80
;1691   FDEV far  *file;
	.debug	L file -4 44
;1692   int  stat;
	.debug	L stat -6 6
;1693 
;1694 
;1695   if (! fsbuf)  { ERRNO = EFAULT;  return -1; }
	.debug	# 1695
	ld	hl,(ix+7)
	bool	hl
	jr	nz,@567
@568:
	.debug	< @568 @569
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xe
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@636
@569:
	.debug	>
;1696 
;1697   memset(fsbuf, 0, sizeof(struct stat));
@567:
	.debug	# 1697
	ld	hl,0x2a
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memset
	add	sp,6
;1698 
;1699   if (! (file = _fdToOpenFile_(fd)))  return -1;
	.debug	# 1699
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@570
@636:
	ld	hl,0xffff
	jr	@565
;1700 
;1701   stat = (file->ioFuncs->fstat)(file->ioDev, fsbuf);
@570:
	.debug	# 1701
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,de
	ld	de,0x8
	ex	de,hl
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,4
	ld	(ix-6),hl
;1702 
;1703   return stat;
	.debug	# 1703
;1704 }
@565:
	.debug	} @565 1704

@564	equ	6
	ld	sp,ix
	pop	ix
	lret
@566	equ	8
;1705 
;1706 
;1707 //-------------------------------------------------------------------------
;1708 //  return information about specified file name
;1709 //-------------------------------------------------------------------------
;1710 int stat(const char *fileName, struct stat *fsbuf)
;1711 {
$stat::
	.debug	G $stat 82 9
	.debug	{ $stat 82 1710 @573 @572
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A fileName 5 43
	.debug	A fsbuf 7 80
;1712   fd_t  fd;
	.debug	L fd -2 6
;1713   int  status;
	.debug	L status -4 6
;1714 
;1715 
;1716   if ((fd = open(fileName, O_RDONLY, 0)) < 0)  return -1;
	.debug	# 1716
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@574
	ld	hl,0xffff
	jr	@572
;1717 
;1718   status = fstat(fd, fsbuf);  close(fd);
@574:
	.debug	# 1718
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fstat
	add	sp,4
	ld	(ix-4),hl
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
;1719 
;1720   return status;
	.debug	# 1720
	ld	hl,(ix-4)
;1721 }
@572:
	.debug	} @572 1721

@571	equ	4
	ld	sp,ix
	pop	ix
	lret
@573	equ	6
;1722 
;1723 
;1724 //-------------------------------------------------------------------------
;1725 //  delete a name and possibly the file it refers to
;1726 //-------------------------------------------------------------------------
;1727 int unlink(char const *path)
;1728 {
$unlink::
	.debug	G $unlink 83 9
	.debug	{ $unlink 83 1727 @577 @576
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A path 5 43
;1729   const FileSysFuncs *fsf;
	.debug	L fsf -2 36
;1730 
;1731   fsf = drvFuncs(path);  if (!fsf)  { ERRNO = ENOENT;  return -1; }
	.debug	# 1731
	ld	hl,(ix+5)
	push	hl
	lcall	$drvFuncs
	pop	de
	ld	(ix-2),hl
	bool	hl
	jr	nz,@578
@579:
	.debug	< @579 @580
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@576
@580:
	.debug	>
;1732 
;1733   return fsf->unlink((char *)path);
@578:
	.debug	# 1733
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xa
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	pop	de
;1734 }
@576:
	.debug	} @576 1734

@575	equ	2
	ld	sp,ix
	pop	ix
	lret
@577	equ	4
;1735 
;1736 //-------------------------------------------------------------------------
;1737 //  User-space func to rename a file
;1738 //-------------------------------------------------------------------------
;1739 int rename(const char *oldPath, const char *newPath)
;1740 {
$rename::
	.debug	G $rename 84 9
	.debug	{ $rename 84 1739 @583 @582
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A oldPath 5 43
	.debug	A newPath 7 43
;1741   const FileSysFuncs  *fsf;
	.debug	L fsf -2 36
;1742 
;1743   fsf = drvFuncs(oldPath);  if (!fsf)  { ERRNO = ENOENT;  return -1; }
	.debug	# 1743
	ld	hl,(ix+5)
	push	hl
	lcall	$drvFuncs
	pop	de
	ld	(ix-2),hl
	bool	hl
	jr	nz,@584
@585:
	.debug	< @585 @586
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	jr	@635
@586:
	.debug	>
;1744   if (fsf != drvFuncs(newPath))  { ERRNO = EXDEV;  return -1; }
@584:
	.debug	# 1744
	ld	hl,(ix+7)
	push	hl
	lcall	$drvFuncs
	pop	de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@587
@588:
	.debug	< @588 @589
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x12
@635:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@582
@589:
	.debug	>
;1745 
;1746   return fsf->rename(oldPath, newPath);
@587:
	.debug	# 1746
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xc
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,4
;1747 }
@582:
	.debug	} @582 1747

@581	equ	2
	ld	sp,ix
	pop	ix
	lret
@583	equ	4
;1748 
;1749 
;1750 //-------------------------------------------------------------------------
;1751 //  Modify date/time stamps on a file
;1752 //-------------------------------------------------------------------------
;1753 int utime(const char *fileName, const struct utimbuf *buf)
;1754 {
$utime::
	.debug	G $utime 85 9
	.debug	{ $utime 85 1753 @592 @591
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fileName 5 43
	.debug	A buf 7 86
;1755 //finish - handle other names besides just flash file names
;1756 
;1757   return  ffile_utime(fileName, buf);
	.debug	# 1757
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_utime
	add	sp,4
;1758 }
@591:
	.debug	} @591 1758

@590	equ	0
	pop	ix
	lret
@592	equ	2
;1759 
;1760 //-------------------------------------------------------------------------
;1761 //  Set or read options for a file descriptor
;1762 //-------------------------------------------------------------------------
;1763 int fcntl(fd_t fd, int cmd, int arg)
;1764 {
$fcntl::
	.debug	G $fcntl 88 9
	.debug	{ $fcntl 88 1763 @595 @594
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A fd 5 6
	.debug	A cmd 7 6
	.debug	A arg 9 6
;1765   int  stat;
	.debug	L stat -2 6
;1766   FDEV far  *file;
	.debug	L file -6 44
;1767 
;1768 
;1769   if (! (file = _fdToOpenFile_(fd)))  return -1;
	.debug	# 1769
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@596
	ld	hl,0xffff
	jr	@594
;1770 
;1771   KLOCK();
@596:
	.debug	# 1771
	call	_KLOCK
;1772 
;1773   switch (cmd)  {
	.debug	# 1773
	ld	hl,(ix+7)
	jr	@597
;1774     case F_GETFL:  // get flags
@599:
	.debug	< @599 @600
;1775       stat = file->flags;  KUNLOCK();  return stat;
	.debug	# 1775
@601:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	call	_KUNLOCK
	ld	hl,(ix-2)
	jr	@594
;1776 
;1777     case F_SETFL:  // set flags
;1778       file->flags = arg;  KUNLOCK();  return 0;
	.debug	# 1778
@602:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+9)
	call	__farst2##
	call	_KUNLOCK
	bool	hl
	ld	l,h
	jr	@594
;1779   }
@600:
	.debug	>
;1780 
;1781   KUNLOCK();  ERRNO = EINVAL;  return -1;  // unsupported cmd value
@597:
	ex	de,hl
	ld	hl,0xfffffffd
	add	hl,de
	bool	hl
	jr	z,@601
	ld	hl,0xfffffffc
	add	hl,de
	bool	hl
	jr	z,@602
@598:
	.debug	# 1781
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;1782 }
@594:
	.debug	} @594 1782

@593	equ	6
	ld	sp,ix
	pop	ix
	lret
@595	equ	8
;1783 
;1784 
;1785 //-------------------------------------------------------------------------
;1786 //  Set or read options for a file descriptor
;1787 //-------------------------------------------------------------------------
;1788 int ioctl(int fd, int request, void *arg)
;1789 {
$ioctl::
	.debug	G $ioctl 89 9
	.debug	{ $ioctl 89 1788 @605 @604
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A fd 5 6
	.debug	A request 7 6
	.debug	A arg 9 46
;1790   FDEV far  *file;
	.debug	L file -4 44
;1791 
;1792 
;1793   if (! (file = _fdToOpenFile_(fd)))  return -1;
	.debug	# 1793
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@606
	ld	hl,0xffff
	jr	@604
;1794 
;1795   return (file->ioFuncs->ioctl)(file->ioDev, request, arg);
@606:
	.debug	# 1795
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,de
	ld	de,0xa
	ex	de,hl
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,6
;1796 }
@604:
	.debug	} @604 1796

@603	equ	4
	ld	sp,ix
	pop	ix
	lret
@605	equ	6
;1797 
;1798 
;1799 //-------------------------------------------------------------------------
;1800 //  Duplicate a file descriptor
;1801 //
;1802 //  If fromFD does not refer to an open file, then an error is returned.
;1803 //  If toFD refers to an open file different than fromFD, then toFD is firs
;1804 //  closed.
;1805 //  Returns fromFD on succcess, -1 if an error (and errno is set)
;1806 //-------------------------------------------------------------------------
;1807 fd_t dup2(fd_t fromFD, fd_t toFD)
;1808 {
$dup2::
	.debug	G $dup2 90 9
	.debug	{ $dup2 90 1807 @609 @608
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A fromFD 5 6
	.debug	A toFD 7 6
;1809   FDEV far  *fromFile, *toFile;
	.debug	L fromFile -4 44
	.debug	L toFile -8 44
;1810   FDEV far  **myFDs;
	.debug	L myFDs -10 64
;1811 
;1812 
;1813 //--- make sure fromFD and toFD are valid descriptor #'s ---
;1814   if ((fromFD < 0) OR (fromFD >= FD_SETSIZE)
;1815      OR (toFD < 0) OR (toFD >= FD_SETSIZE))  { ERRNO = EBADF;  return -1; }
	.debug	# 1815
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@610
	ld	hl,(ix+5)
	ld	e,0x10
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@610
	ld	hl,(ix+7)
	ld	e,0
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@610
	ld	hl,(ix+7)
	ld	e,0x10
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@611
@610:
@612:
	.debug	< @612 @613
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@634
@613:
	.debug	>
;1816 
;1817   KLOCK();
@611:
	.debug	# 1817
	call	_KLOCK
;1818 
;1819   myFDs = FD[userPix];
	.debug	# 1819
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	(ix-10),hl
;1820 
;1821   fromFile = myFDs[fromFD];  toFile = myFDs[toFD];
	.debug	# 1821
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+7)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;1822 
;1823 //--- make sure fromFD points to a an entry for an open device ---
;1824   if (! fromFile)  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 1824
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@614
@615:
	.debug	< @615 @616
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@634:
	ld	e,0x9
	jr	@633
@616:
	.debug	>
;1825   if (fromFile->openCount < 1)  { KUNLOCK();  ERRNO = EBADF;  return -1; }
@614:
	.debug	# 1825
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farld2##
	ld	hl,0x8001
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@617
@618:
	.debug	< @618 @619
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
@633:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@608
@619:
	.debug	>
;1826 
;1827 //--- if toFD already points to the same file as fromFD, we are done ---
;1828   if (toFile == fromFile)   { KUNLOCK();  return toFD; }
@617:
	.debug	# 1828
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fpcmp##
	jr	nz,@620
@621:
	.debug	< @621 @622
	call	_KUNLOCK
	ld	hl,(ix+7)
	jr	@608
@622:
	.debug	>
;1829 
;1830 //--- if toFD points to an open file, close it first ---
;1831   if (toFile)  _closeFD_(current, toFD);
@620:
	.debug	# 1831
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@623
	ld	hl,(ix+7)
	push	hl
	ld	hl,(_current)
	push	hl
	lcall	$_closeFD_
	add	sp,4
;1832 
;1833 //--- set toFD to point to the same file as fromFD and increment the ---
;1834 //--- file's openCount ---
;1835   myFDs[toFD] = myFDs[fromFD];  ++fromFile->openCount;
@623:
	.debug	# 1835
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+7)
	add	hl,hl
	add	hl,hl
	push	de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
;1836 
;1837   KUNLOCK();  return toFD;
	.debug	# 1837
	call	_KUNLOCK
	ld	hl,(ix+7)
;1838 }
@608:
	.debug	} @608 1838

@607	equ	10
	ld	sp,ix
	pop	ix
	lret
@609	equ	12
;1839 
;1840 
;1841 //=========================================================================
;1842 //                       conventional stdio type functions
;1843 //=========================================================================
;1844 
;1845 //-------------------------------------------------------------------------
;1846 //  User-space func to flush the output buffer for a FILE stream
;1847 //-------------------------------------------------------------------------
;1848 int fflush(FILE *stream)
;1849 {
$fflush::
	.debug	G $fflush 91 9
	.debug	{ $fflush 91 1848 @626 @625
	ld	hl,-136
	call	__fent##
	.debug	A stream 5 92
;1850   int  count, saveFlags;
	.debug	L count -2 6
	.debug	L saveFlags -4 6
;1851   FDEV far *file;
	.debug	L file -8 44
;1852   char  buf[StdOutBufSize];
	.debug	L buf -136 94
;1853 
;1854 
;1855   if (stream != _stdio)  { ERRNO = EBADF;  return EOF; }
	.debug	# 1855
	ld	hl,(__stdio)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@627
@628:
	.debug	< @628 @629
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@632
@629:
	.debug	>
;1856 
;1857   count = current->outCount;
@627:
	.debug	# 1857
	ld	hl,(_current)
	ld	de,0xd7
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-2),hl
;1858 
;1859   if (count < 1)  return 0;
	.debug	# 1859
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@630
	bool	hl
	ld	l,h
	jp	@625
;1860 
;1861   if (! (file = _fdToOpenFile_(1)))  return -1;
@630:
	.debug	# 1861
	ld	hl,0x1
	push	hl
	lcall	$_fdToOpenFile_
	pop	hl
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@631
@632:
	ld	hl,0xffff
	jp	@625
;1862 
;1863   fmemcpy(buf, outBuf[(uint)userPix], count);
@631:
	.debug	# 1863
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(_userPix)
	ex	de,hl
	ld	bc,0
	ld	a,0x7
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _outBuf)
	ld	c,phys _outBuf >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,-128+@624
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;1864 
;1865   saveFlags = file->flags;  file->flags &= ~O_NONBLOCK;
	.debug	# 1865
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld2##
	res	5,e
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
;1866   write_(1, buf, count, -1);
	.debug	# 1866
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	ld	hl,-130+@624
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write_
	add	sp,10
;1867   file->flags = saveFlags;
	.debug	# 1867
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
;1868 
;1869   current->outCount = 0;  current->outPtr = outBuf[(uint)userPix];
	.debug	# 1869
	ld	hl,(_current)
	ld	de,0xd7
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(_userPix)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x7
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _outBuf)
	ld	c,phys _outBuf >> 16
	call	__ladd##
	ld	hl,(_current)
	push	de
	ld	de,0xd8
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1870 
;1871   return 0;
	.debug	# 1871
	bool	hl
	ld	l,h
;1872 }
@625:
	.debug	} @625 1872

@624	equ	136
	ld	sp,ix
	pop	ix
	lret
@626	equ	138
;1873 
;1874 
;1875 
;1876 //-------------------------------------------------------------------------
;1877 
	.extern	_memset 95
	.extern	_strcmp 84
	.extern	_strlen 83
	.extern	_strncmp 96
	.extern	$fmemcpy 97
	.extern	_fmemset 99
	.extern	$logStdout 100
	.extern	$localtime_r 101
	.extern	$write_ 103
	.extern	_cllCmd 104
	.extern	$prepare_to_wait 105
	.extern	$finish_wait 106
	.extern	$alloc_WaitQueueNode 107
	.extern	__disabled 3
	.extern	_tasks 108
	.extern	_current 57
	.extern	_userPix 6
	.extern	_applTask 57
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 39
	.extern	$schedule_timeout 109
	.extern	__stdio 92
	.extern	$farfprintf 110
	.extern	$farprintf 111
	.extern	$farsprintf 112
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 113
	.extern	$SerialSendCountA 114
	.extern	_SerialPutcA 62
	.extern	$registerFileSystems 39
	.defseg	FARBSS
	.seg	FARBSS
_fileTbl::
	.ds	2496
	.debug	G _fileTbl 115 8
	.bseg
_FD::
	.ds	1280
	.debug	G _FD 116 0
_diagLogInfo::
	.ds	4
	.debug	G _diagLogInfo 118 0
_DiagLogSize::
	.ds	2
	.debug	G _DiagLogSize 7 0
_diagLogBuf::
	.ds	4
	.debug	G _diagLogBuf 120 0
	.cseg
_rcvChar:
	pop	iy
	lcall	$$rcvChar
_xmitChar:
	pop	iy
	lcall	$$xmitChar
_diagIn:
	pop	iy
	lcall	$$diagIn
_diagOut:
	pop	iy
	lcall	$$diagOut
	.extern	$klockErr 121
	.extern	_KLOCK 39
	.extern	_KUNLOCK 39
	.extern	_outBuf 122
	.extern	$_activeTaskIdx_ 62
	.extern	_osDTM 123
	.extern	_diagLog 93
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_sleepQueue 74
	.extern	$sleepMS 124
	.extern	$msToTicks 124
	.extern	$Exit 125
	.extern	$ffile_utime 85
	.extern	_applName 104
	.extern	_applDTM 104
	.extern	$fifoInit_ 39
	.bseg
_fileSysFuncs::
	.ds	16
	.debug	G _fileSysFuncs 126 0
	.debug	T	0900012000240021000600
	.debug	T	32000321000600030001002B00000007707265666978002B000200
	.debug	T	0B6472697665724E616D65002400040008667346756E637300
	.debug	T	070002220000000100
	.debug	T	0B000223000100060024000000
	.debug	T	070000240002002500
	.debug	T	57000325000E00070001002B000000056E616D65002F0002000869
	.debug	T	6F46756E6373007F000400057469636B008000060006656E74
	.debug	T	72790082000800056F70656E0083000A0007756E6C696E6B00
	.debug	T	84000C000772656E616D6500
	.debug	T	070000260002002400
	.debug	T	0B000227000100010001000000
	.debug	T	0B000228000100070029000000
	.debug	T	070000290002000700
	.debug	T	1300022A0003000100030000002B00020006000400
	.debug	T	0700002B0002000300
	.debug	T	0700082C0004002D00
	.debug	T	0B01032D00270013000100060000000A6F70656E436F756E74002F
	.debug	T	00020008696F46756E6373002E00040006696F446576008500
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	0700002E0002000100
	.debug	T	0700002F0002003000
	.debug	T	640003300010000800010086000000057265616400860002000677
	.debug	T	72697465008800040006636C6F73650089000600066C736565
	.debug	T	6B008B000800066673746174008D000A0006696F63746C008F
	.debug	T	000C000664657363720091000E000A67657451756575657300
	.debug	T	2400033100030002000100060000000A6F70656E436F756E740003
	.debug	T	00020007756E7573656400
	.debug	T	0900013200080003000800
	.debug	T	0900013300280034001400
	.debug	T	0900013400020003000200
	.debug	T	0B00023500010006002E000000
	.debug	T	0B000236000100010003000000
	.debug	T	0F0002370002000600030000002E000200
	.debug	T	7E000338001200090003746D000600000007746D5F736563000600
	.debug	T	020007746D5F6D696E000600040008746D5F686F7572000600
	.debug	T	060008746D5F6D646179000600080007746D5F6D6F6E000600
	.debug	T	0A0008746D5F796561720006000C0008746D5F776461790006
	.debug	T	000E0008746D5F79646179000600100009746D5F6973647374
	.debug	T	00
	.debug	T	070000390002003A00
	.debug	T	7702033A00E8002D000C7461736B5F737472756374002900000006
	.debug	T	737461636B00290002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720093000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465003900150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630094001A000561726776005E001C0005617267
	.debug	T	73004A009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773009500B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74007800D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0900013B00400003004000
	.debug	T	0B00023C00010024002B000000
	.debug	T	0F00023D00020001000600000003000200
	.debug	T	0B00023E000100060006000000
	.debug	T	0F00023F00020006000700000006000200
	.debug	T	070000400002002C00
	.debug	T	0B00024100010003002C000000
	.debug	T	0B00024200010006002C000000
	.debug	T	130002430003000600060000002F0002002E000400
	.debug	T	0B0002440001002C0006000000
	.debug	T	0F00024500020006002C0000002C000400
	.debug	T	0F00024600020006003900000006000200
	.debug	T	1300024700030006002B0000000600020006000400
	.debug	T	1700024800040006002C0000002E0004000600060008000800
	.debug	T	070000490002004A00
	.debug	T	2800034A0004000100125F5F776169745F71756575655F68656164
	.debug	T	0097000000096C6973744865616400
	.debug	T	0700004B0002004C00
	.debug	T	7100034C0012000700125F5F776169745F71756575655F6E6F6465
	.debug	T	000700000006666C6167730039000200057461736B002E0004
	.debug	T	00046F626A00980006000B72656D6F766546756E6300970008
	.debug	T	00097461736B4C6973740097000C000A71756575654C697374
	.debug	T	002E001000076D794164647200
	.debug	T	1300024D0003000600060000002E00020006000400
	.debug	T	1300024E0003000900060000000900020006000600
	.debug	T	0F00024F00020006000600000050000200
	.debug	T	070000500002005100
	.debug	T	BB000351002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	0F00025200020006002B00000050000200
	.debug	T	0B00025300010006002B000000
	.debug	T	0F00025400020006002B0000002B000200
	.debug	T	0F00025500020006002B00000056000200
	.debug	T	070000560002005700
	.debug	T	290003570008000200087574696D62756600090000000761637469
	.debug	T	6D650009000400086D6F6474696D6500
	.debug	T	130002580003000600060000000600020006000400
	.debug	T	13000259000300060006000000060002002E000400
	.debug	T	0F00025A00020006000600000006000200
	.debug	T	0B00025B00010006005C000000
	.debug	T	0700005C0002005D00
	.debug	T	5400035D000C00060001009A000000065F5F6F7574008800020005
	.debug	T	5F5F696E009B000400085F5F7772697465009B000600075F5F
	.debug	T	726561640006000800085F5F756E676574002E000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0900015E00800003008000
	.debug	T	1300025F0003002E002E0000000600020007000400
	.debug	T	1300026000030006002B0000002B00020007000400
	.debug	T	130002610003006200620000006200040009000800
	.debug	T	070008620004000100
	.debug	T	130002630003006200620000000600040009000600
	.debug	T	0B000264000100060001000000
	.debug	T	0F00026500020066009D00000066000200
	.debug	T	070000660002003800
	.debug	T	170002670004000600060000002E0002000600040008000600
	.debug	T	0900016800000003000000
	.debug	T	130002690003000100490000004B00020006000400
	.debug	T	0F00026A0002000100490000004B000200
	.debug	T	0B00026B0001004B0001000000
	.debug	T	0900016C0000003A000000
	.debug	T	0B00026D000100080008000000
	.debug	T	1300026E00030006005C000000780002000D000000
	.debug	T	0F00026F0002000600780000000D000000
	.debug	T	13000270000300060078000000780004000D000000
	.debug	T	0900017100080009000200
	.debug	T	0B000272000100070001000000
	.debug	T	0900017300C0092D004000
	.debug	T	0900017400000575001400
	.debug	T	090001750040002C001000
	.debug	T	070008760004007700
	.debug	T	2701037700F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D65009E001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B6579009F0085000866696C6C65723200
	.debug	T	070008780004000300
	.debug	T	0B000279000100010078000000
	.debug	T	0900017A00000A5E001400
	.debug	T	0900017B00200003002000
	.debug	T	0B00027C000100090009000000
	.debug	T	0B00027D000100010006000000
	.debug	T	0900017E00100024000800
	.debug	T	0700007F0002002700
	.debug	T	070000800002008100
	.debug	T	0F0002810002002E0007000000A0000200
	.debug	T	070000820002004700
	.debug	T	070000830002005300
	.debug	T	070000840002005400
	.debug	T	2800038500040002000100490000000A7265616451756575650049
	.debug	T	0002000B7772697465517565756500
	.debug	T	070000860002008700
	.debug	T	1700028700040006002E0000002B0002000600040003000600
	.debug	T	070000880002003500
	.debug	T	070000890002008A00
	.debug	T	1300028A00030009002E0000000900020006000600
	.debug	T	0700008B0002008C00
	.debug	T	0F00028C00020006002E00000050000200
	.debug	T	0700008D0002008E00
	.debug	T	1300028E00030006002E000000060002002E000400
	.debug	T	0700008F0002009000
	.debug	T	130002900003002B002E0000002B00020006000400
	.debug	T	070000910002009200
	.debug	T	0F00029200020006002E000000A1000200
	.debug	T	070000930002006200
	.debug	T	070000940002002B00
	.debug	T	070000950002009600
	.debug	T	0F00029600020001000600000094000200
	.debug	T	2600039700040002000A6C6973745F6865616400A2000000056E65
	.debug	T	787400A2000200057072657600
	.debug	T	070000980002009900
	.debug	T	0B00029900010001004B000000
	.debug	T	0700009A0002003700
	.debug	T	0700009B0002009C00
	.debug	T	1300029C000300080078000000080004002E000800
	.debug	T	0700009D0002000900
	.debug	T	0900019E00500003005000
	.debug	T	0900019F00740003007400
	.debug	T	070000A00002003100
	.debug	T	070008A10004008500
	.debug	T	070000A20002009700
	.defseg	CONST
	.seg	CONST
@1:
	.db	0,"flashFile",0,"fifo",0,"/srfs/",0,"srfs",0,"/dev/tty",0,"serial",0,"/dev/ttyx",0,"/dev/spi",0,"crash-log",0
	.defseg	FARCONST
	.seg	FARCONST
@8:
	.db	"  Registering file system: %.32s",13,10,0,"checking fsf[%u] (%.32s)%s",13,10,0,"  [%2u]: %2u refs:  %"
	.db	".100s%s",13,10,0,"PID %5d:  fd[%u]:  Invalid fd%s",13,10,0,"Orphaned global fd[%d]: %.128%s",0,13,10,"======="
	.db	"==============================================================",13,10,0,13,10,"  RTOS: %.40ls",13,10,"  "
	.db	"APPL: %.40ls  %.40ls",13,10,13,10,0,"%04d-%02d-%02d %02d:%02d:%02d.%03d %.24s[%d]: ",0,"pid: %d: setI"
	.db	"stty(%d, %d)",13,10,0,"_addFileRef_",0,"_allocFile_",0,"_File_Swap_",0,"close fd %d for [%d](%s), openCou"
	.db	"nts: %d",10,0,"open('%.*s', 0x%04x, 0%03o)",10,0,"failed open [%.32s] using [%.32s]",13,10,0,"close(%d)",10,0
	.db	"readFDEV([%05lX], 0x%04X, %d)",13,10,0,"  read returned: %d",13,10,0,"writeFDEV([%05lX], 0x%04X, %d, "
	.db	"%ld)",13,10,0,"  writeFDEV returned: %d",13,10,0
	.end
