	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\daemons\modbus.c' 22 2 11 7 12 32
;1 //----- modbus.c ----- 12/05/12 -----(05/08/06)-----
;2 
;3 // based on earlier work for ZWorld/Rabbit-based controllers
;4 
;5 //  Application-specific register definitions are in the application source
;6 //  file  (in the application-specific directory)
;7 
;8 //-------------------------------------------------------------------------
;9 //  Update log (most recent first):
;10 //
;11 //
;12 //  2012-12-05 - Mark Davis
;13 //               - Moved MB_cmdBitsStd() and MB_timeZone() from modbus.c
;14 //                 to sharedApplic.c
;15 //
;16 //  2012-10-02 - Mark Davis
;17 //               - perror() rather than printf() is now used to log the err
;18 //                 when reading the start of the next modbus cmd times out.
;19 //                 This may provide more information about why these TCP
;20 //                 connections often fail during a restart of an EPICS SIOC
;21 //
;22 //  2012-07-18 - Mark Davis
;23 //               - Changes to PV_Desc and related macros to support locking
;24 //                 and PVs without a separate read buffer.
;25 //
;26 //  2012-05-31 - Mark Davis
;27 //               - pvCheckAllEvents() now limits the # of non-register PV
;28 //                 events based on the total # of bytes those events repres
;29 //
;30 //  2012-03-27 - Mark Davis
;31 //               - Began changes to support PV types defined by structures
;32 //                 other then RegInfo.
;33 //
;34 //  2012-02-23 - Mark Davis
;35 //               - Added the anyChg option to pvCheckAllEvents(), which all
;36 //                 the use of the much faster mode of checking for ANY chan
;37 //                 in the value of the PVs (compared to computing what the
;38 //                 change was and comparing it to the minChg setting for th
;39 //                 PVs).
;40 //
;41 //  2012-02-23 - Mark Davis
;42 //               - A list of pointers to PV's is now created and sorted by 
;43 //                 The index in to this array is now used as the ID for eac
;44 //                 This allows us to do a binary search when looking for a 
;45 //                 by name, which makes pvGetID() faster (which is importan
;46 //                 for the CA protocol which has very short timeouts).
;47 //
;48 //  2012-02-14 - Mark Davis
;49 //               - Changed references to pid in the PV functions to just id
;50 //                 to avoid confusion with process IDs.  For the same reaso
;51 //                 I made the following func name changes:
;52 //                    pvGetPID() is now pvGetID()
;53 //                    pidToRegInfo() is now pvToRegInfo()
;54 //               - Added temporary code to provide "fake" PVs RTYP, STAT, a
;55 //                 DESC to make Qt CA interface happy.
;56 //
;57 //  2011-05-23 - Mark Davis
;58 //               - Fixed bug in fmtVal() so it handles type S32 properly.
;59 //
;60 //  2011-05-09 - Mark Davis (*)
;61 //               - Made sure all the places that use the RegInfo.setRegFunc
;62 //                 value check to make sure it is not NULL first (although
;63 //                 this shouldn't actually be possible, since the macros th
;64 //                 set them complain if you try to use NULL rather than roR
;65 //                 for read-only 4xxxx registers).
;66 //
;67 //  2011-05-04 - Mark Davis
;68 //               - Logging of messages for writes to registers are now
;69 //                 supressed until startupComplete is true.  Prior to this,
;70 //                 the last change (use of the new restoreIfRegValue() func
;71 //                 would cause the syslog log buffer to overflow during sta
;72 //                 before it could be copied to the server.
;73 //
;74 //  2011-04-22 - Mark Davis
;75 //               - Added restoreIfRegValue() for other modules to call if t
;76 //                 have a value to write to memory that may be a register.
;77 //                 This is now used by the functions in the backup.c module
;78 //                 that restore values from a file.  If no value-specific
;79 //                 restore function is specified, restoreIfRegValue() is ca
;80 //                 to cause the register-specific processing to be invoked 
;81 //                 the value is a register/PV value.  This insures that any
;82 //                 value-specific processing is invoked for regsiter values
;83 //                 that are saved/restored to/from files.
;84 //
;85 //  2011-04-19 - Mark Davis
;86 //               - Added MB_setACoil() and MB_resetACoil()
;87 //
;88 //  2010-12-14 - Mark Davis
;89 //               - Changed _TimerSeconds + secTimerOffset to TIME()
;90 //
;91 //  2010-08-04 - Mark Davis
;92 //               - Added setF32_ABS()
;93 //
;94 //  2010-06-10 - Mark Davis
;95 //               - Changed PID values for pvXXX functions from long to int 
;96 //                 added a pointer to the PV's name to the PV_Info structur
;97 //
;98 //  2010-05-27 - Mark Davis
;99 //               - Added following functions to support EPICS CA/PV interfa
;100 //                   pvCheckAllEvents(), pvCheckEvents()
;101 //
;102 //  2010-05-25 - Mark Davis
;103 //               - Added following functions to support EPICS CA/PV interfa
;104 //                   pvGetPID(), pvGetInfo(), pvGetVal(), pvSetVal()
;105 //
;106 //  2010-01-14 - Mark Davis
;107 //               - Added setMBReg() and setRegXXX() functions to allow code
;108 //                 to change a register value and invoke the change functio
;109 //                 (if any) specified in the definition of the register.
;110 //
;111 //  2009-10-26 - Mark Davis
;112 //               - changes to work with register names ref via far ptr
;113 //
;114 //  2009-10-06 - Mark Davis
;115 //               - Updated call to saveParams() to include new parameter th
;116 //                 tells it to save to flash (which was the only option bef
;117 //
;118 //  2009-04-30 - Mark Davis
;119 //               - modbusScanTables() now returns a value indicating if the
;120 //                 is a problem.
;121 //
;122 //  2008-02-23 - Mark Davis
;123 //               - added global values to support "software oscilliscope"
;124 //                 for real-time capture of register values
;125 //
;126 //  2007-03-20 - Mark Davis
;127 //               - removed all KLOCK()/KUNLOCK() calls in ModBusCmd() for 2
;128 //                 reasons:  It improves concurrency of scheduling, and wri
;129 //                 functions can block on a shared resource which would loc
;130 //                 up the system if the scheduler was disabled.
;131 //
;132 //  2007-02-12 - Mark Davis
;133 //               - removed an extra KUNLOCK() call in ModBusCmd()
;134 //
;135 //  2006-05-08 - Mark Davis
;136 //               - started work on new version for DEBROS base
;137 //
;138 //-------------------------------------------------------------------------
;139 //
;140 //  Module to support standard ModBus register interface.
;141 //
;142 //  The primary goals of this particular implementation:
;143 //
;144 //  1. Using values accessable via the ModBus interface should not affect
;145 //     the complexity, efficiency, or portability of the application code.
;146 //
;147 //  2. Defining the relationship between register #'s and values used in th
;148 //     application must be as simple and straighforward as possible.  Requi
;149 //     additions or changes in multiple places (even within a single file)
;150 //     should be avoided if at all possible.
;151 //
;152 //  3. Ability for multiple instances of a logical device to share a single
;153 //     set of register definitions (i.e. avoid having to define one set of
;154 //     registers for each instance).
;155 //
;156 //  4. Provide a generic diagnostic interface (separate from the ModBus
;157 //     interface itself) for examining and modifying the logical values
;158 //     accessed via the ModBus interface (e.g. if 2 registers map to a
;159 //     4-byte floating-point value, then you should be able to display and/
;160 //     modify the value by giving the name of the floating point value).
;161 //
;162 //-------------------------------------------------------------------------
;163 //
;164 //  When designing this interface I considered 2 basic approaches:
;165 //
;166 //  - Store all register values as a contiguous array of integer values
;167 //    and define a bunch of macros to simplify the application code that
;168 //    needs to access one or more words as a single logical value (for
;169 //    example:   #define FloatValX  (*(float *)intArray+10))
;170 //
;171 //  - Store all values as standard C variables and map the register #'s to
;172 //    the variables.
;173 //
;174 //  The advantage of the 1st method is that implementation of the ModBus
;175 //  interface would (in theory) be simple and efficient, making it more
;176 //  practical to support more or faster ModBus clients.  This was very
;177 //  tempting, but I soon realized there where some problems with this
;178 //  simple approach:
;179 //
;180 //  - Portability:  Referencing an arbitrary location in an array (even an
;181 //    array of 16-bit values) via a pointer to a type that is larger than
;182 //    16 bits can lead to allignment problems (if not outright failure, the
;183 //    at least reducing the CPU's efficiency compared to the same operation
;184 //    on a properly alligned value).  Not a problem on 8-bit, or even 16-bi
;185 //    controllers, but on 32-bit ones, a definite possibility.
;186 //
;187 //  - Byte order:  Different CPU's store values in different byte order,
;188 //    and different ModBus clients expect the bytes or words for multi-word
;189 //    values in different orders.  So simply copying a group of bytes from
;190 //    the array does not result in a usable response for all ModBus clients
;191 //
;192 //  - Increased size and Decreased efficiency of the application code:
;193 //    Having to use pointers to indirectly reference all the values
;194 //    accessable via the ModBus interface requires more code and an added
;195 //    level of indirection.  Best case would be a compiler that supports
;196 //    declaring const pointers and treats dereferenced const pointer values
;197 //    the same as static addresses (i.e. as a reference to a standard varia
;198 //    type).  Don't know how many compilers (if any) could manage this.
;199 //
;200 //  - Definition of the logical values (from the application's view) and
;201 //    the registers are separate tasks.  This requires keeping two
;202 //    interdependant sets of definitions in sync (and we all know how likel
;203 //    that is to cause a problem!).
;204 //
;205 //  - It does absolutely nothing to support the goal of avoiding having one
;206 //    set of register definitions per logical device.
;207 //
;208 //
;209 //  Given the above issues with the "straighforard" approach, and the fact
;210 //  that it still does not help me at all with my goal of a diagnostic
;211 //  interface, I opted for the 2nd approach:  Use standard C variables, at
;212 //  the cost of a (possibly) less efficient ModBus interface.
;213 //
;214 //
;215 //  The methodology I implemented works as follows:
;216 //
;217 //  - All logical values and how they relate to the ModBus register interfa
;218 //    are defined in the application source file.  With just a single line
;219 //    entry for each logical value I was able to handle all the following:
;220 //
;221 //     - Definition and declaration of a standard C variable type
;222 //
;223 //     - A statically initialized structure of information about each value
;224 //       that includes:
;225 //        - the registers encompased by the variable
;226 //        - the variable name
;227 //        - the data type
;228 //        - a pointer to variable
;229 //        - a single set of register definitions that can be used by multip
;230 //          instances of a logical device
;231 //
;232 //     - A statically initialized array of pointers, where each entry in th
;233 //       array corresponds to a single register, and points to the informat
;234 //       structure for the variable that contains the register value (note 
;235 //       multiple entries can point to the same information structure).
;236 //
;237 //     - A single set of register definitions that can be used by multiple
;238 //       instances of a logical device
;239 //
;240 //  The last item allows the ModBus interface to quickly locate (through
;241 //  a few indirections, I admit) the needed register value given the
;242 //  register # and the type of client asking for it.  The client type is
;243 //  important since there is no standard for the register order for logical
;244 //  values composed of mulitple registers (like a 32-bit float or integer).
;245 //
;246 //  To deal with the lack of standard register order, the ModBus interface
;247 //  uses a table to determine how to reorder registers for each combination
;248 //  client type and data type.  This is why it is important to know what ki
;249 //  of logical value (C data type) each register is a part of.
;250 //
;251 //-------------------------------------------------------------------------
;252 //  Open issues/To-Do:
;253 //
;254 //  Given that registers are global variables, reads and writes to them nee
;255 //  to be protected.  A Modbus read should be able to read all the values
;256 //  as they are at a given moment, and writes should be an atomic transacti
;257 //  (i.e. changes to a group of registers should NOT be interrupted).
;258 //
;259 //  To address this, the reads really have to disable the scheduler while
;260 //  copying the requested values, and writes send a message to the main
;261 //  application process, and wait for a response.  Simply locking the regis
;262 //  values does not accomplish everything:
;263 //
;264 //  - The application logic is not informed of the change.  Even if it were
;265 //    check for changes, it would not know the order the changes were made 
;266 //    which can often be critical.  It could even miss changes that toggled
;267 //    a value.
;268 //
;269 //  - The registers values are simply global variables.  Allowing more than
;270 //    one process to write to them means ALL processes must imploy locking
;271 //    when accessing or altering them.
;272 //
;273 //  Seems I can't escape the simple fact that I have to coordinate the
;274 //  processing of all events that potentially change the state of the
;275 //  application or device, REGARDLESS of what process actually requests the
;276 //  change.  The easiest way to do that is to make one process responsible 
;277 //  all such changes and use msgs to request changes (with responses where
;278 //  feedback is needed).
;279 //
;280 //  Given that reads should be fairly quick, I might be able to get away wi
;281 //  simply disabling the scheduler during the read transaction to insure th
;282 //  copying of the values is not interrupted.  Using just a lock would
;283 //  protect the data as well, but would then allow the application process 
;284 //  run and find it could not do a pending write request from a different
;285 //  process (possibly OK if I simply defer ALL msg processing when the
;286 //  current request cannot be processed).
;287 //
;288 //-------------------------------------------------------------------------
;289 
;290 #include <common.h>
;291 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;292 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;293 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;294 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;295 #include <errno.h>
;296 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;297 #include <string.h>
;298 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;299 #include <sys/backup.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
;300 //#include <sys/hdwDefs.h>
;301 
;302 #include <sys/modbus.h>
;303 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
;304 #include <math.h>
;305 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
;306 
;307 extern bool  startupComplete;  //temp
;308 
;309 
;310 #define MaxCmdMsgLen    64
;311 #define MaxRespMsgLen  256
;312 
;313 
;314 #define  ModbusWriteBits    0x00000001
;315 #define  ModbusReadBits     0x00000002
;316 
;317 #define  ShowWrites   (DiagFlags & ModbusWriteBits)
;318 #define  ShowReads    (DiagFlags & ModbusReadBits)
;319 
;320 
;321 const char *typeDesc[NUM_MB_TYPES] =
;322        { "S16", "U16", "S32", "U32", "F32", "STR", "U8", "S8" };
	.defseg	CONST
	.seg	CONST
_typeDesc::
	.dw	@1
	.dw	@1+4
	.dw	@1+8
	.dw	@1+12
	.dw	@1+16
	.dw	@1+20
	.dw	@1+24
	.dw	@1+27
	.debug	G _typeDesc 32 0
;323 
;324 
;325 //--- table to control how to swap register #'s by client and data types --
;326 //--- #'s represent amount to change RegInfo.wordIdx by to get the ---
;327 //--- register value expected for different client types ---
;328 const schar regOrder[4][5][2] = {  // [clientType][dataType][wordIdx]
;329 //   --I16--   --U16--   --I32--   --U32--   --F32--
;330   { { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 } }, // CT_MBSerial
_regOrder::
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
;331   { { 0, 0 }, { 0, 0 }, { 1,-1 }, { 1,-1 }, { 0, 0 } }, // CT_MBNSCL
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0x1
	.db	0xff
	.db	0x1
	.db	0xff
	.db	0
	.db	0
;332   { { 0, 0 }, { 0, 0 }, { 1,-1 }, { 1,-1 }, { 0, 0 } }, // CT_MBTCP
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0x1
	.db	0xff
	.db	0x1
	.db	0xff
	.db	0
	.db	0
;333   { { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 } }  // CT_Native
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
	.db	0
;334 };
	.debug	G _regOrder 34 0
;335 typedef schar ClientOrder[5][2];
;336 
;337 
;338 //--- Save 16-bit value to a Byte array in Big-Endian (MSB-1st) format ---
;339 #define  SetWordVal(offset,val,buf)  
;340   (((buf)[offset] = (val) >> 8), ((buf)[(offset)+1] = (val) & 0xff))
;341 
;342 
;343 #include <sys/farprintf.h>
;344 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;345 PV_Ref far *pvList;   // array of PV_Ref structures
;346 
;347 
;348 uint  numC0Coils, numR3Regs, numR4Regs, numRegPVs, numNonRegPVs, numPVs;
;349 
;350 
;351 //--- defs for "SoftScope" values ---
;352 uint  numScopeRegs, captureIdx, scopeBufSampleSize, bytesPerScopeSample;
;353 ulong  captureCount;
;354 RegInfo  *scopeList[MaxWatchSize];
;355 char far  *scopeBuf, *capturePtr;
;356 
;357 
;358 //-------------------------------------------------------------------------
;359 //  Parse a string value according to the data type of the specified regist
;360 //
;361 //  Returns the value in native binary form in the given buffer
;362 //-------------------------------------------------------------------------
;363 void *parseValue(RegInfo *reg, char *valStr, char *buf)
;364 {
	.defseg	FARCODE
	.seg	FARCODE
$parseValue::
	.debug	G $parseValue 37 9
	.debug	{ $parseValue 37 363 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A valStr 7 33
	.debug	A buf 9 33
;365   switch (reg->dataType)  {
	.debug	# 365
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	jr	@5
;366 
;367     case DT_S16:
@7:
	.debug	< @7 @8
;368     case DT_U16:
	.debug	# 368
@9:
;369       *(short *)buf = ATOI(valStr);  break;
	.debug	# 369
@10:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$strtoi
	add	sp,6
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;370 
;371     case DT_S32:
	jr	@6
;372     case DT_U32:
	.debug	# 372
@11:
;373       *(ulong *)buf = ATOL(valStr);  break;
	.debug	# 373
@12:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$strtol
	add	sp,6
	jr	@810
;374 
;375     case DT_F32:
;376       *(float *)buf = atof(valStr);
	.debug	# 376
@13:
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_strtod
	add	sp,4
@810:
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;377       break;
	.debug	# 377
;378   }
	jr	@6
@8:
	.debug	>
;379 
;380   return buf;
@5:
	or	a,a
	jr	z,@9
	cp	0x1
	jr	z,@10
	cp	0x2
	jr	z,@11
	cp	0x3
	jr	z,@12
	cp	0x4
	jr	z,@13
@6:
	.debug	# 380
	ld	hl,(ix+9)
;381 }
@3:
	.debug	} @3 381

@2	equ	0
	pop	ix
	lret
@4	equ	2
;382 
;383 //-------------------------------------------------------------------------
;384 //  format a numeric value as a string, blnak filling the string on the lef
;385 //  if necessary to insure the result is at least minWidth chars in length
;386 //-------------------------------------------------------------------------
;387 char *fmtVal(char *buf, uchar type, int minWidth, void *val)
;388 {
$fmtVal::
	.debug	G $fmtVal 41 9
	.debug	{ $fmtVal 41 387 @16 @15
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A buf 5 33
	.debug	A type 7 3
	.debug	A minWidth 9 6
	.debug	A val 11 38
;389   int  sigDigits, len, fill;
	.debug	L sigDigits -2 6
	.debug	L len -4 6
	.debug	L fill -6 6
;390 
;391   *buf = 0;
	.debug	# 391
	xor	a,a
	ld	hl,(ix+5)
	ld	(hl),a
;392 
;393   switch (type)  {
	.debug	# 393
	ld	a,(ix+7)
	jp	@17
;394     case DT_S16:  sprintf(buf, "%d",  *(S16 *)val);  break;
@19:
	.debug	< @19 @20
	.debug	# 394
@21:
	ld	hl,(ix+11)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @22)
	ld	c,phys @22 >> 16
	jr	@809
;395     case DT_U16:  sprintf(buf, "%u",  *(U16 *)val);  break;
	.debug	# 395
@23:
	ld	hl,(ix+11)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @22+3)
	ld	c,phys @22+3 >> 16
@809:
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;396     case DT_S32:  sprintf(buf, "%ld", *(S32 *)val);  break;
	jr	@18
	.debug	# 396
@24:
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+6)
	ld	c,phys @22+6 >> 16
	jr	@808
;397     case DT_U32:  sprintf(buf, "%lu", *(U32 *)val);  break;
	.debug	# 397
@25:
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+10)
	ld	c,phys @22+10 >> 16
@808:
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;398     case DT_F32:
	jr	@18
;399       sigDigits = 6;
	.debug	# 399
@26:
	ld	hl,0x6
	ld	(ix-2),hl
;400       if (minWidth > 8)  sigDigits = minWidth - 6;
	.debug	# 400
	ld	hl,(ix+9)
	ld	de,0x8008
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@27
	jr	z,@27
	ld	hl,(ix+9)
	ld	de,0xfffa
	add	hl,de
	ld	(ix-2),hl
;401       Engineering(*(F32 *)val, sigDigits, buf);
@27:
	.debug	# 401
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
;402   }
@20:
	.debug	>
;403 
;404   if ((len = strlen(buf)) < minWidth)  {
	jr	@18
@17:
	or	a,a
	jp	z,@21
	cp	0x1
	jp	z,@23
	cp	0x2
	jr	z,@24
	cp	0x3
	jr	z,@25
	cp	0x4
	jr	z,@26
@18:
	.debug	# 404
	ld	hl,(ix+5)
	push	hl
	call	_strlen
	pop	de
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@28
;405     fill = minWidth - len;
@29:
	.debug	< @29 @30
	.debug	# 405
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-6),hl
;406     memmove(buf+fill, buf, len+1);
	.debug	# 406
	ld	h,d
	ld	l,e
	inc	hl
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	push	hl
	call	_memmove
	add	sp,6
;407     memset(buf, ' ', fill);
	.debug	# 407
	ld	hl,(ix-6)
	push	hl
	ld	hl,0x20
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_memset
	add	sp,6
;408   }
@30:
	.debug	>
;409 
;410   return buf;
@28:
	.debug	# 410
	ld	hl,(ix+5)
;411 }
@15:
	.debug	} @15 411

@14	equ	6
	ld	sp,ix
	pop	ix
	lret
@16	equ	8
;412 
;413 //-------------------------------------------------------------------------
;414 //  format a register value as a string
;415 //-------------------------------------------------------------------------
;416 char *fmtRegVal(RegInfo *reg, S16 *useVal, uint chanNum, char *buf)
;417 {
$fmtRegVal::
	.debug	G $fmtRegVal 42 9
	.debug	{ $fmtRegVal 42 416 @33 @32
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A reg 5 39
	.debug	A useVal 7 43
	.debug	A chanNum 9 7
	.debug	A buf 11 33
;418   S16  *valPtr;
	.debug	L valPtr -2 43
;419 
;420   if (useVal)
	.debug	# 420
	ld	hl,(ix+7)
	bool	hl
	jr	z,@34
;421     valPtr = useVal;
	.debug	# 421
	ld	hl,(ix+7)
	ld	(ix-2),hl
;422   else  {
	jr	@35
@34:
;423     valPtr = reg->regVal;
@36:
	.debug	< @36 @37
	.debug	# 423
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
;424     if (reg->flags & OnePerChan)  valPtr += chanNum * reg->numRegs;
	.debug	# 424
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,1
	jr	z,@38
	ld	hl,(ix+5)
	ld	e,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
;425   }
@38:
@37:
	.debug	>
;426 
;427   fmtVal(buf, reg->dataType, 12, valPtr);
@35:
	.debug	# 427
	ld	hl,(ix-2)
	push	hl
	ld	hl,0xc
	push	hl
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$fmtVal
	add	sp,8
;428 
;429   if (reg->numRegs == 1)
	.debug	# 429
	ld	hl,(ix+5)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	sub	a,1
	jr	nz,@39
;430     sprintf(buf+12, " (0x%04x)    ", *(U16 *)valPtr);
	.debug	# 430
	ld	hl,(ix-2)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @22+14)
	ld	c,phys @22+14 >> 16
	push	bc
	push	de
	ld	hl,(ix+11)
	ld	de,0xc
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;431   else
;432     sprintf(buf+12, " (0x%08lx)", *(U32 *)valPtr);
	jr	@40
@39:
	.debug	# 432
	ld	hl,(ix-2)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+28)
	ld	c,phys @22+28 >> 16
	push	bc
	push	de
	ld	hl,(ix+11)
	ld	de,0xc
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;433 
;434   return buf;
@40:
	.debug	# 434
	ld	hl,(ix+11)
;435 }
@32:
	.debug	} @32 435

@31	equ	2
	ld	sp,ix
	pop	ix
	lret
@33	equ	4
;436 
;437 
;438 
;439 //-------------------------------------------------------------------------
;440 //  generic routine to set the value of a coil.  Used when no special
;441 //  processing is required when changing a specific value.
;442 //-------------------------------------------------------------------------
;443 bool _nearcall setCoil(SetCoilFuncParams)
;444 {
	.align	4
$$setCoil::
	ex	(sp),iy
$setCoil::
	.debug	G $setCoil 44 9
	.debug	{ $setCoil 44 443 @43 @42
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 3
	.debug	A eventsfd 11 6
;445   if ((COIL->flags & LogChanges) AND startupComplete)
	.debug	# 445
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@45
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@45
;446     fprintf(DiagLog, "setCoil: %ls[%d] = %d\n", COIL->name, chanNum, newVal
	.debug	# 446
	bool	hl
	ld	l,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+39)
	ld	c,phys @22+39 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;447 
;448   COIL->coilVal[chanNum] = newVal;
@45:
	.debug	# 448
	ld	hl,(ix+5)
	ld	d,0
	ld	e,(ix+7)
	ld	hl,(hl)
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;449 
;450   return true;
	.debug	# 450
	ld	a,0x1
;451 }
@42:
	.debug	} @42 451

@41	equ	0
	pop	ix
	lret
@43	equ	2
;452 
;453 //-------------------------------------------------------------------------
;454 //  Function called by MB_setACoil() or MB_resetACoil() for the purpose of
;455 //  changing the value of the specified coil.  This differs from setCoil()
;456 //  in that this function CALLs the function specified in the coil definiti
;457 //  whereas setCoil() is just the default function specified in coil
;458 //  definitions when no special processing is required at the time the coil
;459 //  is set.
;460 //-------------------------------------------------------------------------
;461 bool setCoilVal(uint coilNum, uint chanNum, uchar coilVal, fd_t eventsfd)
;462 {
$setCoilVal::
	.debug	G $setCoilVal 45 9
	.debug	{ $setCoilVal 45 461 @48 @47
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A coilNum 5 7
	.debug	A chanNum 7 7
	.debug	A coilVal 9 3
	.debug	A eventsfd 11 6
;463   bool  accepted;
	.debug	L accepted -1 3
;464   CoilInfo  *coil;
	.debug	L coil -3 46
;465 
;466 
;467   if (coilNum > numC0Coils)  return false;
	.debug	# 467
	ld	hl,(ix+5)
	ld	de,(_numC0Coils)
	or	a,a
	sbc	hl,de
	jr	c,@49
	jr	nz,@807
;468 
;469   coil = c0Coils[coilNum-1];
@49:
	.debug	# 469
	ld	hl,(ix+5)
	dec	hl
	add	hl,hl
	ld	de,_c0Coils
	add	hl,de
	ld	hl,(hl)
	ld	(ix-3),hl
;470   chanNum = ((uint)coil->flags & OnePerChan ? chanNum : 0);
	.debug	# 470
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@50
	ld	hl,(ix+7)
	jr	@51
@50:
	bool	hl
	ld	l,h
@51:
	ld	(ix+7),hl
;471 
;472   if (!coil->setCoilFunc)  return false;
	.debug	# 472
	ld	hl,(ix-3)
	ld	de,0x7
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@52
@807:
	xor	a,a
	jr	@47
;473 
;474   accepted = (coil->setCoilFunc)(coil, chanNum, coilVal, eventsfd);
@52:
	.debug	# 474
	ld	hl,(ix+11)
	push	hl
	ld	a,(ix+9)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-3)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x7
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-1),a
;475 
;476   if ((coil->flags & LogChanges) AND startupComplete)
	.debug	# 476
	ld	hl,(ix-3)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@54
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@54
;477     fprintf(DiagLog, "set %ls[%d] = %u: %s\r\n\n",
;478             coil->name, chanNum, coilVal, (accepted ? "OK" : "Rejected")  )
	.debug	# 478
	ld	a,(ix-1)
	or	a,a
	jr	z,@55
	ld	hl,@1+30
	jr	@56
@55:
	ld	hl,@1+33
@56:
	push	hl
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-3)
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+62)
	ld	c,phys @22+62 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;479 
;480   return accepted;
@54:
	.debug	# 480
	ld	a,(ix-1)
;481 }
@47:
	.debug	} @47 481

@46	equ	3
	ld	sp,ix
	pop	ix
	lret
@48	equ	5
;482 
;483 //-------------------------------------------------------------------------
;484 //  Got a new value for the setACoil register, which attempts to set the co
;485 //  whose ID is the value writtent to the setACoil register.
;486 //-------------------------------------------------------------------------
;487 bool _nearcall MB_setACoil(SetRegFuncParams)
;488 {
	.align	4
$$MB_setACoil::
	ex	(sp),iy
$MB_setACoil::
	.debug	G $MB_setACoil 48 9
	.debug	{ $MB_setACoil 48 487 @60 @59
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;489   return setCoilVal(MB_VAL(U16), chanNum, 1, eventsfd);
	.debug	# 489
	ld	hl,(ix+11)
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	push	hl
	lcall	$setCoilVal
	add	sp,8
;490 }
@59:
	.debug	} @59 490

@58	equ	0
	pop	ix
	lret
@60	equ	2
;491 
;492 //-------------------------------------------------------------------------
;493 //  Got a new value for the resetACoil register, which attempts to clear th
;494 //  coil whose ID is the value writtent to the setACoil register.
;495 //-------------------------------------------------------------------------
;496 bool _nearcall MB_resetACoil(SetRegFuncParams)
;497 {
	.align	4
$$MB_resetACoil::
	ex	(sp),iy
$MB_resetACoil::
	.debug	G $MB_resetACoil 48 9
	.debug	{ $MB_resetACoil 48 496 @63 @62
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;498   return setCoilVal(MB_VAL(U16), chanNum, 0, eventsfd);
	.debug	# 498
	ld	hl,(ix+11)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	push	hl
	lcall	$setCoilVal
	add	sp,8
;499 }
@62:
	.debug	} @62 499

@61	equ	0
	pop	ix
	lret
@63	equ	2
;500 
;501 //-------------------------------------------------------------------------
;502 //  generic routine to serve as placeholder for registers that shouldn't be
;503 //  set
;504 //-------------------------------------------------------------------------
;505 bool _nearcall roReg(SetRegFuncParams)
;506 {
	.align	4
$$roReg::
	ex	(sp),iy
$roReg::
	.debug	G $roReg 48 9
	.debug	{ $roReg 48 505 @66 @65
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;507   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 507
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@68
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@68
;508     fprintf(DiagLog, "attempt to change ReadOnly reg: %ls\n", REG->name);
	.debug	# 508
	ld	hl,(ix+5)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+86)
	ld	c,phys @22+86 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;509 
;510   return false;
@68:
	.debug	# 510
	xor	a,a
;511 }
@65:
	.debug	} @65 511

@64	equ	0
	pop	ix
	lret
@66	equ	2
;512 
;513 //-------------------------------------------------------------------------
;514 //  generic routine to set the value of a register.  Used when no special
;515 //  processing is required when changing a specific value.
;516 //-------------------------------------------------------------------------
;517 bool _nearcall setS16(SetRegFuncParams)
;518 {
	.align	4
$$setS16::
	ex	(sp),iy
$setS16::
	.debug	G $setS16 48 9
	.debug	{ $setS16 48 517 @71 @70
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;519   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 519
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@73
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@73
;520     fprintf(DiagLog, "setS16: %ls[%d] = %d\n",
;521             REG->name, chanNum, MB_VAL(S16) );
	.debug	# 521
	ld	hl,(ix+9)
	ld	hl,(hl)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+123)
	ld	c,phys @22+123 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;522 
;523   _EnterCritical_();
@73:
	.debug	# 523
	ipset	2
;524   ((int *)REG->regVal)[chanNum] = MB_VAL(S16);
	.debug	# 524
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;525   _ExitCritical_();
	.debug	# 525
	ipres
;526 
;527   return true;
	.debug	# 527
	ld	a,0x1
;528 }
@70:
	.debug	} @70 528

@69	equ	0
	pop	ix
	lret
@71	equ	2
;529 
;530 //-------------------------------------------------------------------------
;531 //  generic routine to set the value of a register.  Used when no special
;532 //  processing is required when changing a specific value.
;533 //-------------------------------------------------------------------------
;534 bool _nearcall setU16(SetRegFuncParams)
;535 {
	.align	4
$$setU16::
	ex	(sp),iy
$setU16::
	.debug	G $setU16 48 9
	.debug	{ $setU16 48 534 @76 @75
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;536   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 536
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@78
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@78
;537     fprintf(DiagLog, "setU16: %ls[%d] = %u\n",
;538             REG->name, chanNum, MB_VAL(U16) );
	.debug	# 538
	ld	hl,(ix+9)
	ld	hl,(hl)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+145)
	ld	c,phys @22+145 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;539 
;540   _EnterCritical_();
@78:
	.debug	# 540
	ipset	2
;541   ((uint *)REG->regVal)[chanNum] = MB_VAL(U16);
	.debug	# 541
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;542   _ExitCritical_();
	.debug	# 542
	ipres
;543 
;544   return true;
	.debug	# 544
	ld	a,0x1
;545 }
@75:
	.debug	} @75 545

@74	equ	0
	pop	ix
	lret
@76	equ	2
;546 
;547 //-------------------------------------------------------------------------
;548 //  generic routine to set the value of a register.  Used when no special
;549 //  processing is required when changing a specific value.
;550 //-------------------------------------------------------------------------
;551 bool _nearcall setS32(SetRegFuncParams)
;552 {
	.align	4
$$setS32::
	ex	(sp),iy
$setS32::
	.debug	G $setS32 48 9
	.debug	{ $setS32 48 551 @81 @80
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;553   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 553
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@83
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@83
;554     fprintf(DiagLog, "setS32: %ls[%d] = %ld\n",
;555             REG->name, chanNum, MB_VAL(S32) );
	.debug	# 555
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+167)
	ld	c,phys @22+167 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;556 
;557   _EnterCritical_();
@83:
	.debug	# 557
	ipset	2
;558   ((long *)REG->regVal)[chanNum] = MB_VAL(S32);
	.debug	# 558
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	de
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;559   _ExitCritical_();
	.debug	# 559
	ipres
;560 
;561   return true;
	.debug	# 561
	ld	a,0x1
;562 }
@80:
	.debug	} @80 562

@79	equ	0
	pop	ix
	lret
@81	equ	2
;563 
;564 //-------------------------------------------------------------------------
;565 //  generic routine to set the value of a register.  Used when no special
;566 //  processing is required when changing a specific value.
;567 //-------------------------------------------------------------------------
;568 bool _nearcall setU32(SetRegFuncParams)
;569 {
	.align	4
$$setU32::
	ex	(sp),iy
$setU32::
	.debug	G $setU32 48 9
	.debug	{ $setU32 48 568 @86 @85
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;570   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 570
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@88
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@88
;571     fprintf(DiagLog, "setU32: %ls[%d] = %lu\n",
;572             REG->name, chanNum, MB_VAL(U32) );
	.debug	# 572
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+190)
	ld	c,phys @22+190 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;573 
;574   _EnterCritical_();
@88:
	.debug	# 574
	ipset	2
;575   ((ulong *)REG->regVal)[chanNum] = MB_VAL(U32);
	.debug	# 575
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	de
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;576   _ExitCritical_();
	.debug	# 576
	ipres
;577 
;578   return true;
	.debug	# 578
	ld	a,0x1
;579 }
@85:
	.debug	} @85 579

@84	equ	0
	pop	ix
	lret
@86	equ	2
;580 
;581 //-------------------------------------------------------------------------
;582 //  generic routine to set the value of a register.  Used when no special
;583 //  processing is required when changing a specific value.
;584 //-------------------------------------------------------------------------
;585 bool _nearcall setF32(SetRegFuncParams)
;586 {
	.align	4
$$setF32::
	ex	(sp),iy
$setF32::
	.debug	G $setF32 48 9
	.debug	{ $setF32 48 585 @91 @90
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;587   char  temp[16];
	.debug	L temp -16 49
;588 
;589 
;590   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 590
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@93
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@93
;591     fprintf(DiagLog, "setF32: %ls[%d] = %s\n",
;592             REG->name, chanNum, Engineering(MB_VAL(F32), 6, temp) );
	.debug	# 592
	ld	hl,-16+@89
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+213)
	ld	c,phys @22+213 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;593 
;594   _EnterCritical_();
@93:
	.debug	# 594
	ipset	2
;595   ((float *)REG->regVal)[chanNum] = MB_VAL(F32);
	.debug	# 595
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	de
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;596   _ExitCritical_();
	.debug	# 596
	ipres
;597 
;598   return true;
	.debug	# 598
	ld	a,0x1
;599 }
@90:
	.debug	} @90 599

@89	equ	16
	ld	sp,ix
	pop	ix
	lret
@91	equ	18
;600 
;601 
;602 //-------------------------------------------------------------------------
;603 //  generic routine to set the value of a register.  Used when no special
;604 //  processing is required when changing a specific value.
;605 //-------------------------------------------------------------------------
;606 bool _nearcall setF32_ABS(SetRegFuncParams)
;607 {
	.align	4
$$setF32_ABS::
	ex	(sp),iy
$setF32_ABS::
	.debug	G $setF32_ABS 48 9
	.debug	{ $setF32_ABS 48 606 @96 @95
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A info 5 38
	.debug	A chanNum 7 3
	.debug	A newVal 9 38
	.debug	A eventsfd 11 6
;608   char  temp[16];
	.debug	L temp -16 49
;609 
;610 
;611   if ((REG->flags & LogChanges) AND startupComplete)
	.debug	# 611
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@98
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@98
;612     fprintf(DiagLog, "setF32_ABS: %ls[%d] = %s\n",
;613             REG->name, chanNum, Engineering(MB_VAL(F32), 6, temp) );
	.debug	# 613
	ld	hl,-16+@94
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+235)
	ld	c,phys @22+235 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;614 
;615   _EnterCritical_();
@98:
	.debug	# 615
	ipset	2
;616   ((float *)REG->regVal)[chanNum] = FABS(MB_VAL(F32));
	.debug	# 616
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	de
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;617   _ExitCritical_();
	.debug	# 617
	ipres
;618 
;619   return true;
	.debug	# 619
	ld	a,0x1
;620 }
@95:
	.debug	} @95 620

@94	equ	16
	ld	sp,ix
	pop	ix
	lret
@96	equ	18
;621 
;622 
;623 //-------------------------------------------------------------------------
;624 //  Generic routine to set the value of a register.  Used to evoke the
;625 //  func specified for changing the register value and insuring the data
;626 //  type of the new value matches that of the register.
;627 //-------------------------------------------------------------------------
;628 bool setMBReg(RegInfo *reg, uchar chanNum, uchar newValType, void *newVal)
;629 {
$setMBReg::
	.debug	G $setMBReg 50 9
	.debug	{ $setMBReg 50 628 @101 @100
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newValType 9 3
	.debug	A newVal 11 38
;630   if (newValType >= NUM_MB_TYPES)  {
	.debug	# 630
	ld	a,(ix+9)
	sub	a,8
	jr	c,@102
;631     printf("setReg() for %ls: invalid type: %u\r\n", reg->name, newValType)
@103:
	.debug	< @103 @104
	.debug	# 631
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+261)
	ld	c,phys @22+261 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;632     return false;
	.debug	# 632
	jr	@806
;633   }
@104:
	.debug	>
;634 
;635   if (reg->dataType != newValType)  {
@102:
	.debug	# 635
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	hl,(ix+9)
	sub	a,l
	jr	z,@105
;636     printf("Attemped to set %ls[%d] (type %s) from value of type %s\r\n",
@106:
	.debug	< @106 @107
;637            reg->name, chanNum, typeDesc[reg->dataType], typeDesc[newValType
	.debug	# 637
	bool	hl
	ld	l,(ix+9)
	add	hl,hl
	ld	de,_typeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	de,_typeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+298)
	ld	c,phys @22+298 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;638     return false;
	.debug	# 638
@806:
	xor	a,a
	jr	@100
;639   }
@107:
	.debug	>
;640 
;641   if (reg->setRegFunc)  return (reg->setRegFunc)(reg, chanNum, newVal, -1);
@105:
	.debug	# 641
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@108
	ld	hl,0xffff
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	a,(ix+7)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	jr	@100
;642 
;643   return false;
@108:
	.debug	# 643
	xor	a,a
;644 }
@100:
	.debug	} @100 644

@99	equ	0
	pop	ix
	lret
@101	equ	2
;645 
;646 
;647 //-------------------------------------------------------------------------
;648 //  Generic routines to set the value of a register.  Used to evoke the
;649 //  func specified for changing the register value and insuring the data
;650 //  type of the new value matches that of the register.
;651 //
;652 //  *** WARNING ***
;653 //  Note that these MUST be done as real functions rather than macros to
;654 //  ensure that the format of the data passed to setMBReg() is correct.
;655 //
;656 //  These functions have a specified type for the newVal argument and requi
;657 //  the value be passed as a COPY of the value on the stack (rather than as
;658 //  a pointer to the value).  This insures that value that is passed to
;659 //  setMBReg() (by reference) is in the format we claim it is.
;660 //
;661 //  While replacing these functions with macros would be slightly more
;662 //  efficient, the macros would still have to use a local variable (i.e. on
;663 //  located on the stack) to store a copy of newVal in the correct format a
;664 //  pass the address of the copy to setMBReg().  Simply using typecasts alo
;665 //  is not sufficient, since telling setMBReg() that we are passing a point
;666 //  to floating point when in fact the data is in integer format is not goi
;667 //  to result in the correct register value.
;668 //-------------------------------------------------------------------------
;669 bool setRegS16(RegInfo *reg, uchar chanNum, S16 newVal)
;670 {  return setMBReg(reg, chanNum, DT_S16, &newVal);  }
$setRegS16::
	.debug	G $setRegS16 51 9
	.debug	{ $setRegS16 51 669 @111 @110
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newVal 9 4
	.debug	# 670
	ld	hl,9+@109
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setMBReg
	add	sp,8
@110:
	.debug	} @110 670

@109	equ	0
	pop	ix
	lret
@111	equ	2
;671 
;672 bool setRegU16(RegInfo *reg, uchar chanNum, U16 newVal)
;673 {  return setMBReg(reg, chanNum, DT_U16, &newVal);  }
$setRegU16::
	.debug	G $setRegU16 52 9
	.debug	{ $setRegU16 52 672 @114 @113
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newVal 9 5
	.debug	# 673
	ld	hl,9+@112
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setMBReg
	add	sp,8
@113:
	.debug	} @113 673

@112	equ	0
	pop	ix
	lret
@114	equ	2
;674 
;675 bool setRegS32(RegInfo *reg, uchar chanNum, S32 newVal)
;676 {  return setMBReg(reg, chanNum, DT_S32, &newVal);  }
$setRegS32::
	.debug	G $setRegS32 53 9
	.debug	{ $setRegS32 53 675 @117 @116
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newVal 9 8
	.debug	# 676
	ld	hl,9+@115
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setMBReg
	add	sp,8
@116:
	.debug	} @116 676

@115	equ	0
	pop	ix
	lret
@117	equ	2
;677 
;678 bool setRegU32(RegInfo *reg, uchar chanNum, U32 newVal)
;679 {  return setMBReg(reg, chanNum, DT_U32, &newVal);  }
$setRegU32::
	.debug	G $setRegU32 54 9
	.debug	{ $setRegU32 54 678 @120 @119
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newVal 9 9
	.debug	# 679
	ld	hl,9+@118
	add	hl,sp
	push	hl
	ld	hl,0x3
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setMBReg
	add	sp,8
@119:
	.debug	} @119 679

@118	equ	0
	pop	ix
	lret
@120	equ	2
;680 
;681 bool setRegF32(RegInfo *reg, uchar chanNum, F32 newVal)
;682 {  return setMBReg(reg, chanNum, DT_F32, &newVal);  }
$setRegF32::
	.debug	G $setRegF32 55 9
	.debug	{ $setRegF32 55 681 @123 @122
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A reg 5 39
	.debug	A chanNum 7 3
	.debug	A newVal 9 10
	.debug	# 682
	ld	hl,9+@121
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setMBReg
	add	sp,8
@122:
	.debug	} @122 682

@121	equ	0
	pop	ix
	lret
@123	equ	2
;683 
;684 
;685 //-------------------------------------------------------------------------
;686 //  Search the specified array of RegInfo pointers for a value with the
;687 //  specified address.
;688 //
;689 //  Returns the addr of the RegInfo structure for the matching register, or
;690 //  NULL if no match is found.
;691 //-------------------------------------------------------------------------
;692 RegInfo *isReg(RegInfo **regs, void far *addr)
;693 {
$isReg::
	.debug	G $isReg 56 9
	.debug	{ $isReg 56 692 @126 @125
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A regs 5 57
	.debug	A addr 7 58
;694   uint  u;
	.debug	L u -2 7
;695   RegInfo  *reg, *lastReg;
	.debug	L reg -4 39
	.debug	L lastReg -6 39
;696 
;697 
;698   lastReg = NULL;
	.debug	# 698
	bool	hl
	ld	l,h
	ld	(ix-6),hl
;699   for (u=0,reg=regs[0]; reg; ++u,reg=regs[u])  {
@127:
	.debug	< @127 @128
	.debug	# 699
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-4),hl
@129:
	ld	hl,(ix-4)
	bool	hl
	jr	z,@130
;700     if (reg == lastReg)  continue;  // skip if not 1st in multi-reg value
@132:
	.debug	< @132 @133
	.debug	# 700
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@131
;701     if ((ulong)reg->regVal == (ulong)addr)  return reg;
	.debug	# 701
	ld	h,d
	ld	l,e
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	b,0
	call	__lsub##
	jr	nz,@135
	ld	hl,(ix-4)
	jr	@125
;702     lastReg = reg;
@135:
	.debug	# 702
	ld	hl,(ix-4)
	ld	(ix-6),hl
;703   }
@133:
	.debug	>
;704 
;705   return NULL;
@131:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	jr	@129
@130:
@128:
	.debug	>
	.debug	# 705
	bool	hl
	ld	l,h
;706 }
@125:
	.debug	} @125 706

@124	equ	6
	ld	sp,ix
	pop	ix
	lret
@126	equ	8
;707 
;708 //-------------------------------------------------------------------------
;709 //  Called when some other module is restoring a value that MAY be a public
;710 //  (register/PV) value.
;711 //
;712 //  Return values:
;713 //     -1:  The value is a register, but the new value was rejected
;714 //      0:  The value is not a register
;715 //      1:  The value is a register and the new value was accepted
;716 //-------------------------------------------------------------------------
;717 int restoreIfRegValue(void far *curVal, char *newVal, uint count)
;718 {
$restoreIfRegValue::
	.debug	G $restoreIfRegValue 59 9
	.debug	{ $restoreIfRegValue 59 717 @138 @137
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
	.debug	A curVal 5 58
	.debug	A newVal 9 33
	.debug	A count 11 7
;719   bool  accepted;
	.debug	L accepted -1 3
;720   uint  chan, valSize;
	.debug	L chan -3 7
	.debug	L valSize -5 7
;721   RegInfo  *reg;
	.debug	L reg -7 39
;722 
;723 
;724   if (!(reg = isReg(r3Regs, curVal)))
	.debug	# 724
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_r3Regs
	push	hl
	lcall	$isReg
	add	sp,6
	ld	(ix-7),hl
	bool	hl
	jr	nz,@139
;725     if (!(reg = isReg(r4Regs, curVal)))  return 0;
	.debug	# 725
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_r4Regs
	push	hl
	lcall	$isReg
	add	sp,6
	ld	(ix-7),hl
	bool	hl
	jr	z,@805
;726 
;727   if (! reg->setRegFunc)  return false;
@139:
	.debug	# 727
	ld	hl,(ix-7)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@141
@805:
	bool	hl
	ld	l,h
	jr	@137
;728 
;729   chan = 0;  valSize = reg->numRegs * 2;  accepted = true;
@141:
	.debug	# 729
	bool	hl
	ld	l,h
	ld	(ix-3),hl
	ld	hl,(ix-7)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-5),hl
	ld	(ix-1),0x1
;730   while (count >= valSize)  {
@142:
	.debug	# 730
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@143
;731 //    printf("    %ls[%u]\r\n", reg->name, chan);  //tdebug
;732     if (! (reg->setRegFunc)(reg, chan, newVal, -1))  accepted = false;
@144:
	.debug	< @144 @145
	.debug	# 732
	ld	hl,0xffff
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix-7)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	or	a,a
	jr	nz,@146
	xor	a,a
	ld	(ix-1),a
;733     ++chan;  count -= valSize;  newVal += valSize;
@146:
	.debug	# 733
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix+11),hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	(ix+9),hl
;734   }
@145:
	.debug	>
;735 
;736   return (accepted ? 1 : -1);
	jr	@142
@143:
	.debug	# 736
	ld	a,(ix-1)
	or	a,a
	jr	z,@147
	ld	a,0x1
	jr	@148
@147:
	ld	a,0xff
@148:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
;737 }
@137:
	.debug	} @137 737

@136	equ	7
	ld	sp,ix
	pop	ix
	lret
@138	equ	9
;738 
;739 
;740 //-------------------------------------------------------------------------
;741 //  Return a pointer to the name of the specified PV
;742 //-------------------------------------------------------------------------
;743 char const *pvGetName(PV_Ref far *pvPtr, char *nameCopy)
;744 {
$pvGetName::
	.debug	G $pvGetName 60 9
	.debug	{ $pvGetName 60 743 @151 @150
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pvPtr 5 61
	.debug	A nameCopy 9 33
;745   char const far *name = "<invalid>";
	.debug	L name -4 63
	.debug	# 745
	ld	de,word (phys @22+356)
	ld	c,phys @22+356 >> 16
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;746 
;747   do  {
;748     if (!pvPtr)  break;
@155:
	.debug	< @155 @156
	.debug	# 748
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@153
;749 
;750     switch (pvPtr->pvType)  {
	.debug	# 750
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jr	@158
;751       case PVT_REG:  name = ((RegInfo *)(pvPtr->pvDef))->name;  break;
@160:
	.debug	< @160 @161
	.debug	# 751
@162:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__farld2##
	ld	hl,0x4
	add	hl,de
	jr	@804
;752 
;753       case PVT_EXT:  name = ((PV_Desc *)(pvPtr->pvDef))->pvInfo.name;  brea
	.debug	# 753
@163:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
@804:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;754     }
	jr	@159
@161:
	.debug	>
;755   }  while(0);
@158:
	cp	0x1
	jr	z,@162
	cp	0x2
	jr	z,@163
@159:
@156:
	.debug	>
	.debug	# 755
;756 
;757   strcpyfn(nameCopy, name);  return nameCopy;
@153:
	.debug	# 757
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	call	_strcpyfn
	add	sp,6
	ld	hl,(ix+9)
;758 }
@150:
	.debug	} @150 758

@149	equ	4
	ld	sp,ix
	pop	ix
	lret
@151	equ	6
;759 
;760 //-------------------------------------------------------------------------
;761 //  Search for a value with the specified name.  If found, return a 16-bit
;762 //  ID that can be used to access the value, or -1 if no such value is foun
;763 //-------------------------------------------------------------------------
;764 int pvGetID(char *pvName)
;765 {
$pvGetID::
	.debug	G $pvGetID 64 9
	.debug	{ $pvGetID 64 764 @166 @165
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-78
	.debug	A pvName 5 33
;766   int  cmp;
	.debug	L cmp -2 6
;767   uint  first, last, test, max;
	.debug	L first -4 7
	.debug	L last -6 7
	.debug	L test -8 7
	.debug	L max -10 7
;768   PV_Ref far  *pvRef;
	.debug	L pvRef -14 61
;769   char  nameBuf[MAX_PV_NAME_LEN];
	.debug	L nameBuf -78 65
;770 
;771 
;772 
;773 //--- do binary search using the list of PVs that is sorted by name ---
;774   first = 0;  last = max = numPVs - 1;
	.debug	# 774
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	hl,(_numPVs)
	dec	hl
	ld	(ix-10),hl
	ld	(ix-6),hl
;775   for (;;)  {
@167:
	.debug	< @167 @168
@169:
;776     pvRef = pvList + (test = (first + last) >> 1);
@172:
	.debug	< @172 @173
	.debug	# 776
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	add	hl,de
	or	a,a
	rr	hl
	ld	(ix-8),hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;777 
;778     cmp = stricmp(pvName, pvGetName(pvRef, nameBuf));
	.debug	# 778
	ld	hl,-78+@164
	add	hl,sp
	push	hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$pvGetName
	add	sp,6
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_stricmp
	add	sp,4
	ld	(ix-2),hl
;779 
;780     if (ShowDebugMsgs)
	.debug	# 780
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x800
	and	hl,de
	jr	z,@174
;781       printf("[%s] %d [%s]  %u,%u,%u\r\n",
;782              pvName, cmp, pvGetName(pvRef, nameBuf), first, test, last);
	.debug	# 782
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,-72+@164
	add	hl,sp
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$pvGetName
	add	sp,6
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @22+366)
	ld	c,phys @22+366 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;783 
;784     if (!cmp)  return (int) test;  // a match!
@174:
	.debug	# 784
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@175
	ld	hl,(ix-8)
	jr	@165
;785 
;786     if (first >= last)  break;      // tested them all?
@175:
	.debug	# 786
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@170
;787 
;788     if (cmp < 0)  {  // reduce the range to the appropriate half
	.debug	# 788
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@177
;789       if (test)  last = test - 1;  else   break; }
@178:
	.debug	< @178 @179
	.debug	# 789
	ld	hl,(ix-8)
	bool	hl
	jr	z,@170
	ld	hl,(ix-8)
	dec	hl
	ld	(ix-6),hl
	jr	@182
@179:
	.debug	>
;790     else
;791       if (test < max)  first = test + 1;  else  break;
@177:
	.debug	# 791
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@170
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-4),hl
;792   }
@182:
@173:
	.debug	>
;793 
;794   if (StrEq(pvName, "RTYP"))  return 900;   //temp
	jp	@169
@170:
@168:
	.debug	>
	.debug	# 794
	ld	hl,@1+42
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@185
	ld	hl,0x384
	jr	@165
;795   if (StrEq(pvName, "STAS"))  return 901;   //temp
@185:
	.debug	# 795
	ld	hl,@1+47
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@186
	ld	hl,0x385
	jr	@165
;796   if (StrEq(pvName, "DESC"))  return 902;   //temp
@186:
	.debug	# 796
	ld	hl,@1+52
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@187
	ld	hl,0x386
	jr	@165
;797 
;798   return -1;
@187:
	.debug	# 798
	ld	hl,0xffff
;799 }
@165:
	.debug	} @165 799

@164	equ	78
	ld	sp,ix
	pop	ix
	lret
@166	equ	80
;800 
;801 
;802 //-------------------------------------------------------------------------
;803 //  Get information for a PV
;804 //
;805 //  Returns 0 on success, < 0 if an error
;806 //-------------------------------------------------------------------------
;807 int pvGetInfo(int id, PV_Info *pvInfo)
;808 {
$pvGetInfo::
	.debug	G $pvGetInfo 66 9
	.debug	{ $pvGetInfo 66 807 @190 @189
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A id 5 6
	.debug	A pvInfo 7 67
;809   RegInfo  *reg;
	.debug	L reg -2 39
;810   PV_Desc  *pv;
	.debug	L pv -4 69
;811   PV_Ref far  *pvRef;
	.debug	L pvRef -8 61
;812 
;813 
;814 
;815 //temp
;816   if (id >= 900)  {
	.debug	# 816
	ld	hl,(ix+5)
	ld	de,0x8384
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@191
;817     pvInfo->dataType = DT_STR;
@192:
	.debug	< @192 @193
	.debug	# 817
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	a,0x5
	ld	(hl),a
;818     pvInfo->flags = PV_RD;
	.debug	# 818
	ld	hl,(ix+7)
	ld	e,0xb
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;819 
;820     switch (id)  {
	.debug	# 820
	ld	hl,(ix+5)
	jr	@194
;821       case 900:  pvInfo->name = "RTYP";  pvInfo->size = 7;  break;
@196:
	.debug	< @196 @197
	.debug	# 821
@198:
	ld	hl,(ix+7)
	ld	de,word (phys @22+391)
	ld	c,phys @22+391 >> 16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+7)
	ld	de,0x5
	add	hl,de
	ld	e,0x7
	jr	@803
;822       case 901:  pvInfo->name = "STAS";  pvInfo->size = 1;  break;
	.debug	# 822
@199:
	ld	hl,(ix+7)
	ld	de,word (phys @22+396)
	ld	c,phys @22+396 >> 16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+7)
	ld	de,0x5
	add	hl,de
	ld	e,0x1
	jr	@803
;823       case 902:  pvInfo->name = "DESC";  pvInfo->size = 12;  break;
	.debug	# 823
@200:
	ld	hl,(ix+7)
	ld	de,word (phys @22+401)
	ld	c,phys @22+401 >> 16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+7)
	ld	de,0x5
	add	hl,de
	ld	e,0xc
@803:
	ld	(hl),e
	inc	hl
	ld	(hl),d
;824       default:  return -1;
	jr	@195
	.debug	# 824
@201:
	jr	@802
;825     }
@197:
	.debug	>
;826     pvInfo->elemSize = pvInfo->size;
@194:
	ex	de,hl
	ld	hl,0xfffffc7c
	add	hl,de
	bool	hl
	jr	z,@198
	ld	hl,0xfffffc7b
	add	hl,de
	bool	hl
	jr	z,@199
	ld	hl,0xfffffc7a
	add	hl,de
	bool	hl
	jr	z,@200
	jr	@802
@195:
	.debug	# 826
	ld	hl,(ix+7)
	ld	de,0x5
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x7
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;827     pvInfo->numElems = 1;
	.debug	# 827
	ld	hl,(ix+7)
	ld	de,0x9
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;828     return 0;
	.debug	# 828
	jp	@801
;829   }
@193:
	.debug	>
;830 
;831 
;832   if ((uint)id >= numPVs)  return -1;
@191:
	.debug	# 832
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jr	c,@202
@802:
	ld	hl,0xffff
	jp	@189
;833 
;834   pvRef = pvList + (uint)id;
@202:
	.debug	# 834
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;835 
;836   switch (pvRef->pvType)  {
	.debug	# 836
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jp	@203
;837 
;838     case PVT_REG:
@205:
	.debug	< @205 @206
;839       reg = (RegInfo *)pvRef->pvDef;
	.debug	# 839
@207:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
;840       pvInfo->name = reg->name;
	.debug	# 840
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;841       pvInfo->dataType = reg->dataType;
	.debug	# 841
	ld	hl,(ix-2)
	ld	de,0xa
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;842       pvInfo->elemSize = pvInfo->size = reg->numRegs << 1;
	.debug	# 842
	ld	hl,(ix-2)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x5
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,d
	ld	l,e
	ld	de,0x7
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;843       pvInfo->numElems = 1;
	.debug	# 843
	ld	hl,(ix+7)
	ld	e,0x9
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;844       pvInfo->flags = PV_RD;
	.debug	# 844
	ld	hl,(ix+7)
	ld	e,0xb
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;845       if (reg->wrMask == REG_RW)  pvInfo->flags |= PV_WR;
	.debug	# 845
	ld	hl,(ix-2)
	ld	e,0xc
	add	hl,de
	ld	a,(hl)
	sub	a,1
	jr	nz,@801
	ld	hl,(ix+7)
	dec	e
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	1,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;846       return 0;
	.debug	# 846
	jr	@801
;847 
;848     case PVT_EXT:
;849       pv = (PV_Desc *)pvRef->pvDef;
	.debug	# 849
@209:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;850       *pvInfo = pv->pvInfo;
	.debug	# 850
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	hl
	ld	bc,13
	ldir
	pop	hl
;851       return 0;
	.debug	# 851
@801:
	bool	hl
	ld	l,h
	jr	@189
;852   }
@206:
	.debug	>
;853 
;854   return -1;
@203:
	cp	0x1
	jp	z,@207
	cp	0x2
	jr	z,@209
@204:
	.debug	# 854
	ld	hl,0xffff
;855 }
@189:
	.debug	} @189 855

@188	equ	8
	ld	sp,ix
	pop	ix
	lret
@190	equ	10
;856 
;857 
;858 //-------------------------------------------------------------------------
;859 //  Attempt to obtain or release a read or write lock on a PV.
;860 //
;861 //  Returns the depth of the lock or < 0 if not successsful.
;862 //
;863 //  For lockMode LM_TryLock, a return value < 0 and errno == EAGAIN means
;864 //  it could not get the lock w/o blocking.
;865 //-------------------------------------------------------------------------
;866 int pvLockVal(int id, int lockMode, int lockType)
;867 {
$pvLockVal::
	.debug	G $pvLockVal 71 9
	.debug	{ $pvLockVal 71 866 @212 @211
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A id 5 6
	.debug	A lockMode 7 6
	.debug	A lockType 9 6
;868   PV_Desc  *pv;
	.debug	L pv -2 69
;869   PV_Ref far  *pvRef;
	.debug	L pvRef -6 61
;870 
;871 
;872   if ((uint)id >= numPVs)  {
	.debug	# 872
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jr	c,@213
;873     if ((id >= 900) AND (id <= 902))  return 0;  //temp
@214:
	.debug	< @214 @215
	.debug	# 873
	ld	hl,(ix+5)
	ld	de,0x8384
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@217
	ld	hl,(ix+5)
	ld	e,0x86
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@800
	jr	c,@800
;874     errno = EINVAL;  return -1;
@217:
	.debug	# 874
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@799
;875   }
@215:
	.debug	>
;876 
;877   pvRef = pvList + (uint)id;
@213:
	.debug	# 877
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;878 
;879 //--- consider ModBus register-defined values as always locked ---
;880   if (pvRef->pvType != PVT_EXT)  return 0;
	.debug	# 880
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,2
	jr	z,@219
@800:
	bool	hl
	ld	l,h
	jr	@211
;881 
;882   pv = (PV_Desc *)pvRef->pvDef;
@219:
	.debug	# 882
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
;883 
;884 //--- All non-reg PV's MUST provide a lock func! ---
;885   if (!pv->lockVal)  return -1;
	.debug	# 885
	ld	de,0x17
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@220
@799:
	ld	hl,0xffff
	jr	@211
;886 
;887   return (*pv->lockVal)(pv, lockMode, lockType);
@220:
	.debug	# 887
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x17
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
;888 }
@211:
	.debug	} @211 888

@210	equ	6
	ld	sp,ix
	pop	ix
	lret
@212	equ	8
;889 
;890 
;891 //-------------------------------------------------------------------------
;892 //  Called to get a copy of a PV's current value.
;893 //
;894 //  The job of this function is to cause the specified copyFunc() to be cal
;895 //  as needed to copy all the bytes for the PV's current value.
;896 //
;897 //  If the PV's description does NOT specify a value-specific read function
;898 //  then the current PV value is assumed to be stored in its entirety at th
;899 //  address indicated by the PV's description and all we have to do is call
;900 //  the copyFunc() once with the location of the value and its size in byte
;901 //
;902 //  If the PV's description DOES specify a value-specific read function, th
;903 //  that function will be called and IT will be responsible for generating
;904 //  the current PV value in a suitable format and calling the copyFunc() as
;905 //  needed to transfer the resulting data.  Note that the copyFunc() may be
;906 //  called many times before the entire value is transferred.
;907 //
;908 //-------------------------------------------------------------------------
;909 int pvCopyVal(int id, uint numElems, void *conInfo, PV_CopyFunc copyFunc)
;910 {
$pvCopyVal::
	.debug	G $pvCopyVal 72 9
	.debug	{ $pvCopyVal 72 909 @223 @222
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A id 5 6
	.debug	A numElems 7 7
	.debug	A conInfo 9 38
	.debug	A copyFunc 11 73
;911   uint  fromSize;
	.debug	L fromSize -2 7
;912   RegInfo  *reg;
	.debug	L reg -4 39
;913   PV_Desc  *pv;
	.debug	L pv -6 69
;914   PV_Info  *pvInfo;
	.debug	L pvInfo -8 67
;915   PV_Ref far  *pvRef;
	.debug	L pvRef -12 61
;916   void far  *fromVal;
	.debug	L fromVal -16 58
;917 
;918 
;919   if ((uint)id >= numPVs)  {
	.debug	# 919
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jr	c,@224
;920     if ((id >= 900) AND (id <= 902))  return 0;  //temp
@225:
	.debug	< @225 @226
	.debug	# 920
	ld	hl,(ix+5)
	ld	de,0x8384
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@228
	ld	hl,(ix+5)
	ld	e,0x86
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@229
	jr	nc,@228
@229:
	bool	hl
	ld	l,h
	jp	@222
;921     errno = EINVAL;  return -1;
@228:
	.debug	# 921
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@238
;922   }
@226:
	.debug	>
;923 
;924 
;925   pvRef = pvList + (uint)id;
@224:
	.debug	# 925
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;926 
;927   switch (pvRef->pvType)  {
	.debug	# 927
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jp	@230
;928 
;929     case PVT_REG:
@232:
	.debug	< @232 @233
;930       reg = (RegInfo *)pvRef->pvDef;
	.debug	# 930
@234:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;931       fromSize = reg->numRegs << 1;
	.debug	# 931
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-2),hl
;932 //      fromVal = (event == DBE_VALUE) ? reg->lastChgVal : reg->regVal;
;933       fromVal = reg->lastChgVal;
	.debug	# 933
	ld	hl,(ix-4)
	ld	e,0x10
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;934       break;
	.debug	# 934
;935 
;936     case PVT_EXT:
	jr	@231
;937       pv = (PV_Desc *)pvRef->pvDef;
	.debug	# 937
@235:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-6),hl
;938       pvInfo = &pv->pvInfo;
	.debug	# 938
	ld	(ix-8),hl
;939       fromSize = numElems * pvInfo->elemSize;
	.debug	# 939
	ld	de,0x7
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,hl
	mul
	ld	(ix-2),c
	ld	(ix-1),b
;940       //finish:  Support for values that don't set pv->val...
;941       fromVal = pv->val;  if (fromVal)  break;
	.debug	# 941
	ld	hl,(ix-6)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@231
;942       if (!pv->sendVal)  return -1;
	.debug	# 942
	ld	hl,(ix-6)
	ld	de,0x19
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@238
;943       return (*pv->sendVal)(id, numElems, conInfo, copyFunc);
	.debug	# 943
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x19
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	jr	@222
;944 
;945     default:
;946       return -1;
	.debug	# 946
@238:
	ld	hl,0xffff
	jr	@222
;947   }
@233:
	.debug	>
;948 
;949   return (*copyFunc)(conInfo, fromVal, fromSize);
@230:
	cp	0x1
	jp	z,@234
	cp	0x2
	jr	z,@235
	jr	@238
@231:
	.debug	# 949
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	call	__callde##
	add	sp,8
;950 }
@222:
	.debug	} @222 950

@221	equ	16
	ld	sp,ix
	pop	ix
	lret
@223	equ	18
;951 
;952 
;953 //-------------------------------------------------------------------------
;954 //  Return the value for the specified event on a PV in the requested forma
;955 //
;956 //  Returns 0 on success, < 0 if an error
;957 //-------------------------------------------------------------------------
;958 int pvGetVal(int id, uint toType, uint toSize, void *toVal, uint event)
;959 {
$pvGetVal::
	.debug	G $pvGetVal 75 9
	.debug	{ $pvGetVal 75 958 @241 @240
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-15
	.debug	A id 5 6
	.debug	A toType 7 7
	.debug	A toSize 9 7
	.debug	A toVal 11 38
	.debug	A event 13 7
;960   uchar  fromType;
	.debug	L fromType -1 3
;961   uint  fromSize;
	.debug	L fromSize -3 7
;962   RegInfo  *reg;
	.debug	L reg -5 39
;963   PV_Desc  *pv;
	.debug	L pv -7 69
;964 //  PV_Info  *pvInfo;
;965   PV_Ref far  *pvRef;
	.debug	L pvRef -11 61
;966   void  *fromVal;
	.debug	L fromVal -13 38
;967   char  *testVal;
	.debug	L testVal -15 33
;968 
;969 #define  FROM_VAL(type)  ( *((type *)fromVal) )
;970 #define  TO_VAL(type)    ( *((type *)toVal) )
;971 
;972 
;973 //temp
;974   if (id >= 900)  {
	.debug	# 974
	ld	hl,(ix+5)
	ld	de,0x8384
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@242
;975     if (toType != DT_STR)  return -1;
@243:
	.debug	< @243 @244
	.debug	# 975
	ld	hl,(ix+7)
	ld	de,0x5
	or	a,a
	sbc	hl,de
	jp	nz,@785
;976 
;977     if (id == 900)  testVal = "DEBROS";
	.debug	# 977
	ld	hl,(ix+5)
	ld	de,0x384
	or	a,a
	sbc	hl,de
	jr	nz,@246
	ld	hl,@1+57
	ld	(ix-15),hl
;978     else  if (id == 902)  testVal = "Rabbit Ctlr";
	jr	@247
@246:
	.debug	# 978
	ld	hl,(ix+5)
	ld	de,0x386
	or	a,a
	sbc	hl,de
	jr	nz,@248
	ld	hl,@1+64
	ld	(ix-15),hl
;979     else  testVal = "";
	jr	@249
@248:
	.debug	# 979
	ld	hl,@1+3
	ld	(ix-15),hl
;980 
;981     strncpy(toVal, testVal, toSize);  return 0;
@249:
@247:
	.debug	# 981
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix-15)
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_strncpy
	jp	@797
;982   }
@244:
	.debug	>
;983 
;984 
;985   if ((uint)id >= numPVs)  return -1;
@242:
	.debug	# 985
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jp	nc,@785
;986 
;987   pvRef = pvList + (uint)id;
	.debug	# 987
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;988 
;989   switch (pvRef->pvType)  {
	.debug	# 989
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jp	@251
;990 
;991     case PVT_REG:
@253:
	.debug	< @253 @254
;992       reg = (RegInfo *)pvRef->pvDef;
	.debug	# 992
@255:
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-5),hl
;993       fromType = reg->dataType;
	.debug	# 993
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
;994       fromSize = reg->numRegs << 1;
	.debug	# 994
	ld	hl,(ix-5)
	inc	e
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-3),hl
;995       fromVal = (event == DBE_VALUE) ? reg->lastChgVal : reg->regVal;
	.debug	# 995
	ld	hl,(ix+13)
	ld	e,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@256
	ld	hl,(ix-5)
	ld	e,0x10
	add	hl,de
	ld	hl,(hl)
	jr	@798
@256:
	ld	hl,(ix-5)
	ld	hl,(hl)
	jr	@798
;996       break;
	.debug	# 996
;997 
;998     case PVT_EXT:
;999       pv = (PV_Desc *)pvRef->pvDef;
	.debug	# 999
@258:
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-7),hl
;1000       fromType = pv->pvInfo.dataType;
	.debug	# 1000
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
;1001       fromSize = pv->pvInfo.size;
	.debug	# 1001
	ld	hl,(ix-7)
	inc	e
	add	hl,de
	ld	hl,(hl)
	ld	(ix-3),hl
;1002       if (((uint)pv->val) >= 0xE000)  return -1;
	.debug	# 1002
	ld	hl,(ix-7)
	ld	e,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,0xe000
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@785
;1003       fromVal = (void *)((uint)pv->val);
	.debug	# 1003
	ld	hl,(ix-7)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
@798:
	ld	(ix-13),hl
;1004       break;
	.debug	# 1004
;1005 
;1006     default:
	jr	@252
;1007       return -1;
	.debug	# 1007
@260:
	jp	@785
;1008   }
@254:
	.debug	>
;1009 
;1010 
;1011 //--- if types are the same, then just copy the value and return ---
;1012   if ((toType == fromType) AND (toSize >= fromSize))  {
@251:
	cp	0x1
	jp	z,@255
	cp	0x2
	jr	z,@258
	jr	@260
@252:
	.debug	# 1012
	bool	hl
	ld	l,(ix-1)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@262
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@262
;1013     memcpy(toVal, fromVal, fromSize);  return 0; }
@263:
	.debug	< @263 @264
	.debug	# 1013
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix-13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_memcpy
@797:
	add	sp,6
	jp	@784
@264:
	.debug	>
;1014 
;1015 //--- otherwise convert as best we can ---
;1016   switch (toType)  {
@262:
	.debug	# 1016
	ld	hl,(ix+7)
	jp	@265
;1017 
;1018     case DT_S16:
@267:
	.debug	< @267 @268
;1019       if (toSize < 2)  return -1;
	.debug	# 1019
@269:
	ld	hl,(ix+9)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@785
;1020       switch (fromType)  {
	.debug	# 1020
	ld	a,(ix-1)
	jr	@271
;1021         case DT_S16:  TO_VAL(S16) = (S16) FROM_VAL(S16);  break;
@273:
	.debug	< @273 @274
	.debug	# 1021
;1022         case DT_U16:  TO_VAL(S16) = (S16) FROM_VAL(U16);  break;
	.debug	# 1022
;1023         case DT_S32:  TO_VAL(S16) = (S16) FROM_VAL(S32);  break;
	.debug	# 1023
@796:
@795:
;1024         case DT_U32:  TO_VAL(S16) = (S16) FROM_VAL(U32);  break;
	.debug	# 1024
@278:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	jr	@794
;1025         case DT_F32:  TO_VAL(S16) = (S16) FROM_VAL(F32);  break;
	.debug	# 1025
@279:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
@794:
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1026         default:  return -1;
	jr	@272
	.debug	# 1026
@280:
	jp	@785
;1027       }
@274:
	.debug	>
;1028       return 0;
@271:
	or	a,a
	jr	z,@796
	cp	0x1
	jr	z,@796
	cp	0x2
	jr	z,@795
	cp	0x3
	jr	z,@278
	cp	0x4
	jr	z,@279
	jr	@280
@272:
	.debug	# 1028
	jp	@784
;1029 
;1030     case DT_U16:
;1031       if (toSize < 2)  return -1;
	.debug	# 1031
@281:
	ld	hl,(ix+9)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@785
;1032       switch (fromType)  {
	.debug	# 1032
	ld	a,(ix-1)
	jr	@283
;1033         case DT_S16:  TO_VAL(U16) = (U16) FROM_VAL(S16);  break;
@285:
	.debug	< @285 @286
	.debug	# 1033
;1034         case DT_U16:  TO_VAL(U16) = (U16) FROM_VAL(U16);  break;
	.debug	# 1034
;1035         case DT_S32:  TO_VAL(U16) = (U16) FROM_VAL(S32);  break;
	.debug	# 1035
@793:
@792:
;1036         case DT_U32:  TO_VAL(U16) = (U16) FROM_VAL(U32);  break;
	.debug	# 1036
@290:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	jr	@791
;1037         case DT_F32:  TO_VAL(U16) = (U16) FROM_VAL(F32);  break;
	.debug	# 1037
@291:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
@791:
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1038         default:  return -1;
	jr	@284
	.debug	# 1038
@292:
	jp	@785
;1039       }
@286:
	.debug	>
;1040       return 0;
@283:
	or	a,a
	jr	z,@793
	cp	0x1
	jr	z,@793
	cp	0x2
	jr	z,@792
	cp	0x3
	jr	z,@290
	cp	0x4
	jr	z,@291
	jr	@292
@284:
	.debug	# 1040
	jp	@784
;1041 
;1042     case DT_S32:
;1043       if (toSize < 4)  return -1;
	.debug	# 1043
@293:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@785
;1044       switch (fromType)  {
	.debug	# 1044
	ld	a,(ix-1)
	jr	@295
;1045         case DT_S16:  TO_VAL(S32) = (S32) FROM_VAL(S16);  break;
@297:
	.debug	< @297 @298
	.debug	# 1045
@299:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	jr	@789
;1046         case DT_U16:  TO_VAL(S32) = (S32) FROM_VAL(U16);  break;
	.debug	# 1046
@300:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	jr	@789
;1047         case DT_S32:  TO_VAL(S32) = (S32) FROM_VAL(S32);  break;
	.debug	# 1047
@790:
;1048         case DT_U32:  TO_VAL(S32) = (S32) FROM_VAL(U32);  break;
	.debug	# 1048
@302:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@789
;1049         case DT_F32:  TO_VAL(S32) = (S32) FROM_VAL(F32);  break;
	.debug	# 1049
@303:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
@789:
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1050         default:  return -1;
	jr	@296
	.debug	# 1050
@304:
	jp	@785
;1051       }
@298:
	.debug	>
;1052       return 0;
@295:
	or	a,a
	jr	z,@299
	cp	0x1
	jr	z,@300
	cp	0x2
	jr	z,@790
	cp	0x3
	jr	z,@302
	cp	0x4
	jr	z,@303
	jr	@304
@296:
	.debug	# 1052
	jp	@784
;1053 
;1054     case DT_U32:
;1055       if (toSize < 4)  return -1;
	.debug	# 1055
@305:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@785
;1056       switch (fromType)  {
	.debug	# 1056
	ld	a,(ix-1)
	jr	@307
;1057         case DT_S16:  TO_VAL(U32) = (U32) FROM_VAL(S16);  break;
@309:
	.debug	< @309 @310
	.debug	# 1057
@311:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	jr	@787
;1058         case DT_U16:  TO_VAL(U32) = (U32) FROM_VAL(U16);  break;
	.debug	# 1058
@312:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	jr	@787
;1059         case DT_S32:  TO_VAL(U32) = (U32) FROM_VAL(S32);  break;
	.debug	# 1059
@788:
;1060         case DT_U32:  TO_VAL(U32) = (U32) FROM_VAL(U32);  break;
	.debug	# 1060
@314:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@787
;1061         case DT_F32:  TO_VAL(U32) = (U32) FROM_VAL(F32);  break;
	.debug	# 1061
@315:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
@787:
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1062         default:  return -1;
	jr	@308
	.debug	# 1062
@316:
	jp	@785
;1063       }
@310:
	.debug	>
;1064       return 0;
@307:
	or	a,a
	jr	z,@311
	cp	0x1
	jr	z,@312
	cp	0x2
	jr	z,@788
	cp	0x3
	jr	z,@314
	cp	0x4
	jr	z,@315
	jr	@316
@308:
	.debug	# 1064
	jp	@784
;1065 
;1066     case DT_F32:
;1067       if (toSize < 4)  return -1;
	.debug	# 1067
@317:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@785
;1068       switch (fromType)  {
	.debug	# 1068
	ld	a,(ix-1)
	jr	@319
;1069         case DT_S16:  TO_VAL(F32) = (F32) FROM_VAL(S16);  break;
@321:
	.debug	< @321 @322
	.debug	# 1069
@323:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	call	__itof##
	jr	@786
;1070         case DT_U16:  TO_VAL(F32) = (F32) FROM_VAL(U16);  break;
	.debug	# 1070
@324:
	ld	hl,(ix-13)
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	jr	@786
;1071         case DT_S32:  TO_VAL(F32) = (F32) FROM_VAL(S32);  break;
	.debug	# 1071
@325:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ltof##
	jr	@786
;1072         case DT_U32:  TO_VAL(F32) = (F32) FROM_VAL(U32);  break;
	.debug	# 1072
@326:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ultof##
	jr	@786
;1073         case DT_F32:  TO_VAL(F32) = (F32) FROM_VAL(F32);  break;
	.debug	# 1073
@327:
	ld	hl,(ix-13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
@786:
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1074         default:  return -1;
	jr	@784
	.debug	# 1074
@328:
	jr	@785
;1075       }
@322:
	.debug	>
;1076       return 0;
@319:
	or	a,a
	jr	z,@323
	cp	0x1
	jr	z,@324
	cp	0x2
	jr	z,@325
	cp	0x3
	jr	z,@326
	cp	0x4
	jr	z,@327
	jr	@785
@320:
	.debug	# 1076
	jr	@784
;1077 
;1078     case DT_STR:
;1079       if (toSize < 12)  return -1;
	.debug	# 1079
@329:
	ld	hl,(ix+9)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	nc,@330
@785:
	ld	hl,0xffff
	jr	@240
;1080       fmtVal(toVal, fromType, 0, fromVal);
@330:
	.debug	# 1080
	ld	hl,(ix-13)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	l,(ix-1)
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$fmtVal
	add	sp,8
;1081       return 0;
	.debug	# 1081
@784:
	bool	hl
	ld	l,h
	jr	@240
;1082   }
@268:
	.debug	>
;1083 
;1084   return -1;
@265:
	ld	bc,hl
	ld	de,-6
	add	hl,de
	jr	c,@266
	ld	hl,@331
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@331:
	dw	@269
	dw	@281
	dw	@293
	dw	@305
	dw	@317
	dw	@329
	.seg	FARCODE
@266:
	.debug	# 1084
	ld	hl,0xffff
;1085 }
@240:
	.debug	} @240 1085

@239	equ	15
	ld	sp,ix
	pop	ix
	lret
@241	equ	17
;1086 
;1087 
;1088 //-------------------------------------------------------------------------
;1089 //  Update the value of a PV using the provided value.
;1090 //
;1091 //  Returns 0 on success, < 0 if an error
;1092 //-------------------------------------------------------------------------
;1093 int pvSetVal(int id, uint fromType, uint fromSize, void *fromVal)
;1094 {
$pvSetVal::
	.debug	G $pvSetVal 76 9
	.debug	{ $pvSetVal 76 1093 @334 @333
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-25
	.debug	A id 5 6
	.debug	A fromType 7 7
	.debug	A fromSize 9 7
	.debug	A fromVal 11 38
;1095   uchar  toType;
	.debug	L toType -1 3
;1096   uint  u16;
	.debug	L u16 -3 7
;1097   int  s16;
	.debug	L s16 -5 6
;1098   ulong  u32;
	.debug	L u32 -9 9
;1099   long  s32;
	.debug	L s32 -13 8
;1100   float  f32;
	.debug	L f32 -17 10
;1101   PV_Desc  *pv;
	.debug	L pv -19 69
;1102   RegInfo  *reg;
	.debug	L reg -21 39
;1103   PV_Ref far  *pvRef;
	.debug	L pvRef -25 61
;1104 //  uint  regSize;
;1105 //  void  *regVal;
;1106 //  char  temp[32];  //tdebug
;1107 
;1108 #define  FROM_VAL(type)   ( *((type *)fromVal) )
;1109 
;1110 
;1111   if ((uint)id >= numPVs)  return -1;
	.debug	# 1111
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jp	nc,@417
;1112 
;1113   pvRef = pvList + (uint)id;
	.debug	# 1113
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
;1114 
;1115   switch (pvRef->pvType)  {
	.debug	# 1115
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jr	@336
;1116 
;1117     case PVT_REG:
@338:
	.debug	< @338 @339
;1118       reg = (RegInfo *)pvRef->pvDef;
	.debug	# 1118
@340:
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-21),hl
;1119       toType = reg->dataType;
	.debug	# 1119
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
;1120 //      toSize = reg->numRegs << 1;
;1121 //      toVal = reg->regVal;
;1122       break;
	.debug	# 1122
;1123 
;1124     case PVT_EXT:
	jr	@337
;1125       pv = (PV_Desc *)pvRef->pvDef;
	.debug	# 1125
@341:
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-19),hl
;1126       toType = pv->pvInfo.dataType;
	.debug	# 1126
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
;1127 //      toSize = pv->pvInfo.size;
;1128 //      toVal = pv->val;
;1129       return -1;  //finish
	.debug	# 1129
	jp	@417
;1130       break;
;1131 
;1132     default:
;1133       return -1;
	.debug	# 1133
@342:
	jp	@417
;1134   }
@339:
	.debug	>
;1135 
;1136 
;1137 //printf("pvSetVal(%d, %u, %u, [%02x %02x %02x %02x])\r\n",  //tdebug
;1138 //       id, fromType, fromSize,
;1139 //       *(char *)fromVal[0], *(char *)fromVal[1],
;1140 //       *(char *)fromVal[2], *(char *)fromVal[3] );
;1141 
;1142 
;1143 //--- if types are the same, then just copy the value and return ---
;1144 //  if ((fromType == toType) AND (fromSize >= toSize))  {
;1145 //    memcpy(toVal, fromVal, toSize);  return 0; }
;1146   // This skips the set function specified for the register!!!!!
;1147 
;1148 //--- otherwise convert as best we can ---
;1149   switch (fromType)  {
@336:
	cp	0x1
	jr	z,@340
	cp	0x2
	jr	z,@341
	jr	@342
@337:
	.debug	# 1149
	ld	hl,(ix+7)
	jp	@343
;1150 
;1151     case DT_S16:
@345:
	.debug	< @345 @346
;1152       if (fromSize < 2)  return -1;
	.debug	# 1152
@347:
	ld	hl,(ix+9)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@417
;1153       s16 = FROM_VAL(S16);
	.debug	# 1153
	ld	hl,(ix+11)
	ld	hl,(hl)
	ld	(ix-5),hl
;1154 //      printf("DT_S16: [%d]\r\n", s16);  //tdebug
;1155       switch (toType)  {
	.debug	# 1155
	ld	a,(ix-1)
	jr	@349
;1156         case DT_S16:  setRegS16(reg, 0, (S16) s16);  break;
@351:
	.debug	< @351 @352
	.debug	# 1156
@353:
	ld	hl,(ix-5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@783
;1157         case DT_U16:  setRegU16(reg, 0, (U16) s16);  break;
	.debug	# 1157
@354:
	ld	hl,(ix-5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@783:
	add	sp,6
;1158         case DT_S32:  setRegS32(reg, 0, (S32) s16);  break;
	jr	@350
	.debug	# 1158
@355:
	ld	hl,(ix-5)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@782
;1159         case DT_U32:  setRegU32(reg, 0, (U32) s16);  break;
	.debug	# 1159
@356:
	ld	hl,(ix-5)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@782
;1160         case DT_F32:  setRegF32(reg, 0, (F32) s16);  break;
	.debug	# 1160
@357:
	ld	hl,(ix-5)
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@782:
	add	sp,8
;1161         default:  return -1;
	jr	@350
	.debug	# 1161
@358:
	jp	@417
;1162       }
@352:
	.debug	>
;1163       return 0;
@349:
	or	a,a
	jr	z,@353
	cp	0x1
	jr	z,@354
	cp	0x2
	jr	z,@355
	cp	0x3
	jr	z,@356
	cp	0x4
	jr	z,@357
	jr	@358
@350:
	.debug	# 1163
	jp	@409
;1164 
;1165     case DT_U16:
;1166       if (fromSize < 2)  return -1;
	.debug	# 1166
@359:
	ld	hl,(ix+9)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@417
;1167       u16 = FROM_VAL(U16);
	.debug	# 1167
	ld	hl,(ix+11)
	ld	hl,(hl)
	ld	(ix-3),hl
;1168 //      printf("DT_U16: [%u]\r\n", u16);  //tdebug
;1169       switch (toType)  {
	.debug	# 1169
	ld	a,(ix-1)
	jr	@361
;1170         case DT_S16:  setRegS16(reg, 0, (S16) u16);  break;
@363:
	.debug	< @363 @364
	.debug	# 1170
@365:
	ld	hl,(ix-3)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@781
;1171         case DT_U16:  setRegU16(reg, 0, (U16) u16);  break;
	.debug	# 1171
@366:
	ld	hl,(ix-3)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@781:
	add	sp,6
;1172         case DT_S32:  setRegS32(reg, 0, (S32) u16);  break;
	jr	@362
	.debug	# 1172
@367:
	ld	hl,(ix-3)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@780
;1173         case DT_U32:  setRegU32(reg, 0, (U32) u16);  break;
	.debug	# 1173
@368:
	ld	hl,(ix-3)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@780
;1174         case DT_F32:  setRegF32(reg, 0, (F32) u16);  break;
	.debug	# 1174
@369:
	ld	hl,(ix-3)
	ex	de,hl
	call	__uitof##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@780:
	add	sp,8
;1175         default:  return -1;
	jr	@362
	.debug	# 1175
@370:
	jp	@417
;1176       }
@364:
	.debug	>
;1177       return 0;
@361:
	or	a,a
	jr	z,@365
	cp	0x1
	jr	z,@366
	cp	0x2
	jr	z,@367
	cp	0x3
	jr	z,@368
	cp	0x4
	jr	z,@369
	jr	@370
@362:
	.debug	# 1177
	jp	@409
;1178 
;1179     case DT_S32:
;1180       if (fromSize < 4)  return -1;
	.debug	# 1180
@371:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@417
;1181       s32 = FROM_VAL(S32);
	.debug	# 1181
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;1182 //      printf("DT_S32: [%ld]\r\n", s32);  //tdebug
;1183       switch (toType)  {
	.debug	# 1183
	ld	a,(ix-1)
	jr	@373
;1184         case DT_S16:  setRegS16(reg, 0, (S16) s32);  break;
@375:
	.debug	< @375 @376
	.debug	# 1184
@377:
	ld	hl,(ix-13)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@779
;1185         case DT_U16:  setRegU16(reg, 0, (U16) s32);  break;
	.debug	# 1185
@378:
	ld	hl,(ix-13)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@779:
	add	sp,6
;1186         case DT_S32:  setRegS32(reg, 0, (S32) s32);  break;
	jr	@374
	.debug	# 1186
@379:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@778
;1187         case DT_U32:  setRegU32(reg, 0, (U32) s32);  break;
	.debug	# 1187
@380:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@778
;1188         case DT_F32:  setRegF32(reg, 0, (F32) s32);  break;
	.debug	# 1188
@381:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	call	__ltof##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@778:
	add	sp,8
;1189         default:  return -1;
	jr	@374
	.debug	# 1189
@382:
	jp	@417
;1190       }
@376:
	.debug	>
;1191       return 0;
@373:
	or	a,a
	jr	z,@377
	cp	0x1
	jr	z,@378
	cp	0x2
	jr	z,@379
	cp	0x3
	jr	z,@380
	cp	0x4
	jr	z,@381
	jr	@382
@374:
	.debug	# 1191
	jp	@409
;1192 
;1193     case DT_U32:
;1194       if (fromSize < 4)  return -1;
	.debug	# 1194
@383:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@417
;1195       u32 = FROM_VAL(U32);
	.debug	# 1195
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
;1196 //      printf("DT_U32: [%lu]\r\n", u32);  //tdebug
;1197       switch (toType)  {
	.debug	# 1197
	ld	a,(ix-1)
	jr	@385
;1198         case DT_S16:  setRegS16(reg, 0, (S16) u32);  break;
@387:
	.debug	< @387 @388
	.debug	# 1198
@389:
	ld	hl,(ix-9)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@777
;1199         case DT_U16:  setRegU16(reg, 0, (U16) u32);  break;
	.debug	# 1199
@390:
	ld	hl,(ix-9)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@777:
	add	sp,6
;1200         case DT_S32:  setRegS32(reg, 0, (S32) u32);  break;
	jr	@386
	.debug	# 1200
@391:
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@776
;1201         case DT_U32:  setRegU32(reg, 0, (U32) u32);  break;
	.debug	# 1201
@392:
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@776
;1202         case DT_F32:  setRegF32(reg, 0, (F32) u32);  break;
	.debug	# 1202
@393:
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@776:
	add	sp,8
;1203         default:  return -1;
	jr	@386
	.debug	# 1203
@394:
	jp	@417
;1204       }
@388:
	.debug	>
;1205       return 0;
@385:
	or	a,a
	jr	z,@389
	cp	0x1
	jr	z,@390
	cp	0x2
	jr	z,@391
	cp	0x3
	jr	z,@392
	cp	0x4
	jr	z,@393
	jr	@394
@386:
	.debug	# 1205
	jp	@409
;1206 
;1207     case DT_F32:
;1208       if (fromSize < 4)  return -1;
	.debug	# 1208
@395:
	ld	hl,(ix+9)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@417
;1209       f32 = FROM_VAL(F32);
	.debug	# 1209
	ld	hl,(ix+11)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;1210 //      printf("DT_F32: [%.32s]\r\n", Engineering(f32, 6, temp));  //tdebug
;1211       switch (toType)  {
	.debug	# 1211
	ld	a,(ix-1)
	jr	@397
;1212         case DT_S16:  setRegS16(reg, 0, (S16) f32);  break;
@399:
	.debug	< @399 @400
	.debug	# 1212
@401:
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@775
;1213         case DT_U16:  setRegU16(reg, 0, (U16) f32);  break;
	.debug	# 1213
@402:
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@775:
	add	sp,6
;1214         case DT_S32:  setRegS32(reg, 0, (S32) f32);  break;
	jr	@398
	.debug	# 1214
@403:
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@774
;1215         case DT_U32:  setRegU32(reg, 0, (U32) f32);  break;
	.debug	# 1215
@404:
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@774
;1216         case DT_F32:  setRegF32(reg, 0, (F32) f32);  break;
	.debug	# 1216
@405:
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@774:
	add	sp,8
;1217         default:  return -1;
	jr	@398
	.debug	# 1217
@406:
	jp	@417
;1218       }
@400:
	.debug	>
;1219       return 0;
@397:
	or	a,a
	jr	z,@401
	cp	0x1
	jr	z,@402
	cp	0x2
	jr	z,@403
	cp	0x3
	jr	z,@404
	cp	0x4
	jr	z,@405
	jr	@406
@398:
	.debug	# 1219
	jp	@409
;1220 
;1221     case DT_STR:
;1222 //      printf("DT_STR: [%.32s]\r\n", fromVal);  //tdebug
;1223       switch (toType)  {
	.debug	# 1223
@407:
	ld	a,(ix-1)
	jp	@408
;1224         case DT_S16:  setRegS16(reg, 0, (S16) ATOI(fromVal));   break;
@410:
	.debug	< @410 @411
	.debug	# 1224
@412:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$strtoi
	add	sp,6
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS16
	jr	@773
;1225         case DT_U16:  setRegU16(reg, 0, (U16) ATOU(fromVal));   break;
	.debug	# 1225
@413:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$strtoui
	add	sp,6
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
@773:
	add	sp,6
;1226         case DT_S32:  setRegS32(reg, 0, (S32) ATOL(fromVal));   break;
	jr	@409
	.debug	# 1226
@414:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$strtol
	add	sp,6
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegS32
	jr	@772
;1227         case DT_U32:  setRegU32(reg, 0, (U32) ATOUL(fromVal));  break;
	.debug	# 1227
@415:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	lcall	$strtoul
	add	sp,6
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU32
	jr	@772
;1228         case DT_F32:  setRegF32(reg, 0, (F32) atof(fromVal));   break;
	.debug	# 1228
@416:
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+11)
	push	hl
	call	_strtod
	add	sp,4
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegF32
@772:
	add	sp,8
;1229         default:  return -1;
	jr	@409
	.debug	# 1229
@417:
	ld	hl,0xffff
	jr	@333
;1230       }
@411:
	.debug	>
;1231       return 0;
@408:
	or	a,a
	jp	z,@412
	cp	0x1
	jr	z,@413
	cp	0x2
	jr	z,@414
	cp	0x3
	jr	z,@415
	cp	0x4
	jr	z,@416
	jr	@417
@409:
	.debug	# 1231
	bool	hl
	ld	l,h
	jr	@333
;1232   }
@346:
	.debug	>
;1233 
;1234   return -1;
@343:
	ld	bc,hl
	ld	de,-6
	add	hl,de
	jr	c,@344
	ld	hl,@418
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@418:
	dw	@347
	dw	@359
	dw	@371
	dw	@383
	dw	@395
	dw	@407
	.seg	FARCODE
@344:
	.debug	# 1234
	ld	hl,0xffff
;1235 }
@333:
	.debug	} @333 1235

@332	equ	25
	ld	sp,ix
	pop	ix
	lret
@334	equ	27
;1236 
;1237 //-------------------------------------------------------------------------
;1238 //  Test all the PV values in the specified list to see which (if any) of t
;1239 //  events we are looking for have occured since we last checked.
;1240 //
;1241 //  For each event that occured, the corresponding bit in the PV's
;1242 //  eventsOccured bitmask is set.
;1243 //
;1244 //  This function clears the checkEvents bitmap for each PV after it
;1245 //  checks for the specified events.  The application must call pvCheckEven
;1246 //  for each PV to see which events happened and to re-assert the bits of
;1247 //  interest in the checkEvents bitmap.
;1248 //
;1249 //  This function returns a count of the number of events that occured.
;1250 //-------------------------------------------------------------------------
;1251 int regTestEvents(RegInfo **regs, bool anyChg)
;1252 {
$regTestEvents::
	.debug	G $regTestEvents 77 9
	.debug	{ $regTestEvents 77 1251 @421 @420
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-19
	.debug	A regs 5 57
	.debug	A anyChg 7 3
;1253   bool  occured;
	.debug	L occured -1 3
;1254   int  numEvents = 0;
	.debug	L numEvents -3 6
	.debug	# 1254
	bool	hl
	ld	l,h
	ld	(ix-3),hl
	.seg	FARCODE
;1255   uint  u;
	.debug	L u -5 7
;1256   S16  diffS16;
	.debug	L diffS16 -7 4
;1257   S32  diffS32;
	.debug	L diffS32 -11 8
;1258   F32  diffF32;
	.debug	L diffF32 -15 10
;1259   RegInfo  *reg, *lastReg;
	.debug	L reg -17 39
	.debug	L lastReg -19 39
;1260 
;1261 #define S16_(val)   (*(S16 *)reg->val)
;1262 #define U16_(val)   (*(U16 *)reg->val)
;1263 #define S32_(val)   (*(S32 *)reg->val)
;1264 #define U32_(val)   (*(U32 *)reg->val)
;1265 #define F32_(val)   (*(F32 *)reg->val)
;1266 
;1267 
;1268   lastReg = NULL;
	.debug	# 1268
	ld	(ix-19),hl
;1269   for (u=0,reg=regs[0]; reg; ++u,reg=regs[u])  {
@422:
	.debug	< @422 @423
	.debug	# 1269
	ld	(ix-5),hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-17),hl
@424:
	ld	hl,(ix-17)
	bool	hl
	jp	z,@425
;1270     if (reg == lastReg)  continue;  // skip if not 1st in multi-reg value
@427:
	.debug	< @427 @428
	.debug	# 1270
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	z,@426
;1271 
;1272     KLOCK();
	.debug	# 1272
	call	_KLOCK
;1273 
;1274     reg->eventsOccured = 0;
	.debug	# 1274
	ld	hl,(ix-17)
	ld	de,0xf
	add	hl,de
	xor	a,a
	ld	(hl),a
;1275 
;1276     if (!reg->checkEvents)  {  KUNLOCK();  continue; }
	.debug	# 1276
	ld	hl,(ix-17)
	dec	e
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@430
@431:
	.debug	< @431 @432
	call	_KUNLOCK
	jp	@426
@432:
	.debug	>
;1277 
;1278 
;1279     if (reg->checkEvents & DBE_VALUE)  {
@430:
	.debug	# 1279
	ld	hl,(ix-17)
	ld	de,0xe
	add	hl,de
	ld	a,(hl)
	and	a,1
	jp	z,@433
;1280 
;1281       if (anyChg)
@434:
	.debug	< @434 @435
	.debug	# 1281
	ld	a,(ix+7)
	or	a,a
	jr	z,@436
;1282         occured = memcmp(reg->lastChgVal, reg->regVal, reg->numRegs << 1);
	.debug	# 1282
	ld	hl,(ix-17)
	ld	e,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	push	hl
	ld	hl,(ix-17)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-17)
	ld	e,0x10
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_memcmp
	add	sp,6
	ld	(ix-1),l
;1283       else  {
	jp	@437
@436:
;1284         occured = false;
@438:
	.debug	< @438 @439
	.debug	# 1284
	xor	a,a
	ld	(ix-1),a
;1285 
;1286         switch (reg->dataType)  {
	.debug	# 1286
	ld	hl,(ix-17)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	jp	@440
;1287           case DT_S16:
@442:
	.debug	< @442 @443
;1288           case DT_U16:
	.debug	# 1288
@444:
;1289             diffS16 = S16_(regVal) - S16_(lastChgVal);
	.debug	# 1289
@445:
	ld	hl,(ix-17)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x10
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	(ix-7),hl
;1290             if (abs(diffS16) >= S16_(minChg))  occured = true;
	.debug	# 1290
	push	hl
	call	_abs
	pop	de
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x12
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,bc
	call	__icmp##
	jr	c,@446
	ld	(ix-1),0x1
;1291             break;
@446:
	.debug	# 1291
;1292 
;1293           case DT_S32:
	jp	@441
;1294           case DT_U32:
	.debug	# 1294
@447:
;1295             diffS32 = S32_(regVal) - S32_(lastChgVal);
	.debug	# 1295
@448:
	ld	hl,(ix-17)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x10
	add	hl,de
	ld	hl,(hl)
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;1296             if (labs(diffS32) >= S32_(minChg))  occured = true;
	.debug	# 1296
	push	bc
	push	de
	call	_labs
	add	sp,4
	ld	hl,(ix-17)
	push	bc
	push	de
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lcmp##
	jr	c,@441
	jr	@771
;1297             break;
	.debug	# 1297
;1298 
;1299           case DT_F32:
;1300             diffF32 = F32_(regVal) - F32_(lastChgVal);
	.debug	# 1300
@450:
	ld	hl,(ix-17)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x10
	add	hl,de
	ld	hl,(hl)
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,bc
	ld	(ix-13),hl
	ex	de,hl
	ld	(ix-15),hl
	ex	de,hl
;1301             if (fabs(diffF32) >= F32_(minChg))  occured = true;
	.debug	# 1301
	push	bc
	push	de
	call	_fabs
	add	sp,4
	ld	hl,(ix-17)
	push	bc
	push	de
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	jp	m,@441
@771:
	ld	a,0x1
	ld	(ix-1),a
;1302             break;
	.debug	# 1302
;1303         }
	jr	@441
@443:
	.debug	>
;1304 
;1305       }
@440:
	or	a,a
	jp	z,@444
	cp	0x1
	jp	z,@445
	cp	0x2
	jp	z,@447
	cp	0x3
	jp	z,@448
	cp	0x4
	jr	z,@450
@441:
@439:
	.debug	>
;1306       if (occured)  {
@437:
	.debug	# 1306
	ld	a,(ix-1)
	or	a,a
	jr	z,@452
;1307         memcpy(reg->lastChgVal, reg->regVal, reg->numRegs << 1);
@453:
	.debug	< @453 @454
	.debug	# 1307
	ld	hl,(ix-17)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	push	hl
	ld	hl,(ix-17)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-17)
	ld	e,0x10
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_memcpy
	add	sp,6
;1308         reg->eventsOccured |= DBE_VALUE;  ++numEvents;
	.debug	# 1308
	ld	hl,(ix-17)
	ld	de,0xf
	add	hl,de
	set	0,(hl)
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
;1309       }
@454:
	.debug	>
;1310 
;1311     }
@452:
@435:
	.debug	>
;1312 
;1313     lastReg = reg;  reg->checkEvents = 0;
@433:
	.debug	# 1313
	ld	hl,(ix-17)
	ld	(ix-19),hl
	ld	de,0xe
	add	hl,de
	xor	a,a
	ld	(hl),a
;1314 
;1315     KUNLOCK();
	.debug	# 1315
	call	_KUNLOCK
;1316   }
@428:
	.debug	>
;1317 
;1318   return numEvents;
@426:
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-5),hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	ld	(ix-17),hl
	jp	@424
@425:
@423:
	.debug	>
	.debug	# 1318
	ld	hl,(ix-3)
;1319 }
@420:
	.debug	} @420 1319

@419	equ	19
	ld	sp,ix
	pop	ix
	lret
@421	equ	21
;1320 
;1321 //-------------------------------------------------------------------------
;1322 //  Check all the registers with subscriptions for a change in value since
;1323 //  the last time this function was called.
;1324 //
;1325 //  If anyChg is true, then any change at all in a PV value will cause the
;1326 //  value change bit to be changed in the eventsOccured mask for the PV.
;1327 //
;1328 //  Otherwise, it uses the minChg value for each PV as the basis for whethe
;1329 //  or not the value change bit should set for the PV.
;1330 //-------------------------------------------------------------------------
;1331 void pvCheckAllEvents(time_t *dateTime, uint *ms, bool anyChg)
;1332 {
$pvCheckAllEvents::
	.debug	G $pvCheckAllEvents 78 9
	.debug	{ $pvCheckAllEvents 78 1331 @457 @456
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A dateTime 5 79
	.debug	A ms 7 80
	.debug	A anyChg 9 3
;1333   uint  u, ttlExtBytes;
	.debug	L u -2 7
	.debug	L ttlExtBytes -4 7
;1334   PV_Desc  *pv;
	.debug	L pv -6 69
;1335   static int  nextExtPV = 0;
	.dseg
@458:
	.dw	0
	.debug	S nextExtPV @458 6
	.seg	FARCODE
;1336 
;1337 
;1338 //--- update eventsOccured mask for PVs defined as ModBus registers ---
;1339   regTestEvents(r3Regs, anyChg);
	.debug	# 1339
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,_r3Regs
	push	hl
	lcall	$regTestEvents
	add	sp,4
;1340   regTestEvents(r4Regs, anyChg);
	.debug	# 1340
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,_r4Regs
	push	hl
	lcall	$regTestEvents
	add	sp,4
;1341 
;1342 //--- update eventsOccured mask for all other PVs ---
;1343 //NOTE:  nonReg values are responsible for updating their own newEvents mas
;1344   for (pv=nonRegPVs; pv->val; ++pv)  pv->eventsOccured = 0;
@459:
	.debug	< @459 @460
	.debug	# 1344
	ld	hl,_nonRegPVs
	ld	(ix-6),hl
@461:
	ld	hl,(ix-6)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@462
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	xor	a,a
	ld	(hl),a
;1345 
;1346   ttlExtBytes = 0;
	ld	hl,(ix-6)
	ld	e,0x1d
	add	hl,de
	ld	(ix-6),hl
	jr	@461
@462:
@460:
	.debug	>
	.debug	# 1346
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;1347   for (u=0; u<numNonRegPVs; ++u)  {
@464:
	.debug	< @464 @465
	.debug	# 1347
	ld	(ix-2),hl
@466:
	ld	hl,(ix-2)
	ld	de,(_numNonRegPVs)
	or	a,a
	sbc	hl,de
	jp	nc,@467
;1348     pv = nonRegPVs + nextExtPV;
@469:
	.debug	< @469 @470
	.debug	# 1348
	ld	hl,(@458)
	ld	bc,0x1d
	ex	de,hl
	mul
	ld	hl,_nonRegPVs
	add	hl,bc
	ld	(ix-6),hl
;1349     if (pv->updateVal)  (*pv->updateVal)(pv);
	.debug	# 1349
	ld	de,0x15
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@471
	ld	hl,(ix-6)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x15
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	pop	de
;1350 
;1351     _EnterCritical_();
@471:
	.debug	# 1351
	ipset	2
;1352     pv->eventsOccured = pv->newEvents;  pv->newEvents = 0;
	.debug	# 1352
	ld	hl,(ix-6)
	ld	de,0x13
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x14
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
	ld	h,d
	ld	l,e
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
;1353     _ExitCritical_();
	.debug	# 1353
	ipres
;1354 
;1355     if (++nextExtPV == numNonRegPVs)  nextExtPV = 0;
	.debug	# 1355
	ld	hl,(@458)
	inc	hl
	ld	(@458),hl
	ld	de,(_numNonRegPVs)
	or	a,a
	sbc	hl,de
	jr	nz,@472
	bool	hl
	ld	l,h
	ld	(@458),hl
;1356 
;1357     // limit # of events we process in one pass based on ttl # of bytes
;1358     if (pv->eventsOccured)  {
@472:
	.debug	# 1358
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@473
;1359       ttlExtBytes += pv->pvInfo.size;
@474:
	.debug	< @474 @475
	.debug	# 1359
	ld	hl,(ix-6)
	ld	e,0x5
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
;1360       if (ttlExtBytes > 1000)  break;
	.debug	# 1360
	ld	de,0x3e8
	or	a,a
	sbc	hl,de
	jr	c,@476
	jr	nz,@467
;1361     }
@476:
@475:
	.debug	>
;1362   }
@473:
@470:
	.debug	>
;1363 
;1364   _EnterCritical_();  *dateTime = TIME();  *ms = milliTicks;  _ExitCritical
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@466
@467:
@465:
	.debug	>
	.debug	# 1364
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(_milliTicks)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
;1365 }
@456:
	.debug	} @456 1365

@455	equ	6
	ld	sp,ix
	pop	ix
	lret
@457	equ	8
;1366 
;1367 
;1368 //-------------------------------------------------------------------------
;1369 //  Check a PV for the specified events and update the mask that determines
;1370 //  which events to check for next time pvCheckAllEvents() is called.
;1371 //
;1372 //  Returns value:
;1373 //    If no events occured: 0
;1374 //    If events occured:  bitmask of the events that occured
;1375 //    If an error: < 0
;1376 //-------------------------------------------------------------------------
;1377 int pvCheckEvents(int id, uint checkEvents)
;1378 {
$pvCheckEvents::
	.debug	G $pvCheckEvents 81 9
	.debug	{ $pvCheckEvents 81 1377 @479 @478
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A id 5 6
	.debug	A checkEvents 7 7
;1379   RegInfo *reg;
	.debug	L reg -2 39
;1380   PV_Ref far  *pvRef;
	.debug	L pvRef -6 61
;1381   PV_Desc  *pv;
	.debug	L pv -8 69
;1382 
;1383 
;1384   if ((uint)id >= numPVs)  return 0;  //temp - so no error for temp "fake" 
	.debug	# 1384
	ld	hl,(ix+5)
	ld	de,(_numPVs)
	or	a,a
	sbc	hl,de
	jr	c,@480
	bool	hl
	ld	l,h
	jp	@478
;1385 //  if ((uint)id >= numPVs)  return -1;  //finish
;1386 
;1387   pvRef = pvList + (uint)id;
@480:
	.debug	# 1387
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x3
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;1388 
;1389   switch (pvRef->pvType)  {
	.debug	# 1389
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jr	@481
;1390 
;1391     case PVT_REG:
@483:
	.debug	< @483 @484
;1392       reg = (RegInfo *)pvRef->pvDef;
	.debug	# 1392
@485:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
;1393       reg->checkEvents |= checkEvents;
	.debug	# 1393
	ld	de,0xe
	add	hl,de
	push	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
;1394       return (int) (reg->eventsOccured & checkEvents);
	.debug	# 1394
	ld	hl,(ix-2)
	ld	de,0xf
	jr	@770
;1395 
;1396     case PVT_EXT:
;1397       pv = (PV_Desc *)pvRef->pvDef;
	.debug	# 1397
@486:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-8),hl
;1398       return (int) (pv->eventsOccured & checkEvents);
	.debug	# 1398
	ld	de,0x14
@770:
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	and	hl,de
	jr	@478
;1399   }
@484:
	.debug	>
;1400 
;1401   return -1;
@481:
	cp	0x1
	jr	z,@485
	cp	0x2
	jr	z,@486
@482:
	.debug	# 1401
	ld	hl,0xffff
;1402 }
@478:
	.debug	} @478 1402

@477	equ	8
	ld	sp,ix
	pop	ix
	lret
@479	equ	10
;1403 
;1404 
;1405 
;1406 //-------------------------------------------------------------------------
;1407 //  Process a ModBus command
;1408 //-------------------------------------------------------------------------
;1409 int ModBusCmd(uchar clientType, char *cmdBuf,
;1410               char *respBuf, int *respLen, fd_t eventsfd)
;1411 {
$ModBusCmd::
	.debug	G $ModBusCmd 82 9
	.debug	{ $ModBusCmd 82 1409 @489 @488
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-95
	.debug	A clientType 5 3
	.debug	A cmdBuf 7 33
	.debug	A respBuf 9 33
	.debug	A respLen 11 83
	.debug	A eventsfd 13 6
;1412   int  i, cmdLen, firstReg, numRegs, funcCode, regNum, regVal,
	.debug	L i -2 6
	.debug	L cmdLen -4 6
	.debug	L firstReg -6 6
	.debug	L numRegs -8 6
	.debug	L funcCode -10 6
	.debug	L regNum -12 6
	.debug	L regVal -14 6
;1413        respBytes, coilNum, firstCoil, numCoils, chanNum, chNum, ttlLen;
	.debug	L respBytes -16 6
	.debug	L coilNum -18 6
	.debug	L firstCoil -20 6
	.debug	L numCoils -22 6
	.debug	L chanNum -24 6
	.debug	L chNum -26 6
	.debug	L ttlLen -28 6
;1414 //  int  transId, slaveAddr, byteCount, protocolId;
;1415   int  idx, offset, wordIdx;
	.debug	L idx -30 6
	.debug	L offset -32 6
	.debug	L wordIdx -34 6
;1416   uint  cliOffset;
	.debug	L cliOffset -36 7
;1417   bool  cmdOK, accepted;
	.debug	L cmdOK -37 3
	.debug	L accepted -38 3
;1418   uchar  coilVal;
	.debug	L coilVal -39 3
;1419   RegInfo  *reg;
	.debug	L reg -41 39
;1420   CoilInfo  *coil;
	.debug	L coil -43 46
;1421   uchar  *bufPtr;
	.debug	L bufPtr -45 33
;1422   ClientOrder  *cliOrder;
	.debug	L cliOrder -47 84
;1423   U16  logicalVal[8];
	.debug	L logicalVal -63 85
;1424   char  temp[32];
	.debug	L temp -95 86
;1425 
;1426 
;1427 
;1428   *respLen = respBytes = 0;
	.debug	# 1428
	bool	hl
	ld	l,h
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1429 
;1430 //  transId = GetShort_(cmdBuf, 0);
;1431 //  protocolId = GetShort_(cmdBuf, 2);
;1432   cmdLen = GetShort_(cmdBuf, 4);
	.debug	# 1432
	ld	hl,0x4
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-4),hl
;1433 //  slaveAddr = cmdBuf[6];
;1434   funcCode = cmdBuf[7];
	.debug	# 1434
	ld	hl,(ix+7)
	ld	de,0x7
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-10),hl
;1435 
;1436   ttlLen = cmdLen + 6;  // cmdLen value bound's checked by caller
	.debug	# 1436
	ld	hl,(ix-4)
	dec	e
	add	hl,de
	ld	(ix-28),hl
;1437   memcpy(respBuf, cmdBuf, ttlLen);
	.debug	# 1437
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_memcpy
	add	sp,6
;1438 
;1439 // Note that "respBytes" should be set to the # bytes following the func co
;1440 // in the respBuf (the func code is at offset 7)
;1441 
;1442 //  fprintf(DiagLog, "Got ModBus cmd func: %d\r\n", funcCode);  //tdebug
;1443 
;1444   cmdOK = false;
	.debug	# 1444
	xor	a,a
	ld	(ix-37),a
;1445   switch (funcCode)  {
	.debug	# 1445
	ld	hl,(ix-10)
	jp	@490
;1446 
;1447 //=================================================
;1448 // === read coils (single bits) (0xxxx series) ===
;1449 //=================================================
;1450     case 1:
@492:
	.debug	< @492 @493
;1451       if (cmdLen < 6)  break;
	.debug	# 1451
@494:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1452 
;1453       firstCoil = GetShort_(cmdBuf, 8);  numCoils = GetShort_(cmdBuf, 10);
	.debug	# 1453
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-20),hl
	ld	hl,0xa
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-22),hl
;1454       respBytes = (numCoils + 7) / 8;
	.debug	# 1454
	ld	de,0x7
	add	hl,de
	ld	b,3
@496:
	sra	h
	rr	l
	djnz	@496
	ld	(ix-16),hl
;1455 
;1456       if (ShowReads)
	.debug	# 1456
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@497
;1457         fprintf(DiagLog, "Read coils: %05d - %05d\r\n",
;1458                           firstCoil, firstCoil + numCoils - 1);
	.debug	# 1458
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	add	hl,de
	dec	hl
	push	hl
	ld	hl,(ix-20)
	push	hl
	ld	de,word (phys @22+406)
	ld	c,phys @22+406 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1459 
;1460       chanNum = firstCoil / C0ChanMult;  firstCoil = firstCoil % C0ChanMult
@497:
	.debug	# 1460
	ld	hl,(ix-20)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-20)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-20),hl
;1461 
;1462       if (respBytes > MaxRespMsgLen-10)  {
	.debug	# 1462
	ld	hl,(ix-16)
	ld	de,0x80f6
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@498
	jr	z,@498
;1463         fprintf(DiagLog, "Response too long\r\n");
@499:
	.debug	< @499 @500
	.debug	# 1463
	ld	de,word (phys @22+432)
	ld	c,phys @22+432 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1464         respBytes = 1;
	.debug	# 1464
	ld	hl,0x1
	ld	(ix-16),hl
;1465         respBuf[7] |= 0x80;  // top bit on indicates exception
	.debug	# 1465
	ld	hl,(ix+9)
	ld	de,0x7
	add	hl,de
	set	7,(hl)
;1466         respBuf[8] = 2;
	.debug	# 1466
	ld	hl,(ix+9)
	inc	e
	jp	@769
;1467         cmdOK = true;  break;
	.debug	# 1467
;1468       }
@500:
	.debug	>
;1469 
;1470       respBuf[8] = respBytes;
@498:
	.debug	# 1470
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ld	a,(ix-16)
	ld	(hl),a
;1471 
;1472       bufPtr = respBuf + 9;
	.debug	# 1472
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	ld	(ix-45),hl
;1473       memset(bufPtr, 0, respBytes);
	.debug	# 1473
	ld	hl,(ix-16)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-45)
	push	hl
	call	_memset
	add	sp,6
;1474 
;1475     //--- note that range may cross chanNum boundaries ---
;1476       chanNum = firstCoil / C0ChanMult;  coilNum = firstCoil % C0ChanMult;
	.debug	# 1476
	ld	hl,(ix-20)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-20)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-18),hl
;1477       KLOCK();
	.debug	# 1477
	call	_KLOCK
;1478       for (i=0; i<numCoils; ++i)  {
@501:
	.debug	< @501 @502
	.debug	# 1478
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@503:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	call	__icmp##
	jp	nc,@504
;1479         coilVal = 0;
@506:
	.debug	< @506 @507
	.debug	# 1479
	xor	a,a
	ld	(ix-39),a
;1480         for (;;)  {
@508:
	.debug	< @508 @509
;1481           if (chanNum >= NumC0Chans)  break;
@513:
	.debug	< @513 @514
	.debug	# 1481
	ld	hl,(ix-24)
	ld	de,(_NumC0Chans)
	or	a,a
	sbc	hl,de
	jr	nc,@511
;1482           if (coilNum >= numC0Coils)  break;
	.debug	# 1482
	ld	hl,(ix-18)
	ld	de,(_numC0Coils)
	or	a,a
	sbc	hl,de
	jr	nc,@511
;1483           coil = c0Coils[coilNum];
	.debug	# 1483
	ld	hl,(ix-18)
	add	hl,hl
	ld	de,_c0Coils
	add	hl,de
	ld	hl,(hl)
	ld	(ix-43),hl
;1484           chNum = ((uint)coil->flags & OnePerChan ? chanNum : 0);
	.debug	# 1484
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@517
	ld	hl,(ix-24)
	jr	@518
@517:
	bool	hl
	ld	l,h
@518:
	ld	(ix-26),hl
;1485           coilVal = coil->coilVal[chNum];
	.debug	# 1485
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	a,(hl)
	ld	(ix-39),a
;1486           break;
	.debug	# 1486
;1487         }
@514:
	.debug	>
;1488         if (coilVal)  SetBit(bufPtr, i);
@511:
@509:
	.debug	>
	.debug	# 1488
	ld	a,(ix-39)
	or	a,a
	jr	z,@519
	ld	hl,(ix-2)
	ld	de,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@520
	ld	b,a
@521:
	add	hl,hl
	djnz	@521
@520:
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	b,3
@522:
	sra	d
	rr	e
	djnz	@522
	ld	bc,hl
	ld	hl,(ix-45)
	add	hl,de
	push	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,bc
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
;1489         if (++coilNum == C0ChanMult)  { coilNum = 0;  ++chanNum; }
@519:
	.debug	# 1489
	ld	hl,(ix-18)
	inc	hl
	ld	(ix-18),hl
	ld	de,(_C0ChanMult)
	or	a,a
	sbc	hl,de
	jr	nz,@523
@524:
	.debug	< @524 @525
	bool	hl
	ld	l,h
	ld	(ix-18),hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
@525:
	.debug	>
;1490       }
@523:
@507:
	.debug	>
;1491       KUNLOCK();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@503
@504:
@502:
	.debug	>
	.debug	# 1491
	call	_KUNLOCK
;1492       ++respBytes;
	.debug	# 1492
	ld	hl,(ix-16)
	inc	hl
	jp	@767
;1493 
;1494       cmdOK = true;  break;
	.debug	# 1494
;1495 
;1496 
;1497 //=====================================================
;1498 // === read multiple R/W registers (4xxxx series) ===
;1499 //=====================================================
;1500     case 3:
;1501       if (cmdLen < 6)  break;
	.debug	# 1501
@526:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1502 
;1503       firstReg = GetShort_(cmdBuf, 8);  numRegs = GetShort_(cmdBuf, 10);
	.debug	# 1503
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-6),hl
	ld	hl,0xa
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-8),hl
;1504 
;1505       if (ShowReads)
	.debug	# 1505
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@528
;1506         fprintf(DiagLog, "Read Regs: 4%04d - 4%04d\r\n",
;1507                           firstReg, firstReg + numRegs - 1);
	.debug	# 1507
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	add	hl,de
	dec	hl
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @22+452)
	ld	c,phys @22+452 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1508 
;1509       respBytes = numRegs * 2;
@528:
	.debug	# 1509
	ld	hl,(ix-8)
	add	hl,hl
	ld	(ix-16),hl
;1510 
;1511       if (respBytes > MaxRespMsgLen-10)  {
	.debug	# 1511
	ld	de,0x80f6
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@529
	jr	z,@529
;1512         fprintf(DiagLog, "Response too long\r\n");
@530:
	.debug	< @530 @531
	.debug	# 1512
	ld	de,word (phys @22+432)
	ld	c,phys @22+432 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1513         respBytes = 1;
	.debug	# 1513
	ld	hl,0x1
	ld	(ix-16),hl
;1514         respBuf[7] |= 0x80;  // top bit on indicates exception
	.debug	# 1514
	ld	hl,(ix+9)
	ld	de,0x7
	add	hl,de
	set	7,(hl)
;1515         respBuf[8] = 2;
	.debug	# 1515
	ld	hl,(ix+9)
	inc	e
@769:
	add	hl,de
	ld	a,0x2
	ld	(hl),a
;1516         cmdOK = true;  break;
	.debug	# 1516
	jp	@768
;1517       }
@531:
	.debug	>
;1518 
;1519       respBuf[8] = respBytes;  ++respBytes;
@529:
	.debug	# 1519
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ld	a,(ix-16)
	ld	(hl),a
	ld	hl,(ix-16)
	inc	hl
	ld	(ix-16),hl
;1520       memset(respBuf + 9, 0, respBytes);
	.debug	# 1520
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	push	hl
	call	_memset
	add	sp,6
;1521 
;1522     //--- note that range of registers may cross chanNum boundaries ---
;1523       chanNum = firstReg / R4ChanMult;  regNum = firstReg % R4ChanMult;
	.debug	# 1523
	ld	hl,(ix-6)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-6)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-12),hl
;1524       offset = 9;  cliOrder = (ClientOrder *)(&regOrder[clientType][0][0]);
	.debug	# 1524
	ld	hl,0x9
	ld	(ix-32),hl
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_regOrder
	add	hl,bc
	ld	(ix-47),hl
;1525       KLOCK();
	.debug	# 1525
	call	_KLOCK
;1526       for (i=0; i<numRegs; ++i)  {
@532:
	.debug	< @532 @533
	.debug	# 1526
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@534:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	call	__icmp##
	jp	nc,@563
;1527         regVal = 0;
@537:
	.debug	< @537 @538
	.debug	# 1527
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;1528         for (;;)  {
@539:
	.debug	< @539 @540
;1529           if (chanNum >= NumR4Chans)  break;
@544:
	.debug	< @544 @545
	.debug	# 1529
	ld	hl,(ix-24)
	ld	de,(_NumR4Chans)
	or	a,a
	sbc	hl,de
	jp	nc,@542
;1530           if (regNum >= numR4Regs)  break;
	.debug	# 1530
	ld	hl,(ix-12)
	ld	de,(_numR4Regs)
	or	a,a
	sbc	hl,de
	jr	nc,@542
;1531           reg = r4Regs[regNum];
	.debug	# 1531
	ld	hl,(ix-12)
	add	hl,hl
	ld	de,_r4Regs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-41),hl
;1532           chNum = ((uint)reg->flags & OnePerChan ? chanNum : 0);
	.debug	# 1532
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@548
	ld	hl,(ix-24)
	jr	@549
@548:
	bool	hl
	ld	l,h
@549:
	ld	(ix-26),hl
;1533           wordIdx = regNum - reg->regNum;  // which word in multi-word valu
	.debug	# 1533
	ld	hl,(ix-41)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-12)
	or	a,a
	sbc	hl,de
	ld	(ix-34),hl
;1534           idx = wordIdx + (chNum * reg->numRegs);  // offset by channel
	.debug	# 1534
	ld	hl,(ix-41)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	bc,hl
	mul
	ld	hl,(ix-34)
	add	hl,bc
	ld	(ix-30),hl
;1535           idx += (*cliOrder)[reg->dataType][wordIdx]; // reorder by client 
	.debug	# 1535
	ld	hl,(ix-41)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-47)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	ex	de,hl
	ld	hl,(ix-30)
	ex	de,hl
	add	hl,de
	ld	(ix-30),hl
;1536           regVal = reg->regVal[idx];
	.debug	# 1536
	ld	hl,(ix-41)
	ex	de,hl
	ld	hl,(ix-30)
	add	hl,hl
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	hl,(hl)
	ld	(ix-14),hl
;1537           break;
	.debug	# 1537
;1538         }
@545:
	.debug	>
;1539         SetWordVal(offset, regVal, respBuf);  offset += 2;
@542:
@540:
	.debug	>
	.debug	# 1539
	ld	hl,(ix-14)
	ld	b,8
@550:
	sra	h
	rr	l
	djnz	@550
	ex	de,hl
	ld	hl,(ix-32)
	ex	de,hl
	ld	bc,hl
	ld	hl,(ix+9)
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-14)
	ld	h,0
	inc	de
	ld	bc,hl
	ld	hl,(ix+9)
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-32)
	inc	hl
	inc	hl
	ld	(ix-32),hl
;1540         if (++regNum == R4ChanMult)  { regNum = 0;  ++chanNum; }
	.debug	# 1540
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	ld	de,(_R4ChanMult)
	or	a,a
	sbc	hl,de
	jr	nz,@551
@552:
	.debug	< @552 @553
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
@553:
	.debug	>
;1541       }
@551:
@538:
	.debug	>
;1542       KUNLOCK();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@534
@533:
	.debug	>
	.debug	# 1542
;1543 
;1544       cmdOK = true;  break;
	.debug	# 1544
;1545 
;1546 
;1547 //======================================================
;1548 // === read multiple input registers (3xxxx series) ===
;1549 //======================================================
;1550     case 4:
;1551       if (cmdLen < 6)  break;
	.debug	# 1551
@554:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1552 
;1553       firstReg = GetShort_(cmdBuf, 8);  numRegs = GetShort_(cmdBuf, 10);
	.debug	# 1553
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-6),hl
	ld	hl,0xa
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-8),hl
;1554 
;1555       if (ShowReads)
	.debug	# 1555
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@556
;1556         fprintf(DiagLog, "Read Regs: 3%04d - 3%04d\r\n",
;1557                           firstReg, firstReg + numRegs - 1);
	.debug	# 1557
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	add	hl,de
	dec	hl
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @22+479)
	ld	c,phys @22+479 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1558 
;1559       respBytes = numRegs * 2;
@556:
	.debug	# 1559
	ld	hl,(ix-8)
	add	hl,hl
	ld	(ix-16),hl
;1560 
;1561       if (respBytes > MaxRespMsgLen-10)  {
	.debug	# 1561
	ld	de,0x80f6
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@557
	jr	z,@557
;1562         fprintf(DiagLog, "Response too long\r\n");
@558:
	.debug	< @558 @559
	.debug	# 1562
	ld	de,word (phys @22+432)
	ld	c,phys @22+432 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1563         respBytes = 1;
	.debug	# 1563
	ld	hl,0x1
	ld	(ix-16),hl
;1564         respBuf[7] |= 0x80;  // top bit on indicates exception
	.debug	# 1564
	ld	hl,(ix+9)
	ld	de,0x7
	add	hl,de
	set	7,(hl)
;1565         respBuf[8] = 2;
	.debug	# 1565
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	ld	a,0x2
	ld	(hl),a
;1566         cmdOK = true;  break;
	.debug	# 1566
@768:
	dec	a
	jp	@765
;1567       }
@559:
	.debug	>
;1568 
;1569       respBuf[8] = respBytes;  ++respBytes;
@557:
	.debug	# 1569
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ld	a,(ix-16)
	ld	(hl),a
	ld	hl,(ix-16)
	inc	hl
	ld	(ix-16),hl
;1570       memset(respBuf+9, 0, respBytes);
	.debug	# 1570
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	push	hl
	call	_memset
	add	sp,6
;1571 
;1572     //--- note that range of registers may cross chanNum boundaries ---
;1573       chanNum = firstReg / R3ChanMult;  regNum = firstReg % R3ChanMult;
	.debug	# 1573
	ld	hl,(ix-6)
	ld	de,(_R3ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-6)
	ld	de,(_R3ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-12),hl
;1574       offset = 9;  cliOrder = (ClientOrder *)(&regOrder[clientType][0][0]);
	.debug	# 1574
	ld	hl,0x9
	ld	(ix-32),hl
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_regOrder
	add	hl,bc
	ld	(ix-47),hl
;1575       KLOCK();
	.debug	# 1575
	call	_KLOCK
;1576       for (i=0; i<numRegs; ++i)  {
@560:
	.debug	< @560 @561
	.debug	# 1576
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@562:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	call	__icmp##
	jp	nc,@563
;1577         if ((chanNum >= NumR3Chans) OR (regNum >= numR3Regs))
@565:
	.debug	< @565 @566
	.debug	# 1577
	ld	hl,(ix-24)
	ld	de,(_NumR3Chans)
	or	a,a
	sbc	hl,de
	jr	nc,@567
	ld	hl,(ix-12)
	ld	de,(_numR3Regs)
	or	a,a
	sbc	hl,de
	jr	c,@568
@567:
;1578           regVal = 0;
	.debug	# 1578
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;1579         else  {
	jr	@569
@568:
;1580           reg = r3Regs[regNum];  // info about registers for this value
@570:
	.debug	< @570 @571
	.debug	# 1580
	ld	hl,(ix-12)
	add	hl,hl
	ld	de,_r3Regs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-41),hl
;1581           chNum = ((uint)reg->flags & OnePerChan ? chanNum : 0);
	.debug	# 1581
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@572
	ld	hl,(ix-24)
	jr	@573
@572:
	bool	hl
	ld	l,h
@573:
	ld	(ix-26),hl
;1582           wordIdx = regNum - reg->regNum;  // which word in multi-word valu
	.debug	# 1582
	ld	hl,(ix-41)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-12)
	or	a,a
	sbc	hl,de
	ld	(ix-34),hl
;1583           idx = wordIdx + (chNum * reg->numRegs);  // offset by channel
	.debug	# 1583
	ld	hl,(ix-41)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	bc,hl
	mul
	ld	hl,(ix-34)
	add	hl,bc
	ld	(ix-30),hl
;1584           idx += (*cliOrder)[reg->dataType][wordIdx]; // reorder by client 
	.debug	# 1584
	ld	hl,(ix-41)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-47)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	ex	de,hl
	ld	hl,(ix-30)
	ex	de,hl
	add	hl,de
	ld	(ix-30),hl
;1585           regVal = reg->regVal[idx];
	.debug	# 1585
	ld	hl,(ix-41)
	ex	de,hl
	ld	hl,(ix-30)
	add	hl,hl
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	hl,(hl)
	ld	(ix-14),hl
;1586         }
@571:
	.debug	>
;1587         SetWordVal(offset, regVal, respBuf);  offset += 2;
@569:
	.debug	# 1587
	ld	hl,(ix-14)
	ld	b,8
@574:
	sra	h
	rr	l
	djnz	@574
	ex	de,hl
	ld	hl,(ix-32)
	ex	de,hl
	ld	bc,hl
	ld	hl,(ix+9)
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-14)
	ld	h,0
	inc	de
	ld	bc,hl
	ld	hl,(ix+9)
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-32)
	inc	hl
	inc	hl
	ld	(ix-32),hl
;1588         if (++regNum == R3ChanMult)  { regNum = 0;  ++chanNum; }
	.debug	# 1588
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	ld	de,(_R3ChanMult)
	or	a,a
	sbc	hl,de
	jr	nz,@575
@576:
	.debug	< @576 @577
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
@577:
	.debug	>
;1589       }
@575:
@566:
	.debug	>
;1590       KUNLOCK();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@562
@563:
@561:
	.debug	>
	.debug	# 1590
	call	_KUNLOCK
;1591 
;1592       cmdOK = true;  break;
	.debug	# 1592
	jp	@766
;1593 
;1594 
;1595 //======================================================
;1596 // === write coil (single bit value) (0xxxx series) ===
;1597 //======================================================
;1598     case 5:
;1599       if (cmdLen < 6)  break;
	.debug	# 1599
@578:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1600 
;1601       coilNum = GetShort_(cmdBuf, 8);  coilVal = cmdBuf[10];
	.debug	# 1601
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-18),hl
	ld	hl,(ix+7)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-39),a
;1602       chanNum = coilNum / C0ChanMult;  coilNum = coilNum % C0ChanMult;
	.debug	# 1602
	ld	hl,(ix-18)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-18)
	ld	de,(_C0ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-18),hl
;1603       if ((chanNum >= NumC0Chans) OR (coilNum >= numC0Coils))  {
	.debug	# 1603
	ld	hl,(ix-24)
	ld	de,(_NumC0Chans)
	or	a,a
	sbc	hl,de
	jr	nc,@580
	ld	hl,(ix-18)
	ld	de,(_numC0Coils)
	or	a,a
	sbc	hl,de
	jr	c,@581
@580:
;1604         if (ShowErrors)
@582:
	.debug	< @582 @583
	.debug	# 1604
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jp	z,@622
;1605           fprintf(DiagLog, "set coil %05d[%d] to %d  *IGNORED*\n",
;1606                   coilNum+1, chanNum, coilVal );
	.debug	# 1606
	bool	hl
	ld	l,(ix-39)
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-18)
	inc	hl
	push	hl
	ld	de,word (phys @22+506)
	ld	c,phys @22+506 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;1607       }
@583:
	.debug	>
;1608       else  {
	jp	@622
@581:
;1609         coil = c0Coils[coilNum];
@586:
	.debug	< @586 @587
	.debug	# 1609
	ld	hl,(ix-18)
	add	hl,hl
	ld	de,_c0Coils
	add	hl,de
	ld	hl,(hl)
	ld	(ix-43),hl
;1610         chNum = ((uint)coil->flags & OnePerChan ? chanNum : 0);
	.debug	# 1610
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@588
	ld	hl,(ix-24)
	jr	@589
@588:
	bool	hl
	ld	l,h
@589:
	ld	(ix-26),hl
;1611         if ((coil->flags & LogChanges) AND startupComplete)
	.debug	# 1611
	ld	hl,(ix-43)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@591
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@591
;1612           fprintf(DiagLog, "set coil %05d[%d] (%ls): %d\n",
;1613                   coil->coilNum+1, chanNum, coil->name, coilVal );
	.debug	# 1613
	bool	hl
	ld	l,(ix-39)
	push	hl
	ld	hl,(ix-43)
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-43)
	inc	hl
	inc	hl
	ld	a,(hl)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @22+542)
	ld	c,phys @22+542 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;1614         (coil->setCoilFunc)(coil, chNum, coilVal, eventsfd);
@591:
	.debug	# 1614
	ld	hl,(ix+13)
	push	hl
	ld	a,(ix-39)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-43)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x7
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
;1615       }
@587:
	.debug	>
;1616       respBytes = 4;
	.debug	# 1616
	jp	@622
;1617       cmdOK = true;  break;
	.debug	# 1617
;1618 
;1619 
;1620 //==============================================
;1621 // === write single register (4xxxx series) ===
;1622 //==============================================
;1623     case 6:
;1624       if (cmdLen < 6)  break;
	.debug	# 1624
@592:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1625 
;1626       regNum = GetShort_(cmdBuf, 8);  regVal = GetShort_(cmdBuf, 10);
	.debug	# 1626
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-12),hl
	ld	hl,0xa
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-14),hl
;1627       respBytes = 4;
	.debug	# 1627
	ld	hl,0x4
	ld	(ix-16),hl
;1628 
;1629       chanNum = regNum / R4ChanMult;  regNum = regNum % R4ChanMult;
	.debug	# 1629
	ld	hl,(ix-12)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-12)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-12),hl
;1630 
;1631       if ((chanNum >= NumR4Chans) OR (regNum > numR4Regs))  {
	.debug	# 1631
	ld	hl,(ix-24)
	ld	de,(_NumR4Chans)
	or	a,a
	sbc	hl,de
	jr	nc,@594
	ld	hl,(ix-12)
	ld	de,(_numR4Regs)
	or	a,a
	sbc	hl,de
	jr	c,@595
	jr	z,@595
@594:
;1632         if (ShowErrors)
@596:
	.debug	< @596 @597
	.debug	# 1632
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jp	z,@766
;1633           fprintf(DiagLog, "set reg 4%04d[%d] to 0x%04X %6d  *IGNORED*\n",
;1634                   regNum+1, chanNum, regVal, regVal );
	.debug	# 1634
	ld	hl,(ix-14)
	push	hl
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-12)
	inc	hl
	push	hl
	ld	de,word (phys @22+571)
	ld	c,phys @22+571 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1635       }
@597:
	.debug	>
;1636       else  {
	jp	@766
@595:
;1637         reg = r4Regs[regNum];
@600:
	.debug	< @600 @601
	.debug	# 1637
	ld	hl,(ix-12)
	add	hl,hl
	ld	de,_r4Regs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-41),hl
;1638         chNum = ((uint)reg->flags & OnePerChan ? chanNum : 0);
	.debug	# 1638
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@602
	ld	hl,(ix-24)
	jr	@603
@602:
	bool	hl
	ld	l,h
@603:
	ld	(ix-26),hl
;1639 
;1640       //--- upate appropriate portion in multi-register value buffer ---
;1641         wordIdx = regNum - reg->regNum;  // which word in multi-word value
	.debug	# 1641
	ld	hl,(ix-41)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-12)
	or	a,a
	sbc	hl,de
	ld	(ix-34),hl
;1642         cliOffset = regOrder[clientType][(int)reg->dataType][wordIdx];
	.debug	# 1642
	ld	hl,(ix-41)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	a,(ix+5)
	ld	e,a
	ld	bc,0xa
	push	hl
	mul
	pop	hl
	ld	de,_regOrder
	ex	de,hl
	add	hl,bc
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	ld	(ix-36),hl
;1643         logicalVal[wordIdx + cliOffset] = regVal;
	.debug	# 1643
	ex	de,hl
	add	hl,de
	add	hl,hl
	ex	de,hl
	ld	hl,-63+@487
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1644 
;1645         if (ShowWrites)
	.debug	# 1645
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@604
;1646           fprintf(DiagLog, "set reg 4%04d[%d] (%ls.%d): 0x%04X %6d\n",
;1647                   regNum+1, chanNum, reg->name, wordIdx, regVal, regVal );
	.debug	# 1647
	ld	hl,(ix-14)
	push	hl
	push	hl
	ld	hl,(ix-34)
	push	hl
	ld	hl,(ix-41)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-12)
	inc	hl
	push	hl
	ld	de,word (phys @22+615)
	ld	c,phys @22+615 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,20
;1648 
;1649         if (reg->wrMask == REG_RO)  {
@604:
	.debug	# 1649
	ld	hl,(ix-41)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@605
;1650           fprintf(DiagLog, "write to RO reg %ls[%d] = ignored\r\n\n",
@606:
	.debug	< @606 @607
;1651                   reg->name, chNum);
	.debug	# 1651
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+655)
	ld	c,phys @22+655 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;1652           cmdOK = true;  break;
	.debug	# 1652
	jp	@766
;1653         }
@607:
	.debug	>
;1654 
;1655       //--- if last reg in multi-reg value, update the value ---
;1656         if (wordIdx == (reg->numRegs - 1))  if (reg->setRegFunc)  {
@605:
	.debug	# 1656
	ld	hl,(ix-41)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	dec	a
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@766
	ld	hl,(ix-41)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jp	z,@766
;1657           accepted = (reg->setRegFunc)(reg, chNum, logicalVal, eventsfd);
@610:
	.debug	< @610 @611
	.debug	# 1657
	ld	hl,(ix+13)
	push	hl
	ld	hl,-61+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-38),a
;1658           if ((reg->flags & LogChanges) AND startupComplete)
	.debug	# 1658
	ld	hl,(ix-41)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@613
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@613
;1659             fprintf(DiagLog, "set %ls[%d] = %s: %s\r\n\n",
;1660                     reg->name, chNum,
;1661                     fmtRegVal(reg, (S16 *)logicalVal, chNum, temp),
;1662                     (accepted ? "OK" : "Rejected")  );
	.debug	# 1662
	ld	a,(ix-38)
	or	a,a
	jr	z,@614
	ld	hl,@1+30
	jr	@615
@614:
	ld	hl,@1+33
@615:
	push	hl
	ld	hl,-93+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,-57+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-41)
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+692)
	ld	c,phys @22+692 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;1663         }
@613:
@611:
	.debug	>
;1664       }
@601:
	.debug	>
;1665 
;1666       cmdOK = true;  break;
	.debug	# 1666
	jp	@766
;1667 
;1668 
;1669 //=================================================
;1670 // === write multiple registers (4xxxx series) ===
;1671 //=================================================
;1672     case 16:
;1673       if (cmdLen < 6)  break;
	.debug	# 1673
@617:
	ld	hl,(ix-4)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@491
;1674 
;1675       firstReg = GetShort_(cmdBuf, 8);  numRegs = GetShort_(cmdBuf, 10);
	.debug	# 1675
	ld	hl,0x8
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-6),hl
	ld	hl,0xa
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-8),hl
;1676 //      byteCount = cmdBuf[12];
;1677 
;1678      //--- note that range of registers may cross chanNum boundaries ---
;1679       chanNum = firstReg / R4ChanMult;  regNum = firstReg % R4ChanMult;
	.debug	# 1679
	ld	hl,(ix-6)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ld	(ix-24),hl
	ld	hl,(ix-6)
	ld	de,(_R4ChanMult)
	call	__uidiv##
	ex	de,hl
	ld	(ix-12),hl
;1680       offset = 13;  cliOrder = (ClientOrder *)(&regOrder[clientType][0][0])
	.debug	# 1680
	ld	hl,0xd
	ld	(ix-32),hl
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_regOrder
	add	hl,bc
	ld	(ix-47),hl
;1681 
;1682       for (i=0; i<numRegs; ++i)  {
@619:
	.debug	< @619 @620
	.debug	# 1682
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@621:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	call	__icmp##
	jp	nc,@622
;1683         if ((chanNum >= NumR4Chans) OR (regNum > numR4Regs))  {
@624:
	.debug	< @624 @625
	.debug	# 1683
	ld	hl,(ix-24)
	ld	de,(_NumR4Chans)
	or	a,a
	sbc	hl,de
	jr	nc,@626
	ld	hl,(ix-12)
	ld	de,(_numR4Regs)
	or	a,a
	sbc	hl,de
	jr	c,@627
	jr	z,@627
@626:
;1684           if (ShowErrors)
@628:
	.debug	< @628 @629
	.debug	# 1684
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@630
;1685             fprintf(DiagLog, "set reg 4%04d[%d] to 0x%04X %6d  *IGNORED*\n"
;1686                     regNum+1, chanNum, regVal, regVal );
	.debug	# 1686
	ld	hl,(ix-14)
	push	hl
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,(ix-12)
	inc	hl
	push	hl
	ld	de,word (phys @22+571)
	ld	c,phys @22+571 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1687         }
@630:
@629:
	.debug	>
;1688         else  {
	jp	@631
@627:
;1689           reg = r4Regs[regNum];
@632:
	.debug	< @632 @633
	.debug	# 1689
	ld	hl,(ix-12)
	add	hl,hl
	ld	de,_r4Regs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-41),hl
;1690           chNum = ((uint)reg->flags & OnePerChan ? chanNum : 0);
	.debug	# 1690
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	e,0x1
	and	hl,de
	jr	z,@634
	ld	hl,(ix-24)
	jr	@635
@634:
	bool	hl
	ld	l,h
@635:
	ld	(ix-26),hl
;1691 
;1692         //--- upate appropriate portion in multi-register value buffer ---
;1693           regVal = GetShort_(cmdBuf, offset);
	.debug	# 1693
	ld	hl,(ix-32)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-14),hl
;1694           wordIdx = regNum - reg->regNum;  // which word in multi-word valu
	.debug	# 1694
	ld	hl,(ix-41)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-12)
	or	a,a
	sbc	hl,de
	ld	(ix-34),hl
;1695           cliOffset = (*cliOrder)[(int)reg->dataType][wordIdx];
	.debug	# 1695
	ld	hl,(ix-41)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-47)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	ld	(ix-36),hl
;1696           logicalVal[wordIdx + cliOffset] = regVal;
	.debug	# 1696
	ex	de,hl
	add	hl,de
	add	hl,hl
	ex	de,hl
	ld	hl,-63+@487
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1697 
;1698           if (ShowWrites)
	.debug	# 1698
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@636
;1699             fprintf(DiagLog, "set reg 4%04d[%d] (%ls.%d): 0x%04X %6d\n",
;1700                     regNum+1, chNum, reg->name, wordIdx, regVal, regVal );
	.debug	# 1700
	ld	hl,(ix-14)
	push	hl
	push	hl
	ld	hl,(ix-34)
	push	hl
	ld	hl,(ix-41)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-12)
	inc	hl
	push	hl
	ld	de,word (phys @22+615)
	ld	c,phys @22+615 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,20
;1701 
;1702           if (reg->wrMask == REG_RO)  {
@636:
	.debug	# 1702
	ld	hl,(ix-41)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@637
;1703             fprintf(DiagLog, "write to RO reg %ls[%d] = ignored\r\n\n",
@638:
	.debug	< @638 @639
;1704                     reg->name, chNum);
	.debug	# 1704
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+655)
	ld	c,phys @22+655 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;1705             continue;
	.debug	# 1705
;1706           }
	jp	@623
@639:
	.debug	>
;1707 
;1708         //--- if last reg in multi-reg value, update the value ---
;1709           if (wordIdx == (reg->numRegs - 1))  if (reg->setRegFunc)  {
@637:
	.debug	# 1709
	ld	hl,(ix-41)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	dec	a
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-34)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@640
	ld	hl,(ix-41)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jp	z,@641
;1710             accepted = (reg->setRegFunc)(reg, chNum, logicalVal, eventsfd);
@642:
	.debug	< @642 @643
	.debug	# 1710
	ld	hl,(ix+13)
	push	hl
	ld	hl,-61+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	push	hl
	ex	de,hl
	ld	h,d
	ld	l,e
	ld	bc,hl
	ld	hl,0x8
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,8
	ld	(ix-38),a
;1711             if ((reg->flags & LogChanges) AND startupComplete)
	.debug	# 1711
	ld	hl,(ix-41)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@645
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@645
;1712               fprintf(DiagLog, "set %ls[%d] = %s: %s\r\n\n",
;1713                       reg->name, chNum,
;1714                       fmtRegVal(reg, (S16 *)logicalVal, chNum, temp),
;1715                       (accepted ? "OK" : "Rejected")  );
	.debug	# 1715
	ld	a,(ix-38)
	or	a,a
	jr	z,@646
	ld	hl,@1+30
	jr	@647
@646:
	ld	hl,@1+33
@647:
	push	hl
	ld	hl,-93+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,-57+@487
	add	hl,sp
	push	hl
	ld	hl,(ix-41)
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-41)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @22+692)
	ld	c,phys @22+692 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;1716           }
@645:
@643:
	.debug	>
;1717         }
@641:
@640:
@633:
	.debug	>
;1718 
;1719         offset += 2;
@631:
	.debug	# 1719
	ld	hl,(ix-32)
	inc	hl
	inc	hl
	ld	(ix-32),hl
;1720         if (++regNum == R4ChanMult)  { regNum = 0;  ++chanNum; }
	.debug	# 1720
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	ld	de,(_R4ChanMult)
	or	a,a
	sbc	hl,de
	jr	nz,@649
@650:
	.debug	< @650 @651
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
@651:
	.debug	>
;1721       }
@649:
@625:
	.debug	>
;1722 
;1723       respBytes = 4;
@623:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@621
@622:
@620:
	.debug	>
	.debug	# 1723
	ld	hl,0x4
@767:
	ld	(ix-16),hl
;1724 
;1725       cmdOK = true;  break;
	.debug	# 1725
@766:
	ld	a,0x1
	jr	@765
;1726 
;1727 
;1728     default:
;1729       if (ShowErrors)
	.debug	# 1729
@652:
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@653
;1730         fprintf(DiagLog,
;1731           "Unrecognized or unsupported command: func code: %d\r\n", funcCod
	.debug	# 1731
	ld	hl,(ix-10)
	push	hl
	ld	de,word (phys @22+716)
	ld	c,phys @22+716 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1732       respBytes = 1;
@653:
	.debug	# 1732
	ld	hl,0x1
	ld	(ix-16),hl
;1733       respBuf[7] |= 0x80;  // top bit on indicates exception
	.debug	# 1733
	ld	hl,(ix+9)
	ld	de,0x7
	add	hl,de
	set	7,(hl)
;1734       respBuf[8] = 1;  cmdOK = true;
	.debug	# 1734
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@765:
	ld	(ix-37),a
;1735   }
@493:
	.debug	>
;1736 
;1737 
;1738   if (! cmdOK)  {
	jr	@491
@490:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jp	z,@494
	ld	hl,0xfffffffd
	add	hl,de
	bool	hl
	jp	z,@526
	ld	hl,0xfffffffc
	add	hl,de
	bool	hl
	jp	z,@554
	ld	hl,0xfffffffb
	add	hl,de
	bool	hl
	jp	z,@578
	ld	hl,0xfffffffa
	add	hl,de
	bool	hl
	jp	z,@592
	ld	hl,0xfffffff0
	add	hl,de
	bool	hl
	jp	z,@617
	jr	@652
@491:
	.debug	# 1738
	ld	a,(ix-37)
	or	a,a
	jr	nz,@654
;1739     if (ShowErrors)  fprintf(DiagLog, "Badly formed command\r\n");
@655:
	.debug	< @655 @656
	.debug	# 1739
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@657
	ld	de,word (phys @22+769)
	ld	c,phys @22+769 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1740     respBytes = 1;
@657:
	.debug	# 1740
	ld	hl,0x1
	ld	(ix-16),hl
;1741     respBuf[7] |= 0x80;  // top bit on indicates exception
	.debug	# 1741
	ld	hl,(ix+9)
	ld	de,0x7
	add	hl,de
	set	7,(hl)
;1742     respBuf[8] = 3;
	.debug	# 1742
	ld	hl,(ix+9)
	inc	e
	add	hl,de
	ld	a,0x3
	ld	(hl),a
;1743   }
@656:
	.debug	>
;1744 
;1745   SetWordVal(4, respBytes+2, respBuf);  *respLen = respBytes + 8;
@654:
	.debug	# 1745
	ld	hl,(ix-16)
	inc	hl
	inc	hl
	ld	b,8
@658:
	sra	h
	rr	l
	djnz	@658
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-16)
	inc	hl
	inc	hl
	ld	h,0
	ld	bc,hl
	ld	l,0x5
	add	hl,de
	ld	(hl),c
	ld	hl,(ix-16)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1746 /*
;1747   if (showDetails)  {
;1748     sprintf(msg, " %3d", respBytes+8);  DispStr(75,y, msg, false);  }
;1749 */
;1750 
;1751   return 0;
	.debug	# 1751
	bool	hl
	ld	l,h
;1752 }
@488:
	.debug	} @488 1752

@487	equ	95
	ld	sp,ix
	pop	ix
	lret
@489	equ	97
;1753 
;1754 
;1755 //-------------------------------------------------------------------------
;1756 void showReg4Info(uint idx)
;1757 {
$showReg4Info::
	.debug	G $showReg4Info 87 9
	.debug	{ $showReg4Info 87 1756 @661 @660
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-72
	.debug	A idx 5 7
;1758   uchar  *lcall;
	.debug	L lcall -2 33
;1759   ulong  absAddr;
	.debug	L absAddr -6 9
;1760   RegInfo  *reg;
	.debug	L reg -8 39
;1761   char  name[64];
	.debug	L name -72 65
;1762 
;1763 
;1764   reg = r4Regs[idx];  lcall = (uchar *)(reg->setRegFunc);
	.debug	# 1764
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_r4Regs
	add	hl,de
	ld	hl,(hl)
	ld	(ix-8),hl
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
;1765 
;1766   absAddr = ((ulong)lcall[5] << 12) + ((ulong)lcall[4]<<8) + (ulong)lcall[3
	.debug	# 1766
	ld	e,0x5
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-2)
	push	bc
	push	de
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	ld	c,d
	ld	b,c
	ld	d,a
	ld	e,b
	call	__ladd##
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	ld	a,(hl)
	push	bc
	push	de
	ld	e,a
	ld	bc,0
	ld	d,c
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;1767 
;1768   strcpyfn(name, reg->name);
	.debug	# 1768
	ld	hl,(ix-8)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,-68+@659
	add	hl,sp
	push	hl
	call	_strcpyfn
	add	sp,6
;1769   printf("r4Regs[%02d]: 4%04d+%d %-16s [%04X]->[%04X]\r\n",
;1770           idx, reg->regNum, idx-reg->regNum, name,
;1771           (uint)lcall, (uint)absAddr );
	.debug	# 1771
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,-68+@659
	add	hl,sp
	push	hl
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	or	a,a
	sbc	hl,de
	push	hl
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @22+792)
	ld	c,phys @22+792 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;1772 }
@660:
	.debug	} @660 1772

@659	equ	72
	ld	sp,ix
	pop	ix
	lret
@661	equ	74
;1773 
;1774 
;1775 //-------------------------------------------------------------------------
;1776 //  Scan a list of registers to make sure they are contiguous (no overlaps 
;1777 //  breaks in the list) and update the global numPVs value.
;1778 //
;1779 //  Returns 0 if no problems found, or < 0 if an error.
;1780 //-------------------------------------------------------------------------
;1781 int scanRegList(RegInfo **regs, uint *numRegs, char prefix)
;1782 {
$scanRegList::
	.debug	G $scanRegList 88 9
	.debug	{ $scanRegList 88 1781 @664 @663
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A regs 5 57
	.debug	A numRegs 7 80
	.debug	A prefix 9 3
;1783   uint  u;
	.debug	L u -2 7
;1784   RegInfo  *reg, *lastReg = NULL;
	.debug	L reg -4 39
	.debug	L lastReg -6 39
	.debug	# 1784
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
;1785 
;1786 
;1787   for (u=0,reg=*regs; reg; ++u,reg=*(++regs))  {
@665:
	.debug	< @665 @666
	.debug	# 1787
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-4),hl
@667:
	ld	hl,(ix-4)
	bool	hl
	jp	z,@668
;1788 //    printf("reg: [%u] %c%04d: %ls\r\n",  //tdebug
;1789 //           u, prefix, reg->regNum, reg->name);
;1790 
;1791     if (reg != lastReg)  ++numPVs;  // count only 1st reg in multi-reg valu
@670:
	.debug	< @670 @671
	.debug	# 1791
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@672
	ld	hl,(_numPVs)
	inc	hl
	ld	(_numPVs),hl
;1792 
;1793     if ((u < reg->regNum) OR (u >= reg->regNum + reg->numRegs))  {
@672:
	.debug	# 1793
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	c,@673
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	c,@674
@673:
;1794       fprintf(DiagLog,
@675:
	.debug	< @675 @676
;1795           "***** modbus REG%c table error: %c%04u at pos for %c%04u *****\n
;1796               prefix, prefix, reg->regNum+1, prefix, u+1);
	.debug	# 1796
	ld	hl,(ix-2)
	inc	hl
	push	hl
	bool	hl
	ld	l,(ix+9)
	push	hl
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ld	hl,(hl)
	inc	hl
	push	hl
	bool	hl
	ld	l,(ix+9)
	push	hl
	push	hl
	ld	de,word (phys @22+838)
	ld	c,phys @22+838 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,16
;1797       return -1;
	.debug	# 1797
	ld	hl,0xffff
	jr	@663
;1798     }
@676:
	.debug	>
;1799 
;1800     lastReg = reg;
@674:
	.debug	# 1800
	ld	hl,(ix-4)
	ld	(ix-6),hl
;1801   }
@671:
	.debug	>
;1802 
;1803   *numRegs = u;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	(ix+5),hl
	ld	hl,(hl)
	ld	(ix-4),hl
	jp	@667
@668:
@666:
	.debug	>
	.debug	# 1803
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1804 
;1805   return 0;
	.debug	# 1805
	bool	hl
	ld	l,h
;1806 }
@663:
	.debug	} @663 1806

@662	equ	6
	ld	sp,ix
	pop	ix
	lret
@664	equ	8
;1807 
;1808 //-------------------------------------------------------------------------
;1809 //  Set the "deadband" value for each PV in a group of registers and add th
;1810 //  to the global list of all PVs.
;1811 //-------------------------------------------------------------------------
;1812 PV_Ref far * setDeadbandDefaults(RegInfo **regs,
;1813                                     PV_Ref far *pvListPtr)
;1814 {
$setDeadbandDefaults::
	.debug	G $setDeadbandDefaults 89 9
	.debug	{ $setDeadbandDefaults 89 1812 @679 @678
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A regs 5 57
	.debug	A pvListPtr 7 61
;1815   RegInfo  *reg, *lastReg = NULL;
	.debug	L reg -2 39
	.debug	L lastReg -4 39
	.debug	# 1815
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;1816 
;1817 
;1818   for (reg=*regs; reg; ++regs,reg=*regs)  {
@680:
	.debug	< @680 @681
	.debug	# 1818
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
@682:
	ld	hl,(ix-2)
	bool	hl
	jp	z,@683
;1819     if (reg == lastReg)  continue;  // skip if not 1st in multi-reg value
@685:
	.debug	< @685 @686
	.debug	# 1819
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	z,@684
;1820     switch (reg->dataType)  {
	.debug	# 1820
	ld	h,d
	ld	l,e
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	jr	@688
;1821       case DT_S16:  case DT_U16:  *(int *)reg->minChg = 1;  break;
@690:
	.debug	< @690 @691
	.debug	# 1821
@692:
@693:
	ld	hl,(ix-2)
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1822       case DT_S32:  case DT_U32:  *(long *)reg->minChg = 1;  break;
	jr	@689
	.debug	# 1822
@694:
@695:
	ld	hl,(ix-2)
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	ld	c,d
	ld	b,d
	jr	@764
;1823       case DT_F32:  *(float *)reg->minChg = 0.0001;  break;
	.debug	# 1823
@696:
	ld	hl,(ix-2)
	ld	de,0x12
	add	hl,de
	ld	hl,(hl)
	ld	de,0xb717
	ld	bc,0x38d1
@764:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1824     }
	jr	@689
@691:
	.debug	>
;1825     lastReg = reg;
@688:
	or	a,a
	jr	z,@692
	cp	0x1
	jr	z,@693
	cp	0x2
	jr	z,@694
	cp	0x3
	jr	z,@695
	cp	0x4
	jr	z,@696
@689:
	.debug	# 1825
	ld	hl,(ix-2)
	ld	(ix-4),hl
;1826     pvListPtr->pvDef = reg;  pvListPtr->pvType = PVT_REG;  ++pvListPtr;
	.debug	# 1826
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;1827   }
@686:
	.debug	>
;1828 
;1829   return pvListPtr;
@684:
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	(ix+5),hl
	ld	hl,(hl)
	ld	(ix-2),hl
	jp	@682
@683:
@681:
	.debug	>
	.debug	# 1829
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
;1830 }
@678:
	.debug	} @678 1830

@677	equ	4
	ld	sp,ix
	pop	ix
	lret
@679	equ	6
;1831 
;1832 
;1833 //-------------------------------------------------------------------------
;1834 //  Initialization for the lists of PVs (Process Variables).  Includes scan
;1835 //  the tables of values accessable via the ModBus interface to determine t
;1836 //  # of logical values represented by the registers and to make sure they 
;1837 //  consistent (i.e. no holes or overlaps in the sequence).
;1838 //
;1839 //  Also sets the defaults for minChg value used to test for value change
;1840 //  events for the EPICS CA (Channel Access) interface.
;1841 //-------------------------------------------------------------------------
;1842 int pvInitLists(void)
;1843 {
$pvInitLists::
	.debug	G $pvInitLists 90 9
	.debug	{ $pvInitLists 90 1842 @699 @698
	ld	hl,-143
	call	__fent##
;1844   uint  u, last;
	.debug	L u -2 7
	.debug	L last -4 7
;1845   CoilInfo  *coil, **coils;
	.debug	L coil -6 46
	.debug	L coils -8 91
;1846   PV_Ref far  *pvPtr;
	.debug	L pvPtr -12 61
;1847   PV_Ref  hold;
	.debug	L hold -15 62
;1848   char  name0[MAX_PV_NAME_LEN], name1[MAX_PV_NAME_LEN];
	.debug	L name0 -79 65
	.debug	L name1 -143 65
;1849 
;1850 
;1851   numC0Coils = numR3Regs = numR4Regs = numNonRegPVs = numPVs = 0;
	.debug	# 1851
	bool	hl
	ld	l,h
	ld	(_numPVs),hl
	ld	(_numNonRegPVs),hl
	ld	(_numR4Regs),hl
	ld	(_numR3Regs),hl
	ld	(_numC0Coils),hl
;1852 
;1853   printf("\nInitialization for ModBus and PV Interfaces...\r\n");
	.debug	# 1853
	ld	de,word (phys @22+902)
	ld	c,phys @22+902 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1854 
;1855 
;1856   coils = c0Coils;
	.debug	# 1856
	ld	hl,_c0Coils
	ld	(ix-8),hl
;1857   for (u=0,coil=*coils; coil; ++u,++coils,coil=*coils)  {
@700:
	.debug	< @700 @701
	.debug	# 1857
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	(ix-6),hl
@702:
	ld	hl,(ix-6)
	bool	hl
	jr	z,@703
;1858 //    printf("coil: [%u][0x%04X] 0%04u [%ls]\r\n", //tdebug
;1859 //           u, (uint)coil, coil->coilNum, coil->name);  //tdebug
;1860     if (coil->coilNum != u)  {
@705:
	.debug	< @705 @706
	.debug	# 1860
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@707
;1861       printf(
@708:
	.debug	< @708 @709
;1862          "\n***** modbus COIL table error: 0%04u at pos for 0%04u *****\n\n
;1863               coil->coilNum+1, u+1);
	.debug	# 1863
	ld	h,d
	ld	l,e
	inc	hl
	push	hl
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @22+952)
	ld	c,phys @22+952 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1864       return -1;
	.debug	# 1864
	ld	hl,0xffff
	jp	@698
;1865     }
@709:
	.debug	>
;1866   }
@707:
@706:
	.debug	>
;1867   numC0Coils = u;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ld	(ix-8),hl
	ld	hl,(hl)
	ld	(ix-6),hl
	jr	@702
@703:
@701:
	.debug	>
	.debug	# 1867
	ld	hl,(ix-2)
	ld	(_numC0Coils),hl
;1868 
;1869 //--- scan the ModBus register lists for errors and count total # of PVs --
;1870   if (scanRegList(r3Regs, &numR3Regs, '3'))  return -2;
	.debug	# 1870
	ld	hl,0x33
	push	hl
	ld	hl,_numR3Regs
	push	hl
	ld	hl,_r3Regs
	push	hl
	lcall	$scanRegList
	add	sp,6
	bool	hl
	jr	z,@710
	ld	hl,0xfffe
	jp	@698
;1871   if (scanRegList(r4Regs, &numR4Regs, '4'))  return -3;
@710:
	.debug	# 1871
	ld	hl,0x34
	push	hl
	ld	hl,_numR4Regs
	push	hl
	ld	hl,_r4Regs
	push	hl
	lcall	$scanRegList
	add	sp,6
	bool	hl
	jr	z,@711
	ld	hl,0xfffd
	jp	@698
;1872   numRegPVs = numPVs;
@711:
	.debug	# 1872
	ld	hl,(_numPVs)
	ld	(_numRegPVs),hl
;1873   for (u=0; nonRegPVs[u].val; ++u)  ++numNonRegPVs;
@712:
	.debug	< @712 @713
	.debug	# 1873
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@714:
	ld	hl,(ix-2)
	ld	bc,0x1d
	ex	de,hl
	mul
	ld	hl,_nonRegPVs
	add	hl,bc
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@715
	ld	hl,(_numNonRegPVs)
	inc	hl
	ld	(_numNonRegPVs),hl
;1874   numPVs += numNonRegPVs;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@714
@715:
@713:
	.debug	>
	.debug	# 1874
	ld	hl,(_numPVs)
	ld	de,(_numNonRegPVs)
	add	hl,de
	ld	(_numPVs),hl
;1875 
;1876   printf("PV counts:\n"
;1877          "  C0Coils: %d\n"
;1878          "  R3Regs: %d\n"
;1879          "  R4Regs: %d\n"
;1880          "  NonReg PVs: %d\n",
;1881          numC0Coils, numR3Regs, numR4Regs, numNonRegPVs);
	.debug	# 1881
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(_numR4Regs)
	push	hl
	ld	hl,(_numR3Regs)
	push	hl
	ld	hl,(_numC0Coils)
	push	hl
	ld	de,word (phys @22+1015)
	ld	c,phys @22+1015 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;1882 
;1883 //--- allocate an array of pointers for the PVs ---
;1884   printf("\nFor sorted list of %u PVs:\n", numPVs);
	.debug	# 1884
	ld	hl,(_numPVs)
	push	hl
	ld	de,word (phys @22+1084)
	ld	c,phys @22+1084 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1885   if (!(pvList = (PV_Ref far *)xalloc(numPVs * sizeof(PV_Ref))))  return -4
	.debug	# 1885
	ld	hl,(_numPVs)
	ld	bc,0x3
	ex	de,hl
	mul
	ld	de,bc
	ld	bc,0
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	ld	(_pvList),de
	ld	(_pvList+2),bc
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@717
	ld	hl,0xfffc
	jp	@698
;1886 
;1887 //--- initialize the list of pointers (and some values for the ModBus regs)
;1888   pvPtr = pvList;
@717:
	.debug	# 1888
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;1889   pvPtr = setDeadbandDefaults(r3Regs, pvPtr);
	.debug	# 1889
	push	bc
	push	de
	ld	hl,_r3Regs
	push	hl
	lcall	$setDeadbandDefaults
	add	sp,6
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;1890   pvPtr = setDeadbandDefaults(r4Regs, pvPtr);
	.debug	# 1890
	push	bc
	push	de
	ld	hl,_r4Regs
	push	hl
	lcall	$setDeadbandDefaults
	add	sp,6
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;1891   for (u=0; u<numNonRegPVs; ++u)  {
@718:
	.debug	< @718 @719
	.debug	# 1891
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@720:
	ld	hl,(ix-2)
	ld	de,(_numNonRegPVs)
	or	a,a
	sbc	hl,de
	jr	nc,@721
;1892     pvPtr->pvDef = nonRegPVs+u;  pvPtr->pvType = PVT_EXT;  ++pvPtr; }
@723:
	.debug	< @723 @724
	.debug	# 1892
	ld	hl,(ix-2)
	ld	bc,0x1d
	ex	de,hl
	mul
	ld	hl,_nonRegPVs
	add	hl,bc
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	hl,(ix-12)
	ex	de,hl
	call	__farst2##
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x2
	call	__farst1##
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
@724:
	.debug	>
;1893 
;1894 //--- let the kernel task run ---
;1895   resetWDT();  current->state = TASK_UNINTERRUPTIBLE;  schedule();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@720
@721:
@719:
	.debug	>
	.debug	# 1895
	lcall	$resetWDT
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
;1896 
;1897 //--- sort the list so we can use a binary search to locate a PV by name --
;1898   printf("Sorting PV names...\n");
	.debug	# 1898
	ld	de,word (phys @22+1113)
	ld	c,phys @22+1113 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1899   for (last=numPVs-1; last; --last)
@725:
	.debug	< @725 @726
	.debug	# 1899
	ld	hl,(_numPVs)
	dec	hl
	ld	(ix-4),hl
@727:
	ld	hl,(ix-4)
	bool	hl
	jp	z,@728
;1900     for (u=0,pvPtr=pvList; u<last; ++u,++pvPtr)  {
@730:
	.debug	< @730 @731
	.debug	# 1900
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,(_pvList)
	ld	bc,(_pvList+2)
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
@732:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@733
;1901       if (stricmp(pvGetName(pvPtr, name0), pvGetName(pvPtr+1, name1)) > 0) 
@735:
	.debug	< @735 @736
	.debug	# 1901
	ld	hl,-143+@697
	add	hl,sp
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	lcall	$pvGetName
	add	sp,6
	push	hl
	ld	hl,-77+@697
	add	hl,sp
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	lcall	$pvGetName
	add	sp,6
	push	hl
	call	_stricmp
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@737
	jr	z,@737
;1902         hold = pvPtr[0];  pvPtr[0] = pvPtr[1];  pvPtr[1] = hold; }
@738:
	.debug	< @738 @739
	.debug	# 1902
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	hl,-15+@697
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,3
	call	__farcopy##
	add	sp,4
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	hl,3
	call	__farcopy##
	add	sp,4
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,-15+@697
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,3
	call	__farcopyr##
	add	sp,4
@739:
	.debug	>
;1903     }
@737:
@736:
	.debug	>
;1904 
;1905 //--- let the kernel task run again ---
;1906   resetWDT();  current->state = TASK_UNINTERRUPTIBLE;  schedule();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	jp	@732
@733:
@731:
	.debug	>
	ld	hl,(ix-4)
	dec	hl
	ld	(ix-4),hl
	jp	@727
@728:
@726:
	.debug	>
	.debug	# 1906
	lcall	$resetWDT
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
;1907 
;1908 /*tdebug
;1909   for (u=0; u<numPVs; ++u)  {
;1910     pvPtr = pvList + u;
;1911     printf("  %3u: Type:%u [%s]\n", u, pvPtr->pvType, pvGetName(pvPtr, name
;1912     WDT_2S();
;1913   }
;1914   resetWDT();  current->state = TASK_UNINTERRUPTIBLE;  schedule();
;1915 */
;1916 
;1917   printf("\n");
	.debug	# 1917
	ld	de,word (phys @22+60)
	ld	c,phys @22+60 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1918 
;1919   return 0;
	.debug	# 1919
	bool	hl
	ld	l,h
;1920 }
@698:
	.debug	} @698 1920

@697	equ	143
	ld	sp,ix
	pop	ix
	lret
@699	equ	145
;1921 
;1922 
;1923 //-------------------------------------------------------------------------
;1924 void _task modbusTCPd(int argc, char **argv)
;1925 {
	.align	4
$$modbusTCPd::
	ex	(sp),iy
$modbusTCPd::
	.debug	G $modbusTCPd 92 9
	.debug	{ $modbusTCPd 92 1924 @742 @741
	ld	hl,-326
	call	__fent##
	.debug	A argc 5 6
	.debug	A argv 7 93
;1926   int  cmdLen, respLen;
	.debug	L cmdLen -2 6
	.debug	L respLen -4 6
;1927   fd_t  eventsfd;
	.debug	L eventsfd -6 6
;1928   uchar  cmdBuf[MaxCmdMsgLen], respBuf[MaxRespMsgLen];
	.debug	L cmdBuf -70 65
	.debug	L respBuf -326 94
;1929 
;1930 
;1931   redirectStdio();  // so printf, perror, etc don't end up in data stream
	.debug	# 1931
	lcall	$redirectStdio
;1932 
;1933   eventsfd = open(EventsFIFO, O_WRONLY, 0);
	.debug	# 1933
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,@1+76
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-6),hl
;1934 
;1935   DiagFlags |= ErrorBits;  // show errors by default
	.debug	# 1935
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	set	0,d
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1936 
;1937   for (;;)  {
@743:
	.debug	< @743 @744
@745:
@747:
;1938     if (read_(0, cmdBuf, 6, 15000) < 6)  {  // get 1st 6 bytes of command
@748:
	.debug	< @748 @749
	.debug	# 1938
	ld	de,0x3a98
	ld	bc,0
	push	bc
	push	de
	ld	hl,0x6
	push	hl
	ld	hl,-64+@740
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read_
	add	sp,10
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@750
;1939       perror("timeout reading modbusTCP cmd");  Exit(-1); }
@751:
	.debug	< @751 @752
	.debug	# 1939
	ld	de,word (phys @22+1134)
	ld	c,phys @22+1134 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@752:
	.debug	>
;1940 
;1941     cmdLen = GetShort_(cmdBuf, 4);
@750:
	.debug	# 1941
	ld	hl,0x4
	push	hl
	ld	hl,-68+@740
	add	hl,sp
	push	hl
	lcall	$GetShort_
	add	sp,4
	ld	(ix-2),hl
;1942 
;1943     if (cmdLen > MaxCmdMsgLen-6)  {
	.debug	# 1943
	ld	de,0x803a
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@753
	jr	z,@753
;1944       if (ShowErrors)  printf("Max cmd len exceeded: %d\n", cmdLen);
@754:
	.debug	< @754 @755
	.debug	# 1944
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@756
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @22+1164)
	ld	c,phys @22+1164 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1945       skipBytes(0, cmdLen, 1000);  continue;
@756:
	.debug	# 1945
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$skipBytes
	add	sp,8
;1946     }
	jp	@747
@755:
	.debug	>
;1947 
;1948     if (read_(0, cmdBuf+6, cmdLen, 15000) < cmdLen)  {
@753:
	.debug	# 1948
	ld	de,0x3a98
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	ld	hl,-58+@740
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read_
	add	sp,10
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	call	__icmp##
	jr	nc,@757
;1949       perror("error reading cmd");  Exit(-2); }
@758:
	.debug	< @758 @759
	.debug	# 1949
	ld	de,word (phys @22+1190)
	ld	c,phys @22+1190 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
@759:
	.debug	>
;1950 
;1951     if (ModBusCmd(CT_MBNSCL, cmdBuf, respBuf, &respLen, eventsfd))  continu
@757:
	.debug	# 1951
	ld	hl,(ix-6)
	push	hl
	ld	hl,-2+@740
	add	hl,sp
	push	hl
	ld	hl,-322+@740
	add	hl,sp
	push	hl
	ld	hl,-64+@740
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$ModBusCmd
	add	sp,10
	bool	hl
	jp	nz,@747
;1952 
;1953     if (write(1, respBuf, respLen) != respLen)  {
	.debug	# 1953
	ld	hl,(ix-4)
	push	hl
	ld	hl,-324+@740
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write
	add	sp,6
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@761
;1954       perror("error writing response");  Exit(-3); }
@762:
	.debug	< @762 @763
	.debug	# 1954
	ld	de,word (phys @22+1208)
	ld	c,phys @22+1208 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
@763:
	.debug	>
;1955   }
@761:
@749:
	.debug	>
;1956 
;1957 }
	jp	@745
@744:
	.debug	>
@741:
	.debug	} @741 1957

@740	equ	326
	ld	sp,ix
	pop	ix
	lret
@742	equ	328
;1958 
;1959 //-------------------------------------------------------------------------
	.extern	_memcmp 95
	.extern	_memcpy 96
	.extern	_memmove 96
	.extern	_memset 97
	.extern	_strcmp 98
	.extern	_stricmp 98
	.extern	_strlen 64
	.extern	_strncpy 99
	.extern	_strcpyfn 100
	.extern	_fabs 101
	.extern	$redirectStdio 90
	.extern	$GetShort_ 102
	.extern	$Engineering 103
	.extern	$skipBytes 104
	.extern	$read_ 105
	.extern	_current 106
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 108
	.extern	$farfprintf 109
	.extern	$farprintf 110
	.extern	$farsprintf 111
	.extern	__TimerSeconds 9
	.extern	$xalloc 112
	.extern	_abs 113
	.extern	_labs 114
	.extern	_strtod 115
	.extern	$strtol 116
	.extern	$strtoi 117
	.extern	$strtoui 118
	.extern	$strtoul 119
	.extern	$open 120
	.extern	$write 121
	.extern	_KLOCK 108
	.extern	_KUNLOCK 108
	.extern	$resetWDT 108
	.extern	_diagLog 122
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	$Exit 123
	.extern	$perror 124
	.extern	_c0Coils 125
	.extern	_r3Regs 126
	.extern	_r4Regs 126
	.extern	_C0ChanMult 7
	.extern	_NumC0Chans 7
	.extern	_R3ChanMult 7
	.extern	_NumR3Chans 7
	.extern	_R4ChanMult 7
	.extern	_NumR4Chans 7
	.bseg
_numC0Coils::
	.ds	2
	.debug	G _numC0Coils 7 0
_numR3Regs::
	.ds	2
	.debug	G _numR3Regs 7 0
_numR4Regs::
	.ds	2
	.debug	G _numR4Regs 7 0
_numPVs::
	.ds	2
	.debug	G _numPVs 7 0
_numScopeRegs::
	.ds	2
	.debug	G _numScopeRegs 7 0
_captureIdx::
	.ds	2
	.debug	G _captureIdx 7 0
_scopeBufSampleSize::
	.ds	2
	.debug	G _scopeBufSampleSize 7 0
_bytesPerScopeSample::
	.ds	2
	.debug	G _bytesPerScopeSample 7 0
_captureCount::
	.ds	4
	.debug	G _captureCount 9 0
_scopeList::
	.ds	32
	.debug	G _scopeList 127 0
_scopeBuf::
	.ds	4
	.debug	G _scopeBuf 63 0
_capturePtr::
	.ds	4
	.debug	G _capturePtr 63 0
	.cseg
_MB_setACoil:
	pop	iy
	lcall	$$MB_setACoil
_MB_resetACoil:
	pop	iy
	lcall	$$MB_resetACoil
_roReg:
	pop	iy
	lcall	$$roReg
_setS16:
	pop	iy
	lcall	$$setS16
_setU16:
	pop	iy
	lcall	$$setU16
_setS32:
	pop	iy
	lcall	$$setS32
_setU32:
	pop	iy
	lcall	$$setU32
_setF32:
	pop	iy
	lcall	$$setF32
_setF32_ABS:
	pop	iy
	lcall	$$setF32_ABS
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.bseg
_pvList::
	.ds	4
	.debug	G _pvList 61 0
	.extern	_nonRegPVs 128
	.extern	_startupComplete 3
_numRegPVs::
	.ds	2
	.debug	G _numRegPVs 7 0
_numNonRegPVs::
	.ds	2
	.debug	G _numNonRegPVs 7 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.debug	T	0900012000100021000800
	.debug	T	070000210002000300
	.debug	T	0900012200280023000400
	.debug	T	09000123000A0024000500
	.debug	T	0900012400020002000200
	.debug	T	130002250003002600270000002100020021000400
	.debug	T	070000260002000100
	.debug	T	070000270002002800
	.debug	T	AD0003280014000C0001002B0000000772656756616C0005000200
	.debug	T	077265674E756D003F000400056E616D6500810008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F63637572656400260010000B
	.debug	T	6C61737443686756616C0026001200076D696E43686700
	.debug	T	17000229000400210021000000030002000600040026000600
	.debug	T	1700022A0004002100270000002B0002000700040021000600
	.debug	T	0700002B0002000400
	.debug	T	1700022C000400030026000000030002000300040006000600
	.debug	T	1700022D000400030007000000070002000300040006000600
	.debug	T	0700002E0002002F00
	.debug	T	4900032F000A00050001002100000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D003F000300056E616D6500820007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	17000230000400030026000000030002002600040006000600
	.debug	T	0900013100100003001000
	.debug	T	17000232000400030027000000030002000300040026000600
	.debug	T	130002330003000300270000000300020004000400
	.debug	T	130002340003000300270000000300020005000400
	.debug	T	130002350003000300270000000300020008000400
	.debug	T	130002360003000300270000000300020009000400
	.debug	T	13000237000300030027000000030002000A000400
	.debug	T	0F0002380002002700390000003A000200
	.debug	T	070000390002002700
	.debug	T	0700083A0004000100
	.debug	T	1300023B00030006003A0000002100040007000600
	.debug	T	0F00023C00020021003D00000021000400
	.debug	T	0700083D0004003E00
	.debug	T	2000033E0003000200010026000000067076446566000300020007
	.debug	T	70765479706500
	.debug	T	0700083F0004000300
	.debug	T	0B000240000100060021000000
	.debug	T	0900014100400003004000
	.debug	T	0F00024200020006000600000043000200
	.debug	T	070000430002004400
	.debug	T	52000344000D00060001003F000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	070000450002004600
	.debug	T	8A000346001D0009000950565F446573635F004400000007707649
	.debug	T	6E666F003A000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F63637572656400830015000A75706461746556616C00
	.debug	T	85001700086C6F636B56616C00870019000873656E6456616C
	.debug	T	0087001B000772637656616C00
	.debug	T	130002470003000600060000000600020006000400
	.debug	T	17000248000400060006000000070002002600040049000600
	.debug	T	070000490002004A00
	.debug	T	1300024A0003000600260000003A00020007000600
	.debug	T	1B00024B0005000600060000000700020007000400260006000700
	.debug	T	0800
	.debug	T	1700024C000400060006000000070002000700040026000600
	.debug	T	0F00024D00020006003900000003000200
	.debug	T	1300024E00030001004F0000005000020003000400
	.debug	T	0700004F0002000900
	.debug	T	070000500002000700
	.debug	T	0F00025100020006000600000007000200
	.debug	T	1B0002520005000600030000002100020021000400530006000600
	.debug	T	0800
	.debug	T	070000530002000600
	.debug	T	070000540002002300
	.debug	T	0900015500100005000800
	.debug	T	0900015600200003002000
	.debug	T	0B000257000100010007000000
	.debug	T	130002580003000600390000005000020003000400
	.debug	T	0F0002590002003D00390000003D000200
	.debug	T	0B00025A000100060001000000
	.debug	T	0700005B0002002E00
	.debug	T	0F00025C0002000100060000005D000200
	.debug	T	0700005D0002002100
	.debug	T	0900015E00000103000001
	.debug	T	1300025F0003000600260000002600020007000400
	.debug	T	130002600003002600260000002600020007000400
	.debug	T	130002610003002600260000000600020007000400
	.debug	T	0F00026200020006002100000021000200
	.debug	T	130002630003002100210000002100020007000400
	.debug	T	0F0002640002000100210000003F000200
	.debug	T	0B0002650001000B000B000000
	.debug	T	0F00026600020004002100000006000200
	.debug	T	1300026700030021000A0000000600040021000600
	.debug	T	130002680003000600060000000600020009000400
	.debug	T	17000269000400060006000000260002000600040008000600
	.debug	T	0700006A0002006B00
	.debug	T	7702036B00E8002D000C7461736B5F737472756374005000000006
	.debug	T	737461636B00500002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720088000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465006A00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	000561726763005D001A0005617267760089001C0005617267
	.debug	T	73008A009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773008B00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74003F00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0B00026C000100010001000000
	.debug	T	1300026D00030006008C0000003F0002000D000000
	.debug	T	0F00026E00020006003F0000000D000000
	.debug	T	1300026F00030006003F0000003F0004000D000000
	.debug	T	0B0002700001003F0009000000
	.debug	T	0B000271000100060006000000
	.debug	T	0B000272000100080008000000
	.debug	T	0F0002730002000B00210000005D000200
	.debug	T	130002740003000800210000005D00020006000400
	.debug	T	130002750003000600210000005D00020006000400
	.debug	T	130002760003000700210000005D00020006000400
	.debug	T	130002770003000900210000005D00020006000400
	.debug	T	130002780003000600210000000600020006000400
	.debug	T	130002790003000600060000002600020006000400
	.debug	T	5400037A000C00060001008D000000065F5F6F7574008F00020005
	.debug	T	5F5F696E0091000400085F5F77726974650091000600075F5F
	.debug	T	726561640006000800085F5F756E6765740026000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0B00027B000100010006000000
	.debug	T	0B00027C00010001003F000000
	.debug	T	0900017D0000002E000000
	.debug	T	0900017E00000027000000
	.debug	T	0900017F00200027001000
	.debug	T	0900018000000046000000
	.debug	T	070000810002003000
	.debug	T	070000820002002C00
	.debug	T	070000830002008400
	.debug	T	0B000284000100060045000000
	.debug	T	070000850002008600
	.debug	T	130002860003000600450000000600020006000400
	.debug	T	070000870002004800
	.debug	T	070000880002003A00
	.debug	T	0900018900800003008000
	.debug	T	2800038A0004000100125F5F776169745F71756575655F68656164
	.debug	T	0093000000096C6973744865616400
	.debug	T	0700008B0002005C00
	.debug	T	0700008C0002007A00
	.debug	T	0700008D0002008E00
	.debug	T	0F00028E00020006000300000026000200
	.debug	T	0700008F0002009000
	.debug	T	0B000290000100060026000000
	.debug	T	070000910002009200
	.debug	T	1300029200030008003F0000000800040026000800
	.debug	T	2600039300040002000A6C6973745F686561640094000000056E65
	.debug	T	78740094000200057072657600
	.debug	T	070000940002009300
	.seg	CONST
@1:
	.db	"S16",0,"U16",0,"S32",0,"U32",0,"F32",0,"STR",0,"U8",0,"S8",0,"OK",0,"Rejected",0,"RTYP",0,"STAS",0,"DESC",0,"DEBROS",0,"Rabbit Ctlr",0,"fifoEvent"
	.db	"s",0
	.defseg	FARCONST
	.seg	FARCONST
@22:
	.db	"%d",0,"%u",0,"%ld",0,"%lu",0," (0x%04x)    ",0," (0x%08lx)",0,"setCoil: %ls[%d] = %d",10,0,"set %ls[%d] = %u: %s",13,10,10
	.db	0,"attempt to change ReadOnly reg: %ls",10,0,"setS16: %ls[%d] = %d",10,0,"setU16: %ls[%d] = %u",10,0,"set"
	.db	"S32: %ls[%d] = %ld",10,0,"setU32: %ls[%d] = %lu",10,0,"setF32: %ls[%d] = %s",10,0,"setF32_ABS: %ls[%d] "
	.db	"= %s",10,0,"setReg() for %ls: invalid type: %u",13,10,0,"Attemped to set %ls[%d] (type %s) from val"
	.db	"ue of type %s",13,10,0,"<invalid>",0,"[%s] %d [%s]  %u,%u,%u",13,10,0,"RTYP",0,"STAS",0,"DESC",0,"Read coils: %05d - "
	.db	"%05d",13,10,0,"Response too long",13,10,0,"Read Regs: 4%04d - 4%04d",13,10,0,"Read Regs: 3%04d - 3%04d",13,10,0,"set "
	.db	"coil %05d[%d] to %d  *IGNORED*",10,0,"set coil %05d[%d] (%ls): %d",10,0,"set reg 4%04d[%d] to 0x%"
	.db	"04X %6d  *IGNORED*",10,0,"set reg 4%04d[%d] (%ls.%d): 0x%04X %6d",10,0,"write to RO reg %ls[%d] ="
	.db	" ignored",13,10,10,0,"set %ls[%d] = %s: %s",13,10,10,0,"Unrecognized or unsupported command: func code: %"
	.db	"d",13,10,0,"Badly formed command",13,10,0,"r4Regs[%02d]: 4%04d+%d %-16s [%04X]->[%04X]",13,10,0,"***** modbus"
	.db	" REG%c table error: %c%04u at pos for %c%04u *****",10,0,10,"Initialization for ModBus and PV"
	.db	" Interfaces...",13,10,0,10,"***** modbus COIL table error: 0%04u at pos for 0%04u *****",10,10,0,"PV co"
	.db	"unts:",10,"  C0Coils: %d",10,"  R3Regs: %d",10,"  R4Regs: %d",10,"  NonReg PVs: %d",10,0,10,"For sorted list of "
	.db	"%u PVs:",10,0,"Sorting PV names...",10,0,"timeout reading modbusTCP cmd",0,"Max cmd len exceeded: %d",10
	.db	0,"error reading cmd",0,"error writing response",0
	.end
