	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\drivers\socket.c' 25 48 11 5 12 32
;1 //----- socket.c ----- 07/31/12 -----(03/12/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  NOTE:  See the _README_.txt file for changes that need to be made to th
;5 //         Softools/ZWorld Stcpip source files .
;6 //-------------------------------------------------------------------------
;7 
;8 //-------------------------------------------------------------------------
;9 //  Standard DEBROS virtual file/device I/O API for reading and writing to
;10 //  sockets
;11 //-------------------------------------------------------------------------
;12 //  Update log (most recent first)
;13 //
;14 //
;15 //  2012-07-31 - Mark Davis (*)
;16 //               - An ENETDOWN error is now only asserted for functions tha
;17 //                 return it if the link was up then went down for at least
;18 //                 30 seconds.
;19 //
;20 //  2012-06-20 - Mark Davis (*)
;21 //               - _socketRead_(), _socketWrite(), send(), sendto(), recv()
;22 //                 and recvfrom() now return an error if the network lib
;23 //                 functions don't even after the link does down for the
;24 //                 interface the socket is attached to.  Prior to this,
;25 //                 attempting to read (and write?) to a socket after the
;26 //                 link goes down did not return an error even if its write
;27 //                 buffer was full (or its read buffer empty).
;28 //
;29 //  2012-06-06 - Mark Davis
;30 //               - When a new connection is established for a listening soc
;31 //                 the socket that replaces the listening one now uses the
;32 //                 local addresses originally set for the listening socket,
;33 //                 rather than the one for the local interface the new
;34 //                 connection was established on.
;35 //               - TCP Listening sockets are now "Virtual".  This means the
;36 //                 do not use a tcp_Socket structure or the related buffers
;37 //                 until they are actually connected. This avoids the need 
;38 //                 tie up a tcp_Socket structure and its I/O buffers until 
;39 //                 socket is actually connected by a successful call to
;40 //                 accept() or connect().  This frees up several sockets th
;41 //                 were tied up as listeners.
;42 //               - Changed SockInfo.closeCalled to noFDEVrefs to clarify th
;43 //                 meaning of this flag.
;44 //
;45 //  2012-04-20 - Mark Davis
;46 //               - Added tcpCounts() and udpCounts() to get total and free
;47 //                 counts for the global pool of sockets.
;48 //
;49 //  2012-02-24 - Mark Davis
;50 //               - Changed SockInfo.state to conState and expanded its use 
;51 //                 better track the state of a connection.
;52 //               - sendto() now checks the connection state of TCP sockets 
;53 //                 whether an address is given or not and returns appropria
;54 //                 error states as needed.
;55 //               - _socketWrite_() now checks the connection state of TCP
;56 //                  sockets and returns an error if the socket is not conne
;57 //               - accept() now sets the conState when the connection is
;58 //                 readable
;59 //               - Reduced the # of UDP socket buffers by 1.  This was made
;60 //                 possible by eliminating some unneeded items from the
;61 //                 Softools/ZWorld socket library that were not needed (but
;62 //                 were still being linked in).
;63 //               - The broadcast address returned by getIFConfig() is now
;64 //                 based on the netmask and IP address (previously it simpl
;65 //                 returned 0xffffffff).
;66 //
;67 //  2012-02-08 - Mark Davis
;68 //               - errno is now set to EBADF rather than ENXIO when a funct
;69 //                 is passed an invalid device pointer.
;70 //
;71 //  2012-02-07 - Mark Davis
;72 //               - The broadcast addr for an interface is now computed base
;73 //                 on the address and the netmask.
;74 //
;75 //  2012-01-25 - Mark Davis
;76 //               - Minor mod to simplify if condition in sendto()
;77 //
;78 //  2011-05-02 - Mark Davis (*)
;79 //               - Added a reset of the watchdog timer to startUpIF().  Pri
;80 //                 to this the updated startup sequence and non-blocking
;81 //                 handling of starting up and taking down the network coul
;82 //                 result in the watchdog timer expiring during startup.
;83 //
;84 //  2011-03-30 - Mark Davis (*)
;85 //               - Fixed bug in socket() that caused it to use the wrong me
;86 //                 address when allocating any UDP connection but the 1st o
;87 //                 Prior to this it would use the correct addr for the 1st 
;88 //                 the addr of the 3rd one for the 2nd one, and addresses p
;89 //                 the end of the array for the 3rd and 4th ones (so basica
;90 //                 anything but the 1st one could cause problems).
;91 //               - _fdSocket_() now returns EBADF rather than ENOTSOCK if t
;92 //                 fd references a SockInfo structure but it is not current
;93 //                 in use.
;94 //
;95 //  2011-03-25 - Mark Davis (*)
;96 //               - Fixed diagnostic code in _socketClose_() so it doesn't
;97 //                 try to dump info on an empty wait queue (which ends up
;98 //                 causing a watchdog timeout when it gets stuck in a loop!
;99 //               - validSOCK() now returns false for invalid pointers (it w
;100 //                 always returning true!)
;101 //               - Added closeCalled to avoid freeing up a SockInfo struct 
;102 //                 it is still in use by an FDEV.  This can happen when soc
;103 //                 connections are closed by the kernel (e.g. in preperatio
;104 //                 for shutting down the network interface to change its
;105 //                 address or to reboot).
;106 //
;107 //  2011-01-31 - Mark Davis
;108 //               - When enabled, the syslog diagnostic messages generated b
;109 //                 tcpSockEvent_() now includes any errors for codes stored
;110 //                 the network library's socket structure.
;111 //
;112 //  2011-01-26 - Mark Davis
;113 //               - getIFConfig() and setIFConfig() now use the new gateway
;114 //                 value in the IFConfig structure.
;115 //
;116 //  2010-09-09 - Mark Davis (*)
;117 //               - Changed validSOCK() to use the new INVALID() macro to be
;118 //                 check for invalid pointers, and to produce log msgs when
;119 //                 an attempt to use one occurs.
;120 //               - _socketTick_() now does its processing each time it is
;121 //                 called if a shutdown is in process.  This helps to fully
;122 //                 close and cleanup the socket connections during a contro
;123 //                 shutdown.
;124 //
;125 //  2010-07-07 - Mark Davis (*)
;126 //               - tcpSockEvent() now checks to make sure the passed socket
;127 //                 is a reference to a valid, in-use socket.
;128 //               - _socketRead_() and _socketWrite_() now make sure the
;129 //                 passed device pointer is valid before setting the device
;130 //                 diagFlags value.
;131 //
;132 //  2010-05-21 - Mark Davis (*)
;133 //               - When a socket connection is reset, the rdOK flag is now 
;134 //                 based on whether there are any unread chars remaining, a
;135 //                 any tasks in the read queue are woken up.
;136 //               - The ioctl call now returns -1 with errno = ENOLINK for t
;137 //                 FIONREAD/FIONSPACE requests if rdOK/wrOK is false.
;138 //
;139 //  2010-05-14 - Mark Davis
;140 //               - Commented out change for 05-11 as it did not change anyt
;141 //                 and it just adds overhead.
;142 //               - ioctl function now supports FIONSPACE request
;143 //
;144 //  2010-05-12 - Mark Davis (*)
;145 //               - accept() now checks to make sure the socket isn't closed
;146 //
;147 //  2010-05-11 - Mark Davis (*)
;148 //               - Added call to sock_tbleft() in _socketWrite_() function
;149 //                 to see if I could eliminate the problem where the
;150 //                 sock_fastwrite() func appears to accept many writes but
;151 //                 not actually deliver the packets.  This was showing up i
;152 //                 the scope command which would have its output "freeze"
;153 //                 even though the lsof command (which shows the writeCount
;154 //                 the FDEV device) showed that data continued to be writte
;155 //                 to the socket.
;156 //
;157 //  2010-05-02 - Mark Davis (*)
;158 //               - Added locks to _socketRead_() and _socketWrite_() functi
;159 //                 in case the locking calls done within the socket library
;160 //                 not sufficient to safeguard the socket structures.
;161 //
;162 //  2010-04-26 - Mark Davis
;163 //               - Changes to accomodate more capable wait queue handling
;164 //
;165 //  2010-04-09 - Mark Davis (*)
;166 //               - Moved the call to sock_flush() in _socketClose_() to wit
;167 //                 KLOCK()/KUNLOCK() sequence.  Without this, it is possibl
;168 //                 for the close call to be preempted after the KUNLOCK() a
;169 //                 the socket and socket table entry to be in various state
;170 //                 between being closed and open and in use by another task
;171 //                 when _socketClose_() resumes and calls sock_flush().
;172 //               - Added check to _socketClose_() to make sure no tasks are
;173 //                 still in the wait queue.
;174 //               - Added lastClosed to SockInfo and use of it to make sure 
;175 //                 a socket entry is allocated it is the least recently use
;176 //                 of the ones available (reducing the risk that some bug i
;177 //                 the socket library is causing a problem when reusing a
;178 //                 socket that it claims is closed).
;179 //
;180 //  2010-03-04 - Mark Davis
;181 //               - recv(), recvfrom(), send(), and sendto() now all take a
;182 //                 far pointer for the buffer.
;183 //
;184 //  2010-03-02 - Mark Davis
;185 //               - recv(), recvfrom(), send(), and sendto() now all update
;186 //                 the readCount/writeCount value in the FDEV structure.
;187 //               - sendto() now uses the port number (if provided) when sen
;188 //                 UDP broadcast packets.
;189 //
;190 //  2010-01-12 - Mark Davis (*)
;191 //               - Added breaks in switch statement and locking to
;192 //                 checkSockets()
;193 //
;194 //  2009-12-10 - Mark Davis
;195 //               - Removed call to DLM_Tick() at least for now. It is one
;196 //                 more possible cause of some unexplained instabilities an
;197 //                 mostly just another opportunity for human error to cause
;198 //                 problems.  With this commented out, the device will not
;199 //                 show up in the SHD Update Manager when not running the D
;200 //                 so there is no chance for someone to accidentially click
;201 //                 on the wrong device and mess up a live controller.
;202 //
;203 //  2009-11-05 - Mark Davis
;204 //               - The configd task's announcementInterval is now reset
;205 //                 whenever the Ethernet link comes up.
;206 //
;207 //  2009-10-01 - Mark Davis
;208 //               - _socketTick_() now calls tcp_tick() each time but only
;209 //                 does the other "housekeeping" stuff (like managing close
;210 //                 sockets) about every 50ms.  This adds a bit of overhead
;211 //                 but reduces latency and improves response time for tasks
;212 //                 that use socket connections (like modbusTCPd).
;213 //
;214 //  2009-09-30 - Mark Davis
;215 //               - _socketTick_() now updates netReady.  This eliminates
;216 //                 errors claiming the Network is down if it was down when
;217 //                 it was first initialized but came up after initializatio
;218 //               - _socketTick_() also checks the physical layer link statu
;219 //                 and logs a message when the status changes.
;220 //
;221 //  2009-09-29 - Mark Davis
;222 //               - _socketTick_() now uses time rather than ticks to determ
;223 //                 when to skip processing.  This improves response time fo
;224 //                 slower tick rates, although it means the overhead of the
;225 //                 network processing does not change when the tick rate is
;226 //                 lowered.
;227 //
;228 //  2009-08-26 - Mark Davis
;229 //               - Removed definition of references to noRefs attribute whi
;230 //                 apparently was only set to false in the close call (i.e.
;231 //                 it had no affect).
;232 //
;233 //  2009-08-25 - Mark Davis
;234 //               -_socketClose_() now calls sock_flush() for TCP socket typ
;235 //                to try to insure the data from any recent writes actually
;236 //                make it to the other end before the socket is reused.
;237 //
;238 //  2009-08-05 - Mark Davis
;239 //               - Moved responsiblity for not messing up an fd's flags
;240 //                 settings from _newListener_() to _File_Swap_() (in the
;241 //                 fcntl.c module).  _newListener_() was actually
;242 //                 just clearing the O_NONBLOCK bit in flags for the new
;243 //                 socket fd, which did not leave the original fd with the
;244 //                 correct settings.
;245 //
;246 //  2009-08-04 - Mark Davis
;247 //               - removed handling of blocking mode from accept() for now
;248 //                 as this can cause problems until I move task-specific
;249 //                 descriptor settings out of the global descriptors and
;250 //                 in to the task-specific ones.
;251 //
;252 //  2009-07-31 - Mark Davis
;253 //               - setsockopt() and getsockopt() now check for a NULL point
;254 //                 for the val parameter.
;255 //               - getsockopt() now checks the value referenced by valLen
;256 //                 to insure the buffer pointed to by val is large enough.
;257 //               - listen() now returns an error if the socket type is not
;258 //                 SOCK_STREAM.
;259 //
;260 //  2009-07-30 - Mark Davis
;261 //               - setsockopt() now pays attention to the val passed so the
;262 //                 broadcast option can be set or reset
;263 //               - getsockopt() now allows the state of the broadcast optio
;264 //                 to be read
;265 //               - Functions that can return a new socket now return an err
;266 //                 if the network is not ready or is going down
;267 //               - accept() now handles blocking mode
;268 //
;269 //  2009-06-23 - Mark Davis
;270 //               - Changed WDT_2S() calls to resetWDT()
;271 //
;272 //  2009-06-19 - Mark Davis
;273 //               - Modified upInterface() so it doesn't cause a reboot if
;274 //                 it takes too long (a recently introduced problem related
;275 //                 to the changes to dump diagnostic data when the watchdog
;276 //                 timer is about to expire and cause a reboot).
;277 //
;278 //  2009-05-01 - Mark Davis
;279 //               - set skipTicks to false at end of socketInit_() so the
;280 //                 _socketTick_() function will actually do something
;281 //
;282 //  2009-03-26 - Mark Davis
;283 //               - Added placeholder unlink and rename functions
;284 //
;285 //  2009-03-24 - Mark Davis
;286 //               - added _socketEntry_() function for getting info about so
;287 //                 fds
;288 //
;289 //  2009-02-20 - Mark Davis
;290 //               - Modified recvfrom() so it doesn't do the work of getting
;291 //                 the address and port of the sender if the fromAddr is NU
;292 //                 This should eliminate lots of ARP traffic when receiving
;293 //                 broadcast messages.
;294 //
;295 //  2006-03-12 - Mark Davis
;296 //               - began work on new module
;297 //
;298 //-------------------------------------------------------------------------
;299 
;300 //-------------------------------------------------------------------------
;301 //  Overview of basics of creating/using socket fd's:
;302 //
;303 //   - Call socket() to create a socket and get a fd for it
;304 //
;305 //   - To open a connection to a specific port+addr:
;306 //        - Call connect()
;307 //
;308 //   - To listen for and accept incoming connections or packets:
;309 //
;310 //        - Call bind() to specify the local port and which interface(s)
;311 //          (indirectly) by specifying a local addr (or INADDR_ANY for all
;312 //          interfaces)
;313 //
;314 //        For TCP (stream-based) sockets:
;315 //          - Call listen() to mark the socket as a passive listener, creat
;316 //            a queue for incoming connection requests, and begin accepting
;317 //            connections on the port+addr/interface(s) specified by bind()
;318 //
;319 //          - Call accept() to create a new fd for a new open socket connec
;320 //            for the first pending connection in the queue for the listeni
;321 //            socket.
;322 //
;323 //        For UDP (packet-based message) sockets:
;324 //          - Call recv() or recvfrom() to get the next packet sent to the
;325 //            port+addr specified in the call to bind()
;326 //
;327 //-------------------------------------------------------------------------
;328 
;329 
;330 /*-------------------------------------------------------------------------
;331 NOTES on DynamicC network stack code (came with Softools WinIDE):
;332 
;333 Functions that call tcp_tick():
;334    tcp_open(), udp_open()
;335    sock_read(), sock_write()
;336    sock_close(), sock_abort()
;337    All blocking functions
;338 
;339    In general, non-blocking functions do NOT call tcp_tick()
;340 
;341 
;342 To manually associate a buffer with a socket:
;343    tcp_extlisten(),  tcp_extopen(), udp_extopen()
;344    sock_xfastread(), sock_xfastwrite(), udp_xsendto()
;345 
;346 
;347 Reserved listening ports:
;348 
;349    (include/Stcpip/tcp.h)
;350       extern word tcp_reserveports[];
;351       extern const char MAX_RESERVEPORTS;
;352 
;353    #define USE_RESERVEDPORTS        (inet.h)
;354 
;355    call to tcp_initreserve()        (tcp_02.c)
;356 
;357    tcp_reserveport(port)            (tcp_38.c)
;358       tcp_reserveports[]
;359 
;360    tcp_initreserve()                (tcp_39.c)
;361 
;362    tcp_clearreserve()               (tcp_40.c)
;363 
;364    void tcp_handler(in_Header *ip)  (tcp_41.c)
;365 
;366 ---------------------------------------------------------------------------
;367 
;368 TO-DO:
;369 
;370   - Would it help at all to switch MAX_ETH_BUFS and ETH_MTU back to their
;371     defaults of 10 and 600 (rather than the 4 and 1500 Softools sets them t
;372     While the smaller MTU might be a problem, having MORE buffers might
;373     improve throughput.  (And what am I using for the MAX_ETH_BUFS?)
;374 
;375 
;376   - Is there a logical place/circumstance that I could call sock_flush() to
;377     avoid any possible delay in sending data when I know I won't be writing
;378     to a socket for a bit?  Perhaps where I currently check # of unused
;379     bytes in the xmit buffer I should call sock_flush() (and then tcp_tick(
;380     if sock_flush() doesn't already?)
;381 
;382 
;383   - Section 3.8.2: "Incoming packets are process whenever tcp_tick() is cal
;384     What about outgoing packets?  Particularly when the nagle algorithm is
;385     enabled (which it is by default)?
;386 
;387 
;388   - The send(), sendto(), recv(), and recvfrom() funcs don't currently hand
;389     blocking mode (they behave as if the fd has non-blocking mode set).
;390 
;391 
;392   - I don't believe blocking mode currently works at ALL for UDP sockets!
;393     Waking up a task blocked on a read from or write to a TCP socket is han
;394     by the event callback mechanism for TCP sockets, but I don't yet use th
;395     callback mechanism for UDP sockets.  At the moment, doing a blocking-mo
;396     read() or write() on an fd for a UDP socket would probably block the
;397     caller forever!
;398 
;399     NOTE:  For UDP sockets, you get a UDP_DH_INDATA event whenever a new,
;400     unread packet has arrived.  There is no equivalent to TCP_DH_OUTBUF to
;401     wake up a task blocked waiting to write to a UDP socket.
;402 
;403     Two possibilities come to mind to handle this:  Either use the default
;404     method for drivers that don't handle the wait queues on their own (whic
;405     is to use the sleep wait queue), or have the _socketTick_() function
;406     check the state of any UDP sockets with blocked tasks and wake them up
;407     as appropriate.
;408 
;409     The later is certainly the preferred method, as it means that tasks are
;410     woken up only when they need to be.  When it comes right down to it, th
;411     callback mechanism for TCP sockets really isn't any different.  It can
;412     only do the callbacks during a call to tcp_tick(), which is done by
;413     _socketTick_(), so all we are doing is adding the same functionality fo
;414     UDP packets.
;415 
;416     In fact, this way the event checking is limited to sockets that need it
;417     whereas the current method for TCP sockets does the callback regardless
;418     whether or not there are tasks blocked waiting for the event.  But I
;419     suppose those callbacks are done as just an extension of the processing
;420     that has to happen for the TCP sockets in any case, so it really isn't
;421     adding all that much to the processing to perform the callbacks.
;422 
;423     And it IS handy for debugging, since I can see all the events for a
;424     socket (at least TCP ones).
;425 
;426 
;427   - Add support for "overflow" buffers.  When the network lib xmit buffer f
;428     a TCP socket is full, then assign an overflow buffer to the socket and
;429     copy the data there.  Then the TCP_DH_OUTBUF event in tcpSockEvent_() c
;430     call sock_xfastwrite() to move data from the overflow buffer to the
;431     network lib's buffer.
;432 
;433     The idea is that this would increase the max throughput rate for a
;434     socket for the following reasons:
;435 
;436       - Without overflow buffers, a call to write to a socket when the
;437         network lib's internal xmit buffer for the socket is nearly full
;438         will result in the task being blocked (or returning with very
;439         little or none of the data being processed).
;440 
;441         Then, during a call to tcp_tick() (during the kernel's periodic
;442         background processing), when the network lib has emptied its intern
;443         xmit buffer for a socket, it will not have any more data to send fo
;444         the socket until the following occurs:
;445           - tcp_tick() returns
;446           - All the rest of the kernel's background processing finishes
;447           - The task that owns the socket is resumed and has time to
;448             write more data to the socket before being preempted.
;449           - The kernel executes again and does it background processing
;450             (which includes a call to tcp_tick())
;451 
;452       - With overflow buffers, a call to write to a socket when the
;453         network lib's internal xmit buffer for the socket is nearly full
;454         will result in at least some of the extra data being copied to an
;455         overflow buffer before the task is blocked (or returning to the tas
;456 
;457         The rest scenario is the same with one exception:  When tcpSockEven
;458         is called for the TCP_DH_OUTBUF event, it can refill the network li
;459         internal buffer by moving data from the overflow buffer.  Assuming 
;460         call to tcp_tick() will process this new data after tcpSockEvent()
;461         returns, this should greatly decrease the time (and most likely the
;462         of CPU cycles) required to send the same amount of data.
;463 
;464         Of course, this assumes that the overhead of the additional logic
;465         for the overflow buffers is less than going through the whole
;466         cycle shown above.
;467 
;468         A related question:  Will tcp_tick() call tcpSockEvent_() multiple
;469         times for the same socket when applicable?
;470 
;471         The one (possibly significant) downside:  tcp_tick() calls will run
;472         longer, which will increase the kernel's CPU usage, which will
;473         decrease the number of cycles available each scheduler tick for oth
;474         tasks.
;475 
;476         Of course, that is a generic issue that applies to any process you
;477         make more efficient by doing the processing in larger chunks:  Whil
;478         it may take fewer CPU cycles per unit of work (in this case, the # 
;479         bytes transmitted), if you make use of the increased efficiency to
;480         get more done per unit of time, then the # of CPU cycles used per
;481         unit of time is the same or even more.
;482 
;483         So the tradeoff is the same as for choosing the interval for the
;484         periodic scheduler tick:
;485 
;486           Shorter intervals:
;487              More task switches per second decreases latency, but lower
;488              overall efficiency due to more time spent switching tasks.
;489 
;490           Longer intervals:
;491              Fewer task switches per second increases latency, but higher
;492              overall efficient due to less time spent switching tasks.
;493 
;494         Adding overflow buffering is just this same concept applied to
;495         socket connections:  Each call to tcp_tick() can do more, but will
;496         require more CPU time to do it.  The result can be 1 of 3 things:
;497 
;498           - The rate of sending data is not allowed to increase, so the
;499             increased efficiency means the CPU usage of the tasks making
;500             use of the overflow buffering decreases (by more than the
;501             averagae increase for tcp_tick() calls), so there are more
;502             CPU cycles available for other tasks.
;503 
;504           - The rate of sending data is allowed to increase but only to
;505             the point where the combination of the CPU usage of tcp_tick()
;506             and the sending tasks are the same as they were before.  The
;507             result is higher throughput with the same CPU usage (although
;508             the increase in tcp_tick()'s usage will affect latency a bit
;509             for other tasks).
;510 
;511           - The rate of sending data is allowed to increase to the new
;512             maximum.  The CPU usage of tcp_tick() will be higher, and the
;513             CPU usage of the sending tasks will probably also increase a
;514             bit (since they will being doing a bit more work before they
;515             block, making use of the overflow buffers).  The result will
;516             be an increase in CPU usage, but also (hopefully) a significant
;517             increase in throughput for the socket connections.
;518 
;519 
;520          But all of this is speculation; An educated guess.  If the call to
;521          tcp_tick() does NOT process new data put in to the xmit buffers by
;522          a call to the event handler, then overflow buffering probably won'
;523          improve throughput much.  After the first call, the # of bytes
;524          processed for each call will be (on average) the same as it was
;525          without the overflow buffering.  A signficant gain requires that t
;526          average per call goes UP by an amount roughly equivalent to the
;527          amount of overflow buffer used.
;528 
;529          And keep in mind that we are also adding ANOTHER buffer-to-buffer
;530          copy for each use of the overflow buffer.  If data added to the
;531          network lib's xmit buffer for a socket by tcpSockEvent_() is NOT
;532          processed before tcp_tick returns, then this is mostly just wasted
;533          additional overhead.  There MIGHT be a small gain by virtue of the
;534          fact that the library's internal buffer will more often be full at
;535          the start of a tcp_tick() call, which would result in fewer/larger
;536          packets on average.  But I doubt any such gain would be as large
;537          as from processing it ASAP.
;538 
;539 
;540 ---------------------------------------------------------------------------
;541 
;542 
;543 #include <common.h>
;544 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;545 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;546 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;547 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;548 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;549 #include <sys/socket.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;550 #include <arpa/inet.h>
;551 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;552 #include <errno.h>
;553 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;554 #include <string.h>
;555 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;556 #include <busybox.h>
;557 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
;558 //#include <sys/RegVars.h>
;559 #include <SHD_DLM.h>
;560 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;561 #include <sys/configd.h>
;562 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\configd.h' 10 21 11 5 11 29
	.debug	I
;563 #include <sys/farprintf.h>
;564 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;565 
;566 
;567 
;568 #define ConnectTimeout  10000  // max time (in ms) for connect() to finish
;569 
;570 
;571 
;572 const char MAX_RESERVEPORTS = MaxListenTCP;
	.defseg	CONST
	.seg	CONST
_MAX_RESERVEPORTS::
	.db	0x6
	.debug	G _MAX_RESERVEPORTS 3 0
;573 word tcp_reserveports[MaxListenTCP];
;574 
;575 
;576 const unsigned  TCP_BUF_SIZE  = 4096;
_TCP_BUF_SIZE::
	.dw	0x1000
	.debug	G _TCP_BUF_SIZE 7 0
;577 const unsigned  UDP_BUF_SIZE  = 2048;
_UDP_BUF_SIZE::
	.dw	0x800
	.debug	G _UDP_BUF_SIZE 7 0
;578 
;579 const char MAX_TCP_SOCKET_BUFFERS = MaxTCPCons;
_MAX_TCP_SOCKET_BUFFERS::
	.db	0xc
	.debug	G _MAX_TCP_SOCKET_BUFFERS 3 0
;580 const char MAX_UDP_SOCKET_BUFFERS = MaxUDPSockets + 1;
_MAX_UDP_SOCKET_BUFFERS::
	.db	0x5
	.debug	G _MAX_UDP_SOCKET_BUFFERS 3 0
;581 
;582 //--- Rabbit TCPIP lib structures for keeping track of each socket ---
;583 tcp_Socket tcpSockDef[MaxTCPCons];
;584 udp_Socket udpSockDef[MaxUDPSockets];
;585 
;586 
;587 //--- DEBROS structures for keeping track of the state of each socket ---
;588 SockInfo  tcpSockets[MaxTCPSockets];
;589 SockInfo  udpSockets[MaxUDPSockets];
;590 
;591 //--- index in to list for a given SockInfo structure ---
;592 #define TCP_SI_Idx(ptr)  ( (uint)((ptr) - tcpSockets) )
;593 #define UDP_SI_Idx(ptr)  ( (uint)((ptr) - udpSockets) )
;594 
;595 //--- get ptr to TCP/UDP SockInfo object from a ptr to a tcp_/udp_Socket --
;596 #define TCP_SD_To_SI(sp) ( (SockInfo *) ((tcp_Socket *)(sp))->user_data )
;597 #define UDP_SD_To_SI(sp) ( udpSockets + (uint)((udp_Socket *)(sp)-udpSockDe
;598 
;599 
;600 
;601 IODEV_FUNCS(socket)
_socketIOFuncs::
	.dw	word __socketRead_
	.dw	word __socketWrite_
	.dw	word __socketClose_
	.dw	word __socketLseek_
	.dw	word __socketFstat_
	.dw	word __socketioctl_
	.dw	word __socketDescr_
	.dw	word __socketGetQueues_
	.debug	G _socketIOFuncs 32 0
;602 IODEV_FUNCS(socket)
;603 FILESYS_FUNCS(socket)
_socketFSysFuncs::
	.dw	@1
	.dw	word _socketIOFuncs
	.dw	word __socketTick_
	.dw	word __socketEntry_
	.dw	word __socketOpen_
	.dw	word __socketUnlink_
	.dw	word __socketRename_
	.debug	G _socketFSysFuncs 33 0
;604 FILESYS_FUNCS(socket)
;605 #define SI  ((SockInfo *)ioDev)
;606 
;607 
;608 #define SockClosed(sock)    
;609         ( (sock_alive(sock) == 0) OR (strcmp(sockstate(sock), "Closed") == 
;610 
;611 //-------------------------------------------------------------------------
;612 bool  skipTicks, netReady, linkWentDown, netGoingDown, closingSockets;
;613 ulong  startedDownMS, linkDownMS;
;614 
;615 
;616 
;617 //*********************************************************************
;618 //***** Must match list found in stcpip/neterrno tcpip lib source *****
;619 //*********************************************************************
;620 
;621 #define NETERR_NONE                 0
;622 #define NETERR_NOHOST_ARP           1     // Local host not reachable (ARP 
;623 #define NETERR_NOHOST_RTE           2     // Host not reachable (Router not
;624 #define NETERR_HOST_REFUSED         3     // Host refused connection
;625 #define NETERR_OPEN_TIMEOUT         4     // Timout on open or close
;626 #define NETERR_CONN_TIMEOUT         5     // Connection timed out (keepaliv
;627 #define NETERR_ABORT                6     // Active abort sent from this pe
;628 #define NETERR_INACTIVE_TIMEOUT     7     // Timed out due to inactivity
;629 #define NETERR_LEASE_EXPIRED        8     // DHCP lease expired
;630 #define NETERR_ICMP                 9     // ICMP reported trouble
;631 #define NETERR_PROTOCOL            10     // Protocol error e.g. bad ack nu
;632 #define NETERR_REMOTE_RESET        11     // Remote peer reset connection
;633 #define NETERR_NET_UNREACH         12     // ICMP errors...
;634 #define NETERR_HOST_UNREACH        13     //
;635 #define NETERR_PROTO_UNREACH       14     //
;636 #define NETERR_PORT_UNREACH        15     //
;637 #define NETERR_FRAG_NEEDED         16     //
;638 #define NETERR_SOURCE_ROUTE_FAIL   17     //
;639 #define NETERR_DEST_NET_UNKNOWN    18     //
;640 #define NETERR_DEST_HOST_UNKNOWN   19     //
;641 #define NETERR_ISOLATED            20     //
;642 #define NETERR_DEST_NET_PRHB       21     //
;643 #define NETERR_DEST_HOST_PRHB      22     //
;644 #define NETERR_NET_TOS_UNREACH     23     //
;645 #define NETERR_HOST_TOS_UNREACH    24     //
;646 #define NETERR_TTL_EXC             25     //
;647 #define NETERR_FRAG_REASM_EXC      26     //
;648 #define NETERR_REDIRECT_NET        27     //
;649 #define NETERR_REDIRECT_HOST       28     //
;650 #define NETERR_REDIRECT_TOS_NET    29     //
;651 #define NETERR_REDIRECT_TOS_HOST   30     //
;652 #define NETERR_PARAM_PROB          31     //
;653 #define NETERR_PARAM_PROB_REQOPT   32     //
;654 #define NETERR_SOURCE_QUENCH       33     // ...last ICMP error
;655 #define NETERR_IPADDR_CHANGE       34     // IP address changed
;656 #define NETERR_OUT_OF_MEMORY       35     // No memory for buffer etc.
;657 #define NETERR_IPADDR_CONFLICT     36     // IP address conflict detected
;658 #define NETERR_IFDOWN              37     // Interface down or deactivated
;659 
;660 
;661 #pragma seg (FARDATA,FARCONST)
;662 
;663 #pragma warn -787
;664 
;665 const char far * far NetErrStrings[] = {
;666   "OK",                                      //  0
	.defseg	FARCONST
	.seg	FARCONST
_NetErrStrings::
	.dw	word (phys @2)
	.dw	phys @2 >> 16
;667   "Local host not reachable (ARP)",          //  1
	.dw	word (phys @2+3)
	.dw	phys @2+3 >> 16
;668   "Host not reachable (Router)",             //  2
	.dw	word (phys @2+34)
	.dw	phys @2+34 >> 16
;669   "Host refused connection",                 //  3
	.dw	word (phys @2+62)
	.dw	phys @2+62 >> 16
;670   "Timout on open or close",                 //  4
	.dw	word (phys @2+86)
	.dw	phys @2+86 >> 16
;671   "Connection timed out",                    //  5
	.dw	word (phys @2+110)
	.dw	phys @2+110 >> 16
;672   "Active abort sent from this peer",        //  6
	.dw	word (phys @2+131)
	.dw	phys @2+131 >> 16
;673   "Timed out due to inactivity",             //  7
	.dw	word (phys @2+164)
	.dw	phys @2+164 >> 16
;674   "DHCP lease expired",                      //  8
	.dw	word (phys @2+192)
	.dw	phys @2+192 >> 16
;675   "ICMP reported trouble",                   //  9
	.dw	word (phys @2+211)
	.dw	phys @2+211 >> 16
;676   "Protocol error",                          // 10
	.dw	word (phys @2+233)
	.dw	phys @2+233 >> 16
;677   "Remote peer reset connection",            // 11
	.dw	word (phys @2+248)
	.dw	phys @2+248 >> 16
;678   "Network unreachable",                     // 12
	.dw	word (phys @2+277)
	.dw	phys @2+277 >> 16
;679   "Host unreachable",                        // 13
	.dw	word (phys @2+297)
	.dw	phys @2+297 >> 16
;680   "Protocol unreachable",                    // 14
	.dw	word (phys @2+314)
	.dw	phys @2+314 >> 16
;681   "Port unreachable",                        // 15
	.dw	word (phys @2+335)
	.dw	phys @2+335 >> 16
;682   "Fragmentation needed but DF",             // 16
	.dw	word (phys @2+352)
	.dw	phys @2+352 >> 16
;683   "Source route failed",                     // 17
	.dw	word (phys @2+380)
	.dw	phys @2+380 >> 16
;684   "Destination network unknown",             // 18
	.dw	word (phys @2+400)
	.dw	phys @2+400 >> 16
;685   "Destination host unknown",                // 19
	.dw	word (phys @2+428)
	.dw	phys @2+428 >> 16
;686   "This host isolated",                      // 20
	.dw	word (phys @2+453)
	.dw	phys @2+453 >> 16
;687   "Destination network prohibited",          // 21
	.dw	word (phys @2+472)
	.dw	phys @2+472 >> 16
;688   "Destination host prohibited",             // 22
	.dw	word (phys @2+503)
	.dw	phys @2+503 >> 16
;689   "Network type-of-service unreachable",     // 23
	.dw	word (phys @2+531)
	.dw	phys @2+531 >> 16
;690   "Host type-of-service unreachable",        // 24
	.dw	word (phys @2+567)
	.dw	phys @2+567 >> 16
;691   "Time-to-live exceeded",                   // 25
	.dw	word (phys @2+600)
	.dw	phys @2+600 >> 16
;692   "Fragment reassembly time exceeded",       // 26
	.dw	word (phys @2+622)
	.dw	phys @2+622 >> 16
;693   "Redirect for network",                    // 27
	.dw	word (phys @2+656)
	.dw	phys @2+656 >> 16
;694   "Redirect for host",                       // 28
	.dw	word (phys @2+677)
	.dw	phys @2+677 >> 16
;695   "Redirect for TOS and network",            // 29
	.dw	word (phys @2+695)
	.dw	phys @2+695 >> 16
;696   "Redirect for TOS and host",               // 30
	.dw	word (phys @2+724)
	.dw	phys @2+724 >> 16
;697   "Parameter problem",                       // 31
	.dw	word (phys @2+750)
	.dw	phys @2+750 >> 16
;698   "Parameter problem: option missing",       // 32
	.dw	word (phys @2+768)
	.dw	phys @2+768 >> 16
;699   "Source quench",                           // 33
	.dw	word (phys @2+802)
	.dw	phys @2+802 >> 16
;700   "IP address changed",                      // 34
	.dw	word (phys @2+816)
	.dw	phys @2+816 >> 16
;701   "Out of memory",                           // 35
	.dw	word (phys @2+835)
	.dw	phys @2+835 >> 16
;702   "IP address conflict",                     // 26
	.dw	word (phys @2+849)
	.dw	phys @2+849 >> 16
;703   "Interface down or deactivated"            // 37
;704 };
	.dw	word (phys @2+869)
	.dw	phys @2+869 >> 16
	.debug	G _NetErrStrings 34 8
;705 
;706 
;707 //--- descr of events for TCP event/datahandler (tcpSockEvent_()) ---
;708 const char far * far EventDescTCP[] = {
;709   "passive open call",            // TCP_DH_LISTEN
_EventDescTCP::
	.dw	word (phys @2+899)
	.dw	phys @2+899 >> 16
;710   "active open call",             // TCP_DH_OPEN
	.dw	word (phys @2+917)
	.dw	phys @2+917 >> 16
;711   "established connection",       // TCP_DH_ESTAB
	.dw	word (phys @2+934)
	.dw	phys @2+934 >> 16
;712   NULL,                           // TCP_DH_INDATA  // new data has arrived
	.dw	0, 0
;713   NULL,                           // TCP_DH_OUTBUF  // more space in xmit b
	.dw	0, 0
;714   "FIN rcvd (no more reads)",     // TCP_DH_INCLOSE
	.dw	word (phys @2+957)
	.dw	phys @2+957 >> 16
;715   "local close (no more writes)", // TCP_DH_OUTCLOSE
	.dw	word (phys @2+982)
	.dw	phys @2+982 >> 16
;716   "Closed",                       // TCP_DH_CLOSED
	.dw	word (phys @2+1011)
	.dw	phys @2+1011 >> 16
;717   "local call to sock_abort()",   // TCP_DH_ABORT
	.dw	word (phys @2+1018)
	.dw	phys @2+1018 >> 16
;718   "rcvd RST",                     // TCP_DH_RESET
	.dw	word (phys @2+1045)
	.dw	phys @2+1045 >> 16
;719   "ICMP rcvd"                     // TCP_DH_ICMPMSG
;720 };
	.dw	word (phys @2+1054)
	.dw	phys @2+1054 >> 16
	.debug	G _EventDescTCP 36 8
;721 
;722 
;723 #pragma warn 787
;724 
	.defseg	FARDATA
	.seg	FARDATA
;725 #pragma seg (FARDATA)
;726 
;727 
;728 #define NETERR_MAX_STRINGS  (sizeof(NetErrStrings) / sizeof(NetErrStrings[0
;729 
;730 #define NUM_TCP_EVENTS  (sizeof(EventDescTCP) / sizeof(EventDescTCP[0]))
;731 
;732 
;733 
;734 #define LogSockMsg(si, msg)  
;735   fprintf(DiagLog, "socket (%04X)[%d]: %ls\n",  
;736           (uint)(si), TCP_SI_Idx(si), (msg) )
;737 
;738 
;739 #define  SetSockLink(si, tcpSock)  
;740   { ((tcp_Socket *)(tcpSock))->user_data = (si);  (si)->sock = (tcpSock); }
;741 
;742 #define ClearSockLink(si)  
;743   {  if ((si)->sock)  
;744        ((tcp_Socket *)((si)->sock))->user_data = NULL;  (si)->sock = NULL; 
;745 
;746 
;747 //-------------------------------------------------------------------------
;748 //  return a far pointer to a string description of the network error #
;749 //-------------------------------------------------------------------------
;750 const char far *sockErrStr(uint errNum)
;751 {
	.defseg	FARCODE
	.seg	FARCODE
$sockErrStr::
	.debug	G $sockErrStr 37 9
	.debug	{ $sockErrStr 37 750 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A errNum 5 7
;752 
;753   if (errNum >= NETERR_MAX_STRINGS)  return "Unknown error";
	.debug	# 753
	ld	hl,(ix+5)
	ld	de,0x26
	or	a,a
	sbc	hl,de
	jr	c,@6
	ld	hl,@1+7
	jr	@4
;754 
;755   return NetErrStrings[errNum];
@6:
	.debug	# 755
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _NetErrStrings)
	ld	c,phys _NetErrStrings >> 16
	call	__ladd##
	call	__farld4##
;756 }
@4:
	.debug	} @4 756

@3	equ	0
	pop	ix
	lret
@5	equ	2
;757 
;758 //-------------------------------------------------------------------------
;759 //  Log the most recent errors (if any) for the specified socket connection
;760 //
;761 //  The DC network lib currently in use saves the codes for the 2 most rece
;762 //  errors.
;763 //-------------------------------------------------------------------------
;764 void showErrs(SockInfo *si, sock_type *sock)
;765 {
$showErrs::
	.debug	G $showErrs 38 9
	.debug	{ $showErrs 38 764 @9 @8
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A si 5 39
	.debug	A sock 7 41
;766   int errCode0, errCode1;
	.debug	L errCode0 -2 6
	.debug	L errCode1 -4 6
;767 
;768 
;769   errCode0 = sock_error(sock, 1);
	.debug	# 769
	ld	hl,0x1
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$sock_error
	add	sp,4
	ld	(ix-2),hl
;770   errCode1 = sock_error(sock, 1);
	.debug	# 770
	ld	hl,0x1
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$sock_error
	add	sp,4
	ld	(ix-4),hl
;771 
;772   if (!errCode1)  return;
	.debug	# 772
	bool	hl
	jr	z,@8
;773 
;774   LogSockMsg(si, sockErrStr(errCode1));
	.debug	# 774
	ld	hl,(ix-4)
	push	hl
	lcall	$sockErrStr
	pop	hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1064)
	ld	c,phys @2+1064 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;775 
;776   if (!errCode0)  return;
	.debug	# 776
	ld	hl,(ix-2)
	bool	hl
	jr	z,@8
;777 
;778   LogSockMsg(si, sockErrStr(errCode0));
	.debug	# 778
	ld	hl,(ix-2)
	push	hl
	lcall	$sockErrStr
	pop	hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1064)
	ld	c,phys @2+1064 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;779 }
@8:
	.debug	} @8 779

@7	equ	4
	ld	sp,ix
	pop	ix
	lret
@9	equ	6
;780 
;781 
;782 //-------------------------------------------------------------------------
;783 //  Get the total and free counts for the global pool of TCP connections.
;784 //  The *ttl is set to the total, and the free count is the return value.
;785 //-------------------------------------------------------------------------
;786 uint tcpCounts(uint *ttl)
;787 {
	.align	4
$$tcpCounts::
	ex	(sp),iy
$tcpCounts::
	.debug	G $tcpCounts 43 9
	.debug	{ $tcpCounts 43 786 @14 @13
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ttl 5 44
;788   uint  u, freeCount = 0;
	.debug	L u -2 7
	.debug	L freeCount -4 7
	.debug	# 788
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;789   tcp_Socket  *sock;
	.debug	L sock -6 45
;790 
;791 
;792   for (u=0,sock=tcpSockDef; u<MaxTCPCons; ++u,++sock)
@15:
	.debug	< @15 @16
	.debug	# 792
	ld	(ix-2),hl
	ld	hl,_tcpSockDef
	ld	(ix-6),hl
@17:
	ld	hl,(ix-2)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	nc,@18
;793     if (!sock->user_data)  ++freeCount;
	.debug	# 793
	ld	hl,(ix-6)
	ld	e,0x88
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@20
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;794 
;795   *ttl = MaxTCPCons;
@20:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ld	de,0xaa
	add	hl,de
	ld	(ix-6),hl
	jr	@17
@18:
@16:
	.debug	>
	.debug	# 795
	ld	hl,0xc
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;796 
;797   return freeCount;
	.debug	# 797
	ld	hl,(ix-4)
;798 }
@13:
	.debug	} @13 798

@12	equ	6
	ld	sp,ix
	pop	ix
	lret
@14	equ	8
;799 
;800 
;801 //-------------------------------------------------------------------------
;802 //  Get the total and free counts for the global pool of UDP sockets.
;803 //  The *ttl is set to the total, and the free count is the return value.
;804 //-------------------------------------------------------------------------
;805 uint udpCounts(uint *ttl)
;806 {
	.align	4
$$udpCounts::
	ex	(sp),iy
$udpCounts::
	.debug	G $udpCounts 43 9
	.debug	{ $udpCounts 43 805 @23 @22
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ttl 5 44
;807   uint  u, freeCount = 0;
	.debug	L u -2 7
	.debug	L freeCount -4 7
	.debug	# 807
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;808   SockInfo  *si;
	.debug	L si -6 39
;809 
;810 
;811   for (u=0,si=udpSockets; u<MaxUDPSockets; ++u,++si)
@24:
	.debug	< @24 @25
	.debug	# 811
	ld	(ix-2),hl
	ld	hl,_udpSockets
	ld	(ix-6),hl
@26:
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@27
;812     if (!si->inUse)  ++freeCount;
	.debug	# 812
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@29
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;813 
;814   *ttl = MaxUDPSockets;
@29:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ld	de,0x2a
	add	hl,de
	ld	(ix-6),hl
	jr	@26
@27:
@25:
	.debug	>
	.debug	# 814
	ld	hl,0x4
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;815 
;816   return freeCount;
	.debug	# 816
	ld	hl,(ix-4)
;817 }
@22:
	.debug	} @22 817

@21	equ	6
	ld	sp,ix
	pop	ix
	lret
@23	equ	8
;818 
;819 
;820 //-------------------------------------------------------------------------
;821 /*
;822 void dumpSockInfo(char *context, SockInfo *si)
;823 {
;824   char  temp[80];
;825 
;826   _socketDescr_(si, temp, sizeof(temp));
;827 
;828   printf("%s\r\n"
;829          "%s\r\n"
;830          "rdOK:%d  wrOk:%d  conState:%d  closeState:%d  opened:%d\r\n",
;831          context, temp,
;832          si->rdOK, si->wrOK, si->conState, si->closeState, si->opened);
;833 }
;834 */
;835 //-------------------------------------------------------------------------
;836 void initSockInfo(SockInfo *si, sock_type *sock, char type)
;837 {
$initSockInfo::
	.debug	G $initSockInfo 47 9
	.debug	{ $initSockInfo 47 836 @32 @31
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A si 5 39
	.debug	A sock 7 41
	.debug	A type 9 3
;838   if (!KLOCKED())  klockErr(__func__);
	.debug	# 838
	ld	a,(__disabled)
	or	a,a
	jr	nz,@33
	ld	de,word (phys @2+1088)
	ld	c,phys @2+1088 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;839 
;840   memset(si, 0, sizeof(SockInfo));
@33:
	.debug	# 840
	ld	hl,0x2a
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_memset
	add	sp,6
;841 
;842   si->type = type;
	.debug	# 842
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;843   si->rdOK = si->wrOK = true;
	.debug	# 843
	ld	hl,(ix+5)
	ld	e,0x13
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix+5)
	dec	e
	add	hl,de
	ld	(hl),a
;844 
;845   si->lastClosed = GetMS();
	.debug	# 845
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix+5)
	push	de
	ld	de,0x1c
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;846 
;847   init_waitqueue_head(&si->readQueue);
	.debug	# 847
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;848   init_waitqueue_head(&si->writeQueue);
	.debug	# 848
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;849 
;850   si->myAddr = si;
	.debug	# 850
	ld	hl,(ix+5)
	ld	de,0x28
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;851 
;852   if (sock)  {  // can be NULL for TCP SockInfo structures...
	.debug	# 852
	ld	hl,(ix+7)
	bool	hl
	jr	z,@34
;853     si->sock = sock;
@35:
	.debug	< @35 @36
	.debug	# 853
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;854     if (type == SOCK_STREAM)  ((tcp_Socket *)sock)->user_data = si;
	.debug	# 854
	ld	a,(ix+9)
	sub	a,2
	jr	nz,@37
	ld	h,d
	ld	l,e
	ld	de,0x88
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;855   }
@37:
@36:
	.debug	>
;856 
;857 
;858 //  if (ShowSocketEvents)  dumpSockInfo("initSockInfo()", si);  //tdebug
;859 }
@34:
@31:
	.debug	} @31 859

@30	equ	0
	pop	ix
	lret
@32	equ	2
;860 
;861 
;862 //-------------------------------------------------------------------------
;863 //  func called once by init process to initialize data structures
;864 //-------------------------------------------------------------------------
;865 void socketInit_()
;866 {
$socketInit_::
	.debug	G $socketInit_ 48 9
	.debug	{ $socketInit_ 48 865 @40 @39
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;867   int  i;
	.debug	L i -2 6
;868 
;869   skipTicks = true;
	.debug	# 869
	ld	a,0x1
	ld	(_skipTicks),a
;870   netReady = linkWentDown = netGoingDown = closingSockets = false;
	.debug	# 870
	xor	a,a
	ld	(_closingSockets),a
	ld	(_netGoingDown),a
	ld	(_linkWentDown),a
	ld	(_netReady),a
;871 
;872   linkDownMS = 0;
	.debug	# 872
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_linkDownMS),de
	ld	(_linkDownMS+2),bc
;873 
;874   for (i=0; i<MaxTCPSockets; ++i)
@41:
	.debug	< @41 @42
	.debug	# 874
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@43:
	ld	hl,(ix-2)
	ld	de,0x8012
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@44
;875     initSockInfo(tcpSockets+i, NULL, SOCK_STREAM );
	.debug	# 875
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_tcpSockets
	add	hl,bc
	push	hl
	lcall	$initSockInfo
	add	sp,6
;876 
;877   for (i=0; i<MaxUDPSockets; ++i)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@43
@44:
@42:
	.debug	>
@46:
	.debug	< @46 @47
	.debug	# 877
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@48:
	ld	hl,(ix-2)
	ld	de,0x8004
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@49
;878     initSockInfo(udpSockets+i, (sock_type *)(udpSockDef + i), SOCK_DGRAM );
	.debug	# 878
	ld	hl,0x1
	push	hl
	ld	hl,(ix-2)
	ld	bc,0x2c
	ex	de,hl
	mul
	ld	hl,_udpSockDef
	add	hl,bc
	push	hl
	ld	h,d
	ld	l,e
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_udpSockets
	add	hl,bc
	push	hl
	lcall	$initSockInfo
	add	sp,6
;879 
;880   for (i=0; i<MaxTCPCons; ++i)  tcpSockDef[i].user_data = NULL;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@48
@49:
@47:
	.debug	>
@51:
	.debug	< @51 @52
	.debug	# 880
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@53:
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@54
	ld	hl,(ix-2)
	ld	bc,0xaa
	ex	de,hl
	mul
	ld	hl,_tcpSockDef
	add	hl,bc
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;881 
;882   registerFileSys(&socketFSysFuncs);
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@53
@54:
@52:
	.debug	>
	.debug	# 882
	ld	hl,_socketFSysFuncs
	push	hl
	lcall	$registerFileSys
	pop	de
;883 
;884   disableIObus();
	.debug	# 884
	ld	a,0xf3
	ld	de,0x24
  ld  hl,_srSPCR##
  ipset  3
  and  a,(hl)
  ld  (hl),a
  ipres
  ioi ldi
;885 
;886 // no point until interface is up and _socketTick_() is being called
;887 //  skipTicks = false;
;888 }
@39:
	.debug	} @39 888

@38	equ	2
	ld	sp,ix
	pop	ix
	lret
@40	equ	4
;889 
;890 
;891 //-------------------------------------------------------------------------
;892 //  Returns true if provided pointer is a valid, in-use socket device.
;893 //  Returns false if is not.
;894 //-------------------------------------------------------------------------
;895 bool  validSOCK(void *ioDev)
;896 {
$validSOCK::
	.debug	G $validSOCK 49 9
	.debug	{ $validSOCK 49 895 @58 @57
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 50
;897   if (!INVALID(SockInfo, ioDev))  if (SI->inUse)  return true;
	.debug	# 897
	ld	hl,@1+21
	push	hl
	ld	hl,@1+31
	push	hl
	ld	hl,(ix+5)
	ld	de,0x28
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jr	nz,@59
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@60
	ld	a,0x1
	jr	@57
;898 
;899   return false;
@60:
@59:
	.debug	# 899
	xor	a,a
;900 }
@57:
	.debug	} @57 900

@56	equ	0
	pop	ix
	lret
@58	equ	2
;901 
;902 //-------------------------------------------------------------------------
;903 //  Display a message and change the active IP address
;904 //-------------------------------------------------------------------------
;905 void chgIPAddr(int iface, ulong newAddr)
;906 {
$chgIPAddr::
	.debug	G $chgIPAddr 51 9
	.debug	{ $chgIPAddr 51 905 @63 @62
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-47
	.debug	A iface 5 6
	.debug	A newAddr 7 9
;907   int  stat;
	.debug	L stat -2 6
;908   char  temp[20];
	.debug	L temp -22 52
;909   IFConfig  ifConfig;
	.debug	L ifConfig -47 53
;910 
;911 
;912   printf("Set IP address to: %s\r\n",
;913           inet_htop(AF_INET, &newAddr, temp, sizeof(temp)) );
	.debug	# 913
	ld	hl,0x14
	push	hl
	ld	hl,-20+@61
	add	hl,sp
	push	hl
	ld	hl,11+@61
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
	push	hl
	ld	de,word (phys @2+1101)
	ld	c,phys @2+1101 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;914 
;915   stat = ifpending(iface);
	.debug	# 915
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-2),hl
;916 
;917   if ((stat == IF_UP) OR (stat == IF_COMING_UP))  startNetDown(iface);
	.debug	# 917
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@64
	ld	hl,(ix-2)
	dec	e
	or	a,a
	sbc	hl,de
	jr	nz,@65
@64:
	ld	hl,(ix+5)
	push	hl
	lcall	$startNetDown
	pop	de
;918 
;919   for (;;)  {
@65:
@66:
	.debug	< @66 @67
@68:
;920     if (ifpending(iface) == IF_DOWN)  break;
@71:
	.debug	< @71 @72
	.debug	# 920
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	bool	hl
	jp	z,@69
;921     if (current != kernelTask)
	.debug	# 921
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	z,@74
;922       sleepMS(100);
	.debug	# 922
	ld	de,0x64
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;923     else  {
	jr	@68
@74:
;924       WDT_2S();  tcp_tick(NULL);  }
@76:
	.debug	< @76 @77
	.debug	# 924
  ld  a,0x5A
  ioi ld  (0x08),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$tcp_tick
	pop	de
@77:
	.debug	>
;925   }
@72:
	.debug	>
;926 
;927   getIFConfig(iface, &ifConfig);
	jp	@68
@69:
@67:
	.debug	>
	.debug	# 927
	ld	hl,-47+@61
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$getIFConfig
	add	sp,4
;928   ifConfig.ipAddr = newAddr;
	.debug	# 928
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	(ix-45),hl
	ex	de,hl
	ld	(ix-47),hl
	ex	de,hl
;929   setIFConfig(iface, &ifConfig);
	.debug	# 929
	ld	hl,-47+@61
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setIFConfig
	add	sp,4
;930 
;931   startNetUp(iface);
	.debug	# 931
	ld	hl,(ix+5)
	push	hl
	lcall	$startNetUp
	pop	de
;932 }
@62:
	.debug	} @62 932

@61	equ	47
	ld	sp,ix
	pop	ix
	lret
@63	equ	49
;933 
;934 //-------------------------------------------------------------------------
;935 //  Get the current network interface configuration
;936 //-------------------------------------------------------------------------
;937 int getIFConfig(int iface, IFConfig *ifConfig)
;938 {
$getIFConfig::
	.debug	G $getIFConfig 54 9
	.debug	{ $getIFConfig 54 937 @80 @79
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A iface 5 6
	.debug	A ifConfig 7 55
;939   memset(ifConfig, 0, sizeof(IFConfig));
	.debug	# 939
	ld	hl,0x19
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memset
	add	sp,6
;940 
;941   KLOCK();
	.debug	# 941
	call	_KLOCK
;942 
;943   ifConfig->state = ifpending(iface);
	.debug	# 943
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x18
	add	hl,de
	ld	(hl),c
;944 
;945   ifconfig( iface,
;946             IFG_IPADDR, &(ifConfig->ipAddr),
;947             IFG_NETMASK, &(ifConfig->netmask),
;948             IFG_ROUTER_DEFAULT, &(ifConfig->gateway),
;949             IFG_MTU, &(ifConfig->mtu),
;950             IFG_HWA, &(ifConfig->macAddr),
;951             IFS_END
;952         );
	.debug	# 952
	bool	hl
	ld	l,h
	push	hl
	ld	h,d
	ld	l,e
	ld	de,0x10
	add	hl,de
	push	hl
	ld	hl,0x17
	push	hl
	ld	hl,(ix+7)
	ld	e,0x16
	add	hl,de
	push	hl
	ld	hl,0x7
	push	hl
	ld	hl,(ix+7)
	ld	e,0xc
	add	hl,de
	push	hl
	ld	hl,0x15
	push	hl
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	push	hl
	ld	hl,0x5
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,0x3
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ifconfig
	add	sp,24
;953 
;954   KUNLOCK();
	.debug	# 954
	call	_KUNLOCK
;955 
;956 //  ifConfig->bcAddr = 0xffffffffL;
;957   ifConfig->bcAddr =
;958                   (ifConfig->netmask & ifConfig->ipAddr) | ~ifConfig->netma
	.debug	# 958
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	ld	hl,(ix+7)
	push	bc
	push	de
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lnot##
	call	__lor##
	ld	hl,(ix+7)
	push	de
	ld	de,0x4
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;959 
;960   return 0;
	.debug	# 960
	bool	hl
	ld	l,h
;961 }
@79:
	.debug	} @79 961

@78	equ	0
	pop	ix
	lret
@80	equ	2
;962 
;963 
;964 //-------------------------------------------------------------------------
;965 //  set the current network interface configuration
;966 //-------------------------------------------------------------------------
;967 int setIFConfig(int iface, IFConfig *ifConfig)
;968 {
$setIFConfig::
	.debug	G $setIFConfig 54 9
	.debug	{ $setIFConfig 54 967 @83 @82
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-25
	.debug	A iface 5 6
	.debug	A ifConfig 7 55
;969   IFConfig  curConfig;
	.debug	L curConfig -25 53
;970 
;971 
;972   getIFConfig(iface, &curConfig);
	.debug	# 972
	ld	hl,-25+@81
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$getIFConfig
	add	sp,4
;973 
;974   if (curConfig.state != IF_DOWN)  return -1;
	.debug	# 974
	ld	a,(ix-1)
	or	a,a
	jr	z,@84
	ld	hl,0xffff
	jr	@82
;975 
;976   KLOCK();
@84:
	.debug	# 976
	call	_KLOCK
;977 
;978   ifconfig( iface,
;979             IFS_IPADDR, ifConfig->ipAddr,
;980             IFS_NETMASK, ifConfig->netmask,
;981             IFS_ROUTER_SET, ifConfig->gateway,
;982             IFS_END
;983         );
	.debug	# 983
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,0xc
	push	hl
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,0x4
	push	hl
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,0x2
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ifconfig
	add	sp,22
;984 
;985   writeIPAddr(ifConfig->ipAddr);
	.debug	# 985
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$writeIPAddr
	add	sp,4
;986 
;987   KUNLOCK();
	.debug	# 987
	call	_KUNLOCK
;988 
;989   return 0;
	.debug	# 989
	bool	hl
	ld	l,h
;990 }
@82:
	.debug	} @82 990

@81	equ	25
	ld	sp,ix
	pop	ix
	lret
@83	equ	27
;991 
;992 //-------------------------------------------------------------------------
;993 //  Start bringing up the specified network interface.  Should ONLY be call
;994 //  by startNetUp()!
;995 //
;996 //  Returns the current state of the interface.
;997 //
;998 //  Use ifpending() to check on the state.
;999 //-------------------------------------------------------------------------
;1000 int startUpIF(int iface)
;1001 {
$startUpIF::
	.debug	G $startUpIF 56 9
	.debug	{ $startUpIF 56 1000 @87 @86
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A iface 5 6
;1002   int  stat;
	.debug	L stat -2 6
;1003 
;1004 
;1005   KLOCK();
	.debug	# 1005
	call	_KLOCK
;1006 
;1007   WDT_2S();  stat = ifpending(iface);
	.debug	# 1007
  ld  a,0x5A
  ioi ld  (0x08),a
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-2),hl
;1008 
;1009   if ((stat != IF_UP) AND (stat != IF_COMING_UP))  {
	.debug	# 1009
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@89
	ld	hl,(ix-2)
	dec	e
	or	a,a
	sbc	hl,de
	jr	z,@89
;1010     printf("Bringing up network interface...\r\n");
@90:
	.debug	< @90 @91
	.debug	# 1010
	ld	de,word (phys @2+1125)
	ld	c,phys @2+1125 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1011     ifconfig(iface, IFS_UP, IFS_END);  stat = ifpending(iface);
	.debug	# 1011
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x8
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$ifconfig
	add	sp,6
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-2),hl
;1012   }
@91:
	.debug	>
;1013 
;1014   KUNLOCK();
@89:
	.debug	# 1014
	call	_KUNLOCK
;1015 
;1016   return stat;
	.debug	# 1016
	ld	hl,(ix-2)
;1017 }
@86:
	.debug	} @86 1017

@85	equ	2
	ld	sp,ix
	pop	ix
	lret
@87	equ	4
;1018 
;1019 //-------------------------------------------------------------------------
;1020 //  Start shutting down the specified network interface.  Should ONLY be
;1021 //  called by _socketTick_()!
;1022 //
;1023 //  Returns the current state of the interface.
;1024 //
;1025 //  Use ifpending() to check on the state.
;1026 //-------------------------------------------------------------------------
;1027 int startDownIF(int iface)
;1028 {
$startDownIF::
	.debug	G $startDownIF 56 9
	.debug	{ $startDownIF 56 1027 @94 @93
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A iface 5 6
;1029   int  stat;
	.debug	L stat -2 6
;1030 
;1031   KLOCK();
	.debug	# 1031
	call	_KLOCK
;1032 
;1033   stat = ifpending(iface);
	.debug	# 1033
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-2),hl
;1034 
;1035   if ((stat != IF_DOWN) AND (stat != IF_COMING_DOWN)) {
	.debug	# 1035
	bool	hl
	jr	z,@96
	ld	hl,(ix-2)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@96
;1036     printf("Taking down network interface...\r\n");
@97:
	.debug	< @97 @98
	.debug	# 1036
	ld	de,word (phys @2+1160)
	ld	c,phys @2+1160 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1037     ifdown(iface);  stat = ifpending(iface);
	.debug	# 1037
	ld	hl,(ix+5)
	push	hl
	lcall	$ifdown
	pop	de
	ld	hl,(ix+5)
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-2),hl
;1038   }
@98:
	.debug	>
;1039 
;1040   KUNLOCK();
@96:
	.debug	# 1040
	call	_KUNLOCK
;1041 
;1042   return stat;
	.debug	# 1042
	ld	hl,(ix-2)
;1043 }
@93:
	.debug	} @93 1043

@92	equ	2
	ld	sp,ix
	pop	ix
	lret
@94	equ	4
;1044 
;1045 
;1046 //-------------------------------------------------------------------------
;1047 //  Configure the network interface using the current settings and start
;1048 //  bringing it up.
;1049 //
;1050 //  Returns the current state of the interface.
;1051 //-------------------------------------------------------------------------
;1052 int startNetUp(int iface)
;1053 {
$startNetUp::
	.debug	G $startNetUp 56 9
	.debug	{ $startNetUp 56 1052 @101 @100
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-25
	.debug	A iface 5 6
;1054   IFConfig  ifConfig;
	.debug	L ifConfig -25 53
;1055 
;1056 
;1057   printf("\r\nConfiguring network interface...\r\n");
	.debug	# 1057
	ld	de,word (phys @2+1195)
	ld	c,phys @2+1195 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1058 
;1059   skipTicks = false;
	.debug	# 1059
	xor	a,a
	ld	(_skipTicks),a
;1060 
;1061   SetHostName(hostName, strlen(hostName));
	.debug	# 1061
	ld	hl,_hostName
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,_hostName
	push	hl
	lcall	$SetHostName
	add	sp,4
;1062 
;1063   memset(&ifConfig, 0, sizeof(IFConfig));
	.debug	# 1063
	ld	hl,0x19
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-21+@99
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;1064 
;1065   ifConfig.ipAddr = readIPAddr();
	.debug	# 1065
	lcall	$readIPAddr
	ld	hl,bc
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
;1066   ifConfig.netmask = netmask;
	.debug	# 1066
	ld	de,(_netmask)
	ld	bc,(_netmask+2)
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;1067   ifConfig.gateway = gateway;
	.debug	# 1067
	ld	de,(_gateway)
	ld	bc,(_gateway+2)
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;1068 
;1069   ifConfig.mtu = ETH_MTU;
	.debug	# 1069
	ld	hl,0x5dc
	ld	(ix-3),hl
;1070 
;1071   setIFConfig(IF_ETH0, &ifConfig);
	.debug	# 1071
	ld	hl,-25+@99
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$setIFConfig
	add	sp,4
;1072 
;1073   return startUpIF(iface);
	.debug	# 1073
	ld	hl,(ix+5)
	push	hl
	lcall	$startUpIF
	pop	de
;1074 }
@100:
	.debug	} @100 1074

@99	equ	25
	ld	sp,ix
	pop	ix
	lret
@101	equ	27
;1075 
;1076 //-------------------------------------------------------------------------
;1077 //  Set close flag for all in-use sockets, give them a moment to close, and
;1078 //  then shut down the network interface.
;1079 //-------------------------------------------------------------------------
;1080 int startNetDown(int iface)
;1081 {
$startNetDown::
	.debug	G $startNetDown 56 9
	.debug	{ $startNetDown 56 1080 @104 @103
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A iface 5 6
;1082   uint  i;
	.debug	L i -2 7
;1083   SockInfo  *si;
	.debug	L si -4 39
;1084 
;1085 
;1086   if (closingSockets)  return 0;
	.debug	# 1086
	ld	a,(_closingSockets)
	or	a,a
	jr	z,@105
	bool	hl
	ld	l,h
	jp	@103
;1087 
;1088   printf("Closing all sockets...\r\n");
@105:
	.debug	# 1088
	ld	de,word (phys @2+1232)
	ld	c,phys @2+1232 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1089 
;1090   KLOCK();
	.debug	# 1090
	call	_KLOCK
;1091 
;1092   for (i=0; i<MaxTCPSockets; ++i)
@106:
	.debug	< @106 @107
	.debug	# 1092
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@108:
	ld	hl,(ix-2)
	ld	de,0x12
	or	a,a
	sbc	hl,de
	jr	nc,@109
;1093     if ((si = tcpSockets+i)->inUse)  si->closeState = CS_CALL_CLOSE;
	.debug	# 1093
	ld	hl,(ix-2)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_tcpSockets
	add	hl,bc
	ld	(ix-4),hl
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@111
	ld	hl,(ix-4)
	ld	de,0x14
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1094 
;1095   for (i=0; i<MaxUDPSockets; ++i)
@111:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@108
@109:
@107:
	.debug	>
@112:
	.debug	< @112 @113
	.debug	# 1095
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@114:
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@115
;1096     if ((si = udpSockets+i)->inUse)  si->closeState = CS_CALL_CLOSE;
	.debug	# 1096
	ld	hl,(ix-2)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_udpSockets
	add	hl,bc
	ld	(ix-4),hl
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@117
	ld	hl,(ix-4)
	ld	de,0x14
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1097 
;1098   netReady = false;  netGoingDown = closingSockets = true;
@117:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@114
@115:
@113:
	.debug	>
	.debug	# 1098
	xor	a,a
	ld	(_netReady),a
	ld	a,0x1
	ld	(_closingSockets),a
	ld	(_netGoingDown),a
;1099 
;1100   startedDownMS = GetMS();
	.debug	# 1100
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_startedDownMS),de
	ld	(_startedDownMS+2),bc
;1101 
;1102   KUNLOCK();
	.debug	# 1102
	call	_KUNLOCK
;1103 
;1104   return 0;
	.debug	# 1104
	bool	hl
	ld	l,h
;1105 }
@103:
	.debug	} @103 1105

@102	equ	4
	ld	sp,ix
	pop	ix
	lret
@104	equ	6
;1106 
;1107 //-------------------------------------------------------------------------
;1108 //  Display the IP routing info
;1109 //-------------------------------------------------------------------------
;1110 typedef struct {
;1111   char  dest[16];
;1112   char  gateway[16];
;1113   char  mask[16];
;1114   char  flags[6];
;1115   char  iface[16];
;1116 } RouteStrings;
;1117 
;1118 int getRouteStrs(word r, RouteStrings *strs)
;1119 {
$getRouteStrs::
	.debug	G $getRouteStrs 57 9
	.debug	{ $getRouteStrs 57 1118 @120 @119
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-11
	.debug	A r 5 5
	.debug	A strs 7 58
;1120   int  rsvd;
	.debug	L rsvd -2 6
;1121   word  iface;
	.debug	L iface -4 5
;1122   RTEntry  *rte;
	.debug	L rte -6 60
;1123   ATEntry  *ate;
	.debug	L ate -8 62
;1124   char  *ptr;
	.debug	L ptr -10 64
;1125   char  ch;
	.debug	L ch -11 3
;1126 
;1127 
;1128   memset(strs, 0, sizeof(RouteStrings));
	.debug	# 1128
	ld	hl,0x46
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memset
	add	sp,6
;1129 
;1130   if (r >= ARP_ROUTER_TABLE_SIZE OR !_arp_gate_data[r].ath)  return -1;
	.debug	# 1130
	ld	hl,(ix+5)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@121
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,__arp_gate_data
	add	hl,bc
	ld	hl,(hl)
	bool	hl
	jr	nz,@122
@121:
	ld	hl,0xffff
	jp	@119
;1131 
;1132   rte = _arp_gate_data + r;
@122:
	.debug	# 1132
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,__arp_gate_data
	add	hl,bc
	ld	(ix-6),hl
;1133 
;1134   if (ATH_IS_P2P(rte->ath)) {
	.debug	# 1134
	ld	hl,(hl)
	ld	de,0x80f2
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@124
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0x8100
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@124
;1135     iface = (word)rte->ath - ATH_P2P;
@125:
	.debug	< @125 @126
	.debug	# 1135
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0xff0e
	add	hl,de
	ld	(ix-4),hl
;1136     ate = NULL;  rsvd = 1;
	.debug	# 1136
	bool	hl
	ld	l,h
	ld	(ix-8),hl
	inc	l
	ld	(ix-2),hl
;1137     inet_ntoa(strs->gateway, _if_tab[iface].u.ppp.peeraddr);
	.debug	# 1137
	ld	hl,(ix-4)
	ld	bc,0x1e
	ex	de,hl
	mul
	ld	hl,__if_tab
	add	hl,bc
	ld	de,0x18
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	push	hl
	lcall	$inet_ntoa
	add	sp,6
;1138     sprintf(strs->iface, "p2p%u", iface);
	.debug	# 1138
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @2+1257)
	ld	c,phys @2+1257 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x36
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;1139   }
@126:
	.debug	>
;1140   else {
	jr	@127
@124:
;1141     iface = (word) ate->iface;
@128:
	.debug	< @128 @129
	.debug	# 1141
	ld	hl,(ix-8)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-4),hl
;1142     ate = _arp_data + ATH2INDEX(rte->ath);
	.debug	# 1142
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	h,d
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,__arp_data
	add	hl,de
	ld	(ix-8),hl
;1143     rsvd = ate->flags & ATE_RESOLVED;
	.debug	# 1143
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	ld	(ix-2),hl
;1144     inet_ntoa(strs->gateway, ate->ip);
	.debug	# 1144
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	push	hl
	lcall	$inet_ntoa
	add	sp,6
;1145     sprintf(strs->iface, "eth%u", iface);
	.debug	# 1145
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @2+1263)
	ld	c,phys @2+1263 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x36
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;1146   }
@129:
	.debug	>
;1147 
;1148   ptr = strs->flags;
@127:
	.debug	# 1148
	ld	hl,(ix+7)
	ld	de,0x30
	add	hl,de
	ld	(ix-10),hl
;1149   ch = ATH_IS_P2P(rte->ath) ? '@' :
;1150        rte->flags & RTE_TRANSIENT ? 'T' :
;1151        !(rte->flags & (RTE_TRANSIENT|RTE_DHCP|RTE_REDIRECT)) ? 'P' : 0;
	.debug	# 1151
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0x80f2
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@131
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0x8100
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@131
	ld	a,0x40
	jr	@132
@131:
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x1
	and	hl,de
	jr	z,@133
	ld	a,0x54
	jr	@134
@133:
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x7
	and	hl,de
	jr	nz,@135
	ld	a,0x50
	jr	@136
@135:
	xor	a,a
@136:
@134:
@132:
	ld	(ix-11),a
;1152   if (ch)  *ptr++ = ch;
	.debug	# 1152
	or	a,a
	jr	z,@137
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	dec	hl
	ld	(hl),a
;1153   if (rte->flags & RTE_DHCP)  *ptr++ = 'D';
@137:
	.debug	# 1153
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x2
	and	hl,de
	jr	z,@138
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	dec	hl
	ld	a,0x44
	ld	(hl),a
;1154   if (rte->flags & RTE_REDIRECT)  *ptr++ = 'R';
@138:
	.debug	# 1154
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x4
	and	hl,de
	jr	z,@139
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	dec	hl
	ld	a,0x52
	ld	(hl),a
;1155   if (rte->flags & RTE_DEAD)  *ptr++ = '?';
@139:
	.debug	# 1155
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x8
	and	hl,de
	jr	z,@140
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	dec	hl
	ld	a,0x3f
	ld	(hl),a
;1156   if (rsvd)  *ptr++ = 'H';
@140:
	.debug	# 1156
	ld	hl,(ix-2)
	bool	hl
	jr	z,@141
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	dec	hl
	ld	a,0x48
	ld	(hl),a
;1157 
;1158   if (rte->flags & (RTE_TRANSIENT | RTE_DHCP | RTE_REDIRECT))  {
@141:
	.debug	# 1158
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x7
	and	hl,de
	jr	z,@142
;1159     strcpy(strs->dest, "???.???.???.???");
@143:
	.debug	< @143 @144
	.debug	# 1159
	ld	hl,@1+40
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_strcpy
	add	sp,4
;1160     strcpy(strs->mask, "???.???.???.???");
	.debug	# 1160
	ld	hl,@1+40
	push	hl
	ld	hl,(ix+7)
	ld	de,0x20
	add	hl,de
	push	hl
	call	_strcpy
	add	sp,4
;1161 //      rte->u.transient.preference,
;1162 //      (long)(rte->u.transient.timestamp - MS_TIMER) / 1000
;1163   }
@144:
	.debug	>
;1164   else  {
	jr	@145
@142:
;1165     inet_ntoa(strs->dest, rte->u.preconfig.subnet & rte->u.preconfig.mask);
@146:
	.debug	< @146 @147
	.debug	# 1165
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4+0x4
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	push	bc
	push	de
	ld	hl,(ix+7)
	push	hl
	lcall	$inet_ntoa
	add	sp,6
;1166     inet_ntoa(strs->mask, rte->u.preconfig.mask);
	.debug	# 1166
	ld	hl,(ix-6)
	ld	de,0x4+0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x20
	add	hl,de
	push	hl
	lcall	$inet_ntoa
	add	sp,6
;1167   }
@147:
	.debug	>
;1168 
;1169   return 0;
@145:
	.debug	# 1169
	bool	hl
	ld	l,h
;1170 }
@119:
	.debug	} @119 1170

@118	equ	11
	ld	sp,ix
	pop	ix
	lret
@120	equ	13
;1171 
;1172 //-------------------------------------------------------------------------
;1173 void printRouteStrs(RouteStrings *strs)
;1174 {
$printRouteStrs::
	.debug	G $printRouteStrs 65 9
	.debug	{ $printRouteStrs 65 1173 @150 @149
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A strs 5 58
;1175   printf("%-15s %-15s %-15s %-5s xxxxxx xxxxxx xxx %s\r\n",
;1176     strs->dest, strs->gateway, strs->mask, strs->flags, strs->iface );
	.debug	# 1176
	ld	hl,(ix+5)
	ld	de,0x36
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	ld	e,0x30
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	ld	e,0x20
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	ld	e,0x10
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1269)
	ld	c,phys @2+1269 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;1177 }
@149:
	.debug	} @149 1177

@148	equ	0
	pop	ix
	lret
@150	equ	2
;1178 
;1179 //-------------------------------------------------------------------------
;1180 void showRoutes(void)
;1181 {
$showRoutes::
	.debug	G $showRoutes 66 9
	.debug	{ $showRoutes 66 1180 @153 @152
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-97
;1182   word r;
	.debug	L r -2 5
;1183   IFConfig  curConfig;
	.debug	L curConfig -27 53
;1184   RouteStrings  strs;
	.debug	L strs -97 59
;1185 
;1186 
;1187   printf(
;1188 "\r\n"
;1189 "Destination     Gateway         Genmask         Flags Metric Ref    Use If
	.debug	# 1188
	ld	de,word (phys @2+1315)
	ld	c,phys @2+1315 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1190 
;1191 //--- first show the route for the local subnet ---
;1192   getIFConfig(IF_ETH0, &curConfig);
	.debug	# 1192
	ld	hl,-27+@151
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;1193 
;1194   memset(&strs, 0, sizeof(RouteStrings));
	.debug	# 1194
	ld	hl,0x46
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-93+@151
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;1195 
;1196   inet_ntoa(strs.dest, curConfig.ipAddr & curConfig.netmask),
;1197   strcpy(strs.gateway, "0.0.0.0");
	.debug	# 1197
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	hl,-93+@151
	add	hl,sp
	push	hl
	lcall	$inet_ntoa
	add	sp,6
	ld	hl,@1+56
	push	hl
	ld	hl,-79+@151
	add	hl,sp
	push	hl
	call	_strcpy
	add	sp,4
;1198   inet_ntoa(strs.mask, curConfig.netmask),
;1199   *strs.flags = (((int)curConfig.state == IF_UP) ? 'U' : 'D');
	.debug	# 1199
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-61+@151
	add	hl,sp
	push	hl
	lcall	$inet_ntoa
	add	sp,6
	bool	hl
	ld	l,(ix-3)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@154
	ld	hl,0x55
	jr	@155
@154:
	ld	hl,0x44
@155:
	ld	(ix-49),l
;1200   strcpy(strs.iface, "eth0");
	.debug	# 1200
	ld	hl,@1+64
	push	hl
	ld	hl,-41+@151
	add	hl,sp
	push	hl
	call	_strcpy
	add	sp,4
;1201   printRouteStrs(&strs);
	.debug	# 1201
	ld	hl,-97+@151
	add	hl,sp
	push	hl
	lcall	$printRouteStrs
	pop	hl
;1202 
;1203 //--- and then any routes to addresses not on the local subnet ---
;1204   for (r=0; r<ARP_ROUTER_TABLE_SIZE; r++)  if (_arp_gate_data[r].ath) break
@156:
	.debug	< @156 @157
	.debug	# 1204
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@158:
	ld	hl,(ix-2)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@159
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,__arp_gate_data
	add	hl,bc
	ld	hl,(hl)
	bool	hl
	jr	nz,@159
;1205 
;1206   if (r == ARP_ROUTER_TABLE_SIZE)  return;
	ld	h,d
	ld	l,e
	inc	hl
	ld	(ix-2),hl
	jr	@158
@159:
@157:
	.debug	>
	.debug	# 1206
	ld	hl,(ix-2)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	z,@152
;1207 
;1208   for (r=0; r<ARP_ROUTER_TABLE_SIZE; r++)
@163:
	.debug	< @163 @164
	.debug	# 1208
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@165:
	ld	hl,(ix-2)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@166
;1209     if (!getRouteStrs(r, &strs))  printRouteStrs(&strs);
	.debug	# 1209
	ld	hl,-97+@151
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$getRouteStrs
	add	sp,4
	bool	hl
	jr	nz,@168
	ld	hl,-97+@151
	add	hl,sp
	push	hl
	lcall	$printRouteStrs
	pop	hl
;1210 
;1211 
;1212 /* from a Linux system:
;1213 Kernel IP routing table
;1214 Destination     Gateway         Genmask         Flags Metric Ref    Use Ifa
;1215 169.254.0.0     0.0.0.0         255.255.0.0     U     1000   0        0 eth
;1216 192.168.0.0     0.0.0.0         255.255.0.0     U     1      0        0 eth
;1217 0.0.0.0         192.168.0.1     0.0.0.0         UG    0      0        0 eth
;1218 */
;1219 
;1220 /*
;1221   RTEntry  *rte;
;1222   ATHandle  ath;
;1223   uint  i;
;1224 
;1225 // extern RTEntry _arp_gate_data[ARP_ROUTER_TABLE_SIZE];
;1226 
;1227   for (i=0, rte=_arp_gate_data; i<ARP_ROUTER_TABLE_SIZE; i++,rte++)  {
;1228     if (!rte->ath)  continue;
;1229       ((!rte->flags AND !rte->u.preconfig.mask)
;1230              OR (rte->flags & RTE_DHCP)) ) {
;1231         ath = rte->ath;
;1232         rx = i;
;1233         break;
;1234      }
;1235 */
;1236 }
@168:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@165
@166:
@164:
	.debug	>
@152:
	.debug	} @152 1236

@151	equ	97
	ld	sp,ix
	pop	ix
	lret
@153	equ	99
;1237 
;1238 //-------------------------------------------------------------------------
;1239 //  Check the given descriptor to see if it refers to a socket.
;1240 //
;1241 //  If it is valid and refers to a socket, then **file is set to the addr o
;1242 //  of the device object that joins the descriptor to a socket.
;1243 //-------------------------------------------------------------------------
;1244 static SockInfo *_fdSocket_(fd_t sockfd, FDEV far **file)
;1245 {
$_fdSocket_:
	.debug	F $_fdSocket_ 67 9
	.debug	{ $_fdSocket_ 67 1244 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A sockfd 5 6
	.debug	A file 7 68
;1246   SockInfo  *si;
	.debug	L si -2 39
;1247 
;1248 //--- does it point to a valid file object? ---
;1249   if (! (*file = _FileFromFD_(sockfd)))  { errno = EBADF;  return NULL; }
	.debug	# 1249
	ld	hl,(ix+5)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@879
@173:
	.debug	< @173 @174
@174:
	.debug	>
;1250   if (! File_OpenCount(*file))  { errno = EBADF;  return NULL; }
	.debug	# 1250
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__farld2##
	ld	a,e
	or	a,d
	jr	nz,@175
@176:
	.debug	< @176 @177
@879:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@878
@177:
	.debug	>
;1251 
;1252 //--- does the file object point to a socket? ---
;1253   if (File_Funcs(*file) != &socketIOFuncs)  { errno = ENOTSOCK;  return NUL
@175:
	.debug	# 1253
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,_socketIOFuncs
	or	a,a
	sbc	hl,de
	jr	z,@178
@179:
	.debug	< @179 @180
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x58
	jr	@877
@180:
	.debug	>
;1254   if (! (si = File_Dev(*file)))  { errno = EBADF;  return NULL; }
@178:
	.debug	# 1254
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	bool	hl
	jr	nz,@181
@182:
	.debug	< @182 @183
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@878:
	ld	e,0x9
	jr	@877
@183:
	.debug	>
;1255   if (! si->inUse)  { errno = EBADF;  return NULL; }
@181:
	.debug	# 1255
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@184
@185:
	.debug	< @185 @186
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
@877:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	jr	@170
@186:
	.debug	>
;1256 
;1257   return si;
@184:
	.debug	# 1257
	ld	hl,(ix-2)
;1258 }
@170:
	.debug	} @170 1258

@169	equ	2
	ld	sp,ix
	pop	ix
	lret
@171	equ	4
;1259 
;1260 
;1261 //-------------------------------------------------------------------------
;1262 //  Returns a pointer to an unused tcp_Socket structure, or NULL if all of
;1263 //  them are in use.
;1264 //-------------------------------------------------------------------------
;1265 tcp_Socket *unusedTCP(void)
;1266 {
$unusedTCP::
	.debug	G $unusedTCP 71 9
	.debug	{ $unusedTCP 71 1265 @189 @188
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1267   uint  ui;
	.debug	L ui -2 7
;1268   tcp_Socket  *sock;
	.debug	L sock -4 45
;1269 
;1270 
;1271   if (!KLOCKED())  klockErr(__func__);
	.debug	# 1271
	ld	a,(__disabled)
	or	a,a
	jr	nz,@190
	ld	de,word (phys @2+1397)
	ld	c,phys @2+1397 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1272 
;1273   for (ui=0,sock=tcpSockDef; ui<MaxTCPCons; ++ui,++sock)  {
@190:
@191:
	.debug	< @191 @192
	.debug	# 1273
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_tcpSockDef
	ld	(ix-4),hl
@193:
	ld	hl,(ix-2)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	nc,@194
;1274     if (sock->user_data)  continue;
@196:
	.debug	< @196 @197
	.debug	# 1274
	ld	hl,(ix-4)
	ld	e,0x88
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@195
;1275     if (SockClosed(sock))  return sock;
	.debug	# 1275
	ld	hl,(ix-4)
	push	hl
	lcall	$sock_alive
	pop	de
	bool	hl
	jr	z,@199
	ld	hl,@1+69
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$sockstate
	pop	de
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@200
@199:
	ld	hl,(ix-4)
	jr	@188
;1276   }
@200:
@197:
	.debug	>
;1277 
;1278   return NULL;
@195:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	ld	de,0xaa
	add	hl,de
	ld	(ix-4),hl
	jr	@193
@194:
@192:
	.debug	>
	.debug	# 1278
	bool	hl
	ld	l,h
;1279 }
@188:
	.debug	} @188 1279

@187	equ	4
	ld	sp,ix
	pop	ix
	lret
@189	equ	6
;1280 
;1281 //-------------------------------------------------------------------------
;1282 //  Func to manage the process of closing sockets marked for closing.
;1283 //
;1284 //  Returns the # of sockets from the given pool that are in still use
;1285 //-------------------------------------------------------------------------
;1286 int checkSockets(SockInfo *sockets, uint count)
;1287 {
$checkSockets::
	.debug	G $checkSockets 72 9
	.debug	{ $checkSockets 72 1286 @203 @202
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-72
	.debug	A sockets 5 39
	.debug	A count 7 7
;1288   uint  i;
	.debug	L i -2 7
;1289   int  inUseCount;
	.debug	L inUseCount -4 6
;1290   SockInfo  *si;
	.debug	L si -6 39
;1291   sock_type  *sock;
	.debug	L sock -8 41
;1292   char  buf[64];
	.debug	L buf -72 73
;1293 
;1294 
;1295   KLOCK();
	.debug	# 1295
	call	_KLOCK
;1296 
;1297   for (i=0,inUseCount=0; i<count; ++i)  {
@204:
	.debug	< @204 @205
	.debug	# 1297
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	(ix-4),hl
@206:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@207
;1298     if (! (si = sockets + i)->inUse)  continue;
@209:
	.debug	< @209 @210
	.debug	# 1298
	ld	hl,(ix-2)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,(ix+5)
	add	hl,bc
	ld	(ix-6),hl
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jp	z,@208
;1299 
;1300 //    if (si->closeState)  {  //tdebug
;1301 //      idx = ((int)si->type == SOCK_STREAM) ? TCP_SI_Idx(si) : UDP_SI_Idx(
;1302 //      fprintf(DiagLog, "socket (%04X)[%d]: closeState: %d\n",
;1303 //              (uint)si, idx, si->closeState);  //tdebug
;1304 //    }
;1305 
;1306     sock = si->sock;
	.debug	# 1306
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	(ix-8),hl
;1307 
;1308     switch (si->closeState)  {
	.debug	# 1308
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	jp	@212
;1309 
;1310       case CS_CALL_CLOSE:  // initiate a close
@214:
	.debug	< @214 @215
;1311         si->rdOK = si->wrOK = false;  si->conState = SS_DISCONNECTED;
	.debug	# 1311
@216:
	ld	hl,(ix-6)
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-6)
	dec	e
	add	hl,de
	ld	(hl),a
	ld	hl,(ix-6)
	ld	e,0xc
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1312         if (si->listener)  {
	.debug	# 1312
	ld	hl,(ix-6)
	ld	e,0xb
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@217
;1313           tcp_clearreserve(si->ourPort);  si->listener = false; }
@218:
	.debug	< @218 @219
	.debug	# 1313
	ld	hl,(ix-6)
	ld	e,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$tcp_clearreserve
	pop	hl
	ld	hl,(ix-6)
	ld	de,0xb
	add	hl,de
	xor	a,a
	ld	(hl),a
@219:
	.debug	>
;1314         if (!sock)
@217:
	.debug	# 1314
	ld	hl,(ix-8)
	bool	hl
	jr	nz,@220
;1315           si->closeState = CS_IS_CLOSED;
	.debug	# 1315
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1316         else {
	jr	@221
@220:
;1317           if (si->type == SOCK_DGRAM)  {
@222:
	.debug	< @222 @223
	.debug	# 1317
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,1
	jr	nz,@224
;1318             sock_close(sock);  si->closeState = CS_IS_CLOSED; }
@225:
	.debug	< @225 @226
	.debug	# 1318
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_close
	pop	hl
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
@226:
	.debug	>
;1319           else  {
	jr	@227
@224:
;1320             if (sock_rbused(sock) > 0)  {
@228:
	.debug	< @228 @229
	.debug	# 1320
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_rbused
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@230
	jr	z,@230
;1321               sock_fastread((tcp_Socket *)sock, buf, sizeof(buf));  break; 
@231:
	.debug	< @231 @232
	.debug	# 1321
	ld	hl,0x40
	push	hl
	ld	hl,-70+@201
	add	hl,sp
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_fastread
	add	sp,6
	jp	@213
@232:
	.debug	>
;1322             sock_close(sock);  si->closeState = CS_CLOSE_WAIT;
@230:
	.debug	# 1322
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_close
	pop	hl
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1323           }
@229:
	.debug	>
;1324         }
@227:
@223:
	.debug	>
;1325         break;
@221:
	.debug	# 1325
;1326 
;1327       case CS_CLOSE_WAIT:  // waiting for close of TCP socket to complete
	jp	@213
;1328         if (SockClosed(sock))  si->closeState = CS_IS_CLOSED;
	.debug	# 1328
@233:
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_alive
	pop	de
	bool	hl
	jr	z,@234
	ld	hl,@1+69
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$sockstate
	pop	de
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jp	nz,@213
@234:
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1329         break;
	.debug	# 1329
;1330 
;1331       case CS_IS_CLOSED:  // close completed
	jp	@213
;1332         if (si->type == SOCK_STREAM)  ClearSockLink(si);
	.debug	# 1332
@236:
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jr	nz,@237
@238:
	.debug	< @238 @239
	ld	hl,(ix-6)
	ld	hl,(hl)
	bool	hl
	jr	z,@240
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	e,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@240:
	ld	hl,(ix-6)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@239:
	.debug	>
@237:
;1333         si->lastClosed = GetMS();  si->closeState = CS_WAIT_FREE;
	.debug	# 1333
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-6)
	push	de
	ld	de,0x1c
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	e,0x4
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1334 
;1335       case CS_WAIT_FREE:  // wait for fcntl layer to call _socketClose_()
;1336         if (!si->noFDEVrefs)  break; // SockInfo struct now safe to reuse?
	.debug	# 1336
@241:
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@213
;1337         si->inUse = false;
	.debug	# 1337
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	xor	a,a
	ld	(hl),a
;1338     }
@215:
	.debug	>
;1339 
;1340     if (si->inUse)  ++inUseCount;
	jr	@213
@212:
	dec	hl
	ld	bc,hl
	ld	de,-4
	add	hl,de
	jr	c,@213
	ld	hl,@243
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@243:
	dw	@216
	dw	@233
	dw	@236
	dw	@241
	.seg	FARCODE
@213:
	.debug	# 1340
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@244
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;1341   }
@244:
@210:
	.debug	>
;1342 
;1343   KUNLOCK();
@208:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@206
@207:
@205:
	.debug	>
	.debug	# 1343
	call	_KUNLOCK
;1344 
;1345   return inUseCount;
	.debug	# 1345
	ld	hl,(ix-4)
;1346 }
@202:
	.debug	} @202 1346

@201	equ	72
	ld	sp,ix
	pop	ix
	lret
@203	equ	74
;1347 
;1348 //-------------------------------------------------------------------------
;1349 //  There is no standard way to create an fd for a socket via a call to ope
;1350 //
;1351 //  socket() is used to create an fd for a socket, which can then be used a
;1352 //  follows:
;1353 //
;1354 //   - To open a connection to a specific port+addr:
;1355 //        - Call connect()
;1356 //
;1357 //   - To listen for and accept incoming connections or packets:
;1358 //
;1359 //        - Call bind() to specify the local port and which interface(s)
;1360 //          (indirectly) by specifying a local addr (or INADDR_ANY for all
;1361 //          interfaces)
;1362 //
;1363 //        For TCP (stream-based) sockets:
;1364 //          - Call listen() to mark the socket as a passive listener, creat
;1365 //            a queue for incoming connection requests, and begin accepting
;1366 //            connections on the port+addr/interface(s) specified by bind()
;1367 //          - Call accept() to create a new fd for a new open socket connec
;1368 //            for the first pending connection in the queue for the listeni
;1369 //            socket.
;1370 //
;1371 //        For UDP (packet-based message) sockets:
;1372 //          - Call recv() or recvfrom() to get the next packet sent to the
;1373 //            port+addr specified in the call to bind()
;1374 //
;1375 //-------------------------------------------------------------------------
;1376 fd_t _socketOpen_(const char *path, int flags, int mode)
;1377 {
	.align	4
$$_socketOpen_::
	ex	(sp),iy
$_socketOpen_::
	.debug	G $_socketOpen_ 74 9
	.debug	{ $_socketOpen_ 74 1376 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A path 5 64
	.debug	A flags 7 6
	.debug	A mode 9 6
;1378   errno = ENXIO;  return -1;
	.debug	# 1378
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;1379 }
@246:
	.debug	} @246 1379

@245	equ	0
	pop	ix
	lret
@247	equ	2
;1380 
;1381 //-------------------------------------------------------------------------
;1382 //  Called each kernel tick to provide the driver with CPU cycles.
;1383 //
;1384 //  Must ONLY be called by the kernel task!!!
;1385 //-------------------------------------------------------------------------
;1386 void _socketTick_(void)
;1387 {
	.align	4
$$_socketTick_::
	ex	(sp),iy
$_socketTick_::
	.debug	G $_socketTick_ 66 9
	.debug	{ $_socketTick_ 66 1386 @250 @249
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;1388   uint  curTime, openSockets;
	.debug	L curTime -2 7
	.debug	L openSockets -4 7
;1389   int  haveLink, ifState;
	.debug	L haveLink -6 6
	.debug	L ifState -8 6
;1390   static uint  lastCheckTime = 0;
	.dseg
@251:
	.dw	0
	.debug	S lastCheckTime @251 7
	.seg	FARCODE
;1391   static int  lastHaveLink = 0, lastState = -1;
	.dseg
@252:
	.dw	0
	.debug	S lastHaveLink @252 6
	.seg	FARCODE
	.dseg
@253:
	.dw	0xffff
	.debug	S lastState @253 6
	.seg	FARCODE
;1392 
;1393 
;1394   if ((current != kernelTask) OR skipTicks) return;
	.debug	# 1394
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@254
	ld	a,(_skipTicks)
	or	a,a
	jr	z,@255
@254:
;1395 
;1396   tcp_tick(NULL);
	jp	@249
@255:
	.debug	# 1396
	bool	hl
	ld	l,h
	push	hl
	lcall	$tcp_tick
	pop	de
;1397 
;1398   ifState = ifpending(IF_ETH0);
	.debug	# 1398
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	(ix-8),hl
;1399   haveLink = pd_havelink(0);
	.debug	# 1399
	bool	hl
	ld	l,h
	push	hl
	lcall	$pd_havelink
	pop	de
	ld	(ix-6),hl
;1400 
;1401   if (ifState != lastState)  {
	.debug	# 1401
	ld	hl,(ix-8)
	ld	de,(@253)
	or	a,a
	sbc	hl,de
	jr	z,@256
;1402     printf("=== network state chgd to %d from %d ===\r\n", lastState, ifSta
@257:
	.debug	< @257 @258
	.debug	# 1402
	ld	hl,(ix-8)
	push	hl
	ld	h,d
	ld	l,e
	push	hl
	ld	de,word (phys @2+1407)
	ld	c,phys @2+1407 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1403     lastState = ifState;
	.debug	# 1403
	ld	hl,(ix-8)
	ld	(@253),hl
;1404   }
@258:
	.debug	>
;1405 
;1406   if (haveLink != lastHaveLink)  {
@256:
	.debug	# 1406
	ld	hl,(ix-6)
	ld	de,(@252)
	or	a,a
	sbc	hl,de
	jp	z,@259
;1407     printf("Ethernet Link %s\r\n", haveLink ? "UP" : "DOWN");
@260:
	.debug	< @260 @261
	.debug	# 1407
	ld	hl,(ix-6)
	bool	hl
	jr	z,@262
	ld	hl,@1+76
	jr	@263
@262:
	ld	hl,@1+79
@263:
	push	hl
	ld	de,word (phys @2+1450)
	ld	c,phys @2+1450 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1408     lastHaveLink = haveLink;
	.debug	# 1408
	ld	hl,(ix-6)
	ld	(@252),hl
;1409     if (haveLink)  {
	.debug	# 1409
	bool	hl
	jr	z,@265
;1410       resetAnnounceInterval();  linkDownMS = 0; }
@266:
	.debug	< @266 @267
	.debug	# 1410
	lcall	$resetAnnounceInterval
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_linkDownMS),de
	ld	(_linkDownMS+2),bc
@267:
	.debug	>
;1411     else
;1412       linkDownMS = GetMS();
	jp	@268
@265:
	.debug	# 1412
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_linkDownMS),de
	ld	(_linkDownMS+2),bc
;1413   }
@268:
@261:
	.debug	>
;1414 
;1415   netReady = haveLink AND !netGoingDown AND (ifState == IF_UP);
@259:
	.debug	# 1415
	ld	hl,(ix-6)
	bool	hl
	jr	z,@270
	ld	a,(_netGoingDown)
	or	a,a
	jr	nz,@270
	ld	hl,(ix-8)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@270
	ld	hl,1
	jr	@271
@270:
	bool	hl
	ld	l,h
@271:
	ld	a,l
	ld	(_netReady),a
;1416 
;1417   linkWentDown = !netReady AND linkDownMS AND (msSince(linkDownMS) > 30);
	.debug	# 1417
	or	a,a
	jp	nz,@273
	ld	de,(_linkDownMS)
	ld	bc,(_linkDownMS+2)
	ld	hl,bc
	or	hl,de
	jp	z,@273
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_linkDownMS)
	ld	bc,(_linkDownMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1e
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@273
	jr	z,@273
	ld	de,1
	jr	@274
@273:
	ld	de,0
@274:
	ld	a,e
	ld	(_linkWentDown),a
;1418 
;1419   if (netGoingDown AND (ifState == IF_DOWN))  netGoingDown = false;
	.debug	# 1419
	ld	a,(_netGoingDown)
	or	a,a
	jr	z,@276
	ld	hl,(ix-8)
	bool	hl
	jr	nz,@276
	xor	a,a
	ld	(_netGoingDown),a
;1420 
;1421   curTime = GetMS_();
@276:
	.debug	# 1421
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-2),hl
;1422 
;1423   if (!doShutdown)  if (curTime - lastCheckTime < 50)  return;
	.debug	# 1423
	ld	a,(_doShutdown)
	or	a,a
	jr	nz,@277
	ld	de,(@251)
	or	a,a
	sbc	hl,de
	ld	de,0x32
	or	a,a
	sbc	hl,de
	jp	c,@249
;1424 
;1425 
;1426 
;1427   openSockets = checkSockets(tcpSockets, MaxTCPSockets)
@277:
;1428               + checkSockets(udpSockets, MaxUDPSockets);
	.debug	# 1428
	ld	hl,0x12
	push	hl
	ld	hl,_tcpSockets
	push	hl
	lcall	$checkSockets
	add	sp,4
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,_udpSockets
	push	hl
	lcall	$checkSockets
	add	sp,4
	pop	de
	add	hl,de
	ld	(ix-4),hl
;1429 
;1430   if (netGoingDown)  {
	.debug	# 1430
	ld	a,(_netGoingDown)
	or	a,a
	jp	z,@279
;1431     if (closingSockets AND (!openSockets OR (msSince(startedDownMS) > 5000)
@280:
	.debug	< @280 @281
	.debug	# 1431
	ld	a,(_closingSockets)
	or	a,a
	jp	z,@283
	bool	hl
	jp	z,@286
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_startedDownMS)
	ld	bc,(_startedDownMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1388
	ld	bc,0
	call	__lsub##
	jr	c,@283
	jr	z,@283
@286:
;1432       printf("# of sockets still open: %d\r\n", openSockets);
@287:
	.debug	< @287 @288
	.debug	# 1432
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @2+1469)
	ld	c,phys @2+1469 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1433       closingSockets = false;  startDownIF(IF_ETH0);
	.debug	# 1433
	xor	a,a
	ld	(_closingSockets),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$startDownIF
	pop	de
;1434     }
@288:
	.debug	>
;1435   }
@283:
@281:
	.debug	>
;1436 
;1437   #ifdef SHD_DLM
;1438 //    if (! doShutdown)  doShutdown |= DLM_Tick();
;1439   #endif
;1440 
;1441   lastCheckTime = curTime;
@279:
	.debug	# 1441
	ld	hl,(ix-2)
	ld	(@251),hl
;1442 }
@249:
	.debug	} @249 1442

@248	equ	8
	ld	sp,ix
	pop	ix
	lret
@250	equ	10
;1443 
;1444 //-------------------------------------------------------------------------
;1445 //  Return the state of the specified ioDev entry or NULL if not a valid
;1446 //  entry #.
;1447 //
;1448 //  For valid entrys, the entryState struct is filled in
;1449 //-------------------------------------------------------------------------
;1450 void *_socketEntry_(uint idx, EntryState *entryState)
;1451 {
	.align	4
$$_socketEntry_::
	ex	(sp),iy
$_socketEntry_::
	.debug	G $_socketEntry_ 75 9
	.debug	{ $_socketEntry_ 75 1450 @291 @290
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A idx 5 7
	.debug	A entryState 7 76
;1452   SockInfo  *si;
	.debug	L si -2 39
;1453 
;1454   if (idx < MaxTCPSockets)
	.debug	# 1454
	ld	hl,(ix+5)
	ld	de,0x12
	or	a,a
	sbc	hl,de
	jr	nc,@292
;1455     si = tcpSockets + idx;
	.debug	# 1455
	ld	hl,(ix+5)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_tcpSockets
	add	hl,bc
	ld	(ix-2),hl
;1456   else  {
	jr	@293
@292:
;1457     idx -= MaxTCPSockets;
@294:
	.debug	< @294 @295
	.debug	# 1457
	ld	hl,(ix+5)
	ld	de,0xffee
	add	hl,de
	ld	(ix+5),hl
;1458     if (idx >= MaxUDPSockets)  return NULL;
	.debug	# 1458
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@296
	bool	hl
	ld	l,h
	jr	@290
;1459     si = udpSockets + idx;
@296:
	.debug	# 1459
	ld	hl,(ix+5)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_udpSockets
	add	hl,bc
	ld	(ix-2),hl
;1460   }
@295:
	.debug	>
;1461 
;1462   entryState->openCount = (si->inUse ? 1 : 0);
@293:
	.debug	# 1462
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@297
	ld	hl,0x1
	jr	@298
@297:
	bool	hl
	ld	l,h
@298:
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1463   entryState->unused = (entryState->openCount == 0);
	.debug	# 1463
	ld	hl,(ix+7)
	ld	hl,(hl)
	bool	hl
	ld	l,h
	jr	nz,@299
	inc	l
@299:
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	(hl),e
;1464 
;1465   return si;
	.debug	# 1465
	ld	hl,(ix-2)
;1466 }
@290:
	.debug	} @290 1466

@289	equ	2
	ld	sp,ix
	pop	ix
	lret
@291	equ	4
;1467 
;1468 
;1469 //-------------------------------------------------------------------------
;1470 //  Placeholder, do-nothing unlink function
;1471 //
;1472 //  To be called ONLY by fcntl functions
;1473 //-------------------------------------------------------------------------
;1474 int _socketUnlink_(char *path)
;1475 {
	.align	4
$$_socketUnlink_::
	ex	(sp),iy
$_socketUnlink_::
	.debug	G $_socketUnlink_ 78 9
	.debug	{ $_socketUnlink_ 78 1474 @302 @301
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A path 5 64
;1476   return -1;
	.debug	# 1476
	ld	hl,0xffff
;1477 }
@301:
	.debug	} @301 1477

@300	equ	0
	pop	ix
	lret
@302	equ	2
;1478 
;1479 
;1480 //-------------------------------------------------------------------------
;1481 //  Placeholder, do-nothing rename function
;1482 //
;1483 //  To be called ONLY by fcntl functions
;1484 //-------------------------------------------------------------------------
;1485 int _socketRename_(const char *oldPath, const char *newPath)
;1486 {
	.align	4
$$_socketRename_::
	ex	(sp),iy
$_socketRename_::
	.debug	G $_socketRename_ 79 9
	.debug	{ $_socketRename_ 79 1485 @305 @304
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A oldPath 5 64
	.debug	A newPath 7 64
;1487   return -1;
	.debug	# 1487
	ld	hl,0xffff
;1488 }
@304:
	.debug	} @304 1488

@303	equ	0
	pop	ix
	lret
@305	equ	2
;1489 
;1490 
;1491 //-------------------------------------------------------------------------
;1492 //  return a count of the # of sockets in use
;1493 //-------------------------------------------------------------------------
;1494 int numOpenSockets(void)
;1495 {
$numOpenSockets::
	.debug	G $numOpenSockets 80 9
	.debug	{ $numOpenSockets 80 1494 @308 @307
;1496   return
;1497      checkSockets(tcpSockets, MaxTCPSockets)
;1498    + checkSockets(udpSockets, MaxUDPSockets);
	.debug	# 1498
	ld	hl,0x12
	push	hl
	ld	hl,_tcpSockets
	push	hl
	lcall	$checkSockets
	add	sp,4
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,_udpSockets
	push	hl
	lcall	$checkSockets
	add	sp,4
	pop	de
	add	hl,de
;1499 
;1500 }
@307:
	.debug	} @307 1500

@306	equ	0
	lret
@308	equ	0
;1501 
;1502 //-------------------------------------------------------------------------
;1503 //  Callback function for TCP events.  Called from within a call to tcp_tic
;1504 //-------------------------------------------------------------------------
;1505 int _nearcall tcpSockEvent_(int event, void *sock, ll_Gather *g, void *info
;1506 {
	.align	4
$$tcpSockEvent_::
	ex	(sp),iy
$tcpSockEvent_::
	.debug	G $tcpSockEvent_ 81 9
	.debug	{ $tcpSockEvent_ 81 1505 @311 @310
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
	.debug	A event 5 6
	.debug	A sock 7 50
	.debug	A g 9 82
	.debug	A info 11 50
;1507   bool  logSockEvents;
	.debug	L logSockEvents -1 3
;1508   SockInfo  *si;
	.debug	L si -3 39
;1509   const char far *eventDesc;
	.debug	L eventDesc -7 35
;1510 
;1511 
;1512   if (!KLOCKED())  klockErr(__func__);
	.debug	# 1512
	ld	a,(__disabled)
	or	a,a
	jr	nz,@312
	ld	de,word (phys @2+1499)
	ld	c,phys @2+1499 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1513 
;1514 
;1515   si = TCP_SD_To_SI(sock);
@312:
	.debug	# 1515
	ld	hl,(ix+7)
	ld	de,0x88
	add	hl,de
	ld	hl,(hl)
	ld	(ix-3),hl
;1516 
;1517   if (INVALID(SockInfo, si))  return 0;
	.debug	# 1517
	ld	hl,@1+84
	push	hl
	ld	hl,@1+31
	push	hl
	ld	hl,(ix-3)
	ld	e,0x28
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$ValidatePtr
	add	sp,8
	bool	hl
	jp	nz,@876
;1518 
;1519   if ((si->sock != sock) OR !si->inUse)  {
	.debug	# 1519
	ld	hl,(ix-3)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@314
	ld	hl,(ix-3)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@315
@314:
;1520     if (!doShutdown)  fprintf(DiagLog,
@316:
	.debug	< @316 @317
	.debug	# 1520
	ld	a,(_doShutdown)
	or	a,a
	jr	nz,@876
;1521             "*** tcpSockEvent(): TCP[%u]: Event %d\r\n"
;1522             "    Invalid socket pointer: %05lX\r\n",
;1523             TCP_SI_Idx(si), event, (ulong)sock);
	.debug	# 1523
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-3)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	de,word (phys @2+1513)
	ld	c,phys @2+1513 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1524     return 0;
	.debug	# 1524
	jr	@876
;1525   }
@317:
	.debug	>
;1526 
;1527 
;1528   logSockEvents = BOOL(si->diagFlags & SocketEventBits);
@315:
	.debug	# 1528
	ld	hl,(ix-3)
	ld	de,0x18
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x200
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@319
	ld	a,0x1
	jr	@320
@319:
	xor	a,a
@320:
	ld	(ix-1),a
;1529 
;1530 
;1531   if (logSockEvents)  showErrs(si, sock);
	.debug	# 1531
	or	a,a
	jr	z,@321
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$showErrs
	add	sp,4
;1532 
;1533 
;1534   if ((uint)event >= NUM_TCP_EVENTS)  return 0;
@321:
	.debug	# 1534
	ld	hl,(ix+5)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	c,@322
@876:
	bool	hl
	ld	l,h
	jp	@310
;1535 
;1536   if (logSockEvents)  {
@322:
	.debug	# 1536
	ld	a,(ix-1)
	or	a,a
	jr	z,@323
;1537     eventDesc = EventDescTCP[(uint)event];
@324:
	.debug	< @324 @325
	.debug	# 1537
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _EventDescTCP)
	ld	c,phys _EventDescTCP >> 16
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-5),hl
	ex	de,hl
	ld	(ix-7),hl
	ex	de,hl
;1538     if (eventDesc)  LogSockMsg(si, eventDesc);
	.debug	# 1538
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@326
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-3)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	de,word (phys @2+1064)
	ld	c,phys @2+1064 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;1539   }
@326:
@325:
	.debug	>
;1540 
;1541 
;1542   switch (event)  {
@323:
	.debug	# 1542
	ld	hl,(ix+5)
	jp	@327
;1543 
;1544     case TCP_DH_LISTEN:  // passive open call (listen)
@329:
	.debug	< @329 @330
;1545       break;
	.debug	# 1545
@331:
;1546 
;1547     case TCP_DH_OPEN:    // active open call (sent FIN)
	jp	@328
;1548       break;
	.debug	# 1548
@332:
;1549 
;1550     case TCP_DH_ESTAB:  // Connection established
	jp	@328
;1551       break;
	.debug	# 1551
@333:
;1552 
;1553     case TCP_DH_INDATA:  // new data has arrived
	jp	@328
;1554       wakeTasks(&si->readQueue);  break;
	.debug	# 1554
@334:
	ld	hl,(ix-3)
	ld	de,0x20
	jp	@873
;1555 
;1556     case TCP_DH_OUTBUF:  // more space in output buffer
;1557       wakeTasks(&si->writeQueue);  break;
	.debug	# 1557
@335:
	jp	@874
;1558 
;1559     case TCP_DH_INCLOSE:  // rcvd FIN - reads will fail
;1560       si->rdOK = false;  wakeTasks(&si->readQueue);  break;
	.debug	# 1560
@336:
	ld	hl,(ix-3)
	ld	de,0x12
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-3)
	ld	e,0x20
	jp	@873
;1561 
;1562     case TCP_DH_OUTCLOSE:  // local appl closed, FIN sent: writes will fail
;1563       si->wrOK = false;  si->rdOK = (sock_rbused(sock) > 0);
	.debug	# 1563
@337:
	ld	hl,(ix-3)
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix+7)
	push	hl
	lcall	$sock_rbused
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	ld	h,e
	ld	l,e
	jr	c,@338
	jr	z,@338
	inc	l
@338:
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x12
	add	hl,de
	ld	(hl),c
;1564       wakeTasks(&si->readQueue);  wakeTasks(&si->writeQueue);  break;
	.debug	# 1564
	ld	h,d
	ld	l,e
	jr	@875
;1565 
;1566     case TCP_DH_CLOSED:  // Socket completed closed
;1567       si->wrOK = false;  si->rdOK = (sock_rbused(sock) > 0);
	.debug	# 1567
@339:
	ld	hl,(ix-3)
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix+7)
	push	hl
	lcall	$sock_rbused
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	ld	h,e
	ld	l,e
	jr	c,@340
	jr	z,@340
	inc	l
@340:
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x12
	add	hl,de
	ld	(hl),c
;1568       wakeTasks(&si->readQueue);  wakeTasks(&si->writeQueue);  break;
	.debug	# 1568
	ld	h,d
	ld	l,e
@875:
	ld	de,0x20
	jr	@872
;1569 
;1570     case TCP_DH_ABORT:   // local call to sock_abort()
;1571       si->rdOK = si->wrOK = false;
	.debug	# 1571
@341:
	ld	hl,(ix-3)
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-3)
	dec	e
	add	hl,de
	ld	(hl),a
;1572       wakeTasks(&si->readQueue);  wakeTasks(&si->writeQueue);  break;
	.debug	# 1572
	ld	hl,(ix-3)
	ld	e,0x20
	jr	@872
;1573 
;1574     case TCP_DH_RESET:   // peer sent RST flag
;1575       si->rdOK = si->wrOK = false;
	.debug	# 1575
@342:
	ld	hl,(ix-3)
	ld	de,0x13
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-3)
	dec	e
	add	hl,de
	ld	(hl),a
;1576       wakeTasks(&si->readQueue);  wakeTasks(&si->writeQueue);  break;
	.debug	# 1576
	ld	hl,(ix-3)
	ld	e,0x20
@872:
	add	hl,de
	push	hl
	lcall	$wakeTasks
	pop	hl
@874:
	ld	hl,(ix-3)
	ld	de,0x24
@873:
	add	hl,de
	push	hl
	lcall	$wakeTasks
	pop	hl
;1577 
;1578     case TCP_DH_ICMPMSG:  // Incoming ICMP message
	jr	@328
;1579       break;
	.debug	# 1579
@343:
;1580   }
	jr	@328
@330:
	.debug	>
;1581 
;1582 
;1583   return 0;
@327:
	ld	bc,hl
	ld	de,-11
	add	hl,de
	jr	c,@328
	ld	hl,@344
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@344:
	dw	@331
	dw	@332
	dw	@333
	dw	@334
	dw	@335
	dw	@336
	dw	@337
	dw	@339
	dw	@341
	dw	@342
	dw	@343
	.seg	FARCODE
@328:
	.debug	# 1583
	bool	hl
	ld	l,h
;1584 }
@310:
	.debug	} @310 1584

@309	equ	7
	ld	sp,ix
	pop	ix
	lret
@311	equ	9
;1585 
;1586 
;1587 //-------------------------------------------------------------------------
;1588 //  Create a new listening socket to replace the one we just got a connecti
;1589 //  on and swap what the descriptor's file objects point to so the new
;1590 //  descriptor refers to the socket just opened
;1591 //
;1592 //  WARNING!  KLOCK() must be in effect when this function is called!
;1593 //-------------------------------------------------------------------------
;1594 static fd_t _newListener_(fd_t curSockfd)
;1595 {
$_newListener_:
	.debug	F $_newListener_ 56 9
	.debug	{ $_newListener_ 56 1594 @347 @346
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
	.debug	A curSockfd 5 6
;1596   fd_t  newSockfd;
	.debug	L newSockfd -2 6
;1597   FDEV far  *newFile, *curFile;
	.debug	L newFile -6 69
	.debug	L curFile -10 69
;1598   SockInfo  *newSI, *curSI;
	.debug	L newSI -12 39
	.debug	L curSI -14 39
;1599 
;1600 
;1601   if (!KLOCKED())  klockErr(__func__);
	.debug	# 1601
	ld	a,(__disabled)
	or	a,a
	jr	nz,@348
	ld	de,word (phys @2+1588)
	ld	c,phys @2+1588 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1602 
;1603   curFile = _FileFromFD_(curSockfd);  curSI = File_Dev(curFile);
@348:
	.debug	# 1603
	ld	hl,(ix+5)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-14),hl
;1604 
;1605 
;1606   if (curSI->type == SOCK_STREAM)  {
	.debug	# 1606
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jp	nz,@349
;1607   //--- allocates new fd-->file-->socket triplet ---
;1608     if ((newSockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)  return -1;
@350:
	.debug	< @350 @351
	.debug	# 1608
	bool	hl
	ld	l,h
	push	hl
	inc	l
	inc	l
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$socket
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@352
	ld	hl,0xffff
	jp	@346
;1609 
;1610   //===== copy existing socket and fd settings to new socket and fd =====
;1611 
;1612     newFile = _FileFromFD_(newSockfd);  newSI = File_Dev(newFile);
@352:
	.debug	# 1612
	ld	hl,(ix-2)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-12),hl
;1613 
;1614     newSI->ourPort = curSI->ourPort;
	.debug	# 1614
	ld	hl,(ix-14)
	ld	de,0x5
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x5
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1615     newSI->ourAddr = curSI->ourAddr;
	.debug	# 1615
	ld	hl,(ix-14)
	ld	de,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-12)
	push	de
	ld	de,0x7
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1616 
;1617     newSI->listener = true;
	.debug	# 1617
	ld	hl,(ix-12)
	ld	de,0xb
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;1618 
;1619   //--- Swap what the global fds point to so the new fd refers to the open 
;1620   //--- socket and the existing one refers to the new listening socket. ---
;1621   //--- Swapping what the global fds point to means that links from the ---
;1622   //--- task's fds to the global fds will remain intact (and there can be
;1623   //--- multiple task fds pointing to the same global fd) ---
;1624   //--- NOTE:  _File_Swap_() does NOT swap the task-level fd values ---
;1625   //--- (openCount and flags) ---
;1626     _File_Swap_(curFile, newFile);
	.debug	# 1626
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	lcall	$_File_Swap_
	add	sp,8
;1627 
;1628     return newSockfd;
	.debug	# 1628
	ld	hl,(ix-2)
	jr	@346
;1629   }
@351:
	.debug	>
;1630 
;1631 //--- error - unsupported type ---
;1632   errno = ESOCKTNOSUPPORT;  return -1;
@349:
	.debug	# 1632
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;1633 }
@346:
	.debug	} @346 1633

@345	equ	14
	ld	sp,ix
	pop	ix
	lret
@347	equ	16
;1634 
;1635 
;1636 //=========================================================================
;1637 //  IODev interface functions (for use by fcntl module)
;1638 //=========================================================================
;1639 
;1640 //-------------------------------------------------------------------------
;1641 int _socketGetQueues_(void *ioDev, WaitQueues far *queues)
;1642 {
	.align	4
$$_socketGetQueues_::
	ex	(sp),iy
$_socketGetQueues_::
	.debug	G $_socketGetQueues_ 84 9
	.debug	{ $_socketGetQueues_ 84 1641 @355 @354
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 50
	.debug	A queues 7 85
;1643   queues->readQueue = &SI->readQueue;
	.debug	# 1643
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farst2##
;1644   queues->writeQueue = &SI->writeQueue;
	.debug	# 1644
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
;1645 
;1646   return 0;
	.debug	# 1646
	bool	hl
	ld	l,h
;1647 }
@354:
	.debug	} @354 1647

@353	equ	0
	pop	ix
	lret
@355	equ	2
;1648 
;1649 //-------------------------------------------------------------------------
;1650 //  Attempt to read bytes from a socket
;1651 //
;1652 //  Should only be called from the fcntl.c/read() function!
;1653 //
;1654 //  RETURN VALUEs:
;1655 //  - if bytes read: # of bytes read
;1656 //  - if no bytes read:
;1657 //    - if more possible in the future: -1 and errno == EAGAIN
;1658 //    - if no more possible (EOF):  0
;1659 //-------------------------------------------------------------------------
;1660 int _socketRead_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;1661 {
	.align	4
$$_socketRead_::
	ex	(sp),iy
$_socketRead_::
	.debug	G $_socketRead_ 87 9
	.debug	{ $_socketRead_ 87 1660 @358 @357
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ioDev 5 50
	.debug	A buf 7 64
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;1662   int  stat, idx;
	.debug	L stat -2 6
	.debug	L idx -4 6
;1663 
;1664 
;1665   stat = -1;
	.debug	# 1665
	ld	hl,0xffff
	ld	(ix-2),hl
;1666 
;1667   KLOCK();
	.debug	# 1667
	call	_KLOCK
;1668 
;1669   if (! validSOCK(ioDev))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1669
	ld	hl,(ix+5)
	push	hl
	lcall	$validSOCK
	pop	hl
	or	a,a
	jr	nz,@359
@360:
	.debug	< @360 @361
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@871
@361:
	.debug	>
;1670 
;1671   SI->diagFlags = current->diagFlags;
@359:
	.debug	# 1671
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1672 
;1673   if (!SI->sock)  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1673
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	nz,@362
@363:
	.debug	< @363 @364
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@871:
	ld	e,0x9
	jp	@869
@364:
	.debug	>
;1674 
;1675 
;1676 //NOTE:  A read can suceed from a socket that is "closed" if there is still
;1677 //       data in its buffer.
;1678 
;1679   switch (SI->type)  {
@362:
	.debug	# 1679
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	jr	@365
;1680     case SOCK_STREAM:
@367:
	.debug	< @367 @368
;1681       stat = sock_fastread((tcp_Socket *)SI->sock, buf, numBytes);
	.debug	# 1681
@369:
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sock_fastread
	add	sp,6
	ld	(ix-2),hl
;1682       idx = TCP_SI_Idx(SI);
	.debug	# 1682
	ld	hl,(ix+5)
	ld	de,_tcpSockets
	jr	@870
;1683       break;
	.debug	# 1683
;1684 
;1685     case SOCK_DGRAM:
;1686       stat = udp_recv( (udp_Socket *)SI->sock, buf, numBytes );
	.debug	# 1686
@370:
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$udp_recvfrom
	add	sp,12
	ld	(ix-2),hl
;1687       if (stat == -1)  { KUNLOCK();  errno = EAGAIN;  return -1; }  // no d
	.debug	# 1687
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@371
@372:
	.debug	< @372 @373
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	jp	@869
@373:
	.debug	>
;1688       idx = UDP_SI_Idx(SI);
@371:
	.debug	# 1688
	ld	hl,(ix+5)
	ld	de,_udpSockets
@870:
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;1689       break;
	.debug	# 1689
;1690 
;1691     default:
	jr	@366
;1692       KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;  // unsupported type
	.debug	# 1692
@374:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	jr	@869
;1693   }
@368:
	.debug	>
;1694 
;1695   KUNLOCK();
@365:
	cp	0x1
	jr	z,@370
	cp	0x2
	jr	z,@369
	jr	@374
@366:
	.debug	# 1695
	call	_KUNLOCK
;1696 
;1697   if (stat > 0)  return stat;
	.debug	# 1697
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@375
	jr	z,@375
	ld	hl,(ix-2)
	jr	@357
;1698 
;1699   if (stat < 0)  {
@375:
	.debug	# 1699
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@376
;1700     if (! SI->rdOK)  {
@377:
	.debug	< @377 @378
	.debug	# 1700
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@379
;1701       if (ShowSocketEvents)
@380:
	.debug	< @380 @381
	.debug	# 1701
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@382
;1702         fprintf(DiagLog, "socket (%04X)[%d]: read from closed socket ...\n"
;1703                 (uint)SI, idx );
	.debug	# 1703
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1602)
	ld	c,phys @2+1602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1704     }
@382:
@381:
	.debug	>
;1705     errno = EPIPE;  return -1;
@379:
	.debug	# 1705
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jr	@869
;1706   }
@378:
	.debug	>
;1707 
;1708 //--- For network lib funcs that don't return an error even after the ---
;1709 //--- network goes down (?!?!?!?) ---
;1710   if (linkWentDown)  { errno = ENETDOWN;  return -1; }
@376:
	.debug	# 1710
	ld	a,(_linkWentDown)
	or	a,a
	jr	z,@383
@384:
	.debug	< @384 @385
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x64
@869:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@357
@385:
	.debug	>
;1711 
;1712 //--- no error - but no new data to read ---
;1713   errno = EAGAIN;  return -1;
@383:
	.debug	# 1713
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;1714 }
@357:
	.debug	} @357 1714

@356	equ	4
	ld	sp,ix
	pop	ix
	lret
@358	equ	6
;1715 
;1716 
;1717 //-------------------------------------------------------------------------
;1718 //  Attempt to write bytes to socket connection
;1719 //
;1720 //  Should only be called from the fcntl.c/write() function!
;1721 //
;1722 //  RETURN VALUEs:
;1723 //  - if bytes written: # of bytes written
;1724 //  - if no bytes written:
;1725 //    - if more possible in the future: -1 and errno == EAGAIN
;1726 //    - if no more possible (EOF):  0
;1727 //-------------------------------------------------------------------------
;1728 int _socketWrite_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;1729 {
	.align	4
$$_socketWrite_::
	ex	(sp),iy
$_socketWrite_::
	.debug	G $_socketWrite_ 87 9
	.debug	{ $_socketWrite_ 87 1728 @388 @387
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ioDev 5 50
	.debug	A buf 7 64
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;1730   int  stat, idx; //, avail;
	.debug	L stat -2 6
	.debug	L idx -4 6
;1731 
;1732 
;1733   stat = -1;
	.debug	# 1733
	ld	hl,0xffff
	ld	(ix-2),hl
;1734 
;1735   KLOCK();
	.debug	# 1735
	call	_KLOCK
;1736 
;1737   if (! validSOCK(ioDev))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1737
	ld	hl,(ix+5)
	push	hl
	lcall	$validSOCK
	pop	hl
	or	a,a
	jr	z,@868
@390:
	.debug	< @390 @391
@391:
	.debug	>
;1738 
;1739   SI->diagFlags = current->diagFlags;
	.debug	# 1739
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1740 
;1741   if (!SI->sock)  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1741
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	nz,@392
@393:
	.debug	< @393 @394
@868:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@867
@394:
	.debug	>
;1742 
;1743 
;1744   switch (SI->type)  {
@392:
	.debug	# 1744
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	jp	@395
;1745     case SOCK_STREAM:
@397:
	.debug	< @397 @398
;1746       idx = TCP_SI_Idx(SI);
	.debug	# 1746
@399:
	ld	hl,(ix+5)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;1747       if (!SI->wrOK)  break;
	.debug	# 1747
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@396
;1748       if (SI->conState != SS_CONNECTED)  {
	.debug	# 1748
	ld	hl,(ix+5)
	ld	e,0xc
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jr	z,@401
;1749         KUNLOCK();  errno = ENOTCONN;  return -1; }
@402:
	.debug	< @402 @403
	.debug	# 1749
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6b
	jp	@866
@403:
	.debug	>
;1750 //    avail = sock_tbleft((tcp_Socket *)SI->sock);
;1751 //    if (avail <= 0)  { stat = 0;  break; }
;1752 //    if (avail < numBytes)  numBytes = avail;
;1753 //      if (sock_tbleft((tcp_Socket *)SI->sock) < 128)  tcp_tick(NULL);  //
;1754       stat = sock_fastwrite((tcp_Socket *)SI->sock, buf, numBytes);
@401:
	.debug	# 1754
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sock_fastwrite
	add	sp,6
	ld	(ix-2),hl
;1755 //      if (sock_tbleft((tcp_Socket *)SI->sock) < 128)  tcp_tick(NULL);  //
;1756       break;
	.debug	# 1756
;1757 
;1758     case SOCK_DGRAM:
	jr	@396
;1759       if (! SI->opened)  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1759
@404:
	ld	hl,(ix+5)
	ld	de,0x17
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@405
@406:
	.debug	< @406 @407
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@867:
	ld	e,0x9
	jp	@866
@407:
	.debug	>
;1760       stat = udp_send( (udp_Socket *)SI->sock, buf, numBytes);
@405:
	.debug	# 1760
	bool	hl
	ld	l,h
	push	hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$udp_sendto
	add	sp,12
	ld	(ix-2),hl
;1761       idx = UDP_SI_Idx(SI);
	.debug	# 1761
	ld	hl,(ix+5)
	ld	de,_udpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;1762       break;
	.debug	# 1762
;1763 
;1764     default:
	jr	@396
;1765       KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;  // unsupported type
	.debug	# 1765
@408:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	jr	@866
;1766   }
@398:
	.debug	>
;1767 
;1768   KUNLOCK();
@395:
	cp	0x1
	jr	z,@404
	cp	0x2
	jp	z,@399
	jr	@408
@396:
	.debug	# 1768
	call	_KUNLOCK
;1769 
;1770 //--- if any successfully buffered, then return the # ---
;1771   if (stat > 0)  return stat;
	.debug	# 1771
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@409
	jr	z,@409
	ld	hl,(ix-2)
	jr	@387
;1772 
;1773   if (stat < 0)  {
@409:
	.debug	# 1773
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@410
;1774     if (! SI->wrOK)  {
@411:
	.debug	< @411 @412
	.debug	# 1774
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@413
;1775       if (ShowSocketEvents)
@414:
	.debug	< @414 @415
	.debug	# 1775
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@416
;1776         fprintf(DiagLog, "socket (%04X)[%d]: write to closed socket ...\n",
;1777                 (uint)SI, idx );
	.debug	# 1777
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1650)
	ld	c,phys @2+1650 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1778     }
@416:
@415:
	.debug	>
;1779     errno = EPIPE;  return -1;
@413:
	.debug	# 1779
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jr	@866
;1780   }
@412:
	.debug	>
;1781 
;1782 
;1783 //--- For network lib funcs that don't return an error even after the ---
;1784 //--- network goes down (?!?!?!?) ---
;1785   if (linkWentDown)  { errno = ENETDOWN;  return -1; }
@410:
	.debug	# 1785
	ld	a,(_linkWentDown)
	or	a,a
	jr	z,@417
@418:
	.debug	< @418 @419
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x64
@866:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@387
@419:
	.debug	>
;1786 
;1787 //--- no error - but output buffer is full ---
;1788   errno = EAGAIN;  return -1;
@417:
	.debug	# 1788
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;1789 }
@387:
	.debug	} @387 1789

@386	equ	4
	ld	sp,ix
	pop	ix
	lret
@388	equ	6
;1790 
;1791 
;1792 //-------------------------------------------------------------------------
;1793 //  Function to reposition the current offset for a file descriptor
;1794 //
;1795 //  To be called ONLY by fcntl functions
;1796 //-------------------------------------------------------------------------
;1797 off_t  _socketLseek_(void *ioDev, off_t offset, int whence)
;1798 {
	.align	4
$$_socketLseek_::
	ex	(sp),iy
$_socketLseek_::
	.debug	G $_socketLseek_ 88 9
	.debug	{ $_socketLseek_ 88 1797 @422 @421
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 50
	.debug	A offset 7 9
	.debug	A whence 11 6
;1799   errno = ESPIPE;  return (off_t) -1;
	.debug	# 1799
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x1d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
;1800 }
@421:
	.debug	} @421 1800

@420	equ	0
	pop	ix
	lret
@422	equ	2
;1801 
;1802 
;1803 //-------------------------------------------------------------------------
;1804 //  Get information about the socket
;1805 //
;1806 //  To be called ONLY by fcntl functions
;1807 //-------------------------------------------------------------------------
;1808 int  _socketFstat_(void *ioDev, struct stat *fsbuf)
;1809 {
	.align	4
$$_socketFstat_::
	ex	(sp),iy
$_socketFstat_::
	.debug	G $_socketFstat_ 89 9
	.debug	{ $_socketFstat_ 89 1808 @425 @424
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 50
	.debug	A fsbuf 7 90
;1810   fsbuf->st_mode = S_IFSOCK | 00777;
	.debug	# 1810
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	de,0xc1ff
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1811 
;1812   return 0;
	.debug	# 1812
	bool	hl
	ld	l,h
;1813 }
@424:
	.debug	} @424 1813

@423	equ	0
	pop	ix
	lret
@425	equ	2
;1814 
;1815 
;1816 //-------------------------------------------------------------------------
;1817 //  Start the close process for a socket connection
;1818 //
;1819 //  Should NOT be called until ALL descriptors for the socket have been clo
;1820 //-------------------------------------------------------------------------
;1821 int _socketClose_(void *ioDev)
;1822 {
	.align	4
$$_socketClose_::
	ex	(sp),iy
$_socketClose_::
	.debug	G $_socketClose_ 92 9
	.debug	{ $_socketClose_ 92 1821 @428 @427
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 50
;1823   KLOCK();
	.debug	# 1823
	call	_KLOCK
;1824 
;1825   if (! validSOCK(ioDev))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 1825
	ld	hl,(ix+5)
	push	hl
	lcall	$validSOCK
	pop	hl
	or	a,a
	jr	nz,@429
@430:
	.debug	< @430 @431
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@427
@431:
	.debug	>
;1826 
;1827   if (!list_empty(&SI->readQueue.listHead)
@429:
;1828     OR !list_empty(&SI->writeQueue.listHead))  {
	.debug	# 1828
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x20
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@432
	inc	l
@432:
	bool	hl
	jr	z,@433
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x24
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@435
	inc	l
@435:
	bool	hl
	jp	nz,@434
@433:
;1829     if (!list_empty(&SI->readQueue.listHead))  {
@436:
	.debug	< @436 @437
	.debug	# 1829
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x20
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@438
	inc	l
@438:
	bool	hl
	jr	nz,@439
;1830       fprintf(DiagLog,
@440:
	.debug	< @440 @441
;1831               "***** tasks in %sQueue for closed socket *****\n", "read");
	.debug	# 1831
	ld	hl,@1+98
	push	hl
	ld	de,word (phys @2+1697)
	ld	c,phys @2+1697 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1832       wqListTasks(&SI->readQueue);  wakeTasks(&SI->readQueue);
	.debug	# 1832
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	push	hl
	lcall	$wqListTasks
	pop	hl
	ld	hl,(ix+5)
	ld	de,0x20
	add	hl,de
	push	hl
	lcall	$wakeTasks
	pop	hl
;1833     }
@441:
	.debug	>
;1834     if (!list_empty(&SI->writeQueue.listHead))  {
@439:
	.debug	# 1834
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x24
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@442
	inc	l
@442:
	bool	hl
	jr	nz,@443
;1835       fprintf(DiagLog,
@444:
	.debug	< @444 @445
;1836               "***** tasks in %sQueue for closed socket *****\n", "write");
	.debug	# 1836
	ld	hl,@1+103
	push	hl
	ld	de,word (phys @2+1697)
	ld	c,phys @2+1697 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1837       wqListTasks(&SI->writeQueue);  wakeTasks(&SI->writeQueue);
	.debug	# 1837
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	push	hl
	lcall	$wqListTasks
	pop	hl
	ld	hl,(ix+5)
	ld	de,0x24
	add	hl,de
	push	hl
	lcall	$wakeTasks
	pop	hl
;1838     }
@445:
	.debug	>
;1839   }
@443:
@437:
	.debug	>
;1840 
;1841   SI->diagFlags = current->diagFlags;
@434:
	.debug	# 1841
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1842 
;1843   if (SI->type == SOCK_STREAM)
	.debug	# 1843
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jr	nz,@446
;1844     if (SI->sock)  sock_flush((tcp_Socket *)SI->sock);
	.debug	# 1844
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@447
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sock_flush
	pop	hl
;1845 
;1846   SI->closeState = CS_CALL_CLOSE;  SI->noFDEVrefs = true;
@447:
@446:
	.debug	# 1846
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	inc	hl
	ld	a,e
	ld	(hl),a
;1847 //  SI->rdOK = SI->wrOK = false;  // done in checkSockets()
;1848 
;1849   KUNLOCK();
	.debug	# 1849
	call	_KUNLOCK
;1850 
;1851   return 0;
	.debug	# 1851
	bool	hl
	ld	l,h
;1852 }
@427:
	.debug	} @427 1852

@426	equ	0
	pop	ix
	lret
@428	equ	2
;1853 
;1854 
;1855 //-------------------------------------------------------------------------
;1856 //  format an addr and port number in host-byte-order to a string
;1857 //-------------------------------------------------------------------------
;1858 char *fmtAddrPort(char *buf, ulong addr, uint port)
;1859 {
$fmtAddrPort::
	.debug	G $fmtAddrPort 93 9
	.debug	{ $fmtAddrPort 93 1858 @450 @449
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A buf 5 64
	.debug	A addr 7 9
	.debug	A port 11 7
;1860   char  *ptr;
	.debug	L ptr -2 64
;1861 
;1862   if (addr)
	.debug	# 1862
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	or	hl,de
	jr	z,@451
;1863     inet_htop(AF_INET, &addr, buf, 4);
	.debug	# 1863
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,11+@448
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;1864   else
;1865     strcpy(buf, "*");
	jr	@452
@451:
	.debug	# 1865
	ld	hl,@1+109
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strcpy
	add	sp,4
;1866 
;1867   ptr = buf + strlen(buf);
@452:
	.debug	# 1867
	ld	hl,(ix+5)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
;1868 
;1869   if (port)  sprintf(ptr, ":%u", port);  else  strcpy(ptr, ":*");
	.debug	# 1869
	ld	hl,(ix+11)
	bool	hl
	jr	z,@453
	ld	hl,(ix+11)
	push	hl
	ld	de,word (phys @2+1745)
	ld	c,phys @2+1745 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	jr	@454
@453:
	ld	hl,@1+111
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcpy
	add	sp,4
;1870 
;1871   return buf;
@454:
	.debug	# 1871
	ld	hl,(ix+5)
;1872 }
@449:
	.debug	} @449 1872

@448	equ	2
	ld	sp,ix
	pop	ix
	lret
@450	equ	4
;1873 
;1874 
;1875 //-------------------------------------------------------------------------
;1876 //  Return a string description of the state of a socket
;1877 //-------------------------------------------------------------------------
;1878 const char *sockState(SockInfo *si)
;1879 {
$sockState::
	.debug	G $sockState 94 9
	.debug	{ $sockState 94 1878 @457 @456
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A si 5 39
;1880   if (! VALID(SockInfo, si))  return "*INVALID*";
	.debug	# 1880
	ld	hl,(ix+5)
	ld	de,0x28
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@458
	ld	hl,@1+114
	jr	@456
;1881 
;1882   if (si->sock)  return sockstate(si->sock);
@458:
	.debug	# 1882
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@459
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sockstate
	pop	de
	jr	@456
;1883 
;1884   if (si->listener)  return "Listen";
@459:
	.debug	# 1884
	ld	hl,(ix+5)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@460
	ld	hl,@1+124
	jr	@456
;1885 
;1886   return "*INVALID*";
@460:
	.debug	# 1886
	ld	hl,@1+114
;1887 }
@456:
	.debug	} @456 1887

@455	equ	0
	pop	ix
	lret
@457	equ	2
;1888 
;1889 
;1890 //-------------------------------------------------------------------------
;1891 //  Kernel-space function to handle ioctl calls for sockets
;1892 //-------------------------------------------------------------------------
;1893 int _socketioctl_(void *ioDev, int request, void *arg)
;1894 {
	.align	4
$$_socketioctl_::
	ex	(sp),iy
$_socketioctl_::
	.debug	G $_socketioctl_ 95 9
	.debug	{ $_socketioctl_ 95 1893 @463 @462
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ioDev 5 50
	.debug	A request 7 6
	.debug	A arg 9 50
;1895   int  stat;
	.debug	L stat -2 6
;1896 
;1897 #define CHAR_ARG   (*((char *)arg))
;1898 #define INT_ARG    (*((int *)arg))
;1899 #define UINT_ARG   (*((uint *)arg))
;1900 #define ULONG_ARG  (*((ulong *)arg))
;1901 
;1902 
;1903   if (! validSOCK(ioDev))  { errno = EBADF;  return -1; }
	.debug	# 1903
	ld	hl,(ix+5)
	push	hl
	lcall	$validSOCK
	pop	hl
	or	a,a
	jr	nz,@464
@465:
	.debug	< @465 @466
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@462
@466:
	.debug	>
;1904 
;1905   SI->diagFlags = current->diagFlags;
@464:
	.debug	# 1905
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1906 
;1907   stat = -1;
	.debug	# 1907
	ld	hl,0xffff
	ld	(ix-2),hl
;1908 
;1909   switch (request)  {
	.debug	# 1909
	ld	hl,(ix+7)
	jp	@467
;1910     case FIONREAD:  // return # of unread bytes
@469:
	.debug	< @469 @470
;1911       if (!SI->rdOK) { INT_ARG = -1;  errno = ENOLINK;  break; }
	.debug	# 1911
@471:
	ld	hl,(ix+5)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@472
@473:
	.debug	< @473 @474
	ld	hl,0xffff
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@865
@474:
	.debug	>
;1912       KLOCK();  INT_ARG = (SI->sock) ? sock_rbused(SI->sock) : 0;  KUNLOCK(
@472:
	.debug	# 1912
	call	_KLOCK
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@475
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sock_rbused
	pop	de
	jr	@482
@475:
	bool	hl
	ld	l,h
	jr	@482
;1913       stat = 0;  break;
	.debug	# 1913
;1914 
;1915     case FIONSPACE:  // return # of free bytes in the xmit buffer
;1916       if (!SI->wrOK) { INT_ARG = -1;  errno = ENOLINK;  break; }
	.debug	# 1916
@477:
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@478
@479:
	.debug	< @479 @480
	ld	hl,0xffff
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@865:
	ld	e,0x43
	jr	@864
@480:
	.debug	>
;1917       KLOCK();  INT_ARG = (SI->sock) ? sock_tbleft(SI->sock) : 0;  KUNLOCK(
@478:
	.debug	# 1917
	call	_KLOCK
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@481
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sock_tbleft
	pop	de
	jr	@482
@481:
	bool	hl
	ld	l,h
@482:
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	_KUNLOCK
;1918       stat = 0;  break;
	.debug	# 1918
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;1919 
;1920     default:
	jr	@468
;1921       errno = EINVAL;
	.debug	# 1921
@483:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@864:
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1922   }
@470:
	.debug	>
;1923 
;1924   return stat;
	jr	@468
@467:
	ex	de,hl
	ld	hl,0xffffabe5
	add	hl,de
	bool	hl
	jp	z,@471
	ld	hl,0xffffa000
	add	hl,de
	bool	hl
	jr	z,@477
	jr	@483
@468:
	.debug	# 1924
	ld	hl,(ix-2)
;1925 }
@462:
	.debug	} @462 1925

@461	equ	2
	ld	sp,ix
	pop	ix
	lret
@463	equ	4
;1926 
;1927 
;1928 //-------------------------------------------------------------------------
;1929 //  Return a description for a socket fd.
;1930 //
;1931 //  To be called ONLY by fcntl functions
;1932 //-------------------------------------------------------------------------
;1933 char *_socketDescr_(void *ioDev, char *buf, int bufSize)
;1934 {
	.align	4
$$_socketDescr_::
	ex	(sp),iy
$_socketDescr_::
	.debug	G $_socketDescr_ 96 9
	.debug	{ $_socketDescr_ 96 1933 @486 @485
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ioDev 5 50
	.debug	A buf 7 64
	.debug	A bufSize 9 6
;1935   char  *ptr;
	.debug	L ptr -2 64
;1936 
;1937 
;1938   if (bufSize < 80)  { *buf = 0;  return buf; }
	.debug	# 1938
	ld	hl,(ix+9)
	ld	de,0x8050
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@487
@488:
	.debug	< @488 @489
	xor	a,a
	ld	hl,(ix+7)
	ld	(hl),a
	jp	@485
@489:
	.debug	>
;1939 
;1940 //IPv4 0x1234 TCP[1] 192.168.250.247:502 -> 192.168.125.102:57159 Establish
;1941 
;1942   sprintf(buf, "IPv4 0x%04lX ", (ulong)ioDev);
@487:
	.debug	# 1942
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @2+1749)
	ld	c,phys @2+1749 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;1943 
;1944   ptr = buf + strlen(buf);  strcpy(ptr, "bad bad");
	.debug	# 1944
	ld	hl,(ix+7)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
	ld	hl,@1+131
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcpy
	add	sp,4
;1945 
;1946 //finish: limit output to bufSize
;1947 
;1948   if (! validSOCK(ioDev))  return buf;
	.debug	# 1948
	ld	hl,(ix+5)
	push	hl
	lcall	$validSOCK
	pop	hl
	or	a,a
	jr	nz,@490
	ld	hl,(ix+7)
	jp	@485
;1949 
;1950   if (SI->type == SOCK_STREAM)
@490:
	.debug	# 1950
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jr	nz,@491
;1951     sprintf(ptr, "TCP[%d] ", SI - tcpSockets);
	.debug	# 1951
	ld	hl,(ix+5)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	de,word (phys @2+1763)
	ld	c,phys @2+1763 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;1952   else
;1953     sprintf(ptr, "UDP[%d] ", SI - udpSockets);
	jr	@492
@491:
	.debug	# 1953
	ld	hl,(ix+5)
	ld	de,_udpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	de,word (phys @2+1772)
	ld	c,phys @2+1772 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;1954   while (*ptr) ++ptr;
@492:
@493:
	.debug	# 1954
	ld	hl,(ix-2)
	ld	a,(hl)
	or	a,a
	jr	z,@494
	inc	hl
	ld	(ix-2),hl
;1955 
;1956   fmtAddrPort(ptr, SI->ourAddr, SI->ourPort);
	jr	@493
@494:
	.debug	# 1956
	ld	hl,(ix+5)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	e,0x7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$fmtAddrPort
	add	sp,8
;1957   strcat(ptr, " -> ");  while (*ptr) ++ptr;
	.debug	# 1957
	ld	hl,@1+139
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcat
	add	sp,4
@495:
	ld	hl,(ix-2)
	ld	a,(hl)
	or	a,a
	jr	z,@496
	inc	hl
	ld	(ix-2),hl
;1958 
;1959   fmtAddrPort(ptr, RemoteAddr(SI), RemotePort(SI));
	jr	@495
@496:
	.debug	# 1959
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@497
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	de,0x19
	add	hl,de
	ld	hl,(hl)
	jr	@498
@497:
	bool	hl
	ld	l,h
@498:
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	bool	hl
	jr	z,@499
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	de,0x15
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@500
@499:
	ld	de,0
	ld	c,e
	ld	b,e
@500:
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$fmtAddrPort
	add	sp,8
;1960   strcat(ptr, " ");  strcat(ptr, sockState(SI));
	.debug	# 1960
	ld	hl,@1+142
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcat
	add	sp,4
	ld	hl,(ix+5)
	push	hl
	lcall	$sockState
	pop	de
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcat
	add	sp,4
;1961 
;1962   return buf;
	.debug	# 1962
	ld	hl,(ix+7)
;1963 }
@485:
	.debug	} @485 1963

@484	equ	2
	ld	sp,ix
	pop	ix
	lret
@486	equ	4
;1964 
;1965 
;1966 
;1967 //=========================================================================
;1968 //  Unix compatible standard BSD socket functions
;1969 //=========================================================================
;1970 
;1971 //-------------------------------------------------------------------------
;1972 //  Allocate a socket and a file descriptor for the specified type of socke
;1973 //-------------------------------------------------------------------------
;1974 fd_t socket(int family, int type, int protocol)
;1975 {
$socket::
	.debug	G $socket 97 9
	.debug	{ $socket 97 1974 @503 @502
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A family 5 6
	.debug	A type 7 6
	.debug	A protocol 9 6
;1976   fd_t  fd;
	.debug	L fd -2 6
;1977   uint  ui;
	.debug	L ui -4 7
;1978   SockInfo  *si, *test;
	.debug	L si -6 39
	.debug	L test -8 39
;1979   void  *sockPtr;
	.debug	L sockPtr -10 50
;1980 
;1981 
;1982   if (family != AF_INET)  { errno = EAFNOSUPPORT;  return -1; }
	.debug	# 1982
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@504
@505:
	.debug	< @505 @506
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x61
	jp	@863
@506:
	.debug	>
;1983 
;1984 //--- get an unused socket of the correct type ---
;1985   si = NULL;
@504:
	.debug	# 1985
	bool	hl
	ld	l,h
	ld	(ix-6),hl
;1986 
;1987   KLOCK();
	.debug	# 1987
	call	_KLOCK
;1988 
;1989 //NOTE:  When there are multiple not-in-use sockets, we choose the one with
;1990 //       the earliest lastClosed time
;1991 
;1992   switch (type)  {
	.debug	# 1992
	ld	hl,(ix+7)
	jp	@507
;1993 
;1994     case SOCK_STREAM:
@509:
	.debug	< @509 @510
;1995       for (ui=0; ui<MaxTCPSockets; ++ui)  {
	.debug	# 1995
@511:
@512:
	.debug	< @512 @513
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@514:
	ld	hl,(ix-4)
	ld	de,0x12
	or	a,a
	sbc	hl,de
	jr	nc,@515
;1996         test = tcpSockets + ui;
@517:
	.debug	< @517 @518
	.debug	# 1996
	ld	hl,(ix-4)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_tcpSockets
	add	hl,bc
	ld	(ix-8),hl
;1997         if (!test->inUse)  if (!si OR (test->lastClosed < si->lastClosed)) 
	.debug	# 1997
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@519
	ld	hl,(ix-6)
	bool	hl
	jr	z,@520
	ld	hl,(ix-8)
	ld	de,0x1c
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x1c
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	jr	nc,@521
@520:
;1998           si = test;  sockPtr = NULL; }
@522:
	.debug	< @522 @523
	.debug	# 1998
	ld	hl,(ix-8)
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(ix-10),hl
@523:
	.debug	>
;1999       }
@521:
@519:
@518:
	.debug	>
;2000       break;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@514
@515:
@513:
	.debug	>
	.debug	# 2000
;2001 
;2002     case SOCK_DGRAM:
	jp	@508
;2003       for (ui=0; ui<MaxUDPSockets; ++ui)  {
	.debug	# 2003
@524:
@525:
	.debug	< @525 @526
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@527:
	ld	hl,(ix-4)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@508
;2004         test = udpSockets + ui;
@530:
	.debug	< @530 @531
	.debug	# 2004
	ld	hl,(ix-4)
	ld	bc,0x2a
	ex	de,hl
	mul
	ld	hl,_udpSockets
	add	hl,bc
	ld	(ix-8),hl
;2005         if (!test->inUse)  if (!si OR (test->lastClosed < si->lastClosed)) 
	.debug	# 2005
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	nz,@532
	ld	hl,(ix-6)
	bool	hl
	jr	z,@533
	ld	hl,(ix-8)
	ld	de,0x1c
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x1c
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	jr	nc,@534
@533:
;2006             si = test;  sockPtr = udpSockDef + ui; }
@535:
	.debug	< @535 @536
	.debug	# 2006
	ld	hl,(ix-8)
	ld	(ix-6),hl
	ld	hl,(ix-4)
	ld	bc,0x2c
	ex	de,hl
	mul
	ld	hl,_udpSockDef
	add	hl,bc
	ld	(ix-10),hl
@536:
	.debug	>
;2007       }
@534:
@532:
@531:
	.debug	>
;2008       break;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@527
@526:
	.debug	>
	.debug	# 2008
;2009 
;2010     default:
;2011       KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;
	.debug	# 2011
@537:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	jr	@863
;2012   }
@510:
	.debug	>
;2013 
;2014   if (! si)  { KUNLOCK();  errno = ENOBUFS;  return -1; }
@507:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@524
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jp	z,@511
	jr	@537
@508:
	.debug	# 2014
	ld	hl,(ix-6)
	bool	hl
	jr	nz,@538
@539:
	.debug	< @539 @540
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x69
@863:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@862
@540:
	.debug	>
;2015 
;2016 //--- initialize SockInfo object ---
;2017   initSockInfo(si, sockPtr, type);
@538:
	.debug	# 2017
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix-10)
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$initSockInfo
	add	sp,6
;2018   si->inUse = true;  si->diagFlags = current->diagFlags;
	.debug	# 2018
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	a,0x1
	ld	(hl),a
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2019 
;2020 //--- allocate a file descriptor to ref the socket data ---
;2021   if ((fd = _allocFile_(3, &socketIOFuncs, si)) < 0)  {
	.debug	# 2021
	ld	hl,(ix-6)
	push	hl
	ld	hl,_socketIOFuncs
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$_allocFile_
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@541
;2022     si->inUse = false;  KUNLOCK();  return -1; }
@542:
	.debug	< @542 @543
	.debug	# 2022
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	xor	a,a
	ld	(hl),a
	call	_KUNLOCK
@862:
	ld	hl,0xffff
	jr	@502
@543:
	.debug	>
;2023 
;2024 
;2025 //--- everything OK - return the descriptor assigned for this process ---
;2026   KUNLOCK();    return fd;
@541:
	.debug	# 2026
	call	_KUNLOCK
	ld	hl,(ix-2)
;2027 }
@502:
	.debug	} @502 2027

@501	equ	10
	ld	sp,ix
	pop	ix
	lret
@503	equ	12
;2028 
;2029 
;2030 
;2031 //-------------------------------------------------------------------------
;2032 //  Bind a socket to a local address (or 0 for all) and port
;2033 //-------------------------------------------------------------------------
;2034 int bind(fd_t sockfd, const struct sockaddr *localAddr, int nameLen)
;2035 {
$bind::
	.debug	G $bind 98 9
	.debug	{ $bind 98 2034 @546 @545
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A sockfd 5 6
	.debug	A localAddr 7 99
	.debug	A nameLen 9 6
;2036   FDEV  far *file;
	.debug	L file -4 69
;2037   SockInfo  *si;
	.debug	L si -6 39
;2038   int  stat;
	.debug	L stat -8 6
;2039 
;2040 
;2041   KLOCK();
	.debug	# 2041
	call	_KLOCK
;2042 
;2043   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK();  return -1; }
	.debug	# 2043
	ld	hl,-4+@544
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jr	nz,@547
@548:
	.debug	< @548 @549
	call	_KUNLOCK
	ld	hl,0xffff
	jp	@545
@549:
	.debug	>
;2044 
;2045   si->diagFlags = current->diagFlags;
@547:
	.debug	# 2045
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2046 
;2047   stat = -1;
	.debug	# 2047
	ld	hl,0xffff
	ld	(ix-8),hl
;2048 
;2049   switch (si->type)  {
	.debug	# 2049
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	jp	@550
;2050 
;2051     case SOCK_STREAM:
@552:
	.debug	< @552 @553
;2052       si->ourPort = ntohs(localAddr->sin_port);
	.debug	# 2052
@554:
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x5
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2053       si->ourAddr = ntohl(localAddr->sin_addr);
	.debug	# 2053
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jp	@861
;2054       stat = 0;  break;
	.debug	# 2054
;2055 
;2056     case SOCK_DGRAM:
;2057       si->ourPort = ntohs(localAddr->sin_port);
	.debug	# 2057
@555:
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x5
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2058       si->ourAddr = ntohl(localAddr->sin_addr);
	.debug	# 2058
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
@861:
	ld	hl,(ix-6)
	push	de
	ld	de,0x7
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2059       stat = 0;  break;
	.debug	# 2059
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;2060 
;2061     default:
	jr	@551
;2062       errno = ESOCKTNOSUPPORT;
	.debug	# 2062
@556:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2063   }
@553:
	.debug	>
;2064 
;2065   KUNLOCK();  return stat;
	jr	@551
@550:
	cp	0x1
	jp	z,@555
	cp	0x2
	jp	z,@554
	jr	@556
@551:
	.debug	# 2065
	call	_KUNLOCK
	ld	hl,(ix-8)
;2066 }
@545:
	.debug	} @545 2066

@544	equ	8
	ld	sp,ix
	pop	ix
	lret
@546	equ	10
;2067 
;2068 
;2069 //-------------------------------------------------------------------------
;2070 //  Set a socket to listen mode so it can accept incoming connections with 
;2071 //  accept() call
;2072 //-------------------------------------------------------------------------
;2073 int listen(fd_t sockfd, int backlog)
;2074 {
$listen::
	.debug	G $listen 101 9
	.debug	{ $listen 101 2073 @559 @558
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-11
	.debug	A sockfd 5 6
	.debug	A backlog 7 6
;2075   FDEV  far *file;
	.debug	L file -4 69
;2076   SockInfo  *si;
	.debug	L si -6 39
;2077   word  netPort;
	.debug	L netPort -8 5
;2078   uint  x;
	.debug	L x -10 7
;2079   bool  allUsed;
	.debug	L allUsed -11 3
;2080 
;2081 
;2082   KLOCK();
	.debug	# 2082
	call	_KLOCK
;2083 
;2084   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK();  return -1; }
	.debug	# 2084
	ld	hl,-4+@557
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jr	nz,@560
@561:
	.debug	< @561 @562
	call	_KUNLOCK
	jp	@860
@562:
	.debug	>
;2085 
;2086   if (si->type != SOCK_STREAM)  { KUNLOCK();  errno = EOPNOTSUPP;  return -
@560:
	.debug	# 2086
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jr	z,@563
@564:
	.debug	< @564 @565
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5f
	jp	@859
@565:
	.debug	>
;2087 
;2088 //--- Check for unused and duplicate listener slots ---
;2089   netPort = intel16(si->ourPort);  allUsed = true;
@563:
	.debug	# 2089
	ld	hl,(ix-6)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-8),hl
	ld	(ix-11),0x1
;2090   for (x=0; x<MAX_RESERVEPORTS; ++x)  {
@566:
	.debug	< @566 @567
	.debug	# 2090
	bool	hl
	ld	l,h
	ld	(ix-10),hl
@568:
	ld	a,(_MAX_RESERVEPORTS)
	bool	hl
	ld	l,a
	ex	de,hl
	ld	hl,(ix-10)
	or	a,a
	sbc	hl,de
	jr	nc,@569
;2091     if (tcp_reserveports[x] == netPort) {
@571:
	.debug	< @571 @572
	.debug	# 2091
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_tcp_reserveports
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@573
;2092       KUNLOCK();  errno = EADDRINUSE;  return -1; }
@574:
	.debug	< @574 @575
	.debug	# 2092
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x62
	jr	@859
@575:
	.debug	>
;2093     if (!tcp_reserveports[x])  allUsed = false;
@573:
	.debug	# 2093
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_tcp_reserveports
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@576
	xor	a,a
	ld	(ix-11),a
;2094   }
@576:
@572:
	.debug	>
;2095 
;2096   if (allUsed)  {  KUNLOCK();  errno = ENOSR;  return -1; }
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jr	@568
@569:
@567:
	.debug	>
	.debug	# 2096
	ld	a,(ix-11)
	or	a,a
	jr	z,@577
@578:
	.debug	< @578 @579
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3f
@859:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@860:
	ld	hl,0xffff
	jr	@558
@579:
	.debug	>
;2097 
;2098   si->diagFlags = current->diagFlags;
@577:
	.debug	# 2098
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2099 
;2100   tcp_reserveport(si->ourPort);
	.debug	# 2100
	ld	hl,(ix-6)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$tcp_reserveport
	pop	hl
;2101 
;2102   si->listener = true;
	.debug	# 2102
	ld	hl,(ix-6)
	ld	de,0xb
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2103 
;2104   KUNLOCK();
	.debug	# 2104
	call	_KUNLOCK
;2105 
;2106   if (ShowSocketEvents)
	.debug	# 2106
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@580
;2107     fprintf(DiagLog, "socket (%04lX)[%d]: listening on port %d\n",
;2108             (ulong)si, TCP_SI_Idx(si), si->ourPort);
	.debug	# 2108
	ld	hl,(ix-6)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-6)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @2+1781)
	ld	c,phys @2+1781 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;2109 
;2110   return 0;
@580:
	.debug	# 2110
	bool	hl
	ld	l,h
;2111 }
@558:
	.debug	} @558 2111

@557	equ	11
	ld	sp,ix
	pop	ix
	lret
@559	equ	13
;2112 
;2113 
;2114 //-------------------------------------------------------------------------
;2115 //  Check for a new connection to a listening socket.
;2116 //
;2117 //  Returns:
;2118 //  - if new connection, a new fd for the new connection and clientAddr fil
;2119 //    in with the addr and port of the remote end of the connection
;2120 //
;2121 //  - if no new connection and blocking disabled, -1 and errno = EAGAIN
;2122 //
;2123 //  - if an error, -1 and errno indicates the error
;2124 //-------------------------------------------------------------------------
;2125 fd_t accept(fd_t sockfd, struct sockaddr *clientAddr, int *addrLen)
;2126 {
$accept::
	.debug	G $accept 102 9
	.debug	{ $accept 102 2125 @583 @582
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.debug	A sockfd 5 6
	.debug	A clientAddr 7 99
	.debug	A addrLen 9 103
;2127   FDEV  far *file;
	.debug	L file -4 69
;2128   fd_t  newSockfd;
	.debug	L newSockfd -6 6
;2129   SockInfo  *si;
	.debug	L si -8 39
;2130   sock_type  *sock;
	.debug	L sock -10 41
;2131   struct sockaddr addr;
	.debug	L addr -24 100
;2132   int  len, fflags;
	.debug	L len -26 6
	.debug	L fflags -28 6
;2133 
;2134 
;2135   KLOCK();
	.debug	# 2135
	call	_KLOCK
;2136 
;2137   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK();  return -1; }
	.debug	# 2137
	ld	hl,-4+@581
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-8),hl
	bool	hl
	jr	nz,@584
@585:
	.debug	< @585 @586
	call	_KUNLOCK
	jp	@857
@586:
	.debug	>
;2138 
;2139   if (!si->listener)  { KUNLOCK();  errno = EINVAL;  return -1; }
@584:
	.debug	# 2139
	ld	hl,(ix-8)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@587
@588:
	.debug	< @588 @589
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@856
@589:
	.debug	>
;2140 
;2141   if (! (sock = (sock_type *)unusedTCP()))  {
@587:
	.debug	# 2141
	lcall	$unusedTCP
	ld	(ix-10),hl
	bool	hl
	jr	nz,@590
;2142     KUNLOCK();  errno = ENOBUFS;  return -1; }
@591:
	.debug	< @591 @592
	.debug	# 2142
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jp	@858
@592:
	.debug	>
;2143 
;2144   SetSockLink(si, sock);
@590:
@593:
	.debug	< @593 @594
	.debug	# 2144
	ld	hl,(ix-10)
	ld	de,0x88
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-10)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@594:
	.debug	>
;2145 
;2146   if (! tcp_listen((tcp_Socket *)sock, si->ourPort, 0, 0, tcpSockEvent_, 0)
	.debug	# 2146
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_tcpSockEvent_
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-8)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-10)
	push	hl
	lcall	$tcp_listen
	add	sp,14
	bool	hl
	jr	nz,@595
;2147     showErrs(si, sock);  ClearSockLink(si);
@596:
	.debug	< @596 @597
	.debug	# 2147
	ld	hl,(ix-10)
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$showErrs
	add	sp,4
@598:
	.debug	< @598 @599
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@600
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@600:
	ld	hl,(ix-8)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@599:
	.debug	>
;2148     KUNLOCK();  errno = EIO;  return -1;
	.debug	# 2148
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5
	jp	@856
;2149   }
@597:
	.debug	>
;2150 
;2151   if (SockClosed(sock))  {
@595:
	.debug	# 2151
	ld	hl,(ix-10)
	push	hl
	lcall	$sock_alive
	pop	de
	bool	hl
	jr	z,@601
	ld	hl,@1+69
	push	hl
	ld	hl,(ix-10)
	push	hl
	lcall	$sockstate
	pop	de
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@602
@601:
;2152     ClearSockLink(si);  KUNLOCK();  errno = EPIPE;  return -1; }
@603:
	.debug	< @603 @604
@605:
	.debug	< @605 @606
	.debug	# 2152
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@607
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@607:
	ld	hl,(ix-8)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@606:
	.debug	>
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jp	@856
@604:
	.debug	>
;2153 
;2154   si->diagFlags = current->diagFlags;
@602:
	.debug	# 2154
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-8)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2155 
;2156   if (si->type == SOCK_STREAM)  for (;;)  {
	.debug	# 2156
	ld	hl,(ix-8)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jp	nz,@608
@609:
	.debug	< @609 @610
@611:
;2157 //    if (tcp_tick(sock) == 0)  { KUNLOCK();  errno = ECONNRESET;  return -
;2158 
;2159     if ( sock_established(sock) OR (sock_rbused(sock) > 0) )  {
@614:
	.debug	< @614 @615
	.debug	# 2159
	ld	hl,(ix-10)
	push	hl
	lcall	$sock_established
	pop	de
	bool	hl
	jr	nz,@616
	ld	hl,(ix-10)
	push	hl
	lcall	$sock_rbused
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@617
	jp	z,@617
@616:
;2160     /*
;2161        If _newListener_() returns >= 0, then newSockfd refers to the just
;2162        accepted/established connection, and sockfd now refers to a new
;2163        listener socket for the same port.
;2164 
;2165        If _newListener_() returns < 0, then there is no new listening socke
;2166        and sockfd still refers to the just accepted/established connection.
;2167        When that occurs, we need to close the new connection and leave the
;2168        existing socket as a listener.
;2169     */
;2170       if ((newSockfd = _newListener_(sockfd)) < 0)  {
@618:
	.debug	< @618 @619
	.debug	# 2170
	ld	hl,(ix+5)
	push	hl
	lcall	$_newListener_
	pop	de
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@620
;2171         ClearSockLink(si);  sock_abort(sock);
@621:
	.debug	< @621 @622
@623:
	.debug	< @623 @624
	.debug	# 2171
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@625
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@625:
	ld	hl,(ix-8)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@624:
	.debug	>
	ld	hl,(ix-10)
	push	hl
	lcall	$sock_abort
	pop	hl
;2172         KUNLOCK();  errno = ENOBUFS;  return -1;
	.debug	# 2172
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@858:
	ld	e,0x69
	jp	@856
;2173       }
@622:
	.debug	>
;2174 
;2175       len = sizeof(struct sockaddr);
@620:
	.debug	# 2175
	ld	hl,0xe
	ld	(ix-26),hl
;2176       getsockname(sock, &addr, &len);
	.debug	# 2176
	ld	hl,-26+@581
	add	hl,sp
	push	hl
	ld	hl,-22+@581
	add	hl,sp
	push	hl
	ld	hl,(ix-10)
	push	hl
	lcall	$getsockname
	add	sp,6
;2177 
;2178       si->ourPort = addr.s_port;
	.debug	# 2178
	ld	hl,(ix-8)
	ld	de,0x5
	add	hl,de
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2179       si->ourAddr = addr.s_ip;
	.debug	# 2179
	ld	hl,(ix-8)
	ld	de,0x7
	add	hl,de
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2180 
;2181       si->rdOK = si->wrOK = true;
	.debug	# 2181
	ld	hl,(ix-8)
	ld	de,0x13
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix-8)
	dec	e
	add	hl,de
	ld	(hl),a
;2182 
;2183       si->listener = false;
	.debug	# 2183
	ld	hl,(ix-8)
	ld	e,0xb
	add	hl,de
	xor	a,a
	ld	(hl),a
;2184 
;2185       si->conState = SS_CONNECTED;
	.debug	# 2185
	ld	hl,(ix-8)
	inc	e
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2186 
;2187       if (clientAddr)  {
	.debug	# 2187
	ld	hl,(ix+7)
	bool	hl
	jp	z,@626
;2188         if (*addrLen >= 2)  clientAddr->sin_family = AF_INET;
@627:
	.debug	< @627 @628
	.debug	# 2188
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	d,0x80
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@629
	ld	hl,(ix+7)
	ld	d,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2189         if (*addrLen >= 4)  clientAddr->sin_port = htons(RemotePort(si));
@629:
	.debug	# 2189
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	de,0x8004
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@630
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@631
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x19
	add	hl,de
	ld	hl,(hl)
	jr	@632
@631:
	bool	hl
	ld	l,h
@632:
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2190         if (*addrLen >= 8)  clientAddr->sin_addr = htonl(RemoteAddr(si));
@630:
	.debug	# 2190
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	de,0x8008
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@633
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@634
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x15
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@635
@634:
	ld	de,0
	ld	c,e
	ld	b,e
@635:
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix+7)
	push	de
	ld	de,0x4
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2191         *addrLen = sizeof(struct sockaddr);
@633:
	.debug	# 2191
	ld	hl,0xe
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2192       }
@628:
	.debug	>
;2193 
;2194       KUNLOCK();
@626:
	.debug	# 2194
	call	_KUNLOCK
;2195 
;2196       if (ShowSocketEvents)   fprintf(DiagLog,
	.debug	# 2196
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@636
;2197             "socket (%04lX)[%d]: new socket connection, port %d\n",
;2198             (ulong)si, TCP_SI_Idx(si), si->ourPort);
	.debug	# 2198
	ld	hl,(ix-8)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-8)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @2+1823)
	ld	c,phys @2+1823 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;2199 
;2200       return newSockfd;
@636:
	.debug	# 2200
	ld	hl,(ix-6)
	jp	@582
;2201     }
@619:
	.debug	>
;2202 
;2203   //--- No new connection, so reset the tcp_Socket we used to check for one
;2204     sock_abort(sock);
@617:
	.debug	# 2204
	ld	hl,(ix-10)
	push	hl
	lcall	$sock_abort
	pop	hl
;2205 
;2206 //    KUNLOCK();  errno = EAGAIN;  return -1;  //tdebug - blocking causes p
;2207 
;2208     fflags = fcntl(sockfd, F_GETFL, 0);
	.debug	# 2208
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-28),hl
;2209 
;2210     ClearSockLink(si);
@637:
	.debug	< @637 @638
	.debug	# 2210
	ld	hl,(ix-8)
	ld	hl,(hl)
	bool	hl
	jr	z,@639
	ld	hl,(ix-8)
	ld	hl,(hl)
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@639:
	ld	hl,(ix-8)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@638:
	.debug	>
;2211 
;2212     KUNLOCK();
	.debug	# 2212
	call	_KUNLOCK
;2213 
;2214     if (fflags & O_NONBLOCK)  { errno = EAGAIN;  return -1; }
	.debug	# 2214
	ld	hl,(ix-28)
	ld	de,0x20
	and	hl,de
	jr	z,@640
@641:
	.debug	< @641 @642
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0xb
	jr	@856
@642:
	.debug	>
;2215 
;2216     if (linkWentDown)  { KUNLOCK();  errno = ENETDOWN;  return -1; }
@640:
	.debug	# 2216
	ld	a,(_linkWentDown)
	or	a,a
	jr	z,@643
@644:
	.debug	< @644 @645
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x64
@856:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@857:
	ld	hl,0xffff
	jr	@582
@645:
	.debug	>
;2217 
;2218     //finish - blocking mode should be handled using a wait queue
;2219     sleepMS(200);  KLOCK();
@643:
	.debug	# 2219
	ld	de,0xc8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
;2220   }
@615:
	.debug	>
;2221 
;2222 
;2223   KUNLOCK();  ERRNO = ESOCKTNOSUPPORT;  return -1;  // unsupported type
	jp	@611
@610:
	.debug	>
@608:
	.debug	# 2223
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2224 }
@582:
	.debug	} @582 2224

@581	equ	28
	ld	sp,ix
	pop	ix
	lret
@583	equ	30
;2225 
;2226 
;2227 
;2228 //-------------------------------------------------------------------------
;2229 //  Initiate a connection on a socket
;2230 //-------------------------------------------------------------------------
;2231 int connect(fd_t sockfd, const struct sockaddr *remoteAddr, int addrLen)
;2232 {
$connect::
	.debug	G $connect 98 9
	.debug	{ $connect 98 2231 @648 @647
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-110
	.debug	A sockfd 5 6
	.debug	A remoteAddr 7 99
	.debug	A addrLen 9 6
;2233   FDEV  far *file;
	.debug	L file -4 69
;2234   SockInfo  *si;
	.debug	L si -6 39
;2235   sock_type  *sock;
	.debug	L sock -8 41
;2236   ulong  remAddr;
	.debug	L remAddr -12 9
;2237   short  remPort;
	.debug	L remPort -14 4
;2238   struct sockaddr addr;
	.debug	L addr -28 100
;2239   int  len;
	.debug	L len -30 6
;2240   char  descr[80];
	.debug	L descr -110 104
;2241 
;2242 
;2243   KLOCK();
	.debug	# 2243
	call	_KLOCK
;2244 
;2245   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK();  return -1; }
	.debug	# 2245
	ld	hl,-4+@646
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jp	z,@854
@650:
	.debug	< @650 @651
@651:
	.debug	>
;2246 
;2247   si->diagFlags = current->diagFlags;
	.debug	# 2247
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2248 
;2249   if (! (sock = (sock_type *)unusedTCP()))  {
	.debug	# 2249
	lcall	$unusedTCP
	ld	(ix-8),hl
	bool	hl
	jr	nz,@652
;2250     KUNLOCK();  errno = ENOBUFS;  return -1; }
@653:
	.debug	< @653 @654
	.debug	# 2250
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x69
	jp	@855
@654:
	.debug	>
;2251 
;2252   SetSockLink(si, sock);
@652:
@655:
	.debug	< @655 @656
	.debug	# 2252
	ld	hl,(ix-8)
	ld	de,0x88
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@656:
	.debug	>
;2253 
;2254   if (si->type == SOCK_STREAM)  {  // TCP socket
	.debug	# 2254
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jp	nz,@657
;2255 
;2256     if (si->conState == SS_UNCONNECTED)  {
@658:
	.debug	< @658 @659
	.debug	# 2256
	ld	hl,(ix-6)
	ld	e,0xc
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jp	nz,@660
;2257       remAddr = ntohl(remoteAddr->sin_addr);
@661:
	.debug	< @661 @662
	.debug	# 2257
	ld	hl,(ix+7)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2258       remPort = ntohs(remoteAddr->sin_port);
	.debug	# 2258
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-14),hl
;2259 
;2260       if (ShowSocketEvents)
	.debug	# 2260
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@663
;2261         fprintf(DiagLog, "socket (%04lX)[%d]: connect(): %s\n",
;2262                 (ulong)si, TCP_SI_Idx(si),
;2263                 fmtAddrPort(descr, remAddr, remPort) );
	.debug	# 2263
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-104+@646
	add	hl,sp
	push	hl
	lcall	$fmtAddrPort
	add	sp,8
	push	hl
	ld	hl,(ix-6)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @2+1875)
	ld	c,phys @2+1875 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,14
;2264 
;2265       if (! tcp_open((tcp_Socket *)sock, 0,
@663:
;2266                       remAddr, remPort, tcpSockEvent_))  {
	.debug	# 2266
	ld	hl,_tcpSockEvent_
	push	hl
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$tcp_open
	add	sp,12
	bool	hl
	jr	nz,@664
;2267         ClearSockLink(si);  KUNLOCK();  errno = ENETUNREACH;  return -1;  }
@665:
	.debug	< @665 @666
@667:
	.debug	< @667 @668
	.debug	# 2267
	ld	hl,(ix-6)
	ld	hl,(hl)
	bool	hl
	jr	z,@669
	ld	hl,(ix-6)
	ld	hl,(hl)
	ld	de,0x88
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@669:
	ld	hl,(ix-6)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
@668:
	.debug	>
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x65
	jp	@855
@666:
	.debug	>
;2268 
;2269       si->startTime = MS_TIMER;  si->conState = SS_CONNECTING;
@664:
	.debug	# 2269
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-6)
	push	de
	ld	de,0xe
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-6)
	ld	de,0xc
	add	hl,de
	ld	e,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2270 
;2271 //finish - support for non-blocking mode (errno == EINPROGRESS or EALREADY)
;2272 //         (i.e. allow return of -1 with errno set while not established)
;2273       errno = EINPROGRESS;
	.debug	# 2273
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x73
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2274     }
@662:
	.debug	>
;2275 
;2276     while (si->conState == SS_CONNECTING)  {
@660:
@670:
	.debug	# 2276
	ld	hl,(ix-6)
	ld	de,0xc
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	or	a,a
	sbc	hl,de
	jp	nz,@671
;2277       if ( sock_established(sock) OR (sock_rbused(sock) > 0) )  {
@672:
	.debug	< @672 @673
	.debug	# 2277
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_established
	pop	de
	bool	hl
	jr	nz,@674
	ld	hl,(ix-8)
	push	hl
	lcall	$sock_rbused
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@675
	jr	z,@675
@674:
;2278         len = sizeof(struct sockaddr);
@676:
	.debug	< @676 @677
	.debug	# 2278
	ld	hl,0xe
	ld	(ix-30),hl
;2279         getsockname(sock, &addr, &len);
	.debug	# 2279
	ld	hl,-30+@646
	add	hl,sp
	push	hl
	ld	hl,-26+@646
	add	hl,sp
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$getsockname
	add	sp,6
;2280         si->ourPort = addr.s_port;
	.debug	# 2280
	ld	hl,(ix-6)
	ld	de,0x5
	add	hl,de
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2281         si->ourAddr = addr.s_ip;
	.debug	# 2281
	ld	hl,(ix-6)
	ld	de,0x7
	add	hl,de
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2282         si->conState = SS_CONNECTED;
	.debug	# 2282
	ld	hl,(ix-6)
	ld	de,0xc
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2283         KUNLOCK();  return 0;
	.debug	# 2283
	call	_KUNLOCK
	bool	hl
	ld	l,h
	jp	@647
;2284       }
@677:
	.debug	>
;2285 
;2286       if (msSince(si->startTime) < ConnectTimeout)  {
@675:
	.debug	# 2286
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-6)
	push	bc
	push	de
	ld	de,0xe
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@678
;2287         KUNLOCK();  sleepMS(10);  KLOCK();  continue;  }
@679:
	.debug	< @679 @680
	.debug	# 2287
	call	_KUNLOCK
	ld	de,0xa
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
	jp	@670
@680:
	.debug	>
;2288 
;2289       KUNLOCK();  errno = ETIMEDOUT;  return -1;
@678:
	.debug	# 2289
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6e
@855:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@853
;2290     }
@673:
	.debug	>
;2291 
;2292     errno = (si->rdOK AND si->wrOK) ? EALREADY : ECONNREFUSED;
@671:
	.debug	# 2292
	ld	hl,(ix-6)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@682
	ld	hl,(ix-6)
	inc	e
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@682
	ld	hl,0x72
	jr	@683
@682:
	ld	hl,0x6f
@683:
	ld	de,(_current)
	ld	bc,hl
	ld	hl,0xb9
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2293     KUNLOCK();  return -1;
	.debug	# 2293
@854:
	call	_KUNLOCK
@853:
	ld	hl,0xffff
	jr	@647
;2294   }
@659:
	.debug	>
;2295 
;2296   KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;  // unsupported type
@657:
	.debug	# 2296
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2297 }
@647:
	.debug	} @647 2297

@646	equ	110
	ld	sp,ix
	pop	ix
	lret
@648	equ	112
;2298 
;2299 
;2300 //-------------------------------------------------------------------------
;2301 //  Read a msg from a socket
;2302 //-------------------------------------------------------------------------
;2303 int recvfrom(fd_t sockfd, void far *buf, int numBytes, int flags,
;2304              struct sockaddr *fromAddr, int *addrLen)
;2305 {
$recvfrom::
	.debug	G $recvfrom 105 9
	.debug	{ $recvfrom 105 2303 @686 @685
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-19
	.debug	A sockfd 5 6
	.debug	A buf 7 106
	.debug	A numBytes 11 6
	.debug	A flags 13 6
	.debug	A fromAddr 15 99
	.debug	A addrLen 17 103
;2306   int  stat, idx;
	.debug	L stat -2 6
	.debug	L idx -4 6
;2307   longword  fromIP;
	.debug	L fromIP -8 9
;2308   word  fromPort;
	.debug	L fromPort -10 5
;2309   SockInfo  *si;
	.debug	L si -12 39
;2310   sock_type  *sock;
	.debug	L sock -14 41
;2311   FDEV  far *file;
	.debug	L file -18 69
;2312   bool  returnFromAddr;
	.debug	L returnFromAddr -19 3
;2313 
;2314 
;2315 //finish: Implement values in "flags"
;2316 
;2317 //finish: Need to handle blocking mode.  NOTE: Blocking and non-blocking
;2318 //        mode is normally handled in the fcntl layer/module, but this func
;2319 //        only applies to sockets, so probably should be done in the driver
;2320 
;2321 #define FromAddr  ((struct sockaddr_in *)fromAddr)
;2322 
;2323 
;2324   KLOCK();
	.debug	# 2324
	call	_KLOCK
;2325 
;2326   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK();  return -1; }
	.debug	# 2326
	ld	hl,-18+@684
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-12),hl
	bool	hl
	jp	z,@729
@688:
	.debug	< @688 @689
@689:
	.debug	>
;2327 
;2328   if (! (sock = si->sock))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 2328
	ld	hl,(ix-12)
	ld	hl,(hl)
	ld	(ix-14),hl
	bool	hl
	jr	nz,@690
@691:
	.debug	< @691 @692
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@850
@692:
	.debug	>
;2329 
;2330 
;2331   si->diagFlags = current->diagFlags;
@690:
	.debug	# 2331
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-12)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2332 
;2333   returnFromAddr = (FromAddr AND (*addrLen >= sizeof(struct sockaddr)));
	.debug	# 2333
	ld	hl,(ix+15)
	bool	hl
	jr	z,@694
	ld	hl,(ix+17)
	ld	hl,(hl)
	ld	de,0x800e
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@694
	ld	hl,1
	jr	@695
@694:
	bool	hl
	ld	l,h
@695:
	ld	(ix-19),l
;2334 
;2335   switch (si->type)  {
	.debug	# 2335
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	jp	@696
;2336     case SOCK_STREAM:
@698:
	.debug	< @698 @699
;2337       stat = sock_xfastread((tcp_Socket *)sock, (ulong)buf, numBytes);
	.debug	# 2337
@700:
	ld	hl,(ix+11)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	push	hl
	lcall	$sock_xfastread
	add	sp,10
	ld	(ix-2),hl
;2338       idx = TCP_SI_Idx(si);
	.debug	# 2338
	ld	hl,(ix-12)
	ld	de,_tcpSockets
	jp	@852
;2339       break;
	.debug	# 2339
;2340 
;2341     case SOCK_DGRAM:
;2342       if (! si->opened)  {
	.debug	# 2342
@701:
	ld	hl,(ix-12)
	ld	de,0x17
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@702
;2343 //        printf("recvfrom() udp open: lport: %d, remIP: -1, remPort: 0\r\n
;2344         if (! udp_open((udp_Socket *)sock, si->ourPort, -1, 0, NULL))  {
@703:
	.debug	< @703 @704
	.debug	# 2344
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-12)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-14)
	push	hl
	lcall	$udp_open
	add	sp,12
	bool	hl
	jr	nz,@705
;2345           KUNLOCK();  errno = EINVAL;  return -1; }  // == 0 means failed
@706:
	.debug	< @706 @707
	.debug	# 2345
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@850
@707:
	.debug	>
;2346         si->opened = true;
@705:
	.debug	# 2346
	ld	hl,(ix-12)
	ld	de,0x17
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2347       }
@704:
	.debug	>
;2348       if (returnFromAddr)
@702:
	.debug	# 2348
	ld	a,(ix-19)
	or	a,a
	jr	z,@708
;2349         stat = udp_recvfrom((udp_Socket *)sock, buf, numBytes,
;2350                             &fromIP, &fromPort);
	.debug	# 2350
	ld	hl,-10+@684
	add	hl,sp
	push	hl
	ld	hl,-6+@684
	add	hl,sp
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	push	hl
	lcall	$udp_recvfrom
	add	sp,12
	ld	(ix-2),hl
;2351       else
;2352         stat = udp_recv((udp_Socket *)sock, buf, numBytes);
	jr	@709
@708:
	.debug	# 2352
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	push	hl
	lcall	$udp_recvfrom
	add	sp,12
	ld	(ix-2),hl
;2353       if (stat == -1) {  // no datagram, possibly an error
@709:
	.debug	# 2353
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@710
;2354         if (! si->rdOK)  errno = EPIPE;  else  errno = EAGAIN;
@711:
	.debug	< @711 @712
	.debug	# 2354
	ld	hl,(ix-12)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@713
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x20
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@714
@713:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2355         KUNLOCK();  return -1;
@714:
	.debug	# 2355
	jp	@729
;2356       }
@712:
	.debug	>
;2357       idx = UDP_SI_Idx(si);
@710:
	.debug	# 2357
	ld	hl,(ix-12)
	ld	de,_udpSockets
@852:
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;2358       break;
	.debug	# 2358
;2359 
;2360     default:
	jr	@697
;2361       KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;  // unsupported type
	.debug	# 2361
@715:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	jp	@850
;2362   }
@699:
	.debug	>
;2363 
;2364   if (stat > 0)  {  // got some data
@696:
	cp	0x1
	jp	z,@701
	cp	0x2
	jp	z,@700
	jr	@715
@697:
	.debug	# 2364
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@716
	jp	z,@716
;2365     if (returnFromAddr)  {
@717:
	.debug	< @717 @718
	.debug	# 2365
	ld	a,(ix-19)
	or	a,a
	jp	z,@719
;2366       FromAddr->sin_family = AF_INET;
@720:
	.debug	< @720 @721
	.debug	# 2366
	ld	hl,(ix+15)
	ld	de,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2367       FromAddr->sin_port   = htons(fromPort);
	.debug	# 2367
	ld	hl,(ix-10)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix+15)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2368       FromAddr->sin_addr   = htonl(fromIP);
	.debug	# 2368
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix+15)
	push	de
	ld	de,0x4
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2369       *addrLen = sizeof(struct sockaddr);
	.debug	# 2369
	ld	hl,0xe
	ex	de,hl
	ld	hl,(ix+17)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2370     }
@721:
	.debug	>
;2371     file->readCount += stat;
@719:
	.debug	# 2371
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld4##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	call	__ladd##
	call	__farst4d##
;2372     KUNLOCK();  return stat;
	.debug	# 2372
	call	_KUNLOCK
	ld	hl,(ix-2)
	jp	@685
;2373   }
@718:
	.debug	>
;2374 
;2375   if (stat < 0)  {  // error
@716:
	.debug	# 2375
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@722
;2376     if (! si->rdOK)  {
@723:
	.debug	< @723 @724
	.debug	# 2376
	ld	hl,(ix-12)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@725
;2377       if (ShowSocketEvents)
@726:
	.debug	< @726 @727
	.debug	# 2377
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@728
;2378         fprintf(DiagLog, "socket (%04X)[%d]: read from closed socket ...\n"
;2379                  (uint)si, idx );
	.debug	# 2379
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	de,word (phys @2+1602)
	ld	c,phys @2+1602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;2380       errno = EBADF;
@728:
	.debug	# 2380
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2381     }
@727:
	.debug	>
;2382     else
;2383       errno = EPIPE;
	jr	@729
@725:
	.debug	# 2383
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2384     KUNLOCK();  return -1;
@729:
	.debug	# 2384
	call	_KUNLOCK
	jr	@851
;2385   }
@724:
	.debug	>
;2386 
;2387   if (stat == 0)  if (! si->rdOK)  {
@722:
	.debug	# 2387
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@730
	ld	hl,(ix-12)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@731
;2388     if (ShowSocketEvents)
@732:
	.debug	< @732 @733
	.debug	# 2388
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@734
;2389       fprintf(DiagLog, "socket (%04X)[%d]: read from closed socket ...\n",
;2390             (uint)si, idx );
	.debug	# 2390
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	de,word (phys @2+1602)
	ld	c,phys @2+1602 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;2391     KUNLOCK();  errno = EPIPE;  return -1;
@734:
	.debug	# 2391
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jr	@850
;2392   }
@733:
	.debug	>
;2393 
;2394 
;2395 //--- For network lib funcs that don't return an error even after the ---
;2396 //--- network goes down (?!?!?!?) ---
;2397   if (linkWentDown)  { KUNLOCK();  errno = ENETDOWN;  return -1; }
@731:
@730:
	.debug	# 2397
	ld	a,(_linkWentDown)
	or	a,a
	jr	z,@735
@736:
	.debug	< @736 @737
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x64
@850:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@851:
	ld	hl,0xffff
	jr	@685
@737:
	.debug	>
;2398 
;2399 //--- no error - but no new data to read ---
;2400   KUNLOCK();  errno = EAGAIN;  return -1;
@735:
	.debug	# 2400
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2401 }
@685:
	.debug	} @685 2401

@684	equ	19
	ld	sp,ix
	pop	ix
	lret
@686	equ	21
;2402 
;2403 
;2404 //-------------------------------------------------------------------------
;2405 //  Read a msg from a socket
;2406 //-------------------------------------------------------------------------
;2407 int recv(fd_t sockfd, void far *buf, int numBytes, int flags)
;2408 {
$recv::
	.debug	G $recv 107 9
	.debug	{ $recv 107 2407 @740 @739
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A sockfd 5 6
	.debug	A buf 7 106
	.debug	A numBytes 11 6
	.debug	A flags 13 6
;2409   int  addrLen;
	.debug	L addrLen -2 6
;2410 
;2411   return recvfrom(sockfd, buf, numBytes, flags, NULL, &addrLen);
	.debug	# 2411
	ld	hl,-2+@738
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$recvfrom
	add	sp,14
;2412 }
@739:
	.debug	} @739 2412

@738	equ	2
	ld	sp,ix
	pop	ix
	lret
@740	equ	4
;2413 
;2414 
;2415 //-------------------------------------------------------------------------
;2416 //  Write a msg to a socket
;2417 //-------------------------------------------------------------------------
;2418 int sendto(fd_t sockfd, const void far *buf, int numBytes, int flags,
;2419            const struct sockaddr *toAddr, int addrLen)
;2420 {
$sendto::
	.debug	G $sendto 108 9
	.debug	{ $sendto 108 2418 @743 @742
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-24
	.debug	A sockfd 5 6
	.debug	A buf 7 106
	.debug	A numBytes 11 6
	.debug	A flags 13 6
	.debug	A toAddr 15 99
	.debug	A addrLen 17 6
;2421   int  stat, idx;
	.debug	L stat -2 6
	.debug	L idx -4 6
;2422   longword  remIP, saveIP;
	.debug	L remIP -8 9
	.debug	L saveIP -12 9
;2423   word  remPort;
	.debug	L remPort -14 5
;2424   bool  addrGiven, nonBlocking;
	.debug	L addrGiven -15 3
	.debug	L nonBlocking -16 3
;2425   SockInfo  *si;
	.debug	L si -18 39
;2426   sock_type  *sock;
	.debug	L sock -20 41
;2427   FDEV  far *file;
	.debug	L file -24 69
;2428 
;2429 
;2430 //finish: Implement values in "flags"
;2431 
;2432 //finish: Need to handle blocking mode.  NOTE: Blocking and non-blocking
;2433 //        mode is normally handled in the fcntl layer/module, but this func
;2434 //        only applies to sockets, so probably should be done in the driver
;2435 
;2436 
;2437 #define ToAddr  ((struct sockaddr_in *)toAddr)
;2438 
;2439   if (ShowRWCalls)
	.debug	# 2439
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@744
;2440     fprintf(DiagLog, "sendto(%d, 0x%05lX, %d, %04X, 0x%04X, %d)\r\n",
;2441             sockfd, (ulong)buf, numBytes, flags, (uint)toAddr, addrLen);
	.debug	# 2441
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @2+1910)
	ld	c,phys @2+1910 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,20
;2442 
;2443   if (numBytes <= 0)  return 0;
@744:
	.debug	# 2443
	ld	hl,(ix+11)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@746
	jr	nc,@745
@746:
	bool	hl
	ld	l,h
	jp	@742
;2444 
;2445   if (!buf)  { errno = EINVAL;  return -1; }
@745:
	.debug	# 2445
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@747
@748:
	.debug	< @748 @749
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jp	@849
@749:
	.debug	>
;2446 
;2447   KLOCK();
@747:
	.debug	# 2447
	call	_KLOCK
;2448 
;2449   if (! (si = _fdSocket_(sockfd, &file)))  { KUNLOCK(); return -1; }
	.debug	# 2449
	ld	hl,-24+@741
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-18),hl
	bool	hl
	jp	z,@803
@751:
	.debug	< @751 @752
@752:
	.debug	>
;2450 
;2451   if (! (sock = si->sock))  { KUNLOCK();  errno = EBADF;  return -1; }
	.debug	# 2451
	ld	hl,(ix-18)
	ld	hl,(hl)
	ld	(ix-20),hl
	bool	hl
	jr	nz,@753
@754:
	.debug	< @754 @755
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@848
@755:
	.debug	>
;2452 
;2453 
;2454   nonBlocking = file->flags & O_NONBLOCK;
@753:
	.debug	# 2454
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x20
	and	hl,de
	ld	(ix-16),l
;2455   addrGiven = (ToAddr AND (addrLen > 0));
	.debug	# 2455
	ld	hl,(ix+15)
	bool	hl
	jr	z,@757
	ld	hl,(ix+17)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@757
	jr	z,@757
	ld	hl,1
	jr	@758
@757:
	bool	hl
	ld	l,h
@758:
	ld	(ix-15),l
;2456 
;2457   si->diagFlags = current->diagFlags;
	.debug	# 2457
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-18)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2458 
;2459 
;2460   switch (si->type)  {
	.debug	# 2460
	ld	hl,(ix-18)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	jp	@759
;2461 
;2462     case SOCK_STREAM:
@761:
	.debug	< @761 @762
;2463       if (si->conState != SS_CONNECTED)  {
	.debug	# 2463
@763:
	ld	hl,(ix-18)
	ld	de,0xc
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jr	z,@764
;2464         KUNLOCK();  errno = ENOTCONN;  return -1; }
@765:
	.debug	< @765 @766
	.debug	# 2464
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6b
	jp	@848
@766:
	.debug	>
;2465       if (addrGiven)  { KUNLOCK();  errno = EISCONN;  return -1; }
@764:
	.debug	# 2465
	ld	a,(ix-15)
	or	a,a
	jr	z,@767
@768:
	.debug	< @768 @769
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6a
	jp	@848
@769:
	.debug	>
;2466 //      if (sock_tbleft((tcp_Socket *)sock) < 128)  tcp_tick(NULL);  //test
;2467       stat = sock_xfastwrite((tcp_Socket *)sock, (ulong)buf, numBytes);
@767:
	.debug	# 2467
	ld	hl,(ix+11)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-20)
	push	hl
	lcall	$sock_xfastwrite
	add	sp,10
	ld	(ix-2),hl
;2468 //      if (sock_tbleft((tcp_Socket *)sock) < 128)  tcp_tick(NULL);  //test
;2469       idx = TCP_SI_Idx(si);
	.debug	# 2469
	ld	hl,(ix-18)
	ld	de,_tcpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;2470       break;
	.debug	# 2470
;2471 
;2472 
;2473     case SOCK_DGRAM:
	jp	@760
;2474       remIP = -1;  remPort = -1;  idx = UDP_SI_Idx(si);
	.debug	# 2474
@770:
	ld	de,0xffff
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-14),hl
	ld	hl,(ix-18)
	ld	de,_udpSockets
	or	a,a
	sbc	hl,de
	ld	de,0x2a
	call	__idiv##
	ld	(ix-4),hl
;2475       if (addrGiven)  {
	.debug	# 2475
	ld	a,(ix-15)
	or	a,a
	jp	z,@771
;2476         remIP = ntohl(ToAddr->sin_addr);  remPort = ntohs(ToAddr->sin_port)
@772:
	.debug	< @772 @773
	.debug	# 2476
	ld	hl,(ix+15)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix+15)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-14),hl
@773:
	.debug	>
;2477       else  {
	jr	@774
@771:
;2478         remIP = 0;  remPort = 0;  }
@775:
	.debug	< @775 @776
	.debug	# 2478
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-14),hl
@776:
	.debug	>
;2479       if (! si->opened)  {
@774:
	.debug	# 2479
	ld	hl,(ix-18)
	ld	de,0x17
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	nz,@777
;2480         if (!si->bcastMode AND !addrGiven)  {
@778:
	.debug	< @778 @779
	.debug	# 2480
	ld	hl,(ix-18)
	dec	e
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@781
	ld	a,(ix-15)
	or	a,a
	jr	nz,@781
;2481           KUNLOCK();  errno = EDESTADDRREQ;  return -1; }
@782:
	.debug	< @782 @783
	.debug	# 2481
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x59
	jp	@848
@783:
	.debug	>
;2482 //      printf("sendto() udp open: lport: %d, remIP: 0x%08lx, remPort: %d\r
;2483 //              si->ourPort, remIP, remPort);  //tdebug
;2484         if (si->bcastMode)  { saveIP = remIP;  remIP = -1; }
@781:
	.debug	# 2484
	ld	hl,(ix-18)
	ld	de,0x16
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@784
@785:
	.debug	< @785 @786
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	de,0xffff
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@786:
	.debug	>
;2485         if (udp_open((udp_Socket *)sock, si->ourPort, remIP, remPort, NULL)
@784:
;2486           == 0)  { KUNLOCK();  errno = EINVAL;  return -1; }  // == 0 means
	.debug	# 2486
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ld	de,0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-20)
	push	hl
	lcall	$udp_open
	add	sp,12
	bool	hl
	jr	nz,@787
@788:
	.debug	< @788 @789
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@849:
	ld	e,0x16
	jp	@848
@789:
	.debug	>
;2487         if (si->bcastMode)  remIP = saveIP;
@787:
	.debug	# 2487
	ld	hl,(ix-18)
	ld	de,0x16
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@790
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2488         si->opened = true;
@790:
	.debug	# 2488
	ld	hl,(ix-18)
	ld	de,0x17
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2489       }
@779:
	.debug	>
;2490       stat = udp_xsendto( (udp_Socket *)sock, (ulong)buf, numBytes,
@777:
;2491                          remIP, remPort );
	.debug	# 2491
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-20)
	push	hl
	lcall	$udp_xsendto
	add	sp,14
	ld	(ix-2),hl
;2492       break;
	.debug	# 2492
;2493 
;2494 
;2495     default:
	jr	@760
;2496       KUNLOCK();  errno = ESOCKTNOSUPPORT;  return -1;  // unsupported type
	.debug	# 2496
@791:
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5e
	jp	@848
;2497   }
@762:
	.debug	>
;2498 
;2499 
;2500 //--- if any successfully buffered, then return the # ---
;2501   if (stat > 0)  {
@759:
	cp	0x1
	jp	z,@770
	cp	0x2
	jp	z,@763
	jr	@791
@760:
	.debug	# 2501
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@792
	jr	z,@792
;2502     file->writeCount += stat;  KUNLOCK();
@793:
	.debug	< @793 @794
	.debug	# 2502
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x19
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld4##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	call	__ladd##
	call	__farst4d##
	call	_KUNLOCK
;2503     if (ShowRWCalls)  fprintf(DiagLog, "  sendto returned: %d\n", stat);
	.debug	# 2503
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x2000
	and	hl,de
	jr	z,@795
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @2+1954)
	ld	c,phys @2+1954 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;2504     return stat;
@795:
	.debug	# 2504
	ld	hl,(ix-2)
	jp	@742
;2505   }
@794:
	.debug	>
;2506 
;2507   if (stat < 0)  {
@792:
	.debug	# 2507
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@796
;2508     if (! si->wrOK)  {
@797:
	.debug	< @797 @798
	.debug	# 2508
	ld	hl,(ix-18)
	ld	de,0x13
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@799
;2509       if (ShowSocketEvents)
@800:
	.debug	< @800 @801
	.debug	# 2509
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x200
	and	hl,de
	jr	z,@802
;2510         fprintf(DiagLog, "socket (%04X)[%d]: write to a closed socket ...\n
;2511                 (uint)si, idx );
	.debug	# 2511
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	de,word (phys @2+1977)
	ld	c,phys @2+1977 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;2512       errno = EBADF;
@802:
	.debug	# 2512
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2513     }
@801:
	.debug	>
;2514     else
;2515       errno = EINVAL;
	jr	@803
@799:
	.debug	# 2515
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2516     KUNLOCK();  return -1;
@803:
	.debug	# 2516
	call	_KUNLOCK
	jr	@847
;2517   }
@798:
	.debug	>
;2518 
;2519 
;2520 //--- For network lib funcs that don't return an error even after the ---
;2521 //--- network goes down (?!?!?!?) ---
;2522   if (linkWentDown)  { KUNLOCK();  errno = ENETDOWN;  return -1; }
@796:
	.debug	# 2522
	ld	a,(_linkWentDown)
	or	a,a
	jr	z,@804
@805:
	.debug	< @805 @806
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x64
@848:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@847:
	ld	hl,0xffff
	jr	@742
@806:
	.debug	>
;2523 
;2524 //--- No other error, so output buffer must be full ---
;2525   KUNLOCK();  errno = EAGAIN;  return -1;
@804:
	.debug	# 2525
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2526 }
@742:
	.debug	} @742 2526

@741	equ	24
	ld	sp,ix
	pop	ix
	lret
@743	equ	26
;2527 
;2528 
;2529 //-------------------------------------------------------------------------
;2530 //  Write a msg to a socket
;2531 //-------------------------------------------------------------------------
;2532 int send(fd_t sockfd, const void far *buf, int numBytes, int flags)
;2533 {
$send::
	.debug	G $send 107 9
	.debug	{ $send 107 2532 @809 @808
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A sockfd 5 6
	.debug	A buf 7 106
	.debug	A numBytes 11 6
	.debug	A flags 13 6
;2534   return sendto(sockfd, buf, numBytes, flags, NULL, 0);
	.debug	# 2534
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sendto
	add	sp,14
;2535 }
@808:
	.debug	} @808 2535

@807	equ	0
	pop	ix
	lret
@809	equ	2
;2536 
;2537 
;2538 
;2539 //-------------------------------------------------------------------------
;2540 //  set options on a socket fd
;2541 //-------------------------------------------------------------------------
;2542 int setsockopt(int sockfd, int level, int opt,
;2543                const void *val, socklen_t valLen)
;2544 {
$setsockopt::
	.debug	G $setsockopt 109 9
	.debug	{ $setsockopt 109 2542 @812 @811
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A sockfd 5 6
	.debug	A level 7 6
	.debug	A opt 9 6
	.debug	A val 11 50
	.debug	A valLen 13 6
;2545   SockInfo  *si;
	.debug	L si -2 39
;2546   FDEV  far *file;
	.debug	L file -6 69
;2547 
;2548 
;2549   if (level != SOL_SOCKET)  { errno = ENOPROTOOPT;  return -1; }
	.debug	# 2549
	ld	hl,(ix+7)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@813
@814:
	.debug	< @814 @815
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x5c
	jr	@846
@815:
	.debug	>
;2550 
;2551   if (! (si = _fdSocket_(sockfd, &file)))  return -1;
@813:
	.debug	# 2551
	ld	hl,-6+@810
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-2),hl
	bool	hl
	jr	z,@845
;2552 
;2553   if (!val)  return -1;
	.debug	# 2553
	ld	hl,(ix+11)
	bool	hl
	jr	z,@845
;2554 
;2555   si->diagFlags = current->diagFlags;
	.debug	# 2555
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2556 
;2557   if (opt == SO_BROADCAST)  {
	.debug	# 2557
	ld	hl,(ix+9)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nz,@818
;2558     if (valLen != sizeof(int))  { errno = EINVAL;  return -1; }
@819:
	.debug	< @819 @820
	.debug	# 2558
	ld	hl,(ix+13)
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jr	z,@821
@822:
	.debug	< @822 @823
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x16
@846:
	ld	(hl),e
	inc	hl
	ld	(hl),d
@845:
	ld	hl,0xffff
	jr	@811
@823:
	.debug	>
;2559     si->bcastMode = BOOL(*((int *)val)) ? true : false;
@821:
	.debug	# 2559
	ld	hl,(ix+11)
	ld	hl,(hl)
	bool	hl
	jr	z,@824
	ld	a,0x1
	jr	@825
@824:
	xor	a,a
@825:
	or	a,a
	jr	z,@826
	ld	a,0x1
	jr	@827
@826:
	xor	a,a
@827:
	ld	hl,(ix-2)
	ld	de,0x16
	add	hl,de
	ld	(hl),a
;2560     return 0;
	.debug	# 2560
	bool	hl
	ld	l,h
	jr	@811
;2561   }
@820:
	.debug	>
;2562 
;2563 //finish:  Add support for other opt values such as SO_RCVTIMEO, which sets
;2564 //         timeout for calls to readv(), rcv(), recvfrom(), recvmsg()
;2565 //         (but what about read()?  And does it apply only to socket fd's
;2566 //         that are not set to non-blocking mode?)
;2567 
;2568   errno = ENOPROTOOPT;  return -1;
@818:
	.debug	# 2568
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2569 }
@811:
	.debug	} @811 2569

@810	equ	6
	ld	sp,ix
	pop	ix
	lret
@812	equ	8
;2570 
;2571 //-------------------------------------------------------------------------
;2572 //  get value of an option on a socket fd
;2573 //-------------------------------------------------------------------------
;2574 int getsockopt(int sockfd, int level, int opt,
;2575                void *val, socklen_t *valLen)
;2576 {
$getsockopt::
	.debug	G $getsockopt 110 9
	.debug	{ $getsockopt 110 2574 @830 @829
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A sockfd 5 6
	.debug	A level 7 6
	.debug	A opt 9 6
	.debug	A val 11 50
	.debug	A valLen 13 103
;2577   SockInfo  *si;
	.debug	L si -2 39
;2578   FDEV  far *file;
	.debug	L file -6 69
;2579 
;2580 
;2581   if (level != SOL_SOCKET)  { errno = ENOPROTOOPT;  return -1; }
	.debug	# 2581
	ld	hl,(ix+7)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@831
@832:
	.debug	< @832 @833
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x5c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@835
@833:
	.debug	>
;2582 
;2583   if (! (si = _fdSocket_(sockfd, &file)))  return -1;
@831:
	.debug	# 2583
	ld	hl,-6+@828
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_fdSocket_
	add	sp,4
	ld	(ix-2),hl
	bool	hl
	jr	z,@835
;2584 
;2585   if (!val OR !valLen)  return -1;
	.debug	# 2585
	ld	hl,(ix+11)
	bool	hl
	jr	z,@835
	ld	hl,(ix+13)
	bool	hl
	jr	nz,@836
@835:
	ld	hl,0xffff
	jr	@829
;2586 
;2587   si->diagFlags = current->diagFlags;
@836:
	.debug	# 2587
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	push	de
	ld	de,0x18
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2588 
;2589   if (opt == SO_BROADCAST)  {
	.debug	# 2589
	ld	hl,(ix+9)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nz,@837
;2590     if (*valLen >= sizeof(int))  {
@838:
	.debug	< @838 @839
	.debug	# 2590
	ld	hl,(ix+13)
	ld	hl,(hl)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@840
;2591       (*(int *)val) = si->bcastMode ? 1 : 0;  *valLen = sizeof(int);  }
@841:
	.debug	< @841 @842
	.debug	# 2591
	ld	hl,(ix-2)
	ld	de,0x16
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@843
	ld	hl,0x1
	jr	@844
@843:
	bool	hl
	ld	l,h
@844:
	ex	de,hl
	ld	hl,(ix+11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x2
	ex	de,hl
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@842:
	.debug	>
;2592     return 0;
@840:
	.debug	# 2592
	bool	hl
	ld	l,h
	jr	@829
;2593   }
@839:
	.debug	>
;2594 
;2595   errno = ENOPROTOOPT;  return -1;
@837:
	.debug	# 2595
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;2596 }
@829:
	.debug	} @829 2596

@828	equ	6
	ld	sp,ix
	pop	ix
	lret
@830	equ	8
;2597 
;2598 //-------------------------------------------------------------------------
;2599 
	.extern	_memset 111
	.extern	_strcat 112
	.extern	_strcmp 79
	.extern	_strcpy 112
	.extern	_strlen 78
	.extern	$ValidatePtr 113
	.extern	$inet_htop 114
	.extern	$init_waitqueue_head 115
	.extern	$wakeTasks 115
	.extern	$wqListTasks 115
	.extern	__disabled 3
	.extern	_current 116
	.extern	_kernelTask 116
	.extern	$farfprintf 118
	.extern	$farprintf 119
	.extern	$farsprintf 120
	.extern	__TimerMilliSeconds 121
	.extern	$registerFileSys 122
	.extern	$_allocFile_ 123
	.extern	$_FileFromFD_ 124
	.extern	$_File_Swap_ 125
	.extern	$fcntl 97
	.extern	$klockErr 126
	.extern	_KLOCK 66
	.extern	_KUNLOCK 66
	.extern	_hostName 127
	.extern	_doShutdown 3
	.extern	_diagLog 128
	.extern	$sleepMS 129
	.extern	$SetHostName 130
	.extern	$sock_error 131
	.extern	__if_tab 132
	.extern	$sock_rbused 92
	.extern	$sock_tbleft 92
	.extern	$ifpending 56
	.extern	$ifdown 56
	.extern	$ifconfig 134
	.extern	$sock_alive 92
	.extern	$sock_abort 135
	.extern	$sock_close 135
	.extern	$inet_ntoa 136
	.extern	__arp_data 137
	.extern	__arp_gate_data 138
	.extern	$udp_open 139
	.extern	$udp_sendto 140
	.extern	$udp_xsendto 141
	.extern	$udp_recvfrom 142
	.bseg
_tcp_reserveports::
	.ds	12
	.debug	G _tcp_reserveports 143 0
	.extern	$sockstate 144
	.extern	$tcp_open 145
	.extern	$tcp_listen 146
	.extern	$tcp_tick 92
	.extern	$tcp_reserveport 147
	.extern	$tcp_clearreserve 147
	.extern	$sock_fastread 148
	.extern	$sock_xfastread 149
	.extern	$sock_fastwrite 148
	.extern	$sock_xfastwrite 149
	.extern	$sock_flush 150
	.extern	$sock_established 92
	.extern	$getsockname 151
	.cseg
_pd_havelink:
	pop	iy
	lcall	$$pd_havelink
	.extern	$$pd_havelink
	.extern	$pd_havelink 56
	.extern	_netmask 9
	.extern	_gateway 9
	.bseg
_tcpSockets::
	.ds	756
	.debug	G _tcpSockets 152 0
_udpSockets::
	.ds	168
	.debug	G _udpSockets 153 0
	.extern	$readIPAddr 154
	.extern	$writeIPAddr 155
	.extern	$resetAnnounceInterval 66
_tcpSockDef::
	.ds	2040
	.debug	G _tcpSockDef 156 0
_udpSockDef::
	.ds	176
	.debug	G _udpSockDef 157 0
	.cseg
__socketRead_:
	pop	iy
	lcall	$$_socketRead_
__socketWrite_:
	pop	iy
	lcall	$$_socketWrite_
__socketClose_:
	pop	iy
	lcall	$$_socketClose_
__socketLseek_:
	pop	iy
	lcall	$$_socketLseek_
__socketFstat_:
	pop	iy
	lcall	$$_socketFstat_
__socketioctl_:
	pop	iy
	lcall	$$_socketioctl_
__socketDescr_:
	pop	iy
	lcall	$$_socketDescr_
__socketGetQueues_:
	pop	iy
	lcall	$$_socketGetQueues_
__socketTick_:
	pop	iy
	lcall	$$_socketTick_
__socketEntry_:
	pop	iy
	lcall	$$_socketEntry_
__socketOpen_:
	pop	iy
	lcall	$$_socketOpen_
__socketUnlink_:
	pop	iy
	lcall	$$_socketUnlink_
__socketRename_:
	pop	iy
	lcall	$$_socketRename_
	.bseg
_skipTicks::
	.ds	1
	.debug	G _skipTicks 3 0
_netReady::
	.ds	1
	.debug	G _netReady 3 0
_linkWentDown::
	.ds	1
	.debug	G _linkWentDown 3 0
_netGoingDown::
	.ds	1
	.debug	G _netGoingDown 3 0
_closingSockets::
	.ds	1
	.debug	G _closingSockets 3 0
_startedDownMS::
	.ds	4
	.debug	G _startedDownMS 9 0
_linkDownMS::
	.ds	4
	.debug	G _linkDownMS 9 0
	.cseg
_tcpSockEvent_:
	pop	iy
	lcall	$$tcpSockEvent_
	.debug	T	64000320001000080001009F0000000572656164009F0002000677
	.debug	T	7269746500A000040006636C6F736500A1000600066C736565
	.debug	T	6B00A200080006667374617400A3000A0006696F63746C00A4
	.debug	T	000C0006646573637200A5000E000A67657451756575657300
	.debug	T	57000321000E000700010040000000056E616D6500A60002000869
	.debug	T	6F46756E637300A7000400057469636B00A800060006656E74
	.debug	T	727900A9000800056F70656E00AA000A0007756E6C696E6B00
	.debug	T	AB000C000772656E616D6500
	.debug	T	0900012200980023002600
	.debug	T	070008230004000300
	.debug	T	09000124002C0023000B00
	.debug	T	0B000225000100230007000000
	.debug	T	0F00022600020001002700000029000200
	.debug	T	070000270002002800
	.debug	T	06010328002A00130001002900000005736F636B00030002000669
	.debug	T	6E55736500030003000B6E6F46444556726566730003000400
	.debug	T	05747970650006000500086F7572506F72740009000700086F
	.debug	T	7572416464720003000B00096C697374656E65720004000C00
	.debug	T	09636F6E53746174650009000E000A737461727454696D6500
	.debug	T	030012000572644F4B00030013000577724F4B00040014000B
	.debug	T	636C6F7365537461746500030016000A62636173744D6F6465
	.debug	T	0003001700076F70656E656400090018000A64696167466C61
	.debug	T	67730009001C000B6C617374436C6F73656400AC0020000A72
	.debug	T	656164517565756500AC0024000B7772697465517565756500
	.debug	T	32002800076D794164647200
	.debug	T	070000290002002A00
	.debug	T	1B00042A00AA00020001009E00000004756470002E000000047463
	.debug	T	7000
	.debug	T	0B00022B00010007002C000000
	.debug	T	0700002C0002000700
	.debug	T	0700002D0002002E00
	.debug	T	FF02032E00AA0038000C5F7463705F736F636B6574002D00000005
	.debug	T	6E65787400030002000869705F747970650005000300086572
	.debug	T	725F6D736700060005000573617468000300070004746F7300
	.debug	T	030008000474746C00AD0009000A7573725F7969656C640003
	.debug	T	000B000672696769640003000C00077374726573730005000D
	.debug	T	000A736F636B5F6D6F64650009000F000A7573657274696D65
	.debug	T	7200AE0013000C6461746148616E646C657200090015000868
	.debug	T	697361646472000500190008686973706F72740005001B0007
	.debug	T	6D79706F72740005001D00096C6F63666C6167730003001F00
	.debug	T	06696661636500B00020000372640005002A00067374617465
	.debug	T	0009002C000761636B6E756D0009003000077365716E756D00
	.debug	T	080034000874696D656F757400050038000777696E646F7700
	.debug	T	06003A000A61647677696E646F7700B0003C00037772000500
	.debug	T	460008756E61636B65640005004800086672756E61636B0005
	.debug	T	004A0008737461727470740005004C000563776E640005004E
	.debug	T	00097373746872657368000900500006766A5F736100090054
	.debug	T	0006766A5F7364000900580008766A5F6C6173740009005C00
	.debug	T	07766A5F73657100090060000472746F000900640009727474
	.debug	T	5F74696D650005006800076B666C6167730004006A00096163
	.debug	T	6B64757063740005006C00046D73730009006E000C696E6163
	.debug	T	746976655F746F00090072000A6461746174696D6572000900
	.debug	T	76000A6F6F6F7373746172740009007A00086F6F6F73656E64
	.debug	T	0003007E00127265736572766564706F72745F666C61670009
	.debug	T	007F000F6B656570616C6976655F74696D650009008300126B
	.debug	T	656570616C6976655F74696D656F75740003008700106B6565
	.debug	T	70616C6976655F737461746500320088000A757365725F6461
	.debug	T	74610009008A0008727462797465730009008E000B72747365
	.debug	T	676D656E74730009009200087478627974657300090096000B
	.debug	T	74787365676D656E74730009009A000974696D656F75747300
	.debug	T	09009E000A73656E64736F6F6E73000900A200086475706163
	.debug	T	6B73000900A60009747865746865727200
	.debug	T	1300022F0003000100270000002900020003000400
	.debug	T	070002300000000100
	.debug	T	0B000231000100030032000000
	.debug	T	070000320002000100
	.debug	T	0F00023300020001000600000009000200
	.debug	T	0900013400140003001400
	.debug	T	5C0003350019000700010009000000076970416464720009000400
	.debug	T	076263416464720009000800086E65746D61736B0009000C00
	.debug	T	086761746577617900B1001000086D61634164647200070016
	.debug	T	00046D7475000300180006737461746500
	.debug	T	0F00023600020006000600000037000200
	.debug	T	070000370002003500
	.debug	T	0B000238000100060006000000
	.debug	T	0F0002390002000600050000003A000200
	.debug	T	0700003A0002003B00
	.debug	T	4000033B00460005000100B2000000056465737400B20010000867
	.debug	T	61746577617900B2002000056D61736B00B100300006666C61
	.debug	T	677300B200360006696661636500
	.debug	T	0700003C0002003D00
	.debug	T	2400033D000C00030001000600000004617468000500020006666C
	.debug	T	61677300B3000400027500
	.debug	T	0700003E0002003F00
	.debug	T	7400033F0020000900095F4154456E747279000600000004617468
	.debug	T	000900020003697000B4000600046877610003000C00066966
	.debug	T	6163650003000D000C726F757465725F757365640009000E00
	.debug	T	0A74696D657374616D70003E001200076E657874746F000500
	.debug	T	140006666C61677300B5001600027500
	.debug	T	070000400002000300
	.debug	T	0B00024100010001003A000000
	.debug	T	0B000242000100010001000000
	.debug	T	0F00024300020027000600000044000200
	.debug	T	070000440002004500
	.debug	T	070008450004004600
	.debug	T	0B01034600270013000100060000000A6F70656E436F756E7400A6
	.debug	T	00020008696F46756E6373003200040006696F446576005600
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	0B0002470001002D0001000000
	.debug	T	0F00024800020006002700000007000200
	.debug	T	0900014900400003004000
	.debug	T	1300024A0003000600400000000600020006000400
	.debug	T	0F00024B0002003200070000004C000200
	.debug	T	0700004C0002004D00
	.debug	T	2400034D00030002000100060000000A6F70656E436F756E740003
	.debug	T	00020007756E7573656400
	.debug	T	0B00024E000100060040000000
	.debug	T	0F00024F00020006004000000040000200
	.debug	T	0B000250000100060001000000
	.debug	T	17000251000400060006000000320002005200040032000600
	.debug	T	070000520002005300
	.debug	T	5E0003530012000800010003000000066966616365000300010006
	.debug	T	73706172650005000200056C656E3100320004000664617461
	.debug	T	310005000600056C656E320008000800066461746132000500
	.debug	T	0C00056C656E330008000E0006646174613300
	.debug	T	0F00025400020006003200000055000200
	.debug	T	070008550004005600
	.debug	T	2800035600040002000100B60000000A72656164517565756500B6
	.debug	T	0002000B7772697465517565756500
	.debug	T	17000257000400060032000000400002000600040003000600
	.debug	T	130002580003000900320000000900020006000600
	.debug	T	0F0002590002000600320000005A000200
	.debug	T	0700005A0002005B00
	.debug	T	BB00035B002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	0B00025C000100060032000000
	.debug	T	1300025D0003004000400000000900020007000600
	.debug	T	0B00025E000100400027000000
	.debug	T	1300025F0003000600320000000600020032000400
	.debug	T	130002600003004000320000004000020006000400
	.debug	T	130002610003000600060000000600020006000400
	.debug	T	130002620003000600060000006300020006000400
	.debug	T	070000630002006400
	.debug	T	41000364000E00040009736F636B61646472000500000007735F74
	.debug	T	797065000500020007735F706F7274000900040005735F6970
	.debug	T	00B100080009735F73706172657300
	.debug	T	0F00026500020006000600000006000200
	.debug	T	130002660003000600060000006300020067000400
	.debug	T	070000670002000600
	.debug	T	0900016800500003005000
	.debug	T	1F0002690006000600060000006A00020006000600060008006300
	.debug	T	0A0067000C00
	.debug	T	0700086A0004000100
	.debug	T	1700026B0004000600060000006A0002000600060006000800
	.debug	T	1F00026C0006000600060000006A00020006000600060008006300
	.debug	T	0A0006000C00
	.debug	T	1B00026D0005000600060000000600020006000400320006000600
	.debug	T	0800
	.debug	T	1B00026E0005000600060000000600020006000400320006006700
	.debug	T	0800
	.debug	T	1300026F0003003200320000000600020007000400
	.debug	T	0F00027000020040004000000040000200
	.debug	T	17000271000400060032000000320002004000040040000600
	.debug	T	17000272000400400006000000320002004000040006000600
	.debug	T	0B0002730001000100B6000000
	.debug	T	070000740002007500
	.debug	T	7702037500E8002D000C7461736B5F737472756374002C00000006
	.debug	T	737461636B002C0002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C687200B7000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465007400150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	00056172676300B8001A00056172677600B9001C0005617267
	.debug	T	7300AC009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C61677300BA00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002300D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	130002760003000600BC000000230002000D000000
	.debug	T	0F0002770002000600230000000D000000
	.debug	T	13000278000300060023000000230004000D000000
	.debug	T	0900017900080009000200
	.debug	T	0B00027A0001000600BD000000
	.debug	T	1300027B000300060006000000A600020032000400
	.debug	T	0B00027C000100450006000000
	.debug	T	0F00027D00020006004500000045000400
	.debug	T	0B00027E000100010023000000
	.debug	T	0900017F00200003002000
	.debug	T	54000380000C0006000100BE000000065F5F6F757400A000020005
	.debug	T	5F5F696E00C0000400085F5F777269746500C0000600075F5F
	.debug	T	726561640006000800085F5F756E6765740032000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0B000281000100090009000000
	.debug	T	0F00028200020006004000000006000200
	.debug	T	0F00028300020006003200000006000200
	.debug	T	09000184002C0185000A00
	.debug	T	66000385001E0009000100050000000375700005000200046D7475
	.debug	T	0009000400076970616464720009000800056D61736B000500
	.debug	T	0C0006666C61677300AE000E0006696663746C00090010000A
	.debug	T	6C61737476316D736700C2001400056468637000C400160002
	.debug	T	7500
	.debug	T	0F0002860002000600060000000D000000
	.debug	T	0B000287000100010032000000
	.debug	T	0F00028800020040004000000009000200
	.debug	T	090001890000043F002000
	.debug	T	0900018A0084003D000B00
	.debug	T	1B00028B0005000600C5000000050002000900040005000800AE00
	.debug	T	0A00
	.debug	T	1B00028C0005000600C50000004000020006000400090006000500
	.debug	T	0A00
	.debug	T	1B00028D0005000600C50000000800020006000600090008000500
	.debug	T	0C00
	.debug	T	1B00028E0005000600C50000006A00020006000600C6000800C700
	.debug	T	0A00
	.debug	T	0900018F000C0005000600
	.debug	T	0B000290000100400032000000
	.debug	T	1B00029100050006002D000000050002000900040005000800AE00
	.debug	T	0A00
	.debug	T	1F00029200060006002D000000050002000900040005000800AE00
	.debug	T	0A0005000C00
	.debug	T	0B000293000100010005000000
	.debug	T	1300029400030006002D0000004000020006000400
	.debug	T	1300029500030006002D0000000800020008000600
	.debug	T	0B00029600010001002D000000
	.debug	T	130002970003000600290000003200020067000400
	.debug	T	0900019800F40228001200
	.debug	T	0900019900A80028000400
	.debug	T	0B00029A000100090001000000
	.debug	T	0B00029B000100060009000000
	.debug	T	0900019C00F8072E000C00
	.debug	T	0900019D00B0009E000400
	.debug	T	0001039E002C0013000C5F7564705F736F636B657400C500000005
	.debug	T	6E65787400030002000869705F747970650005000300086572
	.debug	T	725F6D736700060005000573617468000300070004746F7300
	.debug	T	030008000474746C00AD0009000A7573725F7969656C640003
	.debug	T	000B000672696769640003000C00077374726573730005000D
	.debug	T	000A736F636B5F6D6F64650009000F000A7573657274696D65
	.debug	T	7200AE0013000C6461746148616E646C657200090015000868
	.debug	T	697361646472000500190008686973706F72740005001B0007
	.debug	T	6D79706F72740005001D00096C6F63666C6167730003001F00
	.debug	T	06696661636500B000200003726400C8002A000B6869736574
	.debug	T	686164647200
	.debug	T	0700009F0002005700
	.debug	T	070000A00002005C00
	.debug	T	070000A10002005800
	.debug	T	070000A20002005900
	.debug	T	070000A30002005F00
	.debug	T	070000A40002006000
	.debug	T	070000A50002005400
	.debug	T	070000A60002002000
	.debug	T	070000A70002004200
	.debug	T	070000A80002004B00
	.debug	T	070000A90002004A00
	.debug	T	070000AA0002004E00
	.debug	T	070000AB0002004F00
	.debug	T	280003AC0004000100125F5F776169745F71756575655F68656164
	.debug	T	00C9000000096C6973744865616400
	.debug	T	070000AD0002003000
	.debug	T	070000AE000200AF00
	.debug	T	070002AF0000000600
	.debug	T	320003B0000A000400010008000000046275660005000400046C65
	.debug	T	6E0005000600076D61786C656E000500080006626567696E00
	.debug	T	090001B100060003000600
	.debug	T	090001B200100003001000
	.debug	T	270004B300080002000100CA0000000A707265636F6E66696700CB
	.debug	T	0000000A7472616E7369656E7400
	.debug	T	140003B400060001000100B100000006656164647200
	.debug	T	250004B5000A0002000100CC00000008706572686F737400CD0000
	.debug	T	000A6D756C74696361737400
	.debug	T	070000B6000200AC00
	.debug	T	070000B70002006A00
	.debug	T	070000B80002004000
	.debug	T	090001B900800003008000
	.debug	T	070000BA000200BB00
	.debug	T	0F0002BB000200010006000000B8000200
	.debug	T	070000BC0002008000
	.debug	T	070000BD0002002100
	.debug	T	070000BE000200BF00
	.debug	T	0F0002BF00020006000300000032000200
	.debug	T	070000C0000200C100
	.debug	T	130002C10003000800230000000800040032000800
	.debug	T	070000C2000200C300
	.debug	T	5F0103C30054001900010005000000106E756D5F7265715F6F7074
	.debug	T	696F6E7300400002000C7265715F6F7074696F6E7300AE0004
	.debug	T	000D6F70745F63616C6C6261636B0032000600056461746100
	.debug	T	05000800106F766572616C6C5F74696D656F75740006000A00
	.debug	T	0673746174650009000C000C66616C6C6261636B5F69700009
	.debug	T	0010000478696400090014000A737461727474696D65000900
	.debug	T	18000874696D656F75740005001C0008746F696E74766C0009
	.debug	T	001E000864686370706B74000500220007706B746C656E0032
	.debug	T	00240008706B747072656600B100260009646863705F687761
	.debug	T	0009002C000874656E745F697000090030000C74656E745F73
	.debug	T	75626E657400090034000C646863705F736572766572000900
	.debug	T	38000B626F6F74705F686F73740009003C00066C6561736500
	.debug	T	09004000037431000900440003743200080048000974696D65
	.debug	T	7A6F6E6500CE004C0007726F7574657200CE00500004646E73
	.debug	T	00
	.debug	T	1B0004C400080002000100CF0000000465746800D0000000047070
	.debug	T	7000
	.debug	T	070000C50002009E00
	.debug	T	070000C60002000900
	.debug	T	070000C70002000500
	.debug	T	070000C8000200B400
	.debug	T	260003C900040002000A6C6973745F6865616400D1000000056E65
	.debug	T	787400D1000200057072657600
	.debug	T	1F0003CA0008000200010009000000077375626E65740009000400
	.debug	T	056D61736B00
	.debug	T	280003CB00080002000100080000000B707265666572656E636500
	.debug	T	090004000A74696D657374616D7000
	.debug	T	310003CC000A00030001000500000009706174685F6D7475000900
	.debug	T	0200087274745F6176670009000600087274745F64657600
	.debug	T	210003CD00030002000100030000000975736572666C6167000600
	.debug	T	010005736C6F7400
	.debug	T	090001CE00040009000100
	.debug	T	210003CF00040002000100050000000765666C6167730005000200
	.debug	T	076E69636E756D00
	.debug	T	320003D000080003000100050000000770666C6167730009000200
	.debug	T	09706565726164647200320006000A7070705F737461746500
	.debug	T	070000D1000200C900
	.seg	CONST
@1:
	.db	"socket",0,"Unknown error",0,"validSOCK",0,"SockInfo",0,"???.???.???.???",0,"0.0.0.0",0,"eth0",0,"Closed",0,"UP",0,"DOWN",0,"t"
	.db	"cpSockEvent_",0,"read",0,"write",0,"*",0,":*",0,"*INVALID*",0,"Listen",0,"bad bad",0," -> ",0
	.seg	FARCONST
@2:
	.db	"OK",0,"Local host not reachable (ARP)",0,"Host not reachable (Router)",0,"Host refused connection"
	.db	0,"Timout on open or close",0,"Connection timed out",0,"Active abort sent from this peer",0,"Timed "
	.db	"out due to inactivity",0,"DHCP lease expired",0,"ICMP reported trouble",0,"Protocol error",0,"Remote "
	.db	"peer reset connection",0,"Network unreachable",0,"Host unreachable",0,"Protocol unreachable",0,"Port "
	.db	"unreachable",0,"Fragmentation needed but DF",0,"Source route failed",0,"Destination network unkno"
	.db	"wn",0,"Destination host unknown",0,"This host isolated",0,"Destination network prohibited",0,"Destina"
	.db	"tion host prohibited",0,"Network type-of-service unreachable",0,"Host type-of-service unreach"
	.db	"able",0,"Time-to-live exceeded",0,"Fragment reassembly time exceeded",0,"Redirect for network",0,"Red"
	.db	"irect for host",0,"Redirect for TOS and network",0,"Redirect for TOS and host",0,"Parameter probl"
	.db	"em",0,"Parameter problem: option missing",0,"Source quench",0,"IP address changed",0,"Out of memory",0,"I"
	.db	"P address conflict",0,"Interface down or deactivated",0,"passive open call",0,"active open call",0,"e"
	.db	"stablished connection",0,"FIN rcvd (no more reads)",0,"local close (no more writes)",0,"Closed",0,"lo"
	.db	"cal call to sock_abort()",0,"rcvd RST",0,"ICMP rcvd",0,"socket (%04X)[%d]: %ls",10,0,"initSockInfo",0,"Set "
	.db	"IP address to: %s",13,10,0,"Bringing up network interface...",13,10,0,"Taking down network interface."
	.db	"..",13,10,0,13,10,"Configuring network interface...",13,10,0,"Closing all sockets...",13,10,0,"p2p%u",0,"eth%u",0,"%-15s "
	.db	"%-15s %-15s %-5s xxxxxx xxxxxx xxx %s",13,10,0,13,10,"Destination     Gateway         Genmask    "
	.db	"     Flags Metric Ref    Use Iface",13,10,0,"unusedTCP",0,"=== network state chgd to %d from %d ="
	.db	"==",13,10,0,"Ethernet Link %s",13,10,0,"# of sockets still open: %d",13,10,0,"tcpSockEvent_",0,"*** tcpSockEvent("
	.db	"): TCP[%u]: Event %d",13,10,"    Invalid socket pointer: %05lX",13,10,0,"_newListener_",0,"socket (%04X)"
	.db	"[%d]: read from closed socket ...",10,0,"socket (%04X)[%d]: write to closed socket ...",10,0,"***"
	.db	"** tasks in %sQueue for closed socket *****",10,0,":%u",0,"IPv4 0x%04lX ",0,"TCP[%d] ",0,"UDP[%d] ",0,"sock"
	.db	"et (%04lX)[%d]: listening on port %d",10,0,"socket (%04lX)[%d]: new socket connection, port"
	.db	" %d",10,0,"socket (%04lX)[%d]: connect(): %s",10,0,"sendto(%d, 0x%05lX, %d, %04X, 0x%04X, %d)",13,10,0," "
	.db	" sendto returned: %d",10,0,"socket (%04X)[%d]: write to a closed socket ...",10,0
	.end
