	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\unistd.c' 15 38 16 11 1 33
;1 //----- unistd.c ----- 12/17/12 -----(03/05/06)----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Functions to mimic unix kernel functions for managing processes
;5 //-------------------------------------------------------------------------
;6 // Update Log (most recent first)
;7 //
;8 //  Entries marked with (*) indicate ones that improve the stability and/or
;9 //  reliability of the code.
;10 //
;11 //
;12 //  2012-12-17 - Mark Davis
;13 //               - Began adding code to support a backup approach to the
;14 //                 softReset concept:  To attempt to restore the state of t
;15 //                 controller ASAP if it did an unexpected CPU reset.
;16 //
;17 //  2012-12-12 - Mark Davis
;18 //               - postMortem() now includes the # of ms since the kernel a
;19 //                 applic tasks have called resetWDT(), and the value of th
;20 //                 flags: doCleanShutdown, useSoftReset, allowSoftReset
;21 //
;22 //  2012-09-13 - Mark Davis (*)
;23 //               - Fixed computeCRC() so it doesn't log ALL tested portions
;24 //                 memory as being corrupted after the first detected
;25 //                 corruption.
;26 //
;27 //  2012-09-06 - Mark Davis
;28 //               - Improved the efficiency of resetWDT() a bit.
;29 //
;30 //  2012-06-11 - Mark Davis
;31 //               - Moved updating of _TimerMilliSeconds[1] and _TimerSecond
;32 //                 and the check for the scheduler tick (a SchedMS millisec
;33 //                 long interval) to _TimerBISR() to avoid the overhead of
;34 //                 calling timer_interrupt() every millisecond.
;35 //               - Renamed timer_interrupt() to sched_tick().
;36 //               - current->lastRunning is no longer set within the periodi
;37 //                 timer interrupt (now sched_tick()) but at the beginning 
;38 //                 schedule() (which has to be called to change which task
;39 //                 has the CPU, so that is the only place it is needed).
;40 //
;41 //  2012-06-07 - Mark Davis
;42 //               - Added schedCallsPrevSec (count of # of times schedule() 
;43 //                 called in the last second).
;44 //
;45 //  2012-03-29 - Mark Davis
;46 //               - The interrupt functions that service fault conditions no
;47 //                 save the AF' regsiter on the stack.  Prior to this, the
;48 //                 various functions called between when the fault occured
;49 //                 and when the dump is done could have used the AF' regist
;50 //                 without saving and restoring its value, resulting in an
;51 //                 incorrect value in the dump.
;52 //
;53 //  2012-03-21 - Mark Davis
;54 //               - Finished changes to new logic to that checks for an
;55 //                 unreasonable hdwResetTime value and attempts to correct 
;56 //                 Prior to this, if the RTC did not have a valid value at
;57 //                 startup, this value would not be updated when the RTC wa
;58 //                 set, which the result that, following a soft reset, the
;59 //                 counter for the # of seconds since the last hard reset c
;60 //                 be wildly off (which could affect application logic whic
;61 //                 uses time-since-hard-reset extensively for managing timi
;62 //               - The IP (Interrupt Priority) register is now cleared a bi
;63 //                 later so there are no values left over from the startup
;64 //                 proceedure.
;65 //
;66 //  2012-03-15 - Mark Davis
;67 //               - The hdwResetTime and rebootTime in the diagLogInfo struc
;68 //                 are now corrected whenever the RTC is updated.
;69 //
;70 //  2012-03-07 - Mark Davis
;71 //               - postMortem() now includes the IP (Interrupt Priority)
;72 //                 register value for each task.
;73 //               - IP reg now zeroed out at startup to insure there is no
;74 //                 value left in it after a soft reboot.
;75 //               - Added rtosVers and invInfoKey to DiagLogInfo struct
;76 //
;77 //  2012-03-02 - Mark Davis
;78 //               - KUNLOCK() now increases/decreases preempt_count by 8 so
;79 //                 other code (primarily postMortem() and ps cmd) can
;80 //                 distinguish between a normal preemption due to a schedul
;81 //                 timer tick and a delayed one from KUNLOCK().
;82 //
;83 //  2012-03-01 - Mark Davis
;84 //               - More fixes to postMortem().  Include changes needed beca
;85 //                 timer_interrupt() is now a far function, and fixing some
;86 //                 bugs that caused it to grab the wrong XPC value from the
;87 //                 stack for preempted tasks.
;88 //
;89 //  2012-02-24 - Mark Davis
;90 //               - tcp_lock and tcp_unlock pointers now refer directly to t
;91 //                 KLOCK() and KUNLOCK() functions, although this is mostly
;92 //                 "backup" as lock macros in the Softools/Rabbit Stcpip/ne
;93 //                 header file have been modified to call KLOCK() and KUNLO
;94 //                 directly.
;95 //
;96 //  2012-02-15 - Mark Davis
;97 //               - Made timer_interrupt() a far func to free up some root
;98 //                 memory space.
;99 //               - If sock_init() fails when starting up the primary boot i
;100 //                 it now sets the flag that tells the DLM to load the back
;101 //                 image.  Prior to this it would just keep running the DLM
;102 //
;103 //  2012-01-03 - Mark Davis
;104 //               - Added getPC() (returns Program Counter for cur task)
;105 //               - postMortem() now shows the correct PC (Program Counter)
;106 //                 value for preempted tasks.
;107 //
;108 //  2011-12-22 - Mark Davis (*)
;109 //               - stackTrace() has been overhauled so it produces more
;110 //                 accurate output.  While there are still lots of (unavoid
;111 //                 false matches, it no longer misses the real matches.
;112 //
;113 //  2011-11-11 - Mark Davis (*)
;114 //               - Missed the watchdog timer imminent-timeout in the last
;115 //                 change.  This also does a softReset now.
;116 //
;117 //  2011-10-20 - Mark Davis (*)
;118 //               - A soft rather than hard reset is now done whenever possi
;119 //                 for any runtime exception.  This should minimize the
;120 //                 disruption such errors can cause.  And since, to date,
;121 //                 nearly all of these coincide with a memory corruption, i
;122 //                 unlikely that a software bug has anything to do with it.
;123 //                 And on the chance that one WAS caused by a bug, then the
;124 //                 crash-log will still be there and will provide the same
;125 //                 information regardless of whether it was followed by a
;126 //                 soft or a hard reset.
;127 //
;128 //  2011-03-29 - Mark Davis
;129 //               - Changes to stop kernel task from blocking when changing
;130 //                 the network configuration.
;131 //
;132 //  2011-03-11 - Mark Davis
;133 //               - Added stack protection values for each task to the data
;134 //                 shown by the showMemProtection() function.
;135 //
;136 //  2011-03-09 - Mark Davis
;137 //               - Significant changes to how a stack trace is done to prov
;138 //                 more accurate information in the crash-log.
;139 //
;140 //  2011-02-10 - Mark Davis
;141 //               - The kernel task now forces a reboot 20 seconds after a
;142 //                 shutdown was started regardless of the number of tasks
;143 //                 still running.
;144 //
;145 //  2011-02-09 - Mark Davis
;146 //               - Moved the code that gets the location and size of the
;147 //                 memory segments to an earlier point in the startup seque
;148 //                 so shared, unnamed semaphores (ones with a static addres
;149 //                 accessable to all tasks) will work earlier.
;150 //
;151 //  2011-01-06 - Mark Davis
;152 //               - Removed code that delayed rebooting when memory corrupti
;153 //                 is detected as there was never a case of a false positiv
;154 //                 the first time.  This reduces the chances of the corrupt
;155 //                 memory will cause worse problems before the controller c
;156 //                 do a soft restart to correct the problem.
;157 //
;158 //  2010-12-14 - Mark Davis
;159 //               - Changed secTimerOffset to hdwResetTime and added rebootT
;160 //
;161 //  2010-12-06 - Mark Davis (*)
;162 //               - Added useSoftReset flag to support restarting the OS wit
;163 //                 resetting the CPU in the process.  This allows the OS to
;164 //                 reload and restart itself without causing the entire CPU
;165 //                 state to revert to its default reset values.  In particu
;166 //                 this makes it possible to reboot without affecting the
;167 //                 state of the analog and digital outputs.
;168 //
;169 //  2010-12-02 - Mark Davis
;170 //               - Began work on softReset() as a way to run the RDLM and
;171 //                 reload and run the boot image.  This provides the means
;172 //                 to do everything that happens for a CPU reset EXCEPT res
;173 //                 the CPU, which means the state of all the I/O bits will 
;174 //                 change to their default modes and states.
;175 //
;176 //  2010-11-08 - Mark Davis
;177 //               - On the off chance that a failure of a block of memory wi
;178 //                 unchanging values fails its CRC test due to a sporadic
;179 //                 glitch in reading it, the failure must now occur twice i
;180 //                 a row before the controller resorts to rebooting itself.
;181 //                 Note that ANY CRC check failures are still recorded in t
;182 //                 log.  While any glitch indicates a problem, the rebootin
;183 //                 of a controller may be more disruptive than the chance t
;184 //                 it happened at some time other than during the continuou
;185 //                 background CRC test and caused a significant problem.  A
;186 //                 while the new approach is statisically more liklely to a
;187 //                 such an occurance to cause ongoing problems, if the prob
;188 //                 is real (i.e. memory HAS become corrupted), then the pro
;189 //                 will still be detected (albiet a bit later than before) 
;190 //                 the controller rebooted to correct it.
;191 //
;192 //  2010-09-22 - Mark Davis
;193 //               - ramSize now set at beginning of main() using the value
;194 //                 found by the CStart module for _xmemEnd (i.e. the end of
;195 //                 unused extended memory BEFORE any of it has been allocat
;196 //
;197 //  2010-08-12 - Mark Davis (*)
;198 //               - Fixed a problem with the process that causes the control
;199 //                 to revert to the backup image when the primary version
;200 //                 crashes unexpectedly.  Previous to this fix, the code ma
;201 //                 no distinction between a reboot that happened for no kno
;202 //                 reason and one that caused a post mortem dump and a
;203 //                 controlled shutdown/reboot.  The result was that, depend
;204 //                 on the timing, the backup image would mistakenly shut do
;205 //                 and run the DLM.
;206 //
;207 //  2010-08-02 - Mark Davis
;208 //               - Added memory protection values to data dumped by
;209 //                 postMortem() when an error occurs.
;210 //
;211 //  2010-07-27 - Mark Davis (*)
;212 //               - Since the RDLM uses a fixed location for its RUN_INFO
;213 //                 structure, and that location is within the memory that
;214 //                 xalloc() and bb_xalloc() allocate from, the value that
;215 //                 the RDLM reads from there to determine what (if any)
;216 //                 binary image should loaded and executed cannot updated
;217 //                 except before it might be allocated for something else
;218 //                 (which is necessary in case we crash during startup),
;219 //                 or just before be do a controller reboot.
;220 //                 To restore the feature that causes the fallback to the
;221 //                 backup boot image or the RDLM in case of a problem, I
;222 //                 now store the last boot time in the BB ram structure.
;223 //                 Along with the flag that indicates an intentional
;224 //                 reboot, this allows me to detect a crash shortly after
;225 //                 startup and do a controlled fallback.
;226 //               - The computeMemCRCs() function now displays all segments
;227 //                 (not just the ones it computes a CRC for).
;228 //
;229 //  2010-07-22 - Mark Davis
;230 //               - Added call to initSemaphores()
;231 //
;232 //  2010-07-19 - Mark Davis (*)
;233 //               - Added check at startup to make sure the segments are in 
;234 //                 correct order and have required alignments.
;235 //               - The mask that controls which 64K segments are write
;236 //                 protected is now reapplied after the task table is
;237 //                 initialized (in case the mask is changed).
;238 //
;239 //  2010-07-15 - Mark Davis
;240 //               - Changes to memory usage to allow ALL of the FARCODE and
;241 //                 FARCONST segments to be write protected as well as all o
;242 //                 the CODE segment and most of the CONST segment.
;243 //
;244 //  2010-07-08 - Mark Davis
;245 //               - Simplified stack trace code.  The changes result in far 
;246 //                 false "calls", but no longer misses actual calls.
;247 //
;248 //  2010-07-07 - Mark Davis (*)
;249 //               - Extended write protection to unused extended memory bloc
;250 //
;251 //  2010-07-01 - Mark Davis
;252 //               - The REBOOT() function argument now specifies if the RDLM
;253 //                 should (re)load one of the boot images (rather than shou
;254 //                 it skip setting the value that tells the RDLM what to do
;255 //                 before forcing a CPU reset).
;256 //
;257 //  2010-06-29 - Mark Davis
;258 //               - Moved bb_xalloc() to modified xalloc.c module
;259 //               - Modified log messages for memory allocations
;260 //               - Ability to force the backup image to run using Ctl-B dur
;261 //                 startup now working again.
;262 //
;263 //  2010-06-24 - Mark Davis
;264 //               - The idle task now continuously recomputes the CRC's for 
;265 //                 memory segments that should never change (those with cod
;266 //                 and constant values) and does a dump/rebooot if any of t
;267 //                 don't match the values computed at startup.
;268 //
;269 //  2010-06-09 - Mark Davis
;270 //               - Basic stack and memory hdw protections implemented
;271 //
;272 //  2010-06-08 - Mark Davis
;273 //               - Moved check for single-key console command to reboot usi
;274 //                 backup image or shutdown and run DLM to BEFORE the check
;275 //                 that determines if main() restarted by some means other
;276 //                 than the RDLM reloading the boot image.
;277 //
;278 //  2010-06-02 - Mark Davis
;279 //               - Began adding support for limited memory protection mecha
;280 //                 available on Rabbit 3000A processors.
;281 //               - Added computeMemCRCs() and showIntVectors()
;282 //
;283 //  2010-05-28 - Mark Davis
;284 //               - The size of the circular buffer used for the system log 
;285 //                 the size of the far heap are both set dynamically based 
;286 //                 the amount of free memory at startup.  This was done to 
;287 //                 up more memory on the BL2200 devices which have only 512
;288 //                 RAM (compared to the 768K on RCM3200 devices).
;289 //
;290 //  2010-05-27 - Mark Davis
;291 //               - The flag that controls if syslog entries are copied to t
;292 //                 console port (serial port A) is set when a shutdown is
;293 //                 started so the console will show the process even if the
;294 //                 was a login shell using it.
;295 //
;296 //  2010-05-14 - Mark Davis (*)
;297 //               - timeoutTicks is now decremented only for tasks in a bloc
;298 //                 state (i.e. INTERRUPTIBLE or UNINTERRUPTIBLE).  This lea
;299 //                 the timeoutTicks count intact when a task is woken up by
;300 //                 a wait queue handler.  Prior to this schedule_timeout()
;301 //                 would always return 0, which would cause problems (or at
;302 //                 least wasted effort) when doing a blocking call with a
;303 //                 timeout.
;304 //               - The postMortem() dump of the interrupt table vectors now
;305 //                 includes the name for each vector.
;306 //
;307 //  2010-05-13 - Mark Davis
;308 //               - Replaced setBlockTimeout() with msToTicks()
;309 //
;310 //  2010-05-10 - Mark Davis
;311 //               - Added recursiveDump flag and used it to avoid postMortem
;312 //                 dumps from happening recursively.
;313 //
;314 //  2010-05-07 - Mark Davis (*)
;315 //               - Changed code so DATASEG is always the same as the ROOT
;316 //                 segment (0), rather than trying to follow the STACK segm
;317 //                 This is simpler, slightly faster. and avoids any possibi
;318 //                 of there being a problem if the schedule() function is
;319 //                 interrupted at just the wrong moment.
;320 //
;321 //  2010-05-03 - Mark Davis (*)
;322 //               - Corrected bug in sleepMS() that could cause a watchdog
;323 //                 timer reboot if sleepMS() was called with the scheduler
;324 //                 locked.
;325 //               - Also made sure that if the applic task calls sleepMS()
;326 //                 that it will relinquish the CPU until the next scheduler
;327 //                 tick.
;328 //
;329 //  2010-04-29 - Mark Davis
;330 //               - Changes to accomodate more capable wait queue handling.
;331 //
;332 //  2010-04-23 - Mark Davis
;333 //               - The WatchDog timer is now enabled first thing and left
;334 //                 enabled except when initializing the network hardware an
;335 //                 the IP stack (which takes longer than the max 2 seconds
;336 //                 the WatchDog timer can be set for).  This helps avoid th
;337 //                 possibility that the a problem during startup could caus
;338 //                 the system to hang.
;339 //
;340 //  2010-04-22 - Mark Davis
;341 //               - Now initializing the wq element rather than the waitq
;342 //                 element for the kernel task (the unused waitq element ha
;343 //                 been removed).
;344 //
;345 //  2010-03-31 - Mark Davis
;346 //               - Expanded on data provided by postMortem()
;347 //
;348 //  2010-03-22 - Mark Davis
;349 //               - postMortem() now takes a string parameter so a descripti
;350 //                 of the cause can be saved in the crash-log file.
;351 //
;352 //  2010-03-11 - Mark Davis (*)
;353 //               - The startup code in main() now checks to see if this is 
;354 //                 first time it has been run since the RDLM loaded it.  If
;355 //                 not, then it forces a reboot using the watchdog timer.  
;356 //                 guards against the endless problems that can arise when
;357 //                 a bug causes a jump to 0, causing my code to restart, bu
;358 //                 without the static variables having the proper values an
;359 //                 (possibly) the code being corrupted.
;360 //
;361 //  2010-03-05 - Mark Davis (*)
;362 //               - Added check for an unbalanced KUNLOCK() (i.e. that it
;363 //                 hasn't been called more times than KLOCK()).  KUNLOCK()
;364 //                 now logs a message if this happens.
;365 //               - postMortem() now includes the state of the _disabled cou
;366 //
;367 //  2010-03-03 - Mark Davis (*)
;368 //               - Completely redid how ISRs are protected from preemption.
;369 //                 The 16-byte interrupt vector itself is now a short piece
;370 //                 code that disables the scheduler, calls the ISR, then
;371 //                 reenables the scheduler and returns.  This drastically
;372 //                 reduces the added overhead, the liklihood that an ISR wi
;373 //                 be preempted, and shrinks the possibility that it would 
;374 //                 a problem if it should still happen to near 0.
;375 //
;376 //  2010-03-01 - Mark Davis
;377 //               - Added check to see if the diagnostic/log info in battery
;378 //                 backed RAM is already where it should be.  Previous to t
;379 //                 change it always checked for a pre-shifted copy, but the
;380 //                 newer version of the RDLM seems to have eliminated this.
;381 //                 Without this change, if the board had been update from a
;382 //                 older version of the RDLM to a newer one, the code could
;383 //                 find the copy of the data structure in its older locatio
;384 //                 which could be months out of date.
;385 //
;386 //  2010-02-27 - Mark Davis (*)
;387 //               - Significant changes to timer_interrupt() to address
;388 //                 recently recognized problem that can cause the stacks of
;389 //                 one or more tasks to overflow.
;390 //               - Added preempt_count to the info shown for each task in
;391 //                 postMortem().
;392 //
;393 //  2010-02-26 - Mark Davis (*)
;394 //               - The timer_interrupt() function now checks the scheduler
;395 //                 disabled flag earlier and does not try to update anythin
;396 //                 related to the current task if it is disabled.  Before
;397 //                 this change it always used the current pointer to update
;398 //                 the lastRunning time and preempt_count.  If schedule()
;399 //                 was interrupted after it had changed the current pointer
;400 //                 but before it had actually switched tasks, then the valu
;401 //                 would be modified for the task about to be resumed, rath
;402 //                 than for the one that was just preempted.
;403 //
;404 //  2010-02-18 - Mark Davis (*)
;405 //               - The timer_interrupt() function now returns if it preempt
;406 //                 the application task.
;407 //
;408 //  2010-02-13 - Mark Davis (*)
;409 //               - The ISR shims now save and restore the Interrupt Priorit
;410 //                 (IP) register.
;411 //               - The timer_interrupt() function now properly checks (and
;412 //                 does not allow) recursive calls (for those once-in-a-gre
;413 //                 while instances where the timer interrupt is delayed
;414 //                 enough to cause a recursive call).
;415 //               - The updating of the time info in the diagLogInfo structu
;416 //                 is now done only every SchedMS milliseconds, which reduc
;417 //                 the overhead of the majority of the calls to this func.
;418 //
;419 //  2010-01-29 - Mark Davis (*)
;420 //               - setBlockTimeout() now properly handles 0.  Prior to this
;421 //                 it ensured a timeout of at least once scheduler tick for
;422 //                 any value it was passed (to avoid a 0 timeout for ms val
;423 //                 that were not zero but smaller than one scheduler tick).
;424 //                 This could explain lots of problems with socket operatio
;425 //                 that didn't make sense before.  Basically any task that
;426 //                 called readBytes() or writeBytes() (directly or indirect
;427 //                 would likely experience problems, especially due to call
;428 //                 that expected to block without a timeout.
;429 //
;430 //  2009-12-25 - Mark Davis
;431 //               - restored resetCode msg now that DLM (supposedly) no long
;432 //                 clears it
;433 //               - Added check and counter for recursive call to
;434 //                 timer_interrupt()
;435 //
;436 //  2009-12-21 - Mark Davis
;437 //               - resetCode msg removed for now as the value is apparently
;438 //                 cleared from the CPU register before we can get to it.
;439 //
;440 //  2009-12-20 - Mark Davis
;441 //               - Added syslog msg with value of resetCode at startup.  Th
;442 //                 is the value read by CStart from the ZWorld Global Contr
;443 //                 Status register at startup (shifted 6 bits so it just ha
;444 //                 the 2 bits indicating the cause of the reset).
;445 //
;446 //  2009-12-18 - Mark Davis
;447 //               - Initialized diaglogInfo->-Ticks before starting the
;448 //                 watchdog timer.  This avoids a possible false triggering
;449 //                 the post-mortem dump code. (*)
;450 //               - Expanded the post-mortem dump code to do the show the sa
;451 //                 info that the inttab userline command does.
;452 //
;453 //  2009-12-09 - Mark Davis (*)
;454 //               - Fixed code for interrupt handler "shims" that wrap all
;455 //                 interrupts but the timer one with a scheduler lock (whic
;456 //                 insures a task switch doesn't occur within an ISR).
;457 //               - Added period check to kernel task to check for interrupt
;458 //                 handlers that have been changed (and to change them to
;459 //                 use the shim again with the new address).
;460 //               - Added UnhandledInterruptHandler() function to override t
;461 //                 default one that simply reboots.  The new function can't
;462 //                 handle an unknown interrupt, but it should at least add
;463 //                 and entry to the log so we know if one happens.
;464 //
;465 //  2009-12-07 - Mark Davis
;466 //               - Added copy of timeZone value to the values stored in
;467 //                 the battery-backed memory (and restored on bootup).  Thi
;468 //                 allows the system log to have the correct time when it
;469 //                 first boots up.
;470 //
;471 //  2009-11-05 - Mark Davis
;472 //               - The configd task's announcementInterval is now reset
;473 //                 whenever the DeviceID changes by calling the new configd
;474 //                 function resetAnnounceInterval() (rather than having the
;475 //                 configd module be responsible for detecting the change).
;476 //               - The new function is also called repeatedly whenever the 
;477 //                 OS is about to shutdown.
;478 //
;479 //  2009-09-18 - Mark Davis
;480 //               - The "killing process ..." syslog message is no longer
;481 //                 written for a task that called Exit()
;482 //
;483 //  2009-08-24 - Mark Davis
;484 //               - Modified resetWDT() so it now works as follows:
;485 //                  - BOTH the kernel and applic tasks must call resetWDT()
;486 //                    at least once every 60000ms
;487 //                  - EITHER the kernel or the applic task must call resetW
;488 //                    at least once every 1900ms.
;489 //                 This change is to avoid the problem with the last method
;490 //                 that allowed the kernel and/or applic task get stuck in 
;491 //                 loop that did NOT call resetWDT().
;492 //
;493 //  2009-07-30 - Mark Davis
;494 //               - sleepMS() no longer lets the kernel try to sleep.  Since
;495 //                 is the one responsible for waking up sleeping tasks this
;496 //                 would effectively hang the OS.
;497 //
;498 //  2009-06-28 - Mark Davis
;499 //               - Task state now shown as "Blocked*" if the task is blocke
;500 //                 but has a timeout value.
;501 //
;502 //  2009-06-23 - Mark Davis
;503 //               - Eliminated the redundant reloading of the param files.
;504 //                 This was a waste of time and just added to the mass of
;505 //                 log entries for each startup.
;506 //
;507 //  2009-06-21 - Mark Davis
;508 //               - The current time is now saved to battery-backed RAM so
;509 //                 the time the module was last running can be logged next
;510 //                 time it boots up.
;511 //
;512 //  2009-06-19 - Mark Davis
;513 //               - Added Module ID (last 3 bytes of MAC addr) to info logge
;514 //                 at startup (independent of the messages showing the stat
;515 //                 of the network, which, on occasion, don't get logged if
;516 //                 there is a problem).
;517 //               - Added Module ID, appl vers, and RTOS vers to info logged
;518 //                 by postMortem()
;519 //               - Increased the length of time that postMortem() resets th
;520 //                 watchdog timer for so it has more time to log its info.
;521 //
;522 //  2009-06-18 - Mark Davis
;523 //               - The postMortem() function now dumps a list of the proces
;524 //                 that were running and some information about each one th
;525 //                 could help determine what caused the reboot.  In case th
;526 //                 controller is unable to save the new log entries after
;527 //                 rebooting, it writes the same information to a file on
;528 //                 the flash file system.
;529 //
;530 //  2009-06-17 - Mark Davis
;531 //               - Added a counter to keep track of how many milliseconds i
;532 //                 has been since the watchdog timer was reset.  If the cou
;533 //                 indicates the timer is about to reset the CPU, the new
;534 //                 new postMortem() func is called to log the fact.
;535 //
;536 //  2009-06-16 - Mark Davis
;537 //               - The system log from the previous reboot/reset is restore
;538 //                 (if there is a recognizable one to restore).
;539 //
;540 //  2009-06-11 - Mark Davis
;541 //               - Added gettimeofday() and settimeofday() functions (altho
;542 //                 the settimeofday() day currently ignores the microsecond
;543 //
;544 //  2009-06-08 - Mark Davis
;545 //               - The interval for scheduler ticks is now settable in the 
;546 //                 This allows applications that do a lot in the main appli
;547 //                 task (which is supposed to run every tick) but don't nee
;548 //                 to do it every 10 ms to free up a lot of CPU cycles by
;549 //                 doing scheduler ticks (and running the main applic task
;550 //                 and the kernel task) less frequently.  This makes most o
;551 //                 the other tasks more responsive since there are more cyc
;552 //                 per second to divide up among them.
;553 //
;554 //  2009-05-13 - Mark Davis -
;555 //               - Network init now done before the majority of the task ta
;556 //                 initialization is done.  The primary reason for this is 
;557 //                 allocate space for the stacks AFTER the network init is
;558 //                 done.  For some reason, the network init fails if the
;559 //                 amount of free memory isn't significantly MORE than what
;560 //                 it allocates (even though it never USES any more than wh
;561 //                 it allocates at init time ?!?!?!?!?)
;562 //
;563 //  2009-04-30 - Mark Davis -
;564 //               - The OS is rebooted if we are running the primary boot im
;565 //                 and the socket lib did not properly initialize
;566 //
;567 //  2009-04-15 - Mark Davis
;568 //               - Added applicActive flag that must be set by the applic t
;569 //                 to indicate when it is NOT safe to reboot the controller
;570 //                 (although it is not used yet...)
;571 //
;572 //  2009-04-13 - Mark Davis
;573 //               - Increased max time for all tasks to exit after a shutdow
;574 //                 starts from 5 to 10 seconds.
;575 //
;576 //  2009-03-19 - Mark Davis
;577 //               - The runningPrimary flag is now set at startup using the
;578 //                 return value of the modified DLM_Init() function.
;579 //
;580 //  2009-03-17 - Mark Davis -
;581 //               - Changed handling of shutdown as follows:
;582 //                  Previous method:
;583 //                  - Send SIGTERM to all processes
;584 //                  - If no tasks but the kernel and idle tasks are left or
;585 //                    10 seconds elapse then shut down the network and rebo
;586 //                  New method:
;587 //                  - Send SIGTERM to all processes
;588 //                  - If 5 seconds elapse, Send SIGKILL to all processes
;589 //                  - When no tasks but the kernel and idle tasks remain, s
;590 //                    down the network and reboot
;591 //                  The old way could result in the system being rebooted w
;592 //                  tasks that had blocked the SIGTERM signal were still
;593 //                  running.  The new approach ensures all but the kernel a
;594 //                  idle tasks have been cleaned up by _killTask_(), which
;595 //                  removes tasks from wait queues and closes any open
;596 //                  descriptors.
;597 //
;598 //  2008-04-07 - Mark Davis -
;599 //               - changes to support more generic "registered" file system
;600 //                 model
;601 //
;602 //  2008-03-07 - Mark Davis -
;603 //               - added applicTicks counter
;604 //
;605 //  2007-11-15 - Mark Davis -
;606 //               - added support for SRFS keep-alive packets
;607 //
;608 //  2007-11-14 - Mark Davis -
;609 //               - fixed first entry in process table that was not properly
;610 //                 initialized (showed up as a problem in the Modular Power
;611 //                 supply appl when trying to init the serial ports)
;612 //
;613 //  2007-07-14 - Mark Davis -
;614 //               - added pipe() function
;615 //
;616 //  2007-02-13 - Mark Davis -
;617 //               - started changes to switch from using TurboTask to using
;618 //                 "really tiny" micro-kernel based on SHD's CoExec lib
;619 //
;620 //  2006-03-11 - Mark Davis -
;621 //               - started work on first version based on pieces from earli
;622 //                 test program
;623 //
;624 //-------------------------------------------------------------------------
;625 
;626 #include <common.h>
;627 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;628 #include <linux/sched.h>
;629 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
;630 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;631 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
	.debug	I
;632 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
;633 #include <sys/socket.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;634 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;635 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;636 #include <signal.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
;637 #include <sys/time.h>
;638 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\time.h' 10 37 11 8 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;639 #include <Rabbit.h>
;640 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
;641 
;642 #include <sys/backup.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
;643 #include <sys/configd.h>
;644 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\configd.h' 10 21 11 5 11 29
	.debug	I
;645 #include <sys/spi.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
	.debug	I
;646 #include <sys/hdwDefs.h>
;647 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;648 
;649 #include <DLMiii.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
;650 #include <SHD_DLM.h>
;651 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;652 
;653 #include <sys/serial.h>
;654 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I
;655 #include <sys/hdwDefs.h>
;656 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
;657 #include <applic.h>
;658 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
	.debug	I
;659 #include <TIMERB.h>
;660 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\TIMERB.h' 7 27 11 11 6 32
	.debug	I
;661 #include <sys/modbus.h>
;662 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
;663 //up above #include <sys/backup.h>
;664 
;665 
;666 #include <linux/wait.h>
;667 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
;668 
;669 //--- buffer for improving printf/etc performance on stdout ---
;670 char far  outBuf[NUM_TASKS][StdOutBufSize];
;671 
;672 
;673 #include <stcpip.h>
;674 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I
;675 #include <inetd.h>
;676 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	I
;677 #include <busybox.h>
;678 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I
;679 #include <semaphore.h>
;680 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;681 #include <sys/serial.h>
;682 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I
;683 
;684 //void startMyTimer(void);
;685 
;686 
;687 //#include <sys/RegVars.h>
;688 
;689 #include <sys/farprintf.h>
;690 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;691 
;692 #define  ValidTZ(tz)  (((tz) >= -12) AND ((tz) <= 13))
;693 
;694 
;695 
;696 extern ulong  rtosVersTime;
;697 
;698 
;699 extern void logAllocation(ulong start, ulong size);
;700 
;701 
;702 void wdTimingOut(void);
;703 
;704 
;705 #asm
	.debug	# 706
.extern __callde

	.debug	# 707
.extern __callhl

;709 
	.cseg
;710 #asm
	.debug	# 711
.defseg FARBSS

;713 
	.cseg
;714 #pragma seg (farbss, xmemstart)
;715 char far xmemplaceholder[2];
;716 #pragma seg (farbss)
;717 
;718 
;719 
;720 #define _str_(s)  # s
;721 
;722 #define  SegStart(seg)  ( 
;723   msw = _asm ([_DE], "ld de,(sgat " _str_(seg) ") >> 16", _DE ),  
;724   lsw = _asm( [_BC], "ld bc,word (sgat " _str_(seg) ")", _BC ),  
;725   (ulong)msw << 16 | lsw )
;726 
;727 #define  SegSize(seg)  ( 
;728   msw = _asm ([_DE], "ld de,(sgsz " _str_(seg) ") >> 16", _DE ),  
;729   lsw = _asm( [_BC], "ld bc,word (sgsz " _str_(seg) ")", _BC ),  
;730   (ulong)msw << 16 | lsw )
;731 
;732 
;733 #define  RootSegStart(seg)  
;734   ( _asm( [_BC], "ld bc,word (sgat " _str_(seg) ")", _BC )  )
;735 
;736 #define  RootSegSize(seg)  
;737   ( _asm( [_BC], "ld bc,word (sgsz " _str_(seg) ")", _BC ) )
;738 
;739 
;740 ulong  xmemAtStartup, xmemAfterBB;
;741 
;742 
;743 //----- Rabbit 3000A interrupts for memory protection errors ---
;744 #define  INT_WRITE_FAULT     0x09
;745 #define  INT_MODE_VIOLATION  0x18
;746 #define  INT_STACK_LIMIT     0x1B
;747 
;748 //-------------------------------------------------------------------------
;749 uint  countersUpdated;
;750 
;751 uint schedCallsPrevSec, taskSwPrevSec;
;752 
;753 ulong  kernelLastCalled, applicLastCalled;
;754 
;755 static int  lastTaskIdx;
;756 
;757 static ulong  lastDeviceID;
;758 
;759 char  hostName[HostNameLen];
;760 
;761 FILE  taskIO, diagLog, *origIO;
;762 
;763 char far osName[64], osDTM[32];
;764 
;765 //uint   kernelTicks, kernelTicksPerSec;
;766 ulong  shutdownStarted;
;767 
;768 bool  checkWDT;
;769 
;770 DiagLogInfo far  prevLogInfo;
;771 
;772 int ii;
;773 
;774 bool  gotTime, runningPrimary, runBackup, recursiveDump, attemptRestore;
;775 
;776 bool  rebootMsg, doReboot, doShutdown, useSoftReset, memCorrupted,
;777       applicActive, restoredLog, doCleanShutdown;
;778 
;779 int  klocks;
;780 
;781 uint  milliTicks;
;782 ulong  hdwResetTime, rebootTime;
;783 uint  applicTicks;
;784 
;785 char nestedTimerInt = -1;
	.dseg
_nestedTimerInt::
	.db	0xff
	.debug	G _nestedTimerInt 3 0
;786 
;787 ulong  deviceID;
;788 uint  devType, hdwType, percentIdle;
;789 int  timeZone, lastTimeZone;
;790 
;791 int copyGCSR;
;792 
;793 
;794 //--- values used by farmalloc()/etc --- must be init before use ---
;795 char const far *_farheap;
;796 unsigned long _farheapsize;
;797 
;798 ulong bbAllocatedCount;
;799 
;800 uint  codeStart, codeSize, codeEnd,
;801       constStart, constSize, constEnd,
;802       dataStart, dataSize, dataEnd,
;803       bssStart, bssSize, bssEnd;
;804 ulong  farCodeStart, farCodeSize, farCodeEnd,
;805        farConstStart, farConstSize, farConstEnd,
;806        farBSSStart, farBSSSize, farBSSEnd;
;807 uint  codeCRC, constCRC, farCodeCRC, farConstCRC;
;808 
;809 uint  intVectStart, intVectEnd;
;810 
;811 uint  roStart, roEnd, wpStart, wpEnd;
;812 ulong  roStartFar, roEndFar, wpStartFar, wpEndFar;
;813 
;814 uint  wpSegMask, wpRootMask;
;815 
;816 uchar  cpuID, cpuRev;
;817 bool  hdwProtection = false;
_hdwProtection::
	.db	0
	.debug	G _hdwProtection 3 0
;818 
;819 int sockStat;
;820 
;821 char  moduleID[8];
;822 
;823 
;824 //#define  MaxReturnAddrs  16
;825 
;826 //ulong  far returnAddrs[MaxReturnAddrs], newReturnAddrs[MaxReturnAddrs];
;827 //uint  numReturnAddrs, nextReturnIdx, numNewAddrs;
;828 
;829 #asm
	.debug	# 830
.cseg

	.debug	# 831
.extern __callhl_

	.debug	# 832
.extern __callde_

;834 
	.cseg
;835 #define  CallDE  ( _asm ([_DE], "ld de,__callde##", _DE ) )
;836 #define  CallHL  ( _asm ([_DE], "ld de,__callhl##", _DE ) )
;837 
;838 
;839 uchar *sp_;
;840 
;841 const far char asterisks[] = {
;842 "**************************************************************************
;843 };
	.defseg	FARCONST
	.seg	FARCONST
_asterisks::
	.db	"******************************************************************************",0
	.debug	G _asterisks 32 8
;844 
;845 const far char *resetCause[4] = {
;846   "Jump to 0?",
	.dseg
_resetCause::
	.dw	word (phys @1)
	.dw	phys @1 >> 16
;847   "Watchdog Timer",
	.dw	word (phys @1+11)
	.dw	phys @1+11 >> 16
;848   "N/A",
	.dw	word (phys @1+26)
	.dw	phys @1+26 >> 16
;849   "Hdw Reset or Power Cycled"
;850 };
	.dw	word (phys @1+30)
	.dw	phys @1+30 >> 16
	.debug	G _resetCause 33 0
;851 
;852 const sigset_t  DefaultIgnoreSet =
;853    (sigmask(SIGCHLD) | sigmask(SIGURG) | sigmask(SIGCONT) | sigmask(SIGWINC
	.defseg	CONST
	.seg	CONST
_DefaultIgnoreSet::
	.dw	0, 0x843
	.debug	G _DefaultIgnoreSet 9 0
;854 
;855 const sigset_t  UnblockableSet = ( sigmask(SIGKILL) | sigmask(SIGSTOP) );
_UnblockableSet::
	.dw	0x100, 0x4
	.debug	G _UnblockableSet 9 0
;856 
;857 
;858 //--- Code sections that can be tracked by toggling digital outputs ---
;859 //--- The "diag" command can be used to set the bits to toggle using ---
;860 //--- these names ---
;861 ulong  TrackApplLoop = 0, TrackScheduler = 0,
	.dseg
_TrackApplLoop::
	.dw	0, 0
	.debug	G _TrackApplLoop 9 0
_TrackScheduler::
	.dw	0, 0
	.debug	G _TrackScheduler 9 0
;862        TrackKernelLock = 0, TrackTimerISR = 0;
_TrackKernelLock::
	.dw	0, 0
	.debug	G _TrackKernelLock 9 0
_TrackTimerISR::
	.dw	0, 0
	.debug	G _TrackTimerISR 9 0
;863 
;864 
;865 DECLARE_WAIT_QUEUE_HEAD(sleepQueue);
_sleepQueue::
	.dw	word _sleepQueue
	.dw	word _sleepQueue
	.debug	G _sleepQueue 35 0
;866 
;867 
;868 //-------------------------------------------------------------------------
;869 //  Print a message regarding a function that was called w/o KLOCK() active
;870 //  The only real purpose of this function is to save code and data space i
;871 //  the calling functions.
;872 //-------------------------------------------------------------------------
;873 void klockErr(const char far *context)
;874 {
	.defseg	FARCODE
	.seg	FARCODE
$klockErr::
	.debug	G $klockErr 36 9
	.debug	{ $klockErr 36 873 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A context 5 34
;875   printf("***** %ls called without KLOCK()!!! *****\r\n", context);
	.debug	# 875
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+56)
	ld	c,phys @1+56 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;876 }
@3:
	.debug	} @3 876

@2	equ	0
	pop	ix
	lret
@4	equ	2
;877 
;878 //-------------------------------------------------------------------------
;879 //  assert "the big kernel lock"
;880 //
;881 //  NOTE:  This is also called directly via lock macros in Stcpip/net.h
;882 //-------------------------------------------------------------------------
;883 void near KLOCK(void)
;884 {
	.cseg
_KLOCK::
	.debug	G _KLOCK 37 1
	.debug	{ _KLOCK 37 883 @7 @6
;885    SAFE_INC(_disabled);
	.debug	# 885
	ld	hl,__disabled
  inc  (hl)
;886 
;887    if (TrackKernelLock)  BITSON_(TrackKernelLock);
	.debug	# 887
	ld	de,(_TrackKernelLock)
	ld	bc,(_TrackKernelLock+2)
	ld	hl,bc
	or	hl,de
	jr	z,@8
@9:
	.debug	< @9 @10
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,(_TrackKernelLock)
	ld	bc,(_TrackKernelLock+2)
	call	__lor##
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@10:
	.debug	>
@8:
;888 }
@6:
	.debug	} @6 888

@5	equ	0
	ret
@7	equ	0
;889 
;890 //-------------------------------------------------------------------------
;891 //  release "the big kernel lock"
;892 //
;893 //  NOTE:  This is also called directly via unlock macros in Stcpip/net.h
;894 //-------------------------------------------------------------------------
;895 void near KUNLOCK(void)
;896 {
_KUNLOCK::
	.debug	G _KUNLOCK 37 1
	.debug	{ _KUNLOCK 37 895 @13 @12
;897   _EnterCritical_();
	.debug	# 897
	ipset	2
;898 
;899   if (!_disabled)  {
	.debug	# 899
	ld	a,(__disabled)
	or	a,a
	jr	nz,@14
;900     _ExitCritical_();
@15:
	.debug	< @15 @16
	.debug	# 900
	ipres
;901     fprintf(DiagLog, "*** Unbalanced KUNLOCK() !!! ***\n");  return;
	.debug	# 901
	ld	de,word (phys @1+100)
	ld	c,phys @1+100 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;902   }
	jr	@12
@16:
	.debug	>
;903 
;904   if (--_disabled)  {  _ExitCritical_();  return; }
@14:
	.debug	# 904
	ld	a,(__disabled)
	dec	a
	ld	(__disabled),a
	or	a,a
	jr	z,@17
@18:
	.debug	< @18 @19
	ipres
	jr	@12
@19:
	.debug	>
;905 
;906   if (TrackKernelLock)  BITSOFF_(TrackKernelLock);
@17:
	.debug	# 906
	ld	de,(_TrackKernelLock)
	ld	bc,(_TrackKernelLock+2)
	ld	hl,bc
	or	hl,de
	jr	z,@20
@21:
	.debug	< @21 @22
	call	__lnot##
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	call	__land##
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@22:
	.debug	>
@20:
;907 
;908 //--- If there is a pending task switch then we "preempt" ourselves ---
;909   if (_pending)  {
	.debug	# 909
	ld	a,(__pending)
	or	a,a
	jr	z,@23
;910     current->preempt_count += 8;
@24:
	.debug	< @24 @25
	.debug	# 910
	ld	hl,(_current)
	ld	de,0xa8
	add	hl,de
	push	hl
	ld	hl,(hl)
	ld	e,0x8
	add	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;911     _ExitCritical_();  schedule();  _EnterCritical_();
	.debug	# 911
	ipres
	lcall	$schedule
	ipset	2
;912     current->preempt_count -= 8;
	.debug	# 912
	ld	hl,(_current)
	ld	de,0xa8
	add	hl,de
	push	hl
	ld	hl,(hl)
	ld	de,0xfff8
	add	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;913   }
@25:
	.debug	>
;914 
;915   _ExitCritical_();
@23:
	.debug	# 915
	ipres
;916 }
@12:
	.debug	} @12 916

@11	equ	0
	ret
@13	equ	0
;917 
;918 //-------------------------------------------------------------------------
;919 //  Reboot the CPU and run the RDLM.
;920 //
;921 //  If restart is false, it tells the RDLM it should NOT (re)load one of th
;922 //  boot images, which leaves the device in a state where the Update Manage
;923 //  application can see it and communicate with it.
;924 //
;925 //  If restart is true, it tells the RDLM to load and run either the primar
;926 //  or backup boot images, based on whether global variable runBackup is tr
;927 //  or false.
;928 //-------------------------------------------------------------------------
;929 void REBOOT(bool restartOS)
;930 {
	.seg	FARCODE
$REBOOT::
	.debug	G $REBOOT 38 9
	.debug	{ $REBOOT 38 929 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A restartOS 5 3
;931   int  mode;
	.debug	L mode -2 6
;932 
;933 
;934   ipset1();
	.debug	# 934
	ipset	1
;935 
;936 //--- lets next instance know this was a controlled shutdown ---
;937   diagLogInfo->ctldShutdown = true;
	.debug	# 937
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;938 
;939 //--- In case time values are goofy.  This helps insure a clean soft reset 
;940 //--- and lets us fix the RTC-based time values if needed. ---
;941   diagLogInfo->timerSeconds = _TimerSeconds;
	.debug	# 941
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x7d
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__farst4d##
;942 
;943 
;944   if (!restartOS)  {
	.debug	# 944
	ld	a,(ix+5)
	or	a,a
	jr	nz,@29
;945     fprintf(DiagLog, "\n----- shutdown, run DLM ---\n\n");
@30:
	.debug	< @30 @31
	.debug	# 945
	ld	de,word (phys @1+134)
	ld	c,phys @1+134 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;946     mode = UDPDNLD_MODE_RUN_DLM;
	.debug	# 946
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;947   }
@31:
	.debug	>
;948   else  {
	jr	@32
@29:
;949     if (runBackup)  {
@33:
	.debug	< @33 @34
	.debug	# 949
	ld	a,(_runBackup)
	or	a,a
	jr	z,@35
;950       fprintf(DiagLog, "\n----- reboot and run Backup -----\n\n");
@36:
	.debug	< @36 @37
	.debug	# 950
	ld	de,word (phys @1+165)
	ld	c,phys @1+165 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;951       mode = UDPDNLD_MODE_RUN_BACKUP;
	.debug	# 951
	ld	hl,0x2
	ld	(ix-2),hl
;952     }
@37:
	.debug	>
;953     else  {
	jr	@38
@35:
;954       fprintf(DiagLog, "\n----- reboot and run Primary -----\n\n");
@39:
	.debug	< @39 @40
	.debug	# 954
	ld	de,word (phys @1+202)
	ld	c,phys @1+202 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;955       mode = UDPDNLD_MODE_RUN_PRIMARY;
	.debug	# 955
	ld	hl,0x3
	ld	(ix-2),hl
;956     }
@40:
	.debug	>
;957   }
@38:
@34:
	.debug	>
;958   if (useSoftReset AND allowSoftReset)  mode |= UDPDNLD_MODE_SOFT_RESET;
@32:
	.debug	# 958
	ld	a,(_useSoftReset)
	or	a,a
	jr	z,@42
	ld	a,(_allowSoftReset)
	or	a,a
	jr	z,@42
	ld	hl,(ix-2)
	set	4,l
	ld	(ix-2),hl
;959 
;960   flushConsole();
@42:
	.debug	# 960
	lcall	$flushConsole
;961 
;962 
;963   #ifdef SHD_DLM
;964     DLM_Reboot(mode);
	.debug	# 964
	ld	hl,(ix-2)
	push	hl
	lcall	$DLM_Reboot
	pop	de
;965   #else
;968 }
@27:
	.debug	} @27 968

@26	equ	2
	ld	sp,ix
	pop	ix
	lret
@28	equ	4
;969 
;970 //-------------------------------------------------------------------------
;971 //  The purpose of these functions is to cause the boot image to reloaded a
;972 //  execution restarted the same as if the CPU had been reset, but with
;973 //  one important exception:  Avoid doing an actual reset.
;974 //
;975 //  This approach to restarting the OS and the application code provides
;976 //  the means for restarting while avoiding one important aspect of a real
;977 //  reset:  It does not cause the processor to return to its default state.
;978 //
;979 //  The advantage of this method is that it provides a less painful way to
;980 //  recover from fatal runtime errors (such as the code becoming corrupted,
;981 //  or some unrecoverable corruption of a data structure.
;982 //
;983 //  This "pseudo" reset is accomplished by allocating a block of memory
;984 //  in a memory bank that is not needed by the RDLM/boot manager, copying
;985 //  a small function to it, and then "calling" the function.  That function
;986 //  then maps the first 256K bytes of flash to the first 256K memory bank
;987 //  and jumps to address 0, causing the RDLM to execute.
;988 //
;989 //  NOTE that this mearly takes care of avoiding the consequences (and
;990 //  advantages) of doing an actual CPU reset.  It still requires that
;991 //  other modules (including cstart and hardware/platform specific ones)
;992 //  skip steps they normally do at startup that may alter the state of
;993 //  any outputs that may affect the devices being controlled.
;994 //
;995 //  Also keep in mind the limitations and downside to this approach:
;996 //
;997 //    - If some part of the hardware or the CPU is in a messed up state
;998 //      and there is no way to insure against this during startup (without
;999 //      changing the state of the outputs), then using this method to resta
;1000 //      can lead to erratic or undesired behavior that a true reset would
;1001 //      have avoided.
;1002 //
;1003 //    - A soft reset is still a significant disruption.  A clean shutdown o
;1004 //      the OS should still be done first (if possible), and the OS will st
;1005 //      be reloaded and restarted.  The only difference is that much of the
;1006 //      default state of the CPU caused by a real reset does not occur, so
;1007 //      it should be possible to avoid changes to the outputs used to contr
;1008 //      any external devices.
;1009 //
;1010 //  If handled properly, a soft reset can leave external devices in a stead
;1011 //  state while the OS is shutting down and restarting.  Of course, it is u
;1012 //  to the application to make sure that the control signals are in a state
;1013 //  that is SAFE to leave them in during a reboot.
;1014 //
;1015 //-------------------------------------------------------------------------
;1016 #define  PseudoReset_FuncSize  256   // must be >= size of pseudoReset() fu
;1017 
;1018 void _nostep pseudoReset(void)
;1019 {
$pseudoReset::
	.debug	G $pseudoReset 37 11
	.debug	{ $pseudoReset 37 1018 @45 @44
;1020 //  ulong  startWait;
;1021 
;1022   fprintf(DiagLog, "\n***** Restarting w/o CPU reset *****\n\n\n");
	.debug	# 1022
	ld	de,word (phys @1+240)
	ld	c,phys @1+240 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1023 
;1024   flushConsole();  KLOCK();
	.debug	# 1024
	lcall	$flushConsole
	call	_KLOCK
;1025 
;1026   // startWait = GetMS();  while (msSince(startWait) < 100);
;1027 
;1028   WDT_DISABLE();  ipset3();
	.debug	# 1028
  ld  l,0x09
  ioi ld  (hl),0x51
  ioi ld  (hl),0x54
	ipset	3
;1029 
;1030   outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
	.debug	# 1030
	ld	a,0x80
	ioi ld	(16),a
;1031 
;1032   outi(STKCR, 0x00);  // disable hdw stack limit checks
	.debug	# 1032
	xor	a,a
	ioi ld	(1092),a
;1033   outi(WPCR, 0);      // disable write protection for System Mode
	.debug	# 1033
	xor	a,a
	ioi ld	(1088),a
;1034 
;1035   outi(WPSALR, 0);    // clear 4K write protection masks
	.debug	# 1035
	xor	a,a
	ioi ld	(1153),a
;1036   outi(WPSAHR, 0);    // clear 4K write protection masks
	.debug	# 1036
	xor	a,a
	ioi ld	(1154),a
;1037   outi(WPSBLR, 0);    // clear 4K write protection masks
	.debug	# 1037
	xor	a,a
	ioi ld	(1157),a
;1038   outi(WPSBHR, 0);    // clear 4K write protection masks
	.debug	# 1038
	xor	a,a
	ioi ld	(1158),a
;1039 
;1040   outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 1040
	xor	a,a
	ioi ld	(16),a
;1041 
;1042 
;1043 // The next statement maps flash to the first memory bank (usually 256K), s
;1044 // don't call any functions after this point that could possibly lead to an
;1045 // attempt to access something in the 1st memory bank (which basically mean
;1046 // NO function calls after this point!)
;1047 
;1048   outi(MB0CR, _CS0 | _OE0_WP | _WS4);
	.debug	# 1048
	ld	a,0x8
	ioi ld	(20),a
;1049 
;1050 #asm
	.debug	# 1051
ld     sp,0

	.debug	# 1053
xor    a,a

	.debug	# 1054
ld     eir,a

	.debug	# 1055
ld     iir,a

	.debug	# 1057
jp     0

;1059 
	.seg	FARCODE
;1060 }
@44:
	.debug	} @44 1060

@43	equ	0
	lret
@45	equ	0
;1061 
;1062 #pragma offset_labels on
;1063 #pragma warn -757
;1064 
;1065 //---------------------------------------------------------------
;1066 void softReset(void)
;1067 {
$softReset::
	.debug	G $softReset 37 9
	.debug	{ $softReset 37 1066 @48 @47
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-9
;1068   char far *bufAddr;
.bufAddr = -4
	.debug	L bufAddr -4 34
;1069   uchar  memBank;
.memBank = -5
	.debug	L memBank -5 3
;1070   uint  logBufAddr;
.logBufAddr = -7
	.debug	L logBufAddr -7 7
;1071   uchar  bufXPC, _4kblock;
.bufXPC = -8
	.debug	L bufXPC -8 3
._4kblock = -9
	.debug	L _4kblock -9 3
;1072 
;1073 
;1074 
;1075   if (!allowSoftReset)  {
	.debug	# 1075
	ld	a,(_allowSoftReset)
	or	a,a
	jr	nz,@49
;1076     printf("Soft Reset disabled - doing normal reset\r\n");
@50:
	.debug	< @50 @51
	.debug	# 1076
	ld	de,word (phys @1+281)
	ld	c,phys @1+281 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1077     REBOOT(true);
	.debug	# 1077
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
;1078   }
@51:
	.debug	>
;1079 
;1080   saveApplState();
@49:
	.debug	# 1080
	lcall	$saveApplState
;1081 
;1082   printf("\nFor PseduoReset func:\r\n");
	.debug	# 1082
	ld	de,word (phys @1+324)
	ld	c,phys @1+324 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1083   bufAddr = bb_xalloc(PseudoReset_FuncSize);  // highest addr unused xmem b
	.debug	# 1083
	ld	de,0x100
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1084 
;1085   _4kblock = (uchar)((ulong)bufAddr >> 12);
	.debug	# 1085
	ld	b,0
	ld	a,0xc
	call	__ulshr##
	ld	(ix-9),e
;1086   memBank = _4kblock >> 6;
	.debug	# 1086
	bool	hl
	ld	l,e
	ld	a,0x6
	call	__uishr##
	ld	(ix-5),l
;1087   logBufAddr = ((uint)(ulong)bufAddr & 0x0FFF) | 0xE000;
	.debug	# 1087
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	b,0
	ld	hl,0xfff
	and	hl,de
	ld	de,-8192
	or	hl,de
	ld	(ix-7),hl
;1088   bufXPC = _4kblock - 0x0E;
	.debug	# 1088
	ld	a,(ix-9)
	add	a,242
	ld	(ix-8),a
;1089 
;1090 //  printf("buffer for pseudoReset():\r\n"
;1091 //         "  bufAddr: 0x%05lX\r\n"
;1092 //         "  _4kblock: 0x%02X\r\n"
;1093 //         "  memBank: %u\r\n"
;1094 //         "  logBufAddr: 0x%04X\r\n"
;1095 //         "  bufXPC: 0x%02X\r\n",
;1096 //         (ulong)bufAddr, _4kblock, memBank, logBufAddr, bufXPC);
;1097 
;1098 // If the buffer for pseudoReset() is in the same bank that the flash needs
;1099 // then we can't use it
;1100   if (memBank == 0)  {
	.debug	# 1100
	ld	a,(ix-5)
	or	a,a
	jr	nz,@52
;1101     printf("Unable to perform softReset(), so doing normal reboot\r\n");
@53:
	.debug	< @53 @54
	.debug	# 1101
	ld	de,word (phys @1+349)
	ld	c,phys @1+349 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1102     REBOOT(true);
	.debug	# 1102
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
;1103   }
@54:
	.debug	>
;1104 
;1105   diagLogInfo->digOutState = digitalOut;
@52:
	.debug	# 1105
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x75
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	call	__farst4d##
;1106   diagLogInfo->didSoftReset = true;
	.debug	# 1106
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x74
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;1107 
;1108 //  ipset3();  ipset3();  ipset3();  ipset3();  // set IntPri "stack" to 0x
;1109 ;
;1110 #asm
	.debug	# 1114
ld      de,0x64

	.debug	# 1115
ld      c,d

	.debug	# 1116
ld      b,d

	.debug	# 1117
push    bc

	.debug	# 1118
push    de

	.debug	# 1121
ld      de,word (phys $pseudoReset)

	.debug	# 1122
ld      c,phys $pseudoReset >> 16

	.debug	# 1123
push    bc

	.debug	# 1124
push    de

	.debug	# 1127
ld      hl,(ix+.bufAddr)

	.debug	# 1128
ex      de,hl

	.debug	# 1129
ld      hl,(ix+.bufAddr+2)

	.debug	# 1130
ld      bc,hl

	.debug	# 1131
push    bc

	.debug	# 1132
push    de

	.debug	# 1134
lcall   $fmemcpy

	.debug	# 1136
add     sp,12

;1138 
	.seg	FARCODE
;1139 ;
;1140 #asm
	.debug	# 1142
ld     hl,(ix+.logBufAddr)  

	.debug	# 1143
push   hl

	.debug	# 1145
ld     hl,(ix+.bufXPC)      

	.debug	# 1146
ld     a,l

	.debug	# 1148
ld     xpc,a                

	.debug	# 1149
ret                         

;1154 
	.seg	FARCODE
;1155 }
@47:
	.debug	} @47 1155

@46	equ	9
	ld	sp,ix
	pop	ix
	lret
@48	equ	11
;1156 #pragma warn 757
;1157 #pragma offset_labels off
;1158 
;1159 
;1160 
;1161 //-------------------------------------------------------------------------
;1162 //  return pointer to a string description of the state of the specified ta
;1163 //-------------------------------------------------------------------------
;1164 char *statusDescr(PIX pix)
;1165 {
$statusDescr::
	.debug	G $statusDescr 39 9
	.debug	{ $statusDescr 39 1164 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A pix 5 6
;1166   uint  state;
	.debug	L state -2 7
;1167   task_t  *task;
	.debug	L task -4 41
;1168   char  *descr;
	.debug	L descr -6 40
;1169 
;1170 
;1171   task = tasks + pix;  state = task->state;
	.debug	# 1171
	ld	hl,(ix+5)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-4),hl
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
;1172 
;1173   do  {
;1174     if (! task->inUse)                      { descr = "Dead    ";  break; }
@61:
	.debug	< @61 @62
	.debug	# 1174
	ld	hl,(ix-4)
	ld	e,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@63
@64:
	.debug	< @64 @65
	ld	hl,@66
	jr	@976
@65:
	.debug	>
;1175 
;1176     if (state == TASK_RUNNING)              { descr = "Ready   ";  break; }
@63:
	.debug	# 1176
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@67
@68:
	.debug	< @68 @69
	ld	hl,@66+9
	jr	@976
@69:
	.debug	>
;1177 
;1178     if ((state == TASK_UNINTERRUPTIBLE) OR (state == TASK_INTERRUPTIBLE))  
@67:
	.debug	# 1178
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@70
	ld	hl,(ix-2)
	dec	e
	or	a,a
	sbc	hl,de
	jr	nz,@71
@70:
;1179       if (list_empty(&task->waitQs.listHead))  { descr = "Schedule";  break
@72:
	.debug	< @72 @73
	.debug	# 1179
	ld	hl,(ix-4)
	ld	de,0x9c
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x9c
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@74
	inc	l
@74:
	bool	hl
	jr	z,@75
@76:
	.debug	< @76 @77
	ld	hl,@66+18
	jr	@976
@77:
	.debug	>
;1180       if (task->sleepTicks)                 { descr = "Sleeping";  break; }
@75:
	.debug	# 1180
	ld	hl,(ix-4)
	ld	de,0xdc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@78
@79:
	.debug	< @79 @80
	ld	hl,@66+27
	jr	@976
@80:
	.debug	>
;1181       if (task->timeoutTicks)               { descr = "Blocked*";  break; }
@78:
	.debug	# 1181
	ld	hl,(ix-4)
	ld	de,0xe4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@81
@82:
	.debug	< @82 @83
	ld	hl,@66+36
	jr	@976
@83:
	.debug	>
;1182                                               descr = "Blocked ";  break;
@81:
	.debug	# 1182
	ld	hl,@66+45
@976:
	ld	(ix-6),hl
;1183     }
	jr	@59
@73:
	.debug	>
;1184                                               descr = "Stopped ";
@71:
	.debug	# 1184
	ld	hl,@66+54
	ld	(ix-6),hl
;1185   }  while (0);
@62:
	.debug	>
	.debug	# 1185
;1186 
;1187 
;1188   return descr;
@59:
	.debug	# 1188
	ld	hl,(ix-6)
;1189 }
@56:
	.debug	} @56 1189

@55	equ	6
	ld	sp,ix
	pop	ix
	lret
@57	equ	8
;1190 
;1191 //-------------------------------------------------------------------------
;1192 //  kill oldest "tsh" process so a newer one can be created
;1193 //-------------------------------------------------------------------------
;1194 void killOldestShell(void)
;1195 {
$killOldestShell::
	.debug	G $killOldestShell 37 9
	.debug	{ $killOldestShell 37 1194 @86 @85
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-58
;1196   PIX  pix;
	.debug	L pix -2 6
;1197   PID  pidOldest;
	.debug	L pidOldest -4 6
;1198   ulong  earliestStarted;
	.debug	L earliestStarted -8 9
;1199   task_t  *task;
	.debug	L task -10 41
;1200   void  *ioDev;
	.debug	L ioDev -12 43
;1201   FDEV  far *file;
	.debug	L file -16 44
;1202   struct stat  fsbuf;
	.debug	L fsbuf -58 46
;1203 
;1204 
;1205   earliestStarted = ULONG_MAX;  pidOldest = 0;
	.debug	# 1205
	ld	de,0xffff
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;1206 
;1207 //--- find earliest started "tsh" process using a socket for stdio ---
;1208   for (pix=0; pix<NUM_TASKS; ++pix)  {
@87:
	.debug	< @87 @88
	.debug	# 1208
	ld	(ix-2),hl
@89:
	ld	hl,(ix-2)
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@90
;1209     if (! (task = tasks + (uint)pix)->inUse)  continue;
@92:
	.debug	< @92 @93
	.debug	# 1209
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-10),hl
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@91
;1210     if (strcmp(task->argv[0], "tsh") != 0)  continue;
	.debug	# 1210
	ld	hl,@66+63
	push	hl
	ld	hl,(ix-10)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jp	nz,@91
;1211     if (! (file = FD[pix][0]))  continue;
	.debug	# 1211
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@91
;1212 
;1213     ioDev = file->ioDev;
	.debug	# 1213
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-12),hl
;1214     if (file->ioFuncs->fstat(ioDev, &fsbuf))  continue;
	.debug	# 1214
	ld	hl,-58+@84
	add	hl,sp
	push	hl
	ld	hl,(ix-12)
	push	hl
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	hl,(ix-16)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,de
	ld	de,0x8
	ex	de,hl
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,4
	bool	hl
	jr	nz,@91
;1215 
;1216     if (! S_ISSOCK(fsbuf.st_mode))  continue;
	.debug	# 1216
	ld	hl,(ix-50)
	ex	de,hl
	ld	hl,(ix-48)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@91
;1217 
;1218     if (task->started < earliestStarted)  {
	.debug	# 1218
	ld	hl,(ix-10)
	ld	de,0xbb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	nc,@99
;1219       pidOldest = task->pid;  earliestStarted = task->started;  }
@100:
	.debug	< @100 @101
	.debug	# 1219
	ld	hl,(ix-10)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-10)
	ld	e,0xbb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@101:
	.debug	>
;1220   }
@99:
@93:
	.debug	>
;1221 
;1222 
;1223   if (pidOldest)  kill(pidOldest, SIGKILL);
@91:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@89
@90:
@88:
	.debug	>
	.debug	# 1223
	ld	hl,(ix-4)
	bool	hl
	jr	z,@102
	ld	l,0x9
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$kill
	add	sp,4
;1224 }
@102:
@85:
	.debug	} @85 1224

@84	equ	58
	ld	sp,ix
	pop	ix
	lret
@86	equ	60
;1225 
;1226 
;1227 //-------------------------------------------------------------------------
;1228 //  Make a copy of the argument strings for a process
;1229 //  Returns 0 on success, < 0 if an error
;1230 //-------------------------------------------------------------------------
;1231 int copyArgs(task_t *task, int argc, char **argv)
;1232 {
$copyArgs::
	.debug	G $copyArgs 47 9
	.debug	{ $copyArgs 47 1231 @105 @104
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A task 5 41
	.debug	A argc 7 6
	.debug	A argv 9 48
;1233   int  i, argBytes;
	.debug	L i -2 6
	.debug	L argBytes -4 6
;1234   char  *fromPtr, *toPtr;
	.debug	L fromPtr -6 40
	.debug	L toPtr -8 40
;1235 
;1236 //--- copy cmd line parameters ---
;1237   for (i=0,argBytes=0; i<argc; ++i)  argBytes += strlen(argv[i]) + 1;
@106:
	.debug	< @106 @107
	.debug	# 1237
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	(ix-4),hl
@108:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@109
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strlen
	pop	de
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
;1238   argBytes += (argc+1) * sizeof(char *);
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@108
@109:
@107:
	.debug	>
	.debug	# 1238
	ld	hl,(ix+7)
	inc	hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
;1239   if (argBytes > MaxArgBytes)  {
	.debug	# 1239
	ld	de,0x8080
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@111
	jr	z,@111
;1240     printf("Argument list too long\r\n");  return -1;  }
@112:
	.debug	< @112 @113
	.debug	# 1240
	ld	de,word (phys @1+405)
	ld	c,phys @1+405 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	jp	@104
@113:
	.debug	>
;1241 
;1242   toPtr = task->args;
@111:
	.debug	# 1242
	ld	hl,(ix+5)
	ld	de,0x1c
	add	hl,de
	ld	(ix-8),hl
;1243   task->argv = (char **)toPtr;  toPtr += (argc+1) * sizeof(char *);
	.debug	# 1243
	ld	hl,(ix+5)
	ld	e,0x1a
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+7)
	inc	hl
	add	hl,hl
	add	hl,de
	ld	(ix-8),hl
;1244   for (i=0; i<argc; ++i)  {
@114:
	.debug	< @114 @115
	.debug	# 1244
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@116:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	nc,@117
;1245     task->argv[i] = toPtr;  fromPtr = argv[i];
@119:
	.debug	< @119 @120
	.debug	# 1245
	ld	hl,(ix+5)
	ld	de,0x1a
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
;1246     while (*fromPtr)  *toPtr++ = *fromPtr++;
@121:
	.debug	# 1246
	ld	hl,(ix-6)
	ld	a,(hl)
	or	a,a
	jr	z,@122
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	inc	de
	ex	de,hl
	ld	(ix-8),hl
	dec	hl
	ld	a,(de)
	ld	(hl),a
;1247     *toPtr++ = 0;
	jr	@121
@122:
	.debug	# 1247
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	dec	hl
	xor	a,a
	ld	(hl),a
;1248 //     printf("(%lu)(%lu)<%s>\r\n", (ulong)task->argv[i], (ulong)argv[i], t
;1249   }
@120:
	.debug	>
;1250   task->argv[argc] = NULL;  task->argc = argc;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@116
@117:
@115:
	.debug	>
	.debug	# 1250
	ld	hl,(ix+5)
	ld	de,0x1a
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	add	hl,hl
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0x18
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1251 
;1252   return 0;
	.debug	# 1252
	bool	hl
	ld	l,h
;1253 }
@104:
	.debug	} @104 1253

@103	equ	8
	ld	sp,ix
	pop	ix
	lret
@105	equ	10
;1254 
;1255 //-------------------------------------------------------------------------
;1256 //  create a new DEBROS process
;1257 //-------------------------------------------------------------------------
;1258 PID createProc(ProcMain procMain, char priority, int argc, char **argv,
;1259                fd_t infd, fd_t outfd, fd_t errfd)
;1260 {
$createProc::
	.debug	G $createProc 49 9
	.debug	{ $createProc 49 1258 @125 @124
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-13
	.debug	A procMain 5 50
	.debug	A priority 7 3
	.debug	A argc 9 6
	.debug	A argv 11 48
	.debug	A infd 13 6
	.debug	A outfd 15 6
	.debug	A errfd 17 6
;1261   PID  pid;
	.debug	L pid -2 6
;1262   PIX  i, j, pix;
	.debug	L i -4 6
	.debug	L j -6 6
	.debug	L pix -8 6
;1263   task_t  *task;
	.debug	L task -10 41
;1264   FDEV far  **fdPtr;
	.debug	L fdPtr -12 52
;1265   uchar  pass;
	.debug	L pass -13 3
;1266 
;1267 
;1268   KLOCK();
	.debug	# 1268
	call	_KLOCK
;1269 
;1270 //--- determine if there is an unused entry in the process table ---
;1271 //--- (use round-robin pattern to minimize reuse of the same slot) ---
;1272   for (pass=0; pass<3; ++pass)  {
@126:
	.debug	< @126 @127
	.debug	# 1272
	xor	a,a
	ld	(ix-13),a
@128:
	ld	a,(ix-13)
	sub	a,3
	jp	nc,@129
;1273     for (pix=lastTaskIdx,j=0; j<=NUM_TASKS; ++j)  {
@131:
	.debug	< @131 @132
@133:
	.debug	< @133 @134
	.debug	# 1273
	ld	hl,(_lastTaskIdx)
	ld	(ix-8),hl
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@135:
	ld	hl,(ix-6)
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@137
	jr	nc,@136
@137:
;1274       if (++pix == NUM_TASKS)  pix = 0;
@139:
	.debug	< @139 @140
	.debug	# 1274
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	ld	d,0
	or	a,a
	sbc	hl,de
	jr	nz,@141
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;1275       if (! (task = tasks + (uint)pix)->claimed)  break;
@141:
	.debug	# 1275
	ld	hl,(ix-8)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-10),hl
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@136
;1276     }
@140:
	.debug	>
;1277     if (task->claimed)  {
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@135
@136:
@134:
	.debug	>
	.debug	# 1277
	ld	hl,(ix-10)
	ld	de,0x12
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@129
;1278       KUNLOCK();
@144:
	.debug	< @144 @145
	.debug	# 1278
	call	_KUNLOCK
;1279       if (strcmp(argv[0], "tsh") == 0)  {
	.debug	# 1279
	ld	hl,@66+63
	push	hl
	ld	hl,(ix+11)
	ld	hl,(hl)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@146
;1280         killOldestShell();  sleepMS(500);  KLOCK();  continue; }
@147:
	.debug	< @147 @148
	.debug	# 1280
	lcall	$killOldestShell
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
	jr	@130
@148:
	.debug	>
;1281       printf("\r\nUnable to create process for: %.20s\r\n", argv[0]);
@146:
	.debug	# 1281
	ld	hl,(ix+11)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+430)
	ld	c,phys @1+430 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1282       return -1;
	.debug	# 1282
	jr	@975
;1283     }
@145:
	.debug	>
;1284     break;
	.debug	# 1284
;1285   }
@132:
	.debug	>
;1286   lastTaskIdx = pix;  task->claimed = true;
@130:
	ld	a,(ix-13)
	inc	a
	ld	(ix-13),a
	jp	@128
@129:
@127:
	.debug	>
	.debug	# 1286
	ld	hl,(ix-8)
	ld	(_lastTaskIdx),hl
	ld	hl,(ix-10)
	ld	de,0x12
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;1287 
;1288   KUNLOCK();
	.debug	# 1288
	call	_KUNLOCK
;1289 
;1290   memset(&task->zeroAfter, 0, sizeof(task_t) - offsetof(task_t, zeroAfter))
	.debug	# 1290
	ld	hl,0xd1
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-10)
	ld	de,0x17
	add	hl,de
	push	hl
	call	_memset
	add	sp,6
;1291 
;1292   if (copyArgs(task, argc, argv))  { task->claimed = false;  return -1; }
	.debug	# 1292
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix-10)
	push	hl
	lcall	$copyArgs
	add	sp,6
	bool	hl
	jr	z,@149
@150:
	.debug	< @150 @151
	ld	hl,(ix-10)
	ld	de,0x12
	add	hl,de
	xor	a,a
	ld	(hl),a
@975:
	ld	hl,0xffff
	jp	@124
@151:
	.debug	>
;1293 
;1294 //  printf("createProc: ");
;1295 //  for (i=0; i<task->argc; ++i)  printf("[%s] ", task->argv[i]);
;1296 //  printf("\r\n");
;1297 
;1298 //--- Create a pid for this process.  The pid is made up of the index into 
;1299 //--- the process table and the # of times the slot has been used.  This --
;1300 //--- avoids resuse of a pid too quickly, but the index in to the table ---
;1301 //--- can still be determined with a simple mask rather than a search ---
;1302   pid = (int)pix + task->useCount * (TaskIdxMask+1);  ++task->useCount;
@149:
	.debug	# 1302
	ld	hl,(ix-10)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
	ld	hl,(ix-10)
	ld	de,0x11
	add	hl,de
	ld	a,(hl)
	inc	a
	ld	(hl),a
;1303 
;1304   if (priority >= NUM_PRIORITIES)  priority = NUM_PRIORITIES - 1;
	.debug	# 1304
	ld	a,(ix+7)
	sub	a,16
	jr	c,@152
	ld	(ix+7),0xf
;1305 
;1306 // ***** IMPORTANT *****
;1307 //--- anything new or changed here must be done in main() for the kernel --
;1308 //--- process as well ---
;1309 
;1310 //--- initialize settings for the new process ---
;1311   task->diagFlags = newTaskDiagFlags;
@152:
	.debug	# 1311
	ld	hl,(ix-10)
	ld	de,0xae
	add	hl,de
	ld	de,(_newTaskDiagFlags)
	ld	bc,(_newTaskDiagFlags+2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1312   task->pid = pid;
	.debug	# 1312
	ld	hl,(ix-10)
	ld	de,0xb4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1313   task->ppid = current->pid;
	.debug	# 1313
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xb6
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1314   task->priority = priority;
	.debug	# 1314
	ld	hl,(ix-10)
	ld	de,0xb8
	add	hl,de
	ld	a,(ix+7)
	ld	(hl),a
;1315   task->outPtr = outBuf[(uint)pix];
	.debug	# 1315
	ld	hl,(ix-8)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x7
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _outBuf)
	ld	c,phys _outBuf >> 16
	call	__ladd##
	ld	hl,(ix-10)
	push	de
	ld	de,0xd8
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1316   task->procMain = procMain;
	.debug	# 1316
	ld	hl,(ix-10)
	ld	de,0xb2
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1317   task->FDSet = (void far **) FD[(uint)pix];
	.debug	# 1317
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xf
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1318 
;1319   KLOCK();
	.debug	# 1319
	call	_KLOCK
;1320 
;1321 //--- copy the specified fd's for stdin, stdout, stderr ---
;1322   FD[pix][0] = FD[userPix][infd];
	.debug	# 1322
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+13)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_FD
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1323   FD[pix][1] = FD[userPix][outfd];
	.debug	# 1323
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+15)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_FD
	add	hl,de
	ld	de,0x4
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1324   FD[pix][2] = FD[userPix][errfd];
	.debug	# 1324
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+17)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_FD
	add	hl,de
	ld	de,0x8
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1325 
;1326 //--- increment the openCount for each file referenced ---
;1327   fdPtr = FD[pix];
	.debug	# 1327
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ld	(ix-12),hl
;1328   for (i=0; i<3; ++i)  if (fdPtr[i])  ++fdPtr[i]->openCount;
@153:
	.debug	< @153 @154
	.debug	# 1328
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@155:
	ld	hl,(ix-4)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@156
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@158
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	__farld2##
	inc	de
	ex	de,hl
	pop	de
	pop	bc
	call	__farst2##
;1329 
;1330   KUNLOCK();
@158:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@155
@156:
@154:
	.debug	>
	.debug	# 1330
	call	_KUNLOCK
;1331 
;1332 
;1333   task->started = readRTC(NULL);
	.debug	# 1333
	bool	hl
	ld	l,h
	push	hl
	lcall	$readRTC
	pop	hl
	ld	hl,(ix-10)
	push	de
	ld	de,0xbb
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1334   task->lastResumed = task->lastStopped = 0;
	.debug	# 1334
	ld	hl,(ix-10)
	ld	de,0xc3
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-10)
	push	de
	ld	de,0xbf
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1335   task->resumedTicks = clockTicks();
	.debug	# 1335
	lcall	$clockTicks
	ld	hl,(ix-10)
	push	de
	ld	de,0xcb
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1336 
;1337 
;1338   init_waitqueue_head(&task->waitQs);
	.debug	# 1338
	ld	hl,(ix-10)
	ld	de,0x9c
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;1339 
;1340   task->inUse = true;
	.debug	# 1340
	ld	hl,(ix-10)
	ld	de,0xaa
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;1341 
;1342   reset_task(pix);  // prep task for running
	.debug	# 1342
	ld	hl,(ix-8)
	push	hl
	lcall	$reset_task
	pop	de
;1343 
;1344   fprintf(DiagLog, "Created process #%d (", pid);
	.debug	# 1344
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+470)
	ld	c,phys @1+470 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1345   for (i=0; i<argc; ++i)  fprintf(DiagLog, " %s", argv[i]);
@159:
	.debug	< @159 @160
	.debug	# 1345
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@161:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@162
	ld	hl,(ix-4)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+492)
	ld	c,phys @1+492 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;1346   fprintf(DiagLog, " )\n");
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@161
@162:
@160:
	.debug	>
	.debug	# 1346
	ld	de,word (phys @1+496)
	ld	c,phys @1+496 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1347 
;1348   _EnterCritical_();  task->state = TASK_RUNNING;  _ExitCritical_();
	.debug	# 1348
	ipset	2
	ld	hl,(ix-10)
	ld	de,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
;1349 
;1350   return pid;
	.debug	# 1350
	ld	hl,(ix-2)
;1351 }
@124:
	.debug	} @124 1351

@123	equ	13
	ld	sp,ix
	pop	ix
	lret
@125	equ	15
;1352 
;1353 
;1354 //-------------------------------------------------------------------------
;1355 //  Determine if a given process id is for an active process
;1356 //
;1357 //  Returns the index if the process id is valid and belongs to a running
;1358 //  or blocked process.  Otherwise it sets errno and returns -1.
;1359 //-------------------------------------------------------------------------
;1360 PIX _activeTaskIdx_(PID pid)
;1361 {
$_activeTaskIdx_::
	.debug	G $_activeTaskIdx_ 53 9
	.debug	{ $_activeTaskIdx_ 53 1360 @166 @165
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pid 5 6
;1362   task_t  *task;
	.debug	L task -2 41
;1363   PIX  pix;
	.debug	L pix -4 6
;1364 
;1365 
;1366   if (pid < 0)  { ERRNO = ESRCH;  return -1; }
	.debug	# 1366
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@974
@168:
	.debug	< @168 @169
@169:
	.debug	>
;1367 
;1368   pix = TaskIdx(pid);
	.debug	# 1368
	ld	hl,(ix+5)
	ld	de,0x1f
	and	hl,de
	ld	(ix-4),hl
;1369 
;1370   if (pix >= NUM_TASKS)  { ERRNO = ESRCH;  return -1; }
	.debug	# 1370
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@974
@171:
	.debug	< @171 @172
@172:
	.debug	>
;1371 
;1372   task = tasks + (uint)pix;
	.debug	# 1372
	ld	hl,(ix-4)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-2),hl
;1373 
;1374   if (task->pid != pid)  { ERRNO = ESRCH;  return -1; }  // slot reused?
	.debug	# 1374
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@173
@174:
	.debug	< @174 @175
@974:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@973
@175:
	.debug	>
;1375 
;1376   if (! task->inUse)  { ERRNO = ESRCH;  return -1; }  // no longer a proces
@173:
	.debug	# 1376
	ld	hl,(ix-2)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@176
@177:
	.debug	< @177 @178
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
@973:
	ld	e,0x3
	jr	@972
@178:
	.debug	>
;1377 
;1378   if (!ActiveTask(task))  { ERRNO = ESRCH;  return -1; }  // dead process?
@176:
	.debug	# 1378
	ld	hl,(ix-2)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	or	a,a
	sbc	hl,de
	jr	c,@179
@180:
	.debug	< @180 @181
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x3
@972:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@165
@181:
	.debug	>
;1379 
;1380   return pix;
@179:
	.debug	# 1380
	ld	hl,(ix-4)
;1381 }
@165:
	.debug	} @165 1381

@164	equ	4
	ld	sp,ix
	pop	ix
	lret
@166	equ	6
;1382 
;1383 
;1384 //-------------------------------------------------------------------------
;1385 //  Determine if a given process id is for an active process
;1386 //
;1387 //  Returns the index if the process id is valid and belongs to a running
;1388 //  or blocked process.  Otherwise it sets errno and returns -1.
;1389 //-------------------------------------------------------------------------
;1390 PIX _inUseTaskIdx_(PID pid)
;1391 {
$_inUseTaskIdx_::
	.debug	G $_inUseTaskIdx_ 53 9
	.debug	{ $_inUseTaskIdx_ 53 1390 @184 @183
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pid 5 6
;1392   task_t  *task;
	.debug	L task -2 41
;1393   PIX  pix;
	.debug	L pix -4 6
;1394 
;1395 
;1396   if (pid < 0)  { ERRNO = ESRCH;  return -1; }
	.debug	# 1396
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@971
@186:
	.debug	< @186 @187
@187:
	.debug	>
;1397 
;1398   pix = TaskIdx(pid);
	.debug	# 1398
	ld	hl,(ix+5)
	ld	de,0x1f
	and	hl,de
	ld	(ix-4),hl
;1399 
;1400   if (pix >= NUM_TASKS)  { ERRNO = ESRCH;  return -1; }
	.debug	# 1400
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@188
@189:
	.debug	< @189 @190
@971:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@970
@190:
	.debug	>
;1401 
;1402   task = tasks + (uint)pix;
@188:
	.debug	# 1402
	ld	hl,(ix-4)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-2),hl
;1403 
;1404   if (task->pid != pid)  { ERRNO = ESRCH;  return -1; }  // slot reused?
	.debug	# 1404
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@191
@192:
	.debug	< @192 @193
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@970:
	ld	e,0x3
	jr	@969
@193:
	.debug	>
;1405 
;1406   if (! task->inUse)  { ERRNO = ESRCH;  return -1; }  // no longer a proces
@191:
	.debug	# 1406
	ld	hl,(ix-2)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@194
@195:
	.debug	< @195 @196
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x3
@969:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@183
@196:
	.debug	>
;1407 
;1408   return pix;
@194:
	.debug	# 1408
	ld	hl,(ix-4)
;1409 }
@183:
	.debug	} @183 1409

@182	equ	4
	ld	sp,ix
	pop	ix
	lret
@184	equ	6
;1410 
;1411 
;1412 //-------------------------------------------------------------------------
;1413 //  Determine the number of unused bytes on an active process' stack
;1414 //  process id.
;1415 //
;1416 //  Returns amount of stack unused if the process id is for an active proce
;1417 //  or -1 if an error.
;1418 //-------------------------------------------------------------------------
;1419 int _stackFree_(PID pid)
;1420 {
$_stackFree_::
	.debug	G $_stackFree_ 53 9
	.debug	{ $_stackFree_ 53 1419 @199 @198
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pid 5 6
;1421   PIX  pix;
	.debug	L pix -2 6
;1422   int  unused;
	.debug	L unused -4 6
;1423 
;1424 
;1425   if ((pix = _inUseTaskIdx_(pid)) < 0)  return -1;
	.debug	# 1425
	ld	hl,(ix+5)
	push	hl
	lcall	$_inUseTaskIdx_
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@200
	ld	hl,0xffff
	jr	@198
;1426 
;1427   unused = check_stack(pix);
@200:
	.debug	# 1427
	ld	hl,(ix-2)
	push	hl
	lcall	$check_stack
	pop	de
	ld	(ix-4),hl
;1428 
;1429   return unused;
	.debug	# 1429
;1430 }
@198:
	.debug	} @198 1430

@197	equ	4
	ld	sp,ix
	pop	ix
	lret
@199	equ	6
;1431 
;1432 
;1433 //-------------------------------------------------------------------------
;1434 //  Get the Program Counter for the current task
;1435 //-------------------------------------------------------------------------
;1436 uint getPC(void)
;1437 {
$getPC::
	.debug	G $getPC 54 9
	.debug	{ $getPC 54 1436 @203 @202
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1438   uint  sp;
	.debug	L sp -2 7
;1439 
;1440   sp = _asm( [_HL], "ld hl,ix", _HL ) + 2; // IX itself is pushed, using 2 
	.debug	# 1440
ld hl,ix
	inc	hl
	inc	hl
	ld	(ix-2),hl
;1441   return *((uint *)sp);
	.debug	# 1441
	ld	hl,(hl)
;1442 }
@202:
	.debug	} @202 1442

@201	equ	2
	ld	sp,ix
	pop	ix
	lret
@203	equ	4
;1443 
;1444 //-------------------------------------------------------------------------
;1445 //  return a count of the # of active tasks
;1446 //-------------------------------------------------------------------------
;1447 int numActiveTasks(void)
;1448 {
$numActiveTasks::
	.debug	G $numActiveTasks 55 9
	.debug	{ $numActiveTasks 55 1447 @206 @205
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1449   task_t  *task;
	.debug	L task -2 41
;1450   int  count;
	.debug	L count -4 6
;1451 
;1452   for (count=0,task=tasks; task<endTasks; ++task)  if (task->inUse)  ++coun
@207:
	.debug	< @207 @208
	.debug	# 1452
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	hl,_tasks
	ld	(ix-2),hl
@209:
	ld	hl,(ix-2)
	ld	de,(_endTasks)
	or	a,a
	sbc	hl,de
	jr	nc,@210
	ld	hl,(ix-2)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@212
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
;1453 
;1454   return count;
@212:
	ld	hl,(ix-2)
	ld	de,0xe8
	add	hl,de
	ld	(ix-2),hl
	jr	@209
@210:
@208:
	.debug	>
	.debug	# 1454
	ld	hl,(ix-4)
;1455 }
@205:
	.debug	} @205 1455

@204	equ	4
	ld	sp,ix
	pop	ix
	lret
@206	equ	6
;1456 
;1457 
;1458 //-------------------------------------------------------------------------
;1459 //  Kill a process and clean up after it
;1460 //
;1461 //  NOTE:  Will NOT kill the kernel or the idle task
;1462 //-------------------------------------------------------------------------
;1463 void _killTask_(task_t *task)
;1464 {
$_killTask_::
	.debug	G $_killTask_ 56 9
	.debug	{ $_killTask_ 56 1463 @215 @214
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A task 5 41
;1465   uint  i;
	.debug	L i -2 7
;1466   int  pid;
	.debug	L pid -4 6
;1467   task_t  *childTask;
	.debug	L childTask -6 41
;1468 
;1469 
;1470   if (! task->inUse)  return;
	.debug	# 1470
	ld	hl,(ix+5)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@214
;1471 
;1472 //--- kernel and idle tasks must NOT be killed ---
;1473   if ((task == kernelTask) OR (task == idleTask))  return;
	.debug	# 1473
	ld	hl,(_kernelTask)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@217
	ld	hl,(_idleTask)
	or	a,a
	sbc	hl,de
	jr	nz,@218
@217:
;1474 
;1475 //  if (strcmp(task->argv[0], "syslog") == 0)  return;  //tdebug
;1476 
;1477 
;1478   pid = task->pid;
	jp	@214
@218:
	.debug	# 1478
	ld	hl,(ix+5)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
;1479 
;1480   if (task != current)  {
	.debug	# 1480
	ld	hl,(_current)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@219
;1481     fprintf(DiagLog, "killing process %.20s[%d]\r\n", task->argv[0], pid);
@220:
	.debug	< @220 @221
	.debug	# 1481
	ld	hl,(ix-4)
	push	hl
	ld	h,d
	ld	l,e
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+500)
	ld	c,phys @1+500 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1482     KLOCK();  task->preempt_count = 0;  task->state = EXIT_DEAD;  KUNLOCK()
	.debug	# 1482
	call	_KLOCK
	ld	hl,(ix+5)
	ld	de,0xa8
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0x13
	add	hl,de
	ld	e,0x20
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	_KUNLOCK
;1483   }
@221:
	.debug	>
;1484 
;1485 //  fprintf(DiagLog, "  pending: 0x%08lX  blocked: 0x%08lX\r\n",  //tdebug
;1486 //          (ulong)task->sig_pending, (ulong)task->sig_blocked);  //tdebug
;1487 
;1488 
;1489 //--- remove all the nodes from any queues the task might be in ---
;1490   KLOCK();
@219:
	.debug	# 1490
	call	_KLOCK
;1491   task->timeoutTicks = 0;
	.debug	# 1491
	ld	hl,(ix+5)
	ld	de,0xe4
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1492   removeFromQueues(task, true);
	.debug	# 1492
	ld	hl,0x1
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$removeFromQueues
	add	sp,4
;1493   KUNLOCK();
	.debug	# 1493
	call	_KUNLOCK
;1494 
;1495 //--- close all of the process' descriptors ---
;1496   for (i=0; i<FD_SETSIZE; ++i)  _closeFD_(task, i);
@222:
	.debug	< @222 @223
	.debug	# 1496
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@224:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@225
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$_closeFD_
	add	sp,4
;1497 
;1498   KLOCK();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@224
@225:
@223:
	.debug	>
	.debug	# 1498
	call	_KLOCK
;1499 
;1500 //--- if the process has any child processes, then change their parent ---
;1501 //--- process id's to -1 ---
;1502   for (childTask=tasks; childTask<endTasks; ++childTask)  {
@227:
	.debug	< @227 @228
	.debug	# 1502
	ld	hl,_tasks
	ld	(ix-6),hl
@229:
	ld	hl,(ix-6)
	ld	de,(_endTasks)
	or	a,a
	sbc	hl,de
	jr	nc,@230
;1503     if (! childTask->inUse)  continue;
@232:
	.debug	< @232 @233
	.debug	# 1503
	ld	hl,(ix-6)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@231
;1504     if (childTask->ppid == pid)  childTask->ppid = -1;
	.debug	# 1504
	ld	hl,(ix-6)
	ld	e,0xb6
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@235
	ld	hl,(ix-6)
	ld	de,0xb6
	add	hl,de
	ld	de,0xffff
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1505   }
@235:
@233:
	.debug	>
;1506 
;1507 //finish - need generic method for handling real-time scheduling
;1508   if (current == applTask)  {
@231:
	ld	hl,(ix-6)
	ld	de,0xe8
	add	hl,de
	ld	(ix-6),hl
	jr	@229
@230:
@228:
	.debug	>
	.debug	# 1508
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@236
;1509     _EnterCritical_();  applTask = NULL;  _ExitCritical_(); }
@237:
	.debug	< @237 @238
	.debug	# 1509
	ipset	2
	bool	hl
	ld	l,h
	ld	(_applTask),hl
	ipres
@238:
	.debug	>
;1510 
;1511 //--- cancel the task and mark the process table entry as free for use ---
;1512   task->preempt_count = 0;  task->state = TASK_DEAD;
@236:
	.debug	# 1512
	ld	hl,(ix+5)
	ld	de,0xa8
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0x13
	add	hl,de
	ld	e,0x80
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1513   task->inUse = task->claimed = false;
	.debug	# 1513
	ld	hl,(ix+5)
	ld	e,0x12
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix+5)
	ld	e,0xaa
	add	hl,de
	ld	(hl),a
;1514 
;1515   KUNLOCK();
	.debug	# 1515
	call	_KUNLOCK
;1516 
;1517   if (task == current)  for (;;)  schedule();
	.debug	# 1517
	ld	hl,(_current)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@239
@240:
	.debug	< @240 @241
@242:
	lcall	$schedule
;1518 }
	jr	@242
@241:
	.debug	>
@239:
@214:
	.debug	} @214 1518

@213	equ	6
	ld	sp,ix
	pop	ix
	lret
@215	equ	8
;1519 
;1520 
;1521 //-------------------------------------------------------------------------
;1522 //  exit the calling process
;1523 //-------------------------------------------------------------------------
;1524 void Exit(int stat)
;1525 {
$Exit::
	.debug	G $Exit 57 9
	.debug	{ $Exit 57 1524 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A stat 5 6
;1526   int  stkFree;
	.debug	L stkFree -2 6
;1527 
;1528 
;1529   current->exit = stat;
	.debug	# 1529
	ld	hl,(_current)
	ld	de,0xab
	add	hl,de
	ld	a,(ix+5)
	ld	(hl),a
;1530 
;1531   stkFree = _stackFree_(getpid());
	.debug	# 1531
	ld	hl,(_current)
	ld	e,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$_stackFree_
	pop	de
	ld	(ix-2),hl
;1532   fprintf(DiagLog, "exiting with status: %d, %d stack free\n", stat, stkFre
	.debug	# 1532
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+528)
	ld	c,phys @1+528 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1533 
;1534   if (stkFree < 1)
	.debug	# 1534
	ld	hl,(ix-2)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@248
;1535     fprintf(DiagLog, "***** !!! overflowed its stack !!! *****\n");
	.debug	# 1535
	ld	de,word (phys @1+568)
	ld	c,phys @1+568 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1536 
;1537 //finish: need to deal with informing parent process, zombie procs, etc...
;1538 
;1539   fflush(stdout);
@248:
	.debug	# 1539
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;1540 
;1541   _killTask_(current);
	.debug	# 1541
	ld	hl,(_current)
	push	hl
	lcall	$_killTask_
	pop	hl
;1542 }
@246:
	.debug	} @246 1542

@245	equ	2
	ld	sp,ix
	pop	ix
	lret
@247	equ	4
;1543 
;1544 //-------------------------------------------------------------------------
;1545 //  Unix-compatible version of sethostname() (unfortunately, the Softools p
;1546 //  of the DC libs already uses the standard name...)
;1547 //-------------------------------------------------------------------------
;1548 int SetHostName(char *name, int nameLen)
;1549 {
$SetHostName::
	.debug	G $SetHostName 58 9
	.debug	{ $SetHostName 58 1548 @251 @250
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A name 5 40
	.debug	A nameLen 7 6
;1550   if (!name)  { errno = EFAULT;  return -1; }
	.debug	# 1550
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@252
@253:
	.debug	< @253 @254
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xe
	jr	@968
@254:
	.debug	>
;1551   if ((nameLen >= sizeof(hostName)) OR (nameLen < 1))  {
@252:
	.debug	# 1551
	ld	hl,(ix+7)
	ld	de,0x8020
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@255
	ld	hl,(ix+7)
	ld	e,0x1
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@256
@255:
;1552     errno = EINVAL;  return -1; }
@257:
	.debug	< @257 @258
	.debug	# 1552
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@968:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@250
@258:
	.debug	>
;1553 
;1554   if (nameLen >= HostNameLen)  nameLen = HostNameLen - 1;
@256:
	.debug	# 1554
	ld	hl,(ix+7)
	ld	de,0x8020
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@259
	ld	hl,0x1f
	ld	(ix+7),hl
;1555 
;1556   KLOCK();
@259:
	.debug	# 1556
	call	_KLOCK
;1557 
;1558   if (name != hostName)  {  // skip copy if src addr same as dest
	.debug	# 1558
	ld	hl,_hostName
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@260
;1559     memcpy(hostName, name, nameLen);  hostName[nameLen] = 0;  }
@261:
	.debug	< @261 @262
	.debug	# 1559
	ld	hl,(ix+7)
	push	hl
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,_hostName
	push	hl
	call	_memcpy
	add	sp,6
	ld	hl,(ix+7)
	ld	de,_hostName
	add	hl,de
	xor	a,a
	ld	(hl),a
@262:
	.debug	>
;1560 
;1561   resetWDT();
@260:
	.debug	# 1561
	lcall	$resetWDT
;1562 
;1563   sethostname(hostName);  ffile_setName(hostName);
	.debug	# 1563
	ld	hl,_hostName
	push	hl
	lcall	$sethostname
	pop	de
	ld	hl,_hostName
	push	hl
	lcall	$ffile_setName
	pop	de
;1564 
;1565   KUNLOCK();
	.debug	# 1565
	call	_KUNLOCK
;1566 
;1567   resetAnnounceInterval();  // announce the change ASAP
	.debug	# 1567
	lcall	$resetAnnounceInterval
;1568 
;1569   return 0;
	.debug	# 1569
	bool	hl
	ld	l,h
;1570 }
@250:
	.debug	} @250 1570

@249	equ	0
	pop	ix
	lret
@251	equ	2
;1571 
;1572 //-------------------------------------------------------------------------
;1573 //  Kernel-space function to send a signal to a process
;1574 //-------------------------------------------------------------------------
;1575 int kill(PID pid, int sig)
;1576 {
$kill::
	.debug	G $kill 59 9
	.debug	{ $kill 59 1575 @265 @264
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A pid 5 6
	.debug	A sig 7 6
;1577   PIX  pix;
	.debug	L pix -2 6
;1578   task_t  *task;
	.debug	L task -4 41
;1579   sigset_t  sigSet;
	.debug	L sigSet -8 9
;1580 
;1581 
;1582 
;1583   if ((sig < 0) OR (sig > 31))  { errno = EINVAL;  return -1; }
	.debug	# 1583
	ld	hl,(ix+7)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@266
	ld	hl,(ix+7)
	ld	e,0x1f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@267
	jr	z,@267
@266:
@268:
	.debug	< @268 @269
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jp	@967
@269:
	.debug	>
;1584 
;1585   sigSet = sigmask(sig);
@267:
	.debug	# 1585
	ld	hl,(ix+7)
	dec	hl
	ld	a,l
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__lshl##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;1586 
;1587   KLOCK();
	.debug	# 1587
	call	_KLOCK
;1588 
;1589 //--- deliver signal to ALL tasks? ---
;1590   if (pid == -1)  {
	.debug	# 1590
	ld	hl,(ix+5)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@270
;1591     for (task=tasks; task!=endTasks; ++task)
@271:
	.debug	< @271 @272
@273:
	.debug	< @273 @274
	.debug	# 1591
	ld	hl,_tasks
	ld	(ix-4),hl
@275:
	ld	hl,(_endTasks)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@276
;1592       if (task->inUse)  task->sig_pending |= sigSet;
	.debug	# 1592
	ld	h,d
	ld	l,e
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@278
	ld	hl,(ix-4)
	ld	e,0xa0
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1593     KUNLOCK();  return 0;
@278:
	ld	hl,(ix-4)
	ld	de,0xe8
	add	hl,de
	ld	(ix-4),hl
	jr	@275
@276:
@274:
	.debug	>
	.debug	# 1593
	call	_KUNLOCK
	bool	hl
	ld	l,h
	jr	@264
;1594   }
@272:
	.debug	>
;1595 
;1596 //--- does the target process still exist? ---
;1597   if ((pix = _inUseTaskIdx_(pid)) < 0)  {
@270:
	.debug	# 1597
	ld	hl,(ix+5)
	push	hl
	lcall	$_inUseTaskIdx_
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@279
;1598     KUNLOCK();  errno = ESRCH;  return -1; }
@280:
	.debug	< @280 @281
	.debug	# 1598
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3
@967:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@264
@281:
	.debug	>
;1599 
;1600   task = tasks + pix;
@279:
	.debug	# 1600
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-4),hl
;1601 
;1602 //finish: LOTS  more to do (check for blocked signals, signal handler, etc)
;1603 
;1604   task->sig_pending |= sigSet;
	.debug	# 1604
	ld	de,0xa0
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1605 
;1606 
;1607   KUNLOCK();  return 0;
	.debug	# 1607
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1608 }
@264:
	.debug	} @264 1608

@263	equ	8
	ld	sp,ix
	pop	ix
	lret
@265	equ	10
;1609 
;1610 //-------------------------------------------------------------------------
;1611 //  kernel-space function to wait for a child process to exit
;1612 //-------------------------------------------------------------------------
;1613 PID waitpid(PID pid, int *status, int options)
;1614 {
$waitpid::
	.debug	G $waitpid 60 9
	.debug	{ $waitpid 60 1613 @284 @283
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A pid 5 6
	.debug	A status 7 61
	.debug	A options 9 6
;1615   int  pix;
	.debug	L pix -2 6
;1616   task_t  *childTask;
	.debug	L childTask -4 41
;1617 
;1618 
;1619   KLOCK();
	.debug	# 1619
	call	_KLOCK
;1620 
;1621   pix = TaskIdx(pid);
	.debug	# 1621
	ld	hl,(ix+5)
	ld	de,0x1f
	and	hl,de
	ld	(ix-2),hl
;1622   if ((pix < 0) OR (pix >= NUM_TASKS))  {
	.debug	# 1622
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@285
	ld	hl,(ix-2)
	ld	e,0x14
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@286
@285:
;1623     ERRNO = ECHILD;  KUNLOCK();  return -1;  }
@287:
	.debug	< @287 @288
	.debug	# 1623
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xa
	jr	@966
@288:
	.debug	>
;1624 
;1625   childTask = tasks + (uint)pix;
@286:
	.debug	# 1625
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-4),hl
;1626 
;1627   fprintf(DiagLog, "blocking on %.20s[%d]\n", childTask->argv[0], pid);
	.debug	# 1627
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-4)
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+610)
	ld	c,phys @1+610 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;1628 
;1629 //finish:  return standard values
;1630 
;1631 //--- check for errors ---
;1632   if ( (childTask->ppid != current->pid) OR  // not a child process
;1633        (childTask->pid != pid) )  {  // process no longer exists
	.debug	# 1633
	ld	hl,(ix-4)
	ld	de,0xb6
	add	hl,de
	ld	de,(_current)
	ld	bc,hl
	ld	hl,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	nz,@289
	ld	hl,(ix-4)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@290
@289:
;1634     ERRNO = ECHILD;  KUNLOCK();  return -1;  }
@291:
	.debug	< @291 @292
	.debug	# 1634
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xa
@966:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	_KUNLOCK
	ld	hl,0xffff
	jr	@283
@292:
	.debug	>
;1635 
;1636 //finish:  need to handle exiting more thoroughly (like what happens if the
;1637 //         task's entry is reused between our checking here.  But task
;1638 //         entries really shouldn't BE reused if another process is blocked
;1639 //         waiting for them to exit)
;1640 
;1641 //--- if child not dead, wait for it to exit ---
;1642   while (childTask->inUse
@290:
@293:
;1643       AND (childTask->ppid == current->pid)
;1644       AND (childTask->pid == pid) )  { KUNLOCK();  sleepMS(50);  KLOCK(); }
	.debug	# 1644
	ld	hl,(ix-4)
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@295
	ld	hl,(ix-4)
	ld	e,0xb6
	add	hl,de
	ld	de,(_current)
	ld	bc,hl
	ld	hl,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	nz,@295
	ld	hl,(ix-4)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@295
@296:
	.debug	< @296 @297
	call	_KUNLOCK
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	call	_KLOCK
@297:
	.debug	>
;1645 
;1646   KUNLOCK();
	jr	@293
@295:
	.debug	# 1646
	call	_KUNLOCK
;1647 
;1648   fprintf(DiagLog, "unblocked\n");
	.debug	# 1648
	ld	de,word (phys @1+633)
	ld	c,phys @1+633 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;1649 
;1650   return pid;  // child exited
	.debug	# 1650
	ld	hl,(ix+5)
;1651 }
@283:
	.debug	} @283 1651

@282	equ	4
	ld	sp,ix
	pop	ix
	lret
@284	equ	6
;1652 
;1653 
;1654 
;1655 //-------------------------------------------------------------------------
;1656 //  Kernel space function to get the priority of a running process
;1657 //-------------------------------------------------------------------------
;1658 int getpriority(int which, int who)
;1659 {
$getpriority::
	.debug	G $getpriority 59 9
	.debug	{ $getpriority 59 1658 @300 @299
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A which 5 6
	.debug	A who 7 6
;1660   PIX  pix;
	.debug	L pix -2 6
;1661   int  pri;
	.debug	L pri -4 6
;1662 
;1663 
;1664   if (which != PRIO_PROCESS)  { ERRNO = EINVAL;  return -1; }
	.debug	# 1664
	ld	hl,(ix+5)
	bool	hl
	jr	z,@301
@302:
	.debug	< @302 @303
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@965
@303:
	.debug	>
;1665 
;1666   KLOCK();
@301:
	.debug	# 1666
	call	_KLOCK
;1667 
;1668   if ((pix = _activeTaskIdx_(who)) < 0)  {
	.debug	# 1668
	ld	hl,(ix+7)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@304
;1669     ERRNO = ESRCH;  KUNLOCK();  return -1; }
@305:
	.debug	< @305 @306
	.debug	# 1669
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	_KUNLOCK
@965:
	ld	hl,0xffff
	jr	@299
@306:
	.debug	>
;1670 
;1671   pri = tasks[(uint)pix].priority;
@304:
	.debug	# 1671
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xb8
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-4),hl
;1672 
;1673   KUNLOCK();  return pri;
	.debug	# 1673
	call	_KUNLOCK
	ld	hl,(ix-4)
;1674 }
@299:
	.debug	} @299 1674

@298	equ	4
	ld	sp,ix
	pop	ix
	lret
@300	equ	6
;1675 
;1676 
;1677 //-------------------------------------------------------------------------
;1678 //  Kernel space function to set the priority of a running process
;1679 //-------------------------------------------------------------------------
;1680 int setpriority(int which, int who, int priority)
;1681 {
$setpriority::
	.debug	G $setpriority 62 9
	.debug	{ $setpriority 62 1680 @309 @308
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A which 5 6
	.debug	A who 7 6
	.debug	A priority 9 6
;1682   PIX  pix;
	.debug	L pix -2 6
;1683 
;1684 
;1685   if (which != PRIO_PROCESS)  { ERRNO = EINVAL;  return -1; }
	.debug	# 1685
	ld	hl,(ix+5)
	bool	hl
	jr	z,@310
@311:
	.debug	< @311 @312
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@964
@312:
	.debug	>
;1686 
;1687   KLOCK();
@310:
	.debug	# 1687
	call	_KLOCK
;1688 
;1689   if ((pix = _activeTaskIdx_(who)) < 0)  {
	.debug	# 1689
	ld	hl,(ix+7)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@313
;1690     ERRNO = ESRCH;  KUNLOCK();  return -1; }
@314:
	.debug	< @314 @315
	.debug	# 1690
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	_KUNLOCK
@964:
	ld	hl,0xffff
	jr	@308
@315:
	.debug	>
;1691 
;1692   if (priority < 1)  priority = 1;
@313:
	.debug	# 1692
	ld	hl,(ix+9)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@316
	ld	hl,0x1
	ld	(ix+9),hl
;1693   if (priority > NUM_PRIORITIES-1)  priority = NUM_PRIORITIES - 1;
@316:
	.debug	# 1693
	ld	hl,(ix+9)
	ld	de,0x800f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@317
	jr	z,@317
	ld	hl,0xf
	ld	(ix+9),hl
;1694 
;1695   tasks[(uint)pix].priority = priority;
@317:
	.debug	# 1695
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0xb8
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;1696 
;1697   KUNLOCK();  return 0;
	.debug	# 1697
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1698 }
@308:
	.debug	} @308 1698

@307	equ	2
	ld	sp,ix
	pop	ix
	lret
@309	equ	4
;1699 
;1700 
;1701 
;1702 //-------------------------------------------------------------------------
;1703 //  Set the Real Time Clock and update any values that are dependent on it
;1704 //-------------------------------------------------------------------------
;1705 int stime(time_t *timePtr)
;1706 {
$stime::
	.debug	G $stime 63 9
	.debug	{ $stime 63 1705 @320 @319
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A timePtr 5 64
;1707   time_t  oldTime, newTime = *timePtr;
	.debug	L oldTime -4 9
	.debug	L newTime -8 9
	.debug	# 1707
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
;1708 
;1709 
;1710   _EnterCritical_();
	.debug	# 1710
	ipset	2
;1711 
;1712   oldTime = TIME();  writeRTC(newTime);
	.debug	# 1712
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	lcall	$writeRTC
	add	sp,4
;1713 
;1714 //--- _TimerSeconds is the # of seconds since the last hard (CPU) reset, so
;1715 //--- rather than apply a correction to hdwResetTime, we simply recompute -
;1716 //--- it from the current time (which is safer, since making sure that the 
;1717 //--- _TimerSeconds value is consistent across soft resets is important) --
;1718   diagLogInfo->hdwResetTime = hdwResetTime = newTime - _TimerSeconds;
	.debug	# 1718
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__lsub##
	ld	(_hdwResetTime),de
	ld	(_hdwResetTime+2),bc
	push	bc
	push	de
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;1719 
;1720   if (newTime > oldTime)
	.debug	# 1720
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	jr	c,@321
	jr	z,@321
;1721     rebootTime += newTime - oldTime;
	.debug	# 1721
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,(_rebootTime)
	ld	bc,(_rebootTime+2)
	call	__ladd##
	ld	(_rebootTime),de
	ld	(_rebootTime+2),bc
;1722   else
;1723     rebootTime -= oldTime - newTime;
	jr	@322
@321:
	.debug	# 1723
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,(_rebootTime)
	ld	bc,(_rebootTime+2)
	call	__lsubr##
	ld	(_rebootTime),de
	ld	(_rebootTime+2),bc
;1724 
;1725   diagLogInfo->rebootTime  = rebootTime;
@322:
	.debug	# 1725
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x70
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_rebootTime)
	ld	bc,(_rebootTime+2)
	call	__farst4d##
;1726 
;1727   _ExitCritical_();
	.debug	# 1727
	ipres
;1728 
;1729 //  The problem is that _TimerSeconds and _TimerMilliSeconds CANNOT be
;1730 //  changed after we have booted because they are used in endless places
;1731 //  to test for how much time has passed.  Change them after we have
;1732 //  booted, and all kinds of logic can simply hang or react at the wrong
;1733 //  time or the wrong way.
;1734 //
;1735 //  Aside from checking for reasonable values for the clock and time values
;1736 //  from the previous run, about all I can do is save a current correction
;1737 //  factor computed from what the clock SHOULD have set at startup and what
;1738 //  it DID say.  This would allow me to update values like upSecs that are
;1739 //  seen by outside parties but not used internally.  Although that could
;1740 //  cause the same kind of problem for external logic that is using such
;1741 //  a value the same way.
;1742 //
;1743 //  NOTE:  Fixing the values I pass on to the next instance will not only
;1744 //  correct the values seen externally, but will cause the internal ones to
;1745 //  drop back to the correct values, which will cause havoc for everything
;1746 //  after a soft reset.
;1747 //
;1748 //  Then again, a controller that is restarted with a soft reset and comes
;1749 //  starts with a messed up value means that the values used by the code
;1750 //  for computing intervals all suddenly jump to a much LARGER value.  Is
;1751 //  that really any better than having a correct value to begin with?
;1752 //
;1753 //  There really isn't a good, practical solution for a controller that is
;1754 //  already running with a messed-up value (other than to reboot it).  The
;1755 //  only REAL solution is to update ALL the starting time values used in
;1756 //  ALL the code, anywhere!  And to force all code that checks for elapsed
;1757 //  time to call some function to compute that time (as opposed to the
;1758 //  current fast, efficient method of simply doing a subtraction).
;1759 //
;1760 
;1761 
;1762   return 0;
	.debug	# 1762
	bool	hl
	ld	l,h
;1763 }
@319:
	.debug	} @319 1763

@318	equ	8
	ld	sp,ix
	pop	ix
	lret
@320	equ	10
;1764 
;1765 //-------------------------------------------------------------------------
;1766 //  standard linux/unix func to get the time with sub-second accuracy
;1767 //-------------------------------------------------------------------------
;1768 int gettimeofday(struct timeval *tv, void *obsolete_tz)
;1769 {
$gettimeofday::
	.debug	G $gettimeofday 65 9
	.debug	{ $gettimeofday 65 1768 @325 @324
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A tv 5 66
	.debug	A obsolete_tz 7 43
;1770   ulong  ms;
	.debug	L ms -4 9
;1771 
;1772 //finish:  Once settimeofday() uses the tv_usecs value, I will have to
;1773 //         set and use a milliTimerOffset as well and deal with
;1774 //         wrap-around (i.e. if ms + milliTimerOffset > 1000, ++secs, or
;1775 //         if millTimerOffset < 0, then ms < 0, etc...)
;1776   _EnterCritical_();
	.debug	# 1776
	ipset	2
;1777   tv->tv_sec = TIME();  ms = milliTicks;
	.debug	# 1777
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(_milliTicks)
	ex	de,hl
	ld	hl,0
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1778   _ExitCritical_();
	.debug	# 1778
	ipres
;1779 
;1780   tv->tv_usec = ms * 1000;
	.debug	# 1780
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	call	__ulmlt##
	ld	hl,(ix+5)
	push	de
	ld	de,0x4
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1781 
;1782   return 0;
	.debug	# 1782
	bool	hl
	ld	l,h
;1783 }
@324:
	.debug	} @324 1783

@323	equ	4
	ld	sp,ix
	pop	ix
	lret
@325	equ	6
;1784 
;1785 //-------------------------------------------------------------------------
;1786 //  standard linux/unix func to set the time with sub-second accuracy
;1787 //-------------------------------------------------------------------------
;1788 int settimeofday(const struct timeval *tv , const void *obsolete_tz)
;1789 {
$settimeofday::
	.debug	G $settimeofday 65 9
	.debug	{ $settimeofday 65 1788 @328 @327
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A tv 5 66
	.debug	A obsolete_tz 7 43
;1790 //finish:  Need to set RTC with sub-second accuracy and implement a
;1791 //         milliTimerOffset value
;1792   writeRTC(tv->tv_sec);
	.debug	# 1792
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$writeRTC
	add	sp,4
;1793 
;1794   return 0;
	.debug	# 1794
	bool	hl
	ld	l,h
;1795 }
@327:
	.debug	} @327 1795

@326	equ	0
	pop	ix
	lret
@328	equ	2
;1796 
;1797 //finish:  Assuming the existing Softools time() func reads the RTC, should
;1798 //         I replace it with one that returns _TimerSeconds + hdwResetTime?
;1799 //         that would be much faster than reading the RTC.  But I would hav
;1800 //         make sure that I DO read the RTC when necessary (like at startup
;1801 //time_t  far time (time_t *__timer);
;1802 
;1803 
;1804 //-------------------------------------------------------------------------
;1805 //  Sleep for at least the specified # of milliseconds.
;1806 //
;1807 //  Returns the aprox # of milliseconds the process actually slept
;1808 //-------------------------------------------------------------------------
;1809 ulong sleepMS(ulong ms)
;1810 {
$sleepMS::
	.debug	G $sleepMS 68 9
	.debug	{ $sleepMS 68 1809 @331 @330
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ms 5 9
;1811   current->sleepStarted = MS_TIMER;
	.debug	# 1811
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	de
	ld	de,0xe0
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1812 
;1813 //--- return immediately if kernel task ---
;1814   if (current == kernelTask)  return msSince(current->sleepStarted);
	.debug	# 1814
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@332
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xe0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	jp	@330
;1815 
;1816   if (_disabled)  // busy wait if scheduler disabled
@332:
	.debug	# 1816
	ld	a,(__disabled)
	or	a,a
	jp	z,@333
;1817     while (msSince(current->sleepStarted) < ms);
@334:
	.debug	# 1817
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xe0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	nc,@336
;1818   else  {  // otherwise use the sleep wait queue
	jp	@334
@333:
;1819     current->sleepTicks = msToTicks(ms);
@337:
	.debug	< @337 @338
	.debug	# 1819
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	ld	hl,(_current)
	push	de
	ld	de,0xdc
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1820     __wait_event(sleepQueue, !current->sleepTicks);
@342:
	.debug	< @342 @343
	.debug	L node -2 69
	.debug	# 1820
	lcall	$alloc_WaitQueueNode
	ld	(ix-2),hl
	.seg	FARCODE
@344:
	.debug	< @344 @345
@346:
@349:
	.debug	< @349 @350
	ld	hl,0x2
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,_sleepQueue
	push	hl
	lcall	$prepare_to_wait
	add	sp,6
	ld	hl,(_current)
	ld	de,0xdc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@347
	lcall	$schedule
@350:
	.debug	>
	jr	@346
@347:
@345:
	.debug	>
	ld	hl,(ix-2)
	push	hl
	ld	hl,_sleepQueue
	push	hl
	lcall	$finish_wait
	add	sp,4
@343:
	.debug	>
;1821   }
@338:
	.debug	>
;1822 
;1823   return msSince(current->sleepStarted);
@336:
	.debug	# 1823
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xe0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
;1824 }
@330:
	.debug	} @330 1824

@329	equ	2
	ld	sp,ix
	pop	ix
	lret
@331	equ	4
;1825 
;1826 
;1827 //-------------------------------------------------------------------------
;1828 //  Return the # of scheduler ticks equivalent to the given # of millisecon
;1829 //  rounded up to the nearest # of ticks.
;1830 //-------------------------------------------------------------------------
;1831 ulong msToTicks(ulong ms)
;1832 {
$msToTicks::
	.debug	G $msToTicks 68 9
	.debug	{ $msToTicks 68 1831 @354 @353
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ms 5 9
;1833   ulong numTicks = (ulong)((ms + ((uint)SchedMS>>1)) / (uint)SchedMS);
	.debug	L numTicks -4 9
	.debug	# 1833
	ld	hl,(_SchedMS)
	or	a,a
	rr	hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ladd##
	ld	hl,(_SchedMS)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;1834   if (ms AND (numTicks < 1))  numTicks = 1;
	.debug	# 1834
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	or	hl,de
	jr	z,@356
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	nc,@356
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1835 
;1836   return numTicks;
@356:
	.debug	# 1836
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;1837 }
@353:
	.debug	} @353 1837

@352	equ	4
	ld	sp,ix
	pop	ix
	lret
@354	equ	6
;1838 
;1839 
;1840 //-------------------------------------------------------------------------
;1841 //  Do nothing process set to lowest priority - runs only when no other
;1842 //  processes are ready
;1843 //-------------------------------------------------------------------------
;1844 void _task idle(int argc, char **argv)
;1845 {
	.align	4
$$idle::
	ex	(sp),iy
$idle::
	.debug	G $idle 51 9
	.debug	{ $idle 51 1844 @359 @358
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A argc 5 6
	.debug	A argv 7 48
;1846   for (;;)  computeMemCRCs(false, false);
@360:
	.debug	< @360 @361
@362:
	.debug	# 1846
	bool	hl
	ld	l,h
	push	hl
	push	hl
	lcall	$computeMemCRCs
	add	sp,4
;1847 }
	jr	@362
@361:
	.debug	>
@358:
	.debug	} @358 1847

@357	equ	0
	pop	ix
	lret
@359	equ	2
;1848 
;1849 
;1850 
;1851 extern ushort nonKernelLocks, duplicateLocks, tcpTickTime, failedLocks;
;1852 
;1853 //sem_t  tcpLock;
;1854 
;1855 //-------------------------------------------------------------------------
;1856 //  Callback for network lib locking when used by an RTOS
;1857 //-------------------------------------------------------------------------
;1858 // void  near lock_semaphore(void) { sem_wait(&tcpLock); }
;1859 // void  near unlock_semaphore( void )  { sem_post(&tcpLock); }
;1860 
;1861 /* This results in much better response times than using a semaphore (as ab
;1862    But they aren't actually needed because we point tcp_lock and tcp_unlock
;1863    directly at KLOCK and KUNLOCK()
;1864   ------------------------------------
;1865 void  near lock_semaphore(void)  {
;1866   KLOCK();  // if (current != kernelTask)  ++nonKernelLocks;
;1867 }
;1868 
;1869 void  near unlock_semaphore( void )  { KUNLOCK(); }
;1870 */
;1871 
;1872 /*
;1873 //-------------------------------------------------------------------------
;1874 //  substitue for Softools tcp_tick(s) func
;1875 //-------------------------------------------------------------------------
;1876 _tcp_nodebug int tcp_tick(void* s)
;1877 {
;1878   int retVal;
;1879   uint  msTaken;
;1880   ulong  startTime;
;1881 
;1882 
;1883   if (SEM_LOCK(_tcpBusy) == 1)  {
;1884     startTime = GetMS();
;1885     retVal = _tcp_tick_internal(s);
;1886     msTaken = (uint) msSince(startTime);
;1887   }
;1888   else  {
;1889     ++failedLocks;  //tdebug
;1890     msTaken = 0;  retVal = 1;  }
;1891 
;1892   _EnterCritical_();  tcpTickTime = msTaken;  _ExitCritical_();
;1893 
;1894   SEM_UNLOCK(_tcpBusy);
;1895 
;1896   return retVal;
;1897 }
;1898 */
;1899 //-------------------------------------------------------------------------
;1900 //  substitue for Softools tcp_tick(s) func
;1901 //-------------------------------------------------------------------------
;1902 _tcp_nodebug int tcp_tick(void *sock)
;1903 {
$tcp_tick::
	.debug	G $tcp_tick 71 9
	.debug	{ $tcp_tick 71 1902 @367 @366
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A sock 5 43
;1904   int  retVal;
	.debug	L retVal -2 6
;1905   uint  startTime;
	.debug	L startTime -4 7
;1906 
;1907   KLOCK();
	.debug	# 1907
	call	_KLOCK
;1908 
;1909   startTime = GetMS_();
	.debug	# 1909
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-4),hl
;1910   retVal = _tcp_tick_internal(sock);
	.debug	# 1910
	ld	hl,(ix+5)
	push	hl
	lcall	$_tcp_tick_internal
	pop	de
	ld	(ix-2),hl
;1911   tcpTickTime = msSince_(startTime);
	.debug	# 1911
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_tcpTickTime),hl
;1912 
;1913   KUNLOCK();
	.debug	# 1913
	call	_KUNLOCK
;1914 
;1915   return retVal;
	.debug	# 1915
	ld	hl,(ix-2)
;1916 }
@366:
	.debug	} @366 1916

@365	equ	4
	ld	sp,ix
	pop	ix
	lret
@367	equ	6
;1917 
;1918 
;1919 //-------------------------------------------------------------------------
;1920 //  Called every SchedMS milliseconds by a periodic timer interrupt to upda
;1921 //  various values and call the scheduler if it is not disabled.
;1922 //
;1923 // *** WARNING ***
;1924 //   The addition of any local variables will require changes to the
;1925 //   postMortem() function!
;1926 // *** WARNING ***
;1927 //-------------------------------------------------------------------------
;1928 void _nostep sched_tick(void)
;1929 {
$sched_tick::
	.debug	G $sched_tick 37 11
	.debug	{ $sched_tick 37 1928 @370 @369
;1930   StartInterval(TrackTimerISR);  // for real-time profiling/diagnostics
;1931 
;1932 //tdebug - generate a write fault to test dumpFault(), stackTrace(), etc --
;1933 //  if (current->priority == 13)  { current->priority = 12;  (*(uchar *)0) 
;1934 
;1935 //--- Check for an imminent Watch-Dog Timer timeout ---
;1936   if (checkWDT)  if ((diagLogInfo->wdtTicks += SchedMS) >= 1900)
	.debug	# 1936
	ld	a,(_checkWDT)
	or	a,a
	jr	z,@371
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	__farld2##
	ld	hl,(_SchedMS)
	add	hl,de
	pop	de
	pop	bc
	call	__farst2##
	ld	de,0x76c
	or	a,a
	sbc	hl,de
	jr	c,@372
;1937     if (!doShutdown)  wdTimingOut();
	.debug	# 1937
	ld	a,(_doShutdown)
	or	a,a
	jr	nz,@373
	lcall	$wdTimingOut
;1938 
;1939 //--- wake up the application and kernel tasks ---
;1940   if (applTask)  if (ActiveTask(applTask))  applTask->state = TASK_RUNNING;
@373:
@372:
@371:
	.debug	# 1940
	ld	hl,(_applTask)
	bool	hl
	jr	z,@374
	ld	hl,(_applTask)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@375
	ld	hl,(_applTask)
	ld	e,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1941   tasks->state = TASK_RUNNING;
@375:
@374:
	.debug	# 1941
	bool	hl
	ld	l,h
	ld	(_tasks+19),hl
;1942 
;1943 //--- keep track of the last time the OS was running (so we can log it when
;1944 //--- we reboot) ---
;1945   diagLogInfo->seconds = TIME();  diagLogInfo->milliSecs = milliTicks;
	.debug	# 1945
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	push	bc
	push	de
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(_milliTicks)
	call	__farst2##
;1946   diagLogInfo->msTime = _TimerMilliSeconds[1];
	.debug	# 1946
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x16
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
	call	__farst4d##
;1947 
;1948 
;1949 /*
;1950   disabled  schedule  preempt     -------- action --------
;1951     x           0        x        return
;1952     0           1        0        call schedule
;1953     x           1        1        set 'pending', then return
;1954     1           1        x        set 'pending', then return
;1955 
;1956     If the scheduler is disabled, or the current task is already marked as
;1957     preempted, then one of 4 things is true:
;1958 
;1959       1. The current task is using the scheduler lock to protect shared dat
;1960 
;1961       2. The current task was just about to call the scheduler.
;1962 
;1963       3. We interrupted the scheduler itself.
;1964 
;1965       4. The current task was just resumed by the scheduler.
;1966 
;1967     In the 1st case, we must wait to switch tasks to avoid possibly corrupt
;1968     the data the current task is accessing.
;1969 
;1970     In the 2nd case, calling the scheduler here would just be a waste, sinc
;1971     the scheduler will be called as soon as we allow the preempted task to
;1972     resume execution.
;1973 
;1974     In the 3rd case, the scheduler will simply return to protect itself fro
;1975     concurrent calls.
;1976 
;1977     The 4th case is a bit tricky.  The issue we need to guard against is as
;1978     follows:
;1979 
;1980       - Suppose a task that was preempted by this function is later resumed
;1981         Tasks that were suspended due to a call to schedule by this functio
;1982         have a bunch of stuff on their stack that was pushed there by the
;1983         TimerBISR function, plus its call to this function, and this
;1984         function's call to schedule.
;1985 
;1986       - If a just-resumed task is preempted again before execution returns 
;1987         the point it was last preempted, we end up shoving all the same stu
;1988         on the task's stack again.  Since each time it happens increases th
;1989         amount of time before execution DOES return to the point it was 1st
;1990         preempted, the risk of this happening a 2nd (and 3rd, and 4th, ...)
;1991         time increases.  Once it starts, this can snowball to the point whe
;1992         the task's stack overflows which can lead to all kinds of chaos
;1993         (although on the Rabbit 3000's this is now trapped by a hardware
;1994         fault, so at least it is obvious when it happens, rather than causi
;1995         strange behavior with no obvious cause).
;1996 
;1997     The way we handle all these cases is to set a flag indicating that we h
;1998     a "pending" call to the scheduler.  Any code that clears the scheduler
;1999     lock (which is limited to the scheduler itself and the KUNLOCK() functi
;2000     checks the pending flag and, if it is set, invokes the scheduler.  For
;2001     the scheduler itself, this just means looping until the flag is clear.
;2002     For the KUNLOCK() function, it means it increments the preempt flag for
;2003     task, calls schedule, then decrements the prempt flag.
;2004 
;2005     NOTE that, while the amount of stuff pushed on to the stack to call the
;2006     KUNLOCK() function is probably much smaller (since it is not invoked by
;2007     an interrupt that has to insure all the registers are protected), the
;2008     risk still exists, so it also increments and decrements the task's
;2009     preempt counter.  This is also useful in monitoring the tasks, as a cal
;2010     to schedule from KUNLOCK is really nothing more than a delayed preempt 
;2011     It just happens to be the task doing so "voluntarily".
;2012 */
;2013 
;2014   if (_disabled OR current->preempt_count)  {
	.debug	# 2014
	ld	a,(__disabled)
	or	a,a
	jr	nz,@376
	ld	hl,(_current)
	ld	de,0xa8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@377
@376:
;2015     _pending = 1;  EndInterval(TrackTimerISR);  return; }
@378:
	.debug	< @378 @379
	.debug	# 2015
	ld	a,0x1
	ld	(__pending),a
	jr	@369
@379:
	.debug	>
;2016 
;2017 /*
;2018     So, we finally eliminated all the special cases.  If we got here then
;2019     we are due to call the scheduler and know of no reason not to, so we
;2020     mark the task as preempted and call the scheduler.  The preempted
;2021     counter serves 2 purposes:
;2022 
;2023       1. It lets the scheduler know that the task was running when it was
;2024          preempted, regardless of what its run state is, so it should be
;2025          treated like any other READY task.  This handles the case where
;2026          the task changed its run state and was then preempted before it
;2027          could call schedule() or at the start of schedule(), before it
;2028          suspended the task.
;2029 
;2030       2. It allows this function to detect the cases described above that
;2031          cause it to set the pending flag instead of calling schedule
;2032          itself.  As noted above this is important because it allows us to
;2033          avoid calling the scheduler recursively.
;2034 */
;2035 
;2036   ++current->preempt_count;
@377:
	.debug	# 2036
	ld	hl,(_current)
	ld	de,0xa8
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2037 
;2038   EndInterval(TrackTimerISR);  // for real-time profiling/diagnostics
;2039 
;2040 //--- Remember that a call to schedule() does not return (for the task ---
;2041 //--- that was running when it was called) until the task is resumed by ---
;2042 //--- the scheduler ---
;2043   ipres();  schedule();  ipset1();
	.debug	# 2043
	ipres
	lcall	$schedule
	ipset	1
;2044 
;2045 //=== WARNING: schedule() usually changes "current" and the stack pointer, 
;2046 //=== so do NOT use any local variables after the call to schedule() !!! ==
;2047 
;2048   --current->preempt_count;
	.debug	# 2048
	ld	hl,(_current)
	ld	de,0xa8
	add	hl,de
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2049 }
@369:
	.debug	} @369 2049

@368	equ	0
	lret
@370	equ	0
;2050 
;2051 
;2052 /*=========================================================================
;2053  Identifier      Vector - Supports
;2054           --- IIR ---
;2055  INT_TIMER         0x00 - Periodic timer
;2056                    0x01 - Secondary WDT (*)
;2057  INT_RST10         0x02 - RST 10
;2058  INT_RST18         0x03 - RST 18
;2059  INT_RST20         0x04 - RST 20
;2060  INT_RST28         0x05 - RST 28 (used by WinIDE debugger)
;2061                    0x06 - Syscall (*)
;2062  INT_RST38         0x07 - RST 38
;2063  INT_SLAVE_PORT    0x08 - Slave port
;2064                    0x09 - Write Protect (*)
;2065  INT_TIMER_A       0x0A - Timer A
;2066  INT_TIMER_B       0x0B - Timer B
;2067  INT_SERIAL_A      0x0C - Serial A
;2068  INT_SERIAL_B      0x0D - Serial B
;2069  INT_SERIAL_C      0x0E - Serial C
;2070  INT_SERIAL_D      0x0F - Serial D
;2071           --- EIR and rest of IIR overlapped ---
;2072  INT_INT0          0x10 - INT0
;2073  INT_INT1          0x11 - INT1
;2074                    0x12 -
;2075                    0x13 -
;2076                    0x14 -
;2077                    0x15 -
;2078                    0x16 -
;2079                    0x17 - PWM (*)
;2080                    0x18 - Mode Violation (*)
;2081  INT_QUAD_DECODER  0x19 - Quadrature decoder
;2082  INT_INPUT_CAP     0x1A - Input capture
;2083                    0x1B - Stack Limit (*)
;2084  INT_SERIAL_E      0x1C - Serial E (*)
;2085  INT_SERIAL_F      0x1D - Serial F (*)
;2086                    0x1E - Network Port A (*)
;2087                    0x1F - Timer C (*)
;2088 
;2089  (*) indicates interrupts not available on the Rabbit 2000 (some where not
;2090      introduced until the Rabbit 3000A)
;2091 */
;2092 
;2093 
;2094 extern void _near _TimerBISR(void);
;2095 
;2096 //-------------------------------------------------------------------------
;2097 //  Modify the entries in the interrupt vector table so ISRs are protected
;2098 //  against preemption.
;2099 //
;2100 //  An example of why this is needed in some cases:
;2101 //
;2102 //  Suppose an ISR starts by performing some time-critical function like
;2103 //  reading a character just received on a serial port, or disabling the
;2104 //  source of the interrupt.  It then restores the processor to the
;2105 //  interrupt priority level that existed before the interrupt occured so
;2106 //  other interrupts of the same level (or possibly even lower) could occur
;2107 //
;2108 //  Once the ISR restores the interrupt priority level, a timer interrupt
;2109 //  could happen, and if the processing of that interrupt causes the
;2110 //  scheduler to be called, then the ISR that interrupted the current task
;2111 //  would be suspended along with the current task.  It would not get to
;2112 //  finish its processing until the task it interrupted was resumed.
;2113 //
;2114 //  Such a delay could be bad enough in its own right.  But what is likely
;2115 //  even worse is if the same interrupt happens again before the processing
;2116 //  for the previous instance finishes.  At the very least, the results
;2117 //  will probably not be correct.  Worse case would be that is causes
;2118 //  chaos.  And if it happened enough times, it might even overflow the
;2119 //  stack of one or more processes.
;2120 //
;2121 //  The method for dealing with this is as follows:
;2122 //    - The simple jump instruction that is normally put in each location o
;2123 //      the interrupt vector table is modified to do the following:
;2124 //         - disable the scheduler
;2125 //         - call the ISR
;2126 //         - enable the scheduler
;2127 //         - return control to the interrupted task
;2128 //
;2129 //  This can all be done (including saving and restoring the state of the
;2130 //  two registers affected) in 13 bytes, which will fit within the 16 bytes
;2131 //  available for each vector.
;2132 //
;2133 //  So, the added overhead is minimal, and does not require any additional
;2134 //  use of the root CODE space.
;2135 //
;2136 //  === NOTES ===
;2137 //  Substitutes for the Softools functions for modifying and accessing the
;2138 //  interrupt vector table should also be provided to minimize the chances 
;2139 //  some other code modifying the table in an incompatible manner.
;2140 //
;2141 //  For now, we rely on periodic scanning of the table to see if it has bee
;2142 //  changed (and then change any that were back to the "shim" again).  This
;2143 //  should be left as a safeguard even after the substitute functions are
;2144 //  written to minimize the risk should some other code modify these later
;2145 //  on.
;2146 //
;2147 //
;2148 //  There is one problem with how the shims work which stems from the use
;2149 //  of a call instruction rather than a jump instruction:
;2150 //
;2151 //  Normally the interrupt vectors contain just a jump instruction to
;2152 //  transfer control to the ISR.  Because the return address was pushed
;2153 //  on the stack when the interrupt occured, the IRET (actually an IPRES
;2154 //  - a privileged instruction - followed by a RET) at the end of the
;2155 //  ISR insures that no interrupts of the same priority can happen until
;2156 //  control is transfered back to the originally interrupted code.
;2157 //
;2158 //  The method below, however, uses a call to transfer control to the
;2159 //  ISR so the IRET at the end of the ISR means that the shim itself
;2160 //  can be interrupted between the return from the ISR and the return
;2161 //  at the end of the shim.  Not REAL likely, but it can (and I believe
;2162 //  has) happen(ed) on at least one of our controllers with a digital
;2163 //  knob connected to an interrupt input.  And if (as in the one case
;2164 //  I have had it happen), you get a lengthy stream of interrupts, it can
;2165 //  cause a stack overflow.
;2166 //
;2167 //  There are, of course ways around this, but it would require more
;2168 //  instructions than will fit in the interrupt vector, which would
;2169 //  mean more overhead and higher latencies (because we would have to
;2170 //  call a function that would call the ISR, adding another call and
;2171 //  return, plus the additional code to save and restore the interrupt
;2172 //  priority register).
;2173 //
;2174 //  And last but not least, the case that has been known to cause a stack
;2175 //  overflow is a problem with how fast the interrupts occur.  While no
;2176 //  shim at all would eliminate the stack overflow issue, the high rate
;2177 //  of interrupts would still be a problem as the CPU would still be doing
;2178 //  nothing but servicing the same interrupt over and over.
;2179 //
;2180   static uchar intVectInstrs[16] =  {
;2181     0xF5,              //  push  AF
	.dseg
_intVectInstrs:
	.db	0xf5
;2182     0xE5,              //  push  HL
	.db	0xe5
;2183     0x21, 0x00, 0x00,  //  ld    HL,mn  (n,m: addr of _disable flag/counter
	.db	0x21
	.db	0
	.db	0
;2184     0x34,              //  inc  (HL)
	.db	0x34
;2185     0xCD, 0x00, 0x00,  //  call  mn  (n,m:  addr of ISR)
	.db	0xcd
	.db	0
	.db	0
;2186     0x35,              //  dec  (HL)
	.db	0x35
;2187     0xE1,              //  pop   HL
	.db	0xe1
;2188     0xF1,              //  pop   AF
	.db	0xf1
;2189     0xC9,              //  ret
	.db	0xc9
;2190     0x00,
	.db	0
;2191     0x00,
	.db	0
;2192     0x00
;2193 };
	.db	0
	.debug	F _intVectInstrs 72 0
;2194 // # of bytes pushed on the stack (incl the return addr pushed by call to I
;2195 //#define IntShim_PushCount  6   // moved to unistd.h
;2196 
;2197 // Any changes to the shim may require udpating viableCodeAddr() (at least)
;2198 
;2199 
;2200 //--------------------------------------------------------------
;2201 void checkIntShims(void)
;2202 {
	.seg	FARCODE
$checkIntShims::
	.debug	G $checkIntShims 37 9
	.debug	{ $checkIntShims 37 2201 @382 @381
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;2203   static bool firstTime = true;
	.dseg
@383:
	.db	0x1
	.debug	S firstTime @383 3
	.seg	FARCODE
;2204   uchar  IIR, EIR;
	.debug	L IIR -1 3
	.debug	L EIR -2 3
;2205   uchar  *ptr;
	.debug	L ptr -4 40
;2206   uint  u;
	.debug	L u -6 7
;2207 
;2208 
;2209   IIR = _asm( [_A], "ld a,iir", _A );
	.debug	# 2209
ld a,iir
	ld	(ix-1),a
;2210   EIR = _asm( [_A], "ld a,eir", _A );
	.debug	# 2210
ld a,eir
	ld	(ix-2),a
;2211 
;2212   if (firstTime)  {
	.debug	# 2212
	ld	a,(@383)
	or	a,a
	jr	z,@384
;2213     printf("\r\nIIR: %02X,  EIR: %02X\r\n", IIR, EIR);
@385:
	.debug	< @385 @386
	.debug	# 2213
	bool	hl
	ld	l,(ix-2)
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys @1+644)
	ld	c,phys @1+644 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2214     printf("_TimerBISR: %04X\r\n", (uint)_TimerBISR);
	.debug	# 2214
	ld	hl,__TimerBISR
	push	hl
	ld	de,word (phys @1+670)
	ld	c,phys @1+670 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2215   }
@386:
	.debug	>
;2216 
;2217 //--- Replace the code for each vector that doesn't yet or no longer has th
;2218 //--- "shim" code to make it scheduler-safe ---
;2219 //   NOTE: This assumes the IIR and EIR tables are contiguous or overlap
;2220   ptr = (uchar *)((uint)IIR << 8);
@384:
	.debug	# 2220
	bool	hl
	ld	h,(ix-1)
	ld	l,0
	ld	(ix-4),hl
;2221   for (u=0; u<NumIntVectors; ++u,ptr+=16)  {
@387:
	.debug	< @387 @388
	.debug	# 2221
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@389:
	ld	hl,(ix-6)
	ld	de,0x1e
	or	a,a
	sbc	hl,de
	jr	nc,@390
;2222     if (*ptr != 0xC3)  continue;  // verify existing JP instr
@392:
	.debug	< @392 @393
	.debug	# 2222
	ld	hl,(ix-4)
	ld	a,(hl)
	sub	a,195
	jr	nz,@391
;2223     *((uint *)(intVectInstrs + 3)) =
;2224        (u == INT_TIMER_B) ? (uint)(&nestedTimerInt) : (uint)(&_disabled);
	.debug	# 2224
	ld	hl,(ix-6)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@395
	ld	hl,_nestedTimerInt
	jr	@396
@395:
	ld	hl,__disabled
@396:
	ld	de,_intVectInstrs+3
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2225     if (!firstTime) fprintf(DiagLog, "*** INT %02X changed to: %04X ***\n",
	.debug	# 2225
	ld	a,(@383)
	or	a,a
	jr	nz,@397
;2226                                      u, *((uint *)(ptr+1)) );
	.debug	# 2226
	ld	hl,(ix-4)
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @1+689)
	ld	c,phys @1+689 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;2227     *((uint *)(intVectInstrs + 7)) = *((uint *)(ptr + 1)); // addr from cur
@397:
	.debug	# 2227
	ld	hl,(ix-4)
	inc	hl
	ld	de,_intVectInstrs+7
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2228     _EnterCritical_();  memcpy(ptr, intVectInstrs, 16);  _ExitCritical_();
	.debug	# 2228
	ipset	2
	ld	hl,0x10
	push	hl
	ld	hl,_intVectInstrs
	push	hl
	ld	hl,(ix-4)
	push	hl
	call	_memcpy
	add	sp,6
	ipres
;2229   }
@393:
	.debug	>
;2230 
;2231   firstTime = false;
@391:
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	ld	hl,(ix-4)
	ld	de,0x10
	add	hl,de
	ld	(ix-4),hl
	jr	@389
@390:
@388:
	.debug	>
	.debug	# 2231
	xor	a,a
	ld	(@383),a
;2232 
;2233 
;2234 
;2235 /*
;2236     wrappedHandler[i] = getInterruptHandler(i);
;2237 
;2238 //    printf("INT %02X: %04X\r\n", i, (uint)wrappedHandler[i]);  //tdebug
;2239 
;2240     if (i == INT_TIMER_B)  continue;
;2241 
;2242     _EnterCritical_();  setInterruptHandler(i, shimFuncs[i]);  _ExitCritica
;2243   }
;2244 */
;2245 
;2246 //  printf("\r\n");
;2247 //  for (i=0; i<16; ++i)
;2248 //    printf("INT %02X: %04X\r\n", i, (uint)getInterruptHandler(i) );
;2249 }
@381:
	.debug	} @381 2249

@380	equ	6
	ld	sp,ix
	pop	ix
	lret
@382	equ	8
;2250 
;2251 //-------------------------------------------------------------------------
;2252 //  Called to dump the state of the machine just before doing a reboot due 
;2253 //  recover from a detected error.  This information is written to the circ
;2254 //  in-memory syslog buffer and to the crash-log file.
;2255 //
;2256 //  NOTE:  On Rabbit 3000 systems, the memory protection capability is used
;2257 //  protect the CODE, CONST, FARCODE, and FARCONST segments from being writ
;2258 //  to.  However, we have found that environmental conditions can still res
;2259 //  in these segments being corrupted without triggering a fault condition.
;2260 //  As it ONLY occurs while the cyclotron is in operation, it could be any
;2261 //  number of things: heat, EMI, power fluctuations, even energetic particl
;2262 //
;2263 //  At present, the most common circumstance that triggers a dump and reboo
;2264 //  is when the idle task has detected corruption in one of the protected
;2265 //  segments, which it does by continuously recomputing checksums on them.
;2266 //  In most cases, the corruption does not appear to be in this code, or th
;2267 //  code it depends on, but there is no guarantee that will always be the c
;2268 //-------------------------------------------------------------------------
;2269 void postMortem(const char far *cause)
;2270 {
$postMortem::
	.debug	G $postMortem 36 9
	.debug	{ $postMortem 36 2269 @400 @399
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-68
	.debug	A cause 5 34
;2271   PID  i;
	.debug	L i -2 6
;2272   task_t  *task;
	.debug	L task -4 41
;2273   ulong  absPC, idle, stackStart, stackEnd;
	.debug	L absPC -8 9
	.debug	L idle -12 9
	.debug	L stackStart -16 9
	.debug	L stackEnd -20 9
;2274   uint  xpc, pc, sp, ui, log_sp, ip;
	.debug	L xpc -22 7
	.debug	L pc -24 7
	.debug	L sp -26 7
	.debug	L ui -28 7
	.debug	L log_sp -30 7
	.debug	L ip -32 7
;2275   uchar far *stackPtr;
	.debug	L stackPtr -36 34
;2276   char  temp[32];
	.debug	L temp -68 73
;2277 
;2278 
;2279   if (recursiveDump)  return;
	.debug	# 2279
	ld	a,(_recursiveDump)
	or	a,a
	jp	nz,@399
;2280   recursiveDump = true;
	.debug	# 2280
	ld	a,0x1
	ld	(_recursiveDump),a
;2281 
;2282   KLOCK();  WDT_2S();  checkWDT = false;
	.debug	# 2282
	call	_KLOCK
  ld  a,0x5A
  ioi ld  (0x08),a
	xor	a,a
	ld	(_checkWDT),a
;2283 
;2284   useSoftReset = doShutdown = doReboot = true;
	.debug	# 2284
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
	ld	(_useSoftReset),a
;2285 
;2286   logDateTime = false;
	.debug	# 2286
	xor	a,a
	ld	(_logDateTime),a
;2287 
;2288   openCrashLog();  // copy all diagnostic msgs to the crash log as well
	.debug	# 2288
	lcall	$openCrashLog
;2289 
;2290 //printf("stdoutDev:[%05lX], logStdout:%d, redirectStdio:%d\r\n",  //tdebug
;2291 //       (ulong)FD[userPix][1], current->logStdout, current->redirStdio);
;2292 
;2293   dateTimeMS(temp, TIME(), milliTicks);
	.debug	# 2293
	ld	hl,(_milliTicks)
	push	hl
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	push	bc
	push	de
	ld	hl,-62+@398
	add	hl,sp
	push	hl
	lcall	$dateTimeMS
	add	sp,8
;2294 
;2295   printf("\r\n"
;2296          "\r\n"
;2297          "---------- Post Mortem dump ----------\r\n"
;2298          "%s %.24s[%d]: ", temp, current->argv[0], current->pid);
	.debug	# 2295
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(_current)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,-64+@398
	add	hl,sp
	push	hl
	ld	de,word (phys @1+724)
	ld	c,phys @1+724 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;2299 
;2300   printf("  Core Module ID: %.6s\r\n"
;2301          "\n"
;2302          " *** %.128ls ***\r\n"
;2303          "\n"
;2304          "  RTOS: %.40ls\r\n"
;2305          "  APPL: %.40ls  %.40ls\r\n"
;2306          "\n"
;2307          "  kernel lock level: %d\r\n"
;2308          "\n"
;2309          "  Age of resetWDT() calls:  kernel: %ldms  applic: %ldms  any: %u
;2310          "\n",
;2311          moduleID, cause, osDTM, applDTM, applName, _disabled,
;2312          GetMS() - kernelLastCalled,
;2313          GetMS() - applicLastCalled,
;2314          diagLogInfo->wdtTicks
;2315         );
	.debug	# 2315
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_applicLastCalled)
	ld	bc,(_applicLastCalled+2)
	call	__lsub##
	push	bc
	push	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_kernelLastCalled)
	ld	bc,(_kernelLastCalled+2)
	call	__lsub##
	push	bc
	push	de
	ld	a,(__disabled)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys _applName)
	ld	c,phys _applName >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	ld	de,word (phys _osDTM)
	ld	c,phys _osDTM >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_moduleID
	push	hl
	ld	de,word (phys @1+783)
	ld	c,phys @1+783 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,34
;2316 
;2317 /*-----------------------
;2318  Using a combination of what is in the task table and what is stored in its
;2319  stack, we can determine the state of each task at the time the error occur
;2320 
;2321  When postMortem() is called, each task will be in one of 4 states:
;2322 
;2323    - The task called a system function that called schedule().  The task's
;2324      preempt_count is not changed in this case.
;2325 
;2326    - The task was pre-empted (i.e sched_tick() called schedule(),
;2327      incrementing the task's preempt_count by 1 just before doing so)
;2328 
;2329    - The task released the scheduler/kernel lock by calling KUNLOCK(),
;2330      which found the pending flag set (which means that sched_tick()
;2331      determined that a call to schedule() was due, but the scheduler was
;2332      disabled by the current task).  In this case, KUNLOCK() effectively
;2333      preempts the task (it increases the task's preempt_count by 8 and
;2334      calls schedule()), allowing the pending call to schedule() to finally
;2335      happen.
;2336 
;2337    - The task was the one running when the error occured (i.e. it was the o
;2338      that called this function)
;2339 
;2340 
;2341  In the first three cases, the task table contains the stack pointer value 
;2342  the task when it was suspeneded.  In addition, the preempt_count value tel
;2343  us which of the first three cases applies.  With these two values, and the
;2344  knowledge of what was pushed on to the stack in each case, we can determin
;2345  the location in memory where we can find the pieces of information that ar
;2346  NOT stored in the task table.
;2347 
;2348  For the last case, the data in the task table is not up to date (it is onl
;2349  updated when a task is suspended), so some of the values we need are copie
;2350  from the live register values.
;2351 
;2352 
;2353  For the current task, the task table value for SP (stack) is outof date, s
;2354  grab the current value for it (and values we normally get from the stack)
;2355  right from the live registers.
;2356 
;2357         ---------------------------------------------------------------
;2358  For every suspended task (i.e. every one BUT the current one), this is ---
;2359  what the top of the task's stack looks like:
;2360 
;2361 --- pushed by schedule() (see Schedule_PushCount in linux/sched.h)---
;2362   stackPtr[0]:    IX (LSB)
;2363   stackPtr[1]:    IX (MSB)
;2364 
;2365   stackPtr[2]:    IY (LSB)
;2366   stackPtr[3]:    IY (MSB)
;2367 
;2368   stackPtr[4]:    IP
;2369 
;2370 --- from call to schedule() (from sys call or sched_tick(): 3 bytes) ---
;2371   stackPtr[5]:    ret_addr (LSB)
;2372   stackPtr[6]:    ret_addr (MSB)
;2373 
;2374   stackPtr[7]:    XPC
;2375 
;2376 
;2377  The ret_addr at stackPtr[5] provides the address from which schedule() was
;2378  called.  But if the task was preempted (task->preempt_count > 0), then
;2379  that call came either from sched_tick() or KUNLOCK(), which doesn't tell
;2380  us anything about what the task was doing when it was preempted.
;2381 
;2382 
;2383         ---------------------------------------------------------------
;2384  If it was preempted by KUNLOCK(), then this is what follows the above:
;2385 
;2386 --- pushed by task's call to KUNLOCK() ---
;2387   stackPtr[8]:    ret_addr (LSB)  (addr following task's call to KUNLOCK())
;2388   stackPtr[9]:    ret_addr (MSB)
;2389 
;2390 
;2391         ---------------------------------------------------------------
;2392 If it was preempted by sched_tick(), then this is what follows the above:
;2393 
;2394  --- pushed by _TimerBISR() (see TimerBISR_PushCount in timerb.h) ---
;2395   stackPtr[8]:    ret_addr (LSB)  (addr inside _TimerBISR())
;2396   stackPtr[9]:    ret_addr (MSB)
;2397 
;2398   stackPtr[10]:   XPC
;2399 
;2400   stackPtr[10]:   AF' (LSB)
;2401   stackPtr[11]:   AF' (MSB)
;2402 
;2403   stackPtr[12]:   BC' (LSB)
;2404   stackPtr[13]:   BC' (MSB)
;2405 
;2406   stackPtr[14]:   DE' (LSB)
;2407   stackPtr[15]:   DE' (MSB)
;2408 
;2409   stackPtr[16]:   HL' (LSB)
;2410   stackPtr[17]:   HL' (MSB)
;2411 
;2412   stackPtr[18]:   BC (LSB)
;2413   stackPtr[19]:   BC (MSB)
;2414 
;2415   stackPtr[20]:   IY (LSB)
;2416   stackPtr[21]:   IY (MSB)
;2417 
;2418   stackPtr[22]:   IX (LSB)
;2419   stackPtr[23]:   IX (MSB)
;2420 
;2421   stackPtr[24]:   HL (LSB)
;2422   stackPtr[25]:   HL (MSB)
;2423 
;2424   stackPtr[26]:   DE (LSB)
;2425   stackPtr[27]:   DE (MSB)
;2426 
;2427   stackPtr[28]:   AF (LSB)
;2428   stackPtr[29]:   AF (MSB)
;2429 
;2430  --- pushed by ISR table "shim" (see IntShim_PushCount) ---
;2431   stackPtr[30]:   ret_addr (LSB)  (addr within ISR table)
;2432   stackPtr[31]:   ret_addr (MSB)
;2433 
;2434   stackPtr[32]:   HL (LSB == L)
;2435   stackPtr[33]:   HL (MSB == H)
;2436 
;2437   stackPtr[34]:   DE (LSB == E)
;2438   stackPtr[35]:   DE (MSB == D)
;2439 
;2440   stackPtr[36]:   AF (LSB == F)
;2441   stackPtr[37]:   AF (MSB == A)
;2442 
;2443  --- pushed by CPU when the timerB interrupt occurs ---
;2444   stackPtr[38]:   ret_addr (LSB)  (addr where task was interrupted)
;2445   stackPtr[39]:   ret_addr (MSB)
;2446 
;2447 NOTE:
;2448 
;2449         ---------------------------------------------------------------
;2450  For the current task, this is what the in-use stack looks like:
;2451 
;2452 --- pushed by postMortem() ---
;2453   stackPtr[0]:    IX (LSB)
;2454   stackPtr[1]:    IX (MSB)
;2455 
;2456 --- pushed by call to postMortem() ---
;2457   stackPtr[2]:    ret_addr (LSB)
;2458   stackPtr[3]:    ret_addr (MSB)
;2459 
;2460   stackPtr[4]:    XPC
;2461 
;2462    Keep in mind that postMortem() is called from a number of places, includ
;2463    dumpFault().  Basically, any code that detects an unrecoverable error wi
;2464    call postMortem() (compared to dumpFault(), which is called ONLY for
;2465    run-time fault interrupts generated by the CPU).
;2466 
;2467 ---------------------*/
;2468 
;2469   printf(
;2470  "                                    ---------Stack--------- \r\n"
;2471  "  PID  PRI  STATUS            IDLE  Start  End   SP  Unused  --PC--  --IP
	.debug	# 2470
	ld	de,word (phys @1+963)
	ld	c,phys @1+963 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2472 //#####  ###  ######## #  ########ms  ##### ##### #####  ####  ######  #-#-
;2473 
;2474 //--- log info about the state of each task ---
;2475   for (i=0; i<NUM_TASKS; ++i)  if ((task = tasks + (uint)i)->inUse)  {
@402:
	.debug	< @402 @403
	.debug	# 2475
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@404:
	ld	hl,(ix-2)
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@405
	ld	hl,(ix-2)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-4),hl
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@407
;2476     WDT_2S();
@408:
	.debug	< @408 @409
	.debug	# 2476
  ld  a,0x5A
  ioi ld  (0x08),a
;2477 
;2478     idle = msSince(task->lastRunning);
	.debug	# 2478
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-4)
	push	bc
	push	de
	ld	de,0xc7
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2479 
;2480     if (task == current)  {
	.debug	# 2480
	ld	hl,(_current)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@410
;2481       sp = _asm( [_HL], "ld hl,ix", _HL );  // IX = SP after IX itself was 
@411:
	.debug	< @411 @412
	.debug	# 2481
ld hl,ix
	ld	(ix-26),hl
;2482       stackPtr = (uchar far *)( ((ulong)(task->sseg) << 12) + (ulong)sp );
	.debug	# 2482
	ld	hl,(ix-4)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-26)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
;2483       pc = *(uint far *)(stackPtr + 2);
	.debug	# 2483
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-24),hl
;2484       xpc = (uint) stackPtr[4];
	.debug	# 2484
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-22),hl
;2485       ip = _asm( [_HL], "push ip", "push ip", "pop hl", _HL ) & 0xFF;
	.debug	# 2485
push ip
push ip
pop hl
	ld	h,0
	ld	(ix-32),hl
;2486     }
@412:
	.debug	>
;2487     else  {  // suspended tasks (i.e. all BUT the current one)
	jp	@413
@410:
;2488       sp = (uint)task->stack;
@414:
	.debug	< @414 @415
	.debug	# 2488
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	(ix-26),hl
;2489       stackPtr = (uchar far *)( ((ulong)(task->sseg) << 12) + (ulong)sp );
	.debug	# 2489
	ld	hl,(ix-4)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-26)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
;2490       if (!task->preempt_count)  {  // schedule() called by kernel func
	.debug	# 2490
	ld	hl,(ix-4)
	ld	de,0xa8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@416
;2491         pc = *(uint far *)(stackPtr + Schedule_PushCount);
@417:
	.debug	< @417 @418
	.debug	# 2491
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-24),hl
;2492         xpc = (uint) stackPtr[Schedule_PushCount + 2];
	.debug	# 2492
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-22),hl
;2493       }
@418:
	.debug	>
;2494       else if (task->preempt_count >= 8)  {  // schedule() called by KUNLOC
	jr	@419
@416:
	.debug	# 2494
	ld	hl,(ix-4)
	ld	de,0xa8
	add	hl,de
	ld	hl,(hl)
	ld	de,0x8008
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@420
;2495         pc = *(uint far *)(stackPtr + Schedule_PushCount + 3);
@421:
	.debug	< @421 @422
	.debug	# 2495
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-24),hl
;2496         xpc = (uint) stackPtr[7];
	.debug	# 2496
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-22),hl
;2497       }
@422:
	.debug	>
;2498       else  {  // schedule() called by sched_tick()
	jr	@423
@420:
;2499         pc = *(uint far *)(stackPtr + Schedule_PushCount + 3 +
@424:
	.debug	< @424 @425
;2500                            TimerBISR_PushCount + IntShim_PushCount);
	.debug	# 2500
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x25
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-24),hl
;2501         xpc = (uint) stackPtr[10];
	.debug	# 2501
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-22),hl
;2502       }
@425:
	.debug	>
;2503       ip = (uint)stackPtr[4];
@423:
@419:
	.debug	# 2503
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-32),hl
;2504     }
@415:
	.debug	>
;2505 
;2506     absPC = (ulong)pc;
@413:
	.debug	# 2506
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,0
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2507     if (pc >= 0xE000)  absPC += ((ulong)xpc << 12);
	.debug	# 2507
	ld	h,d
	ld	l,e
	ld	de,0xe000
	or	a,a
	sbc	hl,de
	jr	c,@426
	ld	hl,(ix-22)
	ex	de,hl
	ld	b,l
	ld	c,l
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2508 
;2509     stackStart = ((ulong)task->stack_start + (((ulong)task->sseg) << 12));
@426:
	.debug	# 2509
	ld	hl,(ix-4)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;2510     stackEnd = stackStart + task->stack_size - 1;
	.debug	# 2510
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__ladd##
	call	__ldec##
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;2511 
;2512     printf("%5d  %3d  %s%2d  %8lums  %05lX %05lX %05lX  %4d  %06lX  %X-%X-%
;2513             task->pid, task->priority, statusDescr(i), task->preempt_count,
;2514             idle, stackStart, stackEnd, (ulong)stackPtr, _stackFree_(task->
;2515             absPC, ip >> 6, (ip >> 4) & 3, (ip >> 2) & 3, ip & 3,
;2516             task->argv[0] );
	.debug	# 2516
	ld	hl,(ix-4)
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-32)
	ld	e,0x3
	and	hl,de
	push	hl
	ld	hl,(ix-32)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	and	hl,de
	push	hl
	ld	hl,(ix-32)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	and	hl,de
	push	hl
	ld	hl,(ix-32)
	ld	a,0x6
	call	__uishr##
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$_stackFree_
	pop	de
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ld	de,0xa8
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$statusDescr
	pop	de
	push	hl
	ld	hl,(ix-4)
	ld	de,0xb8
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	ld	e,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1109)
	ld	c,phys @1+1109 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,44
;2517 
;2518     if (task == current)  {
	.debug	# 2518
	ld	hl,(_current)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@427
;2519       printf(" Stack: ");
@428:
	.debug	< @428 @429
	.debug	# 2519
	ld	de,word (phys @1+1186)
	ld	c,phys @1+1186 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2520       for (ui=0,log_sp=sp;
@430:
	.debug	< @430 @431
	.debug	# 2520
	bool	hl
	ld	l,h
	ld	(ix-28),hl
	ld	hl,(ix-26)
	ld	(ix-30),hl
;2521             (ulong)stackPtr<=stackEnd; ++ui,++stackPtr,++log_sp)  {
@432:
	.debug	# 2521
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	jr	z,@434
	jr	nc,@433
@434:
;2522         if ((ui & 0x0F) == 0)
@436:
	.debug	< @436 @437
	.debug	# 2522
	ld	hl,(ix-28)
	ld	de,0xf
	and	hl,de
	jr	nz,@438
;2523           printf("%05lX (%04X): ", (ulong)stackPtr, log_sp);
	.debug	# 2523
	ld	hl,(ix-30)
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	de,word (phys @1+1195)
	ld	c,phys @1+1195 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;2524         printf("%02X ", *stackPtr);
@438:
	.debug	# 2524
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	de,word (phys @1+1210)
	ld	c,phys @1+1210 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2525         if ((ui & 0x0F) == 0x0F)  printf("\r\n        ");
	.debug	# 2525
	ld	hl,(ix-28)
	ld	de,0xf
	and	hl,de
	or	a,a
	sbc	hl,de
	jr	nz,@439
	ld	de,word (phys @1+1216)
	ld	c,phys @1+1216 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2526       }
@439:
@437:
	.debug	>
;2527       printf("\r\n");
	ld	hl,(ix-28)
	inc	hl
	ld	(ix-28),hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
	ld	hl,(ix-30)
	inc	hl
	ld	(ix-30),hl
	jp	@432
@433:
@431:
	.debug	>
	.debug	# 2527
	ld	de,word (phys @1+97)
	ld	c,phys @1+97 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2528     }
@429:
	.debug	>
;2529 
;2530   }
@427:
@409:
	.debug	>
;2531 
;2532   printf("\n\n");  WDT_2S();
@407:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@404
@405:
@403:
	.debug	>
	.debug	# 2532
	ld	de,word (phys @1+162)
	ld	c,phys @1+162 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
  ld  a,0x5A
  ioi ld  (0x08),a
;2533 
;2534 
;2535   showMemProtection();
	.debug	# 2535
	lcall	$showMemProtection
;2536 
;2537   showIntVectors();
	.debug	# 2537
	lcall	$showIntVectors
;2538 
;2539 
;2540 
;2541 //--- recompute and log the CRCs for the code and const segments ---
;2542   computeMemCRCs(false, true);
	.debug	# 2542
	ld	hl,0x1
	push	hl
	ld	l,h
	push	hl
	lcall	$computeMemCRCs
	add	sp,4
;2543 
;2544   WDT_2S();
	.debug	# 2544
  ld  a,0x5A
  ioi ld  (0x08),a
;2545 
;2546   printf("doCleanShutdown:%d  useSoftReset:%d  allowSoftReset:%d\r\n",
;2547          doCleanShutdown, useSoftReset, allowSoftReset);
	.debug	# 2547
	ld	a,(_allowSoftReset)
	bool	hl
	ld	l,a
	push	hl
	ld	a,(_useSoftReset)
	bool	hl
	ld	l,a
	push	hl
	ld	a,(_doCleanShutdown)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+1227)
	ld	c,phys @1+1227 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;2548 
;2549   closeCrashLog();
	.debug	# 2549
	lcall	$closeCrashLog
;2550 
;2551 
;2552   logDateTime = true;
	.debug	# 2552
	ld	a,0x1
	ld	(_logDateTime),a
;2553 
;2554 
;2555   if (doCleanShutdown AND (current != kernelTask))  for (;;)  {
	.debug	# 2555
	ld	a,(_doCleanShutdown)
	or	a,a
	jr	z,@441
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	z,@441
@442:
	.debug	< @442 @443
@444:
;2556     while (KLOCKED())  KUNLOCK();
@447:
	.debug	< @447 @448
@449:
	.debug	# 2556
	ld	a,(__disabled)
	or	a,a
	jr	z,@450
	call	_KUNLOCK
;2557     if (current == applTask)  {
	jr	@449
@450:
	.debug	# 2557
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jr	nz,@451
;2558       resetWDT();  current->state = TASK_UNINTERRUPTIBLE;  }
@452:
	.debug	< @452 @453
	.debug	# 2558
	lcall	$resetWDT
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
@453:
	.debug	>
;2559     else  {
	jr	@454
@451:
;2560       current->state = TASK_STOPPED;
@455:
	.debug	< @455 @456
	.debug	# 2560
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x4
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2561       current->sig_pending |= sigmask(SIGKILL);
	.debug	# 2561
	ld	hl,(_current)
	ld	e,0xa0
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	set	0,d
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2562     }
@456:
	.debug	>
;2563     schedule();
@454:
	.debug	# 2563
	lcall	$schedule
;2564   }
@448:
	.debug	>
;2565 
;2566 
;2567   REBOOT(true);
	jr	@444
@443:
	.debug	>
@441:
	.debug	# 2567
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
;2568 }
@399:
	.debug	} @399 2568

@398	equ	68
	ld	sp,ix
	pop	ix
	lret
@400	equ	70
;2569 
;2570 
;2571 
;2572 //-------------------------------------------------------------------------
;2573 //  Called when the watchdog timer is about to reboot the system.  This giv
;2574 //  us a chance to copy important diagnostic information to the log, which
;2575 //  will be accessable after we reboot.
;2576 //-------------------------------------------------------------------------
;2577 void wdTimingOut(void)
;2578 {
$wdTimingOut::
	.debug	G $wdTimingOut 37 9
	.debug	{ $wdTimingOut 37 2577 @459 @458
;2579   KLOCK();  WDT_2S();  openCrashLog();
	.debug	# 2579
	call	_KLOCK
  ld  a,0x5A
  ioi ld  (0x08),a
	lcall	$openCrashLog
;2580 
;2581   printf("\r\n***** WatchDog Timer reboot imminent! *****\r\n");
	.debug	# 2581
	ld	de,word (phys @1+1284)
	ld	c,phys @1+1284 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2582 
;2583   doCleanShutdown = false;
	.debug	# 2583
	xor	a,a
	ld	(_doCleanShutdown),a
;2584 
;2585   postMortem("WatchDog Timeout");
	.debug	# 2585
	ld	de,word (phys @1+1332)
	ld	c,phys @1+1332 >> 16
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
;2586 }
@458:
	.debug	} @458 2586

@457	equ	0
	lret
@459	equ	0
;2587 
;2588 
;2589 //-------------------------------------------------------------------------
;2590 //  Test an address to see if it is a viable return address
;2591 //-------------------------------------------------------------------------
;2592 bool  viableCodeAddr(ulong addr)
;2593 {
$viableCodeAddr::
	.debug	G $viableCodeAddr 74 9
	.debug	{ $viableCodeAddr 74 2592 @462 @461
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A addr 5 9
;2594   if (IN_CODE(addr))  return true;
	.debug	# 2594
	ld	hl,(_codeStart)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	c,@464
	ld	hl,(_codeEnd)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	z,@963
	jr	c,@963
;2595 
;2596   if (IN_FARCODE(addr))  return true;
@464:
	.debug	# 2596
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jr	c,@467
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@963
	jr	c,@963
;2597 
;2598 //--- The return addr for all ISR "shims" is 9 bytes into the table entry -
;2599   if (IN_ISR_TBL(addr))  if (((uint)addr & 0x000F) == 9)  return true;
@467:
	.debug	# 2599
	ld	hl,(_intVectStart)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	c,@470
	ld	hl,(_intVectEnd)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsubr##
	jr	z,@471
	jr	nc,@470
@471:
	ld	hl,(ix+5)
	ld	de,0xf
	and	hl,de
	ld	e,0x9
	or	a,a
	sbc	hl,de
	jr	nz,@472
@963:
	ld	a,0x1
	jr	@461
;2600 
;2601   return false;
@472:
@470:
	.debug	# 2601
	xor	a,a
;2602 }
@461:
	.debug	} @461 2602

@460	equ	0
	pop	ix
	lret
@462	equ	2
;2603 
;2604 
;2605 
;2606 //--- values for flags argument ---
;2607 #define  GuessedXPC    0x0001
;2608 //-------------------------------------------------------------------------
;2609 //  Generate a msg showing the following info on an (alleged) function call
;2610 //    - The address of the called function (if not an indirect call)
;2611 //    - The address where the call was made from
;2612 //    - The (logical) address on the stack of the (alleged) return address
;2613 //-------------------------------------------------------------------------
;2614 void showMatch(ulong toAddr, ulong fromAddr, uint flags, uchar *sp)
;2615 {
$showMatch::
	.debug	G $showMatch 75 9
	.debug	{ $showMatch 75 2614 @475 @474
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A toAddr 5 9
	.debug	A fromAddr 9 9
	.debug	A flags 13 7
	.debug	A sp 15 40
;2616   static uchar  *prevSP;
	.bseg
@476:
	.ds	2
	.debug	S prevSP @476 40
	.seg	FARCODE
;2617   static ulong  prevTo, prevFrom;
	.bseg
@477:
	.ds	4
	.debug	S prevTo @477 9
	.seg	FARCODE
	.bseg
@478:
	.ds	4
	.debug	S prevFrom @478 9
	.seg	FARCODE
;2618   char *str;
	.debug	L str -2 40
;2619 
;2620 
;2621   if (!toAddr)  return;
	.debug	# 2621
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	or	hl,de
	jp	z,@474
;2622 
;2623   if ((sp == prevSP) AND (toAddr == prevTo) AND (fromAddr == prevFrom))  re
	.debug	# 2623
	ld	hl,(@476)
	ex	de,hl
	ld	hl,(ix+15)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@481
	ld	hl,(ix+5)
	ex	de,hl
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,(@477)
	ld	bc,(@477+2)
	call	__lsub##
	jr	nz,@481
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(@478)
	ld	bc,(@478+2)
	call	__lsub##
	jp	z,@474
;2624 
;2625   str = (flags & GuessedXPC) ? "(?)" : "";
@481:
	.debug	# 2625
	ld	hl,(ix+13)
	ld	de,0x1
	and	hl,de
	jr	z,@482
	ld	hl,@66+67
	jr	@483
@482:
	ld	hl,@66+8
@483:
	ld	(ix-2),hl
;2626 
;2627   if (sp != prevSP)  printf("\r\n");
	.debug	# 2627
	ld	hl,(@476)
	ex	de,hl
	ld	hl,(ix+15)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@485
	ld	de,word (phys @1+97)
	ld	c,phys @1+97 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2628 
;2629   if ((toAddr == (ulong)CallDE) OR (toAddr == (ulong)CallHL))
@485:
	.debug	# 2629
ld de,__callde##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jp	z,@486
ld de,__callhl##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	nz,@487
@486:
;2630     printf("  ?????");
	.debug	# 2630
	ld	de,word (phys @1+1349)
	ld	c,phys @1+1349 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2631   else
;2632     printf("  %05lX", toAddr);
	jr	@488
@487:
	.debug	# 2632
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1357)
	ld	c,phys @1+1357 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2633 
;2634   printf(" called from %05lX [%04X] %s\r\n", fromAddr, (uint)sp, str);
@488:
	.debug	# 2634
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1365)
	ld	c,phys @1+1365 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;2635 
;2636   prevTo = toAddr;  prevFrom = fromAddr;  prevSP = sp;
	.debug	# 2636
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(@477),de
	ld	(@477+2),bc
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ld	(@478),de
	ld	(@478+2),bc
	ld	hl,(ix+15)
	ld	(@476),hl
;2637 }
@474:
	.debug	} @474 2637

@473	equ	2
	ld	sp,ix
	pop	ix
	lret
@475	equ	4
;2638 
;2639 //-------------------------------------------------------------------------
;2640 //  Attempt to provide a reasonably accurate stack trace using heuristic
;2641 //  methods to deduce the sequence of function calls that preceeded a hardw
;2642 //  protection fault or an unhandled interrupt.
;2643 //
;2644 //  Arguments:
;2645 //    sp:
;2646 //       Logical addr within the current stack to begin looking.
;2647 //    endStack:
;2648 //       The logical addr of the end of the current stack
;2649 //  -----------------------------------------------------------------------
;2650 //
;2651 //  There is no information on the stack that makes a stack trace easy and
;2652 //  reliable.  However, using the following facts and some assumptions base
;2653 //  on the code generated by the compiler, we should still be able to repro
;2654 //  the sequence of calls that got us here.
;2655 //
;2656 //  NOTE:  There are many false positives in the results, which I expect is
;2657 //         to the following fact:  Any local variable that a function doesn
;2658 //         use means the location on the stack corresponding to that variab
;2659 //         will retain whatever value it had before.  For variables like
;2660 //         strings, there is a good chance that a significant size chunk of
;2661 //         the data on the stack has values from past function call events
;2662 //         that are not along the path leading to the present call to this
;2663 //         function.
;2664 //
;2665 //         The bytes that DO contain the return addresses for the calls alo
;2666 //         the path should still be there, which means we should be able to
;2667 //         find them.  But experience has shown that the majority of the
;2668 //         candidates we find do NOT actually represent calls that are part
;2669 //         of the sequence that lead to this function being called, which m
;2670 //         we have to manually illiminate all the false positives to make
;2671 //         sense out of the result.
;2672 //
;2673 //
;2674 //    - Return addresses for function/subroutine calls will point to an add
;2675 //      that follows a CALL, LCALL, or some equivalent set of instructions
;2676 //      (like one or more PUSH instructions followed by a JP or LJP).
;2677 //
;2678 //    - A call from (or interrupt of) a far function will push a 2-byte add
;2679 //      that is >= 0xE000.  For a near function, the address will be < 0xD0
;2680 //
;2681 //    - Return addresses will always be within one of the CODE segments or 
;2682 //      interrupt vector table.
;2683 //
;2684 //    - The presence (or lack of) an XPC value on the stack is dependent up
;2685 //      whether the call was TO a near function or a far function.  It has
;2686 //      nothing to do with what type of function the call was FROM.  An LCA
;2687 //      in a near func still pushes the current XPC value, and a CALL in a 
;2688 //      function does NOT.
;2689 //
;2690 //      Since we don't know with any certainty if the call sequence we are
;2691 //      trying to reconstruct is accurate, we cannot know for certain if we
;2692 //      are looking for a CALL or LCALL (or their equivalent) to preceed a
;2693 //      potential return address.  And the use of indirect calls (particula
;2694 //      to a redirector for a far function) just makes any attempt to deter
;2695 //      such information even more difficult.
;2696 //
;2697 //      However, there is still one use we can get out of the difference
;2698 //      between CALL and LCALL:  When testing a potential return address, t
;2699 //      presence of an LCALL at the appropriate address can be further veri
;2700 //      by the fact that a real LCALL pushes the XPC value on the stack.  W
;2701 //      means that if the next byte on the stack isn't a viable XPC value, 
;2702 //      the value being tested is isn't really a return address.
;2703 //
;2704 //    - DEBROS uses the interrupt vectors to disable the scheduler while an
;2705 //      interrupt is being serviced, and it calls the ISR from the vector.
;2706 //      This means the return address (from the point of view of the ISR) w
;2707 //      always be at a specific offset from the start of the vector.  This
;2708 //      makes it easy to determine when an interrupt has happened and makes
;2709 //      easy to find the return address that was pushed when the interrupt
;2710 //      occured (since it will be at a fixed offset from the one the vector
;2711 //      pushed).
;2712 //
;2713 //      This is important because the address pushed on the stack when the
;2714 //      interrupt occured can be for any address in the CODE or FARCODE
;2715 //      segments, and there won't be any CALL or LCALL (or equiv instructio
;2716 //      preceeding the address.
;2717 //
;2718 //
;2719 //  Since we can't, as stated, have any real confidence in our reconstructi
;2720 //  of the sequence of calls, here is how we use the above facts:
;2721 //
;2722 //    - For each pair of bytes on the stack, check to see if they form an
;2723 //      address within the CODE or FARCODE segment, or at the appropriate
;2724 //      offset within one of the entries of the interrupt vector table.  If
;2725 //      value doesn't meet one of these criteria, advance to the next byte 
;2726 //      the stack.
;2727 //
;2728 //    - For each potential return address in the CODE or FARCODE segments,
;2729 //      check for a preceeding CALL or LCALL instruction at the appropriate
;2730 //      address.  If neither is found, then advance to the next byte in the
;2731 //      stack.
;2732 //
;2733 //    - If a CALL is found, make sure the called address is in the CODE seg
;2734 //      If an LCALL is found, make sure the called address is in the FARCOD
;2735 //      segment, and that the next byte on the stack contains an XPC value 
;2736 //      matches the return address currently being tested.
;2737 //
;2738 //      Remember that, if the LCALL being tested is in the CODE segment, th
;2739 //      only verification we can do on the potential XPC value on the stack
;2740 //      to determine whether or not it can point to addresses within the
;2741 //      FARCODE segment.
;2742 //
;2743 //    - For potential return addresses that point to an interrupt vector, c
;2744 //      the appropriate bytes on the stack to make sure they form an addres
;2745 //      that passes the first test (i.e. the address is within one of the C
;2746 //      segments or the interrupt vector table).
;2747 //  -----------------------------------------------------------------------
;2748 //
;2749 //  NOTES/Thoughts:
;2750 //
;2751 //     The stack trace is not MISSING calls, so all the false matches are
;2752 //     coming from values on the stack that represent either arguments push
;2753 //     on the stack before a call or local variables for the called functio
;2754 //
;2755 //     The only plausible reason I can think of for there being so many fal
;2756 //     positives is that they are leftover from earlier calls along differe
;2757 //     branches that happen to reside in a memory location for a local
;2758 //     variable that was not used by the sequence of functions along the pa
;2759 //     that lead to the stack trace.
;2760 //
;2761 //  False vs real matches:
;2762 //
;2763 //     The existence of a "add sp,nn" instruction at a return address could
;2764 //     tell me how many bytes following a return address could be ignored.
;2765 //     But if the call is a false match, then that could easily cause me to
;2766 //     ignore real matches.
;2767 //
;2768 //     Then again, it is likely that the pushed argument values will overwr
;2769 //     leftover return addresses.  What is MORE likely is that the leftover
;2770 //     values are occupying local variable space for variables that were no
;2771 //     written to before the function they belong to called another functio
;2772 //
;2773 //     In that case, I would want to look for a "sub sp,nn" (or whatever) a
;2774 //     the start of a function.  But I don't know where to look for that un
;2775 //     AFTER I have already processed the bytes I would most likely want to
;2776 //     skip.  And the effect of using this information for false matches is
;2777 //     still the same.
;2778 //
;2779 //  XPC values, near vs far calls:
;2780 //
;2781 //     The redirector method used by the Softools compiler means that near
;2782 //     calls can lead to far functions.  And the fact that the most common
;2783 //     (possibly the only) use of this approach is for indirect calls (i.e.
;2784 //     a pointer refers to the redirector) means there is no practical way
;2785 //     to determine WHAT was called by the redirector.
;2786 //
;2787 //     However, it is worth remembering that an XPC value can be useful
;2788 //     in tracing backwards beyond a single call.  If the potential return
;2789 //     address matches a call from a near function to a far function (which
;2790 //     could be a near call to a redirector), then the XPC value doesn't
;2791 //     tell us anything about the call that (potentialy) put it on the
;2792 //     stack, but it does help filter out false matches for an earlier call
;2793 //     Specifically, as we trace backwards along the sequence of calls, we
;2794 //     can throw out any calls to near funcs from far funcs that don't fit
;2795 //     the XPC value until we find one that does.
;2796 //
;2797 //
;2798 //  Build a tree of possible call sequences:
;2799 //
;2800 //     The more I think about it, the only way I can think of to filter out
;2801 //     the false positives is to build a tree of possible call sequences.
;2802 //
;2803 //     Like I did with my original (less than accurate) attempt at a stack
;2804 //     trace, I need to take in to account the possible matches preceeding
;2805 //     the ones currently under consideration to help eliminate false
;2806 //     positives.  However, rather than merely keeping a fixed-size list of
;2807 //     recent possible called addresses, I need to make it a tree.
;2808 //
;2809 //     Using the address I am tracing backwards from as the root, what I
;2810 //     do is test each potential return address against every node in the
;2811 //     tree.  Each one that could be call leading to that node is added
;2812 //     as a child of that node.
;2813 //
;2814 //     When I am done, I print out all the sequences that lead back to
;2815 //     an address within the taskStart() function.
;2816 //
;2817 //     (Actually, that last part doesn't really work, since the call from
;2818 //     taskStart() is an indirect one, so it would match ALL the leaves on
;2819 //     the tree, so they would ALL pass that test!)
;2820 //
;2821 //     But, while there may be many trees, they should each be reasonably
;2822 //     short, so perhaps printing them all out is not a big deal.
;2823 //
;2824 //     However, to keep the dump process as quick as possible (and to avoid
;2825 //     using up even MORE memory on the controller for the additional code
;2826 //     and the data), this is probably best left as something to do in the
;2827 //     application that currently parses a dump file and a map file and add
;2828 //     the symbolic information.
;2829 //
;2830 //-------------------------------------------------------------------------
;2831 void stackTrace(uchar *sp, uchar *stackEnd)
;2832 {
$stackTrace::
	.debug	G $stackTrace 76 9
	.debug	{ $stackTrace 76 2831 @491 @490
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-22
	.debug	A sp 5 40
	.debug	A stackEnd 7 40
;2833   uint  retAddr,  prevAddr, intNum;
	.debug	L retAddr -2 7
	.debug	L prevAddr -4 7
	.debug	L intNum -6 7
;2834   ulong  testAddr, toAddr, xpcWindow;
	.debug	L testAddr -10 9
	.debug	L toAddr -14 9
	.debug	L xpcWindow -18 9
;2835   uchar far  *instrAddr;
	.debug	L instrAddr -22 34
;2836 
;2837 
;2838 #define  VIABLE_RET_ADDR(addr)  
;2839   (IN_CODE(retAddr) OR IN_FARCODE(retAddr) OR IN_ISR_TBL(retAddr))
;2840 
;2841 
;2842   prevAddr = 0;
	.debug	# 2842
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;2843 
;2844   for  (; sp < stackEnd; ++sp)  {
@492:
	.debug	< @492 @493
@494:
	.debug	# 2844
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@495
;2845     retAddr = *(uint *)sp;  WDT_2S();
@497:
	.debug	< @497 @498
	.debug	# 2845
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
  ld  a,0x5A
  ioi ld  (0x08),a
;2846 
;2847     if ((retAddr == 0xFFFF) AND (prevAddr == 0xFFFF))  continue;
	.debug	# 2847
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@500
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jp	z,@496
;2848 
;2849     prevAddr = retAddr;
@500:
	.debug	# 2849
	ld	hl,(ix-2)
	ld	(ix-4),hl
;2850 
;2851 //    printf("    %04X: %04X\r\n", (uint)sp, retAddr);  //tdebug
;2852 
;2853     if (!viableCodeAddr(retAddr))  continue;
	.debug	# 2853
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$viableCodeAddr
	add	sp,4
	or	a,a
	jp	z,@496
;2854 
;2855 
;2856   //--- test for a call from an interrupt vector ---
;2857     if (IN_ISR_TBL(retAddr))  {
	.debug	# 2857
	ld	hl,(ix-2)
	ld	de,(_intVectStart)
	or	a,a
	sbc	hl,de
	jp	c,@503
	ld	hl,(ix-2)
	ld	de,(_intVectEnd)
	or	a,a
	sbc	hl,de
	jr	z,@504
	jr	nc,@503
@504:
;2858       intNum = (retAddr - intVectStart) >> 4;
@505:
	.debug	< @505 @506
	.debug	# 2858
	ld	hl,(ix-2)
	ld	de,(_intVectStart)
	or	a,a
	sbc	hl,de
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-6),hl
;2859       retAddr = *(uint *)(sp + IntShim_PushCount);
	.debug	# 2859
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
;2860       if (!viableCodeAddr(retAddr))  continue;
	.debug	# 2860
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$viableCodeAddr
	add	sp,4
	or	a,a
	jp	z,@496
;2861       printf("\r\n*** Interrupt 0x%02X occured at ", intNum);
	.debug	# 2861
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @1+1396)
	ld	c,phys @1+1396 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2862       if (retAddr < 0xE000)
	.debug	# 2862
	ld	hl,(ix-2)
	ld	de,0xe000
	or	a,a
	sbc	hl,de
	jr	nc,@508
;2863         printf("%05X", retAddr);
	.debug	# 2863
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1431)
	ld	c,phys @1+1431 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2864       else
;2865         printf("??:%04X", retAddr);
	jr	@509
@508:
	.debug	# 2865
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1436)
	ld	c,phys @1+1436 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2866       printf(" ***\r\n");  continue;
@509:
	.debug	# 2866
	ld	de,word (phys @1+1444)
	ld	c,phys @1+1444 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2867     }
	jp	@496
@506:
	.debug	>
;2868 
;2869 
;2870     toAddr = 0;
@503:
	.debug	# 2870
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2871 
;2872   //===== NEAR call from NEAR func =====
;2873   //---  For this case, there is no XPC value on the stack and the retAddr 
;2874   //--- tells us precisely where to look for a CALL instruction ---
;2875     if (IN_CODE(retAddr))  {
	.debug	# 2875
	ld	hl,(ix-2)
	ld	de,(_codeStart)
	or	a,a
	sbc	hl,de
	jp	c,@511
	ld	hl,(ix-2)
	ld	de,(_codeEnd)
	or	a,a
	sbc	hl,de
	jr	z,@512
	jr	nc,@511
@512:
;2876       instrAddr = (uchar far *)retAddr - 3;
@513:
	.debug	< @513 @514
	.debug	# 2876
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	de,0xfffd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2877       if (*instrAddr == 0xCD)  {   // CALL mn (n m)
	.debug	# 2877
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,205
	jr	nz,@515
;2878         toAddr = *(uint far *)(instrAddr+1);
@516:
	.debug	< @516 @517
	.debug	# 2878
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	hl,0
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2879         if (IN_CODE(toAddr))
	.debug	# 2879
	ld	hl,(_codeStart)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsubr##
	jr	c,@519
	ld	hl,(_codeEnd)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsubr##
	jr	z,@520
	jr	nc,@519
@520:
;2880           showMatch(toAddr, (ulong)instrAddr, 0, sp);
	.debug	# 2880
	ld	hl,(ix+5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2881       }
@519:
@517:
	.debug	>
;2882     }
@515:
@514:
	.debug	>
;2883 
;2884 
;2885   //==== FAR call from FAR func =====
;2886   //--- For this case, the return addr on the stack includes an XPC value -
;2887   //--- and it tells us precisely where to look for an LCALL instr ---
;2888     if (retAddr >= 0xE000)  {
@511:
	.debug	# 2888
	ld	hl,(ix-2)
	ld	de,0xe000
	or	a,a
	sbc	hl,de
	jp	c,@521
;2889       testAddr = (ulong)retAddr + ((ulong)sp[2] << 12);
@522:
	.debug	< @522 @523
	.debug	# 2889
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	e,(hl)
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;2890       instrAddr = (uchar far *)testAddr - 4;
	.debug	# 2890
	push	bc
	push	de
	ld	de,0xfffc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2891       if (*instrAddr == 0xCF)  {  // LCALL x,mn  (n m x)
	.debug	# 2891
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,207
	jp	nz,@524
;2892         toAddr = (ulong) *((uint far *)(instrAddr+1))
@525:
	.debug	< @525 @526
;2893                    + ((ulong)instrAddr[3] << 12);
	.debug	# 2893
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	e,l
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2894         if (IN_FARCODE(toAddr))
	.debug	# 2894
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jr	c,@528
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@529
	jr	nc,@528
@529:
;2895           showMatch(toAddr, (ulong)instrAddr, 0, sp);
	.debug	# 2895
	ld	hl,(ix+5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2896       }
@528:
@526:
	.debug	>
;2897     }
@524:
@523:
	.debug	>
;2898 
;2899 
;2900   //===== FAR call from NEAR func =====
;2901   //--- For this case, the return addr on the stack contains an XPC but it 
;2902   //--- has nothing to do with where we look for the LCALL instr.  However,
;2903   //--- the XPC value DOES have to be one that at least starts in FARCODE -
;2904     if (IN_CODE(retAddr))  {
@521:
	.debug	# 2904
	ld	hl,(ix-2)
	ld	de,(_codeStart)
	or	a,a
	sbc	hl,de
	jp	c,@531
	ld	hl,(ix-2)
	ld	de,(_codeEnd)
	or	a,a
	sbc	hl,de
	jr	z,@532
	jp	nc,@531
@532:
;2905       xpcWindow = 0x0E000L + ((ulong)sp[2] << 12);
@533:
	.debug	< @533 @534
	.debug	# 2905
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	e,(hl)
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,0xe000
	ld	c,e
	ld	b,e
	call	__ladd##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;2906       if (IN_FARCODE(xpcWindow))  {
	.debug	# 2906
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jp	c,@536
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@537
	jp	nc,@536
@537:
;2907         instrAddr = (uchar far *)retAddr - 4;
@538:
	.debug	< @538 @539
	.debug	# 2907
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xfffc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2908         if (*instrAddr == 0xCF)  {  // LCALL x,mn  (n m x)
	.debug	# 2908
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,207
	jp	nz,@540
;2909           toAddr = (ulong) *((uint far *)(instrAddr+1))
@541:
	.debug	< @541 @542
;2910                      + ((ulong)instrAddr[3] << 12);
	.debug	# 2910
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	e,l
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2911           if (IN_FARCODE(toAddr))
	.debug	# 2911
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jr	c,@544
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@545
	jr	nc,@544
@545:
;2912             showMatch(toAddr, (ulong)instrAddr, 0, sp);
	.debug	# 2912
	ld	hl,(ix+5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2913         }
@544:
@542:
	.debug	>
;2914       }
@540:
@539:
	.debug	>
;2915     }
@536:
@534:
	.debug	>
;2916 
;2917 
;2918   //===== INDIRECT calls to a FAR func ====
;2919   //--- Such calls are accomplished by doing a near call to a redirector --
;2920   //--- function using __callde() or __callhl().  The redirector pops the -
;2921   //--- logical return addr and does an LCALL to a stub preceeding the far 
;2922   //--- func which replaces the 2-byte logical return addr (from the ---
;2923   //--- redirector) with the popped addr from the original near call to the
;2924   //--- redirector.  The result is the logical return addr + the XPC value 
;2925   //--- the far func needs to do an LRET to the orig caller.  The retAddr -
;2926   //--- being tested tells us whether the call came from a near or far ---
;2927   //--- function, which tells us whether the XPC value on the stack is ---
;2928   //--- part of the return address ---
;2929 
;2930   //===== INDIRECT call to a FAR from a FAR func ====
;2931   //--- This is very similar to a "FAR call from FAR func" except that it -
;2932   //--- uses a CALL to an indirection func rather than a direct LCALL to --
;2933   //--- the target function ---
;2934     if (retAddr >= 0xE000)  {
@531:
	.debug	# 2934
	ld	hl,(ix-2)
	ld	de,0xe000
	or	a,a
	sbc	hl,de
	jp	c,@546
;2935       testAddr = (ulong)retAddr + ((ulong)sp[2] << 12);
@547:
	.debug	< @547 @548
	.debug	# 2935
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	e,(hl)
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;2936       if (IN_FARCODE(testAddr))  {
	.debug	# 2936
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jp	c,@550
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@551
	jp	nc,@550
@551:
;2937         instrAddr = (uchar far *)testAddr - 3;
@552:
	.debug	< @552 @553
	.debug	# 2937
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2938         if (*instrAddr == 0xCD)  {   // CALL mn (n m)
	.debug	# 2938
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,205
	jp	nz,@554
;2939           toAddr = *(uint far *)(instrAddr+1);
@555:
	.debug	< @555 @556
	.debug	# 2939
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	bc,0
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2940           if ((toAddr == (ulong)CallDE) OR (toAddr == (ulong)CallHL))
	.debug	# 2940
ld de,__callde##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsub##
	jp	z,@557
ld de,__callhl##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsub##
	jr	nz,@558
@557:
;2941             showMatch(toAddr, (ulong)instrAddr, 0, sp);
	.debug	# 2941
	ld	hl,(ix+5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2942         }
@558:
@556:
	.debug	>
;2943       }
@554:
@553:
	.debug	>
;2944     }
@550:
@548:
	.debug	>
;2945 
;2946   //===== INDIRECT call to a FAR from a NEAR func ====
;2947   //--- This is very similar to a "FAR call from NEAR func" except that it 
;2948   //--- uses a CALL to an indirection func rather than a direct LCALL to --
;2949   //--- the target function ---
;2950     if (IN_CODE(retAddr))  {
@546:
	.debug	# 2950
	ld	hl,(ix-2)
	ld	de,(_codeStart)
	or	a,a
	sbc	hl,de
	jp	c,@560
	ld	hl,(ix-2)
	ld	de,(_codeEnd)
	or	a,a
	sbc	hl,de
	jr	z,@561
	jp	nc,@560
@561:
;2951       xpcWindow = 0x0E000L + ((ulong)sp[2] << 12);
@562:
	.debug	< @562 @563
	.debug	# 2951
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	e,(hl)
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,0xe000
	ld	c,e
	ld	b,e
	call	__ladd##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;2952       if (IN_FARCODE(xpcWindow))  {
	.debug	# 2952
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jp	c,@565
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@566
	jp	nc,@565
@566:
;2953         instrAddr = (uchar far *)retAddr - 3;
@567:
	.debug	< @567 @568
	.debug	# 2953
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xfffd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2954         if (*instrAddr == 0xCD)  {   // CALL mn (n m)
	.debug	# 2954
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,205
	jp	nz,@569
;2955           toAddr = *(uint far *)(instrAddr+1);
@570:
	.debug	< @570 @571
	.debug	# 2955
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	bc,0
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2956           if ((toAddr == (ulong)CallDE) OR (toAddr == (ulong)CallHL))
	.debug	# 2956
ld de,__callde##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsub##
	jp	z,@572
ld de,__callhl##
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsub##
	jr	nz,@573
@572:
;2957             showMatch(toAddr, (ulong)instrAddr, 0, sp);
	.debug	# 2957
	ld	hl,(ix+5)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2958         }
@573:
@571:
	.debug	>
;2959       }
@569:
@568:
	.debug	>
;2960     }
@565:
@563:
	.debug	>
;2961 
;2962 
;2963   //===== NEAR call from FAR func =====
;2964   //--- For this case, there is no XPC value on the stack, but we DO care -
;2965   //--- what it was since such a call would have come from memory mapped by
;2966   //--- the XPC reg.  Since we don't have any way to know what it was, all 
;2967   //--- we can do is try every viable XPC value and look for a valid-lookin
;2968   //--- CALL instruction ---
;2969   //  NOTE:  I STILL cannot believe how many legitamate looking calls this
;2970   //         finds!  Anywhere from 1 to 4 of the tested XPC values finds
;2971   //         the value CD at the same offset from the 4K XPC boundaries,
;2972   //         followed by a 2-byte value that is within the range of addrs
;2973   //         in the CODE segment).   Even MORE unbelievable is that the
;2974   //         addresses actually ARE valid function pointers in almost
;2975   //         every case.  Which suggests that these really ARE function
;2976   //         calls being found, and just by chance happen to be at an
;2977   //         address whose least-significant 12-bits just happens to be
;2978   //         the same as 1, 2, even 3 other function calls AND matches
;2979   //         the least 12 significant bits of the value from the stack
;2980   //         that is being tested.
;2981     if (retAddr >= 0xE000)  {
@560:
	.debug	# 2981
	ld	hl,(ix-2)
	ld	de,0xe000
	or	a,a
	sbc	hl,de
	jp	c,@574
;2982       testAddr = (ulong)retAddr;
@575:
	.debug	< @575 @576
	.debug	# 2982
	ld	hl,(ix-2)
	ex	de,hl
	ld	c,l
	ld	h,l
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;2983       for (; testAddr<=farCodeEnd; testAddr+=0x1000L)  {
@577:
	.debug	< @577 @578
@579:
	.debug	# 2983
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	call	__lsub##
	jr	z,@581
	jp	nc,@580
@581:
;2984         instrAddr = (uchar far *)testAddr - 3;
@583:
	.debug	< @583 @584
	.debug	# 2984
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;2985         if (*instrAddr == 0xCD)  {   // CALL mn (n m)
	.debug	# 2985
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,205
	jr	nz,@585
;2986           toAddr = *(uint far *)(instrAddr+1);
@586:
	.debug	< @586 @587
	.debug	# 2986
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__linc##
	call	__farld2##
	ld	hl,0
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2987           if (IN_CODE(toAddr))
	.debug	# 2987
	ld	hl,(_codeStart)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsubr##
	jr	c,@589
	ld	hl,(_codeEnd)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__lsubr##
	jr	z,@590
	jr	nc,@589
@590:
;2988             showMatch(toAddr, (ulong)instrAddr, GuessedXPC, sp);
	.debug	# 2988
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x1
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showMatch
	add	sp,12
;2989         }
@589:
@587:
	.debug	>
;2990       }
@585:
@584:
	.debug	>
;2991     }
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	jp	@579
@580:
@578:
	.debug	>
@576:
	.debug	>
;2992 
;2993   }
@574:
@498:
	.debug	>
;2994 
;2995 }
@496:
	ld	hl,(ix+5)
	inc	hl
	ld	(ix+5),hl
	jp	@494
@495:
@493:
	.debug	>
@490:
	.debug	} @490 2995

@489	equ	22
	ld	sp,ix
	pop	ix
	lret
@491	equ	24
;2996 
;2997 
;2998 //-------------------------------------------------------------------------
;2999 //  The current task caused a hardware protection fault or invoked an inter
;3000 //  for which no handler was set.
;3001 //
;3002 //  This function dumps the state the processor had at the time the fault
;3003 //  occured.  It should ONLY be called by the ISR functions that handle one
;3004 //  of the hardware detected run-time faults.
;3005 //-------------------------------------------------------------------------
;3006 void dumpFault(const char far *context)
;3007 {
$dumpFault::
	.debug	G $dumpFault 36 9
	.debug	{ $dumpFault 36 3006 @593 @592
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-48
	.debug	A context 5 34
;3008   uint  ui;
	.debug	L ui -2 7
;3009   uchar  *sp, *ptr, *stackEnd;
	.debug	L sp -4 40
	.debug	L ptr -6 40
	.debug	L stackEnd -8 40
;3010   ulong  faultAddr, absAddr;
	.debug	L faultAddr -12 9
	.debug	L absAddr -16 9
;3011   char  temp[32];
	.debug	L temp -48 73
;3012 
;3013 
;3014   KLOCK();  WDT_2S();  openCrashLog();  ipset1();  logDateTime = false;
	.debug	# 3014
	call	_KLOCK
  ld  a,0x5A
  ioi ld  (0x08),a
	lcall	$openCrashLog
	ipset	1
	xor	a,a
	ld	(_logDateTime),a
;3015 
;3016   useSoftReset = doShutdown = doReboot = true;
	.debug	# 3016
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
	ld	(_useSoftReset),a
;3017 
;3018 /*====================================================================*
;3019   ===== This is what the stack should look like at this point: =====
;3020 
;3021       SP ==> (logical addr of last byte pushed on to stack)
;3022 
;3023     ---- pushed by this function (2 bytes) ---
;3024               (?) local variables
;3025     sp[-36]   (2) IX
;3026 
;3027     --- pushed by interrupt/fault handler (28 bytes) ---
;3028     --- (e.g. WriteFault(), StackLimit(), ...)
;3029     sp[-34]   (2) logical return address
;3030     sp[-32]   (1) XPC of return address
;3031     sp[-31]   (4) far pointer to context str
;3032     sp[-27]   (2) AF'
;3033     sp[-25]   (2) IX
;3034     sp[-23]   (2) IY
;3035     sp[-21]   (2) BC'
;3036     sp[-19]   (2) DE'
;3037     sp[-17]   (2) HL'
;3038     sp[-15]   (2) AF  (F already altered by int vector shim)
;3039     sp[-13]   (2) BC
;3040     sp[-11]   (2) DE
;3041     sp[-9]    (2) HL  (set to addr of _disable by int vector)
;3042     sp[-7]    (1) IP
;3043 
;3044     --- pushed by interrupt vector "shim" (IntShim_PushCount bytes)---
;3045     sp[-6]    (2) return addr within int vector
;3046     sp[-4]    (2) HL
;3047     sp[-2]    (2) AF
;3048 
;3049     --- pushed when fault occured ---
;3050     sp[0]     (2) Addr of instr following the one that caused the fault
;3051 
;3052     --- everything that was on the stack before the fault occured ---
;3053     sp[2]     (?) ...
;3054  *====================================================================*/
;3055 
;3056 //--- Assumes above is correct and sp = value of SP at time fault occured -
;3057 #define  ReturnAddr  (*(uint *)(sp-6))
;3058 
;3059 #define  REG_AF   (*(uint *)(sp-2))
;3060 #define  REG_HL   (*(uint *)(sp-4))
;3061 #define  REG_DE   (*(uint *)(sp-11))
;3062 #define  REG_BC   (*(uint *)(sp-13))
;3063 
;3064 //#define  REG_AF_  _asm( [_HL], "exx", "push af", "pop hl", "exx", _HL )
;3065 #define  REG_AF_  (*(uint *)(sp-27))
;3066 #define  REG_HL_  (*(uint *)(sp-17))
;3067 #define  REG_DE_  (*(uint *)(sp-19))
;3068 #define  REG_BC_  (*(uint *)(sp-21))
;3069 
;3070 #define  REG_IX   (*(uint *)(sp-25))
;3071 #define  REG_IY   (*(uint *)(sp-23))
;3072 #define  REG_SP   (sp)
;3073 #define  REG_PC   (*(uint *)(sp))
;3074 
;3075 #define  REG_IP   (*(uchar *)(sp-7))
;3076 #define  REG_IIR  _asm( [_A], "ld a,iir", _A )
;3077 #define  REG_EIR  _asm( [_A], "ld a,eir", _A )
;3078 #define  REG_XPC  (*(uchar *)(sp-32))
;3079 
;3080 
;3081   // When the fault occurs, the logical address at which it happened is pus
;3082   // on to the stack.  The interrupt vector "shim" then pushes IntShimCount
;3083   // bytes (currently 6), the fault-handler pushes 26 bytes, and this funct
;3084   // pushes IX (2 more) before copying the value of SP to IX.  Here we get 
;3085   // value SP had at that time from IX, then add to it so it points to the
;3086   // logical address in the currently mapped in stack where the occurance o
;3087   // a fault caused the value of PC to be saved.
;3088   sp = (uchar *) _asm( [_HL], "ld hl,ix", _HL ) + 2 + 28 + IntShim_PushCoun
	.debug	# 3088
ld hl,ix
	ld	de,0x1c+1+1
	add	hl,de
	ld	de,0x6
	add	hl,de
	ld	(ix-4),hl
;3089 
;3090   faultAddr = REG_PC;
	.debug	# 3090
	ld	hl,(hl)
	ex	de,hl
	ld	l,h
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;3091   if (faultAddr >= 0xE000)  faultAddr += (ulong)REG_XPC << 12;
	.debug	# 3091
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe000
	call	__lsub##
	jr	c,@594
	ld	hl,(ix-4)
	ld	de,0xffe0
	add	hl,de
	ld	e,(hl)
	ld	bc,0
	ld	d,c
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;3092 
;3093   dateTimeMS(temp, TIME(), milliTicks);
@594:
	.debug	# 3093
	ld	hl,(_milliTicks)
	push	hl
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	push	bc
	push	de
	ld	hl,-42+@591
	add	hl,sp
	push	hl
	lcall	$dateTimeMS
	add	sp,8
;3094 
;3095   printf("\r\n\r\n%s %.24s[%d]:\r\n"
;3096          " ***** %ls fault occured at: 0x%05lX *****\r\n"
;3097          "\n"
;3098          "Interrupt Vector: 0x%04X\r\n"
;3099          "\n",
;3100          temp, current->argv[0], current->pid, context, faultAddr,
;3101          ReturnAddr & 0xFFF0 );
	.debug	# 3101
	ld	hl,(ix-4)
	ld	de,0xfffa
	add	hl,de
	ld	hl,(hl)
	ld	e,0xf0
	and	hl,de
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(_current)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,-34+@591
	add	hl,sp
	push	hl
	ld	de,word (phys @1+1451)
	ld	c,phys @1+1451 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;3102 
;3103   faultAddr -= 16;
	.debug	# 3103
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfff0
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;3104   printf("Code preceeding fault:\r\n  %06lX: ", faultAddr);
	.debug	# 3104
	push	bc
	push	de
	ld	de,word (phys @1+1543)
	ld	c,phys @1+1543 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3105   for (ui=0; ui<16; ++ui,++faultAddr)
@595:
	.debug	< @595 @596
	.debug	# 3105
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@597:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@598
;3106     printf("%02X ", *(uchar far *)faultAddr);
	.debug	# 3106
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	de,word (phys @1+1210)
	ld	c,phys @1+1210 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3107   printf("\r\n\n");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	jr	@597
@598:
@596:
	.debug	>
	.debug	# 3107
	ld	de,word (phys @1+959)
	ld	c,phys @1+959 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3108 
;3109   printf("Registers:\r\n"
;3110          "  AF: %04X  AF': %04X    IX: %04X    IP:  %02X\r\n"
;3111          "  HL: %04X  HL': %04X    IY: %04X    IIR: %02X\r\n"
;3112          "  DE: %04X  DE': %04X    SP: %04X    EIR: %02X\r\n"
;3113          "  BC: %04X  BC': %04X    PC: %04X    XPC: %02X\r\n\n",
;3114          REG_AF, REG_AF_, REG_IX, REG_IP,
;3115          REG_HL, REG_HL_, REG_IY, REG_IIR,
;3116          REG_DE, REG_DE_, REG_SP, REG_EIR,
;3117          REG_BC, REG_BC_, REG_PC, REG_XPC );
	.debug	# 3117
	ld	hl,(ix-4)
	ld	de,0xffe0
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xeb
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xf3
	add	hl,de
	ld	hl,(hl)
	push	hl
ld a,eir
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	de,0xffed
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xf5
	add	hl,de
	ld	hl,(hl)
	push	hl
ld a,iir
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	ld	de,0xffe9
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xef
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xfc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xf9
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	ld	e,0xe7
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ld	e,0xe5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	dec	hl
	dec	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1577)
	ld	c,phys @1+1577 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,36
;3118 
;3119 
;3120   stackEnd = (uchar *)((uint)current->stack_start + current->stack_size - 1
	.debug	# 3120
	ld	hl,(_current)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,(_current)
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	add	hl,bc
	dec	hl
	ld	(ix-8),hl
;3121 
;3122   printf("Stack:");
	.debug	# 3122
	ld	de,word (phys @1+1783)
	ld	c,phys @1+1783 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3123   absAddr = ((ulong)current->sseg << 12) + (uint)sp;
	.debug	# 3123
	ld	hl,(_current)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix-4)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;3124   for (ui=0,ptr=sp; ptr<=stackEnd; ++ui,++absAddr)  {
@600:
	.debug	< @600 @601
	.debug	# 3124
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,(ix-4)
	ld	(ix-6),hl
@602:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@604
	jp	nc,@603
@604:
;3125     if (!(ui & 0x0f))  printf("\r\n  %05lX (%04X): ", absAddr, (uint)ptr);
@606:
	.debug	< @606 @607
	.debug	# 3125
	ld	hl,(ix-2)
	ld	de,0xf
	and	hl,de
	jr	nz,@608
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1790)
	ld	c,phys @1+1790 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;3126     printf("%02X ", *ptr++);  WDT_2S();
@608:
	.debug	# 3126
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+1210)
	ld	c,phys @1+1210 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
  ld  a,0x5A
  ioi ld  (0x08),a
;3127     if (ui & 0xFFC0)  { printf("...\r\n");  break; }
	.debug	# 3127
	ld	hl,(ix-2)
	ld	de,0xffc0
	and	hl,de
	jr	z,@609
@610:
	.debug	< @610 @611
	ld	de,word (phys @1+1809)
	ld	c,phys @1+1809 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@603
@611:
	.debug	>
;3128   }
@609:
@607:
	.debug	>
;3129 
;3130   printf("\r\n\n"
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	jp	@602
@603:
@601:
	.debug	>
;3131          "Stack Trace:\r\n"
;3132          "  %ls fault occured at: %05lX\r\n", context, faultAddr);
	.debug	# 3130
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1815)
	ld	c,phys @1+1815 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3133 
;3134   stackTrace(sp, stackEnd-4);
	.debug	# 3134
	ld	hl,(ix-8)
	ld	de,0xfffc
	add	hl,de
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$stackTrace
	add	sp,4
;3135 
;3136   postMortem(context);
	.debug	# 3136
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
;3137 }
@592:
	.debug	} @592 3137

@591	equ	48
	ld	sp,ix
	pop	ix
	lret
@593	equ	50
;3138 
;3139 //-------------------------------------------------------------------------
;3140 //  Override the standard UnhandledInterruptHandler (which just reboots).  
;3141 //  if this can't handle the unexpected interrupt, at least we will know th
;3142 //  it happened.
;3143 //----------------------------------
;3144 //  WARNING:  Do NOT add any local variables as this will change the conten
;3145 //            of the stack, causing dumpFault() to produce invalid informat
;3146 //-------------------------------------------------------------------------
;3147 void _int UnhandledInterruptHandler( void )
;3148 {
	.cseg
_UnhandledInterruptHandler::
	.debug	G _UnhandledInterruptHandler 37 3
	.debug	{ _UnhandledInterruptHandler 37 3147 @614 @613
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;3149 //  save AF' on the stack
;3150 ;
;3151 #asm
	.debug	# 3152
exx

	.debug	# 3153
push    af

	.debug	# 3154
exx

	.cseg
;3156 ;
;3157   outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
	.debug	# 3157
	ld	a,0x80
	ioi ld	(16),a
;3158 
;3159   outi(STKCR, 0x00);  // disable hdw stack limit checks
	.debug	# 3159
	xor	a,a
	ioi ld	(1092),a
;3160   outi(WPCR, 0);  // disable write protection for System Mode
	.debug	# 3160
	xor	a,a
	ioi ld	(1088),a
;3161 
;3162   outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 3162
	xor	a,a
	ioi ld	(16),a
;3163 
;3164   KLOCK();
	.debug	# 3164
	call	_KLOCK
;3165 
;3166   logDateTime = true;  fprintf(DiagLog, "Unhandled Interrupt error\r\n");
	.debug	# 3166
	ld	a,0x1
	ld	(_logDateTime),a
	ld	de,word (phys @1+1864)
	ld	c,phys @1+1864 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3167 
;3168   dumpFault("Unhandled Interrupt");
	.debug	# 3168
	ld	de,word (phys @1+1892)
	ld	c,phys @1+1892 >> 16
	push	bc
	push	de
	lcall	$dumpFault
	add	sp,4
;3169 }
@613:
	.debug	} @613 3169

@612	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@614	equ	2
;3170 
;3171 
;3172 //-------------------------------------------------------------------------
;3173 //  The current task (or an interrupt routine) attempted to write to a memo
;3174 //  location in a block of write-protected memory.
;3175 //----------------------------------
;3176 //  WARNING:  Do NOT add any local variables as this will change the conten
;3177 //            of the stack, causing dumpFault() to produce invalid informat
;3178 //-------------------------------------------------------------------------
;3179 void _int WriteFault( void )
;3180 {
_WriteFault::
	.debug	G _WriteFault 37 3
	.debug	{ _WriteFault 37 3179 @617 @616
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;3181 //  save AF' on the stack
;3182 ;
;3183 #asm
	.debug	# 3184
exx

	.debug	# 3185
push    af

	.debug	# 3186
exx

	.cseg
;3188 ;
;3189   outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
	.debug	# 3189
	ld	a,0x80
	ioi ld	(16),a
;3190 
;3191   outi(STKCR, 0x00);  // disable hdw stack limit checks
	.debug	# 3191
	xor	a,a
	ioi ld	(1092),a
;3192   outi(WPCR, 0);  // disable write protection for System Mode
	.debug	# 3192
	xor	a,a
	ioi ld	(1088),a
;3193 
;3194   outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 3194
	xor	a,a
	ioi ld	(16),a
;3195 
;3196   KLOCK();
	.debug	# 3196
	call	_KLOCK
;3197 
;3198   logDateTime = true;  fprintf(DiagLog, "Write Protection error\r\n");
	.debug	# 3198
	ld	a,0x1
	ld	(_logDateTime),a
	ld	de,word (phys @1+1912)
	ld	c,phys @1+1912 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3199 
;3200   dumpFault("Write Protection");
	.debug	# 3200
	ld	de,word (phys @1+1937)
	ld	c,phys @1+1937 >> 16
	push	bc
	push	de
	lcall	$dumpFault
	add	sp,4
;3201 }
@616:
	.debug	} @616 3201

@615	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@617	equ	2
;3202 
;3203 
;3204 //-------------------------------------------------------------------------
;3205 //  A user/system mode violation occured
;3206 //----------------------------------
;3207 //  WARNING:  Do NOT add any local variables as this will change the conten
;3208 //            of the stack, causing dumpFault() to produce invalid informat
;3209 //-------------------------------------------------------------------------
;3210 void _int ModeViolation( void )
;3211 {
_ModeViolation::
	.debug	G _ModeViolation 37 3
	.debug	{ _ModeViolation 37 3210 @620 @619
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;3212 //  save AF' on the stack
;3213 ;
;3214 #asm
	.debug	# 3215
exx

	.debug	# 3216
push    af

	.debug	# 3217
exx

	.cseg
;3219 ;
;3220   dumpFault("User/Sys Mode Violation");
	.debug	# 3220
	ld	de,word (phys @1+1954)
	ld	c,phys @1+1954 >> 16
	push	bc
	push	de
	lcall	$dumpFault
	add	sp,4
;3221 }
@619:
	.debug	} @619 3221

@618	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@620	equ	2
;3222 
;3223 
;3224 //-------------------------------------------------------------------------
;3225 //  The stack pointer for the current task exceeded the set limits
;3226 //----------------------------------
;3227 //  WARNING:  Do NOT add any local variables as this will change the conten
;3228 //            of the stack, causing dumpFault() to produce invalid informat
;3229 //-------------------------------------------------------------------------
;3230 void _int StackLimit( void )
;3231 {
_StackLimit::
	.debug	G _StackLimit 37 3
	.debug	{ _StackLimit 37 3230 @623 @622
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;3232 //  save AF' on the stack
;3233 ;
;3234 #asm
	.debug	# 3235
exx

	.debug	# 3236
push    af

	.debug	# 3237
exx

	.cseg
;3239 ;
;3240   outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
	.debug	# 3240
	ld	a,0x80
	ioi ld	(16),a
;3241 
;3242   outi(STKCR, 0x00);  // disable hdw stack limit checks
	.debug	# 3242
	xor	a,a
	ioi ld	(1092),a
;3243   outi(WPCR, 0);  // disable write protection for System Mode
	.debug	# 3243
	xor	a,a
	ioi ld	(1088),a
;3244 
;3245   outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 3245
	xor	a,a
	ioi ld	(16),a
;3246 
;3247   KLOCK();
	.debug	# 3247
	call	_KLOCK
;3248 
;3249   logDateTime = true;  fprintf(DiagLog, "Stack Limit error\r\n");
	.debug	# 3249
	ld	a,0x1
	ld	(_logDateTime),a
	ld	de,word (phys @1+1978)
	ld	c,phys @1+1978 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3250 
;3251   doCleanShutdown = false;
	.debug	# 3251
	xor	a,a
	ld	(_doCleanShutdown),a
;3252 
;3253   dumpFault("Stack Limit");
	.debug	# 3253
	ld	de,word (phys @1+1998)
	ld	c,phys @1+1998 >> 16
	push	bc
	push	de
	lcall	$dumpFault
	add	sp,4
;3254 }
@622:
	.debug	} @622 3254

@621	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@623	equ	2
;3255 
;3256 
;3257 
;3258 //-------------------------------------------------------------------------
;3259 //  As the two truly critical tasks, the kernel and applic tasks must each 
;3260 //  this function at least once every 60 seconds.  In addition, this functi
;3261 //  must be called by SOME task at least once every 1900ms to avoid a force
;3262 //  reboot (the sched_tick() function increments and checks the wdtTicks va
;3263 //  that is set to 0 here each time this function is called).
;3264 //-------------------------------------------------------------------------
;3265 void resetWDT(void)
;3266 {
	.seg	FARCODE
$resetWDT::
	.debug	G $resetWDT 37 9
	.debug	{ $resetWDT 37 3265 @626 @625
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
;3267   bool  bothActive = false;
	.debug	L bothActive -1 3
	.debug	# 3267
	xor	a,a
	ld	(ix-1),a
	.seg	FARCODE
;3268 
;3269 
;3270   KLOCK();
	.debug	# 3270
	call	_KLOCK
;3271 
;3272   if (current == kernelTask)  {
	.debug	# 3272
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@627
;3273     kernelLastCalled = GetMS();
@628:
	.debug	< @628 @629
	.debug	# 3273
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_kernelLastCalled),de
	ld	(_kernelLastCalled+2),bc
;3274     if (msSince(applicLastCalled) < 60000L)  bothActive = true;
	.debug	# 3274
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_applicLastCalled)
	ld	bc,(_applicLastCalled+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__lsub##
	jp	nc,@631
	ld	a,0x1
	ld	(ix-1),a
;3275   }
@629:
	.debug	>
;3276   else  if (current == applTask)  {
	jp	@631
@627:
	.debug	# 3276
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@632
;3277     applicLastCalled = GetMS();
@633:
	.debug	< @633 @634
	.debug	# 3277
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_applicLastCalled),de
	ld	(_applicLastCalled+2),bc
;3278     if (msSince(kernelLastCalled) < 60000L)  bothActive = true;
	.debug	# 3278
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_kernelLastCalled)
	ld	bc,(_kernelLastCalled+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__lsub##
	jr	nc,@635
	ld	(ix-1),0x1
;3279   }
@635:
@634:
	.debug	>
;3280 
;3281   if (bothActive)  {
@632:
@631:
	.debug	# 3281
	ld	a,(ix-1)
	or	a,a
	jp	z,@636
;3282     WDT_2S();  // reset 2-second countdown Watchdog timer
@637:
	.debug	< @637 @638
	.debug	# 3282
  ld  a,0x5A
  ioi ld  (0x08),a
;3283     _EnterCritical_();  diagLogInfo->wdtTicks = 0;  _ExitCritical_();
	.debug	# 3283
	ipset	2
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
	ipres
;3284   }
@638:
	.debug	>
;3285 
;3286   KUNLOCK();
@636:
	.debug	# 3286
	call	_KUNLOCK
;3287 }
@625:
	.debug	} @625 3287

@624	equ	1
	ld	sp,ix
	pop	ix
	lret
@626	equ	3
;3288 
;3289 //-------------------------------------------------------------------------
;3290 typedef struct {
;3291   const char far *segName;
;3292   ulong  *start;
;3293   ulong  *end;
;3294   ulong  *size;
;3295   uint   *origCRC;
;3296   uint   *errCount;
;3297 } CRC_Params;
;3298 
;3299 //-------------------------------------------------------------------------
;3300 //  Compute, display, validate, etc a CRC for a portion of memory.  Called 
;3301 //  startup to compute the CRC values for memory segments whose data should
;3302 //  not change after startup (i.e. CODE, CONST, FARCODE, FARCONST), and
;3303 //  periodically after startup to check for corruption to these segments.
;3304 //
;3305 //  NOTE that for Rabbit 3000 processors, nearly all the memory occupied by
;3306 //  these segments is write protected, so an attempt to write to them due t
;3307 //  a software bug causes a runtime fault interrupt which is caught and
;3308 //  logged (without changing the contents of the protected memory), so any
;3309 //  changes to these segments indicates an external (enviornmental) cause.
;3310 //
;3311 //  Parameters:
;3312 //     firstTime:
;3313 //         != 0:  Set *origCRC to computed CRC value
;3314 //         == 0:  Compare computed CRC value to *origCRC value
;3315 //     display:
;3316 //         != 0:  Show result regardless of whether there is an error
;3317 //         == 0:  Don't show result unless there is an error
;3318 //     *name:
;3319 //         Name of the memory segment
;3320 //     start:
;3321 //         The address of the first byte in the memory segment
;3322 //     end:
;3323 //         The address of the last byte in the memory segment
;3324 //     size:
;3325 //         The length of the memory segment
;3326 //     *origCRC:
;3327 //         if firstTime != 0: The location to store the computed CRC value
;3328 //         if firstTime == 0: The CRC value computed for the segment at sta
;3329 //-------------------------------------------------------------------------
;3330 void computeCRC(bool firstTime, bool display, const far char *name,
;3331                 ulong start, ulong end, ulong size, uint *origCRC)
;3332 {
$computeCRC::
	.debug	G $computeCRC 77 9
	.debug	{ $computeCRC 77 3330 @641 @640
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A firstTime 5 3
	.debug	A display 7 3
	.debug	A name 9 34
	.debug	A start 13 9
	.debug	A end 17 9
	.debug	A size 21 9
	.debug	A origCRC 25 78
;3333   bool  match;
	.debug	L match -1 3
;3334   uint  curCRC;
	.debug	L curCRC -3 7
;3335 
;3336 
;3337   if (display)  {
	.debug	# 3337
	ld	a,(ix+7)
	or	a,a
	jr	z,@642
;3338     printf("%ls  %05lX  %05lX  ", name, start, end);
@643:
	.debug	< @643 @644
	.debug	# 3338
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2010)
	ld	c,phys @1+2010 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;3339     fflush(stdout);
	.debug	# 3339
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;3340   }
@644:
	.debug	>
;3341 
;3342   curCRC = memCRC16(start, size);
@642:
	.debug	# 3342
	ld	hl,(ix+21)
	ex	de,hl
	ld	hl,(ix+23)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ld	(ix-3),hl
;3343   if (firstTime)  {
	.debug	# 3343
	ld	a,(ix+5)
	or	a,a
	jr	z,@645
;3344     *origCRC = curCRC;  match = true; }
@646:
	.debug	< @646 @647
	.debug	# 3344
	ex	de,hl
	ld	hl,(ix+25)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	a,0x1
	ld	(ix-1),a
@647:
	.debug	>
;3345   else
;3346     match = (curCRC == *origCRC);
	jr	@648
@645:
	.debug	# 3346
	ld	hl,(ix+25)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-3)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@649
	inc	l
@649:
	ld	(ix-1),l
;3347 
;3348   if (!match)  memCorrupted = true;
@648:
	.debug	# 3348
	ld	a,(ix-1)
	or	a,a
	jr	nz,@650
	ld	a,0x1
	ld	(_memCorrupted),a
;3349 
;3350   if (display OR !match)
@650:
	.debug	# 3350
	ld	a,(ix+7)
	or	a,a
	jr	nz,@651
	ld	a,(ix-1)
	or	a,a
	jr	nz,@652
@651:
;3351     printf("%04X %s\r\n", curCRC, firstTime ? "" : (match ? "OK" : "*BAD*")
	.debug	# 3351
	ld	a,(ix+5)
	or	a,a
	jr	z,@653
	ld	hl,@66+8
	jr	@654
@653:
	ld	a,(ix-1)
	or	a,a
	jr	z,@655
	ld	hl,@66+71
	jr	@656
@655:
	ld	hl,@66+74
@656:
@654:
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	de,word (phys @1+2030)
	ld	c,phys @1+2030 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3352 
;3353   if (!match)  {
@652:
	.debug	# 3353
	ld	a,(ix-1)
	or	a,a
	jr	nz,@658
;3354     printf("***** %ls failed CRC test *****\r\n", name);
@659:
	.debug	< @659 @660
	.debug	# 3354
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2040)
	ld	c,phys @1+2040 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3355     useSoftReset = doShutdown = doReboot = true;
	.debug	# 3355
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
	ld	(_useSoftReset),a
;3356   }
@660:
	.debug	>
;3357 
;3358 }
@658:
@640:
	.debug	} @640 3358

@639	equ	3
	ld	sp,ix
	pop	ix
	lret
@641	equ	5
;3359 
;3360 //-------------------------------------------------------------------------
;3361 //  Recompute the CRCs for the areas of memory containing code and constant
;3362 //  and compare them to the values that were computed at startup.
;3363 //-------------------------------------------------------------------------
;3364 void computeMemCRCs(bool firstTime, bool display)
;3365 {
$computeMemCRCs::
	.debug	G $computeMemCRCs 79 9
	.debug	{ $computeMemCRCs 79 3364 @663 @662
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A firstTime 5 3
	.debug	A display 7 3
;3366   if (display)
	.debug	# 3366
	ld	a,(ix+7)
	or	a,a
	jr	z,@664
;3367     printf("\r\n\n"
;3368            "Segment   Start  End    CRC  \r\n"
;3369            "--------  -----  -----  ---- \r\n");
	.debug	# 3367
	ld	de,word (phys @1+2074)
	ld	c,phys @1+2074 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3370 
;3371   computeCRC(firstTime, display, "CODE    ",
@664:
;3372              codeStart, codeEnd, codeSize, &codeCRC);
	.debug	# 3372
	ld	hl,_codeCRC
	push	hl
	ld	hl,(_codeSize)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(_codeEnd)
	ex	de,hl
	push	bc
	push	de
	ld	hl,(_codeStart)
	ex	de,hl
	push	bc
	push	de
	ld	de,word (phys @1+2140)
	ld	c,phys @1+2140 >> 16
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$computeCRC
	add	sp,22
;3373 
;3374   computeCRC(firstTime, display, "CONST   ",
;3375              constStart, constEnd, constSize, &constCRC);
	.debug	# 3375
	ld	hl,_constCRC
	push	hl
	ld	hl,(_constSize)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(_constEnd)
	ex	de,hl
	push	bc
	push	de
	ld	hl,(_constStart)
	ex	de,hl
	push	bc
	push	de
	ld	de,word (phys @1+2149)
	ld	c,phys @1+2149 >> 16
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$computeCRC
	add	sp,22
;3376 
;3377   if (display)  {
	.debug	# 3377
	ld	a,(ix+7)
	or	a,a
	jr	z,@665
;3378     printf("%ls  %05X  %05X  ----\r\n",
@666:
	.debug	< @666 @667
;3379            (const char far *)"DATA    ", dataStart, dataEnd);
	.debug	# 3379
	ld	hl,(_dataEnd)
	push	hl
	ld	hl,(_dataStart)
	push	hl
	ld	de,word (phys @1+2158)
	ld	c,phys @1+2158 >> 16
	push	bc
	push	de
	ld	de,word (phys @1+2167)
	ld	c,phys @1+2167 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3380     printf("%ls  %05X  %05X  ----\r\n",
;3381            (const char far *)"BSS     ", bssStart, bssEnd);
	.debug	# 3381
	ld	hl,(_bssEnd)
	push	hl
	ld	hl,(_bssStart)
	push	hl
	ld	de,word (phys @1+2191)
	ld	c,phys @1+2191 >> 16
	push	bc
	push	de
	ld	de,word (phys @1+2167)
	ld	c,phys @1+2167 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3382     printf("%ls  %05X  %05X  ----\r\n",
;3383            (const char far *)"STACK   ", 0xD000, 0xDFFF);
	.debug	# 3383
	ld	hl,0xdfff
	push	hl
	ld	hl,0xd000
	push	hl
	ld	de,word (phys @1+2200)
	ld	c,phys @1+2200 >> 16
	push	bc
	push	de
	ld	de,word (phys @1+2167)
	ld	c,phys @1+2167 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3384   }
@667:
	.debug	>
;3385 
;3386   computeCRC(firstTime, display, "FARCODE ",
@665:
;3387              farCodeStart, farCodeEnd, farCodeSize, &farCodeCRC);
	.debug	# 3387
	ld	hl,_farCodeCRC
	push	hl
	ld	de,(_farCodeSize)
	ld	bc,(_farCodeSize+2)
	push	bc
	push	de
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	push	bc
	push	de
	ld	de,word (phys @1+2209)
	ld	c,phys @1+2209 >> 16
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$computeCRC
	add	sp,22
;3388 
;3389   computeCRC(firstTime, display, "FARCONST",
;3390              farConstStart, farConstEnd, farConstSize, &farConstCRC);
	.debug	# 3390
	ld	hl,_farConstCRC
	push	hl
	ld	de,(_farConstSize)
	ld	bc,(_farConstSize+2)
	push	bc
	push	de
	ld	de,(_farConstEnd)
	ld	bc,(_farConstEnd+2)
	push	bc
	push	de
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	push	bc
	push	de
	ld	de,word (phys @1+2218)
	ld	c,phys @1+2218 >> 16
	push	bc
	push	de
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$computeCRC
	add	sp,22
;3391 
;3392   if (display)
	.debug	# 3392
	ld	a,(ix+7)
	or	a,a
	jr	z,@668
;3393     printf("%ls  %05lX  %05lX  ----\r\n",
;3394            (const char far *)"FARBSS  ", farBSSStart, farBSSEnd);
	.debug	# 3394
	ld	de,(_farBSSEnd)
	ld	bc,(_farBSSEnd+2)
	push	bc
	push	de
	ld	de,(_farBSSStart)
	ld	bc,(_farBSSStart+2)
	push	bc
	push	de
	ld	de,word (phys @1+2227)
	ld	c,phys @1+2227 >> 16
	push	bc
	push	de
	ld	de,word (phys @1+2236)
	ld	c,phys @1+2236 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;3395 
;3396   if (display)  printf("\n\n");
@668:
	.debug	# 3396
	ld	a,(ix+7)
	or	a,a
	jr	z,@669
	ld	de,word (phys @1+162)
	ld	c,phys @1+162 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3397 }
@669:
@662:
	.debug	} @662 3397

@661	equ	0
	pop	ix
	lret
@663	equ	2
;3398 
;3399 
;3400 //-------------------------------------------------------------------------
;3401 //  Show the current contents of the Interrupt Vectors
;3402 //-------------------------------------------------------------------------
;3403 void showIntVectors(void)
;3404 {
$showIntVectors::
	.debug	G $showIntVectors 37 9
	.debug	{ $showIntVectors 37 3403 @672 @671
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;3405   char *intvec;
	.debug	L intvec -2 40
;3406   uchar  IIR, EIR;
	.debug	L IIR -3 3
	.debug	L EIR -4 3
;3407   uint  ui, uj;
	.debug	L ui -6 7
	.debug	L uj -8 7
;3408 
;3409 //--- show the contents of the Interrupt vector table ---
;3410   IIR = _asm( [_A], "ld a,iir", _A );
	.debug	# 3410
ld a,iir
	ld	(ix-3),a
;3411   EIR = _asm( [_A], "ld a,eir", _A );
	.debug	# 3411
ld a,eir
	ld	(ix-4),a
;3412 
;3413   printf(" IIR: 0x%02X,  EIR: 0x%02X\r\n", IIR, EIR);
	.debug	# 3413
	bool	hl
	ld	l,a
	push	hl
	bool	hl
	ld	l,(ix-3)
	push	hl
	ld	de,word (phys @1+2262)
	ld	c,phys @1+2262 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3414   printf(" _TimerBISR: 0x%04X\r\n\n", (uint)_TimerBISR);
	.debug	# 3414
	ld	hl,__TimerBISR
	push	hl
	ld	de,word (phys @1+2291)
	ld	c,phys @1+2291 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3415 
;3416   intvec = (uchar *)((uint)IIR << 8);
	.debug	# 3416
	bool	hl
	ld	h,(ix-3)
	ld	l,0
	ld	(ix-2),hl
;3417   for (ui=0; ui<NumIntVectors; ++ui)  {
@673:
	.debug	< @673 @674
	.debug	# 3417
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@675:
	ld	hl,(ix-6)
	ld	de,0x1e
	or	a,a
	sbc	hl,de
	jp	nc,@676
;3418     printf(" %04X: ", (uint)intvec);
@678:
	.debug	< @678 @679
	.debug	# 3418
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2314)
	ld	c,phys @1+2314 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3419     for (uj=0; uj<16; ++uj,intvec)  {
@680:
	.debug	< @680 @681
	.debug	# 3419
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@682:
	ld	hl,(ix-8)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@683
;3420       printf("%02X ", *intvec++);
@685:
	.debug	< @685 @686
	.debug	# 3420
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	dec	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+1210)
	ld	c,phys @1+1210 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3421       if ((uj == 6) OR (uj == 8) OR (uj == 15))  printf(" ");
	.debug	# 3421
	ld	hl,(ix-8)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	z,@687
	ld	hl,(ix-8)
	ld	e,0x8
	or	a,a
	sbc	hl,de
	jr	z,@687
	ld	hl,(ix-8)
	ld	e,0xf
	or	a,a
	sbc	hl,de
	jr	nz,@688
@687:
	ld	de,word (phys @1+781)
	ld	c,phys @1+781 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3422     }
@688:
@686:
	.debug	>
;3423     printf("%ls\r\n", IntVectDesc[ui]);
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jr	@682
@683:
@681:
	.debug	>
	.debug	# 3423
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	ld	de,_IntVectDesc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+2322)
	ld	c,phys @1+2322 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3424     if (ui == 15)  printf("\n");
	.debug	# 3424
	ld	hl,(ix-6)
	ld	de,0xf
	or	a,a
	sbc	hl,de
	jr	nz,@689
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3425   }
@689:
@679:
	.debug	>
;3426 
;3427   printf("\n");
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jp	@675
@676:
@674:
	.debug	>
	.debug	# 3427
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3428 }
@671:
	.debug	} @671 3428

@670	equ	8
	ld	sp,ix
	pop	ix
	lret
@672	equ	10
;3429 
;3430 
;3431 //-------------------------------------------------------------------------
;3432 //  Enable write protection for the largest portion of root and extended
;3433 //  memory we can to cover as much as possible of the CODE, CONST, FARCODE,
;3434 //  and FARCONST segments.
;3435 //-------------------------------------------------------------------------
;3436 void initWriteProtect(void)
;3437 {
$initWriteProtect::
	.debug	G $initWriteProtect 37 9
	.debug	{ $initWriteProtect 37 3436 @692 @691
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;3438   uchar  seg, page, firstPage, lastPage, firstSeg, lastSeg;
	.debug	L seg -1 3
	.debug	L page -2 3
	.debug	L firstPage -3 3
	.debug	L lastPage -4 3
	.debug	L firstSeg -5 3
	.debug	L lastSeg -6 3
;3439   uint  mask;
	.debug	L mask -8 7
;3440 
;3441 
;3442   if (!hdwProtection)  return;
	.debug	# 3442
	ld	a,(_hdwProtection)
	or	a,a
	jp	z,@691
;3443 
;3444   setInterruptHandler(INT_WRITE_FAULT, WriteFault);
	.debug	# 3444
	ld	hl,_WriteFault
	push	hl
	ld	hl,0x9
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;3445   setInterruptHandler(INT_MODE_VIOLATION, ModeViolation);
	.debug	# 3445
	ld	hl,_ModeViolation
	push	hl
	ld	hl,0x18
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;3446   setInterruptHandler(INT_STACK_LIMIT, StackLimit);
	.debug	# 3446
	ld	hl,_StackLimit
	push	hl
	ld	hl,0x1b
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;3447 
;3448   checkIntShims();
	.debug	# 3448
	lcall	$checkIntShims
;3449 
;3450 
;3451 //--- Determine the start and end addr of the ReadOnly portion of root mem 
;3452   if (codeStart < constStart)  {
	.debug	# 3452
	ld	hl,(_codeStart)
	ld	de,(_constStart)
	or	a,a
	sbc	hl,de
	jr	nc,@694
;3453     roStart = codeStart;  roEnd = constEnd; }
@695:
	.debug	< @695 @696
	.debug	# 3453
	ld	hl,(_codeStart)
	ld	(_roStart),hl
	ld	hl,(_constEnd)
	ld	(_roEnd),hl
@696:
	.debug	>
;3454   else  {
	jr	@697
@694:
;3455     roStart = constStart;  roEnd =  codeEnd; }
@698:
	.debug	< @698 @699
	.debug	# 3455
	ld	hl,(_constStart)
	ld	(_roStart),hl
	ld	hl,(_codeEnd)
	ld	(_roEnd),hl
@699:
	.debug	>
;3456 
;3457 //--- Determine the start and end addr of the ReadOnly portion of far mem -
;3458   if (farCodeStart < farConstStart)  {
@697:
	.debug	# 3458
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	push	bc
	push	de
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	call	__lsub##
	jr	nc,@700
;3459     roStartFar = farCodeStart;  roEndFar = farConstEnd; }
@701:
	.debug	< @701 @702
	.debug	# 3459
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	ld	(_roStartFar),de
	ld	(_roStartFar+2),bc
	ld	de,(_farConstEnd)
	ld	bc,(_farConstEnd+2)
	ld	(_roEndFar),de
	ld	(_roEndFar+2),bc
@702:
	.debug	>
;3460   else  {
	jr	@703
@700:
;3461     roStartFar = farConstStart;  roEndFar = farCodeEnd; }
@704:
	.debug	< @704 @705
	.debug	# 3461
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	ld	(_roStartFar),de
	ld	(_roStartFar+2),bc
	ld	de,(_farCodeEnd)
	ld	bc,(_farCodeEnd+2)
	ld	(_roEndFar),de
	ld	(_roEndFar+2),bc
@705:
	.debug	>
;3462 
;3463 
;3464 //--- determine the start and end addrs in root that can be write protected
;3465   wpStart = (roStart + 0xFFF) & 0xF000;
@703:
	.debug	# 3465
	ld	hl,(_roStart)
	ld	de,0xfff
	add	hl,de
	ld	de,0xf000
	and	hl,de
	ld	(_wpStart),hl
;3466   wpEnd = (roEnd + 1) & 0xF000;
	.debug	# 3466
	ld	hl,(_roEnd)
	inc	hl
	and	hl,de
	ld	(_wpEnd),hl
;3467 
;3468 //--- determine the start and end addrs in xmem that can be write protected
;3469   wpStartFar = (roStartFar + 0xFFFFL) & 0xF0000L;
	.debug	# 3469
	ld	de,(_roStartFar)
	ld	bc,(_roStartFar+2)
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	ld	de,0
	ld	bc,0xf
	call	__land##
	ld	(_wpStartFar),de
	ld	(_wpStartFar+2),bc
;3470   wpEndFar = (roEndFar + 1) & 0xF0000L;
	.debug	# 3470
	ld	de,(_roEndFar)
	ld	bc,(_roEndFar+2)
	call	__linc##
	push	bc
	push	de
	ld	de,0
	ld	bc,0xf
	call	__land##
	ld	(_wpEndFar),de
	ld	(_wpEndFar+2),bc
;3471 
;3472 
;3473 
;3474 //--- compute write protection for 4K ROOT memory blocks ---
;3475   firstPage = (uchar)(wpStart >> 12);  lastPage = (uchar)(wpEnd >> 12);
	.debug	# 3475
	ld	hl,(_wpStart)
	ld	l,h
	ld	h,0
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-3),l
	ld	hl,(_wpEnd)
	ld	l,h
	ld	h,0
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	(ix-4),l
;3476 
;3477 //  wpRootMask = 0x2000;  // protect the kernel's stack as well (at 0xD000)
;3478   mask = 1 << firstPage;
	.debug	# 3478
	ld	hl,0x1
	ld	a,(ix-3)
	or	a,a
	jr	z,@706
	ld	b,a
@707:
	add	hl,hl
	djnz	@707
@706:
	ld	(ix-8),hl
;3479   for (page=firstPage; page<lastPage; ++page,mask<<=1)  wpRootMask |= mask;
@708:
	.debug	< @708 @709
	.debug	# 3479
	ld	a,(ix-3)
	ld	(ix-2),a
@710:
	ld	a,(ix-2)
	ld	hl,(ix-4)
	sub	a,l
	jr	nc,@711
	ld	hl,(_wpRootMask)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	hl,de
	ld	(_wpRootMask),hl
;3480 
;3481 //--- compute write protection for 64K extended memory blocks ---
;3482   firstSeg = (uchar) MSWL(wpStartFar);  lastSeg = (uchar) MSWL(wpEndFar);
	ld	a,(ix-2)
	inc	a
	ld	(ix-2),a
	ld	h,d
	ld	l,e
	add	hl,hl
	ld	(ix-8),hl
	jr	@710
@711:
@709:
	.debug	>
	.debug	# 3482
	ld	a,(_wpStartFar+2)
	ld	(ix-5),a
	ld	a,(_wpEndFar+2)
	ld	(ix-6),a
;3483 
;3484   wpSegMask = 0;  mask = 1 << firstSeg;
	.debug	# 3484
	bool	hl
	ld	l,h
	ld	(_wpSegMask),hl
	inc	l
	ld	a,(ix-5)
	or	a,a
	jr	z,@713
	ld	b,a
@714:
	add	hl,hl
	djnz	@714
@713:
	ld	(ix-8),hl
;3485   for (seg=firstSeg; seg<lastSeg; ++seg)  { wpSegMask |= mask;  mask <<= 1;
@715:
	.debug	< @715 @716
	.debug	# 3485
	ld	a,(ix-5)
	ld	(ix-1),a
@717:
	ld	a,(ix-1)
	ld	hl,(ix-6)
	sub	a,l
	jr	nc,@718
@720:
	.debug	< @720 @721
	ld	hl,(_wpSegMask)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	hl,de
	ld	(_wpSegMask),hl
	ld	h,d
	ld	l,e
	add	hl,hl
	ld	(ix-8),hl
@721:
	.debug	>
;3486 //NOTE:  wpSegMask MAY be added to later by code in sched.c
;3487 
;3488 
;3489   outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
	ld	a,(ix-1)
	inc	a
	ld	(ix-1),a
	jr	@717
@718:
@716:
	.debug	>
	.debug	# 3489
	ld	a,0x80
	ioi ld	(16),a
;3490 
;3491 //--- apply mask that sets which of the 16 64K pages are write protected --
;3492   outi(WPHR, MSBI(wpSegMask));  outi(WPLR, LSBI(wpSegMask));
	.debug	# 3492
	ld	a,(_wpSegMask+1)
	ioi ld	(1121),a
	ld	a,(_wpSegMask)
	ioi ld	(1120),a
;3493   outi(WPCR, 1);  // enable Write Protection in System and User modes
	.debug	# 3493
	ld	a,0x1
	ioi ld	(1088),a
;3494 
;3495 //--- enable hdw stack limit checking ---
;3496   outi(STKLLR, current->stkllr);
	.debug	# 3496
	ld	hl,(_current)
	ld	de,0x7
	add	hl,de
	ld	a,(hl)
	ioi ld	(1093),a
;3497   outi(STKHLR, current->stkhlr);
	.debug	# 3497
	ld	hl,(_current)
	inc	e
	add	hl,de
	ld	a,(hl)
	ioi ld	(1094),a
;3498   outi(STKCR, 0x01);
	.debug	# 3498
	ld	a,0x1
	ioi ld	(1092),a
;3499 
;3500   outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 3500
	xor	a,a
	ioi ld	(16),a
;3501 }
@691:
	.debug	} @691 3501

@690	equ	8
	ld	sp,ix
	pop	ix
	lret
@692	equ	10
;3502 
;3503 //-------------------------------------------------------------------------
;3504 //  Show the address ranges write protected by a given segment and 4k-write
;3505 //  protection bitmap
;3506 //-------------------------------------------------------------------------
;3507 void showRanges(ulong addr, uint wpMask, ulong addrInc)
;3508 {
$showRanges::
	.debug	G $showRanges 80 9
	.debug	{ $showRanges 80 3507 @724 @723
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A addr 5 9
	.debug	A wpMask 9 7
	.debug	A addrInc 11 9
;3509   uint  mask, prevBit, curBit;
	.debug	L mask -2 7
	.debug	L prevBit -4 7
	.debug	L curBit -6 7
;3510 
;3511 
;3512   prevBit = curBit = 0;
	.debug	# 3512
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	ld	(ix-4),hl
;3513 
;3514   for (mask=1; mask; mask<<=1)  {
@725:
	.debug	< @725 @726
	.debug	# 3514
	inc	l
	ld	(ix-2),hl
@727:
	ld	hl,(ix-2)
	bool	hl
	jr	z,@728
;3515     curBit = wpMask & mask;
@730:
	.debug	< @730 @731
	.debug	# 3515
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	and	hl,de
	ld	(ix-6),hl
;3516     if (!prevBit AND curBit)  printf("  %05lX-", addr);
	.debug	# 3516
	ld	hl,(ix-4)
	bool	hl
	jr	nz,@733
	ld	hl,(ix-6)
	bool	hl
	jr	z,@733
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2328)
	ld	c,phys @1+2328 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3517     if (prevBit AND !curBit)  printf("%05lX", addr-1);
@733:
	.debug	# 3517
	ld	hl,(ix-4)
	bool	hl
	jr	z,@735
	ld	hl,(ix-6)
	bool	hl
	jr	nz,@735
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ldec##
	push	bc
	push	de
	ld	de,word (phys @1+1359)
	ld	c,phys @1+1359 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3518     prevBit = curBit;  addr += addrInc;
@735:
	.debug	# 3518
	ld	hl,(ix-6)
	ld	(ix-4),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;3519   }
@731:
	.debug	>
;3520   if (curBit)  printf("%05lX", addr-1);
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-2),hl
	jr	@727
@728:
@726:
	.debug	>
	.debug	# 3520
	ld	hl,(ix-6)
	bool	hl
	jr	z,@736
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ldec##
	push	bc
	push	de
	ld	de,word (phys @1+1359)
	ld	c,phys @1+1359 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3521 
;3522 }
@736:
@723:
	.debug	} @723 3522

@722	equ	6
	ld	sp,ix
	pop	ix
	lret
@724	equ	8
;3523 
;3524 //-------------------------------------------------------------------------
;3525 //  Show the areas of memory with write protection enabled
;3526 //-------------------------------------------------------------------------
;3527 void showMemProtection(void)
;3528 {
$showMemProtection::
	.debug	G $showMemProtection 37 9
	.debug	{ $showMemProtection 37 3527 @739 @738
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;3529   uint  u;
	.debug	L u -2 7
;3530   ulong  addr = 0;
	.debug	L addr -6 9
	.debug	# 3530
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.seg	FARCODE
;3531   task_t  *task;
	.debug	L task -8 41
;3532 
;3533 
;3534   if (!hdwProtection)  return;
	.debug	# 3534
	ld	a,(_hdwProtection)
	or	a,a
	jp	z,@738
;3535 
;3536   printf("64K protections for all tasks:\r\n");
	.debug	# 3536
	ld	de,word (phys @1+2337)
	ld	c,phys @1+2337 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3537   showRanges(0, wpSegMask, 0x10000L);  printf("\r\n\n");
	.debug	# 3537
	ld	de,0
	ld	bc,0x1
	push	bc
	push	de
	ld	hl,(_wpSegMask)
	push	hl
	ld	c,e
	push	bc
	push	de
	lcall	$showRanges
	add	sp,10
	ld	de,word (phys @1+959)
	ld	c,phys @1+959 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3538 
;3539   printf("4K protections by task:                       STKxLR\r\n");
	.debug	# 3539
	ld	de,word (phys @1+2370)
	ld	c,phys @1+2370 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3540   for (u=0,task=tasks; u<NUM_TASKS; ++u,++task)  {
@741:
	.debug	< @741 @742
	.debug	# 3540
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_tasks
	ld	(ix-8),hl
@743:
	ld	hl,(ix-2)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jp	nc,@744
;3541     printf("  %2d:", u);
@746:
	.debug	< @746 @747
	.debug	# 3541
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2425)
	ld	c,phys @1+2425 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3542     MSWL(addr) = task->wpsar;
	.debug	# 3542
	ld	hl,(ix-8)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-4),hl
;3543     showRanges(addr, task->wpsalhr, 0x1000L);
	.debug	# 3543
	ld	de,0x1000
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-8)
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showRanges
	add	sp,10
;3544     MSWL(addr) = task->wpsbr;
	.debug	# 3544
	ld	hl,(ix-8)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	(ix-4),hl
;3545     showRanges(addr, task->wpsblhr, 0x1000L);
	.debug	# 3545
	ld	de,0x1000
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-8)
	ld	de,0xd
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$showRanges
	add	sp,10
;3546     printf("   %02X-%02X\r\n", task->stkllr, task->stkhlr );
	.debug	# 3546
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-8)
	dec	e
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+2432)
	ld	c,phys @1+2432 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3547   }
@747:
	.debug	>
;3548 
;3549   printf("\r\n");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-8)
	ld	de,0xe8
	add	hl,de
	ld	(ix-8),hl
	jp	@743
@744:
@742:
	.debug	>
	.debug	# 3549
	ld	de,word (phys @1+97)
	ld	c,phys @1+97 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3550 }
@738:
	.debug	} @738 3550

@737	equ	8
	ld	sp,ix
	pop	ix
	lret
@739	equ	10
;3551 
;3552 //-------------------------------------------------------------------------
;3553 //  Give some CPU time to various subsystems that need to do periodic
;3554 //  processing in order to function.
;3555 //
;3556 //  This process can only be called by the kernel task
;3557 //-------------------------------------------------------------------------
;3558 void backgroundIO(void)
;3559 {
$backgroundIO::
	.debug	G $backgroundIO 37 9
	.debug	{ $backgroundIO 37 3558 @750 @749
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-41
;3560   static uint  ioTicks;
	.bseg
@751:
	.ds	2
	.debug	S ioTicks @751 7
	.seg	FARCODE
;3561   task_t  *task;
	.debug	L task -2 41
;3562   list_head_t  *cur, *next;
	.debug	L cur -4 81
	.debug	L next -6 81
;3563   WaitQueueNode  *node;
	.debug	L node -8 69
;3564   sigset_t  notBlockedPending;
	.debug	L notBlockedPending -12 9
;3565   IFConfig  ifConfig;
	.debug	L ifConfig -37 83
;3566   ulong  ipAddr;
	.debug	L ipAddr -41 9
;3567 
;3568 
;3569   if (current != kernelTask)  return;
	.debug	# 3569
	ld	hl,(_kernelTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@749
;3570 
;3571 
;3572   if (msSince_(countersUpdated) >= 1000)  {
	.debug	# 3572
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_countersUpdated)
	or	a,a
	sbc	hl,de
	ld	de,0x3e8
	or	a,a
	sbc	hl,de
	jr	c,@753
;3573     _EnterCritical_();
@754:
	.debug	< @754 @755
	.debug	# 3573
	ipset	2
;3574 
;3575     schedCallsPrevSec = schedCalls;  schedCalls = 0;
	.debug	# 3575
	ld	hl,(_schedCalls)
	ld	(_schedCallsPrevSec),hl
	bool	hl
	ld	l,h
	ld	(_schedCalls),hl
;3576     taskSwPrevSec = taskSwitches;  taskSwitches = 0;
	.debug	# 3576
	ld	hl,(_taskSwitches)
	ld	(_taskSwPrevSec),hl
	bool	hl
	ld	l,h
	ld	(_taskSwitches),hl
;3577 
;3578     _ExitCritical_();
	.debug	# 3578
	ipres
;3579     countersUpdated = GetMS_();
	.debug	# 3579
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_countersUpdated),hl
;3580   }
@755:
	.debug	>
;3581 
;3582 
;3583 
;3584   resetWDT();  ++ioTicks;
@753:
	.debug	# 3584
	lcall	$resetWDT
	ld	hl,(@751)
	inc	hl
	ld	(@751),hl
;3585 
;3586 //===== give file system drivers some CPU time =====
;3587   fileSysTick();
	.debug	# 3587
	lcall	$fileSysTick
;3588 
;3589 
;3590   diagLogInfo->tz = timeZone;
	.debug	# 3590
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6a
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(_timeZone)
	call	__farst2##
;3591 
;3592   if (timeZone != lastTimeZone)  {
	.debug	# 3592
	ld	hl,(_timeZone)
	ld	de,(_lastTimeZone)
	or	a,a
	sbc	hl,de
	jr	z,@756
;3593     resetAnnounceInterval();  // announce the change ASAP
@757:
	.debug	< @757 @758
	.debug	# 3593
	lcall	$resetAnnounceInterval
;3594     lastTimeZone = timeZone;
	.debug	# 3594
	ld	hl,(_timeZone)
	ld	(_lastTimeZone),hl
;3595   }
@758:
	.debug	>
;3596 
;3597 //--- periodically check for a change in the interrupt vectors ---
;3598   if ((ioTicks & 0x007) == 2)  checkIntShims();
@756:
	.debug	# 3598
	ld	hl,(@751)
	ld	de,0x7
	and	hl,de
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@759
	lcall	$checkIntShims
;3599 
;3600 
;3601 //===== Periodically check the device ID and make sure the current =====
;3602 //===== configuration is correct for the current device ID =====
;3603   if ((ioTicks & 0x01f) == 0)  {
@759:
	.debug	# 3603
	ld	hl,(@751)
	ld	de,0x1f
	and	hl,de
	jp	nz,@760
;3604 
;3605   //--- check for a change in the device ID switches ---
;3606     deviceID = ReadDeviceID();
@761:
	.debug	< @761 @762
	.debug	# 3606
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
;3607     if (deviceID != lastDeviceID)  {
	.debug	# 3607
	push	bc
	push	de
	ld	de,(_lastDeviceID)
	ld	bc,(_lastDeviceID+2)
	call	__lsub##
	jr	z,@763
;3608       printf("deviceID changed: from:[%04lX]  to:[%04lX]\r\n",
@764:
	.debug	< @764 @765
;3609              lastDeviceID, deviceID);
	.debug	# 3609
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	de,(_lastDeviceID)
	ld	bc,(_lastDeviceID+2)
	push	bc
	push	de
	ld	de,word (phys @1+2447)
	ld	c,phys @1+2447 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3610       lastDeviceID = deviceID;  loadAllParamsMsg();
	.debug	# 3610
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_lastDeviceID),de
	ld	(_lastDeviceID+2),bc
	lcall	$loadAllParamsMsg
;3611       resetAnnounceInterval();
	.debug	# 3611
	lcall	$resetAnnounceInterval
;3612     }
@765:
	.debug	>
;3613 
;3614   //--- if deviceID is in range 0x00E0 to 0x00FF, then use the last nibble 
;3615   //--- as an index in to the range of rsvd addrs (192.168.250.224 - .255) 
;3616     if (FixedAddr())  {
@763:
	.debug	# 3616
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	de,0xffe0
	ld	bc,0
	call	__land##
	push	bc
	push	de
	ld	de,0xff20
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	nz,@766
;3617       ipAddr = 0xC0A8FA00L | (deviceID & 0x00FF);
@767:
	.debug	< @767 @768
	.debug	# 3617
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	de,0xff
	ld	c,d
	ld	b,d
	call	__land##
	push	bc
	push	de
	ld	de,0xfa00
	ld	bc,0xc0a8
	call	__lor##
	ld	hl,bc
	ld	(ix-39),hl
	ex	de,hl
	ld	(ix-41),hl
	ex	de,hl
;3618       getIFConfig(IF_ETH0, &ifConfig);
	.debug	# 3618
	ld	hl,-37+@748
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;3619       if (ifConfig.ipAddr != ipAddr)  {
	.debug	# 3619
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-41)
	ex	de,hl
	ld	hl,(ix-39)
	ld	bc,hl
	call	__lsub##
	jr	z,@769
;3620         if ((ifConfig.state == IF_UP) OR (ifConfig.state == IF_COMING_UP))
@770:
	.debug	< @770 @771
	.debug	# 3620
	ld	a,(ix-13)
	sub	a,2
	jr	z,@772
	ld	a,(ix-13)
	sub	a,1
	jr	nz,@773
@772:
;3621           startNetDown(IF_ETH0);
	.debug	# 3621
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetDown
	pop	de
;3622         if (ifConfig.state == IF_DOWN)  chgIPAddr(IF_ETH0, ipAddr);
@773:
	.debug	# 3622
	ld	a,(ix-13)
	or	a,a
	jr	nz,@774
	ld	hl,(ix-41)
	ex	de,hl
	ld	hl,(ix-39)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$chgIPAddr
	add	sp,6
;3623       }
@774:
@771:
	.debug	>
;3624     }
@769:
@768:
	.debug	>
;3625   }
@766:
@762:
	.debug	>
;3626 
;3627 
;3628 //===== Check to see if we should initiate a shutdown or reboot =====
;3629   if (doShutdown)  do {
@760:
	.debug	# 3629
	ld	a,(_doShutdown)
	or	a,a
	jp	z,@775
;3630     resetAnnounceInterval();
@779:
	.debug	< @779 @780
	.debug	# 3630
	lcall	$resetAnnounceInterval
;3631 
;3632     if (!shutdownStarted)  {  // send terminate signal to all processes
	.debug	# 3632
	ld	de,(_shutdownStarted)
	ld	bc,(_shutdownStarted+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@781
;3633       noGettyOnA = true;
@782:
	.debug	< @782 @783
	.debug	# 3633
	ld	a,0x1
	ld	(_noGettyOnA),a
;3634       printf("----- starting shutdown ----\r\n\n");
	.debug	# 3634
	ld	de,word (phys @1+2492)
	ld	c,phys @1+2492 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3635       kill(-1, SIGTERM);  shutdownStarted = GetMS();  break;
	.debug	# 3635
	ld	hl,0xf
	push	hl
	ld	hl,0xffff
	push	hl
	lcall	$kill
	add	sp,4
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_shutdownStarted),de
	ld	(_shutdownStarted+2),bc
;3636     }
	jp	@777
@783:
	.debug	>
;3637 
;3638     //--- if all but the kernel and idle tasks are gone, shutdown now ---
;3639     if ((numActiveTasks() <= 2) AND (numOpenSockets() < 1))  {
@781:
	.debug	# 3639
	lcall	$numActiveTasks
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@786
	jp	nc,@785
@786:
	lcall	$numOpenSockets
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@785
;3640       if (! rebootMsg)  { printf("bye bye...\r\n\n\n\n");  rebootMsg = true
@787:
	.debug	< @787 @788
	.debug	# 3640
	ld	a,(_rebootMsg)
	or	a,a
	jr	nz,@789
@790:
	.debug	< @790 @791
	ld	de,word (phys @1+2524)
	ld	c,phys @1+2524 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	a,0x1
	ld	(_rebootMsg),a
@791:
	.debug	>
;3641       if (msSince(shutdownStarted) > 2000)  {
@789:
	.debug	# 3641
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_shutdownStarted)
	ld	bc,(_shutdownStarted+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7d0
	ld	bc,0
	call	__lsub##
	jr	c,@792
	jr	z,@792
;3642         startNetDown(IF_ETH0);  sleepMS(1000);  REBOOT(doReboot);  }
@793:
	.debug	< @793 @794
	.debug	# 3642
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetDown
	pop	de
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	ld	a,(_doReboot)
	bool	hl
	ld	l,a
	push	hl
	lcall	$REBOOT
	pop	hl
@794:
	.debug	>
;3643     }
@792:
@788:
	.debug	>
;3644 
;3645   //--- kill any tasks still running 10 seconds after getting SIGTERM ---
;3646     if (msSince(shutdownStarted) > 10000)  kill(-1, SIGKILL);
@785:
	.debug	# 3646
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_shutdownStarted)
	ld	bc,(_shutdownStarted+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	c,@795
	jr	z,@795
	ld	hl,0x9
	push	hl
	ld	hl,0xffff
	push	hl
	lcall	$kill
	add	sp,4
;3647 
;3648   //--- Reboot after 15 seconds no matter WHAT!!! ---
;3649     if (msSince(shutdownStarted) > 15000)  REBOOT(doReboot);
@795:
	.debug	# 3649
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_shutdownStarted)
	ld	bc,(_shutdownStarted+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3a98
	ld	bc,0
	call	__lsub##
	jr	c,@796
	jr	z,@796
	ld	a,(_doReboot)
	bool	hl
	ld	l,a
	push	hl
	lcall	$REBOOT
	pop	hl
;3650 
;3651   } while(0);
@796:
@780:
	.debug	>
	.debug	# 3651
;3652 
;3653 
;3654 
;3655 //===== Check to see if any sleeping tasks should be woken up or have =====
;3656 //===== pending signals to be processed =====
;3657   KLOCK();
@777:
@775:
	.debug	# 3657
	call	_KLOCK
;3658 
;3659 //--- check for expired sleep timers ---
;3660   list_for_each_safe(cur, next, &sleepQueue.listHead)  {
@797:
	.debug	< @797 @798
	.debug	# 3660
	ld	hl,(_sleepQueue)
	ld	(ix-4),hl
	ld	hl,(hl)
	ld	(ix-6),hl
@799:
	ld	hl,_sleepQueue
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	z,@800
;3661     node = list_entry(cur, WaitQueueNode, taskList);
@802:
	.debug	< @802 @803
	.debug	# 3661
	ld	h,d
	ld	l,e
	ld	de,0xfff8
	add	hl,de
	ld	(ix-8),hl
;3662     task = node->task;
	.debug	# 3662
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-2),hl
;3663 
;3664     if (_activeTaskIdx_(task->pid) < 0)  {
	.debug	# 3664
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@804
;3665       fprintf(DiagLog, "bad task in sleepQueue: %d/%d\r\n",   //tdebug
@805:
	.debug	< @805 @806
;3666                (uint)(task-tasks), task->pid);
	.debug	# 3666
	ld	hl,(ix-2)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	push	hl
	ld	de,word (phys @1+2540)
	ld	c,phys @1+2540 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;3667       __removeWaitQueue(&sleepQueue, node);  free_WaitQueueNode(node);
	.debug	# 3667
	ld	hl,(ix-8)
	push	hl
	ld	hl,_sleepQueue
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-8)
	push	hl
	lcall	$free_WaitQueueNode
	pop	hl
;3668       continue;
	.debug	# 3668
;3669     }
	jr	@801
@806:
	.debug	>
;3670     if (task->preempt_count)  continue;
@804:
	.debug	# 3670
	ld	hl,(ix-2)
	ld	de,0xa8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@801
;3671 
;3672     if (task->sleepTicks)
	.debug	# 3672
	ld	hl,(ix-2)
	ld	e,0xdc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@808
;3673       --task->sleepTicks;
	.debug	# 3673
	ld	hl,(ix-2)
	ld	de,0xdc
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ldec##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3674     else  {
	jr	@809
@808:
;3675       __removeWaitQueue(&sleepQueue, node);  task->state = TASK_RUNNING; }
@810:
	.debug	< @810 @811
	.debug	# 3675
	ld	hl,(ix-8)
	push	hl
	ld	hl,_sleepQueue
	push	hl
	lcall	$__removeWaitQueue
	add	sp,4
	ld	hl,(ix-2)
	ld	de,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@811:
	.debug	>
;3676   }
@809:
@803:
	.debug	>
;3677 
;3678 
;3679   for (task=tasks; task!=endTasks; ++task)  {
@801:
	ld	hl,(ix-6)
	ld	(ix-4),hl
	ld	hl,(hl)
	ld	(ix-6),hl
	jp	@799
@800:
@798:
	.debug	>
@812:
	.debug	< @812 @813
	.debug	# 3679
	ld	hl,_tasks
	ld	(ix-2),hl
@814:
	ld	hl,(_endTasks)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	z,@815
;3680     if (! task->inUse)  continue;
@817:
	.debug	< @817 @818
	.debug	# 3680
	ld	h,d
	ld	l,e
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@816
;3681 
;3682   //--- check for an expired timeout count ---
;3683       if (task->timeoutTicks AND BlockedTask(task))
	.debug	# 3683
	ld	hl,(ix-2)
	ld	e,0xe4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@821
	ld	hl,(ix-2)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x3
	and	hl,de
	jr	z,@821
;3684         if (--task->timeoutTicks == 0)  task->state = TASK_RUNNING;
	.debug	# 3684
	ld	hl,(ix-2)
	ld	e,0xe4
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ldec##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,bc
	or	hl,de
	jr	nz,@822
	ld	hl,(ix-2)
	ld	de,0x13
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3685 
;3686   //--- check for pending signals ---
;3687     if (! task->sig_pending)  continue;
@822:
@821:
	.debug	# 3687
	ld	hl,(ix-2)
	ld	de,0xa0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@816
;3688 
;3689   //finish:  clear ignored signals without a handler
;3690 
;3691   //finish
;3692   // until I implement signal handlers, just clear any pending signals
;3693   // for ones that are normally ignored
;3694   // (use another mask for ones that have an associated handler?)
;3695     task->sig_pending &= ~DefaultIgnoreSet;
	.debug	# 3695
	ld	de,(_DefaultIgnoreSet)
	ld	bc,(_DefaultIgnoreSet+2)
	call	__lnot##
	ld	hl,(ix-2)
	push	bc
	push	de
	ld	de,0xa0
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3696 
;3697   //--- Remove blocked pending signals from the set being considered ---
;3698   //--- NOTE that they have to be left in the pending list for the task ---
;3699   //--- so it can check for ones it blocked and deal with them when and ---
;3700   //--- how it wants. ---
;3701     notBlockedPending = task->sig_pending & ~task->sig_blocked;
	.debug	# 3701
	ld	hl,(ix-2)
	ld	de,0xa0
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xa4
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lnot##
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__land##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;3702     if (! notBlockedPending)  continue;
	.debug	# 3702
	or	hl,de
	jr	z,@816
;3703 
;3704   //--- process has pending signals that are not blocked and not ignored --
;3705   //finish: until I implement signal handlers, just terminate it
;3706     _killTask_(task);
	.debug	# 3706
	ld	hl,(ix-2)
	push	hl
	lcall	$_killTask_
	pop	hl
;3707   }
@818:
	.debug	>
;3708 
;3709   KUNLOCK();
@816:
	ld	hl,(ix-2)
	ld	de,0xe8
	add	hl,de
	ld	(ix-2),hl
	jp	@814
@815:
@813:
	.debug	>
	.debug	# 3709
	call	_KUNLOCK
;3710 }
@749:
	.debug	} @749 3710

@748	equ	41
	ld	sp,ix
	pop	ix
	lret
@750	equ	43
;3711 
;3712 
;3713 //-------------------------------------------------------------------------
;3714 //  Do remaining hardware initialization then process kernel/system calls
;3715 //
;3716 //  This process must be run at the 2nd highest priority (below the applic
;3717 //  task priority, but above everything else).
;3718 //-------------------------------------------------------------------------
;3719 void _task kernel(int argc, char **argv)
;3720 {
	.align	4
$$kernel::
	ex	(sp),iy
$kernel::
	.debug	G $kernel 51 9
	.debug	{ $kernel 51 3719 @827 @826
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-78
	.debug	A argc 5 6
	.debug	A argv 7 48
;3721 //  PIX  pix;
;3722   int  pid, ch;
	.debug	L pid -2 6
	.debug	L ch -4 6
;3723   uint  startTime;
	.debug	L startTime -6 7
;3724   char  *argv_[2];
	.debug	L argv_ -10 84
;3725   uchar  *macAddr;
	.debug	L macAddr -12 40
;3726   uint  u;
	.debug	L u -14 7
;3727   char  temp[64];
	.debug	L temp -78 85
;3728 
;3729 
;3730 //--- initialize IP "stack" and allow all levels of interrupts
;3731   ipset0();  ipset0();  ipset0();  ipset0();  // initialize IP "stack"
	.debug	# 3731
	ipset	0
	ipset	0
	ipset	0
	ipset	0
;3732 
;3733   printf("\r\nkernel process started\r\n");
	.debug	# 3733
	ld	de,word (phys @1+2572)
	ld	c,phys @1+2572 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3734 
;3735 //--- set up buffer and FILE "device" to handle diagnostic msgs ---
;3736   fassign(DiagLog, diagIn, diagOut);
	.debug	# 3736
	ld	hl,_diagOut
	push	hl
	ld	hl,_diagIn
	push	hl
	ld	hl,_diagLog
	push	hl
	lcall	$fassign
	add	sp,6
;3737 
;3738 
;3739 //--- redirect Softools stdin/stdout ---
;3740   fassign(&taskIO, rcvChar, xmitChar);
	.debug	# 3740
	ld	hl,_xmitChar
	push	hl
	ld	hl,_rcvChar
	push	hl
	ld	hl,_taskIO
	push	hl
	lcall	$fassign
	add	sp,6
;3741   origIO = _stdio;  _stdio = &taskIO;
	.debug	# 3741
	ld	hl,(__stdio)
	ld	(_origIO),hl
	ld	hl,_taskIO
	ld	(__stdio),hl
;3742 
;3743 
;3744   setApplDTM();
	.debug	# 3744
	lcall	$setApplDTM
;3745 
;3746   logDateTime = false;
	.debug	# 3746
	xor	a,a
	ld	(_logDateTime),a
;3747 
;3748   macAddr = idBlock->macAddr[0];
	.debug	# 3748
	ld	hl,_idBlock+11
	ld	(ix-12),hl
;3749   sprintf(moduleID, "%02X%02X%02X", macAddr[3], macAddr[4], macAddr[5]);
	.debug	# 3749
	ld	de,0x5
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-12)
	dec	e
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-12)
	inc	hl
	inc	hl
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+2599)
	ld	c,phys @1+2599 >> 16
	push	bc
	push	de
	ld	hl,_moduleID
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,14
;3750 
;3751 
;3752   if (!restoredLog)
	.debug	# 3752
	ld	a,(_restoredLog)
	or	a,a
	jr	nz,@828
;3753     fprintf(DiagLog, "\r\n----- Starting new log -----\r\n");
	.debug	# 3753
	ld	de,word (phys @1+2612)
	ld	c,phys @1+2612 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3754   else  {
	jp	@829
@828:
;3755     fprintf(DiagLog, "\r\n***** Restored previous log *****\r\n"
@830:
	.debug	< @830 @831
;3756                      "\n"
;3757                      "Module %s was last running at: %s\r\n"
;3758                      "\n"
;3759                      "This reboot was %sexpected\r\n\n",
;3760             moduleID,
;3761             dateTimeMS(temp, prevLogInfo.seconds, prevLogInfo.milliSecs),
;3762             (prevLogInfo.ctldShutdown ? "" : "NOT ")
;3763           );
	.debug	# 3763
	ld	de,word (phys _prevLogInfo+13)
	ld	c,phys _prevLogInfo+13 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@832
	ld	hl,@66+8
	jr	@833
@832:
	ld	hl,@66+80
@833:
	push	hl
	ld	de,word (phys _prevLogInfo+20)
	ld	c,phys _prevLogInfo+20 >> 16
	call	__farld2##
	push	de
	ld	de,word (phys _prevLogInfo+16)
	ld	c,phys _prevLogInfo+16 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	hl,-70+@825
	add	hl,sp
	push	hl
	lcall	$dateTimeMS
	add	sp,8
	push	hl
	ld	hl,_moduleID
	push	hl
	ld	de,word (phys @1+2645)
	ld	c,phys @1+2645 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,12
;3764     if (!prevLogInfo.ctldShutdown AND (time(NULL) - prevLogInfo.seconds < 9
	.debug	# 3764
	ld	de,word (phys _prevLogInfo+13)
	ld	c,phys _prevLogInfo+13 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	nz,@836
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+16)
	ld	c,phys _prevLogInfo+16 >> 16
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x5a
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	nc,@836
;3765       attemptRestore = true;
	.debug	# 3765
	ld	a,0x1
	ld	(_attemptRestore),a
;3766   }
@836:
@831:
	.debug	>
;3767 
;3768 //--- If using hdw protection make sure the order and alignment of the ---
;3769 //--- segments are correct ---
;3770   if (hdwProtection)
@829:
	.debug	# 3770
	ld	a,(_hdwProtection)
	or	a,a
	jp	z,@837
;3771     if (!( (codeStart == 0) AND (constStart > codeStart)
;3772          AND (farCodeStart > constStart) AND (farConstStart > farCodeStart)
;3773          AND (farBSSStart > farConstStart)
;3774          AND ((farCodeStart & 0x0FFF) == 0) AND ((farBSSStart & 0x0FFF) == 
;3775        ) )
	.debug	# 3775
	ld	hl,(_codeStart)
	bool	hl
	jp	nz,@839
	ld	hl,(_constStart)
	ld	de,(_codeStart)
	or	a,a
	sbc	hl,de
	jr	c,@839
	jr	z,@839
	ld	hl,(_constStart)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsubr##
	jr	c,@839
	jr	z,@839
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	push	bc
	push	de
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	call	__lsub##
	jr	c,@839
	jr	z,@839
	ld	de,(_farBSSStart)
	ld	bc,(_farBSSStart+2)
	push	bc
	push	de
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	call	__lsub##
	jr	c,@839
	jr	z,@839
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	push	bc
	push	de
	ld	de,0xfff
	ld	bc,0
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@839
	ld	de,(_farBSSStart)
	ld	bc,(_farBSSStart+2)
	push	bc
	push	de
	ld	de,0xfff
	ld	bc,0
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@841
@839:
;3776       printf("***** Segment order or alignment not correct *****\r\n"
;3777              "Must be as follows:\r\n"
;3778              "  CODE, CONST, DATA, BSS, FARCODE, FARCONST, FARBSS, XMEMSTAR
;3779              "  with FARCODE and FARBSS using an alignment of 0x1000\r\n");
	.debug	# 3776
	ld	de,word (phys @1+2749)
	ld	c,phys @1+2749 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3780 
;3781 //--- compute CRCs for each segment and save the result for comparison ---
;3782 //--- should a detectable crash occur ---
;3783   computeMemCRCs(true, true);
@841:
@837:
	.debug	# 3783
	ld	hl,0x1
	push	hl
	push	hl
	lcall	$computeMemCRCs
	add	sp,4
;3784 
;3785 
;3786 //--- check for reboot or shutdown command before continuing ---
;3787   ch = getcConsole() & 0x7F;
	.debug	# 3787
	call	_SerialGetcA
	ld	de,0x7f
	and	hl,de
	ld	(ix-4),hl
;3788   for (u=0; u<20; ++u)  if (((ch = getcConsole()) & 0x7F) < 0x7F)  break;
@842:
	.debug	< @842 @843
	.debug	# 3788
	bool	hl
	ld	l,h
	ld	(ix-14),hl
@844:
	ld	hl,(ix-14)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@845
	call	_SerialGetcA
	ld	(ix-4),hl
	ld	de,0x7f
	and	hl,de
	ld	d,0x80
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@845
;3789 //  printf("\r\nConsole char: 0x%02X\r\n\n", ch);  //tdebug
;3790   if (ch == 0x02)  {  // Ctl-B:  reboot and run backup bootimg
	ld	hl,(ix-14)
	inc	hl
	ld	(ix-14),hl
	jr	@844
@845:
@843:
	.debug	>
	.debug	# 3790
	ld	hl,(ix-4)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@848
;3791     runBackup = true;  REBOOT(true); }
@849:
	.debug	< @849 @850
	.debug	# 3791
	ld	a,0x1
	ld	(_runBackup),a
	ld	h,d
	ld	l,a
	push	hl
	lcall	$REBOOT
	pop	hl
@850:
	.debug	>
;3792   if ((ch == 0x03) OR (ch == 0x1B)) REBOOT(false); // Ctl-C or ESC: restart
@848:
	.debug	# 3792
	ld	hl,(ix-4)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@851
	ld	hl,(ix-4)
	ld	e,0x1b
	or	a,a
	sbc	hl,de
	jr	nz,@852
@851:
	bool	hl
	ld	l,h
	push	hl
	lcall	$REBOOT
	pop	hl
;3793 
;3794 //--- If we rebooted unexpectedly shortly after the previous startup, then 
;3795 //--- revert to the backup image or the DLM ---
;3796   if (restoredLog)  // we have info from previous reboot/run
@852:
	.debug	# 3796
	ld	a,(_restoredLog)
	or	a,a
	jr	z,@853
;3797     if (!prevLogInfo.ctldShutdown)  // last reboot was not intentional
	.debug	# 3797
	ld	de,word (phys _prevLogInfo+13)
	ld	c,phys _prevLogInfo+13 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	nz,@854
;3798       // prev run crashed after a short time
;3799       if (diagLogInfo->rebootTime - prevLogInfo.rebootTime < 90)  {
	.debug	# 3799
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x70
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+112)
	ld	c,phys _prevLogInfo+112 >> 16
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x5a
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	nc,@855
;3800         if (runningPrimary)  { runBackup = true;  REBOOT(true); }
@856:
	.debug	< @856 @857
	.debug	# 3800
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@858
@859:
	.debug	< @859 @860
	ld	a,0x1
	ld	(_runBackup),a
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@860:
	.debug	>
;3801         REBOOT(false);  // no good boot image - revert to DLM
@858:
	.debug	# 3801
	bool	hl
	ld	l,h
	push	hl
	lcall	$REBOOT
	pop	hl
;3802       }
@857:
	.debug	>
;3803 
;3804 
;3805   fprintf(DiagLog,
@855:
@854:
@853:
;3806          "%ls\r\n"
;3807          " RTOS: %.40ls  %.40ls\r\n"
;3808          " APPL: %.40ls  %.40ls\r\n"
;3809          "%ls\r\n",
;3810          asterisks, osDTM, osName, applDTM, applName, asterisks);
	.debug	# 3810
	ld	de,word (phys _asterisks)
	ld	c,phys _asterisks >> 16
	push	bc
	push	de
	ld	de,word (phys _applName)
	ld	c,phys _applName >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	ld	de,word (phys _osName)
	ld	c,phys _osName >> 16
	push	bc
	push	de
	ld	de,word (phys _osDTM)
	ld	c,phys _osDTM >> 16
	push	bc
	push	de
	ld	de,word (phys _asterisks)
	ld	c,phys _asterisks >> 16
	push	bc
	push	de
	ld	de,word (phys @1+2943)
	ld	c,phys @1+2943 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,30
;3811 
;3812 
;3813   logDateTime = true;
	.debug	# 3813
	ld	a,0x1
	ld	(_logDateTime),a
;3814 
;3815   if (prevLogInfo.didSoftReset)
	.debug	# 3815
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@861
;3816     printf("*** Restarted from a Soft Reset ***\r\n"
;3817            "===== Last hard/CPU reset occured at: %.19s ====\r\n\n",
;3818            dateTimeMS(temp, hdwResetTime, 0) );
	.debug	# 3818
	bool	hl
	ld	l,h
	push	hl
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	hl,-72+@825
	add	hl,sp
	push	hl
	lcall	$dateTimeMS
	add	sp,8
	push	hl
	ld	de,word (phys @1+3000)
	ld	c,phys @1+3000 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3819 //  else
;3820 //    if (attemptRestore)  printf("*** Attempt to restore prev state ***\r\
;3821 
;3822   if (copyGCSR < 0)
@861:
	.debug	# 3822
	ld	hl,(_copyGCSR)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@862
;3823     printf("*** GCSR was not saved ***\r\n");
	.debug	# 3823
	ld	de,word (phys @1+3089)
	ld	c,phys @1+3089 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3824   else  {
	jr	@863
@862:
;3825     resetCode = (copyGCSR >> 6) & 0x03;
@864:
	.debug	< @864 @865
	.debug	# 3825
	ld	hl,(_copyGCSR)
	ld	b,6
@866:
	sra	h
	rr	l
	djnz	@866
	ld	de,0x3
	and	hl,de
	ld	a,l
	ld	(_resetCode),a
;3826     printf("GCSR at restart: [0x%02X] (%d)(%ls)\r\n",
;3827            copyGCSR, resetCode, resetCause[resetCode] );
	.debug	# 3827
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	ld	de,_resetCause
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(_copyGCSR)
	push	hl
	ld	de,word (phys @1+3118)
	ld	c,phys @1+3118 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3828   }
@865:
	.debug	>
;3829 
;3830   printf("\r\n"
@863:
;3831          "free Root: %u\r\n"
;3832          "free xmem: %lu  (%05lX-%05lX)\r\n"
;3833          "\n",
;3834          (uint)0xD000 - bssStart - bssSize,
;3835          xavail(), _xmemHeap, _xmemEnd-1 );
	.debug	# 3835
	ld	de,(__xmemEnd)
	ld	bc,(__xmemEnd+2)
	call	__ldec##
	push	bc
	push	de
	ld	de,(__xmemHeap)
	ld	bc,(__xmemHeap+2)
	push	bc
	push	de
	lcall	$xavail
	push	bc
	push	de
	ld	hl,0xd000
	ld	de,(_bssStart)
	or	a,a
	sbc	hl,de
	ld	de,(_bssSize)
	or	a,a
	sbc	hl,de
	push	hl
	ld	de,word (phys @1+3156)
	ld	c,phys @1+3156 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;3836 
;3837 
;3838   printf("for CStart, BB log & info (earlier, during startup):\r\n");
	.debug	# 3838
	ld	de,word (phys @1+3206)
	ld	c,phys @1+3206 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3839   logAllocation(_xmemEnd, xmemAtStartup - xmemAfterBB);
	.debug	# 3839
	ld	de,(_xmemAtStartup)
	ld	bc,(_xmemAtStartup+2)
	push	bc
	push	de
	ld	de,(_xmemAfterBB)
	ld	bc,(_xmemAfterBB+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,(__xmemEnd)
	ld	bc,(__xmemEnd+2)
	push	bc
	push	de
	lcall	$logAllocation
	add	sp,8
;3840 
;3841 
;3842   printf("Initializing... (%.6s)\r\n", moduleID);
	.debug	# 3842
	ld	hl,_moduleID
	push	hl
	ld	de,word (phys @1+3261)
	ld	c,phys @1+3261 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3843 
;3844 
;3845   initWriteProtect();  // must come BEFORE init_tasks()
	.debug	# 3845
	lcall	$initWriteProtect
;3846 
;3847 
;3848 //NOTE:  sock_init() cannot be called until after the periodic timer interr
;3849 //       (the one that updates the milliseconds and seconds counters) is
;3850 //       running.  For DEBROS, that means the timerB ISR that calls the
;3851 //       sched_tick() function in this module.
;3852 
;3853 //finish:  The various fcntl drivers are "registered" much earlier than thi
;3854 //         (during the fcntlInit() call).  But for drivers like the socket 
;3855 //         that need additional initialization that cannot be done at the t
;3856 //         they are registered, I should add an init function to the std fc
;3857 //         driver interface and call it for each driver at this time...
;3858 
;3859 //--- initialize network interface ---
;3860 //  tcp_lock = lock_semaphore;  tcp_unlock = unlock_semaphore;
;3861   tcp_lock = KLOCK;  tcp_unlock = KUNLOCK;  // just in case I missed any...
	.debug	# 3861
	ld	hl,_KLOCK
	ld	(_tcp_lock),hl
	ld	hl,_KUNLOCK
	ld	(_tcp_unlock),hl
;3862   printf("Initializing network hdw...\r\n"
;3863          "  tcp_Socket size: %d   udp_Socket size: %d\r\n",
;3864          sizeof(tcp_Socket), sizeof(udp_Socket) );
	.debug	# 3864
	ld	hl,0x2c
	push	hl
	ld	l,0xaa
	push	hl
	ld	de,word (phys @1+3286)
	ld	c,phys @1+3286 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3865   WDT_DISABLE();
	.debug	# 3865
  ld  l,0x09
  ioi ld  (hl),0x51
  ioi ld  (hl),0x54
;3866   netHdwInit();
	.debug	# 3866
	lcall	$netHdwInit
;3867   printf("Initializing network stack (xavail():%ld)...\r\n", xavail());
	.debug	# 3867
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+3361)
	ld	c,phys @1+3361 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3868   sockStat = sock_init();
	.debug	# 3868
	lcall	$sock_init
	ld	(_sockStat),hl
;3869   if (sockStat)  printf("***** sock_init() error: %d *****\r\n", sockStat);
	.debug	# 3869
	bool	hl
	jr	z,@867
	ld	hl,(_sockStat)
	push	hl
	ld	de,word (phys @1+3408)
	ld	c,phys @1+3408 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3870   WDT_2S();  WDT_ENABLE();
@867:
	.debug	# 3870
  ld  a,0x5A
  ioi ld  (0x08),a
  ld  l,0x09
  ioi ld  (hl),l
;3871   printf("\n");
	.debug	# 3871
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3872 
;3873   if (init_tasks())  REBOOT(runningPrimary);
	.debug	# 3873
	lcall	$init_tasks
	bool	hl
	jr	z,@868
	ld	a,(_runningPrimary)
	bool	hl
	ld	l,a
	push	hl
	lcall	$REBOOT
	pop	hl
;3874 
;3875   printf("Task table initialized\r\n\n");
@868:
	.debug	# 3875
	ld	de,word (phys @1+3444)
	ld	c,phys @1+3444 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3876 
;3877 
;3878   if (hdwProtection)  {
	.debug	# 3878
	ld	a,(_hdwProtection)
	or	a,a
	jr	z,@869
;3879 //    showMemProtection();
;3880 
;3881   //--- in case the 64K WP segment mask was changed ---
;3882     outi(MMIDR, 0x80);  // enable access to registers > 0x00FF
@870:
	.debug	< @870 @871
	.debug	# 3882
	ld	a,0x80
	ioi ld	(16),a
;3883     outi(WPHR, MSBI(wpSegMask));  outi(WPLR, LSBI(wpSegMask));
	.debug	# 3883
	ld	a,(_wpSegMask+1)
	ioi ld	(1121),a
	ld	a,(_wpSegMask)
	ioi ld	(1120),a
;3884     outi(MMIDR, 0x00);  // disable access to registers > 0x00FF
	.debug	# 3884
	xor	a,a
	ioi ld	(16),a
;3885   }
@871:
	.debug	>
;3886 
;3887   printf("For far heap:\r\n");
@869:
	.debug	# 3887
	ld	de,word (phys @1+3470)
	ld	c,phys @1+3470 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3888   if (_farheapsize > xavail())  _farheapsize = xavail();
	.debug	# 3888
	lcall	$xavail
	push	bc
	push	de
	ld	de,(__farheapsize)
	ld	bc,(__farheapsize+2)
	call	__lsubr##
	jr	c,@872
	jr	z,@872
	lcall	$xavail
	ld	(__farheapsize),de
	ld	(__farheapsize+2),bc
;3889   if (! (_farheap = xalloc(_farheapsize)))
@872:
	.debug	# 3889
	ld	de,(__farheapsize)
	ld	bc,(__farheapsize+2)
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	ld	(__farheap),de
	ld	(__farheap+2),bc
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@873
;3890     printf("***** Unable to init far heap *****\r\n");
	.debug	# 3890
	ld	de,word (phys @1+3486)
	ld	c,phys @1+3486 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3891 
;3892   fmemset((void far *)_farheap, 0, _farheapsize);
@873:
	.debug	# 3892
	ld	de,(__farheapsize)
	ld	bc,(__farheapsize+2)
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,(__farheap)
	ld	bc,(__farheap+2)
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3893 
;3894 
;3895   deviceID = lastDeviceID = ReadDeviceID();
	.debug	# 3895
	lcall	$ReadDeviceID
	ld	(_lastDeviceID),de
	ld	(_lastDeviceID+2),bc
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
;3896   printf("\r\nDevice ID: 0x%04lX\r\n\n", deviceID);
	.debug	# 3896
	push	bc
	push	de
	ld	de,word (phys @1+3524)
	ld	c,phys @1+3524 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3897 
;3898   flushConsole();
	.debug	# 3898
	lcall	$flushConsole
;3899 
;3900 #ifdef SHD_DLM
;3901   DLM_Init(hostName);    // initializes flash file system
	.debug	# 3901
	ld	hl,_hostName
	push	hl
	lcall	$DLM_Init
	pop	de
;3902   if (sockStat AND runningPrimary)  doShutdown = doReboot = true;
	.debug	# 3902
	ld	hl,(_sockStat)
	bool	hl
	jr	z,@875
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@875
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
;3903 #endif
;3904 
;3905 
;3906   lastReadTime = 0;
@875:
	.debug	# 3906
	bool	hl
	ld	l,h
	ld	(_lastReadTime),hl
;3907 
;3908   hdwInit2();
	.debug	# 3908
	lcall	$hdwInit2
;3909 
;3910 
;3911   checkIntShims();  // make ISR vectors "scheduler-safe"
	.debug	# 3911
	lcall	$checkIntShims
;3912 
;3913   countersUpdated = GetMS_();
	.debug	# 3913
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_countersUpdated),hl
;3914 
;3915   schedCallsPrevSec = 0;
	.debug	# 3915
	bool	hl
	ld	l,h
	ld	(_schedCallsPrevSec),hl
;3916 
;3917 
;3918   diagLogInfo->wdtTicks = 0;
	.debug	# 3918
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;3919 
;3920   WDT_ENABLE();  WDT_2S();  checkWDT = true;  // start 2-second countdown W
	.debug	# 3920
  ld  l,0x09
  ioi ld  (hl),l
  ld  a,0x5A
  ioi ld  (0x08),a
	ld	a,0x1
	ld	(_checkWDT),a
;3921 
;3922 
;3923   applicActive = false;
	.debug	# 3923
	xor	a,a
	ld	(_applicActive),a
;3924 
;3925   argv_[0] = "idle";  argv_[1] = NULL;
	.debug	# 3925
	ld	hl,@66+85
	ld	(ix-10),hl
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;3926   pid = createProc(idle, NUM_PRIORITIES-1, 1, argv_, 0, 1, 2);
	.debug	# 3926
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-4+@825
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xf
	push	hl
	ld	hl,_idle
	push	hl
	lcall	$createProc
	add	sp,14
	ld	(ix-2),hl
;3927   idleTask = tasks + TaskIdx(pid);
	.debug	# 3927
	ld	de,0x1f
	and	hl,de
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(_idleTask),hl
;3928 
;3929   argv_[0] = "applic";  argv_[1] = NULL;
	.debug	# 3929
	ld	hl,@66+90
	ld	(ix-10),hl
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;3930   pid = createProc(applic, 0, 1, argv_, 0, 1, 2);
	.debug	# 3930
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-4+@825
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,h
	push	hl
	ld	hl,_applic
	push	hl
	lcall	$createProc
	add	sp,14
	ld	(ix-2),hl
;3931   applTask = tasks + TaskIdx(pid);
	.debug	# 3931
	ld	de,0x1f
	and	hl,de
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(_applTask),hl
;3932 
;3933   resetWDT();
	.debug	# 3933
	lcall	$resetWDT
;3934 
;3935   srand(GetMS_());
	.debug	# 3935
	ld	hl,(__TimerMilliSeconds+4)
	push	hl
	lcall	$srand
	pop	hl
;3936 
;3937   KUNLOCK();  // and away we go!!!
	.debug	# 3937
	call	_KUNLOCK
;3938 
;3939 
;3940   for (;;)  {
@876:
	.debug	< @876 @877
@878:
;3941     KLOCK();
@881:
	.debug	< @881 @882
	.debug	# 3941
	call	_KLOCK
;3942 
;3943     startTime = GetMS_();
	.debug	# 3943
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-6),hl
;3944 
;3945     backgroundIO();
	.debug	# 3945
	lcall	$backgroundIO
;3946 
;3947     kernelLoopTime = msSince_(startTime);
	.debug	# 3947
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_kernelLoopTime),hl
;3948 
;3949     current->state = TASK_UNINTERRUPTIBLE;
	.debug	# 3949
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3950 
;3951     KUNLOCK();  schedule();  // woken by sched_tick() each scheduler tick
	.debug	# 3951
	call	_KUNLOCK
	lcall	$schedule
;3952   }
@882:
	.debug	>
;3953 
;3954 }
	jr	@878
@877:
	.debug	>
@826:
	.debug	} @826 3954

@825	equ	78
	ld	sp,ix
	pop	ix
	lret
@827	equ	80
;3955 
;3956 //-------------------------------------------------------------------------
;3957 //  Check for a copy of the GCSR register value saved to RAM by a patched
;3958 //  version of the RDLM.  This value tells us if the CPU was reset by the
;3959 //  Reset signal (or a power failure), or by the watchdog timer.
;3960 //
;3961 //  The patched copy of the RDLM does the following:
;3962 //
;3963 //    - Reads the value of GCSR and creates a 16-bit value with the value i
;3964 //      LSB and a 1's complement of the value in the MSB
;3965 //
;3966 //    - Stores a copy of the 16-bit value at the following offsets from the
;3967 //      start of the RAM activated by the /CS1 signal:
;3968 //          0x28000, 0x28080, 0x78000, 0x78080
;3969 //      Which means the following:
;3970 //        For RCM3200:  The value will be at 0xA8000 and 0xA8080
;3971 //        For RCM22xx:  The value will be at 0x78000 and 0x78080
;3972 //
;3973 //  Returns the value if found, or -1 if the value was not found at the
;3974 //  specified locations.
;3975 //-------------------------------------------------------------------------
;3976 int readGCSR(ulong testAddr)
;3977 {
$readGCSR::
	.debug	G $readGCSR 86 9
	.debug	{ $readGCSR 86 3976 @885 @884
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A testAddr 5 9
;3978   uint  copy1, copy2;
	.debug	L copy1 -2 7
	.debug	L copy2 -4 7
;3979 
;3980 
;3981   copy1 = *((uint far *)testAddr);  copy2 = *((uint far *)(testAddr + 0x80L
	.debug	# 3981
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;3982 
;3983   if ((copy1 == copy2) AND (LSBI(copy1) == ~MSBI(copy1)))  return LSBI(copy
	.debug	# 3983
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@887
	ld	a,(ix-1)
	cpl	a
	ld	hl,(ix-2)
	sub	a,l
	jr	nz,@887
	bool	hl
	ld	l,(ix-2)
	jr	@884
;3984 
;3985   return -1;
@887:
	.debug	# 3985
	ld	hl,0xffff
;3986 }
@884:
	.debug	} @884 3986

@883	equ	4
	ld	sp,ix
	pop	ix
	lret
@885	equ	6
;3987 
;3988 
;3989 //-------------------------------------------------------------------------
;3990 //  Start of execution:  Initialize hardware, the timer interrupt, and crea
;3991 //  the kernel process
;3992 //-------------------------------------------------------------------------
;3993 void main( void )
;3994 {
$main::
	.debug	G $main 37 9
	.debug	{ $main 37 3993 @890 @889
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-40
;3995   uint  i, msw, lsw;
	.debug	L i -2 7
	.debug	L msw -4 7
	.debug	L lsw -6 7
;3996   int  runKey;
	.debug	L runKey -8 6
;3997   time_t  curTime;
	.debug	L curTime -12 9
;3998   DiagLogInfo far *prevInfo;
	.debug	L prevInfo -16 87
;3999   char far *fromPtr, *toPtr;
	.debug	L fromPtr -20 34
	.debug	L toPtr -24 34
;4000   ulong  len, downSecs;
	.debug	L len -28 9
	.debug	L downSecs -32 9
;4001   char  *argv[2], *stack_low, *stack_high;
	.debug	L argv -36 84
	.debug	L stack_low -38 40
	.debug	L stack_high -40 40
;4002 #define LocalVarBytes  64  // must be at LEAST as large as above local vars
;4003 
;4004 
;4005 //--- Get the value GCSR had after a restart, if available ---
;4006   copyGCSR = readGCSR(0xA8000L);
	.debug	# 4006
	ld	de,0x8000
	ld	bc,0xa
	push	bc
	push	de
	lcall	$readGCSR
	add	sp,4
	ld	(_copyGCSR),hl
;4007   if (copyGCSR < 0)  copyGCSR = readGCSR(0x78000L);
	.debug	# 4007
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@891
	ld	bc,0x7
	push	bc
	push	de
	lcall	$readGCSR
	add	sp,4
	ld	(_copyGCSR),hl
;4008 
;4009 
;4010   KLOCK();  // make sure the scheduler can't start until we are ready
@891:
	.debug	# 4010
	call	_KLOCK
;4011 
;4012   WDT_ENABLE();  WDT_2S();  kernelLastCalled = applicLastCalled = 0;
	.debug	# 4012
  ld  l,0x09
  ioi ld  (hl),l
  ld  a,0x5A
  ioi ld  (0x08),a
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_applicLastCalled),de
	ld	(_applicLastCalled+2),bc
	ld	(_kernelLastCalled),de
	ld	(_kernelLastCalled+2),bc
;4013 
;4014   xmemAtStartup = xavail();  ramSize = _xmemEnd;
	.debug	# 4014
	lcall	$xavail
	ld	(_xmemAtStartup),de
	ld	(_xmemAtStartup+2),bc
	ld	de,(__xmemEnd)
	ld	bc,(__xmemEnd+2)
	ld	(_ramSize),de
	ld	(_ramSize+2),bc
;4015 
;4016   cpuID = ini(GCPU) & 0x1F;  cpuRev = ini(GREV) & 0x1F;
	.debug	# 4016
	ioi ld	a,(46)
	and	a,31
	ld	(_cpuID),a
	ioi ld	a,(47)
	and	a,31
	ld	(_cpuRev),a
;4017 
;4018   hdwProtection = (cpuID > 1) OR ((cpuID == 1) AND (cpuRev >= 1));
	.debug	# 4018
	ld	a,(_cpuID)
	sub	a,1
	jr	z,@894
	jr	nc,@892
@894:
	ld	a,(_cpuID)
	sub	a,1
	jr	nz,@893
	ld	a,(_cpuRev)
	sub	a,1
	jr	c,@893
@892:
	ld	a,1
	jr	@898
@893:
	xor	a
@898:
	ld	(_hdwProtection),a
;4019 
;4020 
;4021   logDateTime = recursiveDump = useSoftReset = memCorrupted = false;
	.debug	# 4021
	xor	a,a
	ld	(_memCorrupted),a
	ld	(_useSoftReset),a
	ld	(_recursiveDump),a
	ld	(_logDateTime),a
;4022   attemptRestore = false;
	.debug	# 4022
	xor	a,a
	ld	(_attemptRestore),a
;4023   runBackup = doCleanShutdown = true;
	.debug	# 4023
	ld	a,0x1
	ld	(_doCleanShutdown),a
	ld	(_runBackup),a
;4024 
;4025 //NOTE:  Interrupts are not yet enabled, so no data would actually be sent
;4026 //       out the console serial port until initialization finishes unless
;4027 //       we temporarily enable interrupts
;4028 
;4029   ipset0();  initConsole();
	.debug	# 4029
	ipset	0
	lcall	$initConsole
;4030 
;4031 
;4032   if (xmemAtStartup < _256K)  {
	.debug	# 4032
	ld	de,(_xmemAtStartup)
	ld	bc,(_xmemAtStartup+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4
	call	__lsub##
	jr	nc,@899
;4033     DiagLogSize = 10 * 1024;  _farheapsize = 12 * 1024;  }
@900:
	.debug	< @900 @901
	.debug	# 4033
	ld	hl,0x2800
	ld	(_DiagLogSize),hl
	ld	de,0x3000
	ld	c,e
	ld	b,e
	ld	(__farheapsize),de
	ld	(__farheapsize+2),bc
@901:
	.debug	>
;4034   else  {
	jr	@902
@899:
;4035     DiagLogSize = 16 * 1024;  _farheapsize = 24 * 1024;  }
@903:
	.debug	< @903 @904
	.debug	# 4035
	ld	hl,0x4000
	ld	(_DiagLogSize),hl
	ld	de,0x6000
	ld	c,e
	ld	b,e
	ld	(__farheapsize),de
	ld	(__farheapsize+2),bc
@904:
	.debug	>
;4036 
;4037   diagLog = *_stdio;  // temporary (until syslog buffer is ready)
@902:
	.debug	# 4037
	ld	hl,(__stdio)
	ld	de,_diagLog
	push	hl
	ld	bc,12
	ldir
	pop	hl
;4038 
;4039 
;4040   timeZone = DEFAULT_TZ;  strcpy(hostName, "unknown");
	.debug	# 4040
	ld	hl,0xfffc
	ld	(_timeZone),hl
	ld	hl,@66+97
	push	hl
	ld	hl,_hostName
	push	hl
	call	_strcpy
	add	sp,4
;4041 
;4042 //--- get location and size of the memory segments that should not change -
;4043   codeStart = RootSegStart(CODE);    codeSize = RootSegSize(CODE);
	.debug	# 4043
ld bc,word (sgat CODE)
	ld	(_codeStart),bc
ld bc,word (sgsz CODE)
	ld	(_codeSize),bc
;4044   codeEnd = codeStart + codeSize - 1;
	.debug	# 4044
	ld	hl,(_codeStart)
	ld	d,b
	ld	e,c
	add	hl,de
	dec	hl
	ld	(_codeEnd),hl
;4045 
;4046   constStart = RootSegStart(CONST);  constSize = RootSegSize(CONST);
	.debug	# 4046
ld bc,word (sgat CONST)
	ld	(_constStart),bc
ld bc,word (sgsz CONST)
	ld	(_constSize),bc
;4047   constEnd = constStart + constSize - 1;
	.debug	# 4047
	ld	hl,(_constStart)
	ld	d,b
	ld	e,c
	add	hl,de
	dec	hl
	ld	(_constEnd),hl
;4048 
;4049   dataStart = RootSegStart(DATA);  dataSize = RootSegSize(DATA);
	.debug	# 4049
ld bc,word (sgat DATA)
	ld	(_dataStart),bc
ld bc,word (sgsz DATA)
	ld	(_dataSize),bc
;4050   dataEnd = dataStart + dataSize - 1;
	.debug	# 4050
	ld	hl,(_dataStart)
	ld	d,b
	ld	e,c
	add	hl,de
	dec	hl
	ld	(_dataEnd),hl
;4051 
;4052   bssStart = RootSegStart(BSS);  bssSize = RootSegSize(BSS);
	.debug	# 4052
ld bc,word (sgat BSS)
	ld	(_bssStart),bc
ld bc,word (sgsz BSS)
	ld	(_bssSize),bc
;4053   bssEnd = bssStart + bssSize - 1;
	.debug	# 4053
	ld	hl,(_bssStart)
	ld	d,b
	ld	e,c
	add	hl,de
	dec	hl
	ld	(_bssEnd),hl
;4054 
;4055   farCodeStart = SegStart(FARCODE);     farCodeSize = SegSize(FARCODE);
	.debug	# 4055
ld de,(sgat FARCODE) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgat FARCODE)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farCodeStart),de
	ld	(_farCodeStart+2),bc
ld de,(sgsz FARCODE) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgsz FARCODE)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farCodeSize),de
	ld	(_farCodeSize+2),bc
;4056   farCodeEnd = farCodeStart + farCodeSize - 1;
	.debug	# 4056
	ld	de,(_farCodeStart)
	ld	bc,(_farCodeStart+2)
	push	bc
	push	de
	ld	de,(_farCodeSize)
	ld	bc,(_farCodeSize+2)
	call	__ladd##
	call	__ldec##
	ld	(_farCodeEnd),de
	ld	(_farCodeEnd+2),bc
;4057 
;4058   farConstStart = SegStart(FARCONST);   farConstSize = SegSize(FARCONST);
	.debug	# 4058
ld de,(sgat FARCONST) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgat FARCONST)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farConstStart),de
	ld	(_farConstStart+2),bc
ld de,(sgsz FARCONST) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgsz FARCONST)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farConstSize),de
	ld	(_farConstSize+2),bc
;4059   farConstEnd = farConstStart + farConstSize - 1;
	.debug	# 4059
	ld	de,(_farConstStart)
	ld	bc,(_farConstStart+2)
	push	bc
	push	de
	ld	de,(_farConstSize)
	ld	bc,(_farConstSize+2)
	call	__ladd##
	call	__ldec##
	ld	(_farConstEnd),de
	ld	(_farConstEnd+2),bc
;4060 
;4061   farBSSStart = SegStart(FARBSS);   farBSSSize = SegSize(FARBSS);
	.debug	# 4061
ld de,(sgat FARBSS) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgat FARBSS)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farBSSStart),de
	ld	(_farBSSStart+2),bc
ld de,(sgsz FARBSS) >> 16
	ex	de,hl
	ld	(ix-4),hl
ld bc,word (sgsz FARBSS)
	ld	(ix-6),c
	ld	(ix-5),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	b,h
	ld	c,l
	call	__lor##
	ld	(_farBSSSize),de
	ld	(_farBSSSize+2),bc
;4062   farBSSEnd = farBSSStart + farBSSSize - 1;
	.debug	# 4062
	ld	de,(_farBSSStart)
	ld	bc,(_farBSSStart+2)
	push	bc
	push	de
	ld	de,(_farBSSSize)
	ld	bc,(_farBSSSize+2)
	call	__ladd##
	call	__ldec##
	ld	(_farBSSEnd),de
	ld	(_farBSSEnd+2),bc
;4063 
;4064 //--- Softools places the Internal (IIR) and External (EIR) vector tables -
;4065 //--- in contiguous memory, so we can treat it as one long table ---
;4066   intVectStart = (uint)_asm( [_A], "ld a,iir", _A ) << 8;
	.debug	# 4066
ld a,iir
	bool	hl
	ld	h,a
	ld	l,0
	ld	(_intVectStart),hl
;4067   intVectEnd = intVectStart + 512;
	.debug	# 4067
	ld	de,0x200
	add	hl,de
	ld	(_intVectEnd),hl
;4068 
;4069 
;4070 
;4071   initWaitQueues();  initSemaphores();
	.debug	# 4071
	lcall	$initWaitQueues
	lcall	$initSemaphores
;4072 
;4073 //  sem_init(&tcpLock, 1, 1);
;4074 
;4075 //--- Detect flash - also initializes lowest-level of flash driver ---
;4076   DetectFlash();
	.debug	# 4076
	lcall	$DetectFlash
;4077 
;4078 //--- bb_xalloc() does a one-time (permanant) allocation of memory from the
;4079 //--- end of memory normally managed by xalloc().  For RCM3200's, this ---
;4080 //--- provides a way to allocate blocks of memory in the upper (slower) 256
;4081 //--- that is battery-backed.  For BL2105's, all memory is battery-backed -
;4082 //--- so for them it doesn't really matter ---
;4083 
;4084   printf("\nFor CStart:\r\n");
	.debug	# 4084
	ld	de,word (phys @1+3548)
	ld	c,phys @1+3548 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4085   bb_xalloc(256);  // reserved space at end of RAM used by CStart (and/or R
	.debug	# 4085
	ld	de,0x100
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
;4086 
;4087   printf("For syslog:\r\n");
	.debug	# 4087
	ld	de,word (phys @1+3563)
	ld	c,phys @1+3563 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4088   diagLogBuf = bb_xalloc(DiagLogSize);
	.debug	# 4088
	ld	hl,(_DiagLogSize)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	(_diagLogBuf),de
	ld	(_diagLogBuf+2),bc
;4089 
;4090   printf("For DiagLogInfo:\r\n");
	.debug	# 4090
	ld	de,word (phys @1+3577)
	ld	c,phys @1+3577 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4091   diagLogInfo = (DiagLogInfo far *) bb_xalloc(sizeof(DiagLogInfo));
	.debug	# 4091
	ld	de,0xf9
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	(_diagLogInfo),de
	ld	(_diagLogInfo+2),bc
;4092 
;4093   if (!diagLogInfo OR !diagLogBuf)  {
	.debug	# 4093
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@905
	ld	de,(_diagLogBuf)
	ld	bc,(_diagLogBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@906
@905:
;4094     printf("\r\n***** Unable to alloc buffer for system log *****\r\n");
@907:
	.debug	< @907 @908
	.debug	# 4094
	ld	de,word (phys @1+3596)
	ld	c,phys @1+3596 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4095     REBOOT(true);
	.debug	# 4095
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
;4096   }
@908:
	.debug	>
;4097 
;4098   printf("For saving Application State:\r\n");
@906:
	.debug	# 4098
	ld	de,word (phys @1+3650)
	ld	c,phys @1+3650 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4099   stateDataBuf = bb_xalloc(ApplStateDataSize + sizeof(ApplStateDataHdr));
	.debug	# 4099
	ld	hl,(_ApplStateDataSize)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	(_stateDataBuf),de
	ld	(_stateDataBuf+2),bc
;4100 
;4101 
;4102   flushConsole();
	.debug	# 4102
	lcall	$flushConsole
;4103 
;4104   xmemAfterBB = xavail();
	.debug	# 4104
	lcall	$xavail
	ld	(_xmemAfterBB),de
	ld	(_xmemAfterBB+2),bc
;4105 
;4106 /*
;4107   The SHDesigns RDLM copies (or did - I think this may no longer be true of
;4108   the newer versions) ALL of regular RAM (the 1st 512K)  "down" by 0x6000 (
;4109   bytes as part of the sequence that loads the code from flash.  For boards
;4110   without fast RAM, this will include the buffer we used for the log.  For
;4111   boards with fast RAM, the log will be in the (slower) 256K battery-backed
;4112   RAM above the 512K mark, and is not moved during the "boot" process.
;4113 
;4114   Check for the case where the allocated memory is in the lower 512K that g
;4115   shifted 24K bytes by cstart.  If this case applies, then copy the memory
;4116   previously allocated by bb_xalloc() back to where it was.  NOTE:  Newer
;4117   version of RDLM seems to have eliminated this process, loading the code i
;4118   to the same place even in the cases where it previously moved it by 24K
;4119   after loading it in to RAM.
;4120 */
;4121   if (diagLogInfo->infoKey != LogInfoKey)  {
	.debug	# 4121
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	call	__farld4##
	push	bc
	push	de
	ld	de,0xedca
	ld	bc,0x531
	call	__ladd##
	jr	z,@909
;4122     prevInfo = (DiagLogInfo far *)((ulong)diagLogInfo - 0x6000L);
@910:
	.debug	< @910 @911
	.debug	# 4122
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	ld	b,0
	push	bc
	push	de
	ld	de,0xa000
	ld	bc,0xffff
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;4123     if (prevInfo->infoKey == LogInfoKey)  {
	.debug	# 4123
	call	__farld4##
	push	bc
	push	de
	ld	de,0xedca
	ld	bc,0x531
	call	__ladd##
	jr	nz,@912
;4124       fromPtr = (char far *)prevInfo;  toPtr = (char far *)diagLogInfo;
@913:
	.debug	< @913 @914
	.debug	# 4124
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;4125       len = prevInfo->bbCount;   //DiagLogSize + sizeof(DiagLogInfo);
	.debug	# 4125
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;4126       fmemcpy(toPtr, fromPtr, len);
	.debug	# 4126
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;4127     }
@914:
	.debug	>
;4128   }
@912:
@911:
	.debug	>
;4129 
;4130 
;4131 /*
;4132   When the RDLM loads the primary of backup boot image file, it saves some
;4133   info in the RUN_INFO struct (located at 0x7FF80-0x7FFFF).  One of these
;4134   values is a Key that indicates which boot image file (the primary or the
;4135   backup) was loaded.  DLM_RunKey() returns this value and sets it to 0, so
;4136   if it called more than once, the value will not be one of the special
;4137   values, which would indicate we somehow got here by some path other than
;4138   a restart that included the RDLM (re)loading one of the boot image files.
;4139 */
;4140   runKey = DLM_RunKey();
@909:
	.debug	# 4140
	lcall	$DLM_RunKey
	ld	(ix-8),hl
;4141 
;4142   runningPrimary = (runKey == UDPDNLD_MODE_RUN_PRIMARY);
	.debug	# 4142
	ld	de,0x3
	or	a,a
	sbc	hl,de
	ld	h,d
	ld	l,d
	jr	nz,@915
	inc	l
@915:
	ld	a,l
	ld	(_runningPrimary),a
;4143 
;4144 /*
;4145   If we don't have any indication that we got here on purpose (i.e. the DLM
;4146   and (re)loaded the OS from flash), then we need to force a reboot.  This
;4147   insures that all the static variables have the right starting values and 
;4148   copy of the code we are running is not corrupted.
;4149 */
;4150   if ((runKey != UDPDNLD_MODE_RUN_PRIMARY)
;4151       AND (runKey != UDPDNLD_MODE_RUN_BACKUP))  {
	.debug	# 4151
	ld	hl,(ix-8)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@917
	ld	hl,(ix-8)
	dec	e
	or	a,a
	sbc	hl,de
	jr	z,@917
;4152     printf("\r\n\n***** Restarted w/o RDLM - Forcing a reboot now *****\r\n
@918:
	.debug	< @918 @919
	.debug	# 4152
	ld	de,word (phys @1+3682)
	ld	c,phys @1+3682 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4153     flushConsole();
	.debug	# 4153
	lcall	$flushConsole
;4154     DLM_Reboot(UDPDNLD_MODE_RUN_OK);  runBackup = false;  REBOOT(true);
	.debug	# 4154
	ld	hl,0xffff
	push	hl
	lcall	$DLM_Reboot
	pop	de
	xor	a,a
	ld	(_runBackup),a
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
;4155   }
@919:
	.debug	>
;4156 
;4157 /*
;4158   Seems we got here via a true reboot (i.e. the RDLM reloaded the image fro
;4159   the flash file), so all static variables should be initialized and the CO
;4160   and CONST segments (near and far) should be intact.
;4161 */
;4162   printf("\r\n ===== Clean bootup verified =====\r\n\n");  flushConsole();
@917:
	.debug	# 4162
	ld	de,word (phys @1+3742)
	ld	c,phys @1+3742 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$flushConsole
;4163 
;4164 
;4165   fstrcpy(osName, "Davis Embedded Basic Real-time OS (DEBROS)");
	.debug	# 4165
	ld	de,word (phys @1+3782)
	ld	c,phys @1+3782 >> 16
	push	bc
	push	de
	ld	de,word (phys _osName)
	ld	c,phys _osName >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;4166 
;4167   sprintf(osDTM, "%s %s", __DATE__, __TIME__);
	.debug	# 4167
	ld	hl,@66+105
	push	hl
	ld	hl,@66+114
	push	hl
	ld	de,word (phys @1+3825)
	ld	c,phys @1+3825 >> 16
	push	bc
	push	de
	ld	de,word (phys _osDTM)
	ld	c,phys _osDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;4168 
;4169   printf("\r\n RTOS: %ls  %ls\r\n\n", osDTM, osName);  flushConsole();
	.debug	# 4169
	ld	de,word (phys _osName)
	ld	c,phys _osName >> 16
	push	bc
	push	de
	ld	de,word (phys _osDTM)
	ld	c,phys _osDTM >> 16
	push	bc
	push	de
	ld	de,word (phys @1+3831)
	ld	c,phys @1+3831 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
	lcall	$flushConsole
;4170 
;4171   WDT_2S();
	.debug	# 4171
  ld  a,0x5A
  ioi ld  (0x08),a
;4172 
;4173 
;4174 //--- Now we check to see if have a filled in DiagLogInfo struct from the -
;4175 //--- previous boot, and deal with any version differences. ---
;4176 #define  DLI  diagLogInfo
;4177 
;4178   do  {
;4179     restoredLog = false;
@923:
	.debug	< @923 @924
	.debug	# 4179
	xor	a,a
	ld	(_restoredLog),a
;4180     if (DLI->infoKey != LogInfoKey)  break;  // no data from last time?
	.debug	# 4180
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	call	__farld4##
	push	bc
	push	de
	ld	de,0xedca
	ld	bc,0x531
	call	__ladd##
	jp	nz,@921
;4181 
;4182   //--- If the log size is now smaller, it is better to loose some of the -
;4183   //--- data (and even risk repeating part of it) than to ignore it all. --
;4184     if (DLI->toIdx > DiagLogSize)  DLI->toIdx = DiagLogSize - 1;
	.debug	# 4184
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(_DiagLogSize)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@926
	jr	z,@926
	ld	h,d
	ld	l,e
	dec	hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
;4185     if (DLI->fromIdx > DiagLogSize)  DLI->fromIdx = DiagLogSize - 1;
@926:
	.debug	# 4185
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(_DiagLogSize)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@927
	jr	z,@927
	ld	h,d
	ld	l,e
	dec	hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
;4186 
;4187   //--- Check for a valid timezone value ---
;4188     if (!ValidTZ(DLI->tz))  DLI->tz = DEFAULT_TZ;
@927:
	.debug	# 4188
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6a
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x7ff4
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@929
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6a
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x800d
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@932
	jr	c,@932
@929:
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6a
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,0xfffc
	call	__farst2##
;4189 
;4190     downSecs = time(NULL) - DLI->seconds;
@932:
	.debug	# 4190
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
;4191 
;4192     if (DLI->didSoftReset AND (downSecs > 120))  {
	.debug	# 4192
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x74
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@934
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x78
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@934
	jr	z,@934
;4193       printf("*** Down for %lu seconds: Soft Reset ignored ***\r\n", downSe
@935:
	.debug	< @935 @936
	.debug	# 4193
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3852)
	ld	c,phys @1+3852 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;4194       DLI->didSoftReset = false;
	.debug	# 4194
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x74
	ld	c,d
	ld	b,d
	call	__ladd##
	xor	a,a
	call	__farst1##
;4195     }
@936:
	.debug	>
;4196 
;4197     restoredLog = true;
@934:
	.debug	# 4197
	ld	a,0x1
	ld	(_restoredLog),a
;4198   } while(0);
@924:
	.debug	>
	.debug	# 4198
;4199 
;4200 
;4201   if (restoredLog)  {
@921:
	.debug	# 4201
	ld	a,(_restoredLog)
	or	a,a
	jr	z,@937
;4202     prevLogInfo = *diagLogInfo;  // save a copy of the header data
@938:
	.debug	< @938 @939
	.debug	# 4202
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo)
	ld	c,phys _prevLogInfo >> 16
	ld	hl,249
	call	__farcopy##
	add	sp,4
;4203     timeZone = prevLogInfo.tz;
	.debug	# 4203
	ld	de,word (phys _prevLogInfo+106)
	ld	c,phys _prevLogInfo+106 >> 16
	call	__farld2##
	ld	(_timeZone),de
;4204   }
@939:
	.debug	>
;4205   else  {
	jr	@940
@937:
;4206     fmemset(diagLogInfo, 0, sizeof(DiagLogInfo));
@941:
	.debug	< @941 @942
	.debug	# 4206
	ld	de,0xf9
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;4207     fmemset(&prevLogInfo, 0, sizeof(DiagLogInfo));
	.debug	# 4207
	ld	de,0xf9
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,word (phys _prevLogInfo)
	ld	c,phys _prevLogInfo >> 16
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;4208     timeZone = DEFAULT_TZ;
	.debug	# 4208
	ld	hl,0xfffc
	ld	(_timeZone),hl
;4209   }
@942:
	.debug	>
;4210 
;4211 
;4212 //--- now we can init/update values based on the current vers of the struct
;4213   diagLogInfo->infoKey = LogInfoKey;
@940:
	.debug	# 4213
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x1236
	ld	bc,0xface
	call	__farst4d##
;4214   diagLogInfo->bbCount = bbAllocatedCount;
	.debug	# 4214
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_bbAllocatedCount)
	ld	bc,(_bbAllocatedCount+2)
	call	__farst4d##
;4215 
;4216   diagLogInfo->ctldShutdown = diagLogInfo->didSoftReset = false;
	.debug	# 4216
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x74
	ld	c,d
	ld	b,d
	call	__ladd##
	xor	a,a
	call	__farst1##
	ld	l,a
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0xd
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,l
	call	__farst1##
;4217 
;4218   FBZERO(diagLogInfo->filler1);
	.debug	# 4218
	ld	de,0x50
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x1a
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;4219   FBZERO(diagLogInfo->filler2);
	.debug	# 4219
	ld	de,0x74
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;4220 
;4221   diagLogInfo->rtosVers = rtosVersTime;
	.debug	# 4221
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x79
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_rtosVersTime)
	ld	bc,(_rtosVersTime+2)
	call	__farst4d##
;4222 
;4223   diagLogInfo->invInfoKey = ~LogInfoKey;
	.debug	# 4223
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x81
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,0xedc9
	ld	bc,0x531
	call	__farst4d##
;4224 
;4225   // hdwResetTime, rebootTime, and others are handled later...
;4226 
;4227 
;4228   ipset3();  // disable all normal interrupts (doesn't include the WDT)
	.debug	# 4228
	ipset	3
;4229 
;4230   if ((time(NULL) - prevLogInfo.seconds) > 60L)
	.debug	# 4230
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+16)
	ld	c,phys _prevLogInfo+16 >> 16
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@943
	jr	z,@943
;4231     prevLogInfo.didSoftReset = false;
	.debug	# 4231
	xor	a,a
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	call	__farst1##
;4232 
;4233 
;4234 //--- initialize hardware ---
;4235   digitalOut =
@943:
;4236     (prevLogInfo.didSoftReset ? prevLogInfo.digOutState : DigOutInitState);
	.debug	# 4236
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@944
	ld	de,word (phys _prevLogInfo+117)
	ld	c,phys _prevLogInfo+117 >> 16
	call	__farld4##
	jr	@945
@944:
	ld	de,(_DigOutInitState)
	ld	bc,(_DigOutInitState+2)
@945:
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;4237 
;4238   hdwInit(digitalOut);  flushConsole();
	.debug	# 4238
	push	bc
	push	de
	lcall	$hdwInit
	add	sp,4
	lcall	$flushConsole
;4239 
;4240 
;4241 //--- initialize I/O related state info ---
;4242   for (i=0; i<NumHdwADC; ++i)  adcForced[i] = false;
@946:
	.debug	< @946 @947
	.debug	# 4242
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@948:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@949
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	xor	a,a
	ld	(hl),a
;4243   for (i=0; i<NumHdwDAC; ++i)  dacForced[i] = false;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@948
@949:
@947:
	.debug	>
@951:
	.debug	< @951 @952
	.debug	# 4243
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@953:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@954
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	xor	a,a
	ld	(hl),a
;4244 
;4245 
;4246 //--- initialize basic kernel data structures ---
;4247   applTask = (task_t *)0;  // gets assigned to actual task later
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@953
@954:
@952:
	.debug	>
	.debug	# 4247
	bool	hl
	ld	l,h
	ld	(_applTask),hl
;4248 
;4249   kernelTask = current = tasks;  userPix = 0;
	.debug	# 4249
	ld	hl,_tasks
	ld	(_current),hl
	ld	(_kernelTask),hl
	bool	hl
	ld	l,h
	ld	(_userPix),hl
;4250 
;4251 
;4252   memset(tasks, 0, sizeof(task_t)*NUM_TASKS);
	.debug	# 4252
	ld	hl,0x1220
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_tasks
	push	hl
	call	_memset
	add	sp,6
;4253 
;4254   TrackApplLoop = TrackScheduler = TrackKernelLock = TrackTimerISR = 0;
	.debug	# 4254
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_TrackTimerISR),de
	ld	(_TrackTimerISR+2),bc
	ld	(_TrackKernelLock),de
	ld	(_TrackKernelLock+2),bc
	ld	(_TrackScheduler),de
	ld	(_TrackScheduler+2),bc
	ld	(_TrackApplLoop),de
	ld	(_TrackApplLoop+2),bc
;4255 
;4256   lastTaskIdx = 0;  klocks = 0;
	.debug	# 4256
	bool	hl
	ld	l,h
	ld	(_lastTaskIdx),hl
	ld	(_klocks),hl
;4257 
;4258   rebootMsg = doShutdown = doReboot = gotTime = false;  shutdownStarted = 0
	.debug	# 4258
	xor	a,a
	ld	(_gotTime),a
	ld	(_doReboot),a
	ld	(_doShutdown),a
	ld	(_rebootMsg),a
	ld	(_shutdownStarted),de
	ld	(_shutdownStarted+2),bc
;4259 
;4260 
;4261 //
;4262 ;
;4263 #asm
	.debug	# 4265
ld      a,0xD0

	.debug	# 4266
ioi ld  (0x13),a

	.debug	# 4269
bool    hl             

	.debug	# 4270
ld      l,h

	.debug	# 4271
add     hl,sp          

	.debug	# 4272
push    hl

	.debug	# 4273
pop     bc

	.debug	# 4275
ld      hl,_stackMarker##

	.debug	# 4276
ld      de,4

	.debug	# 4277
add     hl,de

	.seg	FARCODE
;4279 ;
;4280   stack_high = (char *)_BC;
	.debug	# 4280
	ld	(ix-40),c
	ld	(ix-39),b
;4281   stack_low = (char *)_HL; // skip over stack marker
	.debug	# 4281
	ld	(ix-38),hl
;4282 
;4283 //--- fill portion of stack not used yet with 0xff ---
;4284   stack_high -= LocalVarBytes;  // shouldn't that already be taken care of?
	.debug	# 4284
	ld	hl,(ix-40)
	ld	de,0xffc0
	add	hl,de
	ld	(ix-40),hl
;4285   memset(stack_low, 0xff, stack_high - stack_low);
	.debug	# 4285
	ex	de,hl
	ld	hl,(ix-38)
	ex	de,hl
	or	a,a
	sbc	hl,de
	push	hl
	ld	hl,0xff
	push	hl
	ld	h,d
	ld	l,e
	push	hl
	call	_memset
	add	sp,6
;4286   stack_high += LocalVarBytes;
	.debug	# 4286
	ld	hl,(ix-40)
	ld	de,0x40
	add	hl,de
	ld	(ix-40),hl
;4287 
;4288   tasks[0].stack_start = (uint *)stack_low;
	.debug	# 4288
	ld	hl,(ix-38)
	ld	(_tasks+2),hl
;4289   tasks[0].stack_size = stack_high - stack_low;
	.debug	# 4289
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_tasks+4),hl
;4290   tasks[0].stack = (uint *)stack_high;
	.debug	# 4290
	ld	hl,(ix-40)
	ld	(_tasks),hl
;4291 
;4292   tasks[0].sseg = ini(STACKSEG);
	.debug	# 4292
	ioi ld	a,(17)
	ld	(_tasks+6),a
;4293 
;4294 
;4295 //--- set values for this process ---
;4296   argv[0] = "[kernel]";  argv[1] = NULL;
	.debug	# 4296
	ld	hl,@66+130
	ld	(ix-36),hl
	bool	hl
	ld	l,h
	ld	(ix-34),hl
;4297 
;4298   copyArgs(tasks, 1, argv);
	.debug	# 4298
	ld	hl,-36+@888
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	hl,_tasks
	push	hl
	lcall	$copyArgs
	add	sp,6
;4299 
;4300   tasks[0].pid = 0;
	.debug	# 4300
	bool	hl
	ld	l,h
	ld	(_tasks+180),hl
;4301   tasks[0].ppid = -1;
	.debug	# 4301
	ld	hl,0xffff
	ld	(_tasks+182),hl
;4302   tasks[0].priority = 1;
	.debug	# 4302
	ld	a,0x1
	ld	(_tasks+184),a
;4303   tasks[0].claimed = true;
	.debug	# 4303
	ld	(_tasks+18),a
;4304 
;4305   tasks[0].outPtr = outBuf[0];
	.debug	# 4305
	ld	de,word (phys _outBuf)
	ld	c,phys _outBuf >> 16
	ld	(_tasks+216),de
	ld	(_tasks+218),bc
;4306   tasks[0].procMain = kernel;
	.debug	# 4306
	ld	hl,_kernel
	ld	(_tasks+178),hl
;4307   tasks[0].FDSet = (void far **) FD[0];
	.debug	# 4307
	ld	hl,_FD
	ld	(_tasks+15),hl
;4308 
;4309   tasks[0].started = readRTC(NULL);
	.debug	# 4309
	bool	hl
	ld	l,h
	push	hl
	lcall	$readRTC
	pop	hl
	ld	(_tasks+187),de
	ld	(_tasks+189),bc
;4310   tasks[0].resumedTicks = clockTicks();
	.debug	# 4310
	lcall	$clockTicks
	ld	(_tasks+203),de
	ld	(_tasks+205),bc
;4311 
;4312   init_waitqueue_head(&tasks[0].waitQs);
	.debug	# 4312
	ld	hl,_tasks+156
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;4313 
;4314   tasks[0].state = TASK_RUNNING;
	.debug	# 4314
	bool	hl
	ld	l,h
	ld	(_tasks+19),hl
;4315 
;4316   tasks[0].inUse = true;
	.debug	# 4316
	ld	a,0x1
	ld	(_tasks+170),a
;4317 
;4318   tasks[0].stkllr = 0xD0;  // stack limits:  0xD000 - 0xDF00
	.debug	# 4318
	ld	a,0xd0
	ld	(_tasks+7),a
;4319   tasks[0].stkhlr = 0xDF;
	.debug	# 4319
	ld	a,0xdf
	ld	(_tasks+8),a
;4320 
;4321 
;4322   rtosVersTime = compileTime(__DATE__, __TIME__);
	.debug	# 4322
	ld	hl,@66+105
	push	hl
	ld	hl,@66+114
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_rtosVersTime),de
	ld	(_rtosVersTime+2),bc
;4323 
;4324   devType = 0;
	.debug	# 4324
	bool	hl
	ld	l,h
	ld	(_devType),hl
;4325 
;4326 //--- initialize file system drivers ---
;4327   WDT_2S();  fcntlInit();  flushConsole();
	.debug	# 4327
  ld  a,0x5A
  ioi ld  (0x08),a
	lcall	$fcntlInit
	lcall	$flushConsole
;4328 
;4329 /*
;4330   If this was a soft reset, then save the hdwResetTime and set the seconds
;4331   and milliseconds since hdwReset so they pick up where left off. Otherwise
;4332   set hdwResetTime to the rebootTime and initialize the counters to 0.
;4333 
;4334   The rebootTime always indicates the time of the most recent restart, for
;4335   both soft and hard (CPU) resets.  NOTE that, if the RTC doesn't have a
;4336   valid value at startup (never set or power cycle w/o battery backup),
;4337   then the rebootTime and/or the hdwResetTime will be invalid.
;4338 
;4339   The newer versions of this code update these values whenever the RTC is
;4340   set, so any controller that has done a hard reset using the newer code
;4341   will have hdwResetTime and rebootTime values that are in sync with the
;4342   seconds value (they may ALL be wrong, but they will all be wrong by a
;4343   consistent amount: RTC - seconds).
;4344 
;4345   But older versions did NOT correct the rebootTime and/or hdwResetTime tim
;4346   when the RTC value was changed.  Because the seconds value has always
;4347   mirrored the RTC value, this means the the hdwResetTime and rebootTime
;4348   values might be based on different values than seconds is, which leaves
;4349   us with no way to determine if (and how much) the hdwResetTime and
;4350   rebootTime might be off.
;4351 
;4352   The best we can do is check for unreasonable values and try our best to
;4353   correct them based on the only bit of information we have, which is that
;4354   msTime should be the # of ms since the last hard reset.  But of course,
;4355   it only has a range of around 49 days, so there is no guarantee that usin
;4356   it will produce the correct result either.
;4357 
;4358   Out one saving grace is that most the application logic that tests for ho
;4359   much time has passed uses the millisecond counter rather than the second
;4360   counter, which at least reduces the risks of having an invalid seconds co
;4361 
;4362   IMPORTANT POINT:  The seconds value is always set from the RTC value, so 
;4363   is always in agreement with the RTC.  And since a soft reset cannot occur
;4364   unless power was maintained during the reboot, the current RTC value must
;4365   still be counting from the last value it had when the seconds value was
;4366   last updated (just prior to shutting down and restarting the OS).
;4367 */
;4368 
;4369 #define  TenYearSecs  315360000L
;4370 
;4371   curTime = time(NULL);
	.debug	# 4371
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;4372 
;4373   hdwResetTime = rebootTime = curTime;  // from real-time clock
	.debug	# 4373
	ld	(_rebootTime),de
	ld	(_rebootTime+2),bc
	ld	(_hdwResetTime),de
	ld	(_hdwResetTime+2),bc
;4374 
;4375   _TimerMilliSeconds[0] = _TimerMilliSeconds[1] = _TimerSeconds = 0;
	.debug	# 4375
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(__TimerSeconds),de
	ld	(__TimerSeconds+2),bc
	ld	(__TimerMilliSeconds+4),de
	ld	(__TimerMilliSeconds+6),bc
	ld	(__TimerMilliSeconds),de
	ld	(__TimerMilliSeconds+2),bc
;4376   milliTicks = 0;
	.debug	# 4376
	bool	hl
	ld	l,h
	ld	(_milliTicks),hl
;4377 
;4378   if (prevLogInfo.didSoftReset)  {
	.debug	# 4378
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jp	z,@956
;4379     _TimerMilliSeconds[1] = prevLogInfo.msTime + downSecs * 1000L;
@957:
	.debug	< @957 @958
	.debug	# 4379
	ld	de,word (phys _prevLogInfo+22)
	ld	c,phys _prevLogInfo+22 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ulmlt##
	call	__ladd##
	ld	(__TimerMilliSeconds+4),de
	ld	(__TimerMilliSeconds+6),bc
;4380 
;4381     hdwResetTime = prevLogInfo.hdwResetTime;
	.debug	# 4381
	ld	de,word (phys _prevLogInfo+108)
	ld	c,phys _prevLogInfo+108 >> 16
	call	__farld4##
	ld	(_hdwResetTime),de
	ld	(_hdwResetTime+2),bc
;4382     _TimerSeconds = curTime - hdwResetTime;
	.debug	# 4382
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	call	__lsub##
	ld	(__TimerSeconds),de
	ld	(__TimerSeconds+2),bc
;4383 
;4384     // In case the hdwResetTime and seconds values are from an older versio
;4385     // of code and are based on before and after RTC-was-set values
;4386 
;4387     if (_TimerSeconds > TenYearSecs)  {  // unlikely time since last hard r
	.debug	# 4387
	push	bc
	push	de
	ld	de,0x300
	ld	bc,0x12cc
	call	__lsub##
	jp	c,@959
	jp	z,@959
;4388       _TimerSeconds = prevLogInfo.seconds - prevLogInfo.rebootTime
@960:
	.debug	< @960 @961
;4389                     - prevLogInfo.hdwResetTime;
	.debug	# 4389
	ld	de,word (phys _prevLogInfo+16)
	ld	c,phys _prevLogInfo+16 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+112)
	ld	c,phys _prevLogInfo+112 >> 16
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+108)
	ld	c,phys _prevLogInfo+108 >> 16
	call	__farld4##
	call	__lsub##
	ld	(__TimerSeconds),de
	ld	(__TimerSeconds+2),bc
;4390 
;4391       if (_TimerSeconds > TenYearSecs)  // fallback: secs since prev reboot
	.debug	# 4391
	push	bc
	push	de
	ld	de,0x300
	ld	bc,0x12cc
	call	__lsub##
	jr	c,@962
	jr	z,@962
;4392         _TimerSeconds = _TimerMilliSeconds[1] / 1000;
	.debug	# 4392
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__uldiv##
	ld	(__TimerSeconds),de
	ld	(__TimerSeconds+2),bc
;4393 
;4394       hdwResetTime = curTime - _TimerSeconds;
@962:
	.debug	# 4394
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__lsub##
	ld	(_hdwResetTime),de
	ld	(_hdwResetTime+2),bc
;4395 
;4396       printf("\r\n"
;4397              "*** Invalid hdwResetTime: ***\r\n"
;4398              "  curTime: 0x%08lX   seconds: 0x%08lX  downSecs: %ld\r\n"
;4399              "  rebootTime: 0x%08lX   hdwResetTime: 0x%08lX  msTime: 0x%08l
;4400              "  Corrected hdwResetTime: 0x%08lX\r\n\n",
;4401              curTime, prevLogInfo.seconds, downSecs,
;4402              prevLogInfo.rebootTime,  prevLogInfo.hdwResetTime,
;4403              prevLogInfo.msTime, hdwResetTime);
	.debug	# 4403
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+22)
	ld	c,phys _prevLogInfo+22 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+108)
	ld	c,phys _prevLogInfo+108 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+112)
	ld	c,phys _prevLogInfo+112 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys _prevLogInfo+16)
	ld	c,phys _prevLogInfo+16 >> 16
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3903)
	ld	c,phys @1+3903 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,32
;4404 
;4405       flushConsole();
	.debug	# 4405
	lcall	$flushConsole
;4406     }
@961:
	.debug	>
;4407 
;4408   }
@959:
@958:
	.debug	>
;4409 
;4410   diagLogInfo->rebootTime = rebootTime;
@956:
	.debug	# 4410
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x70
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_rebootTime)
	ld	bc,(_rebootTime+2)
	call	__farst4d##
;4411   diagLogInfo->hdwResetTime = hdwResetTime;
	.debug	# 4411
	ld	de,(_diagLogInfo)
	ld	bc,(_diagLogInfo+2)
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	call	__farst4d##
;4412 
;4413 
;4414   checkWDT = false;  //  Don't check for imminent WatchDog timer reboot yet
	.debug	# 4414
	xor	a,a
	ld	(_checkWDT),a
;4415 
;4416 //--- start periodic timer ---
;4417   select_timer(1000, 1);  // calls sched_tick() every SchedMS ms; use IP 1
	.debug	# 4417
	ld	hl,0x1
	push	hl
	ld	de,0x3e8
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$select_timer
	add	sp,6
;4418 
;4419 //  startTimer(1000, timer_interrupt, 1);
;4420 
;4421   kernel(1, argv);  // doesn't return
	.debug	# 4421
	ld	hl,-36+@888
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$kernel
	add	sp,4
;4422 }
@889:
	.debug	} @889 4422

@888	equ	40
	ld	sp,ix
	pop	ix
	lret
@890	equ	42
;4423 
;4424 
;4425 //-------------------------------------------------------------------------
;4426 
;4427 
	.extern	$time 89
	.extern	_memcpy 90
	.extern	_memset 91
	.extern	_strcmp 92
	.extern	_strcpy 93
	.extern	_strlen 94
	.extern	$fmemcpy 95
	.extern	_fmemset 97
	.extern	_fstrcpy 98
	.extern	$clockTicks 99
	.extern	$dateTimeMS 100
	.extern	$memCRC16 101
	.extern	$compileTime 102
	.extern	$init_waitqueue_head 103
	.extern	$__removeWaitQueue 104
	.extern	$prepare_to_wait 105
	.extern	$finish_wait 106
	.extern	$initWaitQueues 37
	.extern	$alloc_WaitQueueNode 107
	.extern	$free_WaitQueueNode 108
	.extern	$removeFromQueues 109
	.extern	__disabled 3
	.extern	__pending 3
	.extern	_schedCalls 7
	.extern	_taskSwitches 7
	.extern	_tasks 110
	.extern	_current 41
	.extern	_userPix 6
	.extern	_endTasks 41
	.extern	_idleTask 41
	.extern	_applTask 41
	.extern	_kernelTask 41
	.extern	_newTaskDiagFlags 9
	.extern	_SchedMS 7
	.extern	$init_tasks 55
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 37
	.extern	$reset_task 53
	.extern	$check_stack 53
	.extern	__stdio 111
	.extern	$fassign 113
	.extern	$farfprintf 114
	.extern	$farprintf 115
	.extern	$farsprintf 116
	.extern	_idBlock 117
	.extern	$DetectFlash 55
	.extern	_resetCode 3
	.extern	$readRTC 119
	.extern	$writeRTC 120
	.extern	$setInterruptHandler 121
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 122
	.extern	_SerialGetcA 55
	.extern	$xalloc 123
	.extern	$xavail 99
	.extern	$srand 124
	.extern	_ramSize 9
	.extern	_adcForced 125
	.extern	_dacForced 125
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.extern	_IntVectDesc 126
	.extern	_digitalOut 9
	.extern	$WriteDigOutputs 120
	.extern	$ReadDeviceID 99
	.extern	$hdwInit 120
	.extern	$hdwInit2 37
	.extern	$netHdwInit 37
	.extern	_FD 127
	.extern	_diagLogInfo 87
	.extern	_DiagLogSize 7
	.extern	_diagLogBuf 34
	.extern	_logDateTime 3
	.extern	_noGettyOnA 3
	.extern	$fcntlInit 37
	.extern	$fileSysTick 37
	.extern	$_closeFD_ 129
_rcvChar:
	pop	iy
	lcall	$$rcvChar
	.extern	$$rcvChar
	.extern	$rcvChar 71
_xmitChar:
	pop	iy
	lcall	$$xmitChar
	.extern	$$xmitChar
	.extern	$xmitChar 130
	.extern	$openCrashLog 37
	.extern	$closeCrashLog 37
_diagIn:
	pop	iy
	lcall	$$diagIn
	.extern	$$diagIn
	.extern	$diagIn 71
_diagOut:
	pop	iy
	lcall	$$diagOut
	.extern	$$diagOut
	.extern	$diagOut 130
	.extern	$fflush 131
	.defseg	FARBSS
	.seg	FARBSS
_outBuf::
	.ds	2560
	.debug	G _outBuf 132 8
	.bseg
_schedCallsPrevSec::
	.ds	2
	.debug	G _schedCallsPrevSec 7 0
_taskSwPrevSec::
	.ds	2
	.debug	G _taskSwPrevSec 7 0
_hostName::
	.ds	32
	.debug	G _hostName 73 0
_checkWDT::
	.ds	1
	.debug	G _checkWDT 3 0
	.seg	FARBSS
_osName::
	.ds	64
	.debug	G _osName 85 8
_osDTM::
	.ds	32
	.debug	G _osDTM 73 8
_prevLogInfo::
	.ds	249
	.debug	G _prevLogInfo 88 8
	.bseg
_klocks::
	.ds	2
	.debug	G _klocks 6 0
_gotTime::
	.ds	1
	.debug	G _gotTime 3 0
_runBackup::
	.ds	1
	.debug	G _runBackup 3 0
_runningPrimary::
	.ds	1
	.debug	G _runningPrimary 3 0
_doReboot::
	.ds	1
	.debug	G _doReboot 3 0
_doShutdown::
	.ds	1
	.debug	G _doShutdown 3 0
_useSoftReset::
	.ds	1
	.debug	G _useSoftReset 3 0
_applicActive::
	.ds	1
	.debug	G _applicActive 3 0
_taskIO::
	.ds	12
	.debug	G _taskIO 112 0
_diagLog::
	.ds	12
	.debug	G _diagLog 112 0
_milliTicks::
	.ds	2
	.debug	G _milliTicks 7 0
_hdwResetTime::
	.ds	4
	.debug	G _hdwResetTime 9 0
_rebootTime::
	.ds	4
	.debug	G _rebootTime 9 0
_applicTicks::
	.ds	2
	.debug	G _applicTicks 7 0
_deviceID::
	.ds	4
	.debug	G _deviceID 9 0
_devType::
	.ds	2
	.debug	G _devType 7 0
_hdwType::
	.ds	2
	.debug	G _hdwType 7 0
_percentIdle::
	.ds	2
	.debug	G _percentIdle 7 0
_timeZone::
	.ds	2
	.debug	G _timeZone 6 0
_moduleID::
	.ds	8
	.debug	G _moduleID 134 0
__farheapsize::
	.ds	4
	.debug	G __farheapsize 9 0
_codeStart::
	.ds	2
	.debug	G _codeStart 7 0
_codeSize::
	.ds	2
	.debug	G _codeSize 7 0
_codeEnd::
	.ds	2
	.debug	G _codeEnd 7 0
_constStart::
	.ds	2
	.debug	G _constStart 7 0
_constSize::
	.ds	2
	.debug	G _constSize 7 0
_constEnd::
	.ds	2
	.debug	G _constEnd 7 0
_dataStart::
	.ds	2
	.debug	G _dataStart 7 0
_dataSize::
	.ds	2
	.debug	G _dataSize 7 0
_dataEnd::
	.ds	2
	.debug	G _dataEnd 7 0
_bssStart::
	.ds	2
	.debug	G _bssStart 7 0
_bssSize::
	.ds	2
	.debug	G _bssSize 7 0
_bssEnd::
	.ds	2
	.debug	G _bssEnd 7 0
_farCodeStart::
	.ds	4
	.debug	G _farCodeStart 9 0
_farCodeSize::
	.ds	4
	.debug	G _farCodeSize 9 0
_farCodeEnd::
	.ds	4
	.debug	G _farCodeEnd 9 0
_farConstStart::
	.ds	4
	.debug	G _farConstStart 9 0
_farConstSize::
	.ds	4
	.debug	G _farConstSize 9 0
_farConstEnd::
	.ds	4
	.debug	G _farConstEnd 9 0
_farBSSStart::
	.ds	4
	.debug	G _farBSSStart 9 0
_farBSSSize::
	.ds	4
	.debug	G _farBSSSize 9 0
_farBSSEnd::
	.ds	4
	.debug	G _farBSSEnd 9 0
_codeCRC::
	.ds	2
	.debug	G _codeCRC 7 0
_constCRC::
	.ds	2
	.debug	G _constCRC 7 0
_farCodeCRC::
	.ds	2
	.debug	G _farCodeCRC 7 0
_farConstCRC::
	.ds	2
	.debug	G _farConstCRC 7 0
_intVectStart::
	.ds	2
	.debug	G _intVectStart 7 0
_intVectEnd::
	.ds	2
	.debug	G _intVectEnd 7 0
_roStart::
	.ds	2
	.debug	G _roStart 7 0
_roEnd::
	.ds	2
	.debug	G _roEnd 7 0
_wpStart::
	.ds	2
	.debug	G _wpStart 7 0
_wpEnd::
	.ds	2
	.debug	G _wpEnd 7 0
_roStartFar::
	.ds	4
	.debug	G _roStartFar 9 0
_roEndFar::
	.ds	4
	.debug	G _roEndFar 9 0
_wpStartFar::
	.ds	4
	.debug	G _wpStartFar 9 0
_wpEndFar::
	.ds	4
	.debug	G _wpEndFar 9 0
_wpSegMask::
	.ds	2
	.debug	G _wpSegMask 7 0
_wpRootMask::
	.ds	2
	.debug	G _wpRootMask 7 0
_cpuID::
	.ds	1
	.debug	G _cpuID 3 0
_cpuRev::
	.ds	1
	.debug	G _cpuRev 3 0
	.extern	__xmemEnd 9
	.extern	__xmemHeap 9
	.extern	$bb_xalloc 123
_bbAllocatedCount::
	.ds	4
	.debug	G _bbAllocatedCount 9 0
	.extern	_tcp_lock 135
	.extern	_tcp_unlock 135
	.extern	$sock_init 55
	.extern	$_tcp_tick_internal 71
	.extern	$sethostname 136
	.extern	$getIFConfig 137
	.extern	$startNetDown 53
	.extern	$chgIPAddr 138
	.extern	$numOpenSockets 55
	.extern	$loadAllParamsMsg 55
	.extern	$resetAnnounceInterval 37
	.extern	$initConsole 37
	.extern	$flushConsole 37
	.extern	$DLM_Init 94
	.extern	$DLM_Reboot 53
	.extern	$DLM_RunKey 55
	.extern	$ffile_setName 94
	.extern	_applName 125
	.extern	_applDTM 125
	.extern	_DigOutInitState 9
	.extern	_lastReadTime 7
	.extern	_kernelLoopTime 5
	.extern	_stateDataBuf 96
	.extern	_ApplStateDataSize 7
	.extern	_allowSoftReset 3
	.extern	$saveApplState 55
	.cseg
_applic:
	pop	iy
	lcall	$$applic
	.extern	$$applic
	.extern	$applic 51
	.extern	$setApplDTM 37
	.extern	__TimerBISR 37
	.extern	$select_timer 139
	.extern	$initSemaphores 37
	.extern	_rtosVersTime 9
	.extern	$logAllocation 140
	.defseg	XMEMSTART
	.seg	XMEMSTART
_xmemplaceholder::
	.ds	2
	.debug	G _xmemplaceholder 141 8
	.bseg
_xmemAtStartup::
	.ds	4
	.debug	G _xmemAtStartup 9 0
_xmemAfterBB::
	.ds	4
	.debug	G _xmemAfterBB 9 0
_countersUpdated::
	.ds	2
	.debug	G _countersUpdated 7 0
_kernelLastCalled::
	.ds	4
	.debug	G _kernelLastCalled 9 0
_applicLastCalled::
	.ds	4
	.debug	G _applicLastCalled 9 0
_lastTaskIdx:
	.ds	2
	.debug	F _lastTaskIdx 6 0
_lastDeviceID:
	.ds	4
	.debug	F _lastDeviceID 9 0
_origIO::
	.ds	2
	.debug	G _origIO 111 0
_shutdownStarted::
	.ds	4
	.debug	G _shutdownStarted 9 0
_ii::
	.ds	2
	.debug	G _ii 6 0
_recursiveDump::
	.ds	1
	.debug	G _recursiveDump 3 0
_attemptRestore::
	.ds	1
	.debug	G _attemptRestore 3 0
_rebootMsg::
	.ds	1
	.debug	G _rebootMsg 3 0
_memCorrupted::
	.ds	1
	.debug	G _memCorrupted 3 0
_restoredLog::
	.ds	1
	.debug	G _restoredLog 3 0
_doCleanShutdown::
	.ds	1
	.debug	G _doCleanShutdown 3 0
_lastTimeZone::
	.ds	2
	.debug	G _lastTimeZone 6 0
_copyGCSR::
	.ds	2
	.debug	G _copyGCSR 6 0
__farheap::
	.ds	4
	.debug	G __farheap 34 0
_sockStat::
	.ds	2
	.debug	G _sockStat 6 0
_sp_::
	.ds	2
	.debug	G _sp_ 40 0
	.cseg
_idle:
	pop	iy
	lcall	$$idle
	.extern	_tcpTickTime 5
_kernel:
	pop	iy
	lcall	$$kernel
	.debug	T	09000120004F0003004F00
	.debug	T	0900012100100022000400
	.debug	T	070008220004000300
	.debug	T	280003230004000100125F5F776169745F71756575655F68656164
	.debug	T	0052000000096C6973744865616400
	.debug	T	0B000224000100010022000000
	.debug	T	0B000225000100010001000000
	.debug	T	0B000226000100010003000000
	.debug	T	0B000227000100280006000000
	.debug	T	070000280002000300
	.debug	T	070000290002002A00
	.debug	T	7702032A00E8002D000C7461736B5F737472756374004E00000006
	.debug	T	737461636B004E0002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872008E000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465002900150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630030001A0005617267760085001C0005617267
	.debug	T	730023009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773003200B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002200D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0700002B0002000100
	.debug	T	0700082C0004002D00
	.debug	T	0B01032D00270013000100060000000A6F70656E436F756E74008F
	.debug	T	00020008696F46756E6373002B00040006696F446576009100
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	BB00032E002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	1300022F0003000600290000000600020030000400
	.debug	T	070000300002002800
	.debug	T	230002310007000600320000000300020006000400300006000600
	.debug	T	080006000A0006000C00
	.debug	T	070000320002003300
	.debug	T	0F00023300020001000600000030000200
	.debug	T	070000340002002C00
	.debug	T	0B000235000100060006000000
	.debug	T	0B000236000100070001000000
	.debug	T	0B000237000100060001000000
	.debug	T	0B000238000100010029000000
	.debug	T	0B000239000100010006000000
	.debug	T	0F00023A00020006002800000006000200
	.debug	T	0F00023B00020006000600000006000200
	.debug	T	1300023C0003000600060000003D00020006000400
	.debug	T	0700003D0002000600
	.debug	T	1300023E0003000600060000000600020006000400
	.debug	T	0B00023F000100060040000000
	.debug	T	070000400002000900
	.debug	T	0F0002410002000600420000002B000200
	.debug	T	070000420002004300
	.debug	T	2900034300080002000874696D6576616C00090000000774765F73
	.debug	T	656300080004000874765F7573656300
	.debug	T	0B000244000100090009000000
	.debug	T	070000450002004600
	.debug	T	710003460012000700125F5F776169745F71756575655F6E6F6465
	.debug	T	000700000006666C6167730029000200057461736B002B0004
	.debug	T	00046F626A00920006000B72656D6F766546756E6300520008
	.debug	T	00097461736B4C6973740052000C000A71756575654C697374
	.debug	T	002B001000076D794164647200
	.debug	T	0B00024700010006002B000000
	.debug	T	0900014800100003001000
	.debug	T	0900014900200003002000
	.debug	T	0B00024A000100030009000000
	.debug	T	1700024B000400010009000000090004000700080028000A00
	.debug	T	0F00024C00020001002800000028000200
	.debug	T	2300024D0007000100030000000300020022000400090008000900
	.debug	T	0C00090010004E001400
	.debug	T	0700004E0002000700
	.debug	T	0F00024F00020001000300000003000200
	.debug	T	130002500003000100090000000700040009000600
	.debug	T	070000510002005200
	.debug	T	2600035200040002000A6C6973745F686561640051000000056E65
	.debug	T	78740051000200057072657600
	.debug	T	5C0003530019000700010009000000076970416464720009000400
	.debug	T	076263416464720009000800086E65746D61736B0009000C00
	.debug	T	08676174657761790093001000086D61634164647200070016
	.debug	T	00046D7475000300180006737461746500
	.debug	T	0900015400040028000200
	.debug	T	0900015500400003004000
	.debug	T	0B000256000100060009000000
	.debug	T	070008570004005800
	.debug	T	2701035800F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D650094001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900950085000866696C6C65723200
	.debug	T	0B000259000100090040000000
	.debug	T	1300025A0003002B002B0000002B00020007000400
	.debug	T	1300025B0003002B002B0000000600020007000400
	.debug	T	0F00025C00020006002800000028000200
	.debug	T	0F00025D00020028002800000028000200
	.debug	T	0B00025E000100060028000000
	.debug	T	1300025F0003006000600000006000040009000800
	.debug	T	070008600004000100
	.debug	T	130002610003006000600000000600040009000600
	.debug	T	0F00026200020001002200000022000400
	.debug	T	0B000263000100090001000000
	.debug	T	130002640003002800280000000900020007000600
	.debug	T	0F00026500020007000900000009000400
	.debug	T	0F00026600020009002800000028000200
	.debug	T	0B000267000100010096000000
	.debug	T	0F00026800020006009600000045000200
	.debug	T	130002690003000100960000004500020006000400
	.debug	T	0F00026A00020001009600000045000200
	.debug	T	0B00026B000100450001000000
	.debug	T	0B00026C000100010045000000
	.debug	T	0F00026D00020001002900000003000200
	.debug	T	0900016E0000002A000000
	.debug	T	0700006F0002007000
	.debug	T	54000370000C000600010097000000065F5F6F7574009800020005
	.debug	T	5F5F696E0099000400085F5F77726974650099000600075F5F
	.debug	T	726561640006000800085F5F756E676574002B000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	1300027100030001006F0000009800020097000400
	.debug	T	1300027200030006006F000000220002000D000000
	.debug	T	0F0002730002000600220000000D000000
	.debug	T	13000274000300060022000000220004000D000000
	.debug	T	0900017500270076000100
	.debug	T	7B0003760027000800010009000000066D6167696300030004000A
	.debug	T	626C6F636B53697A6500050005000B696E436865636B73756D
	.debug	T	00030007000E76657273696F6E4E756D626572000300080009
	.debug	T	76656E646F72494400050009000A70726F647563744944009B
	.debug	T	000B00086D616341646472009C00170006666C61736800
	.debug	T	0B00027700010009004E000000
	.debug	T	0B000278000100010009000000
	.debug	T	0F00027900020001009E00000087000200
	.debug	T	0900017A00080009000200
	.debug	T	0B00027B000100220009000000
	.debug	T	0B00027C000100010007000000
	.debug	T	0900017D00000003000000
	.debug	T	0900017E00780022001E00
	.debug	T	0900017F00000580001400
	.debug	T	090001800040002C001000
	.debug	T	0F00028100020006002900000006000200
	.debug	T	0F0002820002000600030000002B000200
	.debug	T	0B00028300010006006F000000
	.debug	T	0900018400000A85001400
	.debug	T	0900018500800003008000
	.debug	T	0900018600080003000800
	.debug	T	070000870002002500
	.debug	T	0B000288000100280028000000
	.debug	T	0F0002890002000600060000009F000200
	.debug	T	0F00028A00020001000600000009000200
	.debug	T	0F00028B00020006000900000003000400
	.debug	T	0F00028C00020001000900000009000400
	.debug	T	0900018D00020003000200
	.debug	T	0700008E0002006000
	.debug	T	0700008F0002009000
	.debug	T	6400039000100008000100A0000000057265616400A00002000677
	.debug	T	72697465009800040006636C6F736500A2000600066C736565
	.debug	T	6B00A400080006667374617400A6000A0006696F63746C00A8
	.debug	T	000C0006646573637200AA000E000A67657451756575657300
	.debug	T	2800039100040002000100960000000A7265616451756575650096
	.debug	T	0002000B7772697465517565756500
	.debug	T	070000920002006C00
	.debug	T	0900019300060003000600
	.debug	T	0900019400500003005000
	.debug	T	0900019500740003007400
	.debug	T	070000960002002300
	.debug	T	070000970002008200
	.debug	T	070000980002004700
	.debug	T	070000990002009A00
	.debug	T	1300029A000300080022000000080004002B000800
	.debug	T	0900019B000C0093000200
	.debug	T	0900019C0010009D000200
	.debug	T	4400039D000800040001000500000008666C617368494400050002
	.debug	T	000A666C6173685479706500050004000A666C61736853697A
	.debug	T	6500050006000B6E756D536563746F727300
	.debug	T	EC01099E0001001F00010000000A494E545F54494D45520001000D
	.debug	T	494E545F4E4F545F555345440002000A494E545F5253543130
	.debug	T	0003000A494E545F52535431380004000A494E545F52535432
	.debug	T	300005000A494E545F52535432380006000E494E545F4E4F54
	.debug	T	5F55534544320007000A494E545F52535433380008000F494E
	.debug	T	545F534C4156455F504F52540009000E494E545F4E4F545F55
	.debug	T	53454433000A000C494E545F54494D45525F41000B000C494E
	.debug	T	545F54494D45525F42000C000D494E545F53455249414C5F41
	.debug	T	000D000D494E545F53455249414C5F42000E000D494E545F53
	.debug	T	455249414C5F43000F000D494E545F53455249414C5F440010
	.debug	T	0009494E545F494E543000110009494E545F494E5431001200
	.debug	T	0E494E545F4E4F545F55534544340013000E494E545F4E4F54
	.debug	T	5F55534544350014000E494E545F4E4F545F55534544360015
	.debug	T	000E494E545F4E4F545F55534544370016000E494E545F4E4F
	.debug	T	545F55534544380017000E494E545F4E4F545F555345443900
	.debug	T	18000F494E545F4E4F545F55534544313000190011494E545F
	.debug	T	515541445F4445434F444552001A000E494E545F494E505554
	.debug	T	5F434150001B000F494E545F4E4F545F555345443131001C00
	.debug	T	0D494E545F53455249414C5F45001D000D494E545F53455249
	.debug	T	414C5F46001E0009494E545F4C41535400
	.debug	T	0700009F0002005300
	.debug	T	070000A0000200A100
	.debug	T	170002A100040006002B000000280002000600040003000600
	.debug	T	070000A2000200A300
	.debug	T	130002A300030009002B0000000900020006000600
	.debug	T	070000A4000200A500
	.debug	T	0F0002A500020006002B000000AC000200
	.debug	T	070000A6000200A700
	.debug	T	130002A700030006002B000000060002002B000400
	.debug	T	070000A8000200A900
	.debug	T	130002A900030028002B0000002800020006000400
	.debug	T	070000AA000200AB00
	.debug	T	0F0002AB00020006002B000000AD000200
	.debug	T	070000AC0002002E00
	.debug	T	070008AD0004009100
	.seg	CONST
@66:
	.db	"Dead    ",0,"Ready   ",0,"Schedule",0,"Sleeping",0,"Blocked*",0,"Blocked ",0,"Stopped ",0,"tsh",0,"(?)",0,"OK",0,"*BAD*",0,"NOT ",0
	.db	"idle",0,"applic",0,"unknown",0,"16:38:38",0,"Fri Jan 11 2013",0,"[kernel]",0
	.seg	FARCONST
@1:
	.db	"Jump to 0?",0,"Watchdog Timer",0,"N/A",0,"Hdw Reset or Power Cycled",0,"***** %ls called without KLOC"
	.db	"K()!!! *****",13,10,0,"*** Unbalanced KUNLOCK() !!! ***",10,0,10,"----- shutdown, run DLM ---",10,10,0,10,"----"
	.db	"- reboot and run Backup -----",10,10,0,10,"----- reboot and run Primary -----",10,10,0,10,"***** Restarti"
	.db	"ng w/o CPU reset *****",10,10,10,0,"Soft Reset disabled - doing normal reset",13,10,0,10,"For PseduoReset"
	.db	" func:",13,10,0,"Unable to perform softReset(), so doing normal reboot",13,10,0,"Argument list too lo"
	.db	"ng",13,10,0,13,10,"Unable to create process for: %.20s",13,10,0,"Created process #%d (",0," %s",0," )",10,0,"killing pr"
	.db	"ocess %.20s[%d]",13,10,0,"exiting with status: %d, %d stack free",10,0,"***** !!! overflowed its st"
	.db	"ack !!! *****",10,0,"blocking on %.20s[%d]",10,0,"unblocked",10,0,13,10,"IIR: %02X,  EIR: %02X",13,10,0,"_TimerBISR"
	.db	": %04X",13,10,0,"*** INT %02X changed to: %04X ***",10,0,13,10,13,10,"---------- Post Mortem dump ---------"
	.db	"-",13,10,"%s %.24s[%d]: ",0,"  Core Module ID: %.6s",13,10,10," *** %.128ls ***",13,10,10,"  RTOS: %.40ls",13,10,"  APPL"
	.db	": %.40ls  %.40ls",13,10,10,"  kernel lock level: %d",13,10,10,"  Age of resetWDT() calls:  kernel: %ld"
	.db	"ms  applic: %ldms  any: %u",13,10,10,0,"                                    ---------Stack-----"
	.db	"---- ",13,10,"  PID  PRI  STATUS            IDLE  Start  End   SP  Unused  --PC--  --IP---  "
	.db	"CMD",13,10,0,"%5d  %3d  %s%2d  %8lums  %05lX %05lX %05lX  %4d  %06lX  %X-%X-%X-%X  %.64s",13,10,0," S"
	.db	"tack: ",0,"%05lX (%04X): ",0,"%02X ",0,13,10,"        ",0,"doCleanShutdown:%d  useSoftReset:%d  allowSoft"
	.db	"Reset:%d",13,10,0,13,10,"***** WatchDog Timer reboot imminent! *****",13,10,0,"WatchDog Timeout",0,"  ?????",0," "
	.db	" %05lX",0," called from %05lX [%04X] %s",13,10,0,13,10,"*** Interrupt 0x%02X occured at ",0,"%05X",0,"??:%04X"
	.db	0," ***",13,10,0,13,10,13,10,"%s %.24s[%d]:",13,10," ***** %ls fault occured at: 0x%05lX *****",13,10,10,"Interrupt Ve"
	.db	"ctor: 0x%04X",13,10,10,0,"Code preceeding fault:",13,10,"  %06lX: ",0,"Registers:",13,10,"  AF: %04X  AF': %04X "
	.db	"   IX: %04X    IP:  %02X",13,10,"  HL: %04X  HL': %04X    IY: %04X    IIR: %02X",13,10,"  DE: %04X"
	.db	"  DE': %04X    SP: %04X    EIR: %02X",13,10,"  BC: %04X  BC': %04X    PC: %04X    XPC: %02X",13
	.db	10,10,0,"Stack:",0,13,10,"  %05lX (%04X): ",0,"...",13,10,0,13,10,10,"Stack Trace:",13,10,"  %ls fault occured at: %05lX",13,10,0,"U"
	.db	"nhandled Interrupt error",13,10,0,"Unhandled Interrupt",0,"Write Protection error",13,10,0,"Write Protect"
	.db	"ion",0,"User/Sys Mode Violation",0,"Stack Limit error",13,10,0,"Stack Limit",0,"%ls  %05lX  %05lX  ",0,"%04X "
	.db	"%s",13,10,0,"***** %ls failed CRC test *****",13,10,0,13,10,10,"Segment   Start  End    CRC  ",13,10,"--------  --"
	.db	"---  -----  ---- ",13,10,0,"CODE    ",0,"CONST   ",0,"DATA    ",0,"%ls  %05X  %05X  ----",13,10,0,"BSS     ",0,"STACK"
	.db	"   ",0,"FARCODE ",0,"FARCONST",0,"FARBSS  ",0,"%ls  %05lX  %05lX  ----",13,10,0," IIR: 0x%02X,  EIR: 0x%02X",13,10
	.db	0," _TimerBISR: 0x%04X",13,10,10,0," %04X: ",0,"%ls",13,10,0,"  %05lX-",0,"64K protections for all tasks:",13,10,0,"4K pr"
	.db	"otections by task:                       STKxLR",13,10,0,"  %2d:",0,"   %02X-%02X",13,10,0,"deviceID chan"
	.db	"ged: from:[%04lX]  to:[%04lX]",13,10,0,"----- starting shutdown ----",13,10,10,0,"bye bye...",13,10,10,10,10,0,"bad t"
	.db	"ask in sleepQueue: %d/%d",13,10,0,13,10,"kernel process started",13,10,0,"%02X%02X%02X",0,13,10,"----- Starting n"
	.db	"ew log -----",13,10,0,13,10,"***** Restored previous log *****",13,10,10,"Module %s was last running at: %"
	.db	"s",13,10,10,"This reboot was %sexpected",13,10,10,0,"***** Segment order or alignment not correct *****",13
	.db	10,"Must be as follows:",13,10,"  CODE, CONST, DATA, BSS, FARCODE, FARCONST, FARBSS, XMEMSTART"
	.db	13,10,"  with FARCODE and FARBSS using an alignment of 0x1000",13,10,0,"%ls",13,10," RTOS: %.40ls  %.40l"
	.db	"s",13,10," APPL: %.40ls  %.40ls",13,10,"%ls",13,10,0,"*** Restarted from a Soft Reset ***",13,10,"===== Last hard"
	.db	"/CPU reset occured at: %.19s ====",13,10,10,0,"*** GCSR was not saved ***",13,10,0,"GCSR at restart: [0"
	.db	"x%02X] (%d)(%ls)",13,10,0,13,10,"free Root: %u",13,10,"free xmem: %lu  (%05lX-%05lX)",13,10,10,0,"for CStart, BB l"
	.db	"og & info (earlier, during startup):",13,10,0,"Initializing... (%.6s)",13,10,0,"Initializing network "
	.db	"hdw...",13,10,"  tcp_Socket size: %d   udp_Socket size: %d",13,10,0,"Initializing network stack (xav"
	.db	"ail():%ld)...",13,10,0,"***** sock_init() error: %d *****",13,10,0,"Task table initialized",13,10,10,0,"For far"
	.db	" heap:",13,10,0,"***** Unable to init far heap *****",13,10,0,13,10,"Device ID: 0x%04lX",13,10,10,0,10,"For CStart:",13,10
	.db	0,"For syslog:",13,10,0,"For DiagLogInfo:",13,10,0,13,10,"***** Unable to alloc buffer for system log *****"
	.db	13,10,0,"For saving Application State:",13,10,0,13,10,10,"***** Restarted w/o RDLM - Forcing a reboot now"
	.db	" *****",13,10,10,0,13,10," ===== Clean bootup verified =====",13,10,10,0,"Davis Embedded Basic Real-time OS ("
	.db	"DEBROS)",0,"%s %s",0,13,10," RTOS: %ls  %ls",13,10,10,0,"*** Down for %lu seconds: Soft Reset ignored ***",13,10
	.db	0,13,10,"*** Invalid hdwResetTime: ***",13,10,"  curTime: 0x%08lX   seconds: 0x%08lX  downSecs: %l"
	.db	"d",13,10,"  rebootTime: 0x%08lX   hdwResetTime: 0x%08lX  msTime: 0x%08lX",13,10,"  Corrected hdwRe"
	.db	"setTime: 0x%08lX",13,10,10,0
	.end
